$MODULE_FACTORY_REGISTRY = typeof $MODULE_FACTORY_REGISTRY != 'undefined' ? $MODULE_FACTORY_REGISTRY : {};
$MODULE_REGISTRY = typeof $MODULE_REGISTRY != 'undefined' ? $MODULE_REGISTRY : {};
if(typeof require == 'undefined')
function require(path){if(!$MODULE_REGISTRY[path]) $MODULE_REGISTRY[path] = $MODULE_FACTORY_REGISTRY[path](); return $MODULE_REGISTRY[path]};$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/NGJSEnvironmentSupport'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/NGJSEnvironmentSupport'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/NGJSEnvironmentSupport'] = exports; /**

 # NGJSEnvironmentSupport.js
 # webgame
 #
 # Created by Frederic Barthelemy on 10/01/10.
 # Copyright 2010 ngmoco:). All rights reserved.

 */

/**
 * Provides Environmental support for features missing on certain platforms.
 */


/**
 * setTimeout and setInterval implementation for platforms that don't have it.
 *	It fires timers at the beginning of the first frame past the requested millisecond,
 *	before it processes messages for a particular frame.
 *
 * Platform Consumers:
 *	- Android
 *
 * Note:
 *	- Only accurate to within the frame.
 *	- Does behaves like webkit in that it lets clearInterval and clearTimeout
 *		clear timers created by each other's constructor style.
 *
 */
var NGSetTimeoutCustom = false;
var NGSetTimeoutCallbacks = {};
var NGSetTimeoutUIDGenerator = 0;

exports.NGSetTimeoutRunTimers = function() {
	if(NGSetTimeoutCustom) {
		var timersToExecute = [];
		var curTime = new Date().getTime();
		for (var tk in NGSetTimeoutCallbacks) {
			if (NGSetTimeoutCallbacks.hasOwnProperty(tk) && NGSetTimeoutCallbacks[tk].shouldExecute(curTime)) {
				timersToExecute.push(NGSetTimeoutCallbacks[tk]);
			}
		}

		for (var i in timersToExecute) {
			if (timersToExecute.hasOwnProperty(i)) {
				timersToExecute[i].execute();
			}
		}
	}
};

if(typeof(setTimeout) != "function") {
	NGSetTimeoutCustom = true;

	var NGSingleTimeoutInstance = function(fptr, timeMs) {
		this.uid = NGSetTimeoutUIDGenerator++;
		if (NGSetTimeoutUIDGenerator == Infinity)
		{
			NGSetTimeoutUIDGenerator = 0;
		}
		this.fptr = fptr;
		this.interval = timeMs;
		this.requestedTime = new Date().getTime() + timeMs;
	};

	NGSingleTimeoutInstance.prototype.shouldExecute = function(curTime) {
		if(curTime < this.requestedTime) {
			return false;
		}
		return true;
	};

	NGSingleTimeoutInstance.prototype.execute = function() {
		delete NGSetTimeoutCallbacks[this.uid];
		this.fptr();
	};
	/**
	*
	*/
	setTimeout = function(fptr,requestedTime) {
		if(requestedTime < 0 || typeof(requestedTime) != "number") {
			requestedTime = 0;
		}

		var inst = new NGSingleTimeoutInstance(fptr,requestedTime);
		NGSetTimeoutCallbacks[inst.uid] = inst;
		return inst.uid;
	};
	/**
	*
	*/
	clearTimeout = function(uid) {
		if(NGSetTimeoutCallbacks.hasOwnProperty(uid)) {
			delete NGSetTimeoutCallbacks[uid];
		}
	};
	/**
	*
	*/
	setInterval = function(fptr,requestedTime) {
		if(requestedTime < 0 || typeof(requestedTime) != "number") {
			requestedTime = 0;
		}

		var inst = new NGSingleTimeoutInstance(fptr,requestedTime);
		/*Special setIntervalMagic */
		inst.execute = function() {
			this.requestedTime = new Date().getTime() + this.interval;
			this.fptr();
		};
		/*End setIntervalMagic */
		NGSetTimeoutCallbacks[inst.uid] = inst;
		return inst.uid;
	};
	clearInterval = clearTimeout;
	
}
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/SystemBinding'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/SystemBinding'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/SystemBinding'] = exports; var ClassReq = require('NGCore/Client/Core/Class');
var Base64 = require('NGCore/Client/Core/Base64').Base64;
var ResultSetReq = require('NGCore/Client/Plus/ResultSet');

var NGSystemBindingCommands = {
    HandleAction: 0
};

var SystemBinding = ClassReq.Class.subclass({
    classname: "SystemBinding",
    callbacks: {},
    callbacksUidGenerator: 0,
    _contResultSets: {},
    _contResultSetIdxs: {}
});

var ResultSet = ClassReq.Class.subclass({
    classname: "ResultSet",
    initialize: function(continueId) {
        this.items = [];
        this._continueId = continueId;
        this.totalLength = Number.MAX_VALUE;
    },
    /*
	 * Call to getMore adds more items to items list.
	 * Please note that in the callback, it is possible that addedCount == 0
	 * in some cases.  In that case access to items[newIdx] does not yield
	 * any result
	 */
    getMore: function(cb) {
        return SystemBinding._getMoreContacts(this, cb);
    },
    /*
	 * Releases resource used by current ResultSet.
	 *
	 * To avoid resource leakage, please call closeResultSet if getMore
	 * is not called all the way to the end.
	 */
    closeResultSet: function() {
        SystemBinding._closeContactsResultSet(this);
    }
});

SystemBinding._pushContactsCmd = function(cmdname, callbackFunc, continueId) {
    // Generate unused callbackEntry
    var callbackId = SystemBinding.callbacksUidGenerator++;
    if ( !! !callbackFunc) {
        callbackFunc = function() {};
    }
    SystemBinding.callbacks[callbackId] = callbackFunc;
    var message = {
        name: cmdname,
        callbackId: callbackId
    };
    if (typeof continueId != 'undefined') {
        message.continueId = continueId;
    }
    message = JSON.stringify(message);
    NgPushCommand3(NgEntityTypes.NgSystemBinding, NGSystemBindingCommands.HandleAction,
    Base64.encode(message));
};

SystemBinding._closeContactsResultSetfunction = function(rSet) {
    // Passing empty callback as caller does not need to know when the close
    // is complete
    var cb = function() {};
    SystemBinding._pushContactsCmd('closecontacts', cb, rSet._continueId);
};

SystemBinding._getMoreContacts = function(rSet, callbackFunc) {
    if ((typeof rSet._continueId != 'undefined') &&
    (rSet.items.length < rSet.totalLength)) {
        SystemBinding._pushContactsCmd('morecontacts', callbackFunc, rSet._continueId);
        return true;
    }
    return false;
};

SystemBinding.getContacts = function(callbackFunc) {
    SystemBinding._pushContactsCmd('contacts', callbackFunc, undefined);
};

SystemBinding.getDeviceToken = function(callbackFunc) {
    // Generate unused callbackEntry
    var callbackId = SystemBinding.callbacksUidGenerator++;
    if ( !! !callbackFunc) {
        callbackFunc = function() {};
    }
    SystemBinding.callbacks[callbackId] = callbackFunc;
    var message = {
        name: 'devicetoken',
        callbackId: callbackId
    };
    message = JSON.stringify(message);
    NgPushCommand3(NgEntityTypes.NgSystemBinding, NGSystemBindingCommands.HandleAction,
    Base64.encode(message));
};

SystemBinding.handleCommand = function(command) {
    var fields = NgParseCommand2(command, NgParseInt, NgParseBase64);
    var cmd = JSON.parse(fields[1]);
    if (cmd.name == 'callback') {
    	var cb = SystemBinding.callbacks[cmd.callbackId];
		if (typeof cb == "function") {
            if (cmd.callbackname == 'contacts') {
                var obj = SystemBinding._contResultSets[cmd.continueId];
                if (typeof obj == 'undefined') {
                    // First time for this callback
                    obj = new ResultSetReq.ResultSet(cmd.continueId);
                    SystemBinding._contResultSets[cmd.continueId] = obj;
                    SystemBinding._contResultSetIdxs[cmd.continueId] = 0;
                }

                var addedCount = cmd.list.length;
                while (cmd.list.length > 0) {
                    var item = cmd.list.shift();
                    obj.items.push(item);
                }

                var newIdx = SystemBinding._contResultSetIdxs[cmd.continueId];
				if ((typeof newIdx) != 'undefined') {
                	SystemBinding._contResultSetIdxs[cmd.continueId] = newIdx + addedCount;
				}

                // Invalidate the continueId if done - when total is return (no
                // more result) or when result set is explicitly closed (cmd.closed)
                if ((typeof cmd.total != 'undefined') ||
                (typeof cmd.rsclosed != 'undefined')) {
                    if (typeof cmd.total != 'undefined') {
                        obj.totalLength = cmd.total;
                    }
                    delete obj._continueId;
                    delete SystemBinding._contResultSets[cmd.continueId];
                    delete SystemBinding._contResultSetIdxs[cmd.continueId];
                }

                delete SystemBinding.callbacks[cmd.callbackId];
				if (cmd.success) {
                	cb(undefined, obj, newIdx, addedCount);
				} else {
                	cb(cmd.error, obj, newIdx, addedCount);
				}
            } else {
                // other callbacks
                delete SystemBinding.callbacks[cmd.callbackId];
                cb(cmd);
            }
        }
    }
};

exports.SystemBinding = SystemBinding;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI'] || {}; $MODULE_REGISTRY['NGCore/Client/UI'] = exports; var Commands = require('NGCore/Client/UI/Commands').Commands;
var ViewGeometry = require('NGCore/Client/UI/ViewGeometry');

/**
 * <p>Classes and objects contained by the UI module.</p>
 * @name UI
 * @namespace
 * @description <p>The UI module is a collection of classes that control user interface components of a device.
 * Each class handles a specific aspect of the module implementation and contains APIs that support the class:</p>
 * <ul>
 * <li><code>{@link UI.AbstractView}</code>A base class object for constructing other UI objects.</li>
 * <li><code>{@link UI.CellView}</code>: Construct <code>CellView</code> objects.</li>
 * <li><code>{@link UI.CheckBox}</code>: Construct objects that are used as checkboxes in an application.</li>
 * <li><code>{@link UI.CheckoutView}</code>: Construct objects that handle and manage information associated with <code>POST</code> methods in an application.</li>
 * <li><code>{@link UI.DateField}</code>: Construct objects used for handling data returned by date functions.</li>
 * <li><code>{@link UI.DocumentView}</code>: Constructs objects that control the location of application documents.</li>
 * <li><code>{@link UI.EditText}</code>: Constructs objects for handling editable text in an application.</li>
 * <li><code>{@link UI.EditTextArea}</code>: Constructs objects for handling multiline editable text in an application.</li>
 * <li><code>{@link UI.Element}</code>: A base class object for constructing other UI objects.</li>
 * <li><code>{@link UI.GLView}</code>: Construct objects that provide applications with access to OpenGL.</li>
 * <li><code>{@link UI.Image}</code>: Constructs objects that control the location and size of images used in the user interface.</li>
 * <li><code>{@link UI.Label}</code>: Constructs objects that control the look and feel of application labels.</li>
 * <li><code>{@link UI.ListView}</code>: Construct <code>ListView</code> objects.</li>
 * <li><code>{@link UI.ListViewItem}</code>: Construct <code>ListViewItem</code> objects.</li>
 * <li><code>{@link UI.ListViewSection}</code>: Construct <code>ListViewSection</code> objects.</li>
 * <li><code>{@link UI.NavController}</code>: Construct objects that control the flow of applcation navigation.</li>
 * <li><code>{@link UI.ProgressDialog}</code>: Construct objects that control application progress messaging.</li>
 * <li><code>{@link UI.ScrollView}</code>: Construct <code>ScrollView</code> objects.</li>
 * <li><code>{@link UI.Spinner}</code>: Construct objects that handle application menu spinners.
 * <li><code>{@link UI.Toast}</code>: Construct <code>Toast</code> objects.
 * <li><code>{@link UI.View}</code>: Construct objects that control the look and feel of the application view state.</li>
 * <li><code>{@link UI.ViewGeometry.Rect}</code>: Construct rectangle objects for use as positionable elements in the user interface.</li>
 * <li><code>{@link UI.ViewGeometry.Scale}</code>: Construct objects that handle view geometry for different scales of measurement.</li>
 * <li><code>{@link UI.WebView}</code>: Construct objects that pass event callback functions when web page events occur.</li>
 * <li><code>{@link UI.Window}</code>: Construct application window objects.</li>
 * </ul>
 */

var UI = exports.UI = {
	Commands: Commands,

	FontStyle: Commands.FontStyle,
	State: Commands.State,
	FitMode: Commands.FitMode,

	ViewGeometry: ViewGeometry,
	Scale: ViewGeometry.Scale,

    /**
	 *	@function
	 * 	@name UI#animate
	 * 	Animate changes to the properties of one or more UI objects.
	 * 	Currently animates changes to frame and alpha, and animates the addition / removal of subviews.
	 * 	@param {Function} action A closure that sets the property or properties to be animated.
	 * 		This function may manipulate several objects.
	 * 	@param {Number} duration The time over which to execute the animation, in milliseconds.
	 * 	@param {Function} onCompletion A closure to be executed after the animation has completed.
	 */
    animate: Commands.animate,

    /**
		@name UI#compositeImages
		Creates a composition of images to an offscreen bitmap, writing the resulting picture to disk.
		
		The filename returned in the callback may not be the same as originally requested!
		
		@example
		UI.compositeImages( 200, 200, "basic.png", [
			{
				image:'./Content/background.png',
				rect:[ 0,0, 200, 200 ]
			},
			{
				image:'./Content/CanYouSeeThisImage.png',
				rect:[ 50, 50, 100, 100 ]
			},
		], function( data ) { 
			if ( data.error == undefined ) { 
				NgLogD("yay, picture! at:"+data.filename);
			}
		} );
	 */
    compositeImages: function(w, h, filename, infoArray, callback) {
        var cb = Commands.registerTemporaryCallback(callback);
        if (cb) {
			Commands.doCompositeImages(w, h, filename, infoArray, cb);
		}
    },

    /**
		@name UI#choosePhoto
		Show fullscreen user interface for taking a picture with the camera or choosing an existing
		photo.
		
		Currently there are no 'options' keys defined.  
		In the future, we're considering "forAvatar" key to use a custom cropping UI.
		
		The filename returned in the callback may not be the same as originally requested!
		If the user cancels or an error occurs, the callback will be passed an error string.
		
		Passing 0 for targetWide or High will return the original unscaled image.
		
		@example
		UI.choosePhoto( 0, 0, "basic.png", undefined, function( data ) { 
			if ( data.error == undefined ) { 
				NgLogD("yay, picture! at:"+data.filename);
			}
		} );
	*/
    choosePhoto: function(width, height, filename, options, callback, invokingView) {
       if (!invokingView || !invokingView.__objectRegistryId) {
            new exports.UI.Toast({
                'text': "Photo picker requires an invoking view.",
                'onDisappear': function() {
                    this.destroy();
                }
            }).show();
            return;
        }

        var cb = Commands.registerTemporaryCallback(callback);
		if (cb) {
        	Commands.doChoosePhoto(width, height, filename, options || {}, cb, invokingView.__objectRegistryId);
		}
    },

    /**
		@name UI#choosePhotoCamera
		Show fullscreen user interface for taking a picture with the camera or choosing an existing
		photo.
		
		Currently there are no 'options' keys defined.  
		In the future, we're considering "forAvatar" key to use a custom cropping UI.
		
		The filename returned in the callback may not be the same as originally requested!
		If the user cancels or an error occurs, the callback will be passed an error string.
		
		Passing 0 for targetWide or High will return the original unscaled image.
		
		@example
		UI.choosePhoto( 0, 0, "basic.png", undefined, function( data ) { 
			if ( data.error == undefined ) { 
				NgLogD("yay, picture! at:"+data.filename);
			}
		} );
	*/
    choosePhotoCamera: function(width, height, filename, options, callback) {
        var cb = Commands.registerTemporaryCallback(callback);
		if (cb) {
        	Commands.doChooseCamera(width, height, filename, options || {}, cb);
		}
    },

	measureText: function( text, w, h, font, size, callback) {
		var cb = Commands.registerTemporaryCallback(callback);
		if (cb != '') {
			Commands.measureText(text, w || -1, h || -1, font, size, cb);
		}
	}
};

exports.UI.__defineGetter__("Window",
function() {
    delete UI.Window;
    return UI.Window = require('NGCore/Client/UI/Window').Window;
});
exports.UI.__defineGetter__("Element",
function() {
    delete UI.Element;
    return UI.Element = require('NGCore/Client/UI/Element').Element;
});
exports.UI.__defineGetter__("View",
function() {
    delete UI.View;
    return UI.View = require('NGCore/Client/UI/View').View;
});
exports.UI.__defineGetter__("Label",
function() {
    delete UI.Label;
    return UI.Label = require('NGCore/Client/UI/Label').Label;
});
exports.UI.__defineGetter__("Image",
function() {
    delete UI.Image;
    return UI.Image = require('NGCore/Client/UI/Image').Image;
});
exports.UI.__defineGetter__("Button",
function() {
    delete UI.Button;
    return UI.Button = require('NGCore/Client/UI/Button').Button;
});
exports.UI.__defineGetter__("GLView",
function() {
    delete UI.GLView;
    return UI.GLView = require('NGCore/Client/UI/GLView').GLView;
});
exports.UI.__defineGetter__("NavController",
function() {
    delete UI.NavController;
    return UI.NavController = require('NGCore/Client/UI/NavController').NavController;
});
exports.UI.__defineGetter__("WebView",
function() {
    delete UI.WebView;
    return UI.WebView = require('NGCore/Client/UI/WebView').WebView;
});
exports.UI.__defineGetter__("ScrollView",
function() {
    delete UI.ScrollView;
    return UI.ScrollView = require('NGCore/Client/UI/ScrollView').ScrollView;
});
exports.UI.__defineGetter__("ListView",
function() {
    delete UI.ListView;
    return UI.ListView = require('NGCore/Client/UI/ListView').ListView;
});
exports.UI.__defineGetter__("ListViewSection",
function() {
    delete UI.ListViewSection;
    return UI.ListViewSection = require('NGCore/Client/UI/ListViewSection').ListViewSection;
});
exports.UI.__defineGetter__("ListViewItem",
function() {
    delete UI.ListViewItem;
    return UI.ListViewItem = require('NGCore/Client/UI/ListViewItem').ListViewItem;
});
exports.UI.__defineGetter__("CellView",
function() {
    delete UI.CellView;
    return UI.CellView = require('NGCore/Client/UI/CellView').CellView;
});
exports.UI.__defineGetter__("CheckBox",
function() {
    delete UI.CheckBox;
    return UI.CheckBox = require('NGCore/Client/UI/CheckBox').CheckBox;
});
exports.UI.__defineGetter__("EditText",
function() {
    delete UI.EditText;
    return UI.EditText = require('NGCore/Client/UI/EditText').EditText;
});
exports.UI.__defineGetter__("EditTextArea",
function() {
    delete UI.EditTextArea;
    return UI.EditTextArea = require('NGCore/Client/UI/EditTextArea').EditTextArea;
});
exports.UI.__defineGetter__("DateField",
function() {
    delete UI.DateField;
    return UI.DateField = require('NGCore/Client/UI/DateField').DateField;
});
exports.UI.__defineGetter__("AlertDialog",
function() {
    delete UI.AlertDialog;
    return UI.AlertDialog = require('NGCore/Client/UI/AlertDialog').AlertDialog;
});
exports.UI.__defineGetter__("ProgressDialog",
function() {
    delete UI.ProgressDialog;
    return UI.ProgressDialog = require('NGCore/Client/UI/ProgressDialog').ProgressDialog;
});
exports.UI.__defineGetter__("Toast",
function() {
    delete UI.Toast;
    return UI.Toast = require('NGCore/Client/UI/Toast').Toast;
});
/** @private */
exports.UI.__defineGetter__("AdView",
function() {
    delete UI.AdView;
    return UI.AdView = require('NGCore/Client/UI/AdView').AdView;
});
exports.UI.__defineGetter__("DocumentView",
function() {
    delete UI.DocumentView;
    return UI.DocumentView = require('NGCore/Client/UI/DocumentView').DocumentView;
});
exports.UI.__defineGetter__("CheckoutView",
function() {
    delete UI.CheckoutView;
    return UI.CheckoutView = require('NGCore/Client/UI/CheckoutView').CheckoutView;
});
exports.UI.__defineGetter__("Spinner",
function() {
    delete UI.Spinner;
    return UI.Spinner = require('NGCore/Client/UI/Spinner').Spinner;
});
exports.UI.__defineGetter__("ProgressBar",
function() {
    delete UI.ProgressBar;
    return UI.ProgressBar = require('NGCore/Client/UI/ProgressBar').ProgressBar;
});
exports.UI.__defineGetter__("MapView",
function() {
    delete UI.MapView;
    return UI.MapView = require('NGCore/Client/UI/MapView').MapView;
});
exports.UI.__defineGetter__("MapAnnotation",
function() {
    delete UI.MapAnnotation;
    return UI.MapAnnotation = require('NGCore/Client/UI/MapAnnotation').MapAnnotation;
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Network/DownloadManifest'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Network/DownloadManifest'] || {}; $MODULE_REGISTRY['NGCore/Client/Network/DownloadManifest'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class XHR
// XMLHttpRequest implementation
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var Class = require('NGCore/Client/Core/Class').Class;
var MessageListener = require('NGCore/Client/Core/MessageListener').MessageListener;
var XHR = require('NGCore/Client/Network/XHR').XHR;
var Util = require('NGCore/Client/Network/Util').Util;
var DownloadFile = require('NGCore/Client/Network/DownloadFile').DownloadFile;
var FileSystem = require('NGCore/Client/Storage/FileSystem').FileSystem;
var LocalGameList = require('NGCore/Client/Core/LocalGameList').LocalGameList;

// JMarr temporary hack to supress archive downloads on flash.
var Capabilities = require('NGCore/Client/Core/Capabilities').Capabilities;

////////////////////////////////////////////////////////////////////////////////

var Manifest = Class.subclass(
{
	classname: 'Manifest',

	initialize: function()
	{
	},

	reset: function ()
	{
		this.mJson = null;
		this.mArchives = null;
	},

	initWithJsonText: function ( text, emptyOnFail)
	{
		try
		{
			this.mJson = JSON.parse ( text );
			if (!this.mJson)
			{
				this.mJson = {};
			}
		}
		catch (e)
		{
			this.mJson = {};
		}

		if('__archives' in this.mJson)
		{
			this.mArchives = this.mJson['__archives'].files;
			delete this.mJson['__archives'];
		}
		else
		{
			this.mArchives = [];
		}
	},

	//cb: function ( itemKey, dstList, srcList ), which is compareItems
	//cb returns ! null, then dst[ item ] = cb return value.
	//cb returns null, then delete dst[ item ].
	foreach: function ( other, cb )
	{
		var dst = this.mJson;
		var src = other.mJson;
		// Handle all things in src.
		for ( var key in src )
		{
			this.handleItem ( key, dst, src, cb );
		}
		// Build up list of all things not in src.
		for ( var key in dst )
		{
			// Handle all things not in src.
			if ( ! (key in src) )
			{
				this.handleItem ( key, dst, src, cb );
			}
		}
	},

	handleItem: function ( key, dst, src, cb )
	{
		var ret = cb ( key, dst, src );
		if ( !ret )
		{
			delete dst[ key ];
		}
	},

	write: function ( fname )
	{
		var cb = function (err)
		{
			if (err)
			{
				console.log('Error writing manifest! ' + err);
			}
			// DO stuff?
		};

		if (this.mJson)
		{
			var out = JSON.stringify(this.mJson);
			FileSystem.writeFile(fname, out, cb);
		}
	}
});

////////////////////////////////////////////////////////////////////////////////

exports.DownloadManifest = MessageListener.subclass(
/** @lends Network.DownloadManifest.prototype */
{
	classname: 'DownloadManifest',

	/**
	 * @class The <code>DownloadManifest</code> class constructs objects that initiate the handling of a manifest file. 
	 * This ensures a set of files are kept up-to-date in the specified directory from the specified URL.
	 * @constructs The default constructor. 
	 * @augments Core.Class
	 */
	initialize: function()
	{
		this.reset();
	},

	_clearConnections: function()
	{
		for (var i in this.mConnections)
		{
			if(!this.mConnections.hasOwnProperty(i)) continue;
			
			this.mConnections[i].abort();
		}
		this.mConnections = [];
	},

	reset: function ()
	{
		this.mConcurrentRequests = 6;

		this.mManifest = null;

		this.mRemoteUrl = null;
		this.mLocalPath = null;
		this.mLocalRoot = null;

		this.mLocalText = null;
		this.mRemoteText = null;
		/** @private */
		this.mProgressCb = function() {};
		/** @private */
		this.mDoneCb = function() {};

		this.mPaused = false;
		this.mValid = false;

		this._clearConnections();
		this.mPendingItems = [];
		this.mCompleteBytes = 0;
		this.mTotalBytes = 0;
		
		this.mSpaceNeeded = 0;
		
		this.mNumRemoteManifestFiles = 0;
		this.mNumRemoteManifestBytes = 0;
		
		this.mDownloadArchives = true;
		this.mActiveRequests = [];

		this.mLocalGameList = LocalGameList;

		this.mNewJS = false;
		this.mAppObserver = null;

		this.mRetrySchedule = Util.RetrySchedule(50, 2000);
		this.mManifestRetrySchedule = this.mRetrySchedule.slice(0);

		if(this._statusListener)
		{
			this._statusListener.destroy();
			this._statusListener = null;
		}
		this.mCheckUpdateOnly = false;
		this.mCheckUpdateCallback = null;
	},

	_ensureTrailingSlashes: function(remoteUrl, localPath, secureContentUrl)
	{
		// Check for trailing slashes
		this.mRemoteUrl = remoteUrl.match(/.*\/$/) ? remoteUrl : remoteUrl + '/';
		// If the local path is nothing, do not alter the filename. Otherwise, ensure trailing slash
		this.mLocalRoot = (localPath.match(/.*\/$/) || (!localPath)) ? localPath : localPath + '/';
		this._secureContentUrl = ((!secureContentUrl) || secureContentUrl.match(/.*\/$/)) ? secureContentUrl : secureContentUrl + '/';
	},

	_readLocalManifest: function()
	{
		FileSystem.readFile ( this.mLocalPath, this._onReadLocalManifest.bind(this) );
	},

	_setRemotePath: function(manifestName)
	{
		if (this._secureContentUrl)
		{
			this.mRemotePath = this._secureContentUrl + manifestName;
		}
		else
		{
			this.mRemotePath = this.mRemoteUrl + manifestName;
		}
	},

	_parseManNames: function (man)
	{
		if (typeof man === 'string')
		{
			var obj = {};
			obj[man] = man;
			man = obj;
		}
		return man;
	},

	isUpdated: function(remoteUrl, localPath, manifest, doneCB, errorCB)
	{
		this.mCheckUpdateOnly = true;
		this.mCheckUpdateCallback = doneCB;

		this.mDoneCb = (typeof errorCB == 'function') ? errorCB : function() {};
		this.mProgressCb = function(done, left) {};
		var httpStatusCode = 0;
		var fullUrl = remoteUrl + "/configuration.json" + Util.getCacheBustingString();
		Util.OperationWithRetries(
			(function(failCall, abortCall)
			{
				// Start remote manifest download.
				var req = new XHR();
				req.onreadystatechange = (function()
				{
					if( req.readyState == 4 && this.mValid )	// done && not cancelled
					{
						this.mManifest = new Manifest ();
						var manifestUrl = null;
						// Only parse if we got a good response back
						if (req.status == 200 && req.responseText)
						{
							var config = JSON.parse(req.responseText);
							manifestUrl = config.contentUrl;
							if (!manifest)
							{
								manifest =
								{
									"webgame.ngmanifest":
									require('NGCore/Client/Core/_int_LGL')._int_LGL.getManifestName(config)
								};
							}

							// If config didn't have contentUrl or we never parsed(local testing), use the base URL
							if (!manifestUrl)
								manifestUrl = remoteUrl;

							manifest = this._parseManNames(manifest);
							var manifestSourceName;
							var manifestName;
							for (var key in manifest)
							{
								manifestSourceName = manifest[key];
								manifestName = key;
								break;
							}

							this._ensureTrailingSlashes(manifestUrl, localPath);
							this.mLocalPath = this.mLocalRoot + manifestName;
							this._setRemotePath(manifestSourceName);
							this._readLocalManifest();
						}
						else if (req.status == 404)
						{
							this._processError('404! Failed to download configuration at '+ fullUrl, false);
						}
						else
						{
							httpStatusCode = req.status;
							failCall();
						}
					}
				}).bind(this);

				req.open ( 'GET', fullUrl, true );
				req.send ();
			}).bind(this),
			(function()
			{
				console.log('Exceeded maximum number of manifest download retires, failing');
				this._processError('Failed to download manifest (' + httpStatusCode + ') at ' + fullUrl, false);
			}).bind(this),
			this.mFailEarly
		);

		this.mValid = true;
	},

	// progressCb: function ( completedRequests, totalRequests )
	// doneCb: function ( err, manifest )
	// throws if url/path arguments are null or empty.
	// TODO: Allow headers argument.  Currently null.
	// TODO: Allow HTTP method argument.  Currently GET.
	/**
	* @name Network.DownloadManifest#start
	* @description Start a download of a remote manifest file at <code>[remoteUrl + manifestName]</code> 
	* and read a local manifest at <code>[localPath + manifestName]</code>.<br><br>
	* <ul>
	* <li>If the local manifest does not exist, all files specified by the remote manifest are downloaded.</li>
	* <li>If the local manifest does exist, this method will update the file system at 
	* <code>[localPath]</code> to match the files specified in the remote manifest.</li>
	* </ul>
	* Each file download will trigger a <code>progress</code> callback function that returns the 
	* number of items downloaded and the total number of items to download.
	* <pre class="code">progressCb: function ( completedRequests, totalRequests )</pre>
	* When all downloads are complete, a <code>done</code> callback function is triggered that returns an error (if any) 
	* and the contents of <code>[localPath + manifestName]</code>. 
	* <pre class="code">doneCb: function ( err, manifest )</pre>
	* If an error does not occur, this function returns <code>undefined</code>.<br><br>
	* <b>Note:</b> The contents of <code>[localPath + manifestName]</code> are saved whether an error occurs or not.
	* @param {String} remoteUrl The URL to a manifest file.
	* @param {String} localPath The directory path to a manifest file.
	* @param {String} manifestName The manifest filename. 
	* @param {Function} progressCb The callback function to call for download progress.
	* @param {Function} doneCb The callback function to call when the download is complete.
	* @throws {invalid arguments} If the URL or directory path returns as empty or <code>null</code>.
	* @example Network.DownloadManifest.start(this._URL, './', this._manifestName, progressCb, doneCallback);
	* @function
    * @status iOS, Android
	*/
	/** @ignore */
	start: function ( remoteUrl, localPath, manifest, progressCb, doneCb, disableArchives, failEarly )
	{
		this.mCheckUpdateOnly = false;
		
		// Allow manifestName to be a hash with {manifestDestName: manifestSourceName}
		manifest = this._parseManNames(manifest);
		var manifestSourceName;
		var manifestName;
		for (var key in manifest)
		{
			manifestSourceName = manifest[key];
			manifestName = key;
			break;
		}

		console.log('DownloadManifest.start(', remoteUrl, localPath, manifestSourceName, ')');
		if ( ! remoteUrl || ! localPath || remoteUrl == '' || localPath == '' )
		{
			throw new Error ( 'invalid arguments: ' + JSON.stringify ( arguments ) );
		}

		// Set up instance state for this request.
		this.mManifest = new Manifest ();
		if(disableArchives)
			this.mDownloadArchives = false;
		
		// JMarr temporary hack to disable archive downloads on flash.
		if(Capabilities.getPlatformOS() == 'flash')
		{
			console.log('Flash does not yet support archive downloads');
			this.mDownloadArchives = false;
		}

		this._ensureTrailingSlashes(remoteUrl, localPath, this._secureContentUrl);
		this._setRemotePath(manifestSourceName);
		this.mLocalPath = this.mLocalRoot + manifestName;
		this.mFailEarly = failEarly;

		// try these to prevent a failed update due to bad code
		/** @private */
		this.mProgressCb = function (done, left)
		{
			try
			{
				progressCb(done, left);
			}
			catch (ex)
			{
				NgLogException(ex);
			}
		};

		var that = this;
		/** @private */
		this.mDoneCb = function (err, man, hadCache)
		{
			try
			{
				// touch the .nomedia file (MOB-1355)
				FileSystem.writeFile(that.mLocalRoot + '/.nomedia', '');

				/** @private */
				this.mProgressCb = function() {};
				/** @private */
				this.mDoneCb = function() {};
				this._setLifecycleListening(false);
				doneCb(err, man, hadCache);
			}
			catch (ex)
			{
				NgLogException(ex);
			}
		};

		this._readLocalManifest();
		this._setLifecycleListening(true);
		this.mValid = true;
	},

	abort: function()
	{
		this.reset();
	},

	pause: function()
	{
		// Cancel downloads
		this._clearConnections();

		// move active requests back to pending
		this.mPendingItems = this.mPendingItems.concat(this.mActiveRequests);
		this.mActiveRequests = [];

		this.mPaused = true;
	},

	resume: function()
	{
		if (this.mPaused)
		{
			this.mPaused = false;
			this._downloadPendingItems();
		}
	},

	_setLifecycleListening: function(toListen)
	{
		if (toListen && !this.lifeListening)
		{
			Device.LifecycleEmitter.addListener(this,
				function (event)
				{
					switch (event)
					{
						case Device.LifecycleEmitter.Event.Suspend:
						case Device.LifecycleEmitter.Event.Terminate:
							this._writeManifest();
						break;
					}
				}
			);
			this.lifeListening = true;
		}
		else if (this.lifeListening)
		{
			Device.LifecycleEmitter.removeListener(this);
			this.lifeListening = false;
		}
	},

	_theQuestion: function (toBe)
	{
		return toBe | !toBe;
	},

	_setConfig: function (cfg)
	{
		// For saving after completion
		this._Config = cfg;
		// for skipping JS download
		this._noJS = cfg.omitJsUpdate;
		// For using separate content URL
		this._secureContentUrl = cfg.secureContentUrl;
	},

	// Callback for read of local manifest file in start method.

	_onReadLocalManifest: function ( err, data )
	{
		if (this.mValid)
		{
			try	// always start try block in async callbacks
			{
				if ( ! err )
				{
					this.mLocalText = data;
				}
				else
				{
					this.mLocalText = '{}';	// Empty string is ! null.  It's ok for the read to fail.
				}
				this._downloadManifest();
			}
			catch ( ex )
			{
				NgLogException ( ex );
				this._processError ( 'Error reading local manifest err: ' + err , false );
			}
		}
	},

	// Called to start the manifest download.
	_downloadManifest: function()
	{
		var httpStatusCode = 0;
		Util.OperationWithRetries(
			(function(failCall, abortCall)
			{
				// Start remote manifest download.
				var req = new XHR();
				var id = this.mConnections.push(req) - 1;
				req.onreadystatechange = (function()
				{
					if( req.readyState == 4 && this.mValid )	// done && not cancelled
					{
						delete this.mConnections[id];
						httpStatusCode = req.status;
						if ( httpStatusCode == 200 )
						{
							this.mRemoteText = req.responseText;
							this._checkItems();

							if (this.mCheckUpdateOnly)
								this._checkUpdate();
							else
								this._evalManifests ();
						}
						else
						{
							console.log( 'Download of manifest at ' + this.mRemotePath
								+Util.getCacheBustingString() + ' failed: ' + httpStatusCode + ' '
								+ req.responseText);
							if (httpStatusCode == 404)
							{
								abortCall();
							}
							else
							{
								failCall();
							}
						}
					}
				}).bind(this);

				req.open ( 'GET', this.mRemotePath + Util.getCacheBustingString(), true );
				req.send ();
			}).bind(this),
			(function()
			{
				this._processError('Failed to download manifest (' + httpStatusCode + ')', false);
			}).bind(this),
			this.mFailEarly
		);
	},

	// Can be called at any time.

	_processError: function ( message , writeManifest)
	{
		if (writeManifest && this.mManifest)
		{
			this._writeManifest();
		}

		// Don't call the doneCB without checking local text
		if (this.mValid)
		{
			this.mDoneCb ( message, null,  this.mLocalText ? this.mLocalText.length > 2 : false );
			this.reset ();
		}
	},

	_checkItems: function()
	{
		// Init source and destination manifests.
		this.mManifest.initWithJsonText ( this.mLocalText , true );
		var other = new Manifest ();
		other.initWithJsonText ( this.mRemoteText );

		// Build list of pending local items.
		this.mManifest.foreach ( other, this._compareItems.bind(this));
	},

	_checkUpdate: function()
	{
		this.mPendingItems = [];
		this.mCheckUpdateCallback(this.mTotalBytes > 0, this.mTotalBytes);
	},

	_evalManifests: function ()
	{
		try
		{
			// JMarr always download with zips if they are available.
			// If we only need to download less than 33% of files and less than 33% of bytes, then don't use an archive.
			// Additinoally, we must be on wifi, or else carriers might tamper with our files.
			/*var NetworkEmitter = require('../Device/NetworkEmitter').NetworkEmitter;
			if(this.mPendingItems.length < this.mNumRemoteManifestFiles * 0.33
				&& this.mTotalBytes < this.mNumRemoteManifestBytes * 0.33
				&& NetworkEmitter.getLastStatus() == NetworkEmitter.Status.Wifi)
			{
				this.mDownloadArchives = false;
			}*/
			
			// Cache total bytes into separate variable. Archive download might increase
			// space needed, but not total bytes.
			this.mSpaceNeeded = this.mTotalBytes;

			var other = new Manifest ();
			other.initWithJsonText ( this.mRemoteText );
			// If there is no archive in the manifest, don't download an archive.
			if(!other.mArchives)
				this.mDownloadArchives = false;

			// Prepare for archive downloads. If mDownloadArchives is true,
			// then all files will be downloaded through an archive. Otherwise,
			// only files that are makred as force archive will be downloaded
			// through archive.
			this._prepareForArchiveDownload(other.mArchives, !this.mDownloadArchives);
			
			// Trigger progress callback.
			this.mProgressCb ( this.mCompleteBytes, this.mTotalBytes );

			this.mLocalGameList.freeSpace(this.mSpaceNeeded, (function (err)
			{
				if (err)
				{
					this._processError(err, false);
					return;
				}
				var num = this.mPendingItems.length;
				if (num)
				{
					console.log("Going to download %d items.", num);
					if (num < 10)
					{
						console.log("Items: " + JSON.stringify(this.mPendingItems));
					}
				}
				// Download anything that got into pending list
				this._downloadPendingItems ();
			}).bind(this));
		}
		catch (e)
		{
			NgLogException ( e );
			this.mDoneCb ( 'Failed processing manifests!', null );
		}
	},
	
	// Decides which archives need to be downloaded to ensure that all of the pending files are downloaded.
	_prepareForArchiveDownload: function(archives, onlyForcedFiles)
	{
		console.log('DownloadManfiest._prepareForArchiveDownload onlyForcedFiles:', onlyForcedFiles);
		// Iterate over files that need to be covered and make sure they are included.
		var neededFiles = [];
		var includedArcns = {};
		var includedExpSize = 0;
		var includedArcSize = 0;
		var filesToCover = this.mPendingItems;
		var nonForcedFiles = [];
		for(var i=0; i < filesToCover.length; ++i)
		{
			// If this file isn't an archive, just download the file.
			var f = filesToCover[i];
			if(!f.arcn)
			{
				//console.log('NonForced: including arnc-less %s', f.name);
				neededFiles.push(f);
				includedExpSize += f.size;
				continue;
			}
			
			// Record that this archive provides this file.
			var arcn = f.arcn;
			var a = archives[arcn];
			if(!a.files)
				a.files = [f];
			else
				a.files.push(f);
			
			// Is this archive already incldued?
			if(includedArcns[arcn])
				continue;
			
			// If we are only including forced files, remember that this
			// is a non forced file that we need to download. If after evaluating
			// all of the forced files and these files are not included, they will
			// be explicitly included.
			if(onlyForcedFiles && !f.arcForce)
			{
				nonForcedFiles.push(f);
				//console.log('NonForced: delaying decision about %s in arcn %d', f.name, f.arcn);
				continue;
			}
			
			//console.log('Forced: including %s from arcn %d', f.name, f.arcn);
			
			// Include the archive associated with this arcn.
			neededFiles.push(a);
			includedArcns[arcn] = true;
			includedExpSize += a.expSize;
			includedArcSize += a.arcSize;
		}
		
		// If only downloading forced archives, examine all of the queued
		// files that are not forced. If their archive is not included, then 
		// directly include the file.
		for(i=0; i < nonForcedFiles.length; ++i)
		{
			// Is the archive for this file already incldued?
			// This will happen if a forced file (like a .js) 
			// forced the archive to be included.
			var f = nonForcedFiles[i];
			if(includedArcns[f.arcn])
			{
				//console.log('NonForced: skipping %s because it is already in arcn %d', f.name, f.arcn);
				continue;
			}
			
			//console.log('NonForced: including %s from arch %d', f.name, f.arcn);
			
			// Otherwise, include this file.
			neededFiles.push(f);
			includedExpSize += f.size;
		}
		
		// Tell the rest of the world about our choices.
		this.mPendingItems = neededFiles;
		this.mTotalBytes = includedExpSize;
		this.mSpaceNeeded = includedExpSize + includedArcSize;
	},

	// Callback from Manifest.foreach.

	_compareItems: function ( key, dst, src )
	{
		var ditem = dst[key];
		var sitem = src[key];

		// Early out for removed file.  Always delete.
		if ( ! sitem )
		{
			var fname = this.mLocalRoot + key;
			var cb = function(err)
			{
				if (err)
				{
					console.log('Error deleting ' + fname + ' error: ' + err);
				}
			};
			FileSystem.deleteFile(fname, cb);

			// If the item was pending, delete the temporary file it was downloading
			if ('pending' in ditem )
			{
				fname = fname + '.tmp';
				FileSystem.deleteFile(fname, cb);
			}
			return false;
		}

		var isJS = this._extensionMatch ( key, 'js' );

		// Don't download the html or the js with noJS.
		if (this._noJS && (isJS || key == "index.html"))
		{
			// Don't download JS!! keep it in the local manifest, but don't push it to download
			return true;
		}

		sitem.name = key;
		this.mNumRemoteManifestFiles += 1;
		this.mNumRemoteManifestBytes += sitem.size;

		// No local version or version mismatch, must download.
		if ( ! ditem || ditem.hash != sitem.hash)
		{
			if ( isJS )
			{
				this.mNewJS = true;
			}

			// Tally the space we need for downloading new items
			this.mTotalBytes += sitem.size;

			// Add to the pending queue.
			this.mPendingItems.push ( sitem );
		}
		
		return true;
	},

	// Utility method to check for case-insensitive match for file extension.
	
	_extensionMatch: function ( fname, ext )
	{
		var pattern = new RegExp ( '^.*\.(' + ext + ')$', 'i' );
		var ret = fname.match ( pattern );
		return ret;
	},

	// Once in download state, this method is called to start downloading 
	// assets from manifest.  When each asset successfully completes, this method
	// will also be called to start the next download.  This method institutes
	// the logic for having a limited number of concurrent downloads from
	// the mCurrentRequests and mConcurrentRequests members.

	_downloadPendingItems: function ()
	{
		if (this.mValid && !this.mPaused)
		{
			// Are we done?
			if ( this.mPendingItems.length == 0 && this.mActiveRequests.length == 0)
			{
				if (this.mTotalBytes > 0)
				{
					this._writeManifest ();
				}
				this._writeConfig();

				// Trigger done callback and reset.
				this.mDoneCb ( null, this.mManifest );
				this.reset ();
				return;
			}

			// Not done, pop more pending items and start their downloads.
			while ( this.mPendingItems.length && this.mActiveRequests.length < this.mConcurrentRequests )
			{
				// Download the next pending file.
				var item = this.mPendingItems.pop ();
				item.retrySchedule = this.mRetrySchedule.slice(0);
				this._downloadItem(item);
			}
		}
	},
	
	_downloadItem: function(item)
	{
		this.mActiveRequests.push(item);
		var remoteUrl = this.mRemoteUrl + item.name;
		if(item.mangled)
		{
			var i = remoteUrl.lastIndexOf('.');
			remoteUrl = remoteUrl.substr(0, i) + '-' + remoteUrl.substr(i+1) + '.bin';
		}

		Util.OperationWithRetries((function(failCb)
		{
			// Start the download.
			var dlFile = new DownloadFile();
			var id = this.mConnections.push(dlFile) - 1;
			dlFile.start(this.mLocalRoot + item.name,
				'GET',
				remoteUrl + Util.getCacheBustingString(),
				[],
				this._onDownloadItemComplete.bind(this, item, failCb, id));
		}).bind(this), (function()
		{
			console.log('Manifest download failed. Too many failed download attempts for ' + item.name );
			this._processError ( 'Could not download file ' + item.name , true);
		}).bind(this), this.mFailEarly);
	},

	_removeActiveRequest: function (item)
	{
		for (var i in this.mActiveRequests)
		{
			if (item == this.mActiveRequests[i])
			{
				this.mActiveRequests.splice(i, 1);
			}
		}
	},

	// Callback for completion of download started in downloadItem method.
	// Will throw if item does not have pending member set.

	_onDownloadItemComplete: function ( item, failCb, id, status, hash )
	{
		try
		{
			delete this.mConnections[id];
			// Was there an error or bad download?
			if(status != 200 || item.hash != hash)
			{
				// Try to download the item again.
				console.log('Download failed.  Retrying ' + item.name );
				console.log('Status: ' + status + ' manifest hash: ' + item.hash + ' actual hash: ' + hash);
				failCb();
				return;
			}
			
			// Is this an archive?
			if(item.files)
			{
				// Temporarially increase the max number of connections while we decompress the archive.
				++this.mConcurrentRequests;
				
				FileSystem.decompressFile(this.mLocalRoot + item.name, this.mLocalRoot, false, (function(err, files)
				{
					// Restore max connections to original value.
					--this.mConcurrentRequests;
					
					// Delete the zip file.
					FileSystem.deleteFile(this.mLocalRoot + '/' + item.name);
					
					if(err)
					{
						// Try to download the item again.
						console.log('Decompress failed.  Retrying ' + item.name );
						failCb();
					}
					
					for(var i=0; i < item.files.length; ++i)
					{
						var f = item.files[i];
						this.mManifest.mJson[f.name] = {size: f.size, hash: f.hash};
					    if (typeof f.encryption != "undefined")
						this.mManifest.mJson[f.name].encryption = f.encryption;
					}

					this._removeActiveRequest(item);
					this.mCompleteBytes += Number(item.expSize);
					this.mProgressCb ( this.mCompleteBytes, this.mTotalBytes );
					this._downloadPendingItems ();
				}).bind(this));
			}
			else
			{
				// Update our working manifest.
				this.mManifest.mJson[item.name] = {size: item.size, hash: item.hash};
			    if (typeof item.encryption != "undefined")
				this.mManifest.mJson[item.name].encryption = item.encryption;
				
				// Make callbacks (like a boss).
				this._removeActiveRequest(item);
				this.mCompleteBytes += Number(item.size);
				this.mProgressCb ( this.mCompleteBytes, this.mTotalBytes );
				this._downloadPendingItems ();
			}
		}
		catch ( ex )
		{
			// Unlikely, but safety
			NgLogException ( ex );
			this._processError ( 'Error after finishing the download of item ' + item 
				+ '. status is ' + status , true );
		}
	},

	// Flush changes to locally cached manifest file.

	_writeManifest: function ()
	{
		console.log("DM Complete!");
		try
		{
			if (this.mManifest)
				this.mManifest.write ( this.mLocalPath );
		}
		catch (ex)
		{
			NgLogException(ex);
		}
	},

	_writeConfig: function ()
	{
		try
		{
			if (this._Config)
			{
				// console.log("writing |%s| to %s", JSON.stringify(this._Config), this.mLocalRoot + Capabilities._getConfigFile());
				FileSystem.writeFile(this.mLocalRoot + Capabilities._getConfigFile(),
					JSON.stringify(this._Config), function(err) {console.log(err); } );
			}
		}
		catch (ex)
		{
			NgLogException(ex);
		}
	}
});

; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/LocalGameList'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/LocalGameList'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/LocalGameList'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class LocalGameList
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var Proc = require('NGCore/Client/Core/Proc').Proc;
var Class = require('NGCore/Client/Core/Class').Class;
var MessageListener = require('NGCore/Client/Core/MessageListener').MessageListener;
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var Capabilities = require('NGCore/Client/Core/Capabilities').Capabilities;
var Base64 = require('NGCore/Client/Core/Base64').Base64;
var toMD5 = require('NGCore/Client/Core/toMD5').toMD5;
var Util = require('NGCore/Client/Network/Util').Util;
var LifecycleEmitter = require('NGCore/Client/Device/LifecycleEmitter').LifecycleEmitter;

////////////////////////////////////////////////////////////////////////////////

var LifeListener = MessageListener.subclass(
{
	initialize: function(listen)
	{
		LifecycleEmitter.addListener(this, this.onLifecycleUpdate);
		this._listener = listen;
	},

	destroy: function()
	{
		LifecycleEmitter.removeListener(this);
	},

	onLifecycleUpdate: function(event)
	{
		switch (event)
		{
			case Device.LifecycleEmitter.Event.Resume:
				this._listener.onResume();
				break;
		}
	}
});

exports.LocalGameList = Class.singleton (
/** @lends Core.LocalGameList.prototype */
{
	classname: 'LocalGameList',

	/**
	 * @class The <code>LocalGameList</code> class constructs objects that handle the loading and updating of a user's game list.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 * @constructs The default constructor. 
	 * @augments Core.Class
	 */
	initialize: function()
	{
		ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);

		new LifeListener(this);
		this.mRefCount = 0;
		this.mRefTable = [];
		this.mSpaceAvailable = 0;
		this.mRequiredAvailableSpace = 0;
		
		this.mSpaceCB = [];

		this._getRepoSpaceSendGen();

		var self = this;
		var KeyValueCache = require('NGCore/Client/Storage/KeyValue').KeyValueCache;
		this.mGameStore = KeyValueCache.global("Core.GameList");
		this.mActiveGameKey = "activeGames";
		this.onResume();
	},


	/** @private */
	onResume: function()
	{
		this._reloadGameList();
	},

	_reloadGameList: function()
	{
		this.mGameStore.getItem(this.mActiveGameKey,
			(function(error, value)
			{
				var list;
				if (value)
					list = JSON.parse(value);
				else
					list = [];

				this.mGameList = list;
				if (typeof this.mListListen == 'function')
					this.mListListen();
			}).bind(this),
			true
		);
	},

	/** @private */
	setListListener: function(funk)
	{
		this.mListListen = funk;
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 302
	// Method create = -1
	// Method updateGame = 2
	// Method updateDone = 3
	// Method getRepoSpace = 4
	// Method repoSpace = 5
	// Method deleteGame = 6
	// Method _setUpdateProgressVisible = 7
	// Method _setUpdateProgressBounds = 8
	// Method pauseUpdate = 9
	// Method resumeUpdate = 10
	// Method cancelUpdate = 11
	// Method updateProgress = 12
	// Method runGame = 13
	// Method finishGame = 14
	// Method _forwardException = 15
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Proc.parseInt( cmd.shift(), 10 );
			var instance = ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 3:
					instance._updateDoneRecv( cmd );
					break;
				case 5:
					instance._repoSpaceRecv( cmd );
					break;
				case 12:
					instance._updateProgressRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in LocalGameList._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in LocalGameList._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[302] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_updateDoneRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in LocalGameList.updateDone from command: " + cmd );
			return false;
		}
		
		obj[ "id" ] = Proc.parseInt( cmd[ 0 ] );
		if( obj[ "id" ] === undefined )
		{
			NgLogE("Could not parse id in LocalGameList.updateDone from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Proc.parseString( cmd[ 1 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in LocalGameList.updateDone from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_repoSpaceRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in LocalGameList.repoSpace from command: " + cmd );
			return false;
		}
		
		obj[ "space" ] = Proc.parseInt( cmd[ 0 ] );
		if( obj[ "space" ] === undefined )
		{
			NgLogE("Could not parse space in LocalGameList.repoSpace from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_updateProgressRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 4 )
		{
			NgLogE("Could not parse due to wrong argument count in LocalGameList.updateProgress from command: " + cmd );
			return false;
		}
		
		obj[ "url" ] = Proc.parseString( cmd[ 0 ] );
		if( obj[ "url" ] === undefined )
		{
			NgLogE("Could not parse url in LocalGameList.updateProgress from command: " + cmd );
			return false;
		}
		
		obj[ "cur" ] = Proc.parseInt( cmd[ 1 ] );
		if( obj[ "cur" ] === undefined )
		{
			NgLogE("Could not parse cur in LocalGameList.updateProgress from command: " + cmd );
			return false;
		}
		
		obj[ "total" ] = Proc.parseInt( cmd[ 2 ] );
		if( obj[ "total" ] === undefined )
		{
			NgLogE("Could not parse total in LocalGameList.updateProgress from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Proc.parseBool( cmd[ 3 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in LocalGameList.updateProgress from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Proc.appendToCommandString( ":302,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_updateGameSendGen: function( url, id )
	{
		Proc.appendToCommandString( ":302,2," + this.__objectRegistryId + "," + Base64.encode( url ) + "," + id  );
	},
	
	/** @private */
	_getRepoSpaceSendGen: function(  )
	{
		Proc.appendToCommandString( ":302,4," + this.__objectRegistryId );
	},
	
	/** @private */
	_deleteGameSendGen: function( mdFive )
	{
		Proc.appendToCommandString( ":302,6," + this.__objectRegistryId + "," + Base64.encode( mdFive )  );
	},
	
	/** @private */
	__setUpdateProgressVisibleSendGen: function( visible )
	{
		Proc.appendToCommandString( ":302,7," + this.__objectRegistryId + "," + ( visible ? 1 : 0 )  );
	},
	
	/** @private */
	__setUpdateProgressBoundsSendGen: function( x, y, w, h )
	{
		Proc.appendToCommandString( ":302,8," + this.__objectRegistryId + "," + x + "," + y + "," + w + "," + h  );
	},
	
	/** @private */
	_pauseUpdateSendGen: function( url )
	{
		Proc.appendToCommandString( ":302,9," + this.__objectRegistryId + "," + Base64.encode( url )  );
	},
	
	/** @private */
	_resumeUpdateSendGen: function( url )
	{
		Proc.appendToCommandString( ":302,10," + this.__objectRegistryId + "," + Base64.encode( url )  );
	},
	
	/** @private */
	_cancelUpdateSendGen: function( url )
	{
		Proc.appendToCommandString( ":302,11," + this.__objectRegistryId + "," + Base64.encode( url )  );
	},
	
	/** @private */
	_runGameSendGen: function( url )
	{
		Proc.appendToCommandString( ":302,13," + this.__objectRegistryId + "," + Base64.encode( url )  );
	},
	
	/** @private */
	_finishGameSendGen: function(  )
	{
		Proc.appendToCommandString( ":302,14," + this.__objectRegistryId );
	},
	
	/** @private */
	__forwardExceptionSendGen: function( exceptionString )
	{
		Proc.appendToCommandString( ":302,15," + this.__objectRegistryId + "," + Base64.encode( exceptionString )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// updateGame: function( url, id ) {}
	
	// _updateDoneRecv: function( cmd ) {}
	// getRepoSpace: function(  ) {}
	
	// _repoSpaceRecv: function( cmd ) {}
	// deleteGame: function( mdFive ) {}
	
	// _setUpdateProgressVisible: function( visible ) {}
	
	// _setUpdateProgressBounds: function( x, y, w, h ) {}
	
	// pauseUpdate: function( url ) {}
	
	// resumeUpdate: function( url ) {}
	
	// cancelUpdate: function( url ) {}
	
	// _updateProgressRecv: function( cmd ) {}
	// runGame: function( url ) {}
	
	// finishGame: function(  ) {}
	
	// _forwardException: function( exceptionString ) {}
	

// {{/Wg Generated Code}}
	
	_setProgressVisible: function (progressVisible) {
		this.progressVisible = progressVisible;
		this.__setUpdateProgressVisibleSendGen(progressVisible);
	},
	
	_setProgressBounds: function(bounds) {
		this.__setUpdateProgressBoundsSendGen(bounds[0],bounds[1],bounds[2],bounds[3]);
	},
	
	_createProcSwitchDialog: function(title)
	{
		var UI = require('NGCore/Client/UI').UI;
		var Device = require('NGCore/Client/Device').Device;
		var w = NGWindow.outerWidth;
		var h = NGWindow.outerHeight;
		
		if(Device.OrientationEmitter.getInterfaceOrientation() == Device.OrientationEmitter.Orientation.Landscape
			|| Device.OrientationEmitter.getInterfaceOrientation() == Device.OrientationEmitter.Orientation.LandscapeLeft)
		{
			w = NGWindow.outerHeight;
			h = NGWindow.outerWidth;
		}
		
		var r = new UI.ViewGeometry.Rect(0, 0, w, h);
		
		var background = new UI.View({
			'frame': r.array(),
			'title': title,
			'backgroundColor': "8000"
		});
		
		r.inset(Math.round( (h - 238) / 2.0 ), 10);
		
		var dialog = new UI.View({
			'frame': r.array(),
			'gradient': {
				gradient: ["FF102031 0.0", "FF102031 0.394", "FF101820 0.394", "FF101820 1.0"],
				outerLine: "FF9c 1.0"
			}
		});
		background.addChild(dialog);

		r.x = r.y = 0;
		
		var header = new UI.Label({
			'frame': r.sliceVertical(94).array(),
			'text': (title || "Please Wait…"),
			'textColor': "FFFF",
			'textShadow': "8000 1.0 {0,-1}",
			'textSize': 24.0,
			'textGravity': [0.0, 0.5],
			'textInsets': [10, 30, 10, 30]
		});
		dialog.addChild(header);
		
		r.inset(36, 36 + Math.floor( (r.w - r.h) / 2));
		r.h = r.w;
		
		var spinner = new UI.Spinner({
			'frame': r.array()
		});
		dialog.addChild(spinner);
		
		UI.Window.document.addChild(background);
		
		return background;
	},

	/**
	* Restart the current game
	*/
	restartGame: function()
	{
		this.runGame(Capabilities.getServer() + "/" + Capabilities.getGame());
	},

	/**
	* Launch a game from the specified URL.
	* @param {String} url The specified URL of a game. Null to return to mobage.
	*/
	
	runGame: function( url )
	{
		console.log("Calling runGame with " + url);
		if (!url)
		{
			console.log("Finishing");
			this._finishGame();
		}
		else
		{
			this._runGameSendGen(Util.NormalizeUrl(url));
		}
	},

/** private */
	_finishGame: function()
	{
		this._finishGameSendGen();
	},

	// Next 5 functions are for mobage, not developers.

	// callback = function(gameUrl, dl'd, total, error)
	// mobage responsibility to intercept when dl'd == total, update is finished
	//	or know if there was an error by checking that param

	listenUpdates: function(callback)
	{
		this.mUpdateListener = callback;
	},

	stopUpdateListening: function()
	{
		delete this.mUpdateListener;
	},

	pauseUpdate: function(url)
	{
		this._pauseUpdateSendGen(Util.NormalizeUrl(url));
	},

	resumeUpdate: function(url)
	{
		this._resumeUpdateSendGen(Util.NormalizeUrl(url));
	},

	cancelUpdate: function(url)
	{
		this._cancelUpdateSendGen(Util.NormalizeUrl(url));
	},

	/**
	* Update an application at the specified URL.
	* @example Core.LocalGameList.updateGame(url, (function(err)
	*	{
	*		if (err)
	*		{
	*			NgLogE("GameHub error updating game! " + err);
	*			Network.Util.showSimpleNetworkError();
	*			this._loadingGame = false;
	*		}
	*		else
	*		{
	*			Core.LocalGameList.runGame(url);
	*		}
	*	});
	* @param {String} url The specified URL.
	* @param {Function} cb The callback function to pass in.
	*/
	
	updateGame: function( url , cb )
	{
		var reqId = this.mRefCount;
		this.mRefTable[this.mRefCount++] = cb;

		this._updateGameSendGen( Util.NormalizeUrl(url), reqId );
		return reqId;
	},
	
	/**
	* Launch an updated application from the specified URL.
	* @example Core.LocalGameList.runUpdatedGame('/games/MyGames');
	* @param {String} url The specified URL of an updated application.
	*/
	
	runUpdatedGame: function (url)
	{
		if (!url)
		{
			this._finishGame();
			return;
		}

		this.updateGame(url,
			(function(err)
			{
				if (err)
				{
					NgLogE("LGL Error updating game! " + err);
					Util.showFatalErrorDialog();
				}
				else
				{
					this.runGame(url);
				}
			}).bind(this)
		);
	},

	_updateProgressRecv: function( cmd )
	{
		var obj = {};
		this._updateProgressRecvGen(cmd, obj);
		if (this.mUpdateListener)
			this.mUpdateListener(obj.url, obj.cur, obj.total, obj.error);
	},

	_updateDoneRecv: function( cmd )
	{
		var obj = {};
		this._updateDoneRecvGen(cmd, obj);

		this._reloadGameList();

		var cb = this.mRefTable[obj.id];
		if (cb)
		{
			cb(obj.error);
		}

		delete this.mRefTable[obj.id];
		this._getRepoSpaceSendGen();
	},

	_repoSpaceRecv: function( cmd )
	{
		var obj = {};
		this._repoSpaceRecvGen(cmd, obj);
		this.mSpaceAvailable = obj.space - 7340032; // KJ report 7mb less
		console.log('LocalGameList.got response:', this.mSpaceAvailable, 'and need:', this.mRequiredAvailableSpace);
		
		if(this.mRequiredAvailableSpace > this.mSpaceAvailable)
		{
			var errorAlert = new UI.AlertDialog();
			errorAlert.setText(Core.Localization.getString("SD card is full"));
			errorAlert.setChoices([Core.Localization.getString("Exit")]);
			errorAlert.game = this.game;
			errorAlert.onchoice = function(ret)
			{
				errorAlert.hide();
				LifecycleEmitter.exitProcess();
			};
			errorAlert.show();
		}
		else
		{
			for(var i=0; i < this.mSpaceCB.length; ++i)
			{
				this.mSpaceCB[i]();
			}
			this.mSpaceCB = [];
			this.mRequiredAvailableSpace = 0;
		}
	},

	/**
	 * @private
	 */
	getGameList: function()
	{
		// Caveat! This will return an empty list if it is the first call. Must initialize beforehand.-KJ
		return this.mGameList;
	},

	/**
	 * @private
	 */
	updateGameList: function(list)
	{
		this.mGameList = list;
	},

	/**
	 * @private
	 */
	freeSpace: function(space, cb)
	{
		this.mRequiredAvailableSpace += space;
		
		this.mSpaceCB.push(cb);
		console.log('LocalGameList.freeSpace space=', this.mRequiredAvailableSpace);
		if(this.mSpaceCB.length == 1)
		{
			console.log('LocalGameList.sending request to native');
			// Send request to native if this is the first requester.
			this._getRepoSpaceSendGen();
		}
	},

	/**
	 * @private
	 */
	deleteGame: function(url)
	{
		url = Util.NormalizeUrl(url);
		var hash = toMD5(url);
		this._deleteGameSendGen(hash);

		var self = this;
		var doneCB = function ()
		{
			NgLogD("LocalGameList finished deleting game from " + self.mActiveGameKey + " for " + hash );
		};

		// Update cached game list to match what's going to happen in high-priv.
		// Matches logic in _LocalGameList._deleteGameFromStorage, but doesn't
		// write to Storage key.
		if( this.mGameList )
		{
			var list = this.mGameList;
			var good = false;
			var ind;
			var out = [];
			for(ind = 0; ind < list.length; ++ind)
			{
				if(list[ind].name == hash)
					good = true;
				else
					out.push(list[ind]);
			}

			if( good )
			{
				NgLogD("LocalGameList found and removed " + hash);
				this.mGameList = out;
			}
			else
				NgLogD("LocalGameList failed to find and remove " + hash);
		}
		else
			NgLogD("LocalGameList cache not warm, can't remove " + hash);
	},

	/**
	 * Check if an update is available for the specified application.<br><br>
	 * The following code illustrates how to retrieve an application name to pass in for this call.
	 * @param {String} game The specified game. Use <code>{@link Core.Capabilities.getGame}</code> to return the game name.
	 * @param {Function} callback The function to call once the check is complete.
	 * @example
	 *
	 * updateButton.onclick = function() {
	 *     LocalGameList.updateAvailable(Core.Capabilities.getUrl(), function(updated, spaceNeeded) {
	 *         if (updated)
	 *             LGL.runUpdatedGame(Core.Capabilities.getUrl());
	 *     });
	 * };
	 * @status
	 */
	updateAvailable: function(game, doneCB, errorCB)
	{
		var _int_LGL = require('NGCore/Client/Core/_int_LGL')._int_LGL;
		_int_LGL.updateAvailable(game, doneCB, errorCB);
	},

	_forwardException: function( exceptionString )
	{
		this.__forwardExceptionSendGen({exceptionString:exceptionString});
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device'] || {}; $MODULE_REGISTRY['NGCore/Client/Device'] = exports; /**
 * <p>Classes and objects contained by the Device module.</p>
 * @name Device
 * @namespace
 * @description <p>The Device module is a collection of classes that support the effect of physical movement on a device.
 * Each class instantiates a device singleton that emits when specific device conditions are met:</p>
 *<ul>
 *<li><code>{@link Device.KeyEmitter}</code>: A singleton object for emitting when the user presses or releases a device hardware key.</li>
 *<li><code>{@link Device.LifecycleEmitter}</code>: A singleton object for emitting when device lifecycle events occur.</li>
 *<li><code>{@link Device.LocationEmitter}</code>: A singleton object for emitting the geographic location of a device.</li>
 *<li><code>{@link Device.MemoryEmitter}</code>: A singleton object for emitting when low-memory states occur on a device.</li>
 *<li><code>{@link Device.MotionEmitter}</code>: A singleton object for emitting objects that collect spatial data from a device.</li>
 *<li><code>{@link Device.NetworkEmitter}</code>: A singleton object for emitting when a change in network status occurs for a device.</li>
 *<li><code>{@link Device.OrientationEmitter}</code>: A singleton object for emitting when a change to the physical orientation of the device occurs.</li>
 *<li><code>{@link Device.ShakeEmitter}</code>: A singleton object for emitting when the device detects a shake gesture.</li>
 *</ul>
 */
exports.Device = {};

exports.Device.__defineGetter__("LifecycleEmitter", function() {
	delete this.LifecycleEmitter;
	return this.LifecycleEmitter = require('NGCore/Client/Device/LifecycleEmitter').LifecycleEmitter;
});
exports.Device.__defineGetter__("LocationEmitter", function() {
	delete this.LocationEmitter;
	return this.LocationEmitter = require('NGCore/Client/Device/LocationEmitter').LocationEmitter;
});
exports.Device.__defineGetter__("MemoryEmitter", function() {
	delete this.MemoryEmitter;
	return this.MemoryEmitter = require('NGCore/Client/Device/MemoryEmitter').MemoryEmitter;
});
exports.Device.__defineGetter__("MotionEmitter", function() {
	delete this.MotionEmitter;
	return this.MotionEmitter = require('NGCore/Client/Device/MotionEmitter').MotionEmitter;
});
exports.Device.__defineGetter__("NetworkEmitter", function() {
	delete this.NetworkEmitter;
	return this.NetworkEmitter = require('NGCore/Client/Device/NetworkEmitter').NetworkEmitter;
});
exports.Device.__defineGetter__("OrientationEmitter", function() {
	delete this.OrientationEmitter;
	return this.OrientationEmitter = require('NGCore/Client/Device/OrientationEmitter').OrientationEmitter;
});
exports.Device.__defineGetter__("ShakeEmitter", function() {
	delete this.ShakeEmitter;
	return this.ShakeEmitter = require('NGCore/Client/Device/ShakeEmitter').ShakeEmitter;
});
exports.Device.__defineGetter__("KeyEmitter", function() {
	delete this.KeyEmitter;
	return this.KeyEmitter = require('NGCore/Client/Device/KeyEmitter').KeyEmitter;
});
exports.Device.__defineGetter__("PushNotificationEmitter", function() {
	delete this.PushNotificationEmitter;
	return this.PushNotificationEmitter = require('NGCore/Client/Device/_PushNotificationEmitter').PushNotificationEmitter;
});
exports.Device.__defineGetter__("InAppPurchaseEmitter", function() {
	delete this.InAppPurchaseEmitter;
	return this.InAppPurchaseEmitter = require('NGCore/Client/Device/_InAppPurchaseEmitter').InAppPurchaseEmitter;
});
exports.Device.__defineGetter__("InAppPurchase", function() {
	delete this.InAppPurchase;
	return this.InAppPurchase = require('NGCore/Client/Device/_InAppPurchase').InAppPurchase;
});
exports.Device.__defineGetter__("IPCEmitter", function() {
	delete this.IPCEmitter;
	return this.IPCEmitter = require('NGCore/Client/Device/IPCEmitter').IPCEmitter;
});
exports.Device.__defineGetter__("LayoutEmitter", function() {
	delete this.LayoutEmitter;
	return this.LayoutEmitter = require('NGCore/Client/Device/LayoutEmitter').LayoutEmitter;
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core'] || {}; $MODULE_REGISTRY['NGCore/Client/Core'] = exports; /**
 * <p>Classes and objects contained by the Core module.</p>
 * @name Core
 * @namespace
 * @description <p>The Core module is a collection of classes that provide applications with access to:</p>
 * <ul>
 * <li>Core components of a device.</li>
 * <li>APIs that define a class-based structure for development.</li>
 * <li>Objects that support application updates.</li>
 * </ul>
 * <p>Each class handles a specific aspect of the module implementation and contains APIs that support the class:</p>
 * <ul>
 * <li><code>{@link Core.Analytics}</code>: Construct objects that keep track of game-specific items that require analysis and counting.</li>
 * <li><code>{@link Core.Capabilities}</code>: A singleton object that contains data about device hardware components.</li>
 * <li><code>{@link Core.Class}</code>: Supports construction of objects and classes for use in OOP environments.</li>
 * <li><code>{@link Core.Color}</code>: Control the RGB color components of a device.</li>
 * <li><code>{@link Core.LocalGameList}</code>: Construct objects that manage a user's game list.</li>
 * <li><code>{@link Core.MessageEmitter}</code>: A base class object for constructing objects that emit application notifications.</li>
 * <li><code>{@link Core.MessageListener}</code>: A base class object for constructing objects that handle application notifications.</li>
 * <li><code>{@link Core.NativeAppLaunch}</code>: Construct objects for storing <code>intent</code> strings.</li>
 * <li><code>{@link Core.Point}</code>: Control the point values for <i>x</i> and <i>y</i> coordinates.</li>
 * <li><code>{@link Core.Rect}</code>: Construct rectangle objects.</li>
 * <li><code>{@link Core.Size}</code>: Control the values for <i>height</i> and <i>width</i> components.</li>
 * <li><code>{@link Core.Time}</code>: A singleton that contains data about device timing values.
 * <li><code>{@link Core.UpdateEmitter}</code>: Control the application update time rate.</li>
 * <li><code>{@link Core.Vector}</code>: Control the vector values for <i>x</i> and <i>y</i> coordinates.</li>
 * </ul>
 */
exports.Core = {};

exports.Core.__defineGetter__("Analytics", function() {
	delete this.Analytics;
	return this.Analytics = require('NGCore/Client/Core/Analytics').Analytics;
});
exports.Core.__defineGetter__("Base64", function() {
	delete this.Base64;
	return this.Base64 = require('NGCore/Client/Core/Base64').Base64;
});
exports.Core.__defineGetter__("Capabilities", function() {
	delete this.Capabilities;
	return this.Capabilities = require('NGCore/Client/Core/Capabilities').Capabilities;
});
exports.Core.__defineGetter__("Class", function() {
	delete this.Class;
	return this.Class = require('NGCore/Client/Core/Class').Class;
});
exports.Core.__defineGetter__("Color", function() {
	delete this.Color;
	return this.Color = require('NGCore/Client/Core/Color').Color;
});
exports.Core.__defineGetter__("Vector", function() {
	delete this.Vector;
	return this.Vector = require('NGCore/Client/Core/Vector').Vector;
});
exports.Core.__defineGetter__("Point", function() {
	delete this.Point;
	return this.Point = require('NGCore/Client/Core/Point').Point;
});
exports.Core.__defineGetter__("Size", function() {
	delete this.Size;
	return this.Size = require('NGCore/Client/Core/Size').Size;
});
exports.Core.__defineGetter__("Rect", function() {
	delete this.Rect;
	return this.Rect = require('NGCore/Client/Core/Rect').Rect;
});
exports.Core.__defineGetter__("MessageEmitter", function() {
	delete this.MessageEmitter;
	return this.MessageEmitter = require('NGCore/Client/Core/MessageEmitter').MessageEmitter;
});
exports.Core.__defineGetter__("MessageListener", function() {
	delete this.MessageListener;
	return this.MessageListener = require('NGCore/Client/Core/MessageListener').MessageListener;
});
exports.Core.__defineGetter__("ObjectRegistry", function() {
	delete this.ObjectRegistry;
	return this.ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
});
exports.Core.__defineGetter__("Time", function() {
	delete this.Time;
	return this.Time = require('NGCore/Client/Core/Time').Time;
});
exports.Core.__defineGetter__("toMD5", function() {
	delete this.toMD5;
	return this.toMD5 = require('NGCore/Client/Core/toMD5').toMD5;
});
exports.Core.__defineGetter__("SHA1", function() {
	delete this.SHA1;
	return this.SHA1 = require('NGCore/Client/Core/SHA1').SHA1;
});
exports.Core.__defineGetter__("UpdateEmitter", function() {
	delete this.UpdateEmitter;
	return this.UpdateEmitter = require('NGCore/Client/Core/UpdateEmitter').UpdateEmitter;
});
exports.Core.__defineGetter__("Proc", function() {
	delete this.Proc;
	return this.Proc = require('NGCore/Client/Core/Proc').Proc;
});
exports.Core.__defineGetter__("Logger", function() {
	delete this.Logger;
	return this.Logger = require('NGCore/Client/Core/Logger').Logger;
});
exports.Core.__defineGetter__("LocalGameList", function() {
	delete this.LocalGameList;
	return this.LocalGameList = require('NGCore/Client/Core/LocalGameList').LocalGameList;
});
exports.Core.__defineGetter__("Localization", function() {
	delete this.Localization;
	return this.Localization = require('NGCore/Client/Core/Localization').Localization;
});
exports.Core.__defineGetter__("_LocalGameList", function() {
	delete this._LocalGameList;
	return this._LocalGameList = require('NGCore/Client/Core/_LocalGameList')._LocalGameList;
});
exports.Core.__defineGetter__("NativeAppLaunch", function() {
	delete this.NativeAppLaunch;
	return this.NativeAppLaunch = require('NGCore/Client/Core/NativeAppLaunch').NativeAppLaunch;
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Capabilities'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Capabilities'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Capabilities'] = exports; 	////////////////////////////////////////////////////////////////////////////////
// Class Capabilities
//
// Copyright (C) 2011 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


var Class = require('NGCore/Client/Core/Class').Class;
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var Proc = require('NGCore/Client/Core/Proc').Proc;

////////////////////////////////////////////////////////////////////////////////

exports.Capabilities = Class.singleton(
/** @lends Core.Capabilities.prototype */
{
	classname: 'Capabilities',
	_configFile: 'configuration.json',

	/**
	 * @class The <code>Capabilities</code> class constructs a singleton object that contains device properties. These objects represent the device and provide access to device information. 
	 * This class also provides information about how a device and game servers communicate.
	 * <br><br>
	 * <b>Note:</b> An application should never directly allocate a singleton.
	 * @constructs The default constructor. 
	 * @augments Core.Class
	 * @status iOS, Android, Flash
	 */
	initialize: function()
	{
		ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);

        // Please keep this on one line, sed won't update otherwise
		this._fields = {version: 'sdks_1.3-20110930-1.3.2', buildDate: '20110930', buildHash: 'ge2bd659'};
	},

	_getConfigFile:			function() {return this._configFile;},
	_isGameLoaded:			function() {return this._fields._gamePreLoaded;},
	_getAccts:				function() {return this._fields._accts;},

	meetsBinaryVersion: function(desiredVersion)
	{
		var binary = this.getBinaryVersion().split('-').pop().split('.');
		var desired = desiredVersion.split('.');

		// A shorter length means a lower version (if all other items match)
		var meets = binary.length >= desired.length;
		var len = Math.min(desired.length, binary.length);
		for (var i = 0; i < len; ++i)
		{
			var bin = Number(binary[i]);
			var des = Number(desired[i]);
			if (bin != des)
			{
				meets = bin > des;
				break;
			}
		}
		return meets;
	},

	/**
	 * Return the object stored in configuration.json for your game.
	 * @returns {Object} The JSON.parsed object represented in your configuration.json file.
	 * @type Object
	 * @status
	 */
	getConfigs:			function() {return this._configuration;},

	/**
	 * Return the SDK version number from the <code>Capabilities</code> of this device.
	 * @returns {String} The version of the SDK on the device.
	 * @type String
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getSDKVersion:           function() { return this._fields.version; },

	/**
	 * Return the build date for the currently installed SDK. The build date is in the format <i>YYYYMMDD</i>.
	 * @returns {String} The build date for the SDK on the device.
	 * @type String
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getSDKBuildDate:           function() { return this._fields.buildDate; },
	
	/**
	 * Return the build hash of the currently installed SDK.
	 * @returns {String} The build hash for the SDK on the device.
	 * @type String
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getSDKBuildHash:           function() { return this._fields.buildHash; },

	/**
	 * Return the version of the currently running ngCore binary
	 * @returns {String} The version of ngCore running
	 * @type String
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getBinaryVersion:           function() { return this._fields.binaryVersion; },

	/**
	 * Return the build date for the currently running ngCore binary. The build date is in the format <i>YYYYMMDD</i>.
	 * @returns {String} The build date for the ngCore binary
	 * @type String
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getBinaryBuildDate:           function() { return this._fields.binaryBuildDate; },

	/**
	 * Return the build hash of the currently running ngCore binary
	 * @returns {String} The build hash for the ngCore binary
	 * @type String
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getBinaryBuildHash:           function() { return this._fields.binaryBuildHash; },
	
	/**
	 * Return the device ID. 
	 * @returns {String} The device ID for the device running the application.
	 * @type String
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getUniqueId:           function() { return this._fields.uniqueId; },

	/**
	 * Return the lifetime constant value of the device.<br><br>
	 * <b>Note:</b> Currently only available on Android.
	 * @returns {String} <code>Settings.Secure.ANDROID_ID</code>: A 64-bit number as a hex string randomly generated on first boot of the device. 
	 * <b>Note:</b> This value only changes when the device is reset.
	 * @status Android
	 */
	getLifetimeName: function() { return this._fields.lifetimeName; },
	
	/**
	 * Return the device name.
	 * @returns {String} The device name for the device running the application.
	 * @type String
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getDeviceName:         function() { return this._fields.deviceName; },
	
	/**
	 * Return the operating system.
	 * @returns {String} The operating system of the device running the application.
	 * @type String
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getPlatformOS:         function() { return this._fields.platformOs; },
	
	/**
	 * Return the operating system version number.
	 * @returns {String} The version number of the operating system running on the device.
	 * @type String
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getPlatformOSVersion:  function() { return this._fields.platformOsVersion; },
	
	/**
	 * Return the device hardware type.
	 * @returns {String} The type of device hardware running the application.
	 * @type String
	 * @status iOS, Flash, Test, iOSTested, AndroidTested
	 */
	getPlatformHW:         function() { return this._fields.platformHw; },
	
	/**
	 * Return the total amount of installed memory.
	 * @returns {Number} The amount of installed memory on the device running the application.
	 * @type Number
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getPhysicalMem:        function() { return this._fields.physicalMem; },
	
	/**
	 * Return the total number of installed CPUs.
	 * @returns {Number} The number of CPUs installed on the device running the application.
	 * @type Number
	 * @status iOS, Test, iOSTested, AndroidTested
	 */
	getPhysicalCpus:       function() { return this._fields.physicalCpus; },
	
	/**
	 * Return the number of active CPUs.
	 * @returns {Number} The number of active CPUs on the device running the application.
	 * @type Number
	 * @status iOS, Test, iOSTested, AndroidTested
	 */
	getActiveCpus:         function() { return this._fields.activeCpus; },
	
	/**
	 * Return the installed user language. 
	 * @returns {String} The installed user language on the device running the application.
	 * Expressed as a canonicalized IETF BCP 47 language identifier.
	 * @type String
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getLanguage:         function() { return this._fields.language; },

	_getBoot:         function() { return this._fields.boot; },
	_getBootServer:         function() { return this._fields.bootServer; },

	/**
	 * Return the URL for the content of this application.
	 * @returns {String} The URL to content for this application.
	 * @status
	 */
	getContentUrl:			function() {return this._fields.contentUrl;},

	/**
	 * Return the name of the root application. Root application refers to the application that launches when the user taps the application icon.
	 * @returns {String} The directory name for the root application.
	 * @status
	 */
	getBootGame:         function() { return this._fields.bootgame; },

	/**
	 * Return the starting server for an application.
	 * @returns {String} The start server.
	 * @type String
	 * @status
	 */
	getStartingServer:         function() { return this._fields.startingServer; },

	/**
	 * Return the name of the application bundled with the binary of this build.
	 * @returns {String} The name of the bundled game.
	 * @type String
	 * @status
	 */
	getBundleGame:         function() { return this._fields.bundleGame; },

	/**
	 * Return the server bundled with the binary of this build.
	 * @returns {String} The bundle server.
	 * @type String
	 * @status
	 */
	getBundleServer:         function() { return this._fields.bundleServer; },

	/**
	 * Return the bundle identifier for the binary of this build.
	 * @returns {String} The bundle identifier.
	 * @type String
	 * @status
	 */
	getBundleIdentifier:         function() { return this._fields.bundleIdentifier; },
	
	/**
	 * Return the directory name of the currently running application.
	 * @returns {String} The current folder name for the application.
	 * @type String
	 * @status iOS, Android, Flash
	 */
	getGame:         function() { return this._fields.game; },

	/**
	 * Return the server from which an application was downloaded.
	 * @returns {String} The download server.
	 * @type String
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getServer:         function() { return this._fields.server; },

	/**
	 * Return the full URL for the current application.
	 * @returns {String} The URL from which a application is downloaded.
	 * @type String
	 * @status
	 */
	getUrl:         function() { return this._fields.url; },

	/**
	 * Return the logical screen width for this device.
	 * @returns {Number} The current screen width of the device.
	 * @type Number
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getScreenWidth:        function() { return this._fields.screenWidth; },
	
	/**
	 * Return the logical screen height for this device.
	 * @returns {Number} The current screen height of the device.
	 * @type Number
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getScreenHeight:       function() { return this._fields.screenHeight; },
	
	/**
	 * Return a reasonable factor for scaling logical coordinates to the current display.
	 * @returns {Number} Logically scaled screen units for the device.
	 * @type Number
	 * @status
	 */
	getScreenUnits:        function() { return this._fields.screenUnits; },
	
	/**
	 * Return the number of physical pixels associated with one unit of logical space.
	 * @returns {Number} The total number of pixels that equal one screen unit.
	 * @type Number
	 * @status
	 */
	getScreenPixelUnits:       function() { return this._fields.screenPixelUnits; },
	
	/**
	 * Return the maximum number of supported textures.
	 * @returns {Number} The maximum number of supported textures per coordinate (<i>x</i>,<i>y</i>).
	 * @type Number
	 * @status Test, iOSTested, AndroidTested
	 */
	getMaxTextureSize:     function() { return this._fields.maxTextureSize; },
	
	/**
	 * Return the maximum number of supported texture units.
	 * @returns {Number} The maximum number of supported texture units per coordinate (<i>x</i>,<i>y</i>).
	 * @type Number
	 * @status Test, iOSTested, AndroidTested
	 */
	getMaxTextureUnits:    function() { return this._fields.maxTextureUnits; },
	
	/**
	 * @deprecated Replaced by {@link UI.GLView#getGLExtensions}.
	 */
	getOglExtensions:      function()
	{
		if (this._fields.oglExtensions)
			return this._fields.oglExtensions;

		// This table should stay in sync with:
		// https://spreadsheets.google.com/a/ngmoco.com/spreadsheet/ccc?key=0AinqDSqLOjJtdDMwNGk0eDgtRFdvQ2N0eWRUcGlsc0E&hl=en_US&authkey=CMWLyoAC
		switch (this._fields.deviceName)
		{
			case "Droid":                // Motorola Droid
			case "DROID2":               // Motorola Droid 2
			case "DROIDX":               // Motorola Droid X
			case "SGH-T959":             // Samsung Galaxy S 19000 8GB
			case "SGH-T959V":            // Samsung Galaxy S 4G
			case "SAMSUNG-SGH-I997":     // Samsung Galaxy S2
			case "SAMSUNG-SGH-I897":     // Samsung Captivate
			case "Nexus S":              // Google Nexus S
				return ["GL_IMG_texture_compression_pvrtc"];
			case "HTC Desire":           // HTC Desire GSM
			case "PC36100":              // HTC Evo 4G
			case "ADR6300":              // HTC Droid Incredible
			case "001HT":                // HTC Desire HD
			case "Nexus One":            // Google Nexus One
			case "HTC Glacier":          // HTC myTouch 4G
				return ["GL_AMD_compressed_ATC_texture"];
			default:
				return [];
		}
	},

	/**
	 * Return the directory path to the temp directory for this device.
	 * @returns {String} The directory path to the temp directory on the device.
	 * @type String
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getTmpDir:           function() { return this._fields.tmpDir; },

	/**
	 * Check the <code>Capabilities</code> of this device for an accelerometer.
	 * @returns {Boolean} Returns <code>true</code> when the device running the application contains an accelerometer.
	 * @type Boolean
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getHasAccel:           function() { return this._fields.hasAccel; },
	
	/**
	 * Check the <code>Capabilities</code> of this device for a gyroscope.
	 * @returns {Boolean} Returns <code>true</code> when the device running the application contains an gyroscope.
	 * @type Boolean
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getHasGyro:            function() { return this._fields.hasGyro; },
	
	/**
	 * Check the <code>Capabilities</code> of this device for touchscreen input support.
	 * @returns {Boolean} Returns <code>true</code> when the device running the application supports touchscreen input.
	 * @type Boolean
	 * @status iOS, Test, iOSTested, AndroidTested
	 */
	getHasTouch:           function() { return this._fields.hasTouch; },
	
	/**
	 * Check the <code>Capabilities</code> of this device for multi-touch input support.
	 * @returns {Boolean} Returns <code>true</code> when the device running the application supports multi-touch input.
	 * @type Boolean
	 * @status iOS, Test, iOSTested, AndroidTested
	 */
	getHasMultiTouch:      function() { return this._fields.hasMultiTouch; },
	
	/**
	 * Check the <code>Capabilities</code> of this device for a GPS unit.
	 * @returns {Boolean} Returns <code>true</code> when the device running the application contains a GPS unit.
	 * @type Boolean
	 * @status Android, Test, iOSTested, AndroidTested
	 */
	getHasGps:             function() { return this._fields.hasGps; },
	
	/**
	 * Check the <code>Capabilities</code> of this device for a magnetic compass.
	 * @returns {Boolean} Returns <code>true</code> when the device running the application contains a magnetic compass.
	 * @type Boolean
	 * @status Android, Test, iOSTested, AndroidTested
	 */
	getHasCompass:         function() { return this._fields.hasCompass; },
	
	/**
	 * Check the <code>Capabilities</code> of this device for a hardware keyboard.
	 * @returns {Boolean} Returns <code>true</code> when the device running the application contains a hardware keyboard.
	 * @type Boolean
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getHasHwKeyboard:      function() { return this._fields.hasHwKeyboard; },
	
	/**
	 * Check the <code>Capabilities</code> of this device for a <b>Back</b> button.
	 * @returns {Boolean} Returns <code>true</code> when the device running the application contains a <b>Back</b> button.
	 * @status
	 */
	getHasBackButton:      function() { return this._fields.hasBackButton; },

	/**
	 * Check the <code>Capabilities</code> of this device for a camera.
	 * @returns {Boolean} Returns <code>true</code> when the device running the application contains a camera.
	 * @type Boolean
	 * @status Test, iOSTested, AndroidTested
	 */
	getHasCamera:          function() { return this._fields.hasCamera; },
	
	/**
	 * Check the <code>Capabilities</code> of this device for access to a wide area network (WAN).
	 * @returns {Boolean} Returns <code>true</code> when the device running the application has access to a WAN.
	 * @type Boolean
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getHasWwan:            function() { return this._fields.hasWwan; },

	/**
	 * Check the <code>Capabilities</code> of this device for access to a Wi-Fi network.
	 * @returns {Boolean} Returns <code>true</code> when the device running the application has access to Wi-Fi.
	 * @type Boolean
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getHasWifi:            function() { return this._fields.hasWifi; },

	/**
	 * Check the <code>Capabilities</code> of this device for access to a Wi-Fi network.
	 * @returns {Boolean} Returns <code>true</code> when the device running the application has access to Wi-Fi.
	 * @status
	 */
	getCarrier:            function() { return this._fields.carrier; },

	/**
	 * Return the URL used to launch this application.
	 * @returns {String} The URL for launching this application. If the application is not launched from a URL, returns an empty string.
	 * @type String
	 * @status
	 */
	getIntentUrl:            function() { return this._fields.intentUrl; },
	
	/**
	 * Return the height of the system status bar.
	 * @returns {Number} The status bar height rounded to the nearest integer (in pixels).
	 * @type Number
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 * @status Android
	*/
     getStatusBarHeight:            function() { return this._fields.statusBarHeight; },
	
	/**
	 * Return the device locale.
	 * @returns {String} The regional location of a device.
	 * The <code>locale</code> string is a combination of ISO 639-1 and ISO 3166-1. For example, <code>en_US</code>, <code>ja_JP</code>.
	 * @type String
	 * @status
	 */
	getLocale: function() { return this._fields.locale; },

	/**
	 * Return a list of installed fonts on this device.
	 * @returns {Array (Strings)} An array of font names installed on the system or addressable by name.
	 * @type Array
	 * @status iOS, Android
	 */
	getAvailableFonts: function()
	{
		return this._deserializedFonts || (this._deserializedFonts = JSON.parse(this._fields.availableFonts));
	},
	
	/** @private */
	getAutorotateDisabled: function()
	{
		return this._fields.autorotateDisabled || false;
	},
	

	/**
	 * Return the social server used for this application.
	 * @returns {String} The social server URL. For example, partner.plusplus.com.
	 * @status
	 */	
	getSocialServer: function()
	{
		return this.socialServer;
	},

	/*
	 * Returns the name of the Mobage distribution first installed on the device.
	 * @returns {String} The name of the distribution.
	 */
	getDistributionName: function() 
	{
		return this._fields.distributionName;
	},

	/*
	 * @status
	 */	
	getSourceAppID: function()
	{
		return this._fields.sourceAppID;
	},

	/*
	 * @status Android
	 */	
	getAppSignatures: function()
	{
		return this._fields.appSignatures;
	},
	
	/*
	 * Return the release version of this application.  The value comes directly from the 
	 * configuration.json value for releaseVersion.
	 * @returns {String} The version identifier. For example, 1.1:20110607183748_blf7gety.
	 * @status
	 */
	getAppReleaseVersion: function()
	{
		return this._releaseVersion;
	},
	
	
	/** @private */
	_init: function(dict)
	{
		// parse the dict
		var ifields = [];
		NgParseCommandDictionary(dict, 2, this._fields, ifields);

		try {
			// Change server based on URL passed in
			var items = /(https?:\/\/.+?)\/(.*)/.exec(this._fields.url);
			this._fields.server = items[1];
			this._fields.game  = items[2];
		}
		catch (e)
		{
			NgLogException(e);
		}

		// KJ this is necessary because an empty string passed becomes undefined
		if (!this._fields.intentUrl)
			this._fields.intentUrl = "";

		if (this._fields.oglExtensions)
		try
		{
			this._fields.oglExtensions = JSON.parse(this._fields.oglExtensions);
		}
		catch (e)
		{
			NgLogE("Unable to parse OGL Extensions! " + this._fields.oglExtensions);
			NgLogException(e);
		}

		if (this._fields._accts)
		try
		{
			this._fields._accts = JSON.parse(this._fields._accts);
		}
		catch (e)
		{
			NgLogE("Unable to parse Accounts! " + this._fields._accts);
			NgLogException(e);
		}

		try
		{
			this._configuration = JSON.parse(this._fields.configJSON);
			this._fields.contentUrl = this._configuration.contentUrl;
			this.socialServer = this._configuration.socialServer;
			this._releaseVersion = this._configuration.releaseVersion;
		}
		catch (e)
		{
			NgLogE("Unable to parse config!! (" + this._fields.configJSON + ")");
			NgLogException(e);
		}

		console.log( "dict : JS version : " + this.getSDKVersion() );
		console.log( "dict : JS build date : " + this.getSDKBuildDate() );
		console.log( "dict : JS build hash : " + this.getSDKBuildHash() );

		console.log("dict : contentUrl : " + this._fields.contentUrl);
		console.log("dict : socialServer : " + this.socialServer);
		console.log("dict : releaseVersion : " + this._releaseVersion);
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 301
	// Method create = -1
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Proc.parseInt( cmd.shift(), 10 );
			var instance = ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Capabilities._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Capabilities._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[301] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Proc.appendToCommandString( ":301,-1," + __objectRegistryId  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	

// {{/Wg Generated Code}}
	// This kills the JSLint error for trailing comma (since we can't change the generated code)
	t: 0
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Localization'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Localization'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Localization'] = exports; var Capabilities = require('NGCore/Client/Core/Capabilities').Capabilities;
var MessageEmitter = require('NGCore/Client/Core/MessageEmitter').MessageEmitter;
var FileSystem = require('NGCore/Client/Storage/FileSystem').FileSystem;

var LocalizationEngine = exports.LocalizationEngine = MessageEmitter.subclass(
/** @lends Core.Localization.prototype */
{
	classname: 'Localization',
    
    /**
     * Specifies the directory path to language files this object will load.
     */
    directoryPath:null,
    
    /**
     * Specifies the directory path to a language file for a specific language.
     */
	languageFilePath:null,
    
	/**
	 * @class The <code>Localization</code> class provides applications with access to localized strings.
	 * Applications supply a language code corresponding to a file in <code>Content/Localization/</code> or a JSON object.<br><br> 
     * Loading of dictionary files is an anynchronous process. Applications need to listen for emitted notifications from <code>Localization</code> objects that signal when the language dictionary
     * is modified. When a <code>Localization</code> object emits a notification, localized strings are available to the application (see <code>{@link Core.MessageEmitter#emit}</code>).
	 * @constructs The default constructor.
	 * @augments Core.MessageEmitter
	 * @status iOS, Android, Flash
	 */
	initialize: function(directoryPath)
	{
		if(!directoryPath){directoryPath = "./Content/Localization/";}
	    NgLogD("Localization : init ("+directoryPath+")");
	    this.directoryPath = directoryPath;
	    
        this.setLanguage(Capabilities.getLanguage());
	},
    
	/**
	 * Aynchronously load the localization dictionary for the specified language.
     * <br><br>
	 * <b>Notes:</b> 
	 * <ul>
	 * <li>This function looks for the corresponding JSON dictionary file in the <code>Content/Localization</code> directory.
     * For example, <code>Content/Localization/fr.json</code>. If the application cannot load a dictionary, this call has no effect.</li>
     * <li><code>Localization</code> objects emit a notification with the new language string if this call succeeds.</li>
     *</ul>
	 *
	 * @example
	 * Core.Localization.addListener(listener, function()
     * {
     *     listener.label.setText(Core.Localization.getString("Hello World"));
     * });
	 * Core.Localization.setLanguage('es');
	 *
	 * @param {String} language The base name of a JSON dictionary file in <code>./Content/Language</code>.
	 * @see Core.Localization#setDictionary, 
	 * @see Core.MessageListener
	 * @status
	 */    
    setLanguage: function(language)
    {
        var dictionaryPath = this.languageFilePath = this.directoryPath + language + '.json';
        var self = this;
        NgLogD("Localization : reading json file "+ dictionaryPath);
        
		FileSystem.readFile(dictionaryPath, function(error, data)
        {
            if(error === '')
            {
                NgLogD("Localization : successfully read json file "+ dictionaryPath);  
                self.setDictionary(language, JSON.parse(data));
            }
            else
            {
                NgLogD("Localization: unable to read json file "+ dictionaryPath + ", use default english setting instead");                
            }
        });
    },

	/**
	 * Directly set the language code and localization dictionary.
     * <code>Localization</code> objects emit a message with the new language string during this call.
	 * 
	 * @example
     * var chDictionary =    
     * {
     *     "Hello World": "你好世界"
     * };
	 * Core.Localization.setDictionary('ch', chDictionary);
	 * label.setText(Core.Localization.getString("Hello World"));
	 *
	 * @param {String} language A string identifying the specified language or localization.
	 * @param {Object} dictionary An object containing key/value pairs for the specified language.
	 * @see Core.Localization#setLanguage,
	 * @see Core.MessageEmitter#emit
	 * @status
	 */    
    setDictionary: function(lang, dictionary)
    {
        this._lang = lang;
        this._dictionary = dictionary;
        this.emit(this._lang);
    },    
    
    /**
	 * Retrieve a localized string.
     * @param {String} str A localization key.
	 * @returns {String} The localized string or the provided key if the application is unable to lcoate the specified string.
	 * @status
	 */
	getString: function(str)
	{        
        if(this._dictionary && typeof this._dictionary === 'object')
        {
            var value = this._dictionary[str];
            if(value && typeof value !== 'undefined')
            {
                return value;
            }
        }
        
        return this.unknownString(str);
	},
	
	/** @protected */
	unknownString:function(str){
		NgLogD("Localization: ... No localization for "+str+" in "+this._lang);
		return str;
	}
});

/**
 * Global Localization Singleton, gets initialized when the device locale is known.
 */
exports.Localization = LocalizationEngine.singleton({});

; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Storage'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Storage'] || {}; $MODULE_REGISTRY['NGCore/Client/Storage'] = exports; /**
 * <p>Classes and objects contained by the Storage module.</p>
 * @name Storage
 * @namespace
 * @description <p>The Storage module is a collection of classes that support file manipulation operations.
 * Each class handles a specific aspect of the module implementation and contains APIs that support the class:</p>
 * <ul>
 *  <li><code>{@link Storage.FileSystem}</code>: Construct objects for reading a file, writing to a file, deleting a file, or decompressing a file.</li>
 *  <li><code>{@link Storage.KeyValue}</code>: Construct objects that store key/value pairs.</li>
 * </ul>
 * <b>Note:</b> The static method <code>KeyValueCache.global()</code> creates a <code>KeyValueCache</code> object that multiple applications can use. 
 * @param {String} globalKey The module name for the <code>KeyValueCache</code> object. The <code>global()</code> method creates a new <code>KeyValueCache</code> 
 * when the module with that name doesn't already exist.
 */
var Storage = exports.Storage = {};

Storage.__defineGetter__("KeyValue", function() {
	delete this.KeyValue;
	return this.KeyValue = require('NGCore/Client/Storage/KeyValue').KeyValue;
});
Storage.__defineGetter__("KeyValueCache", function() {
	delete this.KeyValueCache;
	return this.KeyValueCache = require('NGCore/Client/Storage/KeyValue').KeyValueCache;
});
Storage.__defineGetter__("FileSystem", function() {
	delete this.FileSystem;
	return this.FileSystem = require('NGCore/Client/Storage/FileSystem').FileSystem;
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Logger'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Logger'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Logger'] = exports; var Class = require('NGCore/Client/Core/Class').Class;
var Proc = require('NGCore/Client/Core/Proc').Proc;
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var sprintf = require('NGCore/Shared/Lib/sprintf').sprintf;
var Base64 = require('NGCore/Client/Core/Base64').Base64;

var Logger = Class.singleton(
/** @lends Core.Logger.prototype */
{
	classname: 'Logger',

	initialize: function()
	{
		ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
	},

	/** @private */
	_disable: function()
	{
		console.log("Logger : javascript logging disabled");
		console.log = Logger.log = function(message, argv) {};
	},

	_enable: function()
	{
		console.log = Logger.log = function(message, argv)
		{
			if (arguments.length > 1) {
				try {
					var params = new Array();
					for (var i = 0; i < arguments.length; ++i) {
						params[i] = arguments[i];
					}
					var result = sprintf(params);
					params.unshift(result);
					message = params.join(" ");
				} catch (err) {
					var concat = new Array();
					for (var i = 0; i < arguments.length; ++i) {
						concat[i] = arguments[i];
					}
					message = concat.join(" ");
				}
			}
			__underscore_SysLog(message);
		};

		console.log("Logger : javascript logging enabled");
	},

	/**
	 * Log a message to the development console.
	 * @param {string} message
	 * @param {Array} argv Additional arguments to log.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	log: function(message, argv)
	{
		
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 305
	// Method create = -1
	// Method log = 2
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Proc.parseInt( cmd.shift(), 10 );
			var instance = ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Logger._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Logger._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[305] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Proc.appendToCommandString( ":305,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_logSendGen: function( msg )
	{
		Proc.appendToCommandString( ":305,2," + this.__objectRegistryId + "," + Base64.encode( msg )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// log: function( msg ) {}
	

// {{/Wg Generated Code}}
	
});

Logger.instantiate();

__underscore_SysLog = function(_massage)
{
	Logger._logSendGen( _massage );
};

// JMarr Don't override console.log when on flash.
if(typeof(_NG_TARGET_FLASH) == 'undefined')
	console.log = Logger.log;

exports.Logger = Logger;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Class'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Class'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Class'] = exports; exports.Class = require('NGCore/Shared/Class').Class;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Base64'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Base64'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Base64'] = exports; exports.Base64 = require('NGCore/Shared/Lib/base64').Base64;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Plus/ResultSet'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Plus/ResultSet'] || {}; $MODULE_REGISTRY['NGCore/Client/Plus/ResultSet'] = exports; var ClassReq = require('NGCore/Client/Core/Class');
var SystemBindingReq = require('NGCore/Client/UI/SystemBinding');

var ResultSet = ClassReq.Class.subclass({
    classname: "ResultSet",
    initialize: function(continueId) {
        this.items = [];
        this._continueId = continueId;
        this.totalLength = Number.MAX_VALUE;
    },
    /*
	 * Call to getMore adds more items to items list.
	 * Please note that in the callback, it is possible that addedCount == 0
	 * in some cases.  In that case access to items[newIdx] does not yield
	 * any result
	 */
    getMore: function(cb) {
        return SystemBindingReq.SystemBinding._getMoreContacts(this, cb);
    },
    /*
	 * Releases resource used by current ResultSet.
	 *
	 * To avoid resource leakage, please call closeResultSet if getMore
	 * is not called all the way to the end.
	 */
    closeResultSet: function() {
        SystemBindingReq.SystemBinding._closeContactsResultSet(this);
    }
});

exports.ResultSet = ResultSet;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/Class'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/Class'] || {}; $MODULE_REGISTRY['NGCore/Shared/Class'] = exports; /**
 * The default constructor.
 * @constructor 
 * @class The <code>Class</code> object provides an environment for Object Oriented Programming (OOP) development in Javascript, such as Java or C++.
 * @name Core.Class
 */
var Class = function() {}
exports.Class = Class;

/**
 * Create a new class by extending another class.
 * @example
 * var MyClass = Class.subclass(
 * {
 *    initialize: function()
 *    {
 *        console.log('constructor');
 *    },
 *    foo: function(v)
 *    {
 *        console.log('MyClass.foo(' + v + ')');
 *    },
 * });
 * var myClass = new MyClass();
 * myClass.foo('param');
 * @param {Object} extensions Object literal containing new functions for the derived class.
 * @function
 * @name Core.Class.subclass
 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
 */
Class.subclass = (function()
{
/**#@+ @ignore */
	// Parse a function body and extract the parameter names.
	function argumentNames(body)
	{
		var names = body.toString().match(/^[\s\(]*function[^(]*\(([^)]*)\)/)[1]
			.replace(/\/\/.*?[\r\n]|\/\*(?:.|[\r\n])*?\*\//g, '')
			.replace(/\s+/g, '').split(',');
		return names.length == 1 && !names[0] ? [] : names;
	}
	
	// Create a function that calls overrideBody with a closure to ancestorBody.
	function overrideMethod(overrideBody, ancestorBody)
	{
		if(ancestorBody !== undefined)
		{
			// Create a function that calls overrideBody with a closure to ancestorBody as the first param.
			var override = function()
			{
				var localThis = this;
				var $super = function() { return ancestorBody.apply(localThis, arguments) };
				Array.prototype.unshift.call(arguments, $super);
				return overrideBody.apply(this, arguments);
			}
		}
		else
		{
			// Create a function that calls overrideBody with undefined as the first param, because ancestorBody is undefined.
			var override = function()
			{
				Array.prototype.unshift.call(arguments, undefined);
				return overrideBody.apply(this, arguments);
			}
		}

		// Hide our dirty tricks from the rest of the world.
		override.valueOf = function() { return overrideBody.valueOf() };
		override.toString = function() { return overrideBody.toString() };
		return override;
	}
	
	// Define some empty functions used later. This is a speed optimization.
	function TempClass() {}
	function emptyFunction() {}
	
	return function()
	{
		// Constructor for new class to be created.
		var properties = arguments[0];
		var classname = properties.classname || "AnonymousClass";
		var NewClass = eval('(function ' + classname + '(){this.initialize.apply(this, arguments)})');
		
		// Copy statics from this.
		for(var property in this)
		{
			if(!this.hasOwnProperty(property)) continue;
			NewClass[property] = this[property];
		}
		
		// Copy prototype from this.
		var ancestorPrototype = this.prototype;
		TempClass.prototype = ancestorPrototype;
		NewClass.prototype = new TempClass();
		NewClass.prototype.superclass = ancestorPrototype;
		NewClass.prototype.constructor = NewClass;
		
		// Copy properties into NewClass prototype.
		for(var property in properties)
		{
			if(!properties.hasOwnProperty(property)) continue;

			// getters / setters behave differently than normal properties.
			var getter = properties.__lookupGetter__(property)
			var setter = properties.__lookupSetter__(property)
			if(getter || setter)
			{
				if(getter)
				{
					// Copy getter into klass.
					var value = getter;
					if(argumentNames(value)[0] == "$super")
						value = overrideMethod(value, ancestorPrototype.__lookupGetter__(property));
					NewClass.prototype.__defineGetter__(property, value);
				}

				if(setter)
				{
					// Copy setter into klass.
					var value = setter;
					if(argumentNames(value)[0] == "$super")
						value = overrideMethod(value, ancestorPrototype.__lookupSetter__(property));
					NewClass.prototype.__defineSetter__(property, value);
				}
			}
			else
			{
				var value = properties[property];
				if(typeof value === "function" && property[0] != '$')
				{
					if(argumentNames(value)[0] == "$super")
					{
						// Create override method if first param is $super.
						value = overrideMethod(value, ancestorPrototype[property]);
					}
					else if(property == 'initialize')
					{
						var ancestorInitialize = ancestorPrototype.initialize
						if(ancestorInitialize)
						{
							// Automatically call inherited constructor.
							var derivedInitialize = value;
							value = function()
							{
								ancestorInitialize.apply(this, arguments);
								derivedInitialize.apply(this, arguments);
							};
						}
					}
					else if(property == 'destroy')
					{
						var ancestorDestroy = ancestorPrototype.destroy
						if(ancestorDestroy)
						{
							// Automatically call inherited destructor.
							var derivedDestroy = value;
							value = function()
							{
								derivedDestroy.apply(this, arguments);
								ancestorDestroy.apply(this, arguments);
							};
						}
					}

					// Copy function into new class prototype.
					NewClass.prototype[property] = value;
				}
				else
				{
					if(property[0] == '$')
						property = property.slice(1);

					// Copy enum into new class and the prototype.
					NewClass[property] = value;
					NewClass.prototype[property] = value;
				}
			}
		}
		
		// Make sure the is an initialize function.
		if(!NewClass.prototype.initialize)
			NewClass.prototype.initialize = emptyFunction;

		return NewClass;
	}
/**#@-*/
})();

/**
 * Create a singleton by extending a class.
 * @example
 * var MySingleton = Class.singleton(
 * {
 *    initialize: function()
 *    {
 *        console.log('constructor');
 *    },
 *    foo: function(v)
 *    {
 *        console.log('MyClass.foo(' + v + ')');
 *    },
 * });
 * MySingleton.foo('param');
 * @param {Object} extensions Object literal containing new functions for the singleton.
 * @function
 * @name Core.Class.singleton
 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
 */
Class.singleton = function()
{
	// Create sublcass as normal.
	var tempClass = this.subclass.apply(this, arguments);
	
	// Hide the initialize.
	var initialize = tempClass.prototype.initialize;
	tempClass.prototype.initialize = function() {};
	
	// Now instantiate.
	var instance = new tempClass();
	
	// Hide every prototype function with an instance function that calls initialize.
	var functions = [];
	/** 
	 * Ensure that the singleton has been created and fully initialized.
	 * @status iOS, Android, Flash
	*/
	var instantiate = function(real)
	{
		// Delete all of the instance functions we added.
		for(var i in functions)
		{
			var func = functions[i];
			delete instance[func];
		}
		
		// Restore the initialize function and call it.
		instance.initialize = initialize;
		instance.initialize();
		
		// Replace instantiate method with an empty function.
		instance.instantiate = function() {};
		
		// Call the function that caused this instantiation.
		var args = Array.prototype.slice.call(arguments, 1);
		return real.apply(instance, args);
	}
	
	// Iterate over all prototype functions.
	for(var i in instance)
	{
		// Don't do anything for setters or getters.
		if(instance.__lookupGetter__(i)
			|| instance.__lookupSetter__(i))
		{
			//TODO Should put proxies here too.
			continue;
		}
			
		var value = instance[i];
		if(typeof(value) == 'function')
		{
			// Remember the function names that we added so that instantiate() can remove them.
			functions.push(i);
			
			// Add an instance function to hide the prototype function, which will call instantiate.
			instance[i] = instantiate.bind(this, value);
		}
	}
	
	// Add instantiate method.
	instance.instantiate = instantiate.bind(this, function() {});
	
	// Return the isntance.
	return instance;
}

/**
 * @ignore
 */
Class.prototype.bind = function(func)
{
	var context = this;
	if(arguments.length < 2)
	{
		// Fast path if only the 'this' pointer is being bound.
		return function()
		{
			return func.apply(context, arguments);
		}
	}
	else
	{
		// Slower path if additional parameters are being bound.
		var args = Array.prototype.slice.call(arguments, 1);
		return function()
		{
			var finalArgs = args.concat(Array.prototype.slice.call(arguments, 0));
			return func.apply(context, finalArgs);
		}
	}
}

/**
 * @ignore
 */
Class.prototype.toString = function()
{
	return this.constructor.name;
}

// Debug implementation that will replace every method in destroyed objects with a grenade.
/*Class.prototype.destroy = function()
{
	function suicide()
	{
		throw new Error('Function called on destroyed object');
	}
	
	for(var i in this)
	{
		var value = this[i];
		if(typeof(value) == 'function')
		{
			this[i] = suicide;
		}
	}
}*/
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/Lib/base64'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/Lib/base64'] || {}; $MODULE_REGISTRY['NGCore/Shared/Lib/base64'] = exports; /**
* @description
* Takes a string and encodes or decodes base-64.
* @class Base64
* @see http://coderepos.org/share/browser/lang/javascript/Base64/trunk/base64.js
*
**/

/*
 * $Id: base64.js,v 1.1 2009/03/01 22:38:45 dankogai Exp dankogai $
 *
 * History:
 *   dankogai's original: character-based
 *   drry's fix: split string to array then join
 *   new version: regexp-based
 */

var Base64 = (function() {
    var b64chars
        = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';
    var b64tab = function(bin){
        var t = {};
        for (var i = 0, l = bin.length; i < l; i++) {
            t[bin.charAt(i)] = i;
        }
        return t;
    }(b64chars);

    var fromCharCode = String.fromCharCode;

    var sub_toBase64 = function(m){
        var n = (m.charCodeAt(0) << 16)
              | (m.charCodeAt(1) <<  8)
              | (m.charCodeAt(2)      );
        return b64chars.charAt( n >>> 18)
             + b64chars.charAt((n >>> 12) & 63)
             + b64chars.charAt((n >>>  6) & 63)
             + b64chars.charAt( n         & 63);
    };

    var toBase64 = function(bin){
        if (bin.match(/[^\x00-\xFF]/)) {
            throw 'unsupported character found';
        }
        var padlen = 0;
        while(bin.length % 3) {
            bin += '\x00';
            padlen++;
        }
        var b64 = bin.replace(/[\x00-\xFF]{3}/g, sub_toBase64);
        if (!padlen) return b64;
        b64 = b64.substr(0, b64.length - padlen);
        while(padlen--) b64 += '=';
        return b64;
    };

    // use native btoa() if it exists
    var _btoa = typeof(btoa) !== "undefined" ? btoa : toBase64;

    var sub_fromBase64 = function(m){
            var n = (b64tab[ m.charAt(0) ] << 18)
                |   (b64tab[ m.charAt(1) ] << 12)
                |   (b64tab[ m.charAt(2) ] <<  6)
                |   (b64tab[ m.charAt(3) ]);
        return fromCharCode(  n >> 16 )
            +  fromCharCode( (n >>  8) & 0xff )
            +  fromCharCode(  n        & 0xff );
    };

    var fromBase64 = function(b64){
        b64 = b64.replace(/[^A-Za-z0-9\+\/]/g, '');
        var padlen = 0;
        while(b64.length % 4){
            b64 += 'A';
            padlen++;
        }
        var bin = b64.replace(/[A-Za-z0-9\+\/]{4}/g, sub_fromBase64);
        bin.length -= [0,0,2,1][padlen];
        return bin;
    };

    // use native atob() if it exists
    var _atob = typeof(atob) !== "undefined" ? atob : fromBase64;

    var re_char_nonascii = /[^\x00-\xFF]/g;

    var sub_char_nonascii = function(m){
        var n = m.charCodeAt(0);
        return n < 0x800 ? fromCharCode(0xc0 | (n >>>  6))
                         + fromCharCode(0x80 | (n & 0x3f))
            :              fromCharCode(0xe0 | ((n >>> 12) & 0x0f))
                         + fromCharCode(0x80 | ((n >>>  6) & 0x3f))
                         + fromCharCode(0x80 |  (n         & 0x3f))
            ;
    };

    var utob = function(uni){
        return uni.replace(re_char_nonascii, sub_char_nonascii);
    };

    var re_bytes_nonascii
        = /[\xC0-\xDF][\x80-\xBF]|[\xE0-\xEF][\x80-\xBF]{2}|[\xF0-\xF7][\x80-\xBF]{3}/g;

    var sub_bytes_nonascii = function(m){
        var c0 = m.charCodeAt(0);
        var c1 = m.charCodeAt(1);
        if(c0 < 0xe0){
            return fromCharCode(((c0 & 0x1f) << 6) | (c1 & 0x3f));
        }else{
            var c2 = m.charCodeAt(2);
            return fromCharCode(
                ((c0 & 0x0f) << 12) | ((c1 & 0x3f) <<  6) | (c2 & 0x3f)
            );
        }
    };

    var btou = function(bin){
        return bin.replace(re_bytes_nonascii, sub_bytes_nonascii);
    };
    return {
        fromBase64:fromBase64,
        toBase64:toBase64,
        atob:_atob,
        btoa:_btoa,
        utob:utob,
        btou:btou,
        /**
        * @description
        * Takes an input value and returns a base-64 encoded string.
        * @name Base64.encode
        * @function
        * @param String input The input to return as a base-64 encoded string.
        * @return String A base-64 encoded string of the input parameter.
        */
        encode:function(u){
            if(!u) {
                return "";
            }
            return _btoa(utob(new String(u)));
        },
        decode:function(a){
            if(!a) {
                return "";
            }
            return btou(_atob(a.replace(/[\-_]/g, function(m0){
                return m0 == '-' ? '+' : '/';
            })));
        }
    };
})();

exports.Base64 = Base64;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/Commands'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/Commands'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/Commands'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class Commands
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


var Core = require('NGCore/Client/Core').Core;

////////////////////////////////////////////////////////////////////////////////

function UIAnimationOptions() {
	this.animationCurve = "EaseInOut";
	return this;
}

var Commands = exports.Commands = Core.Class.singleton(
/** @lends UI.Commands.prototype */
{
	/**
	 * @name UI.Commands
	 * @class 
	 * @augments Core.Class
	 */
	/** 
	 * @field
	 */
	classname: 'Commands',
	
	/**
	 * @constructs
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this.initializeNative(this.__objectRegistryId);
		this._tempCBs = {};
		this._tempCBCount = 0;
	},
	
// {{?Wg Generated Code}}
	
	// Enums.
	/** 
			* Enumeration for image fit modes.
			* Image Fit is always applied relative to view bounds *after* content insets are applied.
			* @namespace
			 */
	FitMode:
	{ 
		/** The image content is not scaled at all. */
		None: 0,
		/** The image will be aspect-scaled to fit completely within the view. */
		Inside: 1,
		/** The image will be aspect-scaled to cover the entire view bounds. Clipping may occur. */
		Fill: 2,
		/** The image will be distorted to cover the exact view bounds. */
		Stretch: 3,
		/** The image will be aspect-scaled so its width matches the view bounds. Clipping may occur. */
		AspectWidth: 5,
		/** The image will be aspect-scaled so its height matches the view bounds. Clipping may occur. */
		AspectHeight: 6,
		/** The image will be scaled down to fit completely within the view, but not upscaled. */
		InsideNoUpscaling: 7,
	},
	
	/** 
			* Enumeration for supported units for dimensions.
			* Math.round() is your friend. Sending decimal pixel coordinates can result in unpredictable behavior on various platforms, but half- and quarter-pixels can be useful tools on iOS.
			* @namespace
			 */
	Scaling:
	{ 
		/** The native format, and the default for view bounds. No conversion will be performed. */
		Pixels: 0,
		/** Adjusted to roughly one typesetting point, downscaled from 72 to 160 dpi. */
		Points: 1,
		/** 1.0 represents 100% of the provided or implied size (usually a view width or height). */
		Unit: 2,
		/** A percentage of the provided or implied size (typically from 0 to 100). */
		Percent: 3,
		/** At this scale, the device's screen is always 320 units wide. */
		iPhone: 4,
	},
	
	/** 
			* Enumeration for text font styles.
			* @namespace
			 */
	FontStyle:
	{ 
		/** * */
		Normal: 0,
		/** * */
		Bold: 1,
		/** * */
		Italic: 2,
		/** * */
		BoldItalic: 3,
	},
	
	/** 
			* Flags for control / view states. Used in View and its subclasses.
			* When setting content and properties for states, the value with the highest id when AND'ed with the current state, but no additional bits, will be used.
			* @namespace
			 */
	State:
	{ 
		/** The view is in an unexceptional state. */
		Normal: 0x00,
		/** * */
		Focused: 0x01,
		/** * */
		Selected: 0x02,
		/** * */
		Pressed: 0x04,
		/** * */
		Checked: 0x08,
		/** * */
		Custom: 0x00FF0000,
		/** * */
		Disabled: 0x40000000,
	},
	
	/** 
			* Enumeration for Enter Key Behavior in editable text fields.
			* @namespace
			 */
	EnterKeyType:
	{ 
		/** * */
		Return: 0,
		/** * */
		Done: 1,
		/** * */
		Next: 2,
		/** * */
		Submit: 3,
		/** * */
		Go: 4,
		/** * */
		Search: 5,
		/** * */
		Send: 6,
	},
	
	/** 
			* Enumeration for Input Types for editable text fields.
			* @namespace
			 */
	InputType:
	{ 
		/** * */
		None: 0,
		/** * */
		TextWithCorrection: 1,
		/** * */
		Password: 2,
		/** * */
		Numeric: 4,
		/** * */
		Email: 5,
		/** * */
		URL: 6,
		/** * */
		Date: 7,
		/** * */
		ANDROID_LANDSCAPE_FULLSCREEN: 8,
	},
	
	/** 
			* Arrangement of combinations of text and images for buttons. When stacked, the button rect will be divided proportionally into two rects that completely cover the button. Gravity will apply to the image and text within their rects.
			* @namespace
			 */
	ButtonLayout:
	{ 
		/** The view is in an unexceptional state. */
		CenterTextOver: 0,
		/** * */
		StackImageLeft: 1,
		/** * */
		StackImageTop: 2,
		/** * */
		StackImageRight: 3,
		/** * */
		StackImageBottom: 4,
		/** * */
		CenterImageOver: 5,
	},
	
	/** 
			* Describes what direction a user swiped during a swipe callback.
			* @see UI.AbstractView#setOnSwipe
			* @namespace
			 */
	SwipeDirection:
	{ 
		/** * */
		Left: 1,
		/** * */
		Right: 2,
		/** * */
		Up: 3,
		/** * */
		Down: 4,
	},
	
	///////
	// Class Summary and Generated Constants (for internal use only):
	// Class ID = 337
	// Method -1: _initializeNative ( int reservedId )
	// Method -2: _create ( int newObjectId, str className )
	// Method 3: _destroy (  )
	// Method 4: _setActive ( bool active )
	// Method 5: _setTouchable ( bool touchable )
	// Method 6: _enableEvent ( str eventName )
	// Method 7: _disableEvent ( str eventName )
	// Method -8: _eventOccurred ( json eventObject )
	// Method 9: _setIsVisible ( bool visible )
	// Method 10: _setEnabled ( bool enable )
	// Method 11: _setState ( int state )
	// Method 12: _addSubview ( int __objectRegistryId, int index )
	// Method 13: _removeFromSuperview (  )
	// Method -14: _startAnimation ( int durationMs, str callbackId )
	// Method -15: _executeAnimation ( json options )
	// Method 16: _setFrame ( float x, float y, float w, float h )
	// Method 17: _setOrigin ( float x, float y )
	// Method 18: _setAnchor ( float x, float y )
	// Method 19: _setSize ( float w, float h )
	// Method 20: _setTransform ( float a, float b, float c, float d, float tx, float ty )
	// Method 21: _setBackgroundColor ( str color )
	// Method 22: _setImage ( int state, str imageURL )
	// Method 23: _setImageBorder ( int state, json gradientJSON )
	// Method 24: _setImageFitMode ( int fitMode )
	// Method 25: _setImageGravity ( float x, float y )
	// Method 26: _setImageOrigin ( float x, float y )
	// Method 27: _setImageAnchor ( float x, float y )
	// Method 28: _setImageSize ( float w, float h )
	// Method 29: _setImageInsets ( float t, float r, float b, float l )
	// Method 30: _setImageTransform ( float a, float b, float c, float d, float tx, float ty )
	// Method 31: _setText ( int state, str text )
	// Method 32: _setTextColor ( int state, str text )
	// Method 33: _setTextFont ( int state, str fontName )
	// Method 34: _setTextShadow ( int state, str shadow )
	// Method 35: _setTextSize ( float textFontSize )
	// Method 36: _setTextGravity ( float x, float y )
	// Method 37: _setTextInsets ( float t, float r, float b, float l )
	// Method 38: _setTextOverflow ( int overflowMode )
	// Method 39: _setTextMaxLines ( int maxLines )
	// Method 40: _setTextMinSize ( float minSize )
	// Method 41: _setTitle ( int state, str title )
	// Method 42: _setTitleColor ( int state, str title )
	// Method 43: _setTitleFont ( int state, str fontName )
	// Method 44: _setTitleShadow ( int state, str shadow )
	// Method 45: _setTitleSize ( float titleFontSize )
	// Method 46: _setTitleGravity ( float x, float y )
	// Method 47: _setTitleInsets ( float t, float r, float b, float l )
	// Method 48: _setTitleOverflow ( int overflowMode )
	// Method 49: _setTitleMaxLines ( int maxLines )
	// Method 50: _setTitleMinSize ( float minSize )
	// Method 51: _setGradient ( int state, json gradientJSON )
	// Method 52: _setStringValue ( str value )
	// Method 53: _setFloatValue ( float value )
	// Method 54: _setIntValue ( int value )
	// Method 55: _setBoolValue ( bool value )
	// Method 56: _setButtonLayout ( int layoutType )
	// Method 57: _setContentInsets ( float t, float r, float b, float l )
	// Method 58: _setBarGradient ( int state, json gradientJSON )
	// Method 59: _setPlaceholderText ( str placeholder )
	// Method 60: _setPlaceholderTextColor ( str color )
	// Method 61: _setPlaceholderTextShadow ( str shadow )
	// Method 62: _setEnterKeyType ( int enterKeyType )
	// Method 63: _setInputType ( int inputType )
	// Method 64: _setChecked ( bool checked )
	// Method 65: _setScrollPosition ( float x, float y )
	// Method 66: _setScrollableSize ( float w, float h )
	// Method 67: _setSections ( json idArray )
	// Method 68: _setTitleView ( int titleObjectID )
	// Method 69: _setSourceDocument ( str documentURL )
	// Method 70: _setChoices ( json stringArray, int defaultChoiceIndex, int cancelChoiceIndex )
	// Method 71: _show (  )
	// Method 72: _hide (  )
	// Method 73: _setPostData ( str data )
	// Method 74: _loadPostURL ( str url )
	// Method 75: _loadGetURL ( str url )
	// Method 76: _loadURL ( str url, json headers, float timeout )
	// Method 77: _stopLoading (  )
	// Method 78: _reload (  )
	// Method 79: _invoke ( str script )
	// Method 80: _goBack (  )
	// Method 81: _goForward (  )
	// Method 82: _setBasicAuthCredentials ( json credentials )
	// Method 83: _setRightImage ( int state, str rightImageURL )
	// Method 84: _setRightImageBorder ( int state, json gradientJSON )
	// Method 85: _setRightImageFitMode ( int fitMode )
	// Method 86: _setRightImageGravity ( float x, float y )
	// Method 87: _setRightImageOrigin ( float x, float y )
	// Method 88: _setRightImageAnchor ( float x, float y )
	// Method 89: _setRightImageSize ( float w, float h )
	// Method 90: _setRightImageInsets ( float t, float r, float b, float l )
	// Method 91: _setRightImageTransform ( float a, float b, float c, float d, float tx, float ty )
	// Method -92: _setStatusBarHidden ( bool statusBarStatus )
	// Method 93: _pauseAds (  )
	// Method 94: _resumeAds (  )
	// Method 95: _setAdRefreshRate ( int refreshRate )
	// Method 96: _setAdAllowAutoplay ( bool autoplay )
	// Method 97: _setAlpha ( float alpha )
	// Method 98: _postURL ( str url, str data )
	// Method 99: _setProgressGradient ( int state, json gradientJSON )
	// Method 100: _setSecondaryGradient ( int state, json gradientJSON )
	// Method 101: _setProgress ( float progress, float secondaryProgress )
	// Method 102: _useForUpdateProgress ( bool use )
	// Method 103: _setDarkStyle ( bool use )
	// Method -104: _doCompositeImages ( int w, int h, str filename, json infoArray, str callbackId )
	// Method -105: _REMOVED_doChoosePhoto ( int w, int h, str filename, json options, str callbackId )
	// Method -106: _doChooseCamera ( int w, int h, str filename, json options, str callbackId )
	// Method 107: _setScrollable ( bool enabled )
	// Method 108: _setZoomable ( bool enabled )
	// Method 109: _addAnnotation ( int __objectRegistryId )
	// Method 110: _removeAnnotation ( int __objectRegistryId )
	// Method 111: _selectAnnotation ( int __objectRegistryId )
	// Method 112: _setRegion ( float latitude, float longitude, float latitudeDelta, float longitudeDelta, bool animated )
	// Method 113: _setView ( int __objectRegistryId )
	// Method 114: _setCoordinate ( float latitude, float longitude )
	// Method 115: _setCalloutTitle ( str title )
	// Method 116: _setCalloutSubtitle ( str subTitle )
	// Method 117: _setCalloutEnabled ( bool enabled )
	// Method 118: _setCalloutLeftView ( int __objectRegistryId )
	// Method 119: _setCalloutRightView ( int __objectRegistryId )
	// Method 120: _setCenterOffset ( float xOffset, float yOffset )
	// Method -121: _doChoosePhoto ( int w, int h, str filename, json options, str callbackId, int invokingView )
	// Method 122: _setScrollIndicatorsVisible ( bool enabled )
	// Method -123: _measureText ( str string, int w, int h, str font, float fontSize, str callbackId )
	// Method 124: _setFocus ( bool enabled )
	// Method 125: _setViewportEnabled ( bool enabled )
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift() );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift() );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Commands._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				case -8:
					Commands._eventOccurredRecv( cmd );
					break;
				default:
					NgLogE("Unknown static method id " + cmdId + " in Commands._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[337] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	$_eventOccurredRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in Commands.eventOccurred from command: " + cmd );
			return false;
		}
		
		obj[ "eventObject" ] = Core.Proc.parseJSONString( cmd[ 0 ] );
		if( obj[ "eventObject" ] === undefined )
		{
			NgLogE("Could not parse eventObject in Commands.eventOccurred from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$initializeNative: function( reservedId )
	{
		Core.Proc.appendToCommandString( ":337,-1," + reservedId  );
	},
	
	/** @private */
	$create: function( newObjectId, className )
	{
		Core.Proc.appendToCommandString( ":337,-2," + newObjectId + "," + Core.Base64.encode( className )  );
	},
	
	/** @private */
	destroy: function(  )
	{
		Core.Proc.appendToCommandString( ":337,3," + this.__objectRegistryId );
	},
	
	/** @private */
	setActive: function( active )
	{
		Core.Proc.appendToCommandString( ":337,4," + this.__objectRegistryId + "," + ( active ? 1 : 0 )  );
	},
	
	/** @private */
	setTouchable: function( touchable )
	{
		Core.Proc.appendToCommandString( ":337,5," + this.__objectRegistryId + "," + ( touchable ? 1 : 0 )  );
	},
	
	/** @private */
	enableEvent: function( eventName )
	{
		Core.Proc.appendToCommandString( ":337,6," + this.__objectRegistryId + "," + Core.Base64.encode( eventName )  );
	},
	
	/** @private */
	disableEvent: function( eventName )
	{
		Core.Proc.appendToCommandString( ":337,7," + this.__objectRegistryId + "," + Core.Base64.encode( eventName )  );
	},
	
	/** @private */
	setIsVisible: function( visible )
	{
		Core.Proc.appendToCommandString( ":337,9," + this.__objectRegistryId + "," + ( visible ? 1 : 0 )  );
	},
	
	/** @private */
	setEnabled: function( enable )
	{
		Core.Proc.appendToCommandString( ":337,10," + this.__objectRegistryId + "," + ( enable ? 1 : 0 )  );
	},
	
	/** @private */
	setState: function( state )
	{
		Core.Proc.appendToCommandString( ":337,11," + this.__objectRegistryId + "," + state  );
	},
	
	/** @private */
	addSubview: function( __objectRegistryId, index )
	{
		Core.Proc.appendToCommandString( ":337,12," + this.__objectRegistryId + "," + __objectRegistryId + "," + index  );
	},
	
	/** @private */
	removeFromSuperview: function(  )
	{
		Core.Proc.appendToCommandString( ":337,13," + this.__objectRegistryId );
	},
	
	/** @private */
	$startAnimation: function( durationMs, callbackId )
	{
		Core.Proc.appendToCommandString( ":337,-14," + durationMs + "," + Core.Base64.encode( callbackId )  );
	},
	
	/** @private */
	$executeAnimation: function( options )
	{
		Core.Proc.appendToCommandString( ":337,-15," + Core.Base64.encode( JSON.stringify( options ) )  );
	},
	
	/** @private */
	setFrame: function( x, y, w, h )
	{
		Core.Proc.appendToCommandString( ":337,16," + this.__objectRegistryId + "," + x + "," + y + "," + w + "," + h  );
	},
	
	/** @private */
	setOrigin: function( x, y )
	{
		Core.Proc.appendToCommandString( ":337,17," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	setAnchor: function( x, y )
	{
		Core.Proc.appendToCommandString( ":337,18," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	setSize: function( w, h )
	{
		Core.Proc.appendToCommandString( ":337,19," + this.__objectRegistryId + "," + w + "," + h  );
	},
	
	/** @private */
	setTransform: function( a, b, c, d, tx, ty )
	{
		Core.Proc.appendToCommandString( ":337,20," + this.__objectRegistryId + "," + a + "," + b + "," + c + "," + d + "," + tx + "," + ty  );
	},
	
	/** @private */
	setBackgroundColor: function( color )
	{
		Core.Proc.appendToCommandString( ":337,21," + this.__objectRegistryId + "," + Core.Base64.encode( color )  );
	},
	
	/** @private */
	setImage: function( state, imageURL )
	{
		Core.Proc.appendToCommandString( ":337,22," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( imageURL )  );
	},
	
	/** @private */
	setImageBorder: function( state, gradientJSON )
	{
		Core.Proc.appendToCommandString( ":337,23," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( JSON.stringify( gradientJSON ) )  );
	},
	
	/** @private */
	setImageFitMode: function( fitMode )
	{
		Core.Proc.appendToCommandString( ":337,24," + this.__objectRegistryId + "," + fitMode  );
	},
	
	/** @private */
	setImageGravity: function( x, y )
	{
		Core.Proc.appendToCommandString( ":337,25," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	setImageOrigin: function( x, y )
	{
		Core.Proc.appendToCommandString( ":337,26," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	setImageAnchor: function( x, y )
	{
		Core.Proc.appendToCommandString( ":337,27," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	setImageSize: function( w, h )
	{
		Core.Proc.appendToCommandString( ":337,28," + this.__objectRegistryId + "," + w + "," + h  );
	},
	
	/** @private */
	setImageInsets: function( t, r, b, l )
	{
		Core.Proc.appendToCommandString( ":337,29," + this.__objectRegistryId + "," + t + "," + r + "," + b + "," + l  );
	},
	
	/** @private */
	setImageTransform: function( a, b, c, d, tx, ty )
	{
		Core.Proc.appendToCommandString( ":337,30," + this.__objectRegistryId + "," + a + "," + b + "," + c + "," + d + "," + tx + "," + ty  );
	},
	
	/** @private */
	setText: function( state, text )
	{
		Core.Proc.appendToCommandString( ":337,31," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( text )  );
	},
	
	/** @private */
	setTextColor: function( state, text )
	{
		Core.Proc.appendToCommandString( ":337,32," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( text )  );
	},
	
	/** @private */
	setTextFont: function( state, fontName )
	{
		Core.Proc.appendToCommandString( ":337,33," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( fontName )  );
	},
	
	/** @private */
	setTextShadow: function( state, shadow )
	{
		Core.Proc.appendToCommandString( ":337,34," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( shadow )  );
	},
	
	/** @private */
	setTextSize: function( textFontSize )
	{
		Core.Proc.appendToCommandString( ":337,35," + this.__objectRegistryId + "," + textFontSize  );
	},
	
	/** @private */
	setTextGravity: function( x, y )
	{
		Core.Proc.appendToCommandString( ":337,36," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	setTextInsets: function( t, r, b, l )
	{
		Core.Proc.appendToCommandString( ":337,37," + this.__objectRegistryId + "," + t + "," + r + "," + b + "," + l  );
	},
	
	/** @private */
	setTextOverflow: function( overflowMode )
	{
		Core.Proc.appendToCommandString( ":337,38," + this.__objectRegistryId + "," + overflowMode  );
	},
	
	/** @private */
	setTextMaxLines: function( maxLines )
	{
		Core.Proc.appendToCommandString( ":337,39," + this.__objectRegistryId + "," + maxLines  );
	},
	
	/** @private */
	setTextMinSize: function( minSize )
	{
		Core.Proc.appendToCommandString( ":337,40," + this.__objectRegistryId + "," + minSize  );
	},
	
	/** @private */
	setTitle: function( state, title )
	{
		Core.Proc.appendToCommandString( ":337,41," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( title )  );
	},
	
	/** @private */
	setTitleColor: function( state, title )
	{
		Core.Proc.appendToCommandString( ":337,42," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( title )  );
	},
	
	/** @private */
	setTitleFont: function( state, fontName )
	{
		Core.Proc.appendToCommandString( ":337,43," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( fontName )  );
	},
	
	/** @private */
	setTitleShadow: function( state, shadow )
	{
		Core.Proc.appendToCommandString( ":337,44," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( shadow )  );
	},
	
	/** @private */
	setTitleSize: function( titleFontSize )
	{
		Core.Proc.appendToCommandString( ":337,45," + this.__objectRegistryId + "," + titleFontSize  );
	},
	
	/** @private */
	setTitleGravity: function( x, y )
	{
		Core.Proc.appendToCommandString( ":337,46," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	setTitleInsets: function( t, r, b, l )
	{
		Core.Proc.appendToCommandString( ":337,47," + this.__objectRegistryId + "," + t + "," + r + "," + b + "," + l  );
	},
	
	/** @private */
	setTitleOverflow: function( overflowMode )
	{
		Core.Proc.appendToCommandString( ":337,48," + this.__objectRegistryId + "," + overflowMode  );
	},
	
	/** @private */
	setTitleMaxLines: function( maxLines )
	{
		Core.Proc.appendToCommandString( ":337,49," + this.__objectRegistryId + "," + maxLines  );
	},
	
	/** @private */
	setTitleMinSize: function( minSize )
	{
		Core.Proc.appendToCommandString( ":337,50," + this.__objectRegistryId + "," + minSize  );
	},
	
	/** @private */
	setGradient: function( state, gradientJSON )
	{
		Core.Proc.appendToCommandString( ":337,51," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( JSON.stringify( gradientJSON ) )  );
	},
	
	/** @private */
	setStringValue: function( value )
	{
		Core.Proc.appendToCommandString( ":337,52," + this.__objectRegistryId + "," + Core.Base64.encode( value )  );
	},
	
	/** @private */
	setFloatValue: function( value )
	{
		Core.Proc.appendToCommandString( ":337,53," + this.__objectRegistryId + "," + value  );
	},
	
	/** @private */
	setIntValue: function( value )
	{
		Core.Proc.appendToCommandString( ":337,54," + this.__objectRegistryId + "," + value  );
	},
	
	/** @private */
	setBoolValue: function( value )
	{
		Core.Proc.appendToCommandString( ":337,55," + this.__objectRegistryId + "," + ( value ? 1 : 0 )  );
	},
	
	/** @private */
	setButtonLayout: function( layoutType )
	{
		Core.Proc.appendToCommandString( ":337,56," + this.__objectRegistryId + "," + layoutType  );
	},
	
	/** @private */
	setContentInsets: function( t, r, b, l )
	{
		Core.Proc.appendToCommandString( ":337,57," + this.__objectRegistryId + "," + t + "," + r + "," + b + "," + l  );
	},
	
	/** @private */
	setBarGradient: function( state, gradientJSON )
	{
		Core.Proc.appendToCommandString( ":337,58," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( JSON.stringify( gradientJSON ) )  );
	},
	
	/** @private */
	setPlaceholderText: function( placeholder )
	{
		Core.Proc.appendToCommandString( ":337,59," + this.__objectRegistryId + "," + Core.Base64.encode( placeholder )  );
	},
	
	/** @private */
	setPlaceholderTextColor: function( color )
	{
		Core.Proc.appendToCommandString( ":337,60," + this.__objectRegistryId + "," + Core.Base64.encode( color )  );
	},
	
	/** @private */
	setPlaceholderTextShadow: function( shadow )
	{
		Core.Proc.appendToCommandString( ":337,61," + this.__objectRegistryId + "," + Core.Base64.encode( shadow )  );
	},
	
	/** @private */
	setEnterKeyType: function( enterKeyType )
	{
		Core.Proc.appendToCommandString( ":337,62," + this.__objectRegistryId + "," + enterKeyType  );
	},
	
	/** @private */
	setInputType: function( inputType )
	{
		Core.Proc.appendToCommandString( ":337,63," + this.__objectRegistryId + "," + inputType  );
	},
	
	/** @private */
	setChecked: function( checked )
	{
		Core.Proc.appendToCommandString( ":337,64," + this.__objectRegistryId + "," + ( checked ? 1 : 0 )  );
	},
	
	/** @private */
	setScrollPosition: function( x, y )
	{
		Core.Proc.appendToCommandString( ":337,65," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	setScrollableSize: function( w, h )
	{
		Core.Proc.appendToCommandString( ":337,66," + this.__objectRegistryId + "," + w + "," + h  );
	},
	
	/** @private */
	setSections: function( idArray )
	{
		Core.Proc.appendToCommandString( ":337,67," + this.__objectRegistryId + "," + Core.Base64.encode( JSON.stringify( idArray ) )  );
	},
	
	/** @private */
	setTitleView: function( titleObjectID )
	{
		Core.Proc.appendToCommandString( ":337,68," + this.__objectRegistryId + "," + titleObjectID  );
	},
	
	/** @private */
	setSourceDocument: function( documentURL )
	{
		Core.Proc.appendToCommandString( ":337,69," + this.__objectRegistryId + "," + Core.Base64.encode( documentURL )  );
	},
	
	/** @private */
	setChoices: function( stringArray, defaultChoiceIndex, cancelChoiceIndex )
	{
		Core.Proc.appendToCommandString( ":337,70," + this.__objectRegistryId + "," + Core.Base64.encode( JSON.stringify( stringArray ) ) + "," + defaultChoiceIndex + "," + cancelChoiceIndex  );
	},
	
	/** @private */
	show: function(  )
	{
		Core.Proc.appendToCommandString( ":337,71," + this.__objectRegistryId );
	},
	
	/** @private */
	hide: function(  )
	{
		Core.Proc.appendToCommandString( ":337,72," + this.__objectRegistryId );
	},
	
	/** @private */
	setPostData: function( data )
	{
		Core.Proc.appendToCommandString( ":337,73," + this.__objectRegistryId + "," + Core.Base64.encode( data )  );
	},
	
	/** @private */
	loadPostURL: function( url )
	{
		Core.Proc.appendToCommandString( ":337,74," + this.__objectRegistryId + "," + Core.Base64.encode( url )  );
	},
	
	/** @private */
	loadGetURL: function( url )
	{
		Core.Proc.appendToCommandString( ":337,75," + this.__objectRegistryId + "," + Core.Base64.encode( url )  );
	},
	
	/** @private */
	loadURL: function( url, headers, timeout )
	{
		Core.Proc.appendToCommandString( ":337,76," + this.__objectRegistryId + "," + Core.Base64.encode( url ) + "," + Core.Base64.encode( JSON.stringify( headers ) ) + "," + timeout  );
	},
	
	/** @private */
	stopLoading: function(  )
	{
		Core.Proc.appendToCommandString( ":337,77," + this.__objectRegistryId );
	},
	
	/** @private */
	reload: function(  )
	{
		Core.Proc.appendToCommandString( ":337,78," + this.__objectRegistryId );
	},
	
	/** @private */
	invoke: function( script )
	{
		Core.Proc.appendToCommandString( ":337,79," + this.__objectRegistryId + "," + Core.Base64.encode( script )  );
	},
	
	/** @private */
	goBack: function(  )
	{
		Core.Proc.appendToCommandString( ":337,80," + this.__objectRegistryId );
	},
	
	/** @private */
	goForward: function(  )
	{
		Core.Proc.appendToCommandString( ":337,81," + this.__objectRegistryId );
	},
	
	/** @private */
	setBasicAuthCredentials: function( credentials )
	{
		Core.Proc.appendToCommandString( ":337,82," + this.__objectRegistryId + "," + Core.Base64.encode( JSON.stringify( credentials ) )  );
	},
	
	/** @private */
	setRightImage: function( state, rightImageURL )
	{
		Core.Proc.appendToCommandString( ":337,83," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( rightImageURL )  );
	},
	
	/** @private */
	setRightImageBorder: function( state, gradientJSON )
	{
		Core.Proc.appendToCommandString( ":337,84," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( JSON.stringify( gradientJSON ) )  );
	},
	
	/** @private */
	setRightImageFitMode: function( fitMode )
	{
		Core.Proc.appendToCommandString( ":337,85," + this.__objectRegistryId + "," + fitMode  );
	},
	
	/** @private */
	setRightImageGravity: function( x, y )
	{
		Core.Proc.appendToCommandString( ":337,86," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	setRightImageOrigin: function( x, y )
	{
		Core.Proc.appendToCommandString( ":337,87," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	setRightImageAnchor: function( x, y )
	{
		Core.Proc.appendToCommandString( ":337,88," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	setRightImageSize: function( w, h )
	{
		Core.Proc.appendToCommandString( ":337,89," + this.__objectRegistryId + "," + w + "," + h  );
	},
	
	/** @private */
	setRightImageInsets: function( t, r, b, l )
	{
		Core.Proc.appendToCommandString( ":337,90," + this.__objectRegistryId + "," + t + "," + r + "," + b + "," + l  );
	},
	
	/** @private */
	setRightImageTransform: function( a, b, c, d, tx, ty )
	{
		Core.Proc.appendToCommandString( ":337,91," + this.__objectRegistryId + "," + a + "," + b + "," + c + "," + d + "," + tx + "," + ty  );
	},
	
	/** @private */
	$setStatusBarHidden: function( statusBarStatus )
	{
		Core.Proc.appendToCommandString( ":337,-92," + ( statusBarStatus ? 1 : 0 )  );
	},
	
	/** @private */
	pauseAds: function(  )
	{
		Core.Proc.appendToCommandString( ":337,93," + this.__objectRegistryId );
	},
	
	/** @private */
	resumeAds: function(  )
	{
		Core.Proc.appendToCommandString( ":337,94," + this.__objectRegistryId );
	},
	
	/** @private */
	setAdRefreshRate: function( refreshRate )
	{
		Core.Proc.appendToCommandString( ":337,95," + this.__objectRegistryId + "," + refreshRate  );
	},
	
	/** @private */
	setAdAllowAutoplay: function( autoplay )
	{
		Core.Proc.appendToCommandString( ":337,96," + this.__objectRegistryId + "," + ( autoplay ? 1 : 0 )  );
	},
	
	/** @private */
	setAlpha: function( alpha )
	{
		Core.Proc.appendToCommandString( ":337,97," + this.__objectRegistryId + "," + alpha  );
	},
	
	/** @private */
	postURL: function( url, data )
	{
		Core.Proc.appendToCommandString( ":337,98," + this.__objectRegistryId + "," + Core.Base64.encode( url ) + "," + Core.Base64.encode( data )  );
	},
	
	/** @private */
	setProgressGradient: function( state, gradientJSON )
	{
		Core.Proc.appendToCommandString( ":337,99," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( JSON.stringify( gradientJSON ) )  );
	},
	
	/** @private */
	setSecondaryGradient: function( state, gradientJSON )
	{
		Core.Proc.appendToCommandString( ":337,100," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( JSON.stringify( gradientJSON ) )  );
	},
	
	/** @private */
	setProgress: function( progress, secondaryProgress )
	{
		Core.Proc.appendToCommandString( ":337,101," + this.__objectRegistryId + "," + progress + "," + secondaryProgress  );
	},
	
	/** @private */
	useForUpdateProgress: function( use )
	{
		Core.Proc.appendToCommandString( ":337,102," + this.__objectRegistryId + "," + ( use ? 1 : 0 )  );
	},
	
	/** @private */
	setDarkStyle: function( use )
	{
		Core.Proc.appendToCommandString( ":337,103," + this.__objectRegistryId + "," + ( use ? 1 : 0 )  );
	},
	
	/** @private */
	$doCompositeImages: function( w, h, filename, infoArray, callbackId )
	{
		Core.Proc.appendToCommandString( ":337,-104," + w + "," + h + "," + Core.Base64.encode( filename ) + "," + Core.Base64.encode( JSON.stringify( infoArray ) ) + "," + Core.Base64.encode( callbackId )  );
	},
	
	/** @private */
	$doChooseCamera: function( w, h, filename, options, callbackId )
	{
		Core.Proc.appendToCommandString( ":337,-106," + w + "," + h + "," + Core.Base64.encode( filename ) + "," + Core.Base64.encode( JSON.stringify( options ) ) + "," + Core.Base64.encode( callbackId )  );
	},
	
	/** @private */
	setScrollable: function( enabled )
	{
		Core.Proc.appendToCommandString( ":337,107," + this.__objectRegistryId + "," + ( enabled ? 1 : 0 )  );
	},
	
	/** @private */
	setZoomable: function( enabled )
	{
		Core.Proc.appendToCommandString( ":337,108," + this.__objectRegistryId + "," + ( enabled ? 1 : 0 )  );
	},
	
	/** @private */
	addAnnotation: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":337,109," + this.__objectRegistryId + "," + __objectRegistryId  );
	},
	
	/** @private */
	removeAnnotation: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":337,110," + this.__objectRegistryId + "," + __objectRegistryId  );
	},
	
	/** @private */
	selectAnnotation: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":337,111," + this.__objectRegistryId + "," + __objectRegistryId  );
	},
	
	/** @private */
	setRegion: function( latitude, longitude, latitudeDelta, longitudeDelta, animated )
	{
		Core.Proc.appendToCommandString( ":337,112," + this.__objectRegistryId + "," + latitude + "," + longitude + "," + latitudeDelta + "," + longitudeDelta + "," + ( animated ? 1 : 0 )  );
	},
	
	/** @private */
	setView: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":337,113," + this.__objectRegistryId + "," + __objectRegistryId  );
	},
	
	/** @private */
	setCoordinate: function( latitude, longitude )
	{
		Core.Proc.appendToCommandString( ":337,114," + this.__objectRegistryId + "," + latitude + "," + longitude  );
	},
	
	/** @private */
	setCalloutTitle: function( title )
	{
		Core.Proc.appendToCommandString( ":337,115," + this.__objectRegistryId + "," + Core.Base64.encode( title )  );
	},
	
	/** @private */
	setCalloutSubtitle: function( subTitle )
	{
		Core.Proc.appendToCommandString( ":337,116," + this.__objectRegistryId + "," + Core.Base64.encode( subTitle )  );
	},
	
	/** @private */
	setCalloutEnabled: function( enabled )
	{
		Core.Proc.appendToCommandString( ":337,117," + this.__objectRegistryId + "," + ( enabled ? 1 : 0 )  );
	},
	
	/** @private */
	setCalloutLeftView: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":337,118," + this.__objectRegistryId + "," + __objectRegistryId  );
	},
	
	/** @private */
	setCalloutRightView: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":337,119," + this.__objectRegistryId + "," + __objectRegistryId  );
	},
	
	/** @private */
	setCenterOffset: function( xOffset, yOffset )
	{
		Core.Proc.appendToCommandString( ":337,120," + this.__objectRegistryId + "," + xOffset + "," + yOffset  );
	},
	
	/** @private */
	$doChoosePhoto: function( w, h, filename, options, callbackId, invokingView )
	{
		Core.Proc.appendToCommandString( ":337,-121," + w + "," + h + "," + Core.Base64.encode( filename ) + "," + Core.Base64.encode( JSON.stringify( options ) ) + "," + Core.Base64.encode( callbackId ) + "," + invokingView  );
	},
	
	/** @private */
	setScrollIndicatorsVisible: function( enabled )
	{
		Core.Proc.appendToCommandString( ":337,122," + this.__objectRegistryId + "," + ( enabled ? 1 : 0 )  );
	},
	
	/** @private */
	$measureText: function( string, w, h, font, fontSize, callbackId )
	{
		Core.Proc.appendToCommandString( ":337,-123," + Core.Base64.encode( string ) + "," + w + "," + h + "," + Core.Base64.encode( font ) + "," + fontSize + "," + Core.Base64.encode( callbackId )  );
	},
	
	/** @private */
	setFocus: function( enabled )
	{
		Core.Proc.appendToCommandString( ":337,124," + this.__objectRegistryId + "," + ( enabled ? 1 : 0 )  );
	},
	
	/** @private */
	setViewportEnabled: function( enabled )
	{
		Core.Proc.appendToCommandString( ":337,125," + this.__objectRegistryId + "," + ( enabled ? 1 : 0 )  );
	},
	

// {{/Wg Generated Code}}

	_eventOccurredRecv: function( cmd ) {
		var str = Core.Proc.parseString( cmd[ 0 ] );
		Commands.Window.doCommand(str);
	},
	
	registerTemporaryCallback: function( callback ) {
		if (typeof callback != 'function') return null;
		var regId = (++this._tempCBCount).toString(36);
		Commands._tempCBs[regId] = callback;
		return regId;
	},
	
	takeTemporaryCallback: function( regId ) {
		var cb = Commands._tempCBs[regId];
		delete Commands._tempCBs[regId];
		return cb;
	},

	/**
	 *	@function UI#animate
	 * 	Animate changes to the properties of one or more UI objects.
	 * 	Currently animates changes to frame and alpha, and animates the addition / removal of subviews.
	 * 	@param {Function} action A closure that sets the property or properties to be animated.
	 * 		This function may manipulate several objects.
	 * 	@param {Number} duration The time over which to execute the animation, in milliseconds.
	 * 	@param {Function} onCompletion A closure to be executed after the animation has completed.
	 */
	animate: function(action, duration, callback) {
		if (typeof action == 'function') {
			var cbFn = (typeof callback == 'function') ? callback : duration;
			var duration = (typeof duration == 'number') ? duration : callback;
			if (typeof duration != 'number') duration = 400;

			Commands.startAnimation( duration, Commands.registerTemporaryCallback(callback));
			var options = new UIAnimationOptions();
			action(options);
			Commands.executeAnimation(options);
		}
	},
});

exports.Commands.instantiate();
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/ViewGeometry'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/ViewGeometry'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/ViewGeometry'] = exports; var Class = require('NGCore/Client/Core/Class').Class;
var Commands = require('NGCore/Client/UI/Commands').Commands;
var Capabilities = require('NGCore/Client/Core/Capabilities').Capabilities;

/**
 * <p>Classes and objects contained by the <code>ViewGeometry</code> class.</p>
 * @name UI.ViewGeometry
 * @namespace
 * @description <p>The <code>ViewGeometry</code> class is a collection of classes and objects that control spatial components for UI views. 
 * Derived classes from <code>ViewGeometry</code> include:</p>
 * <ul>
 * <li><code>{@link UI.ViewGeometry.Rect}</code></li>
 * <li><code>{@link UI.ViewGeometry.Scale}</code></li>
 * </ul>
 * <p><code>ViewGeometry</code> utilizes the following enumerated constants:</p>
 * <ul>
 * <li><code>{@link UI.ViewGeometry.FitMode}</code></li>
 * <li><code>{@link UI.ViewGeometry.Gravity}</code></li>
 * </ul>
 */

var Scale = exports.Scale = Class.singleton(
/** @lends UI.ViewGeometry.Scale.prototype */
{
	/**
	 * @name UI.ViewGeometry.Scale
	 * @class The <code>Scale</code> class constructs objects that handle view geometry for different scales of measurement.
         * @constructs The default constructor.
	 * @augments Core.Class
	 */
   
	initialize: function() {
		var screenUnits = Capabilities.getScreenUnits();
		this.iOSConversion = screenUnits;
		this.pointConversion = this.iOSConversion * 160 / 72; 
	},

	// Use the values of generated constants... Mostly for if we need to send these to native in the future.
	Pixels: Commands.Scaling.Pixels,
	Points: Commands.Scaling.Points,
	Unit: Commands.Scaling.Unit,
	Percent: Commands.Scaling.Percent,
	iPhone: Commands.Scaling.iPhone,
	
	// Internals.
    
	pointConversion: 1.0,
    
	iOSConversion: 1.0,

    /** 
     * Retrieve the supported measurement scale from the device.
     * @param {Number} units The unit of measure.
     * @param {Number} size The screen size of the device.
     * @returns The current screen dimension supported by the device.
     */
	getScale: function(units, size) {
		switch (+units) {
			case this.Points:
				return this.pointConversion;
			case this.Unit:
				return size;
			case this.Percent:
				return size / 100;
			case this.iPhone:
				return this.iOSConversion;
		}
		return 1.0;
	}
});

var Gravity = exports.Gravity = 
{
		
	/** 
	 * @name UI.ViewGeometry.Gravity
	 * @class Enumeration for image gravity in a view.
	 */
	/** 
	* Center of gravity is the top-left corner of the image.
	* @memberOf UI.ViewGeometry.Gravity.prototype
	* @constant
	*/
	TopLeft: [0.0,0.0],
	/** 
	* Center of gravity is the top-center portion of the image. 
	* @memberOf UI.ViewGeometry.Gravity.prototype
	* @constant
	*/
	TopCenter: [0.5,0.0],
	/** 
	* Center of gravity is the top-right corner of the image. 
	* @memberOf UI.ViewGeometry.Gravity.prototype
	* @constant
	*/
	TopRight: [1.0, 0.0],
	/** 
	* Center of gravity is the left side of the image. 
	* @memberOf UI.ViewGeometry.Gravity.prototype
	* @constant
	*/
	Left: [0.0,0.5],
	/** 
	* Center of gravity is the center of the image. 
	* @memberOf UI.ViewGeometry.Gravity.prototype
	* @constant
	*/
	Center: [0.5,0.5],
	/** 
	* Center of gravity is the right side of the image. 
	* @memberOf UI.ViewGeometry.Gravity.prototype
	* @constant
	*/
	Right: [1.0,0.5],
	/** 
	* Center of gravity is the bottom-left corner of the image. 
	* @memberOf UI.ViewGeometry.Gravity.prototype
	* @constant
	*/
	BottomLeft: [0.0,1.0],
	/** 
	* Center of gravity is the bottom-center portion of the image. 
	* @memberOf UI.ViewGeometry.Gravity.prototype
	* @constant
	*/
	BottomCenter: [0.5,1.0],
	/** 
	* Center of gravity is the bottom-right corner of the image. 
	* @memberOf UI.ViewGeometry.Gravity.prototype
	* @constant
	*/
	BottomRight: [1.0,1.0]
};

 
exports.FitModes = Commands.FitMode;
/** 
* @name UI.ViewGeometry.FitMode
* @class Enumeration for image fit modes in a view.
* @see UI.Commands#FitMode
*/

	
var Rect = exports.Rect = Class.subclass(
/** @lends UI.ViewGeometry.Rect.prototype */
{
	/**
	 * @name UI.ViewGeometry.Rect
	 * @class <code>Rect</code> constructs rectangle objects for use as positionable elements in the user interface. 
	 * @constructs The default constructor.
	 * @augments Core.Class
	 */

    initialize: function(arg0)
    {
    	if (arg0 instanceof this.constructor){
    		// Another Rect
    		this.x = arg0.x;
    		this.y = arg0.y;
    		this.w = arg0.w;
    		this.h = arg0.h;
    	} else if (arg0 instanceof Array) {
    		if (arguments.length == 2 
    			&& arguments[0].length >= 2 
    			&& arguments[1] instanceof Array 
    			&& arguments[1].length >= 2) {
				
				// Arguments can be two arrays, one of which is a point and one of which is a size,
				this.x = arguments[0][0];
				this.y = arguments[0][1];
				this.w = arguments[1][0];
				this.h = arguments[1][1];
			}
			else if (arguments.length == 1 && arg0.length >= 4) {
				// Single Array
				this.x = arg0[0];
				this.y = arg0[1];
				this.w = arg0[2];
				this.h = arg0[3];
			}
			else {
				NgLogD("UI.ViewGeometry.Rect initialized with unparseable Array(s)");
			}
		} else if (arguments.length == 4) {
			// Four numbers
			this.x = arguments[0];
			this.y = arguments[1];
			this.w = arguments[2];
			this.h = arguments[3];
		}
		return this;
    },
	/**
	 * @returns {Boolean} Returns <code>true</code> if any component value is undefined, NaN, or the value indicates this rect has an area of 0 (<i>width</i> * <i>height</i>).
	 */
	isEmpty: function(){
		return !(this.w * this.h > 0) || isNaN(this.x) || isNaN(this.y) || isNaN(this.w) || isNaN(this.h);
	},
	/**
	 * Copy the component values of this <code>Rect</code>
	 * @returns {UI.ViewGeometry.Rect} A new <code>Rect</code> with identical component values.
	 */	
	copy: function() {
		return new (this).constructor(this);
	},
    /**
	 * Retrieve the component values of this <code>Rect</code>.
	 * @returns {Array (Number)} An array of component values for the specified <code>Rect</code> (<i>x</i>, <i>y</i>, <i>height</i>, <i>width</i>).
	 */	
	array: function() {
		return [this.x, this.y, this.w, this.h];
	},
    /**
	 * Set the dimensions of this <code>Rect</code> as an inset.
	 * @example var imageRect = null;
	 * var remainingRect = rect.copy();
	 * ...
	 * imageRect = remainingRect.sliceHorizontal(110).inset(8,15,8,15);
	 * @param {Number} t The size for the top of the rectangle.
	 * @param {Number} r The size for the right side of the rectangle.
	 * @param {Number} b The size for the bottom of the rectangle.
	 * @param {Number} l The size for the left side of the rectangle.
	 * @param {UI.ViewGeometry.Scale} units The unit of measure for the rectangle.
	 * @returns {UI.ViewGeometry.Rect} This function returns <code>this</code> to support method invocation chaining.
	 */	
	inset: function(t, r, b, l, units) {
		if (arguments.length > 4) {
			var xScale = Scale.getScale(units, this.w);
			var yScale = Scale.getScale(units, this.h);
			t = Math.floor(t * yScale);
			r = Math.floor(r * xScale);
			b = Math.floor(b * yScale);
			l = Math.floor(l * xScale);
		}
		
		if (arguments.length < 2) {
			r = t;
		}
		if (arguments.length < 4) {
			b = t;
			l = r;
		}
		this.y += t;
		this.h -= t + b;
		this.x += l;
		this.w -= l + r;
		return this;
	},
    /**
	 *	Create and return a new <code>Rect</code> representing the top (if positive) or bottom (if negative).
	 *	Destructively modifies this Rect, removing the new rect area from the receiver.
	 * @example var topPart = rect.inset(10).sliceVertical(50, UI.Scale.Percent);
	 * @param {Number} height The new rect height.
	 * @param {UI.ViewGeometry.Scale} [units] The scale of measurement.
	 * @returns {UI.ViewGeometry.Rect} A new <code>Rect</code> object.<br>
	 * @see UI.ViewGeometry.Rect#sliceHorizontal
	 */	
	sliceVertical: function(height, units) {
		if (arguments.length > 1) height = Math.floor(height * Scale.getScale(units, this.h));
		
		var newRect = this.copy();
		if (height < 0) {
			// Return the bottom area...
			newRect.h = -height;
			this.h += height;
			newRect.y += this.h;
		} else {
			newRect.h = height;
			this.y += height;
			this.h -= height;
		}
		return newRect;
	},
    /**
	 *	Create and return a new <code>Rect</code> representing the left (if positive) or right (if negative).
	 *	Destructively modifies this Rect, removing the new rect area from the receiver.
	 * @example var imageRect = null;
	 * var remainingRect = rect.copy();
	 * ...
	 * imageRect = remainingRect.sliceHorizontal(110).inset(8,15,8,15);
	 * @param {Number} width The new rect width.
	 * @param {UI.ViewGeometry.Scale} [units] The scale of measurement.
	 * @returns {UI.ViewGeometry.Rect} A new <code>Rect</code> object.<br>
	 * @see UI.ViewGeometry.Rect#sliceVertical
	 */	
	sliceHorizontal: function(width, units) {
		if (arguments.length > 1) width = Math.floor(width * Scale.getScale(units, this.w));

		var newRect = this.copy();
		if (width < 0) {
			newRect.w = -width;
			this.w += width;
			newRect.x += this.w;
		} else {
			newRect.w = width;
			this.x += width;
			this.w -= width;
		}
		return newRect;
	},

	toString: function() {
		return "Rect: {" + this.array().join(',') + "}";
	},

	/**
	 * Retrieve an array of component values for this <code>Rect</code> with rows and columns redistributed evenly.
	 * @returns {Array (Number)}
	 * @param {Number} rows The rect rows.
	 * @param {Number} columns The rect columns.
	 * @param {String} flat A one-dimensional array (left to right, top to bottom).
	 */
	getGrid: function(rows, columns, flat) {
		// Return an array of this rect divided equally into columns and rows.
		flat = (flat == true);
		var cellW = Math.floor(this.w / columns);
		var cellH = Math.floor(this.h / rows);
		
		var rowSet = new Array();
		for (var i = 0; i < rows; i++) {
			var colSet = new Array();
			for (var j = 0; j < columns; j++) {
				var r = new this.constructor(this.x + j * cellW, this.y + i * cellH, cellW, cellH);
				(flat ? rowSet : colSet).push(r);
			}
			if (!flat) rowSet.push(colSet);
		}
		return rowSet;
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/Window'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/Window'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/Window'] = exports; var Class = require('NGCore/Client/Core/Class').Class;
var Commands = require('NGCore/Client/UI/Commands').Commands;
var Capabilities = require('NGCore/Client/Core/Capabilities').Capabilities;
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Element = require('NGCore/Client/UI/Element').Element;
var Rect = require('NGCore/Client/UI/ViewGeometry').Rect;

var WindowLayer = require('NGCore/Client/UI/WindowLayer').WindowLayer;

// Singleton
// Methods beginning with an underscore are considered private and should
// not be called from outside of the class.

Commands.Window = exports.Window = Class.singleton({

	/**
	 * @deprecated Replaced by {@link UI.Window#getWidth}.
	 */
	_outerWidth: 0,

	/**
	 * @deprecated Replaced by {@link UI.Window#getHeight}.
	 */
	_outerHeight: 0,

	/**
	 * @private
	 */
	_width: 0,
	/**
	 * @private
	 */
	_height: 0,

	 /**
	 * @class The <code>Window</code> class constructs a singleton object that manages application access to native UI.<br><br>
	 * <b>Note:</b> An application should never directly allocate a singleton.
	 * @name UI.Window
	 * @augments Core.Class	
	 * @see UI.Window#document
	 * @constructs The default constructor.
	 */
	initialize: function() {
		if (!this._outerWidth || !this._outerHeight) this.setWidthAndHeight(Capabilities.getScreenWidth(), Capabilities.getScreenHeight());
		if (!this._width || !this._height) this._setWidthAndHeight(Capabilities.getScreenWidth(), Capabilities.getScreenHeight());
		
		Commands.instantiate();
		var LayoutListener = Core.MessageListener.subclass(
		{
			initialize: function()
			{
				Device.LayoutEmitter.addListener(this, this.onUpdate);
			},
			
			onUpdate: function(layout)
			{
				UI.Window._setWidthAndHeight(layout['width'], layout['height']);
			}
		});
		var layout = new LayoutListener();
		NgLogD("window: outer = " + this._outerWidth + " × " + this._outerHeight + " frame = " + this._width + " × " + this._height);
	},
	
	document: WindowLayer.singleton({
		'type': 'document',
		register: function() {
			// This is not a registered object.
			this.__objectRegistryId = 0;
		}
	}),
	
	_layers: {},
	_getLayer: function(level) {
		return this._layers[level] || (this._layers[level] = new WindowLayer({'level':level || 0}));
	},
	
	/**
	 * @private
	 */
	destroyObject: function(obj) {
		obj.removeFromParent();
		Commands.destroy.call(obj);
		ObjectRegistry.unregister(obj);
	},
	
	/**
	 * @private
	 */
	handleCommand: function(command) {
		// this.log(["Raw Command", command]);
		var fields = NgParseCommand2(command, NgParseInt, NgParseBase64);
	//	this.log(["handleCommand:", fields[1]]);
		this.doCommand(fields[1]);
	},
	/**
	* @private
	*/
	setStatusBarHidden: function(value) {
		Commands.setStatusBarHidden(value);
		this._outerHeight = Capabilities.getScreenHeight() - (value ? 0 : (Capabilities.getStatusBarHeight() || 0));
	},
	
	/**
	 * @private
	 */
	doCommand: function(jsonString) {
		//NgLogD(jsonString);
		var command = JSON.parse(jsonString);
		if(command.name == 'callback'){
			var cb = Commands.takeTemporaryCallback(command.callback_id);
			if (typeof cb == 'function') {
				cb(command);
			}
		} else {
			var object = ObjectRegistry.idToObject(command.objId);
			if (object instanceof Element) {
				switch (command.name) {
					case 'event':
						object.performEventCallback(command);
						break;
					case 'update':
						var properties = command.properties || {};
						for (var property in properties) {
							try {
								var setter = object['update' + property.charAt(0).toUpperCase() + property.substr(1)];
								if (typeof setter == 'function') {
									setter.apply(object, [properties[property]]);
								} else {
									// Set read-only properties!
									object['_'+property] = properties[property];
								}
							} catch (e) {};
						}
						break;
					default:
						object.handleCommand(command);
				}
			} else {
				console.log("Message received for non-element object with id " + command.objId);
				return;
			}
		}
		// log(["Got message back", command]);
	},
    
	/**
	 * @private
	 */    
	log: function(object) {
		NgLogD(object.toString());
		// this.postMessage({name: 'log', message: object});
	},
	/**
	 * Return the available screen width, with respect to orientation and system status bars.
	 * @returns {Number} The currently available width in pixels that can be drawn to.
	 * @type Number
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getWidth: function()
	{
		return this._width;
	},

	/**
	 * Return the available screen height, with respect to orientation and system status bars.
	 * @returns {Number} The currently available height in pixels that can be drawn to.
	 * @type Number
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getHeight: function()
	{
		return this._height;
	},

	getOuterWidth: function() {
		return this._outerWidth;
	},
	
	getOuterHeight: function() {
		return this._outerHeight;
	},

	getFrame: function() {
		return new Rect(0, 0, this._width, this._height);
	}
});

// Cause property access to initialize the singleton. Needed for backward compatibility.
Commands.Window.__defineGetter__("outerWidth", function() {return this.getOuterWidth()});
Commands.Window.__defineGetter__("outerHeight", function() {return this.getOuterHeight()});

/**
 * @private
 */
Commands.Window._setWidthAndHeight = function(width, height)
{
	console.log("window: set layout size to: " + width + ' × ' + height);
	this._width = width;
	this._height = height;
};

/**
 * @private
 */
Commands.Window.setWidthAndHeight = function(width, height)
{
	console.log("window: set outer size to: " + width + ' × ' + height);
	this._outerWidth = width;
	this._outerHeight = height;
};

; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/Element'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/Element'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/Element'] = exports; var Class = require('NGCore/Client/Core/Class').Class;
var Commands = require('NGCore/Client/UI/Commands').Commands;
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;

var Element = exports.Element = Class.subclass(
/** @lends UI.Element.prototype */
{
	$subclass: function() {
		if (typeof this._init == 'function') this._init();
		return Class.subclass.apply(this, arguments);
	},
	
	classname: "UI_Element",

	/**
	 * @class The <code>Element</code> class is a base class for derived classes that manage object properties and handle user interface events.<br><br>
	 * <b>Caution!:</b> This base class is not exported in the UI module. Do not access it or subclass it at runtime.
	 * Derived classes from <code>Element</code> include:
	* <div class="ul">
	 * <li>{@link UI.AbstractView}</li>
	 * <li>{@link UI.AlertDialog}</li>
	 * <li>{@link UI.ListViewSection}</li>
	 * <li>{@link UI.ProgressDialog}</li>	 
	 * </div>
	 * @constructs The default constructor. 
	 * @param {String} properties
	 * @augments Core.Class
	*/
	initialize: function(properties) {
		if (Element._init) Element._init();
		
		this.register();
		
		// Enable events that are being handled at the class level...
		var events = this._eventNames;
		if (events) for (var e in events) {
			if (this[events[e]]) Commands.enableEvent.call(this, e);
		}
		
		//	Reimplement setAttributes here for speed
		var setters = this._setters;
		if (setters) for (var k in properties) {
			if (typeof setters[k] == 'function') try {
				setters[k].call(this, properties[k]);
			} catch (e) {
				NgLogD("Unable to set " + this.type + '.' + k);
			}
		}
		
	/*	This is awesome. Maybe use it in production code, but we want to keep
	//	our stylistic constraints for core development.
	
		for (var propName in this._setters) {
			this.__defineSetter__(propName, this._setters[propName]);
		}
		for (propName in this._getters) {
			this.__defineGetter__(propName, this._getters[propName]);
		}
	*/
	
		return this;
	},
	
	register: function() {
		try {
			ObjectRegistry.register(this);
			Commands.create(this.__objectRegistryId, this.type || this.classname);
		} catch (e) {
			// Nothing yet
		} finally {
			return this.__objectRegistryId;
		}
	},
	
	retain: function() {
		(this.__retainCount) ? ++this.__retainCount : (this.__retainCount = 1);
		return this;
	},
	
	release: function() {
		if (--this.__retainCount === 0) {
			this.destroy();
		}
	},
		
	/**
	 * Retrieve the property value of the given key. 
	 * @param {String} key The property keyword.
	 * @returns {String} The current property value.
	 * @see UI.Element#getAttributes,
	 * @see UI.Element#setAttribute,
	 * @see UI.Element#setAttributes
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	getAttribute: function(key) {
		var getter = this._getters[key];
		return (typeof getter == 'function') ? getter.call(this) : undefined;
	},
	
	/**
	 * Set the property value for the given key.
	 * @example var glView = new UI.GLView
	 * ...
	 * glView.setAttribute('active', true);
	 * @param {String} key The property keyword.
	 * @param {String} value The new property value.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see UI.Element#getAttribute,
	 * @see UI.Element#getAttributes,
	 * @see UI.Element#setAttributes
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	setAttribute: function(key, value){
		var setter = this._setters[key];
		if (typeof setter == 'function') {
			return setter.call(this, value);
		} else {
			NgLogD("Unable to set " + this.type + '.' + key);
		}
		return this;
	},
	
	/**
	 * Set the property value for each specified key. Property values are passed in as key/value pairs.
	 * @param {Object} dict A dictionary of property key/value pairs.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see UI.Element#getAttribute,
	 * @see UI.Element#getAttributes,
	 * @see UI.Element#setAttribute
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	setAttributes: function(dict) {
		var setters = this._setters;
		if (setters) for (var k in dict) {
			if (typeof setters[k] == 'function') try {
				setters[k].call(this, dict[k]);
			} catch (e) {
				NgLogD("Unable to set " + this.type + '.' + k);
			}
		}
		return this;
	},
	
	/**
	 * Retrieve property values for each specified key. 
	 * @param {String} list A list of property keywords.
	 * @returns {Object} A list of key/value pairs.
	 * @see UI.Element#getAttribute,
	 * @see UI.Element#setAttribute,
	 * @see UI.Element#setAttributes
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	getAttributes: function(list) {
		var output = {};
		if (list instanceof Array) {
			var key;
			for (var i = 0; i < list.length; i++) {
				key = list[i];
				output[key] = this._getters[key].call(this);
			}
		} else {
			for (var key in this._getters) {
				output[key] = this._getters[key].call(this);
			}
		}
		return output;
	},

	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	enableEvent: Commands.enableEvent,
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	toString: function() {
		return this.type + '(' + this.__objectRegistryId + ')';
	},

	/**
	 * @function
	 * @description Destroy this instance and release resources on the backend.
	 * @status Javascript, iOS, Android, Flash, Test
	*/
	destroy: function() {
		Commands.destroy.call(this);
		ObjectRegistry.unregister(this);
		delete this.prototype;
		for (var i in this) {
			if (this.hasOwnProperty(i)) {
				delete this[i];
			}
		}
		this._destroyed = true;
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash, Test
	*/
	registerCallback: function(func, oneTime) {
		var callbackId = ++this.callbackCounter;
		var obj = this;
		this.callbacks[callbackId] = function(obj, args) {
			try {
				func(obj, args);
				if(oneTime) {
					delete obj.callbacks[callbackId];
				}
			}
			catch(e) {
				NgHandleException(e);
			}
		};
		return callbackId;
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	performCallback: function(event) {
		var cb = this.callbacks[event.callbackId];
		if(cb) {
			cb(this, event.arguments);
		}
	},
	
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	performEventCallback: function(event) {
		try {
			// Look up the event by its 'onXXX' name...
			var eName = this._eventNames[event.eventType];
			var fn = this['_'+eName] || this[eName];
			if (typeof fn == 'function') {
				fn.call(this, event);
			}
		}
		catch(e) {
			NgHandleException(e);
		}
	},	
	
	// STATICS: Setter and Getter Registration
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	$registerAccessors: function(propName, getterFn, setterFn, deprecationMessage) {
		// Put the new setter / getter functions into the prototype.
		var caseAdjusted = propName.charAt(0).toUpperCase() + propName.substr(1);
		var byKeyOnly = Boolean(deprecationMessage || false);
	//	NgLogD("Synthesizing set" + caseAdjusted + (shouldSetClosure ? " (custom)" : " (standard)") +
	//		" and get" + caseAdjusted + (onGetClosure ? " (custom)" : " (standard)") + " for member variable " + localVar);
	
		// If this is an instance, use the instance. Otherwise, if we are a class constructor, modify the prototype.
		var pType = (this instanceof Element) ? this : this.prototype;
		if (typeof getterFn == 'function') {
			if (!pType.hasOwnProperty('_getters')) {
				try {
					var heritableMap = function() {return this;};
					var superGetters = pType.superclass._getters;
					if (superGetters) heritableMap.prototype = superGetters;
					pType._getters = new heritableMap();
				} catch (e) {};
			}
			if (byKeyOnly) {
				pType['get'+caseAdjusted] = function() {
					NgLogD("WARNING: Use of get" + caseAdjusted + "() is deprecated. " + deprecationMessage);
					getterFn.apply(this, arguments);
				};
			} else {
				pType['get'+caseAdjusted] = getterFn;
			}
			pType._getters[propName] = getterFn;
		}
		if (typeof setterFn == 'function') {
			if (!pType.hasOwnProperty('_setters')) {
				try {
					var heritableMap = function() {return this;};
					var superSetters = pType.superclass._setters;
					if (superSetters) heritableMap.prototype = superSetters;
					pType._setters = new heritableMap();
				} catch (e) {};
			}
			if (byKeyOnly) {
				pType['set'+caseAdjusted] = function() {
					NgLogD("WARNING: Calling set" + caseAdjusted + "() is deprecated. " + deprecationMessage);
					setterFn.apply(this, arguments);
				}
			} else {
				pType['set'+caseAdjusted] = setterFn;
			}
			pType._setters[propName] = setterFn;
		}
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	$registerEventType: function(eventName) {
		var onEventName = 'on' + eventName.charAt(0).toUpperCase() + eventName.substr(1);
		var localVar = '_' + onEventName;
		var pType = this.prototype;
		
		var getterFn = function() {
			return this[localVar] || this[onEventName];
		};
		var setterFn = function(callback) {
			var isFn = (typeof callback == 'function');
			if (isFn) {
				this[localVar] = callback;
			} else {
				delete this[localVar];
			}
			this.enableEvent(eventName, isFn);
		};
		if (!pType.hasOwnProperty('_eventNames')) {
			try {
				var heritableMap = function() {return this;};
				var superEvents = pType.superclass._eventNames;
				if (superEvents) heritableMap.prototype = superEvents;
				pType._eventNames = new heritableMap();
			} catch (e) {};
		}
		pType._eventNames[eventName] = onEventName;
		
		this.registerAccessors(onEventName, getterFn, setterFn);
		
		// Legacy support. Let's concentrate on removing this soon or at least fixing the casing.
		pType.__defineGetter__(onEventName.toLowerCase(), getterFn);
		pType.__defineSetter__(onEventName.toLowerCase(), setterFn);
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	$synthesizePropertyWithState: function(propName, CommandsFn) {
		var lVarName = '_' + propName + 'Map';
		var setterFn;
		if (propName) {
			setterFn = function(value, optState) {
				optState |= 0;
			//	NgLogD("Set " + this.type + "." + propName + "[" + optState + "] = " + value);
				(this[lVarName] || (this[lVarName] = {}))[optState] = value;
				CommandsFn.call(this, optState, value);
				return this;
			};
		} else {
			setterFn = function(value, optState) {
				CommandsFn.call(this, (optState | 0), value);
				return this;
			};
		}
		
		var getterFn = function(state) {
			return (this[lVarName] || 0)[(state | 0)];
		};
		
		this.registerAccessors(propName, getterFn, setterFn);
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	$synthesizeCompoundProperty: function(propName, CommandsFn) {
		var lVarName = '_' + propName;
		var setterFn;
		if (CommandsFn) {
			// Synthesized setters accept EITHER an array of reasonable length OR individual args.
			setterFn = function(args) {
				this[lVarName] = (args instanceof Array)
					? args
					: Array.prototype.slice.call(arguments);
				CommandsFn.apply(this, this[lVarName]);
				return this;
			}
		} else {
			setterFn = function(args) {
				this[lVarName] = (args instanceof Array) ? args : Array.prototype.slice.call(arguments);
				return this;
			}
		}
		
		this.registerAccessors(propName, function() {return this[lVarName];} , setterFn);
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	$synthesizeProperty: function(propName, CommandsFn) {
		var lVarName = '_' + propName;
		var setterFn;
		if (CommandsFn) {
			// Optional args are still passed through, even though only the first arg is assigned.
			setterFn = function(arg) {
				this[lVarName] = arg;
				CommandsFn.apply(this, arguments);
				return this;
			}
		} else {
			setterFn = function(arg) {
				this[lVarName] = arg;
				return this;
			}
		}
		
		this.registerAccessors(propName, function() {return this[lVarName];} , setterFn);
	}
});


// Event Handlers
Element._init = function() {
	delete Element._init;
	
	/**
	 * @name UI.Element#setOnLoad
	 * @description Set a function to call when the <code>load</code> event occurs.
	 * @param {Function} loadCallback The new functoin to call.<br><br><b>Note:</b> The <code>load</code> event is disabled 
	 * if the value of this parameter is not a function.
	 * @example function() { 
	 *	onLoad.loaded = true; 
	 * };
	 * @see UI.Element#event:getOnLoad
	 * @event
	 */
	/**
	 * @name UI.Element#getOnLoad
	 * @description Retrieve the function to call when the <code>load</code> event occurs.
	 * @returns {Function} The current function to call.
	 * @see UI.Element#event:setOnLoad
	 * @event
	 */
	Element.registerEventType('load');
	/**
	 * @name UI.Element#setOnUnload
	 * @description Set a function to call when the <code>unload</code> event occurs.
	 * @param {Function} unloadCallback The new functoin to call.<br><br><b>Note:</b> The <code>unload</code> event is disabled 
	 * if the value of this parameter is not a function.
	 * @example function() { 
	 *	onUnload.unloaded = true; 
	 * };
	 * @see UI.Element#event:getOnUnload	
	 * @event
	 */
	/**
	 * @name UI.Element#getOnUnload
	 * @description Retrieve the function to call when the <code>unload</code> event occurs.
	 * @returns {Function} The current function to call.
	 * @see UI.Element#event:setOnUnload	 
	 * @event
	 */
	Element.registerEventType('unload');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/View'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/View'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/View'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;
var Window = require('NGCore/Client/UI/Window').Window;

var ViewParent = require('NGCore/Client/UI/ViewParent').ViewParent;

var View = exports.View = AbstractView.subclass(
/** @lends UI.View.prototype */
{
	'type':'view',

	/**	 
	 * @class The <code>View</code> class is a base class for derived classes that handle application views. Derived classes from <code>View</code> include:
	 * <div class="ul">
	 * <li>{@link UI.ScrollView}</li>
	 * <li>{@link UI.Toast}</li>
	 * </div>
	 * @constructs The default constructor. 
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {String} properties Object properties.
	 * @augments UI.AbstractView
	 */
	initialize: function($super, properties) {
		if (View._init) View._init();
		ViewParent.initialize.call(this);
		return $super(properties);
	},
	/**
	* Add a child node to this <code>View</code> at the specified index.
	* @example var mainView = new UI.View();
	* ...
	* var errorView = new UI.View();
	* ...
	* mainView.addChild(errorView);
	* @param {GL2.Node} childNode The child node to add.
	* @param {Number} index The specified index.
	* @throws {this.type + ".addChild: " + childNode + " is not a view!"} Specified node is not attached to a view.
	* @returns This function returns <code>this</code> to support method invocation chaining.
	* @see UI.View#removeChild
    * @status iOS, Android, Test
	*/
	addChild: ViewParent.addChild,
	
	/**
	* Remove a child node from this <code>View</code> at the specified index.
	* @example mainView.removeChild(errorView);
	* @param {GL2.Node} childNode The child node to remove.
	* @throws {this.type + ".removeChild: " + childNode + " is not a view!} Specified node is not attached to a view.
	* @returns The child node that was removed.
	* @see UI.View#addChild
    * @status iOS, Android, Test
	*/    
	removeChild: ViewParent.removeChild,


	/**
	 * Retrieve a count of the child nodes attached to this <code>View</code>.
	 * @return {Number} The current number of child nodes.
	 * @status Javascript, iOS, Android, Flash
	 */
	getChildCount: ViewParent.getChildCount,

	/**
	 * Retrieve the child nodes attached to this <code>View</code>.
	 * @return {Object} All attached children nodes.
	 * @status Javascript, iOS, Android, Flash
	 */
	getChildren: ViewParent.getChildren,

	/**
	 * @function
	 * @description Override this for custom view subclass layout code.
	 */
	layoutSubviews: function() {
		//Override this for custom view subclass layout code
	},
	/** @protected */
	_style:null,
	/**
	 * Retrieve the style for this <code>View</code>.
	 * @returns {UI.Style} The current <code>View</code> style.
	 * @see UI.View#setStyle
	 * @status Javascript, iOS, Android, Flash
	 */
	getStyle:function(){
		return this._style;
	},
	/**
	 * Set the style for this <code>View</code>. This call allows custom view objects to process and update their styles more easily.
	 * @param {UI.Style} style The new <code>View</code> style.
	 * @see UI.View#getStyle
	 * @status Javascript, iOS, Android, Flash
	 */
	setStyle: function(/*UI.Style*/style) {
		//Override this for custom view subclass styling code
		this._style = style;
	},
	
	/**
	 * @protected
	 * @function
	 * @status Javascript, iOS, Android, Flash
	 */
	_setVisible: function($super, makeVisible) {
		var wasVisible = this._visible;
		$super(makeVisible);
		if (this._visible != wasVisible) {
			var l = this._children.length;
			for (var i = 0; i < l; i++) {
				this._children[i]._setVisible(makeVisible);
			}
		}
	},
});

// Properties
View._init = function() {
	delete View._init;
	if (AbstractView._init) AbstractView._init();

	/**
	 * @name UI.View#setImage
	 * @description Set an image URL for a view state. This property defines a remote image resource to use in arbitrary contexts.
	 * @example var someSprite = new UI.View();        
	 * someSprite.setImage('./Content/mySprite.png', [w, h], [0, 0]);
	 * @see UI.View#getImage
	 * @param {String} imageURL The new image URL.
	 * @param {UI.State} [flags=UI.State.Normal] A set of flags describing the view state(s) for using this URL.
 	 * @status iOS, Android, Test
	 * @function 
	 */
	/**
	 * @name UI.View#getImage
	 * @description Retrieve the <code>image</code> URL for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current image URL for the specified view state.
	 * @see UI.View#setImage
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	View.synthesizePropertyWithState('image', Commands.setImage);
	/**
	 * @name UI.View#setImageBorder
	 * @description Set the value of the <code>imageBorder</code> property for a view state. This property defines a border for images used in the specified view state.
	 * @param {Object} imageBorder The new value for <code>imageBorder</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.View#getImageBorder
 	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.View#getImageBorder
	 * @description Retrieve the value of the <code>imageBorder</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {Object} The current value of <code>imageBorder</code>.
	 * @see UI.View#setImageBorder
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	View.synthesizePropertyWithState('imageBorder', Commands.setImageBorder);
	/**
	 * @name UI.View#setImageGravity
	 * @description Set the value of the <code>imageGravity</code> property. This property defines how an image is positioned within a viewable area.
	 * @example var someSprite = new UI.View();
	 * ...
	 * someSprite.setImageGravity([0.5, 0.0]);
	 * @param {Number} imageGravity The new value for <code>imageGravity</code> (expressed as two floats).
	 * @see UI.View#getImageGravity
	 * @function
 	 * @status iOS, Android, Test
	 */
	/**
	 * @name UI.View#getImageGravity
	 * @description Retrieve the value of the <code>imageGravity</code> property.
	 * @returns {Number} The current value of <code>imageGravity</code> (expressed as two floats).
	 * @see UI.View#setImageGravity
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	View.synthesizeCompoundProperty('imageGravity', Commands.setImageGravity);
	/**
	 * @name UI.View#setImageFit
	 * @description Set the value of the <code>imageFit</code> property. This property defines the scaling of bitmap images to fit within the bounds of a control 
	 * (subtracting the value for <code>imageInsets</code>).
	 * @example var someSprite = new UI.View();
	 * ...
	 * someSprite.setImageFit(UI.FitMode.None);
	 * @param {Number} imageFit The new value for <code>imageFit</code>.
	 * @see UI.View#getImageFit
	 * @function
	 */
	/**
	 * @name UI.View#getImageFit
	 * @description Retrieve the value of the <code>imageFit</code> property.
	 * @returns {Number} The current value of <code>imageFit</code>.
	 * @see UI.View#setImageFit
	 * @function
 	 * @status 
	 */
	View.synthesizeProperty('imageFit', Commands.setImageFitMode);
	
	// helpers for legacy support... Bind full properties to a single state of another.
	var states = {
		'normal': Commands.State.Normal,
		'focused': Commands.State.Focused,
		'pressed': Commands.State.Pressed,
		'disabled': Commands.State.Disabled,
		//** extra-deprecated */
		'selected': Commands.State.Focused,
		'highlighted': Commands.State.Pressed
	};
	
	function bindStateProperties(propName) {
		var doSynthesis = function(propName, stateName, stateFlags) {
			var getterFn = function() {
				return this._getters[propName].call(this, stateFlags);
			}
			var setterFn = function(val) {
				return this._setters[propName].call(this, val, stateFlags);
			}
			var thisStatePropName = stateName + propName.charAt(0).toUpperCase() + propName.substr(1);
		//	NgLogD("Synthesizing View." + thisStatePropName + " as getters[" + propName + "][" + stateFlags + "]");
			View.registerAccessors(thisStatePropName, getterFn, setterFn,
				"Use " + propName + " accessors with a final state parameter instead.");
		}
		for (var stateName in states) {
			if (!states.hasOwnProperty(stateName)) continue;
			doSynthesis(propName, stateName, states[stateName]);
		}
	};
	
	bindStateProperties('image');
	bindStateProperties('imageBorder');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/Label'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/Label'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/Label'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var Label = exports.Label = AbstractView.subclass(
/** @lends UI.Label.prototype */
{
	'type':'label',
	/**
	 * @name UI.Label
	 * @class The <code>Label</code> class constructs objects for managing strings that are used as application labels. 
	 * These objects include access to a wide range of attributes for manipulating the look and feel of application labels.
	 * @augments UI.AbstractView
	 */
	initialize: function($super, properties) {
		if (Label._init) Label._init();
		$super(properties);
	}
});

Label._init = function() {
	delete Label._init;
	if (AbstractView._init) AbstractView._init();
	
	/**
	 * @name UI.Label#setText
	 * @description Set the value of the <code>text</code> property for a view state. This property defines a text string to use as a label in the specified view state.
	 * @example var label = new UI.Label();
	 * ...
	 * label.setText("Friends List");
	 * @param {String} text The new value for <code>text</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.Label#getText
	 * @status iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.Label#getText
	 * @description Retrieve the value of the <code>text</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value for <code>text</code>.
	 * @see UI.Label#setText
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Label.synthesizePropertyWithState('text', Commands.setText);	
	/**
	 * @name UI.Label#setTextFont
	 * @description Set the value of the <code>textFont</code> property. This property defines the font face used with labels in the specified view state.
	 * @example var label = new UI.Label();
	 * ...
	 * label.setTextFont(myFont);
	 * @param {String} textFont The new value for <code>textFont</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.Label#getTextFont
	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.Label#getTextFont
	 * @description Retrieve the value of the <code>textFont</code> property.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value for <code>textFont</code>.
	 * @see UI.Label#setTextFont
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Label.synthesizePropertyWithState('textFont', Commands.setTextFont);
	/**
	 * @name UI.Label#setTextColor
	 * @description Set the value of the <code>textColor</code> property for a view state. This property defines the color of a text string for a label in the specified view state.
	 * @example var label = new UI.Label();
	 * ...
	 * label.setTextColor('FFFF');
	 * @param {String} textColor The new value for <code>textColor</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.Label#getTextColor
	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.Label#getTextColor
	 * @description Retrieve the value of the <code>textColor</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>textColor</code>.
	 * @see UI.Label#setTextColor
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Label.synthesizePropertyWithState('textColor', Commands.setTextColor);
	/**
	 * @name UI.Label#setTextShadow
	 * @description Set the value of the <code>textShadow</code> property for a view state. This property defines the amount of text shadowing used on labels in the specified view state.
	 * @example var label = new UI.Label();
	 * ...
	 * label.setTextShadow("FF00 2.0 {0,-1}");
	 * @param {String} textShadow The new value for <code>textShadow</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.Label#getTextShadow
	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.Label#getTextShadow
	 * @description Retrieve the value of the <code>textShadow</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>textShadow</code>.
	 * @see UI.Label#setTextShadow
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Label.synthesizePropertyWithState('textShadow', Commands.setTextShadow);
	
	/**
	 * @name UI.Label#setTextGravity
	 * @description Set the value of the <code>textGravity</code> property for this <code>Label</code>. This property defines how a text string is positioned within a viewable area.
	 * @example var label = new UI.Label();
	 * ...
	 * label.setTextGravity([0.1, 0.5]);
	 * @param {Number, Array (Number)} textGravity The new value for <code>textGravity</code>. Set as individual components or a single array of components.
	 * @see UI.Label#getTextGravity
	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.Label#getTextGravity
	 * @description Retrieve the value of the <code>textGravity</code> property for this <code>Label</code>.
	 * @returns {Number, Array (Number)} The current value of <code>textGravity</code>.
	 * @see UI.Label#setTextGravity
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Label.synthesizeCompoundProperty('textGravity', Commands.setTextGravity);
	/**
	 * @name UI.Label#setTextSize
	 * @description Set the value of the <code>textSize</code> property for this <code>Label</code>. This property defines the size of text strings for a label.
	 * @example var label = new UI.Label();
	 * ...
	 * label.setTextGravity(24);
	 * @param {Number} textSize The new value for <code>textSize</code>.
	 * @see UI.Label#getTextSize
	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.Label#getTextSize
	 * @description Retrieve the value of the <code>textSize</code> property for this <code>Label</code>.
	 * @returns {Number} The current value of <code>textSize</code>.
	 * @see UI.Label#setTextSize
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Label.synthesizeProperty('textSize', Commands.setTextSize);

	/**
	 * @name UI.Label#setTextInsets
	 * @description Set the value of the <code>textInsets</code> property for this <code>Label</code>. This property defines the viewable area of a text string when applying gravity.
	 * @example var label = new UI.Label();
	 * ...
	 * label.setTextInsets(0, 0, 0, 64);
	 * @param {Number, Array (Number)} textInsets The new value for <code>textInsets</code>. Set as individual components or a single array of components.
	 * @see UI.Label#getTextInsets
	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.Label#getTextInsets
	 * @description Retrieve the value of the <code>textInsets</code> property for this <code>Label</code>.
	 * @returns {Number, Array (Number)} The current value of <code>textInsets</code>.
	 * @see UI.Label#setTextInsets
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Label.synthesizeCompoundProperty('textInsets', Commands.setTextInsets);
	
			// helpers for legacy support... Bind full properties to a single state of another.
	var states = {
		'normal': Commands.State.Normal,
		'focused': Commands.State.Focused,
		'pressed': Commands.State.Pressed,
		'selected': Commands.State.Focused,
		'highlighted': Commands.State.Pressed,
		'disabled': Commands.State.Disabled
	};
	
	function bindStateProperties(propName) {
		var doSynthesis = function(propName, stateName, stateFlags) {
			var getterFn = function() {
				return this._getters[propName].call(this, stateFlags);
			}
			var setterFn = function(val) {
				return this._setters[propName].call(this, val, stateFlags);
			}
			var thisStatePropName = stateName + propName.charAt(0).toUpperCase() + propName.substr(1);
		//	NgLogD("Synthesizing Label." + thisStatePropName + " as getters[" + propName + "][" + stateFlags + "]");
			Label.registerAccessors(thisStatePropName, getterFn, setterFn,
				"Use " + propName + " accessors with a final state parameter instead.");
		}
		for (var stateName in states) {
			if (!states.hasOwnProperty(stateName)) continue;
			doSynthesis(propName, stateName, states[stateName]);
		}
	};
	
	bindStateProperties('text');
	bindStateProperties('textColor');
	bindStateProperties('textShadow');
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/Image'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/Image'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/Image'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var Image = exports.Image = AbstractView.subclass(
/** @lends UI.Image.prototype */
{
	/**
	 * @name UI.Image
	 * @class The <code>Image</code> class constructs objects that control the location and size of images used in the user interface.
	 * @augments UI.AbstractView
	 */
	initialize: function($super, properties) {
		if (Image._init) Image._init();
		$super(properties);
	},
	
	'type':'image'
});


// Properties
Image._init = function() {
	delete Image._init;
	if (AbstractView._init) AbstractView._init();

	/**
	 * @name UI.Image#setImage
	 * @description Set an image URL for a view state. This property defines how an image appears for specific conditions. For example,
	 * set one image for the default view state and another image for a view state with focus.
	 * @example var splashGraphic = new UI.Image();
	 * ...
	 * splashGraphic.setImage('./Content/splash.png');
	 * @see UI.Image#getImage
	 * @param {String} imageURL The new image URL.
	 * @param {UI.State} [flags=UI.State.Normal] A set of flags describing the view state(s) for using this URL.
	 * @status iOS, Android, Test
	 * @function 
	 */
	/**
	 * @name UI.Image#getImage
	 * @description Retrieve the <code>image</code> URL for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current image URL for the specified view state..
	 * @see UI.Image#setImage
	 * @status iOS, Android, Test
	 * @function
	 */
	Image.synthesizePropertyWithState('image', Commands.setImage);
	/**
	 * @name UI.Image#setImageBorder
	 * @description Set the value of the <code>imageBorder</code> property for a view state. This property defines a border for images used in the specified view state.
	 * @param {Object} imageBorder The new value for <code>imageBorder</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.Image#getImageBorder
	 * @function
 	 * @status iOS, Android, Test
	 */
	/**
	 * @name UI.Image#getImageBorder
	 * @description Retrieve the value of the <code>imageBorder</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {Object} The current value of <code>imageBorder</code>.
	 * @see UI.Image#setImageBorder
	 * @function
	 * @status iOS, Android, Test
	 */
	Image.synthesizePropertyWithState('imageBorder', Commands.setImageBorder);
	/**
	 * @name UI.Image#setImageGravity
	 * @description Set the value of the <code>imageGravity</code> property. This property defines how an image is positioned within a viewable area.
	 * @example var splashGraphic = new UI.Image();
	 * ...
	 * splashGraphic.setImageGravity([0.5, 0.0]);
	 * @param {Number} imageGravity The new value for <code>imageGravity</code> expressed as two floats.
	 * @see UI.Image#getImageGravity
	 * @function
	 * @status iOS, Android, Test
	 */
	/**
	 * @name UI.Image#getImageGravity
	 * @description Retrieve the value of the <code>imageGravity</code> property.
	 * @returns {Number} The current value of <code>imageGravity</code> expressed as two floats.
	 * @see UI.Image#setImageGravity
	 * @function
	 * @status iOS, Android, Test
	 */
	Image.synthesizeCompoundProperty('imageGravity', Commands.setImageGravity);
	 /**
	 * @name UI.Image#setImageTransform
	 * @description Set the value of the <code>imageTransform</code> property. This property defines data compression for images.
	 * @example var splashGraphic = new UI.Image();
	 * ...
	 * splashGraphic.setImageTransform([Math.cos(angle), Math.sin(angle), Math.sin(angle), Math.cos(angle), 0, 0]);
	 * @param {Array (Number)} imageTransform The new value for <code>imageTransform</code>. 
	 * Set as an array of floats (<i>a</i>, <i>b</i>, <i>c</i>, <i>d</i>, <i>tx</i>, <i>ty</i>).
	 * @see UI.Image#getImageTransform
	 * @function
	 */
	/**
	 * @name UI.Image#getImageTransform
	 * @description Retrieve the value of the <code>imageTransform</code> property.
	 * @returns {Array (Number)} The current value of <code>imageTransform</code>.
	 * @see UI.Image#setImageTransform
	 * @function
	 */
	 Image.synthesizeCompoundProperty('imageTransform', Commands.setImageTransform);
	/**
	 * @name UI.Image#setImageFit
	 * @description Set the value of the <code>imageFit</code> property. This property defines the scaling of bitmap images to fit within the bounds of a control 
	 * (subtracting the value for <code>imageInsets</code>).
	 * @example var splashGraphic = new UI.Image();
	 * ...
	 * splashGraphic.setImageFit(UI.FitMode.None);
	 * @param {Number} imageFit The new value for <code>imageFit</code>.
	 * @see UI.Image#getImageFit
	 * @function
 	 * @status iOS, Android, Test
	 */
	/**
	 * @name UI.Image#getImageFit
	 * @description Retrieve the value of the <code>imageFit</code> property.
	 * @returns {Number} The current value of <code>imageFit</code>.
	 * @see UI.Image#setImageFit
	 * @function
 	 * @status iOS, Android, Test
	 */
	Image.synthesizeProperty('imageFit', Commands.setImageFitMode);
	
		// helpers for legacy support... Bind full properties to a single state of another.
	var states = {
		'normal': Commands.State.Normal,
		'focused': Commands.State.Focused,
		'pressed': Commands.State.Pressed,
		'selected': Commands.State.Focused,
		'highlighted': Commands.State.Pressed,
		'disabled': Commands.State.Disabled
	};
	
	function bindStateProperties(propName) {
		var doSynthesis = function(propName, stateName, stateFlags) {
			var getterFn = function() {
				return this._getters[propName].call(this, stateFlags);
			}
			var setterFn = function(val) {
				return this._setters[propName].call(this, val, stateFlags);
			}
			var thisStatePropName = stateName + propName.charAt(0).toUpperCase() + propName.substr(1);
		//	NgLogD("Synthesizing Image." + thisStatePropName + " as getters[" + propName + "][" + stateFlags + "]");
			Image.registerAccessors(thisStatePropName, getterFn, setterFn,
				"Use " + propName + " accessors with a final state parameter instead.");
		}
		for (var stateName in states) {
			if (!states.hasOwnProperty(stateName)) continue;
			doSynthesis(propName, stateName, states[stateName]);
		}
	};
	
	bindStateProperties('image');
    bindStateProperties('imageBorder');
	bindStateProperties('gradient');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/Button'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/Button'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/Button'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var Button = exports.Button = AbstractView.subclass(
/** @lends UI.Button.prototype */
{
	/**
	 * @name UI.Button
	 * @class The <code>Button</code> class constructs objects that are used as application buttons.
	 * @augments UI.AbstractView
	 */
	'type':'button',

	'Layout':Commands.ButtonLayout,
	
	initialize: function($super, properties) {
		if (Button._init) Button._init();
		$super(properties);
	}
});

// Properties
Button._init = function() {
	delete Button._init;
	if (AbstractView._init) AbstractView._init();
	
	/**
	 * @name UI.Button#setImage
	 * @description Set an image URL for a view state. This defines how buttons appear for specific conditions. For example, 
	 * set different images for a button in the default view state and a button when it is pressed.
	 * @example var backButton = new UI.Button();        
	 * backButton.setImage('./Content/backButton.png', [w, h], [0, 0]);
	 * @see UI.Button#getImage
	 * @param {String} imageURL The new image URL.
	 * @param {UI.State} [flags=UI.State.Normal] A set of flags describing the view state(s) for using this URL.
 	 * @status iOS, Android, Test
	 * @function 
	 */
	/**
	 * @name UI.Button#getImage
	 * @description Retrieve the <code>image</code> URL for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current image URL for the specified view state..
	 * @see UI.Button#setImage
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Button.synthesizePropertyWithState('image', Commands.setImage);
	/**
	 * @name UI.Button#setImageInsets
	 * @description Set the value of the <code>imageInsets</code> property. This property defines the viewable area of an image when applying gravity.
	 * @example var backButton = new UI.Button();
	 * ...
	 * backButton.setImageInset([10,10,10,10]);
	 * @param {Number, Array (Number)} imageInsets The new value for <code>imageInsets</code>. Set as insets or an array of insets (expressed as floats).
	 * @see UI.Button#getImageInsets
 	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.Button#getImageInsets
	 * @description Retrieve the value of the <code>imageInsets</code> property.
	 * @returns {Number, Array (Number)} The current value of <code>imageInsets</code>.
	 * @see UI.Button#setImageInsets
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Button.synthesizeCompoundProperty('imageInsets', Commands.setImageInsets);
	/**
	 * @name UI.Button#setImageFit
	 * @description Set the value of the <code>imageFit</code> property. This property defines the scaling of bitmap images to fit within the bounds of a control 
	 * (subtracting the value for <code>imageInsets</code>).
	 * @example var backButton = new UI.Button();
	 * ...
	 * backButton.setImageFit(UI.FitMode.None);
	 * @param {Number} imageFit The new value for <code>imageFit</code>.
	 * @see UI.Button#getImageFit
	 * @function
 	 * @status iOS, Android, Test
	 */
	/**
	 * @name UI.Button#getImageFit
	 * @description Retrieve the value of the <code>imageFit</code> property.
	 * @returns {Number} The current value of <code>imageFit</code>.
	 * @see UI.Button#setImageFit
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	Button.synthesizeProperty('imageFit', Commands.setImageFitMode);
	/**
	 * @name UI.Button#setImageGravity
	 * @description Set the value of the <code>imageGravity</code> property. This property defines how a image for a button is positioned within a viewable area.
	 * @example var backButton = new UI.Button();
	 * ...
	 * backButton.setImageGravity([0.5, 0.0]);
	 * @param {Number} imageGravity The new value for <code>imageGravity</code> (expressed as two floats).
	 * @see UI.Button#getImageGravity
	 * @function
 	 * @status iOS, Android, Test
	 */
	/**
	 * @name UI.Button#getImageGravity
	 * @description Retrieve the value of the <code>imageGravity</code> property.
	 * @returns {Number} The current value of <code>imageGravity</code> (expressed as two floats).
	 * @see UI.Button#setImageGravity
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	Button.synthesizeCompoundProperty('imageGravity', Commands.setImageGravity);
	/**
	 * @name UI.Button#setImageTransform
	 * @description Set the value of the <code>imageTransform</code> property. This property defines data compression for an image used as a button.
	 * @example var button = new UI.Button()
	 * ...
	 * button.setImageTransform([Math.cos(angle), Math.sin(angle), Math.sin(angle), Math.cos(angle), 0, 0]);
	 * @param {Array (Number)} imageTransform The new value for <code>imageTransform</code>. 
	 * Set as an array of floats (<i>a</i>, <i>b</i>, <i>c</i>, <i>d</i>, <i>tx</i>, <i>ty</i>).
	 * @see UI.Button#getImageTransform
 	 * @status iOS, Android
	 * @function
	 */
	/**
	 * @name UI.Button#getImageTransform
	 * @description Retrieve the value of the <code>imageTransform</code> property.
	 * @returns {Array (Number)} The current value of <code>imageTransform</code>.
	 * @see UI.Button#setImageTransform
 	 * @status Javascript, iOS, Android, Flash
	 * @function
	 */
	Button.synthesizeCompoundProperty('imageTransform', Commands.setImageTransform);
	/**
	 * @name UI.Button#setImageBorder
	 * @description Set the value of the <code>imageBorder</code> property for a view state. This property defines a border for images used in the specified view state.
	 * @param {Object} imageBorder The new value for <code>imageBorder</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.Button#getImageBorder
 	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.Button#getImageBorder
	 * @description Retrieve the value of the <code>imageBorder</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {Object} The current value of <code>imageBorder</code>.
	 * @see UI.Button#setImageBorder
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Button.synthesizePropertyWithState('imageBorder', Commands.setImageBorder);
	
	/**
	 * @name UI.Button#setText
	 * @description Set the value of the <code>text</code> property for a view state. This property defines a text string to use as a label for a button in different view states.
	 * @example var infoButton = new UI.Button();
	 * ...
	 * infoButton.setText("More information");
	 * @see UI.Button#getText
	 * @param {String} text The new value for <code>text</code> in the specified view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
 	 * @status iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.Button#getText
	 * @description Retrieve the value of the <code>text</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>text</code> in the specified view state..
	 * @see UI.Button#setText
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Button.synthesizePropertyWithState('text', Commands.setText);
	/**
	 * @name UI.Button#setTextColor
	 * @description Set the value of the <code>textColor</code> property for a view state. This property defines the color of a text string used as a label on a 
	 * button in different view states.
	 * @example var infoButton = new UI.Button();
	 * ...
	 * infoButton.setTextColor('FFFFFF');
	 * @see UI.Button#getTextColor
	 * @param {String} textColor The new value for <code>textColor</code> in the specified view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
 	 * @status iOS, Android, Test
	 * @function 
	 */
	/**
	 * @name UI.Button#getTextColor
	 * @description Retrieve the value of the <code>textColor</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>textColor</code> in the specified view state..
	 * @see UI.Button#setTextColor
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Button.synthesizePropertyWithState('textColor', Commands.setTextColor);
	/**
	 * @name UI.Button#setTextFont
	 * @description Set the value of the <code>textFont</code> property. This property defines the font face used with labels for a button in different view states.
	 * @example var infoButton = new UI.Button();
	 * ...
	 * infoButton.setTextFont(myFont);
	 * @param {String} textFont The new value for <code>textFont</code> in the specified view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.Button#getTextFont
 	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.Button#getTextFont
	 * @description Retrieve the value of the <code>textFont</code> property.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value for <code>textFont</code> in the specified view state.
	 * @see UI.Button#setTextFont
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Button.synthesizePropertyWithState('textFont', Commands.setTextFont);
	/**
	 * @name UI.Button#setTextShadow
	 * @description Set the value of the <code>textShadow</code> property for a view state. This property defines the amount of text shadowing used on text strings for a button in different view states.
	 * @example var infoButton = new UI.Button();
	 * ...
	 * infoButton.setTextShadow("FF00 2.0 {0,-1}");
	 * @see UI.Button#getTextShadow
	 * @param {String} textShadow The new value for <code>textShadow</code> in the specified view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
 	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.Button#getTextShadow
	 * @description Retrieve the value of the <code>textShadow</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>textShadow</code> in the specified view state..
	 * @see UI.Button#setTextShadow	
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Button.synthesizePropertyWithState('textShadow', Commands.setTextShadow);
	/**
	 * @name UI.Button#setTextGravity
	 * @description Set the value of the <code>textGravity</code> property. This property defines how a text string for a button is positioned within a viewable area.
	 * @example var infoButton = new UI.Button();
	 * ...
	 * infoButton.setTextGravity([0.1, 0.5]);
	 * @param {Number, Array (Number)} textGravity The new value for <code>textGravity</code>. Set as individual components or a single array of components.
	 * @see UI.Button#getTextGravity
 	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.Button#getTextGravity
	 * @description Retrieve the value of the <code>textGravity</code> property.
	 * @returns {Number, Array (Number)} The current value of <code>textGravity</code>.
	 * @see UI.Button#setTextGravity
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Button.synthesizeCompoundProperty('textGravity', Commands.setTextGravity);

	/**
	 * @name UI.Button#setTextSize
	 * @description Set the value of the <code>textSize</code> property. This property defines the text size of labels for a button.
	 * @example var infoButton = new UI.Button();
	 * ...
	 * infoButton.setTextSize(24);
	 * @param {Number} textSize The new value for <code>textSize</code>.
	 * @see UI.Button#getTextSize
 	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.Button#getTextSize
	 * @description Retrieve the value of the <code>textSize</code> property.
	 * @returns {Number} The current value for <code>textSize</code>.
	 * @see UI.Button#setTextSize
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Button.synthesizeProperty('textSize', Commands.setTextSize);
	/**
	 * @name UI.Button#setTextInsets
	 * @description Set the value of the <code>textInsets</code> property. This property defines the viewable area of a text string when applying gravity.
	 * @example var infoButton = new UI.Button();
	 * ...
	 * infoButton.setTextInsets(0, 0, 0, 64);
	 * @param {Array (Number)} textInsets The new value for <code>textInsets</code>.
	 * @see UI.Button#getTextInsets
 	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.Button#getTextInsets
	 * @description Retrieve the value of the <code>textInsets</code> property.
	 * @returns {Array (Number)} The curent value for <code>textInsets</code>.
	 * @see UI.Button#setTextInsets
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Button.synthesizeCompoundProperty('textInsets', Commands.setTextInsets);
	
	// helpers for legacy support... Bind full properties to a single state of another.
	var states = {
		'normal': Commands.State.Normal,
		'focused': Commands.State.Focused,
		'pressed': Commands.State.Pressed,
		'disabled': Commands.State.Disabled,
		//** extra-deprecated */
		'selected': Commands.State.Focused,
		'highlighted': Commands.State.Pressed
	};
	
	function bindStateProperties(propName) {
		var doSynthesis = function(propName, stateName, stateFlags) {
			var getterFn = function() {
				return this._getters[propName].call(this, stateFlags);
			}
			var setterFn = function(val) {
				return this._setters[propName].call(this, val, stateFlags);
			}
			var thisStatePropName = stateName + propName.charAt(0).toUpperCase() + propName.substr(1);
		//	NgLogD("Synthesizing Button." + thisStatePropName + " as getters[" + propName + "][" + stateFlags + "]");
			Button.registerAccessors(thisStatePropName, getterFn, setterFn,
				"Use " + propName + " accessors with a final state parameter instead.");
		}
		for (var stateName in states) {
			if (!states.hasOwnProperty(stateName)) continue;
			doSynthesis(propName, stateName, states[stateName]);
		}
	};
	
	bindStateProperties('text');
	bindStateProperties('textColor');
    bindStateProperties('textFont');
	bindStateProperties('textShadow');
	bindStateProperties('gradient');
	bindStateProperties('image');
    bindStateProperties('imageBorder');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/GLView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/GLView'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/GLView'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var GLView = exports.GLView = AbstractView.subclass(
/** @lends UI.GLView.prototype */
{
	'type':'glview',
	/**
	* @class The <code>GLView</code> class constructs objects that provide applications with access to OpenGL. Games must instantiate a <code>GLView</code> object, 
	* set the active state to <code>true</code> and wait for the callback before instantiating any objects in the {@link GL2} module.
	* @name UI.GLView
	* @augments UI.AbstractView	
	*/
	initialize: function($super, properties) {
		if (GLView._init) GLView._init();
		$super(properties);
	}
});

GLView._init = function() {
	delete GLView._init;
	if (AbstractView._init) AbstractView._init();

	/**
	 * @name UI.GLView#setActive
	 * @description Set the value of the <code>active</code> property.
	 * @example var glView = new UI.GLView()
	 * ...
	 * glView.setActive(true);
	 * @param {Boolean} active Set as <code>true</code> if the <code>GLView</code> object is active.
	 * @see UI.GLView#getActive
	 * @status iOS, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.GLView#getActive
	 * @description Retrieve the value of the <code>active</code> property.
	 * @returns {Boolean} Returns <code>true</code> if the <code>GLView</code> object is active.
	 * @see UI.GLView#setActive
	 * @status iOS, Android, Flash, Test
	 * @function
	 */
	GLView.synthesizeProperty('active', Commands.setActive);
	
	/**
	 * @name UI.GLView#getOGLExtensions
	 * @description Return an array containing all of the OpenGL extensions that are supported within the context of this view.
	 * The return value of this method is only valid when the view is active.
	 * @status Android
	 * @function
	 */
	GLView.registerAccessors('OGLExtensions', function() {return this['_OGLExtensions'];}, function() {} );
	
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/NavController'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/NavController'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/NavController'] = exports; var MessageListener = require('NGCore/Client/Core/MessageListener').MessageListener;
var KeyEmitter = require('NGCore/Client/Device/KeyEmitter').KeyEmitter;
var Window = require('NGCore/Client/UI/Window').Window;
var Capabilities = require('NGCore/Client/Core/Capabilities').Capabilities;
var Device = require('NGCore/Client/Device').Device;
var Element = require('NGCore/Client/UI/Element').Element;
var View = require('NGCore/Client/UI/View').View;

function getAnalyticsName(item){
	if(item && item.hasOwnProperty("analyticsName")){
		return item["analyticsName"] || undefined;	// If NULL, return undefined.
	}
	return undefined;
}

var NavKeyListener = MessageListener.subclass({
	classname: "UI_NavController_KeyListener",
});

var NavController = exports.NavController = View.subclass(
/** @lends UI.NavController.prototype */
{
	/**
	 * @class The <code>NavController</code> class constructs objects that define application navigation components.
	 * @constructs The default constructor. 
	 * @augments Core.Class
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {String} properties Object properties.
	 */
	initialize: function($super, properties) {
		if (NavController._init) NavController._init();
		
	    this.navStack = [];
		var onAndroid = Capabilities.getPlatformOS() == 'Android';
	    this._useBackButton = !onAndroid;
	
		this.keyListener = new NavKeyListener();
		KeyEmitter.addListener(this.keyListener, this.onKeyPressed.bind(this));
		$super(properties);
	},
	
	/**
	 * Turn on the onscreen <b>Back</b> button. Applications designed for iOS should always provide the <b>Back</b> button 
	 * and integrate it into the application UI (calling <code>{@link UI.NavController#back}</code> when pressed).<br><br>
	 * <b>Note:</b> This is turned off by default for applcations designed for Android because Android devices contain a hardware <b>Back</b> button.
	 * @param {Boolean} toUse Set as <code>true</code> to enable the onscreen <b>Back</b> button.
	 * @function
	 * @status Javascript, iOS, Android, Flash
	 */
	setUseBackButton: function(toUse) {
		this._useBackButton = toUse;
		if (toUse) {
			this._createBackButton();
		} else if (this.backButton) {
			this.backButton.removeFromParent();
		}
	},
    
	/**
	 * Reset the stack for this <code>NavController</code>.
	 * @param {String} fromButton The button to reset.
	 * @status Javascript, iOS, Android, Flash
	 */    
	clear: function(fromButton) {
		return this.backToView(undefined);
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	logNavEvent: function (from, to, via) {
		var toName = getAnalyticsName(to);
		var fromName = getAnalyticsName(from);
		var viaName = getAnalyticsName(via);
		if (fromName || toName) {
			Core.Analytics._getPipe().navigationEvent(fromName, toName, viaName);
		}
	},
	
	/**
	 * Retrieve the top view from the nav stack of this <code>NavController</code>.
	 * @returns {Object} The top view in the nav stack
	 * @status Javascript, iOS, Android, Flash
	 * @function
	 */
	getTopView: function() {
		return (this.navStack.length > 0) ? this.navStack[ (this.navStack.length - 1) ] : undefined;
	},
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash
	*/
	navStackDepth: function() {
		return this.navStack.length;
	},
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash
	*/
	depthOfView: function(targetView) {
		var targetIndex = this.navStack.indexOf(targetView);
		if(targetIndex == -1){return -1;}
		
		return this.navStack.length - targetIndex - 1;
	},
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash
	*/
	viewAtDepth: function(targetDepth) {
		if(targetDepth >= this.navStack.length){
			return null;
		}
		return this.navStack[this.navStack.length - targetDepth - 1];
	},
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash
	*/
	removeDeepView:function(targetView) {
		var targetIndex = this.navStack.indexOf(targetView);
		if(targetIndex == -1){
			NgLogE("NavController: trying to remove a nonexistent view from the nav stack!");
			return;
		}
		this.navStack.splice(targetIndex,1);
	},
    
	/**
	 * @protected
	 * @status Javascript, iOS, Android, Flash
	 * @function
	 */
	_viewTransition: function(fromView, toView, back, buttonRef) {
		//The views transition within the container (which is 'this')
		var myFrame = this.getFrame();
		var w = myFrame[2];
		var h = myFrame[3];
		
		//TODO: animate this (below) transition.
		if (toView) {
			toView.setFrame( (back ? -w : w), 0, w, h);
			this.addChild(toView);
		}
		
		UI.animate(function() {
			if (fromView) fromView.setFrame( (back ? w : -w), 0, w, h);
			if (toView) toView.setFrame(0, 0, w, h);
		}, 400, function() {
			if (fromView) fromView.removeFromParent();
		});
		
		this.logNavEvent(fromView, toView, buttonRef);
		this._createBackButton();
	},

	/**
	 * Retrieve removed views in the reverse order they were removed.
	 * @example var page = new NavPage({...});
	 *
	 * var controller = new UI.NavController({...});
	 *
	 * NavPage.navController = controller;
	 * controller.forwardToView(page);
	 * @param {String} destView The destination view for this navigation component.
	 * @param {String} fromButton The button that triggers this navigation component.
	 * @status Javascript, iOS, Android, Flash
	 * @see UI.NavController#backToView
	 */    
	forwardToView: function(destView, fromButton) {
		var currentView = this.getTopView();
		if (destView && 
			(!this._delegate 
				|| (this._delegate 
					&& typeof this._delegate.navControllerShouldPush == "function" 
					&& this._delegate.navControllerShouldPush(this,destView))
			)) {
			
			destView.performEventCallback({eventType:"push",navController:this})
			
			this.navStack.push(destView);
			this._viewTransition(currentView, destView, false, fromButton);
		}
	},
    
	/**
	 * Set back navigation for this <code>NavController</code>.
	 * @param {String} fromButton The button that triggers this navigation component.
	 * @status Javascript, iOS, Android, Flash
	 * @see UI.NavController#forward	
	 */
	back: function(fromButton) {
		var removed = this.navStack.pop();
		
		if (removed && 
			(!this._delegate 
				|| (this._delegate 
					&& typeof this._delegate.navControllerShouldPop == "function" 
					&& this._delegate.navControllerShouldPop(this,removed))
			)) {
			removed.performEventCallback({eventType:"pop",navController:this});
		} else {
			return null;
		}
		this._viewTransition(removed, this.getTopView(), true, fromButton);
		return removed;
	},

	/**
	 * Retrieve removed views in the order they were removed.
	 * @example var page = new NavPage({...});
	 *
	 * var controller = new UI.NavController({...});
	 *
	 * NavPage.navController = controller;
	 * controller.backToView(page);
	 * @param {String} destView The destination view for this navigation component.
	 * @param {String} fromButton The button that triggers this navigation component.
	 * @status Javascript, iOS, Android, Flash
	 * @see UI.NavController#forwardToView
	 */    
	backToView: function(destView, fromButton) {
		var removedSet = [];
		var removed = this.navStack.pop();
		var originalView = removed;
		if (removed) {
			do {
				if (removed && 
					(!this._delegate 
						|| (this._delegate 
							&& typeof this._delegate.navControllerShouldPop == "function" 
							&& this._delegate.navControllerShouldPop(this,removed))
					)) {
					removedSet.push(removed);
					removed.performEventCallback({eventType:"pop",navController:this});
				}
				else {
					//There was nothing to remove, or the this._delegate said "don't remove".
					break;
				}
				
				if (this.getTopView() == destView){break;}
			} while ((removed = this.navStack.pop()));
		}
		if(removedSet.length > 0) {
			this._viewTransition(originalView, this.getTopView(), true, fromButton);
		}
		return removedSet;
	},

	/**
	 * Set this <code>NavController</code> to launch the application when activated.
	 * @status Javascript, iOS, Android, Flash
	 */    
	loadApp: function() {		
	},
    
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash
	 */    
	onBackPressed: function() {
		if (this.navStack.length > 1) {
		//	NgLogD("Handle back on nav stack. Number of views on stack=" + this.navStack.length);
			
			var analyticsName = "bcksbtn"; // Back System Button
			
			// if the topmost view has an analytics name, prefix the button
			var topView = this.getTopView();
			if(topView.analyticsName){
				analyticsName = topView.analyticsName + "." + analyticsName;
			}

			this.back({
				analyticsName: analyticsName
			});
			return true;
		}
		return false;
	},
	
	onKeyPressed: function(event) {
		if ((event.code === Device.KeyEmitter.Keycode.back) && (this.navStack.length > 1)) {
			this.back();
			return true;
		}
		return false;
	},
	
	/**
	 * @protected
	 * @status Javascript, iOS, Android, Flash
	 */
	_delegate:null,
	/**
	 * @description Set subscribers to the <code>NavController</code> behavior. Subscribers can modify what happens. 
	 * NavControllerDelegateProtocol:
	 *	@optional - (BOOL)navControllerShouldPop(NavController,View)
	 *	@optional - (BOOL)navControllerShouldPush(NavController,View)
	 * @param {String} navDelegate A <code>NavController</code> subscriber.
	 * @private
	 * @status Javascript, iOS, Android, Flash
	 */
	setDelegate:function( /*NavControllerDelegate*/ navDelegate){
		this._delegate = navDelegate;
	},
	
	delegate:function(){return this._delegate;},
	
	/**
	 * @protected
	 * @status Javascript, iOS, Android, Flash
	 * @function
	 */
	_createBackButton: function() {
		// Do nothing if this device does not require an onscreen button.
		if (!this._useBackButton) return;
		
		if (!this.backButton) {
			this.backButton = new UI.Button({
				normalText: 'Back',
				textSize: 13.0,
				normalTextColor: "FF",
				normalTextShadow: "00 1.5 {0,-1}",
				frame: [-2, 20, Window.outerWidth / 5, Window.outerHeight / 12],
				normalGradient: {
					corners: "0 8 8 0",
					outerLine: "00 1.5",
					innerShadow: "99FF 2.0 {0,-1}",
					gradient: [
						"FFCC 0.0",
						"FF80 1.0"
					]
				},
				highlightedGradient: {
					corners: "0 8 8 0",
					outerLine: "00 1.5",
					innerLine: "FF00 15 {0,-1}",
					gradient: [
						"FF50 0.0",
						"FF80 1.0"
					]
				}
			});
			this.backButton.onclick = this.bind(this.onBackPressed);
		}
		
		if (this.navStack.length > 1) {
			if (!this.backButton.getParent()) Window.document.addChild(this.backButton);
		} else if ( this.backButton.getParent() ) {
			this.backButton.removeFromParent();
		}
	}
});

NavController._init = function() {
	delete NavController._init;
	if (View._init) View._init();
}; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/WebView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/WebView'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/WebView'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var WebView = exports.WebView = AbstractView.subclass(
/** @lends UI.WebView.prototype */
{
	'type':'webview',

	/**
	 * @class The <code>WebView</code> class constructs objects for loading and navigating documents. 
	 * <code>WebView</code> objects also trigger event callback functions when web page events occur.
	 * @constructs The default constructor. 
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {String} properties Object properties.
	 * @augments UI.AbstractView
	 */
	initialize: function($super, properties) {
		if (WebView._init) WebView._init();
		this._canGoBack = false;
		this._canGoForward = false;
		return $super(properties);
	},
	
	/** @private */
	_onShouldLoad: function(event) {
		NgLogD("Should Load " + event.url + " ???????");
		var fn = this.getOnShouldload();
		if (typeof fn == 'function') {
			// If we SHOULDN'T load the url, bail.
			if (!Boolean(fn.call(this, event))) return;
		}
		// The default (if the function was missing or not a function) is to load the url.
		this.loadUrl(event.url);
	},
	
	/** @private */
	performEventCallback: function($super, event) {
		try {
			if (event.eventType == 'shouldload') {
				// We need to call the onShouldLoad function in a way that captures the return value.
				this._onShouldLoad(event);
				return;
			}
			if (event.eventType == 'pageload') {
				// Do not touch this parsing code. Everything else is wrong, extensive testing was done.
				this._canGoBack = event.canGoBack = Boolean(JSON.parse(event.canGoBack));
				this._canGoForward = event.canGoForward = Boolean(JSON.parse(event.canGoForward));
			}
			$super(event);
		} catch(e) {
			NgHandleException(e);
		}
	},
	// invoke doesn't return a value. to get response, use onpageevent
	/**
	* Run a string of Javascript code in this <code>WebView</code>. Any code requiring a result from <code>invoke()</code> must explicitly 
	* return a value by attempting to load an ngcore:// URL. The attempted load is caught by <code>pageEvent</code>. 
	* @see UI.WebView#event:setOnPageevent
	* @function
    * @status iOS, Android
	*/
	invoke: Commands.invoke,
	/**
	* Set a document to load from the specified URL.
	* @example myWebView = new UI.WebView();
	* ...
	* myWebView.loadUrl('http://www.webdoc.com/");
	* @param {String} url The URL from which to load a document.
	* @param {String} [headers] The document headers.
	* @param {Number} [timeout] The timeout duration.
	* @see UI.WebView#loadDocument
    * @status iOS, Android
	*/
	loadUrl: function(url, headers, timeout) {
		Commands.loadURL.call(this, url, headers || null, +(timeout || 0));
	},
	/**
	* Set a document to load from the specified local path.
	* @example myWebView = new UI.WebView();
	* ...
	* myWebView.loadUrl('./path/to/document/");
	* @param {String} relativePath The local path from which to load a document.
	* @see UI.WebView#loadUrl
    * @status iOS, Android
	*/
	loadDocument: function(relativePath){
		Commands.setSourceDocument.call(this, relativePath);
	},
	/**
	* Load a URL using the HTTP <code>POST</code> method.
	* @param {String} url The URL to load using <code>POST</code>.
	* @param {String / Object} data A string containing the raw <code>POST</code> body, or an object to post with <code>www/form-data</code> encoding containing key/value pairs.
	* @see UI.WebView#loadUrl,
	* @see UI.WebView#loadDocument
    * @status iOS, Android
	*/
	postUrl: function(url, data){
		var dataStr;
		if(typeof data == "object"){
			var params = [];
			for(var key in data){
				params.push(encodeURIComponent(key) + '=' + encodeURIComponent(data[key]));
			}
			dataStr = params.join('&');
		}else{
			dataStr = data;
		}
		Commands.postURL.call(this, url, dataStr);
	},
	/**
	* Stop loading a document. 
	* @function
    * @status iOS, Android
	*/
	stopLoading: Commands.stopLoading,
	/**
	* Reload a document called with <code>loadDocument()</code> or <code>loadUrl()</code>.
	* @see UI.WebView#loadDocument,
	* @see UI.WebView#loadUrl
	* @function
    * @status iOS, Android
	*/
	reload: Commands.reload,
	/**
	* Navigate to the previous page in a document view.
	* @see UI.WebView#goForward
	* @function
    * @status iOS, Android
	*/
	goBack: Commands.goBack,
	/**
	* Navigate to the next page in a document view.
	* @see UI.WebView#goBack
	* @function
    * @status iOS, Android
	*/
	goForward: Commands.goForward,
	/**
	* Set back navigation as supported in this <code>WebView</code>.
	* @returns {Boolean} Returns <code>true</code> if this <code>WebView</code> supports back navigation.
	* @see UI.WebView#canGoForward
    * @status iOS
	*/
	canGoBack: function(){
		return this._canGoBack;
	},
	/**
	* Set that forward navigation is supported in this <code>WebView</code>.
	* @returns {Boolean} Returns <code>true</code> if this <code>WebView</code> supports forward navigation.
	* @see UI.WebView#canGoBack
    * @status iOS
	*/
	canGoForward: function(){
		return this._canGoForward;
	},
	/**
	* Set the authentication credentials for this <code>WebView</code> session.
	* @param {String} host The authentication host.
	* @param {String} realm The security realm.
	* @param {String} username The username to use for authenticating the session.
	* @param {String} password The password to use for authenticating the session.
    * @status iOS, Android
	*/
	setBasicAuthCredential: function(host, realm, username, password){
		Commands.setBasicAuthCredentials.call(this, {'host':host, 'realm':realm, 'username':username, 'password':password});
	},

	setViewportEnabled: function(enabled) {
		Commands.setViewportEnabled.call(this, enabled);
	}
});

WebView._init = function() {
	delete WebView._init;
	if (AbstractView._init) AbstractView._init();
	
	WebView.synthesizeProperty('scrollable', Commands.setScrollable);
	
	/**
	 * @name UI.WebView#setOnStartload
	 * @description Set a function to call when the <code>startload</code> event occurs.
	 * @param {Function} startloadCallback The function to call.<br><br>
	 * <b>Note:</b> The <code>startload</code> event is disabled if the value of this parameter is not a function.
	 * @see UI.WebView#event:getOnStartload
	 * @event
	 * @status iOS, Android
	 */
	/**
	 * @name UI.WebView#getOnStartload
	 * @description Retrieve the function to call when the <code>startload</code> event occurs.
	 * @returns {Function} The current callback function.
	 * @see UI.WebView#event:setOnStartload
	 * @event
	 * @status iOS, Android
	 */
	WebView.registerEventType('startload');
	/**
	 * @name UI.WebView#setOnPageload
	 * @description Set a function to call when the <code>pageload</code> event occurs.
	 * @param {Function} pageloadCallback The function to call.<br><br>
	 * <b>Note:</b> The <code>pageload</code> event is disabled if the value of this parameter is not a function.
	 * @see UI.WebView#event:getOnPageload
	 * @event
	 * @status iOS, Android
	 */
	/**
	 * @name UI.WebView#getOnPageload
	 * @description Retrieve the function to call when the <code>pageload</code> event occurs.
	 * @returns {Function} The current callback function.
	 * @see UI.WebView#event:setOnPageload
	 * @event
	 * @status iOS, Android
	 */
	WebView.registerEventType('pageload');
	/**
	 * @name UI.WebView#setOnError
	 * @description Set a function to call when the <code>error</code> event occurs.
	 * @param {Function} [errorCallback] The function to call.<br><br>
	 * <b>Note:</b> The <code>error</code> event is disabled if the value of this parameter is not a function.
	 * @see UI.WebView#event:getOnError
	 * @event
	 * @status iOS, Android
	 */
	/**
	 * @name UI.WebView#getOnError
	 * @description Retrieve the function to call when the <code>error</code> event occurs.
	 * @returns {Function} The current callback function.
	 * @see UI.WebView#event:setOnError
	 * @event
	 * @status iOS, Android
	 */
	WebView.registerEventType('error');
	/**
	 * @name UI.WebView#setOnPageevent
	 * @description Set a function to call when the <code>pageevent</code> event occurs.
	 * @param {Function} pageeventCallback The new callback function.<br><br>
	 * <b>Note:</b> The <code>pageevent</code> event is disabled if the value of this parameter is not a function.
	 * @see UI.WebView#event:getOnPageevent
	 * @event
	 * @status iOS, Android
	 */
	/**
	 * @name UI.WebView#getOnPageevent
	 * @description Retrieve the function to call when the <code>pageevent</code> event occurs.
	 * @returns {Function} The current callback function.
	 * @see UI.WebView#event:setOnPageevent
	 * @event
	 * @status iOS, Android
	 */
	WebView.registerEventType('pageevent');	
	/** 
	* @name UI.WebView#setOnShouldLoad
	* @description Set a function to call when the <code>shouldload</code> event occurs. The callback for the event returns 
	* <code>true</code> if the page should be loaded. Otherwise, the callback returns <code>false</code>.
	* @param {function} shouldloadCallback The new callback function.<br><br>
	* <b>Note:</b> The <code>shouldload</code> event is disabled if the value of this parameter is not a function.
	* @example  myWebView.setOnShouldload( function(event) {
	NgLogD("URL is " + event.url);
	NgLogD("Nav Type is " + event.navigation);
  } );
	* @see UI.WebView#event:getOnShouldLoad
	* @event
	*/
	/**
	* @name UI.WebView#getOnShouldLoad
	* @description Retrieve the function to call when the <code>shouldload</code> event occurs.
	* @returns {function} The current callback function.
	* @see UI.WebView#event:setOnShouldLoad
	* @event
	*/
	WebView.registerEventType('shouldload');
	
	/** 
	* @name UI.WebView#setOnExternalLink
	* @description Set a function to call when a link will be opened in an external application.
	* @param {function} ExternalLinkCallback The new callback function.<br><br>
	* @see UI.WebView#event:getOnExternalLink
	* @event
	*/
	/**
	* @name UI.WebView#getOnExternalLink
	* @description Retrieve the function to call when the <code>ExternalLink</code> event occurs.
	* @returns {function} The current callback function.
	* @see UI.WebView#event:setOnExternalLink
	* @event
	*/
	WebView.registerEventType('externalLink');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/ScrollView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/ScrollView'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/ScrollView'] = exports; var View = require('NGCore/Client/UI/View').View;
var ViewGeometry = require('NGCore/Client/UI/ViewGeometry');
var Commands = require('NGCore/Client/UI/Commands').Commands;

var ScrollView = exports.ScrollView = View.subclass(
/** @lends UI.ScrollView.prototype */
{
	'type':'scrollview',
	/**
	* @class The <code>ScrollView</code> class constructs objects that handle views in a scrolling list (see <code>{@link UI.ListView}</code>). 
	* You can define these views as scrolling vertically, horizontially, or both directions.<br><br>
	* <b>Note:</b> Android devices can only scroll in one direction at a time.
	* @name UI.ScrollView
	* @augments UI.View
	*/
	initialize: function($super, properties) {
		if (ScrollView._init) ScrollView._init();
		this._scrollPosition = [0, 0];
		return $super(properties);
	},
	
	/**
	 * @private
	 */    
	updateScrollPosition: function(newVal) {
		this._scrollPosition = newVal;
	},
	
	/**
	 * @private
	 */    
	performEventCallback: function($super, e) {
		if (e.eventType == 'scroll') this.updateScrollPosition(e.scrollPosition);
		$super(e);
	}
});

// Properties
ScrollView._init = function() {
	delete ScrollView._init;
	if (View._init) View._init();

	/**
	 * @name UI.ScrollView#setContentSize
	 * @description Set the value for the <code>contentSize</code> property. This property defines the size of a scroll area.
	 * @example var dialog = {
	 * 	width: screen.width * sizeRate.width / 100,
	 *	height: screen.height * sizeRate.height / 100
	 * };
	 * ...
	 * this.scrollView.setContentSize([dialog.width, 600]);
	 * @params {Number, Array (Number, String)} Individual components or a component array.
	 * @see UI.ScrollView#getContentSize
	 * @function
     * @status iOS, Android, Test
	 */
	/**
	 * @name UI.ScrollView#getContentSize
	 * @description Retrieve the value of the <code>contentSize</code> property.
	 * @returns {Number, Array (Number, String)} The current value of <code>contentSize</code>.
	 * @see UI.ScrollView#setContentSize
	 * @function
     * @status iOS, Android, Test
	 */
	ScrollView.synthesizeCompoundProperty('contentSize', Commands.setScrollableSize);
	/**
	 * @name UI.ScrollView#setScrollPosition
	 * @description Set the value for the <code>scrollPosition</code> property.
	 * @example var hscroller = new UI.ScrollView();
	 * ...
	 * hscroller.setScrollPosition([0.5,0]);
	 * @params {Number, Array (Number)} Individual components or a component array.
	 * @see UI.ScrollView#getScrollPosition
	 * @function
     * @status iOS, Android, Test
	 */
	/**
	 * @name UI.ScrollView#getScrollPosition
	 * @description Retrieve the value of the <code>scrollPosition</code> property.
	 * @returns {Number, Array (Number)} The current value of <code>scrollPosition</code>.
	 * @see UI.ScrollView#setScrollPosition
	 * @function
     * @status iOS, Android, Test
	 */
	ScrollView.synthesizeCompoundProperty('scrollPosition', Commands.setScrollPosition);
	
	/**
	 * @name UI.ScrollView#setScrollIndicatorsVisible
	 * @description Set the value for the <code>scrollIndicatorsVisible</code> property.
	 * @example var hscroller = new UI.ScrollView();
	 * ...
	 * hscroller.setScrollIndicatorsVisible(false);
	 * @params {Boolean} Whether scroll indicators should be visible.
	 * @see UI.ScrollView#getScrollIndicatorsVisible
	 * @function
     * @status iOS, Android, Test
	 */
	/**
	 * @name UI.ScrollView#getScrollIndicatorsVisible
	 * @description Retrieve the value of the <code>scrollIndicatorsVisible</code> property.
	 * @returns {Boolean} Whether scroll indicators will be visible during scrolling.
	 * @see UI.ScrollView#setScrollIndicatorsVisible
	 * @function
     * @status iOS, Android, Test
	 */
	ScrollView.synthesizeCompoundProperty('scrollIndicatorsVisible', Commands.setScrollIndicatorsVisible);

	/**
	 * @name UI.ScrollView#setOnScroll
	 * @description Set a function to call when the <code>scroll</code> event occurs.
	 * @param {Function} scrollCallback The new callback function.<br><br>
	 * <b>Note:</b> The <code>scroll</code> event is disabled if the value of this parameter is not a function.
	 * @see UI.ScrollView#event:getOnScroll
	 * @event
     * @status iOS, Android, Test
	 */
	/**
	 * @name UI.ScrollView#getOnScroll
	 * @description Retrieve the function to call when the <code>scroll</code> event occurs.
	 * @returns {Function} The current callback function.
	 * @see UI.ScrollView#event:setOnScroll
	 * @event
     * @status iOS, Android, Test
	 */
	ScrollView.registerEventType('scroll');
	
	ScrollView.registerEventType('scrollEnded');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/ListView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/ListView'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/ListView'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var ScrollView = require('NGCore/Client/UI/ScrollView').ScrollView;
var ViewGeometry = require('NGCore/Client/UI/ViewGeometry');

var ListView = exports.ListView = ScrollView.subclass(
/** @lends UI.ListView.prototype */
{
	'type':'listview',
	/**
	* @class The <code>ListView</code> class constructs objects that contain <code>{@link UI.ListViewItem}</code> and <code>{@link UI.ListViewSection}</code> objects. 
	* These objects handle and render scrolling lists in an application.
	* A <code>ListView</code> object can contain potentially thousands of items, 
	* in sections, that use a pool of reusable views to display content.
	* @name UI.ListView
	* @augments UI.ScrollView
	*/
	initialize:function($super, properties) {
		if (ListView._init) ListView._init();
		$super(properties);
		
		this._sections = [];
		this._scrollPosition = [0,0];
		this.enableEvent('scroll', true);
		
		this._ownedViews = [];
		this._queuedViews = {};
		
		this._cellDivider = 0;
		
		return this;
	},
	
	destroy: function($super) {
		var l = this._ownedViews.length;
		for (var i = 0; i < l; i++) {
			this._ownedViews[i].release();
		}
		this._ownedViews = null;
		$super();
	},
	
	addChild: function($super, child, index) {
		if (index == "cell") {
			index = this._cellDivider++;
		} else if ((index || -1) >= 0) {
			index += this._cellDivider;
		}
		$super(child, index);
	},
	
	_viewForItem: function(lvItem) {
		if (lvItem._currentView instanceof AbstractView) return lvItem._currentView;
		
		var rID = lvItem._reuseId;
		var queue = this._queuedViews[rID];
		
		var view = null;
		while (queue && queue.length > 0) {
			if ((view = queue.pop()) instanceof AbstractView) break;
		}
		
		if (!(view instanceof AbstractView)) {
			view = lvItem._onCreateView(lvItem);
			if (view instanceof AbstractView) {
				this._ownedViews.push(view.retain());
				this.addChild(view, "cell");
			} else {
				console.log("Error creating view for list item with reuse id " + rID);
			}
		}
	//	console.log("_viewForItem: " + lvItem + " = " + view);
		return view;
	},
	
	_queueViewForItem: function(lvItem) {
		var viewToQueue = lvItem._currentView;
		if (viewToQueue instanceof AbstractView) {
			var rId = lvItem._reuseId;
			var queue = this._queuedViews[rId] || (this._queuedViews[rId] = []);
			queue.push(viewToQueue);
		}
		lvItem._setCurrentView();
	},
	
	_removeQueuedViews: function() {
		for (var q in this._queuedViews) {
			if (!this._queuedViews.hasOwnProperty(q)) continue;
			
			q = this._queuedViews[q];
			for (var i = 0, l = q.length; i < l; i++) {
				q[i].removeFromParent();
			}
		}
		this._cellDivider = 0;
	},
	
	/**
	 * @private
 	 * @status Javascript, iOS, Android, Flash
	 */
	flushSections: function() {
		for (var i in this._sections) {
			if(!this._sections.hasOwnProperty(i)) { continue; }
				
			var section = this._sections[i];
			// Cause every section to completely queue out its item views.
			section.flush();
			section.calculateItemPositions();
		}
		this._removeQueuedViews();
	},
	
	/**
	 * Clear this <code>ListView</code> and reload all list data.
	 * @see UI.ListViewItem,
	 * @see UI.ListViewSection
 	 * @status Javascript, iOS, Android, Flash
	 */
	reloadData: function() {
		this.flushSections();
		this.calculateSectionPositions();
		this.updateScrollPosition(this._scrollPosition);
	},
	
	/**
	 * Retrieve all contained sections by this <code>ListView</code>.
	 * @returns {Object} The current section list as an array of section IDs.
	 * @see UI.ListView#setSections
 	 * @status Javascript, iOS, Android, Flash
	 */
	getSections: function() {
		return this._sections;
	},
	
	/**
	 * Set the list of sections that this <code>ListView</code> contains.
	 * @example var sections = [];
	 * var section = new UI.ListViewSection;
	 * ...
	 * var items = [];
	 * for(news in News)
	 * {
	 *	var item = new ListItem.ListItem();
	 *	item.game = News[news];
	 *	items.push(item);
	 * }
	 *
	 * section.setItems(items);
	 * sections.push(section);
	 *
	 * gameNews.setSections(sections);
	 * @param {Object} newSections A new aray of section IDs.
	 * @see UI.ListView#getSections
 	 * @status Javascript, iOS, Android, Flash
	 */
	setSections: function(newSections) {
		this.flushSections();
		for (var i in this._sections) {
			if(this._sections.hasOwnProperty(i)) {
				this._sections[i].setListView(null);
			}
		}
		this._sections = newSections;
		var idArray = new Array();
		for (var i in newSections) {
			if(newSections.hasOwnProperty(i)) {
				idArray.push(0+(newSections[i].__objectRegistryId || 0));
			}
		}
		UI.Commands.setSections.call(this, idArray);
		this.reloadData();
	},
	
	/**
	 * @private
 	 * @status Javascript, iOS, Android, Flash
	 */
	calculateSectionPositions: function() {
		this._stackedSections = {};
		topY = 0;
		// Should account for header here.
		var l = this._sections.length;
		for (var i = 0; i < l; i++) {
		//	NgLogD("Calculating height for Section " + i + " / " + l + " from yPos " + topY);
			var section = this._sections[i];
			this._stackedSections[topY] = section;
			section.setListView(this);
			section.setYPosition(topY);
			var relTopY = this._scrollPosition[1/*y*/] - topY;
			section.updateVisibleRange(relTopY, relTopY + this._frame[3/*h*/]);
			var h = section._measureHeight();
			// Set the section's frame...
			section._setFrame(0, topY, this._frame[2], h);
			topY += h;
		}
		// Should account for footer here.
		this.setContentSize([this._frame[2], topY]);
	},
	
	/**
	 * @private
 	 * @status Javascript, iOS, Android, Flash
	 */
	updateScrollPosition:function(newVal) {
		if (this._scrollPosition[1] === newVal[1]) return;
		this._scrollPosition = newVal;
		
		var myHeight = this._frame[3];
		for (var yPos in this._stackedSections) {
			if(this._stackedSections.hasOwnProperty(yPos)) {
				var section = this._stackedSections[yPos];
				relTopY = newVal[1] - yPos;
				section.updateVisibleRange(relTopY, relTopY + myHeight);
			}
		}
	},
	
	/**
	 * @protected
 	 * @status Javascript, iOS, Android, Flash
	 */
	'_onScroll': function() {},
	
	/**
	 * @private
 	 * @status Javascript, iOS, Android, Flash
	 */
	enableEvent: function($super, eventName, enable) {
		// Don't allow scrolling events to be turned off!
		if ( (eventName == 'scroll') && !enable ) return;
		$super(eventName, enable);
	}
});

ListView._init = function() {
	delete ListView._init;
	if (ScrollView._init) ScrollView._init();

	/**
	 * @name UI.ListView#setHeader
	 * @description Set the value for the <code>header</code> property. This string is used as a header for the <code>ListView</code>.
	 * @example var friendHeader = mew UI.ListView();
	 * ...
	 * friendHeader.setHeader('Friends List');
	 * @param {String} header The new header.
	 * @see UI.ListView#getHeader
	 * @function
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * @name UI.ListView#getHeader
	 * @description Retrieve the value of the <code>header</code> property.
	 * @returns {String} The current header.
	 * @see UI.ListView#setHeader
	 * @function
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	ListView.synthesizeProperty('header');
	/**
	 * @name UI.ListView#setFooter
	 * @description Set the value for the <code>footer</code> property. This string is used as a footer for the <code>ListView</code>.
	 * @example var friendFooter = mew UI.ListView();
	 * ...
	 * friendHeader.setHeader('This is a footer');
	 * @param {String} footer The new footer.
	 * @see UI.ListView#getFooter
	 * @function
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * @name UI.ListView#getFooter
	 * @description Retrieve the value of the <code>footer</code> property.
	 * @returns {String} The current footer.
	 * @see UI.ListView#setFooter
	 * @function
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	ListView.synthesizeProperty('footer');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/ListViewSection'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/ListViewSection'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/ListViewSection'] = exports; var Element = require('NGCore/Client/UI/Element').Element;
var ViewGeometry = require('NGCore/Client/UI/ViewGeometry');
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var Commands = require('NGCore/Client/UI/Commands').Commands;
var ListViewItem = require('NGCore/Client/UI/ListViewItem').ListViewItem;

/* This class does not have a physical view representation.
	We still fully map and register it so that sections can be persisted independently of tables. */

var ListViewSection = exports.ListViewSection = Element.subclass(
/** @lends UI.ListViewSection.prototype */
{
	'type':'listview-section',
	/**
	* @class The <code>ListViewSection</code> class constructs objects that contain <code>ListViewItem</code> objects. 
	* These objects are rendered as individual sections of a scrolling list (see <code>{@link UI.ListView}</code>).
	* @name UI.ListViewSection
	* @augments UI.Element
	*/
	initialize:function($super, properties) {
		if (ListViewSection._init) ListViewSection._init();
		
		this._visibleRange = [0,0];
		this._headerHeight = 0;
		this._titleHeight = 0;
		
		delete this._measuredHeight;
		this._needsLayout = false;
		
		$super(properties);
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash
	 */
	addItemToVisible: function(lvItem, index) {
		if (!(lvItem instanceof ListViewItem)) return;
		if (lvItem._currentView instanceof Element) return;
		
		var useView = this._listView._viewForItem(lvItem);
		var w = this._listView.getFrame()[2];
		
		if (this._rowHeight > 0) {
			useView.setFrame(0, this._yPosition + this._titleHeight + index * this._rowHeight, w, this._rowHeight);
		} else {
			useView.setFrame(0, this._yPosition + this._cellPositions[index], w, lvItem._height);
		}
		
		lvItem._setCurrentView(useView);
		if (!useView.getParent()) this._listView.addChild(useView, "cell");
	},
	
	_setFrame: function(l, t, w, h) {
		UI.Commands.setFrame.call(this, l, t, w, h);
		if (this._titleView) {
			var f = this._titleView.getFrame();
			this._titleView.setFrame(l, t, w, f[3]);
		}
	},
	
	/**
	 * Reset the visible range for this <code>ListViewSection</code>.
	 * @function
	 * @status Javascript, iOS, Android, Flash
	 */
	flush: function() {
		for (var i = this._visibleRange[0], l = this._visibleRange[1]; i < l; i++) {
			this._listView._queueViewForItem(this._items[i]);
		}
		this._visibleRange = [0,0];
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash
	 */
	updateVisibleRange: function(topY, bottomY) {
		var totalH = this._getMeasuredHeight();
		
		// Expand the view window. This is really only necessary for Android...
		var l = this._items.length;
		var rowH = this._rowHeight > 0 ? this._rowHeight : totalH / l;
		topY -= rowH * 5;
		bottomY += rowH * 5;
		
		var oldStartIndex = this._visibleRange[0];
		var oldEndIndex = this._visibleRange[1];
		var startIndex = l > 0 ? Math.max(0, Math.floor(topY / rowH)) : 0;
		var endIndex = l > 0 ? Math.min(l, startIndex + Math.floor((bottomY - topY) / rowH)) : 0;
		
		if (this._cellPositions) {
			// We should have a good guess into the array from the above code,
			// so now it just needs to be adjusted until accurate.
			while (startIndex < l && this._cellPositions[startIndex] < topY) startIndex++;
			while (startIndex > 0 && this._cellPositions[startIndex] > topY) startIndex--;
			if (startIndex >= l) startIndex = Math.max(0, l - 1);
			
			while (endIndex < l && this._cellPositions[endIndex] < bottomY) endIndex++;
			while (endIndex > startIndex && this._cellPositions[endIndex] > bottomY) endIndex--;
		
			topY = this._cellPositions[startIndex];
			// EndIndex is one past the last element...
			bottomY = endIndex == 0 ? topY : (this._cellPositions[endIndex-1] + this._items[endIndex-1]._height );
		}
		if (bottomY < 0 || topY > totalH) {
			for (var i = this._visibleRange[0]; i < this._visibleRange[1]; i++) {
				this._listView._queueViewForItem(this._items[i]);
			}
			this._visibleRange = [0,0];
			return;
		}
		
		if (oldStartIndex == startIndex && oldEndIndex == endIndex) return;
		
//		NgLogD("(" + oldStartIndex + "," + oldEndIndex + ") -> (" + startIndex + "," + endIndex + ")");
		
		if (oldStartIndex == oldEndIndex) {
			for (var i = startIndex; i < endIndex; i++) {
				this.addItemToVisible(this._items[i], i);
			}
		} else {
			// Dequeue and requeue from both ends.
			if (oldStartIndex < startIndex) {
				do {
					this._listView._queueViewForItem(this._items[oldStartIndex]);
				} while (++oldStartIndex < startIndex);
			}
			if (oldEndIndex > endIndex) {
				while (oldEndIndex-- > endIndex) {
					this._listView._queueViewForItem(this._items[oldEndIndex]);
				}
				oldEndIndex = endIndex;	// Keep later codepath from triggering
			}
		
			if (oldStartIndex > startIndex) {
				while (oldStartIndex-- > startIndex) {
					this.addItemToVisible(this._items[oldStartIndex], oldStartIndex);
				}
				oldStartIndex = startIndex;
			} 
			if (oldEndIndex < endIndex) {
				do {
					this.addItemToVisible(this._items[oldEndIndex], oldEndIndex);
				} while (++oldEndIndex < endIndex)
			}
		
		}
		this._visibleRange = [startIndex, endIndex];
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash
	 */
	setListView : function(listView) {
		this._listView = listView;
		delete this._measuredHeight;
		return this;
	},
	
	_getMeasuredHeight : function() {
		return this._measuredHeight || this._measureHeight();
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash
	 */
	_measureHeight : function() {
		// Sum the heights of the rows.  No variable-heights yet!!!
		if (this._rowHeight < 0) {
			// Variable Height Trigger
			var totalHeight = this._titleHeight + this._headerHeight;
			var runningHeights = [];
			var l = this._items.length;
			for (var i = 0; i < l; i++) {
				runningHeights.push(totalHeight);
				totalHeight += this._items[i]._height;
			}
			this._cellPositions = runningHeights;
			return this._measuredHeight = totalHeight;
		}
		
		delete this._cellPositions;
		return this._measuredHeight = this._titleHeight + this._headerHeight + this._rowHeight * this._items.length;
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash
	 */
	calculateItemPositions: function() {
		// Not used?.
	},
});

ListViewSection._init = function() {
	delete ListViewSection._init;
	if (Element._init) Element._init();

	// We don't have a set pattern for sending the id of a view we want to assign by reference...
	/**
	 * @name UI.ListViewSection#setTitleView
	 * @description 
	 * @function
	 * @see UI.ListViewSection#getTitleView
 	 * @status Javascript, iOS, Android, Flash
	 */
	var boundTitleFunction = function() {
		if (this.listViewMonitor) this.listViewMonitor.setTitleView(this);
		boundTitleFunction._superfunc.apply(this, Array.prototype.slice.call(arguments));
	};
	var setTitleView = function(titleView) {
		if (this._titleView && this._titleView.listViewMonitor == this) {
			delete this._titleView.listViewMonitor;
		}
		this._titleView = titleView;
		
		if (!(titleView.listViewMonitor == this)) {
			titleView.listViewMonitor = this;
			if (!boundTitleFunction._superfunc) {
				boundTitleFunction._superfunc = titleView.setFrame;
			}
			if (titleView.setFrame != boundTitleFunction) {
				titleView.registerAccessors('frame', null, boundTitleFunction);
			}
		}
		
		this._titleHeight = titleView.getFrame()[3];
		delete this._measuredHeight;
		Commands.setTitleView.call(this, ObjectRegistry.objectToId(titleView));
		return this;
	}
	/**
	 * @name UI.ListViewSection#getTitleView
	 * @description 
	 * @function
	 * @see UI.ListViewSection#setTitleView
 	 * @status Javascript, iOS, Android, Flash
	 */
	var getTitleView = function() {
		return this._titleView;
	}
	/**
	 * @name UI.ListViewSection#setTitle
	 * @description Set the value for the <code>title</code> property.
	 * @param {String} title The new section title.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.ListViewSection#getTitle
	 * @function
	 */
	/**
	 * @name UI.ListViewSection#getTitle
	 * @description Retrieve the value of the <code>title</code> property.
	 * @returns {String} The current section title.
	 * @see UI.ListViewSection#setTitle
	 * @function
	 */
	ListViewSection.registerAccessors('titleView', getTitleView, setTitleView);
	
	// Other properties
	/**
	 * @name UI.ListViewSection#setRowHeight
	 * @description Set the value for the <code>rowHeight</code> property.
	 * @param {Number} rowHeight The new row height.
	 * @see UI.ListViewSection#getRowHeight
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.ListViewSection#getRowHeight
	 * @description Retrieve the value of the <code>rowHeight</code> property.
	 * @returns {Number} The current row height.
	 * @see UI.ListViewSection#setRowHeight
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	ListViewSection.synthesizeProperty('rowHeight');
	/**
	 * @name UI.ListViewSection#setItems
	 * @description Set the value for the <code>items</code> property.
	 * Setting this updates the visual state of the <code>listView</code> if the section is in a <code>listView</code> that is visible.
	 * @param {UI.ListViewItem} items The new <code>ListView</code> items.
	 * @see UI.ListViewSection#getItems
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	var setItems = function(newItems) {
		newItems = (newItems instanceof Array) ? newItems : Array.prototype.slice.call(arguments);
		
		this.flush();
		this._items = newItems;
		
		if (!this._listView) return;
		this._listView.reloadData();
		delete this._measuredHeight;
	}
	/**
	 * @name UI.ListViewSection#getItems
	 * @description Retrieve the value of the <code>items</code> property.
	 * @returns {UI.ListViewItem} The current <code>ListView</code> items.
	 * @see UI.ListViewSection#setItems
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	var getItems = function() {
		return this._items;
	}
	ListViewSection.registerAccessors('items', getItems, setItems);
	/**
	 * @name UI.ListViewSection#setYPosition
	 * @description Set the value for the <code>yPosition</code> property.
	 * @param {Number} yPosition The new position for <i>y</i>.
	 * @see UI.ListViewSection#getYPosition
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.ListViewSection#getYPosition
	 * @description Retrieve the value of the <code>yPosition</code> property.
	 * @returns {Number} The current position of <i>y</i>.
	 * @see UI.ListViewSection#setYPosition
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	ListViewSection.synthesizeProperty('yPosition');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/ListViewItem'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/ListViewItem'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/ListViewItem'] = exports; /* This class does not have a physical view representation, and is just a holder for closures / a bag for data...
	We still fully map and register it so that sections can be persisted independently of tables. */
var Class = require('NGCore/Client/Core/Class').Class;

var ListViewItem = exports.ListViewItem = Class.subclass(
/** @lends UI.ListViewItem.prototype */
{	/**
	* @class The <code>ListViewItem</code> class constructs objects that contain data for individual items in a scrolling list (see <code>{@link UI.ListView}</code>).
	* @name UI.ListViewItem
	* @constructs The default constructor.
	* @augments Core.Class
	*/
	
	'type':'listview-item',
	
	_reuseId: "__default__",
	/** @protected */
	_currentView: null,
	
	/**
	 * @function
	 * @protected
 	 * @status Javascript, iOS, Android, Flash
	 */
	_onCreateView: function() {},
	/**
	 * @function
	 * @protected
 	 * @status Javascript, iOS, Android, Flash
	 */
	_onReleaseView: function(oldView) {},
	/**
	 * @function
	 * @protected
 	 * @status Javascript, iOS, Android, Flash
	 */
	_onSetView: function(newView) {},
	
	/**
	 * Set the callback for the <code>onCreateView</code> event. 
	 * This event must return a newly created view that displays the data type represented by the item.
	 * @param {Function} newFn The new function to call.
	 * @event
	 */
	setOnCreateView: function(newFn)	{this._onCreateView = newFn},
	/**
	 * Set the callback for the <code>onReleaseView</code> event. This event occurs when the view is set to <code>null</code>. 
	 * Use this to remove uncommon view states or clean up the view when necessary.
	 * @param {Function} newFn The new function to call.
	 * @event
	 */
	setOnReleaseView: function(newFn)	{this._onReleaseView = newFn},
	/**
	 * Set the callback for the <code>onSetView</code> event. When this event occurs, the item puts any relevant visual state / data into <code>newView</code>.
	 * This transfer should occur before the item is visible to the user:
	 * <pre class="code">onSetView(newView)</pre>
	 * @param {Function} newFn The new function to call.
	 * @event
	 */
	setOnSetView: function(newFn)		{this._onSetView = newFn},
	
	/**
	 * Set the height of the current ListViewItem in pixels.
	 * <pre class="code">setHeight(Number)</pre>
	 * This should occur before the item is visible to the user.
	 * This setting is only used when the item's ListViewSection has height = -1
	 * @param {Function} newFn The new function to call.
	 */
	setHeight: function(h) {
		this._height = h;
	},
	
	/**
	 * Get the current height of the ListViewItem.
	 * <pre class="code">getHeight()</pre>
	 * This should occur before the item is visible to the user.
	 * @returns {Number} The height of this ListViewItem.
	 */
	getHeight: function() {
		return this._height;
	},
	
	/**
	 * @function
	 * @protected
 	 * @status Javascript, iOS, Android, Flash
	 */
	_setCurrentView: function(newView) {
		if (newView instanceof Class) {
			this._onSetView(newView);
		} else {
			this._onReleaseView(this._currentView);
		}
		this._currentView = newView;
		return this;
	},
	
	/**
 	 * Retrieve the current view attached to this <code>ListViewItem</code>.
	 * @returns {UI.View} The current <code>ListViewItem</code> view.
	 * @status Javascript, iOS, Android, Flash
	 */
	getCurrentView: function(){
		return this._currentView;
	},
		
	initialize: function(reuseId) {
		if (reuseId) this._reuseId = reuseId;
		return this;
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/CellView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/CellView'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/CellView'] = exports; var View = require('NGCore/Client/UI/View').View;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var CellView = exports.CellView = View.subclass(
/** @lends UI.CellView.prototype */
{
	'type':'cell',
	/**
	* @class The <code>CellView</code> class constructs objects that handle cell views in an application. For example, a cell in a scrolling list.
	* These objects are rendered with images on the left and right, and two text areas (title and text) stacked vertically in the middle.
	* @name UI.CellView
	* @augments UI.AbstractView
	*/
	initialize: function($super, properties) {
		if (CellView._init) CellView._init();
		$super(properties);
	}
});

// Properties
CellView._init = function() {
	delete CellView._init;
	if (View._init) View._init();
	
	/**
	 * @name UI.CellView#setImage
	 * @description Set the value of the <code>image</code> property for a view state. This defines how a cell view appears for specific conditions. For example,
	 * set different images for a cell view in the default state and when the cell view has focus.
	 * @example background.setImage('./Content/blank.png', [w, h], [0, 0]);
	 * @param {String} image The new <code>image</code> URL.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.CellView#getImage
	 * @function
 	 * @status iOS, Android, Test
	 */
	/**
	 * @name UI.CellView#getImage
	 * @description Retrieve the value of the <code>image</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current <code>image</code> URL.
	 * @see UI.CellView#setImage
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	CellView.synthesizePropertyWithState('image', Commands.setImage);
	/**
	 * @name UI.CellView#setImageBorder
	 * @description Set the value of the <code>imageBorder</code> property for a view state. This property defines a border for images used in the specified view state.
	 * @param {Object} imageBorder The new value for <code>imageBorder</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.CellView#getImageBorder
	 * @function
 	 * @status iOS, Android, Test
	 */
	/**
	 * @name UI.CellView#getImageBorder
	 * @description Retrieve the value of the <code>imageBorder</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {Object} The current value of <code>imageBorder</code>.
	 * @see UI.CellView#setImageBorder
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	CellView.synthesizePropertyWithState('imageBorder', Commands.setImageBorder);
	/**
	 * @name UI.CellView#setImageInsets
	 * @description Set the value of the <code>imageInsets</code> property. This property defines the viewable area of an image when applying gravity.
	 * @example background.setImageInsets([10,10,10,10]);
	 * @param {Number, Array (Number)} imageInsets The new value for <code>imageInsets</code>. Set as insets or an array of insets (float).
	 * @see UI.CellView#getImageInsets
 	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.CellView#getImageInsets
	 * @description Retrieve the value of the <code>imageInsets</code> property.
	 * @returns {Number, Array (Number)} The current value of <code>imageInsets</code>.
	 * @see UI.CellView#setImageInsets
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	CellView.synthesizeCompoundProperty('imageInsets', Commands.setImageInsets);
	/**
	 * @name UI.CellView#setImageFit
	 * @description Set the value of the <code>imageFit</code> property. This property defines the scaling of bitmap images to fit within the bounds of a control 
	 * (subtracting the value for <code>imageInsets</code>).
	 * @example background.setImageFit(UI.FitMode.None);
	 * @param {Number} imageFit The new value for <code>imageFit</code>.
	 * @see UI.CellView#getImageFit
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.CellView#getImageFit
	 * @description Retrieve the value of the <code>imageFit</code> property.
	 * @returns {Number} The current value of <code>imageFit</code>.
	 * @see UI.CellView#setImageFit
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	CellView.synthesizeProperty('imageFit', Commands.setImageFitMode);
	/**
	 * @name UI.CellView#setImageGravity
	 * @description Set the value of the <code>imageGravity</code> property. This property defines how an image is positioned within a viewable area.
	 * @example background.setImageGravity([0.5, 0.0]);
	 * @param {Number} imageGravity The new value for <code>imageGravity</code> (expressed as two floats).
	 * @see UI.CellView#getImageGravity
	 * @function
 	 * @status iOS, Android, Test
	 */
	/**
	 * @name UI.CellView#getImageGravity
	 * @description Retrieve the value of the <code>imageGravity</code> property.
	 * @returns {Number} The current value of <code>imageGravity</code> (expressed as two floats).
	 * @see UI.CellView#setImageGravity
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	CellView.synthesizeProperty('imageGravity', Commands.setImageGravity);
	 /**
	 * @name UI.CellView#setImageTransform
	 * @description Set the value of the <code>imageTransform</code> property. This property defines data compression for images used with a cell view.
	 * @example background.setImageTransform([Math.cos(angle), Math.sin(angle), Math.sin(angle), Math.cos(angle), 0, 0]);
	 * @param {Array (Number)} imageTransform The new value for <code>imageTransform</code>. Set as an array of floats (<i>a</i>, <i>b</i>, <i>c</i>, <i>d</i>, <i>tx</i>, <i>ty</i>).
	 * @see UI.CellView#getImageTransform
 	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.CellView#getImageTransform
	 * @description Retrieve the value of the <code>imageTransform</code> property.
	 * @returns {Array (Number)} The current value of <code>imageTransform</code>.
	 * @see UI.CellView#setImageTransform
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	 CellView.synthesizeCompoundProperty('imageTransform', Commands.setImageTransform);
	/**
	 * @name UI.CellView#getRightImage
	 * @description Retrieve the value of the <code>rightImage</code> property in the specified view state.
	 * @returns {String} The current value of <code>rightImage</code>.
	 * @function
	 * @see UI.CellView#setRightImage
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * @name UI.CellView#setRightImage
	 * @description Set the value of the <code>rightImage</code> property in the specified view state. This defines how images used for UI controls appear for specific conditions. For example, 
	 * use seperate images for a closure arrow in the default state and a closure arrow when expanded.
	 * @example var cellClosure = new UI.CellView()
	 * ...
	 * cellClosure.setRightImage('./Content/closure.png', [w, h], [0, 0]);
	 * @param {String} rightImage The new value for <code>rightImage</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI State.
	 * @function
 	 * @status iOS, Android, Test
	 * @see UI.CellView#getRightImage
	 */
	CellView.synthesizePropertyWithState('rightImage', Commands.setRightImage);
	/**
	 * @name UI.CellView#getRightImageBorder
	 * @description Retrieve the value of the <code>rightImageBorder</code> property in the specified view state. 
	 * @returns {Object} The current value of <code>rightImageBorder</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 * @see UI.CellView#setRightImageBorder
	 */
	/**
	 * @name UI.CellView#setRightImageBorder
	 * @description Set the value of the <code>rightImageBorder</code> property in the specified view state. This property defines a border for images used in the specified view state.
	 * @param {Object} rightImageBorder The new value for <code>rightImageBorder</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI View state.
 	 * @status iOS, Android, Test
	 * @function
	 * @see UI.CellView#getRightImageBorder
	 */
	CellView.synthesizePropertyWithState('rightImageBorder', Commands.setRightImageBorder);
	/**
	 * @name UI.CellView#getRightImageInsets
	 * @description Retrieve the value of the <code>rightImageInsets</code> property.
	 * @returns {Array (Number)} The current value of <code>rightImageInsets</code>.
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @see UI.CellView#setRightImageInsets
	 */
	/**
	 * @name UI.CellView#setRightImageInsets
	 * @description Set the value of the <code>rightImageInsets</code> property. This property defines the viewable area of an image when applying gravity.
	 * @example closureIcon.setRightImageInsets([10,10,10,10]);
	 * @param {Array (Number)} rightImageInsets The new value for <code>rightImageInsets</code>. Set as floats (<i>t</i>, <i>r</i>, <i>b</i>, <i>l</i>).
	 * @function
 	 * @status iOS, Android, Test
	 * @see UI.CellView#getRightImageInsets
	 */
	CellView.synthesizeProperty('rightImageInsets', Commands.setRightImageInsets);
	/**
	 * @name UI.CellView#getRightImageFit
	 * @description Retrieve the value of the <code>rightImageFit</code> property. 
	 * @returns {Number} The current value of <code>rightImageFit</code>.
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @see UI.CellView#setRightImageFit
	 */
	/**
	 * @name UI.CellView#setRightImageFit
	 * @description Set the value of the <code>rightImageFit</code> property. This property defines the scaling of bitmap images to fit within the bounds of a control 
	 * (subtracting the value for <code>imageInsets</code>).
	 * @example closureIcon = new UI.CellView();
	 * ...
	 * closureIcon.setRightImageFit(UI.FitMode.None);
	 * @param {Number} rightImageFit The new value for <code>rightImageFit</code>.
	 * @function
 	 * @status iOS, Android, Test
	 * @see UI.CellView#getRightImageFit
	 */
	CellView.synthesizeProperty('rightImageFit', Commands.setRightImageFitMode);
	/**
	 * @name UI.CellView#getRightImageGravity
	 * @description Retrieve the value of the <code>rightImageGravity</code> property. 
	 * @returns {Number} The current value of <code>rightImageGravity</code>.
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @see UI.CellView#setRightImageGravity
	 */
	/**
	 * @name UI.CellView#setRightImageGravity
	 * @description Set the value of the <code>rightImageGravity</code> property. This property defines how a image for a control is positioned within a viewable area.
	 * @example var closureIcon = new UI.CellView();
	 * ...
	 * closureIcon.setRightImageGravity([0.5, 0.0]);
	 * @param {Number} rightImageGravity The new value for <code>rightImageGravity</code>. Set as two floats (<i>x</i>, <i>y</i>).
	 * @function
 	 * @status iOS, Android, Test
	 * @see UI.CellView#getRightImageGravity
	 */
	CellView.synthesizeProperty('rightImageGravity', Commands.setRightImageGravity);
	/**
	 * @name UI.CellView#getRightImageTransform
	 * @description Retrieve the value of the <code>rightImageTransform</code> property.
	 * @returns {Array (Number)} The current value of <code>rightImageTransform</code>.
	 * @see UI.CellView#setRightImageTransform
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	 /**
	 * @name UI.CellView#setRightImageTransform
	 * @description Set the value of the <code>rightImageTransform</code> property. This property defines data compression for images used with right image objects.
	 * @example var closureIcon = new UI.CellView();
	 * ...
	 * closureIcon.setRightImageTransform([Math.cos(angle), Math.sin(angle), Math.sin(angle), Math.cos(angle), 0, 0]);
	 * @param {Array (Number)} rightImageTransform The new value for <code>rightImageTransform</code>. 
	 * Set as six floats (<i>a</i>, <i>b</i>, <i>c</i>, <i>d</i>, <i>tx</i>, <i>ty</i>).
	 * @see UI.CellView#getRightImageTransform
 	 * @status iOS, Android, Test
	 * @function
	 */
	 CellView.synthesizeCompoundProperty('rightImageTransform', Commands.setRightImageTransform);
	 
	/**
	 * @name UI.CellView#getTitle
	 * @description Retrieve the value of the <code>title</code> property in a view state.
	 * @returns {String} The current value of <code>title</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 * @see UI.CellView#setTitle
	 */
	/**
	 * @name UI.CellView#setTitle
	 * @description Set the value of the <code>title</code> property for a view state. This property defines the title string for a view in the specified view state.
	 * @example var cellTitle = new UI.CellView()
	 * ...
	 * cellTitle.setTitle('Game of Foo');
	 * @param {String} title The new value for <code>title</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
 	 * @status iOS, Android, Test
	 * @see UI.CellView#getTitle
	 * @function
	 */
	CellView.synthesizePropertyWithState('title', Commands.setTitle);
	/**
	 * @name UI.CellView#getTitleColor
	 * @description Retrieve the value of the <code>titleColor</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>titleColor</code>.
	 * @see UI.CellView#setTitleColor
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.CellView#setTitleColor
	 * @description Set the value of the <code>titleColor</code> property for a view state. This property defines the title string color for the <code>CellView</code> object in the specified view state.
	 * @example var cellTitle = new UI.CellView()
	 * ...
	 * cellTitle.setTitleColor(0,0,1);
	 * @param {String} titleColor The new value for <code>titleColor</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.CellView#getTitleColor
	 * @function 
 	 * @status iOS, Android, Test
	 */
	CellView.synthesizePropertyWithState('titleColor', Commands.setTitleColor);
	/**
	 * @name UI.CellView#getTitleFont	 
	 * @description Retrieve the value of the <code>titleFont</code> property in a view state. 
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>titleFont</code>.
	 * @function
	 * @see UI.CellView#setTitleFont
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * @name UI.CellView#setTitleFont
	 * @description Set the value of the <code>titleFont</code> property in a view state. This property defines the title string font for cell view labels in the specified view state.
	 * @example var cellTitle = new UI.CellView()
	 * ...
	 * cellTitle.setTitleFont('Content/Cacophony.ttf');
	 * @param {String} titleFont The new value for <code>titleFont</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @function
	 * @see UI.CellView#getTitleFont
 	 * @status iOS, Android, Test
	 */
	CellView.synthesizePropertyWithState('titleFont', Commands.setTitleFont);
	/**
	 * @name UI.CellView#getTitleShadow
	 * @description Retrieve the value of the <code>titleShadow</code> property in a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>titleShadow</code>.
	 * @see UI.CellView#setTitleShadow
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * @name UI.CellView#setTitleShadow
	 * @description Set the value of the <code>titleShadow</code> property in a view state. This property defines the amount of text shadowing used for title strings in a cell view.
	 * @example var cellTitle = new UI.CellView()
	 * ...
	 * cellTitle.setTitleShadow('FFCCCCFF 2.0 {0,0}');
	 * @param {String} titleShadow The new value for <code>titleShadow</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
 	 * @status iOS, Android, Test
	 * @see UI.CellView#getTitleShadow
	 * @function
	 */
	CellView.synthesizePropertyWithState('titleShadow', Commands.setTitleShadow);

	/**
	 * @name UI.CellView#getTitleGravity
	 * @description Retrieve the value of the <code>titleGravity</code> property. 
	 * @returns {Array (Number)} The current value of <code>titleGravity</code>.
	 * @see UI.CellView#setTitleGravity
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * @name UI.CellView#setTitleGravity
	 * @description Set the value of the <code>titleGravity</code> property. This property defines how a title string is positioned within a viewable area.
	 * @example var cellTitle = new UI.CellView()
	 * ...
	 * cellTitle.setTitleGravity([0.5, 0.0]);	 
	 * @param {Array (Number)} titleGravity The new value for <code>titleGravity</code>. Set as two floats (<i>x</i>, <i>y</i>).
	 * @see UI.CellView#getTitleGravity
 	 * @status iOS, Android, Test
	 * @function
	 */
	CellView.synthesizeCompoundProperty('titleGravity', Commands.setTitleGravity);

	/**
	 * @name UI.CellView#getTitleSize
	 * @description Retrieve the value of the <code>titleSize</code> property.
	 * @returns {Number} The current value of <code>titleSize</code>.
	 * @see UI.CellView#setTitleSize
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * @name UI.CellView#setTitleSize
	 * @description Set the value of the <code>titleSize</code> property. This property defines the text size of title strings in the specified view state.
	 * @example var cellTitle = new UI.CellView()
	 * ...
	 * cellTitle.setTitleSize(32);
	 * @param {Number} titleSize The new value for <code>titleSize</code>. Set as two floats (<i>x</i>, <i>y</i>).	
	 * @function
	 * @see UI.CellView#getTitleSize
 	 * @status iOS, Android, Test
	 */
	CellView.synthesizeProperty('titleSize', Commands.setTitleSize);
	/**
	 * @name UI.CellView#getTitleInsets
	 * @description Retrieve the value of the <code>titleInsets</code> property.	 
	 * @returns {Array (Number)} The current value of <code>titleInsets</code>.
	 * @function
	 * @see UI.CellView#setTitleInsets
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * @name UI.CellView#setTitleInsets
	 * @description Set the value of the <code>titleInsets</code> property. This property defines the viewable area of a title string when applying gravity.
	 * @example var cellTitle = new UI.CellView()
	 * ...
	 * cellTitle.setTitleInsets([10,10,10,10]);	 
	 * @param {Array (Number)} titleInsets The new value for <code>titleInsets</code>. Set as four floats (<i>t</i>, <i>r</i>, <i>b</i>, <i>l</i>).
	 * @function
	 * @see UI.CellView#getTitleInsets
 	 * @status iOS, Android, Test
	 */
	CellView.synthesizeCompoundProperty('titleInsets', Commands.setTitleInsets);
	
	/**
	 * @name UI.CellView#getText
	 * @description Retrieve the value of the <code>text</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>text</code>..
	 * @see UI.CellView#setText
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.CellView#setText
	 * @description Set the value of the <code>text</code> property for a view state. This property defines a text string to use in the specified view state.
	 * @example var cellView = new UI.CellView();
	 * ...
	 * cellView.setText(this.game.description);
	 * @see UI.CellView#getText
	 * @param {String} text The new value for <code>text</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
 	 * @status iOS, Android, Test
	 * @function
	 */
	CellView.synthesizePropertyWithState('text', Commands.setText);
	/**
	 * @name UI.CellView#getTextColor
	 * @description Retrieve the value of the <code>textColor</code> property for a view state. 
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>textColor</code>.
	 * @see UI.CellView#setTextColor
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * @name UI.CellView#setTextColor
	 * @description Set the value of the <code>textColor</code> property for a view state. This property defines the color of a text string in the specified view state.
	 * @example var cellText = new UI.CellView();
	 * ...
	 * cellText.setTextColor('FFFF');
	 * @see UI.CellView#getTextColor
	 * @param {String} textColor The new value for <code>textColor</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
 	 * @status iOS, Android, Test
	 * @function 
	 */
	CellView.synthesizePropertyWithState('textColor', Commands.setTextColor);
	/**
	 * @name UI.CellView#getTextShadow
	 * @description Retrieve the value of the <code>textShadow</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>textShadow</code>.
	 * @see UI.CellView#setTextShadow	
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * @name UI.CellView#setTextShadow
	 * @description Set the value of the <code>textShadow</code> property for a view state. This property defines the amount of text shadowing used on text strings in this view.
	 * @example var cellText = new UI.CellView();
	 * ...
	 * cellText.setTextShadow('FFCCCCFF 2.0 {0,0}');
	 * @see UI.CellView#getTextShadow
	 * @param {String} textShadow The new value for <code>textShadow</code> in the specified view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
 	 * @status iOS, Android, Test
	 * @function
	 */
	CellView.synthesizePropertyWithState('textShadow', Commands.setTextShadow);
	/**
	 * @name UI.CellView#getTextFont
	 * @description Retrieve the value of the <code>textFont</code> property. 
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value for <code>textFont</code> in the specified view state.
	 * @see UI.CellView#setTextFont
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * @name UI.CellView#setTextFont
	 * @description Set the value of the <code>textFont</code> property. This property defines the font face used with labels for a cell view.
	 * @example var cellText = new UI.CellView()
	 * ...
	 * cellText.setTextFont('Content/Cacophony.ttf');
	 * @param {String} textFont The new value for <code>textFont</code> in the specified view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.CellView#getTextFont
 	 * @status iOS, Android, Test
	 * @function
	 */
	CellView.synthesizePropertyWithState('textFont', Commands.setTextFont);
	
	/**
	 * @name UI.CellView#getTextGravity
	 * @description Retrieve the value of the <code>textGravity</code> property.
	 * @returns {Number, Array (Number)} The current value of <code>textGravity</code>.
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @see UI.CellView#setTextGravity
	 */
	/**
	 * @name UI.CellView#setTextGravity	 
	 * @description Set the value of the <code>textGravity</code> property. This property defines how a text string is positioned within a viewable area.
	 * @example var cellText = new UI.CellView()
	 * ...
	 * cellText.setTextGravity([0.5, 0.0]);
	 * @param {Number, Array (Number)} textGravity The new value for <code>textGravity</code>. Set as individual components or a component array (<i>x</i>, <i>y</i>).
	 * @function
 	 * @status iOS, Android, Test
	 * @see UI.CellView#getTextGravity
	 */
	CellView.synthesizeCompoundProperty('textGravity', Commands.setTextGravity);

	/**
	 * @name UI.CellView#getTextSize
	 * @description Retrieve the value of the <code>textSize</code> property.
	 * @returns {Number} The current value for <code>textSize</code>.
	 * @see UI.CellView#setTextSize
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.CellView#setTextSize
	 * @description Set the value of the <code>textSize</code> property. This property defines the size of text strings for a view.
	 * @example var cellText = new UI.CellView()
	 * ...
	 * cellText.setTextSize(18);
	 * @param {Number} textSize The new value for <code>textSize</code>.
	 * @see UI.CellView#getTextSize
 	 * @status iOS, Android, Test
	 * @function
	 */
	CellView.synthesizeProperty('textSize', Commands.setTextSize);
	/**
	 * @name UI.CellView#getTextInsets
	 * @description Retrieve the value of the <code>textInsets</code> property.
	 * @returns {Array (Number)} The curent value for <code>textInsets</code>.
	 * @see UI.CellView#setTextInsets
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.CellView#setTextInsets
	 * @description Set the value of the <code>textInsets</code> property. This property defines the viewable area of a text string when applying gravity.
	 * @example var cellText = new UI.CellView()
	 * ...
	 * cellText.setTextInsets([10,10,10,10]);
	 * @param {Array (Number)} textInsets The new value for <code>textInsets</code>.
	 * @see UI.CellView#getTextInsets
 	 * @status iOS, Android, Test
	 * @function
	 */
	CellView.synthesizeCompoundProperty('textInsets', Commands.setTextInsets);
	
	// helpers for legacy support... Bind full properties to a single state of another.
	var states = {
		'normal': Commands.State.Normal,
		'focused': Commands.State.Focused,
		'pressed': Commands.State.Pressed,
		'disabled': Commands.State.Disabled,
		//** extra-deprecated */
		'selected': Commands.State.Focused,
		'highlighted': Commands.State.Pressed
	};
	
	function bindStateProperties(propName) {
		var doSynthesis = function(propName, stateName, stateFlags) {
			var getterFn = function() {
				return this._getters[propName].call(this, stateFlags);
			}
			var setterFn = function(val) {
				return this._setters[propName].call(this, val, stateFlags);
			}
			var thisStatePropName = stateName + propName.charAt(0).toUpperCase() + propName.substr(1);
		//	NgLogD("Synthesizing CellView." + thisStatePropName + " as getters[" + propName + "][" + stateFlags + "]");
			CellView.registerAccessors(thisStatePropName, getterFn, setterFn,
				"Use " + propName + " accessors with a final state parameter instead.");
		}
		for (var stateName in states) {
			if (!states.hasOwnProperty(stateName)) continue;
			doSynthesis(propName, stateName, states[stateName]);
		}
	};
	
	bindStateProperties('text');
	bindStateProperties('textColor');
	bindStateProperties('textShadow');
	bindStateProperties('textFont');
	bindStateProperties('title');
	bindStateProperties('titleColor');
	bindStateProperties('titleFont');
	bindStateProperties('titleShadow');
	bindStateProperties('gradient');
	bindStateProperties('image');
	bindStateProperties('imageBorder');
	bindStateProperties('rightImage');
	bindStateProperties('rightImageBorder');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/CheckBox'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/CheckBox'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/CheckBox'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;
var WindowR = require('NGCore/Client/UI/Window');

var gradients = {
	'normal': {
		"gradient": ["FFED 0.000", "FFA4 1.000"],
		"insets": "{4.0,4.0,4.0,4.0}",
		"outerLine": "FF51 2.0",
		"outerShadow": "0000 0.0 {0.0,0.0}",
		"corners": "3.0 3.0 3.0 3.0"
	},
	'pressed': {
		"innerShadow": "FF00 6.0 {0.0,-1.0}",
		"gradient": ["FF80 0.000", "FF80 1.000"],
		"insets": "{4.0,4.0,4.0,4.0}",
		"outerLine": "FF51 2.0",
		"outerShadow": "0000 0.0 {0.0,0.0}",
		"corners": "3.0 3.0 3.0 3.0"
	},
	'checked': {"innerLine":"FF27A227 2.0","corners":"3.0 3.0 3.0 3.0","insets":"{4.0,4.0,4.0,4.0}","gradient":["FF2CFF2B 0.000","FF179117 1.000"],"outerShadow":"0000 0.0 {0.0,0.0}","outerLine":"FF51 3.0","innerShadow":"FF97FE97 1.0 {0.0,0.0}"},
	'checkedpressed': {"innerShadow":"FF0F610F 5.0 {0.0,-1.0}","gradient":["FF179117 0.000","FF179117 1.000"],"insets":"{4.0,4.0,4.0,4.0}","outerLine":"FF2B512B 3.0","outerShadow":"0000 0.0 {0.0,0.0}","corners":"3.0 3.0 3.0 3.0"},
	'disabled': {
		"innerShadow": "0000 0.0 {0.0,0.0}",
		"gradient": ["66B6 0.000", "66CA 1.000"],
		"insets": "{4.0,4.0,4.0,4.0}",
		"outerLine": "7FE0 3.0",
		"outerShadow": "0000 0.0 {0.0,0.0}",
		"corners": "3.0 3.0 3.0 3.0"
	},
};

var CheckBox = exports.CheckBox = AbstractView.subclass(
/** @lends UI.CheckBox.prototype */
{
	'type':'checkbox',

    /**
     * @class The <code>CheckBox</code> class constructs objects that handle the state of application checkboxes.
     * @constructs The default constructor. 
     * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
     * @param {String} properties Object properties.
     * @augments UI.AbstractView
     */
    initialize: function($super, properties) {
		if (CheckBox._init) CheckBox._init();
        this._checked = false;
        $super();
		this.setGradient(gradients['normal'], Commands.State.Normal);
		this.setGradient(gradients['pressed'], Commands.State.Pressed);
		this.setGradient(gradients['checked'], Commands.State.Checked);
		this.setGradient(gradients['checkedpressed'], Commands.State.Checked | Commands.State.Pressed);
		this.setGradient(gradients['disabled'], Commands.State.Disabled);
		this.setImageInsets([4,4,4,4]);
		this.setAttributes(properties);
    },
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash
	 */
    performEventCallback: function($super, event) {
		if (event.eventType == 'click') {
        	this._checked = event.checked;
			if (this._checked) {
				this._state = this._state | Commands.State.Checked;
			} else {
				this._state = this._state & ~Commands.State.Checked;
			}
		}
		$super(event);
    }
});

CheckBox._init = function() {
	delete CheckBox._init;
	if (AbstractView._init) AbstractView._init();
	
	/**
	 * @name UI.CheckBox#getImage
	 * @description Retrieve the <code>image</code> URL for a view state. 
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current image URL for the specified view state.
	 * @see UI.CheckBox#setImage
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.CheckBox#setImage
	 * @description Set an image URL for a view state. This defines how a checkbox appears for specific conditions. For example,
	 * set different images for a checkbox in the default state and when the checkbox is checked.
	 * @example var gameCheck = new UI.CheckBox();
	 * ...
	 * gameCheck.setImage('./Content/checkbox.png', [w, h], [0, 0]);
	 * @see UI.CheckBox#getImage
	 * @param {String} imageURL The new image URL.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @status iOS, Android, Test
	 * @function 
	 */
	CheckBox.synthesizePropertyWithState('image', Commands.setImage);
	/**
	 * @name UI.CheckBox#getImageInsets
	 * @description Retrieve the value of the <code>imageInsets</code> property (expressed as floats).
	 * @returns {Number, Array (Number)} The current value of <code>imageInsets</code>.
	 * @see UI.CheckBox#setImageInsets
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.CheckBox#setImageInsets
	 * @description Set the value of the <code>imageInsets</code> property. This property defines the viewable area of an image when applying gravity.
	 * @example var gameCheck = new UI.CheckBox();
	 * ...
	 * gameCheck.setImageInset([10,10,10,10]);
	 * @param {Number, Array (Number)} imageInsets The new value for <code>imageInsets</code>. Set as insets or an array of insets (expressed as floats).
	 * @see UI.CheckBox#getImageInsets
	 * @status iOS, Android, Test
	 * @function
	 */
	CheckBox.synthesizeCompoundProperty('imageInsets', Commands.setImageInsets);
	
	/**
	 * @name UI.CheckBox#getText
	 * @description Retrieve the value of the <code>text</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>text</code> in the specified view state.
	 * @see UI.CheckBox#setText
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.CheckBox#setText
	 * @description Set the value of the <code>text</code> property for a view state. This property defines a text string to use as a label for a 
	 * checkbox in the specified view state.
	 * @example var gameCheck = new UI.CheckBox();
	 * ...
	 * gameCheck.setText("Yes");
	 * @see UI.CheckBox#getText
	 * @param {String} text The new value for <code>text</code> in the specified view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @status iOS, Android, Test
	 * @function
	 */
	CheckBox.synthesizePropertyWithState('text', Commands.setText);
	/**
	 * @name UI.CheckBox#getTextColor
	 * @description Retrieve the value of the <code>textColor</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>textColor</code> in the specified view state.
	 * @see UI.CheckBox#setTextColor
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.CheckBox#setTextColor
	 * @description Set the value of the <code>textColor</code> property for a view state. This property defines the color of a text string used as a label for a 
	 * checkbox in different view states.
	 * @example var gameCheck = new UI.CheckBox();
	 * ...
	 * gameCheck.setTextColor('FFFFFF');
	 * @see UI.CheckBox#getTextColor
	 * @param {String} textColor The new value for <code>textColor</code> in the specified view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @status iOS, Android, Test
	 * @function 
	 */
	CheckBox.synthesizePropertyWithState('textColor', Commands.setTextColor);
	/**
	 * @name UI.CheckBox#getTextShadow
	 * @description Retrieve the value of the <code>textShadow</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>textShadow</code> in the specified view state.
	 * @see UI.CheckBox#setTextShadow	
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.CheckBox#setTextShadow
	 * @description Set the value of the <code>textShadow</code> property for a view state. This property defines the amount of shadowing used on text strings for a checkbox in different view states.
	 * @example var gameCheck = new UI.CheckBox();
	 * ...
	 * gameCheck.setTextShadow("FF00 2.0 {0,-1}");
	 * @see UI.CheckBox#getTextShadow
	 * @param {String} textShadow The new value for <code>textShadow</code> in the specified view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @status iOS, Android, Test
	 * @function
	 */
	CheckBox.synthesizePropertyWithState('textShadow', Commands.setTextShadow);
	/**
	 * @name UI.CheckBox#getTextGravity
	 * @description Retrieve the value of the <code>textGravity</code> property (expressed as floats).
	 * @returns {Number, Array (Number)} The current value of <code>textGravity</code>.
	 * @see UI.CheckBox#setTextGravity
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.CheckBox#setTextGravity
	 * @description Set the value of the <code>textGravity</code> property. This property defines how a text string is positioned within a viewable area.
	 * @example var gameCheck = new UI.CheckBox();
	 * ...
	 * gameCheck.setTextGravity([0.1, 0.5]);
	 * @param {Number, Array (Number)} textGravity The new value for <code>textGravity</code>. Set as individual components or a single array of components (expressed as floats).
	 * @see UI.CheckBox#getTextGravity
	 * @status iOS, Android, Test
	 * @function
	 */
	CheckBox.synthesizeCompoundProperty('textGravity', Commands.setTextGravity);

	/**
	 * @name UI.CheckBox#getTextSize
	 * @description Retrieve the value of the <code>textSize</code> property.
	 * @returns {Number} The current value for <code>textSize</code>.
	 * @see UI.CheckBox#setTextSize
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.CheckBox#setTextSize
	 * @description Set the value of the <code>textSize</code> property. This property defines the text size of labels for a checkbox.
	 * @example var gameCheck = new UI.CheckBox();
	 * ...
	 * gameCheck.setTextSize(18);
	 * @param {Number} textSize The new value for <code>textSize</code>.
	 * @see UI.CheckBox#getTextSize
	 * @status iOS, Android, Test
	 * @function
	 */
	CheckBox.synthesizeProperty('textSize', Commands.setTextSize);
	/**
	 * @name UI.CheckBox#getTextFont
	 * @description Retrieve the value of the <code>textFont</code> property.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value for <code>textFont</code> in the specified view state.
	 * @see UI.CheckBox#setTextFont
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.CheckBox#setTextFont
	 * @description Set the value of the <code>textFont</code> property. This property defines the font face used with labels for a checkbox in different view states.
	 * @example var gameCheck = new UI.CheckBox();
	 * ...
	 * gameCheck.setTextFont(myFont);
	 * @param {String} textFont The new value for <code>textFont</code> in the specified view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.CheckBox#getTextFont
	 * @status iOS, Android, Test
	 * @function
	 */
	CheckBox.synthesizePropertyWithState('textFont', Commands.setTextFont);
	/**
	 * @name UI.CheckBox#getTextInsets
	 * @description Retrieve the value of the <code>textInsets</code> property.
	 * @returns {Array (Number)} The curent value for <code>textInsets</code>.
	 * @see UI.CheckBox#setTextInsets
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.CheckBox#setTextInsets
	 * @description Set the value of the <code>textInsets</code> property. This property defines the viewable area of a text string when applying gravity.
	 * @example var gameCheck = new UI.CheckBox();
	 * ...
	 * gameCheck.setTextInsets(0, 0, 0, 64);
	 * @param {Array (Number)} textInsets The new value for <code>textInsets</code>.
	 * @see UI.CheckBox#getTextInsets
	 * @status iOS, Android, Test
	 * @function
	 */
	CheckBox.synthesizeCompoundProperty('textInsets', Commands.setTextInsets);
	
	// Corresponding event is onClick
	/**
	 * @name UI.CheckBox#getChecked
	 * @description Retrieve whether this <code>CheckBox</code> is currently "checked".
	 * @returns {Boolean} Returns <code>true</code> if this <code>CheckBox</code> is currently "checked".
	 * @see UI.CheckBox#setChecked
	 * @status Javascript, iOS, Android, Flash
	 * @function
	 */
	/**
	 * @name UI.CheckBox#setChecked
	 * @description Set whether this <code>CheckBox</code> is "checked".
	 * @example var gameCheck = new UI.CheckBox();
	 * ...
	 * gameCheck.setChecked(true);
	 * @param {Boolean} checked Set as <code>true</code> if this <code>CheckBox</code> is "checked".
	 * @see UI.CheckBox#getChecked
	 * @status iOS, Android
	 * @function 
	 */
	CheckBox.synthesizeProperty('checked', Commands.setChecked);
	
	// helpers for legacy support... Bind full properties to a single state of another.
	var states = {
		'focused': Commands.State.Focused,
		'pressed': Commands.State.Pressed,
		'selected': Commands.State.Focused,
		'highlighted': Commands.State.Pressed,
		'disabled': Commands.State.Disabled,
		'checked': Commands.State.Checked,
	};

	function bindStateProperties(propName) {
		var doSynthesis = function(propName, stateName, stateFlags) {
			var getterFn = function() {
				return this._getters[propName].call(this, stateFlags);
			}
			var setterFn = function(val) {
				return this._setters[propName].call(this, val, stateFlags);
			}
			var thisStatePropName = stateName + propName.charAt(0).toUpperCase() + propName.substr(1);
		//	NgLogD("Synthesizing Button." + thisStatePropName + " as getters[" + propName + "][" + stateFlags + "]");
			CheckBox.registerAccessors(thisStatePropName, getterFn, setterFn, 
				"Use " + propName + " accessors with a final state parameter instead.");
		}
		for (var stateName in states) {
			if (!states.hasOwnProperty(stateName)) continue;
			doSynthesis(propName, stateName, states[stateName]);
		}
	};

	bindStateProperties('text');
	bindStateProperties('textColor');
    bindStateProperties('textFont');
	bindStateProperties('textShadow');
	bindStateProperties('gradient');
	bindStateProperties('image');
    bindStateProperties('imageBorder');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/EditText'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/EditText'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/EditText'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var EditText = exports.EditText = AbstractView.subclass(
/** @lends UI.EditText.prototype */
{
	'type':'edittext',
	/**
	* @class The <code>EditText</code> class is a base class for derived classes that handle text-editing functions.
	* Derived classes from <code>EditText</code> include:
	* <div class="ul">
	 * <li>{@link UI.DateField}</li>
	 * </div>
	* @name UI.EditText
	* @augments UI.AbstractView
	*/
	initialize: function($super, properties) {
		if (EditText._init) EditText._init();
		$super(properties);
	},
	
	
	'InputTypes': Commands.InputType,
	'EnterKeyTypes': Commands.EnterKeyType,
	
	
	performEventCallback: function($super, event) {
		try {
			switch (event.eventType) {
				case 'change':
					this._text = event.text;
					// Fallthrough
				default: $super(event);
			}
		} catch(e) {
			NgHandleException(e);
		}
	},
	
	// Adapt API to the single-state model for "text" on editable text.
	/**
	 * Retrieve the value of the <code>text</code> property.
	 * @returns {String} The current value of <code>text</code>.
	 * @see UI.EditText#setText
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */	
	getText: function() {
		return this._text || "";
	},
	
	/**
	 * Set the value of the <code>text</code> property. This property defines a text string to use in arbitrary fashion.
	 * @example var someText = new UI.EditText();
	 * ...
	 * someText.setText("Pow!");
	 * @param {String} text The new value for <code>text</code>.
	 * @see UI.EditText#getText
	 * @status Javascript, iOS, Android, Test
	 * @function
	 */
	setText: function(text) {
		this._text = text;
		Commands.setText.call(this, 0, text);
	},

	setFocus: function(focus) {
		Commands.setFocus.call(this, focus);
	}
});

EditText._init = function() {
	delete EditText._init;
	if (AbstractView._init) AbstractView._init();
	
	// ==== Content
	// API defines state for the text property, but we ONLY support one state for this control.
	
	EditText.registerAccessors('text', EditText.prototype.getText, EditText.prototype.setText);
	
	/**
	 * @name UI.EditText#getPlaceholder
	 * @description Retrieve the value of the <code>placeholderText</code> property.
	 * @returns {String} The current value of <code>placeholder</code>.
	 * @see UI.EditText#setPlaceholder
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditText#setPlaceholder
	 * @description Set the value of the <code>placeholderText</code> property. This property defines a text string to use as a placeholder for fields that require text input.
	 * @example var placeHolder = new UI.EditText();
	 * ...
	 * placeHolder.setPlaceholder("This is a placeholder");
	 * @param {String} placeholder The new value for <code>placeholder</code>.
	 * @see UI.EditText#getPlaceholder
	 * @function
	 */
	EditText.synthesizeProperty('placeholder', Commands.setPlaceholderText);
	/**
	 * @name UI.EditText#getPlaceholderColor
	 * @description Retrieve the value of the <code>placeholderTestColor</code> property. 
	 * @see UI.EditText#setPlaceholderColor
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */	
	/**
	 * @name UI.EditText#setPlaceholderColor
	 * @description Set the value of the <code>placeholderTestColor</code> property. This property defines the color of the placeholder text string.
	 * @returns {String} The current value of <code>placeholderTextColor</code>.
	 * @example var placeHolder = new UI.EditText();
	 * ...
	 * placeHolder.setPlaceholderColor('FFFFFF');
	 * @param {String} placeholderColor The new value for <code>placeholderTestColor</code>.
	 * @see UI.EditText#getPlaceholderColor
	 * @function
	 */
	EditText.synthesizeProperty('placeholderColor', Commands.setPlaceholderTextColor);
	/**
	 * @name UI.EditText#getPlaceholderShadow
	 * @description Retrieve the value of the <code>placeholderTestShadow</code> property.
	 * @returns {String} The current value of <code>placeholderTestShadow</code>.
	 * @see UI.EditText#setPlaceholderShadow
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditText#setPlaceholderShadow
	 * @description Set the value of the <code>placeholderTestShadow</code> property.  This property defines the amount of shawdow applied to the placeholder text string.
	 * @example var placeHolder = new UI.EditText();
	 * ...
	 * placeHolder.setPlaceholderShadow("FF00 2.0 {0,-1}");
	 * @param {String} placeholderShadow The new value for <code>placeholderTestShadow</code>.
	 * @see UI.EditText#getPlaceholderShadow
	 * @function
	 */
	 EditText.synthesizeProperty('placeholderShadow', Commands.setPlaceholderTextShadow);
	
	// ==== Behavior
	/**
	 * @name UI.EditText#getInputType
	 * @description Retrieve the value of the <code>inputType</code> property.
	 * @returns {Number} The current value of <code>inputType</code>.
	 * @see UI.EditText#setInputType
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditText#setInputType
	 * @description Set the value of the <code>inputType</code> property.
	 * @param {Number} inputType The new value for <code>inputType</code>.
	 * @see UI.EditText#getInputType
	 * @function
	 */	
	 EditText.synthesizeProperty('inputType', Commands.setInputType);
	/**
	 * @name UI.EditText#getEnterKeyType
	 * @description Retrieve the value of the <code>enterKeyType</code> property.
	 * @returns {Number} The current value of <code>enterKeyType</code>.
	 * @see UI.EditText#setEnterKeyType
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditText#setEnterKeyType
	 * @description Set the value of the <code>enterKeyType</code> property.
	 * @param {Number} enterKeyType The new value for <code>enterKeyType</code>.
	 * @see UI.EditText#getEnterKeyType
	 * @function
	 */
	EditText.synthesizeProperty('enterKeyType', Commands.setEnterKeyType);
	
	// ==== Appearance
	/**
	 * @name UI.EditText#getTextColor
	 * @description Retrieve the value of the <code>textColor</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} textColor The current value of <code>textColor</code>.
	 * @see UI.EditText#setTextColor
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditText#setTextColor
	 * @description Set the value of the <code>textColor</code> property for a view state. This property defines the color of a text string in the specified view state.
	 * @example var placeHolder = new UI.EditText();
	 * ...
	 * placeHolder.setTextColor('FFFFFF');
	 * @param {String} textColor The new value for <code>textColor</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.EditText#getTextColor
	 * @status iOS, Test
	 * @function
	 */
	EditText.synthesizePropertyWithState('textColor', Commands.setTextColor);
	/**
	 * @name UI.EditText#getTextShadow
	 * @description Retrieve the value of the <code>textShadow</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>textShadow</code>.
	 * @see UI.EditText#setTextShadow
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditText#setTextShadow
	 * @description Set the value of the <code>textShadow</code> property for a view state. This property defines the amount of text shadowing used on text strings in this view.
	 * @example var placeHolder = new UI.EditText();
	 * ...
	 * placeHolder.setTextShadow("FF00 2.0 {0,-1}");
	 * @param {String} textShadow The new value for <code>textShadow</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.EditText#getTextShadow
	 * @status iOS, Test
	 * @function
	 */
	EditText.synthesizePropertyWithState('textShadow', Commands.setTextShadow);
	
	/**
	 * @name UI.EditText#getTextGravity
	 * @description Retrieve the value of the <code>textGravity</code> property for this <code>EditText</code>.
	 * @returns {Number, Array (Number)} The current value of <code>textGravity</code>.
	 * @see UI.EditText#setTextGravity
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditText#setTextGravity
	 * @description Set the value of the <code>textGravity</code> property for this <code>EditText</code>. This property defines how a text string is positioned within a viewable area.
	 * @example var placeHolder = new UI.EditText();
	 * ...
	 * placeHolder.setTextGravity([0.1, 0.5]);
	 * @param {Number, Array (Number)} textGravity The new value for <code>textGravity</code>. Set as a float or an array.
	 * @see UI.EditText#getTextGravity
	 * @function
	 */
	EditText.synthesizeCompoundProperty('textGravity', Commands.setTextGravity);
	/**
	 * @name UI.EditText#getTextSize
	 * @description Retrieve the value of the <code>teztSize</code> property for this <code>EditText</code>.
	 * @returns {Number} The current value of <code>textSize</code>.
	 * @see UI.EditText#setTextSize
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditText#setTextSize
	 * @description Set the value of the <code>textSize</code> property for this <code>EditText</code>. This property defines the size of text strings for a view.
	 * @example var placeHolder = new UI.EditText();
	 * ...
	 * placeHolder.setTextSize(18);
	 * @param {Number} textSize The new value for <code>textSize</code>.
	 * @see UI.EditText#getTextSize
	 * @status iOS, Test
	 * @function
	 */
	EditText.synthesizeProperty('textSize', Commands.setTextSize);
	/**
	 * @name UI.EditText#getTextFont
	 * @description Retrieve the value of the <code>textFont</code> property for this <code>EditText</code>.
	 * @returns {String} The current value of <code>textFont</code>.
	 * @see UI.EditText#setTextFont
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditText#setTextFont
	 * @description Set the value of the <code>textFont</code> property. This property defines the font face used with text strings in a view.
	 * @example var placeHolder = new UI.EditText();
	 * ...
	 * placeHolder.setTextFont(myFont);
	 * @param {String} textFont The new value for <code>textFont</code>.
	 * @see UI.EditText#getTextFont
	 * @status iOS, Test
	 * @function
	 */
	EditText.synthesizePropertyWithState('textFont', Commands.setTextFont);
	
	// ==== Events
	/**
	 * @name UI.EditText#getOnChange
	 * @description Retrieve the function to call when the <code>change</code> event occurs.
	 * @returns {Function} The current <code>change</code> callback function.
	 * @see UI.EditText#event:setOnChange
	 * @status Javascript, iOS, Android, Flash, Test
	 * @event
	 */
	/**
	 * @name UI.EditText#setOnChange
	 * @description Set a function to call when the <code>change</code> event occurs.
	 * @param {Function} changeCallback The new <code>change</code> callback function. <br><br><b>Note:</b> The <code>change</code> event is disabled 
	 * if the value of this parameter is not a function.
	 * @example EditText.setOnChange( function(event) { 
	 * 	console.log(event.text) 
	 *	} 
	 * );
	 * @see UI.EditText#event:getOnChange
	 * @status iOS
	 * @event
	 */
	EditText.registerEventType('change');
	/**
	 * @name UI.EditText#getOnFocus 
	 * @description Retrieve the function to call when the <code>focus</code> event occurs.
	 * @returns {Function} The current <code>focus</code> callback function.
	 * @see UI.EditText#event:setOnFocus
	 * @status Javascript, iOS, Android, Flash, Test
	 * @event	 
	 */
	/**
	 * @name UI.EditText#setOnFocus
	 * @description Set a function to call when the <code>focus</code> event occurs.
	 * @param {Function} focusCallback The new <code>focus</code> callback function. <br><br><b>Note:</b> The <code>focus</code> event is disabled 
	 * if the value of this parameter is not a function.
	 * @example EditText.setOnFocus( function(event) { 
	 * 	console.log(event.text) 
	 *	} 
	 * );
	 * @see UI.EditText#event:getOnFocus
	 * @event
	 */
	EditText.registerEventType('focus');
	/**
	 * @name UI.EditText#getOnBlur
	 * @description Retrieve the function to call when the <code>blur</code> event occurs.
	 * @returns {Function} The current <code>blur</code> callback function.
	 * @see UI.EditText#event:setOnBlur
	 * @status Javascript, iOS, Android, Flash, Test
	 * @event
	 */
	/**
	 * @name UI.EditText#setOnBlur
	 * @description Set a function to call when the <code>blur</code> event occurs.
	 * @note WARNING! This event is not guaranteed to occur on Android devices. Developers must not rely on this event occurring.
	 * @param {Function} blurCallback The new <code>blur</code> callback function.<br><br><b>Note:</b> The <code>blur</code> event is disabled 
	 * if the value of this parameter is not a function.
	 * @example EditText.setOnBlur( function(event) { 
	 * 	console.log(event.text) 
	 *	} 
	 * );
	 * @see UI.EditText#event:getOnBlur
	 * @event
	 */
	EditText.registerEventType('blur');

	/**
	 * @name UI.EditText#getOnAction
	 * @description Retrieve the function to call when the <code>action</code> event occurs.
	 * @returns {Function} The current <code>action</code> callback function.
	 * @see UI.EditText#event:setOnAction
	 * @status Javascript, iOS, Android, Flash, Test
	 * @event
	 */
	/**
	 * @name UI.EditText#setOnAction
	 * @description Set a function to call when a keyboard key corresponding to executing an action is pressed.
	 * Available since 1.1.6
	 * @note WARNING! Soft keyboards on Android devices are not required to offer actions. Developers must not rely on this event occurring.
	 * @param {Function} actionCallback The new <code>action</code> callback function.<br><br><b>Note:</b> The <code>action</code> event is disabled 
	 * if the value of this parameter is not a function.
	 * @see UI.EditText#event:getOnAction
	 * @event
	 */
	EditText.registerEventType('action');

	
	// helpers for legacy support... Bind full properties to a single state of another.
	var states = {
		'normal': Commands.State.Normal,
		'focused': Commands.State.Focused,
		'pressed': Commands.State.Pressed,
		'selected': Commands.State.Focused,
		'highlighted': Commands.State.Pressed,
		'disabled': Commands.State.Disabled
	};
	
	function bindStateProperties(propName) {
		var doSynthesis = function(propName, stateName, stateFlags) {
			var getterFn = function() {
				return this._getters[propName].call(this, stateFlags);
			};
			var setterFn = function(val) {
				return this._setters[propName].call(this, val, stateFlags);
			};
			var thisStatePropName = stateName + propName.charAt(0).toUpperCase() + propName.substr(1);
		//	NgLogD("Synthesizing Button." + thisStatePropName + " as getters[" + propName + "][" + stateFlags + "]");
			EditText.registerAccessors(thisStatePropName, getterFn, setterFn,
				"Use " + propName + " accessors with a final state parameter instead.");
		};
		for (var stateName in states) {
			if (!states.hasOwnProperty(stateName)) continue;
			doSynthesis(propName, stateName, states[stateName]);
		}
	};
	
	bindStateProperties('textColor');
	bindStateProperties('textShadow');
	bindStateProperties('gradient');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/EditTextArea'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/EditTextArea'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/EditTextArea'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var EditTextArea = exports.EditTextArea = AbstractView.subclass(
/** @lends UI.EditTextArea.prototype */
{
	'type':'edittextarea',
	/**
	* @class The <code>EditTextArea</code> class is multiline text-editing area.
	* @name UI.EditTextArea
	* @augments UI.AbstractView
	*/
	initialize: function($super, properties) {
		if (EditTextArea._init) EditTextArea._init();
		$super(properties);
	},
	
	
	performEventCallback: function($super, event) {
		try {
			switch (event.eventType) {
				case 'change':
					this._text = event.text;
					$super(event);
					break;
				case 'focus':
				case 'blur':
					$super(event);
					break;
			}
		} catch(e) {
			NgHandleException(e);
		}
	},
	
	// Adapt API to the single-state model for "text" on editable text.
	/**
	 * Retrieve the value of the <code>text</code> property.
	 * @returns {String} The current value of <code>text</code>.
	 * @see UI.EditTextArea#setText
	 * @status Javascript, iOS
	 * @function
	 */	
	getText: function() {
		return this._text || "";
	},
	
	/**
	 * Set the value of the <code>text</code> property.
	 * @param {String} text The new value for <code>text</code>.
	 * @see UI.EditTextArea#getText
	 * @status Javascript, iOS
	 * @function
	 */
	setText: function(text) {
		this._text = text;
		Commands.setText.call(this, 0, text);
	},

	setFocus: function(focus) {
		Commands.setFocus.call(this, focus);
	}
});

EditTextArea._init = function() {
	delete EditTextArea._init;
	if (AbstractView._init) AbstractView._init();
	
	// ==== Content
	// API defines state for the text property, but we ONLY support one state for this control.
	
	EditTextArea.registerAccessors('text', EditTextArea.prototype.getText, EditTextArea.prototype.setText);
	
	/**
	 * @name UI.EditTextArea#getPlaceholder
	 * @description Retrieve the value of the <code>placeholder</code> property.
	 * @returns {String} The current value of <code>placeholder</code>.<br>
	 * @see UI.EditTextArea#setPlaceholder
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditTextArea#setPlaceholder
	 * @description Set the value of the <code>placeholder</code> property.
	 * @param {String} placeholder The new value for <code>placeholder</code>.
	 * @see UI.EditTextArea#getPlaceholder
	 * @function
	 */
	EditTextArea.synthesizeProperty('placeholder', Commands.setPlaceholderText);
	/**
	 * @name UI.EditTextArea#getPlaceholderColor
	 * @description Retrieve the value of the <code>placeholder color</code> property.
	 * @returns {String} The current value of <code>placeholder color</code>.<br>
	 * @see UI.EditTextArea#setPlaceholderColor
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */	
	/**
	 * @name UI.EditTextArea#setPlaceholderColor
	 * @description Set the value of the <code>placeholder color</code> property.
	 * @param {String} placeholderColor The new value for <code>placeholder color</code>.
	 * @see UI.EditTextArea#getPlaceholderColor
	 * @function
	 */
	EditTextArea.synthesizeProperty('placeholderColor', Commands.setPlaceholderTextColor);
	/**
	 * @name UI.EditTextArea#getPlaceholderShadow
	 * @description Retrieve the value of the <code>placeholder shadow</code> property.
	 * @returns {String} The current value of <code>placeholder shadow</code>.<br>
	 * @see UI.EditTextArea#setPlaceholderShadow
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditTextArea#setPlaceholderShadow
	 * @description Set the value of the <code>placeholder shadow</code> property.
	 * @param {String} placeholderShadow The new value for <code>placeholder shadow</code>.
	 * @see UI.EditTextArea#getPlaceholderShadow
	 * @function
	 */
	 EditTextArea.synthesizeProperty('placeholderShadow', Commands.setPlaceholderTextShadow);
	
	
	// ==== Appearance
	/**
	 * @name UI.EditTextArea#getTextColor
	 * @description Retrieve the value of the <code>textColor</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} textColor The current value of <code>textColor</code>.<br>
	 * @see UI.EditTextArea#setTextColor
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditTextArea#setTextColor
	 * @description Set the value of the <code>textColor</code> property for a view state.
	 * @param {String} textColor The new value for <code>textColor</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.EditTextArea#getTextColor
	 * @status iOS, Test
	 * @function
	 */
	EditTextArea.synthesizePropertyWithState('textColor', Commands.setTextColor);
	/**
	 * @name UI.EditTextArea#getTextShadow
	 * @description Retrieve the value of the <code>textShadow</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>textShadow</code>.<br>
	 * @see UI.EditTextArea#setTextShadow
	 * @private not working on iOS
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditTextArea#setTextShadow
	 * @description Set the value of the <code>textShadow</code> property for a view state.
	 * @param {String} textShadow The new value for <code>textShadow</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.EditTextArea#getTextShadow
	 * @private not working on iOS
	 * @status iOS, Test
	 * @function
	 */
	EditTextArea.synthesizePropertyWithState('textShadow', Commands.setTextShadow);
	
	/**
	 * @name UI.EditTextArea#getTextGravity
	 * @description Retrieve the value of the <code>textGravity</code> property for this <code>EditTextArea</code>.
	 * @returns {Number, Array (Number)} The current value of <code>textGravity</code>.<br>
	 * @see UI.EditTextArea#setTextGravity
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditTextArea#setTextGravity
	 * @description Set the value of the <code>textGravity</code> property for this <code>EditTextArea</code>.
	 * @param {Number, Array (Number)} textGravity The new value for <code>textGravity</code>. Set as a float or an array.
	 * @see UI.EditTextArea#getTextGravity
	 * @function
	 */
	EditTextArea.synthesizeCompoundProperty('textGravity', Commands.setTextGravity);
	/**
	 * @name UI.EditTextArea#getTextSize
	 * @description Retrieve the value of the <code>teztSize</code> property for this <code>EditTextArea</code>.
	 * @returns {Number} The current value of <code>textSize</code>.<br>
	 * @see UI.EditTextArea#setTextSize
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditTextArea#setTextSize
	 * @description Set the value of the <code>textSize</code> property for this <code>EditTextArea</code>.
	 * @param {Number} textSize The new value for <code>textSize</code>.
	 * @see UI.EditTextArea#getTextSize
	 * @status iOS, Test
	 * @function
	 */
	EditTextArea.synthesizeProperty('textSize', Commands.setTextSize);
	/**
	 * @name UI.EditTextArea#getTextFont
	 * @description Retrieve the value of the <code>textFont</code> property for this <code>EditTextArea</code>.
	 * @returns {String} The current value of <code>textFont</code>.<br>
	 * @see UI.EditTextArea#setTextFont
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditTextArea#setTextFont
	 * @description Set the value of the <code>textFont</code> property for this <code>EditTextArea</code>.
	 * @param {String} textFont The new value for <code>textFont</code>.
	 * @see UI.EditTextArea#getTextFont
	 * @status iOS, Test
	 * @function
	 */
	EditTextArea.synthesizePropertyWithState('textFont', Commands.setTextFont);
	
	// ==== Events
	/**
	 * @name UI.EditTextArea#getOnChange
	 * @description Retrieve the function to call when the <code>change</code> event occurs.
	 * @returns {Function} The current <code>change</code> callback function.
	 * @see UI.EditTextArea#event:setOnChange
	 * @status Javascript, iOS, Android, Flash, Test
	 * @event
	 */
	/**
	 * @name UI.EditTextArea#setOnChange
	 * @description Set a function to call when the <code>change</code> event occurs.
	 * @param {Function} changeCallback The new <code>change</code> callback function. <br><br><b>Note:</b> The <code>change</code> event is disabled 
	 * if the value of this parameter is not a function.
	 * @see UI.EditTextArea#event:getOnChange
	 * @status iOS
	 * @event
	 */
	EditTextArea.registerEventType('change');
	/**
	 * @name UI.EditTextArea#getOnFocus 
	 * @description Retrieve the function to call when the <code>focus</code> event occurs.
	 * @returns {Function} The current <code>focus</code> callback function.
	 * @see UI.EditTextArea#event:setOnFocus
	 * @status Javascript, iOS, Android, Flash, Test
	 * @event	 
	 */
	/**
	 * @name UI.EditTextArea#setOnFocus
	 * @description Set a function to call when the <code>focus</code> event occurs.
	 * @param {Function} focusCallback The new <code>focus</code> callback function. <br><br><b>Note:</b> The <code>focus</code> event is disabled 
	 * if the value of this parameter is not a function.
	 * @see UI.EditTextArea#event:getOnFocus
	 * @event
	 */
	EditTextArea.registerEventType('focus');
	/**
	 * @name UI.EditTextArea#getOnBlur
	 * @description Retrieve the function to call when the <code>blur</code> event occurs.
	 * @returns {Function} The current <code>blur</code> callback function.
	 * @see UI.EditTextArea#event:setOnBlur
	 * @status Javascript, iOS, Android, Flash, Test
	 * @event
	 */
	/**
	 * @name UI.EditTextArea#setOnBlur
	 * @description Set a function to call when the <code>blur</code> event occurs.
	 * @param {Function} blurCallback The new <code>blur</code> callback function.<br><br><b>Note:</b> The <code>blur</code> event is disabled 
	 * if the value of this parameter is not a function.
	 * @see UI.EditTextArea#event:getOnBlur
	 * @event
	 */
	EditTextArea.registerEventType('blur');
	
	// helpers for legacy support... Bind full properties to a single state of another.
	var states = {
		'normal': Commands.State.Normal,
		'focused': Commands.State.Focused,
		'pressed': Commands.State.Pressed,
		'selected': Commands.State.Focused,
		'highlighted': Commands.State.Pressed,
		'disabled': Commands.State.Disabled
	};
	
	function bindStateProperties(propName) {
		var doSynthesis = function(propName, stateName, stateFlags) {
			var getterFn = function() {
				return this._getters[propName].call(this, stateFlags);
			};
			var setterFn = function(val) {
				return this._setters[propName].call(this, val, stateFlags);
			};
			var thisStatePropName = stateName + propName.charAt(0).toUpperCase() + propName.substr(1);
		//	NgLogD("Synthesizing Button." + thisStatePropName + " as getters[" + propName + "][" + stateFlags + "]");
			EditTextArea.registerAccessors(thisStatePropName, getterFn, setterFn,
				"Use " + propName + " accessors with a final state parameter instead.");
		};
		for (var stateName in states) {
			if (!states.hasOwnProperty(stateName)) continue;
			doSynthesis(propName, stateName, states[stateName]);
		}
	};
	
	bindStateProperties('textColor');
	bindStateProperties('textShadow');
	bindStateProperties('gradient');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/DateField'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/DateField'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/DateField'] = exports; var EditText = require('NGCore/Client/UI/EditText').EditText;

function isValidDate(d) {
	if ( !d.getTime )
		return false; 
		
	return !isNaN(d.getTime());
}

/*
 Date Parser code to handle WebKit's lack of following the implementation.
 http://stackoverflow.com/questions/3085937/safari-js-cannot-parse-yyyy-mm-dd-date-format/3085993#3085993
 */
function parseDate(input, format) {
  format = format || 'yyyy-mm-dd'; // default format
  var parts = input.match(/(\d+)/g), 
      i = 0, fmt = {};
  // extract date-part indexes from the format
  format.replace(/(yyyy|dd|mm)/g, function(part) { fmt[part] = i++; });

  return new Date(parts[fmt['yyyy']], parts[fmt['mm']]-1, parts[fmt['dd']]);
}
/*
 * Our Code is not actually passing its format to parseDate (already had all the code to rejigger the date pieces to yyyy-mm-dd before I realized the problems with webkit's date constructor / date string parser). -fbartho 2010-11-30
 */

exports.DateField = EditText.subclass(
/** @lends UI.DateField.prototype */
{
	/**
	 * @class The <code>DateField</code> class constructs objects that handle data returned by date functions.
	 * @constructs The default constructor. 
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {String} properties
	 * @augments UI.EditText
	 */
	initialize: function($super, properties) {
		var constructorRVal = $super(properties);
		this.setDateFormat("yyyy-mm-dd");
		this.ondatechange = function(newDate){};
		
		this.setInputType(EditText.InputTypes.Date);
		return constructorRVal;
	},
    
	/**
	 * Trigger an event callback for this <code>DateField</code>.
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {String} event The event that triggers a callback function.
	 * @private
	 * @status Javascript, iOS, Android, Flash
	 */
	performEventCallback: function($super, event) {
		try {
			if (event.eventType == 'change') {
				// Make Sure the Text is changed (call $super), before we call our listeners!
				var oldText = this.getText();
				$super(event);
				this.ondatechange(this.getDate());
			}
		} catch(e) {
			NgHandleException(e);
		}
	},
	_filterAndInsertDashes:function(oldText,newText) {
		var t = newText;
		if((oldText.length == t.length + 1) && oldText[oldText.length-1] == "-") {
			//This lets the user backspace through - marks as if they weren't there.
			// fbartho: Currently not in use! 2010-12-10
			//this.setText(t.substring(0,t.length-1));
			return t.substring(0,t.length-1);
		}
		
		var nt = "";
		var j = 0;
		for(var i = 0; i < t.length && nt.length < this.formatStr.length; i++,j++) {
			if(j < this.formatStr.length && this.formatStr[j] == "-" && i < t.length){
				if(t[i] == "-"|| t[i] == "/"){
					nt+="-";
					continue;
				}
				else {
					nt+="-";
					nt+=t[i];
					continue;
				}
			}
			if ( i < t.length && (t[i] == "-" || t[i] == "/") ) {
				--j; 
				continue;
			}
			nt+=t[i];
		}
		
		if(this.formatStr.length > j && (this.formatStr[j] == "-" || this.formatStr[j] == "/") ) {
			nt+="-";
		}
		
		return nt;
	},
	/**
	 * Format a date parsed from this <code>DateField</code> into a human-readable string.
	 * @status Javascript, iOS, Android, Flash, Test
	 */    
	normalizeDateLayout:function() {
		var ot = this.getText();
		var nt = this._filterAndInsertDashes(this.getText(),this.getText());
		if(ot!=nt)this.setText(nt);
	},
	/**
	 * Retrieve the date format of date strings parsed from this <code>DateField</code>
	 * @returns {String} The current date format.
	 * @see UI.DateField#setDateFormat
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	getDateFormat:function() {
		return this.formatStr;
	},
	/**
	 * Set the date format for date strings parsed from this <code>DateField</code>.
	 * @param {String} dateFormat The new date format.
	 * @see UI.DateField#getDateFormat
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	setDateFormat:function(fStr) 
	{
		if (   fStr != "yyyy-mm-dd"
			&& fStr != "mm-yyyy"
			&& fStr != "yyyy-mm"
			&& fStr != "mm-dd-yyyy"
			&& fStr != "dd-mm-yyyy" ) {
			// Invalid Format String Error Case
			NgLogD("Error: Invalid Format String set for Birthdate Field!!\n");
			
			return;
		}
		
		this.formatStr = fStr;
		this.setPlaceholder(this.formatStr);
		return;
	},
	/**
	 * Retrieve a date string parsed from this <code>DateField</code>.
	 * @returns {String} The current date.
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	getDate:function() {
		return this._dateFromText(this._filterAndInsertDashes(this.getText(),this.getText()));
	}, 
	_dateFromText:function(text) 
	{
		var tmp = null;
		var t = text;
		var bits = null;
		var b2 = null;
		if ( this.formatStr == "dd-mm-yyyy" ) {
			bits = t.split("-");
			if(bits.length != 3 || bits[2].length != 4)
				return null;
			
			b2 = [];
			b2.push(bits.pop());
			b2.push(bits.pop());
			b2.push(bits.pop());
			tmp = parseDate(b2.join("-"));
		} else if ( this.formatStr == "mm-yyyy" ) {
			bits = t.split("-");
			if(bits.length != 2 || bits[1].length != 4)
				return null;
			
			b2 = [];
			b2.push(bits.pop());
			b2.push(bits.pop());
			b2.push("01");
			var tStr = b2.join("-");
			
			tmp = parseDate(tStr);
		} else if ( this.formatStr == "yyyy-mm" ) {
			bits = t.split("-");
			if(bits.length != 2 || bits[0].length != 4)
				return null;
			
			tmp = parseDate(t+"-01");
		} else if ( this.formatStr == "mm-dd-yyyy" ) {
			bits = t.split("-");
			if(bits.length != 3 || bits[2].length != 4)
				return null;
			
			b2 = [];
			b2.push(bits.pop());
			b2.push(bits.shift());
			b2.push(bits.shift());
			tmp = parseDate(b2.join("-"));
		} else {
			tmp = parseDate(t);
		}
		
		if(!isValidDate(tmp)) {
			NgLogD("Failed to parse date: "+tmp+"   -  "+tmp.toString()+"\n");
			return null;
		}
		return tmp;
	}
});

//TODO: make a proper DatePicker?
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/AlertDialog'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/AlertDialog'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/AlertDialog'] = exports; var Element = require('NGCore/Client/UI/Element').Element;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var AlertDialog = exports.AlertDialog = Element.subclass(
/** @lends UI.AlertDialog.prototype */
{
	'type':'alertdialog',
	/**
	 * @name UI.AlertDialog
	 * @class The <code>AlertDialog</code> class constructs objects that handle alert dialogs in an application.
	 * @augments UI.Element
	 */
	initialize: function($super, properties) {
		if (AlertDialog._init) AlertDialog._init();
		$super(properties);
	},
	
	/** 
	 * Show this dialog.
	 * @function
	 */
	show: Commands.show,
	/** 
	 * Hide this dialog.
	 * @function
	 */
	hide: Commands.hide
});

// Properties
AlertDialog._init = function() {
	delete AlertDialog._init;
	if (Element._init) Element._init();

	/**
	 * @name UI.AlertDialog#setTitle
	 * @description Set the value of the <code>title</code> property for a view state. This property defines the title string for an alert dialog window.
	 * @example var alertDialog = new UI.AlertDialog();
	 * alertDialog.setTitle("Exiting Game..");
	 * @see UI.AlertDialog#getTitle
	 * @param {String} title The new value for <code>title</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
 	 * @status iOS, Android
	 * @function
	 */
	/**
	 * @name UI.AlertDialog#getTitle
	 * @description Retrieve the value of the <code>title</code> property for a view state.
	 * @see UI.AlertDialog#setTitle
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>title</code>.
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	AlertDialog.synthesizePropertyWithState('title', Commands.setTitle);
	/**
	 * @name UI.AlertDialog#setText
	 * @description Set the value of the <code>text</code> property for a view state. This property defines a text string that is on display within an alert dialog window.
	 * @example var alertDialog = new UI.AlertDialog();
	 * ...
	 * alertDialog.setText("Returning to launcher..");
	 * @see UI.AlertDialog#getText
	 * @param {String} text The new value for <code>text</code>
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
 	 * @status iOS, Android
	 * @function
	 */
	/**
	 * @name UI.AlertDialog#getText
	 * @description Retrieve the value of the <code>text</code> property for a view state.
	 * @see UI.AlertDialog#setText
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>text</code>.
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	AlertDialog.synthesizePropertyWithState('text', Commands.setText);
	// Not a compound property; AlertDialog.getChoices() should return the array of strings.
	/**
	 * @name UI.AlertDialog#setChoices
	 * @description Set the value of the <code>choices</code> property. This property defines any available interface options for the user.
	 * @example var errorAlert = new UI.AlertDialog();
	 * ...
	 * errorAlert.setChoices(["Yes", "No"]);
	 * @see UI.AlertDialog#getChoices
	 * @param {String} choices The new value for <code>choices</code>.
	 * @param {Number} defaultChoice The index of the default choice.
	 * @param {Number} cancelChoice The index of the <code>cancel</code> choice.
 	 * @status iOS, Android
	 * @function
	 */
	/**
	 * @name UI.AlertDialog#getChoices
	 * @description Retrieve the value of the <code>choices</code> property.
	 * @see UI.AlertDialog#setChoices
	 * @returns {Array (String)} The current value of <code>choices</code>.
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	AlertDialog.synthesizeProperty('choices', Commands.setChoices);
	
	// Event will contain .choice, which is the index of the option chosen.
	/**
	 * @name UI.AlertDialog#setOnChoice
	 * @description Set a function to call on <code>choice</code> events.	 
	 * @param {Function} choiceCallback The new function to call. <br><br>
	 * <b>Note:</b> The <code>choice</code> event is disabled if the value for this parameter is not a function.
	 * @see UI.AlertDialog#event:getOnChoice
 	 * @status iOS, Android, Test
	 * @event
	 */
	/**
	 * @name UI.AlertDialog#getOnChoice
	 * @description Retrieve the function to call on <code>choice</code> events.
	 * @see UI.AlertDialog#event:setOnChoice
	 * @returns {Function} The current function to call.
	 * @event
	 * @type {Function}
 	 * @status iOS, Android, Test
	 */
	 AlertDialog.registerEventType('choice');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/ProgressDialog'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/ProgressDialog'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/ProgressDialog'] = exports; var Element = require('NGCore/Client/UI/Element').Element;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var ProgressDialog = exports.ProgressDialog = Element.subclass(
/** @lends UI.ProgressDialog.prototype */
{
	'type':'progressdialog',

    /**
     * @class The <code>ProgressDialog</code> class constructs objects that handle progress updates from the application.
     * @constructs The default constructor. 
     * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
     * @param {String} properties Object properties.
     * @augments UI.Element
     */
    initialize: function($super, properties) {
		if (ProgressDialog._init) ProgressDialog._init();
        return $super(properties);
    },
	/**
	 * Show this dialog.
	 * @function
     * @status iOS, Android, Test
	 */    
    show: Commands.show,
	/**
	 * Hide this dialog.
	 * @function
     * @status iOS, Android, Test
	 */    
    hide: Commands.hide
});

ProgressDialog._init = function() {
	delete ProgressDialog._init;
	if (Element._init) Element._init();
	
	/**
	 * @name UI.ProgressDialog#setTitle
	 * @description Set the value of the <code>title</code> property for a <code>ProgressDialog</code>. This property defines the title string for a progress dialog in the specified view state.
	 * @example var progDialog = new UI.ProgressDialog();
	 * progDialog.setTitle("Downloading game components...");
	 * @param {String} title The new value for <code>title</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.ProgressDialog#getTitle
	 * @function
     * @status iOS, Android, Test
	 */
	/**
	 * @name UI.ProgressDialog#getTitle
	 * @description Retrieve the value of the <code>title</code> property for a <code>ProgressDialog</code> in the specified view state. 
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>title</code>.
	 * @see UI.ProgressDialog#setTitle
	 * @function
     * @status iOS, Android, Test
	 */
	ProgressDialog.synthesizePropertyWithState('title', Commands.setTitle);
	/**
	 * @name UI.ProgressDialog#setText
	 * @description Set the value of the <code>text</code> property for a <code>ProgressDialog</code> in the specified view state. This property defines a text string for a progress dialog in the specified view state.
	 * @example var progDialog = new UI.ProgressDialog();
	 * progDialog.setText("Please wait...");
	 * @param {String} text The new value for <code>text</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.ProgressDialog#getText
	 * @function
     * @status iOS, Android, Test
	 */
	/**
	 * @name UI.ProgressDialog#getText
	 * @description Retrieve the value of the <code>text</code> property for a <code>ProgressDialog</code> in the specified view state.	 
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>text</code>.
	 * @see UI.ProgressDialog#setText
	 * @function
     * @status iOS, Android, Test
	 */
	ProgressDialog.synthesizePropertyWithState('text', Commands.setText);
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/Toast'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/Toast'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/Toast'] = exports; var Element = require('NGCore/Client/UI/Element').Element;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var Toast = exports.Toast = Element.subclass(
/** @lends UI.Toast.prototype */
{	
    'type': 'toast',
    /**
    * @class The <code>Toast</code> class constructs objects that render temporary messages on the device screen.
    * @name UI.Toast
    * @augments UI.View
    */
	initialize: function($super, properties) {
		if (Toast._init) Toast._init();
		$super(properties);
	},
	
	/** 
	 * Show this dialog.
	 * @function
     * @status iOS, Android, Test
	 */
    show: Commands.show
});

Toast._init = function() {
	delete Toast._init;
	if (Element._init) Element._init();

	/**
	 * @name UI.Toast#setText
	 * @description Set the value of the <code>text</code> property for a view state. This property defines a text string to use in the specified view state.
	 * @example var tempMessage = new UI.Toast();
	 * tempMessage.setText("Game Over");
	 * @param {String} text The new value for <code>text</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.Toast#getText
	 * @function
     * @status iOS, Android, Test
	 */
	/**
	 * @name UI.Toast#getText
	 * @description Retrieve the value of the <code>text</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>text</code>.
	 * @see UI.Toast#setText
	 * @function	 
     * @status iOS, Android, Test
	 */
	Toast.synthesizePropertyWithState('text', Commands.setText);
	/** 
	* @name UI.Toast#setOnDisappear
	* @description Set a function to call when the <code>disappear</code> event occurs. The callback for the event returns 
	* <code>true</code> if the temporary message should disappear. Otherwise, the callback returns <code>false</code>.
	* @param {function} disappearCallback The new callback function.<br><br>
	* <b>Note:</b> The <code>disappear</code> event is disabled if the value of this parameter is not a function.
	* @see UI.Toast#event:getOnDisappear
	* @event
	*/
	/**
	* @name UI.Toast#getOnDisappear
	* @description Retrieve the function to call when the <code>disappear</code> event occurs.
	* @returns {function} The current callback function.
	* @see UI.Toast#event:setOnDisappear
	* @event
	*/
	Toast.registerEventType('disappear');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/AdView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/AdView'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/AdView'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;

/** @private */
var AdView = exports.AdView = AbstractView.subclass(
{
	'type':'adview',

	/**
	 * @class The <code>AdView</code> class constructs objects that handle event callback functions and ad event metadata.
	 * @constructs The default constructor. 
	 * @param $super This parameter is stripped out during execution. Do not supply it.
	 * @param {String} properties
	 * @augments UI.AbstractView
	 */
	initialize: function($super, properties) {
		if (AdView._init) AdView._init();
		$super(properties);
		
		this.onappear = this.bind(this._onappear);
		this.ondisappear = this.bind(this._ondisappear);
		this.onclick = this.bind(this._onclick);
	},
	
	/**
	 * An event for signaling when an <code>AdView</code> is on display.
	 * @event
	 */
	onappear: function() {
	 },
	
	/**
	 * An event for signaling when an <code>AdView</code> has been closed.
	 * @event
	 */
	ondisappear: function() { 
	},
	
	/** @protected */
	_onappear: function($super, event) {
		( $super || function(){} )(event);
//		Core.Analytics._getPipe().revenueEvent("ADSHOW",  this.getAdEventMetadata());
        visible = true;
	},
	
	/** @protected */
	_ondisappear: function($super, event) {
		( $super || function(){} )(event);
//		Core.Analytics._getPipe().revenueEvent("ADCLOSE", this.getAdEventMetadata());
        visible = false;
	},
	
	performEventCallback: function($super, event) {
		if (event.eventType == 'click')
		{
//			Core.Analytics._getPipe().revenueEvent("ADCLCK", this.getAdEventMetadata());
			NgLogD("AD WAS CLICKED in AdView wooo!!!!");
			( $super || function(){} )(event);
		}
		if (event.eventType == 'load')
		{
//			Core.Analytics._getPipe().revenueEvent("ADLOAD", this.getAdEventMetadata());
			NgLogD("AD WAS LOADED in AdView wooo!!!!");
			( $super || function(){} )(event);
		}
	},
	/**
	* Pause this <code>AdView</code>.<br><br>
	* <b>Note:</b> If an <code>AdView</code> is already paused, this call does nothing.
	* @see UI.AdView#resumeAds
	* @status Android
	*/
	pauseAds: function() {
		Commands.pauseAds.call(this);
	},
	/**
	* Resume this <code>AdView</code> from a paused state. Setting this will resume the <code>AdView</code> from the current position.
	* @see UI.AdView#resumeAds
	* @status Android
	*/
	resumeAds: function() {
		Commands.resumeAds.call(this);
	},
	/**
	* Set the refresh rate for this <code>AdView</code>. 
	* @param {Number} refreshRate The amount of time each ad is on display (in milliseconds).
	* @status Android
	*/
	setRefreshRate: function(refreshRate) {
		Commands.setAdRefreshRate.call(this, refreshRate);
	},
	/**
	* Set this <code>AdView</code> to automatically play.
	* @status Android
	* @param {Boolean} autoplay Set as <code>true</code> if autoplay is enabled.
	*/
	setAutoplay: function(autoplay) {
		Commands.setAdRefreshRate.call(this, autoplay);
	},
	
	/**
	 * Retrieve event metadata from this <code>AdView</code>. 
	 */
	getAdEventMetadata: function(){
		NgLogD("AD EventMetetData was requested!");
		var AdMeteData = "DefaultAdEventMetaData";
		return AdMeteData;
	}
});

// Event Handlers
AdView._init = function() {
	delete AdView._init;
	if (AbstractView._init) AbstractView._init();

    /**
	 * @name UI.AdView#getActive
	 * @description Retrieve the value of the <code>active</code> property.
	 * @returns {Boolean} Returns <code>true</code> if the <code>AdView</code> object is set to active.
	 * @see UI.AdView#setActive
	 * @status iOS, Android, Flash, Test
	 * @function
	 */
	AdView.synthesizeProperty('active', Commands.setActive);
    
	/**
	 * @name UI.AdView#setOnClick
	 * @description Set a function to call on <code>click</code> events.	 
	 * @param {Function} clickCallback The new <code>click</code> callback function. <br><br>
	 * <b>Note:</b> The <code>click</code> event is disabled if the value for this parameter is not a function.<br>
	 * @see UI.AdView#event:setOnClick
 	 * @status Android, Test
	 * @event
	 */
	/**
	 * @name UI.AdView#getOnClick
	 * @description Retrieve the function to call on <code>click</code> events.<br>
	 * @see UI.AdView#event:getOnClick
	 * @returns {Function} The current <code>click</code> callback function.<br>
 	 * @status Android, Test
	 * @event
	 */
	AdView.registerEventType('click');
	/**
	 * @name UI.AdView#setOnLoad
	 * @description Set a function to call on <code>load</code> events.	 
	 * @param {Function} loadCallback The new <code>load</code> callback function. <br><br>
	 * <b>Note:</b> The <code>load</code> event is disabled if the value for this parameter is not a function.<br>
	 * @see UI.AdView#event:getOnClick
 	 * @status Android, Test
	 * @event
	 */
	/**
	 * @name UI.AdView#getOnLoad
	 * @description Retrieve the function to call on <code>load</code> events.<br>
	 * @see UI.AdView#event:getOnClick
	 * @returns {Function} The current <code>load</code> callback function.<br>
 	 * @status Android, Test
	 * @event
	 */
	AdView.registerEventType('load');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/DocumentView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/DocumentView'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/DocumentView'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var DocumentView = exports.DocumentView = AbstractView.subclass(
/** @lends UI.DocumentView.prototype */
{
	'type':'documentview',
	/**
	 * @name UI.DocumentView
	 * @class The <code>DocumentView</code> class constructs objects that handle document locations.
	 * @augments UI.AbstractView
	 */
	initialize: function($super, properties) {
		if (DocumentView._init) DocumentView._init();
		$super(properties);
	}
});

// Properties
DocumentView._init = function() {
	delete DocumentView._init;
	if (AbstractView._init) AbstractView._init();
	
	/**
	 * @name UI.DocumentView#setDocumentURL
	 * @description Set the document URL for this <code>DocumentView</code>.
	 * @param {String} documentURL The new document URL.
	 * @see UI.DocumentView#getDocumentURL
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.DocumentView#getDocumentURL
	 * @description Retrieve the document URL of this <code>DocumentView</code>.
	 * @returns {String} The current document URL.
	 * @see UI.DocumentView#setDocumentURL
	 * @status iOS, Android, Test
	 * @function
	 */
	DocumentView.synthesizeProperty('documentURL', Commands.setSourceDocument);
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/CheckoutView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/CheckoutView'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/CheckoutView'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var ViewGeometry = require('NGCore/Client/UI/ViewGeometry');
var Commands = require('NGCore/Client/UI/Commands').Commands;

var CheckoutView = exports.CheckoutView = AbstractView.subclass(
/** @lends UI.CheckoutView.prototype */
{
	'type':'checkoutview',
	/**
	 * @name UI.CheckoutView
	 * @class The <code>CheckoutView</code> class constructs objects that handle and manage information associated with <code>POST</code> methods in an application.
	 * @augments UI.AbstractView
	 */
	initialize: function($super, properties) {
		if (CheckoutView._init) CheckoutView._init();
		$super(properties);
	}
});

// Properties
CheckoutView._init = function() {
	delete CheckoutView._init;
	if (AbstractView._init) AbstractView._init();
	
	// THESE ARE METHODS NOT PROPERTIES... THIS SHOULD BE FIXED.
	// We define ONLY setters, and no getters (write-only props, no local copies)
	/**
	 * @name UI.CheckoutView#setPostData
	 * @description Set the value returned by the <code>postData()</code> method of this <code>CheckoutView</code>.
	 * @param {String} postData The new value for <code>postData</code>.
	 * @see UI.CheckoutView#getPostData
	 * @status Android
	 * @function
	 */
	/**
	 * @name UI.CheckoutView#getPostData
	 * @description Retrieve the value returned by the <code>postData()</code> method of this <code>CheckoutView</code>.
	 * @returns {String} The current value of <code>postData</code>.
	 * @see UI.CheckoutView#setPostData
	 * @status Android
	 * @function
	 */
	CheckoutView.registerAccessors('postData', null, Commands.setPostData);
	/**
	 * @name UI.CheckoutView#setPostURL
	 * @description Set the value returned by the <code>postURL()</code> method of this <code>CheckoutView</code>.
	 * @param {String} postURL The new value for <code>postURL</code>.
	 * @see UI.CheckoutView#getPostURL
	 * @status Android
	 * @function
	 */
	/**
	 * @name UI.CheckoutView#getPostURL
	 * @description Retrieve the value returned by the <code>postURL()</code> method of this <code>CheckoutView</code>.
	 * @returns {String} The current value of <code>postURL</code>.
	 * @see UI.CheckoutView#setPostURL
	 * @status Android
	 * @function
	 */
	CheckoutView.registerAccessors('postURL', null, Commands.loadPostURL);
	/**
	 * @name UI.CheckoutView#setGetURL
	 * @description Set the value returned by the <code>getURL()</code> method of this <code>CheckoutView</code>.
	 * @param {String} getURL The new value for <code>getURL</code>.
	 * @see UI.CheckoutView#getGetURL
	 * @status Android
	 * @function
	 */
	/**
	 * @name UI.CheckoutView#getGetURL
	 * @description Retrieve the value returned by the <code>getURL()</code> method of this <code>CheckoutView</code>.
	 * @returns {String} The current value for <code>getURL</code>.
	 * @see UI.CheckoutView#setGetURL
	 * @status Android
	 * @function
	 */
	CheckoutView.registerAccessors('getURL', null, Commands.loadGetURL);
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/Spinner'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/Spinner'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/Spinner'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var Spinner = exports.Spinner = AbstractView.subclass(
/** @lends UI.Spinner.prototype */
{
	'type':'spinner',
	
	/**
	* @class The <code>Spinner</code> class constructs objects that handle menu spinners in a user interface. 
	* @name UI.Spinner
	* @augments UI.AbstractView
	*/
	initialize: function($super, properties) {
		if (Spinner._init) Spinner._init();
		return $super(properties);
	}
});

Spinner._init = function() {
	delete Spinner._init;
	if (AbstractView._init) AbstractView._init();
	
	Spinner.synthesizeProperty('darkStyle', Commands.setDarkStyle);
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/ProgressBar'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/ProgressBar'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/ProgressBar'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;
var WindowR = require('NGCore/Client/UI/Window');

var ProgressBar = exports.ProgressBar = AbstractView.subclass(
/** @lends UI.ProgressBar.prototype */
{
	'type':'progressbar',

    /**
     * @class <code>ProgressBar</code> constructs a horizontal bar that gives a finite indication of progress.
     * @constructs The default constructor. 
     * @param $super This parameter is stripped out during execution. Do not supply it.
     * @param {String} properties
     * @augments UI.AbstractView
     */
    initialize: function($super, properties) {
		if (ProgressBar._init) ProgressBar._init();
        return $super(properties);
    },

	useForUpdateProgress: Commands.useForUpdateProgress,
});

ProgressBar._init = function() {
	delete ProgressBar._init;
	if (AbstractView._init) AbstractView._init();

	/**
	 * @name UI.ProgressBar#getProgressGradient
	 * @description Retrieve the <code>progressGradient</code> for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {Object} The current progressGradient for the specified view state.<br>
	 * @see UI.ProgressBar#setProgressGradient
	 * @status Javascript, Android
	 * @function
	 */
	/**
	 * @name UI.ProgressBar#setProgressGradient
	 * @description Set a progressGradient for a view state.
	 * @see UI.ProgressBar#getProgressGradient
	 * @param {Object} progressGradientURL The new progressGradient.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @status Android
	 * @function 
	 */
	ProgressBar.synthesizePropertyWithState('progressGradient', Commands.setProgressGradient);
	/**
	 * @name UI.SecondaryBar#getSecondaryGradient
	 * @description Retrieve the <code>secondaryGradient</code> for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {Object} The current secondaryGradient for the specified view state.<br>
	 * @see UI.SecondaryBar#setSecondaryGradient
	 * @status Javascript, Android
	 * @function
	 */
	/**
	 * @name UI.SecondaryBar#setSecondaryGradient
	 * @description Set a secondaryGradient for a view state.
	 * @see UI.SecondaryBar#getSecondaryGradient
	 * @param {Object} secondaryGradientURL The new secondaryGradient.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @status Android
	 * @function 
	 */
	ProgressBar.synthesizePropertyWithState('secondaryGradient', Commands.setSecondaryGradient);
	
	/**
	 * @name UI.ProgressBar#getProgress
	 * @description Retrieve the value of the <code>progress</code> properties.
	 * @returns {Array} The current values of <code>progress</code> and <code>secondaryProgress</code>.<br>
	 * @see UI.ProgressBar#setProgress
	 * @status Javascript, Android
	 * @function
	 */
	/**
	 * @name UI.ProgressBar#setProgress
	 * @description Set the values of the <code>progress</code> properties.
	 * @see UI.ProgressBar#getProgress
	 * @param {Number} progress The new value for <code>progress</code>, as a decimal Number between 0.0 and 1.0.
	 * @param {Number} secondaryProgress The new value for <code>secondaryProgress</code>, as a decimal Number between 0.0 and 1.0.
	 * @status Javascript, Android
	 * @function
	 */
	var setProgressGuarded = function(arg0) {
		var args = (arg0 instanceof Array) ? arg0 : Array.prototype.slice.call(arguments);
		while (args.length < 2) args.push(0);
		Commands.setProgress.apply(this, args);
	}
	ProgressBar.synthesizeCompoundProperty('progress', setProgressGuarded);
	
	// helpers for legacy support... Bind full properties to a single state of another.
	var states = {
		'focused': Commands.State.Focused,
		'pressed': Commands.State.Pressed,
		'selected': Commands.State.Focused,
		'highlighted': Commands.State.Pressed,
		'disabled': Commands.State.Disabled,
	};

	function bindStateProperties(propName) {
		var doSynthesis = function(propName, stateName, stateFlags) {
			var getterFn = function() {
				return this._getters[propName].call(this, stateFlags);
			}
			var setterFn = function(val) {
				return this._setters[propName].call(this, val, stateFlags);
			}
			var thisStatePropName = stateName + propName.charAt(0).toUpperCase() + propName.substr(1);
		//	NgLogD("Synthesizing Button." + thisStatePropName + " as getters[" + propName + "][" + stateFlags + "]");
			ProgressBar.registerAccessors(thisStatePropName, getterFn, setterFn,
				"Use " + propName + " accessors with a final state parameter instead.");
		}
		for (var stateName in states) {
			if (!states.hasOwnProperty(stateName)) continue;
			doSynthesis(propName, stateName, states[stateName]);
		}
	};

	bindStateProperties('progressGradient');
	bindStateProperties('secondaryGradient');
	bindStateProperties('gradient');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/MapView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/MapView'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/MapView'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;
var MapAnnotation = require('NGCore/Client/UI/MapAnnotation').MapAnnotation;

var MapView = exports.MapView = AbstractView.subclass(
/** @lends UI.MapView.prototype */
{
	'type':'mapview',
	/**
	* @class <code>MapView</code>
	* @name UI.MapView
	* @augments UI.View
	*/
	initialize: function($super, properties) {
		this._annotations = [];
		this._region = [];
		return $super(properties);
	},
	
	getCenterCoordinate: function()
	{
		return [this._region[0], this._region[1]];
	},
    
    setCenterCoordinate: function(lat, lon, animated)
    {
        this._region[0] = lat;
        this._region[1] = lon;
        if (!this._region[2])
            this._region[2] = 0.05;
        if (!this._region[3])
            this._region[3] = 0.05;            
        this.setRegion(this._region[0], this._region[1], this._region[2], this._region[3], animated);
    },
	
	getCoordinateSpan: function()
	{
		return [this._region[2], this._region[3]];
	},	
	
	selectAnnotation: function(annotation)
	{
		if (annotation instanceof MapAnnotation) {
			var index = this._annotations.indexOf(annotation);
			if (index != -1) {
				Commands.selectAnnotation.call(this, annotation.__objectRegistryId);
				return;
			}
		}
		Commands.selectAnnotation.call(this, -1);
	},
	
	addAnnotation: function(annotation)
	{
		if (annotation instanceof MapAnnotation) {
			this._annotations.push(annotation);
			
			Commands.addAnnotation.call(this, annotation.__objectRegistryId);
			
		} else throw {message: this.type + ".addAnnotation: " + annotation + " is not a MapAnnotation!"};
		return this;
	},
	
	removeAnnotation: function(annotation)
	{
		if (annotation instanceof MapAnnotation) {
			// Remove this node from parent's child list
			var index = this._annotations.indexOf(annotation);
			if (index != -1) {
				this._annotations.splice(index, 1);
			}
			
			// Remove from the parent at the system level
			Commands.removeAnnotation.call(this, annotation.__objectRegistryId);
		} else throw {message: this.type + ".removeAnnotation: " + annotation + " is not a MapAnnotation!"};
		return annotation;
	},
	
	/**
	 * @private
	 */    
	updateRegionFits: function(lat, lon ,latD , lonD) {
		//console.log(lat + " " + lon + " " + latD + " " + lonD);
		//console.log(this._region[0] + " " + this._region[1] + " " + this._region[2] + " " + this._region[3]);
		this._region[0] = lat;
		this._region[1] = lon;
		this._region[2] = latD;
		this._region[3] = lonD;
	},
	
	/**
	 * @private
	 */    
	performEventCallback: function($super, e) {
		if (e.eventType == 'regionchange') this.updateRegionFits(e.latitude, e.longitude , e.latitudeDelta , e.longitudeDelta);
		$super(e);
	}
});

// Properties
(function() {
	MapView.synthesizeProperty('scrollable', Commands.setScrollable);
	
	MapView.synthesizeProperty('zoomable', Commands.setZoomable);
	
	MapView.synthesizeCompoundProperty('region', Commands.setRegion);
	
	MapView.registerEventType('regionchange');
})();
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/MapAnnotation'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/MapAnnotation'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/MapAnnotation'] = exports; var Element = require('NGCore/Client/UI/Element').Element;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var MapAnnotation = exports.MapAnnotation = Element.subclass(
/** @lends UI.MapAnnotation.prototype */
{
	'type':'mapannotation',
	/**
	* @class <code>MapAnnotation</code>
	* @name UI.MapAnnotation
	* @augments Core.Class
	*/
	initialize: function($super, properties) {
		return $super(properties);
	},

	setCalloutLeftView: function(view)
	{
		this._calloutLeftView = view;
		Commands.setCalloutLeftView.call(this, view.__objectRegistryId);
	},

	getCalloutLeftView: function()
	{
		return this._calloutLeftView;
	},

	setCalloutRightView: function(view)
	{
		this._calloutRightView = view;
		Commands.setCalloutRightView.call(this, view.__objectRegistryId);
	},

	getCalloutRightView: function()
	{
		return this._calloutRightView;
	},

	setView: function(view)
	{
		this._view = view;
		Commands.setView.call(this, view.__objectRegistryId);
	},

	getView: function()
	{
		return this._view;
	},

	setImage: function(image)
	{
		console.log("WARNING : MapAnnotation.setImage has been deprecated. Use MapAnnotation.setView instead.");
		var iV = new UI.Image();
		iV.setImage(image);
		iV.setFrame([0, 0, 40, 40]);
		this.setView(iV);
	},

	/**
	 * @private
	 */    
	performEventCallback: function($super, e) {
		$super(e);
	}
});

// Properties
(function() {

	MapAnnotation.synthesizeCompoundProperty('coordinate', Commands.setCoordinate);
	
	MapAnnotation.synthesizeCompoundProperty('centerOffset', Commands.setCenterOffset);
	
	MapAnnotation.synthesizeProperty('calloutTitle', Commands.setCalloutTitle);

	MapAnnotation.synthesizeProperty('calloutSubtitle', Commands.setCalloutSubtitle);
	
	MapAnnotation.synthesizeProperty('calloutEnabled', Commands.setCalloutEnabled);

	MapAnnotation.registerEventType('select');
	MapAnnotation.registerEventType('deselect');
})();
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Analytics'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Analytics'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Analytics'] = exports; var Class = require('NGCore/Client/Core/Class').Class,
NgPipe = require('NGCore/Shared/NgPipe').NgPipe,
NgPipesRemote = require('NGCore/Shared/NgPipesRemote').NgPipesRemote;

var Analytics = Class.singleton(
/** @lends Core.Analytics.prototype */
{
    classname: 'Analytics',

    /**
     * @class The <code>Analytics</code> class serves as the custom messaging channel to the ngCore platform. 
     * The <code>Analytics</code> class provides developers with a way to keep track of game-specific items that require analysis and counting.
     * Use this class when you need your games to send custom elements that require in-game analytics support. 
     * @constructs The default constructor for setting up the NgPipe.
     * @augments Core.Class
     * @param {Boolean} [sendToRemote=true] Set <code>sendToRemote</code> to <code>true</code> to send analytics data to a remote server.
     * @param {String} [analyticsServer=ngmoco analytics server] A custom analytics server.
     * @private
     */
    initialize: function() {
        if (!this._pipe) {
          this._pipe = new NgPipe();
        }
    },

	/** @private */
	updateGLEXT: function()
	{
		try
		{
			var caps = require('NGCore/Client/Core/Capabilities').Capabilities;
			var ext = caps.getOglExtensions();
			if (ext.length > 2)	// > 2 means we got some actual data, not our fake string
			{
				// We need to rip out just one of the four tex compressions we want.
				var list = [];
				var goodies =
				[
					"GL_IMG_texture_compression_pvrtc",
					"GL_AMD_compressed_ATC_texture",
					"GL_OES_compressed_ETC1_RGB8_texture",
					"GL_AMD_compressed_3DC_texture"
				];
				for (var i in goodies)
				{
					var item = goodies[i];
					for (var j in ext)
					{
						if (ext[j] ===  item)
						{
							var rep = {};
							rep[caps.getDeviceName()] = item;
							list.push(rep);
						}
					}
				}

				for (i in list)
				{
					Analytics.reportGameEvent("openglexts", list[i]);
				}
			}
		}
		catch (e)
		{
			NgLogException(e);
		}
	},

    /** @private */
    enable: function() {
        this._pipe.enable();
    },

    /** @private */
    disable: function() {
        this._pipe.disable();
    },

    /** @private */
    setUrl: function(url) {
        this._pipe.setRemoteUrl(url);
    },

    /**
    * Report a navigation event that occurs when users navigate between application pages. 
    * Calling this function will alert the analytics platform that a user has generated a navigation event.
    * This information is used to plot how users move through the game, how long they spend on a page, and what page they navigate to next.
    *
    * @param {String} from The name of the page from which navigation originates. 
    * @param {String} to An analytics name for the destination page.
    * @param {String} btnid The ID of the button that triggered the navigation.
    */
    reportNavigation : function(from, to, btnid) {
        if (!(from && to)) {
            return false;
        }
        this._pipe.uiEvent('NAV', {to: to, fro: from, btnid: btnid} );
        return true;
    },
    /**
    * Report a custom game event. Use this when something in your game happens that you want to know about, 
    * but does not change the user's core stats.<br><br>
    * <b>Note:</b> This function serves as a catch-all. If you need your game to count or analyze something that does not fit into any 
    * other category, use this call.
    * 
    * @param {String} eventId The ID for the custom event.
    * @param {Object} payload A hash of extra information.
    * @param {Object} playerState A hash of important player states.
    */
    reportGameEvent : function(eventId, payload, playerState ) {
        if (!eventId) {
            return false;
        }

        this._pipe.gameEvent(eventId, payload, playerState);

        return true;
    },
    /**
    * Report a change to a playerstate. A playerstate is the object representation of the player's core stats. 
    * For example, if a player purchased an in-game item, you would call this to let the analytics system know what happened and how much gold was spent.
    * Everything in the player state is counted and recorded. Make sure to only pass in things for which you want to see the change 
    * (gold, mojo, grow, level, xp, health, lives, and so on).
    * <b>Note:</b> This is only for game state and should not include information that is unique to a user. For example, the user game tag or the user ID.
    *
    * @param {String} action The product ID of a purchased product. This essentially points out when an action is performed.
    * @param {Object} change A hash of currencies spent and/or gained. For example {mojo: 100, gold:-10}
    * @param {Object} playerState A hash of important player states after the purchase.
    */
    reportPlayerStateChange : function(action, change,  playerState) {
        if (action) {
            this._pipe.playerEvent(action, 'PLSTCHANGE', change, playerState);
            return true;
        } else {
            return false;
        }
    },

    /**
    * Report when a user reaches a new stage of a funnel. Funnel refers to a set of pages or requirements a user is required to engage in before proceeding. 
    * You can use this call to keep track of progress for all users. For example, keeping track of various stages users engage in for game registration.
    * Funnel stages are ordered by numeric ID. The funnel <code>stageName</code> is used for display. You do not need to define funnels ahead of time.
    * Funnel stages start at 0 and increase as the user proceeds further.<br><br>
    * <b>Note:</b> Calling <code>reportFunnelStage()</code> multiple times for a single user generates an incorrect count.
    *
    * @param {String} funnelName The name of the funnel that the user has progressed to.
    * @param {Number} funnelStage The integer value of the stage that the user reached.
    * @param {String} stageName The name of the stage that the user reached.
    * @param {Object} playerState A hash of important player states after a funnel stage.
    * @private
    */
    reportFunnelStage : function(funnelName, funnelStage, stageName, playerState) {
        var payload =  {};

        if (!(funnelName)) {
            return false;
        }
        if (funnelStage !== null && funnelStage !== undefined) {
            payload.stage = funnelStage;
        } else {
            return false;
        }

        if (stageName) {
            payload.stageName = stageName;
        }
        this._pipe.funnelEvent(funnelName, payload, playerState);

        return true;
    },
    /**
     * Report an interaction between two users.
     *
     * @param {String} actionId The action that the user is performing to interact with the other user
     * @param {String} friendGamerTag The other user with whom the current user is interacting.
     * @param {Object} payload A hash of extra information
     */
    reportSocialEvent: function(actionId, friendGamerTag, payload) {
        if (actionId && actionId.length && friendGamerTag && friendGamerTag.length ) {
            this._pipe.socialEvent(actionId, friendGamerTag, payload);
            return true;
        }
        return false;
    },
    /**
    * Report an error to analytics.
    *
    * @param {String} error_msg The error message to log.
    */
    reportError : function(error_msg) {
        if (!error_msg) {
            return false;
        }
        this._pipe.gameOpsEvent("ERR", {err: error_msg } );
        return true;
    },
    /**
     * @private
     */
    addTag: function(tag) {
        if (tag) {
            var evpl = {tag:tag};
            this._pipe.gameEvent('tag', evpl);
            return true;
        }
        return false;
    },
    /** @private */
    _getPipe: function() {
        return this._pipe;
    },
    /**
    * Game Service running inside privileged interpreter may use this method
    * to change the Social Analytic object to be used.  Please see MOBWEST-2300
	* for details
	*
    * @private
    */
	_setNgPipeSocialAnalytics: function(socialAnalyticObj) {
		if (this._pipe) {
			this._pipe._setSocialAnalytics(socialAnalyticObj);
		}
	}
});
exports.Analytics = Analytics;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Color'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Color'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Color'] = exports; exports.Color = require('NGCore/Shared/Color').Color;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Vector'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Vector'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Vector'] = exports; exports.Vector = require('NGCore/Shared/Vector').Vector;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Point'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Point'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Point'] = exports; exports.Point = require('NGCore/Shared/Point').Point;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Size'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Size'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Size'] = exports; exports.Size = require('NGCore/Shared/Size').Size;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Rect'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Rect'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Rect'] = exports; exports.Rect = require('NGCore/Shared/Rect').Rect;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/MessageEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/MessageEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/MessageEmitter'] = exports; exports.MessageEmitter = require('NGCore/Shared/MessageEmitter').MessageEmitter;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/MessageListener'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/MessageListener'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/MessageListener'] = exports; exports.MessageListener = require('NGCore/Shared/MessageListener').MessageListener;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/ObjectRegistry'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/ObjectRegistry'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/ObjectRegistry'] = exports; var Class = require('NGCore/Client/Core/Class').Class;

exports.ObjectRegistry = Class.singleton(
{
	classname: 'ObjectRegistry',
		
	/** @private @class @status */
	initialize: function()
	{
		this._currentId = 0;
		this._guardId = 0;
		this._objects = {};
	},
	
	/** @status */
	register: function(obj)
	{
		if(obj.__objectRegistryId)
			throw new Error('ObjectRegistry.register: object already registered');
			
		var id = "" + ++this._currentId;
		obj.__objectRegistryId = id;
		this._objects[id] = obj;
	},
	
	/** @status */
	unregister: function(obj)
	{
		if(!obj.__objectRegistryId)
			throw new Error('ObjectRegistry.unregister: object not registered');
			
		var id = obj.__objectRegistryId;
		obj.__objectRegistryId = 0;
		delete this._objects[id];
	},
	
	/** @status */
	isObjectRegistered: function(obj)
	{
		if(obj.__objectRegistryId)
			return true;
		else
			return false;
	},
	
	/** @status */
	isIdRegistered: function(id)
	{
		if(this._objects[id])
			return true;
		else
			return false;
	},
	
	/** @status */
	objectToId: function(obj)
	{
		var id = obj.__objectRegistryId;
		
		if(!id)
			throw new Error('ObjectRegistry.objectToId: object not registered');
		
		return id;
	},
	
	/** @status */
	idToObject: function(id)
	{
		return this._objects[id];
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Time'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Time'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Time'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class Time
//
// Copyright (C) 2011 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


var Class = require('NGCore/Client/Core/Class').Class;
var Proc = require('NGCore/Client/Core/Proc').Proc;

var Time = Class.singleton(
/** @lends Core.Time.prototype */
{
	classname: 'Time',
	mFrameTime: 0,
	mFrameDelta: 0,

	/**
	 * @class the <code>Time</code> class constructs objects that provide access to the system clock and system timings for a device.
	 * @status iOS, Android, Flash
	 * @constructs The default constructor. 
	 * @augments Core.Class
	 */
	initialize: function()
	{
	},

	/**
	 * Return the timestamp for the current time frame (expressed in milliseconds).
	 * @returns {Number} The timestamp for the current time frame.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getFrameTime: function()
	{
		return this.mFrameTime;
	},

	/**
	 * Return the delta time in milliseconds since the last time frame.
	 * @returns {Number} The delta time since the last time frame.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getFrameDelta: function()
	{
		return this.mFrameDelta;
	},

	/**
	 * Return the real-time clock in milliseconds. 
	 * <b>Note:</b> This differs from the time frame timestamp, which is constant for the entire time frame.
	 * @returns {Number} The real-time clock.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getRealTime: function()
	{
		return (new Date()).getTime();
	},

	$_frameTimeRecv: function( cmd )
	{
		var o = {};
		this._frameTimeRecvGen(cmd, o);

		this.mFrameDelta = this.mFrameTime ? o.time - this.mFrameTime : 1;
		this.mFrameTime = o.time;
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 351
	// Method frameTime = -1
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Proc.parseInt( cmd.shift(), 10 );
			var instance = ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Time._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				case -1:
					Time._frameTimeRecv( cmd );
					break;
				default:
					NgLogE("Unknown static method id " + cmdId + " in Time._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[351] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	$_frameTimeRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in Time.frameTime from command: " + cmd );
			return false;
		}
		
		obj[ "time" ] = Proc.parseInt( cmd[ 0 ] );
		if( obj[ "time" ] === undefined )
		{
			NgLogE("Could not parse time in Time.frameTime from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $_frameTimeRecv: function( cmd ) {}

// {{/Wg Generated Code}}

});

exports.Time = Time;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/toMD5'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/toMD5'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/toMD5'] = exports; exports.toMD5 = require('NGCore/Shared/Lib/md5').toMD5;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/SHA1'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/SHA1'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/SHA1'] = exports; var sha1 = require('NGCore/Shared/Lib/sha1');

exports.SHA1 = {
	b64_hmac_sha1: sha1.b64_hmac_sha1,
	hex_sha1: sha1.hex_sha1,
	b64_sha1: sha1.b64_sha1
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/UpdateEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/UpdateEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/UpdateEmitter'] = exports; var MessageEmitter = require('NGCore/Client/Core/MessageEmitter').MessageEmitter;
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var Proc = require('NGCore/Client/Core/Proc').Proc;
var Time = require('NGCore/Client/Core/Time').Time;

exports.UpdateEmitter = MessageEmitter.singleton(
/** @lends Core.UpdateEmitter.prototype */
{
	classname: 'UpdateEmitter',
		
	/**
	 * @class The <code>UpdateEmitter</code> module constructs a singleton object that emits every frame with the delta in milliseconds since the last frame.<br><br>
	 * <b>Note:</b> <code>{@link Core.UpdateEmitter#setTickRate}</code> is also used to define the framerate of any animation reproduced by a sprite 
	 * (see <code>{@link GL2.Sprite#setAnimation}</code>).
	 * @constructs The default constructor. 
	 * @augments Core.MessageEmitter
	 * @status iOS, Android, Flash
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		
		this.__clubObject = new NgEngineEntity();
		this.__clubObject.mIsUpdatable = true;
		this.__clubObject.onUpdate = this._emitTime.bind(this);
		this.__clubObject.register();
		
		this._createSendGen(this.__objectRegistryId);
	},
	
	_emitTime: function()
	{
		this.emit(Time.getFrameDelta());
	},
	/**
	 * Set the tick rate that this <code>UpdateEmitter</code> object uses to send updates.<br><br>
	 * <b>Example:</b> Calling <code>setTickRate(15)</code>, any <code>MessageListener</code> objects that are listening 
	 * to the <code>UpdateEmitter</code> receive messages 15 times a second.	 
	 * @param {Number} r The new tick rate.
	 * @see GL2.Sprite
	 * @status iOS, Android, Flash
	 */
	setTickRate: function( r ) 
	{
		this._setTickRateSendGen(r);
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 304
	// Method create = -1
	// Method setTickRate = 2
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Proc.parseInt( cmd.shift(), 10 );
			var instance = ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in UpdateEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in UpdateEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[304] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Proc.appendToCommandString( ":304,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_setTickRateSendGen: function( rate )
	{
		Proc.appendToCommandString( ":304,2," + this.__objectRegistryId + "," + rate  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// setTickRate: function( rate ) {}
	

// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Proc'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Proc'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Proc'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class Proc
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var Class = require('NGCore/Client/Core/Class').Class;
var Base64 = require('NGCore/Client/Core/Base64').Base64;

////////////////////////////////////////////////////////////////////////////////

exports.Proc = Class.singleton(
{
	classname: 'Proc',
	
	initialize: function()
	{
		this._commandString = "";
	},
	
	appendToCommandString: function( str )
	{
		this._commandString += str;
	},
	
	getCommandString: function()
	{
		return this._commandString;
	},
	
	clearCommandString: function ()
	{
		this._commandString = "";
	},
	
	parseBool: function( v )
	{
		return v == 1 ? true : false;
	},

	parseInt: function( v )
	{
		return parseInt( v, 10 );
	},
	
	parseFloat: function( v )
	{
		return parseFloat( v );
	},
	
	parseString: function( v )
	{
		return Base64.decode( v );
	},
	
	parseJSONString: function( v )
	{
		return JSON.parse( Base64.decode( v ) );
	},

	setPrivileged: function()
	{
		this._privileged = true;
	},

	isPrivileged: function()
	{
		return this._privileged ? true : false;
	},

// {{?Wg Generated Code}}
	_classRecvGen: function( cmd )
	{
		var classId = parseInt( cmd.shift(), 10 );
		
		var handler = PROC_DISPATCH_TABLE[classId];
		if(handler)
		{
			handler(cmd);
		}
		else
		{
			NgLogE( "Unknown class id " + classId + " in _classRecvGen" );
		}
	}
// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/_LocalGameList'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/_LocalGameList'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/_LocalGameList'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class _LocalGameList
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var Class = require('NGCore/Client/Core/Class').Class;
var Proc = require('NGCore/Client/Core/Proc').Proc;
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var Capabilities = require('NGCore/Client/Core/Capabilities').Capabilities;
var Time = require('NGCore/Client/Core/Time').Time;
var toMD5 = require('NGCore/Client/Core/toMD5').toMD5;
var Util = require('NGCore/Client/Network/Util').Util;
var Base64 = require('NGCore/Client/Core/Base64').Base64;

////////////////////////////////////////////////////////////////////////////////

exports._LocalGameList = Class.singleton (
/** @lends Core._LocalGameList.prototype */
{
	classname: '_LocalGameList',

	/**
	 * Function.
	 * @constructs
	 * @augments Core.Class
	 */
	initialize: function()
	{
		ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);

		this.mGameList = [];
		var Storage = require('NGCore/Client/Storage').Storage;
		this.mFile = Storage.FileSystem;
		this.mGameStore = Storage.KeyValueCache.global("Core.GameList");

		this.mLoadingGames = {};
		this.mActiveGameKey = "activeGames";
		this.mRequiredAvailableSpace = 0;
		this.mSpaceAvailable = 0;
		this.mSpaceFreeCallbacks = [];
		this._firstBootGameLaunch = true;

		this._getRepoSpaceSendGen();

		this._setStage(this.ProgressStage.BootFirst);
		this._reloadGameList();
	},
	
	ProgressStage:
	{
		BootFirst: {},
		BootSecond: {},
		GameWithoutSecond: {},
		GameWithSecond: {},
		Regular: {}
	},
	
	_setStage: function(stage)
	{
		this._progressStage = stage;
		switch(stage)
		{
			case this.ProgressStage.BootFirst:
				console.log('setStage BootFirst');
				this._progressMin = 0;
				this._progressRange = 0.25;
				break;
			case this.ProgressStage.BootSecond:
				console.log('setStage BootSecond');
				this._progressMin = 0.25;
				this._progressRange = 0.25;
				break;
			case this.ProgressStage.GameWithoutSecond:
				console.log('setStage GameWithoutSecond');
				this._progressMin = 0.25;
				this._progressRange = 0.75;
				break;
			case this.ProgressStage.GameWithSecond:
				console.log('setStage GameWithSecond');
				this._progressMin = 0.5;
				this._progressRange = 0.5;
				break;
			case this.ProgressStage.Regular:
				console.log('setStage Regular');
				this._progressMin = 0;
				this._progressRange = 1;
				break;
			default:
				console.log('setStage ERROR');
				this._progressMin = 0;
				this._progressRange = 1;
		}
		console.log('min:', this._progressMin, 'range:', this._progressRange);
	},
	
	_nextStage: function()
	{
		switch(this._progressStage)
		{
			case this.ProgressStage.BootFirst:
				this._setStage(this.ProgressStage.GameWithoutSecond);
				break;
			case this.ProgressStage.BootSecond:
				this._setStage(this.ProgressStage.GameWithSecond);
				break;
			case this.ProgressStage.GameWithoutSecond:
				this._setStage(this.ProgressStage.Regular);
				break;
			case this.ProgressStage.GameWithSecond:
				this._setStage(this.ProgressStage.Regular);
				break;
		}
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 303
	// Method create = -1
	// Method updateGame = 2
	// Method updateDone = 3
	// Method getRepoSpace = 4
	// Method repoSpace = 5
	// Method deleteGame = 6
	// Method setUpdateProgress = 7
	// Method pauseUpdate = 8
	// Method resumeUpdate = 9
	// Method cancelUpdate = 10
	// Method updateProgress = 11
	// Method allowBGUpdates = 12
	// Method runGame = 13
	// Method finishGame = 14
	// Method setProgressText = 15
	// Method setSplashVisible = 16
	// Method exceptionForwarded = 17
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Proc.parseInt( cmd.shift(), 10 );
			var instance = ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._updateGameRecv( cmd );
					break;
				case 5:
					instance._repoSpaceRecv( cmd );
					break;
				case 6:
					instance._deleteGameRecv( cmd );
					break;
				case 8:
					instance._pauseUpdateRecv( cmd );
					break;
				case 9:
					instance._resumeUpdateRecv( cmd );
					break;
				case 10:
					instance._cancelUpdateRecv( cmd );
					break;
				case 12:
					instance._allowBGUpdatesRecv( cmd );
					break;
				case 13:
					instance._runGameRecv( cmd );
					break;
				case 14:
					instance._finishGameRecv( cmd );
					break;
				case 17:
					instance._exceptionForwardedRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in _LocalGameList._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in _LocalGameList._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[303] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_updateGameRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in _LocalGameList.updateGame from command: " + cmd );
			return false;
		}
		
		obj[ "url" ] = Proc.parseString( cmd[ 0 ] );
		if( obj[ "url" ] === undefined )
		{
			NgLogE("Could not parse url in _LocalGameList.updateGame from command: " + cmd );
			return false;
		}
		
		obj[ "id" ] = Proc.parseInt( cmd[ 1 ] );
		if( obj[ "id" ] === undefined )
		{
			NgLogE("Could not parse id in _LocalGameList.updateGame from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_repoSpaceRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in _LocalGameList.repoSpace from command: " + cmd );
			return false;
		}
		
		obj[ "space" ] = Proc.parseInt( cmd[ 0 ] );
		if( obj[ "space" ] === undefined )
		{
			NgLogE("Could not parse space in _LocalGameList.repoSpace from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_deleteGameRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in _LocalGameList.deleteGame from command: " + cmd );
			return false;
		}
		
		obj[ "mdFive" ] = Proc.parseString( cmd[ 0 ] );
		if( obj[ "mdFive" ] === undefined )
		{
			NgLogE("Could not parse mdFive in _LocalGameList.deleteGame from command: " + cmd );
			return false;
		}
		
		obj[ "game" ] = Proc.parseString( cmd[ 1 ] );
		if( obj[ "game" ] === undefined )
		{
			NgLogE("Could not parse game in _LocalGameList.deleteGame from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_pauseUpdateRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in _LocalGameList.pauseUpdate from command: " + cmd );
			return false;
		}
		
		obj[ "url" ] = Proc.parseString( cmd[ 0 ] );
		if( obj[ "url" ] === undefined )
		{
			NgLogE("Could not parse url in _LocalGameList.pauseUpdate from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_resumeUpdateRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in _LocalGameList.resumeUpdate from command: " + cmd );
			return false;
		}
		
		obj[ "url" ] = Proc.parseString( cmd[ 0 ] );
		if( obj[ "url" ] === undefined )
		{
			NgLogE("Could not parse url in _LocalGameList.resumeUpdate from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_cancelUpdateRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in _LocalGameList.cancelUpdate from command: " + cmd );
			return false;
		}
		
		obj[ "url" ] = Proc.parseString( cmd[ 0 ] );
		if( obj[ "url" ] === undefined )
		{
			NgLogE("Could not parse url in _LocalGameList.cancelUpdate from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_allowBGUpdatesRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in _LocalGameList.allowBGUpdates from command: " + cmd );
			return false;
		}
		
		obj[ "allow" ] = Proc.parseBool( cmd[ 0 ] );
		if( obj[ "allow" ] === undefined )
		{
			NgLogE("Could not parse allow in _LocalGameList.allowBGUpdates from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_runGameRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in _LocalGameList.runGame from command: " + cmd );
			return false;
		}
		
		obj[ "url" ] = Proc.parseString( cmd[ 0 ] );
		if( obj[ "url" ] === undefined )
		{
			NgLogE("Could not parse url in _LocalGameList.runGame from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_finishGameRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 0 )
		{
			NgLogE("Could not parse due to wrong argument count in _LocalGameList.finishGame from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_exceptionForwardedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in _LocalGameList.exceptionForwarded from command: " + cmd );
			return false;
		}
		
		obj[ "exceptionString" ] = Proc.parseString( cmd[ 0 ] );
		if( obj[ "exceptionString" ] === undefined )
		{
			NgLogE("Could not parse exceptionString in _LocalGameList.exceptionForwarded from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Proc.appendToCommandString( ":303,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_updateDoneSendGen: function( id, error )
	{
		Proc.appendToCommandString( ":303,3," + this.__objectRegistryId + "," + id + "," + Base64.encode( error )  );
	},
	
	/** @private */
	_getRepoSpaceSendGen: function(  )
	{
		Proc.appendToCommandString( ":303,4," + this.__objectRegistryId );
	},
	
	/** @private */
	_setUpdateProgressSendGen: function( progress )
	{
		Proc.appendToCommandString( ":303,7," + this.__objectRegistryId + "," + progress  );
	},
	
	/** @private */
	_updateProgressSendGen: function( url, cur, total, error )
	{
		Proc.appendToCommandString( ":303,11," + this.__objectRegistryId + "," + Base64.encode( url ) + "," + cur + "," + total + "," + ( error ? 1 : 0 )  );
	},
	
	/** @private */
	_setProgressTextSendGen: function( text )
	{
		Proc.appendToCommandString( ":303,15," + this.__objectRegistryId + "," + Base64.encode( text )  );
	},
	
	/** @private */
	_setSplashVisibleSendGen: function( visible )
	{
		Proc.appendToCommandString( ":303,16," + this.__objectRegistryId + "," + ( visible ? 1 : 0 )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _updateGameRecv: function( cmd ) {}
	// updateDone: function( id, error ) {}
	
	// getRepoSpace: function(  ) {}
	
	// _repoSpaceRecv: function( cmd ) {}
	// _deleteGameRecv: function( cmd ) {}
	// setUpdateProgress: function( progress ) {}
	
	// _pauseUpdateRecv: function( cmd ) {}
	// _resumeUpdateRecv: function( cmd ) {}
	// _cancelUpdateRecv: function( cmd ) {}
	// updateProgress: function( url, cur, total, error ) {}
	
	// _allowBGUpdatesRecv: function( cmd ) {}
	// _runGameRecv: function( cmd ) {}
	// _finishGameRecv: function( cmd ) {}
	// setProgressText: function( text ) {}
	
	// setSplashVisible: function( visible ) {}
	
	// _exceptionForwardedRecv: function( cmd ) {}

// {{/Wg Generated Code}}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////
	_updateGameRecv: function( cmd )
	{
		this._getRepoSpaceSendGen();

		var o = {};
		this._updateGameRecvGen(cmd, o);

		if (o.url in this.mLoadingGames)
		{
			this.mLoadingGames[o.url].id = o.id;
			this.mLoadingGames[o.url].dlman.resume();
		}
		else
		{
			this.updateGame(o.url, o.id,
				(function (url, newFiles, err)
				{
					o.id = this.mLoadingGames[url].id;
					this._updateDoneSendGen(o.id, err);
				}).bind(this, o.url)
			);
		}
	},
	mobageRunGame: function (funk)
	{
		this._gameRunner = funk;
	},
	_runGameRecv: function( cmd )
	{
		var o = {};
		this._runGameRecvGen(cmd, o);
		if (this._gameRunner)
		{
			console.log("_LGL running gameRunner " + o.url);
			this._gameRunner(o.url);
		}
		else
		{
			console.log("_LGL running game " + o.url);
			var _int_LGL = require('NGCore/Client/Core/_int_LGL')._int_LGL;
			_int_LGL.launch(o.url, _int_LGL.ProcID.Game);
		}
	},
	/**
	 * set the function that kills the current game app
	 */
	setFinishGameHandler: function(funk)
	{
		this._finishGameHandler = funk;
	},
	_finishGameRecv: function()
	{
		if (this._finishGameHandler)
		{
			this._finishGameHandler();
		} else {
			console.log("_LocalGameList: finishGameHandler is not set");
		}
	},
	_repoSpaceRecv: function( cmd )
	{
		var obj = {};
		this._repoSpaceRecvGen(cmd, obj);
		this.mSpaceAvailable = obj.space;
		console.log("SD card space available(b): " + this.mSpaceAvailable);

		var length = this.mSpaceFreeCallbacks.length;
		while (length--)
		{
			(this.mSpaceFreeCallbacks.pop())();
		}
	},

	_deleteGameRecv: function( cmd )
	{
		// site to calc md5: http://pajhome.org.uk/crypt/md5/
		var allowedGames =
		[
			"http://10.15.", // Allow partial ones, for testing
			'http://gamehub.mobage.com/app/1.0s/gamehub',
			'url of allowed game'
		];

		var obj = {};
		this._deleteGameRecvGen(cmd, obj);
		var i;
		for(i in allowedGames)
		{
			var match = obj.game.match(allowedGames[i]);
			if(match && !match.index)
			{
				NgLogD("Deleting " + obj.mdFive);
				this.deleteGameFiles(obj.mdFive);

				var doneCB = (function ()
				{
					NgLogD("Finished deleting game from " + this.mActiveGameKey + " for " + obj.mdFive );
				}).bind(this);
				this._deleteGameFromStorage(obj.mdFive,doneCB);

				return;
			}
			else
			{
				// for testing, allow any local server starting with 10.15
			}
		}
		NgLogE("_LocalGameList unauthorized call to deleteGame from "+obj.game+"!");
	},

// _deleteGameFromStorage is for deleting the games info from LGL storage, not the game's storage

	_deleteGameFromStorage: function(mdFive,doneCB)
	{
		var self = this;
		this.mGameStore.getItem(this.mActiveGameKey,
			function(error, value)
			{
				var list = JSON.parse(value);
				
				var good = false;
				var ind;
				var out = [];
				for(ind = 0; ind < list.length; ++ind)
				{
					if(list[ind].name == mdFive)
						good = true;
					else
						out.push(list[ind]);
				}
				
				if( good )
				{
					NgLogD("_LocalGameList found and removed " + mdFive);
					self.mGameStore.setItem(self.mActiveGameKey, JSON.stringify(out), doneCB);
				}
				else
				{
					NgLogD("_LocalGameList failed to find and remove " + mdFive);
					doneCB("Could not remove item: " + error);
				}
				
			}, true
		);
	},

	getGameConfig: function(identifier, isMDFive, callBack)
	{
		if (typeof isMDFive == 'function')
		{
			callBack = isMDFive;
			isMDFive = false;
		}

		var folder;
		if (isMDFive)
		{
			folder = identifier;
		}
		else
		{
			var Util = require('NGCore/Client/Network/Util').Util;
			var norm = Util.NormalizeUrl(identifier);
			folder = toMD5(norm);
		}

		this.mFile.readFile(folder + "/" + Capabilities._getConfigFile(),
			function (err, contents)
			{
				var ret = {};
				if (err || !contents)
				{
					console.log("Could not get config from %s! err: %s", identifier, err);
				}
				else
				{
					ret = JSON.parse(contents);
				}
				callBack(ret);
			}
		);
	},

	getRepoSpace: function()
	{
		return this.mSpaceAvailable;
	},

	getConfig: function(gameOrigin, name, callback, failEarly)
	{// callback = function (config, err)
		// XHR
		var XHR = require('NGCore/Client/Network/XHR').XHR;
		var Util = require('NGCore/Client/Network/Util').Util;
		
		var httpStatus = 0;
		
		Util.OperationWithRetries(function(failCb)
		{
			var req = new XHR();
			req.onreadystatechange = function()
			{
				if(req.readyState == 4)
				{
					httpStatus = req.status;
					if(httpStatus == 200)
					{
						// Succes.
						callback(req.responseText);
					}
					else if(httpStatus == 404)
					{
						// File not on server, so load from the regular location
						console.log("no configuration file found at %s, using root server", gameOrigin + name);
						callback( "{}" );
					}
					else
					{
						//Error! Retry
						failCb();
					}
				}
			};

			req.open('GET', gameOrigin + name + Util.getCacheBustingString(), true);
			req.send();
		}, function()
		{
			callback(null, true, httpStatus);
		}, failEarly);
	},

	// gameOrigin: url to folder holding webgame.ngmanifest
	// doneCB = function(totalBytes, error)
	updateGame: function(gameOrigin, id, doneCB, failEarly, failAllowed)
	{
		// console.log ( "LGL.updateGame url = " + gameOrigin );
		// console.log ( "LGL.updateGame boot game = " + Capabilities.getBootGame() );
		
		var re = new RegExp(".*" + Capabilities.getBootGame());
		var match = gameOrigin.match(re);
		
		if (match) 
			this._firstBootGameLaunch = false;
			
		// console.log ( "_LocalGameList.updateGame updating game." );

		// Normalize URL
		var Util = require('NGCore/Client/Network/Util').Util;
		gameOrigin = Util.NormalizeUrl(gameOrigin);
		var name = toMD5(gameOrigin);
		this.mLoadingGames[gameOrigin] = {id: id};

		console.log(gameOrigin + " toMD5: " + name);

		// Get device-specific manifest directory
		var buildPath = {"Android" : "android", "iPhone OS" : "ios", "flash" : ""};
		// Get Device capabilities platformOs
		var caps = require('NGCore/Client/Core/Capabilities').Capabilities;
		var build = "/" + buildPath[caps.getPlatformOS()];

		this._setProgress(0);

		var curContUrl = "";
		var configFile = toMD5(gameOrigin) + "/" + caps._getConfigFile();
		
		// This is guaranteed to be synchronous, so will always occur before the callback for subsequent operations.
		this.mFile.readFile(configFile,
			function(err, data)
			{
				if (data)
				{
					var obj = JSON.parse(data);
					curContUrl = obj.contentUrl;
				}
			}
		);

		this.getConfig(gameOrigin + build, "/" + caps._getConfigFile(),
		(function(config, error, status)
		{
			if (error)
			{
				doneCB(0, error);
				delete this.mLoadingGames[gameOrigin];
			}
			else
			{
				this._setProgress(0.1);

				// Read config
				var parsedConfig = JSON.parse(config);
				if(!parsedConfig.contentUrl)
				{
					parsedConfig.contentUrl = gameOrigin + build;
				}
				else if (parsedConfig.contentUrl == curContUrl)
				{
					// no need to update.
					this._setProgress( 1.0 );
					this._setStage(this.ProgressStage.Regular);
					this.mFile.writeFile(configFile, JSON.stringify(parsedConfig),
						function(err) {console.log(err); } );
					doneCB(0);
					delete this.mLoadingGames[gameOrigin];
					return;
				}

				this._callDownloadManifest(parsedConfig, gameOrigin, name, failEarly, failAllowed, (function(bytes, error)
				{
					this._setProgress( 1.0 );
					this._nextStage();

					if (! error) {
						var that = this;
						this._reloadGameList({name:name, url:gameOrigin}, function()
						{
							if (doneCB && (typeof doneCB == 'function')) {
								doneCB(bytes, error);
								delete that.mLoadingGames[gameOrigin];
							}
						});
					} else {
						doneCB(bytes, error);
						delete this.mLoadingGames[gameOrigin];
					}
				}).bind(this));
			}
		}).bind(this), failEarly);
	},

	_allowBGUpdatesRecv: function( cmd )
	{
		var o = {};
		this._allowBGUpdatesRecvGen(cmd, o);
		this._pauseOrResumeAll(o.allow);
	},

	_pauseOrResumeAll: function(resume)
	{
		for (i in this.mLoadingGames)
		{
			if (resume)
			{
				console.log("Resuming download of " + i);
				this.resumeUpdate(i);
			}
			else
			{
				console.log("Pausing download of " + i);
				this.pauseUpdate(i);
			}
		}
	},

	pauseUpdate: function(url)
	{
		if (this.mLoadingGames[url])
		{
			if(this.mLoadingGames[url].dlman)
			{
				this.mLoadingGames[url].dlman.pause();
				this.mLoadingGames[url].userPause = true;
			}
		}
	},

	_pauseUpdateRecv: function(cmd)
	{
		var o = {};
		this._pauseUpdateRecvGen(cmd, o);
		this.pauseUpdate(o.url);
	},

	resumeUpdate: function(url)
	{
		if (this.mLoadingGames[url])
		{
			if(this.mLoadingGames[url].dlman)
			{
				this.mLoadingGames[url].dlman.resume();
				this.mLoadingGames[url].userPause = false;
			}
		}
	},

	_resumeUpdateRecv: function(cmd)
	{
		var o = {};
		this._resumeUpdateRecvGen(cmd, o);
		this.resumeUpdate(o.url);
	},

	cancelUpdate: function(url)
	{
		if (this.mLoadingGames[url])
		{
			if (this.mLoadingGames[url].dlman) {
                this.mLoadingGames[url].dlman.abort();
            }
			delete this.mLoadingGames[url];

			//Cancel the keep alive request as well
			var LifecycleEmitter = require('NGCore/Client/Device/LifecycleEmitter').LifecycleEmitter;

            this.identification_key = 'manifest_download';
            LifecycleEmitter.cancelEngineKeepAlive(this);
		}
	},

	_cancelUpdateRecv: function(cmd)
	{
		var o = {};
		this._cancelUpdateRecvGen(cmd, o);
		this.cancelUpdate(o.url);
	},

	_setProgress: function (progress) {
		if(progress > 1) progress = 1;
		if(progress < 0) progress = 0;
		progress = progress*this._progressRange + this._progressMin;
		this._setUpdateProgressSendGen(progress);
	},

	listenToProgress: function (listener)
	{
		this._privListener = listener;
	},

	_updateProgress: function(url, prog, total, err)
	{
		//console.log("Updating progress for: %s, %d, %d " + err, url, prog, total);
		if (this._privListener)
			this._privListener(url, prog, total, err);

		if (this.mLoadingGames[url] && this.mLoadingGames[url].id >=0)
			this._updateProgressSendGen(url,prog,total,err);
	},

	// doneCB = function(totalBytes, error)
	_callDownloadManifest: function (config, gameOrigin, name, failEarly, failAllowed, doneCB)
	{
		var contentUrl = config.contentUrl;
		var reportTotalBytes = 0;
		var self = this;
		var Downloader = require('NGCore/Client/Network/DownloadManifest').DownloadManifest;
		
		var manifestName = require('NGCore/Client/Core/_int_LGL')._int_LGL.getManifestName(config);

		// Do download
		(function doDownload()
		{
			var dler = new Downloader();
			dler.mLocalGameList = self;
			var firstProgress = true;
            var LifecycleEmitter = require('NGCore/Client/Device/LifecycleEmitter').LifecycleEmitter;
            this.identification_key = 'manifest_download';
            NgLogD("++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++Manifest Download Request Keep Engine Alive");
            LifecycleEmitter.requestEngineKeepAlive(this);
			// Only allow this on iOS
			config.omitJsUpdate = config.omitJsUpdate && (Capabilities.getPlatformOS() == "iPhone OS");
			dler._setConfig(config);
			dler.start(contentUrl, name, {'webgame.ngmanifest':manifestName}, function(bytesDownloaded, bytesTotal)
			{
				if(firstProgress)
				{
					// First progress callback is made when manifest is downloaded.
					firstProgress = false;
					self._setProgress(0.2);
					reportTotalBytes = bytesTotal;
				}
				else
				{
					self._setProgress(0.3 + 0.6 * (bytesDownloaded / bytesTotal));
				}

				// update LGL
				self._updateProgress(gameOrigin, bytesDownloaded, bytesTotal);
			}, function(error, manifest, wasCached)
			{
				if (failAllowed)
				{
					if (doneCB)
					{
						doneCB(reportTotalBytes, error);
					}
				}
				else if(error)
				{
					NgLogE("Error: " + error);
					// update LGL
					self._updateProgress(gameOrigin, 0, 0, error);
					doneCB(0, error);
				}
				else
				{
					if (doneCB)
					{
						doneCB(reportTotalBytes);
					}
				}

                this.identification_key = 'manifest_download';
                LifecycleEmitter.cancelEngineKeepAlive(this);
			}, false, failEarly);
			self.mLoadingGames[gameOrigin].dlman = dler;
		})();
	},

	freeSpace: function(space, cb)
	{
		this.mRequiredAvailableSpace = space;
		this.mSpaceFreeCallbacks.push(
			(function()
			{
				if (this.mRequiredAvailableSpace > this.mSpaceAvailable)
				{
					if (this._privListener)
					{
						this._privListener("", 0, 0, "SD card is full");
					}
					else
					{
						console.log("Warning!! Mobage is not handling SD card full error!");
						// This is Preservation of ancient code which has and will likely never execute
						var checkAgain = function()
						{
							if (this.mRequiredAvailableSpace > this.mSpaceAvailable)
							{
								this.pruneGames(1);
								this.mSpaceFreeCallbacks.push(checkAgain);
							}
							else
							{
								cb();
							}
						};
						// Is a redundant check on space, but looks better/is simpler/won't ever be used anyhow
						checkAgain();
					}
				}
				else
				{
					cb();
				}
			}).bind(this)
		);

		this._getRepoSpaceSendGen();
	},

	pruneGames: function(number)
	{
		var self = this;

		// Function to put oldest games on top of the stack
		var sort = function (l, r)
		{
			return r.lastRun - l.lastRun;
		};

		this.mGameStore.getItem(this.mActiveGameKey,
			function(error, value)
			{
				var list = JSON.parse(value);
				list.sort(sort);
				while (number-- && (list.length - 1))
				{
					var game = list.pop();

					// Do not delete the currently loading game
					if (!(game.name in self.mLoadingGames))
					{
						// delete game
						self.deleteGameFiles(game.name);
					}
					else
					{
						list.push(game);
					}
				}

				// Save the data
				self.mGameStore.setItem(self.mActiveGameKey, JSON.stringify(list));
			}, true
		);
	},

	deleteGame: function (url, callBack)
	{
		var Util = require('NGCore/Client/Network/Util').Util;
		var norm = Util.NormalizeUrl(url);
		var mdFive = toMD5(norm);

		this.deleteGameFiles(mdFive);
		this._deleteGameFromStorage(mdFive, callBack);
	},

	// Delete the KeyValueCache.local of the given game
	deleteGameKeyValue: function(mdFive)
	{
		var kvm = require('NGCore/Client/Storage').KeyValueCache;
		kvm.global(mdFive).clear();
	},

	deleteGameFiles: function(game)
	{
		var self = this;
		self.mFile.deleteFile( game , 
			function(err)
				{
					if(err == "" )
						NgLogI('Deleted');
					else
						NgLogD("Could not delete game");

					self._getRepoSpaceSendGen();
				});
	},

	getGameList: function()
	{
		return this.mGameList;
	},

	clearWatch: function()
	{
		var fs = require('NGCore/Client/Storage/FileSystem').FileSystem;
		fs.deleteFile(".watch");
	},

	/**
	 * @private
	 */
	_reloadGameList: function(newItem, cb)
	{
		this.mGameStore.getItem(this.mActiveGameKey,
			(function(error, value)
			{
				var list;
				if (value)
					list = JSON.parse(value);
				else
					list = [];

				if (newItem)
				{
					var bNew = true;
					for (var i in list)
					{
						if (list[i].name == newItem.name)
						{
							bNew = false;
							newItem.lastRun = list[i].lastRun;
							list[i] = newItem;
							break;
						}
					}

					if (bNew)
					{
						list.push(newItem);
					}
					this.mGameStore.setItem(this.mActiveGameKey, JSON.stringify(list));
				}

				this.mGameList = list;

				if (typeof cb == 'function')
					cb();
			}).bind(this),
			true
		);
	},

	_getRunningGame: function(callBack)
	{
		// Function to put oldest games on top of the stack
		var sort = function (l, r)
		{
			return r.lastRun - l.lastRun;
		};

		this._reloadGameList(false, (function(cb)
		{
			var list = this.mGameList;
			list.sort(sort);
			var current = null;
			var len = list.length;
			for (var i = 0; i < len; ++i)
			{
				if (list[i].lastRun)
				{
					current = list[i];
					break;
				}
			}
			if (current && current.url)
				cb(current.url);
		}).bind(this, callBack));
	},

	/** @private */
	_pausingGame: function()
	{
		// true to resume download when pausing a game
		this._pauseOrResumeAll(true);
	},

	/** @private */
	_resumingGame: function()
	{
		// Check if the current game allows downloading
		this._getRunningGame((function(game)
		{
			this.getGameConfig(game, (function(config)
			{
				if (config.noBackgroundUpdates)
				{
					// false to pause download when resuming a game
					this._pauseOrResumeAll(false);
				}
			}).bind(this));
		}).bind(this));
	},

	setSplashVisible: function( visible )
	{
		this._setSplashVisibleSendGen(visible);
	},

	setProgressText: function( text )
	{
		this._setProgressTextSendGen(text);
	},

	updateAvailable: function(game, doneCB, errorCB)
	{
		var _int_LGL = require('NGCore/Client/Core/_int_LGL')._int_LGL;
		_int_LGL.updateAvailable(game, doneCB, errorCB);
	},

	/*
	 * Set the exception handler. Default is undefined.
	 * @param {Function} the function that handles the exception occurred in the Game proc. signature: function(exceptionString)
	 */
	setExceptionHandler: function(func)
	{
		this._exceptionHandler = func;
	},

	_exceptionForwardedRecv: function( cmd )
	{
		var obj = {};
		this._exceptionForwardedRecvGen(cmd, obj);
		var exception = JSON.parse(obj.exceptionString);
		
		if (this._exceptionHandler)
			this._exceptionHandler(exception);
		else
			NgLogException(exception);
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/NativeAppLaunch'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/NativeAppLaunch'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/NativeAppLaunch'] = exports; // @deprecated
var NativeAppLaunch;

exports.NativeAppLaunch = NativeAppLaunch;; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/NgPipe'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/NgPipe'] || {}; $MODULE_REGISTRY['NGCore/Shared/NgPipe'] = exports; var Class = require('NGCore/Shared/Class').Class;
var NgPipesRemote = require('NGCore/Shared/NgPipesRemote').NgPipesRemote;
var hex_sha1 = require('NGCore/Shared/Lib/sha1').hex_sha1;
var __hasProp = Object.prototype.hasOwnProperty;
var CapabilitiesReq = require('NGCore/Client/Core/Capabilities');

/*
The NgPipes object
*/

NgPipe = Class.subclass({
    classname: "NgPipe",
    initialize: function(options) {
        options = options || {};
		/*
		 * Note that this require statement cannot be put at the top level
		 * because it will cause code to fail to execute.  It's an intricacy
		 * in our require system.
		 */
		this._socAnalytics = require('NGCore/Client/Social').Social.Common.Analytics;
        this._meta = options.meta || {};
        this._queue = null;
        this._isSendQueued = false;
        this._sendDelay = options.sendDelay || 5000;
        this._meta = options.meta || {};
        this._seqStart = options.seqStart || new Date().getTime();
        this._playerState = options.playerState || null;
        this._seqNumber = options.seqNumber || 0;
        this._allowedLargeValue = {
            msg: 1024 * 5,
            err: 1024 * 5,
            sid: 64,
            udid: 64
        };

        this._sendToRemote = true;
        this._globalKey = '__NgPipeStorage';
        var self = this;
        var cb = function(error,value, key) {
            var new_queue = [];
            if (!error) {
                try {
                    new_queue = JSON.parse(value);
                } catch(e) {
                    new_queue = [];
                }
            }

            if (self._queue) {
                new_queue = self._queue.concat(new_queue);
            }

            self._setQueue(new_queue);
            if (self._queue.length > 0 ){
                self._drainQueue();
            }
        };
        this._locListener = null;
        this._location = null;
        Storage.KeyValueCache.global(this._globalKey).getItem(this._globalKey, cb);
        var starting_queue = [].concat(options.queue || []);
        this._queue = starting_queue;
        this._sessionEnded = false;
        this._capAlphaNumStringKeys = ['afam', 'asku', 'srcty', 'evcl', 'evid', 'pltfmsku','carr','srv'];
        this.sessionStartEvent();
        this._tagQa();
        this._hookLifetime();
        this._hookGeo();
        return true;
    },

    close: function() {
        this._drainQueue();
        return true;
    },

    enable: function() {
        this._sendToRemote = true;
    },

    disable: function() {
        this._sendToRemote = false;
    },

    setRemoteUrl: function(url) {
        NgPipesRemote.setUrl(url);
    },

    playerEvent: function(eventId, evcl, change, playerState) {
        var e;
        evcl || (evcl = "PLST");
        e = {
            change: change,
            srcty: 'GC',
            evid: eventId,
            evcl: evcl,
            plst: this._getPlayerStateDiff(playerState || this._playerState)
        };
        this._queueMessage(e);
        this._setCurrentPlayerState(playerState);
        return e;
    },
    gameEvent: function(eventId, payload, playerState) {
        var e;
        e = {
            evid: eventId,
            evpl: payload,
            srcty: 'GC',
            evcl: 'GAME'
        };

        if (playerState) {
          e.plst = this._getPlayerStateDiff(playerState || this._playerState);
        }
        this._queueMessage(e);
        return e;
    },
    gameOpsEvent: function(eventId, payload) {
        var e;
        e = {
            evid: eventId,
            evpl: payload,
            srcty: 'GC',
            evcl: 'GAMEOPS'
        };
        this._queueMessage(e);
        return e;
    },
    revenueEvent: function(eventId, payload) {
        var e;
        e = {
            evcl: 'REV',
            evid: eventId,
            srcty: 'PC',
            evpl: payload
        };
        this._queueMessage(e);
        return e;
    },
    uiEvent: function(eventId, payload) {
        var e;
        e = {
            evcl: 'UI',
            srcty: 'GC',
            evid: eventId,
            evpl: payload
        };
        this._queueMessage(e);
        return e;
    },
    funnelEvent: function(eventId, payload, playerState) {
        var e;
        e = {
            evcl: 'FUNNEL',
            srcty: 'GC',
            evid: eventId,
            evpl: payload
        };

        if (playerState) {
          e.plst = this._getPlayerStateDiff(playerState || this._playerState);
          this._setCurrentPlayerState(playerState);
        }
        this._queueMessage(e);
        return e;
    },
    plusEvent: function(eventId, payload) {
        var e;
        e = {
            evcl: 'PLUS',
            srcty: 'PC',
            evid: eventId,
            evpl: payload
        };
        this._queueMessage(e);
        return e;
    },
    plusUIEvent: function(eventId, payload) {
        var e = {
            evcl: 'PLUSUI',
            srcty: 'PC',
            evid: eventId,
            evpl: payload
        };
        this._queueMessage(e);
        return e;
    },
    navigationEvent: function(fromScreen, toScreen, buttonID){
        var payload = {};
        payload.fro = fromScreen;
        payload.to  = toScreen;
        if(buttonID){
            payload.btnid = buttonID;
        }

        return this.plusUIEvent("NAV", payload);
    },
    sessionEndEvent: function() {
        if (!(this._sessionEnded)) {
            var e;
            var Capabilities = CapabilitiesReq.Capabilities;

            e = {
                evid:  'SFN',
                evcl:  'PLUS',
                srcty: 'PC',
                hwty:  Capabilities.getDeviceName(), // cat ro.product.manufacturer, ro.product.brandh, ro.product.model
                hwrev: Capabilities.getPlatformHW(), // cat ro.revision + ro.build.date.utc
                osrev: ""+  Capabilities.getPlatformOS() + " " + Capabilities.getPlatformOSVersion(), // ro.build.fingerprint
                lang: Capabilities.getLanguage()
            };

            e = this._queueMessage(e);
            this._sessionEnded = true;
            return e;
        }
        return null;
    },
    sessionStartEvent: function() {
        var e;
        var Capabilities = CapabilitiesReq.Capabilities;

        e = {
            evid:  'SST',
            evcl:  'PLUS',
            srcty: 'PC',
            hwty:  Capabilities.getDeviceName(), // cat ro.product.manufacturer, ro.product.brandh, ro.product.model
            hwrev: Capabilities.getPlatformHW(), // cat ro.revision + ro.build.date.utc
            osrev: ""+  Capabilities.getPlatformOS() + " " + Capabilities.getPlatformOSVersion(), // ro.build.fingerprint
            lang: Capabilities.getLanguage()
        };



        e = this._queueMessage(e);
        return e;
    },
    socialEvent: function(eventId, friendId,  payload) {
        var e;
        e = {
            evcl: 'SOCL',
            srcty: 'GC',
            frid: friendId,
            evid: eventId,
            evpl: payload
        };
        return this._queueMessage(e);
    },
    initPlayerState: function(inState) {
        this._setCurrentPlayerState(inState);
        return true;
    },

    updatePlayerState: function(newState) {
        this._setCurrentPlayerState(newState);
        return true;
    },

    //params for internal IAP events:

    //promo campaign unique identifier
    //promoid (String)

    //price of virtual good
    //price (Float)

    //currency used. Defaults to USD
    //cur (String)

    //user's moba balance after purchase
    //mobabalance (Integer)

    //unique identifier for purchase
    //orderid (String)

    //a string identifier for an item, e.g. "IceCastle"
    //sku (String)

    //the value of the item in moba
    //mobaprice (Float)

    //the quantity of item being purchased
    //itemamt (Float)

    //a text description of the item.
    //desc (String)

    //a message displayed to the user when the debit or credit occurs
    //dispmsg (String)

    //the name of the item, as displayed to the user
    //dispname (String)

    //the Mobage ID for the product.
    //productid (Integer)

    //dynamic data accepts a custom object with any params not included above
    //dynamicdata (Object)

    reportAdShow : function(adid) {
        return this.revenueEvent('ADSHOW',{'adid':adid});      
    },

    reportAdClick : function(adid) {
        return this.revenueEvent('ADCLCK',{'adid':adid});    
    },

    reportPromoShow : function(promoid) {
        return this.revenueEvent('PROMOSHOW',{'promoid':promoid});    
    },

    reportPromoClick : function(promoid) {
        return this.revenueEvent('PROMOCLCK',{'promoid':promoid});    
    },

    reportPromoRedeem : function(promoid) {
        return this.revenueEvent('PROMOREDM',{'promoid':promoid});    
    },

    //user clicks on money sku
    reportMoneyIAPIntent : function(sku,item_amt,price,product_id,display_name,user_end_moba_balance,description,display_message,cur,dynamicdata) {
        var evpl = {
            sku : sku,
            itemamt : item_amt,
            productid: product_id,
            //desc : description,
            dispmsg : display_message,
            dispname : display_name,
            mobabalance : user_end_moba_balance,
            amt : price,
            cur : cur || 'USD'
            };
        dynamicdata ? evpl.dynamicdata = dynamicdata : '';
        return this.revenueEvent('IAPINTENT', evpl);
    },

    //user cancels a money sku transaction
    reportMoneyIAPCancel : function(sku,item_amt,price,product_id,display_name,user_end_moba_balance,description,display_message,cur,dynamicdata) {
        var evpl = {
            sku : sku,
            itemamt : item_amt,
            productid: product_id,
            //desc : description,
            dispmsg : display_message,
            dispname : display_name,
            mobabalance : user_end_moba_balance,
            amt : price,
            cur : cur || 'USD'
            };
        dynamicdata ? evpl.dynamicdata = dynamicdata : '';
        return this.revenueEvent('IAPCANCEL', evpl);
    },

    //money sku transaction is successful; orderid required
    reportMoneyIAPSuccess : function(sku,item_amt,price,orderid,product_id,display_name,user_end_moba_balance,description,display_message,cur,dynamicdata) {
        var evpl = {
            sku : sku,
            itemamt : item_amt,
            orderid : orderid,
            productid: product_id,
            //desc : description,
            dispmsg : display_message,
            dispname : display_name,
            mobabalance : user_end_moba_balance,
            amt : price,
            cur : cur || 'USD'
            };
        dynamicdata ? evpl.dynamicdata = dynamicdata : '';
        return this.revenueEvent('IAPSUCCESS',evpl);
    },

    //money iap purchase fails after being authorized by user; orderid optional if available, pass in null otherwise
    reportMoneyIAPFail : function(sku,item_amt,price,orderid,product_id,display_name,user_end_moba_balance,description,display_message,cur,dynamicdata) {
        var evpl = {
            sku : sku,
            itemamt : item_amt,
            productid: product_id,
            //desc : description,
            dispmsg : display_message,
            dispname : display_name,
            mobabalance : user_end_moba_balance,
            amt : price,
            cur : cur || 'USD'
            };
        orderid ? evpl.orderid = orderid : "";
        dynamicdata ? evpl.dynamicdata = dynamicdata : '';
        return this.revenueEvent('IAPFAIL', evpl);
    },

    //user opens money IAP store
    reportMoneyIAPShow : function() {
        return this.revenueEvent('IAPSHOW',{});
    },

    //user opens moba IAP store
    reportMobaIAPShow : function() {
        return this.revenueEvent('MOBAIAPSHOW',{});
    },

    //user clicks on a moba sku
    reportMobaIAPIntent : function(sku,moba_price,product_id,display_name,user_end_moba_balance,description,display_message,dynamicdata) {
        var evpl = {
            sku : sku,
            mobaprice : moba_price,
            productid : product_id,
            //desc : description,
            dispmsg : display_message,
            dispname : display_name,
            mobabalance : user_end_moba_balance
            };
        dynamicdata ? evpl.dynamicdata = dynamicdata : '';
        return this.revenueEvent('MOBAIAPINTENT', evpl);
    },

    //user cancels moba sku transaction
    reportMobaIAPCancel : function(sku,moba_price,product_id,display_name,user_end_moba_balance,description,display_message,dynamicdata) {
        var evpl = {
            sku : sku,
            mobaprice : moba_price,
            productid : product_id,
            //desc : description,
            dispmsg : display_message,
            dispname : display_name,
            mobabalance : user_end_moba_balance
            };
        dynamicdata ? evpl.dynamicdata = dynamicdata : '';
        return this.revenueEvent('MOBAIAPCANCEL', evpl);
    },

    //moba sku transaction is successful. orderid required. 
    reportMobaIAPSuccess : function(sku,moba_price,orderid,product_id,display_name,user_end_moba_balance,description,display_message,dynamicdata) {
        var evpl = {
            sku : sku,
            mobaprice : moba_price,
            orderid : orderid,
            productid : product_id,
            //desc : description,
            dispmsg : display_message,
            dispname : display_name,
            mobabalance : user_end_moba_balance
            };
        dynamicdata ? evpl.dynamicdata = dynamicdata : '';
        return this.revenueEvent('MOBAIAPSUCCESS', evpl);
    },

    //moba sku purchase fails after being authorized by user. orderid optional if available, pass in null otherwise
    reportMobaIAPFail : function(sku,moba_price,orderid,product_id,display_name,user_end_moba_balance,description,display_message,dynamicdata) {
        var evpl = {
            sku : sku,
            mobaprice : moba_price,
            productid : product_id,
            //desc : description,
            dispmsg : display_message,
            dispname : display_name,
            mobabalance : user_end_moba_balance
            };
        orderid ? evpl.orderid = orderid : '';
        dynamicdata ? evpl.dynamicdata = dynamicdata : '';
        return this.revenueEvent('MOBAIAPFAIL', evpl);
    },

    /**
    * Report us scraping a facebook user's profile - ext_id is the user's facebook ID.
    *
    */
    reportFacebookScrape : function(ext_id, dynamicdata) {
        var e;
        var evpl={};
        dynamicdata ? evpl.dynamicdata = dynamicdata : '';
        e = {
            evcl: 'PLUS',
            srcty: 'PC',
            extid: ext_id,
            evid: 'FBSCRAPE',
            evpl: evpl
        };
        this._queueMessage(e);
        return e;
    },

    /**
    * Report us scraping a user's contact list - ext_id is the user's facebook ID.
    *
    */
    reportContactScrape : function(dynamicdata) {
        var e;
        var evpl={};
        dynamicdata ? evpl.dynamicdata = dynamicdata : '';
        e = {
            evcl: 'PLUS',
            srcty: 'PC',
            evid: 'CONTACTSCRAPE',
            evpl: evpl
        };
        this._queueMessage(e);
        return e;
    },

    /**
    * Report a user posting to another user's wall.
    *
    */
    reportWallPost : function(friendId, payload) {
        var e;
        e = {
            evcl: 'SOCL',
            srcty: 'PC',
            frid: friendId,
            evid: 'WALLPOST',
            evpl: payload
        };
        this._queueMessage(e);
        return e;
    },

    /**
    * Report a user downloading a game from a specific section in the store.
    * @param {String} game is the asku for the game being downloaded.
    * @param {String} section is the name of the section that the user downloaded from:
    *   AllGames, FeaturedGames, MyProfile, FriendsLastPlayedGame, FriendsPlayingGame
    * @param {String} slot is the order of the game in the section (if applicable)
    */
    reportDownload : function(game, section, slot) {
        var payload = {};
        payload.game = game;
        payload.section = section;
        payload.slot = slot;
        var e;
        e = {
            evcl: 'PLUS',
            srcty: 'PC',
            evid: 'DOWNLOAD',
            evpl: payload
        };
        this._queueMessage(e);
        return e;
    },

    /**
    * add internal tag to a user.
    */
    addTag : function(tagName) {
        var payload = {};
        payload.tag = tagName;
        var e;
        e = {
            evcl: 'PLUS',
            evid: 'TAG', 
            srcty: 'PC',
            evpl: payload
        };
        this._queueMessage(e);
        return e;
    },

    getSeqNumber: function() {
        this._seqNumber += 1;
        return this._seqNumber;
    },

    getQueueCount: function() {
        return this._queue.length;
    },

    getSendDelay: function() {
        return this._sendDelay;
    },

    setSendDelay: function(val) {
        return (this._sendDelay = val);
    },

    setMeta: function(key, value) {
        if (!value) {
            value = key;
            return (this._meta = value);
        } else {
            return (this._meta[key] = value);
        }
    },

    getMeta: function(key) {
        if (key) {
            return this._meta[key];
        } else {
            return this._meta;
        }
    },

    _queueMessage: function(msg) {
        if (!msg) {
            return false;
        }

        var self = this;

        //This sets metas that don't change often
        this._setUnsetMetaKeys();

        // The rest of these function set properties that 
        msg = this._mergeMeta(msg);
        msg = this._addSeqDetails(msg);
        msg = this._addGeo(msg);
        msg = this._addEvts(msg);
        msg = this._addGameSku(msg);
        msg = this._addGameRel(msg);
        msg = this._addCarrier(msg);
        msg = this._addService(msg);
        msg = this._addPlatformVersion(msg);
        msg = this._addUserId(msg);
        msg = this._addUserName(msg);
        msg = this._normalizeValues(msg);
        var queue = this._getQueue();
        queue.push(msg);
        this._setQueue(queue);

        if (!this._isSendQueued) {
            setTimeout(function() {
                self._isSendQueued = false;
                return self._drainQueue();
            }, self._sendDelay);
        }
        return msg;
    },
    _tagQa: function() {
        var fs = require('NGCore/Client/Storage/FileSystem').FileSystem;
        var self = this;
        fs.readFile('QA',function(err,data) {
            if (!err) {
                self.addTag("NGMOCOQA");
            }
        });
    },
    _hookGeo: function() {
        var Social = require('NGCore/Client/Social').Social;
        if(Social.US){
            var MessageListener = require('NGCore/Client/Core/MessageListener').MessageListener;
            var Device = require('NGCore/Client/Device').Device, self = this;
            var LocationListener = MessageListener.subclass({
                initialize: function() {
                    Device.LocationEmitter.addListener(this, this.onUpdate, false);
                },
                onUpdate: function(location) {
                    self._location = location;
                    Device.LocationEmitter.removeListener(this);
                    self._locListener = null;
                }
            });
            this._locListener = new LocationListener();
        }
    },
    _hookLifetime: function() {
        var self = this;
        var MessageListener = require('NGCore/Client/Core/MessageListener').MessageListener;
        var Device = require('NGCore/Client/Device').Device;
        var ListenerClass =  MessageListener.subclass({
            initialize: function() {
                Device.LifecycleEmitter.addListener(this, this.onLifecycleUpdate);
            },
            onLifecycleUpdate: function(event) {
                switch (event) {
                case Device.LifecycleEmitter.Event.Suspend:
                case Device.LifecycleEmitter.Event.Terminate:
                    self.sessionEndEvent();
					self._drainQueue();
                    break;
                case Device.LifecycleEmitter.Event.Resume:
                default:
                    self.initialize();
                    break;
                }
            }
        });
        if (!this._listener) {
            this._listener = new ListenerClass();
        }
    },
    /**
    * Game Service running inside privileged interpreter may use this method
    * to change the Social Analytic object to be used.  Please see MOBWEST-2300
	* for details
	*
    * @private
    */
	_setSocialAnalytics: function(obj) {
		this._socAnalytics = obj;
	},
    _setUnsetMetaKeys: function() {
        var Capabilities = CapabilitiesReq.Capabilities, udid;
        if ((!this.getMeta('udid')) && (udid = Capabilities.getUniqueId() )) {
            this.setMeta('udid', udid);
        }

        if (!this.getMeta('sid')) {
            var sid = ''+ hex_sha1(this._seqStart+ (this.getMeta('udid')|| "UNKNOWN"));
            this.setMeta('sid', sid);
        }

        if (!this.getMeta('pltfmsku')) {
            var platRegex = /android/;

            var plat = Capabilities.getPlatformOS();
            if (plat) {
                plat = plat.toLowerCase();
                if (plat.match(platRegex) ) {
                    plat = "android";
                } else if ("flash" === plat ) {
                    plat = "flash";
                } else {
                    plat = "ios";
                }
                this.setMeta( 'pltfmsku', plat);
            }
        }

        if (!this.getMeta('apiver')) {
            this.setMeta('apiver', 5);
        }
        return true;
    },

    _getPlayerStateDiff: function(newState) {
        var delta_sign, delta_value, diff, key, value;
        diff = {};
        if (!this._playerState) {
            this._setCurrentPlayerState(newState);
        }
        for (key in newState) {
            if (!__hasProp.call(newState, key)) continue;
            value = newState[key];
            if (typeof value === 'number') {
                delta_value = (value - this._playerState[key]) || 0;
                if (delta_value < 0) {
                    delta_sign = '-';
                }
                if (delta_value >= 0) {
                    delta_sign = '+';
                }
                diff[key] = "" + delta_sign + "," + Math.abs(delta_value) + "," + (this._playerState[key]);
            } else if (typeof value === 'string') {
                diff[key] = value;
            }
        }
        return diff;
    },

    _setCurrentPlayerState: function(pst) {
        var key, value;
        this._playerState = {};
        for (key in pst) {
            if (!__hasProp.call(pst, key)) continue;
            value = pst[key];
            this._playerState[key] = value;
        }
        return true;
    },

    _addEvts: function(msg) {
      var d = new Date(); 
      msg.evts =  d.getTime();
      return msg;
    },
    _addGeo: function(msg) {
        var loc_point;

        if (this._location && (loc_point = this._location.getPosition())  && !isNaN(loc_point.getX()) && !isNaN(loc_point.getY())) {
            msg.geo = "" + loc_point.getX() + "," + loc_point.getY();
        }
        return msg;
    },
    _addCarrier: function(msg) {
        var Capabilities = CapabilitiesReq.Capabilities;
        var carr = Capabilities.getCarrier();
        if (carr) {
            msg.carr = carr;
        }
        return msg;
    },
    _addService: function(msg) {
        var Analytics = this._socAnalytics;
        msg.srvc = Analytics.getServiceId();
        return msg;
    },
    _addPlatformVersion: function(msg) {
        var Analytics = this._socAnalytics;
        msg.pver = Analytics.getPlatformVersion();
        return msg;

    },
    _addSeqDetails: function(msg) {
        this._seqNum += 1;
        msg.seq = this.getSeqNumber();
        msg.seqdt = new Date().getTime() - this._seqStart;
        return msg;
    },
    _addUserId: function(msg) {
      var Analytics = this._socAnalytics;
      var uid = Analytics.getUserId();
      if (uid) {
        msg.uid = uid;
      }
      return msg;
    },
    _addUserName: function(msg) {
      var Analytics = this._socAnalytics;
      var un = Analytics.getUsername();
      if (un) {
        msg.plus = un;
      }
      return msg;
    },
    _addGameSku: function(msg) {
        var app_key = (Capabilities.getConfigs() || {} )["appId"];
        if ( app_key ) {
            msg.asku = app_key;
        }
        return msg;
    },
    _addGameRel: function(msg) {
        var arel = Capabilities.getAppReleaseVersion();
        if (arel) {
          msg.arel = arel;
        }
        return msg;
    },
    _normalizeValues: function(msg) {
        var key, value;
        for (key in msg) {
            if (!__hasProp.call(msg, key)) continue;
            value = msg[key];
            if (typeof value === 'string') {
                value = this._normalizeString(key, value);
            } else if (typeof value === 'object') {
                value = this._normalizeValues(value);
            }
            msg[key] = value;
        }
        return msg;
    },

    _normalizeString: function(key, value) {
        value = value.substring(0, this._allowedLargeValue[key] || 32);
        if (-1 !== this._capAlphaNumStringKeys.indexOf(key)) {
            value = value.toUpperCase().replace(/[^\w]+/g, "").replace("_", "");
        }
        return value;
    },

    _mergeMeta: function(msg) {
        var _ref, _ref2, key, new_msg, value;
        new_msg = {};
        for (key in msg) {
            if (!__hasProp.call(msg, key)) continue;
            value = msg[key];
            new_msg[key] = value;
        }
        for (key in _ref = this._meta) {
            if (!__hasProp.call(_ref, key)) continue;
            value = _ref[key];
            (_ref2 = new_msg[key]) ? _ref2 : new_msg[key] = value;
        }
        return new_msg;
    },

    _drainQueue: function() {
        var cb, self, toDrain;
        toDrain = this._getQueue();
        this._setQueue([]);
        self = this;

        if (! this._sendToRemote)
            return true;

        cb = function(state, not_sent) {
            if (state === NgPipesRemote.possibleStates.error) {
                self._queueMany(not_sent);
                self._sendDelay = self._sendDelay * 2;
            } else if (state === NgPipesRemote.possibleStates.finished ) {
                self._sendDelay = 5000;
            }
            return true;
        };
        NgPipesRemote.clearQueue(toDrain, cb);
        toDrain = null; // explicit clear to keep memory down
        return true;
    },

    _queueMany: function(msg_arr) {
        var _i, _len, msg, self = this;
        this._setQueue( (this._getQueue() || [] ).concat(msg_arr) );
        if (this._isSendQueued) {
          this._isSendQueued = true;
          setTimeout(function() {
              self._isSendQueued = false;
              return self._drainQueue();
          }, self._sendDelay);
        }

        return true;
    },
    _setQueue: function(new_queue) {
        this._queue = new_queue;
        Storage.KeyValueCache.global(this._globalKey).setItem(this._globalKey, JSON.stringify(this._queue));
        return true;
    },
    _getQueue: function() {
        return this._queue;

    }
});

exports.NgPipe = NgPipe;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/NgPipesRemote'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/NgPipesRemote'] || {}; $MODULE_REGISTRY['NGCore/Shared/NgPipesRemote'] = exports; var Network = require('NGCore/Client/Network').Network;

NgPipesRemote = {
  listeners: [],
  debug: true,

  possibleStates: {
    unknown: {},
    finished: {},
    error: {}
  }
};

NgPipesRemote.addListener = function(listner) {
  this.listeners.push(listner);
  return true;
};

NgPipesRemote.clearQueue = function(queue, callback) {

  if (!queue) {
    return false;
  }

  if (!this.getUrl()) {
    if (callback) {
      callback(NgPipesRemote.possibleStates.finished, []);
    }
    return false;
  }
	var copy_array = queue.slice(0, queue.length);

	var _j, _len2, data;
  while (copy_array && copy_array.length > 0) {
    var to_send = copy_array.slice(0, 10);
    copy_array = copy_array.slice(10);
    data = "";

    for (_j = 0, _len2 = to_send.length; _j < _len2; _j++) {
      data += JSON.stringify(to_send[_j]);
      if (_j+1 < _len2) {
         data += "\r\n";
      } //if len
    } //for

    if (data) {
      NgPipesRemote._makeRequest(data, to_send, callback);
    } //if data
  }//while

};

NgPipesRemote._makeRequest = function(json_data, objs, callback) {
  var request = new Network.XHR(), url = this.getUrl();
  if (this.debug) {
    NgPipesRemote._debugOutput(json_data);
  }

	var LifecycleEmitter = require('NGCore/Client/Device/LifecycleEmitter').LifecycleEmitter;
	LifecycleEmitter.requestEngineKeepAlive(objs);
  request.onreadystatechange = function() {
    var status = null;
    try {
      if (this.readyState === 4) {
		LifecycleEmitter.cancelEngineKeepAlive(objs);
        status = NgPipesRemote._handleResponse(request.responseText);
      } else {
        status = NgPipesRemote.possibleStates.unknown;
      }
    } catch (ex) {
      status = NgPipesRemote.possibleStates.error;
      NgLogException(ex);
    }

    if (callback) {
      callback(status, objs);
    }

    NgPipesRemote._notifyListeners(status);
    return true;
  };

  request.open("POST", url, true);

  request.setRequestHeader("X-Ngpipes-Api", "1.0");
  request.setRequestHeader("Content-Type", "application/json+batch");
  request.setRequestHeader("If-None-Match", "0");

  request.send(json_data);

  NgPipesRemote._notifyListeners('started');
  return true;
};
NgPipesRemote.setUrl = function(url) {
    this.url = url;
};
NgPipesRemote.getUrl = function() {
    if (this.url)
        return this.url;
    var Capabilities = require('NGCore/Client/Core/Capabilities').Capabilities;
    var url = null;
    
    if (Capabilities) {
      //Get the url from the configuration.json
      url = (Capabilities.getConfigs() || {} )["analyticsServer"] || null;
      if (url) {
        url = "https://"+url+"/pipes/r.2/bulk_record_stats";
        if (this.debug) {
          NgLogD("Pipes URL => " + url );
        }
      }
    }
    return url;
};


NgPipesRemote._handleResponse = function(respText) {
  var respObj, result;
  result = NgPipesRemote.possibleStates.unknown;
  if (respText && respText.length > 0) {
    try {
    respObj = JSON.parse(respText);
    } catch (e) {
      //Clean up after ourselves.
      respObj = null;
    }
	if (respObj  && (respObj.success !== null && respObj.success !== undefined ) && respObj.success) {
      if (this.debug) {
        NgLogD("[NgPipesRemote] Got Success" );
      }
      result = NgPipesRemote.possibleStates.finished;
    } else {
      result = NgPipesRemote.possibleStates.error;
    }
  } else {
      if (this.debug) {
        NgLogD('[NgPipesRemote] ERROR posting');
      }

    result = NgPipesRemote.possibleStates.error;
  }
  return result;
};

NgPipesRemote._debugOutput = function(str) {
  var _i, _len, _result, msg, msgs;
  msgs = str.split("\r\n");
  for (_i = 0, _len = msgs.length; _i < _len; _i++) {
    msg = msgs[_i];
    NgLogD("[NgPipesRemote] Message sent: " + msg);
  }
  return false;
};

NgPipesRemote._notifyListeners = function(state) {
  var _i, _len, _ref, l;
  for (_i = 0, _len = (_ref = this.listeners).length; _i < _len; _i++) {
    l = _ref[_i];
    l(state);
  }
  return true;
};

exports.NgPipesRemote = NgPipesRemote;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/Lib/sha1'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/Lib/sha1'] || {}; $MODULE_REGISTRY['NGCore/Shared/Lib/sha1'] = exports; /*
 * @description
 * A JavaScript implementation of the Secure Hash Algorithm, SHA-1, as defined
 * in FIPS PUB 180-1
 * Version 2.1a Copyright Paul Johnston 2000 - 2002.
 * Other contributors: Greg Holt, Andrew Kepert, Ydnar, Lostinet
 * Distributed under the BSD License
 * See http://pajhome.org.uk/crypt/md5 for details.
 * @namespace
 * @name sha1
 */

/*
 * Configurable variables. You may need to tweak these to be compatible with
 * the server-side, but the defaults work in most cases.
 */
var hexcase = 0;  /* hex output format. 0 - lowercase; 1 - uppercase        */
var b64pad  = ""; /* base-64 pad character. "=" for strict RFC compliance   */
var chrsz   = 8;  /* bits per input character. 8 - ASCII; 16 - Unicode      */

/*
 * Add integers, wrapping at 2^32. This uses 16-bit operations internally
 * to work around bugs in some JS interpreters.
 */
function safe_add(x, y)
{
  var lsw = (x & 0xFFFF) + (y & 0xFFFF);
  var msw = (x >> 16) + (y >> 16) + (lsw >> 16);
  return (msw << 16) | (lsw & 0xFFFF);
}

/*
 * Bitwise rotate a 32-bit number to the left.
 */
function rol(num, cnt)
{
  return (num << cnt) | (num >>> (32 - cnt));
}

/*
 * Perform the appropriate triplet combination function for the current
 * iteration
 */
function sha1_ft(t, b, c, d)
{
  if(t < 20) { return (b & c) | ((~b) & d); }
  if(t < 40) { return b ^ c ^ d; }
  if(t < 60) { return (b & c) | (b & d) | (c & d); }
  return b ^ c ^ d;
}

/*
 * Determine the appropriate additive constant for the current iteration
 */
function sha1_kt(t)
{
  return (t < 20) ?  1518500249 : (t < 40) ?  1859775393 :
         (t < 60) ? -1894007588 : -899497514;
}

/*
 * Calculate the SHA-1 of an array of big-endian words, and a bit length
 */
function core_sha1(x, len)
{
  /* append padding */
  x[len >> 5] |= 0x80 << (24 - len % 32);
  x[((len + 64 >> 9) << 4) + 15] = len;

  var w = Array(80);
  var a =  1732584193;
  var b = -271733879;
  var c = -1732584194;
  var d =  271733878;
  var e = -1009589776;

  for(var i = 0; i < x.length; i += 16)
  {
    var olda = a;
    var oldb = b;
    var oldc = c;
    var oldd = d;
    var olde = e;

    for(var j = 0; j < 80; j++)
    {
      if(j < 16) { w[j] = x[i + j]; }
      else {
		w[j] = rol(w[j-3] ^ w[j-8] ^ w[j-14] ^ w[j-16], 1);
	  }
      var t = safe_add(safe_add(rol(a, 5), sha1_ft(j, b, c, d)),
                       safe_add(safe_add(e, w[j]), sha1_kt(j)));
      e = d;
      d = c;
      c = rol(b, 30);
      b = a;
      a = t;
    }

    a = safe_add(a, olda);
    b = safe_add(b, oldb);
    c = safe_add(c, oldc);
    d = safe_add(d, oldd);
    e = safe_add(e, olde);
  }
  return Array(a, b, c, d, e);

}

/*
 * Convert an 8-bit or 16-bit string to an array of big-endian words
 * In 8-bit function, characters >255 have their hi-byte silently ignored.
 */
function str2binb(str)
{
  var bin = Array();
  var mask = (1 << chrsz) - 1;
  for(var i = 0; i < str.length * chrsz; i += chrsz) {
    bin[i>>5] |= (str.charCodeAt(i / chrsz) & mask) << (32 - chrsz - i%32);
  }
  return bin;
}

/**
 * @description
 * Call the <code>core_hmac_sha1()</code> function to calculate the HMAC-SHA1 of a key and some data.
 * A JavaScript implementation of the Secure Hash Algorithm, SHA-1, as defined
 * in FIPS PUB 180-1
 * Version 2.1a Copyright Paul Johnston 2000 - 2002.
 * Other contributors: Greg Holt, Andrew Kepert, Ydnar, Lostinet
 * Distributed under the BSD License
 * See <a href="http://pajhome.org.uk/crypt/md5">this</a> or <a href="http://www.itl.nist.gov/fipspubs/fip180-1.htm">NIST</a> for details.
 * @namespace
 * @name core_hmac_sha1
 * @function
 * @param key The key to use with sha1.
 * @param data The data to hash.
 * @return A sha1 hash of the data and key.
 * @example
 * var key = "12345"
 * var data = "The data I would like to hash."
 * core_hmac_sha1(key, data);
 */
function core_hmac_sha1(key, data)
{
  var bkey = str2binb(key);
  if(bkey.length > 16) {
	bkey = core_sha1(bkey, key.length * chrsz);
  }

  var ipad = Array(16), opad = Array(16);
  for(var i = 0; i < 16; i++)
  {
    ipad[i] = bkey[i] ^ 0x36363636;
    opad[i] = bkey[i] ^ 0x5C5C5C5C;
  }

  var hash = core_sha1(ipad.concat(str2binb(data)), 512 + data.length * chrsz);
  return core_sha1(opad.concat(hash), 512 + 160);
}

/*
 * Convert an array of big-endian words to a string
 */
function binb2str(bin)
{
  var str = "";
  var mask = (1 << chrsz) - 1;
  for(var i = 0; i < bin.length * 32; i += chrsz) {
    str += String.fromCharCode((bin[i>>5] >>> (32 - chrsz - i%32)) & mask);
  }
  return str;
}

/*
 * Convert an array of big-endian words to a hex string.
 */
function binb2hex(binarray)
{
  var hex_tab = hexcase ? "0123456789ABCDEF" : "0123456789abcdef";
  var str = "";
  for(var i = 0; i < binarray.length * 4; i++)
  {
    str += hex_tab.charAt((binarray[i>>2] >> ((3 - i%4)*8+4)) & 0xF) +
           hex_tab.charAt((binarray[i>>2] >> ((3 - i%4)*8  )) & 0xF);
  }
  return str;
}

/*
 * Convert an array of big-endian words to a base-64 string
 */
function binb2b64(binarray)
{
  var tab = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
  var str = "";
  for(var i = 0; i < binarray.length * 4; i += 3)
  {
    var triplet = (((binarray[i   >> 2] >> 8 * (3 -  i   %4)) & 0xFF) << 16) |
                  (((binarray[i+1 >> 2] >> 8 * (3 - (i+1)%4)) & 0xFF) << 8 ) |
                   ((binarray[i+2 >> 2] >> 8 * (3 - (i+2)%4)) & 0xFF);
    for(var j = 0; j < 4; j++)
    {
      if(i * 8 + j * 6 > binarray.length * 32){
		str += b64pad;
	  } else {
		str += tab.charAt((triplet >> 6*(3-j)) & 0x3F);
	  }
    }
  }
  return str;
}

/*
 * These are the functions you'll usually want to call
 * They take string arguments and return either hex or base-64 encoded strings
 */
function hex_sha1(s){return binb2hex(core_sha1(str2binb(s),s.length * chrsz));}
function b64_sha1(s){return binb2b64(core_sha1(str2binb(s),s.length * chrsz));}
function str_sha1(s){return binb2str(core_sha1(str2binb(s),s.length * chrsz));}
function str_hmac_sha1(key, data){ return binb2str(core_hmac_sha1(key, data));}
function hex_hmac_sha1(key, data){ return binb2hex(core_hmac_sha1(key, data));}
function b64_hmac_sha1(key, data, padChar){
	if ((typeof padChar != "undefined") && padChar) {
        b64pad = padChar;
	}
	return binb2b64(core_hmac_sha1(key, data));
}

/*
 * Perform a simple self-test to see if the VM is working
 */
function sha1_vm_test()
{
  return hex_sha1("abc") == "a9993e364706816aba3e25717850c26c9cd0d89d";
}

// Exports for node.js
if((typeof exports != "undefined") && exports)
{
	exports.b64_hmac_sha1 = b64_hmac_sha1;
	exports.hex_sha1 = hex_sha1;
	exports.b64_sha1 = b64_sha1;
}
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social'] || {}; $MODULE_REGISTRY['NGCore/Client/Social'] = exports; /**
 * Public API for GameService
 * 
 * Access this file as NGCore/Client/Social.js
 */

// Note the proper require path for our public interface files is: "./Social/US/[filename]"

/** @namespace
 * @name Social
 * @description
 * The <code>Social</code> namespace provides interfaces for the Mobage Social APIs.
 */
exports.Social = {
};

/** @namespace
 * @name Social.Common
 * @description
 * The <code>Social.Common</code> namespace provides interfaces for functionality common to submodules for Japan (JP), the United States (US), 
 * and future submodules. The common features include Auth, People, Appdata, Blacklist, Profanity and Service. Service APIs can be both common
 * or native, and include the Community button, the Balance button, the Friend Picker, the User Finder, and the User Profile.
 */
exports.Social.Common = {
	Appdata: require('NGCore/Client/Social/US/Common/Appdata').Appdata,
	Auth: require('NGCore/Client/Social/US/Common/Auth').Auth,
	Blacklist: require('NGCore/Client/Social/US/Common/Blacklist').Blacklist,
	Config: require('NGCore/Client/Social/US/Common/Config').Config,
	People: require('NGCore/Client/Social/US/Common/People').People,
	Profanity: require('NGCore/Client/Social/US/Common/Profanity').Profanity,
	Request: require('NGCore/Client/Social/US/Common/Request').Request,
	Service: require('NGCore/Client/Social/US/Common/Service').Service,
  Analytics: require('NGCore/Client/Social/US/Common/Analytics').Analytics
};

/** @namespace
 * @name Social.US
 * @description
 * The <code>Social.US</code> namespace provides interfaces for the United States (US) submodule. 
 * The features include User, Game, Leaderboard, Score, Ordered List, and AppData.
 */
exports.Social.US = {
	// Data Models
	DataModel: require('NGCore/Client/Social/US/Models/DataModel').DataModel,
	User: require('NGCore/Client/Social/US/Models/User').User,
	Game: require('NGCore/Client/Social/US/Models/Game').Game,
	Leaderboard: require('NGCore/Client/Social/US/Models/Leaderboard').Leaderboard,
	Score: require('NGCore/Client/Social/US/Models/Score').Score,
	
	AppData: require('NGCore/Client/Social/US/Models/AppData').AppData,
	
	// Data Cache
	Cache: require('NGCore/Client/Social/US/Models/Cache').Cache,

	// Data APIs
	Session: require('NGCore/Client/Social/US/Data/Session').Session,
	Dispatcher: require('NGCore/Client/Social/US/Data/Dispatcher').Dispatcher
};

/** @namespace
 * @name Social.US.Service
 * @description
 * Service APIs include the Community button, the Balance button, the Friend Picker, the User Finder, and the User Profile.
 */
exports.Social.US.Service = {
	Friends: require('NGCore/Client/Social/US/Service/Friends').Friends,
	Profile: require('NGCore/Client/Social/US/Service/Profile').Profile,
	ButtonOverlays: require('NGCore/Client/Social/US/Service/ButtonOverlays').ButtonOverlays,
	GameLaunchPayload: require('NGCore/Client/Social/US/Service/GameLaunchPayload').GameLaunchPayload
};

/** @namespace
 * @name Bank
 * @description
 * The <code>Bank</code> namespace provides interfaces for the Mobage Bank APIs.
 */
exports.Bank = require('NGCore/Client/Social/US/Service/Bank').Bank;; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Storage/FileSystem'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Storage/FileSystem'] || {}; $MODULE_REGISTRY['NGCore/Client/Storage/FileSystem'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class FileSystem
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var Class = require('NGCore/Client/Core/Class').Class;

////////////////////////////////////////////////////////////////////////////////

exports.FileSystem = Class.singleton(
/** @lends Storage.FileSystem.prototype */
{
	classname: 'FileSystem',
	
	/**
	 * @class The <code>FileSystem</code> class constructs a singleton object that controls file manipulation tasks: reading, writing, deleting, or decompressing a file.
	 * 
	 * @constructs The default constructor.
	 * @augments Core.Class
	 */
	initialize: function()
	{
		/** @private */
		this.readRequests = {};
		/** @private */
		this.writeRequests = {};
		/** @private */
		this.cbIdCounter = 1;
		
		ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
	},

	/**
	 * Read a file into memory from local storage.
	 * @example FileSys.readFile(SomeFile, true, function(err, data){...}
	 * @param {String} fname The name of the file to read into memory.
	 * @param {Boolean} [binary=false] Set as <code>true</code> if <code>readFile()</code> shouuld conduct a binary read.
	 * @param {Function} [cb] Specifies a callback function that returns an error if the file read operation fails.
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	readFile: function( fname, binary, cb )
	{
		this.readFileIn(this.Store.Local, fname, binary, cb);
	},

	/**
	 * @private
	 *	read a file from a common store on the filesystem
	 *	NOTE: This is not a secure location and games should not rely on this for critical data
	 *	@param {store} The shared location to read from
	 *	@param {fname} The name of the file to be read
	 *	@param {cb} The callback function to be called
	 *	@param {binary} binary mode or not
     *  @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	readFileIn: function( store, fname, binary, cb )
	{
		var cbId = 0;

		if(typeof(binary) == 'function')
		{
			cb = binary;
			binary = false;
		}
		binary = binary || false;

		if ( cb )
		{
			cbId = this.cbIdCounter++;
			this.readRequests[ cbId ] = cb;
		}
		this._readFileSendGen(cbId,store,fname,binary);
	},

	/**
	 * Write a file to local storage.
	 * @example FileSys.writeFile(SomeFile, someData, true, (function(){...});
	 * @param {String} fname The name of the file to write into storage.
	 * @param {Binary, String} data The data to write to the file.
	 * @param {Boolean} [binary=false] Set as <code>true</code> if <code>writeFile()</code> should conduct a binary write.
	 * @param {Function} [cb] Specifies a callback function that returns an error if the file write operation fails.
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	writeFile: function( fname, data, binary, cb )
	{
		this.writeFileIn(this.Store.Local, fname, data, binary, cb);
	},

	/**
	 * @private
	 *	write a file to a common store on the filesystem
	 *	NOTE: This is not a secure location and games should not rely on this for critical data
	 *	@param {store} The shared location to write to
	 *	@param {fname} The name of the file to be written
	 *	@param {cb} The callback function to be called after completion
	 *	@param {binary} binary mode or not
     *  @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	writeFileIn: function( store, fname, data, binary, cb )
	{
		var cbId = 0;

		if(typeof(binary) == 'function')
		{
			cb = binary;
			binary = false;
		}
		binary = binary || false;

		if ( cb )
		{
			cbId = this.cbIdCounter++;
			this.writeRequests[ cbId ] = cb;
		}

		this._writeFileSendGen(cbId,store,fname,data,binary);
	},

	/**
	 * Delete a file from local storage.
	 * @example FileSys.deleteFile(SomeFile,function(err, data){});
	 * @param {String} fname The name of the file to delete.
	 * @param {Function} [cb] Specifies a callback function that returns an error if the file delete operation fails.
     * @status iOS, Android, Test, iOSTested, AndroidTested     
	 */
	deleteFile: function ( fname, cb )
	{
		this.deleteFileIn(this.Store.Local, fname, cb);
	},

	/**
	 * @private
	 *	delete a file from a common store on the filesystem
	 *	NOTE: This is not a secure location and games should not rely on this for critical data
	 *	@param {store} The shared location path
	 *	@param {fname} The name of the file to be deleted
	 *	@param {cb} The callback function to be called
     *  @status iOS, Android, Test, iOSTested, AndroidTested     
	 */
	deleteFileIn: function ( store, fname, cb )
	{
		var cbId = 0;

		if ( cb )
		{
			cbId = this.cbIdCounter++;
			this.writeRequests[ cbId ] = cb;
		}
		this._deleteFileSendGen(cbId,store,fname);
	},
	
	/**
	 * Decompress a zipfile.
	 * @example FileSys.readFile(SomeFile, ./some/path/to/destination/, true, function(err, data){...}
	 * @param {String} fname The name of the zipfile to decompress.
	 * @param {String} destination The directory path where the contents of the decompressed file are written.
	 * @param {Boolean} [returnFiles] Set as <code>true</code> if <code>decompressFile()</code> should return a list of files contained in the zipfile specified by the <code>fname</code> parameter.
	 * @param {Function} [cb] Specifies a callback function that returns an error if the file decompress operation fails.
     * @status iOS, Android
	 */
	decompressFile: function( fname, destination, returnFiles, cb )
	{
		this.decompressFileIn(this.Store.Local, fname, destination, returnFiles, cb);
	},
	
	/**
	 * @private
	 *	decompress a file to a shared location on the filesystem
	 *	NOTE: This is not a secure location and games should not rely on this for critical data
	 *	@param {store} The shared location path
	 *	@param {fname} The name of the file to be read
	 *	@param {cb} The callback function to be called
	 *	@param {destination} destination location to unzip files to
	 *	@param {returnFiles} true/false if true it returns a json object with a list of each file, its MD5 hash and its size
     *  @status iOS, Android    
	 */
	decompressFileIn: function( store, fname, destination, returnFiles, cb )
	{
		var cbId = 0;

		if ( cb )
		{
			cbId = this.cbIdCounter++;
			this.writeRequests[ cbId ] = cb;
		}
		this._decompressFileSendGen(cbId,store,fname,destination,returnFiles);
	},
	
	/**
	 * @private
	 */
	_readFileCbRecv: function( cmd ) 
	{
		var msg = {};
		if(!this._readFileCbRecvGen(cmd, msg))
			return;
			
		var cbId = msg[ "callbackId" ];
		var data = msg[ "data" ];
		var err = msg[ "error" ];
		
		if ( !cbId )
		{
			NgLogE ( "FileSystem.onReadFile: No cbId" );
			return;
		}
		
		var cb = this.readRequests[ cbId ];
		
		if ( !cb )
		{
			NgLogE ( "FileSystem.onReadFile: No registered cb found..cbId is :" + cbId );
			return;
		}
		
		delete this.readRequests[ cbId ];
		cb ( err, data );
	},
	
	/**
	 * @private
	 */
	_writeFileCbRecv: function( cmd )
	{
		var msg = {};
		if(!this._writeFileCbRecvGen(cmd, msg))
			return;
		
		var cbId = msg[ "callbackId" ];
		var err = msg[ "error" ];
		
		if ( !cbId )
		{
			//NgLogE ( "FileSystem command : No cbId" );
			return;
		}
		
		var cb = this.writeRequests[ cbId ];
			
		if ( !cb )
		{
			NgLogE ( "FileSystem command : No registered cb found..cbId is :" + cbId );
			return;
		}

		delete this.writeRequests[ cbId ];
		cb ( err );
	},
	
	/**
	 * @private
	 */
	_deleteFileCbRecv: function( cmd )
	{
		var msg = {};
		if(!this._deleteFileCbRecvGen(cmd, msg))
			return;
		
		var cbId = msg[ "callbackId" ];
		var err = msg[ "error" ];
		
		if ( !cbId )
		{
			//NgLogE ( "FileSystem command : No cbId" );
			return;
		}
		
		var cb = this.writeRequests[ cbId ];
		
		if ( !cb )
		{
			NgLogE ( "FileSystem command : No registered cb found..cbId is :" + cbId );
			return;
		}
		
		delete this.writeRequests[ cbId ];
		cb ( err );
	},
	
	/**
	 * @private
	 */
	_decompressFileCbRecv: function( cmd )
	{
		var msg = {};
		if(!this._decompressFileCbRecvGen(cmd, msg))
			return;
			
		var cbId = msg[ "callbackId" ];
		var files = msg[ "files" ];
		var err = msg[ "error" ];
		
		if ( !cbId )
		{
			//NgLogE ( "FileSystem command : No cbId" );
			return;
		}
		
		var cb = this.writeRequests[ cbId ];
		
		if ( !cb )
		{
			NgLogE ( "FileSystem command : No registered cb found..cbId is :" + cbId );
			return;
		}
		
		try
		{
			files = JSON.parse(files);
		}
		catch(e)
		{
			NgLogE ( "FileSystem command : Could not parse response :" + files );
			err = "Could not parse files";
		}
		
		delete this.writeRequests[ cbId ];
		cb ( err, files );
	},
	
// {{?Wg Generated Code}}
	
	// Enums.
	Store:
	{ 
		/** /tmp */
		Temp: 0,
		/** local sandbox */
		Local: 1,
	},
	
	///////
	// Class constants (for internal use only):
	// Class ID = 338
	// Method create = -1
	// Method readFile = 2
	// Method writeFile = 3
	// Method deleteFile = 4
	// Method decompressFile = 5
	// Method readFileCb = 6
	// Method writeFileCb = 7
	// Method deleteFileCb = 8
	// Method decompressFileCb = 9
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 6:
					instance._readFileCbRecv( cmd );
					break;
				case 7:
					instance._writeFileCbRecv( cmd );
					break;
				case 8:
					instance._deleteFileCbRecv( cmd );
					break;
				case 9:
					instance._decompressFileCbRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in FileSystem._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in FileSystem._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[338] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_readFileCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 3 )
		{
			NgLogE("Could not parse due to wrong argument count in FileSystem.readFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in FileSystem.readFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "data" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "data" ] === undefined )
		{
			NgLogE("Could not parse data in FileSystem.readFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 2 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in FileSystem.readFileCb from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_writeFileCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in FileSystem.writeFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in FileSystem.writeFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in FileSystem.writeFileCb from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_deleteFileCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in FileSystem.deleteFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in FileSystem.deleteFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in FileSystem.deleteFileCb from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_decompressFileCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 3 )
		{
			NgLogE("Could not parse due to wrong argument count in FileSystem.decompressFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in FileSystem.decompressFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "files" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "files" ] === undefined )
		{
			NgLogE("Could not parse files in FileSystem.decompressFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 2 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in FileSystem.decompressFileCb from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":338,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_readFileSendGen: function( callbackId, storeId, filename, binary )
	{
		Core.Proc.appendToCommandString( ":338,2," + this.__objectRegistryId + "," + callbackId + "," + storeId + "," + Core.Base64.encode( filename ) + "," + ( binary ? 1 : 0 )  );
	},
	
	/** @private */
	_writeFileSendGen: function( callbackId, storeId, filename, data, binary )
	{
		Core.Proc.appendToCommandString( ":338,3," + this.__objectRegistryId + "," + callbackId + "," + storeId + "," + Core.Base64.encode( filename ) + "," + Core.Base64.encode( data ) + "," + ( binary ? 1 : 0 )  );
	},
	
	/** @private */
	_deleteFileSendGen: function( callbackId, storeId, filename )
	{
		Core.Proc.appendToCommandString( ":338,4," + this.__objectRegistryId + "," + callbackId + "," + storeId + "," + Core.Base64.encode( filename )  );
	},
	
	/** @private */
	_decompressFileSendGen: function( callbackId, storeId, filename, destination, returnFiles )
	{
		Core.Proc.appendToCommandString( ":338,5," + this.__objectRegistryId + "," + callbackId + "," + storeId + "," + Core.Base64.encode( filename ) + "," + Core.Base64.encode( destination ) + "," + ( returnFiles ? 1 : 0 )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// readFile: function( callbackId, storeId, filename, binary ) {}
	
	// writeFile: function( callbackId, storeId, filename, data, binary ) {}
	
	// deleteFile: function( callbackId, storeId, filename ) {}
	
	// decompressFile: function( callbackId, storeId, filename, destination, returnFiles ) {}
	
	// _readFileCbRecv: function( cmd ) {}
	// _writeFileCbRecv: function( cmd ) {}
	// _deleteFileCbRecv: function( cmd ) {}
	// _decompressFileCbRecv: function( cmd ) {}

// {{/Wg Generated Code}}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Network'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Network'] || {}; $MODULE_REGISTRY['NGCore/Client/Network'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class Network
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////
/**
 * @name Network
 * @namespace
 * <p>Classes and objects contained by the Network module.</p>
 * @description <p>The Network module is a collection of classes that support manipulation of network flow.
 * Each class handles a specific aspect of the module implementation and contains APIs that support the class:</p>
 *<ul>
 *<li><code>{@link Network.DownloadFile}</code>: Construct objects that conduct a file download.</li>
 *<li><code>{@link Network.DownloadManifest}</code>: Construct objects that keep manifests up-to-date.</li>
 *<li><code>{@link Network.XHR}</code>: Construct XmlHttpRequest objects.</li>
 *</ul>
 */
exports.Network = {};

exports.Network.__defineGetter__("XHR", function() {
	delete this.XHR;
	return this.XHR = require('NGCore/Client/Network/XHR').XHR;
});
exports.Network.__defineGetter__("DownloadFile", function() {
	delete this.DownloadFile;
	return this.DownloadFile = require('NGCore/Client/Network/DownloadFile').DownloadFile;
});
exports.Network.__defineGetter__("DownloadManifest", function() {
	delete this.DownloadManifest;
	return this.DownloadManifest = require('NGCore/Client/Network/DownloadManifest').DownloadManifest;
});
exports.Network.__defineGetter__("Util", function() {
	delete this.Util;
	return this.Util = require('NGCore/Client/Network/Util').Util;
});
exports.Network.__defineGetter__("_int_Util", function() {
	delete this._int_Util;
	return this._int_Util = require('NGCore/Client/Network/_int_Util')._int_Util;
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/LifecycleEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/LifecycleEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/LifecycleEmitter'] = exports; var MessageEmitter = require('NGCore/Client/Core/MessageEmitter').MessageEmitter;
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var Proc = require('NGCore/Client/Core/Proc').Proc;

exports.LifecycleEmitter = MessageEmitter.singleton(
/** @lends Device.LifecycleEmitter.prototype */
{
	classname: 'LifecycleEmitter',
		
	/**
	 * @class The <code>LifecycleEmitter</code> class constructs a singleton object that emits <code><a href="Device.LifecycleEmitter.html#Event">Event</a></code> 
	 * objects when device lifecycle events occur.
	 * Applications can respond to these events by notifying external sources. For example,
	 * an application can respond to a <code>Terminate</code> event by writing an analytics log.<br><br>
	 * <b>Note:</b> Applications should never directly allocate a singleton.
	 * @constructs The default constructor. 
	 * @augments Core.MessageEmitter
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	initialize: function()
	{
		ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
		/** @private */
		this.identificationCache = {};
		this.numEngineRequests = 0;
	},
	
	_lifecycleEventRecv: function( cmd )
	{
		var msg = {};
		if(!this._lifecycleEventRecvGen(cmd, msg))
			return;
			
		this.emit(msg.event);
		//Cascade the original message back out to native for forwarding
		//	to the next interpreter in the chain.
		this._lifecycleEventSendGen(msg.event);
	},

	/** @private */
	$exitProcess: function()
	{
		this._exitProcessSendGen();
	},
	
	/** @private */
	$_bgMe: function()
	{
		this.__bgMeSendGen();
	},

	/** @private */
	$pauseGame: function()
	{
		NgLogD("+++++++++++++++++++++++++++++++++++++++++Pausing Game");
		this._pauseGameSendGen();
		var _lgl = require('NGCore/Client/Core/_LocalGameList')._LocalGameList;
		_lgl._pausingGame();
	},

	/** @private */
	$resumeGame: function()
	{
		NgLogD("+++++++++++++++++++++++++++++++++++++++++Resuming Game");
		this._resumeGameSendGen();
		var _lgl = require('NGCore/Client/Core/_LocalGameList')._LocalGameList;
		_lgl._resumingGame();
	},

	requestEngineKeepAlive: function(obj)
	{
		var key = obj;
		if (obj.identification_key !== undefined)
		{
			key = obj.identification_key;
		}

		{
			//Store identification key and increment request to engine
			this.identificationCache[key] = true;
			++this.numEngineRequests;
			this.incrementEngineAlive();
		}
	},
	
	cancelEngineKeepAlive: function(obj)
	{
		var key = obj;
		if (obj.identification_key !== undefined)
		{
			key = obj.identification_key;
		}

		{
			if (this.identificationCache[key])
			{
				//Store identification key and increment request to engine
				delete this.identificationCache[key];
				--this.numEngineRequests;
				this.decrementEngineAlive();
			}else{
				NgLogD("Identification Key not found");
			}
		}
	},

	incrementEngineAlive: function()
	{
		this._incrementEngineAliveSendGen();
	},
	
	decrementEngineAlive: function()
	{
		this._decrementEngineAliveSendGen();
	},
	
	cancelAllEngineRequests: function()
	{
		this._cancelAllEngineRequestsSendGen();
	},

	_killGameProc: function( )
	{
		this.__killGameProcSendGen();
	},

// {{?Wg Generated Code}}
	
	// Enums.
	/** 
	 * Enumeration values for lifecycle events.
	 * @fieldOf Device.LifecycleEmitter.prototype
	 */
	Event:
	{ 
		/** Application is being suspended. */
		Suspend: 0,
		/** Application is being resumed. */
		Resume: 1,
		/** Application is being terminated. */
		Terminate: 2,
	},
	
	///////
	// Class constants (for internal use only):
	// Class ID = 334
	// Method create = -1
	// Method lifecycleEvent = 2
	// Method exitProcess = -3
	// Method pauseGame = -4
	// Method resumeGame = -5
	// Method incrementEngineAlive = 6
	// Method decrementEngineAlive = 7
	// Method cancelAllEngineRequests = 8
	// Method _killGameProc = -9
	// Method _bgMe = -10
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._lifecycleEventRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in LifecycleEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in LifecycleEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[334] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_lifecycleEventRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in LifecycleEmitter.lifecycleEvent from command: " + cmd );
			return false;
		}
		
		obj[ "event" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "event" ] === undefined )
		{
			NgLogE("Could not parse event in LifecycleEmitter.lifecycleEvent from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":334,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_lifecycleEventSendGen: function( event )
	{
		Core.Proc.appendToCommandString( ":334,2," + this.__objectRegistryId + "," + event  );
	},
	
	/** @private */
	$_exitProcessSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":334," + -3  );
	},
	
	/** @private */
	$_pauseGameSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":334," + -4  );
	},
	
	/** @private */
	$_resumeGameSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":334," + -5  );
	},
	
	/** @private */
	_incrementEngineAliveSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":334,6," + this.__objectRegistryId );
	},
	
	/** @private */
	_decrementEngineAliveSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":334,7," + this.__objectRegistryId );
	},
	
	/** @private */
	_cancelAllEngineRequestsSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":334,8," + this.__objectRegistryId );
	},
	
	/** @private */
	$__killGameProcSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":334," + -9  );
	},
	
	/** @private */
	$__bgMeSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":334," + -10  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _lifecycleEventRecv: function( cmd ) {}
	// lifecycleEvent: function( event ) {}
	
	// $exitProcess: function(  ) {}
	
	// $pauseGame: function(  ) {}
	
	// $resumeGame: function(  ) {}
	
	// incrementEngineAlive: function(  ) {}
	
	// decrementEngineAlive: function(  ) {}
	
	// cancelAllEngineRequests: function(  ) {}
	
	// $_killGameProc: function(  ) {}
	
	// $_bgMe: function(  ) {}
	

// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Network/XHR'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Network/XHR'] || {}; $MODULE_REGISTRY['NGCore/Client/Network/XHR'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class XHR
// XMLHttpRequest implementation
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var Class = require('NGCore/Client/Core/Class').Class;
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var Util = require('NGCore/Client/Network/Util').Util;
var Caps = require('NGCore/Client/Core/Capabilities').Capabilities;

////////////////////////////////////////////////////////////////////////////////

var Header = function (item, content)
{
	this.item = item;
	this.content = content;
};
var headerEx = /(.*?): (.*)/;

/**
 * Constants
 */
var State =
{
	UNSENT: 0,
	OPENED: 1,
	HEADERS_RECEIVED: 2,
	LOADING: 3,
	DONE: 4
};

// ///////////// Begin HTTP req'd methods of testing! //////
var methods =
[
	"OPTIONS",
	"GET",
	"HEAD",
	"POST",
	"PUT",
	"DELETE",
	"TRACE",
	"CONNECT"
];

var unsecureMethods = ["CONNECT", "TRACE", "TRACK"];

var checkMethod = function(method)
{
	if(!method) return "GET";

	method = method.toString();

	if (method in unsecureMethods)
	{
		throw "SECURITY_ERROR " + method + " not allowed.";
	}
	if (method.toUpperCase() in methods)
	{
		return method.toUpperCase();
	}
	return method;
};

// ////////////////////////// End! /////////////////////

////////////////////////////////////////////////////////////////////////////////

exports.XHR = Class.subclass(
/** @lends Network.XHR.prototype */
{
	classname: 'XHR',
	
	/**
	 * @class The <code>XHR</code> class constructs <code>XmlHttpRequest</code> objects. Applications can use these objects to
	 * send HTTP or HTTPS requests directly to a web server and load the server response data directly back into a script.
	 * @constructs The default constructor. 
	 * @see <a href="http://www.w3.org/TR/XMLHttpRequest/">Official W3C XmlHttpRequest specification</a>
	 * @augments Core.Class
	 */
	initialize: function()
	{
		this.request;
		this.respHeaders = {};

		this.settings = {};
		this.headers = [];

		// State-associated flags
		this.sendFlag = false;
		this.errorFlag = false;
		
		// Status & response
		this.readyState = State.UNSENT;
		this.responseText = null;
		this.responseXML = null;
		this.status = 0;
		this.statusText = "";
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 340
	// Method create = -1
	// Method destroy = 2
	// Method sendStatus = 3
	// Method sendHeaders = 4
	// Method sendData = 5
	// Method onFinish = 6
	// Method start = 7
	// Method header = 8
	// Method setComposition = 9
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 3:
					instance._sendStatusRecv( cmd );
					break;
				case 4:
					instance._sendHeadersRecv( cmd );
					break;
				case 5:
					instance._sendDataRecv( cmd );
					break;
				case 6:
					instance._onFinishRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in XHR._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in XHR._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[340] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_sendStatusRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in XHR.sendStatus from command: " + cmd );
			return false;
		}
		
		obj[ "statNum" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "statNum" ] === undefined )
		{
			NgLogE("Could not parse statNum in XHR.sendStatus from command: " + cmd );
			return false;
		}
		
		obj[ "statStr" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "statStr" ] === undefined )
		{
			NgLogE("Could not parse statStr in XHR.sendStatus from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_sendHeadersRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in XHR.sendHeaders from command: " + cmd );
			return false;
		}
		
		obj[ "headers" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "headers" ] === undefined )
		{
			NgLogE("Could not parse headers in XHR.sendHeaders from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_sendDataRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in XHR.sendData from command: " + cmd );
			return false;
		}
		
		obj[ "data" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "data" ] === undefined )
		{
			NgLogE("Could not parse data in XHR.sendData from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_onFinishRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in XHR.onFinish from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseBool( cmd[ 0 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in XHR.onFinish from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":340,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":340,2," + this.__objectRegistryId );
	},
	
	/** @private */
	_startSendGen: function( method, url, data, headers )
	{
		Core.Proc.appendToCommandString( ":340,7," + this.__objectRegistryId + "," + Core.Base64.encode( method ) + "," + Core.Base64.encode( url ) + "," + Core.Base64.encode( data ) + "," + headers  );
	},
	
	/** @private */
	_headerSendGen: function( item, content )
	{
		Core.Proc.appendToCommandString( "," + Core.Base64.encode( item ) + "," + Core.Base64.encode( content )  );
	},
	
	/** @private */
	_setCompositionSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":340,9," + this.__objectRegistryId );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// _sendStatusRecv: function( cmd ) {}
	// _sendHeadersRecv: function( cmd ) {}
	// _sendDataRecv: function( cmd ) {}
	// _onFinishRecv: function( cmd ) {}
	// start: function( method, url, data, headers ) {}
	
	// header: function( item, content ) {}
	
	// setComposition: function(  ) {}
	

// {{/Wg Generated Code}}

// API
	/**
	 * Initialize a request for this <code>XHR</code>.
	 *
	 * <b>Note:</b> Calling <code>open()</code> will wipe all request headers. You must set them after making this call.
	 *
	 * @param {String}
	 *            method The request method 
	 * 		(<code>GET</code>, <code>POST</code>, <code>OPTIONS</code>, <code>HEAD</code>,  
	 *		<code>PUT</code>, <code>DELETE</code>, <code>TRACE</code>, <code>CONNECT</code>)
	 * @param {String}
	 *            url The request URL.
	 * @param {Boolean}
	 *            [async=true] Returns <code>true</code> if the request is synchronous. Returns <code>false</code> in all other cases.<br><br> 
	 * 		<b>Note:</b> Currently not implemented.
	 * @param {String}
	 *            [user] Username for basic authentication.<br><br> 
	 *		<b>Note:</b> Currently not implemented.
	 * @param {String}
	 *            [password] Password for basic authentication.
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	open: function(method, url, async, user, password)
	{
		url = url.split(' ').join('%20');
		this.settings =
		{
			"method": checkMethod(method),
			"url": Util.buildRelativeUrl(url),
			"async": async,
			"user": user,
			"password": password
		};

		// Check URL and set XHR flag appropriately
// 		var localServer = Caps.getServer();
// 		if (localServer == url.substr(0, localServer.length) && Caps.getPlatformOS() == "Android")
// 		{
// 			this.NXS = true;
// 		}

		if (this.me && this.sendFlag)
		{
			http.abort(this.me);
		}
		this.reset();
		this.setState(State.OPENED);
	},

	/**
	* @ private
	* Send a request initialized by the <code>open()</code> method. 
	* @param {Array} [composition] Array of strings and file names to be composed into the body.<br><br>
	* <b>Note:</b> This parameter is ignored if <code>readyState</code> is set as <code>GET</code> or <code>HEAD</code>.
	* @throws {INVALID_STATE_ERR} If <code>readyState</code> is set as anything other than <code>OPENED</code> or if the <code>send()</code> flag is true.
	* @see Network.XHR#open
	* @status iOS, Android
	*/

	sendComposition: function(comp)
	{
		// ex: [{"str":"string to send"},{"file":"path/to/file.bin"},{"str":"more goods"}]
		this.composing = true;
		this.send(JSON.stringify(comp));
	},

	/**
	* Send a request initialized by the <code>open()</code> method.
	* @param {String} [data] The request entity body.<br><br>
	* <b>Note:</b> This parameter is ignored if <code>readyState</code> is set as <code>GET</code> or <code>HEAD</code>.
	* @throws {INVALID_STATE_ERR} If <code>readyState</code> is set as anything other than <code>OPENED</code> or if the <code>send()</code> flag is true.
	* @see Network.XHR#open
	* @status iOS, Android, Test, iOSTested, AndroidTested
	*/
	send: function(data)
	{
		if (this.readyState != State.OPENED || this.sendFlag)
		{
			throw "INVALID_STATE_ERR: " + (this.sendFlag ? "Already sending" : "in state " + this.readyState);
		}
		this.sendFlag = true;

		if (data && this.settings.method != "GET" && this.settings.method != "HEAD")
		{
			// TODO http://www.w3.org/TR/XMLHttpRequest/#the-send-method step 3
		}

		this.errorFlag = false;

		// Set content length header
		if (this.settings.method == "GET" || this.settings.method == "HEAD")
		{
			data = null;
		}
		else if (data)
		{
			var bFound = false;
			for (var i in this.headers)
			{
				if (this.headers[i].item == "Content-Type")
				{
					bFound = true;
					break;
				}
			}
			if (!bFound)
			{
				this.setRequestHeader("Content-Type", "text/plain;charset=UTF-8");
			}
		}

		this.responseText = "";

		// Send data to the server
		if (!data)
		{
			data = "";
		}

		ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);

/* Not supporting NXS. Could remove it, but maybe we will support it one day */
		if (this.NXS)
		{
			this.me = http.create(this);
			for (var i in this.headers)
			{
				var h = this.headers[i];
				http.addHeader(this.me, h.item + ": " + h.content);
			}
			http.send(this.me, this.settings.method, this.settings.url, data);
		}
		else
		{
			if (this.composing)
				this._setCompositionSendGen();

			this._startSendGen(this.settings.method, this.settings.url, data, this.headers.length);
			for (var i in this.headers)
			{
				var obj = this.headers[i];
				this._headerSendGen(obj.item, obj.content);
			}
		}
	}, // this.send() 

	/**
	 * Cancel any existing or pending network activity for this <code>XHR</code>. 
	 * This method is invoked using the specification outlined by W3C.
	 * @see <a href="http://www.w3.org/TR/XMLHttpRequest/#the-abort-method">W3C specification outline for <code>abort()</code></a>
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	abort: function()
	{
		this.responseText = null;
		this.errorFlag = true;
		this.headers = [];

		if (this.sendFlag)
		{
			if (this.NXS)
			{
				http.abort(this.me);
			}

			if (this.readyState != State.DONE)
			{
				this.sendFlag = false;
				this.setState(State.DONE);
			}
		}
		this.readyState = State.UNSENT;
	},

	/**
	 * Retrieve a header from the server response.
	 *
	 * @param {String}
	 *            header Name of header to retrieve.
	 * @returns {String} Text of the header or <code>null</code> if text does not exist.
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getResponseHeader: function(header)
	{
		if (this.readyState > State.OPENED)
		{
			return this.respHeaders[header.toLowerCase()];
		}
		return null;
	},

	/**
	 * Nonstandard: Retrieve the key-value map of all response headers.
	 *
	 * @return {Object} A key-value map as an object.
     * @status iOS, Android, Test, iOSTested, AndroidTested
     */
	getUnflattenedResponseHeaders: function()
	{
		return this.respHeaders;
	},

	/**
	 * Retrieve all the response headers from a request.
	 * This method is invoked using the specification outlined by W3C.
	 * @return {String} All the response headers from a request.
	 * @see <a href="http://www.w3.org/TR/XMLHttpRequest/#the-getallresponseheaders-method">W3C specification outline for <code>getAllResponseHeaders()</code>.</a>
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getAllResponseHeaders: function()
	{
		if (this.readyState < State.HEADERS_RECEIVED || this.errorFlag)
		{
			return "";
		}

		var result = "";
		for (var i in this.respHeaders)
		{
			result += i + ": " + this.respHeaders[i] + "\r\n";
		}
		return result.substr(0, result.length - 2);
	},

	/**
	 * Set a header for the request.
	 *
	 * @param {String}
	 *            header The name of the header.
	 * @param {String}
	 *            value The value of the header.
	 * @see Network.XHR#getRequestHeader
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	setRequestHeader: function(header, value)
	{
		this.headers.push(new Header(header, value));
	},

	/**
	 * Retrieve a header from the request.
	 *
	 * @param {String} header The name of the header.
	 * @return {String} The value of the header.
	 * @see Network.XHR#setRequestHeader
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getRequestHeader: function(header)
	{
		var ret = null;
		for (var i in this.headers)
		{
			if (this.headers[i].item == header)
			{
				ret = this.headers[i].content;
				break;
			}
		}
		return ret;
	},

// Receivers
    /*
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	onStatus: function ( num, str)
	{
		this.status = num;
		this.statusText = str;
	},

	_sendStatusRecv: function( cmd )
	{
		var obj = {};
		this._sendStatusRecvGen(cmd, obj);
		this.onStatus(obj.statNum, obj.statStr);
	},
    /*
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	onHeaders: function(str)
	{
		var lines = str.split('\n');
		lines.pop();
		for (var i in lines)
		{
			var match = headerEx.exec(lines[i]);
			if (match)
				this.respHeaders[match[1].toLowerCase()] = match[2];
		}
		this.setState(State.HEADERS_RECEIVED);
	},

	_sendHeadersRecv: function( cmd )
	{
		var obj = {};
		this._sendHeadersRecvGen(cmd, obj);
		this.onHeaders(obj.headers);
	},
    /*
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	onData: function(data)
	{
		this.responseText += data;
		this.setState(State.LOADING);
	},

	_sendDataRecv: function( cmd )
	{
		var obj = {};
		this._sendDataRecvGen(cmd, obj);
		this.onData(obj.data);
	},
    /*
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	onFinish: function (err)
	{
		this.sendFlag = false;
		if (err)
		{
			this.responseText = null;
			this.error = "Network Error";
			this.errorFlag = true;
			this.status = 0;
		}
		this.setState(State.DONE);
	},

	_onFinishRecv: function( cmd )
	{
		var obj = {};
		this._onFinishRecvGen(cmd, obj);
		this.onFinish(obj.error);
	},

// Internal methods
	/**
	 * Reset all fields from a request. This call sets <code>readyState</code> to <code>UNSENT</code> 
	 * and the response properties to <code>null</code>.
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	reset: function()
	{
		this.headers = [];
		this.readyState = State.UNSENT;
		this.responseText = null;
		this.responseXML = null;
		this.composing = false;
	},
	/**
	 * Change the value of <code>readyState</code> and call <code>onreadystatechange()</code>.
	 *
	 * @param {Number}
	 *            state The new value for <code>readyState</code>
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	setState: function(state)
	{
		this.readyState = state;
		if (state == State.DONE)
		{
			this._destroySendGen();
			ObjectRegistry.unregister(this);
		}
		if (typeof this.onreadystatechange != 'undefined')
		{
			try
			{
				this.onreadystatechange();
			}
			catch (e)
			{
				NgLogException(e);
			}
		}
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Network/DownloadFile'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Network/DownloadFile'] || {}; $MODULE_REGISTRY['NGCore/Client/Network/DownloadFile'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class DownloadFile
// Downloads a file to the sandbox
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var Class = require('NGCore/Client/Core/Class').Class;

////////////////////////////////////////////////////////////////////////////////

exports.DownloadFile = Class.subclass(
/** @lends Network.DownloadFile.prototype */
{
	classname: 'DownloadFile',
	/**
	* @class The <code>DownloadFile</code> class constructs objects that conduct a file download through an HTTP request.
	* @constructs The default constructor. 
	* @augments Core.Class
	*/
	initialize: function() {},

	/**
	  * Initiate a file download.
	  * @example var url = 'http://url/to/stuff/
	  * new Network.DownloadFile).start(filename, 'GET', url, [], (function(status, md5)
	  * @param {String} filename A local and relative path for storing the downloaded data.
	  * @param {String} method The HTTP method to use.  For example, <code>GET</code> or <code>POST</code>.
	  * @param {String} url The URL of the downloaded file.
	  * @param {Object} [headers] A dictionary that maps header names to header values.
	  * @param {Function} [callback] A callback function for notification
	  * of when the download completes. The signature for the callback is equivalent
	  * to:<br><br>
	  * <pre>function(statusCode,fileSignature)</pre><br>
	  * The <code>fileSignature</code> is currently the
	  * md5 checksum of the file.
	  * @type void
      * @status iOS, Android, Test, iOSTested, AndroidTested
	  */
	start: function(filename, method, url, headers, callback)
	{
		ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);

		url = url.split(' ').join('%20');
		// Check headers
		if (!(headers instanceof Array))
		{
			NgLogE('Improper headers sent('+headers+'). Need an array, ex: ["Content-Easter: egg"]');
			headers = [];
		}

		// Send the goods
		this.__sendSendGen( filename, method, url, headers.length );

		// Send headers
		for (var i in headers)
		{
			this.__headerSendGen(headers[i].item, headers[i].content);
		}

		// Save the callback
		this.mCB = callback
	},

	abort: function()
	{
		this._destroySendGen();
		ObjectRegistry.unregister(this);
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 341
	// Method create = -1
	// Method destroy = 2
	// Method _send = 3
	// Method _header = 4
	// Method finish = 5
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 5:
					instance._finishRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in DownloadFile._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in DownloadFile._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[341] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_finishRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in DownloadFile.finish from command: " + cmd );
			return false;
		}
		
		obj[ "status" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "status" ] === undefined )
		{
			NgLogE("Could not parse status in DownloadFile.finish from command: " + cmd );
			return false;
		}
		
		obj[ "signature" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "signature" ] === undefined )
		{
			NgLogE("Could not parse signature in DownloadFile.finish from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":341,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":341,2," + this.__objectRegistryId );
	},
	
	/** @private */
	__sendSendGen: function( fileName, method, url, headers )
	{
		Core.Proc.appendToCommandString( ":341,3," + this.__objectRegistryId + "," + Core.Base64.encode( fileName ) + "," + Core.Base64.encode( method ) + "," + Core.Base64.encode( url ) + "," + headers  );
	},
	
	/** @private */
	__headerSendGen: function( item, content )
	{
		Core.Proc.appendToCommandString( "," + Core.Base64.encode( item ) + "," + Core.Base64.encode( content )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// _send: function( fileName, method, url, headers ) {}
	
	// _header: function( item, content ) {}
	
	// _finishRecv: function( cmd ) {}

// {{/Wg Generated Code}}
	
	_finishRecv: function( cmd )
	{
		this._destroySendGen();
		
		var obj = {};
		this._finishRecvGen(cmd, obj);

		if (this.mCB)
			this.mCB(obj.status, obj.signature);

		ObjectRegistry.unregister(this);
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Network/Util'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Network/Util'] || {}; $MODULE_REGISTRY['NGCore/Client/Network/Util'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Utilities for Network
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var Caps = require('NGCore/Client/Core/Capabilities').Capabilities;
var Time = require('NGCore/Client/Core/Time').Time;
var LifecycleEmitter = require('NGCore/Client/Device/LifecycleEmitter').LifecycleEmitter;

////////////////////////////////////////////////////////////////////////////////

var urlPathServerSplit = /^(https?:\/\/)?([^\/]*)(.*[^\/])?.?/i;

var Util = exports.Util =
{
    /*
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	NormalizeUrl: function(url, keepTrailingSlash)
	{
		url = Util.buildRelativeUrl(url);

		// Now split it into parts and make server bits lower case
		var parsed = url.match(urlPathServerSplit);
		if (parsed && parsed[1])
		{
			// absolute path!
			url = parsed[1].toLowerCase() + parsed[2].toLowerCase() + (parsed[3] ? parsed[3] : "");
		}
		else
		{
			// Direct server, no path
			url = url.toLowerCase();
		}
		return url;
	},

	buildRelativeUrl: function(url)
	{
		if (!url.match(/^(https?:\/\/)/))
		{
			// If the path is relative, then we append our server to the beginning of it
			if (url.charAt(0) == '/' || !url.length)
			{
				url = Caps.getServer() + url;
			}
			else
			{
				url = Caps.getServer() + "/" + Caps.getGame() + "/" + url;
			}
		}

		return url;
	},

	RetrySchedule: function(initialRetry, maxDuration)
	{
		var count = Math.floor(Math.log(maxDuration / initialRetry));
		var schedule = [initialRetry];
		for(var i=0; i < count + 1; ++i)
		{
			initialRetry *= 2;
			schedule.push(initialRetry);
		}
		return schedule;
	},
	
	OperationWithRetries: function(operationCb, failureCb, failEarly)
	{
		var abortAttempts;
		var abortTime;
		var abortTimeAttempts;
		
		if(failEarly)
		{
			abortAttempts = 3;
			abortTime = 10000;
			abortTimeAttempts = 1;
		}
		else
		{
			abortAttempts = Infinity;
			abortTime = 30000;
			abortTimeAttempts = 6;
		}
		
		// console.log('retry config abortAttempts:', abortAttempts, 'abortTime', abortTime, 'abortTimeAttempts', abortTimeAttempts);
		
		abortTime = Core.Time.getRealTime() + abortTime;
		var timeout = 250;
		var attemptCount = 1;
		
		var failed = false;
		var armed = true;
		
		var failureParam = function()
		{
			if(failed) return;
			
			if(!armed)
			{
				console.log('OperationWithRetries: failureParam called when not armed');
				return;
			}
			armed = false;
			
			if(attemptCount >= abortAttempts)
			{
				console.log('OperationWithRetries: too many retry attempts');
				var failed = true;
				failureCb();
				return;
			}
			
			if(Core.Time.getRealTime() >= abortTime && attemptCount >= abortTimeAttempts)
			{
				console.log('OperationWithRetries: retries took too long');
				console.log('OperationWithRetries: abortTime:', abortTime, 'realTime:', Core.Time.getRealTime());
				console.log('OperationWithRetries: attemptCount:', attemptCount, 'abortTimeAttempts:', abortTimeAttempts);
				var failed = true;
				failureCb();
				return;
			}
			
			console.log('OperationWithRetries: Failure, will retry in ' + timeout + 'ms');
			setTimeout(function()
			{
				if(failed) return;
				armed = true;
				operationCb(failureParam, abortParam);
			}, timeout);
			
			attemptCount += 1;
			timeout *= 2;
		};
		
		var abortParam = function()
		{
			var failed = true;
			failureCb();
		};
		
		operationCb(failureParam, abortParam);
		
		return abortParam;
	},
	
	showFatalErrorDialog: function(status)
	{
		// Set up info dialog
		var myAlert = new AlertDialog();
		myAlert.setTitle(Core.Localization.getString("Network failure"));
		myAlert.setChoices([Core.Localization.getString("Exit")]);

		myAlert.onchoice =
		function(ret)
		{
			myAlert.hide();
			LifecycleEmitter.exitProcess();
		};
		
		// TODO: Move this list somewhere localizable
		var commonErrors = {
			'302': "File location has changed (302)",
			'400': "Bad request to server (400)",
			'401': "Authorization failed (401)",
			'403': "Server permissions error (403)",
			'404': "Resource not found (404)",
			'408': "Request timed out (408)",
			'500': "Internal server error (500)",
			'501': "Cannot process request (501)",
			'502': "Bad Gateway (502)",
			'503': "Service overloaded / down for maintenance (503)",
			'504': "Timeout at intervening gateway (504)"
		};
		myAlert.setText( Core.Localization.getString( commonErrors[status] || "This application requires a working data connection." ) );
		myAlert.show();
	},

	showSimpleNetworkError: function(status)
	{
		// Set up info dialog
		var myAlert = new AlertDialog();
		myAlert.setTitle(Core.Localization.getString("Network failure"));
		myAlert.setChoices([Core.Localization.getString("OK")]);

		myAlert.onchoice =
		function(ret)
		{
			myAlert.hide();
		};

		// TODO: Move this list somewhere localizable
		var commonErrors = {
			'302': " File location has changed (302)",
			'400': " Bad request to server (400)",
			'401': " Authorization failed (401)",
			'403': " Server permissions error (403)",
			'404': " Resource not found (404)",
			'408': " Request timed out (408)",
			'500': " Internal server error (500)",
			'501': " Cannot process request (501)",
			'502': " Bad Gateway (502)",
			'503': " Service overloaded / down for maintenance (503)",
			'504': " Timeout at intervening gateway (504)"
		};
		var message = "Cannot download game without network connection.";
		if (commonErrors[status])
		{
			message += commonErrors[status];
		}
		myAlert.setText( Core.Localization.getString( message ) );
		myAlert.show();
	},
	
	getCacheBustingString: function()
	{
		return '?t=' + (new Date()).getTime();
	}
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Network/_int_Util'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Network/_int_Util'] || {}; $MODULE_REGISTRY['NGCore/Client/Network/_int_Util'] = exports; ///////////////////////////////////////////////////////////////////////////////
// Class _int_Util
//
// Copyright (C) 2011 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var Class = require('NGCore/Client/Core/Class').Class;
////////////////////////////////////////////////////////////////////////////////

exports._int_Util = Class.singleton(
/** @lends Network._int_Util.prototype */
{
	classname: '_int_Util',
	
	/**
	 * Function.
	 * @constructs
	 * @augments Core.Class
	 */
	initialize: function()
	{
		this._callbackID = 0;
		this._callbacks = [];

		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
	},
	
// {{?Wg Generated Code}}
	
	// Enums.
	ProcID:
	{ 
		/** High privilege proc */
		Persist: -1,
		/** Low priv */
		Game: -2,
	},
	
	///////
	// Class constants (for internal use only):
	// Class ID = 350
	// Method create = -1
	// Method destroy = 2
	// Method sign = 3
	// Method signCallback = 4
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 4:
					instance._signCallbackRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in _int_Util._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in _int_Util._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[350] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_signCallbackRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in _int_Util.signCallback from command: " + cmd );
			return false;
		}
		
		obj[ "signature" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "signature" ] === undefined )
		{
			NgLogE("Could not parse signature in _int_Util.signCallback from command: " + cmd );
			return false;
		}
		
		obj[ "callbackID" ] = Core.Proc.parseInt( cmd[ 1 ] );
		if( obj[ "callbackID" ] === undefined )
		{
			NgLogE("Could not parse callbackID in _int_Util.signCallback from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":350,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":350,2," + this.__objectRegistryId );
	},
	
	/** @private */
	_signSendGen: function( baseString, callbackID, environment )
	{
		Core.Proc.appendToCommandString( ":350,3," + this.__objectRegistryId + "," + Core.Base64.encode( baseString ) + "," + callbackID + "," + Core.Base64.encode( environment )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// sign: function( baseString, callbackID, environment ) {}
	
	// _signCallbackRecv: function( cmd ) {}

// {{/Wg Generated Code}}

	sign: function( baseString, environment, callback) {
		this._callbacks[this._callbackID] = callback;
		this._signSendGen(baseString,this._callbackID, environment);
		this._callbackID++;
	},
	_signCallbackRecv: function( cmd ) {
		var msg = {};
		if (! this._signCallbackRecvGen(cmd, msg)) {
			return;
		}
		var func = this._callbacks[parseInt(msg.callbackID)];
		if (func) {
			func(msg.signature);
		}
	}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/MessageEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/MessageEmitter'] || {}; $MODULE_REGISTRY['NGCore/Shared/MessageEmitter'] = exports; var Class = require('NGCore/Shared/Class').Class;
var MessageListener = require('NGCore/Shared/MessageListener').MessageListener;

exports.MessageEmitter = Class.subclass(
/** @lends Core.MessageEmitter.prototype */
{
	classname: 'MessageEmitter',
	
	/**
	 * @status iOS, Android, Flash
	 * @class The <code>MessageEmitter</code> class constructs emitter objects that send messages to registered <code>{@link Core.MessageListener}</code> objects. 
	 * When a defined condition triggers an emitter, all registered listener objects are in turn triggered.
	 * <br><br>
	 * Emitter objects support two communication modes: emit and chain. When emitting, each listener is called in turn.
	 * When chaining, each listener can halt the propagation of a message to 
	 * other listeners by returning <code>true</code> from their callback.
	 * <br><br>
	 * Each listener can include an optional priority ranking. Priority determines the order
	 * in which an emitter calls each listener. 
	 * If two listener objects are registered with the same priority, the emitter calls them in the order they were registered. 
	 * The default priority is <code>0</code>. 
	 * <br><br>
	 * <b>Note:</b> Do not instantiate this class directly. Use classes derived from <code>MessageEmitter</code> for instantiation. This includes:
	 * <div class="ul">
	 * <li>{@link Core.Localization}</li>
	 * <li>{@link Core.UpdateEmitter}</li>
	 * <li>{@link Device.KeyEmitter}</li>
	 * <li>{@link Device.LifecycleEmitter}</li>
	 * <li>{@link Device.LocationEmitter}</li>
	 * <li>{@link Device.MemoryEmitter}</li>
	 * <li>{@link Device.MotionEmitter}</li>
	 * <li>{@link Device.NetworkEmitter}</li>
	 * <li>{@link Device.OrientationEmitter}</li>
	 * <li>{@link Device.ShakeEmitter}</li>
	 * </div>
	 * @constructs The default constructor.
	 * @augments Core.Class
	 */
	initialize: function()
	{
		this._messageListenersCount = 0;
		this._messageListenerRecords = [];
		this._messageDeferredWork = [];
		this._messageShouldDefer = false;
	},
	
	/**
	 * Unregister all <code>MessageListener</code> objects from this <code>MessageEmitter</code>.<br><br>
	 * <b>Note:</b> Do not use the emitter after calling this.
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	destroy: function($super)
	{
		if(this._messageShouldDefer)
		{
			this._messageDeferredWork.push(this._destroyActual.bind(this, $super));
		}
		else
		{
			this._destroyActual($super);
		}
	},
	
	_destroyActual: function(superDestroy)
	{
		// Unregister all listeners.
		var records = this._messageListenerRecords;
		while(records.length)
		{
			this.removeListener(records[0].l);
		}
		
		if(superDestroy)
			superDestroy();
	},
	
	/**
	 * Retrieve the number of <code>MessageListener</code> objects registered with this <code>MessageEmitter</code>.
	 * @returns {Number} The current number of <code>MessageListener</code> objects.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getListenerCount: function()
	{
		return this._messageListenersCount;
	},
	
	/**
	 * Add a <code>MessageListener</code> to this <code>MessageEmitter</code>. When an application calls <code>emit()</code> 
	 * or <code>chain()</code> 
	 * on this emitter, a callback function passed as a parameter is called on the specified listener.
	 * The parameters for the callback function are identical to parameters for <code>emit()</code> or
	 * <code>chain()</code>.
	 * <br><br>
	 * <b>Note:</b> Each listener can only listen to an emitter one time.<br><br>
	 * The following code examples illustrate different call styles for <code>addListener()</code>.
	 *
	 * @example
	 * emitter.addListener(myListener, myListener.onCallback);
	 *
	 * @example
	 * emitter.addListener(myListener, myListener.onEvent, 200);
	 *
	 * @param {Core.MessageListener} listener The <code>MessageListener</code> to add.
	 * @param {Function} func The callback function.
	 * @param {Number} [priority=0] The priority for this <code>MessageListener</code>.
	 * @throws {MessageEmitter.addListener: listener is already listening} Calling <code>addListener()</code> multiple times on the same emitter
	 * with the same listener.
	 * @throws {MessageEmitter.addListener: listener must be instances of MessageListener} Listener is not an instance of <code>MessageListener</code>.
	 * @see Core.MessageEmitter#removeListener,
	 * @see Core.MessageEmitter#emit,
	 * @see Core.MessageEmitter#chain
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	addListener: function(listener, func, priority)
	{
		if(!listener instanceof MessageListener)
			throw new Error('MessageEmitter.addListener: listener must be instances of MessageListener');
			
		if(!listener._startListeningEmitter(this))
			throw new Error('MessageEmitter.addListener: listener is already listening');
			
		if(!priority)
		{
			priority = 0;
		}
		
		this._messageListenersCount++;	
		if(this._messageShouldDefer)
		{
			this._messageDeferredWork.push(this._addListenerActual.bind(this, listener, func, priority));
		}
		else
		{
			this._addListenerActual(listener, func, priority);
		}
	},
	
	_addListenerActual: function(listener, func, priority)
	{
		//  The priority for default value is <code>0</code>
		if ((typeof priority) == 'undefined') {
			priority = 0;
		}
		// TODO Replace with binary search.
		var records = this._messageListenerRecords;
		var len = records.length;
		for(var i=0; i < len; ++i)
		{
			if(records[i].p <= priority)
				break;
		}
		records.splice(i, 0, {l: listener, f: func, p: priority});
	},
	
	/**
	 * Remove a <code>MessageListener</code> from this <code>MessageEmitter</code>.<br><br> 
	 * The following code examples illustrate different call styles for <code>removeListener</code>.
	 * @example
	 * emitter.removeListener(myListener, myListener.onCallback);
	 * @example
	 * emitter.removeListener(myListener);
	 *
	 * @param {Core.MessageListener} listener The <code>MessageListener</code> to remove.
	 * @returns {Boolean} Returns <code>true</code> if the registered listener was removed. Returns <code>false</code> if the registered listener is not found 
	 * or is not registered with this emitter.
	 * @throws {MessageEmitter.removeListener: listener is not listening} Specified listener is not currently registered
	 * with this <code>MessageEmitter</code>.
	 * @see Core.MessageEmitter#addListener
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	removeListener: function(listener)
	{
		if(!listener._stopListeningEmitter(this))
			//throw new Error('MessageEmitter.removeListner: listener is not listening');
			return false;
		
		this._messageListenersCount--;
		if(this._messageShouldDefer)
		{
			// TODO Replace with binary search.
			var records = this._messageListenerRecords;
			var len = records.length;
			for(var i=0; i < len; ++i)
			{
				var record = records[i];
				if(record.l == listener)
				{
					record.f = null;
					break;
				}
			}
			
			this._messageDeferredWork.push(this._removeListenerActual.bind(this, listener));
		}
		else
		{
			this._removeListenerActual(listener);
		}
		
		return true;
	},
	
	_removeListenerActual: function(listener)
	{
		// TODO Replace with binary search.
		var records = this._messageListenerRecords;
		var len = records.length;
		for(var i=0; i < len; ++i)
		{
			var record = records[i];
			if(record.l == listener)
			{
				records.splice(i, 1);
				break;
			}
		}
	},
	
	/**
	 * Send a message to every registered <code>MessageListener</code>. This emitter will trigger all listeners
	 * in descending order based on the listener priority. All listener callback functions are generated
	 * with parameters passed to <code>emit()</code>.
	 * @param {Parameters} parameters Parameters to pass in the generated callback funtion.
	 * @see Core.MessageEmitter#chain
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	emit: function(params)
	{
		var handled = false;
		if(this._messageShouldDefer)
		{
			this._messageDeferredWork.push(this._emitActual.bind(this, arguments, false));
		}
		else
		{
			handled = this._emitActual(arguments, true);
		}
		return handled;
	},
	
	_emitActual: function(params, executeDeferred)
	{
		this._messageShouldDefer = true;
		
		var records = this._messageListenerRecords;
		var len = records.length;
		var handled = false;
		for(var i=0; i < len; ++i)
		{
			var record = records[i];
			if(!record.f) continue;
			
			if(record.f.apply(record.l, params))
				handled = true;
		}

		if(!handled)
		{
			//NgLogD("No listeners handling emitted key");
		}
		
		this._messageShouldDefer = false;
		
		if(this._messageDeferredWork.length && executeDeferred)
		{
			this._executeDeferred();
		}

		return handled;
	},
	
	/**
	 * Send a message to every registered <code>MessageListener</code> through a chain of command. 
	 * This emitter will trigger all listeners in descending order based on the listener priority.
	 * All listener callback functions are generated with parameters passed to <code>chain()</code>.	 
	 * <br><br>
	 * Unlike <code>emit()</code>, <code>chain()</code> allows a <code>MessageListener</code> to halt propagation of a message 
	 * to other listener objects by returning <code>true</code> for the callback function.
	 * This is useful for things like touch event handling. A <code>MessageListener</code> can respond to a touch event
	 * by returning <code>true</code>, masking the touch event from other listener objects.
	 *
	 * @param {Parameters} parameters Parameters to pass in the generated callback funtion.
	 * @returns {Boolean} Returns <code>true</code> if the registered listener responded. Returns <code>false</code> in all other cases.
	 * <br><br>
	 * <b>Note:</b> If the application calls <code>chain()</code> recursively from
	 * within a message handler callback, it will always return <code>undefined</code>
	 * regardless of if a <code>MessageListener</code> responds or not.
	 * @see Core.MessageEmitter#emit
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	chain: function(params)
	{
		if(this._messageShouldDefer)
		{
			this._messageDeferredWork.push(this._chainActual.bind(this, arguments, false));
			return undefined;
		}
		else
		{
			return this._chainActual(arguments, true);
		}
	},
	
	_chainActual: function(params, executeDeferred)
	{
		var result = false;
		this._messageShouldDefer = true;
		
		var records = this._messageListenerRecords;
		var len = records.length;
		for(var i=0; i < len; ++i)
		{
			var record = records[i];
			if(!record.f) continue;
			
			if(record.f.apply(record.l, params))
			{
				result = true;
				break;
			}
		}
		
		this._messageShouldDefer = false;
		
		if(this._messageDeferredWork.length && executeDeferred)
		{
			this._executeDeferred();
		}
		
		return result;
	},
	
	_executeDeferred: function()
	{
		// NOTE: Don't factor out deferred.length. Deferred work can add more deferred work.
		var deferred = this._messageDeferredWork;
		for(var i=0; i < deferred.length; ++i)
		{
			deferred[i]();
		}
		this._messageDeferredWork = [];
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/MessageListener'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/MessageListener'] || {}; $MODULE_REGISTRY['NGCore/Shared/MessageListener'] = exports; var Class = require('NGCore/Shared/Class').Class;

exports.MessageListener = Class.subclass(
/** @lends Core.MessageListener.prototype */
{
	classname: 'MessageListener',
	
	/**
	 * @class The <code>MessageListener</code> class is a base class for constructing objects that listen for notifications from emitters 
	 * (see <code>{@link Core.MessageEmitter}</code>). Objects of this type are registered with emitters.
	 * When <code>{@link Core.MessageEmitter#emit}</code> or <code>{@link Core.MessageEmitter#chain}</code> is called on an emitter
	 * all registered listeners will generate a callback function.
	 * <br><br>
	 * Applications must unregister listener objects when they are no longer required in one of three ways: 
	 * <div class="ul"><font size="3">
	 * <li>Calling <code>{@link Core.MessageEmitter#removeListener}</code> on the <code>MessageEmitter</code>.</li>
	 * <li>Calling <code>{@link Core.MessageEmitter#destroy}</code> on the <code>MessageEmitter</code>.</li>
	 * <li>Calling <code>{@link Core.MessageListener#destroy}</code> on the <code>MessageListener</code></li>
	 * </font></div><br>
	 * <font size="3"><b>Note:</b> Applications should not attempt to register a listener with an emitter more than once. Registering a listener with an emitter
	 * multiple times results in exceptions. </font>
	 * @example
	 * var MyListener = Core.MessageListener.subclass(
	 * {
	 *     myCallback: function(verb, value)
	 *     {
	 *         console.log('MyListener.myCallback(' + verb + ', ' + value + ')');
	 *     },
	 * }
	 * var listener = new MyListener();
	 * emitter.addListener(listener, listener.myCallback);
	 * emitter.emit('fun', 5);
	 * @constructs The default constructor.
	 * @augments Core.Class
	 * @status iOS, Android, Flash
	 */
	initialize: function()
	{
		this._messageEmitters = [];
	},
	
	/**
	 * Unregister this <code>MessageListener</code> from all emitters.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	destroy: function()
	{
		// Unregister from all emitters.
		var emitters = this._messageEmitters;
		while(emitters.length)
			emitters[0].removeListener(this);
	},
	
	// Called by MessageEmitter when this receiver starts listening.
	_startListeningEmitter: function(emitter)
	{
		var emitters = this._messageEmitters;
		var index = emitters.indexOf(emitter);
		if(index !== -1)
			return false;
		
		emitters.push(emitter);
		return true;
	},
	
	// Called by MessageEmitter when this receiver stops listening.
	_stopListeningEmitter: function(emitter)
	{
		var emitters = this._messageEmitters;
		var index = emitters.indexOf(emitter);
		if(index === -1)
			return false;
		
		emitters.splice(index, 1);
		return true;
	},
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/_int_LGL'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/_int_LGL'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/_int_LGL'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class _int_LGL
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


var Class = require('NGCore/Client/Core/Class').Class;
var Proc = require('NGCore/Client/Core/Proc').Proc;
var Base64 = require('NGCore/Client/Core/Base64').Base64;
var toMD5 = require('NGCore/Client/Core/toMD5').toMD5;

////////////////////////////////////////////////////////////////////////////////
function getCorrectedPlatformOS() {
	var os = Capabilities.getPlatformOS();
	switch (os) {
		case 'Android': return 'android';
		case 'iPhone OS': return 'ios';
	}
	return os;
};

function expandTexName(name)
{
	var list =
	{
		"pvr": "GL_IMG_texture_compression_pvrtc",
		"atc": "GL_AMD_compressed_ATC_texture",
		"etc1": "GL_OES_compressed_ETC1_RGB8_texture",
		"3dc": "GL_AMD_compressed_3DC_texture"
	};

	return list[name] || name;
};

var overridePropertyEvaluators = {
	isMatch: function(condition, value) {
		// Return true if the condition holds for the provided value
		// condition may be prefixed with an operator, so we extract it.
		var symbol;
		switch (condition.charAt(0)) {
		case '>':
			symbol = (condition.charAt(1) == '=') ? '>=' : '>';
			break;
		case '<':
			symbol = (condition.charAt(1) == '=') ? '<=' : '<';
			break;
		}
		// Consume any characters we detected, then set the default operation (equals)
		if (symbol) {
			condition = condition.slice(symbol.length);
		} else symbol = '=';

		if (condition == value) {
			return (symbol == '=' || symbol == '<=' || symbol == '>=');
		} else if (condition < value) {
			return (symbol == '<' || symbol == '<=');
		} else {
			return (symbol == '>' || symbol == '>=');
		}
	},

	isVersionMatch: function(condition, value) {
		// Return true if the condition holds for the provided value
		// condition may be prefixed with an operator, so we extract it.
		var symbol;
		if (condition.length > 0) switch (condition.charAt(0)) {
		case '>':
			symbol = (condition.charAt(1) == '=') ? '>=' : '>';
			break;
		case '<':
			symbol = (condition.charAt(1) == '=') ? '<=' : '<';
			break;
		case '=':
			symbol = (condition.charAt(1) == '=') ? '==' : '=';
			break;
		}
		// Consume any characters we detected, or set the default operation (equals)
		if (symbol) {
			condition = condition.slice(symbol.length);
		} else symbol = '=';

		var condition = condition.split('.');
		var value = value.split('.');

		var l = Math.max(condition.length, value.length);

		for (var i = 0; i < l; i++) {
			var ci = '0.' + (condition[i] || 0);
			var vi = '0.' + (value[i] || 0);
			if (ci == vi) continue;
			if (ci < vi) {
				return (symbol == '<' || symbol == '<=');
			} else {
				return (symbol == '>' || symbol == '>=');
			}
		}
		return true;
	},

	'sdkVersion': function(v) {
		return this.isVersionMatch('' + v, Capabilities.getSDKVersion());
	},

	'binaryVersion': function(v) {
		return this.isVersionMatch('' + v, Capabilities.getBinaryVersion());
	},

	'platformOS': function(v) {
		return v == getCorrectedPlatformOS();
	},

	'platformOSVersion': function(v) {
		return this.isVersionMatch('' + v, Capabilities.getPlatformOSVersion());
	},

	'platformHW': function(v) {
		return v == Capabilities.getPlatformHW();
	},

	'physicalMem': function(v) {
		return this.isMatch(v, Capabilities.getPhysicalMem());
	},

	'physicalCpus': function(v) {
		return this.isMatch(v, Capabilities.getPhysicalCpus());
	},

	'activeCpus': function(v) {
		return this.isMatch(v, Capabilities.getActiveCpus());
	},

	'language': function(v) {
		return v == Capabilities.getLanguage();
	},

	'textureMatch': "none",
	'textureCompression': function(v) {
		var matched = Capabilities.getOglExtensions().indexOf(expandTexName(v)) > -1;
		if (matched) this.textureMatch = v;
		return matched;
	},

	'screenWidth': function(v) {
		return this.isMatch(v, Capabilities.getScreenWidth());
	},

	'screenHeight': function(v) {
		return this.isMatch(v, Capabilities.getScreenHeight());
	},

	'screenResolution': function(v) {
		return v == (Capabilities.getScreenWidth() + 'x' + Capabilities.getScreenHeight());
	},

	'screenUnits': function(v) {
		return this.isMatch(v, Capabilities.getScreenUnits());
	},

	'screenPixelUnits': function(v) {
		return this.isMatch(v, Capabilities.getScreenPixelUnits());
	},

	'maxTextureSize': function(v) {
		return this.isMatch(v, Capabilities.getMaxTextureSize());
	},
	
	'reset': function(v) {
		this.textureMatch = "none";
	}
};

var _int_LGL = Class.singleton(
/** @lends Core._int_LGL.prototype */
{
	classname: '_int_LGL',

	launch: function(url, proc)
	{
		var Util = require('NGCore/Client/Network/Util').Util;
		// Default to game proc. Games should actually not be aware of the third option,
		//	as they cannot use it anyway.
		if (!proc)
			proc = _int_LGL.ProcID.Game;

		url = Util.NormalizeUrl(url);

//		console.log("launching game url " + url);

		var run = (function()
		{
			gNgShutdownPending = true;
			this._launchSendGen(url,proc);
		}).bind(this);

		if (proc == _int_LGL.ProcID.Game)
		{
			this.updateGameUse(url, run);
		}
		else
		{
			run();
		}
	},

	updateAvailable: function(game, doneCB, errorCB)
	{
		// Normalize URL
		var url = game;
		if (! url.match(/^\//) && !url.match(/https?:\/\//))
			url = '/' + url;

		var caps = require('NGCore/Client/Core/Capabilities').Capabilities;

		// If we are testing ourselves, we don't to md5 our url
		var name = "";
		if (caps.getUrl() != game)
		{
			var Util = require('NGCore/Client/Network/Util').Util;
			url = Util.NormalizeUrl(url);
			name = toMD5(url);
		}

		// Get device-specific manifest directory
		var buildPath = {"Android" : "android", "iPhone OS" : "ios", "flash" : ""};
		// Get Device capabilities platformOs
		var build = "/" + buildPath[caps.getPlatformOS()];

		var DownloadManifest = require('NGCore/Client/Network/DownloadManifest').DownloadManifest;
		var dm = new DownloadManifest();

		dm.isUpdated(url + build, name, false, doneCB, errorCB);
	},

// Utility (non-generated) functionality
	updateGameUse: function(game, doneCB)
	{
		var name = toMD5(game);
		var self = this;
		var KeyValueCache = require('NGCore/Client/Storage/KeyValue').KeyValueCache;
		this.mGameStore = KeyValueCache.global("Core.GameList");
		this.mActiveGameKey = "activeGames";

		// Get our list of games
		this.mGameStore.getItem(this.mActiveGameKey,
			function(error, value)
			{
				var list;
				if (value)
					list = JSON.parse(value);
				else
					list = [];

				var item;
				for (var i in list)
				{
					if (list[i].name == name)
					{
						item = list[i];
						break;
					}
				}

				if (!item)
				{
					item = {"name": name};
					list.push(item);
				}

				item.lastRun = (new Date()).getTime();
				item.url = game;

 				self.mGameStore.setItem(self.mActiveGameKey, JSON.stringify(list));

                LocalGameList.updateGameList(list);
 				doneCB();
			}, true
		);
	},
	
	getManifestName: function(config) {
		var manifestName = 'webgame.ngmanifest';

		if (config && config.manifestOverrides) {
			try {
				var overrides = config.manifestOverrides;

				for (var i = 0; i < overrides.length; i++) {
					var override = overrides[i];
					if (override && override.criteria) {
						// Clear any matched values...
						overridePropertyEvaluators.reset();

						var criteria = override.criteria;
						var overrideMatched = true;
						for (var key in criteria) {
							if (!criteria.hasOwnProperty(key)) continue;
							var value = criteria[key];

							var evaluator = overridePropertyEvaluators[key];
							if (typeof evaluator != 'function') {
								console.log("ERROR! Undefined criterion " + key + " in configuration.json");
								overrideMatched = false;
								break;
							}

							var criterionMatched = false;
							if (value instanceof Array) {
								for (vi = 0; vi < value.length; vi++) {
									criterionMatched |= evaluator.call(overridePropertyEvaluators, value[vi]);
									if (criterionMatched) break;
								}
							} else {
								criterionMatched = evaluator(value);
							}

							if (!criterionMatched) {
								overrideMatched = false;
								break;
							}
						}

						// At this point, the override has matched. Figure out its name and return the value.
						if (overrideMatched) {
							console.log("MATCHED Override: " + JSON.stringify(override));

							// Format the override manifest name:
							var format = override.manifest.slice(0);
							for (var fi = 1; fi < format.length; fi++) {
								var key = format[fi];
								switch (key) {
								case 'textureCompression':
									format[fi] = overridePropertyEvaluators.textureMatch;
									break;
								case 'platformOS':
									format[fi] = getCorrectedPlatformOS();
									break;
								default:
									// Look up the named property on Capabilities.
									var cap = Capabilities['get' + key.charAt(0).toUpperCase() + key.slice(1)]();
									format[fi] = cap.replace(' ', '_');
								}
							}

							return require('NGCore/Shared/Lib/sprintf').sprintf(format);
						} else {
							console.log("DID NOT MATCH Override: " + JSON.stringify(override));
						}
					}
				}
			} catch (e) {
				console.log("ERROR! Exception occurred in manifest overrides: " + e);
			}
		}

		return manifestName;
	},

// {{?Wg Generated Code}}
	
	// Enums.
	ProcID:
	{ 
		/** High privilege proc */
		Persist: -1,
		/** Low priv */
		Game: -2,
	},
	
	///////
	// Class constants (for internal use only):
	// Class ID = 342
	// Method launch = -1
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Proc.parseInt( cmd.shift(), 10 );
			var instance = ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in _int_LGL._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in _int_LGL._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[342] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_launchSendGen: function( url, proc )
	{
		Proc.appendToCommandString( ":342,-1," + Base64.encode( url ) + "," + proc  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $launch: function( url, proc ) {}
	

// {{/Wg Generated Code}}

});

exports._int_LGL = _int_LGL;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/Lib/md5'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/Lib/md5'] || {}; $MODULE_REGISTRY['NGCore/Shared/Lib/md5'] = exports; /*
 * A JavaScript implementation of the RSA Data Security, Inc. MD5 Message
 * Digest Algorithm, as defined in RFC 1321.
 * Version 2.2 Copyright (C) Paul Johnston 1999 - 2009
 * Other contributors: Greg Holt, Andrew Kepert, Ydnar, Lostinet
 * Distributed under the BSD License
 * See http://pajhome.org.uk/crypt/md5 for more info.
 */

/*
 * Calculate the MD5 of a raw string
 */
function rstr_md5(s)
{
  return binl2rstr(binl_md5(rstr2binl(s), s.length * 8));
}

/*
 * Convert a raw string to a hex string
 */
function rstr2hex(input)
{
  var hex_tab = "0123456789abcdef";
  var output = "";
  var x;
  for(var i = 0; i < input.length; i++)
  {
    x = input.charCodeAt(i);
    output += hex_tab.charAt((x >>> 4) & 0x0F)
           +  hex_tab.charAt( x        & 0x0F);
  }
  return output;
}

/*
 * Encode a string as utf-8.
 * For efficiency, this assumes the input is valid utf-16.
 */
function str2rstr_utf8(input)
{
  var output = "";
  var i = -1;
  var x, y;

  while(++i < input.length)
  {
    /* Decode utf-16 surrogate pairs */
    x = input.charCodeAt(i);
    y = i + 1 < input.length ? input.charCodeAt(i + 1) : 0;
    if(0xD800 <= x && x <= 0xDBFF && 0xDC00 <= y && y <= 0xDFFF)
    {
      x = 0x10000 + ((x & 0x03FF) << 10) + (y & 0x03FF);
      i++;
    }

    /* Encode output as utf-8 */
    if(x <= 0x7F)
      output += String.fromCharCode(x);
    else if(x <= 0x7FF)
      output += String.fromCharCode(0xC0 | ((x >>> 6 ) & 0x1F),
                                    0x80 | ( x         & 0x3F));
    else if(x <= 0xFFFF)
      output += String.fromCharCode(0xE0 | ((x >>> 12) & 0x0F),
                                    0x80 | ((x >>> 6 ) & 0x3F),
                                    0x80 | ( x         & 0x3F));
    else if(x <= 0x1FFFFF)
      output += String.fromCharCode(0xF0 | ((x >>> 18) & 0x07),
                                    0x80 | ((x >>> 12) & 0x3F),
                                    0x80 | ((x >>> 6 ) & 0x3F),
                                    0x80 | ( x         & 0x3F));
  }
  return output;
}

/*
 * Convert a raw string to an array of little-endian words
 * Characters >255 have their high-byte silently ignored.
 */
function rstr2binl(input)
{
  var output = Array(input.length >> 2);
  for(var i = 0; i < output.length; i++)
    output[i] = 0;
  for(var i = 0; i < input.length * 8; i += 8)
    output[i>>5] |= (input.charCodeAt(i / 8) & 0xFF) << (i%32);
  return output;
}

/*
 * Convert an array of little-endian words to a string
 */
function binl2rstr(input)
{
  var output = "";
  for(var i = 0; i < input.length * 32; i += 8)
    output += String.fromCharCode((input[i>>5] >>> (i % 32)) & 0xFF);
  return output;
}

/*
 * Calculate the MD5 of an array of little-endian words, and a bit length.
 */
function binl_md5(x, len)
{
  /* append padding */
  x[len >> 5] |= 0x80 << ((len) % 32);
  x[(((len + 64) >>> 9) << 4) + 14] = len;

  var a =  1732584193;
  var b = -271733879;
  var c = -1732584194;
  var d =  271733878;

  for(var i = 0; i < x.length; i += 16)
  {
    var olda = a;
    var oldb = b;
    var oldc = c;
    var oldd = d;

    a = md5_ff(a, b, c, d, x[i+ 0], 7 , -680876936);
    d = md5_ff(d, a, b, c, x[i+ 1], 12, -389564586);
    c = md5_ff(c, d, a, b, x[i+ 2], 17,  606105819);
    b = md5_ff(b, c, d, a, x[i+ 3], 22, -1044525330);
    a = md5_ff(a, b, c, d, x[i+ 4], 7 , -176418897);
    d = md5_ff(d, a, b, c, x[i+ 5], 12,  1200080426);
    c = md5_ff(c, d, a, b, x[i+ 6], 17, -1473231341);
    b = md5_ff(b, c, d, a, x[i+ 7], 22, -45705983);
    a = md5_ff(a, b, c, d, x[i+ 8], 7 ,  1770035416);
    d = md5_ff(d, a, b, c, x[i+ 9], 12, -1958414417);
    c = md5_ff(c, d, a, b, x[i+10], 17, -42063);
    b = md5_ff(b, c, d, a, x[i+11], 22, -1990404162);
    a = md5_ff(a, b, c, d, x[i+12], 7 ,  1804603682);
    d = md5_ff(d, a, b, c, x[i+13], 12, -40341101);
    c = md5_ff(c, d, a, b, x[i+14], 17, -1502002290);
    b = md5_ff(b, c, d, a, x[i+15], 22,  1236535329);

    a = md5_gg(a, b, c, d, x[i+ 1], 5 , -165796510);
    d = md5_gg(d, a, b, c, x[i+ 6], 9 , -1069501632);
    c = md5_gg(c, d, a, b, x[i+11], 14,  643717713);
    b = md5_gg(b, c, d, a, x[i+ 0], 20, -373897302);
    a = md5_gg(a, b, c, d, x[i+ 5], 5 , -701558691);
    d = md5_gg(d, a, b, c, x[i+10], 9 ,  38016083);
    c = md5_gg(c, d, a, b, x[i+15], 14, -660478335);
    b = md5_gg(b, c, d, a, x[i+ 4], 20, -405537848);
    a = md5_gg(a, b, c, d, x[i+ 9], 5 ,  568446438);
    d = md5_gg(d, a, b, c, x[i+14], 9 , -1019803690);
    c = md5_gg(c, d, a, b, x[i+ 3], 14, -187363961);
    b = md5_gg(b, c, d, a, x[i+ 8], 20,  1163531501);
    a = md5_gg(a, b, c, d, x[i+13], 5 , -1444681467);
    d = md5_gg(d, a, b, c, x[i+ 2], 9 , -51403784);
    c = md5_gg(c, d, a, b, x[i+ 7], 14,  1735328473);
    b = md5_gg(b, c, d, a, x[i+12], 20, -1926607734);

    a = md5_hh(a, b, c, d, x[i+ 5], 4 , -378558);
    d = md5_hh(d, a, b, c, x[i+ 8], 11, -2022574463);
    c = md5_hh(c, d, a, b, x[i+11], 16,  1839030562);
    b = md5_hh(b, c, d, a, x[i+14], 23, -35309556);
    a = md5_hh(a, b, c, d, x[i+ 1], 4 , -1530992060);
    d = md5_hh(d, a, b, c, x[i+ 4], 11,  1272893353);
    c = md5_hh(c, d, a, b, x[i+ 7], 16, -155497632);
    b = md5_hh(b, c, d, a, x[i+10], 23, -1094730640);
    a = md5_hh(a, b, c, d, x[i+13], 4 ,  681279174);
    d = md5_hh(d, a, b, c, x[i+ 0], 11, -358537222);
    c = md5_hh(c, d, a, b, x[i+ 3], 16, -722521979);
    b = md5_hh(b, c, d, a, x[i+ 6], 23,  76029189);
    a = md5_hh(a, b, c, d, x[i+ 9], 4 , -640364487);
    d = md5_hh(d, a, b, c, x[i+12], 11, -421815835);
    c = md5_hh(c, d, a, b, x[i+15], 16,  530742520);
    b = md5_hh(b, c, d, a, x[i+ 2], 23, -995338651);

    a = md5_ii(a, b, c, d, x[i+ 0], 6 , -198630844);
    d = md5_ii(d, a, b, c, x[i+ 7], 10,  1126891415);
    c = md5_ii(c, d, a, b, x[i+14], 15, -1416354905);
    b = md5_ii(b, c, d, a, x[i+ 5], 21, -57434055);
    a = md5_ii(a, b, c, d, x[i+12], 6 ,  1700485571);
    d = md5_ii(d, a, b, c, x[i+ 3], 10, -1894986606);
    c = md5_ii(c, d, a, b, x[i+10], 15, -1051523);
    b = md5_ii(b, c, d, a, x[i+ 1], 21, -2054922799);
    a = md5_ii(a, b, c, d, x[i+ 8], 6 ,  1873313359);
    d = md5_ii(d, a, b, c, x[i+15], 10, -30611744);
    c = md5_ii(c, d, a, b, x[i+ 6], 15, -1560198380);
    b = md5_ii(b, c, d, a, x[i+13], 21,  1309151649);
    a = md5_ii(a, b, c, d, x[i+ 4], 6 , -145523070);
    d = md5_ii(d, a, b, c, x[i+11], 10, -1120210379);
    c = md5_ii(c, d, a, b, x[i+ 2], 15,  718787259);
    b = md5_ii(b, c, d, a, x[i+ 9], 21, -343485551);

    a = safe_add(a, olda);
    b = safe_add(b, oldb);
    c = safe_add(c, oldc);
    d = safe_add(d, oldd);
  }
  return Array(a, b, c, d);
}

/*
 * These functions implement the four basic operations the algorithm uses.
 */
function md5_cmn(q, a, b, x, s, t)
{
  return safe_add(bit_rol(safe_add(safe_add(a, q), safe_add(x, t)), s),b);
}
function md5_ff(a, b, c, d, x, s, t)
{
  return md5_cmn((b & c) | ((~b) & d), a, b, x, s, t);
}
function md5_gg(a, b, c, d, x, s, t)
{
  return md5_cmn((b & d) | (c & (~d)), a, b, x, s, t);
}
function md5_hh(a, b, c, d, x, s, t)
{
  return md5_cmn(b ^ c ^ d, a, b, x, s, t);
}
function md5_ii(a, b, c, d, x, s, t)
{
  return md5_cmn(c ^ (b | (~d)), a, b, x, s, t);
}

/*
 * Add integers, wrapping at 2^32. This uses 16-bit operations internally
 * to work around bugs in some JS interpreters.
 */
function safe_add(x, y)
{
  var lsw = (x & 0xFFFF) + (y & 0xFFFF);
  var msw = (x >> 16) + (y >> 16) + (lsw >> 16);
  return (msw << 16) | (lsw & 0xFFFF);
}

/*
 * Bitwise rotate a 32-bit number to the left.
 */
function bit_rol(num, cnt)
{
  return (num << cnt) | (num >>> (32 - cnt));
}

var toMD5 = function(s) { return rstr2hex(rstr_md5(str2rstr_utf8(s))); }

/*
 * Perform a simple self-test to see if the VM is working
 */
function md5_vm_test()
{
  return toMD5("abc").toLowerCase() == "900150983cd24fb0d6963f7d28e17f72";
}

exports.toMD5 = toMD5;
exports.testMD5 = md5_vm_test;; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Storage/KeyValue'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Storage/KeyValue'] || {}; $MODULE_REGISTRY['NGCore/Client/Storage/KeyValue'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class KeyValue
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


var Core = require('NGCore/Client/Core').Core;

////////////////////////////////////////////////////////////////////////////////

function KeyValueCache() {
};
exports.KeyValueCache = KeyValueCache;
/** @private */
KeyValueCache.lruMeanCacheSize = 100;
/** @private */
KeyValueCache.instanceMap = {};
//TODO: rename this later
var StorageGlobalScopes = [];

KeyValueCache.optimizeCaches = function() 
{
	for (var storeKey in KeyValueCache.instanceMap) {
		if(KeyValueCache.instanceMap.hasOwnProperty(storeKey)) {
			KeyValueCache.instanceMap[storeKey].optimize();
		}
	}
};

KeyValueCache.lowMemoryWarning = function() 
{
	for (var storeKey in KeyValueCache.instanceMap) {
		if(KeyValueCache.instanceMap.hasOwnProperty(storeKey)) {
			var instance = KeyValueCache.instanceMap[storeKey];
			instance.data = {};

			//Purge entries in callbacks
			var newCallbacks = {};
			newCallbacks.uidGenerator = instance.callbacks.uidGenerator;
			for(var cbId in instance.callbacks)
			{
				if(instance.callbacks.hasOwnProperty(cbId)) {
					if(instance.callbacks[cbId]) {
						newCallbacks = instance.callbacks[cbId];
					}
				}
			}
			instance.callbacks = newCallbacks;
		}
	}
};

KeyValueCache.init = function()
{
	KeyValueCache.local = new Storage.KeyValue();
	KeyValueCache.local.registerForKey("local");
};

/**
 * @static Scopes this <code>KeyValueCache</code> object as global. A globally scoped KeyValueCache object can be used by multiple applications for the same data. 
 * @param {String} globalKey The store key for the <code>KeyValueCache</code> object.
 */
KeyValueCache.global = function(globalKey)
{
	if(StorageGlobalScopes[globalKey])
	{
		return StorageGlobalScopes[globalKey];
	}

	//Miss Global Table Cache.
	var scope = new Storage.KeyValue();
	scope.registerForKey(globalKey);
	StorageGlobalScopes[globalKey] = scope;
	return scope;
};

exports.KeyValue = Core.Class.subclass(
/** @lends Storage.KeyValue.prototype */
{
	classname: "KeyValue",
	/**
	 * @class The <code>KeyValue</code> class constructs objects that allow you to manage application key/value pairs in a datastore.
	 * <div class="ul">
	 * <li>Call <code>KeyValueCache.local()</code> to access the <code>local</code> datastore for your application.</li>
	 * <li>Call <code>KeyValueCache.global(globalKey)</code> to access a globally scoped datastore. Multiple applications can use a globally scoped
	 * datastore for the same data. The <code>globalKey</code> parameter is a string that uniquely identifies the datastore.</li>
	 * </div>
	 *
	 * @constructs
	 * @augments Core.Class
	 */
	initialize: function()
	{
		/** @private */
		this.initialized = false;
		/** @private */
		this.origin = null;
		/** @private */
		this.callbacks = {};
		/** @private */
		this.callbacks.uidGenerator = 0;
		/** @private */
		this.local = false;
		/** @private */
		this.lruCacheShrinkCounter = 0;
	
		/** @private */
		this.data = {};
		/** @private */
		this.usage = {};
		
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
	},
	
	/**
	 * Destroy this instance and release resources on the backend.
	 */
	destroy: function()
	{
		this._destroySendGen();
		Core.ObjectRegistry.unregister(this);
	},
    /*
	 * @private
	 * Call <code>registerForKey()</code> to access a datastore identified by the value of the <code>storeKey</code> parameter.
	 * @param {String} storeKey The unique identifier of the datastore.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */	
	registerForKey: function(storeKey) 
	{
		this.origin = storeKey;
		KeyValueCache.instanceMap[storeKey] = this;

		//Push this instance across the native bridge
		this._registerCommandSendGen(this.origin,KeyValueCache.lruMeanCacheSize);
		
		return this;
	},
	/**
	 * Pass the value associated with the key to the callback function.
	 * @param {String} key The key that is associated with the value to pass to the callback function.
	 * @param {Function} callbackFunc The callback function that uses the value associated with the key.
	 * @param {Boolean} [ignoreCache=false] Set <code>ignoreCache</code> to <code>true</code> to force a read from storage.
	 * @example KeyValue.getItem(SomeKey, function(err){...})
     * @status iOS, Android, Test, iOSTested, AndroidTested     
	 */
	getItem: function(key,callbackFunc,ignoreCache /*defaults to false*/)
	{
		if(!ignoreCache)
		{
			if(this.data[key]) {
				callbackFunc(null,this.data[key],key);
				this.usage[key]++;
				return;
			}
			else
			{
				NgLogD("Value not found in cache for..falling back to native");
			}
		}

		//Generate unused callbackEntry
		var callbackId = this.callbacks.uidGenerator++;

		if(!!!callbackFunc) {
			callbackFunc = function(){};
		}
		this.callbacks[callbackId] = callbackFunc;

		this._getItemSendGen(this.origin,callbackId,key);
	},
	
	/**
	 * Associate a value with a key.
	 * @param {String} key The key to associate with the value.
	 * @param {String} value The value to associate with the key.
	 * @param {Function} [callbackFunc] A callback function with an error parameter. The error parameter is null when the <code>setItem()</code> function completes successfully.
	 * @example KeyValue.setItem(someKey, someValue, function(err){...})
     * @status iOS, Android, Test, iOSTested, AndroidTested          
	 */
	setItem: function(key,value,callbackFunc)
	{
		var value = value;
		this.data[key] = value;

		var callbackId = this.callbacks.uidGenerator++;
		if(!callbackFunc) {
			callbackFunc = function(){};
		}
		this.callbacks[callbackId] = callbackFunc;

		this._setItemSendGen(this.origin,callbackId,key,value);
	},
	
	/**
	 * Remove the value that is associated with a key.
	 * @param {String} key The key that is associated with the value to remove.
	 * @param {Function} [callbackFunc] A callback function with an error parameter. The error parameter is null when the <code>removeItem()</code> function completes successfully.
	 * @example KeyValue.removeItem(someKey, function(err){...})
     * @status iOS, Android, Test, iOSTested, AndroidTested     
	 */
	removeItem: function(key,callbackFunc)
	{
		var callbackId = this.callbacks.uidGenerator++;
		if(!!!callbackFunc) {
			callbackFunc = function(){};
		}
		this.callbacks[callbackId] = callbackFunc;

		this._removeItemSendGen(this.origin,callbackId,key);
	},

	/**
	 *  @private
	 * 	clear all key/value pairs stored within this store
	 *  @param {callbackFunc} The callback function to be called
     *  @status iOS, Android, Test, iOSTested, AndroidTested          
	 */
	clear: function(callbackFunc)
	{
		var callbackId = this.callbacks.uidGenerator++;
		if(!!!callbackFunc) {
			callbackFunc = function(){};
		}
		this.callbacks[callbackId] = callbackFunc;

		this._clearSendGen(this.origin,callbackId);
	},
    /*
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	enforceLRUCacheSize: function()
	{
		NgLogD("Enforcing KeyValue Cache Size");
		var tmp = [];
		for (var k in this.data) {
			if (this.data.hasOwnProperty(k)) {
				tmp.push(k);
			}
		}
		var usage = this.usage;
		tmp.sort(function(a,b) {
			var p1 = usage[a];
			if (!p1) {
				p1 = 0;
			}

			var p2 = usage[b];
			if (!p2) {
				p2 = 0;
			}

			if (p1 == p2) { return 0; }
			return p1 < p2 ? 1 : -1;
		});

		var oldData = this.data;
		this.data = {};
		//Copy over the lruMeanCache(number) most used entries
		var stopPoint = KeyValueCache.lruMeanCacheSize;
		for (var i = 0; i < stopPoint && i < tmp.length; i++)
		{
			if(!oldData[tmp[i]]) {
				//Case cache didn't contain that key at this point in time
				stopPoint++;
			}
			else {
				this.data[tmp[i]] = oldData[tmp[i]];
			}
		}
	},
	
	_getInstanceRecv : function(cmd)
	{
		var msg = {};
		if(!this._getInstanceRecvGen(cmd, msg))
			return;
			
		var storeKey = msg["storeKey"];

		var instance = KeyValueCache.instanceMap[storeKey];
		//NgLogD("Storage.getInstanceForCommand Found instance for key [" + storeKey + "]: " + instance + " (" + command + ")");
		return instance;
	},
	
	_registerCommandCbRecv : function(cmd)
	{		
		var msg = {};
		if(!this._registerCommandCbRecvGen(cmd, msg))
			return;
		
		//NgLogD("Storage registerCallback: "+command+"\n");
		if(msg["error"]){
			console.log("Storage: Error registering for KeyValue location '"+msg["error"]+"'");
			if(!this.initialized) {
				delete StorageGlobalScopes[msg["originalStoreKey"]];
			}
			return;
		}

		if(this.origin == "local") {
			this.local = true;
			StorageGlobalScopes[this.origin] = this;
		}

		this.origin = msg["storeKey"];
		this.initialized = true;
		
		for(var i=0; i < msg.preloadDataCount; ++i)
		{
			var preload = {};
			if(!this._preloadDataRecvGen(cmd, preload))
				return;
			
			this.data[preload.key] = preload.value;
		}
	},
	
	_getItemCommandCbRecv : function(cmd)
	{
		var msg = {};
		if(!this._getItemCommandCbRecvGen(cmd, msg))
			return;
		
		var cbId = msg["callbackId"];
		var error = msg["error"];
		var key = msg["key"];
		var value = msg["value"];
		if (error) {
			value = null;
		}

		this.data[key] = value;
		if(!this.usage[key]) {
			this.usage[key] = 1;
		} else {
			this.usage[key]++;
		}

		cb = this.callbacks[cbId];
		if(typeof cb == "function") {
			cb(error,value,key);
			this.callbacks[cbId] = null;
		}

		if(((this.lruCacheShrinkCounter++) % KeyValueCache.lruMeanCacheSize) === 0) {
			this.enforceLRUCacheSize();
		}
		return this;
	},
	
	_setItemCommandCbRecv : function(cmd)
	{
		var msg = {};
		if(!this._setItemCommandCbRecvGen(cmd, msg))
			return;
		
		var cbId = msg["callbackId"];
		var error = msg["error"];
		var key = msg["key"];

		if(!this.usage[key]) {
			this.usage[key] = 1;
		} else {
			this.usage[key]++;
		}
		
		//NgLogD("Storage.setItemCommand Found instance for key [" + key + "]: " + " (" + cbId + ")");

		cb = this.callbacks[cbId];
		if(typeof cb == "function") {
			//NgLogD("Storage.setItemCommand Found callback");
			cb(error,key);
			this.callbacks[cbId] = null;
		}
		if(((this.lruCacheShrinkCounter++) % KeyValueCache.lruMeanCacheSize) === 0) {
			this.enforceLRUCacheSize();
		}
	},
	
	_removeItemCbRecv : function(cmd)
	{
		var msg = {};
		if(!this._removeItemCbRecvGen(cmd, msg))
			return;
		
		var cbId = msg["callbackId"];
		var error = msg["error"];
		var key = msg["key"];
		delete this.usage[key];
		delete this.data[key];

		cb = this.callbacks[cbId];
		if(typeof cb == "function") {
			cb(error,key);
			this.callbacks[cbId] = null;
		}
	},
	
	_clearCommandCbRecv : function(cmd)
	{
		var msg ={};
		if(!this._clearCommandCbRecvGen(cmd, msg))
			return;
		
		var cbId = msg["callbackId"];
		var error = msg["error"];

		this.data = {};
		this.usage = {};

		cb = this.callbacks[cbId];
		if(typeof cb == "function") {
			cb(error,this.origin);
			this.callbacks[cbId] = null;
		}

	},

	
// {{?Wg Generated Code}}
	
	// Enums.
	/** 
	 * Enumeration for response types.
	 * @namespace
	 */
	Responses:
	{ 
		/** Register Storage */
		Register: 0,
		/** Get Item */
		GetItem: 1,
		/** Set Item */
		SetItem: 2,
		/** Remove Item */
		RemoveItem: 3,
		/** Clear All */
		Clear: 4,
	},
	
	///////
	// Class constants (for internal use only):
	// Class ID = 339
	// Method create = -1
	// Method destroy = 2
	// Method registerCommand = 3
	// Method getItem = 4
	// Method setItem = 5
	// Method removeItem = 6
	// Method clear = 7
	// Method getInstance = 8
	// Method registerCommandCb = 9
	// Method preloadData = 10
	// Method getItemCommandCb = 11
	// Method setItemCommandCb = 12
	// Method removeItemCb = 13
	// Method clearCommandCb = 14
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 8:
					instance._getInstanceRecv( cmd );
					break;
				case 9:
					instance._registerCommandCbRecv( cmd );
					break;
				case 10:
					instance._preloadDataRecv( cmd );
					break;
				case 11:
					instance._getItemCommandCbRecv( cmd );
					break;
				case 12:
					instance._setItemCommandCbRecv( cmd );
					break;
				case 13:
					instance._removeItemCbRecv( cmd );
					break;
				case 14:
					instance._clearCommandCbRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in KeyValue._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in KeyValue._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[339] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_getInstanceRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 3 )
		{
			NgLogE("Could not parse due to wrong argument count in KeyValue.getInstance from command: " + cmd );
			return false;
		}
		
		obj[ "response" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "response" ] === undefined )
		{
			NgLogE("Could not parse response in KeyValue.getInstance from command: " + cmd );
			return false;
		}
		
		obj[ "storeKey" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "storeKey" ] === undefined )
		{
			NgLogE("Could not parse storeKey in KeyValue.getInstance from command: " + cmd );
			return false;
		}
		
		obj[ "key" ] = Core.Proc.parseString( cmd[ 2 ] );
		if( obj[ "key" ] === undefined )
		{
			NgLogE("Could not parse key in KeyValue.getInstance from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_registerCommandCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length < 5 )
		{
			NgLogE("Could not parse due to wrong argument count in KeyValue.registerCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "response" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "response" ] === undefined )
		{
			NgLogE("Could not parse response in KeyValue.registerCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "originalStoreKey" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "originalStoreKey" ] === undefined )
		{
			NgLogE("Could not parse originalStoreKey in KeyValue.registerCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 2 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in KeyValue.registerCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "storeKey" ] = Core.Proc.parseString( cmd[ 3 ] );
		if( obj[ "storeKey" ] === undefined )
		{
			NgLogE("Could not parse storeKey in KeyValue.registerCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "preloadDataCount" ] = Core.Proc.parseInt( cmd[ 4 ] );
		if( obj[ "preloadDataCount" ] === undefined )
		{
			NgLogE("Could not parse preloadDataCount in KeyValue.registerCommandCb from command: " + cmd );
			return false;
		}
		
		cmd.splice(0, 5);
		return true;
	},
	
	/** @private */
	_preloadDataRecvGen: function( cmd, obj )
	{ 
		if( cmd.length < 2 )
		{
			NgLogE("Could not parse due to wrong argument count in KeyValue.preloadData from command: " + cmd );
			return false;
		}
		
		obj[ "key" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "key" ] === undefined )
		{
			NgLogE("Could not parse key in KeyValue.preloadData from command: " + cmd );
			return false;
		}
		
		obj[ "value" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "value" ] === undefined )
		{
			NgLogE("Could not parse value in KeyValue.preloadData from command: " + cmd );
			return false;
		}
		
		cmd.splice(0, 2);
		return true;
	},
	
	/** @private */
	_getItemCommandCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 6 )
		{
			NgLogE("Could not parse due to wrong argument count in KeyValue.getItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "response" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "response" ] === undefined )
		{
			NgLogE("Could not parse response in KeyValue.getItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "storeKey" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "storeKey" ] === undefined )
		{
			NgLogE("Could not parse storeKey in KeyValue.getItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 2 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in KeyValue.getItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 3 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in KeyValue.getItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "key" ] = Core.Proc.parseString( cmd[ 4 ] );
		if( obj[ "key" ] === undefined )
		{
			NgLogE("Could not parse key in KeyValue.getItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "value" ] = Core.Proc.parseString( cmd[ 5 ] );
		if( obj[ "value" ] === undefined )
		{
			NgLogE("Could not parse value in KeyValue.getItemCommandCb from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_setItemCommandCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 6 )
		{
			NgLogE("Could not parse due to wrong argument count in KeyValue.setItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "response" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "response" ] === undefined )
		{
			NgLogE("Could not parse response in KeyValue.setItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "storeKey" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "storeKey" ] === undefined )
		{
			NgLogE("Could not parse storeKey in KeyValue.setItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 2 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in KeyValue.setItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 3 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in KeyValue.setItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "key" ] = Core.Proc.parseString( cmd[ 4 ] );
		if( obj[ "key" ] === undefined )
		{
			NgLogE("Could not parse key in KeyValue.setItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "value" ] = Core.Proc.parseString( cmd[ 5 ] );
		if( obj[ "value" ] === undefined )
		{
			NgLogE("Could not parse value in KeyValue.setItemCommandCb from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_removeItemCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 5 )
		{
			NgLogE("Could not parse due to wrong argument count in KeyValue.removeItemCb from command: " + cmd );
			return false;
		}
		
		obj[ "response" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "response" ] === undefined )
		{
			NgLogE("Could not parse response in KeyValue.removeItemCb from command: " + cmd );
			return false;
		}
		
		obj[ "storeKey" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "storeKey" ] === undefined )
		{
			NgLogE("Could not parse storeKey in KeyValue.removeItemCb from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 2 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in KeyValue.removeItemCb from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 3 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in KeyValue.removeItemCb from command: " + cmd );
			return false;
		}
		
		obj[ "key" ] = Core.Proc.parseString( cmd[ 4 ] );
		if( obj[ "key" ] === undefined )
		{
			NgLogE("Could not parse key in KeyValue.removeItemCb from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_clearCommandCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 4 )
		{
			NgLogE("Could not parse due to wrong argument count in KeyValue.clearCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "response" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "response" ] === undefined )
		{
			NgLogE("Could not parse response in KeyValue.clearCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "storeKey" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "storeKey" ] === undefined )
		{
			NgLogE("Could not parse storeKey in KeyValue.clearCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 2 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in KeyValue.clearCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 3 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in KeyValue.clearCommandCb from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":339,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":339,2," + this.__objectRegistryId );
	},
	
	/** @private */
	_registerCommandSendGen: function( storeKey, lruMeanCacheSize )
	{
		Core.Proc.appendToCommandString( ":339,3," + this.__objectRegistryId + "," + Core.Base64.encode( storeKey ) + "," + lruMeanCacheSize  );
	},
	
	/** @private */
	_getItemSendGen: function( storeKey, callbackId, key )
	{
		Core.Proc.appendToCommandString( ":339,4," + this.__objectRegistryId + "," + Core.Base64.encode( storeKey ) + "," + callbackId + "," + Core.Base64.encode( key )  );
	},
	
	/** @private */
	_setItemSendGen: function( storeKey, callbackId, key, value )
	{
		Core.Proc.appendToCommandString( ":339,5," + this.__objectRegistryId + "," + Core.Base64.encode( storeKey ) + "," + callbackId + "," + Core.Base64.encode( key ) + "," + Core.Base64.encode( value )  );
	},
	
	/** @private */
	_removeItemSendGen: function( storeKey, callbackId, key )
	{
		Core.Proc.appendToCommandString( ":339,6," + this.__objectRegistryId + "," + Core.Base64.encode( storeKey ) + "," + callbackId + "," + Core.Base64.encode( key )  );
	},
	
	/** @private */
	_clearSendGen: function( storeKey, callbackId )
	{
		Core.Proc.appendToCommandString( ":339,7," + this.__objectRegistryId + "," + Core.Base64.encode( storeKey ) + "," + callbackId  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// registerCommand: function( storeKey, lruMeanCacheSize ) {}
	
	// getItem: function( storeKey, callbackId, key ) {}
	
	// setItem: function( storeKey, callbackId, key, value ) {}
	
	// removeItem: function( storeKey, callbackId, key ) {}
	
	// clear: function( storeKey, callbackId ) {}
	
	// _getInstanceRecv: function( cmd ) {}
	// _registerCommandCbRecv: function( cmd ) {}
	// _preloadDataRecv: function( cmd ) {}
	// _getItemCommandCbRecv: function( cmd ) {}
	// _setItemCommandCbRecv: function( cmd ) {}
	// _removeItemCbRecv: function( cmd ) {}
	// _clearCommandCbRecv: function( cmd ) {}

// {{/Wg Generated Code}}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/Lib/sprintf'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/Lib/sprintf'] || {}; $MODULE_REGISTRY['NGCore/Shared/Lib/sprintf'] = exports; /**
sprintf() for JavaScript 0.6

Copyright (c) Alexandru Marasteanu <alexaholic [at) gmail (dot] com>
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:
    * Redistributions of source code must retain the above copyright
      notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright
      notice, this list of conditions and the following disclaimer in the
      documentation and/or other materials provided with the distribution.
    * Neither the name of sprintf() for JavaScript nor the
      names of its contributors may be used to endorse or promote products
      derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL Alexandru Marasteanu BE LIABLE FOR ANY
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


Changelog:
2007.04.03 - 0.1:
 - initial release
2007.09.11 - 0.2:
 - feature: added argument swapping
2007.09.17 - 0.3:
 - bug fix: no longer throws exception on empty paramenters (Hans Pufal)
2007.10.21 - 0.4:
 - unit test and patch (David Baird)
2010.05.09 - 0.5:
 - bug fix: 0 is now preceeded with a + sign
 - bug fix: the sign was not at the right position on padded results (Kamal Abdali)
 - switched from GPL to BSD license
2010.05.22 - 0.6:
 - reverted to 0.4 and fixed the bug regarding the sign of the number 0
 Note:
 Thanks to Raphael Pigulla <raph (at] n3rd [dot) org> (http://www.n3rd.org/)
 who warned me about a bug in 0.5, I discovered that the last update was
 a regress. I appologize for that.
**/



exports.sprintf = function() {
	str_repeat = function(i, m) {
		for (var o = []; m > 0; o[--m] = i);
		return o.join('');
	};

	var params = new Array();
	var outputArray = false;
	var paramsConsumed = 1;
	if (typeof(arguments[0]) == 'object' && arguments[0].length) {
		outputArray = true;
		for (var i = 0; i < arguments[0].length; ++i) {
			params[i] = arguments[0][i];
		}
	} else {
		for (var i = 0; i < arguments.length; ++i) {
			params[i] = arguments[i];
		}
	}

	var i = 0, a, f = params[i++], o = [], m, p, c, x, s = '';
	while (f) {
		if (m = /^[^\x25]+/.exec(f)) {
			o.push(m[0]);
		}
		else if (m = /^\x25{2}/.exec(f)) {
			o.push('%');
		}
		else if (m = /^\x25(?:(\d+)\$)?(\+)?(0|'[^$])?(-)?(\d+)?(?:\.(\d+))?([b-fosuxX])/.exec(f)) {
			if (((a = params[m[1] || i++]) == null) || (a == undefined)) {
				throw('Too few arguments.');
			}
			if (/[^s]/.test(m[7]) && (typeof(a) != 'number')) {
				throw('Expecting number but found ' + typeof(a));
			}
			switch (m[7]) {
				case 'b': a = a.toString(2); break;
				case 'c': a = String.fromCharCode(a); break;
				case 'd': a = parseInt(a); break;
				case 'e': a = m[6] ? a.toExponential(m[6]) : a.toExponential(); break;
				case 'f': a = m[6] ? parseFloat(a).toFixed(m[6]) : parseFloat(a); break;
				case 'o': a = a.toString(8); break;
				case 's': a = ((a = String(a)) && m[6] ? a.substring(0, m[6]) : a); break;
				case 'u': a = Math.abs(a); break;
				case 'x': a = a.toString(16); break;
				case 'X': a = a.toString(16).toUpperCase(); break;
			}
			a = (/[def]/.test(m[7]) && m[2] && a >= 0 ? '+'+ a : a);
			c = m[3] ? m[3] == '0' ? '0' : m[3].charAt(1) : ' ';
			x = m[5] - String(a).length - s.length;
			p = m[5] ? str_repeat(c, x) : '';
			o.push(s + (m[4] ? a + p : p + a));
			if (outputArray) ++paramsConsumed;
		}
		else {
			throw('Huh ?!');
		}
		f = f.substring(m[0].length);
	}
	if (outputArray && paramsConsumed > 0) {
		arguments[0].splice(0, paramsConsumed);
	}
	return o.join('');
};

; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/LocationEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/LocationEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/LocationEmitter'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class LocationEmitter
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var Core = require('NGCore/Client/Core').Core;

////////////////////////////////////////////////////////////////////////////////

exports.LocationEmitter = Core.MessageEmitter.singleton(
/** @lends Device.LocationEmitter.prototype */
{
	classname: 'LocationEmitter',

	Accuracy:
	{
		LOW:    0, // less power consumption. equivalent to "3km"  in iOS
		MEDIUM: 1, // equivalent to "100m" in iOS
		HIGH:   2  // most accurate, high power consumption. equivalent to "Best" in iOS
	},

	Elements:
	{
		LATITUDE:  1,
		LONGITUDE: 2,
		ALTITUDE:  4,
		HEADING:   8  // equivalent to "bearing" in Android
	},

	/**
	 * @class The <code>LocationEmitter</code> class constructs a singleton object that emits <a href="Device.LocationEmitter.Location.html">Location</a> objects.<br><br>
     * @constructs The default constructor. 
 	 * @see Device.LocationEmitter.Location
	 * @augments Core.MessageEmitter
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
		this._lastLocation = undefined;
		this._forceListeners = [];
	},

	/**
	 * @param {LocationEmitter#Accuracy} Accuracy accuracy of updates. The default value is HIGH.
	 * @param {Number} elements OR-ed <code>LocationEmitter.Elements</code>. Example: LATITUDE | LONGITUDE. The default value is LATITUDE | LONGITUDE | ALTITUDE | HEADING (i.e. listens to all elements).
	 * @status
	 */
	setProperties: function(accuracy, elements)
	{
		if (! accuracy) accuracy = this.Accuracy.HIGH;
		if (! elements) elements = this.Elements.LATITUDE | this.Elements.LONGITUDE | this.Elements.ALTITUDE | this.Elements.HEADING;
		this.accuracy = accuracy;
		this.elements = elements;
		this._setPropertiesSendGen(accuracy,elements);
	},

	/**
	 * Add a <code>MessageListener</code> to this emitter. When an application calls <code>emit()</code> 
	 * or <code>chain()</code> 
	 * on this emitter, a callback function passed as a parameter is called on the specified listener.
	 * The parameters for the callback function are identical to parameters for <code>emit()</code> or
	 * <code>chain()</code>.
	 * <br><br>
	 * <b>Note:</b> Each listener can only listen to an emitter one time.<br><br>
	 * The following code examples illustrate different call styles for <code>addListener()</code>.
	 *
	 * @example
	 * emitter.addListener(myListener, myListener.onCallback);
	 *
	 * @example
	 * emitter.addListener(myListener, myListener.onEvent, 200);
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {Core.MessageListener} listener The <code>MessageListener</code> to add.
	 * @param {Function} func The callback function.
	 * @param {Number} [priority=0] The priority for this <code>MessageListener</code>.
	 * @throws {MessageEmitter.addListener: listener is already listening} Calling <code>addListener()</code> multiple times on the same emitter
	 * with the same listener.
	 * @throws {MessageEmitter.addListener: listener must be instances of MessageListener} Listener is not an instance of <code>MessageListener</code>.
	 * @see Device.LocationEmitter#removeListener,
	 * @see Core.MessageEmitter#emit,
	 * @see Core.MessageEmitter#chain
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	addListener: function($super, listener, func, forceStart, priority) {
		if(forceStart == undefined)
		{
			this._startUpdatingSendGen(true);
			this._forceListeners.push(listener);
		}
		else
		{
			this._startUpdatingSendGen(forceStart);
			if(forceStart == true)
				this._forceListeners.push(listener);
		}

		$super(listener, func, priority);
	},
	
	/**
	 * Remove a <code>MessageListener</code> from this emitter.<br><br> 
	 * The following code examples illustrate different call styles for <code>removeListener()</code>.
	 * @example
	 * emitter.removeListener(myListener, myListener.onCallback);
	 * @example
	 * emitter.removeListener(myListener);
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {Core.MessageListener} listener The <code>MessageListener</code> to remove.
	 * @returns {Boolean} Returns <code>true</code> if the registered listener was removed. Returns <code>false</code> if the registered listener is not found 
	 * or is not registered with this emitter.
	 * @throws {MessageEmitter.removeListener: listener is not listening} Specified listener is not currently registered
	 * with this emitter.
	 * @see Device.LocationEmitter#addListener
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	removeListener: function($super, listener) {
		$super(listener);

		var index = this._forceListeners.indexOf(listener);
		if(index != -1)
		{
			this._forceListeners.splice(index,1);
			if(this._forceListeners.length == 0)
				this._stopUpdatingSendGen();
		}
	},
    
	/**
	 * Retrieve the last location returned by this <code>LocationEmitter</code>.
	 * @returns {Device.LocationEmitter.Location} The last location returned.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getLastLocation: function()
	{
		if(this._lastLocation == undefined || !this._lastLocation.getPosition()) return undefined;
		
		return this._lastLocation;
	},
	
    _locationUpdatedRecv: function( cmd ) {
		var msg = {};
		if (!this._locationUpdatedRecvGen(cmd, msg))
		    return;
		
		if (((this.elements & this.Elements.LATITUDE) == 0)  &&
			((this.elements & this.Elements.LONGITUDE) == 0) &&
			((this.Elements & this.Elements.ALTITUDE) == 0))
			return;

		this._lastLocation = new this.Location(
			new Core.Point(msg["latitude"], msg["longitude"]),
			msg["altitude"],
			undefined,
			msg["accuracy"],
			msg["timestamp"]);

		this.emit(this._lastLocation);
    },
	
	_headingUpdatedRecv: function( cmd ) 
	{
		var msg = {};
		if (!this._headingUpdatedRecvGen(cmd, msg))
			return;
			
		if ((this.elements & this.Elements.HEADING) == 0)
			return;

		this._lastLocation = new this.Location(
			this._lastLocation ? this._lastLocation.getPosition() : undefined,
			this._lastLocation ? this._lastLocation.getAltitude() : undefined,
			msg['magneticHeading'],
			this._lastLocation ? this._lastLocation.getAccuracy() : undefined,
			msg['timestamp']);
		
		if(msg['magneticHeading']) {
			this.emit(this._lastLocation);
		}
	},
	
	Location: Core.Class.subclass(
	/** @lends Device.LocationEmitter.Location.prototype */
	{
		classname: 'Location',
		
		/**
		 * @class <code>Location</code> constructs objects that encapsulate the location of a device.
		 * <code>Location</code> objects contain spatial components, like position and heading information, and a timestamp that indicates when a location is measured.
		 * 
		 * @constructs The default constructor. 
		 * @param {Core.Point} position The latitude / longitude of the device.
		 * @param {Number} altitude The altitude of the device.
		 * @param {Number} heading The heading of the device.
		 * @param {Number} accuracy The accuracy of the measurement.
		 * @param {Number} timestamp The timestamp when the location was measured.
		 * @augments Core.Class
		 */
		initialize: function(position, altitude, heading, accuracy, timestamp)
		{
			this._position = position;
			this._altitude = altitude;
			this._accuracy = accuracy;
			this._heading = heading;
			this._timestamp = timestamp;
		},
		
		/**
		 * Return the position of this <code>Location</code> as latitude / longitude.
		 * @returns {Core.Point} The current latitude / longitude.
		 * @status iOS, Android, Test, iOSTested, AndroidTested
		 */
		getPosition: function()
		{
			return this._position;
		},
		
		/**
		 * Return the altitude of this <code>Location</code> in feet (ft).
		 * @returns {Number} The current altitude.
		 * @status iOS, Android, Test, iOSTested, AndroidTested
		 */
		getAltitude: function()
		{
			return this._altitude;
		},
		
		/**
		 * Return the heading of this <code>Location</code> in degrees east of north.
		 * @returns {Number} The current heading.
		 * @status iOS, Android, Test, iOSTested, AndroidTested
		 */
		getHeading: function()
		{
			return this._heading;
		},
		
		/**
		 * Return the accuracy of the measurement for this <code>Location</code>.
		 * @returns {Number} The current location accuracy.
		 * @status iOS, Android, Test, iOSTested, AndroidTested
		 */
		getAccuracy: function()
		{
			return this._accuracy;
		},
		
		/**
		 * Return the timestamp when this measurement was taken.
		 * Expressed in milliseconds since Epoch (Unix time).
		 * @returns {Number} The timestamp of the measurement.
		 * @status iOS, Android, Test, iOSTested, AndroidTested
		 */
		getTimestamp: function()
		{
			return this._timestamp;
		},
	}),
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 333
	// Method create = -1
	// Method destroy = 2
	// Method startUpdatingLocation = 3
	// Method stopUpdatingLocation = 4
	// Method locationUpdated = 5
	// Method startUpdatingHeading = 6
	// Method stopUpdatingHeading = 7
	// Method headingUpdated = 8
	// Method setProperties = 9
	// Method startUpdating = 10
	// Method stopUpdating = 11
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 5:
					instance._locationUpdatedRecv( cmd );
					break;
				case 8:
					instance._headingUpdatedRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in LocationEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in LocationEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[333] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_locationUpdatedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 5 )
		{
			NgLogE("Could not parse due to wrong argument count in LocationEmitter.locationUpdated from command: " + cmd );
			return false;
		}
		
		obj[ "timestamp" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "timestamp" ] === undefined )
		{
			NgLogE("Could not parse timestamp in LocationEmitter.locationUpdated from command: " + cmd );
			return false;
		}
		
		obj[ "latitude" ] = Core.Proc.parseFloat( cmd[ 1 ] );
		if( obj[ "latitude" ] === undefined )
		{
			NgLogE("Could not parse latitude in LocationEmitter.locationUpdated from command: " + cmd );
			return false;
		}
		
		obj[ "longitude" ] = Core.Proc.parseFloat( cmd[ 2 ] );
		if( obj[ "longitude" ] === undefined )
		{
			NgLogE("Could not parse longitude in LocationEmitter.locationUpdated from command: " + cmd );
			return false;
		}
		
		obj[ "altitude" ] = Core.Proc.parseFloat( cmd[ 3 ] );
		if( obj[ "altitude" ] === undefined )
		{
			NgLogE("Could not parse altitude in LocationEmitter.locationUpdated from command: " + cmd );
			return false;
		}
		
		obj[ "accuracy" ] = Core.Proc.parseFloat( cmd[ 4 ] );
		if( obj[ "accuracy" ] === undefined )
		{
			NgLogE("Could not parse accuracy in LocationEmitter.locationUpdated from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_headingUpdatedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 4 )
		{
			NgLogE("Could not parse due to wrong argument count in LocationEmitter.headingUpdated from command: " + cmd );
			return false;
		}
		
		obj[ "timestamp" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "timestamp" ] === undefined )
		{
			NgLogE("Could not parse timestamp in LocationEmitter.headingUpdated from command: " + cmd );
			return false;
		}
		
		obj[ "magneticHeading" ] = Core.Proc.parseFloat( cmd[ 1 ] );
		if( obj[ "magneticHeading" ] === undefined )
		{
			NgLogE("Could not parse magneticHeading in LocationEmitter.headingUpdated from command: " + cmd );
			return false;
		}
		
		obj[ "trueHeading" ] = Core.Proc.parseFloat( cmd[ 2 ] );
		if( obj[ "trueHeading" ] === undefined )
		{
			NgLogE("Could not parse trueHeading in LocationEmitter.headingUpdated from command: " + cmd );
			return false;
		}
		
		obj[ "accuracy" ] = Core.Proc.parseFloat( cmd[ 3 ] );
		if( obj[ "accuracy" ] === undefined )
		{
			NgLogE("Could not parse accuracy in LocationEmitter.headingUpdated from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":333,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":333,2," + this.__objectRegistryId );
	},
	
	/** @private */
	_startUpdatingLocationSendGen: function( accuracy, distanceFilter )
	{
		Core.Proc.appendToCommandString( ":333,3," + this.__objectRegistryId + "," + accuracy + "," + distanceFilter  );
	},
	
	/** @private */
	_stopUpdatingLocationSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":333,4," + this.__objectRegistryId );
	},
	
	/** @private */
	_locationUpdatedSendGen: function( timestamp, latitude, longitude, altitude, accuracy )
	{
		Core.Proc.appendToCommandString( ":333,5," + this.__objectRegistryId + "," + timestamp + "," + latitude + "," + longitude + "," + altitude + "," + accuracy  );
	},
	
	/** @private */
	_startUpdatingHeadingSendGen: function( orientation, angularFilter )
	{
		Core.Proc.appendToCommandString( ":333,6," + this.__objectRegistryId + "," + orientation + "," + angularFilter  );
	},
	
	/** @private */
	_stopUpdatingHeadingSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":333,7," + this.__objectRegistryId );
	},
	
	/** @private */
	_headingUpdatedSendGen: function( timestamp, magneticHeading, trueHeading, accuracy )
	{
		Core.Proc.appendToCommandString( ":333,8," + this.__objectRegistryId + "," + timestamp + "," + magneticHeading + "," + trueHeading + "," + accuracy  );
	},
	
	/** @private */
	_setPropertiesSendGen: function( accuracy, elements )
	{
		Core.Proc.appendToCommandString( ":333,9," + this.__objectRegistryId + "," + accuracy + "," + elements  );
	},
	
	/** @private */
	_startUpdatingSendGen: function( force )
	{
		Core.Proc.appendToCommandString( ":333,10," + this.__objectRegistryId + "," + ( force ? 1 : 0 )  );
	},
	
	/** @private */
	_stopUpdatingSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":333,11," + this.__objectRegistryId );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// startUpdatingLocation: function( accuracy, distanceFilter ) {}
	
	// stopUpdatingLocation: function(  ) {}
	
	// _locationUpdatedRecv: function( cmd ) {}
	// locationUpdated: function( timestamp, latitude, longitude, altitude, accuracy ) {}
	
	// startUpdatingHeading: function( orientation, angularFilter ) {}
	
	// stopUpdatingHeading: function(  ) {}
	
	// _headingUpdatedRecv: function( cmd ) {}
	// headingUpdated: function( timestamp, magneticHeading, trueHeading, accuracy ) {}
	
	// setProperties: function( accuracy, elements ) {}
	
	// startUpdating: function( force ) {}
	
	// stopUpdating: function(  ) {}
	

// {{/Wg Generated Code}}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/MemoryEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/MemoryEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/MemoryEmitter'] = exports; var Core = require('NGCore/Client/Core').Core;

exports.MemoryEmitter = Core.MessageEmitter.singleton(
/** @lends Device.MemoryEmitter.prototype */
{
	classname: 'MemoryEmitter',
		
	/**
	 * @class The <code>MemoryEmitter</code> class constructs a singleton object that emits messages
	 * when a low memory warning is received from the system.
	 * Applications can respond by releasing unused objects, allowing the system to re-allocate free memory.
	 * Failure to respond to low memory warnings may result in application 
	 * termination by the operating system.<br><br>
	 * <b>Note:</b> Applications should never directly allocate a singleton.
	 * @constructs The default constructor. 
	 * @augments Core.MessageEmitter
	 * @status iOS, Android, Test
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
	},
	
	_memoryEventRecv: function( cmd ) 
	{
		this.emit();
		
		//Cascade the original message back out to native for forwarding
		this._memoryEventSendGen();
	},
													  
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 331
	// Method create = -1
	// Method memoryEvent = 2
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._memoryEventRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in MemoryEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in MemoryEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[331] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_memoryEventRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 0 )
		{
			NgLogE("Could not parse due to wrong argument count in MemoryEmitter.memoryEvent from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":331,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_memoryEventSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":331,2," + this.__objectRegistryId );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _memoryEventRecv: function( cmd ) {}
	// memoryEvent: function(  ) {}
	

// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/MotionEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/MotionEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/MotionEmitter'] = exports; var Core = require('NGCore/Client/Core').Core;

exports.MotionEmitter = Core.MessageEmitter.singleton(
/** @lends Device.MotionEmitter.prototype */
{
	classname: 'MotionEmitter',
	
	/**
	 * @class The <code>MotionEmitter</code> class constructs a singleton object that tracks device movement through 3D space. 
	 * These objects emit <a href="Device.MotionEmitter.Motion.html">Motion</a> objects that retrieve spatial data for a given component from the device.<br><br>
	 * <b>Note:</b> Applications should never directly allocate a singleton.
	 * @constructs The default constructor. 
	 * @see Device.MotionEmitter.Motion
	 * @augments Core.MessageEmitter
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);

		this._lastAccel = null;
		this._lastGyro  = null;
		this._lastCompass = null;
	},

	Motion: Core.Class.subclass(
	/** @lends Device.MotionEmitter.Motion.prototype */
	{
		classname: 'Motion',
		
		/**
		 * @class A <code>Motion</code> object is what <code>MotionEmitter</code> uses to capture device movement through 3D space.
		 * These objects retrieve data from device components on how a device responds to 
		 * physical movement, as reported by the accelerometer, gyroscope and compass instruments.
		 * @constructs The default constructor. 
		 * @param {Array (Number)} accel The accelerometer data.
		 * @param {Array (Number)} gyro The gyroscope data.
		 * @param {Array (Number)} compass The compass data.
		 * @see Device.MotionEmitter
		 * @augments Core.Class
		 */
		initialize: function(accel, gyro, compass)
		{
			this._accel = accel;
			this._gyro  = gyro;
			this._compass = compass;
		},
		
		/**
		 * Retrieve accelerometer data from the device. If the device contains an accelerometer,
		 * calling <code>getAccelData()</code> returns an array of three floating point values. In all other cases,
		 * calling <code>getAccelData()</code> returns <code>undefined</code>.
		 * <b>Note:</b> Use a <code>{@link Core.Capabilities</code> object 
		 * to programmatically check a device for a accelerometer. 
		 * @returns {Array (Number)} The accelerometer data for the device.
		 * @see Core.Capabilities#getHasAccel
		 * @status iOS, Android, Test, iOSTested, AndroidTested
		 */
		getAccelData: function()
		{
			return this._accel;
		},
		
		/**
		 * Retrieve gyroscope data from the device. If the device contains a gyroscope,
		 * this call returns an array of three floating point values. In all other cases,
		 * this call returns <code>undefined</code>. <br><br>
		 * <b>Note:</b> Use a <code>{@link Core.Capabilities</code> object 
		 * to programmatically check a device for a gyroscope. 
		 * @returns {Array (Number)} The gyroscope data for the device.
		 * @see Core.Capabilities#getHasGyro
		 * @status iOS, Android, Test, iOSTested, AndroidTested
		 */
		getGyroData: function()
		{
			return this._gyro;
		},
		
		/**
		 * Retrieve compass data from the device. If the device contains a magnetic compass,
		 * this call returns an array of three floating point values. In all other cases,
		 * this call returns <code>undefined</code>.<br><br>
		 * <b>Note:</b> Use a <code>Capabilities</code> object to programmatically check a device for a compass. 
		 * @returns {Array (Number)} The compass data for the device.
		 * @see Core.Capabilities#getHasCompass
		 * @status iOS, Android, Test, iOSTested, AndroidTested
		 */
		getCompassData: function()
		{
			return this._compass;
		},
	}),

	/**
	 * Construct a <code>MessageListener</code> object and register it with this <code>MotionEmitter</code> object. If an application calls <code>emit()</code> 
	 * or <code>chain()</code> 
	 * on this emitter, a callback function passed as a parameter is called on the specified listener.
	 * The parameters for the callback function are identical to parameters for <code>emit()</code> or
	 * <code>chain()</code>.<br><br>
	 * <b>Note:</b> Each listener can only listen to an emitter once.
	 * The following code examples illustrate different call styles for <code>addListener()</code>.
	 *
	 * @example
	 * emitter.addListener(myListener, myListener.onCallback);
	 *
	 * @example
	 * emitter.addListener(myListener, myListener.onEvent, 200);
	 *
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {Core.MessageListener} listener The <code>MessageListener</code> to add.
	 * @param {Function} func The callback function.
	 * @param {Number} [priority=0] The priority for this <code>MessageListener</code>.
	 * @see Core.MessageEmitter#emit,
	 * @see Core.MessageEmitter#chain
	 *
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	addListener: function($super, listener, func, priority)
	{
		if (this.getListenerCount() == 0) {
			// start the Accelerometer if this is the first listener
			this._startMotionSendGen();
		}

		$super(listener, func, priority);
	},

	/**
	 * Remove a <code>MessageListener</code> object from this <code>MotionEmitter</code> object. 
	 * The following code examples illustrate different call styles for <code>removeListener()</code>.
	 * @example
	 * emitter.removeListener(myListener, myListener.onCallback);
	 * @example
	 * emitter.removeListener(myListener);
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {Core.MessageListener} listener The <code>MessageListener</code> to remove.	 
	 * @returns {Boolean} Returns <code>true</code> when the registered listener was removed. Returns <code>false</code> in all other cases.
	 * @see Core.MessageEmitter#addListener
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	
	removeListener: function($super, listener)
	{
		$super(listener);

		if (this.getListenerCount() == 0) {
			// stop the Accelerometer if this is the last listener
			this._stopMotionSendGen();
		}
	},

	_emitMotion: function()
	{
		var motion = new Device.MotionEmitter.Motion(this._lastAccel, this._lastGyro, this._lastCompass);
		this.emit(motion);
	},

	_accelChangedRecv: function( cmd )
	{
		var msg = {};
		if(!this._accelChangedRecvGen(cmd, msg))
			return;

		this._lastAccel = msg;
		this._emitMotion();
		
		//Cascade the original message back out to native for forwarding
		this._accelChangedSendGen(msg.x, msg.y, msg.z);
	},

	_gyroChangedRecv: function( cmd )
	{
		var msg = {};
		if(!this._gyroChangedRecvGen(cmd, msg))
			return;

		this._lastGyro = msg;
		this._emitMotion();
		
		//Cascade the original message back out to native for forwarding
		this._gyroChangedSendGen(msg.x, msg.y, msg.z);
	},
	
	_magneticChangedRecv: function( cmd ) 
	{
		var msg = {};
		if(!this._magneticChangedRecvGen(cmd, msg))
			return;
		
 		this._lastCompass = msg;
		this._emitMotion();
		
		//Cascade the original message back out to native for forwarding
		this._magneticChangedSendGen(msg.x, msg.y, msg.z);
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 330
	// Method create = -1
	// Method accelChanged = 2
	// Method gyroChanged = 3
	// Method magneticChanged = 4
	// Method startMotion = 5
	// Method stopMotion = 6
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._accelChangedRecv( cmd );
					break;
				case 3:
					instance._gyroChangedRecv( cmd );
					break;
				case 4:
					instance._magneticChangedRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in MotionEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in MotionEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[330] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_accelChangedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 3 )
		{
			NgLogE("Could not parse due to wrong argument count in MotionEmitter.accelChanged from command: " + cmd );
			return false;
		}
		
		obj[ "x" ] = Core.Proc.parseFloat( cmd[ 0 ] );
		if( obj[ "x" ] === undefined )
		{
			NgLogE("Could not parse x in MotionEmitter.accelChanged from command: " + cmd );
			return false;
		}
		
		obj[ "y" ] = Core.Proc.parseFloat( cmd[ 1 ] );
		if( obj[ "y" ] === undefined )
		{
			NgLogE("Could not parse y in MotionEmitter.accelChanged from command: " + cmd );
			return false;
		}
		
		obj[ "z" ] = Core.Proc.parseFloat( cmd[ 2 ] );
		if( obj[ "z" ] === undefined )
		{
			NgLogE("Could not parse z in MotionEmitter.accelChanged from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_gyroChangedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 3 )
		{
			NgLogE("Could not parse due to wrong argument count in MotionEmitter.gyroChanged from command: " + cmd );
			return false;
		}
		
		obj[ "x" ] = Core.Proc.parseFloat( cmd[ 0 ] );
		if( obj[ "x" ] === undefined )
		{
			NgLogE("Could not parse x in MotionEmitter.gyroChanged from command: " + cmd );
			return false;
		}
		
		obj[ "y" ] = Core.Proc.parseFloat( cmd[ 1 ] );
		if( obj[ "y" ] === undefined )
		{
			NgLogE("Could not parse y in MotionEmitter.gyroChanged from command: " + cmd );
			return false;
		}
		
		obj[ "z" ] = Core.Proc.parseFloat( cmd[ 2 ] );
		if( obj[ "z" ] === undefined )
		{
			NgLogE("Could not parse z in MotionEmitter.gyroChanged from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_magneticChangedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 3 )
		{
			NgLogE("Could not parse due to wrong argument count in MotionEmitter.magneticChanged from command: " + cmd );
			return false;
		}
		
		obj[ "x" ] = Core.Proc.parseFloat( cmd[ 0 ] );
		if( obj[ "x" ] === undefined )
		{
			NgLogE("Could not parse x in MotionEmitter.magneticChanged from command: " + cmd );
			return false;
		}
		
		obj[ "y" ] = Core.Proc.parseFloat( cmd[ 1 ] );
		if( obj[ "y" ] === undefined )
		{
			NgLogE("Could not parse y in MotionEmitter.magneticChanged from command: " + cmd );
			return false;
		}
		
		obj[ "z" ] = Core.Proc.parseFloat( cmd[ 2 ] );
		if( obj[ "z" ] === undefined )
		{
			NgLogE("Could not parse z in MotionEmitter.magneticChanged from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":330,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_accelChangedSendGen: function( x, y, z )
	{
		Core.Proc.appendToCommandString( ":330,2," + this.__objectRegistryId + "," + x + "," + y + "," + z  );
	},
	
	/** @private */
	_gyroChangedSendGen: function( x, y, z )
	{
		Core.Proc.appendToCommandString( ":330,3," + this.__objectRegistryId + "," + x + "," + y + "," + z  );
	},
	
	/** @private */
	_magneticChangedSendGen: function( x, y, z )
	{
		Core.Proc.appendToCommandString( ":330,4," + this.__objectRegistryId + "," + x + "," + y + "," + z  );
	},
	
	/** @private */
	_startMotionSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":330,5," + this.__objectRegistryId );
	},
	
	/** @private */
	_stopMotionSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":330,6," + this.__objectRegistryId );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _accelChangedRecv: function( cmd ) {}
	// accelChanged: function( x, y, z ) {}
	
	// _gyroChangedRecv: function( cmd ) {}
	// gyroChanged: function( x, y, z ) {}
	
	// _magneticChangedRecv: function( cmd ) {}
	// magneticChanged: function( x, y, z ) {}
	
	// startMotion: function(  ) {}
	
	// stopMotion: function(  ) {}
	

// {{/Wg Generated Code}} }}}

});
// vim:set fdm=marker noexpandtab:
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/NetworkEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/NetworkEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/NetworkEmitter'] = exports; var Core = require('NGCore/Client/Core').Core;

////////////////////////////////////////////////////////////////////////////////

exports.NetworkEmitter = Core.MessageEmitter.singleton(
/** @lends Device.NetworkEmitter.prototype */
{
	classname: 'NetworkEmitter',
	
	/**
	 * @class The <code>NetworkEmitter</code> class constructs a singleton object that tracks network connectivity status for a device.
	 * These objects emit a <a href="Device.NetworkEmitter.html#Status">Status</a> object when a change to device network connectivity status occurs.
	 * A change in network status is defined as:
	 * <div class="ul"><font size="3">
	 * <li>The device loses access to a network.</li>
	 * <li>The device gains access to a network.</li>
	 * <li>The device switches between cellular and Wi-Fi network access.</li>
	 * </font></div><br>
	 * <p><b>Note:</b> Applications should never directly allocate a singleton.</p>
	 * @constructs The default constructor. 
	 * @see Device.NetworkEmitter#Status
	 * @augments Core.MessageEmitter
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);

		this._lastStatus = null;
	},

	/**
	 * Retrieve the network status of the device.
	 * @returns {Device.NetworkEmitter#Status} The current device network status.
	 * @status iOS, Android, Test
	 */
	getLastStatus: function()
	{
		return this._lastStatus;
	},

	/** 
	 * Enumeration values for device network status.
	 * @fieldOf Device.NetworkEmitter.prototype
	 */
	Status:
	{
		/** 
		* <code>0</code> = No network connectivity. 
		* @fieldOf Device.NetworkEmitter.prototype
		* @constant
		*/
		None: 0,
		
		/** 
		* <code>1</code> = Cellular network connectivity. 
		* @fieldOf Device.NetworkEmitter.prototype
		* @constant
		*/
		Cellular: 1,
		
		/** 
		* <code>2</code> = Wi-Fi network connectivity. 
		* @fieldOf Device.NetworkEmitter.prototype
		* @constant
		*/
		Wifi: 2,
	},

	_statusChangedRecv: function( cmd )
	{
		var msg = {};
		if (!this._statusChangedRecvGen(cmd, msg))
		    return;

		this._lastStatus = msg['status'];
		this.emit(this._lastStatus);
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 336
	// Method create = -1
	// Method statusChanged = 2
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._statusChangedRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in NetworkEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in NetworkEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[336] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_statusChangedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in NetworkEmitter.statusChanged from command: " + cmd );
			return false;
		}
		
		obj[ "status" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "status" ] === undefined )
		{
			NgLogE("Could not parse status in NetworkEmitter.statusChanged from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":336,-1," + __objectRegistryId  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _statusChangedRecv: function( cmd ) {}

// {{/Wg Generated Code}}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/OrientationEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/OrientationEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/OrientationEmitter'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class OrientationEmitter
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var Core = require('NGCore/Client/Core').Core;

////////////////////////////////////////////////////////////////////////////////

exports.OrientationEmitter = Core.MessageEmitter.singleton(
/** @lends Device.OrientationEmitter.prototype */
{
	classname: 'OrientationEmitter',
		
	/**
	 * @class <code>OrientationEmitter</code> constructs a singleton object that tracks the physical orientation of the device.
	 * These objects emit an <code><a href="Device.OrientationEmitter.html#Orientation">Orientation</a></code> object when a change in device orientation occurs.<br><br>
	 * Rotating the device does not necessarily rotate the 
	 * interface presented to the user. Applications must
	 * explicitly call <code><a href="Device.OrientationEmitter.html#setInterfaceOrientation">setInterfaceOrientation()</a></code> to rotate the interface.
	 * This allows an application to selectively choose a supported device orientation.
	 * For example, an application can observe orientation change events and change the interface orientation only if the application suppoorts it.<br><br>
	 * <b>Note:</b> Applications should never directly allocate a singleton.
	 * @constructs The default constructor. 	 
	 * @augments Core.MessageEmitter
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);

		this._lastDeviceOrientation    = this.Orientation.Portrait;
		this._lastInterfaceOrientation = this.Orientation.Portrait;
	},
	
	/**
	 * Retrieve the device orientation.
	 * @returns {Device.OrientationEmitter#Orientation} The current device orienation.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getDeviceOrientation: function()
	{
		return this._lastDeviceOrientation;
	},
	
	/**
	 * Retrieve the interface orientation. Initially, this is the same
	 * as the device orientation.
	 * @returns {Device.OrientationEmitter#Orientation} The current interface orientation.
	 * @see Device.OrientationEmitter#setInterfaceOrientation
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getInterfaceOrientation: function()
	{
		return this._lastInterfaceOrientation;
	},
	
	/**
	 * Set the interface orientation.
	 * @example var orientation = new Device.OrientationEmitter(Device.OrientationEmitter.Orientation.Portrait, true);
	 * @param {Device.OrientationEmitter#Orientation} orientation The new device orientation.
	 * @param {Boolean} [animated] Set as <code>true</code> to render the orientation change with an animated effect.
	 * @see Device.OrientationEmitter#getInterfaceOrientation
	 * @status iOS, Test
	 */
	setInterfaceOrientation: function(orientation, animated)
	{
		if (orientation != this._lastInterfaceOrientation)
		{
			NgLogD("setInterfaceOrientation to " + orientation);
			this._setInterfaceOrientationSendGen(orientation,animated);
			this._lastInterfaceOrientation = orientation;
		}
	},
	
	/**
	 * Enumeration for device orientation.
	 * @fieldOf Device.OrientationEmitter.prototype
	 */
	Orientation:
	{ 
		/** 
		* Portrait orientation. 
		* @fieldOf Device.OrientationEmitter.prototype
		* @constant
		*/
		Portrait: 0,
		/** 
		* Portrait orientation, but rotated 180 degrees. 
		* @fieldOf Device.OrientationEmitter.prototype
		* @constant
		*/
		PortraitUpsideDown: 1,
		/** 
		* Landscape orientation with the top of the device to the left. 
		* @fieldOf Device.OrientationEmitter.prototype
		* @constant
		*/
		LandscapeLeft: 2,
		/** 
		* Landscape orientation with the top of the device to the right. 
		* @fieldOf Device.OrientationEmitter.prototype
		* @constant
		*/
		LandscapeRight: 3,
		/** 
		* Oriented with the face of the device up. 
		* @fieldOf Device.OrientationEmitter.prototype
		* @constant
		*/
		FaceUp: 4,
		/** 
		* Oriented with the face of the device down. 
		* @fieldOf Device.OrientationEmitter.prototype
		* @constant
		*/
		FaceDown: 5,
	},

	/**
	 * Enumeration for orientation type.
	 * It can be used to identify which event happens.
	 * @filedOf Device.OrientationEmitter.prototype
	 */
	OrientationType:
	{
		/**
		* Device orientation has changed.
		* @fieldOf Device.OrientationEmitter.prototype
		* @constant
		*/
		Device: 0,
		/**
		* Interface orientation has changed.
		* @fieldOf Device.OrientationEmitter.prototype
		* @constant
		*/
		Interface: 1
	},

	_orientationChangedRecv: function( cmd )
	{
		var msg = {};
		if(!this._orientationChangedRecvGen(cmd, msg))
			return;
 
 		this._lastDeviceOrientation = msg['orientation'];
		this.emit({type: this.OrientationType.Device, orientation:msg['orientation']});
		
		//Cascade the original message back out to native for forwarding
		this._orientationChangedSendGen(msg.orientation);
	},
	
	_interfaceOrientationChangedRecv: function( cmd )
	{
		var msg = {};
		if(!this._interfaceOrientationChangedRecvGen(cmd, msg))
			return;
 
 		this._lastInterfaceOrientation = msg['orientation'];
		this.emit({type: this.OrientationType.Interface, orientation:msg['orientation']});
		
		//Cascade the original message back out to native for forwarding
		this._interfaceOrientationChangedSendGen(msg.orientation);
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 335
	// Method create = -1
	// Method orientationChanged = 2
	// Method setInterfaceOrientation = 3
	// Method interfaceOrientationChanged = 4
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._orientationChangedRecv( cmd );
					break;
				case 4:
					instance._interfaceOrientationChangedRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in OrientationEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in OrientationEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[335] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_orientationChangedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in OrientationEmitter.orientationChanged from command: " + cmd );
			return false;
		}
		
		obj[ "orientation" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "orientation" ] === undefined )
		{
			NgLogE("Could not parse orientation in OrientationEmitter.orientationChanged from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_interfaceOrientationChangedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in OrientationEmitter.interfaceOrientationChanged from command: " + cmd );
			return false;
		}
		
		obj[ "orientation" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "orientation" ] === undefined )
		{
			NgLogE("Could not parse orientation in OrientationEmitter.interfaceOrientationChanged from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":335,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_orientationChangedSendGen: function( orientation )
	{
		Core.Proc.appendToCommandString( ":335,2," + this.__objectRegistryId + "," + orientation  );
	},
	
	/** @private */
	_setInterfaceOrientationSendGen: function( orientation, animated )
	{
		Core.Proc.appendToCommandString( ":335,3," + this.__objectRegistryId + "," + orientation + "," + ( animated ? 1 : 0 )  );
	},
	
	/** @private */
	_interfaceOrientationChangedSendGen: function( orientation )
	{
		Core.Proc.appendToCommandString( ":335,4," + this.__objectRegistryId + "," + orientation  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _orientationChangedRecv: function( cmd ) {}
	// orientationChanged: function( orientation ) {}
	
	// setInterfaceOrientation: function( orientation, animated ) {}
	
	// _interfaceOrientationChangedRecv: function( cmd ) {}
	// interfaceOrientationChanged: function( orientation ) {}
	

// {{/Wg Generated Code}} }}}

});
// vim:set fdm=marker noexpandtab:
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/ShakeEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/ShakeEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/ShakeEmitter'] = exports; var Core = require('NGCore/Client/Core').Core;
var MotionEmitter = require('NGCore/Client/Device/MotionEmitter').MotionEmitter;

var ProxyListener = Core.MessageListener.subclass(
{
	onUpdate: function() {}
});

exports.ShakeEmitter = Core.MessageEmitter.singleton(
/** @lends Device.ShakeEmitter.prototype */
{
	classname: 'ShakeEmitter',
		
	/**
	 * @class The <code>ShakeEmitter</code> class constructs a singleton object that tracks when users physically shake the device. 
	 * These objects emit messages when the device recognizes a shake gesture.<br><br>
	 * <b>Note:</b> Applications should never directly allocate a singleton.
	 * @constructs The default constructor. 
	 * @augments Core.MessageEmitter
	 * @status iOS, Android
	 */
	
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
		this._proxyListener = new ProxyListener();
		
	},
	
	/**
	 * Add a <code>MessageListener</code> to this emitter. When an application calls <code>emit()</code> 
	 * or <code>chain()</code> 
	 * on this emitter, a callback function passed as a parameter is called on the specified listener.
	 * The parameters for the callback function are identical to parameters for <code>emit()</code> or
	 * <code>chain()</code>.
	 * <br><br>
	 * <b>Note:</b> Each listener can only listen to an emitter one time.<br><br>
	 * The following code examples illustrate different call styles for <code>addListener()</code>.
	 *
	 * @example
	 * emitter.addListener(myListener, myListener.onCallback);
	 *
	 * @example
	 * emitter.addListener(myListener, myListener.onEvent, 200);
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {Core.MessageListener} listener The <code>MessageListener</code> to add.
	 * @param {Function} func The callback function.
	 * @param {Number} [priority=0] The priority for this <code>MessageListener</code>.
	 * @throws {MessageEmitter.addListener: listener is already listening} Calling <code>addListener()</code> multiple times on the same emitter
	 * with the same listener.
	 * @throws {MessageEmitter.addListener: listener must be instances of MessageListener} Listener is not an instance of <code>MessageListener</code>.
	 * @see Device.ShakeEmitter#removeListener,
	 * @see Core.MessageEmitter#emit,
	 * @see Core.MessageEmitter#chain
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	addListener: function($super, listener, func, priority)
	{
		if (this.getListenerCount() == 0) {
			MotionEmitter.addListener(this._proxyListener, function(){});
		}

		$super(listener, func, priority);
	},
	
	/**
	 * Remove a <code>MessageListener</code> from this emitter.<br><br> 
	 * The following code examples illustrate different call styles for <code>removeListener()</code>.
	 * @example
	 * emitter.removeListener(myListener, myListener.onCallback);
	 * @example
	 * emitter.removeListener(myListener);
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {Core.MessageListener} listener The <code>MessageListener</code> to remove.
	 * @returns {Boolean} Returns <code>true</code> if the registered listener was removed. Returns <code>false</code> if the registered listener is not found 
	 * or is not registered with this emitter.
	 * @throws {MessageEmitter.removeListener: listener is not listening} Specified listener is not currently registered
	 * with this emitter.
	 * @see Device.ShakeEmitter#addListener
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	removeListener: function($super, listener)
	{
		$super(listener);

		if (this.getListenerCount() == 0) {
			MotionEmitter.removeListener(this._proxyListener);
		}
	},
	
	_shakeRecv: function( cmd )
	{
		this.emit();
		
		//Cascade the original message back out to native for forwarding
		this._shakeSendGen();
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 332
	// Method create = -1
	// Method shake = 2
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._shakeRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in ShakeEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in ShakeEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[332] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_shakeRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 0 )
		{
			NgLogE("Could not parse due to wrong argument count in ShakeEmitter.shake from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":332,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_shakeSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":332,2," + this.__objectRegistryId );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _shakeRecv: function( cmd ) {}
	// shake: function(  ) {}
	

// {{/Wg Generated Code}}	

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/KeyEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/KeyEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/KeyEmitter'] = exports; var Core = require('NGCore/Client/Core').Core;
var UI = require('NGCore/Client/UI').UI;

////////////////////////////////////////////////////////////////////////////////

// Private Class Statics
var keyCodeReverseMap = null;

exports.KeyEmitter = Core.MessageEmitter.singleton(
/** @lends Device.KeyEmitter.prototype */
{
	classname: 'KeyEmitter',

	/**
	 * @class The <code>KeyEmitter</code> class constructs a singleton object that emits a <code><a href="Device.KeyEmitter.KeyEvent.html">KeyEvent</a></code> object 
	 * when the user presses or releases a device hardware key.<br><br>
	 * <b>Note:</b> Applications should never directly allocate a singleton.
	 * @constructs The default constructor. 
	 * @augments Core.MessageEmitter
	 * @require Device
	 * @example
	 *
	 * var KeyListener = Core.MessageListener.subclass({
	 *   onUpdate: function(keyEvent) {
	 *     // back to the launcher when the back button is pressed
	 *     if (keyEvent.code === Device.KeyEmitter.Keycode.back) {
	 *        this.destroy();
	 *        LGL.runUpdatedGame('/Samples/Launcher');
	 *        return;
	 *     }
	 *
	 *     var text = '';
	 *     switch (keyEvent.type) {
	 *        case Device.KeyEmitter.EventType.onDown:
	 *           text += 'onDown :'
	 *           break;
	 *        case Device.KeyEmitter.EventType.onUp:
	 *           text += 'onUp :'
	 *           break;
	 *     }
	 *
	 *     text += Device.KeyEmitter.keyCodeToSymbol(keyEvent.code);
	 *     console.log(text);
	 *   }
	 * };
	 *
	 * var keyListener = new KeyListener();
	 * Device.KeyEmitter.addListener(keyListener, keyListener.onUpdate);
	 *
	 * @status Android, Test, AndroidTested
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
	},

	/**
	 * Convert a keycode into the equivalent human-readable symbol. The keycode to convert is passed in as a parameter.
	 * The following code example illustrates how to convert a keycode into a human-readable symbol.
	 * @param {String} keyCode The keycode to convert.
	 * @static
	 *
	 * @example
	 *   var symbol = Device.KeyEmitter.keyCodeToSymbol(0x1d);
	 *   // symbol => 'a'
	 *
	 * @status
	 */
	keyCodeToSymbol: function(keyCode)
	{
		if (!keyCodeReverseMap) {
			keyCodeReverseMap = {};
			for (var codename in this.Keycode) {
				keyCodeReverseMap[this.Keycode[codename]] = codename;
			}
		}
		return keyCodeReverseMap[keyCode] || '';
	},

	KeyEvent: Core.Class.subclass(
	/** @lends Device.KeyEmitter.KeyEvent.prototype */
	{
		classname: 'KeyEvent',

		/**
		 * @class <code>KeyEvent</code> constructs objects that contain the parcel of a keyboard event. 
		 * The keycode of the key that triggered the event is passed in as a parameter.
		 * @constructs The default constructor. 
		 * @augments Core.Class
		 * @param {Device.KeyEmitter.EventType} type The type of the keyboard event.
		 * @param {Integer} modifiers the bit-and of {@link Device.KeyEmitter#Modifier} combination.
		 * @param {Device.KeyEmitter.Keycode} code The actual keycode.
		 */
		initialize: function(type, modifiers, code)
		{
			this.type      = type;
			this.modifiers = modifiers;
			this.code      = code;
		}
	}),

	_onKeyEventRecv: function( cmd )
	{
		var msg = {};
		if(!this._onKeyEventRecvGen(cmd, msg))
			return;

		var keyEvent = new Device.KeyEmitter.KeyEvent(msg.type, msg.modifiers, msg.code);
		
		if(!this.chain(keyEvent)) {
			//Noone handled this keyEvent. Cascade the original back out to native for forwarding
			//	to the next interpreter in the chain.
			this._onKeyEventSendGen(msg.type, msg.modifiers, msg.code);
		}
	},

// {{?Wg Generated Code}}
	
	// Enums.
	/** 
	 * Event type Enums.
	 * Currently we only have onUp and onDown events.
	 *
	 * @namespace
	 * */
	EventType:
	{ 
		/** the key is hooked up. */
		onUp: 0,
		/** the key is pressed down. */
		onDown: 1,
	},
	
	/** 
	 * Enums for modifiers that are being pressed.
	 * They are passed as bit-and-ed.
	 *
	 * @namespace
	 * @example
	 *
	 * var keyEvent; // emitted from KeyEmitter
	 * if (keyEvent.modifiers & Device.KeyEmitter.Modifier.ALT && 
	 *     keyEvent.modifiers & Device.KeyEmitter.Modifier.SHIFT)
	 *    console.log("ALT+SHIFT");
	 * */
	Modifier:
	{ 
		/** no modifiers */
		NONE: 0,
		/** SYMBOL modifier */
		SYMBOL: 1 << 0,
		/** ALT modifier */
		ALT: 1 << 1,
		/** ALT_LEFT modifier */
		ALT_LEFT: 1 << 2,
		/** ALT_RIGHT modifier */
		ALT_RIGHT: 1 << 3,
		/** SHIFT modifier */
		SHIFT: 1 << 4,
		/** SHIFT_LEFT modifier */
		SHIFT_LEFT: 1 << 5,
		/** SHIFT_RIGHT modifier */
		SHIFT_RIGHT: 1 << 6,
	},
	
	/** 
	 * Keycode Enums.
	 * Define bunch of key codes.
	 * @namespace
	 * */
	Keycode:
	{ 
		/** * */
		a: 0x1d,
		/** * */
		b: 0x1e,
		/** * */
		c: 0x1f,
		/** * */
		d: 0x20,
		/** * */
		e: 0x21,
		/** * */
		f: 0x22,
		/** * */
		g: 0x23,
		/** * */
		h: 0x24,
		/** * */
		i: 0x25,
		/** * */
		j: 0x26,
		/** * */
		k: 0x27,
		/** * */
		l: 0x28,
		/** * */
		m: 0x29,
		/** * */
		n: 0x2a,
		/** * */
		o: 0x2b,
		/** * */
		p: 0x2c,
		/** * */
		q: 0x2d,
		/** * */
		r: 0x2e,
		/** * */
		s: 0x2f,
		/** * */
		t: 0x30,
		/** * */
		u: 0x31,
		/** * */
		v: 0x32,
		/** * */
		w: 0x33,
		/** * */
		x: 0x34,
		/** * */
		y: 0x35,
		/** * */
		z: 0x36,
		/** TBD */
		up: 0x13,
		/** TBD */
		down: 0x14,
		/** TBD */
		left: 0x15,
		/** TBD */
		right: 0x16,
		/** * */
		enter: 0x42,
		/** * */
		backspace: 0x43,
		/** * */
		back: 0x04,
		/** backunhandled: 0x54, Special KeyCode to tell MobageService that the back was unhandled by the game, after the service declined first dibs. Stole MAX_KEYCODE (deprecated constant). */
		backunhandled: 0x54,
		/** * */
		menu: 0x52,
	},
	
	///////
	// Class constants (for internal use only):
	// Class ID = 343
	// Method create = -1
	// Method onKeyEvent = 2
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._onKeyEventRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in KeyEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in KeyEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[343] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_onKeyEventRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 3 )
		{
			NgLogE("Could not parse due to wrong argument count in KeyEmitter.onKeyEvent from command: " + cmd );
			return false;
		}
		
		obj[ "type" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "type" ] === undefined )
		{
			NgLogE("Could not parse type in KeyEmitter.onKeyEvent from command: " + cmd );
			return false;
		}
		
		obj[ "modifiers" ] = Core.Proc.parseInt( cmd[ 1 ] );
		if( obj[ "modifiers" ] === undefined )
		{
			NgLogE("Could not parse modifiers in KeyEmitter.onKeyEvent from command: " + cmd );
			return false;
		}
		
		obj[ "code" ] = Core.Proc.parseInt( cmd[ 2 ] );
		if( obj[ "code" ] === undefined )
		{
			NgLogE("Could not parse code in KeyEmitter.onKeyEvent from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":343,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_onKeyEventSendGen: function( type, modifiers, code )
	{
		Core.Proc.appendToCommandString( ":343,2," + this.__objectRegistryId + "," + type + "," + modifiers + "," + code  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _onKeyEventRecv: function( cmd ) {}
	// onKeyEvent: function( type, modifiers, code ) {}
	

// {{/Wg Generated Code}}

});
// vim:set fdm=marker noexpandtab:
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/_PushNotificationEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/_PushNotificationEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/_PushNotificationEmitter'] = exports; var Core = require('NGCore/Client/Core').Core;

/*
	NOTE: 	THIS IS FOR INTERNAL USE ONLY AND WILL BE DEPRECATED IN THE FUTURE.
			DO NOT USE IT IN ANY OF YOUR CODE.
*/

exports.PushNotificationEmitter = Core.MessageEmitter.singleton(
/** @lends Device.PushNotificationEmitter.prototype */
{
	classname: 'PushNotificationEmitter',
		
	/**
	 * @class Emits when native code recieves a push notification
	 * @constructs The default constructor.
	 * @augments Core.MessageEmitter
	 */
	
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
	},
	
	_onPushNotificationRecv: function( cmd )
	{
		var msg = {};
		if (!this._onPushNotificationRecvGen(cmd, msg))
			return;
			
		this._lastMsgPayload = msg.msgPayload;
		
		if(!this.chain(msg.msgPayload))	{
			//Noone handled this keyEvent. Cascade the original back out to native for forwarding
			//	to the next interpreter in the chain.
			this._onPushNotificationSendGen(msg.msgPayload);
		}
		
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 345
	// Method create = -1
	// Method onPushNotification = 2
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._onPushNotificationRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in PushNotificationEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in PushNotificationEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[345] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_onPushNotificationRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in PushNotificationEmitter.onPushNotification from command: " + cmd );
			return false;
		}
		
		obj[ "msgPayload" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "msgPayload" ] === undefined )
		{
			NgLogE("Could not parse msgPayload in PushNotificationEmitter.onPushNotification from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":345,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_onPushNotificationSendGen: function( msgPayload )
	{
		Core.Proc.appendToCommandString( ":345,2," + this.__objectRegistryId + "," + Core.Base64.encode( msgPayload )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _onPushNotificationRecv: function( cmd ) {}
	// onPushNotification: function( msgPayload ) {}
	

// {{/Wg Generated Code}}	

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/_InAppPurchaseEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/_InAppPurchaseEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/_InAppPurchaseEmitter'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class InAppPurchaseEmitter
//
// Copyright (C) 2011 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


var Core = require('NGCore/Client/Core').Core;

////////////////////////////////////////////////////////////////////////////////

exports.InAppPurchaseEmitter = Core.MessageEmitter.singleton(
/** @lends Device.InAppPurchaseEmitter.prototype */
{
	classname: 'InAppPurchaseEmitter',
	
	/**
	 * Function.
	 * @constructs
	 * @augments Core.Class
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
	},
	
	_onPurchaseEventRecv: function( cmd ) {
		var msg = {};
		if (!this._onPurchaseEventRecvGen(cmd, msg))
			return;
		if(!this.chain(msg.err, msg.data, msg.verificationToken))	{
			//Noone handled this keyEvent. Cascade the original back out to native for forwarding
			//	to the next interpreter in the chain.
			this._onPurchaseEventSendGen(msg.err, msg.data, msg.verificationToken);
		}
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 347
	// Method create = -1
	// Method onPurchaseEvent = 2
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._onPurchaseEventRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in InAppPurchaseEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in InAppPurchaseEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[347] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_onPurchaseEventRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 3 )
		{
			NgLogE("Could not parse due to wrong argument count in InAppPurchaseEmitter.onPurchaseEvent from command: " + cmd );
			return false;
		}
		
		obj[ "err" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "err" ] === undefined )
		{
			NgLogE("Could not parse err in InAppPurchaseEmitter.onPurchaseEvent from command: " + cmd );
			return false;
		}
		
		obj[ "data" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "data" ] === undefined )
		{
			NgLogE("Could not parse data in InAppPurchaseEmitter.onPurchaseEvent from command: " + cmd );
			return false;
		}
		
		obj[ "verificationToken" ] = Core.Proc.parseString( cmd[ 2 ] );
		if( obj[ "verificationToken" ] === undefined )
		{
			NgLogE("Could not parse verificationToken in InAppPurchaseEmitter.onPurchaseEvent from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":347,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_onPurchaseEventSendGen: function( err, data, verificationToken )
	{
		Core.Proc.appendToCommandString( ":347,2," + this.__objectRegistryId + "," + Core.Base64.encode( err ) + "," + Core.Base64.encode( data ) + "," + Core.Base64.encode( verificationToken )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _onPurchaseEventRecv: function( cmd ) {}
	// onPurchaseEvent: function( err, data, verificationToken ) {}
	

// {{/Wg Generated Code}}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/_InAppPurchase'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/_InAppPurchase'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/_InAppPurchase'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class InAppPurchase
//
// Copyright (C) 2011 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


var Class = require('NGCore/Client/Core/Class').Class;
var DeviceReq = require('NGCore/Client/Device');
var Localization = require('NGCore/Client/Core/Localization').Localization;

////////////////////////////////////////////////////////////////////////////////

exports.InAppPurchase = Class.singleton(
/** @lends Device.InAppPurchase.prototype */
{
	classname: 'InAppPurchase',
	
	/**
	 * Function.
	 * @constructs
	 * @augments Core.Class
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
	},

	initService: function(ordercb, donecb) {
		if ((!this._isIOS()) && (!this._isAndroid())) {
			NgLogE("ERROR: Neither Android nor iOS platform, IAP will not work");
			donecb();
			return;
		}
		if (!this._iapInited) {
			var IAPListener = Core.MessageListener.subclass({
				onPurchaseEvent: this._iapCallback.bind(this)
			});
			// Register for Android / iOS IAP callbacks the same way
			this.listener = new IAPListener();
	        DeviceReq.Device.InAppPurchaseEmitter.addListener(
				this.listener, this.listener.onPurchaseEvent);
	    	// listener will be called when purchase state changes
		}
		this._initDonecb = donecb;
		this._initOrdercb = ordercb;
		if (this._isAndroid()) {
			this._iapCallback('morenonces', '', '');
			/*
			 * Gets persisted unfulfilled orders, calls back ordercb for each
			 * unfulfilled order.
			 */
			var self = this;
			Storage.KeyValueCache.local.getItem(this._IAB_ORPHANED,
			function(err, currorders) {
	   			if (currorders && (currorders.length > 0)) {
					var orders = JSON.parse(currorders);
   					// _restoreOrders eventually calls _initService when fully
					// done.
					self._restoreOrders(orders);
				} else {
					self._initService();
				}
			});
		} else {
			// _isIOS - call _initService directly.  It will call back with
			// orphaned order if any.
			this._initService();
		}
	},

	launchPurchaseView: function(productID, quantity, purchasecb, failcb, cancelcb) {
		if (!this._iapInited) {
			NgLogE("ERROR: function initService must be called and its donecb " +
			"called back, before launchPurchaseView may be used.");
			failcb(false, "failed:initservice_not_done");
			return;
		}

		this._currentOrderProductID = productID;

		this._currentOrderCancelcb = cancelcb;
		this._currentOrderFailcb = failcb;
		this._currentOrderPurchasecb = purchasecb;

		// Android IAB currently only supports quantity of 1
		if (quantity !== 1 && this._isAndroid()) {
			failcb(false, "failed:unsupported_quantity");
			return;
		}

		// Place progress dialog underneath the IAB view first
        if(this._isIOS()) {
	        this._currentOrderProgressDialog = (new UI.ProgressDialog()).retain();
	        this._currentOrderProgressDialog.setText(Localization.getString("Processing Order"));
        } else if(!this._isIOS()) {
	        this._currentOrderProgressDialog = (new UI.AlertDialog()).retain();
	        this._currentOrderProgressDialog.setTitle(Localization.getString("Processing Order"));
            // todo: localization???
            this._currentOrderProgressDialog.setText(
                "Your order is being processed. You will receive a confirmation momentarily.");
            this._currentOrderProgressDialog.setChoices(["OK"]);
            this._currentOrderProgressDialog.onchoice = function(event) {
                this._currentOrderProgressDialog.release();
                this._currentOrderProgressDialog = null;
            };
        }

	    this._currentOrderProgressDialog.show();

		if (this._isIOS() || this._isAndroid()) {
	        DeviceReq.Device.InAppPurchase._requestPurchase(productID, quantity);
			// Note that _iapCallback will call the *cb callback function(s)
			return;
		}
	    this._currentOrderProgressDialog.hide();
        this._currentOrderProgressDialog.release();
	    this._currentOrderProgressDialog = undefined;
		NgLogE('launchPurchaseView failed: only Android and iOS platforms are currently supported.');
		failcb(false, "failed:unsupported_platform");
		return;
	},

	pushSingleNonce: function(nonce){
		var noncePool = [];
		noncePool.push(nonce);
		this._fillIABNoncePool(JSON.stringify(noncePool));
	},

	/**
	 * get a product information specified by productId.
	 * @param {String} productId the product ID registered at iTunes connect.
	 * @param {Function} callback called back when it gets a response. The signature for the callback is equivalent to:<br><br>
	 * <pre>function(productData, err)</pre><br>
	 * The <code>productData</code> is an product information like "JPY,115.000000".
	 * When something bad happenes, <code>err</code> is set to the error message. Otherwise, err will be null or undefined.
	 * @status iOS, iOSTested
	 */
	getProductInformation: function(productId, callback) {
		this._getProductInformationCB = callback;
		this._getProductInformationSendGen(productId);
	},

	/*
	 * For Google IAB, these constants come from
	 * Consts.java in IAB sample code
	 *
	 *	public enum PurchaseState {
     *   PURCHASED,   // User was charged for the order. -- 0
     *   CANCELED,    // The charge failed on the server. -- 1
	 *   REFUNDED;    // User received a refund for the order. -- 2
	 */
	_IAB_PURCHASED: 0,
	_IAB_CANCELED: 1,
	_IAB_REFUNDED: 2,
	_IAB_ORPHANED: "com.ngmoco.in_app_purchase.iab_orphaned_orders",

	_capIsAndroid: undefined,
	_capIsIOS: undefined,

	// at most one outstanding order is supported
	_currentOrderCancelcb : undefined,
	_currentOrderFailcb : undefined,
	_currentOrderProductID : undefined,
	_currentOrderProgressDialog : undefined,
	_currentOrderPurchasecb : undefined,

	_initDonecb : undefined,
	_initOrdercb : undefined,
	_iapInited: false,

	_generateIABNonce: function(){
		var timestamp = new Date().getTime();
		var random = Math.floor(Math.random() * 1000);
		var nonce = (timestamp * 1000) + random;
		NgLogD("Generated nonce: " + nonce);
		return nonce;
	},

	_iapCallback: function( err, data, verificationToken ) {
		if (err == 'morenonces') {
			var count = 10;
			var noncePool = [];
			while(noncePool.length < count){
				noncePool.push(this._generateIABNonce());
			}
			this._fillIABNoncePool(JSON.stringify(noncePool));
			return true;
		}
		if ((err == 'initdone') || (err == 'initcheckdone')) {
			if (typeof this._initDonecb == 'function') {
				this._iapInited = true;
				this._initDonecb();
				this._initDonecb = undefined;
				this._initOrdercb = undefined;
			} else {
				NgLogW("WARN: " + err + " callback with empty donecb");
			}
	        // at most one listener gets iap events
	        return true;
		}
		if (err == 'getProductInformationDone') {
			if (data && data.length > 0) {
				var datajsonp = JSON.parse(data);
				this._getProductInformationCB(datajsonp.productId);
			} else {
				this._getProductInformationCB('', "no information on this product");
			}
			this._getProductInformationCB = undefined;
			return true;
		}
		var orderId = undefined;
		var prodId = "";
	    var firstOrder = undefined;
	    var datajson = undefined;
		if (data && data.length > 0) {
		    datajson = JSON.parse(data);
		    if ((typeof datajson.orders == 'undefined') ||
		        (datajson.orders.length <= 0)) {
		        // callback with no orders, try to get prodId
			    if (typeof datajson.productId != 'undefined') {
					prodId = datajson.productId.toUpperCase();
				}
		    } else {
 				if (this._isAndroid() &&
				 	(typeof this._currentOrderProgressDialog == 'undefined')) {
						// this callback comes in 'out of band', when user did
						// not attempt a purchase.  This happens on Android
						// when async callbacks are not confirmed due to
						// connectivity issue.  This callback is persisted for
						// the next 'initService' call to pick up. Only
						// successful orders will be used in callbacks.
						// Failed order and refunds are ignored.
						//
						// Note also that Android IAB could callback with
						// duplicate order numbers.  In other words, the same
						// order number could come back twice in 2 different
						// callbacks.  There is no code on client to detect
						// such duplicate.  It is up to the server to detect
						// orders which have already been fulfilled.
						//
						var successOrders = this._filterSuccessOrders(datajson, verificationToken);
						if (successOrders.length > 0) {
							this._persistOrphanedOrders(successOrders);
						}
						return true;
				} else if (datajson.orders.length === 1) {
					// on iOS, and in common cases on Android, there is at
					// most one order
				    firstOrder = datajson.orders[0];
					prodId = firstOrder.productId.toUpperCase();
					orderId = firstOrder.orderId;
				} else {
					var successOrders2 = this._filterSuccessOrders(datajson, verificationToken);
					// on Android, get the first match.  Then add any orphaned
					// orders to existing list of persisted
					// orders.  These will be processed during next initService
					if (successOrders2.length > 0) {
					    firstOrder = successOrders2.shift();
						prodId = firstOrder.productId.toUpperCase();
						orderId = firstOrder.orderId;
						if (successOrders2.length > 0) {
							this._persistOrphanedOrders(successOrders2);
						}
					}
				}
			}
		}
		if (this._currentOrderProductID != prodId) {
			NgLogW("iapCallback: product id mismatch in callback.  Req: '" +
					this._currentOrderProductID + "' CB:'" + prodId + "'");
		}
		if ((err && (err.length > 0)) || (firstOrder && firstOrder.purchaseState &&
			(firstOrder.purchaseState !== this._IAB_PURCHASED))) {
			if (firstOrder && firstOrder.purchaseState &&
				(firstOrder.purchaseState === this._IAB_REFUNDED)) {
				// refunds are generated 'out of the blue' by merchant and is
				// not part of normal flow.  Hence it is ignored.  Code now
				// continues to wait for actual purchase callback
				NgLogD("iapCallback: ignoring refunded order: " +
						JSON.stringify(firstOrder));
				return true;
			}
			if (typeof this._currentOrderProgressDialog != 'undefined') {
				this._currentOrderProgressDialog.hide();
                this._currentOrderProgressDialog.release();
				this._currentOrderProgressDialog = undefined;
			}

			if (err == 'cancelled') {
				if ((typeof this._currentOrderCancelcb) == 'function') {
					this._currentOrderCancelcb();
					this._currentOrderCancelcb = undefined;
				}
			} else {
				if (err) {
					NgLogD("DEBUG: iapCallback: got error: " + err);
				} else {
					// _IAB_CANCELED
					NgLogD("DEBUG: iapCallback: got canceled purchaseState.");
				}
				if ((typeof this._currentOrderFailcb) == 'function') {
					this._currentOrderFailcb(false, err);
					this._currentOrderFailcb = undefined;
				}
			}

	        // at most one listener gets iap events
	        return true;
	    }
		if (typeof firstOrder == 'undefined') {
			// there was no (non-refunded) order in callback
			return true;
		}
	    var nextcb2 = function(cbIsDone) {
			if (typeof this._currentOrderProgressDialog != 'undefined') {
				this._currentOrderProgressDialog.hide();
		        this._currentOrderProgressDialog.release();
				this._currentOrderProgressDialog = undefined;
			}
		    if (cbIsDone !== false) {
				return;
			}
			// Currently, fail if the first try is not done, no retry
			if ((typeof this._currentOrderFailcb) == 'function') {
				this._currentOrderFailcb(true, "failed:no_more_retry");
				this._currentOrderFailcb = undefined;
			}
	    };
		if ((typeof this._currentOrderPurchasecb) == 'function') {
			var receipt = verificationToken;
			if (this._isAndroid()) {
				// on Android, both the data and signature are required
				// for verification
				var receiptj = {
					data: data,
					signature: verificationToken
				};
				receipt = JSON.stringify(receiptj);
			}
		    this._currentOrderPurchasecb(prodId, orderId, receipt, firstOrder, nextcb2.bind(this));
			this._currentOrderPurchasecb = undefined;
		} else if ((!this._iapInited) && ((typeof this._initOrdercb) ==
		 			'function')) {
			var initcb2 = function(){
				// Do nothing on iOS as Store Observer simply emits
				// asychronously until done.
			};
			// part of initService flow
		    this._initOrdercb(prodId, orderId, verificationToken, firstOrder,
			initcb2);
		}
        // at most one listener gets iap events
        return true;
    },

	_isAndroid: function() {
		if (typeof this._capIsAndroid != 'undefined') {
			return this._capIsAndroid;
		}
		// Find out from capabilities
	    var capabilities = Core.Capabilities;
	    if ((typeof capabilities.getPlatformOS() != "undefined") &&
	        (capabilities.getPlatformOS().toLowerCase() == 'android')) {
	        this._capIsAndroid = true;
	    } else {
	        this._capIsAndroid = false;
		}
		return this._capIsAndroid;
	},

	_isIOS: function() {
		if (typeof this._capIsIOS != 'undefined') {
			return this._capIsIOS;
		}
		// Find out from capabilities
	    var capabilities = Core.Capabilities;
	    if ((typeof capabilities.getPlatformOS() != "undefined") &&
	        (capabilities.getPlatformOS().toLowerCase() == 'iphone os')) {
	        this._capIsIOS = true;
	    } else {
	        this._capIsIOS = false;
		}
		return this._capIsIOS;
	},

	_fillIABNoncePool: function(nonces) {
		this._fillIABNoncePoolSendGen(nonces);
	},
	_filterSuccessOrders: function(datajson, verificationToken) {
		var successOrders = [];
		for (var kdx in datajson.orders) {
			if ((datajson.orders[kdx].purchaseState) &&
				(datajson.orders[kdx].purchaseState ===
					this._IAB_PURCHASED)) {
				var theorder = datajson.orders[kdx];
				theorder.verificationToken = verificationToken;
				successOrders.push(theorder);
			}
		}
		return successOrders;
	},
	_persistOrphanedOrders: function(successOrders) {
		// add orders to existing list of persisted orders
		Storage.KeyValueCache.local.getItem(this._IAB_ORPHANED,
			(function(err, currorders){
				if (currorders && (currorders.length > 0)) {
					var orderlist = JSON.parse(currorders);
					for (var idx in orderlist) {
						successOrders.push(orderlist[idx]);
					}
				}
			    Storage.KeyValueCache.local.setItem(this._IAB_ORPHANED,
					JSON.stringify(successOrders), function(){
					NgLogD("Orphaned orders added to persistent store: " + JSON.stringify(successOrders));
			    });
			}).bind(this));
	},
	_initService: function() {
		this._initServiceSendGen();
	},

	_requestPurchase: function( sku, quantity ) {
		this._requestPurchaseSendGen(sku, quantity);
	},

	/*
	 * Given unfulfilled orders, calls back ordercb for each unfulfilled order.
	 * Resets persisted store using removeItem when done, then call
	 * _initService to continue init process.
	 */
	_restoreOrders: function(orders) {
		var self = this;
		if (orders.length <= 0) {
			// No more unfulfilled orders
			Storage.KeyValueCache.local.removeItem(this._IAB_ORPHANED,
			function() {
				self._initService();
			});
			return;
		}
		var order = orders.pop();
		var cb = function() {
			self._restoreOrders(orders);
		};
		// part of initService flow
		this._initOrdercb(order.productId.toUpperCase(), order.orderId, order.verificationToken, order, cb.bind(this));
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 348
	// Method create = -1
	// Method initService = 2
	// Method requestPurchase = 3
	// Method fillIABNoncePool = 4
	// Method getProductInformation = 5
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in InAppPurchase._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in InAppPurchase._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[348] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":348,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_initServiceSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":348,2," + this.__objectRegistryId );
	},
	
	/** @private */
	_requestPurchaseSendGen: function( sku, quantity )
	{
		Core.Proc.appendToCommandString( ":348,3," + this.__objectRegistryId + "," + Core.Base64.encode( sku ) + "," + quantity  );
	},
	
	/** @private */
	_fillIABNoncePoolSendGen: function( nonces )
	{
		Core.Proc.appendToCommandString( ":348,4," + this.__objectRegistryId + "," + Core.Base64.encode( nonces )  );
	},
	
	/** @private */
	_getProductInformationSendGen: function( productId )
	{
		Core.Proc.appendToCommandString( ":348,5," + this.__objectRegistryId + "," + Core.Base64.encode( productId )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// initService: function(  ) {}
	
	// requestPurchase: function( sku, quantity ) {}
	
	// fillIABNoncePool: function( nonces ) {}
	
	// getProductInformation: function( productId ) {}
	

// {{/Wg Generated Code}}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/IPCEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/IPCEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/IPCEmitter'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class IPCEmitter
//
// Copyright (C) 2011 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var Core = require('NGCore/Client/Core').Core;
var Class          = require('NGCore/Client/Core/Class').Class;
var Proc           = require('NGCore/Client/Core/Proc').Proc;
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var Base64         = require('NGCore/Client/Core/Base64').Base64;
var MessageEmitter = require('NGCore/Client/Core/MessageEmitter').MessageEmitter;
var DownloadFile   = require('NGCore/Client/Network/DownloadFile').DownloadFile;
var Util           = require('NGCore/Client/Network/Util').Util;
var FileSystem     = require('NGCore/Client/Storage/FileSystem').FileSystem;

////////////////////////////////////////////////////////////////////////////////

exports.IPCEmitter = MessageEmitter.singleton(
/** @lends Device.IPCEmitter.prototype */
{

	classname: 'IPCEmitter',

	/**
	 * @class The IPCEmitter class constructs a singleton object that handles Inter-Process Communication. 
	 * These objects emit events when a specified application is launched from within another application.
	 * @constructs The default constructor.
	 * @augments Core.MessageEmitter
	 */
	initialize: function()
	{
		console.log('IPCEmitter.initialize');
		this._callbackID = 0;
		this._callbacks = [];
		
		this._shouldEmitIntents = false;

		ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
	},

	/**
	 * Check whether the host OS can launch the provided URL asynchronously.
	 * @example var appToLaunch = 'mobage//auth?packageName=xxx.xxx&className=xxx.xxx';
	 * Device.IPCEmitter.canLaunch(appToLaunch, function(canLaunch) {
	 * 	if (canLaunch) {
	 * 		console.log('launching... ' + canLaunch);
	 * 		Device.IPCEmitter.launch(appToLaunch, function(error) {
	 * 			label.setText('failed in launching the URL:' + appToLaunch);
	 * 		});
	 * 	} else {
	 * 		label.setText('cannot launch the URL:' + appToLaunch);
	 * 	}
	 * });
	 * @param {String} url A URL to test
	 * @param {Function} callback A callback function that passes a Boolean value when a result is returned. 
	 * If the URL is OK to launch, the callback returns <code>true</code>.
	 * @status
	 */
	canLaunch: function(url, callback)
	{
		this._callbacks[this._callbackID] = callback;
		this._canLaunchSendGen(url,this._callbackID);
		this._callbackID++;
	},

	/**
	 * Request that the host OS launch the provided URL.
	 * @example var appToLaunch = 'mobage//auth?packageName=xxx.xxx&className=xxx.xxx'
	 * Device.IPCEmitter.launch(appToLaunch, function(error) {
	 * 	label.setText('failed in  launching the URL:' + appToLaunch);
	 * });
	 * @param {String} url A URL to launch
	 * @param {Function} errCallback A callback function that passes an error object when an error occurs. 
	 * If the URL is successfully launched, no callback. Otherwise, the callback returns an error.
	 */
	launch: function(url, callback)
	{
		 this._callbacks[this._callbackID] = callback;
		 this._launchSendGen(url,this._callbackID);
		 this._callbackID++;
	},

	launchIntent: function( intent, extras )
	{
		this._launchIntentSendGen(intent,extras);
	},
	
	launchService: function( intent, extras, packageName )
	{
		//This function originally did not take a "packageName" parameter, it was part of the extrasObj.
		//The separate parameter is added to make it a bit more clear that it is necessary to pass in a packageName.
		//Not sure it's going to help though, because we're trying to preserve backwards compatibility here.
		if (typeof(packageName) == "string")
		{
			var extrasObj;
			if (typeof(extras) == "string")
			{
				extrasObj = JSON.parse(extras);
			}
			else
			{
				extrasObj = {};
			}
			extrasObj["packageName"] = packageName;
			extras = JSON.stringify(extrasObj);
		}
		this._launchServiceSendGen(intent,extras);
	},

	/**
	 * Launch a Single Sign-on URL.
	 * @example var appToLaunch = 'mobage//auth?packageName=xxx.xxx&className=xxx.xxx';
	 * Device.IPCEmitter.launchForSSO(appToLaunch, function(error) {
	 * 	label.setText('failed in  launching the URL:' + appToLaunch);
	 * });
	 * @param {String} url The URL to launch. The URL must include the following as part of the query string: packageName=xxxx&className=yyyy.
	 * @param {Function} callback The callback function. 
	 * @status
	 */
	launchForSSO: function(url, callback)
	{
		url += '&sso_auth';
		this.launch(url, callback);
	},

	/**
	 * Return an array of signatures for the packageName.
	 * @param {String} packageName packageName is like "com.ngmoco.gamejs"
	 * @param {Function} callback callback function signature: function(signatures) { }
	 * @status Android
	 */
	getAppSignatures: function(packageName, callback)
	{
		this._callbacks[this._callbackID] = callback;
		this._getAppSignaturesSendGen(packageName,this._callbackID);
		this._callbackID++;
	},

	/**
	 * Return the package name that invokes this ngCore app.
	 * @param {Function} callback The current callback function. Below is the callback signature. 
	 * @example function(packageName) { }
	 * @status Android
	 */
	getCallingPackage: function(callback)
	{
		this._callbacks[this._callbackID] = callback;
		this._getCallingPackageSendGen(this._callbackID);
		this._callbackID++;
	},
	
	/**
	 * Return whether the service .
	 * @param {Function} callback The current callback function. Below is the callback signature. 
	 * @example function(packageName) { }
	 * @status Android
	 */
	getIsServiceRunning: function(serviceEnum, callback)
	{
		this._callbacks[this._callbackID] = callback;
		this._getIsServiceRunningSendGen(serviceEnum, this._callbackID);
		this._callbackID++;
	},


	app: function()
	{
		return this._app;
	},

	App: Class.subclass(
	/** @lends Device.IPCEmitter.App.prototype */
	{
		classname: 'App',

		/**
		 * @class Information about the app.
		 */
		initialize: function(sourceAppID, intentURL)
		{
			this._sourceAppID   = sourceAppID;
			this._intentURL     = intentURL;
		},

		/**
		 * information for checking if application has launched or resumed with custom URL scheme.
		 * @type String
		 */
		getID: function()
		{
			return this._sourceAppID;
		},

		/**
		 * Returns the URL used to launch this app, or an empty string if not launched via URL
		 * @type String
		 */
		getURL: function()
		{
			return this._intentURL;
		}
	}),

	Intent: Class.subclass(
	/** @lends Device.IPCEmitter.App.prototype */
	{
		classname: 'Intent',

		/**
		 * @class Information about the app.
		 */
		initialize: function(action, extras)
		{
			this._action   = action;
			this._extras   = extras;
		},

		/**
		 * information for checking if application has launched or resumed with custom URL scheme.
		 * @type String
		 */
		getAction: function()
		{
			return this._action;
		},

		/**
		 * Returns the URL used to launch this app, or an empty string if not launched via URL
		 * @type String
		 */
		getExtras: function()
		{
			return this._extras;
		}
	}),

	/**
	 * Create home screen shortcut icon.
	 * @param {String} name Displayed shortcut name
	 * @param {String} url Invoked url when icon clicked. 
	 * @param {String} icon_path Local file path that stores icon file.
	 * @status Android
	 */
	createShortcut: function( name, url, icon_path )
	{
		this._createShortcutSendGen(name, url, icon_path);
	},

	/**
	 * Create home screen shortcut icon with downloading its image.
	 * @param {String} name Displayed shortcut name.
	 * @param {String} url Invoked url when icon clicked. 
	 * @param {String} icon_url Icon image url.
	 * @param {Function} callback Callback function that passes a Boolean value whether download succeed. Below is the callback signature.
	 * @example function(hasDownloadError) { }
	 * @status Android
	 */
	createShortcutByIconUrl: function( name, url, icon_url, callback )
	{
                NgLogD("createShortcutByIconUrl called", name, url, icon_url);

                var df = new DownloadFile();
                var filename = 'shortcut_icon_image'+(new Date().getTime());
                var self = this;
                NgLogD("Icon download begin");
		Util.OperationWithRetries(function(failCb, abortCb) {
			df.start(filename, 'GET', icon_url, [], function( statusCode, fileSignature ) {
				NgLogD("Icon download finished status="+statusCode);
				if(statusCode == 200) {
					self.createShortcut( name, url, filename );
					FileSystem.deleteFile( filename, function() {
						if(callback)
							callback(false);
					});
				}
				else if(statusCode == 404)
				{
					NgLogE("Unable download icon file: icon_url="+icon_url+", status="+statusCode);
					abortCb();
				}
				else
				{
					NgLogE("Unable download icon file: icon_url="+icon_url+", status="+statusCode);
					failCb();
				}
			});
		},
		function() {
			NgLogE("Unable download icon file");
			if(callback)
				callback(true);
		}, 
		true);
	},

	// ------------------------------------------------------------------
	// private
	//

	/**
	 * invoked from native when the app is resumed back from other app.
	 */
	_onResumedFromOthers: function (url, sourceAppID)
	{
		this._app = new Device.IPCEmitter.App(sourceAppID, url);
		this.emit(this._app);

		//Cascade the original message back out to native for forwarding
		this._onResumeFromOthersSendGen(url, sourceAppID);
	},
	
	// Should only be called by privileged callers
	_setEmitIntents: function ( emit ) {
		this._shouldEmitIntents = Boolean(emit);
	},

	_onIntentReceived: function (action, extras)
	{
		console.log("On IntentReceived: " + action + " / " + JSON.stringify(extras));
		if (this._shouldEmitIntents) {
			this.emit( new exports.IPCEmitter.Intent(action, extras) );
		}
	},

	// private
	_canLaunchCallbackRecv: function( cmd )
	{
		var msg = {};
		if (! this._canLaunchCallbackRecvGen(cmd, msg))
			return;

		var func = this._callbacks[parseInt(msg.callbackID, 10)];
		if (func) {
			func(msg.canLaunch);
		}
	},

	_onResumeFromOthersRecv: function(cmd)
	{
		var msg = {};
		if (! this._onResumeFromOthersRecvGen(cmd, msg))
			return;

		this._onResumedFromOthers(msg.url, msg.sourceAppID);
	},

	_launchFailedRecv: function( cmd )
	{
		var msg = {};
		if (! this._launchFailedRecvGen(cmd, msg))
			return;

		var func = this._callbacks[parseInt(msg.callbackID, 10)];
		if (func) {
			func(msg.canLaunch);
		}
	},

	_getAppSignaturesCallbackRecv: function( cmd )
	{
		var msg = {};
		if (! this._getAppSignaturesCallbackRecvGen(cmd, msg))
			return;

		var func = this._callbacks[parseInt(msg.callbackID, 10)];
		if (func) {
			func(msg.signatures.split(','));
		}
	},

	_getCallingPackageCallbackRecv: function( cmd )
	{
		var msg = {};
		if (! this._getCallingPackageCallbackRecvGen(cmd, msg))
			return;

		var func = this._callbacks[parseInt(msg.callbackID, 10)];
		if (func) {
			func(msg.packageName);
		}
	},
	
	
	_getIsServiceRunningCallbackRecv: function( cmd )
	{
		var msg = {};
		if (! this._getIsServiceRunningCallbackRecvGen(cmd, msg))
			return;

		var func = this._callbacks[parseInt(msg.callbackID, 10)];
		if (func) {
			func(msg.running);
		}
	},
	
	_onIntentReceivedRecv: function( cmd )
	{
		var msg = {};
		if (! this._onIntentReceivedRecvGen(cmd, msg))
			return;
		
		this._onIntentReceived( msg.action, JSON.parse(msg.extras, 10) );
	},

// {{?Wg Generated Code}}
	
	// Enums.
	/** 
			* Enumeration for services whose status may be queried.
			* @namespace
			 */
	Service:
	{ 
		/** * */
		SystemDownloadProvider: 1,
	},
	
	///////
	// Class constants (for internal use only):
	// Class ID = 349
	// Method create = -1
	// Method canLaunch = 2
	// Method launch = 3
	// Method onResumeFromOthers = 4
	// Method launchFailed = 5
	// Method canLaunchCallback = 6
	// Method getAppSignatures = 7
	// Method getAppSignaturesCallback = 8
	// Method getCallingPackage = 9
	// Method getCallingPackageCallback = 10
	// Method launchIntent = 11
	// Method launchService = 12
	// Method onIntentReceived = 13
	// Method getIsServiceRunning = 14
	// Method getIsServiceRunningCallback = 15
	// Method createShortcut = 16
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 4:
					instance._onResumeFromOthersRecv( cmd );
					break;
				case 5:
					instance._launchFailedRecv( cmd );
					break;
				case 6:
					instance._canLaunchCallbackRecv( cmd );
					break;
				case 8:
					instance._getAppSignaturesCallbackRecv( cmd );
					break;
				case 10:
					instance._getCallingPackageCallbackRecv( cmd );
					break;
				case 13:
					instance._onIntentReceivedRecv( cmd );
					break;
				case 15:
					instance._getIsServiceRunningCallbackRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in IPCEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in IPCEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[349] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_onResumeFromOthersRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in IPCEmitter.onResumeFromOthers from command: " + cmd );
			return false;
		}
		
		obj[ "url" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "url" ] === undefined )
		{
			NgLogE("Could not parse url in IPCEmitter.onResumeFromOthers from command: " + cmd );
			return false;
		}
		
		obj[ "sourceAppID" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "sourceAppID" ] === undefined )
		{
			NgLogE("Could not parse sourceAppID in IPCEmitter.onResumeFromOthers from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_launchFailedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in IPCEmitter.launchFailed from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in IPCEmitter.launchFailed from command: " + cmd );
			return false;
		}
		
		obj[ "callbackID" ] = Core.Proc.parseInt( cmd[ 1 ] );
		if( obj[ "callbackID" ] === undefined )
		{
			NgLogE("Could not parse callbackID in IPCEmitter.launchFailed from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_canLaunchCallbackRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in IPCEmitter.canLaunchCallback from command: " + cmd );
			return false;
		}
		
		obj[ "canLaunch" ] = Core.Proc.parseBool( cmd[ 0 ] );
		if( obj[ "canLaunch" ] === undefined )
		{
			NgLogE("Could not parse canLaunch in IPCEmitter.canLaunchCallback from command: " + cmd );
			return false;
		}
		
		obj[ "callbackID" ] = Core.Proc.parseInt( cmd[ 1 ] );
		if( obj[ "callbackID" ] === undefined )
		{
			NgLogE("Could not parse callbackID in IPCEmitter.canLaunchCallback from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_getAppSignaturesCallbackRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in IPCEmitter.getAppSignaturesCallback from command: " + cmd );
			return false;
		}
		
		obj[ "signatures" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "signatures" ] === undefined )
		{
			NgLogE("Could not parse signatures in IPCEmitter.getAppSignaturesCallback from command: " + cmd );
			return false;
		}
		
		obj[ "callbackID" ] = Core.Proc.parseInt( cmd[ 1 ] );
		if( obj[ "callbackID" ] === undefined )
		{
			NgLogE("Could not parse callbackID in IPCEmitter.getAppSignaturesCallback from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_getCallingPackageCallbackRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in IPCEmitter.getCallingPackageCallback from command: " + cmd );
			return false;
		}
		
		obj[ "packageName" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "packageName" ] === undefined )
		{
			NgLogE("Could not parse packageName in IPCEmitter.getCallingPackageCallback from command: " + cmd );
			return false;
		}
		
		obj[ "callbackID" ] = Core.Proc.parseInt( cmd[ 1 ] );
		if( obj[ "callbackID" ] === undefined )
		{
			NgLogE("Could not parse callbackID in IPCEmitter.getCallingPackageCallback from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_onIntentReceivedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in IPCEmitter.onIntentReceived from command: " + cmd );
			return false;
		}
		
		obj[ "action" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "action" ] === undefined )
		{
			NgLogE("Could not parse action in IPCEmitter.onIntentReceived from command: " + cmd );
			return false;
		}
		
		obj[ "extras" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "extras" ] === undefined )
		{
			NgLogE("Could not parse extras in IPCEmitter.onIntentReceived from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_getIsServiceRunningCallbackRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in IPCEmitter.getIsServiceRunningCallback from command: " + cmd );
			return false;
		}
		
		obj[ "running" ] = Core.Proc.parseBool( cmd[ 0 ] );
		if( obj[ "running" ] === undefined )
		{
			NgLogE("Could not parse running in IPCEmitter.getIsServiceRunningCallback from command: " + cmd );
			return false;
		}
		
		obj[ "callbackID" ] = Core.Proc.parseInt( cmd[ 1 ] );
		if( obj[ "callbackID" ] === undefined )
		{
			NgLogE("Could not parse callbackID in IPCEmitter.getIsServiceRunningCallback from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":349,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_canLaunchSendGen: function( url, callbackID )
	{
		Core.Proc.appendToCommandString( ":349,2," + this.__objectRegistryId + "," + Core.Base64.encode( url ) + "," + callbackID  );
	},
	
	/** @private */
	_launchSendGen: function( url, callbackID )
	{
		Core.Proc.appendToCommandString( ":349,3," + this.__objectRegistryId + "," + Core.Base64.encode( url ) + "," + callbackID  );
	},
	
	/** @private */
	_onResumeFromOthersSendGen: function( url, sourceAppID )
	{
		Core.Proc.appendToCommandString( ":349,4," + this.__objectRegistryId + "," + Core.Base64.encode( url ) + "," + Core.Base64.encode( sourceAppID )  );
	},
	
	/** @private */
	_getAppSignaturesSendGen: function( packageName, callbackID )
	{
		Core.Proc.appendToCommandString( ":349,7," + this.__objectRegistryId + "," + Core.Base64.encode( packageName ) + "," + callbackID  );
	},
	
	/** @private */
	_getCallingPackageSendGen: function( callbackID )
	{
		Core.Proc.appendToCommandString( ":349,9," + this.__objectRegistryId + "," + callbackID  );
	},
	
	/** @private */
	_launchIntentSendGen: function( intent, extras )
	{
		Core.Proc.appendToCommandString( ":349,11," + this.__objectRegistryId + "," + Core.Base64.encode( intent ) + "," + Core.Base64.encode( extras )  );
	},
	
	/** @private */
	_launchServiceSendGen: function( intent, extras )
	{
		Core.Proc.appendToCommandString( ":349,12," + this.__objectRegistryId + "," + Core.Base64.encode( intent ) + "," + Core.Base64.encode( extras )  );
	},
	
	/** @private */
	_getIsServiceRunningSendGen: function( serviceEnum, callbackID )
	{
		Core.Proc.appendToCommandString( ":349,14," + this.__objectRegistryId + "," + serviceEnum + "," + callbackID  );
	},
	
	/** @private */
	_createShortcutSendGen: function( name, url, icon_path )
	{
		Core.Proc.appendToCommandString( ":349,16," + this.__objectRegistryId + "," + Core.Base64.encode( name ) + "," + Core.Base64.encode( url ) + "," + Core.Base64.encode( icon_path )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// canLaunch: function( url, callbackID ) {}
	
	// launch: function( url, callbackID ) {}
	
	// _onResumeFromOthersRecv: function( cmd ) {}
	// onResumeFromOthers: function( url, sourceAppID ) {}
	
	// _launchFailedRecv: function( cmd ) {}
	// _canLaunchCallbackRecv: function( cmd ) {}
	// getAppSignatures: function( packageName, callbackID ) {}
	
	// _getAppSignaturesCallbackRecv: function( cmd ) {}
	// getCallingPackage: function( callbackID ) {}
	
	// _getCallingPackageCallbackRecv: function( cmd ) {}
	// launchIntent: function( intent, extras ) {}
	
	// launchService: function( intent, extras ) {}
	
	// _onIntentReceivedRecv: function( cmd ) {}
	// getIsServiceRunning: function( serviceEnum, callbackID ) {}
	
	// _getIsServiceRunningCallbackRecv: function( cmd ) {}
	// createShortcut: function( name, url, icon_path ) {}
	

// {{/Wg Generated Code}}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/LayoutEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/LayoutEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/LayoutEmitter'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class LayoutEmitter
//
// Copyright (C) 2011 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


var Core = require('NGCore/Client/Core').Core;

////////////////////////////////////////////////////////////////////////////////

exports.LayoutEmitter = Core.MessageEmitter.singleton(
/** @lends Device.LayoutEmitter.prototype */
{
	classname: 'LayoutEmitter',
	
	/**
	 * Function.
	 * @constructs
	 * @augments Core.Class
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
	},
	
	_layoutChangedRecv: function( cmd ) 
	{
		var msg = {};
		if(!this._layoutChangedRecvGen(cmd, msg))
			return;

 		this._width = msg['width'];
 		this._height = msg['height'];
 		//NgLogD("+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++JS received width as :"+ this._width + " and height as :" + this._height); 
		this.emit(msg);
		this._layoutChangedSendGen(msg.width, msg.height);
	},
	
	$getWidth: function()
	{
		return this._width;
	},
	
	$getHeight: function()
	{
		return this._height;
	},
	
	/**
	 * @private
	 */
	setWidthAndHeight: function(width, height) {
		//NgLogD("---------------------------------Setting width and height for LayoutEmitter directly from native ......... width is " + width + " and height is " + height );
		this._width = width;
		this._width = height;
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 352
	// Method create = -1
	// Method layoutChanged = 2
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._layoutChangedRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in LayoutEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in LayoutEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[352] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_layoutChangedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in LayoutEmitter.layoutChanged from command: " + cmd );
			return false;
		}
		
		obj[ "width" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "width" ] === undefined )
		{
			NgLogE("Could not parse width in LayoutEmitter.layoutChanged from command: " + cmd );
			return false;
		}
		
		obj[ "height" ] = Core.Proc.parseInt( cmd[ 1 ] );
		if( obj[ "height" ] === undefined )
		{
			NgLogE("Could not parse height in LayoutEmitter.layoutChanged from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":352,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_layoutChangedSendGen: function( width, height )
	{
		Core.Proc.appendToCommandString( ":352,2," + this.__objectRegistryId + "," + width + "," + height  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _layoutChangedRecv: function( cmd ) {}
	// layoutChanged: function( width, height ) {}
	

// {{/Wg Generated Code}}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Common/Appdata'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Appdata'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Appdata'] = exports; var GSGlobals = require('NGCore/Client/Social/_Internal/GSGlobals');

/**
 * @class 
 * @name Social.Common.Appdata
 * @description
 * Mobage provides a common API for application data, which you can use for both Japan and the US. 
 * <code>Appdata</code> is consistent with the Open Social <code>osapi.appdata</code> interface, 
 * and enables the application to store name/value pairs for arbitrary application data.
 * To add or update application data, call <code>updateEntries()</code>. To retrieve entries, call <code>getEntries()</code>. 
 * To delete entries, call <code>deleteEntries()</code>.
 * @see Social.US.AppData for additional Mobage persistence facilities.
 * @see Storage.KeyValue for additional ngCore persistence facilities.
 * @see Storage.FileSystem for additional ngCore persistence facilities.
 */
exports.Appdata = {
		
	/**
	 * Retrieves a hash of one or more key/value pairs.
	 * If the <code>keys</code> parameter is <code>null</code>, <code>undefined</code> or an empty array, <code>getEntries()</code> 
	 * returns all key/value pairs to the callback function.
	 *
	 * @name Social.Common.Appdata.getEntries
	 * @function
	 * @public
	 * 
	 * @param {Array} keys Set as an array of key names. For example, <code>['key1', 'key2']</code>.
	 * @param {Function} callback Retrieves a hash of key/value pairs. If an error occurs, retursn an error code and description.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">var entries = {"key1": "value1", "key2": "value2"};
     * ...
     * function(error, entries){
     * &nbsp;&nbsp;   if (error){
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var errorDesc = error.description;
     * &nbsp;&nbsp;   } else {
     * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var retrievedEntries = entries;
     * &nbsp;&nbsp;   }
	 * }
	 * </pre>
	 * @see Social.Common.Appdata.updateEntries
	 * @example 
	 * Appdata.getEntries(['key1', 'key2'], callback );
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */	
	getEntries: function(keys, callback) {
		var cmd = {apiURL:"Common.Appdata.getEntries", keys:keys, callbackFunc:callback};
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);		
	},
	
	/**
	 * Inserts or updates the submitted key/value pairs. 
	 * <b>Note:</b> Limited to 30 key/value pairs per user, per game. 
	 * Maximum key name limited to 32 bytes. Maximum value limited to 1,024 bytes.
     * To use key/value pairs without the foregoing constraints, use <code>Storage.KeyValue</code>
     * in ngCore.
	 *
	 * @name Social.Common.Appdata.updateEntries
	 * @function
	 * @public
	 * 
	 * @param {Hash} entries Takes a hash of key/value pairs. For example, <code>{"favoriteMovie": "Pulp Fiction", "petName": "Rover"}</code>.
	 * @param {Function} callback Retrieves the updated entries. If an error occurs, returns an error code and description.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">var entries = {"favoriteMovie": "Pulp Fiction", "petName": "Rover"};
     * ...
     * function(error, entries){
     * &nbsp;&nbsp;   if (error){
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var errorDesc = error.description;
     * &nbsp;&nbsp;   } else {
     * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var updatedEntries = entries;
     * &nbsp;&nbsp;   }
	 * }
	 * </pre>
	 * @see Social.Common.Appdata.getEntries
	 * @example
	 * Appdata.updateEntries(
	 *              {   'favoriteMovie':'Pulp Fiction',    
	 *                  'petName':'Rover' }, 
	 *              callback );
	 * @status iOS, Android, Test, iOSTested, AndroidTested
     * @see Social.US.AppData for additional Mobage persistence facilities.
     * @see Storage.KeyValue for additional ngCore persistence facilities.
     * @see Storage.FileSystem for additional ngCore persistence facilities.
	 */		
	updateEntries: function(entries, callback) {
		if(entries) {
			var cmd = {apiURL:"Common.Appdata.updateEntries", entries:entries, callbackFunc:callback};
			GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
		} else {
			if(typeof callback === 'function') {
				callback({ 
						errorCode: 400,
						description: "Entries to update are a required parameter"
					}, null);
			}
		}
	},
	
	
	/**
	 * Deletes one or more key/value pairs.
	 *
	 * @name Social.Common.Appdata.deleteEntries
	 * @function
	 * @public
	 * 
	 * @param {Array} keys Takes an array of key names. For example, <code>['petName']</code>. 
     * If <code>null</code>, the return object in the callback is not defined.
	 * @param {Function} callback  Retrieves a hash of the deleted entries. If an error occurs, returns an error code and description.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">var keys = {"petName"};
     * ...
     * function(error, keys){
     * &nbsp;&nbsp;   if (error){
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var errorDesc = error.description;
     * &nbsp;&nbsp;   } else {
     * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var deletedKeys = keys;
     * &nbsp;&nbsp;   }
	 * }
	 * </pre>
	 * @example
	 * Appdata.deleteEntries(['petName'], callback );
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */		
	deleteEntries: function(keys, callback) {
		if(keys && keys.length > 0) {
			var cmd = {apiURL:"Common.Appdata.deleteEntries", keys:keys, callbackFunc:callback};
			GSGlobals.getRouterInstance().sendCommandToGameService(cmd);		
		} else {
			if(typeof callback === 'function') {
				callback({ 
						errorCode: 400,
						description: "Keys to delete are a required parameter"
					}, null);
			}
		}
	}
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Common/Auth'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Auth'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Auth'] = exports; var GSGlobals = require('NGCore/Client/Social/_Internal/GSGlobals');

/**
 * @class
 * @name Social.Common.Auth
 * @description
 * Retrieves a verification code.
 * Games call <code>Auth.authorizeToken()</code> if the game server is using the Mobage REST API.
 * For more information, refer to the Mobage RESTful API Conventions section of the developer's guide.
 */
exports.Auth = {
		
		
	/**
	 * Authorizes a temporary credential and returns a verification code.
	 *
	 * 
	 * @name Social.Common.Auth.authorizeToken
	 * @function
	 * @public
	 *
	 * @param {String} token The temporary credential identifier. 
	 * @param {Function} callback The callback function that handles the verification code and errors.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 *  <pre class="code">
     *  var verifier = "jklmnop";
	 *  function(error, verifier){
     *  &nbsp;&nbsp; if (error){
	 *  &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	 *  &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
	 *  &nbsp;&nbsp; } else {
     *  &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var verificationCode = verifier;    
     *  &nbsp;&nbsp; }
     *  }
	 * </pre>
	 * @example
	 * var token = "abcdefghi";
     * ...
	 * Social.Common.Auth.authorizeToken (token, callback);
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */		
	authorizeToken: function(token, callback) {
		var cmd = {apiURL:"Common.Auth.authorizeToken", token:token, callbackFunc: callback };
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);		
		//callback(error, verifier)
	}
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Common/Blacklist'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Blacklist'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Blacklist'] = exports; var GSGlobals = require('NGCore/Client/Social/_Internal/GSGlobals');

/**
 * @class 
 * @name Social.Common.Blacklist
 * @description
 * Provides an interface for checking the user's blacklist.
 */
exports.Blacklist = {

	/**
	 * Retrieves the target user ID from the specified user's blacklist.
	 * This call passes a user ID and a target user ID to determine if the specified target user is blacklisted. 
	 * If the target user ID parameter is <code>null</code>, this call retrieves the entire blacklist. The callback function also receives the total number of 
	 * target user IDs, the starting index, and the number of target IDs returned for paging the results.
	 *
	 * @name Social.Common.Blacklist.checkBlacklist
	 * @function
	 * @public
	 *
	 * @param {String} userId The user ID for the user who owns the blacklist. 
	 * @param {String} targetUserId The target user ID to check in the blacklist. <br/>If <code>null</code>, it checks the entire blacklist.
	 * @param {Hash} opt Takes a hash containing the start index and count for pagination. <br/>E.g., <code>{'start': 1, 'count': 100}</code> 
     * Requires start index and count. The minimum start index is 1. 
     * If <code>null</code>, undefined or an empty array, the start index is 1 and the count is 50.
	 * @param {Function} callback Retrieves an array of user IDs found in the blacklist. Otherwise, it retrieves an empty array.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">var listedUsers = ['user1', 'user2'];
     * ...
     * function(error, listedUsers, result)
	 * &nbsp;&nbsp;		{
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;			var blackListedUsers = listedUsers;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;			var total = result.total;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;			var start = result.start;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;			var count = result.count;
  	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;			var errorCode = error.errorCode;
  	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;			var errorDesc = error.description;
  	 * &nbsp;&nbsp;	}
  	 * </pre>
  	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */			
	checkBlacklist: function(userId, targetUserId, opt, callback) {
		var cmd = {apiURL:"Common.Blacklist.checkBlacklist", userId:userId, targetUserId:targetUserId, opt:opt, callbackFunc: function(error, args) {
			callback(error, args.users, args.result);
		}};
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);		
	}
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Common/Config'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Config'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Config'] = exports; var Session = require('NGCore/Client/Social/US/Data/Session').Session;

/**
 * @class 
 * @name Social.Common.Config
 * @description
 * Mobage provides a common API to determine if the server is a sandbox server or a production server. 
 */
exports.Config = {

    /**
    * Returns whether the server is a sandbox server or a production server. 
    * Returns "unknown" if it cannot retrieve the current session
    * or if the server mode is not "sandbox" or "production."
    * 
    * @name Social.Common.Config.getServerEnvironment
    * @public
    * @function
    * @returns {String} "sandbox," "production" or "unknown."
    * @see Social.US.Session.serverModes
    * @status iOS, Android, Test, iOSTested, AndroidTested
    */
	getServerEnvironment: function(){
		var session = Session.getCurrentSession();
		if(!session){
			return "unknown";
		}
		
		var serverMode = Session.getCurrentSession().serverMode();
		if(serverMode == Session.serverModes.production){
			return "production";
		}else if(serverMode == Session.serverModes.sandbox){
			return "sandbox";
		}else{
			return "unknown";
		}
	}
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Common/People'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Common/People'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Common/People'] = exports; var GSGlobals = require('NGCore/Client/Social/_Internal/GSGlobals');

/**
 * @class 
 * @name Social.Common.People
 * @description
 * The social API for returning user objects with their social graphs. The user object
 * retrieved varies from platform to platform. US platform required fields are <code>id</code>, <code>displayName</code>, <code>hasApp</code> 
 * and <code>thumbnailUrl</code> of the <code>Person</code> data type.
 */
exports.People = {
	
	/**
	 * Retrieves fields for the specified user from the <code>Person</code> data type. The specified user corresponds to the user ID parameter.
	 * Below are the fields returned by this call:
	 * <ul>
	 * <li><code>id</code></li>
	 * <li><code>displayName</code></li>
	 * <li><code>hasApp</code></li>
	 * <li><code>thumbnailUrl</code></li>
	 * </ul>
	 * Use the <code>fields</code> parameter to retrieve non-required fields of the <code>Person</code> data type.
	 *
	 * @name Social.Common.People.getUser
	 * @function 
	 * @public 
	 *
	 * @param {String} userId The user ID of the user to retrieve.
	 * @param {Array} fields An array of non-required fields of the <code>Person</code> data type to include in the response to the callback. 
     * <br/>For example, <code>['nickname','aboutMe']</code>. If <code>null</code>, <code>undefined</code> or an empty array, this call only retrieves the required fields.
	 * @param {Function} callback Retrieves the user specified by the <code>userId</code> parameter. If an error occurs, returns an error code and error description.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error, user){
     * &nbsp;&nbsp; if (error) {
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
     * &nbsp;&nbsp; } else {
     * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var retrievedUser = user;
     * &nbsp;&nbsp;}
	 * }</pre>
	 * @see Social.Common.People.getCurrentUser
	 * @example
	 * var recordID = 2;
	 *
	 * Social.Common.People.getUser(recordID, 
	 *                              ['id','nickname','aboutMe'], 
	 *                              callback
	 *		});
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */						
	getUser: function(userId, fields, callback) {
		var cmd = {apiURL:"Common.People.getUser", userId:userId, fields:fields, callbackFunc:callback};
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},

	/**
	 * Retrieves an array of users.
	 * Takes one or more user IDs and retrieves an array of users with the callback. 
	 * Retrieves up to 100 users, with no guarantee of retrieving the user array 
	 * in the order specified.
	 * Retrieves the <code>id</code>, <code>displayName</code>, <code>hasApp</code> 
	 * and <code>thumbnailUrl</code> fields of the <code>Person</code> data type for each user.
	 * To retrieve non-required fields of the <code>Person</code> data type, specify the non-required fields 
	 * desired in the <code>fields</code> parameter.
	 *	 
	 * @name Social.Common.People.getUsers
	 * @function 
	 * @public
	 * 
	 * @param {Array} userIds An array of user IDs of the users to retrieve. Minimum array size is 1, and maximum is 100.
	 * @param {Array} fields An array of non-required fields of the <code>Person</code> data type to include in the callback. <br/>For example, <code>['nickname','aboutMe']</code>.
     * <br/>If <code>null</code>, <code>undefined</code> or an empty array, it retrieves only the required fields.
	 * @param {Function} callback Retrieves an array of users specified by the <code>userIds</code> parameter and/or an error code and description.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error, users){
     * &nbsp;&nbsp; if (error) {
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
     * &nbsp;&nbsp; } else {
     * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var retrievedUsers = users;
     * &nbsp;&nbsp;}
	 * }</pre>
	 * @see Social.Common.People.getUser
	 * @example
	 * People.getUsers([1,2,3],null, callback);
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */				
	getUsers: function(userIds, fields, callback) {
		var cmd = {apiURL:"Common.People.getUsers", userIds:userIds, fields:fields, callbackFunc:function(errors, args) {
			callback(errors, args.users, args.results);
		}};
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},
	
	
	/**
	 * Retrieves fields for the current user from the <code>Person</code> data type. Below are the fields returned by this call:
	 * <ul>
	 * <li><code>id</code></code>
	 * <li><code>displayName</code></li>
	 * <li><code>hasApp</code></li>
	 * <li><code>thumbnailUrl</code></li>
	 * </ul>
	 *
	 * @name Social.Common.People.getCurrentUser
	 * @function
	 * @public
	 *
	 * @param {Array} fields An array of non-required fields of the <code>Person</code> data type to include in the callback. <br/>For example, <code>['nickname','aboutMe']</code>.
     * <br/>If <code>null</code>, <code>undefined</code> or an empty array, this call only retrieves the required fields.
	 * @param {Function} callback Retrieves the current user. If an error occurs, returns an error code and error description.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error, user){
     * &nbsp;&nbsp; if (error) {
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
     * &nbsp;&nbsp; } else {
     * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var currentUser = user;
     * &nbsp;&nbsp;}
	 * }</pre>
	 * @see Social.Common.People.getUser
	 * @example
	 * People.getCurrentUser(null, callback);
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */				
	getCurrentUser: function(fields, callback) {
		var cmd = {apiURL:"Common.People.getCurrentUser", fields:fields, callbackFunc:callback};
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},
	
	
	/**
	 * Retrieves fields for friends of a specified user. Below are the fields returned by this call:
	 * <ul>
	 * <li><code>id</code></li>
	 * <li><code>displayName</code></li>
	 * <li><code>hasApp</code></li> 
	 * <li><code>thumbnailUrl</code></li>
	 * </ul>
	 *
	 * @name Social.Common.People.getFriends
	 * @function
	 * @public
	 * 
	 * @param {String} userId The user ID of the user whose friends are retrieved by the callback function. 
	 * @param {Array} [fields] An array of non-required fields of the <code>Person</code> data type to include in the response to the callback. 
     * <br/>For example, <code>['nickname','aboutMe']</code>.
     * <br/> If <code>null</code>, <code>undefined</code> or an empty array, this call only retrieves the required fields.
	 * @param {Hash} [opt] A hash containing the start index and count for pagination. <br/>For example, <code>{'start': 1, 'count': 100}</code> 
	 * @param {Function} callback Retrieves the friends of the given user. If an error occurs, returns an error code and description.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error, friends){
     * &nbsp;&nbsp; if (error) {
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
     * &nbsp;&nbsp; } else {
     * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var retrievedFriends = friends;
     * &nbsp;&nbsp;}
	 * }</pre>
	 * @see Social.Common.People.getFriendsWithGame
	 * @example
	 * People.getFriends(4, null, {'start': 2}, callback);
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */					
	getFriends: function(userId, fields, opt, callback) {
		var cmd = {apiURL:"Common.People.getFriends", userId:userId, fields:fields, opt:opt, callbackFunc: function(errors, args) {
			callback(errors, args.users, args.results);
		}};
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},
	
	
	/**
	 * Retrieves a list of the user's friends playing the current game.
	 *
	 * @name Social.Common.People.getFriendsWithGame
	 * @function
	 * @public
	 *
	 * @param {String} userId The user ID of the person whose friends play the current game.
	 * @param {Array} fields An array of non-required fields of the <code>Person</code> data type to include in the response to the callback. 
     * <br/>For example, <code>['nickname','aboutMe']</code>.
     * <br/> If <code>null</code>, <code>undefined</code> or an empty array, this call retrieves only the required fields.
	 * @param {Hash} opt A hash containing the start index and count for pagination. <br/>For example, <code>{'start': 1, 'count': 100}</code> 
	 * @param {Function} callback Retrieves the friends of the specified user. If an error occurs, returns an error code and error description.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error, friends){
     * &nbsp;&nbsp; if (error) {
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
     * &nbsp;&nbsp; } else {
     * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var retrievedFriends = friends;
     * &nbsp;&nbsp;}
	 * }</pre>
	 * @see Social.Common.People.getFriends
	 * @example 
	 * People.getFriendsWithGame(4, null, null, callback);
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */						
	getFriendsWithGame: function(userId, fields, opt, callback) {
		var cmd = {apiURL:"Common.People.getFriendsWithGame", userId:userId, fields:fields, opt:opt, callbackFunc: function(errors, args) {
			callback(errors, args.users, args.results);
		}};
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	}
	
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Common/Profanity'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Profanity'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Profanity'] = exports; var GSGlobals = require('NGCore/Client/Social/_Internal/GSGlobals');	

/**
 * @class 
 * @name Social.Common.Profanity
 * @description
 * Provides an interface to check games for profanity.
 */
exports.Profanity = {
	
	/**
	 * Checks a text string to determine if it contains profanity.
	 * This call only conducts a check and does not attempt to cleanup the string.<br><br>
	 * <b>Note:</b> The server handles locale and language automatically.
	 *
	 * @name Social.Common.Profanity.checkProfanity
	 * @function
	 * @public
	 * 
	 * @param {String} text The string to check for profanity.
	 * @param {Function} callback Retrieves any profane words or phrases in the text parameter. 
     * The result of checking is either <code>true</code> or <code>false</code>. If the result is <code>false</code>, the text string contains profanity. 
     	 * If an error occurs, returns an error code and error description to the callback.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class='code'>function(error, args){
     * &nbsp;&nbsp; if(error){
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var errorDesc = error.description;
     * &nbsp;&nbsp;} else {
     * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var profanity = args.profanity;
     * &nbsp;&nbsp;}
	 * }
	 * </pre>
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */		
	checkProfanity: function(text, callback) {
		var cmd = {apiURL:"Common.Profanity.checkProfanity", text:text, callbackFunc:function(error, args) {
			callback(error, args.profanity);
		}};
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);		
	}	
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Common/Request'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Request'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Request'] = exports; var Class = require('NGCore/Client/Core/Class').Class;


//Don't need to document
exports.Request = Class.subclass({
	execute: function(callback) {
		// [call US function here]	
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Common/Service'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Service'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Service'] = exports; var UI = require('NGCore/Client/UI').UI;

var RouterInited = require('NGCore/Client/Social/_Internal/RouterInit');
var GSGlobals = require('NGCore/Client/Social/_Internal/GSGlobals');

var MessageEmitter = require('NGCore/Client/Core/MessageEmitter').MessageEmitter;

var ButtonOverlays = require('NGCore/Client/Social/US/Service/ButtonOverlays').ButtonOverlays;
var Friends = require('NGCore/Client/Social/US/Service/Friends').Friends;
var Profile = require('NGCore/Client/Social/US/Service/Profile').Profile;
var User    = require('NGCore/Client/Social/US/Models/User').User;

/**
 * @class 
 * @name Social.Common.Service
 * @description
 * This interface provides the following social game services: <br/>
 * <div class="ul">
 * <li>Balance Button</li>
 * <li>Community Button</li>
 * <li>Friend Picker</li>
 * <li>User Finder</li>
 * <li>User Profile</li>
 * </div>
 */
exports.Service = {

	
	/**
	* Opens the user finder screen.
	* The user finder provides a way for users to find other users using the following filters:
	* <ul>
	* <li>Suggested Friends</li>
	* <li>Contacts</li> 
	* <li>Requests</li>
	* <li>Search</li>
	* </ul>
	*
	* @name Social.Common.Service.openUserFinder 
	* @function
	* @public
	* @status iOS, Android, Test, iOSTested, AndroidTested
    */		
	openUserFinder: function() {
		Friends.showFindFriends(undefined);
	},

	
	/**
	* Opens the friend picker.
	*
	* @name Social.Common.Service.openFriendPicker 
	* @function
	* @public 
	* 
	* @param {Number} maxFriendsToSelect The maximum number of friends the user may select.
	* @param {Function} callback The callback function called after the view closes. Returns an array of friends.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <pre class="code">function(error, friendUserIds){
	* 	&nbsp;&nbsp;&nbsp;if (error){
	* 	&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;  		var errorCode = error.errorCode;
	*   &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;  		var errorDesc = error.description;
	* 	&nbsp;&nbsp;&nbsp;} else {
	*   &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;  		var pickedFriends = friendUserIds;
	*   &nbsp;&nbsp;&nbsp;  	}
	*   &nbsp;&nbsp;  }
	* </pre>
	* @status iOS, Android, Test, iOSTested, AndroidTested
	*/
	openFriendPicker: function(maxFriendsToSelect, callback) {
		Friends.showFriendPicker(maxFriendsToSelect, function(err, friends){
			var userIDs = [];
			friends = friends || [];
			for(var idx = 0; idx < friends.length; idx++){
				userIDs.push(friends[idx].recordID);
			}
			callback( userIDs );
		});
	},

	
	/**
	* Opens the specified profile page.
	*
	* @name Social.Common.Service.openUserProfile 
	* @function
	* @public 
	* 
	* @param {String} userId The user ID or gamer name of the profile page to open.
	* @param {Function} callback The callback function if there is an error with the user ID or gamer name.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <pre class="code">function(error){
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
	* &nbsp;&nbsp;   }
	* </pre>
	* @status iOS, Android, Test, iOSTested, AndroidTested
	*/
	openUserProfile: function(userId, callback) {
		if(typeof userId == "string"){
			// if the userId string contains no non-numeral characters:
			//   parse it into a number
			// else null it out, because it's not a valid userId
			if(userId.match(/[^0-9]/) === null){
				userId = parseInt(userId, 10);
			}else{
				userId = null;
			}
		}
		
		if( !userId ){
			callback({errorCode: 400, description: "userid is invalid"});
		}
		else{
			User.getUserWithID(userId, function(err, user){
				if(err){
					if( err==="Sorry, we can't find anyone with that name." ){
						callback({errorCode: 404, description: err});
					} else {
						callback({errorCode: 500, description: err});
					}
				}else if(!user){
					callback({errorCode: 404, description: "User not found"});
				}else{
					Profile.showUserProfile(user, undefined);
				}
			});
	}
	},


	/**
	* Displays the <b>Mobage Community</b> button.
	*	
	* @name Social.Common.Service.showCommunityButton
	* @function
	* @public 
	* 
	* @param {exports.Gravity} gravity Displays the button in the specified corner. 
    * <b>Note:</b> Only supported for the US. Japan uses the top-left corner only.
	* @param {String} theme Displays the theme for the button (for example, "default", "dark", "light"). 
    * <b>Note:</b> Only supported for Japan. You can specify <code>null</code> for the US region.
	* @param {Function} callback The callback function if there is an error related
    * to <code>gravity</code> or <code>theme</code> usage.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <pre class="code">function(error){
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
	* &nbsp;&nbsp;   }
	* </pre>
	* @see exports.Gravity
	* @status iOS, Android, Test, iOSTested, AndroidTested
	*/           
	showCommunityButton: function(gravity, theme, callback) {
		ButtonOverlays.showCommunityButton(gravity, callback);
	},

	/**
	* Hides the <b>Mobage Community</b> button.
	*
	* @name Social.Common.Service.hideCommunityButton
	* @function
	* @public 
	*	
	* @param {Function} callback The callback function if there is an error hiding the button.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <pre class="code">function(error){
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
	* &nbsp;&nbsp;   }
	* </pre>
	* @status iOS, Android, Test, iOSTested, AndroidTested
	*/		
	hideCommunityButton: function(callback) {
		ButtonOverlays.hideCommunityButton(callback);
	},

	
	/**
	* A message emitter object for adding a message emitter when inviting a user.
	*
	* @name Social.Common.Service.invitedUserEmitter
	* @field
	* @public
	* @example 
	* Social.Common.Service. ...
	* ... invitedUserEmitter.addListener(
	*			new Core.MessageListener(), 
	*			function(userId){
	*				NgLogD("New Emitter! " + userId);
	*			}
	*		);
    * @status iOS, Android, Test, iOSTested, AndroidTested	
	*/
	invitedUserEmitter : new MessageEmitter(),

	
	/**
	 * Shows the balance button where the <code>rect</code> parameter 
	 * determines the size and position of the button.
     * The minimum size of the button is:<br/>
     * <ul>
     * <li>10% of height in Landscape, and the absolute minimum size is 150 x 50.</li>
     * <li>6% of height in Portrait, and the absolute minimum size is 150 x 50.</li>
     	 * </ul>
	 *
	 * @name Social.Common.Service.showBalanceButton
	 * @function
	 * @public
	 *	 
	 * @param {UI.ViewGeometry.Rect} rect Determines the size and position of the balance button.
	 * @param {Function} callback The callback function if there is an error with the <code>rect</code> parameter.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error){
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
	 * &nbsp;&nbsp;   }
	 * </pre>
	 * @see UI.ViewGeometry.Rect
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	showBalanceButton: function(rect, callback) {		
		ButtonOverlays.showBalanceButton(rect, callback);
	},
	
	/**
	 * Hides the balance button.	
	 * @name Social.Common.Service.hideBalanceButton
	 * @function
	 * @public 
	 * 
	 * @param {Function} callback The callback function called after the view closes.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error){
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
	 * &nbsp;&nbsp;   }
     * </pre>
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */		
	hideBalanceButton: function(callback) {
		ButtonOverlays.hideBalanceButton(callback);
	}
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Common/Analytics'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Analytics'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Analytics'] = exports; var SessionReq = require('NGCore/Client/Social/US/Data/Session');

/**
 * @private
 * @name Social.Common.Analytics
 * @description Private interface for analytics data
 *
 * TODO: These should be going into the priv interpreter. But need to check with Japan.
 */
exports.Analytics = {
  getUserId: function() {
	var cur_sess =	this._getSession(), cur_u = null;
	if (cur_sess) {
	  cur_u = (cur_sess.user() || {}).recordID;
	}
	return cur_u;
  },
  getUsername: function() {
	var cur_sess =	this._getSession(), cur_u = null;
	if (cur_sess) {
	  cur_u = (cur_sess.user() || {}).gamertag;
	}
	return cur_u;
  },
  getPlatformVersion: function() {
	var cur_sess =	this._getSession(), cur_pver = null;
	if (cur_sess) {
	  cur_pver = cur_sess.platformVersion();
	}
	return cur_pver;
  },
  getServiceId: function() { 
	return "US"; 
  },
  _getSession: function() {
	return SessionReq.Session.getCurrentSession();
  }
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Models/DataModel'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Models/DataModel'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Models/DataModel'] = exports; var MessageEmitter = require('NGCore/Client/Core/MessageEmitter').MessageEmitter;
var SocialR = require('NGCore/Client/Social');
var SessionR        = require('NGCore/Client/Social/US/Data/Session');
var DispatcherR     = require('NGCore/Client/Social/US/Data/Dispatcher');

/**
 * <code>DataModel</code> constructs objects that emit messages when properties of an object change, and provides automatic caching,
 * serialization and deserialization between interpreters. 
 * <br/><br/>
 * <b>Note:</b> Do not instantiate this class directly. Use classes derived from <code>DataModel</code> for instantiation. These include:
 * <div class="ul">
 * <li>{@link Social.US.User}</li>
 * <li>{@link Social.US.AppData}</li>
 * <li>{@link Social.US.Game}</li>
 * <li>{@link Social.US.Score}</li>
 * <li>{@link Social.US.Leaderboard}</li>
 * </div>
 * @class 
 * @name Social.US.DataModel
 */
var DataModel = exports.DataModel = MessageEmitter.subclass({
		
	/**
	 * The default constructor.
	 * @constructs
	 * @private
	 */		
	initialize: function(recordID){
		this.recordID = recordID;

		this._cache();
	},
	beginChanges: function(){
		DispatcherR.Dispatcher.beginBatching();
	},
	endChanges: function(){
		DispatcherR.Dispatcher.endBatching();
	},
	_classname: function(){
		var classname = this.classname;
		return classname;
	},
	_cache: function(){
		if(!this._dataCache){
			var session = SessionR.Session.getCurrentSession();
			if(session){
				var cache = session.dataCache();
				if(cache){
					cache.addObject(this);
					this._dataCache = cache;
				}
			}
		}
		return this._dataCache;
	},
	$_serializedDataModel: function(obj){
		if(obj instanceof(DataModel)){
			obj = {
				classname: obj.classname,
				recordID:  obj.recordID
			};
		}
		return obj;
	},
	$_deserializedDataModel: function(value, cache){
		if(value && value.hasOwnProperty && value.hasOwnProperty("classname") && value.hasOwnProperty("recordID")){
			var theClassname = value.classname;
			var theClass = SocialR.Social.US[theClassname];
			var theRecordID = value.recordID;
			if(theClass && theRecordID){
				var theInstance = cache.getObjectWithRecordID(theClassname, theRecordID);
				if(!theInstance){
					theInstance = new theClass(theRecordID);
				}
				
				theInstance._deserializeFromHash(value.data);
				cache.addObject(theInstance);
    
				value = theInstance;
			}
		}
		return value;
	},
	_serializedHash: function(full){
		var theClass = this.constructor;
		var hash = {classname: theClass.classname, recordID: this.recordID};
		if(full === false){
			return hash; // if it's undefined, assume we want all the data
		}
		
		hash.data = {};
		
		var properties = this.constructor.properties || [];
		for(var idx = 0; idx < properties.length; idx++){
			var propertyName = properties[idx];
			var propertyValue = this[propertyName];

			if(propertyValue instanceof(Array)){
				for(var propertyIndex = 0; propertyIndex < propertyValue.length; propertyIndex++){
					propertyValue[propertyIndex] = DataModel._serializedDataModel(propertyValue[propertyIndex]);
				}
			}else{
				propertyValue = DataModel._serializedDataModel(propertyValue);
			}
			
			hash.data[propertyName] = propertyValue;
		}
		
		return hash;
	},
	_deserializeFromHash: function(data){
		if(!data){
			NgLogD("No public hash data for " + this.classname + " " + this.recordID);
			return;
		}
		
		var cache = this._cache();
		for(var key in data){
			var value = data[key];
			if(value instanceof(Array)){
				for(var propertyIndex = 0; propertyIndex < value.length; propertyIndex++){
					value[propertyIndex] = DataModel._deserializedDataModel(value[propertyIndex], cache);
				}
			}else{
				value = DataModel._deserializedDataModel(value, cache);
			}
			this[key] = value;
		}
	}
});

DataModel._oldSubclass = DataModel.subclass;
DataModel.subclass = function(contents){
	var theClass = DataModel._oldSubclass(contents);
	var properties = contents.properties || [];
	for(var idx = 0; idx < properties.length; idx++){
		var propertyName = properties[idx];
		
		(function(name){
			theClass.prototype.__defineSetter__(name, function(value){
				this["___" + name] = value;
				
				var msg = {};
				msg[""+name] = value;
				
				this.emit(msg);
			});
			theClass.prototype.__defineGetter__(name, function(value){
				return this["___" + name];
			});
		})(propertyName);
	}
	return theClass;
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Models/User'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Models/User'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Models/User'] = exports; var DataModelR  = require('NGCore/Client/Social/US/Models/DataModel');
var Dispatcher  = require('NGCore/Client/Social/US/Data/Dispatcher').Dispatcher;
var OrderedList = require('NGCore/Client/Social/US/Models/OrderedList').OrderedList;
var Social      = require('NGCore/Client/Social').Social;

/**
* <code>User</code> constructs objects that provide a service interface for the current user. 
* <code>User</code> objects enable the current user to retrieve:
* <div class="ul">
* <li>user details</li>
* <li>a list of friends</li>
* <li>games</li>
* </div>
* @class
* @name Social.US.User
* @augments Social.US.DataModel
*/
var User = exports.User = DataModelR.DataModel.subclass({
		
    /**
    * @constructs
    * @ignore
    */
	classname: "User",

	 /**
	 * The user's gamer tag. Read-only.
	 * @name Social.US.User.gamertag
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */

	 /**
	 * The user's avatar ID. Read-only.
	 * @name Social.US.User.avatarId
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	 /**
	 * The user's motto. Read-only.
	 * @name Social.US.User.motto
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	 /**
	 * The relation to this user. Read-only.
	 * @name Social.US.User.relation
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */

	 /**
	 * Sparse limits attributes in search results. Read-only.
	 * @name Social.US.User.sparse
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * The user's photo ID. Read-only.
	 * @name Social.US.User.photoId
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	 /**
	 * The user's email address. Read-only.
	 * @name Social.US.User.emailAddress
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * A hash of the user's email address. Read-only.
	 * @name Social.US.User.emailHash
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * The user's phone number. Read-only.
	 * @name Social.US.User.phoneNumber
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */


	 /**
	 * The user's password. Read-only.
	 * @name Social.US.User.password
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * The user's first name. Read-only.
	 * @name Social.US.User.firstName
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */


	 /**
	 * The user's last name. Read-only.
	 * @name Social.US.User.lastName
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * Whether to hide the user's full name. Read-only.
	 * @name Social.US.User.hideFullName
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	 /**
	 * Whether the user is age restricted. Read-only.
	 * @name Social.US.User.ageRestricted
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */

	 /**
	 * Whether the relationship to the user is new. Read-only.
	 * @name Social.US.User.isNewRelationship
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */

	 /**
	 * Whether the user is a mutual friend. Read-only.
	 * @name Social.US.User.isMutualFriend
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */

	 /**
	 * Whether the user shows his/her presence. Read-only.
	 * @name Social.US.User.showsPresence
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	 /**
	 * Whether the user only shows friend notifications. Read-only.
	 * @name Social.US.User.setOnlyShowFriendNotifications
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */	 

	 /**
	 * The user's capabilities. Read-only.
	 * @name Social.US.User.capabilities
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	 /**
	 * The user's gamer score. Read-only.
	 * @name Social.US.User.gamerscore
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */	 

	 /**
	 * The user's gamer level. Read-only.
	 * @name Social.US.User.gamerLevel
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */	 

	 /**
	 * The user's gamer level name. Read-only.
	 * @name Social.US.User.gamerLevelName
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	 /**
	 * The gamer level score. Read-only.
	 * @name Social.US.User.gamerLevelScore
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	 /**
	 * The gamer score for the next level. Read-only.
	 * @name Social.US.User.gamerNextLevelScore
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	 /**
	 * The user's games. Read-only.
	 * @name Social.US.User.games
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */

	properties: [
		// public
		"gamertag",
		"avatarId",
		"motto",
		"relation",
		"sparse",
		"photoId",
		"emailHash",
		"ageRestricted",
		"isMutualFriend",
		
		// private
		"phoneNumber",
		"password",
		"firstName",
		"lastName",
		"hideFullName",
		"emailAddress",
		"isNewRelationship",
		"showsPresence",
		"onlyShowFriendNotifications",
		"capabilities",
		"gamerscore",
		"gamerLevel",
		"gamerLevelName",
		"gamerLevelScore",
		"gamerNextLevelScore",
		"games"
	],
	
	/**
	 * @constructs The default constructor constructs <code>User</code> objects.
	 * @name Social.US.User.initialize 
	 * @private
	 */
	initialize: function($super, recordID){
		$super(recordID);
		NgLogD("User Public! " + recordID + " " + this.recordID);
	},
	
	
	/**
	* Adds a user to the buddies list and ensures the added user is not on the blocked users list.
	* @name Social.US.User.addBuddy
	* @function
	* @private
	*
	* @param {Social.US.User} buddy The user to add to the buddies list. If not a user, the callback error is "No user."
	* @param {Function} cb The callback function.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <pre class="code">function(error, data){
    * &nbsp;&nbsp;  if (error){
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorCode = error.errorCode;
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorDesc = error.description;
    * &nbsp;&nbsp;  } else {
    * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var buddyData = data;
    * &nbsp;&nbsp;  }
	* }
	* </pre>	
	*/	
	addBuddy: function(buddy, cb){
		Dispatcher.callMethodOnRemoteObject(this, "addBuddy", [buddy, cb]);
	},
	
	
	/**
	* Removes a user from the buddies list.
	* @name Social.US.User.removeBuddy
	* @function
	* @private
	*
	* @param {User} buddy The user to remove from the buddies list. If not a user, the callback error is "No user."
	* @param {Function} cb The callback function.
	* <br/> 
	* <b>Callback Example:</b>
	* <pre class="code">function(error, data){
    * &nbsp;&nbsp;  if (error){
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorCode = error.errorCode;
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorDesc = error.description;
    * &nbsp;&nbsp;  } else {
    * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var buddyData = data;
    * &nbsp;&nbsp;  }
	* }
	* </pre>
	*/		
	removeBuddy: function(buddy, cb){
		Dispatcher.callMethodOnRemoteObject(this, "deleteBuddy", [buddy, cb]);
	},
	
	
	/**
	* Retrieves a user object with all of the this user's details.
	*
	* @name Social.US.User.getUserDetails
	* @function
	* @public
	* 
	* @param {Function} cb The callback function.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <pre class="code">function(error, user){
    * &nbsp;&nbsp;  if (error){
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorCode = error.errorCode;
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorDesc = error.description;
    * &nbsp;&nbsp;  } else {
    * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var userWithDetails = user;
    * &nbsp;&nbsp;  }
	* }
	* </pre>
	* @status iOS, Android, Test, iOSTested, AndroidTested
	*/			
	getUserDetails: function(cb){
		Dispatcher.callMethodOnRemoteObject(this, "getUserDetails", [cb]);		
	},
	
	/**
	* Retrieves an ordered list of the user's friend requests on Mobage.
	* @name Social.US.User.getMobageFriendRequestLists
	* @function
	* @public
	*
	* @return {Social.US.OrderedList} A list of the user's friend requests.
    * @example
    * var myMobageFriendRequests = userA.getMobageFriendRequestsList();
    * @see Social.US.OrderedList for more information on iterating over the Mobage Friend Requests list.
	*/			
	getMobageFriendRequestsList: function(){
		return OrderedList.getObjectPublicInterface(this, "getInvitesList", "_followersListInterface");
	},
	
	/**
	* Returns the user's friends list on Mobage.
	* @name Social.US.User.getMobageFriendsList
	* @function
	* @public	
	*
	* @return {Social.US.OrderedList} The user's friend list on Mobage.
    * @example
    * var myMobageFriendsList = userA.getMobageFriendsList();
    * @see Social.US.OrderedList for more information on iterating over the Mobage friends list.
    * @status iOS, Android, Test, iOSTested, AndroidTested
	*/
	getMobageFriendsList: function(){
		return OrderedList.getObjectPublicInterface(this, "getFriendsList", "_friendsListInterface");
	},
	
	/**
	* Returns the user's blocked user list.
	* @name Social.US.User.getMobageBlockedUserList
	* @function
	* @public	
	*
	* @return {Social.US.OrderedList} The user's blocked user list on Mobage.
	* @see Social.US.OrderedList
	* @status iOS, Android, Test, iOSTested, AndroidTested
	*/
	getMobageBlockedUserList: function(){
		return OrderedList.getObjectPublicInterface(this, "getBlockedUserList", "_enemyListInterface");
	},
	
	/**
	* Returns the user's games list.
	* @name Social.US.User.getOwnedGamesList
	* @function
	* @public	
	*
	* @return {Social.US.OrderedList} The user's Mobage game list.
    * @example
    * var myGamesList = userA.getOwnedGamesList();
    * @see Social.US.OrderedList for more information on iterating over the games list.
    * @status iOS, Android, Test, iOSTested, AndroidTested
	*/			
	getOwnedGamesList: function(){
		return OrderedList.getObjectPublicInterface(this, "getOwnedGamesList", "_ownedGamesListInterface");
	},
	
	/**
	* Returns the list of "featured" users.
	* @name Social.US.User.getFeaturedUsersList
	* @function
	* @public	
	*
	* @return {Social.US.OrderedList} The list of "featured" users.
    * @example
    * var mobageFeaturedUsers = userA.getFeaturedUsersList();
    * @see Social.US.OrderedList for more information on iterating over the Mobage Featured Users list.
    * @status iOS, Android, Test, iOSTested, AndroidTested
	*/	
	getFeaturedUsersList: function(){
		return OrderedList.getObjectPublicInterface(this, "getFeaturedUsersList", "_featuredUsersListInterface");
	},

	/**
	* Invites the user to the current game.
	* @name Social.US.User.inviteToCurrentGame
	* @public
	* @function
	* 
	* @param {Function} cb The callback function if an error occurs.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <pre class="code">function(error){
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorCode = error.errorCode;
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorDesc = error.description;
	* &nbsp;&nbsp;   }
	* </pre>
	* @status iOS, Android, Test, iOSTested, AndroidTested
	*/
	inviteToCurrentGame: function(cb){
		var user = this;
		Dispatcher.callMethodOnRemoteObject(this, "inviteToCurrentGame", [function(err){
			if(!err){
				Social.Common.Service.invitedUserEmitter.emit({userId: user.recordID});
				Social.US.Service.Friends.invitedUserEmitter.emit({user: user});
			}
			cb.apply(this, Array.apply(null, arguments));
		}]);		
	},
	
	/**
	 * Send a Push notification to this user through the GameService back end.
	 * @name Social.US.User.sendNotificationToUser
	 * @public
	 * @function
	 *
	 * @param {Alert Text} alertText The displayed message when the push is received.
	 * @param {Badge ID} badgeId Badge displayed on the push.
	 * @param {Sound} sound Sound played when push is received.
	 * @param {Extra Data} extraData Additional payload.
	 *
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */	
	sendNotificationToUser: function(alertText, badgeId, sound, extraData) {
		Dispatcher.callMethodOnRemoteObject(this, "sendNotificationToUser", [alertText, badgeId, sound, extraData]);
	},

    /**
    * Adds a user to the current user's friend list for the current game. Implies a one-directional relationship or "follower" model.
    * Takes an optional group parameter to add the user to a particular group. Current user can only 
    * add the user to one group. If the current user adds the user to a second group in the friend list, 
    * the user is moved from the first group.
    *
    * A group is an arbitrary classification of friends. The <code>group</code> parameter is a string, which 
    * takes the name of the group. You may allow users to manage their own groups, create game-level groups, 
    * or omit groups altogether. A user may only reside in one group of another user's friend list.<br><br>
    * <b>Note:</b> This is part of the Game Graph API. 
    *
    * @example
    * //Retrieve a user and set up a follower relationship.
    * var userA = Social.US.User; 
    * Social.US.User.getUserWithGamertag("chuck", function(error, user){
    *   if(!user) {
    *       var errorCode = error.errorCode;
    *       var errorDesc = error.description;
    *   } else {
    *        userA = user;
    *   }
    * });
    * var userB = Social.US.Session.getCurrentSession().user();
    * userB.addFriend(userA, callback);
    * //...
    * @example
    * //To make the relationship bi-directional, 
    * //you must make the same call for the other user.
    * userA.addFriend(userB, callback);
    *
    * @name Social.US.User.addFriend
    * @public
    * @function
    *
    * @param user The user to add to the current user's friend list. If <code>null</code>, <code>undefined</code> or not a 
    * <code>Social.US.User</code> object, the callback error is "No user."
    * @param {String} [group] An optional parameter for adding the friend into a group within the friend list.
    * @param {Function} cb The callback function.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <pre class="code">function(error, data){
    * &nbsp;&nbsp;  if (error){
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorCode = error.errorCode;
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorDesc = error.description;
    * &nbsp;&nbsp;  } else {
    * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var appData = data;
    * &nbsp;&nbsp;  }
	* } </pre>
	* @status iOS, Android, Test, iOSTested, AndroidTested
    */	
	addFriend: function(user, group, cb){
		if(typeof arguments[1] == "function" && !arguments[2]){
			cb = arguments[1];
			group = undefined;
		}
		Dispatcher.callMethodOnRemoteObject(this, "addGameFriend", [user, group, cb]);
	},

    /**
    * Removes a user from the current user's friend list for the current game.<br><br>
    * Does not require a group parameter, friends are only associated to one group in a friend list.
    * @name Social.US.User.removeFriend
    * @public
    * @function
    *
    * @param {Social.US.User} user The user to remove from the current user's friend list. If <code>null</code>, <code>undefined</code> or not a 
    * <code>Social.US.User</code> object, the callback error is "No user."
    * @param {Function} cb The callback function.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <pre class="code">function(error, data){
    * &nbsp;&nbsp;  if (error){
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorCode = error.errorCode;
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorDesc = error.description;
    * &nbsp;&nbsp;  } else {
    * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var appData = data;
    * &nbsp;&nbsp;  }
	* } </pre>
	* @status iOS, Android, Test, iOSTested, AndroidTested
    */		
	removeFriend: function(user, cb){
		Dispatcher.callMethodOnRemoteObject(this, "removeGameFriend", [user, cb]);
	},
	
	report: function(reason, cb){
		Dispatcher.callMethodOnRemoteObject(this, "report", [reason, cb]);
	},

    /**
    * Returns the user's friend list for the current game. If you specify the <code>group</code>
    * parameter, this call only returns friends within the group.<br><br>
    * <b>Note:</b> This is part of the Game Graph API.
    * @name Social.US.User.getFriendsList
    * @public
    * @function
    *
    * @param {String} group If specified, returns only friends in the group.
    * @return {Social.US.OrderedList} The user's friend list for the current game.
    * @example
    * var myFriendsList = userA.getFriendsList ("Best Buddies");
    * @see Social.US.OrderedList for more information on iterating over the friends list.
    * @status iOS, Android, Test, iOSTested, AndroidTested
    */	
	getFriendsList: function(group){
		return OrderedList.getObjectPublicInterface(this, "getGameFriendsList", (group ? ("_gameFriendsList-friends-" + group ) : "_gameFriendsList-friends"), "friends", group);
	},


    /**
    * Returns the user's mutual friends.
    * Mutual friends result when two users add each other to their respective friend list.<br><br>
    * <b>Note:</b> This is part of the game graph API.
    * @name Social.US.User.getMutualFriendsList
    * @public
    * @function
    *
    * @param {String} group The group within the friend list. If specified, returns only mutual friends within the group.
    * @return {Social.US.OrderedList} The user's mutual friend list.
    * @example
    * userA.addFriend(userB);
    * userB.addFriend(userA);
    * var myMutualFriends = userA.getMutualFriendsList();
    * //userA appears in userB's mutual friends list, 
    * //because they are in each other's friend lists.
    * @see Social.US.OrderedList for more information on iterating over the mutual friends list.
    * @status iOS, Android, Test, iOSTested, AndroidTested    
    */	
	getMutualFriendsList: function(group){
		return OrderedList.getObjectPublicInterface(this, "getGameFriendsList", (group ? ("_gameFriendsList-mutual-" + group) : "_gameFriendsList-mutual"), "mutual", group);
	},


    /**
    * Returns the user's friend requests list. If the <code>group</code> parameter is specified, returns
    * only friends within the group.
    * @name Social.US.User.getFriendRequestsList
    * @public
    * @function
    *
    * @param {String} group The group within the friend request list.
    * @return {Social.US.OrderedList} The user's friend requests list.
    * @example
    * var myFriendRequestsList = userA.getFriendRequestsList ();
    * @see Social.US.OrderedList for more information on iterating over the friend requests list. 
    * @status iOS, Android, Test, iOSTested, AndroidTested
    */	
	getFriendRequestsList: function(group){
		return OrderedList.getObjectPublicInterface(this, "getGameFriendsList", (group ? ("_gameFriendsList-invitation-" + group) : "_gameFriendsList-invitation"), "invitation", group);
	},

	/**
	* Updates the email address for the current user.
	* @name Social.US.User.setEmailAddress
	* @function
	* @private
	*
	* @param {String} newAddress The email address for the current user.
	* @param {Function} cb The callback function if an error occurs (for example, invalid email address format).
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <code>function(error){<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;<br/>
	* &nbsp;&nbsp;   }<br/>
	* </code>
    * @status iOS, Android, Test, iOSTested, AndroidTested	
	*/	
	setEmailAddress:function(newAddress,cb) {
		Dispatcher.callMethodOnRemoteObject(this, "setEmailAddress", [newAddress, cb]);
	},
	
	/**
	* Sets whether the current user will receive notifications from other Mobage users or just from Mobage friends.
	* @name Social.US.User.setOnlyShowFriendNotifications
	* @function
	* @private
	*
	* @param {Boolean} isFriendsOnly Set to <code>true</code> if the current user will only receive notifications from Mobage users who are also Mobage friends. 
    * If set to <code>false</code>, the user receives notifications from all Mobage users. 
	* @param {Function} cb The callback function if an error occurs.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <code>function(error){<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;<br/>
	* &nbsp;&nbsp;   }<br/>
	* </code>
    * @status iOS, Android, Test, iOSTested, AndroidTested	
	*/	
	setOnlyShowFriendNotifications:function(isFriendsOnly,cb) {
		Dispatcher.callMethodOnRemoteObject(this, "setOnlyShowFriendNotifications", [isFriendsOnly, cb]);
	},
	
	/**
	* Sets whether the current user will receive game news and updates from Mobage.
	* @name Social.US.User.setOptsIn
	* @function
	* @private
	*
	* @param {Boolean} optIn Set to <code>true</code> if the current user will receive news and updates from Mobage. 
    * If set to <code>false</code>, the user will not receive news or updates from Mobage. 
	* @param {Function} cb The callback function if an error occurs.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <code>function(error){<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;<br/>
	* &nbsp;&nbsp;   }<br/>
	* </code>
    * @status iOS, Android, Test, iOSTested, AndroidTested	
	*/
	setOptsIn:function(optIn,cb) {
		Dispatcher.callMethodOnRemoteObject(this, "setOptsIn", [optIn, cb]);
	},

	/**
	* Sets a motto for the current user. In other words, the user's "about me" text string.
	* @name Social.US.User.setMotto
	* @function
	* @private
	*
	* @param {String} motto The motto for the current user.
	* @param {Function} cb The callback function if an error occurs.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <code>function(error){<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;<br/>
	* &nbsp;&nbsp;   }<br/>
	* </code>
    * @status iOS, Android, Test, iOSTested, AndroidTested	
	*/	
	setMotto:function(motto,cb) {
		Dispatcher.callMethodOnRemoteObject(this, "setMotto", [motto, cb]);
	},
	
	/**
	* Updates the first name for the current user.
	* @name Social.US.User.setFirstName
	* @function
	* @private
	*
	* @param {String} firstName The first name for the current user.
	* @param {Function} cb The callback function if an error occurs.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <code>function(error){<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;<br/>
	* &nbsp;&nbsp;   }<br/>
	* </code>
    * @status iOS, Android, Test, iOSTested, AndroidTested	
	*/	
	setFirstName:function(firstName,cb) {
		Dispatcher.callMethodOnRemoteObject(this, "setFirstName", [firstName, cb]);
	},
	
	/**
	* Updates the last name for the current user.
	* @name Social.US.User.setLastName
	* @function
	* @private
	*
	* @param {String} lastName The last name for the current user.
	* @param {Function} cb The callback function if an error occurs.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <code>function(error){<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;<br/>
	* &nbsp;&nbsp;   }<br/>
	* </code>
    * @status iOS, Android, Test, iOSTested, AndroidTested	
	*/
	setLastName:function(lastName,cb) {
		Dispatcher.callMethodOnRemoteObject(this, "setLastName", [lastName, cb]);
	},
	

	/**
	* Sets a password for the current user.
	* @name Social.US.User.setPassword
	* @function
	* @private
	*
	* @param {String} password The password for the current user.
    * @param {String} confirmation The password confirmation for the current user.
	* @param {Function} cb The callback function if an error occurs. For example, password does not meet requirements; password and confirmation do not match, and so on.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <code>function(error){<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;<br/>
	* &nbsp;&nbsp;   }<br/>
	* </code>
    * @status iOS, Android, Test, iOSTested, AndroidTested	
	*/
	setPassword:function(password,confirmation, cb) {
		Dispatcher.callMethodOnRemoteObject(this, "setPassword", [password, confirmation, cb]);
	},

	/**
	* Sets whether the target user is in the logged-in user's blocked user list.
	* @name Social.US.User.setBlocked
	* @function
	* @private
	*
	* @param {Social.US.User} user The user that is the subject of blocking or unblocking.
    * @param {Boolean} blocked Whether the current user blocks the specified user. If <code>true</code>, the specified user is blocked.
    	* @param {Function} cb The callback function if an error occurs.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <code>function(error){<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;<br/>
	* &nbsp;&nbsp;   }<br/>
	* </code>
    * @status iOS, Android, Test, iOSTested, AndroidTested	
	*/	
	setBlocked:function(blocked, cb){
		Dispatcher.callMethodOnRemoteObject(this, "setBlocked", [blocked, cb]);
	},
	
	/**
	 * Gets the origin of the user's registration.
	 * Mobage records the origin of a user's registration. The "origin" may be the name of an alliance partner.
	 * The origin is typically used as a means of tracking revenue sharing events, such as the promotional activity 
	 * of an alliance partner that attracts new users to Mobage and thereby entitles the alliance partner 
	 * to share in revenue generated by the application.  
	 *
	 * @name Social.US.User.getOriginOfRegistration
	 * @private
	 * @static
	 * @function
	 *
	 * @param {Function} cb The callback function returns the origin of registration, or an error code and description.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error, originOfRegistration){
	 *     if(!originOfRegistration) {
	 *          var errorCode = error.errorCode;
	 *          var errorDesc = error.description;
	 *     } else {
	 *          var origin = originOfRegistration;
	 *     }
	 * }
	 * </pre>
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getOriginOfRegistration: function(cb) {
		Dispatcher.callMethodOnRemoteObject(this, "getOriginOfRegistration", [cb]);
	}
});

User.GamertagKey = "gamertag";
User.AvatarKey = "badge_id";
User.MottoKey = "motto";
User.RelationKey = "relation";
User.FirstNameKey = "first_name";
User.LastNameKey = "last_name";
User.BirthdateKey = "birth_date";
User.GenderKey = "gender";
User.PrivacyKey = "fullname_privacy";
User.PhotoKey = "photo_url";
User.EmailAddressKey = "email";
User.EmailHashKey = "email_hash";
User.PhoneNumberKey = "phone_number";
User.AgeRangeKey = "age_restricted";
User.SpamKey = "opt_in";

User.PasswordKey = "password";
User.PasswordConfirmKey = "password_confirmation";
User.GamesKey = "games";
User.CapabilitiesKey = "capabilities";
User.NewBuddyKey = "new_buddy";
User.IsMutualFriendKey = "mutual_friends";
User.HidePresenceKey = "hide_presence";
User.OnlyShowFriendNotificationsKey = "friend_only_notification";

User.GamerScoreKey = "gamerscore";
User.LevelNumberKey = "level_position";
User.LevelNameKey = "level_name";
User.CurrentLevelScoreKey = "level_points";
User.NextLevelScoreKey = "level_next_points";

// properties that are not returned in sparse search results
User.NonSparseKeys = [User.PhotoKey, User.EmailAddressKey,
User.EmailHashKey, User.PhoneNumberKey, User.PasswordKey,
User.FirstNameKey, User.LastNameKey, User.PrivacyKey,
User.NewBuddyKey, User.CapabilitiesKey, User.HidePresenceKey,
User.OnlyShowFriendNotificationsKey, User.GamerScoreKey,
User.LevelNumberKey, User.LevelNameKey, User.CurrentLevelScoreKey,
User.NextLevelScoreKey, User.GamesKey];


/**
* Retrieves the user corresponding to the <code>userID</code> parameter.
* @name Social.US.User.getUserWithID
* @public
* @static
* @function
* 
* @param {String} userID The ID for the user.
* @param {Function} cb The callback function if an error occurs.
* <br/> 
* <b>Callback Example:</b><br/>
* <pre class="code">function(error, user){
* &nbsp;&nbsp;  if(!user) {
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorCode = error.errorCode;
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorDesc = error.description;
* &nbsp;&nbsp;  } else {
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var userWithID = user;
* &nbsp;&nbsp;  }
* }
* </pre>
* @status iOS, Android, Test, iOSTested, AndroidTested
*/	
User.getUserWithID = function(userID, cb){
	Dispatcher.callClassMethodOnRemoteObject(User, "getUserWithID", [userID, cb]);
};

/**
* Retrieves the user corresponding to the <code>gamertag</code> parameter.
* @name Social.US.User.getUserWithGamertag
* @public
* @static
* @function
* 
* @param {String} gamertag The user's gamertag.
* @param {Function} cb The callback function if an error occurs.
* <br/> 
* <b>Callback Example:</b><br/>
* <pre class="code">function(error, user){
* &nbsp;&nbsp;  if(!user) {
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorCode = error.errorCode;
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorDesc = error.description;
* &nbsp;&nbsp;  } else {
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var userWithGamertag = user;
* &nbsp;&nbsp;  }
* }
* </pre>
* @status iOS, Android, Test, iOSTested, AndroidTested
*/	
User.getUserWithGamertag = function(gamertag, cb){
	Dispatcher.callClassMethodOnRemoteObject(User, "getUserWithGamertag", [gamertag, cb]);
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Models/Game'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Models/Game'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Models/Game'] = exports; var DataModelR = require('NGCore/Client/Social/US/Models/DataModel');
var OrderedList = require('NGCore/Client/Social/US/Models/OrderedList').OrderedList;
var Dispatcher = require('NGCore/Client/Social/US/Data/Dispatcher').Dispatcher;

/**
 * <code>Game</code> objects identify a game and its properties.
 * Game properties include: 
 * <div class="ul">
 * <li><code>name</code></li>
 * <li><code>publisher</code></li>
 * <li><code>category</code></li>
 * <li><code>featured</code></li>
 * <li><code>numberOfLeaderboards</code></li> 
 * <li><code>numberOfAchievements</code></li>
 * <li><code>masterProductID</code></li>
 * <li><code>iconURL</code></li>
 * <li><code>AppStoreURL</code></li>
 * <li><code>feedURL</code></li>
 * <li><code>catalogURL</code></li>
 * </div>
 * <code>Game</code> objects provide static functions to return all games in a catalog or games associated to a user profile.
 * 
 * @class 
 * @name Social.US.Game
 * @augments Social.US.DataModel
 */
var Game = exports.Game = DataModelR.DataModel.subclass({
	classname: "Game",
	
	
	 //Game is a subclass of data model, and the getter/setter methods are generated by defineSetterCallbacks. The following
	 //comments document the generated methods.
	 /**
	 * The game name. Read-only.
	 * @name Social.US.Game.name
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */

	 /**
	 * The publisher name. Read-only.
	 * @name Social.US.Game.publisher
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * The game category name. Read-only.
	 * @name Social.US.Game.category
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * Whether the game is featured. Read-only.
	 * @name Social.US.Game.featured
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * The number of leaderboards for the game. Read-only.
	 * @name Social.US.Game.numberOfLeaderboards
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */

	 /**
	 * The number of achievements. Read-only.
	 * @name Social.US.Game.numberOfAchievements
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * The master product ID. Read-only.
	 * @name Social.US.Game.masterProductID
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * A URL to the icon for a game. Read-only.
	 * @name Social.US.Game.iconURL
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * A URL to the store or marketplace for a game. Read-only.
	 * @name Social.US.Game.appStoreURL
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * A URL to the RSS feed for a game. Read-only.
	 * @name Social.US.Game.feedURL
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * Sets a catalog URL for the catalog of game items. Read-only.
	 * @name Social.US.Game.catalogURL
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	properties: [
		// public
		"name",
		"publisher",
		"category",
		"numberOfLeaderboards",
		"iconURL",
		
		// private
		"numberOfAchievements",
		"featured",
		"masterProductID",
		"appStoreURL",
		"feedURL",
		"catalogURL",
		"description",
		"phone_screenshot_urls",
		"ngcore_url"
	]
});

/**
 * Returns an ordered list interface to the Mobage game catalog.
 * 
 * @name Social.US.Game.getAllGamesList
 * @function
 * @private 
 * @static
 *
 * @returns {Social.US.OrderedList} An ordered list interface to the catalog of games.
 * @see Social.US.OrderedList
 * @status iOS, Android, Test, iOSTested, AndroidTested
 */
Game.getAllGamesList = function(){
		
	return OrderedList.getClassPublicInterface(Game, "getAllGamesList", "_allGamesInterface");
};

/**
 * Returns the current game. 
 *
 * @name Social.US.Game.getCurrentGame
 * @function
 * @public 
 * @static
 *
 * @param {Function} cb The callback function returns the current game or an error code and description.
 * <br/> 
 * <b>Callback Example:</b><br/>
 * <pre class="code">function(error, game){
 * &nbsp;&nbsp; if(!game){
 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorCode = error.errorCode;
 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorDesc = error.description;
 * &nbsp;&nbsp;} else {
 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var currentGame = game;
 * &nbsp;&nbsp;}
 * }
 * </pre>
 * @status iOS, Android, Test, iOSTested, AndroidTested
 */
Game.getCurrentGame = function(cb){
	Dispatcher.callClassMethodOnRemoteObject(Game, "getCurrentGame", [cb]);
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Models/Leaderboard'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Models/Leaderboard'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Models/Leaderboard'] = exports; var DataModelR = require('NGCore/Client/Social/US/Models/DataModel');
var Dispatcher = require('NGCore/Client/Social/US/Data/Dispatcher').Dispatcher;
var OrderedList = require('NGCore/Client/Social/US/Models/OrderedList').OrderedList;

/**
 * <code>Leaderboard</code> objects enable the current user to get friend scores, top scores, and submit a score.
 * To return a leaderboard, you must set up at least one leaderboard for your game in the Mobabe Sandbox or Production environment.
 * @class 
 * @name Social.US.Leaderboard
 * @augments Social.US.DataModel
 */
var Leaderboard = exports.Leaderboard = DataModelR.DataModel.subclass({

	 
	classname: "Leaderboard",
	properties: [
	"level",
	"title",
	"game",
	"iconURL"
	],

	
	/** 
	 * @constructs Constructs a <code>Leaderboard</code> object identified by the record ID. 
	 * @private
	 *
	 * @param {Type} $super A reference to the DataModel superclass.
	 * @param {String} recordId The record ID of the object.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */	
	initialize: function($super, recordID){
		$super(recordID);
		NgLogD("Leaderboard Public! " + recordID + " " + this.recordID);
	},
	
	
	/**
	* Submits a score to the leaderboard.
	*
	* @name Social.US.Leaderboard.submitScore
	* @function
	* @public
	*
	* @param {Numeric} points The score points. If <code>null</code> or <code>undefined</code>, the callback error is "No score."
	* @param {Function} cb The callback function.
	* <br/> 
    * <b>Callback Example:</b><br/>
    * <pre class='code'>function(error, score){
    * &nbsp;&nbsp;  if(error) {
    * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorCode = error.errorCode;
    * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorDesc = error.description;
    * &nbsp;&nbsp;  } else {
    * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var setScore = score;
    * }
    * </pre>
    * @status iOS, Android, Test, iOSTested, AndroidTested
    */
	submitScore: function(points, cb){
		Dispatcher.callMethodOnRemoteObject(this, "submitScoreWithPoints", [points, cb]);
	},	
	
	/**
	* Returns an <code>OrderedList</code> with the user's score and the highest scores.
	* 
	* @name Social.US.Leaderboard.getTopScoresList
	* @function
	* @public
	*
	* @return {Social.US.OrderedList} The list of highest scores.
	* @see Social.US.OrderedList
	* @status iOS, Android, Test, iOSTested, AndroidTested
	*/		
	getTopScoresList: function(){
		return OrderedList.getObjectPublicInterface(this, "getTopScoresList", "_leaderboardTopScoresInterface");
	},
	
	/**
	* Returns an <code>OrderedList</code> of scores for the user's friends.
	* 
	* @name Social.US.Leaderboard.getFriendsScoresList
	* @function
	* @public
	*
	* @return {Social.US.OrderedList} The list of scores for the user's friends.
	* @see Social.US.OrderedList
	* @status iOS, Android, Test, iOSTested, AndroidTested
	*/		
	getFriendsScoresList: function(){
		return OrderedList.getObjectPublicInterface(this, "getFriendsScoresList", "_leaderboardFriendsScoresInterface");
	}

	 /**
	 * The user's level in the game. Read-only.
	 * @name Social.US.Leaderboard.level
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	 /**
	 * The leaderboard title. Read-only.
	 * @name Social.US.Leaderboard.title
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */

	 /**
	 * The game name. Read-only.
	 * @name Social.US.Leaderboard.game
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	 /**
	 * A URL to the leaderboard icon. Read-only.
	 * @name Social.US.Leaderboard.iconURL
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
		 
});

/**
* Returns the leaderboard(s) for the current game.
* To return a leaderboard, you must set up at least one leaderboard for your game in the Mobabe Sandbox or Production environment.
*
* @name Social.US.Leaderboard.getLeaderboards
* @function
* @public
* @static
*
* @param cb Retrieves the leaderboard(s) for the current game. If an error occurs, returns an error code and error description.
* <br/> 
* <b>Callback Example:</b><br/>
* <pre class='code'>function(error, leaderboards){
*     if(error) {
*          var errorCode = error.errorCode;
*          var errorDesc = error.description;
*     } else {
*          var retrievedLeaderboards = leaderboards;
* }
* </pre>
* @status iOS, Android, Test, iOSTested, AndroidTested
*/
Leaderboard.getLeaderboards = function(cb){
	Dispatcher.callClassMethodOnRemoteObject(Leaderboard, "getLeaderboards", [cb]);
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Models/Score'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Models/Score'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Models/Score'] = exports; var DataModel 	  = require('NGCore/Client/Social/US/Models/DataModel').DataModel;

/**
 * <code>Score</code> constructs objects that reflect a user's score for the current game.
 * @class 
 * @name Social.US.Score
 * @augments Social.US.DataModel
 */
var Score = exports.Score = DataModel.subclass({
	
    classname: "Score",
    	
	 /**
	 * A user's score. Read-only.
	 * @name Social.US.Score.score
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * The score as formatted for display. Read-only.
	 * @name Social.US.Score.displayScore
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	
	 /**
	 * The user's rank. Read-only.
	 * @name Social.US.Score.rank
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	
	 /**
	 * The user's level in the current game. Read-only.
	 * @name Social.US.Score.level
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	
    
	 /**
	 * A <code>Social.US.User</code> reference to the user associated to the score. Read-only.
	 * @name Social.US.Score.user
	 * @field
	 * @public
     * @see Social.US.User
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */    
	 
    properties: [
	"points",
	"displayScore",
	"rank",
	"level",
	"user"
	]
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Models/AppData'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Models/AppData'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Models/AppData'] = exports; var DataModelReq = require('NGCore/Client/Social/US/Models/DataModel');
var Dispatcher = require('NGCore/Client/Social/US/Data/Dispatcher').Dispatcher;

/**
 * <code>AppData</code> constructs objects that get and set a user's properties, 
 * and provides permissions for sharing the user's properties with other users.
 * @class 
 * @name Social.US.AppData
 * @see Social.Common.Appdata for additional Mobage persistence facilities;
 * @see Storage.KeyValue for additional ngCore persistence facilities; and,
 * @see Storage.FileSystem for additional ngCore persistence facilities. 
 */
var AppData = exports.AppData = DataModelReq.DataModel.subclass({
		
	classname: "AppData",
	properties: [
		"data",
		"key",
		"user",
		"permissions"
	],
	
	/**
	 * The application data for the user. Limited to 1024 bytes.
	 * 
	 * @name Social.US.AppData.data
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	
	/**
	 * The key describing the application data. Limited to 32 bytes.
	 * 
	 * @name Social.US.AppData.key
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	
	/**
	 * The name of the user who owns the data.
	 * 
	 * @name Social.US.AppData.name
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	
	/**
	 * The permissions for the application data.<br/><br/>
	 * <code>Private</code>: only the user can read and write the user data.<br/>
	 * <code>FriendsReadOnly</code>: friends can read the user data, but cannot write it.<br/>
	 * <code>PublicReadOnly</code>: all users can read the user data, but cannot write it.     
	 * 
	 * @name Social.US.AppData.permissions
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	
	
	
    /**
     * The default constructor.
     * @constructs 
     * @name Social.US.AppData.initialize
     * @private
     *
     * @param recordID A unique ID for the <code>AppData</code> object.
     *
     * @augments Social.US.DataModel
     * @status iOS, Android, Test, iOSTested, AndroidTested
     */	
    initialize: function($super, recordID) {
        $super(recordID);
    }
});

/**
* Takes a user reference and returns key/value pairs of the user for the current game.
* @name Social.US.AppData.getKeysForUser
* @function
* @public
* @static
*
* @param {Social.US.User} user A reference to the user.
* @param {Function} callback The callback function returns key/value pairs for the user and/or and error code and description.
* <br/> 
* <b>Callback Example:</b><br/>
* <pre class="code">var entries = {"key1": "value1", "key2": "value2"};
* ...
* function(error, entries){
* &nbsp;&nbsp;   if (error){
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var errorCode = error.errorCode;
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var errorDesc = error.description;
* &nbsp;&nbsp;   } else {
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var retrievedEntries = entries;
* &nbsp;&nbsp;   }
* }
* </pre>
* @example
* var user = Social.US.Session.getCurrentSession().user();
* var AppData = Social.US.AppData;
* var retrievedEntries = null;
* AppData.getKeysForUser(user, function(error, entries){
*				retrievedEntries = entries;
*			});
* @status iOS, Android, Test, iOSTested, AndroidTested
*/
AppData.getKeysForUser = function(user, cb){
	Dispatcher.callClassMethodOnRemoteObject(AppData, "getKeysForUser", [user, cb]);
};

/**
* Takes a user, a key (the name of the key for a name/value pair) and returns the key/value pair for the user for the current game.
* @name Social.US.AppData.getDataForUserWithKey
* @function
* @public
* @static
*
* @param {Social.US.User} user A reference to the user.
* @param {String} key The name of the key.
* @param {Function} callback Retrieves the key/value pair for the user and/or an error code and description.
* <br/> 
* <b>Callback Example:</b><br/>
* <pre class="code">function(error, response){
* &nbsp;&nbsp;   if (error){
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var errorCode = error.errorCode;
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var errorDesc = error.description;
* &nbsp;&nbsp;   } else {
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var fetchedData = response.data;
* &nbsp;&nbsp;   }
* }
* </pre>
* @example
* var user = Social.US.Session.getCurrentSession().user();
* var AData = Social.US.AppData;
* var errorCode = null;
* var errorDesc = null;
* var fetchedData = null;
* AData.getDataForUserWithKey( user, 
*                              key, 
*                              function(error, response){
*                                   errorCode = error.errorCode;
*                                   errorDesc = error.description;
*                                   fetchedData = response.data;
*                              }
*                            );
* @status iOS, Android, Test, iOSTested, AndroidTested
*/
AppData.getDataForUserWithKey = function(user, key, cb){
	Dispatcher.callClassMethodOnRemoteObject(AppData, "getDataForUserWithKey", [user, key, cb]);
};


/**
* Takes data, a user, a key (the name of the key for a name/value pair) and permissions for the data and sets the application data for the user.
* <b>Note:</b> Limited to 30 key/value pairs per user, per game. 
* Maximum key name limited to 32 bytes. Maximum value limited to 1,024 bytes.
* To use key/value pairs without the foregoing constraints, use <code>Storage.KeyValue</code>
* in ngCore.
* @name Social.US.AppData.setDataForUserWithKeyAndPermissions
* @function
* @public
* @static 
*
* @param {String} data The data to set.
* @param {Social.US.User} user A reference to the user.
* @param {String} key The name of the key.
* @param {Social.US.AppData.Permissions} permission The permissions for the data.
* @param {Function} cb The callback function if there is an error with the parameters.
* <br/> 
* <b>Callback Example:</b><br/>
* <pre class="code">function(error){
* &nbsp;&nbsp;  if(!response) {
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorCode = error.errorCode;
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorDesc = error.description;
* &nbsp;&nbsp;   } else {
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var responseValues = response;
* &nbsp;&nbsp;   }
* }
* </pre>
* @example
* var user = Social.US.Session.getCurrentSession().user();
* var data = "some data";
* var key = "some key";
* var errorCode = null;
* var errorDesc = null;
* var result = null; 
*
* var AData = Social.US.AppData;
* 
* AData.setDataForUserWithKeyAndPermissions(data, 
*                                           user, 
*                                           key, 
*                                           AppData.Permissions.Private, 
*                                           function(error, response){
*                                             errorCode = error.errorCode;
*                                             errorDesc = error.description;
*                                             result = response;
*                                           }
*                                         );
* @status iOS, Android, Test, iOSTested, AndroidTested
* @see Social.US.AppData.Permissions for permission settings;
* @see Social.Common.Appdata for additional Mobage persistence facilities;
* @see Storage.KeyValue for additional ngCore persistence facilities; and,
* @see Storage.FileSystem for additional ngCore persistence facilities.
*/
AppData.setDataForUserWithKeyAndPermissions = function(data, user, key, permissions, cb){
	Dispatcher.callClassMethodOnRemoteObject(AppData, "setDataForUserWithKeyAndPermissions", [data, user, key, permissions, cb]);
};



/**
* Defines permissions for viewing user data.<br/><br/>
* <code>Private</code>: only the user can read and write the user data.<br/>
* <code>FriendsReadOnly</code>: friends can read the user data, but cannot write it.<br/>
* <code>PublicReadOnly</code>: all users can read the user data, but cannot write it. 
* @name Social.US.AppData.Permissions
* @field
* @public
* @status iOS, Android, Test, iOSTested, AndroidTested
*/
AppData.Permissions = {
	Private: 0,
	FriendsReadOnly: 1,
	PublicReadOnly: 2
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Models/Cache'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Models/Cache'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Models/Cache'] = exports; var Class = require('NGCore/Client/Core/Class').Class;
var SocialR = require('NGCore/Client/Social');

/**
 * <code>Cache</code> provides caching for a user's objects residing in the local interpreter.
 * @class 
 * @name Social.US.Cache
 * @private
 */
var Cache = exports.Cache = Class.subclass({


	classname: "Cache",
	inMemoryObjects: {},
	caches: {},
	
	/**
	 * Initializes a cache object upon instantiation. 
	 * @name Social.US.Cache.initialize
	 * @constructs
	 * @private
	 */			
	initialize: function(){
	},

	
	/**
	* Takes a classname and a unique record ID and returns the object or <code>null</code> if it doesn't find the object.
	*
	* @name Social.US.Cache.getObjectWithRecordID
	* @function
	* @private
	*
	* @param {String} classname The name of the class.
	* @param {Number} recordID The object ID.
	*
	* @return Returns the object corresponding to the <code>recordID</code> parameter or <code>null</code> if it doesn't find the object.
	*/
	getObjectWithRecordID: function(classname, recordID){
		var category = this.inMemoryObjects[classname];
		if(category){
			return category[recordID] || null;
		}else{
			return null;
		}
	},
	
	/**
	* Takes an object and adds it to the cache.
	* <code>addObject()</code> takes an object, ensures that it is not already in the cache, and adds it to the cache.
	*
	* @name Social.US.Cache.addObject
	* @function
	* @private
	*	
	* @param {Object} obj The object to add to the cache.
	* @return Returns the record ID of the object added to the cache.
	*/	
	addObject: function(obj){
		var classname = obj._classname();
		var category = this.inMemoryObjects[classname];
		if(!category){
			category = {};
			this.inMemoryObjects[classname] = category;
		}

		var object = category[obj.recordID];
		if(object){
			return object;
		}else{
			category[obj.recordID] = obj;
			return obj;
		}
	},
	
	/**
	* Takes an object reference and removes the object from the cache.
	* 
	* @name Social.US.Cache.removeObject
	* @function
	* @private
	*	
	* @param {Object} obj The object to remove from the cache.
	*/	
	removeObject: function(obj){
		var classname = obj._classname();
		var category = this.inMemoryObjects[classname];
		if(category){
			delete category[obj.recordID]; // ZOMG THE DELETE OPERATOR
		}
	},
	
	/**
	* Takes an object reference and returns whether the object is in the cache.
	* 
	* @name Social.US.Cache.isObjectCached
	* @function
	* @private
	*	
	* @param {Object} obj The object to select in the cache.
	*
	* @return Returns <code>true</true> if the object is in the cache; otherwise, it returns <code>false</code>.
	*/		
	isObjectCached: function(obj){
		var classname = obj._classname();
		var category = this.inMemoryObjects[classname];
		return (category && (category[obj.recordID] == obj));
	},
	
	
	saveCache: function(){
		
	},
	
	
	loadCache: function(){
		
	},
	
	/**
	* Takes a JSON array of objects and loads them into the cache.
	*
	* @name Social.US.Cache.loadCacheFromJSONArray
	* @function
	* @private
	*
	* @param {JSON} jsonArray The JSON object array to load into the cache.
	* @param {function} cb <code>loadCacheFromJSONArray()</code> takes an optional callback function.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <code>function(error){<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;<br/>
	* &nbsp;&nbsp;   }<br/>
	* </code>
	*/			
	loadCacheFromJSONArray: function(jsonArray, cb){
		var objects = [];
        
		for(var idx = 0; idx < jsonArray.length; idx++){
			var hash = jsonArray[idx];
			if(hash && hash.hasOwnProperty("classname") && hash.hasOwnProperty("recordID")){
				var theClassname = hash.classname;
				var theClass = SocialR.Social.US[theClassname];
				var theRecordID = hash.recordID;
				if(theClass && theRecordID){
					var theInstance = this.getObjectWithRecordID(theClassname, theRecordID);
					if(!theInstance){
						theInstance = new theClass(theRecordID, {});
					}
        
					theInstance._deserializeFromHash(hash);
					this.addObject(theInstance);
				}
			}
		}
        
		cb(null, this);
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Data/Session'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Data/Session'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Data/Session'] = exports; var CoreReq = require('NGCore/Client/Core');
//var UserReq = require('../Models/User');
var MessageEmitterReq = require('NGCore/Client/Core/MessageEmitter');
var CacheReq = require('NGCore/Client/Social/US/Models/Cache');
var Dispatcher = require('NGCore/Client/Social/US/Data/Dispatcher').Dispatcher;

/**
 * <code>Session</code> manages a user's game sessions.
 * @class 
 * @name Social.US.Session
 */
var Session = exports.Session = MessageEmitterReq.MessageEmitter.subclass({
		
	classname: "Session",
	
	/**
	 * Constructs a session object.
	 * @name Social.US.Session.initialize
	 * @private
	 * @constructs 
	 */	
	initialize: function(gameData){
		if(gameData){
			this._loadSessionData(gameData);
		}
	},
	
	/**
	 * Loads the user's game data into the current session.
	 *
	 * @name Social.US.Session._loadSessionData
	 * @function
	 * @private
	 *
	 * @param {Type} gameData Takes game data and loads it into the current session.
	 */		
	_loadSessionData: function(gameData){
		this._appKey = gameData.appId || this._appKey || null;
		this._appVersion = gameData.appVersion || this._appVersion || null;
		this._platformVersion = gameData.platformVersion || this._platformVersion || "1.0";
		this._serverMode = gameData.serverMode || this._serverMode || null;

		this._user = (gameData.userID ? this.dataCache().getObjectWithRecordID("User", gameData.userID) : null);		
		this.emit({user: this._user});
	},
	
	/**
	 * Returns the cache for the current session. If a session cache does not exist, this call creates a new cache, loads it and returns it.
	 *
	 * @name Social.US.Session.dataCache
	 * @function
	 * @private
	 *
	 * @return {Social.US.Cache} The cache for the current session.
	 */			
	dataCache: function(){
		if(!this._cache){
			this._cache = new CacheReq.Cache();
			this._cache.loadCache(function(err){
				NgLogD("Loaded cache: " + err);
			});
		}
		return this._cache;
	},
	
	
	/**
	 * Returns the user for this session.
	 *
	 * @name Social.US.Session.user
	 * @function
	 * @public
	 *
	 * @return {Social.US.User} The user for the current session.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */					
	user: function(){
		return this._user;
	},
	
	

	// data you probably don't need
	/**
	 * Returns the name of the game for this session.
	 *
	 * @name Social.US.Session.appKey
	 * @function
	 * @public
	 *
	 * @return {String} The application name.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */						
	appKey: function(){
		return this._appKey;
	},
	
	/**
	 * Returns the version of the game for this session.	 
	 *
	 * @name Social.US.Session.appVersion
	 * @function
	 * @public
	 *
	 * @return {String} The application version.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */	
	appVersion: function(){
		return this._appVersion;
	},
	
	/**
	 * Returns the server mode of the game for this session.
	 *
	 * @name Social.US.Session.serverMode
	 * @function
	 * @public
	 *
	 * @return {String} The server mode.
	 * <b>Note:</b> Valid settings for the server mode include:<br/>
	 * <ul>
	 * <li>staging</li>
	 * <li>integration</li>
	 * <li>sandbox</li>
	 * <li>production</li>
	 * <li>unknown</li>
	 * </ul>
	 * @see Social.US.Session.serverModes
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */		
	serverMode: function(){
		return this._serverMode;
	},
	
	/**
	 * Returns the platform version of the game for this session.
	 *
	 * @name Social.US.Session.platformVersion
	 * @function
	 * @public
	 *
	 * @return {String} The platform version.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */		
	platformVersion: function(){
		return this._platformVersion;
	},
	

	/**
	 * Takes a consumer key and retrieves the session tokens for the the consumer key.
	 *
	 * @name Social.US.Session.getSessionTokensForConsumerKey
	 * @function
	 * @public
	 * 
     * @param {String} consumerKey The consumer key.
	 * @param {Function} cb A callback that retrieves the session tokens for the consumer key. If an error occurs, returns an error code 
	 * and error description.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */	
	getSessionTokensForConsumerKey: function(consumerKey, cb){
		Dispatcher.callClassMethodOnRemoteObject("Session", ["getCurrentSession", "getSessionTokensForConsumerKey"], [[], [consumerKey, cb]]);
	}
});


/**
 * The session modes for the server. Session modes include:
 * <ul>
 * <li><code>staging</code></li>
 * <li><code>integration</code></li>
 * <li><code>sandbox</code></li>
 * <li><code>production</code></li>
 * <li><code>unknown</code></li>
 * </ul>
 * @name Social.US.Session.serverModes
 * @field
 * @public
 * @status iOS, Android, Test, iOSTested, AndroidTested
 */
Session.serverModes = {
	staging: "staging",
	integration: "integration",
	partner: "sandbox",
	sandbox: "sandbox",
	production: "production",
	unknown: "unknown"
};

/**
 * Returns the current session.  
 * @name Social.US.Session.getCurrentSession
 * @function
 * @public 
 * @static
 *
 * @return {Social.US.Session} The current session.
 * @status iOS, Android, Test, iOSTested, AndroidTested
 */	
Session.getCurrentSession = function(){
	return Session._currentSession;
};



Session._emitter = null;

/**
 * Adds a listener to the current session.
 *
 * @name Social.US.Session.addCurrentSessionListener
 * @function
 * @public
 * @static
 *  
 * @param {Core.MessageListener }listener The listener to add to the current session.
 * @param {Function} callback The callback function.
 * @param priority The priority for this <code>MessageListener</code>.
 *
 * @see Core.MessageListener
 * @status iOS, Android, Test, iOSTested, AndroidTested
 */
Session.addCurrentSessionListener = function(listener, callback, priority){	
	if(!Session._emitter){
		Session._emitter = new MessageEmitterReq.MessageEmitter();
	}
	
	Session._emitter.addListener(listener, callback, priority);
};

/**
 * Removes the listener from the current session.
 *
 * @name Social.US.Session.removeCurrentSessionListener 
 * @function
 * @public 
 * @static
 *
 * @param {Core.MessageListener} listener The listener for the current session.
 * @status iOS, Android, Test, iOSTested, AndroidTested
 */
Session.removeCurrentSessionListener = function(listener){
	if(Session._emitter){
		Session._emitter.removeListener(listener);
	}
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Data/Dispatcher'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Data/Dispatcher'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Data/Dispatcher'] = exports; var GSGlobals = require('NGCore/Client/Social/_Internal/GSGlobals');

var Core = require('NGCore/Client/Core').Core;
var CacheR = require('NGCore/Client/Social/US/Models/Cache');

var SocialR = require('NGCore/Client/Social');
var SessionR = require('NGCore/Client/Social/US/Data/Session');

/**
 * <code>Dispatcher</code> objects know about <code>DataModel</code> objects and can "push" <code>DataModel</code> objects between interpreters.
 * <code>Dispatcher</code> objects can find classes and specific instances of objects, and may invoke their functions.
 * <code>Dispatcher</code> objects also provide a series of convenience functions to facilitate communication between interpreters.
 * @class 
 * @name Social.US.Dispatcher
 * @private
 */
var Dispatcher = exports.Dispatcher = {
				
	classname: "Dispatcher",
	callbackUIDCounter: 0,
	callbacks: {
		"-2": {},
		"-1": {}
	},
	
	/**
	 * Returns the data cache for the current session.
	 * @name Social.US.Dispatcher.cache
	 * @function
	 * @private
	 *
	 * @return {Social.US.Cache} The data cache for the current session.
	 * @see Social.US.Cache
	 */		
	cache: function(){		
		try {		
			return SessionR.Session.getCurrentSession().dataCache();
		}
		catch (err) {
			NgLogD("Mobage/Dispatcher/cache-Warning: cannot get cache. NOTE: This may be expected behavior if early on in initialization. Err=" 
				+ err);

			return null;
		}
	},
	
	
	/**
	 * Gets the current session and loads session data.
	 * If there is no current session, <code>receiveSession()</code> creates a new session.
	 *	 
	 * @name Social.US.Dispatcher.receiveSession
	 * @function
	 * @private
	 *
	 * @param {Type} command Takes a command, which may include the platform version, server mode, application name and application version. 
	 */		
	receiveSession: function(command){		
		var session = SessionR.Session.getCurrentSession();
		if(!session){
			session = new SessionR.Session();
			SessionR.Session._currentSession = session;
		}
		
		var userData = command.data.userData;
		if(userData){
			// the User object will be cached implicitly, then loaded in _loadSessionData
			Dispatcher.receiveObject({data: userData});
		}
		
		session._loadSessionData(command.data);
		
		if(SessionR.Session._emitter){
			SessionR.Session._emitter.emit({session: session});
		}
	},
	
	// DataModel communication
	/**
	 * Finds a particular instance of an object in the local interpreter and calls a method on the object.
	 *	 
	 * @name Social.US.Dispatcher.callMethodOnLocalObject
	 * @function
	 * @private
	 *
	 * @param {Command} command Takes a command object that identifies the class name of the object, 
     * its record ID, the method name to call, and any parameters for the method.
	 * The command object takes an optional callback and <code>callMethodOnLocalObject()</code> returns returns the result 
     * and/or any error code and description to the callback function.
	 */		
	callMethodOnLocalObject: function(command){		
		var recordID = command.recordID;
		var classname = command.classname;
		
		var object = Dispatcher.cache().getObjectWithRecordID(classname, recordID);
		if(object){
			var methodName = command.methodName;

			var error = false;
			var args;
			var retVal;
			if(methodName instanceof Array) {
				var methodOwner = object;
				for(var idx = 0; idx < methodName.length; idx++) {
					if(typeof methodOwner[methodName[idx]] == "function") {
						args = Dispatcher.convertArgumentsArrayFromJSON(command.arguments[idx] || []);
						retVal = methodOwner[methodName[idx]].apply(methodOwner, args);
						methodOwner = retVal;						
					}
					else {
						error = true;
						break;
					}
				}
			}
			else {
				if(typeof object[methodName] == "function") {
					args = Dispatcher.convertArgumentsArrayFromJSON(command.arguments || []);
					retVal = object[methodName].apply(object, args);
				}
				else {
					error = true;
				}
			}
			
			if(error) {
				NgLogD("ERROR: Invalid methods for calling on local object: " + command.recordID + " " + methodName);
			}
			else if(command.callback){
				var callback = Dispatcher.convertFunctionFromJSON({callbackUID: command.callback});
				if(callback){
					callback(retVal);
				}
			}
		}
	},
	
	
	/**
	 * Finds a particular instance of an object in a remote interpreter and calls a method on the remote object.
	 *	 
	 * @name Social.US.Dispatcher.callMethodOnRemoteObject
 	 * @function
 	 * @private
 	 *
	 * @param {Number} object The object reference (i.e., typically the keyword 'this').
	 * @param {String} method The method name to call.
	 * @param {Array} args An array of parameters for the method, including other <code>DataModel</code> objects or functions.
	 * @param {Function} cb Returns the result and/or any error code and description to the callback function.
	 *
	 * <b>Note:</b> If the target method wants a callback as one/more of its arguments, supply it as an element in the argument array, <b>NOT</b> as the fourth parameter.
	 */			
	callMethodOnRemoteObject: function(object, method, args, cb){		
		if(!object || !method){
			NgLogD("Public.Dispatcher.callMethodOnRemoteObject - bailing");
			if(cb){
				cb();
			}
			return;
		}

		args = Dispatcher.convertArgumentsArrayToJSON(args || []);
		
		var cmd = {
			apiURL: "US.Dispatcher.callMethodOnLocalObject",
			recordID: object.recordID,
			classname: object._classname(),
			methodName: method,
			arguments: args,
			callback: Dispatcher.convertFunctionToJSON(cb)
		};
		
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},

	/**
	 * Calls a static method on a class in the local interpreter.
	 *	 
	 * @name Social.US.Dispatcher.callClassMethodOnLocalObject	
	 * @function
	 * @private
	 *
	 * @param {Command} command Takes a command object that identifies the class name of the object, the method name to call, and any parameters for the method.
	 * The command parameter takes an optional callback function and <code>callMethodOnLocalObject()</code> returns returns the result and/or any error code and description to the callback function.
	 */		
	callClassMethodOnLocalObject: function(command){		
		Dispatcher.beginBatching();
		
		var classname = command.classname;
		var methodName = command.methodName;
		if(classname && methodName){
			var theClass = SocialR.Social.US[classname];
			if(!theClass){
				theClass = SocialR.Social.US.Service[classname];
			}
			
			if(theClass){
				var error = false;
				var args;
				var retVal;
				if(methodName instanceof Array) {
					var methodOwner = theClass;
					for(var idx = 0; idx < methodName.length; idx++) {
						if(typeof methodOwner[methodName[idx]] == "function") {
							args = Dispatcher.convertArgumentsArrayFromJSON(command.arguments[idx] || []);
							retVal = methodOwner[methodName[idx]].apply(methodOwner, args);
							methodOwner = retVal;						
						}
						else {
							error = true;
							break;
						}
					}
				}
				else {
					if(typeof theClass[methodName] == "function") {
						args = Dispatcher.convertArgumentsArrayFromJSON(command.arguments || []);
						retVal = theClass[methodName].apply(theClass, args);
					}
					else {
						error = true;
					}
				}
				
				if(error) {
					NgLogD("ERROR: Invalid methods for calling on local Class: " + classname + " " + methodName);
				}
				else if(command.callback){
					var callback = Dispatcher.convertFunctionFromJSON({callbackUID: command.callback});
					if(callback){
						callback(retVal);
					}
				}				
			}
		}
		
		Dispatcher.endBatching();
	},

	/**
	 * Calls a static method on a class in a remote interpreter.
	 *	 
	 * @name Social.US.Dispatcher.callClassMethodOnRemoteObject
	 * @function
	 * @private
	 *
	 * @param {String} theClass The name of the class.
	 * @param {String} method The method name to call.
	 * @param {Array} args An array of parameters for the method.
	 * @param {Function} cb <code>callClassMethodOnRemoteObject()</code> returns returns the result and/or any error code and description to the callback function.
	 * 
	 */			
	callClassMethodOnRemoteObject: function(theClass, methodName, args, cb){		
		if(!theClass || !methodName){
			NgLogD("Public.Dispatcher.callClassMethodOnRemoteObject - bailing");
			if(cb){
				cb();
			}
			return;
		}

		args = Dispatcher.convertArgumentsArrayToJSON(args || []);
		
		var cmd = {
			apiURL: "US.Dispatcher.callClassMethodOnLocalObject",
			classname: (theClass.classname ? theClass.classname : theClass),
			methodName: methodName,
			arguments: args,
			callback: (cb ? Dispatcher.convertFunctionToJSON(cb) : null)
		};
		
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},


	// callback communication

	/**
  	 * Takes a callback and sends it to a remote interpreter.
	 *	 
	 * @name Social.US.Dispatcher.sendCallbackToRemote
	 * @function
	 * @private
	 *
	 * @param {String} callbackUID The user ID of the user receiving the callback.
	 * @param {Array} args An array of parameters for the callback function.
	 */		
	sendCallbackToRemote: function(callbackUID, args){		
		args = Dispatcher.convertArgumentsArrayToJSON(args || []);
		
		var cmd = {
			apiURL: "US.Dispatcher.receiveCallbackFromRemote",
			callbackUID: callbackUID,
			arguments: args,
			zone: GSGlobals.getRouterInstance().zone
		};

		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},
	
	/**
	 * Receives a callback from a remote interpreter and provides the arguments to the local callback function.
	 *	 
	 * @name Social.US.Dispatcher.receiveCallbackFromRemote
	 * @function
	 * @private
	 *
	 * @param {Type} command A JSON object containing the user ID of the user receiving the callback and the callback arguments array.
	 */			
	receiveCallbackFromRemote: function(command){
		var callback = Dispatcher.callbacks[GSGlobals.getRouterInstance().zone][command.callbackUID]; //Dispatcher.convertFunctionFromJSON(command);
		if(!callback){
			return;
		}

		var args = Dispatcher.convertArgumentsArrayFromJSON(command.arguments || []);
		
		callback.apply(callback, args);
	},
	

	// convenience functions to facilitate communication of all objects
	
	/**
	 * Parses a JSON array of function parameters and returns an array of function parameters.
	 *	 
	 * @name Social.US.Dispatcher.convertArgumentsArrayFromJSON
	 * @function
	 * @private
	 * 
	 * @param {Array} args An array of function parameters in JSON format.
	 * @return {Array} Returns an array of function parameters.
	 */	
	convertArgumentsArrayFromJSON: function(args){		
		var newArgs = [];
		for(var idx=0; idx < args.length; idx++){
			var arg = args[idx];
			
			if(arg && ((arg.recordID && arg.classname) || arg instanceof Array)){
				newArgs[idx] = Dispatcher.convertModelObjectFromJSON(arg);
			}else if(arg && arg.callbackUID){
				newArgs[idx] = Dispatcher.convertFunctionFromJSON(arg);
			}else{
				newArgs[idx] = arg;
			}
		}
		return newArgs;
	},

	/**
	 * Parses an array of function parameters and returns the array in JSON format.	 
	 * @name Social.US.Dispatcher.convertArgumentsArrayToJSON
	 * @function
	 * @private
	 *
	 * @param {Array} args An array of function parameters.
	 * 
	 * @returns {JSON} An array of function parameters in JSON format.
	 */
	convertArgumentsArrayToJSON: function(args){		
		var newArgs = [];
		for(var idx=0; idx < args.length; idx++){
			var arg = args[idx];
			if(arg && (arg.recordID && arg._classname && typeof arg._classname == "function" && arg._classname())){
				Dispatcher.sendObjectImmediately(arg);

				arg = Dispatcher.convertModelObjectToJSON(arg);
				newArgs[idx] = arg;
			}else if(arg && arg instanceof Array){
				arg = Dispatcher.convertArgumentsArrayToJSON(arg);
				newArgs[idx] = arg;
			}else if(arg && typeof arg == "function"){
				newArgs[idx] = Dispatcher.convertFunctionToJSON(arg);
			}else{
				newArgs[idx] = arg;
			}
		}
		return newArgs;
	},

	// convenience functions to facilitate communication of DataModel objects
	
	/**
	 * Takes a <code>DataModel</code> object and returns the object in JSON format.
	 *	 
	 * @name Social.US.Dispatcher.convertModelObjectToJSON
	 * @function
	 * @private
	 * 
	 * @param {Social.Models.DataModel} object A reference to a <code>DataModel</code> object (i.e., typically a subclass of <code>Models.DataModel</code>).
	 *
	 * @return {JSON} A <code>DataModel</code> object in JSON format.
	 */		
	convertModelObjectToJSON: function(object){		
		if(object && object.recordID && object._classname()){
			object = {
				classname: object._classname(),
				recordID:  object.recordID
			};
		}
		return object;
	},


	/**
	 * Takes a <code>DataModel</code> object in JSON format and returns the object.
	 *	 
	 * @name Social.US.Dispatcher.convertModelObjectFromJSON
 	 * @function
 	 * @private
 	 *
	 * @param {JSON} json A <code>DataModel</code> object in JSON format.
	 * 
	 * @return {Social.US.DataModel} A <code>DataModel</code> object.
	 */		
	convertModelObjectFromJSON: function(json){		
		var object = json;
		if(json.recordID && json.classname){
			var obj = Dispatcher.cache().getObjectWithRecordID(json.classname, json.recordID);
			if(obj){
				object = obj;
				if(json.data){
					object._deserializeFromHash(json.data);
				}
			}
		}else if(json instanceof Array){
			for(var idx=0; idx < json.length; idx++){
				var arg = json[idx];
				json[idx] = Dispatcher.convertModelObjectFromJSON(arg);
			}
		}
		return object;
	},

	// convenience functions to facilitate communication of functions
	
	/**
	 * Takes a function and returns the function in JSON format.
	 *	 
	 * @name Social.US.Dispatcher.convertFunctionToJSON
	 * @function
	 * @private	 
	 * 
	 * @param {function} The function to conver to JSON format.
	 * 
	 * @return {JSON} Returns a function in JSON format.
	 */		
	convertFunctionToJSON: function(fn){		
		if(fn && typeof fn == "function"){
			
			var callbackUID = ++Dispatcher.callbackUIDCounter;
			var zone = GSGlobals.getRouterInstance().zone;
			Dispatcher.callbacks[zone][callbackUID] = fn;

			fn = {
				callbackUID: callbackUID,
				zone: zone
			};
		}
		return fn;
	},


	
	/**
 	 * Takes a function expressed in JSON format and returns the function.
	 * @name Social.US.Dispatcher.convertFunctionFromJSON
	 * @function
	 * @private
	 * 
	 * @param {JSON} A function in JSON format.
	 * 
	 * @return {Function} Returns a function.
	 */	
	convertFunctionFromJSON: function(json){		
		var fn = json;
		var callbackUID = fn.callbackUID;
		var zone = fn.zone;
		
		if(callbackUID){
			var callback = Dispatcher.callbacks[zone][callbackUID];
			if(callback){
				fn = callback;
				delete Dispatcher.callbacks[zone][callbackUID];
			}else{
				fn = Dispatcher.generateCallbackForUID(callbackUID);
			}
		}
		return fn;
	},


	
	/**
	 * Takes a user ID and sends the callback to the remote interpreter.
	 *
	 * @name Social.US.Dispatcher.generateCallbackForUID
	 * @function
	 * @private
	 *	 
	 * @param {Number} The user ID.
	 * @return {Function} Returns a callback to the remote interpreter.
	 */	
	generateCallbackForUID: function(uid){		
		if(uid.callbackUID){
			uid = uid.callbackUID;
		}
		
		return function(){
			Dispatcher.sendCallbackToRemote(uid, arguments);
		};
	},
	
	
	// object sending and batching
	_batchCount: 0,
	_queuedObjects: [],
	
	/**
	 * <code>beginBatching()</code> increments the batch count.
	 * 
	 * @name Social.US.Dispatcher.
	 * @function
	 * @private
	 */	
	beginBatching: function(){		
		++Dispatcher._batchCount;
	},

	/**
	 * Decrements the batch count.
	 * Decrements the batch count and sends any objects remaining in the queue immediately.
	 *
	 * @name Social.US.Dispatcher.endBatching
	 * @function
	 * @private
	 */	
	endBatching: function(){		
		if((--Dispatcher._batchCount) === 0){
			for(var objKey in Dispatcher._queuedObjects){
				var obj = Dispatcher._queuedObjects[objKey];
				Dispatcher._queuedObjects[objKey] = undefined;
				Dispatcher.sendObjectImmediately(obj);
			}
		}
	},

	/**
	 * Takes an object and adds it to a queue, which pushes the object to the remote interpreter.
	 *
	 * @name Social.US.Dispatcher.sendObject
	 * @function
	 * @private
	 */
	sendObject: function(obj){		
		if(Dispatcher._queuedObjects.indexOf(obj) == -1){
			Dispatcher.beginBatching();
			
			var key = "" + obj.classname + "---" + obj.recordID;
			Dispatcher._queuedObjects[key] = obj;
			
			Dispatcher.endBatching();
		}
	},

	/**
	 * Takes an object and pushes it to the remote interpreter immediately (i.e., bypassing the queue).
	 *
	 * @name Social.US.Dispatcher.sendObjectImmediately
	 * @function
	 * @private
	 */
	sendObjectImmediately: function(obj){		
		if(!obj){
			return;
		}
		
		var cmd = {
			apiURL: "US.Dispatcher.receiveObject",
			data:   obj._serializedHash()
		};
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},

	/**
	 * Receives a serialized object from the remote interpreter, retrieves the local version of the same object from the cache, and deserializes the received object to the local object.
	 * If there is no local version of the received object, <code>receiveObject()</code> creates a local version and adds it to the cache; then, it deserializes the received object to the newly created local object.
	 *
	 * @name Social.US.Dispatcher.receiveObject
	 * @function
	 * @private
	 */
	receiveObject: function(command){		
		var data = command.data;
		var theRecordID  = data.recordID;
		var theClassname = data.classname;
		var theData      = data.data;
		
		if(theRecordID && theClassname && Dispatcher.cache()){
			var obj = Dispatcher.cache().getObjectWithRecordID(theClassname, theRecordID);
			if(!obj){
				var theClass = SocialR.Social.US[theClassname];
				obj = new theClass(theRecordID);
				
				Dispatcher.cache().addObject(obj);
			}

			// TODO disable emitting somehow
			if(theData){
				obj._deserializeFromHash(theData);
			}
		}
	}
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Service/Friends'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Service/Friends'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Service/Friends'] = exports; var RouterInited = require('NGCore/Client/Social/_Internal/RouterInit');
var GSGlobals = require('NGCore/Client/Social/_Internal/GSGlobals');

var MessageEmitter = require('NGCore/Client/Core/MessageEmitter').MessageEmitter;

var DataModelR = require('NGCore/Client/Social/US/Models/DataModel');
var Dispatcher = require('NGCore/Client/Social/US/Data/Dispatcher').Dispatcher;

/**
 * @class 
 * @name Social.US.Service.Friends
 */
var Friends = exports.Friends = DataModelR.DataModel.subclass({
    classname: "Friends"
});

/**
 * Opens the "Find Friends" view.
 *
 * @name Social.US.Service.Friends.showFindFriends
 * @function
 * @public
 * @static
 *
 * @param selectedTab Takes an optional tab reference.
 * @status iOS, Android, Test, iOSTested, AndroidTested
 */		
Friends.showFindFriends = function(selectedTab) {
		NgLogD("Public call showFindFriends");
	
		var cmd = {
			apiURL:"US.Service.Friends.showFindFriends"
		};
		
		if(selectedTab){
			cmd.data.tab = selectedTab;
		}
		
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
};

/**
 * Opens the "Friend Picker" view.
 * 
 * @name Social.US.Service.Friends.openFriendPicker
 * @function
 * @public 
 * @static
 * 
 * @param maxFriendsToPick The maximum number of friends to pick. <code>0</code> for unlimited.
 * @param {Function} callback Retrieves an array of picked users.
 * 
 * <br/> 
 * <b>Callback Example:</b><br/>
 * <pre class="code">function(error, pickedUsers){
 * &nbsp;&nbsp; if(error){
 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
 * &nbsp;&nbsp; } else {
 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var users = pickedUsers;
 * &nbsp;&nbsp;}
 * }
 * </pre>
 * @status iOS, Android, Test, iOSTested, AndroidTested
 */		
Friends.showFriendPicker = function(maxFriendsToPick, callback) { 
    Dispatcher.callClassMethodOnRemoteObject(Friends, "showFriendPicker", [maxFriendsToPick, callback]);
};

/**
* <code>Social.US.Service.Friends</code> has an invited user message emitter. 
* To add a message listener to the message emitter, see the example below.
*
* @name Social.US.Service.Friends.invitedUserEmitter
* @field
* @public
* @example
* 
* Social.US.Service.Friends.invitedUserEmitter.addListener(
*				new Core.MessageListener(), 
*				function(user){ 
*				// do sth. w/ User object 
*				}
* Social.US.Service.Friends.invitedUserEmitter.emit({user: user});
* @see Core.MessageListener
* @see Core.MessageEmitter
* @status iOS, Android, Test, iOSTested, AndroidTested
*/
Friends.invitedUserEmitter = new MessageEmitter();; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Service/Profile'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Service/Profile'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Service/Profile'] = exports; var RouterInited = require('NGCore/Client/Social/_Internal/RouterInit');
var GSGlobals = require('NGCore/Client/Social/_Internal/GSGlobals');

/**
 * @class
 * @name Social.US.Service.Profile
 */

exports.Profile = {
	
	/**
	 * Shows the user profile of the user specified by the <code>userOrGamertag</code> parameter.
	 * 
	 * @name Social.US.Service.Profile.showUserProfile
	 * @function
	 * @public
	 * 
	 * @param userOrGamertag Identifies the user or gamertag corresponding to the user profile.
	 * @param tab Specifies the name of the tab to show when the UI opens. If <code>null</code>, it opens the default tab.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */			
	showUserProfile:function(userOrUserGamertag,tab){		
		var cmd = {
			apiURL:"US.Service.Profile.showUserProfile", 
			data:{
				user:userOrUserGamertag
			}
		};
		if(tab){cmd.tab = tab;}
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	}
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Service/ButtonOverlays'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Service/ButtonOverlays'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Service/ButtonOverlays'] = exports; var UI = require('NGCore/Client/UI').UI;

var RouterInited = require('NGCore/Client/Social/_Internal/RouterInit');
var GSGlobals = require('NGCore/Client/Social/_Internal/GSGlobals');

var MessageEmitter = require('NGCore/Client/Core/MessageEmitter').MessageEmitter;

var Friends = require('NGCore/Client/Social/US/Service/Friends').Friends;
var Profile = require('NGCore/Client/Social/US/Service/Profile').Profile;
var User    = require('NGCore/Client/Social/US/Models/User').User;

/**
 * @class 
 * @name Social.US.Service.ButtonOverlays
 */
exports.ButtonOverlays = {
	/**
	* Displays the "Mobage Community" button.
	*	
	* @name Social.US.Service.ButtonOverlays.showCommunityButton
	* @function
	* @public 
	* 
	* @param {exports.Gravity} gravity Displays the button in the specified corner.
	* @param {Function} callback The callback function if there is an error related to <code>gravity</code> or <code>theme</code> usage.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <pre class="code">function(error){
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
	* &nbsp;&nbsp;   }
	* </pre>
	* @see exports.Gravity
	* @status iOS, Android, Test, iOSTested, AndroidTested
	*/   
	showCommunityButton: function(gravity, callback) {
		NgLogD("Public - showCommunityButton");
		
		var cmd = {
			apiURL:"US.Service.ButtonOverlays.showCommunityButton"
		};
		
		cmd["gravity"] = gravity;
		
		if (callback != undefined && typeof callback == "function") {
			cmd["callbackFunc"] = callback;
		} else {
			cmd["callbackFunc"] = null;
		}
		
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},

	/**
	* Hides the "Mobage Community" button.
	*
	* @name Social.US.Service.ButtonOverlays.hideCommunityButton
	* @function
	* @public 
	*	
	* @param {Function} callback The callback function if there is an error hiding the button.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <pre class="code">function(error){
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
	* &nbsp;&nbsp;   }
	* </pre>
	* @status iOS, Android, Test, iOSTested, AndroidTested
	*/	
	hideCommunityButton: function(callback) {
		NgLogD("Public - hideCommunityButton");
		
		var cmd = {
			apiURL:"US.Service.ButtonOverlays.hideCommunityButton"
		};
		
		if (callback != undefined && typeof callback == "function") {
			cmd["callbackFunc"] = callback;
		} else {
			cmd["callbackFunc"] = null;
		}
		
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},

	/**
	 * Shows the balance button.
	 * Shows the balance button where the <code>rect</code> parameter 
	 * determines the size and position of the button.
	 *
	 * @name Social.US.Service.ButtonOverlays.showBalanceButton
	 * @function
	 * @public
	 *	 
	 * @param {UI.ViewGeometry.Rect} rect Determines the size and position of the balance button.
	 * @param {Function} callback The callback function if there is an error with the <code>rect</code> parameter.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error){
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
	 * &nbsp;&nbsp;   }
	 * </pre>
	 * @see UI.ViewGeometry.Rect
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	showBalanceButton: function(rect, callback) {
		NgLogD("Public - showBalanceButton");
		
		var cmd = {
			apiURL:"US.Service.ButtonOverlays.showBalanceButton"
		};
		
		if (rect != undefined) {
			cmd["rect"] = rect;
		} else {
			cmd["rect"] = new UI.ViewGeometry.Rect(50, 50, 0, 0);
		}
		
		if (callback != undefined && typeof callback == "function") {
			cmd["callbackFunc"] = callback;
		} else {
			cmd["callbackFunc"] = null;
		}
	
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},
	
	/**
	 * Hides the balance button.	
	 * @name Social.US.Service.ButtonOverlays.hideBalanceButton
	 * @function
	 * @public 
	 * 
	 * @param {Function} callback The callback function called after the view closes.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error){
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
	 * &nbsp;&nbsp;   }
	 * </pre>
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */		
	hideBalanceButton: function(callback) {
		NgLogD("Public - hideBalanceButton");
		
		var cmd = {
			apiURL:"US.Service.ButtonOverlays.hideBalanceButton"
		};

		if (callback != undefined && typeof callback == "function") {
			cmd["callbackFunc"] = callback;
		} else {
			cmd["callbackFunc"] = null;
		}
	
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	}
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Service/GameLaunchPayload'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Service/GameLaunchPayload'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Service/GameLaunchPayload'] = exports; var RouterInited = require('NGCore/Client/Social/_Internal/RouterInit');
var GSGlobals = require('NGCore/Client/Social/_Internal/GSGlobals');

var MessageEmitter = require('NGCore/Client/Core/MessageEmitter').MessageEmitter;

/**
* Provides an interface for retrieving a game's last payload from the game service. The game
* payload is returned as a string.
* @name Social.US.GameLaunchPayload
*/

var GameLaunchPayload = exports.GameLaunchPayload = {


	/**
	 * @name Social.US.GameLaunchPayload.getLastPayload
	 * @function
	 * @public
	 * 
	 * @param {Function} callback Retrieves the last payload generated by the game client from the game service 
     * as a string (e.g., JSON) and/or any error code and description.
	 * <br/>
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error, payload){
     *      if(error) {
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
     *      } else {
     * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var pl = payload;     
     *      }
	 * }
	 * </pre>
	 * @status iOS, Android, Test, iOSTested, AndroidTested
     */
	getLastPayload:function(callback)
	{
        if(callback != undefined && typeof callback == "function")
		{
			var cmd = {
				apiURL:"US.Service.GameLaunchPayload.getLastPayload"
			};

            cmd["callbackFunc"] = callback;

			GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
		}
	},
	
	// private, automatically called when new payload arrives. Do not call.
	onGameLaunchPayload:function(data)
	{
		this.newGamePayloadEmitter.emit(data);
	}
};

GameLaunchPayload.newGamePayloadEmitter = new MessageEmitter();; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Service/Bank'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Service/Bank'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Service/Bank'] = exports; // Bank Public Interface
var RouterInited 	= require('NGCore/Client/Social/_Internal/RouterInit');
var GSGlobals 		= require('NGCore/Client/Social/_Internal/GSGlobals');
var UI 				= require('NGCore/Client/UI').UI;

/**
* @ignore
* @private
*/
exports.Bank = {
};


/**
 * @class 
 * @name Bank.Debit
 * @description
 * Bank.Debit is an interface for in-game item purchasing. A transaction begins with a call to <code>createTransaction()</code>, which presents
 * a user interface to the user. If the user follows through with a purchase, the <code>transaction.state</code> property changes from 
 * <code>new</code> to <code>authorized</code>. Once <code>createTransaction()</code> executes its callback, the game may call 
 * <code>openTransaction()</code>, which changes the state from <code>authorized</code> to <code>open</code> and puts funds into escrow. 
 * At this point, the game/game server should deliver the purchased items. Once the items have been delivered, the game should call   
 * <code>closeTransaction()</code>. If there is a problem at any point in the transaction lifecycle, call <code>cancelTransaction()</code>,
 * which sets the <code>transactionState</code> property to <code>canceled</code> and restores funds from escrow back to the user.
 */
exports.Bank.Debit = {
	
		
	/**
	 * Creates a transaction. Initially, it sets the <code>transaction.state</code> to <code>new</code>.
     * Mobage presents a dialog that prompts the user to confirm the transaction. 
	 * If the user decides not to proceed with the transaction, the callback error returns as "usercanceled."
	 * In the client-only flow, this call checks inventory and sets the state to <code>authorized</code>.
	 * 
	 * @name Bank.Debit.createTransaction
	 * @function
	 * @public
	 * 
	 * @param {Array} billingItems The billing items for the transaction. <br/><b>Note:</b> The array is limited to one item for this release.
     * <br/><b>Array Example:</b><br/>
     * <pre class="code"> var billingItems = [{
     *     "item": {
     *           "id": "iceCastle",
     *          },
     *     "quantity": 1
     *    },
     *    {
     *     "item": {
     *           "id": "cobbleStoneRoad",
     *          },
     *     "quantity": 3
     *    } 
     * ];
     * </pre>
	 * @param {String} comment A comment about the transaction.
	 * @param {Function} callback Retrieves the transaction details and/or any error code and description.
	 * <br/> 
     * <b>Callback Example:</b><br/>
	 * <pre class="code">var createTxCallback = function (error, transaction){
	 *     if (error === 'usercanceled'){
     *         var userCanceledDlg = new UI.AlertDialog();
     *         userCanceledDlg.setTitle("Cancel Transaction");
     *         userCanceledDlg.setText("User canceled transaction.");
     *         userCanceledDlg.setChoices([('OK')]);
     *         userCanceledDlg.show();
     *     } else if(error){
     *         var errorCode = error.errorCode;
     *         var errorDesc = error.description;
     *         Bank.Debit.cancelTransaction(transaction.id);
     *     } else {
     *         txId = transaction.id;
     *         Bank.Debit.openTransaction(txId, openTxCallback)
     * };
	 * </pre>
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */				
    createTransaction: function(billingItems, comment, callback) {
		NgLogD("Public call createTransaction");
		
		
	var data = {
	    billingItems: billingItems,
	    comment: comment
	};
		var cmd = {
			apiURL:"US.Service.Banking.Purchase.createTransaction",
			data: data
		};

		if (callback != undefined && typeof callback == "function") {
			cmd["callbackFunc"] = this._getCallBackFunc(callback);
		}    
        GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},
	
	/**
	 * Places funds into escrow and begins processing the transaction. 
	 * Indicates the game server needs to deliver the purchased item.
	 * The <code>transaction.state</code> transitions from <code>authorized</code> to <code>open</code>.
	 *
	 * @name Bank.Debit.openTransaction
	 * @function
	 * @public
	 * 
	 * @param {String} transactionId The <code>transactionId</code> identifying this transaction.
	 * @param {Function} callback Retrieves the transaction details and/or any error code and description.
	 * <br/>
	 * <b>Callback Example:</b><br/>
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">var openTxCallback = function (error, transaction){
	 *      if (error){
	 *          var errorCode = error.errorCode;
     *          var errorDesc = error.errorDescription;
     *          Bank.Debit.cancelTransaction( transaction.id, 
     *                                        cancelTxCallback );
     *      } else {
     *          var txId = transaction.id;
     *          var txState = transaction.state;
     *          var txComment = transaction.comment;
     *          //You are responsible for delivering items to the client.
     *          MyGameTxClass.deliverItems(transaction.items);
     *          //If you do not close the tx, you do not get paid.
     *          Bank.Debit.closeTransaction( transaction.id, 
     *                                       closeTxCallback );
     *      }	
     * };
	 * </pre>
	 * @status iOS, Android, Test, iOSTested, AndroidTested
     */
	openTransaction: function(transactionId, callback) {
		NgLogD("Public call openTransaction");
		
		var cmd = {
			apiURL:"US.Service.Banking.Purchase.openTransaction",
			data:{}
		};
		
		if (transactionId) {
			cmd.data.transactionId = transactionId;
		}
		if (callback != undefined && typeof callback == "function") {
			cmd["callbackFunc"] = this._getCallBackFunc(callback);
		}
        
        GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},
	
	/**
	 * Continues processing a transaction.
	 * Checks the inventory to verify the item is valid, available, and so on. After verification, the <code>transaction.state</code> chranges from <code>new</code> to <code>authorized</code>,
	 * and funds are placed in escrow. The <code>transaction.state</code> transitions from <code>authorized</code> to <code>open</code>, which 
	 * indicates the game server needs to deliver the purchased item. 
	 * 	 
	 *
	 * @name Bank.Debit.continueTransaction
	 * @function
	 * @public
	 * 
	 * @param {String} transactionId The <code>transactionId</code> identifying this transaction.
	 * @param {Function} callback Retrieves the transaction details and/or any error code and description.
	 * <br/>
     * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error, transaction){
     *      if(error) {
	 *           var errorCode = error.errorCode;
	 *           var errorDesc = error.description;
     *           Bank.Debit.cancelTransaction( transaction.id, 
     *                                         cancelTxCallback );
     *      } else {
     *           var tx = transaction;
     *           Bank.Debit.openTransaction( transaction.id, 
     *                                       openTxCallback );
     *      }
	 * };
	 * </pre>
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
    continueTransaction: function(transactionId, callback) {
		NgLogD("Public call continueTransaction");
		
		var cmd = {
			apiURL:"US.Service.Banking.Purchase.continueTransaction",
			data:{}
		};
		
		if (transactionId) {
			cmd.data.transactionId = transactionId;
		}
		if (callback != undefined && typeof callback == "function") {
			cmd["callbackFunc"] = callback;
		}
        
        GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},
	

    /**
     * Cancels the transaction. The transaction was canceled or the purchased item was not delivered and the game
     * needs to return the user's funds. The <code>transaction.state</code> transitions to <code>canceled</code>.
     *
     * @name Bank.Debit.cancelTransaction
     * @function
     * @public 
     * 
     * @param {String} transactionId The <code>transactionId</code> identifying this transaction.
     * @param {Function} callback Retrieves the transaction ID and/or an error code and description.
     * <br/>
     * <b>Callback Example:</b><br/>
	 * <pre class="code">var cancelTxCallback = function (error, transaction){
     *     if (error){
     *        var errorCode = error.errorCode;
     *        var errorDesc = error.errorDescription;
     *        NgLogD('Time to freak out!: ' + errorCode+ ': ' + errorDesc);
     *     } else {
     *        var txId = transaction.id;
     *        var txState = transaction.state;
     *        var txComment = transaction.comment;
     *        if (txState === 'canceled'){
     *          NgLogD('Sniff, sniff... Whaaaaahhhh!!!');
     *        }	
	 *     }	
     * };
	 * </pre>
	 * @status iOS, Android, Test, iOSTested, AndroidTested
     */
    cancelTransaction: function(transactionId, callback) {
		NgLogD("Public call cancelTransaction");
		
		var cmd = {
			apiURL:"US.Service.Banking.Purchase.cancelTransaction",
			data:{}
		};
		
		if (transactionId) {
			cmd.data.transactionId = transactionId;
		}
		if (callback != undefined && typeof callback == "function") {
			cmd["callbackFunc"] = callback;
		}
        
        GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
    },


	/**
	 * Closes the transaction. The virtual item was delivered.
	 * The <code>transaction.state</code> transitions from <code>open</code> to <code>closed</code>.
	 *
	 * @name Bank.Debit.closeTransaction
	 * @function
	 * @public
	 * 
	 * @param {String} transactionId The <code>transactionId</code> identifying this transaction.
	 * @param {Function} callback Retrieves the transaction details and/or an error code and description.
	 * <br/>
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">var closeTxCallback = function (error, transaction){
     *     if (error){
     *          var errorCode = error.errorCode;
     *          var errorDesc = error.errorDescription;
     *          NgLogD('Oh my goodness! A transaction error: ' +
     *                  errorCode + ': ' + errorDesc);
     *          Bank.Debit.cancelTransaction( transaction.id, 
     *                                        cancelTxCallback );
	 *     } else {
     *          var txId = transaction.id;
     *          var txState = transaction.state;
     *          var txComment = transaction.comment;
     *          if (txState === 'closed'){
     *              NgLogD('I'm rich! I'm rich!');
     *          }	
     *     }	
     * };
	 * </pre>
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	closeTransaction: function(transactionId, callback) {
		NgLogD("Public call closeTransaction");
		
		var cmd = {
			apiURL:"US.Service.Banking.Purchase.closeTransaction",
			data:{}
		};
		
		if (transactionId) {
			cmd.data.transactionId = transactionId;
		}
		if (callback != undefined && typeof callback == "function") {
			cmd["callbackFunc"] = this._getCallBackFunc(callback);
		}
        
        GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},
	
	/**
	 * Retrieves the transaction corresponding to the given transaction ID parameter.
	 *
	 * @name Bank.Debit.getTransaction
	 * @function
	 * @public
	 * 
	 * @param {String} transactionId The <code>transactionId</code> identifying this transaction.
	 * @param {Function} callback Retrieves the transaction details and/or an error code and description.
	 * <br/>
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error, transaction){
     *      if(error) {
	 *            var errorCode = error.errorCode;
	 *            var errorDesc = error.description;
     *      } else {
     *            var tx = transaction;     
     *      }
	 *   }
	 * </pre>
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getTransaction: function(transactionId, callback) {
		NgLogD("Public call getTransaction");
		
		var cmd = {
			apiURL:"US.Service.Banking.Purchase.getTransaction",
			data:{}
		};
		
		if (transactionId) {
			cmd.data.transactionId = transactionId;
		}
		if (callback != undefined && typeof callback == "function") {
			cmd["callbackFunc"] = this._getCallBackFunc(callback);
		}
        
        GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},

	/**
	 * Retrieves the user's transactions where the state is <code>new</code>, <code>authorized</code> or <code>open</code>.
     * See the Game Service Programming Guide for details.
	 *
	 * @name Bank.Debit.getPendingTransactions
	 * @function
	 * @public
	 * 
	 * @param {Function} callback Retrieves the user's pending transactions and/or an error code and description.
	 * <br/>
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error, transaction){
     *      if(error) {
	 *         var errorCode = error.errorCode;
	 *         var errorDesc = error.description;
     *      } else {
     *         var tx = transaction;     
     *      }
	 * }
	 * </pre>
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getPendingTransactions: function(callback) {
		NgLogD("Public call getPendingTransactions");

		var cmd = {
			apiURL:"US.Service.Banking.Purchase.getPendingTransactions",
			data:{}
		};

		if (callback != undefined && typeof callback == "function") {
			cmd["callbackFunc"] = function(err, data) {
				callback(err.error, data.openTransactions);
			};
		}

	    GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},

	_getCallBackFunc : function(callback) {
			return function(err, data) {
				if(err) {
					callback(err, undefined);
				} else {
					callback(err, data.transaction);					
				}
			};
	}
};

/**
 * @class 
 * @name Bank.Inventory
 * @description
 * Provides an interface to retrieve items from inventory. The Mobage platform
 * server is responsible for managing item inventory in games.
 */
exports.Bank.Inventory = {


	/**
	 * Retrieves the item identified by its product ID from inventory on the Mobage platform server.
	 *
	 * @name Bank.Inventory.getItem
	 * @function
	 * @public
	 * 
	 * @param {Number} itemId The product ID for the item.
     * @param {Function} callback Retrieves the item from inventory on the Mobage platform server and/or an error code and description.
	 * <br/>
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">var item = {
     *      "id" : "XXXXXXXXX",
     *      "name" : "Tractor",
     *      "price" : 350,
     *      "description" : "Tractor conveys huge amount of equipment.",
     *      "imageUrl" : "http://someurl.com"
     * }
     *function(error, item){
     *      if(error) {
	 *         var errorCode = error.errorCode;
	 *         var errorDesc = error.description;
     *      } else {
     *         var itemData = item;
     *      }
	 * }
	 * </pre>
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */    
    getItem: function(itemId,callback) {
	NgLogD("Public call Inventory getItem");

	var data = {
	    itemId: itemId
	};

	var cmd = {
	    apiURL:"US.Service.Banking.Purchase.getItem",
	    data:data
	};

	if (callback != undefined && typeof callback == "function") {
	    cmd["callbackFunc"] =  function(err, data) {
		if(err) {
		    callback(err, undefined);
		} else {
		    callback(err, data.item);					
		}
	    };
	}

	GSGlobals.getRouterInstance().sendCommandToGameService(cmd);

    }


};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/_Internal/GSGlobals'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/_Internal/GSGlobals'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/_Internal/GSGlobals'] = exports; /**
 * Annoyingly necessary file to break circular dependencies.
 */
var theRouter = null;
exports.setRouterInstance = function(router){
	theRouter = router;
};
exports.getRouterInstance = function(){
	return theRouter;
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/_Internal/RouterInit'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/_Internal/RouterInit'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/_Internal/RouterInit'] = exports; var Router = require('NGCore/Client/Social/_Internal/_Router').Router;
var GSGlobals = require('NGCore/Client/Social/_Internal/GSGlobals');

//Generate 1 instance of our router now and treat as the global instance!
GSGlobals.setRouterInstance(new Router());; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/_Internal/_Router'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/_Internal/_Router'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/_Internal/_Router'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class Router INTERNAL ROUTING CLASS
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


var Class = require('NGCore/Shared/Class').Class;
var Core = require('NGCore/Client/Core').Core;
var GSCommand = require('NGCore/Client/Social/_Internal/GSCommand');
var Public = require('NGCore/Client/Social').Social;

////////////////////////////////////////////////////////////////////////////////
var RouterVerbose = false;

exports.Router = Class.subclass(
/** @lends GameService.Router.prototype */
{
	classname: 'Router',
	
	/**
	 * Function.
	 * @constructs
	 * @augments Core.Class
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
	},
	
	/** Member var to help shortcircuit uneccessary bounces out to native. */
	zone:-2,
	
// {{?Wg Generated Code}}
	
	// Enums.
	/** 
			* Zone for this Router Singleton (per-process)
			* @private */
	Zone:
	{ 
		/** Public Zone */
		Public: -2,
		/** GameService Zone */
		GameService: -1,
	},
	
	///////
	// Class constants (for internal use only):
	// Class ID = 346
	// Method create = -1
	// Method sendToOtherProcess = 2
	// Method onCreate = 3
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._sendToOtherProcessRecv( cmd );
					break;
				case 3:
					instance._onCreateRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Router._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Router._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[346] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_sendToOtherProcessRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in Router.sendToOtherProcess from command: " + cmd );
			return false;
		}
		
		obj[ "gsCommand" ] = Core.Proc.parseJSONString( cmd[ 0 ] );
		if( obj[ "gsCommand" ] === undefined )
		{
			NgLogE("Could not parse gsCommand in Router.sendToOtherProcess from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_onCreateRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in Router.onCreate from command: " + cmd );
			return false;
		}
		
		obj[ "zone" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "zone" ] === undefined )
		{
			NgLogE("Could not parse zone in Router.onCreate from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":346,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_sendToOtherProcessSendGen: function( gsCommand )
	{
		Core.Proc.appendToCommandString( ":346,2," + this.__objectRegistryId + "," + Core.Base64.encode( JSON.stringify( gsCommand ) )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _sendToOtherProcessRecv: function( cmd ) {}
	// sendToOtherProcess: function( gsCommand ) {}
	
	// _onCreateRecv: function( cmd ) {}

// {{/Wg Generated Code}}
	_onCreateRecv:function(cmd) {
		if (!this._onCreateRecvGen(cmd,this)){
			return;
		}
		NgLogD("_Router/_onCreateRecv: "+this.zone);
		//We already stored the zone directly in ourselves (by passing in 'this').
	},
	_sendToOtherProcessRecv: function( cmd )
	{
		var decodedCommand = {};
		if(!this._sendToOtherProcessRecvGen(cmd,decodedCommand)){
			NgLogE("Decode of data for router, failed.");
			return;
		}
		
		var commandObject = decodedCommand["gsCommand"];
		
		//Incoming commands all get executed immediately.
		if(this.zone == this.Zone.Public) {
			if(RouterVerbose) {
				NgLogD("_Router/_sendToOtherProcessRecv - in public");
			}
			
			this.dispatchGameCommand(commandObject);
		}
		else if(this.zone == this.Zone.GameService) {
			if(RouterVerbose) {
				NgLogD("_Router/ _sendToOtherProcessRecv - in privileged");
			}
			
			// Dispatch Immediately, because we are in the right interpreter
			this.dispatchGameServiceCommand(commandObject);
		}
		else {
			NgLogE("Unknown Command Zone for the GameService Router.");
			// Assume public
			this.dispatchGameCommand(commandObject);
		}
	},
 	sendToOtherProcess: function( gsCommand ) 
	{
		var jsonCommand = GSCommand.makeSafe(gsCommand);
		if(!jsonCommand) {
			NgLogD("Couldn't prep GSCommand message for sending!");
			return;
		}
		
		if(RouterVerbose) {
			NgLogD("_Router.js/sendToOtherProcess: " + JSON.stringify(jsonCommand));
		}
		
		this._sendToOtherProcessSendGen(jsonCommand);
	},
	sendCommandToGameService:function(gsCommand) 
	{		
		if(this.zone == this.Zone.Public) {
			if(RouterVerbose) {
				NgLogD("_Router: sendCommandToGameService - in public");
			}
			
			// In the Public Interface, this is an alias for sendToOtherProcess
			this.sendToOtherProcess(gsCommand);
		}
		else if(this.zone == this.Zone.GameService) {
			if(RouterVerbose) {
				NgLogD("_Router: sendCommandToGameService - in privileged");
			}
			
			// Dispatch Immediately, because we are in the right interpreter
			this.dispatchGameServiceCommand(gsCommand);
		}
		else {
			NgLogE("Unknown Command Zone for the GameService Router.");
			// Assume public
			this.sendToOtherProcess(gsCommand);
		}
	},
	sendCommandToGame:function(gsCommand)
	{
		if(this.zone == this.Zone.GameService) {
			// In the GameService Interface, this is an alias for sendToOtherProcess
			this.sendToOtherProcess(gsCommand);
		}
		else if(this.zone == this.Zone.Public) {
			// Dispatch Immediately, because we are in the right interpreter
			this.dispatchGameCommand(gsCommand);
		}
		else {
			NgLogE("Unknown Command Zone for the GameService Router.");
			// Assume Privileged
			this.sendToOtherProcess(gsCommand);
		}
	},
	dispatchGameCommand:function(jsonCommand) 
	{
		var tCommand = GSCommand.makeExecutable(jsonCommand);
		//For the time being we expect this to almost always be callbacks
		if(tCommand && tCommand.hasOwnProperty("callbackFunc")) {	
			if( typeof tCommand["callbackFunc"] == "function" ) {
				var args = null;
				var error = null;
				if(tCommand.hasOwnProperty("error")) {
					error = tCommand["error"];
				}
				if(tCommand.hasOwnProperty("callbackData")) {
					args = tCommand["callbackData"];
				}

				//Time to execute the callback function!
				tCommand["callbackFunc"](error,args);
			}
		}
		else if(tCommand) {
			// Case there was no callbackFunc this is odd!!
			var apiURL = null;
			if(tCommand && tCommand.hasOwnProperty("apiURL") ) {
				apiURL = tCommand["apiURL"];

				var apiPieces = apiURL.split(".");
				var curPackage = Public;

				for ( var i = 0; i < apiPieces.length; i++ )
				{
					if(curPackage.hasOwnProperty(apiPieces[i])) {
						curPackage = curPackage[apiPieces[i]];
					}
					else {
						//Total Fail
						NgLogE("Cannot find namespace " + apiURL + " in GameService");
						curPackage = null;
						break;
					}
				}

				if(curPackage && typeof curPackage == "function" ) {			
					curPackage(tCommand);

					return; //done dispatching!
				}else{
					NgLogE("GameService Public cannot dispatch game command " + JSON.stringify(tCommand));
				}
			}
		}
	},
	dispatchGameServiceCommand:function(jsonCommand) 
	{
		//Don't decode the callbackId into a func when on a different interpreter!
		var apiURL = null;
		if(jsonCommand && jsonCommand.hasOwnProperty("apiURL") ) {
			apiURL = jsonCommand["apiURL"];

			var apiPieces = apiURL.split(".");
			var curPackage = require('NGCore/Client/Social/_Internal/Privileged').Social;

			for ( var i = 0; i < apiPieces.length; i++ )
			{
				if(curPackage.hasOwnProperty(apiPieces[i])) {
					curPackage = curPackage[apiPieces[i]];
				}
				else {
					//Total Fail
					NgLogE("Cannot find namespace " + apiURL + " in GameService");
					curPackage = null;
					break;
				}
			}

			if(curPackage && typeof curPackage == "function" ) {			
				curPackage(jsonCommand);

				return; //done dispatching!
			}
		}
		else {
			NgLogE("Someone called GameService without the proper parameters.\n");
		}
	},
	setVerboseLogging:function(useVerbose)
	{
		RouterVerbose = useVerbose;
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/_Internal/GSCommand'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/_Internal/GSCommand'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/_Internal/GSCommand'] = exports; /**
 * GSCommand.js
 * GameService Command Helper
 *
 * @summary Converts hashes for sending across the interpreter bounds, specifically:
 *		- Takes a hash with a callbackFunc
 * 			- Takes callbackFunc and converts to callbackId
 *		- Takes a hash with a callbackId
 *			- Takes the callbackId and looks up a callbackFunc from the local cache
 */
 
var GameServiceCommandCallbackStore = {};
GameServiceCommandCallbackStore.uidGenerator = 0;

/* @private */
var storeCallbackIdForFunc = function(callbackFunc) {
	var uid = GameServiceCommandCallbackStore.uidGenerator++;
	GameServiceCommandCallbackStore[uid] = callbackFunc;
	return uid;
};
/* @private */
var extractFuncForCallbackId = function(callbackId) {
	if(GameServiceCommandCallbackStore.hasOwnProperty(callbackId)){
		var callbackFunc = GameServiceCommandCallbackStore[callbackId];
		delete GameServiceCommandCallbackStore[callbackId];
		return callbackFunc;
	}
	return null;
};

var blindConvert = function(hash) {
	if ( typeof hash == "object" ) {
		// Case we have a hash
		if ( hash.hasOwnProperty("callbackFunc") ) {
			//	with a callback func to convert
			hash["callbackId"] = storeCallbackIdForFunc(hash["callbackFunc"]);
			
			delete hash["callbackFunc"];
		}
		else if (hash.hasOwnProperty("callbackId")) {
			hash["callbackFunc"] = extractFuncForCallbackId(hash["callbackId"]);
			delete hash["callbackId"];
		}
		return hash;
	}
	
	NgLogD("Error: invalid or non-object passed to gsCmdConvert.");
	return null;
};
exports.makeSafe = function(hash) {
	if (hash && typeof hash == "object" && hash.hasOwnProperty("callbackFunc"))
	{
		return blindConvert(hash);
	}
	return hash;
};
exports.makeExecutable = function(hash) {
	if (hash && typeof hash == "object" && hash.hasOwnProperty("callbackId"))
	{
		return blindConvert(hash);
	}
	return hash;
};

; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/_Internal/Privileged'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/_Internal/Privileged'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/_Internal/Privileged'] = exports; /**
 * Privileged API for GameService (Public Stub)
 * 
 * Access this file as NGCore/Client/Social.js
 */
exports.Social = {
	// stubbed out for the SDK
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Models/OrderedList'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Models/OrderedList'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Models/OrderedList'] = exports; var Dispatcher = require('NGCore/Client/Social/US/Data/Dispatcher').Dispatcher;

/**
 * @class 
 * @name Social.US.OrderedList
 * @description
 * Do not instantiate <code>OrderedList</code> objects directly. This description is for information purposes only. 
 * <code>DataModel</code> subclasses that return <code>OrderedList</code> interfaces include:<br/><br/>
 * <div class="ul">
 * <li>{@link Social.US.User}</li>
 * <li>{@link Social.US.Leaderboard}</li>
 * </div><br/>
 * Some <code>DataModel</code> subclasses can return an <code>OrderedList</code>,
 * which is an interface for iterating over a range of values. You determine the iteration range by
 * selecting one of three common functions: <br/><br/>
 * <div class="ul">
 * <li><code>forAll(iterCb, doneCb):</code> Iterates over all values.</li>
 * <li><code>forRange(start, count, iterCb, doneCb):</code> Iterates from the starting index to the count.</li>
 * <li><code>forItem(index, iterCb, doneCb):</code> Iterates over a particular item given by its index.</li>
 * </div>
 * Each of the functions calls an iteration callback (iterCb) for every available item. 
 * When the function iterates over all items or an error occurs, it calls the done callback (doneCb). You <b>MUST</b> provide both callbacks.
 * <br/><br/>
 * <b>Note:</b> The <code>OrderedList</code> interface invokes an iterator on the server. Do NOT assume it will execute your callback functions immediately.
 *
 * @example
 * //NOTE: You MUST provide both callback functions.
 * userBuddiesList.forAll( 
 *      function(error, details){//per item cb body}, 
 *      function(error, details){//done cb body}
 * );
 *
 * @example
 * //Callback examples
 * var done = false;
 * var err = null;
 *
 * currentUser.getFriendsList().forAll(
 *          function(continueCb, user, index){
 *				if(user == otherUser){
 *					foundBuddy = true;
 *					continueCb(false);
 *				}else{
 *					continueCb(true);
 *				}
 *			}, 
 *          function(error){
 *                  if (!error){
 *                      done = true;
 *                   } else {
 *                      err = error;
 *                   }
 *          }
 * );
 * @status iOS, Android, Test, iOSTested, AndroidTested
 */
var OrderedList = {

    /**
    * Returns a public interface for an object.
    * 
    * To expose a privelegee ordered list of a <code>DataModel</code> object in the public interface, 
    * add a function to the object of the corresponding <code>DataModel</code>
    * subclass in the public interface.
    * @example
    * getFollowersList: function(cb){
 	* 	return OrderedList.getObjectPublicInterface(this, "getFollowersList", "_followersListInterface");
	* },
    *
    * @name Social.US.OrderedList.getObjectPublicInterface
    * @function    
    * @private
    *
    * @param {Object} ownerObject The object that will "own" the public interface.
    * @param {Function} getListFn The function that returns a list of values to the <code>OrderedList</code>.
    * @param interfaceName The name of the interface.
    *
    * @return {Social.US.OrderedList} The public interface.
    * @status iOS, Android, Test, iOSTested, AndroidTested
    */
    getObjectPublicInterface: function(ownerObject, getListFn, interfaceName) {
		if(ownerObject[interfaceName]) {
			return ownerObject[interfaceName];
		}
		
		var args = Array.apply(null, arguments);
		if(args && args.length > 3){
			args.splice(0, 3);
		}else{
			args = [];
		}
		
		var newInterface = {
			forAll: function(perItemCb, doneCb) {
				Dispatcher.callMethodOnRemoteObject(ownerObject, [getListFn, "forAll"], [args,[perItemCb, doneCb]]);		
			},
			forRange: function(start, count, perItemCb, doneCb) {
				Dispatcher.callMethodOnRemoteObject(ownerObject, [getListFn, "forRange"], [args,[start, count, perItemCb, doneCb]]);
			},
			forItem: function(index, perItemCb, doneCb) {
				Dispatcher.callMethodOnRemoteObject(ownerObject, [getListFn, "forItem"], [args,[index, perItemCb, doneCb]]);
			}
		};
		
		ownerObject[interfaceName] = newInterface;
		
		return newInterface;
	},

    /**
    * Returns a public interface for a class.
    * To expose a priveleged ordered list of a <code>DataModel</code> subclass in the public interface, 
    * add a function to the subclass of the corresponding <code>DataModel</code>
    * subclass in the public interface.
    * @example
    * getFollowersList: function(cb){
 	* 	return OrderedList.getClassPublicInterface(this, "getFollowersList", "_followersListInterface");
	* },    
    *
    * @name Social.US.OrderedList.getClassPublicInterface
    * @function
    * @private
    *
    * @param {Object} owner The owner of the the public interface.
    * @param {Function} getListFn The function to call on each iteration.
    * @param interfaceName The name of the interface.
    * 
    * @return {Social.US.OrderedList} The public interface.
    * @status iOS, Android, Test, iOSTested, AndroidTested
    */
    getClassPublicInterface: function(owner, getListFn, interfaceName) {
		if(owner[interfaceName]) {
			return owner[interfaceName];
		}
		
		var newInterface = {
			forAll: function(perItemCb, doneCb) {
				Dispatcher.callClassMethodOnRemoteObject(owner, [getListFn, "forAll"], [[],[perItemCb, doneCb]]);
			},
			forRange: function(start, count, perItemCb, doneCb) {
				Dispatcher.callClassMethodOnRemoteObject(owner, [getListFn, "forRange"], [[],[start, count, perItemCb, doneCb]]);
			},
			forItem: function(index, perItemCb, doneCb) {
				Dispatcher.callClassMethodOnRemoteObject(owner, [getListFn, "forItem"], [[],[index, perItemCb, doneCb]]);
			}
		};
		
		owner[interfaceName] = newInterface;
		
		return newInterface;
	}
};

exports.OrderedList = OrderedList;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/Color'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/Color'] || {}; $MODULE_REGISTRY['NGCore/Shared/Color'] = exports; var Class = require('NGCore/Shared/Class').Class;

exports.Color = Class.subclass(
/** @lends Core.Color.prototype */
{
	classname: 'Color',
	
	/**
	 * @class The <code>Color</code> class constructs objects that control the RGB components of a device. 
	 * RGB is a color model used for rendering objects on-screen and is derived 
	 * from the three primary colors used in the model: red, green, and blue.
	 * Each value ranges from <code>(0-1)</code> and determines the color saturation level.	 
	 * @constructs The default constructor.<br><br>
	 * <b>Example:</b> The following code examples illustrate different call styles for <code>Color</code> objects.<br><br>
	 * A new color with all components set to one (1 = white).
	 * <pre class="code">var style1 = new Core.Color();</pre>
	 *
	 * Copy an existing color.
	 * <pre class="code">var style2 = new Core.Color(style1);</pre>
	 *
	 * Specify all three components.
	 * <pre class="code">var style3 = new Core.Color(1.0, 1.0, 1.0);</pre>
	 *
	 * Specify the color as solid blue.
	 * <pre class="code">var style4 = new Core.Color([0, 0, 1.0]);</pre>
	 *
	 * Specify the color as solid red.
	 * <pre class="code">var style5 = new Core.Color([1.0, 0, 0]);</pre>
	 * 
	 * Specify the color as a dark shade of red.
	 * <pre class="code">var style6 = new Core.Color([.5, 0, 0]);'</pre>
	 * @augments Core.Class
	 * @param {Number} [red=1] The red component.
	 * @param {Number} [green=1] The green component.
	 * @param {Number} [blue=1] The blue component.
	 * @throws {Wrong number of arguments for a Color} Number of parameters passed by this call is invalid.
	 */
	initialize: function(red, green, blue)
	{
		switch(arguments.length)
		{
			case 0:
				// ()
				this._red = 1.0;
				this._green = 1.0;
				this._blue = 1.0;
				break;
			case 1:
				var rhs = arguments[0];
				if(rhs === undefined)
				{
					// (undefined)
					this._red = 1.0;
					this._green = 1.0;
					this._blue = 1.0;
				}
				else if(!rhs.hasOwnProperty('length'))
				{
					// (color)
					this._red = rhs.getRed();
					this._green = rhs.getGreen();
					this._blue = rhs.getBlue();
				}
				else
				{
					switch(rhs.length)
					{
						case 0:
							// ([])
							this._red = 1.0;
							this._green = 1.0;
							this._blue = 1.0;
							break;
						case 1:
							// ([color])
							rhs = rhs[0];
							this._red = rhs.getRed();
							this._green = rhs.getGreen();
							this._blue = rhs.getBlue();
							break;
						case 3:
							// ([red, green, blue])
							this._red = rhs[0];
							this._green = rhs[1];
							this._blue = rhs[2];
							break;
						default:
							throw new Error('Wrong number of arguments for a Color');
					}
				}
				break;
			case 3:
				// (red, gree, blue)
				this._red = arguments[0];
				this._green = arguments[1];
				this._blue = arguments[2];
				break;
			default:
				throw new Error('Wrong number of arguments for a Color');
		}
		return this;
	},
	
	/**
	 * Set the saturation level for all three color components.
	 * @example Core.Color.setAll(0.5, 0.5, 1.0);
	 * @param {Number} [red=1] The red component.
	 * @param {Number} [green=1] The green component.
	 * @param {Number} [blue=1] The blue component.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Color for a full list of supported calling styles.
	 */
	setAll: function(red, green, blue)
	{
		this.constructor.apply(this, arguments);
		return this;
	},
	
	/**
	 * Retrieve the saturation level for the red component of this <code>Color</code>.
	 * @returns {Number} The current saturation level for the red component.
	 */
	getRed: function()
	{
		return this._red;
	},
	
	/**
	 * Retrieve the saturation level for the green component of this <code>Color</code>.
	 * @returns {Number} The current saturation level for the green component.
	 */
	getGreen: function()
	{
		return this._green;
	},
	
	/**
	 * Retrieve the saturation level for the blue component of this <code>Color</code>.
	 * @returns {Number} The current saturation level for the blue component.
	 */
	getBlue: function()
	{
		return this._blue;
	},
	
	/**
	 * Set the saturation level for the red component of this <code>Color</code>.
	 * @example Core.Color.setRed(0.7);
	 * @param {Number} red The new saturation level for the red component.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Color#getRed
	 */
	setRed: function(red)
	{
		this._red = red;
		return this;
	},
	
	/**
	 * Set the saturation level for the green component of this <code>Color</code>.
	 * @example Core.Color.setGreen(0.3);
	 * @param {Number} green The new saturation level for the green component.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Color#getGreen
	 */
	setGreen: function(green)
	{
		this._green = green;
		return this;
	},
	
	/**
	 * Set the saturation level for the blue component of this <code>Color</code>.
	 * @example Core.Color.setBlue(1.0);
	 * @param {Number} blue The new saturation level for the blue component.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Color#getBlue
	 */
	setBlue: function(blue)
	{
		this._blue = blue;
		return this;
	},
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/Vector'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/Vector'] || {}; $MODULE_REGISTRY['NGCore/Shared/Vector'] = exports; var Class = require('NGCore/Shared/Class').Class;

exports.Vector = Class.subclass(
/** @lends Core.Vector.prototype */
{
	classname: 'Vector',
	
	/**
	 * @class The <code>Vector</code> class constructs objects that define vector point values for the <i>x</i> and <i>y</i> components. 
	 * Supported values range between <code>(0-1)</code>.
	 * @constructs The default constructor. <br><br>
	 * The following code examples illustrate a variety of different calling styles for <code>Vector</code> objects.<br><br>
	 * All components are set to zero.
	 * <pre class="code">var style1 = new Core.Vector();</pre>
	 *
	 * Copy an existing vector.
	 * <pre class="code">var style2 = new Core.Vector(style1);</pre>
	 *
	 * Specify a value for both components.
	 * <pre class="code">var style3 = new Core.Vector(1.0, 1.0);</pre>
	 *
	 * Specify a value for both components.
	 * <pre class="code">var style4 = new Core.Vector([1.0, 1.0]);</pre>
	 * @augments Core.Class
	 * @param {Number} [x=0] The <i>x</i> component.
	 * @param {Number} [y=0] The <i>y</i> component.
	 * @throws {Wrong number of arguments for a Vector} Number of parameters passed by this call is invalid.
	 * @status iOS, Android, Flash
	 */
	initialize: function()
	{
		switch(arguments.length)
		{
			case 0:
				// ()
				this._x = 0;
				this._y = 0;
				break;
			case 1:
				var rhs = arguments[0];
				if(rhs === undefined)
				{
					// (undefined)
					this._x = 0;
					this._y = 0;
				}
				else if(!rhs.hasOwnProperty('length'))
				{
					// (vector)
					this._x = rhs.getX();
					this._y = rhs.getY();
				}
				else
				{
					switch(rhs.length)
					{
						case 0:
							// ([])
							this._x = 0;
							this._y = 0;
							break;
						case 1:
							// ([vector])
							rhs = rhs[0];
							this._x = rhs.getX();
							this._y = rhs.getY();
							break;
						case 2:
							// ([x, y])
							this._x = rhs[0];
							this._y = rhs[1];
							break;
						default:
							throw new Error('Wrong number of arguments for a Vector');
					}
				}
				break;
			case 2:
				// (x, y)
				this._x = arguments[0];
				this._y = arguments[1];
				break;
			default:
				throw new Error('Wrong number of arguments for a Vector');
		}
	},
	
	/**
	 * Set the value of both components for this <code>Vector</code>. 
	 * @param {Number} [x=0] The new <i>x</i> coordinate.
	 * @param {Number} [y=0] The new <i>y</i> coordinate.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Vector for examples of supported calling styles.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setAll: function()
	{
		this.constructor.apply(this, arguments);
		return this;
	},
	
	/**
	 * Duplicate this <code>Vector</code>.
	 * @returns {Core.Vector} A new vector with identical coordinates to the duplicated vector.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	clone: function()
	{
		return new this.constructor(this);
	},
	
	/**
	 * Retrieve the value of the <i>x</i> component for this <code>Vector</code>.
	 * @returns {Number} The current <i>x</i> coordinate.
	 * @see Core.Vector#setX
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getX: function()
	{
		return this._x;
	},
	
	/**
	 * Set the value of the <i>x</i> component for this <code>Vector</code>.
	 * @param {Number} <i>x</i> The new <i>x</i> coordinate.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Vector#getX
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setX: function(x)
	{
		this._x = x;
		return this;
	},
	
	/**
	 * Retrieve the value of the <i>y</i> component for this <code>Vector</code>.
	 * @returns {Number} The current <i>y</i> coordinate.
	 * @see Core.Vector#setY
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getY: function()
	{
		return this._y;
	},
	
	/**
	 * Set the value of the <i>y</i> component for this <code>Vector</code>.
	 * @param {Number} <i>y</i> The new <i>y</i> coordinate.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Vector#getY
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setY: function(y)
	{
		this._y = y;
		return this;
	},
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/Point'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/Point'] || {}; $MODULE_REGISTRY['NGCore/Shared/Point'] = exports; var Class = require('NGCore/Shared/Class').Class;

exports.Point = Class.subclass(
/** @lends Core.Point.prototype */
{
	classname: 'Point',
	
	/**
	 * @class The <code>Point</code> class defines a 2D point coordinate (<i>x</i> and <i>y</i>). 
	 * @status iOS, Android, Flash, Test
	 * @constructs The default constructor. <br><br>
	 * <b>Example:</b>The following code examples illustrate a variety of different calling styles for <code>Point</code> objects.<br><br>
	 * All components are set to zero.
	 * <pre class="code">var style1 = new Core.Point();</pre>
	 *
	 * Copy an existing point.
	 * <pre class="code">var style2 = new Core.Point(style1);</pre>
	 *
	 * Specify a value for both components.
	 * <pre class="code">var style3 = new Core.Point(1.0, 1.0);</pre>
	 *
	 * Specify a value for both components.
	 * <pre class="code">var style4 = new Core.Point([1.0, 1.0]);</pre>
	 * @augments Core.Class
	 * @param {Number} [x=0] The <i>x</i> coordinate.
	 * @param {Number} [y=0] The <i>y</i> coordinate.
	 * @throws {Wrong number of arguments for a Point} Number of parameters passed by this call is invalid.
	 */
	initialize: function(x, y)
	{
		switch(arguments.length)
		{
			case 0:
				// ()
				this._x = 0;
				this._y = 0;
				break;
			case 1:
				var rhs = arguments[0];
				if(rhs === undefined)
				{
					// (undefined)
					this._x = 0;
					this._y = 0;
				}
				else if(!rhs.hasOwnProperty('length'))
				{
					// (point)
					this._x = rhs.getX();
					this._y = rhs.getY();
				}
				else
				{
					switch(rhs.length)
					{
						case 0:
							// ([])
							this._x = 0;
							this._y = 0;
							break;
						case 1:
							// ([point])
							rhs = rhs[0];
							this._x = rhs.getX();
							this._y = rhs.getY();
							break;
						case 2:
							// ([x, y])
							this._x = rhs[0];
							this._y = rhs[1];
							break;
						default:
							throw new Error('Wrong number of arguments for a Point');
					}
				}
				break;
			case 2:
				// (x, y)
				this._x = arguments[0];
				this._y = arguments[1];
				break;
			default:
				throw new Error('Wrong number of arguments for a Point');
		}
	},
	
	/**
	 * Set the value of both the <i>x</i> and <i>y</i> components. 
	 * @param {Number} [<i>x</i>=0] The new <i>x</i> coordinate.
	 * @param {Number} [<i>y</i>=0] The new <i>y</i> coordinate.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Point for examples of supported calling styles.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setAll: function(x, y)
	{
		this.constructor.apply(this, arguments);
		return this;
	},
	
	/**
	 * Duplicate this <code>Point</code>.
	 * @returns {Core.Point} A new point with identical <i>x</i> and <i>y</i> coordinates to the cloned point.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	clone: function()
	{
		return new this.constructor(this);
	},
	
	/**
	 * Retrieve the value of the <i>x</i> component of this <code>Point</code>.
	 * @returns {Number} The current <i>x</i> coordinate.
	 * @see Core.Point#setX
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getX: function()
	{
		return this._x;
	},
	
	/**
	 * Set the value of the <i>x</i> component for this <code>Point</code>.
	 * @param {Number} <i>x</i> The new <i>x</i> coordinate.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Point#getX
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setX: function(x)
	{
		this._x = x;
		return this;
	},
	
	/**
	 * Retrieve the value of the <i>y</i> component of this <code>Point</code>.
	 * @returns {Number} The current <i>y</i> coordinate.
	 * @see Core.Point#setY
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getY: function()
	{
		return this._y;
	},
	
	/**
	 * Set the value of the <i>y</i> component for this <code>Point</code>.
	 * @param {Number} <i>y</i> The new <i>y</i> coordinate.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Point#getY
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setY: function(y)
	{
		this._y = y;
		return this;
	},
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/Size'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/Size'] || {}; $MODULE_REGISTRY['NGCore/Shared/Size'] = exports; var Class = require('NGCore/Shared/Class').Class;

exports.Size = Class.subclass(
/** @lends Core.Size.prototype */
{
	classname: 'Size',
	
	/**
	 * @class The <code>Size</code> class constructs objects that define size values for the <i>height</i> and <i>width</i> components. 
	 * @status iOS, Android, Flash
	 * Supported values range between <code>(0-1)</code>.
	 * @constructs The default constructor. <br><br>
	 * The following code examples illustrate a variety of different calling styles for <code>Size</code> objects.<br><br>
	 * Set both component values to 0.
	 * <pre class="code">var style1 = new Core.Size();</pre>
	 *
	 * Copy an existing size.
	 * <pre class="code">var style2 = new Core.Size(style1);</pre>
	 *
	 * Specify a value for both components.
	 * <pre class="code">var style3 = new Core.Size(1.0, 1.0);</pre>
	 *
	 * Specify a value for both components.
	 * <pre class="code">var style4 = new Core.Size([1.0, 1.0]);</pre>
	 * @augments Core.Class
	 * @param {Number} [width=0] The <i>width</i> component.
	 * @param {Number} [height=0] The <i>height</i> component.
	 */
	initialize: function(width, height)
	{
		switch(arguments.length)
		{
			case 0:
				// ()
				this._width = 0;
				this._height = 0;
				break;
			case 1:
				var rhs = arguments[0];
				if(rhs === undefined)
				{
					// (undefined)
					this._width = 0;
					this._height = 0;
				}
				else if(!rhs.hasOwnProperty('length'))
				{
					// (size)
					this._width = rhs.getWidth();
					this._height = rhs.getHeight();
				}
				else
				{
					switch(rhs.length)
					{
						case 0:
							// ([])
							this._width = 0;
							this._height = 0;
							break;
						case 1:
							// ([size])
							rhs = rhs[0];
							this._width = rhs.getWidth();
							this._height = rhs.getHeight();
							break;
						case 2:
							// ([x, y])
							this._width = rhs[0];
							this._height = rhs[1];
							break;
						default:
							throw new Error('Wrong number of arguments for a Size');
					}
				}
				break;
			case 2:
				// (x, y)
				this._width = arguments[0];
				this._height = arguments[1];
				break;
			default:
				throw new Error('Wrong number of arguments for a Size');
		}
	},
	
	/**
	 * Set the value of all components for this <code>Size</code>. 
	 * @param {Number} [width=0] The new <i>width</i>.
	 * @param {Number} [height=0] The new <i>height</i>.
	 * @throws {Wrong number of arguments for a Size} Number of parameters passed by this call is invalid.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Size for examples of supported calling styles.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setAll: function(width, height)
	{
		this.constructor.apply(this, arguments);
		return this;
	},
	
	/**
	 * Duplicate this <code>Size</code>.
	 * @returns {Core.Size} A new size with identical <i>height</i> and <i>width</i> components.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	clone: function()
	{
		return new this.constructor(this);
	},
	
	/**
	 * Retrieve the value of the <i>width</i> component for this <code>Size</code>.
	 * @returns {Number} The current <i>width</i>.
	 * @see Core.Size#setWidth
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getWidth: function()
	{
		return this._width;
	},
	
	/**
	 * Set the value of the <i>width</i> component for this <code>Size</code>.
	 * @param {Number} width The new <i>width</i>.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Size#getWidth
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setWidth: function(width)
	{
		this._width = width;
		return this;
	},
	
	/**
	 * Retrieve the value of the <i>height</i> component for this <code>Size</code>.
	 * @returns {Number} The current <i>height</i>.
	 * @see Core.Size#setHeight
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getHeight: function()
	{
		return this._height;
	},
	
	/**
	 * Set the value of the <i>height</i> component for this <code>Size</code>.
	 * @param {Number} height The new <i>height</i>.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Size#getHeight
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setHeight: function(height)
	{
		this._height = height;
		return this;
	},
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/Rect'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/Rect'] || {}; $MODULE_REGISTRY['NGCore/Shared/Rect'] = exports; var Class = require('NGCore/Shared/Class').Class;
var Point = require('NGCore/Shared/Point').Point;
var Size = require('NGCore/Shared/Size').Size;

exports.Rect = Class.subclass(
/** @lends Core.Rect.prototype */
{
	classname: 'Rect',
	
	/**
	 * @class The <code>Rect</code> class constructs a rectangle object that is derived from two values: a point of origin  
	 * and a size.	 
	 * @status iOS, Android, Flash
	 * @constructs The default constructor. <br><br>
	 * The following code examples illustrate a variety of different calling styles for <code>Rect</code> objects.<br><br>
	 * All components set to zero.
	 * <pre class="code">var style1 = new Core.Rect();</pre>
	 *
	 * Copy an existing <code>rect</code>.
	 * <pre class="code">var style2 = new Core.Rect(style1);</pre>
	 *
	 * Specify a point and size.
	 * <pre class="code">var style3 = new Core.Rect(new Core.Point(), new Core.Size());</pre>
	 *
	 * Specify four components.
	 * <pre class="code">var style4 = new Core.Rect(0, 0, 100, 100);</pre>
	 * @augments Core.Class
	 * @param {Core.Point} [origin=0] The rectangle point of origin.
	 * @param {Core.Size} [size=0] The rectangle size.
	 * @throws {Wrong number of arguments for a Rect} Number of parameters passed by this call is invalid.
	 */
	initialize: function(origin, size)
	{
		switch(arguments.length)
		{
			case 0:
				// ()
				this._origin = new Point();
				this._size = new Size();
				break;
			case 1:
				var rhs = arguments[0];
				if(rhs === undefined)
				{
					// (undefined)
					this._origin = new Point();
					this._size = new Size();
				}
				else if(!rhs.hasOwnProperty('length'))
				{
					// (rect)
					this._origin = new Point(rhs.getOrigin());
					this._size = new Size(rhs.getSize());
				}
				else
				{
					switch(rhs.length)
					{
						case 0:
							// ([])
							this._origin = new Point();
							this._size = new Size();
							break;
						case 1:
							// ([rect])
							rhs = rhs[0];
							this._origin = new Point(rhs.getOrigin());
							this._size = new Size(rhs.getSize());
							break;
						case 2:
							// ([point, size])
							// ([[x, y], [width, height]])
							this._origin = new Point(rhs[0]);
							this._size = new Size(rhs[1]);
							break;
						case 4:
							// ([x, y, width, height])
							this._origin = new Point(rhs[0], rhs[1]);
							this._size = new Size(rhs[2], rhs[3]);
							break;
						default:
							throw new Error('Wrong number of arguments for a Rect');
					}
				}
				break;
			case 2:
				// (point, size)
				this._origin = new Point(arguments[0]);
				this._size = new Size(arguments[1]);
				break;
			case 4:
				// (x, y, width, height)
				this._origin = new Point(arguments[0], arguments[1]);
				this._size = new Size(arguments[2], arguments[3]);
				break;
			default:
				throw new Error('Wrong number of arguments for a Rect');
		}
	},
	
	/**
	 * Set the value of all components for this <code>rect</code>. 
	 * @param {Core.Point} [origin=0] The new point of origin.
	 * @param {Core.Size} [size=0] The new rectangle size.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Rect for examples of supported calling styles.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setAll: function(origin, size)
	{
		this.constructor.apply(this, arguments);
		return this;
	},
	
	/**
	 * Duplicate the point of origin of this <code>rect</code>.
	 * @returns {Core.Point} A new rectangle with an identical origin and size.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	clone: function()
	{
		return new this.constructor(this);
	},
	
	/**
	 * Retrieve the point of origin for this <code>rect</code>.
	 * @returns {Core.Point} The current point of origin.
	 * @see Core.Rect#setOrigin
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getOrigin: function()
	{
		return this._origin;
	},
	
	/**
	 * Set the point of origin for this <code>rect</code>.
	 * @param {Core.Point} origin The new point of origin.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Rect#getOrigin
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setOrigin: function(origin)
	{
		this._origin.setAll(origin);
		return this;
	},
	
	/**
	 * Change the point of origin so that the center of this <code>rect</code> is at the specified location.
	 * @param {Core.Point} origin The new point of origin that results in a rectangle with a center position at the specified location.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Rect#setSizeCentered,
	 * @see Core.Rect#setOrigin
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setOriginCentered: function(origin)
	{
		origin = new Core.Point(origin);
		this._origin.setX(origin.getX() - this._size.getWidth()/2);
		this._origin.setY(origin.getY() - this._size.getHeight()/2);
		return this;
	},
	
	/**
	 * Retrieve the size of this <code>rect</code>.
	 * @returns {Core.Size} The current rectangle size.
	 * @see Core.Rect#setSize
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getSize: function()
	{
		return this._size;
	},
	
	/**
	 * Set the size of this <code>rect</code>.
	 * @param {Core.Size} size The new rectangle size.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Rect#getSize
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setSize: function(size)
	{
		this._size.setAll(size);
		return this;
	},
	
	/**
	 * Set the size of this <code>rect</code> and preserve the current center position.
	 * @param {Core.Size} size The new rectangle size that retains the current center position.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Rect#setOriginCentered,
	 * @see Core.Rect#setSize
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setSizeCentered: function(size)
	{
		var oldWidth = this._size.getWidth();
		var oldHeight = this._size.getHeight();
		
		this._size.setAll(size);

		this._origin.setX(this._origin.getX() + oldWidth/2 - this._size.getWidth()/2);
		this._origin.setY(this._origin.getY() + oldHeight/2 - this._size.getHeight()/2);
		return this;
	},
	
	/**
	 * Retrieve the minimum value for <i>x</i>. This is represented by the left coordinate.
	 * @returns {Number} The current minimum value of  the <i>x</i> coordinate.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getMinX: function()
	{
		return this._origin.getX();
	},
	
	/**
	 * Retrieve the average of the minimum and maximum <i>x</i> values. This is the middle coordinate.
	 * @returns {Number} The current average of the minimum and maximum <i>x</i> coordinate values. 
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getMidX: function()
	{
		return this._origin.getX() +  this._size.getWidth()/2;
	},
	
	/**
	 * Retrieve the maximum value for <i>x</i>. This is the right coordinate.
	 * @returns {Number} The current maximum value of the <i>x</i> coordinate.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getMaxX: function()
	{
		return this._origin.getX() + this._size.getWidth();
	},
	
	/**
	 * Retrieve the minimum value for <i>y</i>. This is the top coordinate.
	 * @returns {Number} The current minimum value of the <i>y</i> coordinate.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getMinY: function()
	{
		return this._origin.getY();
	},
	
	/**
	 * Retrieve the average of the minimum and maximum <i>y</i> values. This is the middle coordinate.
	 * @returns {Number} The current average of the minimum and maximum <i>y</i> coordinate values.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getMidY: function()
	{
		return this._origin.getY() + this._size.getHeight()/2;
	},
	
	/**
	 * Retrieve the maximum value for <i>y</i>. This is the bottom coordinate.
	 * @returns {Number} The current maximum value of the <i>y</i> coordinate.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getMaxY: function()
	{
		return this._origin.getY() + this._size.getHeight();
	},
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/AbstractView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/AbstractView'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/AbstractView'] = exports; var Element = require('NGCore/Client/UI/Element').Element;
var Commands = require('NGCore/Client/UI/Commands').Commands;
var Rect = require('NGCore/Client/UI/ViewGeometry').Rect;

var AbstractView = exports.AbstractView = Element.subclass(
/** @lends UI.AbstractView.prototype */
{
	'type':'<com.ngmoco.view.abstract>',
	/**
	* @class The <code>AbstractView</code> class is a base class for derived classes that handle and manage application views.<br><br>
	* <b>Caution!:</b> This base class is not exported in the UI module. Do not access it or subclass it at runtime. 
	* Derived classes from <code>AbstractView</code> include:
	* <div class="ul">
	 * <li>{@link UI.Button}</li>
	 * <li>{@link UI.CellView}</li>
	 * <li>{@link UI.CheckBox}</li>
	 * <li>{@link UI.CheckoutView}</li>
	 * <li>{@link UI.DocumentView}</li>
	 * <li>{@link UI.EditText}</li>
	 * <li>{@link UI.GLView}</li>
	 * <li>{@link UI.Image}</li>
	 * <li>{@link UI.Label}</li>
	 * <li>{@link UI.Spinner}</li>
	 * <li>{@link UI.View}</li>
	 * <li>{@link UI.WebView}</li>
	 * </div>
	* @constructs The default constructor.
	* @augments UI.Element
	* @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	* @param {String} properties Object properties.
	*/
	initialize: function($super, properties) {
		if (AbstractView._init) AbstractView._init();
		
		this._assignedVisible = true;
		$super(properties);
	},
	
	/** @private */
	destroy: function($super){
		this.removeFromParent();
		$super();
	},
	
	/**
	 * @function 
	 * @description Retrieve the parent node for this view.
	 * @returns Returns the parent if this view is a child of another element. Otherwise, returns undefined.
	 * @see UI.AbstractView#addToParent,
	 * @see UI.AbstractView#removeFromParent
	 */    
	getParent: function(){
		return this._parent;
	},
    
	/**
	 * Add a node at the specified index to the specified parent node.
	 * @example var myParent = new UI.View({
	 * 	...
	 * });
	 * var childNode = new UI.View({
	 *	...
	 * });
	 * ...
	 * childNode.addToParent(myParent); 
	 * @function
	 * @param {Object} parentNode The parent node.
	 * @param {Number} [index] The parent node index location.
	 * @see UI.AbstractView#getParent,
	 * @see UI.AbstractView#removeFromParent
	 */    
	addToParent: function(parentNode, index){
		parentNode.addChild(this, index);
	},
    
	/**
	 * Remove a node from the parent node.
	 * @example childNode.removeFromParent(myParent);
	 * @function 
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see UI.AbstractView#getParent,
	 * @see UI.AbstractView#addToParent
	 */    
	removeFromParent: function(){
		if (this._parent && !this._parent._destroyed) {
			this._parent.removeChild(this);
			this._parent = null;
		}
		return this;
	},
	
	
	/**
	 * Add a new view state.
	 * @function 
	 * @example this.addState(UI.State.Disabled);
	 * @param {UI.State} flags View state flags supported by the new view state.
	 * @see UI.AbstractView#getState,
	 * @see UI.AbstractView#setState,
	 * @see UI.AbstractView#clearState
	 */  
	addState: function(flags) {
		this.setState(this._state | flags);
	},
	
	/**
	 * Clear the view state and set view state flags to the default value.
	 * @function 
	 * @example this.clearState(UI.State.Disabled);
	 * @param {UI.State} flags
	 * @see UI.AbstractView#getState,
	 * @see UI.AbstractView#setState,
	 * @see UI.AbstractView#addState
	 */  
	clearState: function(flags) {
		this.setState(this._state & ~flags);
	},
    
	/**
	 * Retrieve the root node for this object.
	 * @function 
	 * @returns Returns the root node if this is a child node. Otherwise, returns undefined.
	 */
	getRoot: function() {
		return this._parent ? this._parent.getRoot() : undefined;
	},
    

	/** @protected */
	_setVisible: function(makeVisible) {
		var willBeVisible = makeVisible && this._assignedVisible && this._parent && this._parent._visible;
		if (this._visible != willBeVisible) {
			this._visible = willBeVisible;
			var fn = (makeVisible ? this.getOnAppear() : this.getOnDisappear());
			if (typeof fn == 'function') fn.call(this);
		}
	}
});

// Properties
AbstractView._init = function() {
	delete AbstractView._init;
	if (Element._init) Element._init();
	
	var getVisible = function() {
		return this._visible;
	};
	var setVisible = function(makeVisible) {
		this._assignedVisible = makeVisible;
		Commands.setIsVisible.call(this, makeVisible);
		this._setVisible(makeVisible);
	};
	/**
	 * @name UI.AbstractView#setVisible
	 * @description Set the visibility for this object.
	 * @example SomeView = new UI.View();
	 * ...
	 * SomeView.setVisible(true);
	 * @function 
	 * @param {boolean} makeVisible Set as <code>true</code> if this object is visible.
	 * @see UI.AbstractView#getVisible
	 */
	/**
	 * @name UI.AbstractView#getVisible
	 * @description Retrieve the state of visibility for this object.
	 * @function
	 * @returns {boolean} Returns <code>true</code> if this object is visible.
	 * @see UI.AbstractView#setVisible
	 */
	AbstractView.registerAccessors('visible', getVisible, setVisible);
	
	/**
	 * @name UI.AbstractView#setBackgroundColor
	 * @description Set the value for the <code>backgroundColor</code> property. This property defines the color of the background for an object when rendered.
	 * @example SomeView = new UI.View();
	 * ...
	 * SomeView.setBackgroundColor("FF000000");
	 * @param {String} backgroundColor The new background color.
	 * @see UI.AbstractView#getBackgroundColor
	 * @type Color
	 * @function
	 */
	/**
	 * @name UI.AbstractView#getBackgroundColor
	 * @description Retrieve the value of the <code>backgroundColor</code> property.
	 * @returns {String} The current background color.
	 * @see UI.AbstractView#setBackgroundColor
	 * @function
	 */
	AbstractView.synthesizeProperty('backgroundColor', Commands.setBackgroundColor);
	/**
	 * @name UI.AbstractView#setEnabled
	 * @description Set the value for the <code>enabled</code> property. This property defines an object as active or inactive.
	 * @param {Boolean} enabled Set as <code>true</code> if this view state is enabled.
	 * @see UI.AbstractView#getEnabled
	 * @function
	 */
	/**
	 * @name UI.AbstractView#getEnabled
	 * @description Retrieve the value of the <code>enabled</code> property. 
	 * @returns {Boolean} Returns <code>true</code> if this view state is enabled.
	 * @see UI.AbstractView#setEnabled
	 * @function
	 */
	
	AbstractView.synthesizeProperty('enabled', function(enable) {
		this[ (enable ? 'clearState' : 'setState') ](Commands.State.Disabled);
	});
	/**
	 * @name UI.AbstractView#setState
	 * @description Set the value for the <code>state</code> property. This property defines the view state for an object.
	 * @example cellView.setState(UI.State.Normal);
	 * @param {Number} state The new view state.
	 * @see UI.AbstractView#getState
	 * @type State
	 * @function
	 */
	/**
	 * @name UI.AbstractView#getState
	 * @description Retrieve the value of the <code>state</code> property.
	 * @returns {Number} The current view state.
	 * @see UI.AbstractView#setState
	 * @function
	 */
	AbstractView.synthesizeProperty('state', Commands.setState);

	
	/**
	 * @name UI.AbstractView#getFrame
	 * @description Retrieve the value of the <code>frame</code> property.
	 * @param {Number, Array (Number)} frame Individual components or a component array (<i>x</i>,<i>y</i>,<i>w</i>,<i>h</i>).
	 * @see UI.AbstractView#setFrame
	 * @function
	 */
	var getFrame = function() {
		return this._frame;
	};
	/**
	 * @name UI.AbstractView#setFrame
	 * @function 
	 * @description Set the value of the <code>frame</code> property. This property defines the size of <code>frame</code> objects.
	 * @example var back = new UI.Button();
	 * ...
	 * back.setFrame([10, 10, 64, 64]);
	 * @param {Number, Array (Number), Object} arg0 This parameter will pass in values in one of three ways:
	 * <div class="ul">
	 * <li>Four float values (<i>x</i>, <i>y</i>, <i>w</i>, <i>h</i>).</li>
	 * <li>Single array containing the above four values.</li>
	 * <li>A rect specifying the frame (see <code>{@link UI.ViewGeometry.Rect}</code>).</li>
	 * </div>
	 * @see UI.AbstractView#getFrame
	 * @function
	 */
	var setFrame = function(arg0) {
		if( arg0 instanceof Rect ){
			this._frame = arg0.array();
		}
		else if( arg0 instanceof Array ){
			this._frame = arg0;
		}
		else {
			this._frame = Array.prototype.slice.call(arguments);
		}
		Commands.setFrame.apply(this, this._frame);
	};
	AbstractView.registerAccessors('frame', getFrame, setFrame);

	/**
	 * @name UI.AbstractView#setGradient
	 * @description Set the value of the <code>gradient</code> property for a view state. This property defines an image gradient for the object when rendered.
	 * @example label.setGradient({
	 *	corners: '11 11 11 11',
	 *	gradient: ['FFFF8000 0.0', 'FF703300 1.0']
	 * }, UI.State.Selected);
	 * @param {Object} gradient The new gradient. 
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.AbstractView#getGradient
	 * @function
	 */
	/**
	 * @name UI.AbstractView#getGradient
	 * @description Retrieve the value of the <code>gradient</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {Object} The current gradient.
	 * @see UI.AbstractView#setGradient
	 * @function	
	 */
	AbstractView.synthesizePropertyWithState('gradient', Commands.setGradient);	
	/**
	 * @name UI.AbstractView#setBlockTouchEvents
	 * @description Set the value of the <code>blockTouchEvents</code> property.
	 * @param {Object} blockTouchEvents The new value for <code>blockTouchEvents</code>.
	 * @see UI.View#getBlockTouchEvents
	 * @function
	 */
	/**
	 * @name UI.AbstractView#getBlockTouchEvents
	 * @description Retrieve the value of the <code>blockTouchEvents</code> property.
	 * @returns {Object} The current value of <code>blockTouchEvents</code>.
	 * @see UI.View#setBlockTouchEvents
	 * @function
	 */
	AbstractView.synthesizeProperty('touchable', Commands.setTouchable);
	/**
	 * @name UI.AbstractView#setAlpha
	 * @function
	 * @description Set the value of the <code>alpha</code> property. This property defines the level of alpha composting for a specified object when rendered.
	 * @example this._node.setAlpha(1);
	 * @param {Number} decimal Alpha value ranging between <code>(0.0-1.0)</code>.
	 * @see UI.AbstractView#getAlpha
	 * @type Float
	 * @status iOS
	 */
	/**
	 * @name UI.AbstractView#getAlpha
	 * @function
	 * @description Retrieve the value of the <code>alpha</code> property.
	 * @returns {Number} Alpha value ranging between </code>(0.0-1.0)</code>.
	 * @see UI.AbstractView#setAlpha
	 * @type Float
	 * @status
	 */
	AbstractView.synthesizeProperty('alpha', Commands.setAlpha);




	// Event Handlers
	/**
	 * @name UI.AbstractView#setOnAppear
	 * @description Set a function to call when the <code>appear</code> event occurs.
	 * @param {Function} appearCallback The new callback function. <br><br><b>Note:</b> The <code>appear</code> event is disabled 
	 * if the value of this parameter is not a function.
	 * @example function() { 
	 *	onAppear.appear = true; 
	 * };
	 * @see UI.AbstractView#event:getOnAppear
	 * @event
	 */
	/**
	 * @name UI.AbstractView#getOnAppear
	 * @description Retrieve the function to call when the <code>appear</code> event occurs.
	 * @returns {Function} The current callback function.
	 * @see UI.AbstractView#event:setOnAppear
	 * @event
	 */
	AbstractView.registerEventType('appear');
	/**
	 * @name UI.AbstractView#setOnDisappear
	 * @description Set a function to call when the <code>disappear</code> event occurs.
	 * @param {Function} disappearCallback The new callback function. <br><br><b>Note:</b> The <code>disappear</code> event is disabled 
	 * if the value of this parameter is not a function.
	 * @example function() { 
	 *	onDisappear.disappear = true; 
	 * };
	 * @see UI.AbstractView#event:getOnDisappear
	 * @event
	 */
	/**
	 * @name UI.AbstractView#getOnDisappear
	 * @description Retrieve a function to call when the <code>disappear</code> event occurs.
	 * @returns {Function} The current callback function.
	 * @see UI.AbstractView#event:setOnDisappear
	 * @event
	 */
	AbstractView.registerEventType('disappear');
	/**
	 * @name UI.AbstractView#setOnClick
	 * @description Set a function to call when the <code>click</code> event occurs.
	 * @param {Function} clickCallback The new callback function. <br><br><b>Note:</b> The <code>click</code> event is disabled 
	 * if the value of this parameter is not a function.
	 * @example function() { 
	 *	onClick.clicked = true; 
	 * };
	 * @see UI.AbstractView#event:getOnClick
	 * @event
	 */
	/**
	 * @name UI.AbstractView#getOnClick
	 * @description Retrieve a function to call when the <code>click</code> event occurs.
	 * @returns {Function} The current callback function.
	 * @see UI.AbstractView#event:setOnClick
	 * @event
	 */
	AbstractView.registerEventType('click');
	/**
	 * @name UI.AbstractView#setOnSwipe
	 * @description Set a function to call when a <code>swipe</code> event occurs. 
	 * This is when the user swipes a finger across this view, similar to how a user indicatea a "delete row"
	 * request on a table view.  The function gets the <code>UI.Commands.SwipeDirection</code> from 
	 * the first <code>parameter.direction</code>.  
	 * @example
	 * view.setOnSwipe( function(params) { 
	 *	NgLogD("swipe code "+params.direction) 
	 *   } 
	 * );
	 * @param {Function} clickCallback The new callback function. <br><br><b>Note:</b> The <code>swipe</code> event is disabled 
	 * if the value of this parameter is not a function.
	 * @see UI.AbstractView#event:getOnSwipe
	 * @event
	 */
	/**
	 * @name UI.AbstractView#getOnSwipe
	 * @description Retrieve a function to call when the <code>swipe</code> event occurs.
	 * @returns {Function} The current callback function.
	 * @see UI.AbstractView#event:setOnSwipe
	 * @event
	 */
	AbstractView.registerEventType('swipe');
	/**
	 * @name UI.AbstractView#setOnLongPress
	 * @description Set a function to call when a user taps and holds on a view. 
	 * @param {Function} clickCallback The new callback function. <br><br><b>Note:</b> The event is disabled 
	 * if the value of this parameter is not a function.
	 * @example function() { 
	 *	onLongPress.longpress = true; 
	 * };
	 * @see UI.AbstractView#event:getOnLongPress
	 * @event
	 */
	/**
	 * @name UI.AbstractView#getOnLongPress
	 * @description Retrieve a function to call when a <code>tap and hold</code> event occurs.
	 * @returns {Function} The current callback function.
	 * @see UI.AbstractView#event:setOnLongPress
	 * @event
	 */
	AbstractView.registerEventType('longPress');

	/** @private NOT IMPLEMENTED */
	/*
		AbstractView.registerEventType('touchdown');
		AbstractView.registerEventType('touchup');
		AbstractView.registerEventType('touchmove');
		AbstractView.registerEventType('touchcancel');
	*/
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/WindowLayer'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/WindowLayer'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/WindowLayer'] = exports; var Element = require('NGCore/Client/UI/Element').Element;
var ViewParent = require('NGCore/Client/UI/ViewParent').ViewParent;
var Commands = require('NGCore/Client/UI/Commands').Commands;

/** @private
 * 	This ENTIRE CLASS is private.
 */
var WindowLayer = exports.WindowLayer = Element.subclass( {
	'type':'windowlayer',
	initialize: function($super, props) {
		if (WindowLayer.init) WindowLayer.init();
		$super(props);
		if (WindowLayer._init) WindowLayer._init();
		ViewParent.initialize.call(this);
		this._visible = true;
	},
	getRoot: function(){
		return this;
	},
	getParent: function(){
		return undefined;
	},
	
	getChildCount: ViewParent.getChildCount,
	getChildren: ViewParent.getChildren,
	addChild: ViewParent.addChild,
	removeChild: ViewParent.removeChild
});

WindowLayer.init = function() {
	delete WindowLayer._init;
	if (Element._init) Element._init();
	
	WindowLayer.synthesizeProperty('level', Commands.setIntValue);
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/ViewParent'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/ViewParent'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/ViewParent'] = exports; var Commands = require('NGCore/Client/UI/Commands').Commands;
var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;

// CAREFUL! THIS IS NOT A CLASS!
exports.ViewParent = {
	initialize : function() {
		this._children = [];
	},

	getChildCount : function() {
		return this._children.length;
	},

	getChildren : function() {
		return this._children.slice();
	},

	addChild : function(childNode,index) {
		if (childNode === this) throw new Error("Cannot add " + childNode + " as a child of itself!");
		if (childNode instanceof AbstractView) {
			if (childNode._parent) childNode.removeFromParent();

			if (index === 0 || index > 0) {
				index = +index;
				this._children.splice(index, 0, childNode);
			} else {
				index = -1;
				this._children.push(childNode);
			}

			// Must populate parent before setting visibility
			childNode._parent = this;
			childNode._setVisible(this._visible);

			Commands.addSubview.call(this, childNode.__objectRegistryId, index);

		} else throw new Error(this.type + ".addChild: " + childNode + " is not a view!");
		return this;
	},

	removeChild : function(childNode) {
		if (childNode instanceof AbstractView) {
			if (childNode._parent == this) {
				childNode._setVisible(false);

				// Remove this node from parent's child list
				var nodeIndex = this._children.indexOf(childNode);
				if (nodeIndex != -1) {
					this._children.splice(nodeIndex, 1);
				}
			}
			// Clear parent value
			childNode._parent = undefined;

			// Remove from the parent at the system level
			Commands.removeFromSuperview.call(childNode);
		} else throw {message: this.type + ".removeChild: " + childNode + " is not a view!"};
		return childNode;
	}

};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/GL2'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/GL2'] || {}; $MODULE_REGISTRY['NGCore/Client/GL2'] = exports; /**
 * <p>Classes and objects contained by the GL2 module.</p>
 * @name GL2
 * @namespace
 * @description <p>The GL2 module is a collection of classes that support manipulation of visual effects and frameworks in an application.
 * Each class handles a specific aspect of the module implementation and contains APIs that support the class:</p>
 * <ul>
 * <li><code>{@link GL2.Animation}</code>: Control animations in applications.</li>
 * <li><code>{@link GL2.Node}</code>: Control positionable screen elements.</li>
 * <li><code>{@link GL2.Primitive}</code>: Control the drawing of arbitrary vertex-based geometry.</li>
 * <li><code>{@link GL2.Root}</code>: A singleton that acts as a proxy object for the GLView node hierarchy 
 * (<code>Root</code> is the root element of the node hierarchy for GL2View).</li>
 * <li><code>{@link GL2.Sprite}</code>: Control resources for and use of application sprites.</li>
 * <li><code>{@link GL2.Text}</code>: Control resources for and use of application text.</li>
 * <li><code>{@link GL2.Touch}</code>: Control objects that track touch events for a device.</li>
 * <li><code>{@link GL2.TouchTarget}</code>: Control objects that support physical touch events on a device.</li>
 * <li><code>{@link GL2.RenderTarget}</code>: Render GL2 Nodes into a texture, which can then be attached to a GL.Animation</li>
 * </ul>
 * Games must instantiate a {@link UI.GLView} object, set the active state to <code>true</code> and wait for the callback before instantiating any objects in the GL2 class.
 */
exports.GL2 = {};

exports.GL2.__defineGetter__("Animation", function() {
	delete this.Animation;
	return this.Animation = require('NGCore/Client/GL2/Animation').Animation;
});
exports.GL2.__defineGetter__("Node", function() {
	delete this.Node;
	return this.Node = require('NGCore/Client/GL2/Node').Node;
});
exports.GL2.__defineGetter__("Primitive", function() {
	delete this.Primitive;
	return this.Primitive = require('NGCore/Client/GL2/Primitive').Primitive;
});
exports.GL2.__defineGetter__("Touch", function() {
	delete this.Touch;
	return this.Touch = require('NGCore/Client/GL2/Touch').Touch;
});
exports.GL2.__defineGetter__("TouchTarget", function() {
	delete this.TouchTarget;
	return this.TouchTarget = require('NGCore/Client/GL2/TouchTarget').TouchTarget;
});
exports.GL2.__defineGetter__("Root", function() {
	delete this.Root;
	return this.Root = require('NGCore/Client/GL2/Root').Root;
});
exports.GL2.__defineGetter__("Sprite", function() {
	delete this.Sprite;
	return this.Sprite = require('NGCore/Client/GL2/Sprite').Sprite;
});
exports.GL2.__defineGetter__("Text", function() {
	delete this.Text;
	return this.Text = require('NGCore/Client/GL2/Text').Text;
});
exports.GL2.__defineGetter__("RenderTarget", function() {
	delete this.RenderTarget;
	return this.RenderTarget = require('NGCore/Client/GL2/RenderTarget').RenderTarget;
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Audio'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Audio'] || {}; $MODULE_REGISTRY['NGCore/Client/Audio'] = exports; /**
 * <p>Classes and objects contained by the Audio module.</p>
 * @name Audio
 * @namespace 
 * @description <p>The Audio module is a collection of classes that support manipulation of audio effects in an application. 
 * Each class handles a specific aspect of the module implementation and contains APIs that support the class:</p>
 *<ul>
 *<li><code>{@link Audio.ActiveEffect}</code>: Construct objects for controlling the reproduction of <code>Effect</code> objects.</li>
 *<li><code>{@link Audio.Device}</code>: A singleton object that controls device sound effects volume.</li>
 *<li><code>{@link Audio.Effect}</code>: Construct objects that load sound resources into memory.</li>
 *<li><code>{@link Audio.Music}</code>: A singleton object that controls the reproduction of application background music.</li>
 *</ul>
 */
exports.Audio = {};

exports.Audio.__defineGetter__("ActiveEffect", function() {
	delete this.ActiveEffect;
	return this.ActiveEffect = require('NGCore/Client/Audio/ActiveEffect').ActiveEffect;
});
exports.Audio.__defineGetter__("Effect", function() {
	delete this.Effect;
	return this.Effect = require('NGCore/Client/Audio/Effect').Effect;
});
exports.Audio.__defineGetter__("Device", function() {
	delete this.Device;
	return this.Device = require('NGCore/Client/Audio/Device').Device;
});
exports.Audio.__defineGetter__("Music", function() {
	delete this.Music;
	return this.Music = require('NGCore/Client/Audio/Music').Music;
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Mobclix'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Mobclix'] || {}; $MODULE_REGISTRY['NGCore/Client/Mobclix'] = exports; //
//  Mobclix.js
//  Mobclix Mobage SDK
//
//  Copyright 2011 Mobclix. All rights reserved.
//

/**
 * Classes and objects contained by the Mobclix package.
 * @name Mobclix
 * @namespace
 * @description
 */

exports.Mobclix = {
	AdView: require('NGCore/Client/Mobclix/AdView').AdView,

	/**
	 * AdView class for the 320x50 unit.
	 * @name Mobclix#AdView_320x50
	 * @see Mobclix.AdView_320x50
	 * @see Mobclix.AdView
	 */
	AdView_320x50: require('NGCore/Client/Mobclix/AdView').AdView_320x50,

	/**
	 * AdView class for the 300x250 unit.
	 * @name Mobclix#AdView_300x250
	 * @see Mobclix.AdView_300x250
	 * @see Mobclix.AdView
	 */
	AdView_300x250: require('NGCore/Client/Mobclix/AdView').AdView_300x250,

	/**
	 * AdView class for the FullScreen unit.
	 * @name Mobclix#AdView_FullScreen
	 * @see Mobclix.AdView_FullScreen
	 * @see Mobclix.FullScreenAdView
	 */
	AdView_FullScreen: require('NGCore/Client/Mobclix/FullScreenAdView').AdView_FullScreen,
	
	/**
	 * Start up the Mobclix SDK, this must be called prior to requesting ads.
	 * @name Mobclix#startWithApplicationId
	 * @function
	 * @param	{String}	applicationId	The Mobclix Application ID for your app
	 */
	startWithApplicationId: function(applicationId) {
		require('NGCore/Client/Mobclix/Core/Controller').Controller.startWithApplicationId(applicationId);
	}
};
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/ngAPI/GACommon/GALogger'] = function(){var exports = $MODULE_REGISTRY['Code/ngAPI/GACommon/GALogger'] || {}; $MODULE_REGISTRY['Code/ngAPI/GACommon/GALogger'] = exports; 
// <author>Ameer Sheikh</author>

exports.GALogger =  Core.Class.singleton({
	
	classname : 'GALogger',
	_logThreshold: 0,
	initialize: function(){
		this._gameName = GAConfigurations.getGameName();
	},
	setLogThreshold: function(myThreshhold)
	{
	    this._logThreshold = myThreshhold;
	},
	
	log: function (myString)
	{
		//by Default logs in verbose mode.
		if(isValidString(myString))
		{
			this.logWithLevel(myString, LOG_LEVEL.LOG_ALL);
		}
	},
		
	logCritical: function (myString)
	{
		//by Default logs in FATAL ERROR mode.
		if(isValidString(myString))
		{
			this.logWithLevel(myString, LOG_LEVEL.LOG_FATAL);
		}
	},
	
	logWithLevel: function(myString, myLevel, isUILog)
	{
		try
		{
		    var localFormat = null;
			
            if(!isValidNumber(myLevel))
            {
                myLevel = LOG_LEVEL.LOG_ALL;
            }
            
		    if (myLevel >= this._logThreshold)
		    {
		        return;
		    }
			
            
            if(!isValidString(myString)) {
                myString = "Not a valid string for Logging";
                return;
            }
            
		    localFormat = 'GALogger [ '+this._gameName+' Log Level: '+this.getLevelString()+']: '+myString+'\n';
		    
			if(isUILog != null && isUILog == true)
			{
				UIFactory.showToast(myString);
			}
			else
			{
				console.log(localFormat);
			}
		}
		catch(exception)
		{
			console.log('Logger: EXCEPTION Occurred in GALogger::logWithLevel. Reason: ' + exception.toString());
		}
	},
	
	getLevelString :function()
	{
		switch(this._logThreshold)
		{
			case LOG_LEVEL.LOG_ALL:
				return 'log all';
				break;
			case LOG_LEVEL.LOG_VERBOSE:
				return 'verbose log';
				break;
			case LOG_LEVEL.LOG_DEBUG:
				return 'debug';
				break;
			case LOG_LEVEL.LOG_NONFATAL_ERROR:
				return 'non-fatal error';
				break;
			case LOG_LEVEL.LOG_EXCEPTION:
				return 'exception';
				break;
			case LOG_LEVEL.LOG_FATAL:
				return 'fatal error';
				break;
			case LOG_LEVEL.LOG_SILENT:
				return 'silent log';
				break;
			default:
				return 'Unknown level';
		}
	}
	
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/ngAPI/GACommon/GAWebFetcher'] = function(){var exports = $MODULE_REGISTRY['Code/ngAPI/GACommon/GAWebFetcher'] || {}; $MODULE_REGISTRY['Code/ngAPI/GACommon/GAWebFetcher'] = exports; /*
 * Filename: GAGameStateHandler.js
 * Author: Abid Hussain
 * Date Modified: 07/06/2011
 * */
var GAXHR = Network.XHR.subclass({
	open: function($super, method, url, async, user, password, overrideNormalize)
	{
		$super(method, url, async, user, password);
		if(overrideNormalize && overrideNormalize == true)
		{
			this.settings.url = url;
		}
	}
});

exports.GAWebFetcher = Core.Class.subclass({

    classname: 'GAWebFetcher',

    initialize: function(delegate, timeout, requestTag) {
        this._delegate = delegate;
        this._timeout = timeout * 1000;
        this.requestTag = requestTag;
        this._abort = false;
        this._timeoutVariable = null;
        this._request = null;
    },
    invokeGetRequest: function(url) {
        this._request = new Network.XHR();
        this._request.onreadystatechange = this._onReadyStateChanged.bind(this);
        this._timeoutVariable = setTimeout(this._requestTimeout.bind(this), this._timeout);
        this._request.open("GET", url, true);
        this._request.send(null);
    },
    invokePostRequest: function(url, data, overrideNormalize) {
    	this._request = new GAXHR();
        this._request.onreadystatechange = this._onReadyStateChanged.bind(this);
        this._timeoutVariable = setTimeout(this._requestTimeout.bind(this), this._timeout);
        this._request.open("POST", url, true,null,null,overrideNormalize); 
        this._request.setRequestHeader("Content-Type", "application/x-www-form-urlencoded; charset=UTF-8");
        if (data == null){ 
            this._request.send("showForm=false");
        }
        else{
            this._request.send(data);
        }
    },
    
    postData: function(baseUrl,params,data){
    	this._makepostbody(baseUrl,params,data);
    },
    _makepostbody: function(baseUrl,params,data)
    {
    	var boundary = "---ABlkjasfdkjsdifsdf098asdfa3lka90aflallyourbasekjas09ds0fjasdkal3lj0sa";
    	var newline = '\r\n';
    	var boundaryLine = "--" + boundary + newline;
    	this._postData = params;
    	var body = [];
    	body.push(this._multipartPostBodyFromDataWithBoundary(this._postData, boundary));
    	body.push(boundaryLine);
    	var aname= "gamestate";
    	var fname= "gamestate";
    	var type="application/zip;base64";
    	body.push("Content-Disposition: form-data; name=\"" + aname + "\"; filename=\"" + fname + "\"" + newline);
    	body.push("Content-Type: " + type + newline + newline+"");
    	if(data != null){
    		body.push( data);
    	}
    	body.push(newline);
    	body.push("--" + boundary + "--" + newline);
    	this._postData = body.join("");
    	this._request = new Network.XHR();
    	this._timeoutVariable = setTimeout(this._requestTimeout.bind(this), this._timeout);
    	this._request.open("POST", baseUrl, true,null,null); 
    	this._request.setRequestHeader("Accept", "application/binary-plist, application/zip;base64");    			
    	this._request.setRequestHeader("Content-Type", "multipart/form-data; boundary=" + boundary);
    	this._request.setRequestHeader("Content-Length", ""+this._postData.length);    		
    	this._request.onreadystatechange = this._onReadyStateChanged.bind(this);
   		this._request.send(this._postData);
    },
    
    _multipartPostBodyFromDataWithBoundary:function (data, boundary){
    	var newline = '\r\n';
    	var boundaryLine = "--" + boundary + newline;
    	var buffer = [];
    	for(var key in data){
    		var value = data[key];
    		buffer.push(boundaryLine);
    		buffer.push("Content-Disposition: form-data; name=\"" + key + "\"" + newline + newline);
    		buffer.push(value);
    		buffer.push(newline);
    	}
    	return buffer.join("");
    },
    
    /* 
     * _onReadyStateChanged: This function checks the response continuously and delegates the  success or failure of request
     * */
    _onReadyStateChanged: function() {
        var authenticated = true;
        try {
        	 if (!this._abort && this._request.readyState == 4) {
                clearTimeout(this._timeoutVariable);
                if (this._request.status == httpStatus.HTTP_STATUS_SUCCESS_OK && this._request.responseText != null) {
                    if (typeof this._delegate.authenticateData === 'function'){ 
                    	authenticated = this._delegate.authenticateData(this._request.responseText);
                    }
                    if (authenticated){ 
                    	this._delegate.webFetchSuccess(this, this._request.responseText);
                    }
                    else{
                    	this._delegate.webFetchFailure(this, httpStatus.HTTP_STATUS_SUCCESS_PARTIAL_CONTENT);
                    }
                } else if (this._request.status == httpStatus.HTTP_STATUS_ZERO && this._request.responseText == null){
                	this._delegate.webFetchFailure(this, httpStatus.HTTP_STATUS_ZERO);
                } else {
                    this._delegate.webFetchFailure(this, (this._request.status == httpStatus.HTTP_STATUS_SUCCESS_OK) ? httpStatus.HTTP_STATUS_SUCCESS_NO_CONTENT : this._request.status);
                }
            }
        } catch (exception) {
        	if(this._delegate != null){
        		this._delegate.webFetchFailure(this,exception);
        	}else 
        	{
        		GALogger.log('this._delegate == null in GAWebfetcher');
        	}
        }
    },
    _requestTimeout: function() {
        this._abort = true;
        this._delegate.webFetchFailure(this, httpStatus.HTTP_STATUS_CLIENT_ERROR_REQUEST_TIMEOUT);
    },
    destroy: function($super) {
    	this._delegate = null;
        this._timeout = null;
        this.requestTag = null;
        this._abort = null;
        this._timeoutVariable = null;
        this._request = null;
        this._postData = null;
    	
    }
    
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/ngAPI/GACommon/GACommonUtils'] = function(){var exports = $MODULE_REGISTRY['Code/ngAPI/GACommon/GACommonUtils'] || {}; $MODULE_REGISTRY['Code/ngAPI/GACommon/GACommonUtils'] = exports; 
exports.GACommonUtils = Core.Class.singleton ({

	initialize: function() {
        this._orientation = Device.OrientationEmitter.Orientation.LandscapeLeft;//NgApplicationOrientation.LandscapeLeft;	
	},
	
	getKeyForStoreObject: function(storeObject) {
		if (storeObject != null) {
			if (storeObject.objectType == "item") {
				var key = [];
				key.push(storeObject.parent.parent.visible_id);
				key.push(storeObject.parent.visible_id);
				key.push(storeObject.visible_id);
				return key.join("_");
			}
			else if (storeObject.objectType == "cat") {
				var key = [];
				key.push(storeObject.parent.visible_id);				
				key.push(storeObject.visible_id);
				return key.join("_");
			}
			else {
				return storeObject.visible_id;
			}
		}
		return null;
	},
	
	getBuyPrice: function(storeObject, currencyName) {
		if (storeObject != null) {
			var prices = storeObject.buy_prices;
			//console.log(">>store Object in GACommonUtils=="+storeObject);
			//console.log(">>prices in GACommonUtils=="+prices);								  
			if (typeof prices != 'undefined') {
				var activeBucket = storeObject.active_bucket;
				var priceForBucket = prices[activeBucket];
				if (typeof priceForBucket != 'undefined') {
					if (typeof currencyName != 'undefined' && currencyName != null) {
						var value = priceForBucket[currencyName];
						if (typeof value != 'undefined') {
							return value;
						}
					}
					else {
						return priceForBucket;
					}
				}
			}
		}
		return null;
	},

	getSellPrice: function(storeObject, currencyName) {
		if (storeObject != null) {
			var sellPrice = storeObject.sell_prices;
			if (typeof sellPrice != 'undefined') {
				if (typeof currencyName != 'undefined' && currencyName != null) {
					var value = sellPrice[currencyName];
					if (typeof value != 'undefined') {
						return value;
					}
				}
				else {
					return sellPrice;
				}
			}
		}
		return null;
	},
	
	getServerParams: function() {
		var params = {};
		params[GA_UDID_PARAM_KEY] = GAConfigurations.getUdid();
		params[GA_DEVICE_TYPE_PARAM_KEY] = GAConfigurations.getDeviceType();
		params[GA_DEVICE_OS_PARAM_KEY] = GAConfigurations.getOsVersion();
		params[GA_GAME_VERSION_PARAM_KEY] = GAConfigurations.getGameVersion();
		params[GA_GAME_NAME_PARAM_KEY] = GAGameLoader.getResponseObject().getGame();
		//params[GA_DEVICE_GENERATION_PARAM_KEY] = GAConfigurations.
		return params;
	},
	
	getScreenWidth: function() {
		return (this._orientation ==  Device.OrientationEmitter.Orientation.Portrait || this._orientation == Device.OrientationEmitter.Orientation.PortraitUpsideDown) ? Core.Capabilities.getScreenWidth() : Core.Capabilities.getScreenHeight();
        //return (this._orientation == NgApplicationOrientation.Portrait || this._orientation == NgApplicationOrientation.PortraitUpsideDown) ? Core.Capabilities.getScreenWidth() : Core.Capabilities.getScreenHeight();
    },

    getScreenHeight: function() {
    	return (this._orientation ==  Device.OrientationEmitter.Orientation.Portrait || this._orientation == Device.OrientationEmitter.Orientation.PortraitUpsideDown) ? Core.Capabilities.getScreenHeight() : Core.Capabilities.getScreenWidth();
        //return (this._orientation == NgApplicationOrientation.Portrait || this._orientation == NgApplicationOrientation.PortraitUpsideDown) ? Core.Capabilities.getScreenHeight() : Core.Capabilities.getScreenWidth();
    },

	/*getAdjustedX: function(x) {
   		
   		var width = 0 , newWidth = 0 ;
   		width = this.getScreenWidth();
   		newWidth = (width / 320) * x;
   		
       	return newWidth;
   		
   },
    
   getAdjustedY: function(y) 
   {
   		var height = 0 , newHeight = 0;
		height = this.getScreenHeight();
		newHeight = (height / 480) * y;
      
       return newHeight;
   },*/
    
    getAdjustedX: function(x) {
        return (x / aspectRatioFactor.x) * this.getScreenWidth();
    },

    getAdjustedY: function(y) {
        return (y / aspectRatioFactor.y) * this.getScreenHeight();
    },
    
	adjustWidthWithDevice: function(aWidth)
	{
		var w = 0, calWidth = 0;
		w = this.getScreenWidth();
		calWidth = aWidth * (w/320);
		return calWidth;			
	},
	adjustHeightWithDevice: function(aHeight)
	{
		var h = 0 , calHeight = 0;
		h = this.getScreenHeight();
		calHeight = aHeight * (h/480);
		return calHeight;		
		
	},
	
    setApplicationOrientation: function(orientation) {
		Device.OrientationEmitter.setInterfaceOrientation(orientation);
        //NgApplication.getInstance().setOrientation(orientation);
        this._orientation = orientation;
    },
	
	getAdjustedFontSize: function(fieldHeight) {
        return this.getAdjustedY(fieldHeight / 2) / aspectRatioFactor.d;
    }
	
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/ngAPI/GACommon/GLFactory'] = function(){var exports = $MODULE_REGISTRY['Code/ngAPI/GACommon/GLFactory'] || {}; $MODULE_REGISTRY['Code/ngAPI/GACommon/GLFactory'] = exports; 
exports.GLFactory = Core.Class.singleton({
	
    classname: 'GLFactory',
    
    initialize: function() {
    
	//	log(NgLogLevel.Info, 'Inside GLFactory::initialize()');
	
	},
	
	getNode: function(position) {
		
        var aNode = new GL2.Node();
        aNode.setPosition(position);
        return aNode;
	},
	
	getSprite: function(position, depth, imagePath, size, anchor) {
		
        var aSprite = new GL2.Sprite();
        if(position != null)
            aSprite.setPosition(position);
        if(depth != -100)
            aSprite.setDepth(depth);
        if(!anchor)
            anchor = [0, 0];
        aSprite.setImage(imagePath, size, anchor);
        return aSprite;
	},
	
	getText: function(position, depth, text, size, fontSize, hAlign, vAlign, overflowMode) {
		
        var aText = new GL2.Text();
        if(position != null)
        	aText.setPosition(position);
        if(depth != -100)
            aText.setDepth(depth);
        aText.setText(text);
        aText.setSize(size);
        if(fontSize > 0)
            aText.setFontSize(fontSize);
        aText.setColor(0, 0, 0);
        if(hAlign)
            aText.setHorizontalAlign(hAlign);
        if(vAlign)
            aText.setVerticalAlign(vAlign);
        if(overflowMode)
            aText.setOverflowMode(overflowMode);
        return aText;
	},
	
	getTouchTarget: function(position, size, parent, touch) {
		
        var aTarget = new GL2.TouchTarget();
        aTarget.setPosition(position);
        aTarget.setSize(size);
        if(touch!=null)
            aTarget.getTouchEmitter().addListener(parent, touch);
        return aTarget;
	}
	
	
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/ngAPI/GACommon/UIFactory'] = function(){var exports = $MODULE_REGISTRY['Code/ngAPI/GACommon/UIFactory'] || {}; $MODULE_REGISTRY['Code/ngAPI/GACommon/UIFactory'] = exports; 
exports.UIFactory = Core.Class.singleton({

    classname: 'UIFactory',

	_progressDialog: null,	//will hold reference to progress dialog box
	_blockView: null,  //a UI block view 


    initialize: function() {
        NgLogD('Inside UIFacgory::initialize()');
	},
    
    getButton: function(frame, image, parent, gradients, text, color) {
    	
        var button = new UI.Button();
        button.setFrame(frame);
        button.setImage(image,UI.State.Normal);
        button.controller = parent;
        button.enable = true;
        
        if(gradients) {
            button.setGradient(gradients[0],UI.State.Normal);
            button.setGradient(gradients[1],UI.State.Pressed);
            button.setGradient(gradients[2],UI.State.Disabled);
        }
        
        if(text)
        button.setText(text);
        button.setTextColor(color);
        button.setImageFit(UI.ViewGeometry.FitModes.Stretch);
        return  button;
    },
    
    getGenericButton: function(frame, normalImage, highlightedImage, text, textColor, textSize,delegate,gradients) {
    	
        var button = new UI.Button();
        button.setFrame(frame);
        button.setImage(normalImage,UI.State.Normal);
        button.setImage(highlightedImage,UI.State.Pressed);
        button.enable = true;
       
        if(text)
        {
            button.setText(text);
        }
        if(textColor)
        {
        	button.setTextColor(textColor);
        }
        if(textSize)
        {
        	button.setTextSize(textSize);
        }
        
        if(delegate)
        {
        	button.controller = delegate;
        }
   
        if(gradients) 
        {
            button.setGradient(gradients[0],UI.State.Normal);
            button.setGradient(gradients[1],UI.State.Pressed);
            button.setGradient(gradients[2],UI.State.Disabled);
        }
        button.setImageFit(UI.ViewGeometry.FitModes.Stretch);
        return  button;
    },
    
	getEditText: function(frame, textSize, attributes, inputType, keyType, placeholder, bgColor) {
    	
        var eText = new UI.EditText();
        eText.setFrame(frame);
        if(textSize > 0)
            eText.setTextSize(textSize);
        if(attributes)
            eText.setAttributes(attributes);
        if(inputType)
            eText.setInputType(inputType);
        if(keyType)
            eText.setEnterKeyType(keyType);
        if(placeholder)
            eText.setPlaceholder(placeholder)
        if(bgColor)
            eText.setBackgroundColor(bgColor);
        else
            eText.setBackgroundColor("000000FF");
        return eText;
	},
	
    getImage: function(frame, imagePath, scale, gradient, bgColor) {
        var image = new UI.Image();
        image.setFrame(frame);
        image.setImage(imagePath);
        if(scale)
            image.setImageScale(scale);
        if(gradient)
            image.setGradient(gradient);
        if(bgColor)
            image.setBackgroundColor(bgColor);
        image.setImageFit(UI.ViewGeometry.FitModes.Stretch);
        return image;
    },
    
    //label
    getTextArea: function(frame, text, textSize, gravity, tColor, bgColor) {
        var label = new UI.Label();
        label.setFrame(frame);
        label.setText(text);
        if(textSize > 0)
            label.setTextSize(textSize);
        if(gravity)
            label.setTextGravity(gravity);
        if(tColor)
            label.setTextColor(tColor);
        else
            label.setTextColor("FF000000");
        if(bgColor)
            label.setBackgroundColor(bgColor);
        else
            label.setBackgroundColor("00FFFFFF");
        return label;
    },
    
    
    getView: function(frame, image, gradient, gravity, scale) {
        var view = new UI.View();
        view.setFrame(frame);
        if(image)
            view.setImage(image);
        if(gradient)
            view.setGradient(gradient);
        if(gravity)
            view.setImageGravity(gravity);
        if(scale)
            view.setImageFit(scale);
        return view;
    },
    
    getWebView: function(frame, url) {
        var webView = new UI.WebView();
		webView.setFrame(frame);
		webView.setBackgroundColor("00000000");
		webView.loadUrl(url);
        return webView;
    },
    
    getCheckBox: function(frame, controller, checked) {
        var checkBox = new UI.CheckBox();
		checkBox.setFrame(frame);
        checkBox.controller = controller;
        if(checked)
            checkBox.setChecked(checked);
		return checkBox;
	},
	
	getDateField: function(frame, attributes, format) {
        var dateField = new UI.DateField();
        dateField.setFrame(frame);
		dateField.setAttributes(attributes);
		dateField.setInputType(UI.EditText.InputTypes.Date);
        dateField.setDateFormat(format);
        return dateField;
	},
	
	
	showProgressHUD: function(msgText) {
	
		if(this._progressDialog == null)  {
			//if not created, create one
			this._progressDialog = new UI.ProgressDialog(); 
		}
		
		if(this._progressDialog != null) {
			if(isValidString(msgText)) {
				//if text is provided, update it
				this._progressDialog.setText(msgText);
			}
			//if already created, show it
			this._progressDialog.show();
		}
    },
	
    hideProgressHUD: function() {
        if (this._progressDialog != null) {
            this._progressDialog.setText("");
            this._progressDialog.hide();
        }
    },
	
	
	showToast: function(msgText) {
		if(isValidString(msgText))
		{
			toastDialog = new UI.Toast();
			toastDialog.setText(msgText);
			toastDialog.show();
		}
	},
	
	showBlockView: function() {
		if(this._blockView) {
			this.hideBlockView();
		}
		var mainRect = new UI.ViewGeometry.Rect(0, 0, GACommonUtils.getScreenWidth(), GACommonUtils.getScreenHeight());
		this._blockView = new UI.View();
		if(this._blockView) {
			this._blockView.setFrame(mainRect.array());
			this._blockView.setGradient({
								  "innerShadow":"22000000 200.0 {0.0,0.0}",
								  "gradient":[
											  "33000000 0.000",
											  "33000000 1.000"
											  ]
								  });
			NGWindow.document.addChild(this._blockView);	
		}
	},
		
	hideBlockView: function() {
		if(this._blockView) {
			NGWindow.document.removeChild(this._blockView);
			this._blockView.destroy()
			this._blockView = null;
		}
	},
	
	destroy: function() {
		if(this._progressDialog != null) {
			this._progressDialog.destroy();
			this._progressDialog = null;
		}
		
		if(this._blockView != null)
		{
			delete(this._blockView);
			this._blockView = null;
		}

	}
	
	
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/ngAPI/GACommon/GLButton'] = function(){var exports = $MODULE_REGISTRY['Code/ngAPI/GACommon/GLButton'] || {}; $MODULE_REGISTRY['Code/ngAPI/GACommon/GLButton'] = exports; /**
 * Filename: GLButton.js  also contains GALayer
 * Author: Sajid Hussain
 * Date Created: 2011-02-08
 * Date Updated: 2011-02-10
 * Date Updated: 2011-05-13
 */
var GALayer = exports.GALayer = Core.MessageListener.subclass({

    classname: 'GALayer',

    initialize: function($super) {
    	$super();
        this._node = new GL2.Node();
    },

    getNode: function() {
        return this._node;
    },

    setPosition: function(x, y) {
        this._node.setPosition(x, y);
    },

    getPosition: function() {
        return this._node.getPosition();
    },

    setDepth: function(depth) {
        this._node.setDepth(depth);
    },

    addChild: function(aNode) {
        if (aNode) {
            this._node.addChild(aNode);
        }
    },

    destroy: function($super) {
    	if(this._node)
    		TFUtil.destroyNode(this._node);
    	$super();
    }
});


exports.GLButton = GALayer.subclass({

    classname: 'GLButton',

    initialize: function($super,path1, path2, sizeX, sizeY, callBackFunc, node, depth ,btnText, normalTextColor,highlitedTextColor,textLableSize,fontSize) {
    	$super();
        this._ButtonEnabled=true;
        this._DisabledImagePath=null;
        if(depth)
		{
			this.setDepth(depth);
		}
        this._button = GLFactory.getSprite(null, depth, path1, new Core.Size(sizeX, sizeY), [0.5, 0.5]);
        this.addChild(this._button);
        if(btnText)
        {
        	
        	if(textLableSize)
        	{
             	this.buttonText = GLFactory.getText([-28, 0],6, btnText, textLableSize,(fontSize) ?fontSize : 20);
        		
        	}
        	else{
        	this.buttonText = GLFactory.getText([0, 0],6, btnText, [sizeX, sizeY], (fontSize) ?fontSize : 20);
        	}
        	this.buttonText.setFontLocation(TFUtil.getFontLocation());
    		this.buttonText.setFontFamily(TFUtil.getFont());
    		this.buttonText.setColor(1, 1, 1);
        	this.buttonText.setHorizontalAlign(UI.ViewGeometry.Gravity.Center);
			this._button.addChild(this.buttonText);
        }
        if(normalTextColor)
        {
         this._normalTextColor = normalTextColor;
		 this.buttonText.setColor(normalTextColor);
        	
        }
        if(highlitedTextColor)
        {
         this._highlitedTextColor = highlitedTextColor;	
        }
        
        this._target = GLFactory.getTouchTarget(this.getPosition(), [sizeX, sizeY]);
        this._target.setAnchor(0.5, 0.5);
        this._target.setDepth(depth);
        this.addChild(this._target);

        this._target.getTouchEmitter().addListener(this, this._onTouch,100);

        this._callBackFunc = callBackFunc;

        this._path1 = path1;
        this._path2 = path2;
        this._sizeX = sizeX;
        this._sizeY = sizeY;

        node.addChild(this.getNode());
    },

    _onTouch: function(touch) {
        switch (touch.getAction()) {
        case touch.Action.Start:
            	
        
       		 if(this._highlitedTextColor)
       		 {
       		  this.buttonText.setColor(this._highlitedTextColor);	
       		 }
            this._button.setImage(this._path2, [this._sizeX, this._sizeY]);
            return true;
        case touch.Action.End:
        	 if(this._normalTextColor)
       		 {
       		  this.buttonText.setColor(this._normalTextColor);	
       		 }
            this._button.setImage(this._path1, [this._sizeX, this._sizeY]);
            if(touch.getIsInside(this._target)) {
            	this._callBackFunc();
            }
            break;
        case touch.Action.Move:
            if(touch.getIsInside(this._target))
            	this._button.setImage(this._path2, [this._sizeX, this._sizeY]);
            else
            	this._button.setImage(this._path1, [this._sizeX, this._sizeY]);
            break;
        }
    },
    
    getButton:function ()
    {
    	return this._button;
    },

    setIsEnabled: function(value)
    {
    	this._ButtonEnabled=value;
    	this._target.setTouchable(this._ButtonEnabled);
    	this.setDisabledImage(value);
    },
    
    setDisabledImage: function(value)
    {
    	
    	if(value)
    	{
    		this._button.setImage(this._path1, new Core.Size(this._sizeX, this._sizeY), [0.5, 0.5]);
	    }
    	else if(this._DisabledImagePath!=null)
    	{
       		this._button.setImage(this._DisabledImagePath, new Core.Size(this._sizeX, this._sizeY), [0.5, 0.5]);
    	}
    },
    
    setButtonImage:function(value)
    {
    	this._button.setImage(value, new Core.Size(this._sizeX, this._sizeY), [0.5, 0.5]);
    },
    
    
    setDisabledImagePath: function(path)
    {
    	this._DisabledImagePath=path;
    },
      
    setTextFont:function(font,fontLocation) 
    {
    	this.buttonText.setFontFamily(font);
    	this.buttonText.setFontLocation(fontLocation);
    },
    
    destroy: function($super) {
        this._target.getTouchEmitter().removeListener(this, this._onTouch);
        if(this._button)
        	TFUtil.destroyNode(this._button);
        $super();
    }

});

; return exports;};
$MODULE_FACTORY_REGISTRY['Code/ngAPI/GACommon/GAMutableDictionary'] = function(){var exports = $MODULE_REGISTRY['Code/ngAPI/GACommon/GAMutableDictionary'] || {}; $MODULE_REGISTRY['Code/ngAPI/GACommon/GAMutableDictionary'] = exports; /**
 * Filename: GAMutableDictionary.js
 * Author: Zeeshan Amjad
 * Date Created: 2011-05-11
 * Date Updated: 2011-05-13
 */

exports.GAMutableDictionary = Core.Class.subclass({

    classname: 'GAMutableDictionary',

    initialize: function() {
		//this._privateDict = {};
		this._privateDict = new Array();
		this.length = 0;
		this._allKeys = new Array();
    },
	
	setObject:function(key, value) {
		this._checkIfReleased();
		if(isValidString(key) && isValidObject(value)) {
			if(!this._privateDict[key]) {
			        this.length++;
				this._allKeys[this._allKeys.length] = key;
			}
			this._privateDict[key] = value;
		}
	},
	allKeys : function()
	{
		return this._allKeys;
	},
	
	objectForKey:function(key) {
		this._checkIfReleased();
		if(key != null) {
			if(this._privateDict[key] != null) {
				return this._privateDict[key];
			}
		}
		return null;
	},
	
	removeObjectForKey:function(key) {
		this._checkIfReleased();
		if(isValidString(key)) {
			if(this.hasKey(key) && this._privateDict[key] != null) {
				//this._privateDict[key] = null;
				this._removeKey(key);
				delete this._privateDict[key];
			} else {
				GALogger.log("Object not removed from the dictionary");
			}
		} else {
			GALogger.log("Invalid key specified while removing an object");
		}
	},
	
	removeAllObjects: function() {
		//harris
		if(this._allKeys)
		{
			delete this._allKeys;
			this._allKeys = null;
		}
		
		if(this._privateDict)
		{
			delete this._privateDict;
			this._privateDict = null;
		}
		
		this.initialize();
		
	},
	
	hasKey: function(key) {
		//harris
		if(isValidString(key))
		{
			var foundIndex = this._indexOfKey(key);
			return (foundIndex != -1);	//will return true or false according to the valid key
		}
		
		GALogger.log("Invalid key for dictionary");
		
		return false;	//returns false if an invalid key is sent key should be string
	},
	
	hasObject: function(obj) {
		//harris
		
		/* will be implemented later 
		for(key in this._allKeys)
		{
			if(this._privateDict[key] == obj)
				return true;
		}	
		*/
		return false;
	},
	
	print: function()
	{
		for(objectId in this._privateDict)
		{
			var myVal = this._privateDict[objectId];
			console.log('GAMutableDictionary: Key ' +objectId +' and value is ' +myVal);
		}
	},
	
	destroy:function() {
		if(this._allKeys)
		{
			delete this._allKeys;
			this._allKeys = null;
		}
		
		if(this._privateDict)
		{
			delete this._privateDict;
			this._privateDict = null;
		}
	},
	
	/* private methods for internal implementation */
	
	_indexOfKey: function(key) {
		//harris
		return this._allKeys.indexOf(key);
	},
	
	_removeKey: function(key) {
		//harris
		var index = this._indexOfKey(key);
		this._allKeys.splice(index,1);
		this.length--;
	},
	
	_checkIfReleased: function()
	{
		if(this._privateDict == null)
		{
			GALogger.log("GAMutableDictionary was released, reinitializing");
			this._privateDict = {};
		}
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/ngAPI/GACommon/GAMutableArray'] = function(){var exports = $MODULE_REGISTRY['Code/ngAPI/GACommon/GAMutableArray'] || {}; $MODULE_REGISTRY['Code/ngAPI/GACommon/GAMutableArray'] = exports; /**
 * Filename: GAMutableArray.js
 * Author: Tariq Akram
 * Date Created: 2011-05-17
 * Date Updated: 2011-05-17
 */

exports.GAMutableArray = Core.Class.subclass({

    classname: 'GAMutableArray',

	initialize: function(array)
	{
		if(array)
		{
		this._array = JSON.parse(JSON.stringify(array));
		this._length = array.length;
		}
		else
		{
			this._array = new Array();
		 	this._length = 0;
		}
	},
	
	sortFunctionAsc: function(a,b)
	{
		return (a-b);	
	},
	
	sortFunctionDesc: function(a,b)
	{
			return (b-a);	
	},
	
	numericSort: function(desc)
	{
		if(desc && desc == true)
		{
			this._array.sort(this.sortFunctionDesc());
			return;
		}
		this._array.sort(this.sortFunctionAsc());
	},
	
	addObject:function(object){
		if(object!= null){
			this._array.push(object);
			this._length++;
		}
	},
	
	objectAtIndex: function(index)
	{
		return this._array[+index];
	},

	getLength: function()
	{
		return this._length;
	},
	
	getArray:function(){       ////////
		if(this.checkIfReleased()){
			return this._array;
		}
	},
	
	removeLastObject:function()
	{
	if(this.checkIfReleased()){
	  		this._array.pop();
			this._length--; 
	}  
	},
	insertObjectAtIndex:function(index,object)
	{
		 
		if(index != null && object != null) {
			this._array.splice(index,0,object);
			this._length++;
		}
		  
	},
	removeObjectAtIndex:function(index){
		if(this.checkIfReleased()){
				if(index != null && index<this._length) {
				this._array.splice(index,1);
				this._length--;
			}
			else
			{
		     	console.log("Index not Exist");		
			}
		}
		
	},
    
    removeObjectsInRange: function(index,range)
	{
		if(index != null) 
		{
			this._array.splice(index,range); // if range == null it will remove all objects from starting index till the end
			this._length = this._array.length;
		}
		
	},
    
	replaceObjectAtindex:function(index,object){
		if(this.checkIfReleased())
		{
			if(index != null && object != null && index<this._length) {
				this._array.splice(index,1,object);
			}
			else
			{
			 	 console.log("Index not Exists.");
			}	
			}
	},
	
	checkIfReleased: function()
	{
		if(this._length == 0)
		{
			console.log("GAMutableArray is Empty.");
			return false;
		}
		else
		{
			return true;
		}
	},
	
	destroy:function() {
		delete this._array;
		this._array = null;
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/ngAPI/GACommon/GAAlertViewPanel'] = function(){var exports = $MODULE_REGISTRY['Code/ngAPI/GACommon/GAAlertViewPanel'] || {}; $MODULE_REGISTRY['Code/ngAPI/GACommon/GAAlertViewPanel'] = exports; //Usage ---
//	Mandatory parameters in show function: bgImage, buttonNormalImagesArray & buttonRectArray
//	var promptView = new GAAlertViewPanel();
//	promptView.show(PURCHASE_MSG.replace('PRICE', price.getDescription()) , "b03060", 13, null, './Content/UI/Alert/alert-panel.png', [ (this.purchaseButtonCallback).bind(this, model, price), (this.purchaseButtonCallbackCancel).bind(this)], ['./Content/UI/Alert/alert-normal.png', './Content/UI/Alert/alert-normal.png'], ['./Content/UI/Alert/alert-selected.png', './Content/UI/Alert/alert-selected.png'], ['OK', 'Cancel'], null, [[130, 180, 100, 50], [250, 180, 100, 50]], null);

exports.GAAlertViewPanel = UI.View.subclass(
{  
	classname: 'GAAlertViewPanel',
	
    //initialize: function() {   },
    
    show: function(message, messageFontColor, messageFontSize, rectForMessage, bgImage, callbackArray, buttonNormalImagesArray, buttonSelectedImagesArray, buttonTextArray, viewSize, buttonRectArray, buttonFontColorArray){
       	
		if(bgImage == null || buttonRectArray == null || buttonNormalImagesArray == null) {
	    	console.log("GAAlertViewPanel: Given parameters are not correct!");
			this.destroy();
			return;
	    }
	
		this.callbacks = callbackArray;
    	var width = GACommonUtils.getScreenWidth(); // change required
    	var height = GACommonUtils.getScreenHeight();  // change required
        NGWindow.document.addChild(this);
        var mainRect = new UI.ViewGeometry.Rect(0, 0, width, height);
        this.setFrame(mainRect.array());
        
         //adding background
        var pW = viewSize == null ? width/2+70 : viewSize.getWidth();
        var pH = viewSize == null ? height/2 : viewSize.getHeight();
        var promptRect = new UI.ViewGeometry.Rect(Math.abs(pW/2-width/2), Math.abs(pH/2-height/2), pW, pH);
        this._promptView = UIFactory.getView(promptRect.array(), bgImage, null, null, UI.ViewGeometry.FitModes.Stretch);
        this.addChild(this._promptView);
        
        //adding buttons
        var totalButtons = buttonNormalImagesArray != null ? buttonNormalImagesArray.length : 0;
        for(var i=0; i<totalButtons; i++) {
        	if(i>=buttonRectArray.length || i>=buttonNormalImagesArray.length) {
        		console.log("GAAlertViewPanel: Given parameters are not correct!");
        		this.destroy();
        		return;
        	}
        	var btnText = (buttonTextArray!=null && i<buttonTextArray.length) ? buttonTextArray[i] : null;
        	var btnTextFont = (buttonFontColorArray != null && i<buttonFontColorArray.length) ? buttonFontColorArray[i] : 'FFFFFF';
        	var btn = UIFactory.getButton(buttonRectArray[i],buttonNormalImagesArray[i],this._promptView,null,btnText,btnTextFont);
        	if(buttonSelectedImagesArray != null && i<buttonSelectedImagesArray.length) { btn.setImage(buttonSelectedImagesArray[i],UI.State.Pressed); }
        	btn.controller = this;
        	btn.index = i;
        	btn.onclick = this.callback;
        	this._promptView.addChild(btn);
        }
            
        //adding Text Area
        rectForMessage = rectForMessage == null ? [125, 70, width/2.5, height/4.5] : rectForMessage;
        messageFontColor = messageFontColor == null ? "b03060" : messageFontColor;
        messageFontSize = messageFontSize == null ? 14 : messageFontSize;
        var alertText = UIFactory.getTextArea(rectForMessage, message, messageFontSize, [0.0, 0.5], messageFontColor);
		this._promptView.addChild(alertText);
    },
    callback: function() {
    	if(this.controller.callbacks != null && this.index < this.controller.callbacks.length && this.controller.callbacks[this.index] != null) {
    		this.controller.callbacks[this.index]();
    	}
        this.controller.destroy();
    },
    destroy: function() {
		if(this._promptView != 'undefined' && this._promptView != null) {
			var children = this._promptView.getChildren();
			var length = children.length;
			for(var i = length-1; i >= 0; i--) {
					children[i].destroy();
					children[i] = null;
			}
			this._promptView.destroy();
			this._promptView = null;
		}
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/ngAPI/GACommon/GAUIAlertViewWithEditText'] = function(){var exports = $MODULE_REGISTRY['Code/ngAPI/GACommon/GAUIAlertViewWithEditText'] || {}; $MODULE_REGISTRY['Code/ngAPI/GACommon/GAUIAlertViewWithEditText'] = exports; // CLass Name UIAlertView

// Initializing UIAlertView 
// there are 5 parameters passed to constructor below are the details of parameters
// 1.initWithTitle				: it is first parameter. it will take title string and set UIAlertView title
// 2.message       				: it will take message string and set Message in UiAlertView
// 3.delegate 	   				: setting delegate.
// 4.cancelButtonTitle			: it will take cancel button title string which should be localized string
// 5.otherButtonTitles			: it will take ok button title string which should be localized string

// setter functions
// there are 9 setter function through which you can set button text, title text and message text colors.
// it is also allow you to set background and button normal and highlighted images path
// you can also set type of your alertView and type detail is given below

// there are two type of alert view
// 1."ok" which means UIAlertView with ok button only
// 2."okwithcancel" means UIAlertView with ok and cancel button both 
// by default it takes type "ok"

//Default type for alert window
var kALERT_WINDOW_TYPE = "ok"
var kALERT_WINDOW_TYPE_WITH_CANCEL = "okwithcancel"

//AlertWindow button image default paths
var kALERT_WINDOW_BACKGROUND  = "./Content/images/UIPanels/AlertWindow/alert-background.png"

// Ok buttons
var kALERT_WINDOW_OK_NORMAL ="./Content/images/UIPanels/Buttons/1buttonNormal.png"
var kALERT_WINDOW_OK_SELECTED ="./Content/images/UIPanels/Buttons/1buttonSelected.png"


// Cancel buttons
var kALERT_WINDOW_CANCEL_NORMAL ="./Content/images/UIPanels/Buttons/1buttonNormal.png"
var kALERT_WINDOW_CANCEL_SELECTED ="./Content/images/UIPanels/Buttons/1buttonSelected.png"
//var Styles = require("./Styles").Styles;

exports.GAUIAlertViewWithEditText = UI.View.subclass({
	
	className: 'GAUIAlertViewWithEditText',
	
	initialize: function(initWithTitle,message,delegate,cancelButtonTitle,otherButtonTitles,texEditText) 
	{
		
			this.w							= null;
			this.h							= null;
			this._tagValue					= null;
			
			this._title 					= null;
			this._message 					= null;
			this._delegate 					= null;
			this.cancelButtonTitle 			= null;
			this._otherButtonTitles			= null;
			
			this._okButton					= null;
			this._cancelButton 				= null;
			this._messageLabel 	    		= null;
			this._titleLabel	    		= null;
			this._backgroundImage 			= null;
			this._type						= null;
			
			this._backgroundImagePath		= null;
			this._okImageNormalPath 		= null;
			this._okImageSelectedPath 		= null;
			this._cancelImageNormalPath		= null;
			this._cancelImageSelectedPath	= null;
	    	
	    	this._buttonsColor				=null;
   	    	this._buttonsFont				=null;
	    	this._titleColor				=null;
	    	this._messageColor				=null;
    	    this._titleFont					=null;
	    	this._messageFont 				=null;
	    	this.editableField				= null ;
	    	this._editedFieldFont			=null;
	    	this._changeCallBack = null ;

			
		    this._textEditText=texEditText;
													 
			// initializing data members with parameters 
			if (initWithTitle == null) 
			{
				initWithTitle = "";
			}
			
			this._title = initWithTitle;
			
			this._message = message;
			this._delegate = delegate;
			this.cancelButtonTitle = cancelButtonTitle;
			this._otherButtonTitles= otherButtonTitles;	
			
																				 
			// setting images default path
			this._backgroundImagePath		=kALERT_WINDOW_BACKGROUND;
			this._okImageNormalPath			=kALERT_WINDOW_OK_NORMAL;
			this._okImageSelectedPath		=kALERT_WINDOW_OK_SELECTED;
		
			this._cancelImageNormalPath	 	=kALERT_WINDOW_OK_NORMAL;
			this._cancelImageSelectedPath	=kALERT_WINDOW_OK_SELECTED;
			
			
			// setting Default type
			this._type = kALERT_WINDOW_TYPE_WITH_CANCEL;
		
			if(cancelButtonTitle == null)
			{
				this._type = kALERT_WINDOW_TYPE;
			}
			
			// setting default colors
			this._buttonsColor="FFD700";
			this._titleColor  ="FFFFFF";
			this._messageColor ="996600";
	    	
			// setting frame of this view
		    this.w = Core.Capabilities.getScreenWidth();										
			this.h =  Core.Capabilities.getScreenHeight();
			
			this.setFrame([0,0,this.h,this.w]);
			
			this.setOnLoad(this.loadView.bind(this));
	},
	
	loadView: function()
	 {
	 	var frame=null;
//	 var x = ((this.h - 356 )/2) - (356/2.4);
//	 var y = ((this.w - 229 )/2) - (229/2.75);
	 	var x = (480/2) - (356/2);
		var y = (320/2) - (229/2);
	 
	 this._backgroundImage = new UI.Image();
	 this._backgroundImage.setImage(this._backgroundImagePath);
	 this._backgroundImage.setImageFit(UI.ViewGeometry.FitModes.Stretch);
	 this._backgroundImage.setFrame([this.getAdjustedY(x),this.getAdjustedX(y),this.adjustHeightWithDevice(356),this.adjustWidthWithDevice(229)]);
	 this.addChild(this._backgroundImage);
													 
		frame=[this.getAdjustedY(x+135),this.getAdjustedX(y+145),this.adjustHeightWithDevice(73),this.adjustWidthWithDevice(37)];
		this._okButton = UIFactory.getGenericButton(frame, this._okImageNormalPath, this._okImageSelectedPath, this._otherButtonTitles,this._buttonsColor,14,this,null);
		this._okButton.setOnClick(this.clickedButtonOk.bind(this));
        if(this._buttonsFont)
			this._okButton.setTextFont(this._buttonsFont);
		this.addChild(this._okButton);
	
		if( this._type == kALERT_WINDOW_TYPE_WITH_CANCEL)
		{

			console.log("ok with cancel");
			frame=[this.getAdjustedY(x+90),this.getAdjustedX(y+145),this.adjustHeightWithDevice(73),this.adjustWidthWithDevice(37)];
			this._okButton.setFrame(frame);
			
			frame=[this.getAdjustedY(x+180),this.getAdjustedX(y+145),this.adjustHeightWithDevice(73),this.adjustWidthWithDevice(37)];
			this._cancelButton = UIFactory.getGenericButton(frame, this._cancelImageNormalPath, this._cancelImageSelectedPath, this.cancelButtonTitle,this._buttonsColor,14,this,null);
			this._cancelButton.setOnClick(this.clickedButtonCancel.bind(this));
            if(this._buttonsFont)
				this._cancelButton.setTextFont(this._buttonsFont);
			this.addChild(this._cancelButton);
			
		}
		
		this._messageLabel = new UI.Label();
		this._messageLabel.setFrame([this.getAdjustedY(x+25),this.getAdjustedX(y+10),this.adjustHeightWithDevice(300),this.adjustWidthWithDevice(150)]);
		this._messageLabel.setTextColor(this._messageColor); 
		this._messageLabel.setTextSize(this.getAdjustedFontSize(100));
		this._messageLabel.setTextGravity(UI.ViewGeometry.Gravity.Left);
		this._messageLabel.setText(this._message);	
		if(this._messageFont)
			this._messageLabel.setTextFont(this._messageFont);
        this.addChild(this._messageLabel);
			
		this._titleLabel = new UI.Label();
		this._titleLabel.setFrame([this.getAdjustedY(x+85),this.getAdjustedX(y+20),this.adjustHeightWithDevice(165),this.adjustWidthWithDevice(30)]);
		this._titleLabel.setTextColor(this._titleColor); 
		this._titleLabel.setTextSize(this.getAdjustedFontSize(100));
		this._titleLabel.setTextGravity(UI.ViewGeometry.Gravity.Center);
		this._titleLabel.setText(this._title);	
  		if(this._titleFont)
			this._titleLabel.setTextFont(this._titleFont);
		this.addChild(this._titleLabel);
		this.editableField = UIFactory.getEditText([this.getAdjustedY(x+75),this.getAdjustedX(y+75),this.adjustHeightWithDevice(200),this.adjustWidthWithDevice(60)], 18, null,UI.EditText.InputTypes.Email, null,"", this._messageColor);
		 //this.editableField.setBackgroundColor(255,255,255);
		 this.editableField.setText(this._textEditText);
   		 if(this._editedFieldFont)
				this.editableField.setTextFont(this._editedFieldFont);
		if(this._changeCallBack != null)
			this.editableField.setOnChange(this._changeCallBack) ;
		 this.addChild(this.editableField);
										 
		
	},
	
	setEditTextOnChange: function(changeMethod) {
		console.log("Moiez Setting the Change Method: ");
		this._changeCallBack = changeMethod ;
	},
												 
	 setText: function(t)
	 {
		this.editableField.setText(t);
	 },
	 getText: function()
	 {
		return this.editableField.getText();
	 },
																
	
	show: function()
	{
		NGWindow.document.addChild(this);
	},
	
	// on click call backs
	clickedButtonOk: function()
	{
		this.clickedButtonAtIndex(0)		
	 return true;
	},
	
	clickedButtonCancel: function()
	{
		this.clickedButtonAtIndex(1)		
	 return true;	
	},
	
	
	clickedButtonAtIndex: function(buttonIndex)
	{
		
		if( this._delegate)		
		{
			this._delegate.clickedButtonAtIndex(buttonIndex,this);
		}
		
		this.destroy();	
		
	},
	
	////////////////////////////////////////////////////////////
	
	//getter
	getTagValue: function()
	{
		return this._tagValue;
	},
	
	
	//setters
	
	setTagValue: function(value)
	{
		this._tagValue = value;
	},
	
	setType : function(type)
	{
		this._type=type;
	},
	setButtonColor : function(color)
	{
		this._buttonsColor=color;
		
	},
    
    setButtonsFont : function(font)
	{
		this._buttonsFont  = font;
	},
	
	setTitleColor : function(color)
	{
		this._titleColor=color;
	},
	
    setTitleFont : function(font)
	{
		this._titleFont  = font;
	},
    
	setMessageColor : function(color)
	{
		this._messageColor=color;
	},

    setMessageFont : function(font)
	{
		this._messageFont =  font;
	},
	
	setEditedTextFont : function(font)
	{
		this._editedFieldFont =  font;
	},
	 
     
	setBackgroundImagePath: function(path)
	{
		this._backgroundImagePath =path;
	},
	
	setOkImageNormalPath: function(path)
	{
		this._okImageNormalPath =path;
	},
	
	setOkImageSelectedPath: function(path)
	{
		this._okImageSelectedPath =path;
	},
	
	setCancelImageNormalPath: function(path)
	{
		this._cancelImageNormalPath =path;
	},
	
	setCancelImageSelectedPath: function(path)
	{
		this._cancelImageSelectedPath =path;
	},
		
	////////////////////////////////////////////////////////////
	
	getAdjustedX: function(x) {
   		
   		var width = 0 , newWidth = 0 ;
   		width = Core.Capabilities.getScreenWidth();
   		newWidth = (width / 320) * x;
   		
       	return newWidth;
   		
   },
    
   getAdjustedY: function(y) 
   {
   		var height = 0 , newHeight = 0;
		height = Core.Capabilities.getScreenHeight();
		newHeight = (height / 480) * y;
      
       return newHeight;
   },
    
	adjustWidthWithDevice: function(aWidth)
	{
		var w = 0, calWidth = 0;
		
		w = Core.Capabilities.getScreenWidth();
		
		calWidth = aWidth * (w/320);
		//////NgLogE('Bandri Width:'+aWidth +'-->'+calWidth +'device W:'+w);
		return calWidth;			
	},
	adjustHeightWithDevice: function(aHeight)
	{
		var h = 0 , calHeight = 0;
		
		h = Core.Capabilities.getScreenHeight();
		
		calHeight = aHeight * (h/480);
		//////NgLogE('Bandri Width:'+aHeight +'-->'+calHeight +'device H:'+h);
		return calHeight;		
		
	},
	
	getAdjustedFontSize: function(fieldHeight) {
        return this.getAdjustedY(fieldHeight / 2) / aspectRatioFactor.d;
    },
	////////////////////////////////////////////////////////////
	
	destroy: function($super)
	{
		// removing from NGWindow
		NGWindow.document.removeChild(this);
		
		// removing childs from this view and destroying them
		
		if(this._titleLabel!=null)
		{
			this.removeChild(this._titleLabel);
			this._titleLabel.destroy();
			this._titleLabel=null;
		}
		
		if(this._messageLabel!=null)
		{
		this.removeChild(this._messageLabel);
		this._messageLabel.destroy();
		this._messageLabel=null;
		}
		
		if(this._cancelButton!=null)
		{
		this.removeChild(this._cancelButton);
		this._cancelButton.destroy();
		this._cancelButton=null;
		}
		
		if(this._backgroundImage!=null)
		{
		this.removeChild(this._backgroundImage);
		this._backgroundImage.destroy();
		this._backgroundImage=null;
		}
		
		
		if( this._okButton != null)
		{	
			this.removeChild(this._okButton);
			this._okButton.destroy();
			this._okButton=null;
		}
	
		
		$super();
		
	}
	
	
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/ngAPI/GACommon/GAUIAlertView'] = function(){var exports = $MODULE_REGISTRY['Code/ngAPI/GACommon/GAUIAlertView'] || {}; $MODULE_REGISTRY['Code/ngAPI/GACommon/GAUIAlertView'] = exports; // CLass Name UIAlertView

// Initializing UIAlertView 
// there are 5 parameters passed to constructor below are the details of parameters
// 1.initWithTitle				: it is first parameter. it will take title string and set UIAlertView title
// 2.message       				: it will take message string and set Message in UiAlertView
// 3.delegate 	   				: setting delegate.
// 4.cancelButtonTitle			: it will take cancel button title string which should be localized string
// 5.otherButtonTitles			: it will take ok button title string which should be localized string

// setter functions
// there are 9 setter function through which you can set button text, title text and message text colors.
// it is also allow you to set background and button normal and highlighted images path
// you can also set type of your alertView and type detail is given below

// there are two type of alert view
// 1."ok" which means UIAlertView with ok button only
// 2."okwithcancel" means UIAlertView with ok and cancel button both 
// by default it takes type "ok"

//Default type for alert window
var kALERT_WINDOW_TYPE = "ok"
var kALERT_WINDOW_TYPE_WITH_CANCEL = "okwithcancel"

//AlertWindow button image default paths
var kALERT_WINDOW_BACKGROUND  = "./Content/images/UIPanels/AlertWindow/alert-background.png"

// Ok buttons
var kALERT_WINDOW_OK_NORMAL ="./Content/images/UIPanels/Buttons/1buttonNormal.png"
var kALERT_WINDOW_OK_SELECTED ="./Content/images/UIPanels/Buttons/1buttonSelected.png"

// Close buttons
var kALERT_WINDOW_CLOSE_NORMAL ="./Content/images/UIPanels/Buttons/cross1.png"
var kALERT_WINDOW_CLOSE_SELECTED ="./Content/images/UIPanels/Buttons/cross2.png"

// Cancel buttons
var kALERT_WINDOW_CANCEL_NORMAL ="./Content/images/UIPanels/Buttons/1buttonNormal.png"
var kALERT_WINDOW_CANCEL_SELECTED ="./Content/images/UIPanels/Buttons/1buttonSelected.png"


exports.GAUIAlertView = UI.View.subclass({
	
	initialize: function(initWithTitle,message,delegate,cancelButtonTitle,otherButtonTitles) 
	{
		
			this.w							= null;
			this.h							= null;
			this._tagValue					= null;
			
			this._title 					= null;
			this._message 					= null;
			this._delegate 					= null;
			this.cancelButtonTitle 			= null;
			this._otherButtonTitles			= null;
			
			this._okButton					= null;
			this._closeButton				= null;
			this._cancelButton 				= null;
			this._messageLabel 	    		= null;
			this._titleLabel	    		= null;
			this._backgroundImage 			= null;
			this._type						= null;
			
			this._backgroundImagePath		= null;
			this._okImageNormalPath 		= null;
			this._okImageSelectedPath 		= null;
			this._cancelImageNormalPath		= null;
			this._cancelImageSelectedPath	= null;
	    	
	    	this._buttonsColor				=null;
         	this._buttonsFont				=null;
	    	this._titleColor				=null;
         	this._titleFont					=null;
	    	this._messageColor				=null;
            this._messageFont 				=null;
	    	this._scrollView 				=null;

			
			// initializing data members with parameters 
			if (initWithTitle == null) 
			{
				initWithTitle = "";
			}
			
			if (initWithTitle.length > 11) 
			{
				this._title = initWithTitle.substring(0, 10);
			} 
			else 
			{
				this._title = initWithTitle;
			}
			
			this._message = message;
			this._delegate = delegate;
			this.cancelButtonTitle = cancelButtonTitle;
			this._otherButtonTitles= otherButtonTitles;	
			
																				 
			// setting images default path
			this._backgroundImagePath		=kALERT_WINDOW_BACKGROUND;
			this._okImageNormalPath			=kALERT_WINDOW_OK_NORMAL;
			this._okImageSelectedPath		=kALERT_WINDOW_OK_SELECTED;
			
			this._closeImageNormalPath		=kALERT_WINDOW_CLOSE_NORMAL;
			this._closeImageSelectedPath	=kALERT_WINDOW_CLOSE_SELECTED;
		
			this._cancelImageNormalPath	 	=kALERT_WINDOW_CANCEL_NORMAL;
			this._cancelImageSelectedPath	=kALERT_WINDOW_CANCEL_SELECTED;
			
			
			// setting Default type
			this._type = kALERT_WINDOW_TYPE_WITH_CANCEL;
		
			if(cancelButtonTitle == null)
			{
				this._type = kALERT_WINDOW_TYPE;
			}
			
			// setting default colors
			this._buttonsColor="FFD700";
			this._titleColor  ="FFFF00";
			this._messageColor ="996600";
	    	
			// setting frame of this view
			this.w = Core.Capabilities.getScreenWidth();
			this.h = Core.Capabilities.getScreenHeight();
			
			this.setFrame([0,0,this.h,this.w]);
			
			this.setOnLoad(this.loadView.bind(this));
	},
	
	loadView: function()
	 {
	 	var frame=null;
	 	var x = (480/2) - (356/2);
		var y = (320/2) - (229/2);		
        
		this._backgroundImage = new UI.Image();
		this._backgroundImage.setImage(this._backgroundImagePath);
		this._backgroundImage.setImageFit(UI.ViewGeometry.FitModes.Stretch);
		this._backgroundImage.setFrame([this.getAdjustedY(x),this.getAdjustedX(y),this.adjustHeightWithDevice(356),this.adjustWidthWithDevice(229)]);
		this.addChild(this._backgroundImage);
		
			
		frame=[this.getAdjustedY(x+135),this.getAdjustedX(y+155),this.adjustHeightWithDevice(73),this.adjustWidthWithDevice(37)];
		this._okButton = UIFactory.getGenericButton(frame, this._okImageNormalPath, this._okImageSelectedPath, this._otherButtonTitles,this._buttonsColor,14,this,null);
		this._okButton.setOnClick(this.clickedButtonOk.bind(this));
        if(this._buttonsFont)
			this._okButton.setTextFont(this._buttonsFont);

		this.addChild(this._okButton);
		if(userMenuCloseButton==true)
		{
			frame=[this.getAdjustedY(x+335),this.getAdjustedX(y-10),this.adjustHeightWithDevice(32),this.adjustWidthWithDevice(32)];
			this._closeButton = UIFactory.getGenericButton(frame, this._closeImageNormalPath, this._closeImageSelectedPath, null,null,null,this,null);
			this._closeButton.setOnClick(this.clickedButtonClose.bind(this));
			this.addChild(this._closeButton);
			userMenuCloseButton = false;
		}
			
	
		if( this._type == kALERT_WINDOW_TYPE_WITH_CANCEL)
		{

			console.log("ok with cancel");
			frame=[this.getAdjustedY(x+90),this.getAdjustedX(y+145),this.adjustHeightWithDevice(73),this.adjustWidthWithDevice(37)];
			this._okButton.setFrame(frame);
			
			frame=[this.getAdjustedY(x+180),this.getAdjustedX(y+145),this.adjustHeightWithDevice(73),this.adjustWidthWithDevice(37)];
			this._cancelButton = UIFactory.getGenericButton(frame, this._cancelImageNormalPath, this._cancelImageSelectedPath, this.cancelButtonTitle,this._buttonsColor,14,this,null);
			this._cancelButton.setOnClick(this.clickedButtonCancel.bind(this));
            if(this._buttonsFont)
				this._cancelButton.setTextFont(this._buttonsFont);

			this.addChild(this._cancelButton);
			
		}
        
        	var numberOfLines = this._message.length/ 40;
			console.log ('Length ' + this._message.length);
			console.log ('Lines ' + numberOfLines);
			var fontSize  = this.getAdjustedFontSize(80);
			var height = (fontSize * numberOfLines);//*2;
			var height  = height + 20; //GAP
			console.log ('height ' + height);
			
			this._scrollView = new UI.ScrollView();
			this._scrollView.setFrame([this.getAdjustedY(x+25),this.getAdjustedX(y+20),this.adjustHeightWithDevice(300),this.adjustWidthWithDevice(120)]);
			this._scrollView.setContentSize([this.adjustHeightWithDevice(300), this.adjustWidthWithDevice(height)]);
			this.addChild(this._scrollView);
		
			this._messageLabel = new UI.Label();
			this._messageLabel.setFrame([0,0,this.adjustHeightWithDevice(300),this.adjustWidthWithDevice(height)]);

			this._messageLabel.setTextColor(this._messageColor); 
			this._messageLabel.setTextSize(fontSize);
			this._messageLabel.setTextGravity(UI.ViewGeometry.Gravity.Center);
			this._messageLabel.setText(this._message);
			if(this._messageFont)
				this._messageLabel.setTextFont(this._messageFont);
			this._scrollView.addChild(this._messageLabel);

			
			this._titleLabel = new UI.Label();
			this._titleLabel.setFrame([this.getAdjustedY(x+120),this.getAdjustedX(y+190),this.adjustHeightWithDevice(100),this.adjustWidthWithDevice(30)]);
			this._titleLabel.setTextColor(this._titleColor); 
			this._titleLabel.setTextSize(this.getAdjustedFontSize(75));
			this._titleLabel.setTextGravity(UI.ViewGeometry.Gravity.Center);
			this._titleLabel.setText(this._title);	
            if(this._titleFont)
				this._titleLabel.setTextFont(this._titleFont);
			this.addChild(this._titleLabel);
		
	},
	
	show: function()
	{
		NGWindow.document.addChild(this);
	},
	
	// on click call backs
	clickedButtonOk: function()
	{
		this.clickedButtonAtIndex(0)		
	 return true;
	},
	
	clickedButtonCancel: function()
	{
		this.clickedButtonAtIndex(1)		
	 return true;	
	},
	
	clickedButtonClose: function()
	{
		this.clickedButtonAtIndex(2)		
	 	return true;
	},
	
	clickedButtonAtIndex: function(buttonIndex)
	{
		
		if( this._delegate)		
		{
			this._delegate.clickedButtonAtIndex(buttonIndex,this);
		}
		
		this.destroy();	
		
	},
	
	////////////////////////////////////////////////////////////
	
	//getter
	getTagValue: function()
	{
		return this._tagValue;
	},
	
	
	//setters
	
	setTagValue: function(value)
	{
		this._tagValue = value;
	},
	
	setType : function(type)
	{
		this._type=type;
	},
	setButtonColor : function(color)
	{
		this._buttonsColor=color;
		
	},
    
    setButtonsFont : function(font)
	{
		this._buttonsFont =  font;
	},
	
	setTitleFont : function(font)
	{
		this._titleFont  = font;
	},
	
	
	setTitleColor : function(color)
	{
		this._titleColor=color;
	},
	
    setMessageFont : function(font)
	{
		this._messageFont =  font;
	},
    
	setMessageColor : function(color)
	{
		this._messageColor=color;
	},

	setBackgroundImagePath: function(path)
	{
		this._backgroundImagePath =path;
	},
	
	setOkImageNormalPath: function(path)
	{
		this._okImageNormalPath =path;
	},
	
	setOkImageSelectedPath: function(path)
	{
		this._okImageSelectedPath =path;
	},
	
	setCancelImageNormalPath: function(path)
	{
		this._cancelImageNormalPath =path;
	},
	
	setCancelImageSelectedPath: function(path)
	{
		this._cancelImageSelectedPath =path;
	},
		
	////////////////////////////////////////////////////////////
	
	getAdjustedX: function(x) {
   		
   		var width = 0 , newWidth = 0 ;
   		width = Core.Capabilities.getScreenWidth();
   		newWidth = (width / 320) * x;
   		
       	return newWidth;
   		
   },
    
   getAdjustedY: function(y) 
   {
   		var height = 0 , newHeight = 0;
		height = Core.Capabilities.getScreenHeight();
		newHeight = (height / 480) * y;
      
       return newHeight;
   },
    
	adjustWidthWithDevice: function(aWidth)
	{
		var w = 0, calWidth = 0;
		
		w = Core.Capabilities.getScreenWidth();
		
		calWidth = aWidth * (w/320);
		//////NgLogE('Bandri Width:'+aWidth +'-->'+calWidth +'device W:'+w);
		return calWidth;			
	},
	adjustHeightWithDevice: function(aHeight)
	{
		var h = 0 , calHeight = 0;
		
		h = Core.Capabilities.getScreenHeight();
		
		calHeight = aHeight * (h/480);
		//////NgLogE('Bandri Width:'+aHeight +'-->'+calHeight +'device H:'+h);
		return calHeight;		
		
	},
	
	getAdjustedFontSize: function(fieldHeight) {
        return this.getAdjustedY(fieldHeight / 2) / aspectRatioFactor.d;
    },
	////////////////////////////////////////////////////////////
	
	destroy: function($super)
	{
		// removing from NGWindow
		NGWindow.document.removeChild(this);
		
		// removing childs from this view and destroying them
		
		if(this._titleLabel!=null)
		{
			this.removeChild(this._titleLabel);
			this._titleLabel.destroy();
			this._titleLabel=null;
		}
		
		if(this._messageLabel!=null)
		{
		this.removeChild(this._messageLabel);
		this._messageLabel.destroy();
		this._messageLabel=null;
		}
		
		if(this._cancelButton!=null)
		{
		this.removeChild(this._cancelButton);
		this._cancelButton.destroy();
		this._cancelButton=null;
		}
		
		if(this._backgroundImage!=null)
		{
		this.removeChild(this._backgroundImage);
		this._backgroundImage.destroy();
		this._backgroundImage=null;
		}
		
		
		if( this._okButton != null)
		{	
			this.removeChild(this._okButton);
			this._okButton.destroy();
			this._okButton=null;
		}
	
		
		$super();
		
	}
	
	
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/ngAPI/GACommon/GAFileDownloader'] = function(){var exports = $MODULE_REGISTRY['Code/ngAPI/GACommon/GAFileDownloader'] || {}; $MODULE_REGISTRY['Code/ngAPI/GACommon/GAFileDownloader'] = exports; 
exports.GAFileDownloader = Core.Class.subclass({
    classname: 'GAFileDownloader',
    initialize: function(filename, method, url, headers, delegate) {
        this._filename = filename;
        this._method = method;
        this._url = url;
        this._headers = headers;
        this._delegate = delegate;
        this._started = false;
    },
    startDownloading: function() {  
        this._downloader = new Network.DownloadFile();
        this._downloader.start(this._filename,this._method, this._url, this._headers, this._doneCb.bind(this));
        this._started = true;
    },
    _doneCb: function(statusCode,fileSignature) {
    	this._started = false;
    	if(this._delegate != null){
	        if(statusCode == httpStatus.HTTP_STATUS_SUCCESS_OK){
	        	this._delegate.onDownloadSuccess(this, fileSignature);
	        }
	        else {
	        	this._delegate.onDownloadFailure(this, statusCode);
	        }
        }
    },
    invalidate: function (){
    	if(this._downloader != null){
    		if (this._started == true) {
    			this._downloader.abort();
    		}
    		this._downloader = null;
    	}
    },
    destroy: function() {
        this._filename = null;
        this._method = null;
        this.invalidate();
        this._url = null;
        this._headers = null;
        this._delegate = null;
        this._filename = null;
        this._method = null;
        this._url = null;
        this._headers = null;
        this._delegate = null;
 
    }
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/ngAPI/GACommon/GAConfigurations'] = function(){var exports = $MODULE_REGISTRY['Code/ngAPI/GACommon/GAConfigurations'] || {}; $MODULE_REGISTRY['Code/ngAPI/GACommon/GAConfigurations'] = exports; /**
 * @author abid.hussain
 */
exports.GAConfigurations = Core.Class.singleton({

	classname : 'GAConfigurations',
	
	intialize : function()
	{
			this._udid = null;
			this._responseObject = null;
			this._gameCode=null;
			this._deviceType = null;
			this._osVersion = null;
			this._deviceName = null;
			this._gameVersion = null;
			this._gameName = null;
			this._gameFamily = null; 
			this._url = null;
			this._gameStateDBPath = null;
			this._gameFamilyId= null;
			this._gameFlavor=null;
			this._resourcesBasePath = null;
			this._userId = null;
			this._dbFileNames = null;
			this._level = 1;
			this._experience = 0;
	},

	setGapiConfiguration : function(gameCode,gameVersion,gameName, gameFamily, url, gamePath, resourcesBasePath,fileNames)
	{
		var errorMsg = null;
		if(typeof(gameCode) == 'undefined' || gameCode == "") {
			errorMsg = "\n - Game code cannot be empty";
		}
		if(typeof(gameName) == 'undefined' || gameName == "") {
			errorMsg = "\n - Game name cannot be empty";
		}
		if(typeof(gameFamily) == 'undefined' || gameFamily == "") {
			errorMsg = "\n - Game Family cannot be empty";
		}
		if(typeof(gameVersion) == 'undefined' || gameVersion < 0.0) {
			errorMsg = "\n - Game Version cannot less than 0.0";
		}
		if(typeof(url) == 'undefined' || url == "") {
			errorMsg = "\n - Game Connect URL can not be empty";
		}
		if(typeof(gamePath) == 'undefined' || gamePath == ""){
			errorMsg = "\n - GameState DB path can not be empty";
		}
		if(typeof(resourcesBasePath) == 'undefined' || resourcesBasePath ==""){
			errorMsg = "\n - resourcesBasePath can not be empty";
		}
		if(typeof(fileNames) == 'undefined' || fileNames == ""){
			
			errorMsg = "\n - fileNames parameter can not be empty";
		}
		if (errorMsg != null) {
			throw errorMsg;
		}
		this._udid= Capabilities.getUniqueId();
		this._deviceType = Capabilities.getPlatformOS().toLowerCase() ;
		this._osVersion =  Capabilities.getPlatformOSVersion();
		this._deviceName=Capabilities.getDeviceName();
		this._gameCode = gameCode;
		this._gameVersion = gameVersion;
		this._gameName = gameName;
		this._gameFamily = gameFamily;
		this._url = url;
		this._gameStateDBPath = gamePath;
		this._gameFamilyId= '1';  	// Game Family id is hard coded temporarily
		this._resourcesBasePath = resourcesBasePath;
		this._dbFileNames = fileNames;
		this._userInfo();
	},
	_userInfo: function(){
		var user = Social.US.Session.getCurrentSession().user();
		this._userId = user.gamertag;
				

	},
	getUdid : function(){
		return this._udid;
	},
	getGameStateDBPath: function(){
		return this._gameStateDBPath;
	},
	getDeviceType: function(){
		return this._deviceType;
	},
	getDeviceName: function(){
		return this._deviceName;
	},
	getOsVersion: function(){
		return this._osVersion;
	},
	getGameCode: function(){
		return this._gameCode ;
	},
	getGameVersion: function(){
		return this._gameVersion;
	},
	getGameName: function(){
		return this._gameName;
	},
	getGameFamily : function(){
		return this._gameFamily;
	},
	getURL : function(){
		return this._url;
	},
	getGameFamilyId: function(){
		return this._gameFamilyId;
	},
	getResourcesBasePath: function() {
		return this._resourcesBasePath;
	},
	getUserId: function(){
		return this._userId;
	},
	getDbFileNames: function(){
		return this._dbFileNames;
	},
	getUserGameStateDBPath: function(){
		var path = this._gameStateDBPath + "/" + this._userId;
		return path;
	},
	getGameXp: function(){
		return this._experience;
	},
	getGameLevel: function(){
		return this._level;
	},
	setDbFileNames: function(filenames){
		this._dbFileNames = filenames;
	},
	setGameXp: function(xp){
		this._experience = xp;
	},
	setGameLevel: function(level){
		this._level = level;
	},
	destroy : function(){
		this._udid = null;
		this._responseObject = null;
		this._deviceType = null;
		this._osVersion = null;
		this._gameVersion = null;
		this._gameName = null;
		this._gameFamily = null; 
		this._url = null;
		this._gameStateDBPath = null;
		this._userId = null;
		this.doneCallback = null;
		this._level = null;
		this._experience = null;
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/ngAPI/GACommon/GAIsoMetricConfigurations'] = function(){var exports = $MODULE_REGISTRY['Code/ngAPI/GACommon/GAIsoMetricConfigurations'] || {}; $MODULE_REGISTRY['Code/ngAPI/GACommon/GAIsoMetricConfigurations'] = exports; /**
 * @author Salman Humdullah
 */
exports.GAIsoMetricConfigurations = Core.Class.singleton({

	classname : 'GAIsoMetricConfigurations',
	
	intialize : function() {
			this._patchImageWidth = null;
			this._patchImageHeight = null;
			this._GRID_SIZE = null;
			this._MAX_GRID_ROWS = null;
			this._patch_path = null;
			this._bg_path = null;
			this._ZOOM_IN_FACTOR = null;
			this._ZOOM_OUT_FACTOR = null;
			this._patchTransparency = null;
			this._cellWidthOffset = null;
			this._cellHeightOffset = null;
			this.USERLAYER_CELL_WIDTH = null;
			this.USERLAYER_CELL_HEIGHT = null;
			this.DIAMOND_LAYER_MARGIN_WIDTH = null;
			this.DIAMOND_LAYER_MARGIN_HEIGHT = null;

	},
	setGapiIsoMetricViewConfiguration : function (gridSize, gridRows,patchPath,bgPath, zoomInFactor,zoomOutFactor, patchTransparency, widthOffset, heightOffset, userLayerCellWidthNumerator, userLayerCellHeightNumerator, diamondLayerMarginWidth, diamondLayerMarginHeight){
//		this._patchImageWidth = patchWidth;
//		this._patchImageHeight = patchHeight;
		this._patchImageWidth = 128;
		this._patchImageHeight = 64;
		if(typeof userLayerCellWidthNumerator != 'undefined' && userLayerCellWidthNumerator != null){
			this.USERLAYER_CELL_WIDTH =  (userLayerCellWidthNumerator/(2*4));
		}else{
			this.USERLAYER_CELL_WIDTH =  (123/(2*4));
		}
		
		if(typeof userLayerCellHeightNumerator != 'undefined' && userLayerCellHeightNumerator != null){
			this.USERLAYER_CELL_HEIGHT = (userLayerCellHeightNumerator/(2*4)); //32
		}else{
			this.USERLAYER_CELL_HEIGHT = (63/(2*4)); //32
		}
		
		if(typeof diamondLayerMarginWidth != 'undefined' && diamondLayerMarginWidth != null){
			this.DIAMOND_LAYER_MARGIN_WIDTH = diamondLayerMarginWidth;
		}else{
			this.DIAMOND_LAYER_MARGIN_WIDTH = 600;
		}
		
		if(typeof diamondLayerMarginHeight != 'undefined' && diamondLayerMarginHeight != null){
			this.DIAMOND_LAYER_MARGIN_HEIGHT = diamondLayerMarginHeight;
		}else{
			this.DIAMOND_LAYER_MARGIN_HEIGHT = 600;
		}
//		this.USERLAYER_CELL_WIDTH =  (120/(2*4));
//		this.USERLAYER_CELL_HEIGHT = (55/(2*4)); //32
//		this.DIAMOND_LAYER_MARGIN_WIDTH = 700;
//		this.DIAMOND_LAYER_MARGIN_HEIGHT = 750;

		
		gridSize.setX(gridSize.getX() * 4);
		gridSize.setY(gridSize.getY() * 4);
		
		this._GRID_SIZE = gridSize;
		
		this._MAX_GRID_ROWS = (gridRows * 4);
		this._patch_path = patchPath;
		this._bg_path = bgPath;
		this._ZOOM_IN_FACTOR = zoomInFactor;
		this._ZOOM_OUT_FACTOR = zoomOutFactor;
		this._patchTransparency = patchTransparency;
		this._cellWidthOffset = widthOffset;
		this._cellHeightOffset = heightOffset;
//		console.log("---===Log: setGapiIsoMetricViewConfiguration : iW" + 		this._patchImageWidth +
//		this._patchImageHeight +		this._GRID_SIZE +  this._MAX_GRID_ROWS +
//		this._patch_path + this._bg_path +  this._ZOOM_IN_FACTOR + this._ZOOM_OUT_FACTOR);

	},
	getPatchWidth: function (){
		return this._patchImageWidth;
	},
	setPatchWidth: function (patchWidth){
		this._patchImageWidth = patchWidth;
	},
	getPatchHeight: function (){
		return this._patchImageHeight;
	},
	setPatchHeight: function (patchHeight){
		this._patchImageHeight = patchHeight;
	},
	getGridSize: function (){
		return this._GRID_SIZE;
	},
	setGridSize: function (size){
		this._GRID_SIZE = size;
	},	
	getMaxGridRows: function (){
		return this._MAX_GRID_ROWS;
	},
	getPatchPath: function (){
		return this._patch_path;
	},
	getBgPath: function (){
		return this._bg_path;
	},
	getZoomInFactor: function (){
		return this._ZOOM_IN_FACTOR;
	},
	getZoomOutFactor: function (){
		return this._ZOOM_OUT_FACTOR;
	},
	getPatchTransparency : function (){
		return this._patchTransparency;
	},
	getCellWidthOffset : function(){
		return this._cellWidthOffset;
	},
	getCellHeightOffset : function() {
		return this._cellHeightOffset;
	},
	destroy : function(){
		this._patchImageWidth = null;
		this._patchImageHeight = null;
		this._GRID_SIZE = null;
		this._MAX_GRID_ROWS = null;
		this._patch_path = null;
		this._bg_path = null;
		this._ZOOM_IN_FACTOR = null;
		this._ZOOM_OUT_FACTOR = null;
		this._patchTransparency = null;
		this._cellWidthOffset = null;
		this._cellHeightOffset = null;

	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/ngAPI/GACommon/GAAudioManager'] = function(){var exports = $MODULE_REGISTRY['Code/ngAPI/GACommon/GAAudioManager'] || {}; $MODULE_REGISTRY['Code/ngAPI/GACommon/GAAudioManager'] = exports; var BACKGROUND_MUSIC = 'BACKGROUND_MUSIC';
var TICK_SOUND = 'TICK_SOUND';
var TRUE_STRING  = 'TRUE';
var FALSE_STRING = 'FALSE';
var CLEAN_SOUND = 'CLEAN_SOUND';

//------Change Start------
var strBG = FALSE_STRING;
var strCS = FALSE_STRING;
var strTS = FALSE_STRING;
//------Change End------

exports.GAAudioManager = Core.Class.singleton({
    classname: 'GAAudioManager',
    initialize: function() {
      //  this._click = new Audio.ActiveEffect(new Audio.Effect('./Content/audio/trampoline.caf'));
        this._tickEffect = null;       
        this._storage = new Storage.KeyValue();
 		this._bgPath = null;
		this._tickPath = null;
        this._cleanEffect = null;
		this._cleanMusicPath = null;
   },
	playBgMusic: function() {
    	if(this._bgPath != null){
			var myself = this;
			this._storage.getItem(BACKGROUND_MUSIC,this._callBack.bind(this));
    	}
    	else{
    		console.log("GAAudioManager::playBgMusic Path not set");
    	}
    },
    setBGMusicPath : function(path){
    	if(path != null && path.length != 0){
    		this._bgPath = path;
    		 Audio.Music.setPath(path);
    	}else{
    		console.log("GAAudioManager::setBGMusicPath path is  not deffined");
    	}
    }, 
    setTickMusicPath : function(path){
    	if(path != null && path.length != 0){
    		this._tickPath = path;
    		if(this._tickEffect != null ){
    			delete this._tickEffect;
    			this._tickEffect = null;
    		}
    		this._tickEffect = new Audio.ActiveEffect(new Audio.Effect(path));
    	}else{
    		console.log("GAAudioManager::setTickMusicPath path is  not deffined");
    	}
    },
    
    isBackgroundSoundPlaying: function () {
    	if(Audio.Music.getIsPlaying()) {
    		return true;
    	}
    	return false;
    },
    
    setCleanMusicPath : function(path){
    	if(path != null && path.length != 0){
			this._cleanMusicPath = path;
    		if(this._cleanEffect != null ){
    			delete this._cleanEffect;
    			this._cleanEffect = null;
    		}
    		this._cleanEffect = new Audio.ActiveEffect(new Audio.Effect(path));
    	}else{
    		console.log("GAAudioManager::setCleanMusicPath path is  not deffined");
    	}
    },
    pauseBgMusic: function() {
    	Audio.Music.pause();
    },
    stopBgMusic: function() {
    	//console.log("GAAudioManager::stopBgMusic");
		GAAudioManager._storage.setItem(BACKGROUND_MUSIC,FALSE_STRING);
    	Audio.Music.stop();
    },
    _callBack : function(error, value, key) {
    	//console.log("GAAudioManager::callBack  error, value, key " + error +  value + key);
    	GAAudioManager._music = false;
    	if(value == null) {
    		Audio.Music.play();
    		GAAudioManager._music = true;
    	}
    	else if(value == TRUE_STRING ) {
    		Audio.Music.play();
    		GAAudioManager._music = true;
    	}
		//GAAudioManager._storage.setItem(BACKGROUND_MUSIC,TRUE_STRING);
    },
//    toggleBackgroundMusic :function() {
//    	//console.log("GAAudioManager::toggleBackgroundMusic");
//    	var toggleValue = !(GAAudioManager._music);
//		var str = FALSE_STRING;
//    	if(toggleValue) {
//    		str = TRUE_STRING;
//    		Audio.Music.play();
//    	}
//    	else {
//    		Audio.Music.stop();
//    	}
//    	GAAudioManager._music= toggleValue;
//    	this._storage.setItem(BACKGROUND_MUSIC,str);
//    },
//        toggleTickSound :function() {
//    	console.log("GAAudioManager::toggleTickSound");
//    	//var toggleValue = !(GAAudioManager._music);
//		var str = FALSE_STRING;
//    	if(GAAudioManager._music) {
//    		str = TRUE_STRING;
//    		//Audio.Music.play();
//    	}
////    	else {
////    		Audio.Music.stop();
////    	}
//    	//GAAudioManager._music= toggleValue;
//    	this._storage.setItem(TICK_SOUND,str);
//    },
//     toggleCleanSound :function() {
//    	console.log("GAAudioManager::toggleCleanSound");
//    	
//		var str = FALSE_STRING;
//    	if(GAAudioManager._music) {
//    		str = TRUE_STRING;
//    	}
//
//    	this._storage.setItem(CLEAN_SOUND,str);
//    },
    

    toggleBackgroundMusic :function() {
    	//console.log("GAAudioManager::toggleBackgroundMusic");
    	var toggleValue = !(GAAudioManager._music);
		strBG = FALSE_STRING;
    	if(toggleValue) {
    		strBG = TRUE_STRING;
    		Audio.Music.play();
    	}
    	else {
    		Audio.Music.stop();
    		//Audio.Music.pause();
    	}
    	GAAudioManager._music= toggleValue;
    	//console.log("sound GAAudioManager._music "+GAAudioManager._music);
    	//this._storage.setItem(BACKGROUND_MUSIC,strBG);
    },
    
    
    toggleTickSound :function() {
    	//console.log("GAAudioManager::toggleTickSound");
    	//var toggleValue = !(GAAudioManager._music);
		strTS = FALSE_STRING;
		//console.log("sound GAAudioManager._music "+GAAudioManager._music);
    	if(GAAudioManager._music) {
    		strTS = TRUE_STRING;
//			Audio.Music.play();
    	}
//    	else {
//    		Audio.Music.stop();
//    	}
//		GAAudioManager._music= toggleValue;
    	//this._storage.setItem(TICK_SOUND,strTS);
    },
    
    storageFunc: function(){
    	
    	//Added by Ahsan
    	//console.log("sound storage func called");
    	
    	this._storage.setItem(CLEAN_SOUND,strCS);
    	this._storage.setItem(TICK_SOUND,strTS);
    	this._storage.setItem(BACKGROUND_MUSIC,strBG);
    	//console.log("sound storage func ends");	
    },
    

     toggleCleanSound :function() {
    	 //console.log("sound GAAudioManager._music "+GAAudioManager._music);
    	console.log("GAAudioManager::toggleCleanSound");
    	
		strCS = FALSE_STRING;
    	if(GAAudioManager._music) {
    		strCS = TRUE_STRING;
    	}

    	//this._storage.setItem(CLEAN_SOUND,strCS);
    },
    
    
    /* added by Kashmala Zafar */
    initializeSoundEffect :function() {
    	//console.log("GAAudioManager::initializeSoundEffect");
    	this._storage.getItem(TICK_SOUND,this._callBackInitializeSound.bind(this));
    },
    _callBackInitializeSound :function(error, value, key) {
    	this._playTickSound = true;
    	if(value == FALSE_STRING) {
    		this._playTickSound = false;
    	}
    },
    /* end added by Kashmala Zafar */
    toggleSoundEffect :function() {
    	//console.log("GAAudioManager::toggleSoundEffect");
    	this._storage.getItem(TICK_SOUND,this._callBackToggleSound.bind(this));
    },
	_callBackToggleSound : function(error, value, key){
    	this._playTickSound = !(this._playTickSound);//kz
		var str = FALSE_STRING;
		if(value == null) {
			str = TRUE_STRING;
			this._playTickSound = true;//kz
    	}
    	else if(value == FALSE_STRING) {
    		str = TRUE_STRING;
    	}
    	this._storage.setItem(TICK_SOUND,str);   	
    },
    playTickSound: function() {    	
    	if(this._tickPath !=null){
    		this._storage.getItem(TICK_SOUND,this._callBackPlayTickSound.bind(this));
    	}else{
    		console.log("GAAudioManager::playTickSound Path not set");
    	}
    },
    playCleanSound: function() {    	
    	if(this._cleanMusicPath !=null){
    		this._storage.getItem(CLEAN_SOUND,this._callBackPlayCleanSound.bind(this));
    	}else{
    		console.log("GAAudioManager::playCleanSound Path not set");
    	}
    },
    disableCleanSound: function() {    	
    	this._cleanMusicPath = null;
    	this._cleanEffect = null;
    	
    },
    isCleanSoundEnabled: function() {    	
    	if(this._cleanMusicPath != null && this._cleanEffect != null)
    	{
    		return true;
    	}
    	else
    	{
    		return false;
    	}
    },
    _callBackPlayTickSound : function(error, value, key){
      if(value == null || value == TRUE_STRING){
			if(this._tickEffect) {
				this._tickEffect.play();
			}else{	
				console.log("GAAudioManager::playTickSound _tickEffect is not deffined");
			}
    	}
    },
    _callBackPlayCleanSound : function(error, value, key){
    	//console.log("_callBackPlayCleanSound is -> "+value);
    	//console.log("_cleanEffect is -> "+this._cleanEffect);
    	if(value == null || value == TRUE_STRING){
			if(this._cleanEffect) {
				this._cleanEffect.play();
			}else{	
				console.log("GAAudioManager::playCleanSound _cleanEffect is not defined");
			}
    	}
    },
    mute : function(){
    	//console.log("GAAudioManager::mute");
    	this.pauseBgMusic();
//    	this._tickEffect = null;
    },
    unmute : function() {
    	//console.log("GAAudioManager::unMute");
//    	this.setTickMusicPath(this._tickPath);
    	this._storage.getItem(BACKGROUND_MUSIC,this._callBackToggle.bind(this));
    },
    _callBackToggle : function(error, value, key){
    	//console.log("GAAudioManager::callBackToggle  error, value, key " + error +  value + key);
    	GAAudioManager._music = false;
    	if(value == null) {
    		Audio.Music.play();
    		GAAudioManager._music = true;
    	}
    	else if(value == TRUE_STRING ) {
    		Audio.Music.play();
    		GAAudioManager._music = true;
    	}
    },
    destroy : function() {
    	//console.log("GAAudioManager::destroy");
    	delete this._tickEffect;
    	this._tickEffect = null
    	this._tick.destroy();
    	this._tick = null;
    	this._storage = null;
        delete this._cleanEffect;
    	this._cleanEffect =null;
    }
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/ngAPI/GACommon/GACopyManager'] = function(){var exports = $MODULE_REGISTRY['Code/ngAPI/GACommon/GACopyManager'] || {}; $MODULE_REGISTRY['Code/ngAPI/GACommon/GACopyManager'] = exports; /**
 * Filename: GACopyManager.js
 * Author: Abid Hussain
 * Date Created: 13/07/2011
 */
exports.GACopyManager = Core.Class.singleton({
	classname: 'GACopyManager',
	initialize: function(){
		this._readCount = 0;
		this._writeCount = 0;
		this._deleteCount = 0;
		this._totalFiles = 0;
		this._readError = false;
		this._writeError = false;
		this._deleteError = false;
	},
	copy: function(fileNames, sourcePath ,destPath, deleteSourceFiles, progressCallback, doneCallback, errorCallback){
		this._fileNames= fileNames;
		this._sourcePath = sourcePath;
		this._destPath = destPath;
		this._deleteSourceFiles = deleteSourceFiles;
		this.progressCallback = progressCallback;
		this.doneCallback = doneCallback;
		this.errorCallback = errorCallback;
		this._totalFiles = this._fileNames.length;
		for(var count = 0; count < this._totalFiles; count++){
			var name = this._fileNames[count];
			this._readFile(name);
		}
	},
	_readFile: function(filename){
		var path = this._sourcePath + "/" + filename;
		Storage.FileSystem.readFile(path, false, this._readFileCallback.bind(this, filename));
	},
	_readFileCallback: function(filename,error,contents){
		this._readCount ++;
		if(!error){
			this._writeFile(filename,contents);
		}
		else{
			this._readError = true;
		}
		if(this._readCount == this._totalFiles){
			this._readCount = 0;
			if(this._readError){
				this._readError = false;
				this.errorCallback();
			}
		}
	},
	
	_writeFile: function(filename,contents){
		var path = this._destPath+"/"+filename; 
		Storage.FileSystem.writeFile(path, contents, false, this._writeFileCallback.bind(this))
	},
	
	_writeFileCallback: function(error){
		this._writeCount ++;
		if(error){
			this._writeError = true;
		}
		else{
			this.progressCallback(this._writeCount, this._totalFiles);
		}
		if( this._writeCount == this._totalFiles){
			this._writeCount = 0;
			if(this._writeError){
				this._writeError = false;
				this.errorCallback();
			}
			else{
				if(this._deleteSourceFiles){
					this._deleteFiles();
				}
				else{
					this.doneCallback();
				}
			}
		}
	},
	
	_deleteFiles: function(){
		for(var i=0; i<this._totalFiles; i++){
			var path = this._sourcePath + "/" + this._fileNames[i];
			Storage.FileSystem.deleteFile(path,this._deleteFileCallback.bind(this));
		}
	},
	
	_deleteFileCallback: function(error,data){
		this._deleteCount ++;
		if(error){
			this._deleteError = true;
		}
		if( this._deleteCount == this._totalFiles ){
			this._deleteCount = 0;
			if(this._deleteError){
				this._deleteError = false;
				this.errorCallback();
			}
			else{
				this.doneCallback();
			}
		}
	},
	
	destroy: function(){
		this._readCount = null;
		this._writeCount = null;
		this._totalFiles = null;
		this._readError = null;
		this._writeError = null;
		this._fileNames= null;
		this._sourcePath = null;
		this._destPath = null;
		this.progressCallback = null;
		this.doneCallback = null;
		this.errorCallback = null;
		this._deleteCount = null;
		this._deleteError = null;
		this._deleteSourceFiles = null;
	}
	
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/ngAPI/GACommon/GACompressionManager'] = function(){var exports = $MODULE_REGISTRY['Code/ngAPI/GACommon/GACompressionManager'] || {}; $MODULE_REGISTRY['Code/ngAPI/GACommon/GACompressionManager'] = exports; /**
 * 
 */
exports.GACompressionManager = Core.Class.singleton({
	classname: "GACompressionManager",
	initialize: function(){
		this._files = [];
	},
	compressFiles: function(filesDataList)
	{

		   asBytes = false;
		   var files = [];
		   for( var fileName in filesDataList){
			   this._add(fileName,filesDataList[fileName].data);
		   }

		   // The central directory, and files data
		   var directory = [];
		   var fileOffset = 0;

		   for (var name in this._files)
		   {
			   
		      if( !this._files.hasOwnProperty(name) ) { continue; }

		      var fileRecord = "";
		      var dirRecord = "";
		      fileRecord = "\x50\x4b\x03\x04" + this._files[name].header + name + this._files[name].data;
		      
		      dirRecord = "\x50\x4b\x01\x02" +
		      // version made by (00: DOS)
		      "\x14\x00" +
		      // file header (common to file and central directory)
		      this._files[name].header +
		      // file comment length
		      "\x00\x00" +
		      // disk number start
		      "\x00\x00" +
		      // internal file attributes TODO
		      "\x00\x00" +
		      // external file attributes
		      (this._files[name].dir===true?"\x10\x00\x00\x00":"\x00\x00\x00\x00")+
		      // relative offset of local header
		      this._decToHex(fileOffset, 4) +
		      // file name
		      name;

		      fileOffset += fileRecord.length;

		      files.push(fileRecord);
		      directory.push(dirRecord);
		   }

		   var fileData = files.join("");
		   var dirData = directory.join("");

		   var dirEnd = "";

		   // end of central dir signature
		   dirEnd = "\x50\x4b\x05\x06" +
		   // number of this disk
		   "\x00\x00" +
		   // number of the disk with the start of the central directory
		   "\x00\x00" +
		   // total number of entries in the central directory on this disk
		   this._decToHex(files.length, 2) +
		   // total number of entries in the central directory
		   this._decToHex(files.length, 2) +
		   // size of the central directory   4 bytes
		   this._decToHex(dirData.length, 4) +
		   // offset of start of central directory with respect to the starting disk number
		   this._decToHex(fileData.length, 4) +
		   // .ZIP file comment length
		   "\x00\x00";

		   var zip = fileData + dirData + dirEnd;
		   return (asBytes) ? zip : GABase64.encode(zip);
	},
	
	
	
	
	_add: function(name,data){
		   var date = new Date();
		   var dosTime;
		   var dosDate;

		   dosTime = date.getHours();
		   dosTime = dosTime << 6;
		   dosTime = dosTime | date.getMinutes();
		   dosTime = dosTime << 5;
		   dosTime = dosTime | date.getSeconds() / 2;

		   dosDate = date.getFullYear() - 1980;
		   dosDate = dosDate << 4;
		   dosDate = dosDate | (date.getMonth() + 1);
		   dosDate = dosDate << 5;
		   dosDate = dosDate | date.getDate();
		   
		   //Required for string data
		   data = this._utf8encode(data);
		   
		   var compression    =  new GAZip();
		   var compressedData = compression.compress(data);


		   var header = "";
		   // version needed to extract
		   header += "\x0A\x00";
		   // general purpose bit flag
		   header += "\x00\x00";
		   // compression method
		   header += compression.MAGIC;
		   // last mod file time
		   header += this._decToHex(dosTime, 2);
		   // last mod file date
		   header += this._decToHex(dosDate, 2);
		   // crc-32
		   header += this._decToHex(this._crc32(data), 4);
		   // compressed size
		   header += this._decToHex(compressedData.length, 4);
		   // uncompressed size
		   header += this._decToHex(data.length, 4);
		   // file name length
		   header += this._decToHex(name.length, 2);
		   // extra field length
		   header += "\x00\x00";
		   // file name
		   this._files[name] = {header: header, data: compressedData,dir: false};
		   return this;
	},
	
	_decToHex: function(dec, bytes)
	{
	   var hex = "";
	   for(var i=0;i<bytes;i++) {
	      hex += String.fromCharCode(dec&0xff);
	      dec=dec>>>8;
	   }
	   return hex;
	},
	_crc32: function(str, crc){

	   if (str === "") return "\x00\x00\x00\x00";

	   var table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

	   if (typeof(crc) == "undefined") { crc = 0; }
	   var x = 0;
	   var y = 0;

	   crc = crc ^ (-1);
	   for( var i = 0, iTop = str.length; i < iTop; i++ ) {
	      y = ( crc ^ str.charCodeAt( i ) ) & 0xFF;
	      x = "0x" + table.substr( y * 9, 8 );
	      crc = ( crc >>> 8 ) ^ x;
	   }

	   return crc ^ (-1);

	},
	
	_utf8encode: function(input)
	{
	   input = encodeURIComponent(input);
	   input = input.replace(/%.{2,2}/g, function(m) {
	      var hex = m.substring(1);
	      return String.fromCharCode(parseInt(hex,16));
	   });
	   return input;
	}


});


var GABase64 = Core.Class.singleton({
	classname: "GABase64",
	initialize: function(){
	   // private property
	   this._keyStr = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
	},

	      // public method for encoding
	      encode : function(input, utf8) {
	         var output = "";
	         var chr1, chr2, chr3, enc1, enc2, enc3, enc4;
	         var i = 0;

	         while (i < input.length) {

	            chr1 = input.charCodeAt(i++);
	            chr2 = input.charCodeAt(i++);
	            chr3 = input.charCodeAt(i++);

	            enc1 = chr1 >> 2;
	            enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
	            enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
	            enc4 = chr3 & 63;

	            if (isNaN(chr2)) {
	               enc3 = enc4 = 64;
	            } else if (isNaN(chr3)) {
	               enc4 = 64;
	            }

	            output = output +
	            this._keyStr.charAt(enc1) + this._keyStr.charAt(enc2) +
	            this._keyStr.charAt(enc3) + this._keyStr.charAt(enc4);

	         }

	         return output;
	      },

	      // public method for decoding
	      decode : function(input, utf8) {
	         var output = "";
	         var chr1, chr2, chr3;
	         var enc1, enc2, enc3, enc4;
	         var i = 0;

	         input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");

	         while (i < input.length) {

	            enc1 = this._keyStr.indexOf(input.charAt(i++));
	            enc2 = this._keyStr.indexOf(input.charAt(i++));
	            enc3 = this._keyStr.indexOf(input.charAt(i++));
	            enc4 = this._keyStr.indexOf(input.charAt(i++));

	            chr1 = (enc1 << 2) | (enc2 >> 4);
	            chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
	            chr3 = ((enc3 & 3) << 6) | enc4;

	            output = output + String.fromCharCode(chr1);

	            if (enc3 != 64) {
	               output = output + String.fromCharCode(chr2);
	            }
	            if (enc4 != 64) {
	               output = output + String.fromCharCode(chr3);
	            }

	         }

	         return output;

	      }
	});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/ngAPI/GACommon/GAZip'] = function(){var exports = $MODULE_REGISTRY['Code/ngAPI/GACommon/GAZip'] || {}; $MODULE_REGISTRY['Code/ngAPI/GACommon/GAZip'] = exports; /**
 * 
 */




	var _DeflateTreeDesc =  Core.Class.subclass({
		classname: "_DeflateTreeDesc",
		initialize: function(){
		    this.dyn_tree = null;	// the dynamic tree
		    this.static_tree = null;	// corresponding static tree or NULL
		    this.extra_bits = null;	// extra bits for each code or NULL
		    this.extra_base = 0;	// base index for extra_bits
		    this.elems = 0;		// max number of elements in the tree
		    this.max_length = 0;	// max bit length for the codes
		    this.max_code = 0;		// largest code with non zero frequency
		}
	});

	/* Values for max_lazy_match, good_match and max_chain_length, depending on
	 * the desired pack level (0..9). The values given below have been tuned to
	 * exclude worst case performance for pathological files. Better values may be
	 * found for specific files.
	 */
	var _DeflateConfiguration = Core.Class.subclass({
		classname: "_DeflateConfiguration",
		initialize: function(a, b, c, d) {
		    this.good_length = a; // reduce lazy search above this match length
		    this.max_lazy = b;    // do not perform lazy search above this match length
		    this.nice_length = c; // quit search above this match length
		    this.max_chain = d;
		}
	});

	var _DeflateBuffer = Core.Class.subclass({
		classname: "_DeflateBuffer",
		initialize: function(outBufSize) {
		    this.next = null;
		    this.len = 0;
		    this.ptr = new Array(outBufSize);
		    this.off = 0;
		}
	});





var _DeflateCT= Core.Class.subclass({
	classname: '_DeflateCT',
	initialize: function(){
	    this.fc = 0; // frequency count or bit string
	    this.dl = 0; // father node in Huffman tree or length of bit string
	}
});

exports.GAZip = Core.Class.subclass({
	classname: 'GAZip',
	initialize: function(){

		/* constant parameters */
		this._WSIZE = 32768;		// Sliding Window size
		this._STORED_BLOCK = 0;
		this._STATIC_TREES = 1;
		this._DYN_TREES    = 2;
		this.MAGIC = '\x08\x00';

		/* for deflate */
		this._DEFAULT_LEVEL = 6;
		this._FULL_SEARCH = true;
		this._INBUFSIZ = 32768;	// Input buffer size
		this._INBUF_EXTRA = 64;	// Extra buffer
		this._OUTBUFSIZ = 1024 * 8;
		this._window_size = 2 * this._WSIZE;
		this._MIN_MATCH = 3;
		this._MAX_MATCH = 258;
		this._BITS = 16;
		// for SMALL_MEM
		this._LIT_BUFSIZE = 0x2000;
		this._HASH_BITS = 13;
		if(this._LIT_BUFSIZE > this._INBUFSIZ){
		    console.log("error: _INBUFSIZ is too small");
		}
		if((this._WSIZE<<1) > (1<<this._BITS)){
		    console.log("error: _WSIZE is too large");
		}
		if(this._HASH_BITS > this._BITS-1){
			console.log("error: this._HASH_BITS is too large");
		}
		if(this._HASH_BITS < 8 || this._MAX_MATCH != 258){
			console.log("error: Code too clever");
		}
		this._DIST_BUFSIZE = this._LIT_BUFSIZE;
		this._HASH_SIZE = 1 << this._HASH_BITS;
		this._HASH_MASK = this._HASH_SIZE - 1;
		this._WMASK = this._WSIZE - 1;
		this._NIL = 0; // Tail of hash chains
		this._TOO_FAR = 4096;
		this._MIN_LOOKAHEAD = this._MAX_MATCH + this._MIN_MATCH + 1;
		this._MAX_DIST = this._WSIZE - this._MIN_LOOKAHEAD;
		this._SMALLEST = 1;
		this._MAX_BITS = 15;
		this._MAX_BL_BITS = 7;
		this._LENGTH_CODES = 29;
		this._LITERALS =256;
		this._END_BLOCK = 256;
		this._L_CODES = this._LITERALS + 1 + this._LENGTH_CODES;
		this._D_CODES = 30;
		this._BL_CODES = 19;
		this._REP_3_6 = 16;
		this._REPZ_3_10 = 17;
		this._REPZ_11_138 = 18;
		this._HEAP_SIZE = 2 * this._L_CODES + 1;
		this._H_SHIFT = parseInt((this._HASH_BITS + this._MIN_MATCH - 1) /
					   this._MIN_MATCH);

		/* variables */
		this._free_queue;
		this._qhead;
		this._qtail;
		this._initflag;
		this._outbuf = null;
		this._outcnt;
		this._outoff;
		this._complete;
		this._window;
		this._d_buf;
		this._l_buf;
		this._prev;
		this._bi_buf;
		this._bi_valid;
		this._block_start;
		this._ins_h;
		this._hash_head;
		this._prev_match;
		this._match_available;
		this._match_length;
		this._prev_length;
		this._strstart;
		this._match_start;
		this._eofile;
		this._lookahead;
		this._max_chain_length;
		this._max_lazy_match;
		this._compr_level;
		this._good_match;
		this._nice_match;
		this._dyn_ltree;
		this._dyn_dtree;
		this._static_ltree;
		this._static_dtree;
		this._bl_tree;
		this._l_desc;
		this._d_desc;
		this._bl_desc;
		this._bl_count;
		this._heap;
		this._heap_len;
		this._heap_max;
		this._depth;
		this._length_code;
		this._dist_code;
		this._base_length;
		this._base_dist;
		this._flag_buf;
		this._last_lit;
		this._last_dist;
		this._last_flags;
		this._flags;
		this._flag_bit;
		this._opt_len;
		this._static_len;
		this._deflate_data;
		this._deflate_pos;
		this._Buf_size = 16; // bit size of bi_buf
		
		
		/* constant tables */
		this._extra_lbits = new Array(
		    0,0,0,0,0,0,0,0,1,1,1,1,2,2,2,2,3,3,3,3,4,4,4,4,5,5,5,5,0);
		this._extra_dbits = new Array(
		    0,0,0,0,1,1,2,2,3,3,4,4,5,5,6,6,7,7,8,8,9,9,10,10,11,11,12,12,13,13);
		this._extra_blbits = new Array(
		    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,3,7);
		this._bl_order = new Array(
		    16,17,18,0,8,7,9,6,10,5,11,4,12,3,13,2,14,1,15);
		this._configuration_table = new Array(
			new _DeflateConfiguration(0,    0,   0,    0),
			new _DeflateConfiguration(4,    4,   8,    4),
			new _DeflateConfiguration(4,    5,  16,    8),
			new _DeflateConfiguration(4,    6,  32,   32),
			new _DeflateConfiguration(4,    4,  16,   16),
			new _DeflateConfiguration(8,   16,  32,   32),
			new _DeflateConfiguration(8,   16, 128,  128),
			new _DeflateConfiguration(8,   32, 128,  256),
			new _DeflateConfiguration(32, 128, 258, 1024),
			new _DeflateConfiguration(32, 258, 258, 4096));

		
		
		
	},
	compress: function(contents){
		return this._deflate(contents);
	},
	_deflate: function(str) {
	    var i; 
	    var j;
	    this._deflate_data = str;
	    this._deflate_pos = 0;
		var level = this._DEFAULT_LEVEL;
		
	    this._deflate_start(level);

	    var buff = new Array(1024);
	    var aout = [];
	    while((i = this._deflate_internal(buff, 0, buff.length)) > 0) {
			var cbuf = new Array(i);
			for(j = 0; j < i; j++){
			    cbuf[j] = String.fromCharCode(buff[j]);
			}
			aout[aout.length] = cbuf.join("");
	    }
	    this._deflate_data = null; // G.C.
	    return aout.join("");
	},
	
	
	_deflate_start: function(level) {
	    var i;

	    if(!level){
	    	level = this._DEFAULT_LEVEL;
	    }
	    else if(level < 1){
	    	level = 1;
	    }
	    else if(level > 9){
	    	level = 9;
	    }

	    this._compr_level = level;
	    this._initflag = false;
	    this._eofile = false;
	    if(this._outbuf != null)
		return;

	    this._free_queue = null;
	    this._qhead = null;
	    this._qtail = null;
	    this._outbuf = new Array(this._OUTBUFSIZ);
	    this._window = new Array(this._window_size);
	    this._d_buf = new Array(this._DIST_BUFSIZE);
	    this._l_buf = new Array(this._INBUFSIZ + this._INBUF_EXTRA);
	    
	    this._prev = new Array(1 << this._BITS);
	    this._dyn_ltree = new Array(this._HEAP_SIZE);
	    
	    
	    
	    for(i = 0; i < this._HEAP_SIZE; i++){
	    	this._dyn_ltree[i] = new _DeflateCT();
	    }
	    
	    
	    this._dyn_dtree = new Array(2*this._D_CODES+1);
	    
	    for(i = 0; i < 2*this._D_CODES+1; i++){
	    	this._dyn_dtree[i] = new _DeflateCT();
	    }
	    
	    this._static_ltree = new Array(this._L_CODES+2);
	    
	    for(i = 0; i < this._L_CODES+2; i++){
	    	this._static_ltree[i] = new _DeflateCT();
	    }
	    
	    this._static_dtree = new Array(this._D_CODES);
	    for(i = 0; i < this._D_CODES; i++){
	    	this._static_dtree[i] = new _DeflateCT();
	    }
	    
	    this._bl_tree = new Array(2*this._BL_CODES+1);
	    for(i = 0; i < 2*this._BL_CODES+1; i++){
	    	this._bl_tree[i] = new _DeflateCT();
	    }
	    
	    this._l_desc = new _DeflateTreeDesc();
	    this._d_desc = new _DeflateTreeDesc();
	    this._bl_desc = new _DeflateTreeDesc();
	    this._bl_count = new Array(this._MAX_BITS+1);
	    this._heap = new Array(2*this._L_CODES+1);
	    this._depth = new Array(2*this._L_CODES+1);
	    this._length_code = new Array(this._MAX_MATCH-this._MIN_MATCH+1);
	    this._dist_code = new Array(512);
	    this._base_length = new Array(this._LENGTH_CODES);
	    this._base_dist = new Array(this._D_CODES);
	    this._flag_buf = new Array(parseInt(this._LIT_BUFSIZE / 8));
	},
	
	_deflate_internal: function(buff, off, buff_size) {
	    var n;

	    if(!this._initflag)
	    {
			this._init_deflate();
			this._initflag = true;
			if(this._lookahead == 0) { // empty
				this._complete = true;
			    return 0;
			}
	    }

	    if((n = this._qcopy(buff, off, buff_size)) == buff_size){
	    	return buff_size;
	    }

	    if(this._complete){
	    	return n;
	    }

	    if(this._compr_level <= 3) {// optimized for speed
	    	this._deflate_fast();
	    }
	    else{
	    	this._deflate_better();
	    }
	    if(this._lookahead == 0) {
			if(this._match_available != 0){
			    this._ct_tally(0, this._window[this._strstart - 1] & 0xff);
			}
			this._flush_block(1);
			this._complete = true;
	    }
	    return n + this._qcopy(buff, n + off, buff_size - n);
	},
	
	_init_deflate: function() {
	    if(this._eofile){
	    	return;
	    }
	    this._bi_buf = 0;
	    this._bi_valid = 0;
	    this._ct_init();
	    this._lm_init();

	    this._qhead = null;
	    this._outcnt = 0;
	    this._outoff = 0;

	    if(this._compr_level <= 3)
	    {
	    	this._prev_length = this._MIN_MATCH - 1;
	    	this._match_length = 0;
	    }
	    else
	    {
	    	this._match_length = this._MIN_MATCH - 1;
	    	this._match_available = 0;
	    }

	    this._complete = false;
	},
	
	_qcopy: function(buff, off, buff_size) {
	    var n;
	    var i;
	    var j;

	    n = 0;
	    while(this._qhead != null && n < buff_size){
			i = buff_size - n;
			if(i > this._qhead.len){
			    i = this._qhead.len;
			}
	//	      System.arraycopy(qhead.ptr, qhead.off, buff, off + n, i);
			for(j = 0; j < i; j++){
			    buff[off + n + j] = this._qhead.ptr[this._qhead.off + j];
			}
			
			this._qhead.off += i;
			this._qhead.len -= i;
			n += i;
			if(this._qhead.len == 0) {
			    var p;
			    p = this._qhead;
			    this._qhead = this._qhead.next;
			    this._reuse_queue(p);
			}
	    }

	    if(n == buff_size){
	    	return n;
	    }

	    if(this._outoff < this._outcnt) {
			i = buff_size - n;
			if(i > this._outcnt - this._outoff){
			    i = this._outcnt - this._outoff;
			}
			// System.arraycopy(outbuf, outoff, buff, off + n, i);
			for(j = 0; j < i; j++){
			    buff[off + n + j] = this._outbuf[this._outoff + j];
			}
			this._outoff += i;
			n += i;
			if(this._outcnt == this._outoff){
				this._outcnt = this._outoff = 0;
			}
	    }
	    return n;
	},
	
	_reuse_queue: function(p) {
	    p.next = this._free_queue;
	    this._free_queue = p;
	},
	
	/* ==========================================================================
	 * Processes a new input file and return its compressed length. This
	 * function does not perform lazy evaluationof matches and inserts
	 * new strings in the dictionary only for unmatched strings or for short
	 * matches. It is used only for the fast compression options.
	 */
	_deflate_fast: function() {
	    while(this._lookahead != 0 && this._qhead == null) {
			var flush; // set if current block must be flushed
	
			/* Insert the string window[strstart .. strstart+2] in the
			 * dictionary, and set hash_head to the head of the hash chain:
			 */
			this._INSERT_STRING();
	
			/* Find the longest match, discarding those <= prev_length.
			 * At this point we have always match_length < MIN_MATCH
			 */
			if(this._hash_head != this._NIL &&
					this._strstart - this._hash_head <= this._MAX_DIST) {
			    /* To simplify the code, we prevent matches with the string
			     * of window index 0 (in particular we have to avoid a match
			     * of the string with itself at the start of the input file).
			     */
				this._match_length = this._longest_match(this._hash_head);
			    /* longest_match() sets match_start */
			    if(this._match_length > this._lookahead){
			    	this._match_length = this._lookahead;
			    }
			}
			if(this._match_length >= this._MIN_MATCH) {
	//		    check_match(strstart, match_start, match_length);
	
			    flush = this._ct_tally(this._strstart - this._match_start,
			    		this._match_length - this._MIN_MATCH);
			    this._lookahead -= this._match_length;
	
			    /* Insert new strings in the hash table only if the match length
			     * is not too large. This saves time but degrades compression.
			     */
			    if(this._match_length <= this._max_lazy_match) {
				    this._match_length--; // string at strstart already in hash table
					do {
						this._strstart++;
						this._INSERT_STRING();
					    /* strstart never exceeds WSIZE-MAX_MATCH, so there are
					     * always MIN_MATCH bytes ahead. If lookahead < MIN_MATCH
					     * these bytes are garbage, but it does not matter since
					     * the next lookahead bytes will be emitted as literals.
					     */
					} while(--this._match_length != 0);
					this._strstart++;
			    } else {
			    	this._strstart += this._match_length;
			    	this._match_length = 0;
			    	this._ins_h = this._window[this._strstart] & 0xff;
		//			UPDATE_HASH(ins_h, window[strstart + 1]);
			    	this._ins_h = ((this._ins_h<<this._H_SHIFT) ^ (this._window[this._strstart + 1] & 0xff)) & this._HASH_MASK;
		
			//#if MIN_MATCH != 3
		//			Call UPDATE_HASH() MIN_MATCH-3 more times
			//#endif
		
			    }
			} else {
			    /* No match, output a literal byte */
			    flush = this._ct_tally(0, this._window[this._strstart] & 0xff);
			    this._lookahead--;
			    this._strstart++;
			}
			if(flush) {
			    this._flush_block(0);
			    this._block_start = this._strstart;
			}
	
			/* Make sure that we always have enough lookahead, except
			 * at the end of the input file. We need MAX_MATCH bytes
			 * for the next match, plus MIN_MATCH bytes to insert the
			 * string following the next match.
			 */
			while(this._lookahead < this._MIN_LOOKAHEAD && !this._eofile){
				this._fill_window();
			}
	    }
	},
	
	_INSERT_STRING: function() {
	    this._ins_h = ((this._ins_h << this._H_SHIFT)
			 ^ (this._window[this._strstart + this._MIN_MATCH - 1] & 0xff))
		& this._HASH_MASK;
	    this._hash_head = this._head1(this._ins_h);
	    this._prev[this._strstart & this._WMASK] = this._hash_head;
	    this._head2(this._ins_h, this._strstart);
	},
	
	_head1: function(i) {
	    return this._prev[this._WSIZE + i];
	},

	_head2: function(i, val) {
	    return this._prev[this._WSIZE + i] = val;
	},

	_deflate_better: function() {
	    /* Process the input block. */
	    while(this._lookahead != 0 && this._qhead == null) {
			/* Insert the string window[strstart .. strstart+2] in the
			 * dictionary, and set hash_head to the head of the hash chain:
			 */
	    	this._INSERT_STRING();
	
			/* Find the longest match, discarding those <= prev_length.
			 */
	    	this._prev_length = this._match_length;
	    	this._prev_match = this._match_start;
	    	this._match_length = this._MIN_MATCH - 1;
	
			if(this._hash_head != this._NIL &&
					this._prev_length < this._max_lazy_match &&
					this._strstart - this._hash_head <= this._MAX_DIST) {
			    /* To simplify the code, we prevent matches with the string
			     * of window index 0 (in particular we have to avoid a match
			     * of the string with itself at the start of the input file).
			     */
				this._match_length = this._longest_match(this._hash_head);
			    /* longest_match() sets match_start */
			    if(this._match_length > this._lookahead){
			    	this._match_length = this._lookahead;
			    }
	
			    /* Ignore a length 3 match if it is too distant: */
			    if(this._match_length == this._MIN_MATCH &&
			       this._strstart - this._match_start > this._TOO_FAR) {
				/* If prev_match is also MIN_MATCH, match_start is garbage
				 * but we will ignore the current match anyway.
				 */
			    	this._match_length--;
			    }
			}
			/* If there was a match at the previous step and the current
			 * match is not better, output the previous match:
			 */
			if(this._prev_length >= this._MIN_MATCH &&
			   this._match_length <= this._prev_length) {
			    var flush; // set if current block must be flushed
	
	//		    check_match(strstart - 1, prev_match, prev_length);
			    flush = this._ct_tally(this._strstart - 1 - this._prev_match,
						 this._prev_length - this._MIN_MATCH);
	
			    /* Insert in hash table all strings up to the end of the match.
			     * strstart-1 and strstart are already inserted.
			     */
			    this._lookahead -= this._prev_length - 1;
			    this._prev_length -= 2;
			    do {
					this._strstart++;
					this._INSERT_STRING();
					/* strstart never exceeds WSIZE-MAX_MATCH, so there are
					 * always MIN_MATCH bytes ahead. If lookahead < MIN_MATCH
					 * these bytes are garbage, but it does not matter since the
					 * next lookahead bytes will always be emitted as literals.
					 */
			    } while(--this._prev_length != 0);
			    this._match_available = 0;
			    this._match_length = this._MIN_MATCH - 1;
			    this._strstart++;
			    if(flush) {
					this._flush_block(0);
					this._block_start = this._strstart;
			    }
			} else if(this._match_available != 0) {
			    /* If there was no match at the previous position, output a
			     * single literal. If there was a match but the current match
			     * is longer, truncate the previous match to a single literal.
			     */
			    if(this._ct_tally(0, this._window[this._strstart - 1] & 0xff)) {
					this._flush_block(0);
					this._block_start = this._strstart;
			    }
			    this._strstart++;
			    this._lookahead--;
			} else {
			    /* There is no previous match to compare with, wait for
			     * the next step to decide.
			     */
			    this._match_available = 1;
			    this._strstart++;
			    this._lookahead--;
			}
	
			/* Make sure that we always have enough lookahead, except
			 * at the end of the input file. We need MAX_MATCH bytes
			 * for the next match, plus MIN_MATCH bytes to insert the
			 * string following the next match.
			 */
			while(this._lookahead < this._MIN_LOOKAHEAD && !this._eofile){
			    this._fill_window();
			}
	    }
	},
	
	

	/* ==========================================================================
	 * Save the match info and tally the frequency counts. Return true if
	 * the current block must be flushed.
	 */
	_ct_tally: function(
		dist, // distance of matched string
		lc) { // match length-MIN_MATCH or unmatched char (if dist==0)
	    this._l_buf[this._last_lit++] = lc;
	    if(dist == 0) {
			// lc is the unmatched char
			this._dyn_ltree[lc].fc++;
	    } else {
			// Here, lc is the match length - MIN_MATCH
			dist--;		    // dist = match distance - 1
	//	      Assert((ush)dist < (ush)MAX_DIST &&
	//		     (ush)lc <= (ush)(MAX_MATCH-MIN_MATCH) &&
	//		     (ush)D_CODE(dist) < (ush)D_CODES,  "ct_tally: bad match");
	
			this._dyn_ltree[this._length_code[lc]+this._LITERALS+1].fc++;
			this._dyn_dtree[this._D_CODE(dist)].fc++;
	
			this._d_buf[this._last_dist++] = dist;
			this._flags |= this._flag_bit;
	    }
	    this._flag_bit <<= 1;

	    // Output the flags if they fill a byte
	    if((this._last_lit & 7) == 0) {
		this._flag_buf[this._last_flags++] = this._flags;
		this._flags = 0;
		this._flag_bit = 1;
	    }
	    // Try to guess if it is profitable to stop the current block here
	    if(this._compr_level > 2 && (this._last_lit & 0xfff) == 0) {
		// Compute an upper bound for the compressed length
		var out_length = this._last_lit * 8;
		var in_length = this._strstart - this._block_start;
		var dcode;

		for(dcode = 0; dcode < this._D_CODES; dcode++) {
		    out_length += this._dyn_dtree[dcode].fc * (5 + this._extra_dbits[dcode]);
		}
		out_length >>= 3;
//	      Trace((stderr,"\nlast_lit %u, last_dist %u, in %ld, out ~%ld(%ld%%) ",
//		     encoder->last_lit, encoder->last_dist, in_length, out_length,
//		     100L - out_length*100L/in_length));
		if(this._last_dist < parseInt(this._last_lit/2) &&
		   out_length < parseInt(in_length/2))
		    return true;
	    }
	    return (this._last_lit == this._LIT_BUFSIZE-1 ||
		    this._last_dist == this._DIST_BUFSIZE);
	    /* We avoid equality with LIT_BUFSIZE because of wraparound at 64K
	     * on 16 bit machines and because stored blocks are restricted to
	     * 64K-1 bytes.
	     */
	},
	
	
	
	/* ==========================================================================
	 * Determine the best encoding for the current block: dynamic trees, static
	 * trees or store, and output the encoded block to the zip file.
	 */
	_flush_block: function(eof) { // true if this is the last block for a file
	    var opt_lenb;
	    var static_lenb; // opt_len and static_len in bytes
	    var max_blindex;	// index of last bit length code of non zero freq
	    var stored_len;	// length of input block

	    stored_len = this._strstart - this._block_start;
	    this._flag_buf[this._last_flags] = this._flags; // Save the flags for the last 8 items

	    // Construct the literal and distance trees
	    this._build_tree(this._l_desc);
//	    Tracev((stderr, "\nlit data: dyn %ld, stat %ld",
//		    encoder->opt_len, encoder->static_len));

	    this._build_tree(this._d_desc);
//	    Tracev((stderr, "\ndist data: dyn %ld, stat %ld",
//		    encoder->opt_len, encoder->static_len));
	    /* At this point, opt_len and static_len are the total bit lengths of
	     * the compressed block data, excluding the tree representations.
	     */

	    /* Build the bit length tree for the above two trees, and get the index
	     * in bl_order of the last bit length code to send.
	     */
	    max_blindex = this._build_bl_tree();

	    // Determine the best encoding. Compute first the block length in bytes
	    opt_lenb	= (this._opt_len   +3+7)>>3;
	    static_lenb = (this._static_len+3+7)>>3;

//	    Trace((stderr, "\nopt %lu(%lu) stat %lu(%lu) stored %lu lit %u dist %u ",
//		   opt_lenb, encoder->opt_len,
//		   static_lenb, encoder->static_len, stored_len,
//		   encoder->last_lit, encoder->last_dist));

	    if(static_lenb <= opt_lenb)
		opt_lenb = static_lenb;
	    if(stored_len + 4 <= opt_lenb // 4: two words for the lengths
	       && this._block_start >= 0) {
		var i;

		/* The test buf != NULL is only necessary if LIT_BUFSIZE > WSIZE.
		 * Otherwise we can't have processed more than WSIZE input bytes since
		 * the last block flush, because compression would have been
		 * successful. If LIT_BUFSIZE <= WSIZE, it is never too late to
		 * transform a block into a stored block.
		 */
		this._send_bits((this._STORED_BLOCK<<1)+eof, 3);  /* send block type */
		this._bi_windup();		 /* align on byte boundary */
		this._put_short(stored_len);
		this._put_short(~stored_len);

	      // copy block
	/*
	      p = &window[block_start];
	      for(i = 0; i < stored_len; i++)
		put_byte(p[i]);
	*/
		for(i = 0; i < stored_len; i++)
		    this._put_byte(this._window[this._block_start + i]);

	    } else if(static_lenb == opt_lenb) {
		this._send_bits((this._STATIC_TREES<<1)+eof, 3);
		this._compress_block(this._static_ltree, this._static_dtree);
	    } else {
		this._send_bits((this._DYN_TREES<<1)+eof, 3);
		this._send_all_trees(this._l_desc.max_code+1,
				   this._d_desc.max_code+1,
				   max_blindex+1);
		this._compress_block(this._dyn_ltree, this._dyn_dtree);
	    }

	    this._init_block();

	    if(eof != 0)
		this._bi_windup();
	},
	
	/* ==========================================================================
	 * Allocate the match buffer, initialize the various tables and save the
	 * location of the internal file attribute (ascii/binary) and method
	 * (DEFLATE/STORE).
	 */
	_ct_init: function() {
	    var n;	// iterates over tree elements
	    var bits;	// bit counter
	    var length;	// length value
	    var code;	// code value
	    var dist;	// distance index

	    if(this._static_dtree[0].dl != 0){
	    	return; // ct_init already called
	    }

	    this._l_desc.dyn_tree		= this._dyn_ltree;
	    this._l_desc.static_tree	= this._static_ltree;
	    this._l_desc.extra_bits	= this._extra_lbits;
	    this._l_desc.extra_base	= this._LITERALS + 1;
	    this._l_desc.elems		= this._L_CODES;
	    this._l_desc.max_length	= this._MAX_BITS;
	    this._l_desc.max_code		= 0;

	    this._d_desc.dyn_tree		= this._dyn_dtree;
	    this._d_desc.static_tree	= this._static_dtree;
	    this._d_desc.extra_bits	= this._extra_dbits;
	    this._d_desc.extra_base	= 0;
	    this._d_desc.elems		= this._D_CODES;
	    this._d_desc.max_length	= this._MAX_BITS;
	    this._d_desc.max_code		= 0;

	    this._bl_desc.dyn_tree	= this._bl_tree;
	    this._bl_desc.static_tree	= null;
	    this._bl_desc.extra_bits	= this._extra_blbits;
	    this._bl_desc.extra_base	= 0;
	    this._bl_desc.elems		= this._BL_CODES;
	    this._bl_desc.max_length	= this._MAX_BL_BITS;
	    this._bl_desc.max_code	= 0;

	    // Initialize the mapping length (0..255) -> length code (0..28)
	    length = 0;
	    for(code = 0; code < this._LENGTH_CODES-1; code++) {
			this._base_length[code] = length;
			for(n = 0; n < (1<<this._extra_lbits[code]); n++){
				this._length_code[length++] = code;
			}
	    }
	    // Assert (length == 256, "ct_init: length != 256");

	    /* Note that the length 255 (match length 258) can be represented
	     * in two different ways: code 284 + 5 bits or code 285, so we
	     * overwrite length_code[255] to use the best encoding:
	     */
	    this._length_code[length-1] = code;

	    /* Initialize the mapping dist (0..32K) -> dist code (0..29) */
	    dist = 0;
	    for(code = 0 ; code < 16; code++) {
			this._base_dist[code] = dist;
			for(n = 0; n < (1<<this._extra_dbits[code]); n++) {
			    this._dist_code[dist++] = code;
			}
	    }
	    // Assert (dist == 256, "ct_init: dist != 256");
	    dist >>= 7; // from now on, all distances are divided by 128
	    for( ; code < this._D_CODES; code++) {
			this._base_dist[code] = dist << 7;
			for(n = 0; n < (1<<(this._extra_dbits[code]-7)); n++){
				this._dist_code[256 + dist++] = code;
			}
	    }
	    // Assert (dist == 256, "ct_init: 256+dist != 512");

	    // Construct the codes of the static literal tree
	    for(bits = 0; bits <= this._MAX_BITS; bits++){
	    	this._bl_count[bits] = 0;
	    }
	    n = 0;
	    while(n <= 143) { this._static_ltree[n++].dl = 8; this._bl_count[8]++; }
	    while(n <= 255) { this._static_ltree[n++].dl = 9; this._bl_count[9]++; }
	    while(n <= 279) { this._static_ltree[n++].dl = 7; this._bl_count[7]++; }
	    while(n <= 287) { this._static_ltree[n++].dl = 8; this._bl_count[8]++; }
	    /* Codes 286 and 287 do not exist, but we must include them in the
	     * tree construction to get a canonical Huffman tree (longest code
	     * all ones)
	     */
	    this._gen_codes(this._static_ltree, this._L_CODES + 1);

	    /* The static distance tree is trivial: */
	    for(n = 0; n < this._D_CODES; n++) {
			this._static_dtree[n].dl = 5;
			this._static_dtree[n].fc = this._bi_reverse(n, 5);
	    }

	    // Initialize the first block of the first file:
	    this._init_block();
	},
	
	/* ==========================================================================
	 * Initialize the "longest match" routines for a new file
	 */
	_lm_init: function() {
	    var j;

	    /* Initialize the hash table. */
	    for(j = 0; j < this._HASH_SIZE; j++){
//		this._head2(j, this._NIL);
	    	this._prev[this._WSIZE + j] = 0;
	    }
	    /* prev will be initialized on the fly */

	    /* Set the default configuration parameters:
	     */
	    this._max_lazy_match = this._configuration_table[this._compr_level].max_lazy;
	    this._good_match     = this._configuration_table[this._compr_level].good_length;
	    if(!this._FULL_SEARCH){
	    	this._nice_match = this._configuration_table[this._compr_level].nice_length;
	    }
	    this._max_chain_length = this._configuration_table[this._compr_level].max_chain;

	    this._strstart = 0;
	    this._block_start = 0;

	    this._lookahead = this._read_buff(this._window, 0, 2 * this._WSIZE);
	    if(this._lookahead <= 0) {
			this._eofile = true;
			this._lookahead = 0;
			return;
	    }
	    this._eofile = false;
	    /* Make sure that we always have enough lookahead. This is important
	     * if input comes from a device such as a tty.
	     */
	    while(this._lookahead < this._MIN_LOOKAHEAD && !this._eofile){
	    	this._fill_window();
	    }

	    /* If lookahead < MIN_MATCH, ins_h is garbage, but this is
	     * not important since only literal bytes will be emitted.
	     */
	    this._ins_h = 0;
	    for(j = 0; j < this._MIN_MATCH - 1; j++) {
//	      UPDATE_HASH(ins_h, window[j]);
		this._ins_h = ((this._ins_h << this._H_SHIFT) ^ (this._window[j] & 0xff)) & this._HASH_MASK;
	    }
	},
	

	/* ==========================================================================
	 * Fill the window when the lookahead becomes insufficient.
	 * Updates strstart and lookahead, and sets eofile if end of input file.
	 * IN assertion: lookahead < MIN_LOOKAHEAD && strstart + lookahead > 0
	 * OUT assertions: at least one byte has been read, or eofile is set;
	 *    file reads are performed for at least two bytes (required for the
	 *    translate_eol option).
	 */
	_fill_window: function() {
	    var n, m;

	    // Amount of free space at the end of the window.
	    var more = this._window_size - this._lookahead - this._strstart;

	    /* If the window is almost full and there is insufficient lookahead,
	     * move the upper half to the lower one to make room in the upper half.
	     */
	    if(more == -1) {
		/* Very unlikely, but possible on 16 bit machine if strstart == 0
	         * and lookahead == 1 (input done one byte at time)
	         */
	    	more--;
	    } else if(this._strstart >= this._WSIZE + this._MAX_DIST) {
			/* By the IN assertion, the window is not empty so we can't confuse
		         * more == 0 with more == 64K on a 16 bit machine.
		         */
	//		Assert(window_size == (ulg)2*WSIZE, "no sliding with BIG_MEM");
	
	//		System.arraycopy(window, WSIZE, window, 0, WSIZE);
			for(n = 0; n < this._WSIZE; n++){
			    this._window[n] = this._window[n + this._WSIZE];
			}
			this._match_start -= this._WSIZE;
			this._strstart    -= this._WSIZE; /* we now have strstart >= MAX_DIST: */
			this._block_start -= this._WSIZE;
	
			for(n = 0; n < this._HASH_SIZE; n++) {
			    m = this._head1(n);
			    this._head2(n, m >= this._WSIZE ? m - this._WSIZE : this._NIL);
			}
			for(n = 0; n < this._WSIZE; n++) {
			    /* If n is not on any hash chain, prev[n] is garbage but
			     * its value will never be used.
			     */
			    m = this._prev[n];
			    this._prev[n] = (m >= this._WSIZE ? m - this._WSIZE : this._NIL);
			}
			more += this._WSIZE;
	    }
	    // At this point, more >= 2
	    if(!this._eofile) {
		n = this._read_buff(this._window, this._strstart + this._lookahead, more);
		if(n <= 0)
		    this._eofile = true;
		else
		    this._lookahead += n;
	    }
	},
	
	/* ==========================================================================
	 * Set match_start to the longest match starting at the given string and
	 * return its length. Matches shorter or equal to prev_length are discarded,
	 * in which case the result is equal to prev_length and match_start is
	 * garbage.
	 * IN assertions: cur_match is the head of the hash chain for the current
	 *   string (strstart) and its distance is <= MAX_DIST, and prev_length >= 1
	 */
	_longest_match: function(cur_match) {
	    var chain_length = this._max_chain_length; // max hash chain length
	    var scanp = this._strstart; // current string
	    var matchp;		// matched string
	    var len;		// length of current match
	    var best_len = this._prev_length;	// best match length so far

	    /* Stop when cur_match becomes <= limit. To simplify the code,
	     * we prevent matches with the string of window index 0.
	     */
	    var limit = (this._strstart > this._MAX_DIST ? this._strstart - this._MAX_DIST : this._NIL);

	    var strendp = this._strstart + this._MAX_MATCH;
	    var scan_end1 = this._window[scanp + best_len - 1];
	    var scan_end  = this._window[scanp + best_len];

	    /* Do not waste too much time if we already have a good match: */
	    if(this._prev_length >= this._good_match){
	    	chain_length >>= 2;
	    }
	//  Assert(encoder->strstart <= window_size-MIN_LOOKAHEAD, "insufficient lookahead");

	    do {
	//	    Assert(cur_match < encoder->strstart, "no future");
			matchp = cur_match;
	
			/* Skip to next match if the match length cannot increase
			    * or if the match length is less than 2:
			*/
			if(this._window[matchp + best_len]	!= scan_end  ||
			   this._window[matchp + best_len - 1]	!= scan_end1 ||
			   this._window[matchp]			!= this._window[scanp] ||
			   this._window[++matchp]			!= this._window[scanp + 1]) {
			    continue;
			}
	
			/* The check at best_len-1 can be removed because it will be made
		         * again later. (This heuristic is not always a win.)
		         * It is not necessary to compare scan[2] and match[2] since they
		         * are always equal when the other bytes match, given that
		         * the hash keys are equal and that HASH_BITS >= 8.
		         */
			scanp += 2;
			matchp++;
	
			/* We check for insufficient lookahead only every 8th comparison;
		         * the 256th check will be made at strstart+258.
		         */
			do {
			} while(this._window[++scanp] == this._window[++matchp] &&
				this._window[++scanp] == this._window[++matchp] &&
				this._window[++scanp] == this._window[++matchp] &&
				this._window[++scanp] == this._window[++matchp] &&
				this._window[++scanp] == this._window[++matchp] &&
				this._window[++scanp] == this._window[++matchp] &&
				this._window[++scanp] == this._window[++matchp] &&
				this._window[++scanp] == this._window[++matchp] &&
				scanp < strendp);
	
		      len = this._MAX_MATCH - (strendp - scanp);
		      scanp = strendp - this._MAX_MATCH;
	
		      if(len > best_len) {
				  this._match_start = cur_match;
				  best_len = len;
				  if(this._FULL_SEARCH) {
				      if(len >= this._MAX_MATCH){
				    	  break;
				      }
				  } else {
				      if(len >= this._nice_match){
				    	  break;
				      }
				  }
		
				  scan_end1  = this._window[scanp + best_len-1];
				  scan_end   = this._window[scanp + best_len];
		      }
	    } while((cur_match = this._prev[cur_match & this._WMASK]) > limit
		    && --chain_length != 0);

	    return best_len;
	},
	
	
	
	/* Send a code of the given tree. c and tree must not have side effects */
	_SEND_CODE: function(c, tree) {
	    this._send_bits(tree[c].fc, tree[c].dl);
	},

	/* Mapping from a distance to a distance code. dist is the distance - 1 and
	 * must not have side effects. dist_code[256] and dist_code[257] are never
	 * used.
	 */
	_D_CODE: function(dist) {
	    return (dist < 256 ? this._dist_code[dist]
		    : this._dist_code[256 + (dist>>7)]) & 0xff;
	},

	/* ==========================================================================
	 * Compares to subtrees, using the tree depth as tie breaker when
	 * the subtrees have equal frequency. This minimizes the worst case length.
	 */
	_SMALLER: function(tree, n, m) {
	    return tree[n].fc < tree[m].fc ||
	      (tree[n].fc == tree[m].fc && this._depth[n] <= this._depth[m]);
	},

	/* ==========================================================================
	 * read string data
	 */
	_read_buff: function(buff, offset, n) {
	    var i;
	    for(i = 0; i < n && this._deflate_pos < this._deflate_data.length; i++)
		buff[offset + i] =
		    this._deflate_data.charCodeAt(this._deflate_pos++) & 0xff;
	    return i;
	},
	
	
	
	
	
	/* ==========================================================================
	 * Construct one Huffman tree and assigns the code bit strings and lengths.
	 * Update the total bit length for the current block.
	 * IN assertion: the field freq is set for all tree elements.
	 * OUT assertions: the fields len and code are set to the optimal bit length
	 *     and corresponding code. The length opt_len is updated; static_len is
	 *     also updated if stree is not null. The field max_code is set.
	 */
	_build_tree: function(desc) { // the tree descriptor
	    var tree	= desc.dyn_tree;
	    var stree	= desc.static_tree;
	    var elems	= desc.elems;
	    var n, m;		// iterate over heap elements
	    var max_code = -1;	// largest code with non zero frequency
	    var node = elems;	// next internal node of the tree

	    /* Construct the initial heap, with least frequent element in
	     * heap[SMALLEST]. The sons of heap[n] are heap[2*n] and heap[2*n+1].
	     * heap[0] is not used.
	     */
	    this._heap_len = 0;
	    this._heap_max = this._HEAP_SIZE;

	    for(n = 0; n < elems; n++) {
			if(tree[n].fc != 0) {
			    this._heap[++this._heap_len] = max_code = n;
			    this._depth[n] = 0;
			} else{
			    tree[n].dl = 0;
			}
	    }

	    /* The pkzip format requires that at least one distance code exists,
	     * and that at least one bit should be sent even if there is only one
	     * possible code. So to avoid special checks later on we force at least
	     * two codes of non zero frequency.
	     */
	    while(this._heap_len < 2) {
			var xnew = this._heap[++this._heap_len] = (max_code < 2 ? ++max_code : 0);
			tree[xnew].fc = 1;
			this._depth[xnew] = 0;
			this._opt_len--;
			if(stree != null){
			    this._static_len -= stree[xnew].dl;
			}
			// new is 0 or 1 so it does not have extra bits
	    }
	    desc.max_code = max_code;

	    /* The elements heap[heap_len/2+1 .. heap_len] are leaves of the tree,
	     * establish sub-heaps of increasing lengths:
	     */
	    for(n = this._heap_len >> 1; n >= 1; n--){
	    	this._pqdownheap(tree, n);
	    }
	    /* Construct the Huffman tree by repeatedly combining the least two
	     * frequent nodes.
	     */
	    do {
		n = this._heap[this._SMALLEST];
			this._heap[this._SMALLEST] = this._heap[this._heap_len--];
			this._pqdownheap(tree, this._SMALLEST);
	
			m = this._heap[this._SMALLEST];  // m = node of next least frequency
	
			// keep the nodes sorted by frequency
			this._heap[--this._heap_max] = n;
			this._heap[--this._heap_max] = m;
	
			// Create a new node father of n and m
			tree[node].fc = tree[n].fc + tree[m].fc;
	//		depth[node] = (char)(MAX(depth[n], depth[m]) + 1);
			if(this._depth[n] > this._depth[m] + 1){
			    this._depth[node] = this._depth[n];
			}
			else{
			    this._depth[node] = this._depth[m] + 1;
			}
			tree[n].dl = tree[m].dl = node;
	
			// and insert the new node in the heap
			this._heap[this._SMALLEST] = node++;
			this._pqdownheap(tree, this._SMALLEST);

	    } while(this._heap_len >= 2);

	    this._heap[--this._heap_max] = this._heap[this._SMALLEST];

	    /* At this point, the fields freq and dad are set. We can now
	     * generate the bit lengths.
	     */
	    this._gen_bitlen(desc);

	    // The field len is now set, we can generate the bit codes
	    this._gen_codes(tree, max_code);
	},

	/* ==========================================================================
	 * Scan a literal or distance tree to determine the frequencies of the codes
	 * in the bit length tree. Updates opt_len to take into account the repeat
	 * counts. (The contribution of the bit length codes will be added later
	 * during the construction of bl_tree.)
	 */
	_scan_tree: function(tree,// the tree to be scanned
			       max_code) {  // and its largest code of non zero frequency
	    var n;			// iterates over all tree elements
	    var prevlen = -1;		// last emitted length
	    var curlen;			// length of current code
	    var nextlen = tree[0].dl;	// length of next code
	    var count = 0;		// repeat count of the current code
	    var max_count = 7;		// max repeat count
	    var min_count = 4;		// min repeat count

	    if(nextlen == 0) {
		max_count = 138;
		min_count = 3;
	    }
	    tree[max_code + 1].dl = 0xffff; // guard

	    for(n = 0; n <= max_code; n++) {
		curlen = nextlen;
		nextlen = tree[n + 1].dl;
		if(++count < max_count && curlen == nextlen)
		    continue;
		else if(count < min_count)
		    this._bl_tree[curlen].fc += count;
		else if(curlen != 0) {
		    if(curlen != prevlen)
			this._bl_tree[curlen].fc++;
		    this._bl_tree[this._REP_3_6].fc++;
		} else if(count <= 10)
		    this._bl_tree[this._REPZ_3_10].fc++;
		else
		    this._bl_tree[this._REPZ_11_138].fc++;
		count = 0; prevlen = curlen;
		if(nextlen == 0) {
		    max_count = 138;
		    min_count = 3;
		} else if(curlen == nextlen) {
		    max_count = 6;
		    min_count = 3;
		} else {
		    max_count = 7;
		    min_count = 4;
		}
	    }
	},

	  /* ==========================================================================
	   * Send a literal or distance tree in compressed form, using the codes in
	   * bl_tree.
	   */
	_send_tree: function(tree, // the tree to be scanned
			   max_code) { // and its largest code of non zero frequency
	    var n;			// iterates over all tree elements
	    var prevlen = -1;		// last emitted length
	    var curlen;			// length of current code
	    var nextlen = tree[0].dl;	// length of next code
	    var count = 0;		// repeat count of the current code
	    var max_count = 7;		// max repeat count
	    var min_count = 4;		// min repeat count

	    /* tree[max_code+1].dl = -1; */  /* guard already set */
	    if(nextlen == 0) {
	      max_count = 138;
	      min_count = 3;
	    }

	    for(n = 0; n <= max_code; n++) {
			curlen = nextlen;
			nextlen = tree[n+1].dl;
			if(++count < max_count && curlen == nextlen) {
			    continue;
			} else if(count < min_count) {
			    do {
			    	this._SEND_CODE(curlen, this._bl_tree); 
			    	} while(--count != 0);
			} else if(curlen != 0) {
			    if(curlen != prevlen) {
					this._SEND_CODE(curlen, this._bl_tree);
					count--;
			    }
			    // Assert(count >= 3 && count <= 6, " 3_6?");
			    this._SEND_CODE(this._REP_3_6, this._bl_tree);
			    this._send_bits(count - 3, 2);
			} else if(count <= 10) {
			    this._SEND_CODE(this._REPZ_3_10, this._bl_tree);
			    this._send_bits(count-3, 3);
			} else {
			    this._SEND_CODE(this._REPZ_11_138, this._bl_tree);
			    this._send_bits(count-11, 7);
			}
			count = 0;
			prevlen = curlen;
			if(nextlen == 0) {
			    max_count = 138;
			    min_count = 3;
			} else if(curlen == nextlen) {
			    max_count = 6;
			    min_count = 3;
			} else {
			    max_count = 7;
			    min_count = 4;
			}
	    }
	},

	/* ==========================================================================
	 * Construct the Huffman tree for the bit lengths and return the index in
	 * bl_order of the last bit length code to send.
	 */
	_build_bl_tree: function() {
	    var max_blindex;  // index of last bit length code of non zero freq

	    // Determine the bit length frequencies for literal and distance trees
	    this._scan_tree(this._dyn_ltree, this._l_desc.max_code);
	    this._scan_tree(this._dyn_dtree, this._d_desc.max_code);

	    // Build the bit length tree:
	    this._build_tree(this._bl_desc);
	    /* opt_len now includes the length of the tree representations, except
	     * the lengths of the bit lengths codes and the 5+5+4 bits for the counts.
	     */

	    /* Determine the number of bit length codes to send. The pkzip format
	     * requires that at least 4 bit length codes be sent. (appnote.txt says
	     * 3 but the actual value used is 4.)
	     */
	    for(max_blindex = this._BL_CODES-1; max_blindex >= 3; max_blindex--) {
	    	if(this._bl_tree[this._bl_order[max_blindex]].dl != 0){
	    		break;
	    	}
	    }
	    /* Update opt_len to include the bit length tree and counts */
	    this._opt_len += 3*(max_blindex+1) + 5+5+4;
//	    Tracev((stderr, "\ndyn trees: dyn %ld, stat %ld",
//		    encoder->opt_len, encoder->static_len));

	    return max_blindex;
	},

	/* ==========================================================================
	 * Send the header for a block using dynamic Huffman trees: the counts, the
	 * lengths of the bit length codes, the literal tree and the distance tree.
	 * IN assertion: lcodes >= 257, dcodes >= 1, blcodes >= 4.
	 */
	_send_all_trees: function(lcodes, dcodes, blcodes) { // number of codes for each tree
	    var rank; // index in bl_order

//	    Assert (lcodes >= 257 && dcodes >= 1 && blcodes >= 4, "not enough codes");
//	    Assert (lcodes <= L_CODES && dcodes <= D_CODES && blcodes <= BL_CODES,
//		    "too many codes");
//	    Tracev((stderr, "\nbl counts: "));
	    this._send_bits(lcodes-257, 5); // not +255 as stated in appnote.txt
	    this._send_bits(dcodes-1,   5);
	    this._send_bits(blcodes-4,  4); // not -3 as stated in appnote.txt
	    for(rank = 0; rank < blcodes; rank++) {
//	      Tracev((stderr, "\nbl code %2d ", bl_order[rank]));
	    	this._send_bits(this._bl_tree[this._bl_order[rank]].dl, 3);
	    }

	    // send the literal tree
	    this._send_tree(this._dyn_ltree,lcodes-1);

	    // send the distance tree
	    this._send_tree(this._dyn_dtree,dcodes-1);
	},
	
	/* ==========================================================================
	 * Send a value on a given number of bits.
	 * IN assertion: length <= 16 and value fits in length bits.
	 */
	
	_send_bits: function(
		value,	// value to send
		length) {	// number of bits
	    /* If not enough room in bi_buf, use (valid) bits from bi_buf and
	     * (16 - bi_valid) bits from value, leaving (width - (16-bi_valid))
	     * unused bits in value.
	     */
	    if(this._bi_valid > this._Buf_size - length) {
			this._bi_buf |= (value << this._bi_valid);
			this._put_short(this._bi_buf);
			this._bi_buf = (value >> (this._Buf_size - this._bi_valid));
			this._bi_valid += length - this._Buf_size;
	    } else {
			this._bi_buf |= value << this._bi_valid;
			this._bi_valid += length;
	    }
	},
	

	/* ==========================================================================
	 * Write out any remaining bits in an incomplete byte.
	 */
	_bi_windup: function() {
	    if(this._bi_valid > 8) {
	    	this._put_short(this._bi_buf);
	    } else if(this._bi_valid > 0) {
	    	this._put_byte(this._bi_buf);
	    }
	    this._bi_buf = 0;
	    this._bi_valid = 0;
	},
	
	/* Output a 16 bit value, lsb first */
	_put_short: function(w) {
	    w &= 0xffff;
	    if(this._outoff + this._outcnt < this._OUTBUFSIZ - 2) {
			this._outbuf[this._outoff + this._outcnt++] = (w & 0xff);
			this._outbuf[this._outoff + this._outcnt++] = (w >>> 8);
	    } else {
			this._put_byte(w & 0xff);
			this._put_byte(w >>> 8);
	    }
	},
	
	/* put_byte is used for the compressed output, put_ubyte for the
	 * uncompressed output. However unlzw() uses window for its
	 * suffix table instead of its output buffer, so it does not use put_ubyte
	 * (to be cleaned up).
	 */
	_put_byte: function(c) {
	    this._outbuf[this._outoff + this._outcnt++] = c;
	    if(this._outoff + this._outcnt == this._OUTBUFSIZ){
	    	this._qoutbuf();
	    }
	},
	
	  /* ==========================================================================
	   * Send the block data compressed using the given Huffman trees
	   */
	_compress_block: function(
		ltree,	// literal tree
		dtree) {	// distance tree
	    var dist;		// distance of matched string
	    var lc;		// match length or unmatched char (if dist == 0)
	    var lx = 0;		// running index in l_buf
	    var dx = 0;		// running index in d_buf
	    var fx = 0;		// running index in flag_buf
	    var flag = 0;	// current flags
	    var code;		// the code to send
	    var extra;		// number of extra bits to send

	    if(this._last_lit != 0){
	    	do {
				if((lx & 7) == 0){
					flag = this._flag_buf[fx++];
				}
				lc = this._l_buf[lx++] & 0xff;
				if((flag & 1) == 0) {
				    this._SEND_CODE(lc, ltree); /* send a literal byte */
		//		Tracecv(isgraph(lc), (stderr," '%c' ", lc));
				} else {
				    // Here, lc is the match length - MIN_MATCH
				    code = this._length_code[lc];
				    this._SEND_CODE(code+this._LITERALS+1, ltree); // send the length code
				    extra = this._extra_lbits[code];
				    if(extra != 0) {
						lc -= this._base_length[code];
						this._send_bits(lc, extra); // send the extra length bits
				    }
				    dist = this._d_buf[dx++];
				    // Here, dist is the match distance - 1
				    code = this._D_CODE(dist);
		//		Assert (code < D_CODES, "bad d_code");
		
				    this._SEND_CODE(code, dtree);	  // send the distance code
				    extra = this._extra_dbits[code];
				    if(extra != 0) {
						dist -= this._base_dist[code];
						this._send_bits(dist, extra);   // send the extra distance bits
				    }
				} // literal or match pair ?
				flag >>= 1;
	    } while(lx < this._last_lit);
	}

	    this._SEND_CODE(this._END_BLOCK, ltree);
	},
	
	
	/* ==========================================================================
	 * Initialize a new block.
	 */
	_init_block: function() {
	    var n; // iterates over tree elements

	    // Initialize the trees.
	    for(n = 0; n < this._L_CODES;  n++){
	    	this._dyn_ltree[n].fc = 0;
	    }
	    for(n = 0; n < this._D_CODES;  n++){
	    	this._dyn_dtree[n].fc = 0;
	    }
	    for(n = 0; n < this._BL_CODES; n++){
	    	this._bl_tree[n].fc = 0;
	    }

	    this._dyn_ltree[this._END_BLOCK].fc = 1;
	    this._opt_len = this._static_len = 0;
	    this._last_lit = this._last_dist = this._last_flags = 0;
	    this._flags = 0;
	    this._flag_bit = 1;
	},

	/* ==========================================================================
	 * Restore the heap property by moving down the tree starting at node k,
	 * exchanging a node with the smallest of its two sons if necessary, stopping
	 * when the heap property is re-established (each father smaller than its
	 * two sons).
	 */
	_pqdownheap: function(tree,	// the tree to restore
			k) {	// node to move down
	    var v = this._heap[k];
	    var j = k << 1;	// left son of k

	    while(j <= this._heap_len) {
			// Set j to the smallest of the two sons:
			if(j < this._heap_len &&
			   this._SMALLER(tree, this._heap[j + 1], this._heap[j])){
				j++;
			}
	
			// Exit if v is smaller than both sons
			if(this._SMALLER(tree, v, this._heap[j])){
				break;
			}
	
			// Exchange v with the smallest son
			this._heap[k] = this._heap[j];
			k = j;
	
			// And continue down the tree, setting j to the left son of k
			j <<= 1;
	    }
	    this._heap[k] = v;
	},

	/* ==========================================================================
	 * Compute the optimal bit lengths for a tree and update the total bit length
	 * for the current block.
	 * IN assertion: the fields freq and dad are set, heap[heap_max] and
	 *    above are the tree nodes sorted by increasing frequency.
	 * OUT assertions: the field len is set to the optimal bit length, the
	 *     array bl_count contains the frequencies for each bit length.
	 *     The length opt_len is updated; static_len is also updated if stree is
	 *     not null.
	 */
	_gen_bitlen: function(desc) { // the tree descriptor
	    var tree		= desc.dyn_tree;
	    var extra		= desc.extra_bits;
	    var base		= desc.extra_base;
	    var max_code	= desc.max_code;
	    var max_length	= desc.max_length;
	    var stree		= desc.static_tree;
	    var h;		// heap index
	    var n, m;		// iterate over the tree elements
	    var bits;		// bit length
	    var xbits;		// extra bits
	    var f;		// frequency
	    var overflow = 0;	// number of elements with bit length too large

	    for(bits = 0; bits <= this._MAX_BITS; bits++){
	    	this._bl_count[bits] = 0;
	    }

	    /* In a first pass, compute the optimal bit lengths (which may
	     * overflow in the case of the bit length tree).
	     */
	    tree[this._heap[this._heap_max]].dl = 0; // root of the heap

	    for(h = this._heap_max + 1; h < this._HEAP_SIZE; h++) {
			n = this._heap[h];
			bits = tree[tree[n].dl].dl + 1;
			if(bits > max_length) {
			    bits = max_length;
			    overflow++;
			}
			tree[n].dl = bits;
			// We overwrite tree[n].dl which is no longer needed
	
			if(n > max_code){
				continue; // not a leaf node
			}
	
			this._bl_count[bits]++;
			xbits = 0;
			if(n >= base){
				xbits = extra[n - base];
			}
			f = tree[n].fc;
			this._opt_len += f * (bits + xbits);
			if(stree != null){
				this._static_len += f * (stree[n].dl + xbits);
			}
	    }
	    if(overflow == 0){
	    	return;
	    }

	    // This happens for example on obj2 and pic of the Calgary corpus

	    // Find the first bit length which could increase:
	    do {
			bits = max_length - 1;
			while(this._bl_count[bits] == 0){
				bits--;
			}
			this._bl_count[bits]--;		// move one leaf down the tree
			this._bl_count[bits + 1] += 2;	// move one overflow item as its brother
			this._bl_count[max_length]--;
			/* The brother of the overflow item also moves one step up,
			 * but this does not affect bl_count[max_length]
			 */
			overflow -= 2;
	    } while(overflow > 0);

	    /* Now recompute all bit lengths, scanning in increasing frequency.
	     * h is still equal to HEAP_SIZE. (It is simpler to reconstruct all
	     * lengths instead of fixing only the wrong ones. This idea is taken
	     * from 'ar' written by Haruhiko Okumura.)
	     */
	    for(bits = max_length; bits != 0; bits--) {
			n = this._bl_count[bits];
			while(n != 0) {
			    m = this._heap[--h];
			    if(m > max_code){
			    	continue;
			    }
			    if(tree[m].dl != bits) {
					this._opt_len += (bits - tree[m].dl) * tree[m].fc;
					tree[m].fc = bits;
			    }
			    n--;
			}
	    }
	},
	
	/* ==========================================================================
	 * Reverse the first len bits of a code, using straightforward code (a faster
	 * method would use a table)
	 * IN assertion: 1 <= len <= 15
	 */
	_bi_reverse: function(
		code,	// the value to invert
		len) {	// its bit length
	    var res = 0;
	    do {
			res |= code & 1;
			code >>= 1;
			res <<= 1;
	    } while(--len > 0);
	    return res >> 1;
	},
	
	
	  /* ==========================================================================
	   * Generate the codes for a given tree and bit counts (which need not be
	   * optimal).
	   * IN assertion: the array bl_count contains the bit length statistics for
	   * the given tree and the field len is set for all tree elements.
	   * OUT assertion: the field code is set for all tree elements of non
	   *     zero code length.
	   */
	_gen_codes: function(tree,	// the tree to decorate
			   max_code) {	// largest code with non zero frequency
	    var next_code = new Array(this._MAX_BITS+1); // next code value for each bit length
	    var code = 0;		// running code value
	    var bits;			// bit index
	    var n;			// code index

	    /* The distribution counts are first used to generate the code values
	     * without bit reversal.
	     */
	    for(bits = 1; bits <= this._MAX_BITS; bits++) {
		code = ((code + this._bl_count[bits-1]) << 1);
		next_code[bits] = code;
	    }

	    /* Check that the bit counts in bl_count are consistent. The last code
	     * must be all ones.
	     */
//	    Assert (code + encoder->bl_count[MAX_BITS]-1 == (1<<MAX_BITS)-1,
//		    "inconsistent bit counts");
//	    Tracev((stderr,"\ngen_codes: max_code %d ", max_code));

	    for(n = 0; n <= max_code; n++) {
		var len = tree[n].dl;
		if(len == 0)
		    continue;
		// Now reverse the bits
		tree[n].fc = this._bi_reverse(next_code[len]++, len);

//	      Tracec(tree != static_ltree, (stderr,"\nn %3d %c l %2d c %4x (%x) ",
//		  n, (isgraph(n) ? n : ' '), len, tree[n].fc, next_code[len]-1));
	    }
	},
	_qoutbuf: function() {
	    if(this._outcnt != 0) {
		var q, i;
		q = this._new_queue();
		if(this._qhead == null)
		    this._qhead = this._qtail = q;
		else
		    this._qtail = this._qtail.next = q;
		q.len = this._outcnt - this._outoff;
//	      System.arraycopy(this._outbuf, this._outoff, q.ptr, 0, q.len);
		for(i = 0; i < q.len; i++)
		    q.ptr[i] = this._outbuf[this._outoff + i];
		this._outcnt = this._outoff = 0;
	    }
	},
	
	_new_queue: function() {
	    var p;

	    if(this._free_queue != null)
	    {
			p = this._free_queue;
			this._free_queue = this._free_queue.next;
	    }
	    else{
	    	p = new _DeflateBuffer(this._OUTBUFSIZ);
	    }
	    p.next = null;
	    p.len = p.off = 0;

	    return p;
	},
	
	destroy: function() {
	    this._free_queue = this._qhead = this._qtail = null;
	    this._outbuf = null;
	    this._window = null;
	    this._d_buf = null;
	    this._l_buf = null;
	    this._prev = null;
	    this._dyn_ltree = null;
	    this._dyn_dtree = null;
	    this._static_ltree = null;
	    this._static_dtree = null;
	    this._bl_tree = null;
	    this._l_desc = null;
	    this._d_desc = null;
	    this._bl_desc = null;
	    this._bl_count = null;
	    this._heap = null;
	    this._depth = null;
	    this._length_code = null;
	    this._dist_code = null;
	    this._base_length = null;
	    this._base_dist = null;
	    this._flag_buf = null;
	}
	
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/ngAPI/GAHandler/GAGameStateHandler'] = function(){var exports = $MODULE_REGISTRY['Code/ngAPI/GAHandler/GAGameStateHandler'] || {}; $MODULE_REGISTRY['Code/ngAPI/GAHandler/GAGameStateHandler'] = exports; /**
 *FileName: GAGameStateHandler.js
 *Author: Abid Hussain
 *DateCreated: 
 */
exports.GAGameStateHandler = Core.Class.singleton({
	classname: 'GAGameStateHandler',
	initialize: function(){
		this._delegate = null;
		this._level = null;
		this._cExperience = null;
		this._sExperience = null;
		this._userkey = null;
		this._fileNames = null;
		this._gameDelegate = null;
		this._lastModifiedTime = 0;
		this._readCount = 0;
		this._fileCount = 0;
		this._udidStatePresent = true;
		this._userKeyStatePresent = true;
		this._serverLastModifiedTime = 0;
		this._storage = new Storage.KeyValue();
		this._dbPath = null;
		this._purchasedCoins = 0;
		this._purchasedBucks = 0;
		this._offerBucks = 0;
		this._offerCoins = 0;
		this._getConfigParams();
	},
	
	startGameState: function(delegate,gameDelegate){
		this._delegate = delegate;
		this._gameDelegate = gameDelegate;
		this._getXPFromServer();
	},
	_getConfigParams: function(){
		this._fileNames = GAConfigurations.getDbFileNames();
		this._dbPath = GAConfigurations.getGameStateDBPath();
		this._userkey = GAConfigurations.getUserId();
		this._saveXpKey = GAConfigurations.getGameCode()+GAConfigurations.getUserId()+kGAGameState.kLastSavedXp;
	},
	
	_getXPFromServer: function(){
		var baseUrl = '';
		var responseObject = GAGameLoader.getResponseObject();
		if(responseObject != null){
			baseUrl = responseObject.getGameServer();	
		}
		baseUrl = baseUrl.replace('/gameState','/getGameStateInfo');
		var url = baseUrl+'?game='+GAConfigurations.getGameCode()+'&userkey='+this._userkey;
		var fetcher = new GAWebFetcher(this,30,0);
		fetcher.invokeGetRequest(url);
	},
	
	webFetchSuccess: function(webFetcher,response){
		try{
			var serverResponse = eval("("+ response +")");
			var status = serverResponse.status;
			if(status.code != 1){
				this._gameDelegate.readDataBase(this._dbPath,this.readDbSuccess.bind(this));
			}
			else{
				var data = serverResponse.data;
				this._sExperience = data.experience;
				var serverLMTime = data.gamestatelastupdatetime;
				serverLMTime  = this._dateFromUTC(serverLMTime, "-");
				this._serverLastModifiedTime = Date.parse(serverLMTime);
				this._saveExperience(this._sExperience);
				var path = this._dbPath+'/'+this._userkey;
				this._gameDelegate.readDataBase(path,this.readXpAndLevelSuccess.bind(this));
			}
		}
		catch(exception){
			this._delegate.gameStateFailure('>>Error while parsing GameStateInfo response = '+exception);
		}
		finally{
			if(webFetcher != null){
				webFetcher.destroy();
				webFetcher = null;
			}
		}
	},
	webFetchFailure: function(webFetcher,error){
		this._delegate.gameStateFailure('>>getGameStateInfo Failure = '+error);
		if(webFetcher != null){
			webFetcher.destroy();
			webFetcher = null;
		}
	},
	_saveExperience: function(value){
		this._storage.setItem(this._saveXpKey,value);
	},
	readDbSuccess: function(level,experience,offerCoins,offerBucks,purchasedCoins,purchasedBucks,fileNames){
		this._level = level;
		this._cExperience = experience;
		this._purchasedCoins = purchasedCoins;
		this._purchasedBucks = purchasedBucks;
		this._offerCoins = offerCoins;
		this._offerBucks = offerBucks;
		if(typeof(fileNames) != 'undefined' && fileNames != null){
			this._fileNames = this._fileNames.concat(fileNames);
			GAConfigurations.setDbFileNames(this._fileNames);
		}
		this._replaceGameState();
	},
	
	readXpAndLevelSuccess: function(level,experience,purchasedCoins,purchasedBucks,offerCoins,offerBucks,fileNames){
		this._level = level;
		this._cExperience = experience;
		if(typeof(fileNames) != 'undefined' && fileNames != null){
			this._fileNames = this._fileNames.concat(fileNames);
			GAConfigurations.setDbFileNames(this._fileNames);
		}
		this._isGameStateForCurrentUserPresent();
	},
	
	_replaceGameState: function (){
		var totalFiles = this._fileNames.length;
		for(var i=0; i< totalFiles; i++){
			var name = this._fileNames[i];
			Storage.FileSystem.readFile(this._dbPath+'/'+name+'.json',false,this._readFileCb.bind(this,name,totalFiles));
		}
	},
	_readFileCb: function(name,totalFiles,error, data){
		this._readCount ++;
		if(!error && this._udidStatePresent){
			Storage.FileSystem.writeFile(this._dbPath+'/'+this._userkey+'/'+name+'.json',data,this._writeFileCb.bind(this));	
		}
		else{
			this._udidStatePresent = false;
		}
		if(this._readCount == totalFiles){
			this._readCount = 0;
			if(this._udidStatePresent){
				//make call to read DB
				var currencyHandler = new GACurrencyUpdateHandler(this);
				currencyHandler.updateCurrency(this._purchasedCoins,this._purchasedBucks,this._offerCoins,this._offerBucks);
			}
			//if gameState against udid is not present
			else{
				// Fetch gameState for the current user
				GAGameStateGetHandler.restoreGameState(this);
			}
		}
	},
	_writeFileCb: function(error){
		if(error){
			this._delegate.gameStateFailure('>>Error while writing gameState = '+error);
		}
	},
	
	currencyUpdateSuccess: function(){
		var totalFiles = this._fileNames.length;
		for(var i=0; i< totalFiles; i++){
			Storage.FileSystem.deleteFile(this._dbPath+'/'+this._fileNames[i]+'.json');
		}
		GAGameStatePostHandler.postGameState(this,this._fileNames,this._level,this._cExperience);
	},
	currencyUpdateFailure: function(error){
		this._delegate.gameStateFailure('>>currencyUpdateFailure with error = '+error);
	},
	
	_isGameStateForCurrentUserPresent: function(){
		var totalFiles = this._fileNames.length;
		for(var i=0; i< totalFiles; i++){
			Storage.FileSystem.readFile(this._dbPath+'/'+this._userkey+'/'+this._fileNames[i]+'.json',this._readGameStateForUserCb.bind(this,totalFiles));
		}
	},
	_readGameStateForUserCb: function(totalFiles,error,data){
		this._fileCount ++;
		if(error){
			this._userKeyStatePresent = false;
		}
		if(this._fileCount == totalFiles){
			//game state exists
			if(this._userKeyStatePresent){
				this._compareXPAndLMD();
			}
			//game state does not exists
			else{
				// Fetch gameState for the current user
				GAGameStateGetHandler.restoreGameState(this);
			}
			this._fileCount = 0;
		}
	},

	
	_compareXPAndLMD: function(){
		console.log('>>ClientXP = '+this._cExperience+' and ServerXP = '+this._sExperience);
		if(this._cExperience > this._sExperience){
			//postGameStatefor current user
			GAGameStatePostHandler.postGameState(this,this._fileNames,this._level,this._cExperience);
		}
		else if( this._cExperience < this._sExperience){
			//Fetch game state for current user
			GAGameStateGetHandler.restoreGameState(this);
		}
		else{
			this._getLMTimeOfClient();
		}
	},
	_getLMTimeOfClient: function(){
		this._storage.getItem(kGAGameState.kLastModifiedTime,this._getLMTimeCb.bind(this));
	},
	
	_getLMTimeCb: function(error,value,key){
		if(!error){
			this._lastModifiedTime = value;
		}
		if(this._lastModifiedTime == this._serverLastModifiedTime){
			//postGameStateFor current user
			GAGameStatePostHandler.postGameState(this,this._fileNames,this._level,this._cExperience);
		}
		else{
			//fetchGameStateforCurrentUser
			GAGameStateGetHandler.restoreGameState(this);
		}
	},
	
	_dateFromUTC: function( dateAsString, ymdDelimiter ){
		 var pattern = new RegExp( "(\\d{4})" + ymdDelimiter + "(\\d{2})" + ymdDelimiter + "(\\d{2}) (\\d{2}):(\\d{2}):(\\d{2})" );
		 var parts = dateAsString.match( pattern );
		 return new Date(Date.UTC(parseInt( parts[1] ), parseInt( parts[2], 10 ) - 1, parseInt( parts[3], 10 ), parseInt( parts[4], 10 ), parseInt( parts[5], 10 ), parseInt( parts[6], 10 ),0));
	},
	
	gameStateGetSuccess: function(){
		console.log('>>gameStateGetSuccess');
		 this._gameDelegate.updateFileNames();
		this._delegate.gameStateSuccess();
	},
	gameStateGetFailure: function(error){
		this._delegate.gameStateFailure('>>gameStateGetFailure with error = '+error);
	},
	gameStatePostSuccess: function(){
		console.log('>>gameStatePostSuccess');
		this._delegate.gameStateSuccess();
	},
	gameStatePostFailure: function(error){	
		this._delegate.gameStateFailure('>>gameStatePostFailure with error = '+error);
	},
	destroy: function(){
		this._dbPath = null;
		this._fileNames = null;
		this._readCount = null;
		this._userkey = null;
		this._udidStatePresent = null;
		this._userKeyStatePresent = null;
		this._level = null;
		this._cExperience = null;
		this._sExperience = null;
		this._fileCount = null;
		this._lastModifiedTime = null;
		this._serverLastModifiedTime = null;
		this._storage = null;
		this._purchasedCoins = null;
		this._purchasedBucks = null;
		this._offerCoins = null;
		this._offerBucks = null;
		this._saveXpKey = null;
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/ngAPI/GAHandler/GAGameStateManager'] = function(){var exports = $MODULE_REGISTRY['Code/ngAPI/GAHandler/GAGameStateManager'] || {}; $MODULE_REGISTRY['Code/ngAPI/GAHandler/GAGameStateManager'] = exports; /**
 * Filename: GAGameStateManager.js
 * Author: Abid Hussain
 * DateCreated: 15/07/2011
 */
exports.GAGameStateManager = Core.Class.singleton({
	initialize: function(){
		this._timeOut = 10;
		this._dbFiles = null;
		this._level = 1;
		this._localXP = 0;
		this._savedXP = 0;
		this._getSaveXpKey();
	},
	startTimer: function(timeOut){
		this._timeOut = timeOut;
		this._getConfigParams();
		this._storage = new Storage.KeyValue();
		setTimeout(this._getSavedXp.bind(this),this._timeOut*1000);
	},
	setDelegate: function(delegate){
		this._delegate = delegate;
	},
	_getSaveXpKey: function(){
		this._saveXpKey = GAConfigurations.getGameCode()+GAConfigurations.getUserId()+kGAGameState.kLastSavedXp;
	},
	_getConfigParams: function(){
		this._dbFiles = GAConfigurations.getDbFileNames();
		this._level = GAConfigurations.getGameLevel();
		this._localXP = GAConfigurations.getGameXp();
	},
	_getSavedXp: function(){
		this._storage.getItem(this._saveXpKey,this._getSavedXpCallback.bind(this));
	},
	_getSavedXpCallback: function(error,value,key){
		this._getConfigParams();
		if(!error){
			this._savedXP = value;
		}
		if(this._localXP > this._savedXP){
			this._postState();
		}
		else{
			this.startTimer(kGAGameState.kTimeOut);
		}
		console.log('>>_getSavedXpCallback :: localXP = '+this._localXP+' and saveXP = '+this._savedXP);
	},
	_postState: function(){
		var level = 0;
		var localXP = 0;
		if(!this._level && !this._localXP)
		{
			var user = TFGameState.getCurrentUser();//TZGameLayer.getUser();
      	 	level = user._userObj.currentLevel;
			localXP = user._userObj.exp;
		}
		else
		{
			level = this._level;
			localXP = this._localXP;
		}
		GAGameStatePostHandler.postGameState(this,this._dbFiles,level,localXP);
	},
	gameStatePostSuccess: function(statusCode){
		console.log('>>gameStatePostSuccess ... '+statusCode);
		if(statusCode == 0){
//			this._delegate.restartGame();
		}
		else{
			this._saveCurrentXp();
		}
	},
	gameStatePostFailure: function(error){
		console.log('gameStatePostFailure ...'+error);
		this.startTimer(kGAGameState.kTimeOut);
	},
	_saveCurrentXp: function(){
		this._storage.setItem(this._saveXpKey,this._localXP,this._savedXPCallback.bind(this));
	},
	_savedXPCallback: function(){
		this.startTimer(kGAGameState.kTimeOut);
	},
	
	destroy: function(){
		this._delegate = null;
		this._timeOut = null;
		this._dbFiles = null;
		this._level = null;
		this._localXP = null;
		this._savedXP = null;
		this._storage = null;
		this._saveXpKey = null;
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/ngAPI/GAHandler/GAStoreLoader'] = function(){var exports = $MODULE_REGISTRY['Code/ngAPI/GAHandler/GAStoreLoader'] || {}; $MODULE_REGISTRY['Code/ngAPI/GAHandler/GAStoreLoader'] = exports; /**
 * @author salman.humdullah
 */
exports.GAStoreLoader = Core.Class.subclass({
	classname: 'GAStoreLoader',

	initialize : function(responseObject) {
		this._delegate = null;
		this._responseObject = responseObject;
		this._storeListener = null;
		this._baseURL = null;
		this._gameName = null;
		this._parseStores = true;
		this._successfullyDownloadedStore = 0;
		this._totalStoresToDownload = 0;
		//this._updatedVersionStores = [];
		this._storage = new Storage.KeyValue();
		var startingServer = Core.Capabilities.getStartingServer();
		if (startingServer!= null && startingServer.length > 30) {
			startingServer = startingServer.substring(0, 30);
		}
		this._keyPrefix = "_" + startingServer + GAConfigurations.getGameCode();
	},

	loadStores : function(delegate)
	{
		this._delegate = delegate;
		this._baseURL = this._responseObject.getStoreServer();
		this._gameName = GAConfigurations.getGameName();
		var storeVersionModel = this._responseObject.getStoresModel();
		this._totalStoresToDownload = storeVersionModel.length;
		if (this._totalStoresToDownload == 0) {
			this._parseStores = false;
			this._delegate.storeDownloaderSuccess(this._parseStores);
		}
		else{
			this._updatedStoreVersions();
		}
	},
	_updatedStoreVersions : function(){
		//var storeNames = this._responseObject.getStoreNames();
		var stores = this._responseObject.getStoresModel();
		var length = stores.length;
		for( var i=length-1 ; i >= 0; i--){
			this._storage.getItem(stores[i].getVisibleId() + this._keyPrefix, this._getVersionKey.bind(this));
		}
	},
	_getVersionKey : function(error, currentVersion, visibleId){
		var parts = visibleId.split("_");
		if (parts.length > 1) {
			visibleId = parts[0];
		}
		var storeVersion = this._responseObject.getStoreVersion(visibleId);
		if(currentVersion == 0 || currentVersion == null || typeof(currentVersion) == 'undefined' || currentVersion == ''){
			this._saveToPreferenceAndDownload(visibleId);
		}
		else if(storeVersion > currentVersion){
			this._saveToPreferenceAndDownload(visibleId);
		}
		else{
			this._successfullyDownloadedStore++;
			if(this._successfullyDownloadedStore == this._totalStoresToDownload) {
				this._delegate.storeDownloaderSuccess(this._parseStores);
			/*}else{
				this._updatedStoreVersions();*/
			}
		}
	},
	_saveToPreferenceAndDownload : function(visibleId){
		//this._updatedVersionStores.push(visibleId);
		this._startDownloadingStores(visibleId);
	},
	_startDownloadingStores : function(visibleId){
		var storeId = this._responseObject.getStoreId(visibleId);
		var url = this._baseURL+"serverstore?store_id=" +storeId+"&game="+this._gameName+"&type=json";
		url=encodeURI(url);
		console.log("Downloading store: " + url);
		var fileDownloader = new GAFileDownloader('./Content/'+visibleId+'.zip' ,'GET' ,url ,null ,new this.GAStoreDownloaderDelegate(visibleId, this));
		fileDownloader.startDownloading();
	},


	$GAStoreDownloaderDelegate : Core.Class.subclass({
		classname : 'GAStoreWebFetcherDelegate',

		initialize : function(storeVisibleId, parent){
			this._parent = parent;
			this._storeVisibleId = storeVisibleId;
		},
		/* abid . hussain*/
		onDownloadSuccess : function(fileDownloader ,fileSignature){
			try{
				var destination = './Content/stores/';
				Storage.FileSystem.decompressFile('./Content/'+this._storeVisibleId+'.zip', destination,true,this._zipExtractionCb.bind(this));
				if( fileDownloader != null){
					fileDownloader.destroy();
					fileDownloader = null;
				}
			}
			catch(exception){
				this._parent._delegate.storeDownloaderFailure(exception);
			}
		},
		/* abid . hussain*/
		_zipExtractionCb : function(error, files){
			if(!error) {
				var storeVersion = this._parent._responseObject.getStoreVersion(this._storeVisibleId);
				this._parent._successfullyDownloadedStore++;
				Storage.FileSystem.deleteFile('./Content/'+this._storeVisibleId+'.zip');
				this._parent._storage.setItem(this._storeVisibleId + this._parent._keyPrefix, storeVersion, this._storeVersionCommittedCB.bind(this));
				//Storage.FileSystem.readFile("./Content/stores/" + this._storeVisibleId + ".json", this.readCompleted.bind(this));
				if(this._parent._successfullyDownloadedStore == this._parent._totalStoresToDownload){
					this._parent._delegate.storeDownloaderSuccess(this._parent._parseStores);
				}
			}
			else{
				this._parent._delegate.storeDownloaderFailure("Zip extraction failed for store with visible Id " + this._storeVisibleId);
			}
		},

		_storeVersionCommittedCB : function(error, key){
		},

		/* abid . hussain*/
		onDownloadFailure : function(fileDownloader, statusCode){
			console.log('Download failed for Store visible Id-> '+this._storeVisibleId+' with StatusCode = '+ statusCode);
			this._parent._delegate.storeDownloaderFailure(statusCode);
			if(fileDownloader != null){
				fileDownloader.destroy();
				fileDownloader = null;
			}
		},
		destroy : function(){
			this._parent = null;
			this._storeVisibleId = null;
		}

	}),

	destroy : function() {
		this._delegate = null;
		/*var size = this._updatedVersionStores.length;
		for(var i=0; i<size; i++){
			this._updatedVersionStores[i] = null;
		}
		this._updatedVersionStores = null;*/
		this._responseObject = null;
		this._storage = null;
		this._keyPrefix = null;
	}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/ngAPI/GAHandler/GAStoreHandler'] = function(){var exports = $MODULE_REGISTRY['Code/ngAPI/GAHandler/GAStoreHandler'] || {}; $MODULE_REGISTRY['Code/ngAPI/GAHandler/GAStoreHandler'] = exports; 
exports.GAStoreHandler = Core.Class.subclass ({

	initialize: function(stores, successCallback, failureCallback) {
		this._stores = stores;
		this._successCallback = successCallback;
		this._failureCallback = failureCallback;
		this._totalStores = this._stores.length;
		this._loadCounter = 0;
		this._objects = {};
	},
	
	startLoading: function() {
		Storage.FileSystem.readFile(this.getStorePath(), this.loadComplete.bind(this));
	},
	
	getStorePath: function(fileName) {
		var path = [];
		path.push("./Content/stores/");
		path.push(this._stores[this._loadCounter]);
		path.push(".json");
		return path.join("");
	},
	
	loadComplete: function(error, contents) {
		var visibleId = this._stores[this._loadCounter];
        this._loadCounter++;		
		if (!error) {
			var obj = eval("(" + contents + ")");
			if (typeof this._companyId == 'undefined') {
				this._companyId = obj.company.id;
			}
			if (typeof this._gameId == 'undefined') {
				this._gameId = obj.company.game.id;
			}
			var store = obj.company.game.store;
			this.setParentReferences(store);
			this._objects[visibleId + ""] = store;
			if (this._loadCounter < this._totalStores) {
				Storage.FileSystem.readFile(this.getStorePath(), this.loadComplete.bind(this));
			}
			else {
				this._successCallback();
			}
		}
		else {
				console.log('*********checking skipping :: storeParserFailure:: *********'+this._loadCounter+' vs '+this._totalStores);
			if(this._loadCounter < this._totalStores) {
				console.log('*********skipping :: storeParserFailure:: *********'+visibleId);
				var preferences = new Storage.KeyValue();
				preferences.setItem(visibleId, -1);
				Storage.FileSystem.readFile(this.getStorePath(), this.loadComplete.bind(this));
			}
			else {
				this._failureCallback(error, visibleId);
			}
		}
	},
	
	setParentReferences: function(store) {
		store.parent = null;
		store.objectType = "store";
		var cats = store.categories;
		if (typeof cats != 'undefined') {
			var totalCats = cats.length;
			for (var i = 0; i < totalCats; i++) {
				var cat = cats[i];
				cat.parent = store;
				cat.objectType = "cat";
				var items = cat.items;
				var totalItems = items.length;
				if (typeof items != 'undefined') {
					for (var j = 0; j < totalItems; j++) {
						items[j].parent = cat;
						items[j].objectType = "item";
					}
					cat.activeItems = items.filter(this.keepObject.bind(this));
				}
			}
			store.activeCategories = cats.filter(this.keepObject.bind(this));
		}
	},
	
	keepObject: function(storeObject) {	// return true if we'd like to keep this object (and NOT filter it)
		var gameVersion = GAConfigurations.getGameVersion();
		var isQAUser = GAGameLoader.getResponseObject().isQAUser();
		var minVersion = (typeof storeObject.version_min != 'undefined') ? storeObject.version_min : 0;
		var maxVersion = (typeof storeObject.version_max != 'undefined') ? storeObject.version_max : gameVersion;
		if (gameVersion >= minVersion && gameVersion <= maxVersion && storeObject.is_active == true) {
			if (isQAUser == false && storeObject.visible_to.toLowerCase() == "qa".toLowerCase()) {
				return false;
			}
			else {
				return true;
			}
		}
		else {
			return false;
		}
	},
	
	getCompanyId: function() {
		return this._companyId;
	},
	
	getGameId: function() {
		return this._gameId;
	},
	
	getStore: function(storeId) {
		var store = this._objects[storeId];
		if (typeof store != 'undefined') {
			return store;
		}
		return null;
	},
	
	getCategory: function(storeId, catId, active) {
		var store = this._objects[storeId];
		if (typeof store != 'undefined') {
			var categories = (active == true) ? store.activeCategories : store.categories;
			if (typeof categories != 'undefined') {
				var totalCats = categories.length;
				for (var i = 0; i < totalCats; i++) {
					if (categories[i].visible_id == catId) {
						return categories[i];
					}
				}
			}
			return null;
		}
		return null;
	},
	
	getCategoryByIndex: function(storeId, catIndex, active) { 
		//catIndex is the position of a category within the categories array.
		var store = this._objects[storeId];
		if (typeof store != 'undefined') {
			var categories = (active == true) ? store.activeCategories : store.categories;
			if (typeof categories != 'undefined') {
				return categories[catIndex];
			}
			return null;
		}
		return null;
	},
	
	getItem: function(storeId, catId, itemId, active) {
		var category = this.getCategory(storeId, catId, active);
		if (category != null) {
			var items = (active == true) ? category.activeItems : category.items;
			if (typeof items != 'undefined') {
				var totalItems = items.length;
				for (var i = 0; i < totalItems; i++) {
					if (items[i].visible_id == itemId) {
						return items[i];
					}
				}
			}
			return null;
		}
		return null;
	},
	
	getItemByIndex: function(storeId, catIndex, itemIndex, active) { 
		//catIndex & itemIndex are the positions of a category and an item within the categories & items array respectively.
		var category = this.getCategory(storeId, catIndex, active);
		if (category != null) {
			var items = active == true ? category.activeItems : category.items;
			if (typeof items != 'undefined') {
				return items[itemIndex];
			}
			return null;
		}
		return null;
	},
	
	getStoreObject: function(storeId,catId,itemId)
	{
		if(itemId != null)
		{
			return this.getItem(storeId, catId, itemId, false);
		}
		if(catId != null)
		{
			return this.getCategory(storeId, catId, false);
		}
		if(storeId != null)
		{
			return this.getStore(storeId);
		}
		return null;
	},
	
	getAllCategories: function(storeId, active) {
		var store = this._objects[storeId];
		if (typeof store != 'undefined') {
			return (active == true ? store.activeCategories : store.categories);
		}
		return null;
	},
	
	getAllItems: function(storeId, catId, active) {
		var category = this.getCategory(storeId, catId, active);
		if (category != null) {
			return (active == true ? category.activeItems : category.items);
		}
		return null;
	},
	
	getAllItemsByCategoryIndex: function(storeId, catIndex, active) {
		var category = this.getCategoryByIndex(storeId, catIndex, active);
		if (category != null) {
			return (active == true) ? category.activeItems : category.items;
		}
		return null;		
	},
	
	releaseObject: function(store) {
		var categories = store.activeCategories;
		var totalCats = categories.length;
		for (var i = 0; i < totalCats; i++) {
			delete categories[i].activeItems;
		}
		delete store.activeCategories;
	},
	
	getStoreObjectForKey: function(key)
	{
		if(key != null)
		{
			var storeKeys = key.split("_");
			if(storeKeys.length == 1)//store
			{
				return this.getStoreObject(storeKeys[0]);
				//console.log("Store");
				return null;
			}
			else if(storeKeys.length == 2)//category
			{
				return this.getStoreObject(storeKeys[0], storeKeys[1]);
				//console.log("Cat");
				return null;
			}
			else if(storeKeys.length == 3)//storeitem
			{
				return this.getStoreObject(storeKeys[0], storeKeys[1], storeKeys[2]);
				//console.log("StoreItem");
				return null;
			}
			else//invalid key
			{
				//console.log("null");
				return null;
			}
		}
		//console.log("null");
		return null;
	},
	
	destroy: function() {
		for (var i in this._objects) {
			this.releaseObject(this._objects[i]);
			this._objects[i] = null;
		}
		this._objects = null;
		this._stores = null;
		this._successCallback = null;
		this._failureCallback = null;
		this._delegate = null;
		this._storesCounter = null;
		this._totalStores = null;
		this._gameId = null;
		this._companyId = null;
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/ngAPI/GAHandler/GAResourceSyncHandler'] = function(){var exports = $MODULE_REGISTRY['Code/ngAPI/GAHandler/GAResourceSyncHandler'] || {}; $MODULE_REGISTRY['Code/ngAPI/GAHandler/GAResourceSyncHandler'] = exports; //# GAResourceSyncHandler.js
//# ngJurassic
//#
//# Created by Washaq.Majeed on 5/18/11.
//# Copyright 2011 __MyCompanyName__. All rights reserved.

exports.GAResourceSyncHandler = Core.Class.subclass ({
	
	classname: 'GAResourceSyncHandler',
  
	initialize: function(storeIdsArray, callBackSuccess, callBackFailed) {
			
			this._resourceDownloader = null;
			this._chekResourceType = null;
			this._callBackSuccess = callBackSuccess;
			this._callBackFailed = callBackFailed;
			this._firstTry = true ;
			this._storeIdsArray = storeIdsArray;//JSON.parse(JSON.stringify(storeIdsArray));
			
			for (var i = 0, l = this._storeIdsArray.length; i < l; i++){
				console.log("STORE IDS " + this._storeIdsArray[i]);
			}
			
			if ((this._storeIdsArray != null) && (this._storeIdsArray instanceof Array)){
				this._totalCount = this._storeIdsArray.length;
			}
			else{
				this._totalCount = 0;
			}
			
			this._totalCount = this._totalCount * 2;
			console.log("totalcount" + this._totalCount);
			this._successCount = 0;
			this._failCount = 0;
			
	},
	startLoading: function() {
		console.log("startLoading");
		
		if ((this._storeIdsArray != null) && (this._storeIdsArray instanceof Array) && (this._storeIdsArray.length > 0)){
		
			var storeItem = null;
			
			this._detailDownloaderArray = new Array();
			this._thumbDownloaderArray = new Array();
			this._failedDetailDownloaderArray = new Array();
			this._failedThumbDownloaderArray = new Array();
			
			for (var i = 0, l = this._storeIdsArray.length; i < l; i++){
//				console.log("startLoading FOR");
				storeItem = GAGameLoader.getStoreHandler().getStoreObjectForKey(this._storeIdsArray[i]);
				
				var thisDetailDownloader = new GAResourceDownloader(storeItem , this.resourceDetailDownloadingSuccessful.bind(this), this.resourceDetailDownloadingFailed.bind(this), GAResourceType.kDetail, false);
				thisDetailDownloader.startDownloading();
				this._detailDownloaderArray.push(thisDetailDownloader);
				
				var thisThumbDownloader = new GAResourceDownloader(storeItem , this.resourceThumbDownloadingSuccessful.bind(this), this.resourceThumbDownloadingFailed.bind(this), GAResourceType.kThumb, false);
				thisThumbDownloader.startDownloading();
				this._thumbDownloaderArray.push(thisThumbDownloader);
			}					
			
		
		}else{
			this.downloadingComplete();
		}
	},
	
	resourceThumbDownloadingSuccessful: function(savePath, downloader) {
		var storeObject = downloader._storeObject;
		if (!this._firstTry)
		{
			console.log("this._firstTry");
			console.log("this._failedThumbDownloaderArray.length " + this._failedThumbDownloaderArray.length);
			for (var i = 0; i< this._failedThumbDownloaderArray.length; i++) {
				if (this._failedThumbDownloaderArray[i] == storeObject) {
					console.log("FAILED RESOURCE DOWNLOADED...REMOVING FROM ARRAY " + storeObject);
					this._failedThumbDownloaderArray.splice(i, 1) ;
					this._failCount-- ;
				}
			}
		}
		this.resourceDownloadingSuccessful(savePath, storeObject);
			
	},
	
	getIdForObject: function(storeObject) {
		var id = [];
		if (storeObject.objectType == "store") {
			id.push(storeObject.id);
		}
		else if (storeObject.objectType == "cat") {
			id.push(storeObject.parent.id);
			id.push(storeObject.id);
		}
		else if (storeObject.objectType == "item") {
			id.push(storeObject.parent.parent.id);
			id.push(storeObject.parent.id);
			id.push(storeObject.id);
		}
		return id;
	},

	
	resourceDetailDownloadingSuccessful: function(savePath, downloader) {
		var storeObject = downloader._storeObject;
		if (!this._firstTry)
		{
			for (var i = 0; i< this._failedDetailDownloaderArray.length; i++) {
				if (this._failedDetailDownloaderArray[i] == storeObject) {
					
					this._failedDetailDownloaderArray.splice(i, 1) ;
					this._failCount-- ;
				}
			}
		}
		this.resourceDownloadingSuccessful(savePath, storeObject);
			
	},

	
	resourceDownloadingSuccessful: function(savePath, storeObject) {
		
		this._successCount++;
		console.log("_successCount" + this._successCount);
//		if(TFGameState.atNeighbor){
//			var percentage = (this._successCount/this._totalCount) * 100;
//			//console.log("aleem: total count " + this._totalCount);
//			//console.log("aleem: success count " + this._successCount);
//			//console.log("aleem: percentage " + (this._successCount/this._totalCount));
//			console.log('aleem: updatePercentage call');
//			GameCentralHandler.updatePercentage(percentage);
//			//GameCentralHandler.showProgress(kGAGameLoadLevel.kGAGameLoadLevelStoreParsingDone);
//			//GameCentralHandler.showProgress(kGAGameLoadLevel.kGAGameLoadLevelStoreParsingDone);
//		}
		this.checkDownloadStatus();
			
	},
	
	resourceThumbDownloadingFailed:function (errorCode, errorMsg, downloader) {
		var storeObject = downloader._storeObject;
		if(this._firstTry){
			if(storeObject && storeObject!='undefined')
				this._failedThumbDownloaderArray.push(storeObject) ;
			else
				console.log("UNABLE TO ADD RESOURCE DUE TO NULL/UNDEFINED");
		}
		
		this.resourceDownloadingFailed(errorCode, errorMsg, storeObject);
	},
	
	resourceDetailDownloadingFailed:function (errorCode, errorMsg, downloader) {
		var storeObject = downloader._storeObject;
		if(this._firstTry){
			if(storeObject && storeObject!='undefined')
				this._failedDetailDownloaderArray.push(storeObject) ;
			else
				console.log("UNABLE TO ADD RESOURCE DUE TO NULL/UNDEFINED");
		}
		
		this.resourceDownloadingFailed(errorCode, errorMsg, storeObject);
	},
	
	resourceDownloadingFailed:function (errorCode, errorMsg, storeObject) {
		this._failCount++;
		console.log("RESOURCE FAILED!! ADDING IN ARRAY " + this._failCount);

		this.checkDownloadStatus();
	},
	
	checkDownloadStatus: function(){
		console.log("checkDownloadStatus ");
		console.log("this._totalCount " + this._totalCount);
		console.log("this._successCount + this._failCount " + (this._successCount + this._failCount));
		var percentage = (this._successCount/this._totalCount)*100;
		GameCentralHandler.showProgress(null,percentage);
		if (this._successCount + this._failCount == this._totalCount){
			if (this._failCount > 0){
				console.log("downloadingFailed IF");
				if ( this._firstTry){
					console.log("ENTERED IN IF");
					this.retrySyncHandler() ;
				}else {
					console.log("ENTERED IN ELSE");
					this.downloadingFailed();
				}
			}
			else{
				console.log("downloadingComplete ELSE");
				this.downloadingComplete();	
			}
		}
	},
	
	downloadingComplete: function(){
		console.log("downloadingComplete ");
		GAGameLoader.persistDownloadedResources();
		this.destroyResourceDownloader();
		this._callBackSuccess();
	},
	
	downloadingFailed: function(){
		console.log("DOWNLOADING FAILED ");
		this._callBackFailed();
		
	},
	
	retrySyncHandler : function() {
		if(this._firstTry)
			this._firstTry = false ;
		this._failCount = 0;
		this._successCount = 0;
		this._totalCount = this._failedThumbDownloaderArray.length + this._failedDetailDownloaderArray.length;
//		this._totalCount = this._totalCount * 2;
		this.destroyResourceDownloader() ;
		console.log("this._failedThumbDownloaderArray.length" + this._failedThumbDownloaderArray.length);
		console.log("this._failedDetailDownloaderArray.length" + this._failedDetailDownloaderArray.length);
		console.log("this._firstTry " + this._firstTry);
		for ( var i =0; i< this._failedThumbDownloaderArray.length; i++ )
		{
			var thisThumbDownloader = new GAResourceDownloader(this._failedThumbDownloaderArray[i] , this.resourceThumbDownloadingSuccessful.bind(this), this.resourceThumbDownloadingFailed.bind(this), GAResourceType.kThumb, false);
			thisThumbDownloader.startDownloading();
			this._thumbDownloaderArray.push(thisThumbDownloader);
		}
		
		for ( var i =0; i< this._failedDetailDownloaderArray.length; i++ )
		{
			var thisDetailDownloader = new GAResourceDownloader(this._failedDetailDownloaderArray[i] , this.resourceDetailDownloadingSuccessful.bind(this), this.resourceDetailDownloadingFailed.bind(this), GAResourceType.kDetail, false);
			thisDetailDownloader.startDownloading();
			this._detailDownloaderArray.push(thisDetailDownloader);
		}
		console.log("loop ended");
	},

	
	destroyResourceDownloader: function(){
		console.log("destroyResourceDownloader ");
		if ((this._detailDownloaderArray != null) && (this._detailDownloaderArray instanceof Array)){
			for (var i = 0, l = this._detailDownloaderArray.length; i < l; i++){
				if (this._detailDownloaderArray[i] != null){
					this._detailDownloaderArray[i].destroy();
					this._detailDownloaderArray[i] = null;
				}
			}
		}
		if ((this._thumbDownloaderArray != null) && (this._thumbDownloaderArray instanceof Array)){
			for (var i = 0, l = this._thumbDownloaderArray.length; i < l; i++){
				if (this._thumbDownloaderArray[i] != null){
					this._thumbDownloaderArray[i].destroy();
					this._thumbDownloaderArray[i] = null;
				}
			}
		}
	},
	
	destroy: function(){
		console.log("destroyResourceDownloader ");
		delete this._storeIdsArray;
		delete this._detailDownloaderArray;
		delete this._thumbDownloaderArray;
	},
	
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/ngAPI/GAHandler/GAGameLoader'] = function(){var exports = $MODULE_REGISTRY['Code/ngAPI/GAHandler/GAGameLoader'] || {}; $MODULE_REGISTRY['Code/ngAPI/GAHandler/GAGameLoader'] = exports; /**
 * @author salman.humdullah
 * @modifiedBy: Abid Hussain
 */ 
exports.GAGameLoader = Core.Class.singleton({
	classname: 'GAGameLoader',
	initialize : function() {
		this._url = null;
		this._isFailed = false;
		this._totalStores = 0;
		this._currentCounter = 0 ;
		this._responseObject = null;
		this._constructURL();
		GALocalizationHandler.instantiate();
		this._downloadedResourcesKey = GAConfigurations.getGameCode() + DOWNLOADED_RESOURCES;
		this._downloadedResources = {};
		var myself = this;
		this._storage = new Storage.KeyValue();
		this._storage.getItem(this._downloadedResourcesKey, 
			function(error, value, key) {
				if (!error) {
					myself._downloadedResources = JSON.parse(value);		
				}
			}
		);
	},
	
	addToDownloadedResources: function(key, resourceType) {
		if (this.isResourceAvailable(key, resourceType) == false) {
			this._downloadedResources[key+resourceType] = "1";
		}
	},
	
	persistDownloadedResources: function() {
		this._storage.setItem(this._downloadedResourcesKey, JSON.stringify(this._downloadedResources));
	},
	
	isResourceAvailable: function(key, resourceType) {
		var keyValue = this._downloadedResources[key+resourceType];
		if (typeof keyValue != 'undefined') {
			return true;
		}
		return false;	
	},
	
	setDelegate: function(delegate) {
		this._gameDelegate = delegate;
	},
	
	_constructURL : function(){
		var url = [];
		url.push(GAConfigurations.getURL());
		url.push("gameConnect?type=userkey");
		url.push("&userkey=");
		url.push(GAConfigurations.getUserId());
		url.push("&udid=");
		url.push(GAConfigurations.getUdid());
		url.push('&deviceType=');
		url.push(GAConfigurations.getDeviceType());
		url.push('&OS=');
		url.push(GAConfigurations.getOsVersion());
		url.push('&GV=');
		url.push(GAConfigurations.getGameVersion());
		url.push('&game=');
		url.push(GAConfigurations.getGameCode());
		url.push('&multipromo=on');
		url.push('&json=1');
		url = encodeURI(url.join(""));
		this._url= url;
	},
	
	startConnect : function() {
		if( this._connectHandler == null){
			this._connectHandler = new GAConnectHandler(this._url, this);
		}
		this._connectHandler.fetchResponse();
	},
	getResponseObject : function() {
		return this._responseObject;
	},
////////////////****START****///////////////////
	connectHandlerSuccess : function(responseObject){
		console.log('********* :: connectHandlerSuccess*********');
		this.showProgress(kGAGameLoadLevel.kGAGameLoadLevelConnectDone);
		this._responseObject = responseObject;
		GAGameStateHandler.startGameState(this,this._gameDelegate);
	},
	connectHandlerFailure : function(errorCode){
		console.log('********* :: connectHandlerFailure*********');
		this._gameDelegate.onFailure(errorCode);
	},
/////////////////*****END******////////////////
	
	
//////////////*****Start******////////////////
	

	gameStateSuccess: function(){
		console.log('********* :: gameStateSuccess *********');
		this._storeloader = new GAStoreLoader(this._responseObject);
		this._storeloader.loadStores(this);
	},
	gameStateFailure: function(error){
		console.log('********* :: gameStateFailure *********');
		this._gameDelegate.onFailure(error);
	},
	
/////////////////*****END******////////////////	
	
//////////////*****Start******////////////////
	storeDownloaderSuccess : function (parseStores){
		console.log('************ :: storeDownloaderSuccess *********');
		this.showProgress(kGAGameLoadLevel.kGAGameLoadLevelStoreVersionsDone);
		var visibleIds = this._responseObject.getStoreVisibleIds();
		if (visibleIds != null && visibleIds.length > 0) {
			this._storeHandler = new GAStoreHandler(visibleIds, this.storeHandlerSuccess.bind(this), this.storeHandlerFailure.bind(this));
			this._storeHandler.startLoading();
		}
		else {
			this.storeHandlerSuccess();
		}
	},
	storeDownloaderFailure : function (errorMessage){
		console.log('********* :: storeDownloaderFailure*********');
		if(!this._isFailed){
			this._isFailed = true;
			this._gameDelegate.onFailure(errorMessage);
		}
	},
//////////////*****END******////////////////

//////////////*****START******////////////////
	storeHandlerSuccess : function (){
		this.showProgress(kGAGameLoadLevel.kGAGameLoadLevelStoreParsingDone);
		GAGameStateManager.setDelegate(this._gameDelegate);
		GAGameStateManager.startTimer(kGAGameState.kTimeOut);
		this._gameDelegate.onSuccess();
	},
	storeHandlerFailure: function (errorMessage, visibleId){
		console.log('********* storeParserFailure:: *********'+visibleId);
		var preferences = new Storage.KeyValue();
		preferences.setItem(visibleId, -1);
		this._gameDelegate.onFailure(errorMessage);
	},
//////////////*****END******////////////////
	showProgress : function(progressStatus) {
		this._gameDelegate.showProgress(progressStatus);
	},
	
	getStoreHandler: function() {
		return this._storeHandler;
	},

	destroy: function() {
		this._gameDelegate = null;
		this._storeloader.destroy();
		this._storeloader = null;
		this._connectHandler.destroy();
		this._connectHandler = null;
		this._storeHandler.destroy();
		this._storeHandler = null;
		this._url = null;
		this._isFailed = false;
		this._totalStores = 0;
		this._currentCounter = 0;
		this._responseObject = null;
		this._downloadedResourcesKey = null;
		this._downloadedResources = null;
		this._storage = null;
		GAGameStateHandler.destroy();
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/ngAPI/GAHandler/GAGameStateGetHandler'] = function(){var exports = $MODULE_REGISTRY['Code/ngAPI/GAHandler/GAGameStateGetHandler'] || {}; $MODULE_REGISTRY['Code/ngAPI/GAHandler/GAGameStateGetHandler'] = exports; /**
 * Filename: GAGameStateGetHandler.js
 * Author: Abid Hussain
 * Date Created: 07/06/2011
 */
exports.GAGameStateGetHandler = Core.Class.singleton({
	classname: 'GAGameStateGetHandler',
	
	initialize: function(){
		this._delegate = null;
		this._error = null;
		this._totalFiles = null;
		this._userkey = null;
		this._baseUrl = null;
		this._dbPath = null;
		this._game = null;
		this._filesCount = null;
		this._lastModifiedTime = null;
		this._storage = new Storage.KeyValue();
		this._getServerParams();
		this.atNeighbor = false;
	},
	
	/*
	 * Public method called by the user for gameStateGet.
	 * This method gets the game state from the server and stores it in user database
	 * */
	restoreGameState: function(delegate){
		this._delegate = delegate;
		this._error = false;
		this._totalFiles = 0;
		this._filesCount = 0;
		this._getGameStateInfo();
	},
	
	_getServerParams: function(){
		var responseObject = GAGameLoader.getResponseObject();
		if(responseObject != null){
			this._baseUrl = responseObject.getGameServer();
			this._userkey = GAConfigurations.getUserId();
			this._game = GAConfigurations.getGameCode();
			this._dbPath = GAConfigurations.getGameStateDBPath();
		}
	},
	_getGameStateInfo: function(){
		var InfoBaseUrl = this._baseUrl.replace('/gameState','/getGameStateInfo');
		var url = InfoBaseUrl+'?game=' + this._game + '&userkey=' + this._userkey;
		var fetcher = new GAWebFetcher(this,30,0);
		fetcher.invokeGetRequest(url);
	},
	
	
	/*
	 * webFetchSuccess: this is called in response of _getGameStateInfo function call and is callback of webFetcher class.
	 * */
	webFetchSuccess: function(webFetcher, responseData){
		try{
			var serverResponse = eval("("+ responseData +")");
			var status = serverResponse.status;
			var data = serverResponse.data;
			var serverLMTime = data.gamestatelastupdatetime;
			if(serverLMTime != null){
				serverLMTime  = this._dateFromUTC(serverLMTime, "-");
				this._serverLastModifiedTime = Date.parse(serverLMTime);
			}
			else{
				this._serverLastModifiedTime = 0;
			}
			this._saveLastModifiedTime(this._serverLastModifiedTime);
			this._gameStateGet();
		}
		catch(exception){
			this._delegate.gameStateGetFailure(exception);
		}
		finally{
			if(webFetcher != null){
				webFetcher.destroy();
				webFetcher = null;
			}
		}
	},
	/*
	 * webFetchFailure: this is called in response of _getGameStateInfo function call and is call back of webFetcher class.
	 * */
	webFetchFailure: function(webFetcher, error){
		if(this._delegate != null){
			this._delegate.gameStateGetFailure(error);
		}
		if(webFetcher != null){
			webFetcher.destroy();
			webFetcher = null;
		}
	},
	
	
	_gameStateGet: function(){
		var url = this._getUrl();
		var fileDownloader = new GAFileDownloader(this._dbPath+'/gameState.zip' ,'GET' ,url ,null ,this);
		fileDownloader.startDownloading();
	},
	
	/*
	 * This function returns the URL for the gameStateGet
	 * */
	_getUrl: function(){
		var url ='';
		var gStateBaseUrl = this._baseUrl.replace('/gameState','/dbfile');
		url = gStateBaseUrl+'?'+'type=userkey&udid='+ this._userkey +'&game='+ this._game +'&encoding=base64';
		return url;
	},
	

	onDownloadSuccess: function(downloader,fileSignature){
		console.log("onDownloadSuccess started");
		if(this.atNeighbor){
			console.log("onDownloadSuccess at neighbor");
			var destination = GAConfigurations.getGameStateDBPath() + '/random/';
			Storage.FileSystem.decompressFile(this._dbPath+'/neighbor.zip',destination,true,this._neighborZipExtractionCb.bind(this));
		} else {
			console.log("onDownloadSuccess at home");
			var destination = GAConfigurations.getGameStateDBPath() + '/' + this._userkey + '/';
			Storage.FileSystem.decompressFile(this._dbPath+'/gameState.zip',destination,true,this._zipExtractionCb.bind(this));
		}
		console.log("onDownloadSuccess ended");
	},
	onDownloadFailure: function(downloader,error){
		console.log("onDownloadFailure started");
		this._delegate.gameStateGetFailure('onDownloadFailure = '+error);
		console.log("onDownloadFailure ended");
	},
	
	_neighborZipExtractionCb: function(error,files){
		if(!error){
			console.log("NO ERROR");
			Storage.FileSystem.deleteFile(this._dbPath+'/neighbor.zip');
			console.log("NO ERROR");
			this._delegate.gameStateGetSuccess(GAConfigurations.getGameStateDBPath() + '/random/');
			console.log("NO ERROR");
		}
		else{
			console.log("ERROR OCCURED " + error);
			this._delegate.gameStateGetFailure('Error while extracting gameState file.');
		}
	},

	
	_zipExtractionCb: function(error,files){
		if(!error){
			console.log("NO ERROR");
			Storage.FileSystem.deleteFile(this._dbPath+'/neighbor.zip');
			console.log("NO ERROR");
			this._delegate.gameStateGetSuccess(GAConfigurations.getGameStateDBPath() + '/neighbor/' + this._userkey + '/');
			console.log("NO ERROR");
		}
		else{
			console.log("ERROR OCCURED " + error);
			this._delegate.gameStateGetFailure('Error while extracting gameState file.');
		}
	},

	
	_zipExtractionCb: function(error,files){
		if(!error){
			Storage.FileSystem.deleteFile(this._dbPath+'/gameState.zip');
			this._delegate.gameStateGetSuccess();
		}
		else{
			this._delegate.gameStateGetFailure('Error while extracting gameState file.');
		}
	},

	_dateFromUTC: function( dateAsString, ymdDelimiter ){
		 var pattern = new RegExp( "(\\d{4})" + ymdDelimiter + "(\\d{2})" + ymdDelimiter + "(\\d{2}) (\\d{2}):(\\d{2}):(\\d{2})" );
		 var parts = dateAsString.match( pattern );
		 return new Date(Date.UTC(parseInt( parts[1] ), parseInt( parts[2], 10 ) - 1, parseInt( parts[3], 10 ), parseInt( parts[4], 10 ), parseInt( parts[5], 10 ), parseInt( parts[6], 10 ),0));
	},
	_saveLastModifiedTime: function(value){
		this._storage.setItem(kGAGameState.kLastModifiedTime,value);
	},
	
	getNeighborState: function(atNeighbor, delegate){
		console.log("getNeighborState started");
		this.atNeighbor = atNeighbor;
		this._delegate = delegate;
		this._friendName = GAConfigurations.getUserId(); //he will be himself the friendName when visiting neighbor
		this._gameStateType = "neighbor";
		var url = this._constructURL();
		console.log("url " + url);
		var fileDownloader = new GAFileDownloader(this._dbPath+'/neighbor.zip' ,'GET' ,url ,null ,this);
		fileDownloader.startDownloading();
		console.log("getNeighborState ended");

	},
	
	getNeighborStateWithName: function(atNeighbor, delegate, neighborName){
		this.getFriendState(atNeighbor, delegate, neighborName);
	},
	
	getFriendState: function(atNeighbor, delegate, friendName){
		console.log("getNeighborState started");
		this.atNeighbor = atNeighbor;
		this._delegate = delegate;
		this._friendName = friendName;
		this._gameStateType = "userkey";
		var url = this._constructURL();
		console.log("url " + url);
		var fileDownloader = new GAFileDownloader(this._dbPath+'/neighbor.zip' ,'GET' ,url ,null ,this);
		fileDownloader.startDownloading();
		console.log("getNeighborState ended");

	},
	_constructURL : function(){
		var url = [];
		url.push(this._baseUrl);
		url.push("?type=" + this._gameStateType);
		url.push("&userkey=");
		url.push(this._friendName);
		url.push("&udid=");
		url.push(GAConfigurations.getUdid());
		url.push('&osType=');
		url.push(GAConfigurations.getDeviceType());
		url.push('&GV=');
		url.push(GAConfigurations.getGameVersion());
		url.push('&game=');
		url.push(GAConfigurations.getGameCode());
		url.push('&json=1');
		url.push('&encoding=base64zip');
		url = encodeURI(url.join(""));
		return url;
	},
	
	_successCb: function(fetcher, response){
		
	},
	_failureCb: function(fetcher, error){
		
	},
	
	destroy: function(){
		this._delegate = null;
		this._error = null;
		this._filesCount = null;
		this._totalFiles = null;
		this._lastModifiedTime = null;
		this._storage = null;
		this._userkey = null;
		this._baseUrl = null;
		this._dbPath = null;
		this._game = null;
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/ngAPI/GAHandler/GAGameStatePostHandler'] = function(){var exports = $MODULE_REGISTRY['Code/ngAPI/GAHandler/GAGameStatePostHandler'] || {}; $MODULE_REGISTRY['Code/ngAPI/GAHandler/GAGameStatePostHandler'] = exports; /**
 * Filename: GAGameStatePostHandler.js
 * Author: Abid Hussain
 * Date Created: 07/06/2011
 */
exports.GAGameStatePostHandler = Core.Class.singleton({
	initialize: function(){
		this._baseUrl = null;
		this._udid = null;
		this._game = null;
		this._dbFiles = null;
		this._DbPath = null;
		this._lastModifiedTime = null;
		this._storage = new Storage.KeyValue();
		this._getParams();
	},
	/*
	 * Public method called by the user for gameStatePost
	 * */
	postGameState: function(delegate,files,level,experience){
		this._delegate = delegate;
		this._dbFiles = files;
		this._level = level;
		this._experience = experience;console.log(">> File to be psted for game state are :"+this._dbFiles);
		this._readGameState();
	},
	
	_getParams: function(){
		var responseObject = GAGameLoader.getResponseObject();
		if(responseObject != 'undefined' && responseObject != null){
			this._baseUrl = responseObject.getGameServer();
		}
		this._udid = GAConfigurations.getUdid();
		this._game = GAConfigurations.getGameName();
		this._DbPath = GAConfigurations.getGameStateDBPath();
	},
	/*
	 * _readGameState: reads the game state stored in local memory of device
	 * */
	_readGameState: function(){
		var resources = [];
		var length = this._dbFiles.length;
		for(var i=0; i< length; i++){
			resources[i] = this._dbFiles[i];
		}
		GAPersistenceManager.loadResources(resources, this._myProgress.bind(this), this._myDoneLoading.bind(this),this._errorLoading.bind(this));
	},
	_myProgress: function(loaded, total) {
		GALogger.log("In Progress!!!");
		GALogger.log("Progress: " + loaded + " / " + total);
	},
	_myDoneLoading: function(){
		var filesData = [];
		var length = 0;
		try{
			length = this._dbFiles.length;
			for(var i=0; i< length; i++){
				var resourceName = this._dbFiles[i];
				var resource = GAPersistenceManager.getResource(resourceName);
				resource = JSON.stringify(resource);
				filesData[resourceName+'.json'] = {data: resource};
			} 
			var data = GACompressionManager.compressFiles(filesData);
			var webFectcher = new GAWebFetcher(this,30,0);
			var params = this._getPostParams();
			webFectcher.postData(this._baseUrl,params,data);
		}
		catch(exception){
			this._delegate.gameStatePostFailure('Error while loading resources = '+exception);
		}
	},
	_errorLoading: function(){
		this._delegate.gameStatePostFailure('Error while loading resources');
	},
	 _getPostParams: function(){
	    	var params = new Object();
	    	params.type = 'userkey';
	    	params.userkey = GAConfigurations.getUserId();
	    	params.udid = GAConfigurations.getUdid();
	    	params.game = GAConfigurations.getGameCode();
	    	params.devicetype = GAConfigurations.getDeviceType();
	    	params.gameversion = GAConfigurations.getGameVersion();
	    	params.osType = GAConfigurations.getOsVersion();
	    	params.level = this._level;
	    	params.experience = this._experience;
	    	params.json = "1";
	    	return params; 
	    },
	
	webFetchSuccess: function(webFetcher, responseData){
		try{
			var response = eval("(" + responseData + ")");
			var serverResponse = response.ServerResponse;
			var status = serverResponse['@status'];
			var statusCode = serverResponse['@status_code'];
			if(status != 'OK'){
				this._delegate.gameStatePostFailure(status);
			}
			else{
				var updatedTime = serverResponse.GameStateLastUpdatedTime;
				updatedTime = this._dateFromUTC(updatedTime, "-");
				this._lastModifiedTime = Date.parse(updatedTime);
				this._saveLastModifiedTime(this._lastModifiedTime);
				this._delegate.gameStatePostSuccess(statusCode);
			}
		}
		catch(exception){
			this._delegate.gameStatePostFailure(exception);
		}
		finally{
			if(webFetcher != null){
				webFetcher.destroy();
				webFetcher = null;
			}
		}
	},
	webFetchFailure: function(webFetcher, error){
		this._delegate.gameStatePostFailure(error);
		if(webFetcher != null){
			webFetcher.destroy();
			webFetcher = null;
		}
	},
	_dateFromUTC: function( dateAsString, ymdDelimiter ){
		 var pattern = new RegExp( "(\\d{4})" + ymdDelimiter + "(\\d{2})" + ymdDelimiter + "(\\d{2}) (\\d{2}):(\\d{2}):(\\d{2})" );
		 var parts = dateAsString.match( pattern );
		 return new Date(Date.UTC(parseInt( parts[1] ), parseInt( parts[2], 10 ) - 1, parseInt( parts[3], 10 ), parseInt( parts[4], 10 ), parseInt( parts[5], 10 ), parseInt( parts[6], 10 ),0));
	},
	_saveLastModifiedTime: function(value){
		this._storage.setItem(kGAGameState.kLastModifiedTime,value);
	},
	destroy: function(){
		this._delegate = null;
		this._level = null;
		this._experience = null;
		this._dbFiles = null;
		this._lastModifiedTime = null;
		this._storage = null;
		this._baseUrl = null;
		this._DbPath = null;
		this._udid = null;
		this._game = null;
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/ngAPI/GAHandler/GACurrencyUpdateHandler'] = function(){var exports = $MODULE_REGISTRY['Code/ngAPI/GAHandler/GACurrencyUpdateHandler'] || {}; $MODULE_REGISTRY['Code/ngAPI/GAHandler/GACurrencyUpdateHandler'] = exports; /**
 * FileName: GACurrencyUpdateHandler.js
 * Author: Abid Hussain
 * DateCreated: 24/06/2011
 */
exports.GACurrencyUpdateHandler = Core.Class.subclass({
	classname: 'GACurrencyUpdateHandler',
	initialize: function(delegate){
		this._delegate = delegate;
	},
	updateCurrency: function(purchasedCoins,purchasedBucks,offerCoins,offerBucks){
		this._purchasedCoins = purchasedCoins;
		this._purchasedBucks = purchasedBucks;
		this._offerCoins = offerCoins;
		this._offerBucks = offerBucks;
		var baseUrl = GAConfigurations.getURL()+'updateCurrencies';
		var params = this._getPostParams();
		var webFetcher = new GAWebFetcher(this,30,0);
		webFetcher.postData(baseUrl,params,null);
	},
	_getPostParams: function(){
		var params = new Object();
		params.type = "userkey";
		params.userkey = GAConfigurations.getUserId();
		params.game = GAConfigurations.getGameCode();
		params.purchasedCurrency1 = this._purchasedBucks;
		params.purchasedCurrency2 = this._purchasedCoins;
		params.offersCurrency1Awarded = this._offerBucks;
		params.offersCurrency2Awarded = this._offerCoins;
		return params;
	},
	webFetchSuccess: function(webFetcher,response){
		try{
			var serverResponse = eval("("+ response +")");
			var status = serverResponse.status;
			if(status.code != 1){
				this._delegate.currencyUpdateFailure(status.message);
			}
			else{
				console.log('GAPI:: Currencies hav been updated..');
				this._delegate.currencyUpdateSuccess();
			}
		}
		catch(exception){
			this._delegate.currencyUpdateFailure(exception);
		}
		finally{
			if(webFetcher != null){
				webFetcher.destroy();
				webFetcher = null;
			}
		}
	},
	webFetchFailure: function(webFetcher, error){
		this._delegate.currencyUpdateFailure(error);
		if(webFetcher != null){
			webFetcher.destroy();
			webFetcher = null;
		}
	},
	destroy: function(){
		this._delegate = null;
		this._purchasedCoins = null;
		this._purchasedBucks = null;
		this._offerCoins = null;
		this._offerBucks = null;
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/ngAPI/GAModel/GAServerResponseCommonModel'] = function(){var exports = $MODULE_REGISTRY['Code/ngAPI/GAModel/GAServerResponseCommonModel'] || {}; $MODULE_REGISTRY['Code/ngAPI/GAModel/GAServerResponseCommonModel'] = exports; /**
 * @author abid.hussain
 */
exports.GAServerResponseCommonModel = Core.Class.subclass({
	classname: 'GAServerResponseCommonModel',
	initialize : function(serverResponse){
		this._signature = null;
		this._customAttributes = null;
		this._currencyUpdated = null;
		this._defaultGame = null;
		this._device = null;
		this._devStat = null;
		this._appsalar = null;
		this._showAds = null;
		this._firstGameState = null;
		this._game = null;
		this._gameId = null;
		this._gameServer = null;
		this._inAppenAbled = null;
		this._offerServer = null;
		this._requestType = null;
		this._serverTime = null;
		this._status = null;
		this._storeServer = null;
		this._superUser = null;
		this._offersUrl = null;
		this._appurl = null;
		this._checkOutServer = null;
		this._qaUser = null;
		this._socialServer = null;
		this._currentTime = null;
		this._timeDifference = null;
		this._pnsurl = null;
		this._isActive = null;
		this._notificationServer = null;
		this._serverResponse = serverResponse;
		this._parseServerResponseTag();
	},
	_parseServerResponseTag : function(){
		if(this._serverResponse != 'undefined' && this._serverResponse != null){
			this._signature = this._serverResponse['Signature'];
			var customAttr = this._serverResponse['custom_attributes'];
			if( customAttr != 'undefined' && customAttr != null){
				this._customAttributes = eval("(" + customAttr + ")");
			}
			this._checkOutServer =  this._serverResponse['@checkoutserver'];
			this._currencyUpdated = this._serverResponse['@currencyupdated'];
			this._defaultGame = this._serverResponse['@default_game'];
			this._device = this._serverResponse['@device'];
			this._devStat = this._serverResponse['@devstat'];
			this._appsalar = this._serverResponse['@appsalar'];
			this._showAds = this._serverResponse['@showads'];
			this._game = this._serverResponse['@game'];
			this._gameId = this._serverResponse['@game_id'];
			this._gameServer = this._serverResponse['@gameserver'];
			this._requestType = this._serverResponse['@requesttype'];
			this._inAppenAbled = this._serverResponse['@inappenabled'];
			this._offerServer = this._serverResponse['@offerserver'];
			this._qaUser = this._serverResponse['@qauser'];
			this._serverTime = this._serverResponse['@servertime'];
			this._timeDifference = this.calculateTimeDifferenceFromServer(this._serverTime);
			this._socialServer = this._serverResponse['@socialserver'];
			this._status = 	this._serverResponse['@status'];
			this._storeServer = this._serverResponse['@storeserver'];
			this._superUser = this._serverResponse['@superuser'];
			this._pnsurl = this._serverResponse['@pnsurl'];
			this._appurl = this._serverResponse['@appurl'];
			this._isActive = this._serverResponse['@isactive'];
			this._notificationServer = this._serverResponse['@notificationserver'];
			this._qaUser = ( this._qaUser != null && this._qaUser.toLowerCase() == "yes".toLowerCase() ) ? true : false;
			this._superUser = ( this._superUser != null && this._superUser.toLowerCase() == "yes".toLowerCase() ) ? true : false;
		}
	},
	
	getSignature: function(){
		return this._signature;
	},
	getCustomAttributes: function(){
		return this._customAttributes;
	},
	getSocialServer: function(){
		return this._socialServer;
	},
	getStoreServer : function(){
		return this._storeServer;
	},
	getCheckOutServer : function(){
		return this._checkOutServer;
	},
	getCurrencyUpdated : function (){
		return this._currencyUpdated;
	},
	getDefaultGame : function (){
		return this._defaultGame;
	},
	getDevice : function (){
		return this._device;
	},
	getDevStat : function (){
		return this._devStat;
	},
	getGame : function (){
		return this._game;
	},
	getGameId : function (){
		return this._gameId;
	},
	getGameServer : function (){
		return this._gameServer;
	},
	getInAppenAbled : function (){
		return this._inAppenAbled;
	},
	getOfferServer : function (){
		return this._offerServer;
	},
	getRequesttype: function(){
		return this._requestType;
	},
	isQAUser : function (){
		return this._qaUser;
	},
	getServerTime : function (){
		return this._serverTime;
	},
	setServerTime : function(sTime) {
		this._serverTime = sTime;
		this._timeDifference = this.calculateTimeDifferenceFromServer(this._serverTime); //updating server time diff
	},
	getTimeDifference : function() {
		return this._timeDifference;
	},
	getStatus : function (){
		return this._status;
	},
	isSuperUser : function (){
		return this._superUser;
	},
	getAppsalar : function(){
		return this._appsalar;
	},
	getShowAds: function(){
		return this._showAds;
	},
	getPnsUrl: function(){
		return this._pnsurl;
	},
	getAppUrl: function(){
		return this._appurl;
	},
	getIsActive: function(){
		return this._isActive;
	},
	getNotificationServer : function (){
		return this._notificationServer;
	},
	calculateTimeDifferenceFromServer: function(serverTime) {
		var sTime = 0;
		if(!serverTime || serverTime.length!=0) {
			sTime = parseFloat(serverTime);
		}
		var today = new Date();
    	var currentDateInSec = today.getTime()/1000; //timeIntervalSince1970
		return (sTime - currentDateInSec);
	},
	destroy : function(){
		this._signature = null;
		this._customAttributes = null;
		this._currencyUpdated = null;
		this._defaultGame = null;
		this._device = null;
		this._devStat = null;
		this._appsalar = null;
		this._showAds = null;
		this._firstGameState = null;
		this._game = null;
		this._gameId = null;
		this._gameServer = null;
		this._inAppenAbled = null;
		this._offerServer = null;
		this._requestType = null;
		this._serverTime = null;
		this._status = null;
		this._storeServer = null;
		this._superUser = null;
		this._offersUrl = null;
		this._appurl = null;
		this._checkOutServer = null;
		this._qaUser = null;
		this._socialServer = null;
		this._currentTime = null;
		this._timeDifference = null;
		this._pnsurl = null;
		this._isActive = null;
		this._serverResponse = null;
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/ngAPI/GAModel/GAConnectResponse'] = function(){var exports = $MODULE_REGISTRY['Code/ngAPI/GAModel/GAConnectResponse'] || {}; $MODULE_REGISTRY['Code/ngAPI/GAModel/GAConnectResponse'] = exports; /**
 * @author abid.hussain
 */
exports.GAConnectResponse = GAServerResponseCommonModel.subclass({
	classname : 'GAConnectResponse',
	initialize : function($super,serverResponse){
		$super(serverResponse);
		this._firstGameState = null ;
		this._serverResponse = serverResponse;
		this._currencyModelArray = []; 
		this._storesModelArray = []; 
		this._userMessageModel = null;
		this._count_threshold=0;
		this._dazzle_server=null;
		this._logging_type=0;
		this._time_threshold=0;
		this._log_transaction= null;
		this._log_event= null;
		this._log_offer= null;
		this._friendAdded = null;
		this._promotions = null;
	},
	parseConnectResponse : function(){
		if(this._serverResponse != 'undefined' && this._serverResponse != null){
			var social = this._serverResponse.SocialAction;
			if(social != 'undefined' && social != null){
				this._friendAdded = social.friendAdded;
			}
			this._friendAdded = (this._friendAdded != null && this._friendAdded.toLowerCase() == "True".toLowerCase()) ? true : false;
			this._parseStoreVersions();
			this._parseCurrencies();
			this._populateUserMessageModel();
			this._populatePromotions();
			this._populateDazzleInfo();
		}
	},
	_parseStoreVersions : function(){
		var storeVersions = this._serverResponse.storeItemVersion;
		if(storeVersions != 'undefined' && storeVersions != null){
			var stores = storeVersions.store;
			if(stores != 'undefined' && stores != null){
				var totalStores = stores.length;
				for(var i=0; i<totalStores; i++){
					var storeVersionModel = new GAStoreVersionModel(stores[i]);
					this._storesModelArray.push(storeVersionModel);
				}
			}
		}
	},
	_parseCurrencies : function(){
		var currenciesObjet = this._serverResponse.currencies;
		if(currenciesObjet!='undefined' && currenciesObjet != null){
			var currencies = currenciesObjet.currency;
			if(currencies != 'undefined' && currencies != null){
				var totalCurrency = currencies.length;
				for(var i=0; i<totalCurrency; i++){
					var currencyModel = new GACurrenciesModel(currencies[i]);
					this._currencyModelArray.push(currencyModel);
				}
			}
		}
	},
	_populateUserMessageModel : function (){
		var userMessageObject = this._serverResponse.UserMessage;
		if(userMessageObject != 'undefined' && userMessageObject != null){
			this._userMessageModel = new GAUserMessageModel();
			this._userMessageModel.setCategory(userMessageObject['@category']);
			this._userMessageModel.setItemId(userMessageObject['@itemId']);
			this._userMessageModel.setStoreName(userMessageObject['@store']);
			this._userMessageModel.setMessage(userMessageObject['#text']);
		}
	},
	_populatePromotions: function(){
		var promotionsObject = this._serverResponse.promotions;
		if(promotionsObject != 'undefined' && promotionsObject != null){
			this._promotions = new GAPromotionsModel();
			this._promotions.parsePromotions(promotionsObject);
		}
	},
	_populateDazzleInfo : function (){
		var dazzleObject = this._serverResponse.dazzle;
		if(dazzleObject!='undefined' && dazzleObject != null){
			this._count_threshold = dazzleObject['@count_threshold'];
			this._dazzle_server = dazzleObject['@dazzle_server'];
			this._log_event = dazzleObject['@log_event'];
			this._log_offer = dazzleObject['@log_offer'];
			this._log_transaction = dazzleObject['@log_transaction'];
			this._log_event = (this._log_event != null && this._log_event == "1") ? true : false;
			this._log_offer = (this._log_offer != null && this._log_offer == "1") ? true : false;
			this._log_transaction = (this._log_transaction != null && this._log_transaction == "1") ? true : false;
			this._logging_type = dazzleObject['@logging_type'];
			this._time_threshold = dazzleObject['@time_threshold'];
		}
	},
	getFriendAdded: function(){
		return this._friendAdded;
	},
	getPromotions: function(){
		return this._promotions;
	},
	getUserMessageModel: function(){
		return this._userMessageModel;
	},
	getCurrencyModel : function(){
		return this._currencyModelArray;
	},	
	getStoresModel : function(){
		return this._storesModelArray;
	},
	getCountThreshold : function (){
		return this._count_threshold;
	},
	getTimeThreshold : function (){
		return this._time_threshold;
	},
	getDazzleServer : function (){
		return this._dazzle_server;
	},
	getLogEvent : function (){
		return this._log_event;
	},
	getLogOffer : function (){
		return this._log_offer;
	},
	getLogTransaction : function (){
		return this._log_transaction;
	},
	getLoggingType : function (){
		return this._logging_type;
	},
	getStoreNames : function (){
		var names = [];
		var length = this._storesModelArray.length;
		for(var i = 0; i < length ; i ++ ){
			names.push(this._storesModelArray[i].getStoreName());
		}
		return names;
	},
	getStoreVisibleIds: function() {
		var visibleIds = [];
		var length = this._storesModelArray.length;
		for(var i = 0; i < length ; i ++ ){
			visibleIds.push(this._storesModelArray[i].getVisibleId());
		}
		return visibleIds;		
	},
	getStoreVersion : function(visibleId){
		var length = this._storesModelArray.length;
		for(var i = length-1 ; i >= 0 ; i-- ){
			if(visibleId == this._storesModelArray[i].getVisibleId()){
				return this._storesModelArray[i].getStoreVersion();
			}
		}
	},
	getStoreId : function(visibleId){
		var length = this._storesModelArray.length;
		for(var i = length; i -- ; ){
			if(visibleId == this._storesModelArray[i].getVisibleId()){
				return this._storesModelArray[i].getStoreId();
			}
		}
	},
	destroy : function($super){
		var modelSize = this._currencyModelArray.length;
		for( var count = 0; count < modelSize ; count ++)
		{
			if(this._currencyModelArray[count] != null){
				this._currencyModelArray[count].destroy();
				this._currencyModelArray[count] = null;
			}
		}
		this._currencyModelArray = null;
		modelSize = this._storesModelArray.length;
		for( var count = 0 ; count < modelSize ; count ++)
		{
			if(this._storesModelArray[count] != null){
				this._storesModelArray[count].destroy();
				this._storesModelArray[count] = null;
			}
		}
		this._storesModelArray = null;
		this._serverResponse = null;
		if(this._promotions != null){
			this._promotions.destroy();
			this._promotions = null;
		}
		this._friendAdded = null;
		this._signatur =null;
		this._firstGameState = null ; 
		this._userMessageModel = null;
		this._count_threshold= null;
		this._dazzle_server= null;
		this._logging_type= null;
		this._time_threshold= null;
		this._log_transaction= null;
		this._log_event= null;
		this._log_offer= null;
		$super();
	}
	
}); ; return exports;};
$MODULE_FACTORY_REGISTRY['Code/ngAPI/GAHandler/GAConnectHandler'] = function(){var exports = $MODULE_REGISTRY['Code/ngAPI/GAHandler/GAConnectHandler'] || {}; $MODULE_REGISTRY['Code/ngAPI/GAHandler/GAConnectHandler'] = exports; /**
 * @author abid.hussain
 */

exports.GAConnectHandler = Core.Class.subclass({
	
	classname : 'GAConnectHandler',
	
	initialize : function(url, delegate)
	{
		this._delegate = delegate;
		this._webFetcher = null;
		this._responseObject = null;
		this._url = url;
	},
	fetchResponse : function(){
		this._webFetcher = new GAWebFetcher(this, 30, 0);
		this._webFetcher.invokeGetRequest(this._url);
	},
	webFetchSuccess : function(webFetcher, responseData){
		this._delegate.showProgress(kGAGameLoadLevel.kGAGameLoadLevelStart);
		try{
			var jsonResponse = eval("(" + responseData + ")");
			var serverResponse = jsonResponse.ServerResponse;
			if(serverResponse['@status'] != 'OK'){
				this._delegate.connectHandlerFailure("Server Response is not ok with value of status = "+serverResponse['@status']);
			}
			else{
				this._responseObject= new GAConnectResponse(serverResponse);
				this._responseObject.parseConnectResponse();
				this._delegate.connectHandlerSuccess(this._responseObject);
			}
		}catch(exception){
			this._delegate.connectHandlerFailure(exception);
		}
		if(webFetcher != null){
			webFetcher.destroy();
			webFetcher = null;
		}
	},
	webFetchFailure : function(webFetcher, errorCode){	
		var errorMsg = "GAConnectHandler::webFetchFailure() responseStatusCode = > " + errorCode ;
		GALogger.logWithLevel(errorMsg,LOG_LEVEL.LOG_NONFATAL_ERROR);
		this._delegate.connectHandlerFailure(errorCode);
		if(webFetcher != null){
			webFetcher.destroy();
			webFetcher = null;
		}
	},
	getResponseObject : function (){
		return this._responseObject;
	},
	destroy : function(){
		this._delegate = null;
		if(this._webFetcher != null){
			this._webFetcher.destroy();
			this._webFetcher = null;
		}
		if(this._responseObject != null){
			this._responseObject.destroy();
			this._responseObject = null;
		}
		this._url=null;
		
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/ngAPI/GAModel/GAPromotionModel'] = function(){var exports = $MODULE_REGISTRY['Code/ngAPI/GAModel/GAPromotionModel'] || {}; $MODULE_REGISTRY['Code/ngAPI/GAModel/GAPromotionModel'] = exports; /**
 * @author salman.humdullah
 */
exports.GAPromotionModel = Core.Class.subclass({
	classname: 'GAPromotionModel',
	initialize : function() {
		this._adtype = null;
		this._pfilter = null;
		this._id = null;
		this._frequency = null;
		this._promotionID = null;
		this._promotionFrequency = null;
		this._promotionText = null;
		this._promotionURL = null;
		this._promotionThumbnailURL = null;
		this._type = null;
		this._priority = null;
	},
	parse: function(promotion){
		this._pfilter = promotion['@pfilter'];
		this._frequency = promotion['@frequency'];
		this._adtype = promotion['@adtype'];
		this._type = promotion['@type'];
		this._id = promotion['@id'];
		var priority = promotion['@priority'];
		if(priority != 'undefined' && priority != null){
			this._priority = priority;
		}
		this._promotionURL = promotion.promotionURL;
		this._promotionThumbnailURL = promotion.promotionThumbnailURL;
		this._promotionText = promotion.promotionText;
		this._promotionID = promotion.promotionId;
	},
	setID: function(id){
		this._id = id;
	},
	getID: function(){
		return this._id;
	},
	setPriority: function(pri){
		this._priority = pri;
	},
	getPriority: function(){
		return this._priority;
	},
	setFrequency: function(freq){
		this._frequency = freq;
	},
	getFrequency: function(){
		return this._frequency;
	},
	
	setPromotionID : function(promotionID) {
		this._promotionID = promotionID;
	},
	getPromotionID : function() {
		return this._promotionID;
	},
	setPromotionFrequency : function(promotionFrequency) {
		this._promotionFrequency = promotionFrequency;
	},
	getPromotionFrequency : function() {
		return this._promotionFrequency;
	},
	setPromotionText : function(promotionText) {
		this._promotionText = promotionText;
	},
	getPromotionText : function() {
		return this._promotionText;
	},
	setPromotionURL : function(promotionURL) {
		this._promotionURL = promotionURL;
	},
	getPromotionURL : function() {
		return this._promotionURL;
	},
	setPromotionThumbnailURL : function(promotionThumbnailURL) {
		this._promotionThumbnailURL = promotionThumbnailURL;
	},
	getPromotionThumbnailURL : function() {
		return this._promotionThumbnailURL;
	},
	setType : function(type) {
		this._type = type;
	},
	getType : function() {
		return this._type;
	},
	setAdType : function(adtype) {
		this._adtype = adtype;
	},
	getAdType : function() {
		return this._adtype;
	},
	setPFilter : function(filter) {
		this._pfilter = filter;
	},
	getPFilter : function() {
		return this._pfilter;
	},
	destroy : function(){
		this._frequency = null;
		this._adtype = null;
		this._id = null;
		this._pfilter = null;
		this._promotionID = null;
		this._promotionFrequency = null;
		this._promotionText = null;
		this._promotionURL = null;
		this._promotionThumbnailURL = null;
		this._type = null;
		this._priority = null;
		
	}
});
 ; return exports;};
$MODULE_FACTORY_REGISTRY['Code/ngAPI/GAModel/GAPromotionsModel'] = function(){var exports = $MODULE_REGISTRY['Code/ngAPI/GAModel/GAPromotionsModel'] || {}; $MODULE_REGISTRY['Code/ngAPI/GAModel/GAPromotionsModel'] = exports; /**
 * @author: Abid Hussain
 */
exports.GAPromotionsModel = Core.Class.subclass({
	classname: 'GAPromotionsModel',
	initialize: function(){
		this._showmulti = null;
		this._cursor = null;
		this._promotionModelArray = [];
	},
	parsePromotions: function(promotionsObject){
		this._showmulti = promotionsObject['@showmulti'];
		this._cursor = promotionsObject['@cursor'];
		var promotion = promotionsObject.promotion;
		var isArray = this._isArray(promotion); 
		if(isArray){
			this._length = (typeof promotions != 'undefined' && promotion != null) ? promotion.length : 0; 
			if(this._length > 0){ 		
				for(var i=0; i<this._length; i++){
					this._parse(promotion[i]);
				}
			}
		}
		else{
			this._parse(promotion);
		}
	},
	_parse: function(promotion){
		var promotionModel = new GAPromotionModel();
		promotionModel.parse(promotion);
		this._promotionModelArray.push(promotionModel);
	},
	_isArray: function(variable) {
		return (variable.constructor == Array);
	},
	getShowMulti: function(){
		return this._showmulti;
	},
	getCursor: function(){
		return this._cursor;
	},
	getPromotionModelArray: function(){
		return this._promotionModelArray;
	},
	destroy: function(){
		for(var i=0; i<this._length; i++){
			this._promotionModelArray[i].destroy();
			this._promotionModelArray[i] = null;
		}
		this._promotionModelArray = null;
		this._length = null;
		this._showmulti = null;
		this._cursor = null;
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/ngAPI/GAModel/GAUserMessageModel'] = function(){var exports = $MODULE_REGISTRY['Code/ngAPI/GAModel/GAUserMessageModel'] || {}; $MODULE_REGISTRY['Code/ngAPI/GAModel/GAUserMessageModel'] = exports; /**
 * @author salman.humdullah
 */
exports.GAUserMessageModel = Core.Class.subclass({
	classname: 'GAUserMessageModel',
	initialize : function() {
		this._category = "";
		this._itemId = -1;
		this._storeName = "";
		this._message = "";
	},
	getCategory : function() {
		return this._category;
	},
	setCategory : function(cat) {
		this._category = cat;
	},
	getItemId : function() {
		return this._itemId;
	},
	setItemId : function(itemId) {
		this._itemId = itemId;
	},
	getStoreName : function() {
		return this._storeName;
	},
	setStoreName : function(storeName) {
		this._storeName = storeName;
	},
	getMessage : function() {
		return this._message;
	},
	setMessage : function(message) {
		this._message = message;
	},
	destroy : function(){
		this._catId = null;
		this._itemId = null;
		this._storeName = null;
		this._message = null;
	}
});
 ; return exports;};
$MODULE_FACTORY_REGISTRY['Code/ngAPI/GAModel/GAStoreVersionModel'] = function(){var exports = $MODULE_REGISTRY['Code/ngAPI/GAModel/GAStoreVersionModel'] || {}; $MODULE_REGISTRY['Code/ngAPI/GAModel/GAStoreVersionModel'] = exports; /**
 * @author abid.hussain 
 */
exports.GAStoreVersionModel = Core.Class.subclass({
	classname : 'GAStoreVersionModel',
	initialize : function(store)
	{
		this._storeName = null;
		this._position = null;
		this._store_id = null;
		this._storeVersion = null;
		this._visible_id = null;
		this._isActive = null;
		this._game_id = null;
		this.parseStore(store);
	},
	parseStore : function(store) {
		if (store != null) {
			this._storeName = store['@name'];
			this._position = store['@position'];
			this._store_id = store['@store_id'];
			this._storeVersion = store['@version'];
			this._game_id = store['@game_id'];
			this._visible_id = store['@visible_id'];
			this._isActive = store['@is_active'];
		}
	},
	getStoreName : function(){
		return this._storeName;
	},
	getPosition : function(){
		return this._position;
	},
	getStoreId : function(){
		return this._store_id;
	},
	getStoreVersion : function(){
		return this._storeVersion;
	},
	getGameId : function(){
		return this._game_id;
	},
	getVisibleId : function(){
		return this._visible_id;
	},
	getIsActive : function(){
		return this._isActive;
	},
	destroy : function(){
		this._storeName = null;
		this._position = null;
		this._store_id = null;
		this._storeVersion = null;
		this._visible_id = null;
		this._isActive = null;
		this._game_id = null;
	}
	
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/ngAPI/GAModel/GACurrenciesModel'] = function(){var exports = $MODULE_REGISTRY['Code/ngAPI/GAModel/GACurrenciesModel'] || {}; $MODULE_REGISTRY['Code/ngAPI/GAModel/GACurrenciesModel'] = exports; /**
 * @author abid.hussain
 */
exports.GACurrenciesModel = Core.Class.subclass({
	classname : 'GACurrenciesModel',
	initialize : function(currencyObject){
		this._currency = null;
		this._value = null;
		this.parseCurrencies(currencyObject);
	},
	parseCurrencies : function(currencyObject){
		this._currency = currencyObject['@currency'];
		this._value = currencyObject['@value'];
	},
	getCurrency : function(){
		return this._currency;
	},
	getValue : function(){
		return this._value;
	},
	destroy : function(){
		this._currency = null;
		this._value = null;
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/ngAPI/GAModel/GASocialGiftReceivedResponse'] = function(){var exports = $MODULE_REGISTRY['Code/ngAPI/GAModel/GASocialGiftReceivedResponse'] || {}; $MODULE_REGISTRY['Code/ngAPI/GAModel/GASocialGiftReceivedResponse'] = exports; /**
 * @author Syed Mauze Rehan
 */
exports.GASocialGiftReceivedResponse = GAServerResponseCommonModel.subclass({
	classname : 'GASocialGiftReceivedResponse',
	initialize : function(serverResponse){
		//$super(serverResponse);
		this._serverResponse = serverResponse;
		this._giftsArray = new Array(); 
		//this._sendersArray = new Array();
		//this._giftItems = new Array();
		this._message = null;
	},
	parseSocialGiftReceivedResponse : function(){
		
		if(this._serverResponse != 'undefined' && this._serverResponse != null)
		{
			
			/*If no gifts present then the response would be something like this
			
			{"status": "NO_GIFTS", "msg": "You have no gifts", "gifts": {}}
			  
			  */
			/* If gifts are available then the response would be like this
			 
			{"status": "OK", "msg": "Your gift list",
			"gifts": 
			{"ahZkZXZzb2NpYWxub3RpZmljYXRpb25zcg0LEgVHaWZ0cxiRyAIM": {"sname": "qq33", "sId": "355921042844124", "gId": "5_1_1", "sgame": "ngFish", "sts": "1", "stype": ""}, 
			 "ahZkZXZzb2NpYWxub3RpZmljYXRpb25zcg0LEgVHaWZ0cxjBuAIM": {"sname": "qq33", "sId": "355921042844124", "gId": "5_1_1", "sgame": "ngFish", "sts": "1", "stype": ""}
			}}      
			    
			  */
			
			this._message = this._serverResponse.msg;
			var gifts = this._serverResponse.gifts;
			
			var GiftModel = require('Code/SocialAPI/SocialModelClasses/GiftModel').GiftModel;

			for(objId in gifts)
			{
			//	if(!SocialUtil.isUserBlocked(gifts[objId].sname)) {
					
					var giftModel = new GiftModel();
					giftModel.setObjId(objId);
					giftModel.setSenderName(gifts[objId].sname+'');
					giftModel.setSenderId(gifts[objId].sId+'');
					giftModel.setGiftId(gifts[objId].gId+'');
					giftModel.setSenderGame(gifts[objId].sgame+'');
					giftModel.setSenderType(gifts[objId].stype+'');
					giftModel.setSenderTimeStamp(gifts[objId].sts+'');
					this._giftsArray.push(giftModel);
			//	}
				
				//console.log("gifts: -> "+giftModel.getObjId()+"_"+giftModel.getSenderName()+"_"+giftModel.getSenderId() +"_"+ giftModel.getGiftId() +"_"+ giftModel.getSenderGame()+"_"+ giftModel.getSenderTimeStamp()+"_"+ giftModel.getSenderType());
				
				
				
			}
			
		}
		  
		
	},
	
	getGiftsArray: function() {
		
		return this._giftsArray;		
	},
//	getSendersArray : function(){
//		return this._sendersArray;
//	},
//	getGiftItems : function(){
//		return this._giftItems;
//	},
	getMessage : function(){
		return this.message;
	},
	destroy : function($super){
		
		this._serverResponse = null;
		if(this._giftsArray !=null && this._giftsArray.length != 0)
		{
			this._giftsArray.splice(0,this._giftsArray.length);
			this._giftsArray = null;
		}
		
		
		this._message = null;
		
		$super();
	}
	
}); ; return exports;};
$MODULE_FACTORY_REGISTRY['Code/ngAPI/Dazzle/GADazzleHandler'] = function(){var exports = $MODULE_REGISTRY['Code/ngAPI/Dazzle/GADazzleHandler'] || {}; $MODULE_REGISTRY['Code/ngAPI/Dazzle/GADazzleHandler'] = exports; /**
 * author: abid.hussain
 */
exports.GADazzleHandler = Core.Class.singleton({
	classname : 'GADazzleHandler',
	initialize : function (){
		this._loggingCount = 0;
		this._countThreshHold = 0;
		this._timeThreshHold = 0;
		this._logOffers = false;
		this._logTransaction = false;
		this._logEvent = false;
		this._loggingType = null;
		this._storage = null;
		this._prevTime = 0;
		this._transMap =  [];
		this._eventsMap = [];
		this._offersMap = [];
		this._getDazzleInfo();
	},
	_getDazzleInfo : function (){
		try{
			var responseObject = GAGameLoader.getResponseObject();
			this._url = responseObject.getDazzleServer();
			console.log('GALOGGER: Dazzle URL is hardcoded....');
			console.log('GALOGGER: Dazzle URL is hardcoded....');
			console.log('GALOGGER: Dazzle URL is hardcoded....');
			console.log('GALOGGER: Dazzle URL is hardcoded....');
			console.log('GALOGGER: Dazzle URL is hardcoded....');
			console.log('GALOGGER: Dazzle URL is hardcoded....');
			console.log('GALOGGER: Dazzle URL is hardcoded....');
			console.log('GALOGGER: Dazzle URL is hardcoded....');
			console.log('GALOGGER: Dazzle URL is hardcoded....');
			console.log('GALOGGER: Dazzle URL is hardcoded....');
			console.log('GALOGGER: Dazzle URL is hardcoded....');
			this._url='http://vmart.gamevstudios.com/addTransactions/';
			this._url = encodeURI(this._url);
			this._countThreshHold = responseObject.getCountThreshold();
			this._timeThreshHold = responseObject.getTimeThreshold();
			this._logOffers = responseObject.getLogOffer();
			this._logTransaction = responseObject.getLogTransaction();
			this._logEvent = responseObject.getLogEvent();
			this._loggingType = responseObject.getLoggingType();
			this._storage = new Storage.KeyValue();
			this._storage.getItem(kGADazzle.kGALoggingCount, this.readCountCb.bind(this));
			if(this._loggingCount == 0){
				var date = new Date();
				this._prevTime = date.getTime();
			}
			this._readTransactions();
			this._readEvents();
			this._readOffers();
		}catch(exception){
			console.log('GALOGGER:Dazzle:: _getDazzleInfo ->'+exception);
		}
	},
	readCountCb: function(error,countValue){
		if(!error){
			this._loggingCount = countValue;
			console.log('GALOGGER: Saved LoggingCount = '+this._loggingCount);
		}else{
			console.log('GALOGGER: READING ERROR = '+error);
		}
	},
	logTransaction: function (transModelObject){
		if (this._logTransaction && this._loggingType != 0 && transModelObject!= null){	
			this._validateOptionalField(transModelObject, 'user_id', '');
			this.validateField(transModelObject, 'user_level','-1');
			this.validateField(transModelObject, 'item_id','-1');
			this.validateField(transModelObject, 'item_name','');
			this.validateField(transModelObject, 'category_id','-1');
			this.validateField(transModelObject, 'category_name','');
			this.validateField(transModelObject, 'store_id','-1');
			this.validateField(transModelObject, 'store_name','');
			this.validateField(transModelObject, 'currency','-1');
			this.validateField(transModelObject, 'price','-1');
			this._validateOptionalField(transModelObject, 'price_bucket', '');
			this.validateField(transModelObject, 'ts','-1');
			this.validateField(transModelObject, 'quantity','-1');
			transModelObject.state =kGADazzle.kGAPendingLog;
			this._transMap.push(transModelObject);
			var json = JSON.stringify(this._transMap);
			this._loggingCount++;
			this._storage.setItem(kGADazzle.kGALoggingCount,this._loggingCount);
			if(this._loggingCount <= kGADazzle.kGALoggingThreshold){
				this._serializeInfo('transaction', json);	
			}
			if( this._isCountOrCommonMode() ){
				this._processBatch();
			}
			else if( this._isTimeOrCommonMode()){
				this._processBatch();
			}
			else if ( this._isImmediateMode()){
				this._processBatch();
			}
		}
	},
	
	logEvent : function (eventsModelObj){
		if(this._logEvent && this._loggingType != 0 && eventsModelObj != null)
		{
			this.validateField(eventsModelObj, 'event_type', '-1');
			this._validateOptionalField(eventsModelObj, '', '-1');
			this.validateField(eventsModelObj, 'user_level', '-1');
			this._validateOptionalField(eventsModelObj, 'p_curr_bal', '-1');
			this._validateOptionalField(eventsModelObj, 's_curr_bal', '-1');
			this.validateField(eventsModelObj, 'ts', '-1');
			this._validateOptionalField(eventsModelObj, 'p_1', '');
			this._validateOptionalField(eventsModelObj, 'p_2', '');
			this._validateOptionalField(eventsModelObj, 'p_3', '');
			eventsModelObj.state = kGADazzle.kGAPendingLog;
			this._eventsMap.push(eventsModelObj);
			var json = JSON.stringify(this._eventsMap);
			this._loggingCount ++;
			this._storage.setItem(kGADazzle.kGALoggingCount,this._loggingCount);
			if(this._loggingCount <= kGADazzle.kGALoggingThreshold){
				this._serializeInfo('event', json);
			}
			if( this._isCountOrCommonMode() ){
				this._processBatch();
			}
			else if(this._isTimeOrCommonMode()){
				this._processBatch();
			}
			else if (this._isImmediateMode()){
				this._processBatch();
			}
		}
	},
	
	logOffer : function (offerObj)
	{
		if(this._logOffers && this._loggingType != 0 && offerObj != null)
		{	
			var value = "";
			this.validateField(offerObj, 'fire_type', '-1');
			this._validateOptionalField(offerObj, 'user_id', '');
			this.validateField(offerObj, 'user_level', '-1');
			this.validateField(offerObj, 'currency', '-1');
			this._validateOptionalField(offerObj, 'offer_id', '');
			this._validateOptionalField(offerObj, 'i_tx_id', '');
			this._validateOptionalField(offerObj, 'i_price_tier', '');
			this.validateField(offerObj, 'ts', '-1');
			this.validateField(offerObj, 'currency_name', '');
			offerObj.state = kGADazzle.kGAPendingLog;
			this._offersMap.push(offerObj);
			var json = JSON.stringify(this._offersMap);
			this._loggingCount ++;
			this._storage.setItem(kGADazzle.kGALoggingCount,this._loggingCount);
			if(this._loggingCount <= kGADazzle.kGALoggingThreshold){
				this._serializeInfo('offer', json);
			}
			if( this._isCountOrCommonMode() ){		
				this._processBatch();
			}
			else if( this._isTimeOrCommonMode() ){
				this._processBatch();
			}
			else if ( this._isImmediateMode() ){
				this._processBatch();
			}
		}
	},
	validateField: function(thisp, fieldName, value) {
		var data = thisp[fieldName];
		if (data == null || data=="" ) {
			thisp[fieldName] = value;
			thisp["isError"] = "1";
		}
	},
	_validateOptionalField: function(thisp, fieldName, value){
		var data = thisp[fieldName];
		if (data == null || data=="" ) {
			thisp[fieldName] = value;
		}
	},
	_processBatch : function (){
		var transArray =[];
		var eventsArray =[];
		var offersArray = [];
		var length = "";
		try{
			length = this._transMap.length;
			for(var i=0; i<length; i++){
				var obj = this._transMap[i];
				if(obj!= undefined && obj.state != kGADazzle.kGAInProgressLog){
					transArray.push(obj);
					obj.state=kGADazzle.kGAInProgressLog;
				}
			}
			length = this._eventsMap.length;
			for(var i=0; i<length; i++){
				var obj = this._eventsMap[i];
				if(obj!= undefined && obj.state != kGADazzle.kGAInProgressLog){
					eventsArray.push(obj);
					obj.state=kGADazzle.kGAInProgressLog;
				}
			}
			length= this._eventsMap.length;
			for(var i=0; i<length; i++){
				var obj = this._offersMap[i];
				if(obj!= undefined && obj.state != kGADazzle.kGAInProgressLog){
					offersArray.push(obj);
					obj.state=kGADazzle.kGAInProgressLog;
				}
			}
			var commonModelObj = new GACommonModel();
			commonModelObj.setCommonParams();
			commonModelObj.setTransactions(transArray);
			commonModelObj.setEvents(eventsArray);
			commonModelObj.setOffers(offersArray);
			var jsonData = JSON.stringify(commonModelObj);
			var encodedData = encodeURIComponent(jsonData);
			var params = "json="+ encodedData;
			var webFetcher = new GAWebFetcher(this, 15, 0);
			webFetcher.invokePostRequest(this._url,params,true);
		}catch(exception){
			console.log('GALOGGER:: _processBatch ->'+exception);
		}
	},
	_isCountOrCommonMode : function (){
		var mode = false;
		if(this._loggingCount == this._countThreshHold &&((this._loggingType == 1) || (this._loggingType == 3))){
			mode = true;
		}
		return mode;
	},
	_isTimeOrCommonMode : function (){
		var mode = false;
		var date = new Date();
		var timeCount = (date.getTime() - this._prevTime)/1000;
		if( timeCount >= this._timeThreshHold &&((this._loggingType == 2) || (this._loggingType == 3))){
			mode = true;
		}
		return mode;
	},
	_isImmediateMode : function (){
		var mode = false;
		if(this._loggingType == 4){
			mode = true;
		}
		return mode;
	},
	_onApplicationTerminate : function (){
		if(this._loggingType == 5){
			ProcessBatch();
		}
	},
	_serializeInfo : function (name,info){
		Storage.FileSystem.writeFile('./Content/Dazzle/'+name+'.json', info);
	},
	_readTransactions : function (){
		Storage.FileSystem.readFile('./Content/Dazzle/transaction.json', false, this.readTransComplete.bind(this));
	},
	_readOffers : function (){
		Storage.FileSystem.readFile('./Content/Dazzle/offer.json', false, this.readOffersComplete.bind(this));
	},
	_readEvents : function (){
		Storage.FileSystem.readFile('./Content/Dazzle/event.json', false, this.readEventsComplete.bind(this));
	},
	
	readTransComplete : function (error,contents){
		if(!error){
			var transArray = eval("(" + contents + ")");
			var length = transArray.length;
			for(var i=0; i<length; i++){
				var obj = transArray[i];
				if(obj != undefined){
					obj.state =kGADazzle.kGAPendingLog;
					this._transMap.push(obj);
				}
			}
		}
	},
	readEventsComplete: function (error,contents){
		if(!error){
			var eventsArray = eval("(" + contents + ")");
			var length = eventsArray.length;
			for(var i=0; i<length; i++){
				var obj = eventsArray[i];
				if(obj != undefined){
					obj.state =kGADazzle.kGAPendingLog;
					this._eventsMap.push(obj);
				}
			}
		}
	},
	
	readOffersComplete: function (error,contents){
		if(!error){
			var offersArray = eval("(" + contents + ")");
			var length = offersArray.length;
			for(var i=0; i<length; i++){
				var obj = offersArray[i];
				if(obj != undefined){
					obj.state =kGADazzle.kGAPendingLog;
					this._offersMap.push(obj);
				}
			}
		}
	},
	
	_revertBatch: function(){
		var length = this._transMap.length;
		for(var i=0; i<length; i++){
			var obj = this._transMap[i];
			if(obj != undefined && obj.state == kGADazzle.kGAInProgressLog){
				obj.state = kGADazzle.kGAPendingLog;
			}
		}
		length = this._eventsMap.length;
		for(var i=0; i<length; i++){
			var obj = this._eventsMap[i];
			if(obj != undefined && obj.state == kGADazzle.kGAInProgressLog){
				obj.state = kGADazzle.kGAPendingLog;
			}
		}
		length = this._offersMap.length;
		for(var i=0; i<length; i++){
			var obj = this._offersMap[i];
			if(obj != undefined && obj.state == kGADazzle.kGAInProgressLog){
				obj.state = kGADazzle.kGAPendingLog;
			}
		}
	},
	
	webFetchSuccess: function (webFetcher, response){
		console.log('GALOGGER:: webFetchSuccess AND response - > '+response);
		var transArray=[];
		var eventsArray=[];
		var offersArray=[];
		var respStatus = "";
		try{
			respStatus = response.match("status=\"SUCCESS\"");
			if(respStatus != -1){
				this._loggingCount = 0;
				this._storage.setItem(kGADazzle.kGALoggingCount,this._loggingCount);
				var date = new Date();
				this._prevTime = date.getTime();
				var length = this._transMap.length;
				for(var i=0; i<length; i++){
					var obj= this._transMap[i];
					if(obj!=undefined && obj!=null){
						if(obj.state == kGADazzle.kGAInProgressLog){
							this._transMap.splice(i, 1);
						}else if(obj.state != undefined){
							transArray.push(obj);
						}
					}
				}
				length = this._eventsMap.length;
				for(var i=0; i<length; i++){
					var obj = this._eventsMap[i];
					if(obj!=undefined && obj!=null){
						if(obj.state == kGADazzle.kGAInProgressLog){
							this._eventsMap.splice(i, 1);
						}else if(obj.state != undefined){
							eventsArray.push(obj);
						}
					}
				}
				length = this._offersMap.length;
				for(var i=0; i<length; i++){
					var obj = this._offersMap[i];
					if(obj!=undefined&&obj!=null){
						if(obj.state == kGADazzle.kGAInProgressLog){
							this._offersMap.splice(i, 1);
						}else if(obj.state != undefined){
							offersArray.push(obj);
						}
					}
				}
				this._serializeInfo('transaction', transArray);
				this._serializeInfo('event', eventsArray);
				this._serializeInfo('offer', offersArray);
			}else{
				console.log("GALOGGER: Server Response is Error");
				this._revertBatch();
			}
		}catch(exception){
			console.log('GALOGGER: webFetchSuccess ->'+exception);
		}
	},

	webFetchFailure: function (webFetcher, error){
		console.log('GALOGGER: webFetchFailure AND response - > '+ error);
		this._revertBatch();
	},
	
	destroy: function(){
		var length = this._transMap.length;
		for(var i=0; i<length; i++){
			this._transMap[i].destroy();
			delete this._transMap[i];
		}
		delete this._transMap;
		length = this._eventsMap.length;
		for(var i=0; i<length; i++){
			this._eventsMap[i].destroy();
			delete this._eventsMap[i];
		}
		delete this._eventsMap;
		length = this._offersMap.length;
		for(var i=0; i<length; i++){
			this._offersMap[i].destroy();
			delete this._offersMap[i];
		}
		delete this._offersMap;
		this._loggingCount = null;
		this._storage = null;
		this._countThreshHold = null;
		this._timeThreshHold = null;
		this._logOffers = null;
		this._logTransaction = null;
		this._logEvent = null;
		this._loggingType = null;
		this._prevTime = null;
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/ngAPI/Dazzle/GACommonModel'] = function(){var exports = $MODULE_REGISTRY['Code/ngAPI/Dazzle/GACommonModel'] || {}; $MODULE_REGISTRY['Code/ngAPI/Dazzle/GACommonModel'] = exports; /**
 * author: abid.hussain
 */
exports.GACommonModel = Core.Class.subclass({
	classname : 'GACommonModel',
	initialize : function (){
		this.udid= null;
		this.device_type= null;
		this.device_model= null;
		this.device_os= null;
		this.game_family_id= null;
		this.game_family= null;
		this.game= null;
		this.game_id= null;
		this.game_flavor= null;
		this.game_version= null;
		this.ts= null;
		this.auth= null;
		this.is_error = "0";
		this.trans_list = [];
		this.events_list = [];
		this.c_offers_list = [];
	},
	
	setCommonParams : function (){
		this.udid = GAConfigurations.getUdid();
		this._authenticateData(this.udid);
		this.device_type = GAConfigurations.getDeviceType();
		this._authenticateData(this.device_type);
		this.device_model = GAConfigurations.getDeviceName();
		this._authenticateData(this.device_model);
		this.device_os = GAConfigurations.getOsVersion();
		this._authenticateData(this.device_os);
		this.game_family_id = GAConfigurations.getGameFamilyId();
		this._authenticateData(this.game_family_id);
		this.game_family = GAConfigurations.getGameFamily();
		this._authenticateData(this.game_family);
		this.game =GAConfigurations.getGameName();
		this._authenticateData(this.game);
		var responseObject = GAConfigurations.getResponseObject();
		if(responseObject != null){
			this.game_id = responseObject.getGameId();
		}
		this._authenticateData(this.game_id);
		this.game_flavor = GAConfigurations.getGameCode();
		this._authenticateData(this.game_flavor);
		this.game_version = GAConfigurations.getGameVersion();
		this._authenticateData(this.game_version);
		this.ts = this.getunixtimestamp();
		this._authenticateData(this.ts);
		var str = this.udid+this.game_family+this.game+this.ts;
		this.auth = Core.toMD5(str);
		this._authenticateData(this.auth);
	},
	
	getunixtimestamp : function()
	{
		var d = new Date();
		var localTime = d.getTime();
		var localOffset = d.getTimezoneOffset() * 60000;
		var utc = localTime + localOffset;
		var returnAble = Math.round(utc / 1000);
		
        return returnAble;
	},
	setTransactions : function (trans){
		this.trans_list = trans;
	},
	setOffers : function (offers){
		this.c_offers_list = offers;
	},
	setEvents : function (events){
		this.events_list = events;
	},
	_authenticateData: function(data){
		if(data == null || data ==""){
			data = "";
			this.is_error = "1";
		}
	},
	destroy: function(){
		delete this.trans_list;
		delete this.c_offers_list;
		delete this.events_list;
		this.udid= null;
		this.device_type= null;
		this.device_model= null;
		this.device_os= null;
		this.game_family_id= null;
		this.game_family= null;
		this.game= null;
		this.game_id= null;
		this.game_flavor= null;
		this.game_version= null;
		this.ts= null;
		this.auth= null;
		this.is_error = null;
	}
});
	; return exports;};
$MODULE_FACTORY_REGISTRY['Code/ngAPI/Dazzle/GATransactionsModel'] = function(){var exports = $MODULE_REGISTRY['Code/ngAPI/Dazzle/GATransactionsModel'] || {}; $MODULE_REGISTRY['Code/ngAPI/Dazzle/GATransactionsModel'] = exports; /**
 * author: abid.hussain
 */
exports.GATransactionsModel = Core.Class.subclass({
	classname : 'GATransactionsModel',
	initialize : function (){
	this.transactionId = 0;
	this.user_id= null;
	this.user_level= null;
	this.item_id= null;
	this.item_name= null;
	this.category_id= null;
	this.category_name= null;
	this.store_id= null;
	this.store_name= null;
	this.currency= null;
	this.price= null;
	this.price_bucket= null;
	this.ts= null;
	this.quantity= null;
	this.is_error = "0";
	this.state = "";
},
	setUserId : function (id){
		this.user_id = id;
	},
	setUserLevel : function (level){
		this.user_level = level;
	},
	setItemId : function (id){
		this.item_id = id;
	},
	setItemName : function (name){
		this.item_name = name;
	},
	setCategoryId : function (id){
		this.category_id = id;
	},
	setCategoryName : function (name){
		this.category_name = name;
	},
	setStoreId : function (id){
		this.store_id = id;
	},
	setStoreName : function (name){
		this.store_name = name;
	},
	setCurrency : function (curr){
		this.currency = curr;
	},
	setPrice : function (price){
		this.price = price;
	},
	setPriceBucket : function (bucket){
		this.price_bucket = bucket;
	},
	setTs : function (ts){
		this.ts = ts;
	},
	setQuantity : function (quantity){
		this.quantity = quantity;
	},
	setIsError : function (error){
		this.is_error = error;
	},
	getUserId : function (){
		return this.user_id;
	},
	getUserLevel : function (){
		return this.user_level;
	},
	getItemId : function (){
		return this.item_id;
	},
	getItemName : function (){
		return this.item_name;
	},
	getCategoryId : function (){
		return this.category_id;
	},
	getCategoryName : function (){
		return this.category_name;
	},
	getStoreId : function (){
		return this.store_id;
	},
	getStoreName : function (){
		return this.store_name;
	},
	getCurrency : function (){
		return this.currency ;
	},
	getPrice : function (){
		return this.price ;
	},
	getPriceBucket : function (){
		return this.price_bucket;
	},
	getTs : function (){
		return this.ts;
	},
	getQuantity : function (){
		return this.quantity;
	},
	getIsError : function (){
		return this.is_error;
	},
	toJSON: function() {
		var obj = {};
		for (var i in this) {
			if (i != "state") {
				obj[i] = this[i];
			}
		}
		return obj;
	},
	destroy: function(){
		this.transactionId =null;
		this.user_id= null;
		this.user_level= null;
		this.item_id= null;
		this.item_name= null;
		this.category_id= null;
		this.category_name= null;
		this.store_id= null;
		this.store_name= null;
		this.currency= null;
		this.price= null;
		this.price_bucket= null;
		this.ts= null;
		this.quantity= null;
		this.is_error =null;
		this.state =null;
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/ngAPI/Dazzle/GAEventsModel'] = function(){var exports = $MODULE_REGISTRY['Code/ngAPI/Dazzle/GAEventsModel'] || {}; $MODULE_REGISTRY['Code/ngAPI/Dazzle/GAEventsModel'] = exports; /**
 * author: abid.hussain
 */
exports.GAEventsModel = Core.Class.subclass({
	classname : 'GAEventsModel',
	initialize : function (){
		this.eventsId =0;
		this.event_type = null;
		this.user_id = null;
		this.user_level = null;
		this.p_curr_bal = null;
		this.s_curr_bal = null;
		this.ts = null;
		this.p_1 = null;
		this.p_2 = null;
		this.p_3 = null;
		this.is_error = "0";
		this.state = "";
	},
	setEventType : function (type){
		this.event_type = type;
	},
	setUserId : function (id){
		this.user_id = id;
	},
	setUserLevel : function (level){
		this.user_level = level;
	},
	setPCurrBal : function (balance){
		this.p_curr_bal = balance;
	},
	setSCurrBal : function (balance){
		this.s_curr_bal = balance;
	},
	setTs : function (time){
		this.ts = time;
	},
	setP1 : function (param){
		this.p_1 = param;
	},
	setP2 : function (param){
		this.p_2 = param;
	},
	setP3 : function (param){
		this.p_3 = param;
	},
	setIsError : function (error){
		this.is_error = error;
	},
	getEventType : function (){
		return this.event_type;
	},
	getUserId : function (){
		return this.user_id ;
	},
	getUserLevel : function (){
		return this.user_level;
	},
	getPCurrBal : function (){
		return this.p_curr_bal;
	},
	getSCurrBal : function (){
		return this.s_curr_bal;
	},
	getTs : function (){
		return this.ts;
	},
	getP1 : function (){
		return this.p_1;
	},
	getP2 : function (){
		return this.p_2;
	},
	getP3 : function (){
		return this.p_3;
	},
	getIsError : function (){
		return this.is_error;
	},
	toJSON: function() {
		var obj = {};
		for (var i in this) {
			if (i != "state") {
				obj[i] = this[i];
			}
		}
		return obj;
	},
	
	destroy: function(){
		this.eventsId =null;
		this.event_type = null;
		this.user_id = null;
		this.user_level = null;
		this.p_curr_bal = null;
		this.s_curr_bal = null;
		this.ts = null;
		this.p_1 = null;
		this.p_2 = null;
		this.p_3 = null;
		this.is_error =null;
		this.state =null;
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/ngAPI/Dazzle/GAOffersModel'] = function(){var exports = $MODULE_REGISTRY['Code/ngAPI/Dazzle/GAOffersModel'] || {}; $MODULE_REGISTRY['Code/ngAPI/Dazzle/GAOffersModel'] = exports; /**
 * author: abid.hussain
 */
exports.GAOffersModel = Core.Class.subclass({
	classname : 'GAOffersModel',
	initialize : function (){
		this.offersId = 0;
		this.user_id = null;
		this.user_level = null;
		this.currency = null;
		this.currency_name = null;
		this.fire_type = null;
		this.offer_id = null;
		this.i_tx_id = null;
		this.i_price_tier = null;
		this.ts = null;
		this.is_error = "0";
		this.state = "";
	},
	setUserId : function (id){
		this.user_id = id;
	},
	setUserLevel : function (level){
		this.user_level = level;
	},
	setCurrency : function (curr){
		this.currency = curr;
	},
	setCurrencyName : function (name){
		this.currency_name = name;
	},
	setFireType : function (type){
		this.fire_type = type;
	},
	setOfferId : function (id){
		this.offer_id = id;
	},
	setITxId : function (id){
		this.i_tx_id = id;
	},
	setIPriceTier : function (priceTier){
		this.i_price_tier = priceTier;
	},
	setTs : function (ts){
		this.ts = ts;
	},
	setIsError : function (error){
		this.is_error = error;
	},
	
	getUserId : function (){
		return this.user_id;
	},
	getUserLevel : function (){
		return this.user_level;
	},
	getCurrency : function (){
		return this.currency;
	},
	getCurrencyName : function (){
		return this.currency_name;
	},
	getFireType : function (){
		return this.fire_type;
	},
	getOfferId : function (){
		return this.offer_id;
	},
	getITxId : function (){
		return this.i_tx_id;
	},
	getIPriceTier : function (){
		return this.i_price_tier;
	},
	getTs : function (){
		return this.ts;
	},
	toJSON: function() {
		var obj = {};
		for (var i in this) {
			if (i != "state") {
				obj[i] = this[i];
			}
		}
		return obj;
	},
	destroy: function(){
		this.offersId = null;
		this.user_id = null;
		this.user_level = null;
		this.currency = null;
		this.currency_name = null;
		this.fire_type = null;
		this.offer_id = null;
		this.i_tx_id = null;
		this.i_price_tier = null;
		this.ts = null;
		this.is_error =null;
		this.state =null;
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/ngAPI/GACommon/GAStorageManager'] = function(){var exports = $MODULE_REGISTRY['Code/ngAPI/GACommon/GAStorageManager'] || {}; $MODULE_REGISTRY['Code/ngAPI/GACommon/GAStorageManager'] = exports; exports.GAStorageManager = Core.Class.singleton({

    classname: 'GAStorageManager',

    initialize: function() {
 
        this._storage = new Storage.KeyValue();
    },

    setItem: function(key, value) {
        if(isValidString(key) && isValidObject(value))
        {
            this._storage.setItem(key, value, function(error, key) {});
        }
        else
        {
            GALogger.log("Invalid key or object for GAStorageManager setItem.");
        }
    },

    removeItem: function(item) {
        if(isValidObject(item))
        {
            this.setItem(item, null);
        }
        else
        {
            GALogger.log("Invalid key or object for GAStorageManager removeItem.");
        }
    },
    getItem : function(key,callback) {
        if(isValidString(key))
        {
            this._storage.getItem(key,callback,true);
        }
        else
        {
            GALogger.log("Invalid key or object for GAStorageManager getItem.");
        }
    },
    destroy : function(){
    	this._storage.destroy();
    }
	
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/ngAPI/GAPersistence/GAPersistedObject'] = function(){var exports = $MODULE_REGISTRY['Code/ngAPI/GAPersistence/GAPersistedObject'] || {}; $MODULE_REGISTRY['Code/ngAPI/GAPersistence/GAPersistedObject'] = exports; 
exports.GAPersistedObject = Core.Class.subclass({
	
	initialize: function(resourceName, callback, atNeighbor) {
		this._callback = callback;
		this._resourceName = resourceName;
		if(!atNeighbor)
			this._neighbor = false;
		else
			this._neighbor = atNeighbor;
		console.log("faizan resourceName:  "+resourceName);
		if(this._neighbor)
			this.loadNeighbor(resourceName);
		else
			this.load(resourceName);
	},
	
	load: function(resourceName) {
		var pathToResource = GAConfigurations.getGameStateDBPath() + "/" +GAConfigurations.getUserId()+"/"+ resourceName + ".json";
		Storage.FileSystem.readFile(pathToResource, false, this.loadComplete.bind(this));
	},
	
	loadNeighbor: function(resourceName) {
		var pathToResource = GAConfigurations.getGameStateDBPath() + "/random/"+ resourceName + ".json";
		console.log("GAPersistedObject => loadNeighbor " + pathToResource);
		Storage.FileSystem.readFile(pathToResource, false, this.loadComplete.bind(this));
	},
	
	
	loadComplete: function(error, contents) {
		if (error) {
			console.log("ERROR loading the object: " + error)
			this._callback(this._resourceName,true);
		}
		else {
			var obj = eval("(" + contents + ")");
			console.log("GAPersistedObject => loadComplete => content " + contents);
			//console.log("GAPersistedObject => loadComplete => content " + obj.classname);
			if (!obj.classname) {
				throw "Property 'classname' missing";
			}
			for (var prop in obj) {
				//console.log("Setting property: [" + prop + "] = " + obj[prop]);
				this[prop] = obj[prop];
			}
			console.log("GAPersistedObject => this.classname " + this.classname);
			this._callback(this.classname);
		}
	},
	
	toJSON: function() {
		var obj = {};
		for (var prop in this) {
			if (prop != "_delegate") {
				obj[prop] = this[prop];	
			}
		}
		return obj;
	},
	
	toJSONString: function(){
		var jsonStr = JSON.stringify(this);
		return jsonStr;
	},
	
	persist: function() {
		var pathToResource = "";
		if(!this._neighbor)
			pathToResource = GAConfigurations.getGameStateDBPath() +"/"+GAConfigurations.getUserId()+"/" + this.classname + ".json";
		else
			pathToResource = GAConfigurations.getGameStateDBPath() +"/random/" + this.classname + ".json";
		//console.log("SAVED at: " + pathToResource);
		var jsonStr = JSON.stringify(this);
		//console.log("JSON string: " + jsonStr);
		Storage.FileSystem.writeFile(pathToResource, jsonStr);
	},
	
	destroy: function() {
		this._callback = null;
	}
	
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/ngAPI/GAPersistence/GAPersistenceManager'] = function(){var exports = $MODULE_REGISTRY['Code/ngAPI/GAPersistence/GAPersistenceManager'] || {}; $MODULE_REGISTRY['Code/ngAPI/GAPersistence/GAPersistenceManager'] = exports; 
exports.GAPersistenceManager = Core.Class.singleton ({

	loadResources: function(resources, progressCallback, doneCallback, errorCallback, atNeighbor) {
		if(resources.length == 0)
			return;
		console.log("resources.length " + resources.length);
		this._resources = resources;
		console.log("this._resources[0] " + this._resources[0]);
		this._progressCallback = progressCallback;
		this._doneCallback = doneCallback;
		this._errorCallback = errorCallback;
		this._totalResources = this._resources.length;
		this._downloadCounter = 0;
		this._objects = {};
		console.log("atNeighbor " + atNeighbor);
		console.log("this._atNeighbor " + this._atNeighbor);
		if(atNeighbor){
			
			console.log("GAPersistence Manager at neighbor");
			this._atNeighbor = atNeighbor;
		}else{
			console.log("GAPersistence Manager not at neighbor");
			this._atNeighbor = false;
		}
		console.log("Going to load resource " + this._resources[this._downloadCounter]);
		this._obj = new GAPersistedObject(this._resources[this._downloadCounter], this.loadComplete.bind(this), this._atNeighbor);
	},
	
	loadComplete: function(resourceName,error) {
		if(error)
		{
			if(this._errorCallback)
			{
				this._errorCallback(resourceName,error);
				return;
			}
		}
		console.log("loadComplete with no error");
		console.log("this._downloadCounter" + this._downloadCounter);
		console.log("this._resources[this._downloadCounter] " + this._resources[this._downloadCounter]);
		console.log("resource name load complete" + this._obj.toJSONString());
		this._objects[this._resources[this._downloadCounter]] = this._obj;
		console.log("this._downloadCounter " + this._downloadCounter);
		console.log("this._totalResources " + this._totalResources);
		if (this._downloadCounter < this._totalResources - 1) {
			this._obj = new GAPersistedObject(this._resources[++this._downloadCounter], this.loadComplete.bind(this), this._atNeighbor);
			this._progressCallback(this._downloadCounter, this._totalResources);
		}
		else {
			console.log("_doneCallback() ");
			this._progressCallback(this._downloadCounter+1, this._totalResources);
			this._doneCallback();
		}
	},
	
	unLoadResource: function(resourceName) {
		console.log("unloading resource objects " + resourceName);
		if(this._objects[resourceName])
		{
			this._objects[resourceName].destroy();
			this._objects[resourceName] = null;
		}
		else
		{
			console.log("ERROR unloading the object: No resource of this name found");
		}
	},
	
	getResource: function(resourceName) {
		console.log("get resource name " +resourceName);
		console.log("this._objects " +this._objects);
		console.log("resource json " +this._objects[resourceName].toJSONString());
		return this._objects[resourceName];
	},
	
	destroy: function() {
		var len = this._objects.length;
		for (var i = 0; i < len; i++) {
			this._objects[i].destroy();
			this._objects[i] = null;
		}
		delete this._objects;
		delete this._resources;
		this._progressCallback = null;
		this._doneCallback = null;
	}
	
	
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/ngAPI/GAInApp/GAInAppPurchaseHandler'] = function(){var exports = $MODULE_REGISTRY['Code/ngAPI/GAInApp/GAInAppPurchaseHandler'] || {}; $MODULE_REGISTRY['Code/ngAPI/GAInApp/GAInAppPurchaseHandler'] = exports; /**
 * Filename: GAInAppPurchaseHandler.js
 * Author: Harris Khurram
 * Updates: Abid Hussain
 * US SDK Integration : May 30, 2011 -- Harris  THIS FILE IS TESTED WITH US INTENT ONLY.
 * Date Created: 04-25-2011
 * Date Updated: 05-30-2011
 */

var GAPurchaseSyncHandler = require('Code/ngAPI/GAInApp/GAPurchaseSyncHandler').GAPurchaseSyncHandler;

exports.GAInAppPurchaseHandler = Core.Class.singleton({

    classname: 'GAInAppPurchaseHandler',
	
	initialize: function() {
		this._initStatusVars();
        this._loadDefaultUserMsgs();
        this._completedTransactions = null;
        this._txnStorage = new Storage.KeyValue();
        var myself = this;
        this._txnStorage.getItem(COMPLETED_TXN_KEY, 
        	function(error, value, key) {
        		if (!error && value != null) {
        			myself._completedTransactions = eval("(" + value + ")");
        		}
        		else {
					myself._completedTransactions = {};
        		}
        	}
        );
		setTimeout(this._loadUserMsgs.bind(this), 6000);
	},
	
	performInAppWithItemIdAndCallback: function(anInAppItemId, aCallBack, aComment) {
		//by default we send quantity as 1
		this.performInAppWithItemIdQuantityAndCallback(anInAppItemId, 1, aCallBack, aComment);
	},
	
	performInAppWithItemIdQuantityAndCallback: function(anInAppItemId, aQuantity, aCallBack, aComment) {
		UIFactory.showProgressHUD(this._msg._contactingServer);
		UIFactory.showBlockView();

		if(isValidString(aQuantity)) {
			aQuantity = parseInt(aQuantity,10);
		} else if (isValidNumber(aQuantity)) {
			aQuantity = aQuantity;
		} else {
			//cannot understand quantity parameter
			aQuantity = -1
		}
		
		
		if(!isValidString(anInAppItemId) || typeof aCallBack != 'function' || aQuantity == -1 )
        {
			this._transactionFailure(GAInAppPurchase.noItem);
			
            console.log('GALogger: Invalid Item Id, Qunatity or Callback-function for GAInAppPurchaseHandler.');
            UIFactory.hideBlockView();
            UIFactory.showToast("Wrong Parameters to Bank Method - GAPI");

			return;
		}
        
        if(!aComment)
        {
            aComment = "";
        }
        
		
		var inAppItemId = anInAppItemId;
		this._quantity = "" + aQuantity   //converting to string
		this._callBack = aCallBack;
        this._msg._InAppComment = aComment;

		
		Bank.Inventory.getItem(inAppItemId, this._performInAppCallback.bind(this));
	},
	
    showMobageBalanceButton: function(uiGeometryRect) {
           var frame = null;
			if (uiGeometryRect instanceof UI.ViewGeometry.Rect){
					frame = uiGeometryRect;
			} else if (uiGeometryRect instanceof Array) {
				if (uiGeometryRect.length >=4) {
					frame = new UI.ViewGeometry.Rect(uiGeometryRect[0], uiGeometryRect[1],uiGeometryRect[2],uiGeometryRect[3]);
				} else {
					//console.log("GALogger: MobageBalance will use default values. for rect.");
				}
			} 
			
			if(frame == null) {
				//if frame is still null, load default values
				frame = new UI.ViewGeometry.Rect(0,0,200,80);
				console.log("GALogger: MobageBalance default values for rect assigned.");
			}
		   
		   Social.US.Service.ButtonOverlays.showBalanceButton(frame, function(error){});		
	},
	hideMobageBalanceButton: function() {
		Social.US.Service.ButtonOverlays.hideBalanceButton(function(error) {});
	},
	
	$mobageTokushohoPolicy: function() {
        UIFactory.showToast("Policy button not implemented yet for US SDK.");
        return;
	},
    
    notifyServer: function(currencyType, amount) {
		var signature = this._getSignature(currencyType, amount);
		var requestUrl = this._getRequestUrl(currencyType, amount, signature);
		var webFetcher = new GAWebFetcher(this, 30, 0);
		webFetcher.invokeGetRequest(requestUrl);
	},


    _initStatusVars: function() {
		this._confirmedTransactionId = null;
		this._callBack = null;
		this._errorMsg = null;
		this._retryCount = 9;
		this._quantity = -1;
	},
    
    
    _loadDefaultUserMsgs: function () {
    		this._msg = new Object();

            this._msg._contactingServer = "Contacting Mobage..."
			this._msg._networkError = "Sorry, a network error occured during the transaction.";
			//this._msg._InAppComment = "Titans vs Olympians purchase of %val1 gold";
			this._msg._authorizingPurchase = "Authorizing the purchase..";
			this._msg._completingTransaction = "Completing the transaction...";
			this._msg._cancellingTransaction = "Cancelling the transaction...";
			this._msg._itemNotFound = "Specified item not found, please contact customer service.";
			this._msg._insufficentFunds = "Sorry, you do not have enough Mobacoins.";
			this._msg._noButtonPressed = "Sorry, the purchase did not go through successfully."
			this._msg._serverUnauth = "Sorry, server did not authorize this purchase.";
    },
	
	_loadUserMsgs: function() {
		if(GALocalizationHandler != undefined) {
			if(GALocalizationHandler.getLocalizedString("inapp_contactingMobage") != "inapp_contactingMobage")		//keys are defined
			{
				this._msg._contactingServer = GALocalizationHandler.getLocalizedString("inapp_contactingMobage");
				this._msg._networkError = GALocalizationHandler.getLocalizedString("inapp_networkError");
				//this._msg._InAppComment = GALocalizationHandler.getLocalizedString("inapp_InAppCommentForTransaction");
				this._msg._authorizingPurchase = GALocalizationHandler.getLocalizedString("inapp_authorizingThePurchase");
				this._msg._completingTransaction = GALocalizationHandler.getLocalizedString("inapp_completingTransaction");
				this._msg._cancellingTransaction = GALocalizationHandler.getLocalizedString("inapp_cancellingTransaction");
				this._msg._itemNotFound = GALocalizationHandler.getLocalizedString("inapp_unableToPerformMobaKoinc");
				this._msg._insufficentFunds = GALocalizationHandler.getLocalizedString("inapp_insufficentBalance");
				this._msg._noButtonPressed = GALocalizationHandler.getLocalizedString("inapp_notAuthorize");
				this._msg._serverUnauth = GALocalizationHandler.getLocalizedString("inapp_unAuthServer");
			}
		}
	},
    
	_performInAppCallback: function(error, item) {	
		setTimeout(UIFactory.hideProgressHUD.bind(this), 3000);		//there is a slight delay in before the confirmation appears, these 3 seconds actually cover that span.
		if(!error)
        {
      		var billingItems = [{"item" : { "id":item.id}, "quantity":"1"}];
            
                                                                        									
			/*
				Do not show progress HUD as it will not let us click the OK button on in App confirmation.
				create a transaction with the above items, once you get the id in the call back you can perform further actions on the transaction
			*/
			
			Bank.Debit.createTransaction(billingItems, this._msg._InAppComment, this._createTransactionCallBack.bind(this));
			//this._completeTransaction();			
			//GAPurchaseSyncHandler.synchPendingTransactions(this.temp);
		}
        else
        {
			this._transactionFailure(error.errorCode)
		}
	},
	
	temp: function(itemId) {
		console.log("Inside temp: " + itemId);	
	},
	
	_createTransactionCallBack: function(error, transaction) {	
		UIFactory.showProgressHUD(this._msg._authorizingPurchase);
		if(!error) {			
			if(transaction) {				
				//user has pressed OKAY Button
				this._confirmedTransactionId = transaction.id;
				//now ask bank to open the transaction.
				Bank.Debit.openTransaction(this._confirmedTransactionId, this._openTransactionCallBack.bind(this));
			} else {
				//user has pressed NO Button
				//this._transactionFailure(GAInAppPurchase.noButton);
				this._transactionFailure(GAInAppPurcahse.miscError);
			}
		} else {
		   var errorCode = GAInAppPurchase.miscError;
		   if(error == "usercanceled")  //spelling from mobage! do not change! you'll regret it afterwards. //you've been warned.
		   {
		         errorCode = GAInAppPurchase.noButton;
		   }
		   
		   this._transactionFailure(errorCode);
		}
	},
	
	addToCompletedTransactions: function(transactionId) {
		this._completedTransactions[transactionId] = "1";
		this._txnStorage.setItem(COMPLETED_TXN_KEY, JSON.stringify(this._completedTransactions));
	},
	
	hasBeenCompleted: function(transactionId) {
		if (this._completedTransactions != null && this._completedTransactions.length > 0) {
			var val = this._completedTransactions[transactionId];
			if (typeof val != 'undefined' && val == "1") {
				return true;
			}
		}
		return false;
	},
	
	_openTransactionCallBack: function(error,transaction) {		
		if(!error) {
			if(transaction) {
				this._notifyGame();
				this.addToCompletedTransactions(this._confirmedTransactionId);
				Bank.Debit.closeTransaction(this._confirmedTransactionId, this._closeTransactionCallBack.bind(this));
				UIFactory.showProgressHUD(this._msg._completingTransaction);
			} else {
				this._transactionFailure(GAInAppPurchase.miscError);
			}
		} else {
			//display alert box
			this._transactionFailure(error.errorCode);
		}
	},

	_closeTransactionCallBack: function(error, transaction) {
		if(!error) {
			if(transaction) {
				this._completeTransaction();
			} else {
				this._transactionFailure(GAInAppPurchase.miscError);
			}
		}
		else {
			this._transactionFailure(GAInAppPurchase.miscError);
		}
	},
	
	_transactionFailure: function(errorCode)
	{
		UIFactory.hideProgressHUD();
		UIFactory.showProgressHUD(this._msg._cancellingTransaction);
		var finalError = new Object();
		finalError.code = errorCode;
		finalError.showAlert = true;
		switch(errorCode) {
			case GAInAppPurchase.noButton:
				finalError.description = this._msg._noButtonPressed;
				break;
			case GAInAppPurchase.noFunds:
				finalError.description = this._msg._insufficentFunds;
				finalError.showAlert = false;
				break;
			case GAInAppPurchase.badServer:
				finalError.description = this._msg._serverUnauth;
				break;
			case GAInAppPurchase.noItem:
				finalError.description = this._msg._itemNotFound;
				break;
			default:
				finalError.description = this._msg._networkError;
				break;
		}
		this._cancelTransaction(finalError);
	},
	
	_cancelTransaction: function(anErrorMsg) {
		this._errorMsg = anErrorMsg;
        if(this._confirmedTransactionId) {
            Bank.Debit.cancelTransaction(this._confirmedTransactionId,this._cancelTransactionCallback.bind(this));
        }
        else {
            this._cancelTransactionCallback();
        }
	},
	
	_cancelTransactionCallback: function(error, transaction) {
		if(!transaction || this._retryCount <= 0) {
			this._completeTransaction();
		}
		else {
			this._retryCount = this._retryCount - 1;
			Bank.Debit.cancelTransaction(this._confirmedTransactionId, this._cancelTransactionCallback.bind(this));
		}
	},
	
	_notifyGame: function() {
		/*if(this._errorMsg) {
			this._callBack(this._errorMsg);
		}
		else {
			this._callBack();
		}*/	
		this._callBack();
	},

	_completeTransaction: function() {
		UIFactory.hideProgressHUD();
		UIFactory.hideBlockView();
		if(this._errorMsg) {
			this._callBack(this._errorMsg);
		}
		/* else {
			this._callBack();
		}*/
		setTimeout(this._initStatusVars.bind(this), 100);
	},
	
	_getRequestParams: function(currencyType, amount, signature) {
		var params = GACommonUtils.getServerParams();
		delete params[GA_UDID_PARAM_KEY];
		params["type"] = "userkey";
		params["snuid"] = GAConfigurations.getUserId();
		params["currencyType"] = currencyType;
		params["currency"] = amount;
		params["signature"] = signature;
		var queryString = [];
		for (var param in params) {
			var paramComponents = [];
			paramComponents.push(param);
			paramComponents.push("=");
			paramComponents.push(params[param]);
			queryString.push(paramComponents.join(""));
		}
		return queryString.join("&");
	},
	
	_getSignature: function(currencyType, amount) {
		var components = [];
		components.push(GAConfigurations.getUserId());
		components.push(currencyType);
		components.push(amount);
		components.push(GAConfigurations.getGameVersion());
		components.push(GAGameLoader.getResponseObject().getGame());
		components.push(GAINAPP_AUTHENTICATION_KEY);
		var str = components.join("");
		return Core.SHA1.hex_sha1(str);
	},
	
	_getRequestUrl: function(currencyType, amount, signature) {
		var requestUrl = [];
		requestUrl.push(GAConfigurations.getURL());
		requestUrl.push("inAppPurchased?");
		requestUrl.push(encodeURI(this._getRequestParams(currencyType, amount, signature)));
		return requestUrl.join("");
	},

    /* private delegate callbacks start */

	webFetchSuccess : function(webFetcher, responseData){
		if(webFetcher != null){
			webFetcher.destroy();
			webFetcher = null;
		}
		console.log("InApp Purchase: Server notification SUCCESSFUL!");
	},
	
	webFetchFailure : function(webFetcher, errorCode){
		if(webFetcher != null){
			webFetcher.destroy();
			webFetcher = null;
		}
		console.log("InApp Purchase: Server notification FAILED! Error code: " + errorCode);
	},
	
    /* private delegate callbacks end */
    
	destroy: function() {
		this._msg._contactingServer = null;
		this._msg._networkError = null;
		this._msg._InAppComment = null;
		this._msg._authorizingPurchase = null;
		this._msg._completingTransaction = null;
		this._msg._cancellingTransaction = null;
		this._msg._itemNotFound = null;
		this._msg._insufficentFunds = null;
		this._msg._noButtonPressed = null;
		this._msg._serverUnauth = null;
		this._msg = null;
		this._confirmedTransactionId = null;
		this._callBack = null;
		this._errorMsg = null;
		this._retryCount = 0;
		this._quantity = 0;
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/ngAPI/GALocalization/GALocalizationHandler'] = function(){var exports = $MODULE_REGISTRY['Code/ngAPI/GALocalization/GALocalizationHandler'] || {}; $MODULE_REGISTRY['Code/ngAPI/GALocalization/GALocalizationHandler'] = exports; /**
 * Filename: GALocalizationHandler.js
 * Author: Wasay Abbasi
 * Date Created: 2011-04-20
 * Date Updated: 2011-04-20
*/

exports.GALocalizationHandler = Core.Class.singleton({
    classname: 'GALocalizationHandler',
    initialize: function() {
    	//console.log("----- GALocalizationHandler initialize-----");
    },
    reverseGameLanguage: function() {
    	var lang = Core.Capabilities.getLanguage();
        this.reversed = 1;   
      	if(lang == 'en') {
   	     	Core.Localization.setLanguage('ja');
        }
        else {
	    	Core.Localization.setLanguage('en');
        }
    },
    setGameLanguage: function(language) {
    	this.language = language;
    	Core.Localization.setLanguage(language);
    },
    getLocalizedString: function(key) {
        return Core.Localization.getString(key);
    },
	getCurrentSetLanguage: function() {
    	if(this.language) {
    		return this.language;
    	}
    	var lang = Core.Capabilities.getLanguage();
        if(this.reversed == 1) {
            if(lang == 'en') {
                return 'ja';
            }
            else {
                return 'en';
            }
        }
        else {
            return lang;
        }
    },
	
	getRelativeString: function(stringValue ,replaceValueArray) {
    	for(var i=0;i<replaceValueArray.length ;i++) {
    		stringValue = stringValue.replace("%val"+(i+1) ,replaceValueArray[i]);
    	}
    	return stringValue;
    }
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/ngAPI/GAResources/GAResourceDownloader'] = function(){var exports = $MODULE_REGISTRY['Code/ngAPI/GAResources/GAResourceDownloader'] || {}; $MODULE_REGISTRY['Code/ngAPI/GAResources/GAResourceDownloader'] = exports; 
exports.GAResourceDownloader = Core.Class.subclass({
	
	initialize: function(storeObject, successCb, failureCb, resourceType, useCache) {
		this._useCache = (typeof useCache == 'undefined') ? true : useCache;
		this._resourceType = resourceType;		
		this._storeObject = storeObject;
		this._storeObjectKey = GACommonUtils.getKeyForStoreObject(this._storeObject);		
		this._resource = GAResourceUtils.getResourceOfType(storeObject, resourceType);
		this._failureCb = failureCb;
		this._tag = null;
		if (typeof this._resource != 'undefined' && this._resource != null) {
			this._successCb = successCb;
			this._savePath = GAResourceUtils.getResourceSavePath(storeObject, this._resource);
			this._keyPath = this._savePath + this._resource.type + ".key";
			//if (this._resource.filetype == "zip") {
				//this._downloadPath = this.constructPath("./Content/downloads/");
			//}
			//else {
				this._downloadPath = this.constructPath(this._savePath);
			//}
			this._fileDownloder = null;
		}
		else {
			this._failureCb(kGAStatusType.kGAResourceObjectNil, "Store object does not have a resource of type: " + resourceType,this);
		}
	},
	
	constructPath: function(basePath) {
		var path = [];
		path.push(basePath);
		var fileName = (this._resource.type == GAResourceType.kThumb) ? "thumb" : this._resource.name;
		path.push(fileName);
		path.push(".");
		path.push(this._resource.filetype);
		return path.join("");
	},
	
	startDownloading: function() {
		if (typeof this._resource != 'undefined' && this._resource != null) {
			if (this._useCache == true) {
				if (GAGameLoader.isResourceAvailable(this._storeObjectKey, this._resourceType) == false) {
					Storage.FileSystem.readFile(this._keyPath, false, this.keyCheck.bind(this));
				}
				else {					
					if(this._successCb)
						this._successCb(this._savePath, true,this);
				}
			}
			else {
				Storage.FileSystem.readFile(this._keyPath, false, this.keyCheck.bind(this));
			}
		}
	},
	
	keyCheck: function(error, contents) {
		if (error || (!error && contents == null)) { //Key is probably not present or invalid, so download this resource
			this.downloadResource();
		}
		else {
			if (contents != this._resource.id) {	// keys do not match, so download this resource
				this.downloadResource();
			}
			else {	// keys match, so no need to download
				GAGameLoader.addToDownloadedResources(this._storeObjectKey, this._resourceType);
				if(this._successCb)
					this._successCb(this._savePath, false,this);
			}
		}
	},
	
	getPathForObject: function(storeObject) {
		var path = [];
		if (storeObject.objectType == "store") {
			path.push(storeObject.id);
		}
		else if (storeObject.objectType == "cat") {
			path.push(storeObject.parent.id);
			path.push(storeObject.id);
		}
		else if (storeObject.objectType == "item") {
			path.push(storeObject.parent.parent.id);
			path.push(storeObject.parent.id);
			path.push(storeObject.id);
		}
		return path.join("/");
	},
	
	getUrl: function() {
		var storeHandler = GAGameLoader.getStoreHandler();
		var url = [];
		url.push(GAGameLoader.getResponseObject().getStoreServer());
		/*
		 * The logic for constructing the URL is different for QA users because of the following reason...
		 * In case of QA users, the server store url contains a vmart base url instead of GAE. In vmart, when you fetch
		 * a resource (either thumb or default_zip) there is an internal redirection that happens on the server side.
		 * ngCore's DownloadFile is not capable of handling url redirections and therefore fails. As a word around, we
		 * are instead fetching the resource directly from the "redirected url".
		 * TODO: Whenever ngCore's DownloadFile starts supporting url redirection, we should revise this logic to simply things!  
		 */
		if (GAGameLoader.getResponseObject().isQAUser()) {
			var parts = [];
			parts.push("clientmedia/uploaded_images");
			parts.push(storeHandler.getCompanyId());
			parts.push(storeHandler.getGameId());
			parts.push(this.getPathForObject(this._storeObject));
			parts.push(this._resource.id);
			url.push(parts.join("/"));
			url.push(".");
			url.push(this._resource.filetype);
		}
		else {
			 url.push("image?key=");
			 url.push(this._resource.id);	
		}
		return url.join("");
	},
	
	downloadResource: function() {
		var url = this.getUrl();
		url = encodeURI(url);
		//console.log("Downloading resource from: " + url);
		this._fileDownloader = new GAFileDownloader(this._downloadPath, 'GET', url, null, this);
		this._fileDownloader.startDownloading();
	},

	onDownloadSuccess: function(fileDownloader, fileSignature){
		try {
			if( fileDownloader != null) {
				fileDownloader.destroy();
				fileDownloader = null;
			}
			if (this._resource.filetype == "zip") {
				Storage.FileSystem.decompressFile(this._downloadPath, this._savePath, true, this.decompressCompleted.bind(this));
			}
			else {
				this.updateKey();
			}
		}
		catch(exception){
			this._failureCb(kGAStatusType.kGAZipExtractionFailedWithUnknownException, "Unzipping failed",this);
		}
	},
	
	onDownloadFailure: function(fileDownloader, errorCode) {
		if( fileDownloader != null){
			fileDownloader.destroy();
			fileDownloader = null;
		}
		this._failureCb(kGAStatusType.kGAResourceDownloadingFailed, errorCode,this);
	},
	
	decompressCompleted : function(error, files){
		var fileName = "";
		if(error == ""){
			Storage.FileSystem.deleteFile(this._downloadPath);
			Storage.FileSystem.writeFile(this._keyPath, this._resource.id, false, this.updateKey.bind(this));
		}
		else{
			this._failureCb(kGAStatusType.kGAZipExtractionFailedWithUnknownException, error,this);
		}
	},
	
	updateKey: function() {
		Storage.FileSystem.writeFile(this._keyPath, this._resource.id, false, this.keyUpdated.bind(this));		
	},
	
	keyUpdated: function() {
        GAGameLoader.addToDownloadedResources(this._storeObjectKey, this._resourceType);		
        
        if(this._successCb) {
			this._successCb(this._savePath, true,this);
        }
	},
	
	setTag: function(tag) {
		this._tag = tag;
	},
	
	getTag : function () {
		return this._tag;
	},
	
	destroy: function() {
		this._storeObject = null;
		this._failureCb = null;
		if (typeof this._resource != 'undefined' && this._resource != null) {
			this._resource = null;
			this._successCb = null;
			this._resourceType = null;
			this._savePath = null;
			this._keyPath = null;
			this._downloadPath = null;
			if( this._fileDownloader != null){
				this._fileDownloader.invalidate();
				this._fileDownloader.destroy();
				this._fileDownloader = null;
			}
		}
	}
	
	
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/ngAPI/GAResources/GAResourceUtils'] = function(){var exports = $MODULE_REGISTRY['Code/ngAPI/GAResources/GAResourceUtils'] || {}; $MODULE_REGISTRY['Code/ngAPI/GAResources/GAResourceUtils'] = exports; 
exports.GAResourceUtils = Core.Class.singleton ({
	
	getResourceOfType: function(storeObject, resourceType) {
		if (storeObject == null) {
			return null;
		}
		if (typeof storeObject.resources != 'undefined') {
			return storeObject.resources[resourceType];
		}
		return null;
	},
	
	getPathForObject: function(storeObject) {
		var path = [];
		if (storeObject.objectType == "store") {
			path.push(storeObject.visible_id);
		}
		else if (storeObject.objectType == "cat") {
			path.push(storeObject.parent.visible_id);
			path.push(storeObject.visible_id);
		}
		else if (storeObject.objectType == "item") {
			path.push(storeObject.parent.parent.visible_id);
			path.push(storeObject.parent.visible_id);
			path.push(storeObject.visible_id);
		}
		return path.join("/");
	},
	
	getResourceSavePath: function(storeObject, resource) {
		if (resource != null) {
			var path = [];
			path.push(GAConfigurations.getResourcesBasePath());
			path.push("/");
			path.push(GAResourceUtils.getPathForObject(storeObject));
			path.push("/");
			if (resource.type == GAResourceType.kDetail) {
				path.push("default_zip/");
			}
			return path.join("");
		}
		return null;
	}
	
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/ngAPI/GAResources/GAStoreIcon'] = function(){var exports = $MODULE_REGISTRY['Code/ngAPI/GAResources/GAStoreIcon'] || {}; $MODULE_REGISTRY['Code/ngAPI/GAResources/GAStoreIcon'] = exports; 
exports.GAStoreIcon = UI.View.subclass ({
	className: "GAStoreIcon",
	
	setup: function(storeObject) {
		this._storeObject = storeObject;
		if (this._storeObject != null) {
			this._resource = GAResourceUtils.getResourceOfType(storeObject, GAResourceType.kThumb);
			if (typeof this._resource != 'undefined' && this._resource != null) {
				this._isLoading = false;
				this._iconDownloader = null;
				this._iconImage = null;
				this._spinner = null;
				return true;
			}
			else {
				console.log("GAStoreIcon: Store object does not have a resource of type: Thumb");
				return false;
			}
		}
		else {
			console.log("GAStoreIcon: Store object found null, not loading any icon");
			return false;
		}
	},
	
	load: function(storeObject) {
		this.invalidate();
		var setupSuccessful = this.setup(storeObject);
		if (setupSuccessful == true) {
			if (this._isLoading == true) {
				return;
			}
			else {
				this.resetView();
				this._spinner = new UI.Spinner();
				var frame = this.getFrame();
				this._spinner.setFrame([(frame[2] - 32) / 2, (frame[3] - 32) / 2, 32, 32]);
				this.addChild(this._spinner);
				this._isLoading = true;
				this._iconDownloader = new GAResourceDownloader(this._storeObject, this.resourceDownloadingSuccessful.bind(this),
				this.resourceDownloadingFailed.bind(this), GAResourceType.kThumb);
				this._iconDownloader.startDownloading();
			}
		}
	},

	resourceDownloadingSuccessful: function(savePath) {
		this._isLoading = false;
		this._iconImage = new UI.Image();
		var filePath = savePath + "thumb." + this._resource.filetype;
		this._iconImage.setImage(filePath);
		var frame = this.getFrame();
		this._iconImage.setFrame([0, 0, frame[2], frame[3]]);
		this._iconImage.setImageFit(UI.ViewGeometry.FitModes.Stretch);
		this.addChild(this._iconImage);
		this.removeSpinner();
	},
	
	resourceDownloadingFailed: function(errorCode, errorMsg) {
		this.removeSpinner();
	},
	
	resetView: function() {
		if (this._iconDownloader != null) {
			this._iconDownloader.destroy();
			this._iconDownloader = null;
		}
		if (this._iconImage != null) {
			this.removeChild(this._iconImage);
			this._iconImage.destroy();
			this._iconImage = null;
		}
		this._isLoading = false;
	},
	
	removeSpinner: function() {
		if (this._spinner != null){
			this.removeChild(this._spinner);
			this._spinner.destroy();
			this._spinner = null;	
		}
	},
	
	invalidate: function() {
		this.removeSpinner();
		this.resetView();
		this._storeObject = null;
		this._resource = null;
	},
	
	destroy: function($super) {
		this.invalidate();
		$super();
	}

});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/ngAPI/GASprite/GASprite'] = function(){var exports = $MODULE_REGISTRY['Code/ngAPI/GASprite/GASprite'] || {}; $MODULE_REGISTRY['Code/ngAPI/GASprite/GASprite'] = exports; 
exports.GASprite = GL2.Node.subclass ({
		initialize : function(path, frame, anchor) {
		this._frame = frame;
		this._anchor = anchor;
		this._path = path;
  		this._sprite = new GL2.Sprite();
		this._sprite.setImage(this._path, frame, anchor);

		this.setup();
		
		this._showBoundaries = false;
		this._drawing = null;
	},
	
	boundariesShown: function() {
		return this._showBoundaries;
	},
	
	showBoundaries: function(flag) {
		if (this._drawing != null) {
			if (flag == false) {
				this._drawing.setVisible(false);
			}
			else {
				this.drawBoundaries();
				this._drawing.setVisible(true);
			}
		}
		this._showBoundaries = flag;
	},
	
	drawBoundaries: function() {
		if (this._drawing == null) {
			this._drawing = new GL2.Primitive();
			this._drawing.setType(3);
			this._sprite.addChild(this._drawing);
		}
		var totalVertices = 2 * this._totalPoints;
		for(var i=0; i < this._totalPoints; i++) {
			var vertex1 = new Core.Point(this._points[i].x, this._points[i].y);
			var vertex2 = new Core.Point(this._points[(i+1) % this._totalPoints].x, this._points[(i+1) % this._totalPoints].y);
			if(this._drawing.getVertexCount() < totalVertices) {
				//console.log("x1:" + vertex1.getX() + ", y1:" + vertex1.getY() + ", x2:" + vertex2.getX() + ", y2:" + vertex2.getY());
				this._drawing.pushVertex(new GL2.Primitive.Vertex(vertex1, [0, 0], [1, 0, 0]));
				this._drawing.pushVertex(new GL2.Primitive.Vertex(vertex2, [0, 0], [1, 0, 0]));
			}
			else {
				this._drawing.setVertex(2*i, new GL2.Primitive.Vertex(vertex1, [0, 0], [1, 0, 0]));
				this._drawing.setVertex(2*i+1, new GL2.Primitive.Vertex(vertex2, [0, 0], [1, 0, 0]));
			}
		}
	},
	
	getNode : function () {
		return this._sprite;
	},
	
	setup: function() {
		Storage.FileSystem.readFile(this._path + ".json", this.readComplete.bind(this));
	},
	
	readComplete: function(error, contents) {
		if (!error && contents != null) {
			this._points = eval("(" + contents + ")");
			this._totalPoints = this._points.length;
			
			var factorX = this._frame[0] * this._anchor[0];
			var factorY = this._frame[1] * this._anchor[1];
			var imageHeight = this._frame[1];
			for (var i = 0; i < this._totalPoints; i++) {
				var point = this._points[i];
				point.x = point.x - factorX;
				point.y = imageHeight - point.y - factorY;
			}
			
			
			if (this._showBoundaries == true) {
				this.drawBoundaries();
			}
		}
		else {
			console.log("GASprite: ERROR READING JSON, ERROR: " + error + ", PATH: " + this._path);
		}
	},
	
	isTouched: function(location) {
		location = this._sprite.screenToLocal(location);
		var i = 0;
		var j = this._totalPoints - 1;
		var x = location.getX();
		var y = location.getY();
		var oddNodes = false; 
		
		for (i = 0; i < this._totalPoints; i++) {
			var pointi = this._points[i];
			var pointj = this._points[j];
			if ( (pointi.y < y && pointj.y >= y) || (pointj.y < y && pointi.y >= y) ) {
				if ( pointi.x + (y - pointi.y) / (pointj.y - pointi.y) * (pointj.x - pointi.x) < x ) {
					oddNodes = !oddNodes;
				}
			}
			j = i;
		}
		return oddNodes;
	},
	
	destroy : function () {
		if (typeof this._drawing != 'undefined') {
			this._drawing.destroy();
			this._drawing = null;
		}
		this._sprite.destroy();
		delete this._points;
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/ngAPI/GAIsoMetricView/GAIsometricView'] = function(){var exports = $MODULE_REGISTRY['Code/ngAPI/GAIsoMetricView/GAIsometricView'] || {}; $MODULE_REGISTRY['Code/ngAPI/GAIsoMetricView/GAIsometricView'] = exports; //<copyright file="IsometricView.js" company="GameViewStudios">
//Copyright (c) 2010, 2011 All Right Reserved, http://www.gameviewstudios.com/
//</copyright>
//<added in version>3.0</added in version>
//<author>xyz</author>
//<email>xyz@xyz.org</email>
//<created date>2008-06-10</created date>
//<summary>Contains a base, abstract class for an �..</summary>

//var DIAMOND_LAYER_MARGIN_HEIGHT = 300;
exports.GAIsometricView = Core.MessageListener.subclass({
	classname : 'GAIsometricView',

	initialize: function() {
		this._countExpanded = 0;
		try{
			var w = Core.Capabilities.getScreenWidth();
			var h = Core.Capabilities.getScreenHeight();
			var multiArray = new Array();
			this._multiArray = multiArray;
			this._diffForPinch = 0;
			this._lastDistance = 0;
			this._isPanningDisabled = false;
			this._isPinchingDisabled = false;
			this._backgroundPatch = [];
			this._gridObjects = new Array(GAIsoMetricConfigurations.getMaxGridRows());
			var maxRows = GAIsoMetricConfigurations.getMaxGridRows()
			for( var i = maxRows; i--;) {

				this._gridObjects[i] = new Array(maxRows);
			}

			var gridSizeX = GAIsoMetricConfigurations.getGridSize().getX();
			var gridSizeY = GAIsoMetricConfigurations.getGridSize().getY();

			var width = gridSizeX*GAIsoMetricConfigurations.USERLAYER_CELL_WIDTH*2 + GAIsoMetricConfigurations.DIAMOND_LAYER_MARGIN_WIDTH*2;
			var height = gridSizeY*GAIsoMetricConfigurations.USERLAYER_CELL_HEIGHT*2 + GAIsoMetricConfigurations.DIAMOND_LAYER_MARGIN_HEIGHT*2;


			this._width = width;
			this._height = height;

			var motherSprite = new GL2.Sprite();

			motherSprite.setImage(GAIsoMetricConfigurations.getBgPath(), [width, height], [.5, .5]);
			//console.log('Logger: grid patch dimensions: ('+GAIsoMetricConfigurations.USERLAYER_CELL_WIDTH+', '+GAIsoMetricConfigurations.USERLAYER_CELL_HEIGHT+')');
			this.addChild(motherSprite);

			this._motherSprite = motherSprite;

			motherSprite.setPosition([h/2,w/2]);

			this._target = new GL2.TouchTarget();
			this._target.setAnchor(0.5,0.5);
			this._target.setSize(width,height);
			this._target.getTouchEmitter().addListener(this, this.onTouch);
			this._target.setDepth(100);
			motherSprite.addChild(this._target);
			var gSize = GAIsoMetricConfigurations.getGridSize();
			for(var j = 0; j < gSize.getY() ; j = j + 4) {
				for(var i = 0; i < gSize.getX(); i = i + 4) {
					var patchSprite = new GL2.Sprite();
					patchSprite.setDepth(2);
					patchSprite.setAlpha(GAIsoMetricConfigurations.getPatchTransparency());
					patchSprite.setImage(GAIsoMetricConfigurations.getPatchPath(), [GAIsoMetricConfigurations.getPatchWidth(), GAIsoMetricConfigurations.getPatchHeight()], [0.5, 1]);
					var tempVector = new Core.Vector(i,j);

					tempVector = this.convertGridPointToLayerPoint(tempVector);

					patchSprite.setPosition(tempVector);
					this._backgroundPatch.push(patchSprite);
					this._motherSprite.addChild(patchSprite);			                
				}
			}
		}
		catch(err){
			console.log("Error description for method initialize in class IsometricView: "+err.message);
		}
	},
	
	getView: function() {
		return this._motherSprite;
	},

	addChild: function(node, zOrder){
		try{
			node.setDepth(zOrder);
			this._motherSprite.addChild(node);
		}
		catch(err){
			console.log("Error description for method addChild in class IsometricView: "+err.message);
		}
	},

	expandView : function (increaseBy){
		var gSize = GAIsoMetricConfigurations.getGridSize();
		var factor = increaseBy;
		increaseBy.setX((4*increaseBy.getX()) + gSize.getX());
		increaseBy.setY((4*increaseBy.getY()) + gSize.getY());
		if(increaseBy.getX() < GAIsoMetricConfigurations.getMaxGridRows()){		    		

			this._diffForPinch = 0;
			this._lastDistance = 0;
			this._isPanningDisabled = false;
			this._isPinchingDisabled = false;

			var child;
			while(child = this._backgroundPatch.pop()){
				this._motherSprite.removeChild(child);
			}

			var gridSizeX = increaseBy.getX();
			var gridSizeY = increaseBy.getY();

			var width = gridSizeX*GAIsoMetricConfigurations.USERLAYER_CELL_WIDTH*2 + GAIsoMetricConfigurations.DIAMOND_LAYER_MARGIN_WIDTH*2;
			var height = (gridSizeY * GAIsoMetricConfigurations.USERLAYER_CELL_HEIGHT * 2) + (GAIsoMetricConfigurations.DIAMOND_LAYER_MARGIN_HEIGHT*2);

			this._width = width;
			this._height = height;

			this._motherSprite.setImage(GAIsoMetricConfigurations.getBgPath(), [width, height], [.5, .5]);

			this._target.setSize(width,height);


			GAIsoMetricConfigurations.setGridSize(increaseBy);

			for(var i = 0; i < increaseBy.getX(); i = i + 4) {
				for(var j = 0; j < increaseBy.getY() ; j = j + 4) {
					var patchSprite = new GL2.Sprite();
					patchSprite.setDepth(2);
					patchSprite.setAlpha(GAIsoMetricConfigurations.getPatchTransparency());
					patchSprite.setImage(GAIsoMetricConfigurations.getPatchPath(), [GAIsoMetricConfigurations.getPatchWidth(), GAIsoMetricConfigurations.getPatchHeight()], [0.5, 1]);
					var tempVector = new Core.Vector(i,j);

					tempVector = this.convertGridPointToLayerPoint(tempVector);

					patchSprite.setPosition(tempVector);
					this._backgroundPatch.push(patchSprite);
					this._motherSprite.addChild(patchSprite);
				}
			}

			for (var i = gSize.getX() ; i-- ;){
				for (var j = gSize.getY() ; j-- ; ){
					if(this._gridObjects[i][j] != null && this._gridObjects[i][j] != undefined){
						var gL = this._gridObjects[i][j].getGridLocation();
						var tempVector = new Core.Vector(gL.getX(),gL.getY());
						tempVector = this.convertGridPointToLayerPoint(tempVector);
						this._gridObjects[i][j].setObjectPosition(tempVector);
					}
				}
			}
		}
	},
	removeChild: function(node){
		try{
			this._motherSprite.removeChild(node);
		}
		catch(err){
			console.log("Error description for method removeChild in class IsometricView: "+err.message);
		}
	},

	getMotherSprite: function(){
		return this._motherSprite;
	},
	convertGridPointToLayerPoint: function(posVector) {

		var newVector = new Core.Vector();
		newVector.setX(posVector.getX() *(GAIsoMetricConfigurations.USERLAYER_CELL_WIDTH + GAIsoMetricConfigurations.getCellWidthOffset()));
		newVector.setY(posVector.getY() *(GAIsoMetricConfigurations.USERLAYER_CELL_HEIGHT + GAIsoMetricConfigurations.getCellHeightOffset()));



		var xShear = -0.73;
		newVector.setX(newVector.getX() + (newVector.getY()*xShear));



		var x = newVector.getX() * 0.894427191000276 - newVector.getY() * 0.447213595499237;
		var y = newVector.getX() * 0.447213595499237 + newVector.getY() * 0.894427191000276;	


		var gridSize = GAIsoMetricConfigurations.getGridSize();

		x = x + gridSize.getX()*GAIsoMetricConfigurations.USERLAYER_CELL_WIDTH;


		x = x + GAIsoMetricConfigurations.DIAMOND_LAYER_MARGIN_WIDTH;
		y = y + GAIsoMetricConfigurations.DIAMOND_LAYER_MARGIN_HEIGHT;


		x = x - this._width/2;
		y = this._height - y - (this._height/2);

		var newVector = new Core.Vector(x,y);

//		console.log("x,y = " + x + ", " + y );
		return newVector;



	},

	convertLayerPointToGridPoint: function(point)
	{

		var gridSize = GAIsoMetricConfigurations.getGridSize();

		point.setX(point.getX() - gridSize.getX()*GAIsoMetricConfigurations.USERLAYER_CELL_WIDTH);

		point.setX(point.getX() - GAIsoMetricConfigurations.DIAMOND_LAYER_MARGIN_WIDTH);
		point.setY(point.getY() - GAIsoMetricConfigurations.DIAMOND_LAYER_MARGIN_HEIGHT);

		var x = point.getX() * 0.894427191000276 - point.getY() * (-0.447213595499237);
		var y = point.getX() * (-0.447213595499237) + point.getY() * 0.894427191000276;	

		var xShear = 0.73;
		x = x + y*xShear;

		x = x / (GAIsoMetricConfigurations.USERLAYER_CELL_WIDTH + GAIsoMetricConfigurations.getCellWidthOffset());
		y = y / (GAIsoMetricConfigurations.USERLAYER_CELL_HEIGHT + GAIsoMetricConfigurations.getCellHeightOffset());

		var resultVector = new Core.Vector(Math.floor(x),Math.floor(y));
		return resultVector;
	},

	olTouchBegan: function(touch)
	{

	},

	touchBegan: function(touch)
	{
		try{
			this.olTouchBegan(touch);

			this._multiArray[this._multiArray.length] = touch;

			if(this._multiArray.length == 1)// save this one for offset
			{
				var panningOffset = new Core.Vector();;
				panningOffset.setX(this._motherSprite.getPosition().getX() - this._multiArray[0].getPosition().getX());
				panningOffset.setY(this._motherSprite.getPosition().getY() - this._multiArray[0].getPosition().getY());
				this._panningOffset = panningOffset;
			}

		}
		catch(err){
			console.log("Error description for method touchBegan in class IsometricView: "+err.message);
		}
	},

	olTouchMoved: function(touch)
	{

	},

	touchMoved: function(touch)
	{
		try {
			this.olTouchMoved(touch, this._multiArray.length);
			if (this._isPanningDisabled){
				return;
			}
			var arrLength = this._multiArray.length;
			for(var i = arrLength ; i--;) {
				var touch1 = this._multiArray[i];
				if(touch1.getId() == touch.getId()) {
					this._multiArray[i] = touch;
				}
			}

			this.multiTouch(this._multiArray);


		}
		catch(err){
			console.log("Error description for method touchMoved in class IsometricView: "+err.message);
		}
	},

	olTouchEnded: function(touch)
	{

	},

	touchEnded: function(touch)
	{
		try{
			this.olTouchEnded(touch);
			//if (this._isPanningDisabled){
			//return;
			//}		        

			var newArray = new Array();
			var arrLength = this._multiArray.length;
			for(var i = arrLength; i--; ) {
				if(this._multiArray[i].getId() != touch.getId()) {
					newArray[newArray.length] = this._multiArray[i];
				}
				else
				{
				}
			}
			this._multiArray = newArray;

			if(this._multiArray.length == 0)//reset everything
			{
				this._diffForPinch = 0;
				this._lastDistance = 0;
			}else if (this._multiArray.length == 1){
				this._panningOffset.setX(this._motherSprite.getPosition().getX() - this._multiArray[0].getPosition().getX());
				this._panningOffset.setY(this._motherSprite.getPosition().getY() - this._multiArray[0].getPosition().getY());
			}
			this.conversionToLayer(touch);

		}
		catch(err){
			console.log("Error description for method touchEnded in class IsometricView: "+err.message);
		}

	},

	onTouch: function(touch)
	{
		//this.zoom();
		try{
			switch(touch.getAction())
			{
			case touch.Action.Start:

				this.touchBegan(touch);
				return true;

			case touch.Action.End:
				this.touchEnded(touch);
				break;


			case touch.Action.Move:
				this.touchMoved(touch);
				break;
			}

		}
		catch(err){
			console.log("Error description for method onTouch in class IsometricView: "+err.message);
		}
	},

	conversionToLayer: function(touch)
	{
		var posVector = new Core.Vector(touch.getPosition().getX(),touch.getPosition().getY());
		posVector = this._motherSprite.screenToLocal(posVector);
		posVector = this.adjustAnchorPoint(posVector);
		posVector = this.convertLayerPointToGridPoint(posVector);
		return posVector;
	},
	adjustAnchorPoint: function(posVector) {
		return new Core.Vector(posVector.getX()+this._width/2, -posVector.getY()+this._height/2);
	},

	multiTouch: function(fullArray)
	{   
		try{

			if(fullArray.length == 2) // it's a pinch
			{
				var touch1 = fullArray[0];
				var touch2 = fullArray[1];

				var distance = 0;

				var location1 = touch1.getPosition();
				var location2 = touch2.getPosition();

				distance = Math.sqrt( Math.pow(location1.getX()-location2.getX(),2) +  Math.pow(location1.getY()-location2.getY(),2));

				var diff = this._lastDistance - distance;

				this._lastDistance = distance;

				this._diffForPinch += diff;
				if(Math.abs(this._diffForPinch) >2) {
					var currentScale = this._motherSprite.getScale();
					var scaleFactor = .05; // why hard coded value??
 					if(this._diffForPinch <0) {

						var zoomIn = GAIsoMetricConfigurations.getZoomInFactor();

						if(currentScale.getX() <= zoomIn) {
							this._motherSprite.setScale(currentScale.getX() + scaleFactor,currentScale.getY()+scaleFactor);
						}
					}
					else {
						var zoomOut = GAIsoMetricConfigurations.getZoomOutFactor();
						var h = GACommonUtils.getScreenHeight();
						var w = GACommonUtils.getScreenWidth();
						var fact = w > h ? w : h;
						var div = w > h ? this._width : this._height;
						var minScale = (fact/div);
						if(div > fact){
							zoomOut = minScale;
						}
						if(currentScale.getX() - scaleFactor >= zoomOut) {
							this._motherSprite.setScale(currentScale.getX() - scaleFactor,currentScale.getY() - scaleFactor);
						}
					}
					this._diffForPinch = 0;

					/////////

					var offsetAdjustedVector = this._motherSprite.getPosition();

					var currScale = this._motherSprite.getScale().getX();
					if(offsetAdjustedVector.getX() > (this._width/2.0)*currScale)
					{
						offsetAdjustedVector.setX((this._width/2.0)*currScale);
						//NgLogE("limit");
					}
					else if(offsetAdjustedVector.getX() + ((this._width/2)*currScale) <  Core.Capabilities.getScreenHeight()){
						offsetAdjustedVector.setX(Core.Capabilities.getScreenHeight() - (this._width/2)*currScale);
					}
					if(offsetAdjustedVector.getY() > (this._height/2.0)*currScale)
					{
						offsetAdjustedVector.setY((this._height/2.0)*currScale);
						//NgLogE("limit");
					}
					else if(offsetAdjustedVector.getY() + ((this._height/2)*currScale) < Core.Capabilities.getScreenWidth()){
						offsetAdjustedVector.setY(Core.Capabilities.getScreenWidth() - (this._height/2)*currScale);
					}
					var sampleVect = new Core.Vector(this._motherSprite.getPosition().getX() + ((this._width/2.0)*currScale),this._motherSprite.getPosition().getY() + ((this._height/2.0)*currScale));

					var result = this._motherSprite.getParent().localToScreen(sampleVect);

					this._motherSprite.setPosition(offsetAdjustedVector);
					//////////

				}
			}
			else if(fullArray.length == 1) // it's panning
			{

				var offsetAdjustedVector = new Core.Vector();
				offsetAdjustedVector.setX(this._multiArray[0].getPosition().getX() + this._panningOffset.getX());
				offsetAdjustedVector.setY(this._multiArray[0].getPosition().getY() + this._panningOffset.getY());
				//this._motherSprite.setPosition(offsetAdjustedVector);

				var currScale = this._motherSprite.getScale().getX();
				if(offsetAdjustedVector.getX() > (this._width/2.0)*currScale)
				{
					offsetAdjustedVector.setX((this._width/2.0)*currScale);
				}
				else if(offsetAdjustedVector.getX() + ((this._width/2)*currScale) <  Core.Capabilities.getScreenHeight()){
					offsetAdjustedVector.setX(Core.Capabilities.getScreenHeight() - (this._width/2)*currScale);
				}

				if(offsetAdjustedVector.getY() > (this._height/2.0)*currScale)
				{
					offsetAdjustedVector.setY((this._height/2.0)*currScale);
				}
				else if(offsetAdjustedVector.getY() + ((this._height/2)*currScale) < Core.Capabilities.getScreenWidth()){
					offsetAdjustedVector.setY(Core.Capabilities.getScreenWidth() - (this._height/2)*currScale);
				}
				this._motherSprite.setPosition(offsetAdjustedVector);

			}
		}
		catch(err){
			console.log("Error description for method multiTouch in class IsometricView: "+err.message);
		}
	},
	setZoom: function(level) {
		var currentScale = this._motherSprite.getScale();
		var zoomIn = GAIsoMetricConfigurations.getZoomInFactor();
		var zoomOut = GAIsoMetricConfigurations.getZoomOutFactor();
		var h = GACommonUtils.getScreenHeight();
		var w = GACommonUtils.getScreenWidth();
		var fact = w > h ? w : h;
		var div = w > h ? this._width : this._height;
		var minScale = (fact/div);
		if(div > fact) {
			zoomOut = minScale;
		}
		if(level < zoomOut) {
			level = zoomOut;
		}
		else if(level >= zoomIn) {
			level = zoomIn;
		}
		this._motherSprite.setScale(level, level);
	},
	destroy: function()
	{
		delete this._multiArray;

		this._diffForPinch = null;
		delete this._diffForPinch;

		this._lastDistance = null;
		delete this._lastDistance;

		this._isPanningDisabled = null;
		delete this._isPanningDisabled;

		this._isPinchingDisabled = null;
		delete this._isPinchingDisabled;

		this._gridObjects = null;
		delete this._gridObjects;

		this._motherSprite = null;
		delete this._motherSprite;

		this._target = null;
		delete this._target;

		this._panningOffset = null;
		delete this._panningOffset;

		this._multiArray = null;
		delete this._multiArray;

		this.olTouchEnded = null;
		delete this.olTouchEnded;

	}

});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/ngAPI/GAIsoMetricView/GAObjectLayer'] = function(){var exports = $MODULE_REGISTRY['Code/ngAPI/GAIsoMetricView/GAObjectLayer'] || {}; $MODULE_REGISTRY['Code/ngAPI/GAIsoMetricView/GAObjectLayer'] = exports; // <copyright file="ObjectLayer.js" company="GameViewStudios">
// Copyright (c) 2010, 2011 All Right Reserved, http://www.gameviewstudios.com/
// </copyright>
//<added in version>1.0</added in version>
// <author>xyz</author>
// <email>xyz@xyz.org</email>
// <created date>2008-06-10</created date>
// <summary>Contains a ObjectLayer class which shows is responsible for handling touches and object placement</summary>

exports.GAObjectLayer = GAIsometricView.subclass({
    classname : 'GAObjectLayer',
    _currentSelectedObject: null,
    _differenceBetweenTouch: null,
    _actionType: null,
    _highLightedObject: null,
    _tempPositionSelected: null,
	_collisionObject: null,
	_shouldMove: null,
	_olDidMove: null,
	_shouldProposeMultipleObjects: null,
	_isMovingAlreadyPlacedObject: null,
	
	_isMultiMoveToolEnabled: null,
	_isMultiSellToolEnabled: null,
	_isRoadToolEnabled: null,
	_tutorial:null,
	_previouslyPlacedObjectPosition: null,
    _previousRoadPosition: null,
	_previousPreviousRoadPosition: null,
    
    initialize: function(){
    	console.log("Log: GAObjectLayer")
    	this._differenceBetweenTouch = new Core.Vector(0,0);
		this._actionType = ActionType.ActionArrow;
		this._shouldProposeMultipleObjects = false;
		
		this._isMultiMoveToolEnabled = false;
		this._isMultiSellToolEnabled = false;
		this._isRoadToolEnabled = false;
	},
    
    getHighLightedObject: function(){
    	return this._highLightedObject;
    },
    
    getMultiToolStatus: function(){
    	return (this._isMultiMoveToolEnabled || this._isMultiSellToolEnabled);
    },
    
    setPreviouslyPlacedObjectPosition: function(thePosition){
    	this._previouslyPlacedObjectPosition = thePosition;
    },
    
    getPreviouslyPlacedObjectPosition: function(){
    	return this._previouslyPlacedObjectPosition;
    },
    
    setPreviousRoadPosition: function(thePosition){
    	this._previousRoadPosition = thePosition;
    },
    
    getPreviousRoadPosition: function(){
    	return this._previousRoadPosition;
    },
    
    setPreviousPreviousRoadPosition: function(thePosition){
    	this._previousPreviousRoadPosition = thePosition;
    },
    
    getPreviousPreviousRoadPosition: function(){
    	return this._previousPreviousRoadPosition;
    },
    
    setIsMultiMoveToolEnabled: function(theState){
    	this._isMultiMoveToolEnabled = theState;
    },
    
    getIsMultiMoveToolEnabled: function(){
    	return this._isMultiMoveToolEnabled;
    },
    
    cancelMultiMove: function(){
    	if (this._highLightedObject){
    		this.cancelPlacingOfObject(this._highLightedObject);
    	}
    },
    
    setIsMultiSellToolEnabled: function(theState){
    	this._isMultiSellToolEnabled = theState;
    },
    
    getIsMultiSellToolEnabled: function(){
    	return this._isMultiSellToolEnabled;
    },
    
    cancelMultiSell: function(){
    	if ((this._highLightedObject) && (this._highLightedObject.objectState() != ObjectState.ObjectPlacement)){
    		this._highLightedObject.setOpacityToFull();
    		this._highLightedObject = null;
    	}
    },
    
    setIsRoadToolEnabled: function(theState){
    	this._isRoadToolEnabled = theState;
    },
    
    getIsRoadToolEnabled: function(){
    	return this._isRoadToolEnabled;
    },
    
    cancelRoadTool: function(){
    	console.log('Logger: Cancelling road tool');
    },
    
    setIsMovingAlreadyPlacedObject: function(theState){
    	this._isMovingAlreadyPlacedObject = theState;
    },
    
    getIsMovingAlreadyPlacedObject: function(){
    	return this._isMovingAlreadyPlacedObject;
    },
    
    setShouldProposeObjects: function(theState){
    	this._shouldProposeMultipleObjects = theState;
    },
    
    setCurrentSelectedObject: function(theObject){
    	this._currentSelectedObject = theObject;
    },
    
    setHighlightedObject: function(theObject){
    	this._highLightedObject = theObject;
    },
    
    getGridObjects: function(){
    	return this._gridObjects;
    },
    
    checkGridOnPositionIsEmpty: function(gridPosX, gridPosY, sizeX, sizeY){
    	var isEmpty = true;
    	for (var i = gridPosX; ((i < gridPosX + (4 * sizeX)) && (i < GAIsoMetricConfigurations.getGridSize().getX())); i = i + 4){
    		for (var j = gridPosY; ((j < gridPosY + (4 *sizeY)) && (j < GAIsoMetricConfigurations.getGridSize().getY())); j = j + 4){
	    		if (this._gridObjects[i][j] != null){
	    			return false;
	    		}
    		}
    	}
    	return isEmpty;
    },
    
    findPositionOnGrid: function(objSizeX, objSizeY, startX, startY){
    	var placeCoordinates = null;
		var placeFound = false;
		
		for (var i = startX; i <= GAIsoMetricConfigurations.getGridSize().getX() - (4 * objSizeX); i = i + 4){
    		for (var j = startY; j <= GAIsoMetricConfigurations.getGridSize().getY() - (4 * objSizeY); j = j + 4){
    			if (this.checkGridOnPositionIsEmpty(i, j, objSizeX, objSizeY)){
					placeFound = true;
					placeCoordinates = new Core.Vector(i, j);
					break;
    			}
    		}
    		if (placeFound){
    			break;
    		}
    	}
    	if (!placeFound){
    		placeCoordinates = new Core.Vector(-1, -1)
    	}
    	
    	return placeCoordinates;
    },
    
    getZ: function(forObject, gridPosition){
    	var constFix = 200;
    	
    	var gridSizeX = forObject.getGridSize().getX();
    	var gridSizeY = forObject.getGridSize().getY();
    	
		var gridPositionX = gridPosition.getX();
		var gridPositionY = gridPosition.getY() + gridSizeY;
		
		var calculatedZ = (GAIsoMetricConfigurations.getGridSize().getX() * 2 + 1) - (gridPositionX + gridPositionY + 1);
		
		calculatedZ = calculatedZ * 16;
		
		var zOrderOfbottomNeighborPoint = calculatedZ;
		var previousFoundZOrder = - 1;
		
		if (gridSizeX > gridSizeY){
			for (var neighborXStart = gridPositionX+1; neighborXStart < gridPositionX + gridSizeX; neighborXStart++){
				var bottomNeighborPoint = new Core.Vector(neighborXStart, gridPositionY - 4)
				if(bottomNeighborPoint.getY() > gridSizeY || bottomNeighborPoint.getX() > gridSizeX){
					return calculatedZ + constFix;
				}
				var bottomNeighbor = this.objectForGridPosition(bottomNeighborPoint);
				
				if (bottomNeighbor){	
					previousFoundZOrder = zOrderOfbottomNeighborPoint;
					zOrderOfbottomNeighborPoint = bottomNeighbor.getObject().getDepth();
					if (previousFoundZOrder > zOrderOfbottomNeighborPoint){
						zOrderOfbottomNeighborPoint = previousFoundZOrder;
					}
				}
			}
			return (zOrderOfbottomNeighborPoint - 1) + constFix;
		}
		
		return calculatedZ + constFix;
    },
    
    addObject: function(theObject){
        if (this._actionType == ActionType.ActionMove){
        	if (this._highLightedObject != null){
        		if (this._isMovingAlreadyPlacedObject){
					this.cancelPlacingOfObject(this._highLightedObject);
        		}
        		else{
        			this.removeObject(this._highLightedObject);
        		}
        	}
        	else{
        		return;
        	}
        }
        if (theObject.getIsSelected()){
            var obj = theObject.getObject();
            this.addChild(obj);
            this.setSenderAsSelectedObject(theObject);
            obj.setDepth(this.getZ(theObject, this._tempPositionSelected));
        }
        else{
            var samplePoint = new Core.Vector(theObject.getGridLocation().getX(), theObject.getGridLocation().getY() + theObject.getGridSize().getY());
            this.addChild(theObject.getObject(), this.getZ(theObject, this._tempPositionSelected));
            theObject.getObject().setDepth(this.getZ(theObject, this._tempPositionSelected));
        }
    },
    
    removeObject: function(theObject){
    	if (theObject == null){
    		return;
    	}
    	this.removeChild(theObject.getObject());
    	return this.cleanGridForSpecificObject(theObject);
    },
    
    cancelPlacingOfObject: function(theObject){
    	if (!this._isMovingAlreadyPlacedObject){
    		return;
    	}
    	var previousPosition = theObject.getGridLocation();
    	if (this._collisionObject){
			this._collisionObject.unmarkAsRed();	
    	}
    	theObject.getObject().setPosition(this.convertGridPointToLayerPoint(previousPosition));
    	theObject.setIsSelected(false);
		theObject.setOpacityToFull();
        this._highLightedObject = null;
        this._actionType = ActionType.ActionArrow;
        this._shouldMove = false;
        this._isMovingAlreadyPlacedObject = false;
        
        //GameController.getWidgetsLayer().allowMultiTools();
    },
    
    resetToPointer: function(){
		if (this._actionType == ActionType.ActionMove){
        	if (this._highLightedObject != null){
				if (this._isMovingAlreadyPlacedObject){
					this.cancelPlacingOfObject(this._highLightedObject);
        		}
        		else{
        			if (this._isRoadToolEnabled){
        				console.log('Logger: do nothing, leave the road there');
        			}
        			else{
	        			if (this._collisionObject){
	        				this._collisionObject.unmarkAsRed();
	        			}
	        			this.removeObject(this._highLightedObject);
	        			this._highLightedObject = null;
				        this._actionType = ActionType.ActionArrow;
				        this._shouldMove = false;
				        this._isMovingAlreadyPlacedObject = false;
        			}
        		}
        	}
    	}
    	
    	//GameController.getWidgetsLayer().allowMultiTools();
    },
    
    didTouchSelectedObject: function(gridLocationForTouch){
        if (!this._highLightedObject){
            return false;
        }
        var origin = new Core.Vector(this._tempPositionSelected.getX(),this._tempPositionSelected.getY());
        var size = new Core.Size(this._highLightedObject.getGridSize().getX(),this._highLightedObject.getGridSize().getY());
        var madeRect = new Core.Rect(origin,size);
        
        if (this.rectContainsPoint(madeRect, gridLocationForTouch)){
            return true;
        }
        else{
            return false;
        }
    },
    
    setHighligtedObjectAtPoint: function(point){
    	//console.log('Logger: HOBJECT GridX = ' + this._highLightedObject.getGridLocation().getX() + ' Y = ' + this._highLightedObject.getGridLocation().getY());
    	var locationInGrid = this.validateLocationForPointAndSize(point, this._highLightedObject.getGridSize());
    	this._highLightedObject.getObject().setPosition(this.convertGridPointToLayerPoint(locationInGrid));
    	this._tempPositionSelected = locationInGrid;
    	
    	this.checkCollisionWithGrid(this._highLightedObject);
    	this._highLightedObject.getObject().setDepth(this.getZ(this._highLightedObject, this._tempPositionSelected));
    	//console.log('Logger: HOBJECT GridX = ' + this._highLightedObject.getGridLocation().getX() + ' Y = ' + this._highLightedObject.getGridLocation().getY());
    },
    
    olTouchBegan: function(touch){
        if (this._actionType == ActionType.ActionMove){
            var point = this.conversionToLayer(touch);
            if (this.didTouchSelectedObject(point)){
                this._shouldMove = true;
                this._differenceBetweenTouch = new Core.Vector(this._tempPositionSelected.getX() - point.getX(), this._tempPositionSelected.getY()-point.getY());
            }
        }
    },
    
    olTouchMoved: function(touch,multiArray){
        if (this._actionType == ActionType.ActionMove){
            if (multiArray == 2){
                this._isPinchingDisabled = false;
                this._isPanningDisabled = false;
                this._shouldMove = false;
                
                this._olDidMove = true;
                return;
            }
            
            if (this._shouldMove){
                var pointWithDifference = this.conversionToLayer(touch);
                pointWithDifference.setX(pointWithDifference.getX() + this._differenceBetweenTouch.getX());
                pointWithDifference.setY(pointWithDifference.getY() + this._differenceBetweenTouch.getY());
                
                this.setHighligtedObjectAtPoint(pointWithDifference);
                
                this._isPanningDisabled = true;
            }
        }
        
        this._olDidMove = true;
    },

    olTouchEnded: function(touch){
        var point = this.conversionToLayer(touch);
        
        this._isPinchingDisabled = false;
        this._isPanningDisabled = false;
        
        if (this._actionType == ActionType.ActionMove){
            if ((!this._olDidMove) && (!this.didTouchSelectedObject(point))){
	            this.setHighligtedObjectAtPoint(point);
            }
            else if ((!this._olDidMove) && (this.didTouchSelectedObject(point))){
                if(this._highLightedObject && (!this.checkCollisionWithGrid(this._highLightedObject))){
                    this._highLightedObject.tap();
				}
            }
        }
        else if (this._actionType == ActionType.ActionArrow){
			if (point.getX() < 0 || point.getY() < 0 ||  point.getX() >= GAIsoMetricConfigurations.getGridSize().getX() || point.getY() >= GAIsoMetricConfigurations.getGridSize().getY()){
	        	return;
	        }
	        if (!this._olDidMove){
	        	var theObject = this._gridObjects[point.getX()][point.getY()];
	        	if (theObject != null){
					theObject.tap();
	        	}
	        }
        }
        
        this._olDidMove = false;
        this._shouldMove = false;
    },
    
    setObjectToMovingMode: function(theObject){
    	this._highLightedObject = theObject;
		this._highLightedObject.setOpacityToLight();
		this.setIsMovingAlreadyPlacedObject(true);
		this._highLightedObject.setIsSelected(true);
		this.setSenderAsSelectedObject(this._highLightedObject);
    },
    
    finalizeObjectAtItsPlace: function(){
    	try{
	    	this.reserveGridForObject(this._highLightedObject);
	    	this._previouslyPlacedObjectPosition = this._highLightedObject.getGridLocation();
	       	this._highLightedObject.setOpacityToFull();
	        this._highLightedObject.begin();
	     	this._highLightedObject.updatePosition();
	        this._highLightedObject.getObject().setDepth(this.getZ(this._highLightedObject, this._tempPositionSelected));
	        this._highLightedObject = null;
	        this._actionType = ActionType.ActionArrow;
			this._shouldMove = false;
			this._isMovingAlreadyPlacedObject = false;
    	}
    	catch(_exception){
    		console.log('Logger: Exception occurred in Finalize of Object Layer: ' + _exception.toString());
    	}
    },
    
    setHighLightedObjectToNil: function(){
		this._highLightedObject = null;
		this._shouldMove = false;
		this._actionType = ActionType.ActionArrow;
    },
    
    objectForGridPosition: function(targetPoint){
        var x = targetPoint.getX();
        var y = targetPoint.getY();
        
        if (x<0 || x >= GAIsoMetricConfigurations.getGridSize().getX() || y<0 || y >= GAIsoMetricConfigurations.getGridSize().getY()){
            return null;
        }
        
        var uiObject = this._gridObjects[x][y];

        return uiObject;
    },
    
    cleanGridForSpecificObject: function(senderObject){
    	var wasObjectFoundOnGrid = false;
    	var gSize = GAIsoMetricConfigurations.getGridSize()
    	for (var i = gSize.getX(); i-- ;){
    		for (var j = gSize.getY(); j-- ; ){
    			if (this._gridObjects[i][j] == senderObject){
    				wasObjectFoundOnGrid = true;
    				console.log('Logger: Found the object ('+this._gridObjects[i][j]+') for cleanup at: ('+ i +', '+ j +')')
    				this._gridObjects[i][j] = null;
    			}
    		}
    	}
    	return wasObjectFoundOnGrid;
    },
    
    reserveGridForObject: function(senderObject){
        var locationX;
        var locationY;
        var sizeX;
        var sizeY;
        
        sizeX = senderObject.getGridSize().getX();
        sizeY = senderObject.getGridSize().getY();
        
        if (this.cleanGridForSpecificObject(senderObject)){
        	console.log('Logger: previous reference removed');
        }
        locationX = this._tempPositionSelected.getX();
        locationY = this._tempPositionSelected.getY();
        
        var xLimit = locationX + sizeX;
        for(var i = locationX; i < xLimit; i++){
        	var yLimit = locationY + sizeY;
            for (var j = locationY; j < yLimit; j++){
                this._gridObjects[i][j] = senderObject;
            }
        }
        senderObject.setGridLocation(new Core.Vector(locationX,locationY));
	},
    
    
    validateLocationForPointAndSize: function(location,gridSizeOfObject){
        var tempPoint = location;
        if(location.getX() < 0)
            tempPoint.setX(0);
        if((tempPoint.getX() + gridSizeOfObject.getX()) >= (GAIsoMetricConfigurations.getGridSize().getX() - 1))
            tempPoint.setX(GAIsoMetricConfigurations.getGridSize().getX() - gridSizeOfObject.getX());
        if(tempPoint.getY() < 0)
            tempPoint.setY(0);
        if((tempPoint.getY() + gridSizeOfObject.getY()) >= (GAIsoMetricConfigurations.getGridSize().getY() - 1))
            tempPoint.setY(GAIsoMetricConfigurations.getGridSize().getY() - gridSizeOfObject.getY());

        tempPoint.setX(parseInt(tempPoint.getX() / 4));
        tempPoint.setY(parseInt(tempPoint.getY() / 4));

        tempPoint.setX(tempPoint.getX() * 4);
        tempPoint.setY(tempPoint.getY() * 4);

        return tempPoint;
    },
    
    setSenderAsSelectedObject: function(sender){
        sender.setIsSelected(true);
        this._highLightedObject = sender;
        this._tempPositionSelected = sender.getGridLocation();
        this._shouldMove = true;
        this._actionType = ActionType.ActionMove;
    },
    
    rectContainsPoint: function (rect,point){
        var rectX = rect.getOrigin().getX();
        var rectY = rect.getOrigin().getY();
        var rectWidth = rect.getSize().getWidth();
        var rectHeight =rect.getSize().getWidth(); 

        var pointX = point.getX();
        var pointY = point.getY();
        
        var temp;
        if ((pointX >= rectX && pointX <= (rectX + rectWidth)) && (pointY >= rectY && pointY <= (rectY + rectHeight))){
            temp = true;
        }
        else{
            temp = false;
        }

        return temp;
    },
    
    checkCollisionWithGrid: function(sender){
    	
    	var locationX;
        
        var sizeX = sender.getGridSize().getX();
        var sizeY = sender.getGridSize().getY();
        
        var doesCollide = false;
        var tempObject;
        var locationX = this._tempPositionSelected.getX();
        var locationY = this._tempPositionSelected.getY();

		if (this._collisionObject){
			this._collisionObject.unmarkAsRed();
		}

       
        for (var i = locationX; i < locationX + sizeX; i++){
            for (var j = locationY; j < locationY + sizeY; j++){
                tempObject = this._gridObjects[i][j];
                
                if (tempObject && (tempObject != this._highLightedObject)){   
						this._collisionObject = tempObject;
						doesCollide = true;
                }
            }
        }
            
        if (doesCollide){
            this._collisionObject.markAsRed();
            doesCollide = true;
			return doesCollide;
        }
        else{
            this._collisionObject = null;
        }
		
        return doesCollide;
    },
    
    destroy: function(){
        
    },
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/ngAPI/GAIsoMetricView/GridObject'] = function(){var exports = $MODULE_REGISTRY['Code/ngAPI/GAIsoMetricView/GridObject'] || {}; $MODULE_REGISTRY['Code/ngAPI/GAIsoMetricView/GridObject'] = exports; exports.GridObject = Core.MessageListener.subclass({
	classname : 'GridObject',
	
	_isSelected: false,
	_objectType: null,
	_gridLocation: null,
	_gridSize: 0,
	_obj: null,
	_markedAsRed: false,
	_objectState: 0,
	_constructionTime: 0.1,
	_width: 1,
	_height: 1,
	imgHeight: 0,
	imgWidth: 0,
    animationImageHeight: 0,
    animationImageWidth: 0,
    _placementTime : 0.0,
    _imagePath:"",
    
    _dbModel:null,
    
    _virtualItem: null,
    
    initialize: function(objectLayer){
		this._isSelected = false;
		this._objectLayer = objectLayer;
		 
		if (this._virtualItem){
			console.log('Logger: VirtualItem was passed, Vitem = ' + this._virtualItem);
		}
		
		this.getConstructionFramesFromJSON();
	},	
	
	setObjectName: function(someName)
	{
		this._name = someName;
	},
	
	objectName: function()
	{
		return this._name;
	},
	setImagePath: function(path)
	{
		this._imagePath = path;
	},
	
	imagePath: function()
	{
		return this._imagePath;
	},
	
	setObjectState: function(someState)
	{
		this._objectState = someState;
	},
	
	objectState: function()
	{
		return this._objectState;
	},
	
	getObject: function(){
		return this._obj;
	},
	
	setWidth: function(someWidth){
		this._width = someWidth;
	},
	
	getWidth: function(){
		return this._width;
	},
	
	setPlacementTime: function(someTime){
		this._placementTime = someTime;
	},
	
	getPlacementTime: function(){
		return this._placementTime;
	},
	
	setHeight: function(someHeight){
		this._height = someHeight;
	},
	
	getHeight: function(){
		return this._height;
	},
	
	setConstructionTime: function(someTime){
		this._constructionTime = someTime;
	},
	
	getConstructionTime: function(){
		return this._constructionTime;
	},
	
	setObjectPosition: function(position){
		this._obj.setPosition(position);
	},
	
	getObjectPosition: function(){
		return this._obj.getPosition();
	},
	
	setIsSelected: function(isSelected){
		this._isSelected = isSelected;
	},
	
	getIsSelected: function(){
		return this._isSelected;
	},
	
	setOpacityToLight: function(){
		this._obj.setAlpha(0.5);
	},
	
	setOpacityToFull: function(){
		this._obj.setAlpha(1);
	},
	
	setObjectType: function(objectType){
		this._objectType = objectType;
	},
	
	getObjectType: function(){
		return this._objectType;
	},
	
	setGridLocation: function(gridLocation){
		this._gridLocation = gridLocation;
	},
	
	getGridLocation: function(){
		return this._gridLocation;
	},
	
	setGridSize: function(gridSize){
		this._gridSize = gridSize;
	},
	
	getGridSize: function(){
		return this._gridSize;
	},
	
	markAsRed: function(){
    	if (this._markedAsRed){
    		return;
    	}
    	this._obj.setColor(1, 0.25, 0.25);
    	this._markedAsRed = true;
	},
	
	unmarkAsRed: function (){
    	this._obj.setColor(1, 1, 1);
    	this._markedAsRed = false;
    },
    
    hasTimedState: function()
    {
    	return true;
    },
    
    move: function(){
    	this._objectLayer.setObjectToMovingMode(this);
    },
    
    tap: function(){
    	console.log('Logger: Parent Tap start');
    	var objectLayer = this._objectLayer;
    	if (this == objectLayer.getHighLightedObject()){
    		if (objectLayer.getIsMultiSellToolEnabled()){
    			this.sell();
    		}
    		else{
    			if (this.objectState() == ObjectState.ObjectPlacement){
    				this.makeTransaction(TransactionType.TransactionBuy);
    			}
    			objectLayer.finalizeObjectAtItsPlace();
    			if (!(objectLayer.getIsRoadToolEnabled())){
//    				GameController.getWidgetsLayer().allowMultiTools();
    			}
    		}
    	}
    	else{
    		if ((objectLayer.getIsMultiMoveToolEnabled()) && (!objectLayer.getIsMultiSellToolEnabled())){
    			this.move();
    		}
    		else if ((!objectLayer.getIsMultiMoveToolEnabled()) && (objectLayer.getIsMultiSellToolEnabled())){
    			if (objectLayer.getHighLightedObject() == null){
    				objectLayer.setHighlightedObject(this);
    				this.setOpacityToLight();
    			}
    			else{
					objectLayer.getHighLightedObject().setOpacityToFull();
    				objectLayer.setHighlightedObject(this);
    				this.setOpacityToLight();
    			}
    		}
    		else if ((!objectLayer.getIsMultiMoveToolEnabled()) && (!objectLayer.getIsMultiSellToolEnabled())){

    		}
    	}
    },
    
    getFrames: function (fileName)
    {
    	console.log('Logger: going to get Frames form file: '+fileName);
    	try
    	{
//    		GameController.getTTUtil().readFile(fileName, this.getXMLFrames.bind(this));
    		console.log('Logger: after the readFile has been completed');
    		return;
    	}
    	catch(e)
    	{
    		console.log('Logger: EXCEPTION! Reason: '+e.toString());
    	}
////    	if(GameController.getTTUtil().fileString() == '')
//    	{
//    		return;
//    	}
    },
    getFramesFromJSON: function (fileName)
    {
		var animJSONObj = null;//GameController.getAnimation(this);
    	if(animJSONObj)
    	{
    		this.animationsJSONObject = animJSONObj;
        	
    		if (this._dbModel != null)
    	   	{
        		//this.loadState(); //STEP-A
        	}
        	return;
    	}
    	console.log('Logger: going to get Frames form file: '+fileName);
    	try
    	{
    		Storage.FileSystem.readFile(fileName, false,this.getAnimationFrames.bind(this));
    		console.log('Logger: after the readFile has been completed');
    		return;
    	}
    	catch(e)
    	{
    		console.log('Logger: EXCEPTION! Reason: '+e.toString());
    	}
    },
	getConstructionAnimationFrames: function(error, text)
    {
    	console.log('Logger: in getXML Frames CallBack');
		if(!error)
		{
			//setFileString(text);
			console.log('Logger: file text is: '+text);
		}
		else
		{
			//setFileString('');
			this.constructionAnimationsJSONObject = null;
			console.log('Logger: error occurred: '+error.toString());
			return;
    	}
    	console.log('Logger: file has successfuly been read, starting parser');
    	
    	this.constructionAnimationsJSONObject = eval('('+ text + ')');
    	
    	//GameController.setConstructionAnimation(this, this.constructionAnimationsJSONObject);
    	
    	var plistPath = './Content/images/' + this._jsonObject.parent.parent.visible_id + '/' + this._jsonObject.parent.visible_id + '/' + this._jsonObject.visible_id + '/default_zip' + '/a.json';
		this.getFramesFromJSON(plistPath);
    },
    
    getAnimationFrames: function(error, text)
    {
    	console.log('Logger: in getXML Frames CallBack');
		if(!error)
		{
			//setFileString(text);
			console.log('Logger: file text is: '+text);
		}
		else
		{
			//setFileString('');
			this.animationsJSONObject = null;
			console.log('Logger: error occurred: '+error.toString());
			//if (this._dbModel != null && GameController.getObjectLayer().getHighLightedObject() == this)
			if (this._dbModel != null)
			{
				//this.loadState(); //STEP-A
	    	}
			return;
    	}
    	console.log('Logger: file has successfuly been read, starting parser');
    	
    	this.animationsJSONObject = eval('('+ text + ')');
    	
    	//GameController.setAnimation(this, this.animationsJSONObject);
    	
    	if (this._dbModel != null)
    	{
    		//this.loadState(); //STEP-A
    	}
    	
    },
    getConstructionFramesFromJSON: function()
    {
    	var animJSONObj = null;//GameController.getConstructionAnimation(this);
    	if(animJSONObj)
    	{
    		this.constructionAnimationsJSONObject = animJSONObj;
        	
        	var plistPath = './Content/images/' + this._jsonObject.parent.parent.visible_id + '/' + this._jsonObject.parent.visible_id + '/' + this._jsonObject.visible_id + '/default_zip' + '/a.json';
    		this.getFramesFromJSON(plistPath);
    		return;
    	}
    	//this.setImagePath('./Content/images/Objects/construction/'+this._width+'x'+this._height+'/a.png');
		var fileName = './Content/images/Objects/construction/'+this._width+'x'+this._height+'/a.json';
    	console.log('Logger: going to get Frames form file: '+fileName);
    	try
    	{
    		Storage.FileSystem.readFile(fileName, false,this.getConstructionAnimationFrames.bind(this));
    		console.log('Logger: after the readFile has been completed');
    		return;
    	}
    	catch(e)
    	{
    		console.log('Logger: EXCEPTION! Reason: '+e.toString());
    	}
    },
    sell: function()
    {
    	this._objectLayer.removeObject(this);
    	this.makeTransaction(TransactionType.TransactionSell);
    },
    
    makeTransaction: function(transactionType){
    	try{
	    	if (transactionType == TransactionType.TransactionBuy){
	    		if (this._virtualItem.getCost().coins > 0){
//	    			GameController.getUser().subtractCoins(parseInt(this._virtualItem.getCost().coins));
	    		}
	    		else if (this._virtualItem.getCost().bucks > 0){
//	    			GameController.getUser().subtractBucks(parseInt(this._virtualItem.getCost().bucks));
	    		}
	    		else{
	    			console.log('Logger: Buy for free');
	    		}
	    	}
	    	else if (transactionType == TransactionType.TransactionSell){
	    		console.log('Logger: Selling this item');
	    	}
    	}
    	catch(_exception){
    		console.log('Logger: Exception in makeTransaction: ' + _exception.toString());
    	}
    },
    
    destroy: function(){
        
    },
    
    updatePosition:function(){
		this._dbModel.setX(this.getGridLocation().getX());
		this._dbModel.setY(this.getGridLocation().getY());
	}
	
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/ngAPI/GAIsoMetricView/GridObjectDecoration'] = function(){var exports = $MODULE_REGISTRY['Code/ngAPI/GAIsoMetricView/GridObjectDecoration'] || {}; $MODULE_REGISTRY['Code/ngAPI/GAIsoMetricView/GridObjectDecoration'] = exports; exports.GridObjectDecoration = GridObject.subclass({
	classname : 'GridObjectDecoration',
	_name: 'Fountain',
	
	_populationLimitAddition: 220,
	
	initialize: function($super, dbModel, virtualItem, objectLayer){
		this._dbModel = dbModel;
		this._virtualItem = virtualItem;
		this._objectLayer = objectLayer;
		
		$super(objectLayer);
		
		this.setGridSize(new Core.Vector(4, 4));
        this.setObjectType(ObjectType["ObjectDecoration"]);
		this._obj = new GL2.Sprite();
		this._baseImage = new GL2.Sprite();
		this._imagePath = './Content/images/Objects/Decorations/Fountain';
		this._baseImage.setImage(this._imagePath+'/1.png', [123,80], [0.5, 1]);
		this._baseImage.setDepth(100);
		this._isAnimatable=true;
		this.setObjectState(ObjectState["ObjectPlacement"]);
		this._obj.addChild(this._baseImage);
		if (dbModel != null){
			this.animate();
		}
	},
	
	hasTimedState: function()
	{
		return false;
	},
		
	animate: function()
	{
		this.theLights = new GL2.Sprite();
		this.theLights.setDepth(102);
		var theLightsAnimation = new GL2.Animation();
		theLightsAnimation.pushFrame(new GL2.Animation.Frame(this._imagePath+'/a.png', 200, [86, 52], [0.5,1], [86/512, 52/128, 86/512, 52/128]));
		//theLightsAnimation.pushFrame(new GL2.Animation.Frame('./Content/images/Objects/Decorations/Fountain/a.png', 200, [84, 52], [0.5,1], [256/512, 0/128, 84/512, 52/128]));
		theLightsAnimation.pushFrame(new GL2.Animation.Frame(this._imagePath+'/a.png', 200, [86, 52], [0.5,1], [172/512, 0/128, 86/512, 52/128]));
		theLightsAnimation.pushFrame(new GL2.Animation.Frame(this._imagePath+'/a.png', 200, [86, 52], [0.5,1], [172/512, 52/128, 86/512, 52/128]));
		theLightsAnimation.pushFrame(new GL2.Animation.Frame(this._imagePath+'/a.png', 200, [86, 52], [0.5,1], [86/512, 0/128, 86/512, 52/128]));
		theLightsAnimation.pushFrame(new GL2.Animation.Frame(this._imagePath+'/a.png', 200, [86, 52], [0.5,1], [0/512, 52/128, 86/512, 52/128]));
		theLightsAnimation.pushFrame(new GL2.Animation.Frame(this._imagePath+'/a.png', 200, [86, 52], [0.5,1], [0/512, 0/128, 86/512, 52/128]));

		this.theLights.setAnimation(theLightsAnimation);
        //this.theLights.setRotation(1);
        //this.theLights.setPosition([8, -5]);
		this.theLights.setPosition([7.5, -8]);
        
        this._obj.addChild(this.theLights);
	},
	
	begin:function()
	{
		if (!(this.objectState() == ObjectState["ObjectPlacement"]))
		{
			return;
		}

		if(this._isAnimatable)
		{
			this.animate();	
		}
//		this.incrementPopLimit();
		this.setObjectState(ObjectState["ObjectReady"]);
//		if (this == GameController.getObjectLayer().getHighLightedObject())
//		 {
//			try
//			{
//				GameController.getWidgetsLayer().getTutorial().nextStep(7);
//			}
//			catch(_exception)
//			{
//				console.log('Logger: Exception: ' + _exception.toString());
//			}
//		}
//		
//		try{
//			var model = this.makeDBObject();
//			TTDbUtil.addDecorationObject(model);
//		}
//		catch(e){
//			console.log('Logger model' +e.toString())
//		}
		
	},
	
	getImagePath: function()
	{
		return this._imagePath;
	},
	
//	incrementPopLimit: function(){
//        var populationLimit = GameController.getWidgetsLayer().getStatusBar().getPopulationLimit();
//        var newPopulationLimit = populationLimit + this._populationLimitAddition;
//        GameController.getWidgetsLayer().getStatusBar().setPopulationLimit(newPopulationLimit);
//	},
	
	sell: function($super)
	{
/*        var populationLimit = GameController.getWidgetsLayer().getStatusBar().getPopulationLimit();
        var newPopulationLimit = populationLimit - this._populationLimitAddition;
        GameController.getWidgetsLayer().getStatusBar().setPopulationLimit(newPopulationLimit);
    	TTDbUtil.removeDecoration(this._dbModel._jsonReference);*/
		$super();
	},
	
	getPopulationLimitAddition: function()
	{
		return this._populationLimitAddition;
	},
	
	
	tap: function($super)
	{
		var objectLayer = this._objectLayer;
		
		if (this == objectLayer.getHighLightedObject()){
			
		}
		else{
			if (!objectLayer.getMultiToolStatus())
			{	
				if (this.objectState() == ObjectState.ObjectDirty)
				{
	        		this.switchToIdle();
	        	}
				else
				{
//					if (!isAttributeWindowOpen)
//					{
//			        	isAttributeWindowOpen = true;
//						//GameController.getGameViewManager().addView(new DecorationAttributeWindow(this));
//					}
				}
			}
		}
		$super();
	},
	
	makeDBObject:function(){
//		try{
//			var newID = TTDbUtil.getNextDecorationID();
//			
//			console.log('Logger: New Decoration ID = '  + newID);
//			
//			var myX = this.getGridLocation().getX();
//			var myY = this.getGridLocation().getY();
//			
//			var decDbModel = new DecorationDbModel(newID, newID, myX, myY, 0);
//			this._dbModel=decDbModel;
//			return decDbModel;
//		}
//		catch(_exception){
//			console.log('Logger Exception: ' + _exception.toString());		
//		}	
	},
	updatePosition:function(){
//		if(!this._dbModel){
//			this._dbModel=this.makeDBObject();
//		}
//		this._dbModel.setX(this.getGridLocation().getX());
//		this._dbModel.setY(this.getGridLocation().getY());
//		TTDbUtil.updateDecoration();
	}
		
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/ngAPI/GAMobageSocial/GAMobageSocialHandler'] = function(){var exports = $MODULE_REGISTRY['Code/ngAPI/GAMobageSocial/GAMobageSocialHandler'] || {}; $MODULE_REGISTRY['Code/ngAPI/GAMobageSocial/GAMobageSocialHandler'] = exports; /**
 * Filename: GAMobageSocialHandler.js
 * Author: Harris Khurram
 * Updates: Abid Hussain
 * Date Created: 05-12-2011
 * Date Updated: 05-18-2011
 */
 
/*
	fieldsOptions [ 
					"id", //Unique id - number
					"displayName", //string
					"aboutMe", //string
					"addresses", //plural field, has office and res address - not supported in gapi v1.0
					"age",	//number
					"birthday", //Date
					"gender",//string
					"hasApp", //bool
					"interests", //plural field - not supported in gapi v1.0
					"nickname",	//string -- beware this can be changed, do not bind things on nicknames, always use id
					"thumbnailUrl", //string
					"jobType", //string
					"bloodType", //string
					"ageRestricted" //bool
					]
*/

exports.GAMobageSocialHandler = Core.Class.singleton({
	classname: 'GAMobageSocialHandler',
	
	_fields: ["id", "displayName", "thumbnailUrl", "nickname"],
	_loggedInMobageUser: null,
	_loginRetryCount: 9,
	
	initialize: function()
	{
		this.loadCurrentMobageUser();
	},
	
	loadCurrentMobageUser: function() {
		this.loadCurrentMobageUserWithCallback(null);
	},
	
	loadCurrentMobageUserWithCallback: function(aCallback) {
		if(aCallback)
		{
			this._socialApiCall(this._fields, this._loadUserCallback.bind(this,aCallback));
		} else {
			this._socialApiCall(this._fields, this._loadUserCallback.bind(this));
		}
	},
	
	getCurrentMobageUser: function() {
		if(this._loggedInMobageUser != null) {
			return this._loggedInMobageUser;
		}
		else{
			this._socialApiCall(this._fields, this.getCurrentMobageUser.bind(this));
		}
	},
	
	isValidUser: function(){
		var returnAble = false;
		
		if(this._loggedInMobageUser == null){
			returnAble = false;
		} else {
			var oldUser = this._loggedInMobageUser;
			var uFields = ["id"];

			this.loadCurrentMobageUser();
			
			if(oldUser.id == this._loggedInMobageUser.id)
			{
				returnAble = true;
			}
		}
		
		return returnAble;
	},

	_socialApiCall: function(fields, callback) {
		
		UIFactory.showProgressHUD(GALocalizationHandler.getLocalizedString("contactingMobage"));
		if(!callback)
		{
			callback = function() { UIFactory.hideProgressHUD(); };
		}
		
		Social.Common.People.getCurrentUser(fields, function() { callback(), UIFactory.hideProgressHUD()});
	},
	
	_loadUserCallback: function(error, user,aCallback) {
		if (error) {
			if (this._loginRetryCount > 0) {
				this.loadCurrentMobageUser(aCallback);
				this._loginRetryCount = this._loginRetryCount - 1;
			} else {
				this._loginRetryCount = 9;
				UIFactory.hideProgressHUD();
				UIFactory.showToast(GALocalizationHandler.getLocalizedString("UserAuthorizationFailureMsg"));
			}
		} else {
		
			UIFactory.hideProgressHUD();
			
			this._loggedInMobageUser = user;
			if(aCallback != null){
				aCallback(this._loggedInMobageUser);
			}
		}
	},
	showCommunityButton: function(btnGravity){
		UIFactory.showProgressHUD(GALocalizationHandler.getLocalizedString("contactingMobage"));
		Social.Common.Service.showCommunityButton(btnGravity, 'default',function(error){
			if(!error) {
				console.log('I have added the community Button');
			} else {
				for(x in error)
					console.log('There was an error adding the community button: ' + error + " , " + x + " ,  " + error[x]);
			}
            UIFactory.hideProgressHUD();
		});
	},
	hideCommunityButton: function(){
		Social.Common.Service.hideCommunityButton();
	},
	
	setCallback: function(aCallback){
		this.aCallback = aCallback;
	},
	removeCallback: function(){
		this.aCallback = null;
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/ngAPI/GACommon/GAManifestContentDownloader'] = function(){var exports = $MODULE_REGISTRY['Code/ngAPI/GACommon/GAManifestContentDownloader'] || {}; $MODULE_REGISTRY['Code/ngAPI/GACommon/GAManifestContentDownloader'] = exports; exports.GAManifestContentDownloader = Core.Class.subclass({

    classname: 'GAManifestContentDownloader',

    initialize: function(url, localPath, filename, ref) {
		this._url = url;
		this._localPath = localPath;
        this._filename = filename;
        this._reference = ref;
         
        this.doDownload();
    },
    doDownload: function() {
        this.dl = new Network.DownloadManifest(); 
        this.dl.start(this._url, this._localPath, this._filename, this._progressCb.bind(this._reference), this._doneCb.bind(this));
    },
    retry: function() {
    	this.dl.start(this._url, this._localPath, this._filename, this._progressCb.bind(this._reference), this._doneCb.bind(this));
    },
    _progressCb: function ( completedRequests, totalRequests ) {
		if(completedRequests <= totalRequests){
			var percentage = 0;
			if(totalRequests > 0) {
				percentage = (parseInt((completedRequests/totalRequests)*100))*0.25;
			}
			else {
				percentage = 25;
			}
			this.updateDownloadingProgress(percentage);
		}
		else {
			
		}
	},
    _doneCb: function ( err, manifest ) {
        if(err) {
        	var errorAlert = new UI.AlertDialog();
    		errorAlert.setTitle(ALERT_MSG_FAILURE_TITLE);
    		errorAlert.setText(ALERT_MSG_MANIFEST_DOWNLOAD_FAILURE);
    		errorAlert.setChoices(["Retry"]);
			var self = this;
			errorAlert.onchoice = function(ret) {
				errorAlert.hide();
				self.retry();
				errorAlert.destroy();
			};
			errorAlert.show();
        }	
        else {
        	this._reference.doneDownloading();
        }
    },
    destroy: function() {
		if(this.dl)
		{
			this.dl.destroy();
			this.dl = null;
		}
    }
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/ngAPI/GAHandler/GAInterfaceListener'] = function(){var exports = $MODULE_REGISTRY['Code/ngAPI/GAHandler/GAInterfaceListener'] || {}; $MODULE_REGISTRY['Code/ngAPI/GAHandler/GAInterfaceListener'] = exports; 
exports.GAInterfaceListener = Core.MessageListener.subclass({
    classname: 'GAInterfaceListener',
    
    initialize: function() {
		Device.OrientationEmitter.addListener(this, this.onUpdate);
	},
	onUpdate : function(msg) { //Orientation Update
		if (msg.type == Device.OrientationEmitter.OrientationType.Interface && msg.orientation != Device.OrientationEmitter.Orientation.LandscapeLeft) {
			Device.OrientationEmitter.setInterfaceOrientation(Device.OrientationEmitter.Orientation.LandscapeLeft, false);
		}
	},
	destroy: function() {
		Device.OrientationEmitter.removeListener(this);
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/ngAPI/GAActions/GAMoveTo'] = function(){var exports = $MODULE_REGISTRY['Code/ngAPI/GAActions/GAMoveTo'] || {}; $MODULE_REGISTRY['Code/ngAPI/GAActions/GAMoveTo'] = exports; exports.GAMoveTo = Core.Class.subclass({
    classname: 'GAMoveTo',
    
    initialize: function(node, time, endPosition, callback, intervalCallback) {
		this._callback = callback;
		this._node = node;
		this._startPosition = new Core.Point(node.getPosition().getX(), node.getPosition().getY());
		this._endPosition = endPosition;
		this._delta = new Core.Point(this._endPosition.getX() - this._startPosition.getX(), this._endPosition.getY() - this._startPosition.getY());
		this._duration = time;
		this._intervalCallback = intervalCallback;
	},
	runAction: function() {
		this._timer = setTimeout(this.update.bind(this, 0), 100);
	},
	update: function(t) {		
		if(t < this._duration) {
			t += 100;
			this.updateAction(Math.min(t/this._duration,1));
			if(this._intervalCallback != null) {
				this._intervalCallback();
			}
			this._timer = setTimeout(this.update.bind(this, t), 100);
		}
		else {
			if(this._callback){
				this._callback();
			}
			else {
				this.stopAction();
			}
		}
	},
	updateAction: function(dT) {
		this._node.setPosition(new Core.Point(this._startPosition.getX() + this._delta.getX() * dT, this._startPosition.getY() + this._delta.getY() * dT));
	},
	/*update: function(t, dT) {
		t += 100;
		this._node.setPosition(new Core.Point(this._startPosition.getX() + this._delta.getX() * dT, this._startPosition.getY() + this._delta.getY() * dT));
		if(t < this._duration) {
			this._timer = setTimeout(this.update.bind(this, t, t/this._duration), 100);
		}
		else {
			console.log("update: endPos"+ this._endPosition.getX() +"-"+this._endPosition.getY());
			console.log("update: nodePos" + this._node.getPosition().getX()+ "-"+this._node.getPosition().getY());
			this._callback();
			//this.destroy();
		}
	},*/
	stopAction: function() {
		 clearTimeout(this._timer);
		 this.destroy();
	},
	destroy: function() {
		delete this._startPosition;
		delete this._delta;
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/ngAPI/GAInApp/GAPurchaseSyncHandler'] = function(){var exports = $MODULE_REGISTRY['Code/ngAPI/GAInApp/GAPurchaseSyncHandler'] || {}; $MODULE_REGISTRY['Code/ngAPI/GAInApp/GAPurchaseSyncHandler'] = exports; 
exports.GAPurchaseSyncHandler = Core.Class.singleton ({

	synchPendingTransactions: function(callback) {
		this._awardCurrency = callback;
		// Get pending transactions and process them.
		var myself = this;
		Bank.Debit.getPendingTransactions(
			function(error, transactionIds) {
				if (error){
					var errorCode = error.errorCode;
					var errorDesc = error.description;
					console.log('Could not retrieve pending transactions. error: ' +errorCode + ', ' + errorDesc);
				}
				else if (transactionIds && (transactionIds.length >= 1)) {
					//console.log("TOTAL PENDING TXNS: " + transactionIds.length);
					myself._processOneTransaction(transactionIds);
				}
		});
	},
	
	// Create a function to process a single transaction at a time. This method prevents uncontrolled numbers of HTTP connections.
	_processOneTransaction: function (transactionIds) {
		var myself = this;
		if (transactionIds.length <= 0) {
			return;
		}
		var oneTransactionId = transactionIds.pop();
		Bank.Debit.getTransaction(oneTransactionId,
			function(error, tx) {
				myself._walkForward(error, tx.transaction, transactionIds);
		});
	},
	
	// Provide a means of processing a transaction in different states.
	_walkForward: function(error, tx, transactionIds) {
		var myself = this;
		//console.log("TXN: " + JSON.stringify(tx));
		if (error || (!error && !tx) || (!error && !tx && !tx.state)) {
			var errorCode = error.errorCode;
			var errorDesc = error.description;
			console.log('Error while processing transaction, Error: ' + errorCode + ', ' + errorDesc);
			myself._processOneTransaction(transactionIds);
		}
		else if (tx.state.toUpperCase() == 'NEW') {
			//console.log("Inside NEW");
			// When a tx is in the "new" state, you can call either continueTransaction() or cancelTransaction();
			Bank.Debit.cancelTransaction(tx.id,
				function(error,transaction){
					myself._processOneTransaction(transactionIds);
				});
		}
		else if (tx.state.toUpperCase() == 'AUTHORIZED') {
			//console.log("Inside AUTHORIZED");
			/* When a tx is in the "authorized" state,
			 * inventory is available funds are in escrow, and the user wants to move forward with the transaction.
			 * You can call openTransaction() or cancelTransaction().
			 */
			Bank.Debit.openTransaction(tx.id,
				function(error,transaction){
					if (error || (!error && !transaction) || (!error && !transaction && !transaction.state)) {
						var errorCode = error.errorCode;
						var errorDesc = error.description;
						console.log('Error while processing transaction, Error: ' + errorCode + ', ' + errorDesc);
						myself._processOneTransaction(transactionIds);
					}
					else {
						if (GAInAppPurchaseHandler.hasBeenCompleted(tx.id) == false) {
							myself._awardCurrency(myself.extractItemId(transaction.item.sku));
							GAInAppPurchaseHandler.addToCompletedTransactions(transaction.id);
						}
						Bank.Debit.closeTransaction(tx.id,
							function(error, transaction) {
								// Game-specific logic here
								myself._processOneTransaction(transactionIds);
						});
					}
				});
		}
		else if (tx.state == 'OPEN') {
			//console.log("Inside OPEN");
			/* When a tx is in the "open" state, you must ensure that the ordered items were delivered, 
			 * or that you deliver the items. You may call closeTransaction() or cancelTransaction.
			 * WARNING DO NOT CALL closeTransaction() if you have not delivered the item to the game client! 
			 */
			 if (GAInAppPurchaseHandler.hasBeenCompleted(tx.id) == true){
				Bank.Debit.closeTransaction(tx.id,
					function(error, transaction) {
					// Game-specific logic here
					myself._processOneTransaction(transactionIds);
				});
			}
			else {
				this._awardCurrency(myself.extractItemId(tx.item.sku));
				GAInAppPurchaseHandler.addToCompletedTransactions(tx.id);
				Bank.Debit.closeTransaction(tx.id,
					function(error, transaction) {
						// Game-specific logic here
						myself._processOneTransaction(transactionIds);
				});
			}
		}
		else {
			// Game-specific logic here for unknown state, this is unlikely
			console.log("GAInAppPurchaseHandler.synchPendingTransaction: Transaction is in unknown state");
			myself._processOneTransaction(transactionIds);
		}
	},

	extractItemId: function(sku) {
		if (sku != null) {
			// sku is in the form "debit:mallbucks_22"
			return sku.replace("debit:", "");
		}
		return null;
	}
	
});; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/GL2/Animation'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/GL2/Animation'] || {}; $MODULE_REGISTRY['NGCore/Client/GL2/Animation'] = exports; var Core = require('NGCore/Client/Core').Core;

exports.Animation = Core.Class.subclass(
/** @lends GL2.Animation.prototype */
{
	classname: 'Animation',
    
	/**
	 * @class The <code>Animation</code> class constructs objects that define application animations. Animations aggregate and control 
	 * the instantiation of <code>Frame</code> objects for manipulation of <code>{@link GL2.Sprite}</code> and
	 * <code>{@link GL2.Primitive}</code> objects. Each <code>Frame</code> object defines a duration and an image display area. 
	 * <code>Frame</code> objects also include a pre-transform 
	 * offset that define the rotation and scale of sprite images. 
	 * @constructs The default constructor.
	 * @augments Core.Class
	 */
    initialize: function()
    {
		Core.ObjectRegistry.register(this);
		
        this._wrapMode = this.WrapMode.WrapNone;
        this._blendEnabled = true;
        this._blendMode = this.BlendMode.Alpha;
        this._filteringEnabled = true;
		this._loopingEnabled = true;
		this._totalDuration = 0;
		this._frames = [];
		
		this._createSendGen(this.__objectRegistryId);
    },

	/**
	 * Destroy this instance and release resources on the backend.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	destroy: function()
	{
		this._destroySendGen();
		Core.ObjectRegistry.unregister(this);
	},
	
	/**
	 * Retrieve the specified texture wrap mode for this <code>Animation</code>.
	 * @returns {GL2.Animation#WrapMode} The current texture wrap mode.
	 * @see GL2.Animation#setWrapMode
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getWrapMode: function()
	{
		return this._wrapMode;
	},
	
	/**
	 * Retrieve the alpha blending state for this <code>Animation</code>.
	 * @returns {Boolean} Returns <code>true</code> if alpha blending is enabled. Returns <code>false</code> in all other cases.
	 * @see GL2.Animation#setBlendEnabled
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getBlendEnabled: function()
	{
		return this._blendEnabled;
	},
	
	/**
	 * Retrieve the filtering state for this <code>Animation</code>. 
	 * @returns {Boolean} Returns <code>true</code> if filtering is enabled. Returns <code>false</code> in all other cases.
	 * @see GL2.Animation#setFilteringEnabled
	 */
	getFilteringEnabled: function()
	{
		return this._filteringEnabled;
	},
	
	/**
	 * Retrieve the looping state of this <code>Animation</code>.
	 * @returns {Boolean} Returns <code>true</code> if looping is enabled. Returns <code>false</code> in all other cases.
	 * @see GL2.Animation#setLoopingEnabled
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getLoopingEnabled: function()
	{
		return this._loopingEnabled;
	},
	
	/**
	 * Retrieve the total duration of this <code>Animation</code> in milliseconds.
	 * @returns {Number} The current duration. 
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getTotalDuration: function()
	{
		return this._totalDuration;
	},
	
	/**
	 * Retrieve the total number of frames in this <code>Animation</code>.
	 * @returns {Number} The current number of frames. 
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getFrameCount: function()
	{
		return this._frames.length;
	},
	
	/**
	 * Retrieve a frame at the specified index for this <code>Animation</code>.
	 * @param {Number} index The specified index.
	 * @returns {GL2.Animation.Frame} The current frame at the specified index.
	 * @see GL2.Animation#setFrame
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getFrame: function(index)
	{
		return this._frames[index];
	},
    
    /**
	 * Apply a wrap mode to frame textures for this <code>Animation</code>.
	 * @param {GL2.Animation#WrapMode} [wrapMode=0] The new texture wrap mode.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Animation#getWrapMode
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */						
    setWrapMode: function(wrapMode)
	{
		this._wrapMode = wrapMode;
		
		this._setWrapModeSendGen(wrapMode);
		
		return this;
	},
    
    /**
	 * Set the alpha blending state for this <code>Animation</code>. 
	 * <br><br>
	 * <b>Note:</b> You can improve performance for animations with completely opaque frames by disabling alpha blending.
	 * @param {Boolean} [blendEnabled=true] Set as <code>true</code> to enable alpha blending.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Animation#getBlendEnabled
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setBlendEnabled: function(blendEnabled)
	{
		this._blendEnabled = blendEnabled;
		
		this._setBlendEnabledSendGen(blendEnabled);
		
		return this;
	},
	
	/**
	 * Set the alpha blend mode.
	 * @see GL2.Animation#setBlendEnabled
	 * @status Android,AndroidTested
	 */
	setBlendMode: function(blendMode)
	{
		this._blendMode = blendMode;
		
		this._setBlendModeSendGen(blendMode);
		
		return this;
	},
	
	getBlendMode: function()
	{
		return this._blendMode;
	},
	
    /**
	 * Set the filtering state for this <code>Animation</code>.
	 * <br><br>
	 * @param {Boolean} [filteringEnabled=false] Set as <code>true</code> to enable filtering. 
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Animation#getFilteringEnabled
	 */
    setFilteringEnabled: function(filteringEnabled)
	{
		this._filteringEnabled = filteringEnabled;
		
		this._setFilteringEnabledSendGen(filteringEnabled);
		
		return this;
	},
    
    /**
	 * Set the looping state for this <code>Animation</code>.
	 * @param {Boolean} [loopingEnabled=false] Set as <code>true</code> to enable animation looping.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Animation#getLoopingEnabled
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setLoopingEnabled: function(loopingEnabled)
	{
		this._loopingEnabled = loopingEnabled;
		
		this._setLoopingEnabledSendGen(loopingEnabled);
		
		return this;
	},
    
    /**
	 * Add a frame to the end of this <code>Animation</code>.<br><br>
	 * <pre class="code"><font size="2">var animation = new GL2.Animation();
	 * animation.pushFrame(new GL2.Animation.Frame('Content/tank.png', 50, [64, 64], [0.5, 0.5], [0/5, 0, 1/5, 1]));</font></pre>
	 * Calling <code>pushFrame()</code> is equivalent to calling <code>spliceFrames()</code> in the following way: 
	 * <pre class="code"><font size="2">animation.spliceFrames(animation.getFrameCount(), 0, frame);</font></pre>
	 * @param {GL2.Animation.Frame} frame The frame to add.
	 * @see GL2.Animation#spliceFrames
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    pushFrame: function(frame)
	{
		return this.spliceFrames(this._frames.length, 0, frame);
	},
    
    /**
	 * Replace the frame at index <i>i</i>.<br><br>
	 * Calling <code>setFrame()</code> is equivalent to calling <code>spliceFrames()</code> in the following way: 
	 * @example animation.spliceFrames(i, 1, frame)
	 * @param {Number} i Index of the frame to replace.
	 * @param {GL2.Animation.Frame} frame The frame to insert.
	 * @see GL2.Animation#getFrame,
	 * @see GL2.Animation#spliceFrames
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setFrame: function(i, frame)
	{
		return this.spliceFrames(i, 1, frame);
	},
    
    /**
	 * Remove a specific number of frames from this <code>Animation</code> and replace them with specified frames.
	 * <br><br>
	 * <b>Note:</b> This method accepts multiple parameters. The third parameter and beyond define all
	 * <code>Frames</code> to use for replacement.<br><br>
	 * The following example passes in three frames to a <code>spliceFrames()</code> call.
	 * @example animation.spliceFrames(0, 0, frame1, frame2, frame3).
	 * @param {Number} start The index of the first frame to remove.
	 * @param {Number} len The total number of frames to remove.
	 * @param {GL2.Animation.Frame} frames The frames to insert. 
	 * <br><br>
	 * <b>Note:</b> This parameter accepts multiple values.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    spliceFrames: function(start, len, frames)
	{
		var i;
		var frameCount = arguments.length-2;
		var frame;

		// Determine if we should use the v2 version of the messsage, which supports renderTargets.
		// This is so that new javaScript that doesn't use renderTargets will still work with an old binary.
		var useV2 = false;
		for (i = 0; i < frameCount; ++i) {
			frame = arguments[i+2];
			if (frame.getImage().classname === 'RenderTarget')
				useV2 = true;
		}

		// Decrement from total duration.
		for (var i=start; i < start + len; ++i) {
			this._totalDuration -= this._frames[i].getDuration();
		}
		
		this._frames.splice.apply(this._frames, arguments);

		if (useV2) {
			this._spliceFrames2SendGen(start, len, frameCount);
		} else {
			this._spliceFramesSendGen(start, len, frameCount);
		}
		
		for (i = 0; i < frameCount; ++i)
		{
			frame = arguments[i+2];
			var duration = frame.getDuration();
			var size = frame.getSize();
			var anchor = frame.getAnchor();
			var uvs = frame.getUVs();
			var uvOrigin = uvs.getOrigin();
			var uvSize = uvs.getSize();
			var image = frame.getImage();

			// if image is a renderTarget
			var renderTargetID = 0;
			if (image.classname === 'RenderTarget') {
				renderTargetID = image.__objectRegistryId;
				image = '';
			}

			if (useV2) {
				this._frame2SendGen(image,
									renderTargetID,
									duration,
									size.getWidth(),
									size.getHeight(),
									anchor.getX(),
									anchor.getY(),
									uvOrigin.getX(),
									uvOrigin.getY(),
									uvSize.getWidth(),
									uvSize.getHeight());
			} else {
				this._frameSendGen(image,
								   duration,
								   size.getWidth(),
								   size.getHeight(),
								   anchor.getX(),
								   anchor.getY(),
								   uvOrigin.getX(),
								   uvOrigin.getY(),
								   uvSize.getWidth(),
								   uvSize.getHeight());
			}
			this._totalDuration += duration;
		}
		
		return this;
	},
	
	$Frame: Core.Class.subclass(
	/** @lends GL2.Animation.Frame.prototype */
	{
		classname: 'Frame',
		
		/**
		 * @class <code>Frame</code> objects define a path to an image and any properties that support the image as
		 * a single frame in an animation.
		 * @constructs The default constructor. 
		 * @param {String|GL2.RenderTarget} image The directory path to an image, or an instance of GL2.RenderTarget.
		 * @param {Number} duration The time duration of the frame in milliseconds.
		 * @param {Core.Size} size The size of the frame in pixels.
		 * @param {Core.Point} anchor The offset within the frame used for scaling and rotation.
		 * @param {Core.Rect} uvs The image region to use for the frame. The default value is <code>[0,0,1,1]</code> (the entire image) 
		 * with a start coordinate of <code>(0,0)</code> and a size of <code>(1,1)</code>.<br><br> 
		 * <b>Example:</b> To select the lower left region of an image with nine distinct frames (three horizontally, three vertically), 
		 * you would specify <code>[0, 0.66, 0.33, 0.33]</code>. The start coordinate is <code>(0, 0.66)</code>, 
		 * which is the left edge of the image and 2/3rds down. 
		 * The size is <code>(0.33, 0.33)</code> which is a third of the image in each <i>x</i> and <i>y</i> direction.
		 * @see GL2.Animation
		 * @default [0,0,1,1] (the entire image)
		 * @augments Core.Class
		 */
		initialize: function(image, duration, size, anchor, uvs)
		{
			this._image     = image;
			this._duration  = duration || 0;
			this._size   = new Core.Size(size);
			
			if(anchor)
				this._anchor = new Core.Point(anchor);
			else
				this._anchor = new Core.Point(0.5, 0.5);
			
			if(uvs)
				this._uvs = new Core.Rect(uvs);
			else
				this._uvs = new Core.Rect(0, 0, 1, 1);
		},

		/**
		 * Retrieve the image directory path or the renderTarget referenced by this <code>Frame</code>.
		 * @returns {String|GL2.RenderTarget} The current directory path to the image, or a GL2.RenderTarget instance.
		 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
		 */
		getImage:    function()
		{
			return this._image;
		},
		
		/**
		 * Retrieve time duration in milliseconds for this <code>Frame</code>.
		 * @returns {Number} The current time duration for the frame.
		 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
		 */
		getDuration:  function()
		{
			return this._duration;
		},

		/**
		 * Retrieve the pixel size of this <code>Frame</code>.
		 * @returns {Core.Size} The current frame size in pixels.
		 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
		 */
		getSize:    function()
		{
			return this._size;
		},

		/**
		 * Retrieve the offset used for scaling and rotation from within this <code>Frame</code>.
		 * @returns {Core.Point} The current frame offset.
		 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
		 */
		getAnchor:  function()
		{
			return this._anchor;
		},

		/**
		 * Retrieve the texture rectangle for this <code>Frame</code> in UV coordinates.
		 * @returns {Core.Rect} The current UV bounds of the frame within the texture.
		 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
		 */
		getUVs:    function()
		{
			return this._uvs;
		},
	}),
	
// {{?Wg Generated Code}}
	
	// Enums.
	/** 
	 * Enumeration for UV wrapping modes.
	 * @namespace
	 */
	WrapMode:
	{ 
		/** Clamp in both U and V. */
		WrapNone: 0,
		/** Wrap in U, clamp in V. */
		WrapU: 1,
		/** Wrap in V, clamp in U. */
		WrapV: 2,
		/** Wrap in both U and V. */
		WrapUV: 3,
	},
	
	/** 
	 * Enumeration for Blend modes.
	 * @namespace
	 */
	BlendMode:
	{ 
		/** blend func: (src alpha, 1 - src alpha). */
		Alpha: 1,
		/** blend func: (src alpha, 1). */
		Add: 2,
	},
	
	///////
	// Class constants (for internal use only):
	// Class ID = 306
	// Method create = -1
	// Method destroy = 2
	// Method setWrapMode = 3
	// Method setBlendEnabled = 4
	// Method setLoopingEnabled = 5
	// Method spliceFrames = 6
	// Method frame = 7
	// Method setFilteringEnabled = 8
	// Method spliceFrames2 = 9
	// Method frame2 = 10
	// Method setBlendMode = 11
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Animation._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Animation._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[306] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":306,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":306,2," + this.__objectRegistryId );
	},
	
	/** @private */
	_setWrapModeSendGen: function( wrapMode )
	{
		Core.Proc.appendToCommandString( ":306,3," + this.__objectRegistryId + "," + wrapMode  );
	},
	
	/** @private */
	_setBlendEnabledSendGen: function( blendEnabled )
	{
		Core.Proc.appendToCommandString( ":306,4," + this.__objectRegistryId + "," + ( blendEnabled ? 1 : 0 )  );
	},
	
	/** @private */
	_setLoopingEnabledSendGen: function( loopingEnabled )
	{
		Core.Proc.appendToCommandString( ":306,5," + this.__objectRegistryId + "," + ( loopingEnabled ? 1 : 0 )  );
	},
	
	/** @private */
	_spliceFramesSendGen: function( start, len, frameCount )
	{
		Core.Proc.appendToCommandString( ":306,6," + this.__objectRegistryId + "," + start + "," + len + "," + frameCount  );
	},
	
	/** @private */
	_frameSendGen: function( image, duration, width, height, anchorX, anchorY, startU, startV, sizeU, sizeV )
	{
		Core.Proc.appendToCommandString( "," + Core.Base64.encode( image ) + "," + duration + "," + width + "," + height + "," + anchorX + "," + anchorY + "," + startU + "," + startV + "," + sizeU + "," + sizeV  );
	},
	
	/** @private */
	_setFilteringEnabledSendGen: function( filteringEnabled )
	{
		Core.Proc.appendToCommandString( ":306,8," + this.__objectRegistryId + "," + ( filteringEnabled ? 1 : 0 )  );
	},
	
	/** @private */
	_spliceFrames2SendGen: function( start, len, frameCount )
	{
		Core.Proc.appendToCommandString( ":306,9," + this.__objectRegistryId + "," + start + "," + len + "," + frameCount  );
	},
	
	/** @private */
	_frame2SendGen: function( image, renderTargetID, duration, width, height, anchorX, anchorY, startU, startV, sizeU, sizeV )
	{
		Core.Proc.appendToCommandString( "," + Core.Base64.encode( image ) + "," + renderTargetID + "," + duration + "," + width + "," + height + "," + anchorX + "," + anchorY + "," + startU + "," + startV + "," + sizeU + "," + sizeV  );
	},
	
	/** @private */
	_setBlendModeSendGen: function( blendMode )
	{
		Core.Proc.appendToCommandString( ":306,11," + this.__objectRegistryId + "," + blendMode  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// setWrapMode: function( wrapMode ) {}
	
	// setBlendEnabled: function( blendEnabled ) {}
	
	// setLoopingEnabled: function( loopingEnabled ) {}
	
	// spliceFrames: function( start, len, frameCount ) {}
	
	// frame: function( image, duration, width, height, anchorX, anchorY, startU, startV, sizeU, sizeV ) {}
	
	// setFilteringEnabled: function( filteringEnabled ) {}
	
	// spliceFrames2: function( start, len, frameCount ) {}
	
	// frame2: function( image, renderTargetID, duration, width, height, anchorX, anchorY, startU, startV, sizeU, sizeV ) {}
	
	// setBlendMode: function( blendMode ) {}
	

// {{/Wg Generated Code}}
});

; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/GL2/Node'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/GL2/Node'] || {}; $MODULE_REGISTRY['NGCore/Client/GL2/Node'] = exports; var Core = require('NGCore/Client/Core').Core;

exports.Node = Core.Class.subclass(
/** @lends GL2.Node.prototype */
{
	classname: 'Node',
	
	/**
	 * @class The <code>Node</code> class constructs base class objects that contain positionable elements in the GL2 module. 
	 * Applications can use <code>Node</code> objects for grouping and organizing the scene graph. 
	 * <p>
	 * Inside the <code>{@link UI.GLView}</code> class, positionable elements are organized into a node hierarchy. This data
	 * structure is analgous to a scene graph or a node tree. Child nodes inherit data for
	 * transform, visibility, and depth from the parent on a conditional basis. Most drawable attributes for nodes, such as size and color, are specified in 
	 * derived classes. 
	 *</p><p>
	 * All derived GL2 classes from <code>Node</code> are native-backed proxies including <code>Node</code>.
	 * When a <code>Node</code> is instantiated on the Javascript side, a C++ object
	 * is instantiated and managed for the user on the native backend. This condition means the application
	 * must explicity destroy any <code>Node</code> that is no longer used.
	 *</p><p>
	 * A <code>Node</code> can exist independent of the scene, but it will only receive draw or touch updates
	 * when it is attached to the root tree.
	 *</p>
	 *<div class="ul">
	 * <li>Add a node as a child to the root of the scene with <code>{@link GL2.Root#addChild}</code>.</li> 
	 * <li>Add a node as a child to another node with <code>{@link GL2.Node#addChild}</code>.</li>
	 * <li>Remove a node from the root of the scene with <code>{@link GL2.Root#removeChild}.</code></li>
	 * <li>Remove a child node from a parent node with <code>{@link GL2.Node#removeChild}</code>.</li> 
	 *</div><br>
	 * <p>
	 * Call <code><a href="GL2.Node.html#destroy">destroy()</a></code> to automatically remove a node from the parent node.
	 * As previously noted, nodes are supported by a native object on the backend. Maintaining a 
	 * node reference outside of the scene instead of calling <code>destroy()</code> and recreating a new node is a recommended best practice.
	 *</p><p>
	 * Absolute positioning of a single node is determined by the following properties in the defined order:
	 *</p>
	 *<div class="ol">
	 * <li>Scale (two-component [x,y] multiple)</li>
	 * <li>Rotation (degrees about z-axis)</li>
	 * <li>Position (two-component translation)</li>
	 *</div><br>
	 * <p>
	 * Each of these properties is applied to the node relative to the parent node. The final transform
	 * for any given node is the concatenation of each transform in the node graph ancestry. The
	 * root ancestor is fixed to the view and composes the scene so that <code>(0,0)</code> is in the upper
	 * left corner. The first anchored
	 * offset to rotate and scale around is not specified because nodes do not inherently contain a size <code>(see {@link GL2.Animation.Frame#getAnchor}</code>). 
	 *</p><p>
	 * The <code>Depth</code> property of a <code>Node</code> object determines that <code>Node</code> sort order when traversing the scene graph.
	 * Depth is roughly equivalent to z-order or index. Each node is sorted among siblings by
	 * <code>Depth</code>, starting with the lowest depth node and sorting in ascending order.
	 *</p><p>
	 * By default, <code>Nodes</code> are grouped 
	 * with their siblings (not interleaved with cousins) and sorted relative to their parent 
	 * as if the parent depth value was <code>0</code>. However, you can modify this behavior for specific use cases 
	 * with <code><a href="GL2.Node.html#setChildrenDepthGrouped">setChildrenDepthGrouped()</a></code>. 
	 *</p><p>
	 * The node depth (order) in the scene graph will dictate the drawing order and determines what the final frame will look like.
	 * When drawing, <code>GL2.Node</code> utilizes the painter's algorithm.
	 * This means lower depth nodes are obscured by higher depth nodes.
	 * Touch priority occurs in reverse order to drawing order. Touches travel through the scene from higher depth to lower depth nodes 
	 * (front of scene earlier to back of scene later).
	 *</p><p>
	 * As a base class, a <code>Node</code> is not drawable but does maintain <code>Color</code> and <code>Alpha</code>
	 * attributes (see <code><a href="GL2.Node.html#getColor">getColor()</a></code> and <code><a href="GL2.Node.html#getAlpha">getAlpha()</a></code>). 
	 * Child nodes that contain drawable derived classes from 
	 * <code>Node</code> inherit these attributes.
	 * As a result, setting the <code>Color</code> for a parent node affects the color of every child node through multiplication
	 * of color components.</p>
	 * <p>Classes derived from Node include:</p>
	 * <div class="ul">
	 * <li>{@link GL2.Primitive}</li>
	 * <li>{@link GL2.Sprite}</li>
	 * <li>{@link GL2.Text}</li>
	 * </div>
	 * @constructs The default constructor. 
	 * @augments Core.Class
	 */
    initialize: function()
    {
		Core.ObjectRegistry.register(this);
        this._parent = null;
        this._position = new Core.Point();
        this._scale = new Core.Vector(1, 1);
        this._color = new Core.Color(1, 1, 1);
        this._alpha = 1;
        this._rotation = 0;
        this._depth = 0;
        this._visible = true;
        this._touchable = true;
		
        this._childrenDepthGrouped = true;
        this._children = [];
		
		this._createSendGen(this.__objectRegistryId);
    },

	/**
	 * The default destructor. Calling <code>destroy()</code> removes the node from the parent, which releases the
	 * native object on the backend. 
	 * <br><br>
	 * <b>Note:</b> Applications must call this explicitly for nodes that are no longer
	 * used.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	destroy: function()
	{
		children = this._children;
		while(children.length)
		{
			this.removeChild(children[0]);
		}
			
		if(this._parent)
		{
			this._parent.removeChild(this);
		}
		
		this._destroySendGen();
		Core.ObjectRegistry.unregister(this);
	},

	/**
	 * Retrieve the position of this <code>Node</code>.
	 * @returns {Core.Vector} The current node position relative to the parent.
	 * @see GL2.Node#setPosition
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getPosition: function()
	{
		return this._position;
	},
	
	/**
	 * Retrieve the <i>width</i> and <i>height</i> scale multiple of this <code>Node</code>. 
	 * The default scale <code>[1,1]</code> will not modify the resulting transform.
	 * @returns {Core.Vector} The current scale multiple (<i>width</i> and <i>height</i>).
	 * @see GL2.Node#setScale
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getScale: function()
	{
		return this._scale;
	},

	/**
	 * Retrieve the <code>Color</code> component of this <code>Node</code>. Values for <code>Color</code> are based on the RGB color model. 
	 * When drawing, the values for <code>Color</code> are multiplied by the value of each drawable pixel. Child nodes will multiply
	 * the values for <code>Color</code> by the parent composite color before drawing. 
	 * @returns {Core.Color} The current value of all three color components (red, green, blue).
	 *<br><br>
	 * <b>Note:</b> The default RGB triplet <code>[1,1,1]</code> does not produce a color change.
	 * @see Core.Color, 
	 * @see GL2.Node#setColor
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getColor: function()
	{
		return this._color;
	},

	/**
	 * Retrieve the <cod>alpha</code> components of this <code>Node</code>.
	 * @returns {Number} The new alpha blending state across the open interval ranging between <code>(0-1)</code>. 
	 * (0 = completely transparent, 1 = completely opaque). Expressed as a float.
	 * @see GL2.Node#setAlpha
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getAlpha: function()
	{
		return this._alpha;
	},

	/**
	 * Retrieve the <code>rotation</code> component for this <code>Node</code>.
	 * The default value is 0 degrees about the z-axis.
	 * @returns {Number} The current degree of rotation. Expressed as a float.
	 * @see GL2.Node#setRotation
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getRotation: function()
	{
		return this._rotation;
	},

	/**
	 * Retrieve the <code>depth</code> component for this <code>Node</code>.
	 * The default value is <code>0</code>.
	 * Applications will sort nodes with identical depth values by the last 
	 * time the node was attached to the root node graph.
	 * @returns {Number} The current node depth level (z-order). Expressed as a float.
	 * @see GL2.Root and 
	 * @see GL2.Node#setDepth
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getDepth: function()
	{
		return this._depth;
	},

	/**
	 * Retrieve the <code>visible</code> component for this <code>Node</code>.
	 * This component defines visibility of the node.
	 * The default value is <code>true</code>.<br><br>
	 * <b>Note:</b> A node can inherit the value of this component from parent nodes in the scene graph.
	 * @returns {Boolean} Returns <code>true</code> if the node is visible. Returns <code>false</code> in all other cases.
	 * @see GL2.Node#setVisible
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getVisible: function()
	{
		return this._visible;
	},

	/**
	 * Retrieve the <code>touchable</code> component for this <code>Node</code>.
	 * This component defines touch-support for a node.
	 * The default value is <code>true</code>.<br><br>
	 * <b>Note:</b> A node can inherit "not touchable" from parent nodes in the scene graph.
	 * @returns {Boolean} Returns <code>true</code> if a node is touchable. Returns <code>false</code> in all other cases.
	 * @see GL2.Node#setTouchable
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getTouchable: function()
	{
		return this._touchable;
	},
	

	/**
	 * Retrieve <code>childrenDepthGrouped</code> component of this <code>Node</code>.
	 * The default value is <code>true</code>.
	 * When <code>childrenDepthGrouped</code> is <code>false</code>, child nodes sort amongst (interleave 
	 * with) the children of the nearest depthgrouped ancestor.
	 * @returns {Boolean} Returns as <code>true</code> if sorting with ancestor siblings. Returns as <code>false</code> if sorting only with siblings in the graph.
	 * @see GL2.Node#setChildrenDepthGrouped
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getChildrenDepthGrouped: function()
	{
		return this._childrenDepthGrouped;
	},
	
	/**
	 * Retrieve the parent node for this <code>Node</code>.
	 * @returns {GL2.Node} The current parent node.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getParent: function()
	{
		return this._parent;
	},

	/**
	 * Retrieve a copy of the child array for this <code>Node</code>.
	 * @returns {Array GL2.Node} The current list of child nodes.
	 * @status 
	 */
	getChildren: function()
	{
		return this._children.slice();
	},
	
    /**
	 * Set the <code>translation</code> component of the transform for this <code>Node</code>.
	 * You can define the parameter value as a vector or two floats.<br><br>
	 * <b>Note:</b> An application can use this property to translate a group of nodes by
	 * translating the parent. Child nodes inherit this property from the parent node.<br/><br/>
	 * The following code examples illustrate different call styles for <code>setPosition()</code>.<br><br>
	 * 
	 * @example
	 * node.setPosition(new Core.Vector(50, 100));
	 *
	 * @example
	 * node.setPosition(50, 100);
	 * 
	 * @param {Core.Vector} position The new node position relative to the parent.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Node#getPosition,
	 * @see Core.Vector
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setPosition: function(position)
	{
		var p = this._position;
		p.setAll.apply(p, arguments);
		this._setPositionSendGen(p.getX(),p.getY());
		return this;
	},
	
    /**
	 * Set the <i>x</i> and <i>y</i> scale of the transform for this <code>Node</code>.<br><br>
	 * <b>Note:</b> This property affects the coordinate system of child nodes and scales drawing for
	 * derived classes like <code>Sprite</code>, <code>Text</code>, and <code>Primitive</code>.
	 * <br><br>
	 * The following code examples illustrate different call styles for <code>setScale()</code>.<br><br>
	 * 
	 * @example
	 * node.setScale(new Core.Vector(2, 0.5));
	 *
	 * @example
	 * node.setScale(2, 0.5);
	 * 
	 * @param {Core.Vector} scale The new scale multiple (<i>width</i> and <i>height</i>). You can define the parameter value as a vector or two floats.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Node#getScale, 
	 * @see GL2.Primitive, 
	 * @see GL2.Sprite, 
	 * @see GL2.Text
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setScale: function(scale)
	{
		var s = this._scale;
		s.setAll.apply(s, arguments);
		this._setScaleSendGen(s.getX(),s.getY());
		return this;
	},
	/**
	 * Set the color for the specified entity. Call this method either by reference to a single vector object  
	 * or by defining three float parameters.
	 * Every color pixel value for the entity is multiplied by the value of the parameter before drawing.
	 * <br><br>
	 * <b>Example:</b> If you specify an entity to draw an orange pixel <code>(1.0, 0.5, 0)</code>,
	 * but the entity color is purple <code>(0.5, 0, 1.0)</code>, the resulting pixel color is
	 * <code>(0.5, 0, 0)</code>, which is dark red. The application conducts this efficiently for each pixel in the
	 * entity.<br><br>
	 * The following code examples illustrate different call styles for <code>setColor()</code>.<br><br>
	 * 
	 * @example
	 * node.setColor(new Core.Color(1.0, 0.5, 0));
	 *
	 * @example
	 * node.setColor(1.0, 0.5, 0);
	 * 
	 * @param {Core.Color} color Pixel color value to muliply by the entity color value.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Color, 
	 * @see GL2.Node#getColor
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setColor: function(color)
	{
		var c = this._color;
		c.setAll.apply(c, arguments);
		this._setColorSendGen(c.getRed(),c.getGreen(),c.getBlue());
		return this;
	},
    /**
	 * Set the alpha blending state for the entity.
	 * Each pixel of the entity blends with the underlying surface. This occurs in proportion to the alpha blending state of the entity.
	 * The application must set the parameter value within the open interval <code>[0, 1]</code>.
	 * <br><br>
	 * <b>Example:</b> Drawing a red entity with an alpha of <code>0.5</code> over a white background results in a light pink entity. 
	 * Drawing an orange pixel <code>(1.0, 0.5, 0)</code> with an alpha of <code>0.66</code> over
	 * a light blue surface <code>(0.0, 1.0, 1.0)</code>, results in a light brown pixel:
	 * @example (1.0, 0.5, 0) * 0.66 + (0.0, 1.0, 1.0) * 0.34 = (0.6, 0.67, 0.34)
	 * @param {Number} alpha The new alpha blending state for the entity ranging between <code>(0-1)</code> 
	 * (0 = completely transparent, 1 = completely opaque). Expressed as a float.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Node#getAlpha
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setAlpha: function(alpha)
	{
		this._alpha = alpha;
		this._setAlphaSendGen(alpha);
		return this;
	},
	
    /**
	 * Set the transform rotation (in degrees) for this <code>Node</code>.<br><br> 	 
	 * <b>Note:</b> This property affects the coordinate system of child nodes and rotates drawing for
	 * derived classes like <code>Sprite</code>, <code>Text</code>, and <code>Primitive</code>.
	 * <br><br>
	 * The following code examples illustrate different call styles for <code>setRotation()</code>.<br><br>
	 * 
	 * Rotate entity 90 degrees.
	 * <pre class="code">node.setRotation(90);</pre> 
	 * Restore entity to original orientation.
	 * <pre class="code">node.setRotation(0);</pre>
	 * Convert radians to degrees.
	 * <pre class="code">var radians = 0.785;
	 * var degrees = radians * Math.PI / 180;</pre>
	 * Convert degrees to radians.
	 * <pre class="code">var degrees = 90;
	 * var radians = degrees * 180 / Math.PI;</pre>
	 *
	 * @param {Number} rotation The new rotation of the entity relative to the parent (in degrees). Expressed as a float.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Node#getRotation, 
	 * @see GL2.Primitive, 
	 * @see GL2.Sprite, 
	 * @see GL2.Text
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setRotation: function(rotation)
	{
		this._rotation = rotation;
		this._setRotationSendGen(rotation);
		return this;
	},
	
    /**
	 * Set the <code>depth</code> component for this <code>Node</code>.
	 * This property affects how a node is sorted when the scene is traversed. Different depth-levels affect
	 * both drawing order (back to front, low to high) and touch priority (front to back,
	 * high to low).<br><br>
	 * <b>Note:</b> Use <code>{@link GL2.Node#setChildrenDepthGrouped}</code> to set how a node will sort with siblings.
	 * @example node.setDepth(20);
	 * @param {Number} depth The new depth for the entity (z-order). Expressed as a float.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Node#getChildrenDepthGrouped, 
	 * @see GL2.Node#setChildrenDepthGrouped
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setDepth: function(depth)
	{
		if(this._depth != depth)
		{
			this._depth = depth;
			this._setDepthSendGen(depth);
		}
		return this;
	},
	
    /**
	 * Set the <code>visible</code> component for this <code>Node</code>.
	 * This component defines visibility of the node.
	 * The default value is <code>true</code>.<br><br>
	 * <b>Note:</b> A node can inherit the value of this component from parent nodes in the scene graph.
	 * @example node.setVisible(true);
	 * @param {Boolean} [visible=true] Set as <code>true</code> if a node is visible.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Node#getVisible
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setVisible: function(visible)
	{
		if(this._visible != visible)
		{
			this._visible = visible;
			this._setVisibleSendGen(visible);
		}
		return this;
	},
	
    /**
	 * Set this <code>Node</code> to support touches.
	 * The <code>touchable</code> property is Boolean and defines a node as supporting touch input.
	 * A node can inherit the value of <code>touchable</code> from parent nodes in the scene graph.<br><br> 
	 * <b>Caution!</b> Instantiating touchable <code>GL2.Node</code> objects will impact performance 
	 * much more than instantiating <code>GL2.Node</code> objects that do not support touch input. If
	 * a node does not need to support touch input, set <code>touchable</code> to <code>false</code>.
	 * @example node.setTouchable(false);
	 * @param {boolean} [touchable=true] Set as <code>true</code> if this node supports touch input.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Node#getTouchahble
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setTouchable: function(touchable)
	{
		this._touchable = touchable;
		this._setTouchableSendGen(touchable);
		return this;
	},
    
	/**
	 * Set whether to sort child nodes adjacent to this <code>Node</code>.
	 * When <code>childrenDepthGrouped</code> is <code>false</code>, the child nodes interleave 
	 * with the children of the nearest similarly grouped ancestor. Applications can use this to sort a distant node
	 * on an independent branch of the graph in close proximity.<br/><br/>
	 * <b>Example:</b> You have multiple group nodes containing a character sprite and a 
	 * shadow sprite. By setting all the shadow sprites to a <code>depth</code> of <code>1</code>, all character sprites to
	 * a <code>depth</code> of <code>2</code>, and setting <code>childrenDepthGrouped</code> to <code>false</code> for each group node, all character sprites will 
	 * sort above shadows when drawn.<br><br>
     * Look at the following structure of nodes.
     * If <code>childrenDepthGrouped</code> is <code>true</code> for the group, the primitive will
     * draw above both the sprite and the text. However, if <code>false</code>,
     * the primitive will draw after the sprite but before the text.
     * <pre class="code">
     * Root
     * +-- Group (depth = 0)
     * |   +-- Sprite (depth = 10)
     * |   +-- Text (depth = -10)
     * |
     * +-- Primitive (depth = 5)
     * </pre>
	 * @param {Boolean} childrenDepthGrouped Set as <code>true</code> to sort with ancestor siblings. Set as <code>false</code> to sort only with siblings in the graph.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Node#getChildrenDepthGrouped
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setChildrenDepthGrouped: function(childrenDepthGrouped)
	{
		if(this._childrenDepthGrouped != childrenDepthGrouped)
		{
			this._childrenDepthGrouped = childrenDepthGrouped;
			this._setChildrenDepthGroupedSendGen(childrenDepthGrouped);
		}
		return this;
	},
	
	/**
	 * Add a node as a child to this <code>Node</code>.
	 * @example node.addChild(this.mySprite);
	 * @param {GL2.Node} child The child node to add.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Node#removeChild
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	addChild: function(child)
	{
		// Add to children list.
		this._children.push(child);
		
		// Tell child.
		child._didAddToParent(this);
		
		this._addChildSendGen(Core.ObjectRegistry.objectToId(child));
		
		return this;
	},
	
	/**
	 * Remove a specified child node and its subtree from this <code>Node</code>.
	 * @example node.removeChild(this.mySprite);
	 * @param {String} child The child node to remove from the current entity.
	 * @throws {removeChild called for a node that is not a child} Specified node is not a child node.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Node#addChild
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	removeChild: function(child)
	{
		// Tell child.
		child._willRemoveFromParent();
		
		// Remove from children list.
		var index = this._children.indexOf(child);
		if(index == -1)
			throw new Error('removeChild called for a node that is not a child');
		this._children.splice(index, 1);
		
		this._removeChildSendGen(Core.ObjectRegistry.objectToId(child));
		
		return this;
	},
	
	/**
	 * Convert the relative location of a scene to the local coordinate space for this <code>Node</code>.
	 * @example var p = Game.getRoot().screenToLocal(touch.getPosition());
	 * @param {Core.Vector} location The relative location for a scene.
	 * @see GL2.Node#localToScreen
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	screenToLocal: function(location)
	{
		var parent = this._parent;
		if(!parent)
			return undefined;
			
		location = parent.screenToLocal(location);
		if(!location)
			return undefined;
		
		var x = location.getX();
		var y = location.getY();
		
		// Undo translation.
		var p = this._position;
		x -= p.getX();
		y -= p.getY();
		
		// Undo rotation.
		var r = this._rotation * Math.PI / 180;
		var cosr = Math.cos(r);
		var sinr = Math.sin(r);
		var tx = cosr*x + sinr*y;
		var ty = -sinr*x + cosr*y;
		x = tx;
		y = ty;
		
		// Undo scale.
		var s = this._scale;
		x /= s.getX();
		y /= s.getY();
		
		return new Core.Point(x, y);
	},
	
	/**
	 * Convert a location within the local coordinate space for this <code>Node</code> to a location within the screen coordinate
	 * space.
	 * @param {Core.Vector} location A location in the local transform for this <code>Node</code>.
	 * @see GL2.Node#screenToLocal
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	localToScreen: function(location)
	{
		var x = location.getX();
		var y = location.getY();
		
		// Undo scale.
		var s = this._scale;
		x *= s.getX();
		y *= s.getY();
		
		// Undo rotation.
		var r = -this._rotation * Math.PI / 180;
		var cosr = Math.cos(r);
		var sinr = Math.sin(r);
		var tx = cosr*x + sinr*y;
		var ty = -sinr*x + cosr*y;
		x = tx;
		y = ty;
		
		// Undo translation.
		var p = this._position;
		x += p.getX();
		y += p.getY();
		
		var parent = this._parent;
		if(!parent)
			return undefined;
		
		location = parent.localToScreen(new Core.Point(x, y));
		if(!location)
			return undefined;
		return location;
	},
	
	_didAddToParent: function(parent)
	{
		if(this._parent)
			this._parent.removeChild(this);
		
		this._parent = parent;
	},
	
	_willRemoveFromParent: function()
	{
		this._parent = null;
	},
	
	_synchronizeNodeRecv: function( cmd )
	{
		var msg = {};
		if(!this._synchronizeNodeRecvGen(cmd, msg))
			return;
		this._position.setAll(msg.x, msg.y);
		this._rotation = msg.rotation;
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 307
	// Method create = -1
	// Method destroy = 2
	// Method setPosition = 3
	// Method setScale = 4
	// Method setColor = 5
	// Method setAlpha = 6
	// Method setRotation = 7
	// Method setDepth = 8
	// Method setVisible = 9
	// Method setTouchable = 10
	// Method setChildrenDepthGrouped = 11
	// Method addChild = 12
	// Method removeChild = 13
	// Method synchronizeNode = 14
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 14:
					instance._synchronizeNodeRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Node._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Node._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[307] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_synchronizeNodeRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 3 )
		{
			NgLogE("Could not parse due to wrong argument count in Node.synchronizeNode from command: " + cmd );
			return false;
		}
		
		obj[ "x" ] = Core.Proc.parseFloat( cmd[ 0 ] );
		if( obj[ "x" ] === undefined )
		{
			NgLogE("Could not parse x in Node.synchronizeNode from command: " + cmd );
			return false;
		}
		
		obj[ "y" ] = Core.Proc.parseFloat( cmd[ 1 ] );
		if( obj[ "y" ] === undefined )
		{
			NgLogE("Could not parse y in Node.synchronizeNode from command: " + cmd );
			return false;
		}
		
		obj[ "rotation" ] = Core.Proc.parseFloat( cmd[ 2 ] );
		if( obj[ "rotation" ] === undefined )
		{
			NgLogE("Could not parse rotation in Node.synchronizeNode from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":307,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":307,2," + this.__objectRegistryId );
	},
	
	/** @private */
	_setPositionSendGen: function( x, y )
	{
		Core.Proc.appendToCommandString( ":307,3," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	_setScaleSendGen: function( x, y )
	{
		Core.Proc.appendToCommandString( ":307,4," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	_setColorSendGen: function( red, green, blue )
	{
		Core.Proc.appendToCommandString( ":307,5," + this.__objectRegistryId + "," + red + "," + green + "," + blue  );
	},
	
	/** @private */
	_setAlphaSendGen: function( alpha )
	{
		Core.Proc.appendToCommandString( ":307,6," + this.__objectRegistryId + "," + alpha  );
	},
	
	/** @private */
	_setRotationSendGen: function( rotation )
	{
		Core.Proc.appendToCommandString( ":307,7," + this.__objectRegistryId + "," + rotation  );
	},
	
	/** @private */
	_setDepthSendGen: function( depth )
	{
		Core.Proc.appendToCommandString( ":307,8," + this.__objectRegistryId + "," + depth  );
	},
	
	/** @private */
	_setVisibleSendGen: function( visible )
	{
		Core.Proc.appendToCommandString( ":307,9," + this.__objectRegistryId + "," + ( visible ? 1 : 0 )  );
	},
	
	/** @private */
	_setTouchableSendGen: function( touchable )
	{
		Core.Proc.appendToCommandString( ":307,10," + this.__objectRegistryId + "," + ( touchable ? 1 : 0 )  );
	},
	
	/** @private */
	_setChildrenDepthGroupedSendGen: function( childrenDepthGrouped )
	{
		Core.Proc.appendToCommandString( ":307,11," + this.__objectRegistryId + "," + ( childrenDepthGrouped ? 1 : 0 )  );
	},
	
	/** @private */
	_addChildSendGen: function( child )
	{
		Core.Proc.appendToCommandString( ":307,12," + this.__objectRegistryId + "," + child  );
	},
	
	/** @private */
	_removeChildSendGen: function( child )
	{
		Core.Proc.appendToCommandString( ":307,13," + this.__objectRegistryId + "," + child  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// setPosition: function( x, y ) {}
	
	// setScale: function( x, y ) {}
	
	// setColor: function( red, green, blue ) {}
	
	// setAlpha: function( alpha ) {}
	
	// setRotation: function( rotation ) {}
	
	// setDepth: function( depth ) {}
	
	// setVisible: function( visible ) {}
	
	// setTouchable: function( touchable ) {}
	
	// setChildrenDepthGrouped: function( childrenDepthGrouped ) {}
	
	// addChild: function( child ) {}
	
	// removeChild: function( child ) {}
	
	// _synchronizeNodeRecv: function( cmd ) {}

// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/GL2/Primitive'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/GL2/Primitive'] || {}; $MODULE_REGISTRY['NGCore/Client/GL2/Primitive'] = exports; var Node = require('NGCore/Client/GL2/Node').Node;
var Animation = require('NGCore/Client/GL2/Animation').Animation;
var Core = require('NGCore/Client/Core').Core;

exports.Primitive = Node.subclass(
/** @lends GL2.Primitive.prototype */
{
	classname: 'Primitive',
    
	/**
	 * @class The <code>Primitive</code> class constructs objects that draw arbitrary vertex-based geometry.
	 * These objects provide a means of drawing raw 2D <a href="GL2.Primitive.Vertex.html">vertex</a> data as polygons to a <code>{@link UI.View}</code>. Data is
	 * provided by users as a vertex list. 
	 * @constructs The default constructor. 
	 * @augments GL2.Node
	 */
    initialize: function()
    {
        this._animation = null;
		this._ownsAnimation = false;
		
		this._animationCompleteEmitter = new Core.MessageEmitter();
        this._type = this.Type.Triangles;
        this._vertexes = [];
    },

	/**
	 * The default destructor.
	 * This call cleans up any attached <code>Animation</code> and <code>AnimationCompleteEmitter</code>.
	 * @see GL2.Animation
	 * @status iOS, Android, Flash
	 */
	destroy: function()
	{
		this._tryDestroyAnimation();
		this._animationCompleteEmitter.destroy();
	},
	
	/**
	 * Retrieve the number of listed vertices in the geometry of this <code>Primitive</code>.
	 * @returns {Number} The current number of vertices.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getVertexCount: function()
	{
		return this._vertexes.length;
	},
	
	/**
	 * Retrieve a single vertex from the vertex list of this <code>Primitive</code>.
	 * @param {Number} index The vertex list offset to retrieve.
	 * @returns {GL2.Primitive.Vertex} The current vertex at the specified index in the vertex list.
	 * @see GL2.Primitive#setVertex
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getVertex: function(index)
	{
		return this._vertexes[index];
	},
	
	/**
	 * Retrieve the GL draw mode for this <code>Primitive</code>.
	 * @returns {GL2.Primitive#Type} The current draw mode.
	 * @see GL2.Primitive#setType
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getType: function()
	{
		return this._type;
	},
	
	/**
	 * Retrieve the current <code>Texture Animation</code> object of this <code>Primitive</code>.
	 * @returns {GL2.Animation} The current animation.
	 * @see GL2.Primitive#setAnimation
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getAnimation: function()
	{
		if(this._ownsAnimation) return null;
		
		return this._animation;
	},
	
	/**
	 * Retrieve the complete message emitter for the current animation.
	 * @returns {Core.MessageEmitter} The emitter for the current texture animation.
	 * @see GL2.Animation,  
	 * @see Core.MessageEmitter
	 * @status iOS, Android, Flash
	 */
	getAnimationCompleteEmitter: function()
	{
		return this._animationCompleteEmitter;
	},
    
	/**
	 * Begin playing the specified animation.
	 * Any animation that is not set to loop will trigger the animation complete callback when done.
	 * @example primitive.setAnimation(myAnimation, 30);
	 * @param {GL2.Animation} animation The current animation.
	 * @param {Number} [startTime=0] The starting point of the animation. Expressed as a float.<br><br>
	 * <b>Example:</b> If <code>setAnimation()</code> is called with a <code>startTime</code> equal to half the total duration of the animation, 
	 * playback begins half way through the animation.
	 * @see GL2.Primitive#getAnimation
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setAnimation: function(animation, startTime)
	{
		this._tryDestroyAnimation();
		this._animation = animation;
		
		this._setAnimationSendGen( Core.ObjectRegistry.objectToId(animation), startTime || 0 );
	},
    
    /**
	 * Set a static image as the current animation for this <code>Primitive</code>.
	 * This method instantiates a single frame animation of infinite duration using the
	 * specified image. If the primitive is playing another animation at the time of this call, 
	 * the new animation will take priority over the primitive.
	 * The previous animation will stop and the complete emitter will not respond. 
	 * This is because the animation did not technically complete a full playback cycle. <br><br>
	 * You can define optional parameters for the size, anchor, and UV coordinates of the specified image. 
	 * @example primitive.setImage('./Content/blank.png', [480, 320], [0, 0]);
	 * @param {String} image The directory path to an image referenced by a frame.
	 * @param {Core.Size} [size] The size of the image to display in pixels.
	 * @param {Core.Point} [anchor] The anchor coordinates that indicate the image center in the animation.
	 * @param {Core.Rect} [uvs] The UV coordinates used to specify the subset of an image.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Animation, 
	 * @see GL2.Animation.Frame
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setImage: function(image, size, anchor, uvs)
	{
		this._tryDestroyAnimation();
		
		// Create a single frame animation.
		var args = Array.prototype.slice.call(arguments, 0);
		args.splice(1, 0, 0); // Insert a duration of zero into our arguments.
		var frame = new Animation.Frame();
		frame.constructor.apply(frame, args);
		var animation = new Animation();
		animation.pushFrame(frame);
		
		this._animation = animation;
		this._ownsAnimation = true;
		
		this._setAnimationSendGen(Core.ObjectRegistry.objectToId(animation),0);
		
		return this;
	},
    
    /**
	 * Set the type of geometry on display for this <code>Primitive</code>.
	 * @example primitive.setType(GL2.Primitive.Type.TriangleFan);
	 * @param {GL2.Primitive#Type} type The new GL draw mode.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setType: function(type)
	{
		this._type = type;
		
		this._setTypeSendGen(type);
		
		return this;
	},
    
    /**
     * Add a vertex to the end of the vertex list for this <code>Primitive</code>.<br>
     * <pre class="code"><font size="2">primitive.pushVertex(new Core.Point(w*2/10, h*5/6));</font></pre><br>
     * Calling <code>pushVertex()</code> is equivalent to calling <code>spliceVertexes()</code> in the following way:
     * <pre class="code"><font size="2">primitive.spliceVertexes(primitive.getVertexCount(), 0, vertex);</font></pre>
     * @param {GL2.Primitive.Vertex} vertex The vertex to add.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    pushVertex: function(vertex)
	{
		return this.spliceVertexes(this._vertexes.length, 0, vertex);
	},
    
    /**
	 * Set the vertex at index <i>i</i> for this <code>Primitive</code>.
	 * Calling <code>setVertex()</code> is equivalent to calling <code>spliceVertexes()</code> in the following way:
	 * @example primitive.spliceVertexes(i, 1, vertex)
	 * @param {Number} <i>i</i> The index in the vertex list to set.
	 * @param {GL2.Primitive.Vertex} vertex The new vertex.
	 * @see GL2.Primitive#getVertex
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setVertex: function(i, vertex)
	{
		return this.spliceVertexes(i, 1, vertex);
	},
    
    /**
	 * Replace <code>len</code> vertices, starting at position <code>start</code>, with specified vertices.<br><br>
	 * The following are examples of different call styles for <code>spliceVertexes</code>.<br><br>
	 * Splice a simple textureless quad into the vertex list.
	 * <pre class="code"><font size="2">var c = new Core.Color([1,1,1]);
	 * var w = 100;
	 * var h = 100;
	 * var v = new Array();
	 * v.push(new GL2.Primitive.Vertex([0,0],[0,0],c));
	 * v.push(new GL2.Primitive.Vertex([w,0],[0,0],c));
	 * v.push(new GL2.Primitive.Vertex([w,h],[0,0],c));
	 * v.push(new GL2.Primitive.Vertex([0,h],[0,0],c));</font></pre>
	 * Insert four vertices at position 0 in the vertex list.
	 * <pre class="code"><font size="2">myPrimitive.spliceVertexes.apply(myPrimitive, ([0,0]).concat(v));
	 * myPrimitive.setType(GL2.Primitive.Type.TriangleFan);</font></pre>
	 * @param {Number} start The index from which to remove vertices in the vertex list.
	 * @param {Number} len The number of vertices to replace.
	 * @param {GL2.Primitive.Vertex} vertexes A list of vertices to insert at the start location.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    spliceVertexes: function(start, len, vertexes)
	{
		this._vertexes.splice.apply(this._vertexes, arguments);
		
		var vertexCount = arguments.length-2;
		this._spliceVertexesSendGen(start,len,vertexCount);
		
		for(var i=0; i < vertexCount; ++i)
		{
			var vertex = arguments[i+2];
			var position = vertex.getPosition();
			var uv = vertex.getUV();
			var color = vertex.getColor();
			this._vertexSendGen(
				position.getX(),
				position.getY(),
				uv.getX(),
				uv.getY(),
				color.getRed(),
				color.getGreen(),
				color.getBlue()
			);
		}
		
		return this;
	},

	$Vertex: Core.Class.subclass(
	/** @lends GL2.Primitive.Vertex.prototype */
	{
		classname: 'Vertex',
		
		/**
		 * @class <code>Vertex</code> objects specify location, texture coordinates, and color data
		 * for GL primitive geometry.
		 * @constructs The default constructor. 
		 * @param {Core.Vector|float[2]} position A location.
		 * @param {Core.Vector|float[2]} uv A texture coordinate.
		 * @param {Core.Color|float[3]} color An RGB color triplet.
		 * @see GL2.Primitive
		 * @augments Core.Class
		 */
		initialize: function(position, uv, color)
		{
			this._position = new Core.Point(position);
			this._uv = new Core.Point(uv);
			this._color = new Core.Color(color);
		},
		
		/**
		 * Retrieve the location of this <code>Vertex</code>.
		 * @returns {Core.Vector} The current <i>x</i>,<i>y</i> coordinates for the vertex.
    	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
		 */
		getPosition: function()
		{
			return this._position;
		},
		
		/**
		 * Retrieve the texture coordinates of this <code>Vertex</code>.
		 * @returns {Core.Vector} The current <i>x</i>,<i>y</i> coordinates for the texture.
		 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
		 */
		getUV: function()
		{
			return this._uv;
		},
		
		/**
		 * Retrieve the color of this <code>Vertex</code>.
		 * @returns {Core.Color} The current vertex color as a RGB triplet.
		 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
		 */
		getColor: function()
		{
			return this._color;
		},
	}),
	
	_tryDestroyAnimation: function()
	{
		if(this._ownsAnimation)
		{
			// Set our animation to NULL to unlink ourselves from the animation on the backend
			// or else trying to destory the animation will fail because we are still using it.
			this._setAnimationSendGen(0,0);
		
			this._animation.destroy();
			this._animation = null;
			this._ownsAnimation = false;
		}
		this._animation = null;
		this._image = null;
	},
	
// {{?Wg Generated Code}}
	
	// Enums.
	/** 
	 * Enumeration for primitive types.
	 * @namespace
	 */
	Type:
	{ 
		/** Every three vertices define a unique triangle. */
		Triangles: 0,
		/** Every vertex defines a triangle with the 2 preceding vertices. */
		TriangleStrip: 1,
		/** Every vertex defines a triangle with the first vertex and the previous vertex. */
		TriangleFan: 2,
		/** Every vertex pair defines a line segment. */
		LineList: 3,
	},
	
	///////
	// Class constants (for internal use only):
	// Class ID = 308
	// Method create = -1
	// Method spliceVertexes = 2
	// Method vertex = 3
	// Method setType = 4
	// Method setAnimation = 5
	// Method animationComplete = 6
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 6:
					instance._animationCompleteRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Primitive._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Primitive._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[308] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_animationCompleteRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 0 )
		{
			NgLogE("Could not parse due to wrong argument count in Primitive.animationComplete from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":308,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_spliceVertexesSendGen: function( start, len, vertexCount )
	{
		Core.Proc.appendToCommandString( ":308,2," + this.__objectRegistryId + "," + start + "," + len + "," + vertexCount  );
	},
	
	/** @private */
	_vertexSendGen: function( x, y, u, v, red, green, blue )
	{
		Core.Proc.appendToCommandString( "," + x + "," + y + "," + u + "," + v + "," + red + "," + green + "," + blue  );
	},
	
	/** @private */
	_setTypeSendGen: function( type )
	{
		Core.Proc.appendToCommandString( ":308,4," + this.__objectRegistryId + "," + type  );
	},
	
	/** @private */
	_setAnimationSendGen: function( animation, startTime )
	{
		Core.Proc.appendToCommandString( ":308,5," + this.__objectRegistryId + "," + animation + "," + startTime  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// spliceVertexes: function( start, len, vertexCount ) {}
	
	// vertex: function( x, y, u, v, red, green, blue ) {}
	
	// setType: function( type ) {}
	
	// setAnimation: function( animation, startTime ) {}
	
	// _animationCompleteRecv: function( cmd ) {}

// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/GL2/Touch'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/GL2/Touch'] || {}; $MODULE_REGISTRY['NGCore/Client/GL2/Touch'] = exports; var Core = require('NGCore/Client/Core').Core;

exports.Touch = Core.Class.subclass(
/** @lends GL2.Touch.prototype */
{
	classname: 'Touch',
	
	/**
	 * @class The <code>Touch</code> class constructs objects that identify and track the life cycle of unique touch events in the system.
	 * @constructs These objects are constructed by the system.
	 * @augments Core.Class
	 */
	initialize: function()
	{
		this._id = 0;
		this._action = {};
		this._position = new Core.Point();
		this._targetIds = null;
	},
	
	/**
	 * Retrieve a list of every <code>TouchTarget</code> object in which this <code>Touch</code> object resides and is marked as touchable.
	 * @returns {GL2.TouchTarget} A prioritized list of every <code>TouchTarget</code> for this <code>Touch</code>.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getTouchTargets: function()
	{
		var ids = this._targetIds;
		var result = [];
		for(var i in ids)
		{
			var t = Core.ObjectRegistry.idToObject(i);
			if(t) result.push(t);
		}
		return result;
	},
	
	/**
	 * Retrieve whether or not this <code>Touch</code> object resides in the specified <code>TouchTarget</code>.
	 * @param {GL2.TouchTarget} touchTarget The <code>TouchTarget</code> to test against.
	 * @returns {Boolean} Returns <code>true</code> when this <code>Touch</code> resides in the <code>TouchTarget</code>.
	 * @status iOS, Android, Flash
	 */
	getIsInside: function(touchTarget)
	{
		// Check if the object's id is in the touchtargets map
		return ( Core.ObjectRegistry.objectToId(touchTarget) in this._targetIds);
	},
	
	/**
	 * Retrieve the location of this <code>Touch</code> object in the global coordinate space.
	 * @returns {Core.Vector} The global coordinates of the <code>Touch</code> location.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getPosition: function()
	{
		return this._position;
	},
	
	/**
	 * Retrieve the ID of this <code>Touch</code> object.
	 * <b>Note:</b> When using this ID as a key, append it to a string so that you can use
	 * it to key an associative array. Otherwise, you will end up with a very large array.
	 * @returns {Number} The current <code>Touch</code> ID.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getId: function()
	{
		return this._id;
	},
	
	/**
	 * Retrieve the phase of this <code>touch</code> event.
	 * Use this method from your listener callback.
	 * The following is an example of a <code>touch</code> event handler for a button.
	 * @example
	 * onTouch: function(touch)
	 * {
	 * 	//getAction() informs us of the type of event being handled.
	 * 	//  In order to get Action.Move and Action.End, we need to return true from Action.Start.
	 * 	switch(touch.getAction())
	 * 	{
	 * 		case touch.Action.Start:
	 * 			//Change the color of our Rectangle
	 * 			this.button.setColor(Defaults.onColor);
	 * 			
	 * 			//Return true here if you want to capture this event for its lifetime.
	 * 			//  returning false will let other, lower priority handlers capture the
	 * 			//  event. In that case we would not want to react to the Action.Start since
	 * 			//  we would not get subsequent Action.End or Action.Move.
	 * 			return true;
	 * 			
	 * 		case touch.Action.End:
	 * 			//Reset the color of our Rectangle
	 * 			this.button.setColor(Defaults.offColor);
	 * 			
	 * 			//We do not need to return anything in Action.End or Action.Move.
	 * 			break;
	 * 		case touch.Action.Move:
	 * 			//The touch object allows us to retrieve metadata about the event.
	 * 			//  If the touch has left our bounds, getIsInside() will return false.
	 * 			if(!touch.getIsInside(this._target))
	 * 			{
	 * 				//If the active touch is outside, reset our Rectangle color.
	 * 				this.button.setColor(Defaults.offColor);
	 * 			}
	 * 			else
	 * 			{
	 * 				//If the active touch is inside, set our Rectangle color to on.
	 * 				this.button.setColor(Defaults.onColor);
	 * 			}
	 * 			break;
	 * 	}
	 * }
	 * @returns {GL2.Touch#Action} The current <code>touch</code> event phase.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getAction: function()
	{
		return this._action;
	},
	
	_setId: function(id)
	{
		this._id = id;
	},
	
	_setAction: function(action)
	{
		this._action = action;
	},
	
	_setPosition: function(position)
	{
		this._position.setAll(arguments);
	},
	
	_setTargetIds: function(targetIds)
	{
		// We transfer the array of numeric target IDs into a
		// map so we can support getIsInside call which uses 'in'.
		this._targetIds = {};
		for(var i in targetIds)
			this._targetIds[targetIds[i]] = null;
	},
	
// {{?Wg Generated Code}}
	
	// Enums.
	/** 
	 * Enumeration for touch action.
	 * @namespace
	 */
	Action:
	{ 
		/** Finger began touching screen. */
		Start: 0,
		/** Finger stopped touching screen. */
		End: 1,
		/** Finger moved where it is touching the screen. */
		Move: 2,
	},
	
	///////
	// Class constants (for internal use only):
	// Class ID = 312
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Touch._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Touch._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[312] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	// This class is expected to implement the following methods outside of
	// the generated block:

// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/GL2/TouchTarget'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/GL2/TouchTarget'] || {}; $MODULE_REGISTRY['NGCore/Client/GL2/TouchTarget'] = exports; var Node = require('NGCore/Client/GL2/Node').Node;
var Sprite = require('NGCore/Client/GL2/Sprite').Sprite;
var Core = require('NGCore/Client/Core').Core;

exports.TouchTarget = Node.subclass(
/** @lends GL2.TouchTarget.prototype */
{
	classname: 'TouchTarget',
    
	/**
	 * @class <code>TouchTarget</code> class constructs objects that provide applications access to touch events.
	 *<br><br>
	 * A <code>TouchTarget</code> is a node with added size and offset attributes that define a
	 * rectangular area as active. Any <a href"GL2.Touch.html">touch</a> that falls within the active area is broadcast
	 * to the <code>TouchTarget</code> where a <code>MessageListener</code> can respond 
	 * to the event. Attach a listener by calling <code><a href="GL2.TouchTarget.html#getTouchEmitter">getTouchEmitter()</a></code>
	 * to retrieve the emitter.
	 *<br><br>
	 * A <code>TouchTarget</code> is created with a <code>0</code> size and a center offset anchor point <code>(0.5,0.5)</code>.
	 * Set these two properties to define a usable area that supports touch events. Generally,
	 * you set these two values as identical to the values for <code><a href="GL2.Sprite.html">sprite</a></code>, <code><a href="GL2.Text.html">text</a></code>, 
	 * or <code><a href="GL2.Primitive.html">primitive</a></code> and add
	 * the <code>TouchTarget</code> as a child of that visible node with a position of <code>0</code>. The <code>TouchTarget</code> 
	 * inherits the transform for the visible node. 
	 * <br><br>
	 * <b>Note:</b> A <code>TouchTarget</code> is not part of the drawing scene traversal and activates regardless of node
	 * visibility or parent visibility. 
	 * Disable touch support for a node by calling <code><a href="GL2.Node.html#setTouchable">setTouchable()</a></code>.
	 * @constructs The default constructor.
	 * @augments GL2.Node
	 */
    initialize: function()
    {
		this._size = new Core.Size();
		this._anchor = new Core.Point(0, 0);
		this._touchEmitter = new Core.MessageEmitter();
    },
    
	/**
	 * Destroy this instance and release resources on the backend that are associated with this <code>TouchTarget</code> object.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	destroy: function()
	{
	},
	
	/**
	 * Return the point size of the <code>TouchTarget</code> area.
	 * @returns {Core.Size} The current size of the <code>TouchTarget</code> area.
	 * @see GL2.TouchTarget#setSize
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getSize: function()
	{
		return this._size;
	},
	
	/**
	 * Return the offset values used for scaling and rotating the <code>TouchTarget</code> area.
	 * @returns {Core.Point} The current offset of the target area.
	 * @see GL2.TouchTarget#setAnchor
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getAnchor: function()
	{
		return this._anchor;
	},
	
	/**
	 * Return the touch emitter for this <code>TouchTarget</code>.
	 * The emitter fires when a captured <code>touch</code> event changes phases. For the initial touch down
	 * phase, this emitter fires when the <code>touch</code> event occurs within the defined touch area. After returning <code>true</code> from
	 * the initial <code>touch</code> event, the emitter fires regardless of where the <code>touch</code> event occurs.<br><br>	 
	 * The following example creates a new <code>TouchTarget</code> in the upper left corner of the scene. 
	 * The listener instance handles the <code>touch</code> events in the <code>onTouch()</code> function.
	 * @example
	 * var target = new GL2.TouchTarget();
	 * target.setAnchor([50,50]);
	 * target.setSize([100,100]);
	 * target.setPosition([50,50]);
	 * 
	 * target.getTouchEmitter().addListener(this, this.onTouch);
	 * 
	 * GL2.Root.addChild(target);
	 * @return {Core.MessageEmitter} The touch emitter for this touch area.
	 * @see GL2.Touch#getAction
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getTouchEmitter: function()
	{
		return this._touchEmitter;
	},
	
    /**
	 * Set the size of this <code>TouchTarget</code> (<i>width</i> and <i>height</i>).
	 * @example this.t = new GL2.TouchTarget();
	 * this.t.setSize(Core.Capabilities.getScreenHeight(), Core.Capabilities.getScreenHeight());
	 * @param {Core.Size} size The new size of the <code>TouchTarget</code> area.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setSize: function(size)
	{
		var s = this._size;
		s.setAll.apply(s, arguments);

		this._setSizeSendGen(s.getWidth(),s.getHeight());
		
		return this;
	},
	
    /**
	 * Set the anchor point used to rotate and scale the <code>TouchTarget</code> area.
	 * @example this.t = new GL2.TouchTarget();
	 * this.t.setAnchor(0, 0);
	 * @param {Core.Point} anchor The new anchor point for the <code>TouchTarget</code> area.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setAnchor: function(anchor)
	{
		var a = this._anchor;
		a.setAll.apply(a, arguments);
		
		this._setAnchorSendGen(a.getX(),a.getY());
		
		return this;
	},
	
	/**
	 * Translate a global scene location to the local coordinate space.
	 * Use this method when determining <code>touchMoved</code> offsets.
	 * @example var p = Game.getRoot().screenToLocal(touch.getPosition());
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {Core.Vector} location The location to transform.
	 * @status iOS, Android, Flash
	 */
	screenToLocal: function($super, location)
	{
		location = $super(location);
		if(!location)
			return undefined;
		
		var a = this._anchor;
		var s = this._size;
			
		location.setX(location.getX() + a.getX() * s.getWidth());
		location.setY(location.getY() + a.getY() * s.getHeight());
		return location;
	},
	
	/**
	 * Translate a location in the local coordinate space to the global scene coordinate space.
	 * Use this method for translating between local coordinate spaces.
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {Core.Vector} location The location to transform.
	 * @status iOS, Android, Flash
	 */
	localToScreen: function($super, location)
	{
		var a = this._anchor;
		var s = this._size;
			
		location.setX(location.getX() - a.getX() * s.getWidth());
		location.setY(location.getY() - a.getY() * s.getHeight());
		
		location = $super(location);
		if(!location)
			return undefined;
		return location;
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 313
	// Method create = -1
	// Method setSize = 2
	// Method setAnchor = 3
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in TouchTarget._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in TouchTarget._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[313] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":313,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_setSizeSendGen: function( width, height )
	{
		Core.Proc.appendToCommandString( ":313,2," + this.__objectRegistryId + "," + width + "," + height  );
	},
	
	/** @private */
	_setAnchorSendGen: function( x, y )
	{
		Core.Proc.appendToCommandString( ":313,3," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// setSize: function( width, height ) {}
	
	// setAnchor: function( x, y ) {}
	

// {{/Wg Generated Code}}
});

; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/GL2/Root'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/GL2/Root'] || {}; $MODULE_REGISTRY['NGCore/Client/GL2/Root'] = exports; var Core = require('NGCore/Client/Core').Core;
var Touch = require('NGCore/Client/GL2/Touch').Touch;

exports.Root = Core.Class.singleton(
/** @lends GL2.Root.prototype */
{
	classname: 'Root',
	
	/**
	 * @class The <code>Root</code> class constructs a singleton object that serves as the proxy object for the {@link UI.GLView} node hierarchy.
	 * <code>Root</code> is the root element of the node hierarchy (also known as a scene graph) for <code>GLView</code>.
	 * The <code>Root</code> transform is composed at the upper left corner of the view with a descending <i>y</i> axis.<br><br>
	 * Adding a node to the <code>Root</code> ensures applications include it when determining drawing and touch events.
	 * @constructs The default constructor.
	 * @augments Core.Class
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		
		this._children = [];
		
		this._createSendGen(this.__objectRegistryId);
		
		this._touchTracking = {};
	},
	
	/**
	 * Add a node and the node subtree to the root of the scene graph.
	 * @example var spr = new GL2.Sprite();
	 * ...
	 * GL2.Root.addChild(spr);
	 * @param {GL2.Node} child The node to add.
	 * @see GL2.Root#removeChild
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	addChild: function(child)
	{
		this._children.push(child);
		child._didAddToParent(this);
		
		this._addChildSendGen(Core.ObjectRegistry.objectToId(child));
	},
	
	/**
	 * Remove the child node and the node subtree from the root of the scene graph.<br><br>
	 * <b>Note:</b> This method will not destroy the node. You can keep or destroy a reference to a node 
	 * if you have no further use for it.
	 * @example GL2.Root.removeChild(spr);
	 * @throws {removeChild called for a node that is not a child} Specified node is not a child node.
	 * @param {GL2.Node} child The node to remove.
	 * @see GL2.Root#addChild
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	removeChild: function(child)
	{
		child._willRemoveFromParent();
		
		var index = this._children.indexOf(child);
		if(index == -1)
			throw new Error('removeChild called for a node that is not a child');
		this._children.splice(index, 1);
		
		this._removeChildSendGen(Core.ObjectRegistry.objectToId(child));
	},
	
	/** 
	 * Translate screen coordinates into node coordinates.
	 * @example var p = Game.getRoot().screenToLocal(touch.getPosition());
	 * @param {Core.Vector} location The screen coordinates to translate.
	 * @returns The location as node coordinates.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	screenToLocal: function(location)
	{
		return location;
	},
	
	/** 
	 * Translate node coordinates into screen coordinates.
	 * @param {Core.Vector} location The node coordinates to translate.
	 * @returns The location as screen coordinates.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	localToScreen: function(location)
	{
		return location;
	},
	
	_onTouchEventRecv: function( cmd )
	{
		var msg = {};
		if(!this._onTouchEventRecvGen(cmd, msg))
			return;
		
		// Build touch object.
		var touchId = msg.touchId;
		var touchAction = msg.touchAction;
		var touch = new Touch();
		touch._setId(touchId);
		touch._setAction(touchAction);
		touch._setPosition(msg.x, msg.y);
		
		// Extract all touch targets.
		var ids = [];
		for(var i=0; i < msg.touchTargetCount; ++i)
		{
			var t = {};
			if(!this._touchTargetRecvGen(cmd, t))
				return;
			// Add an array entry for every touch event that we have gotten from native.
			ids.push(t.nodeId);
		}
		
		touch._setTargetIds(ids);
		
		switch(touchAction)
		{
			case Touch.Action.Start:
				// Dispatch to all touch targets until one handles it.
				for(var key in ids)
				{
					var id=ids[key];
					var o = Core.ObjectRegistry.idToObject(id);
					if(o && o.getTouchEmitter().chain(touch))
					{
						this._touchTracking[touchId] = id;
						break;
					}
				}
				break;
			case Touch.Action.End:
				// Dispatch to tracking object.
				var track = this._touchTracking[touchId];
				if(track)
				{
					var o = Core.ObjectRegistry.idToObject(track);
                    if (o)
                        o.getTouchEmitter().chain(touch);
					delete this._touchTracking[touch.getId()];
				}
				break;
			case Touch.Action.Move:
				// Dispatch to tracking object.
				var track = this._touchTracking[touchId];
				if(track)
				{
					var o = Core.ObjectRegistry.idToObject(track);
                    if (o)
                        o.getTouchEmitter().chain(touch);
				}
				break;
		}
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 309
	// Method create = -1
	// Method addChild = 2
	// Method removeChild = 3
	// Method onTouchEvent = 4
	// Method touchTarget = 5
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 4:
					instance._onTouchEventRecv( cmd );
					break;
				case 5:
					instance._touchTargetRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Root._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Root._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[309] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_onTouchEventRecvGen: function( cmd, obj )
	{ 
		if( cmd.length < 5 )
		{
			NgLogE("Could not parse due to wrong argument count in Root.onTouchEvent from command: " + cmd );
			return false;
		}
		
		obj[ "touchId" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "touchId" ] === undefined )
		{
			NgLogE("Could not parse touchId in Root.onTouchEvent from command: " + cmd );
			return false;
		}
		
		obj[ "touchAction" ] = Core.Proc.parseInt( cmd[ 1 ] );
		if( obj[ "touchAction" ] === undefined )
		{
			NgLogE("Could not parse touchAction in Root.onTouchEvent from command: " + cmd );
			return false;
		}
		
		obj[ "x" ] = Core.Proc.parseFloat( cmd[ 2 ] );
		if( obj[ "x" ] === undefined )
		{
			NgLogE("Could not parse x in Root.onTouchEvent from command: " + cmd );
			return false;
		}
		
		obj[ "y" ] = Core.Proc.parseFloat( cmd[ 3 ] );
		if( obj[ "y" ] === undefined )
		{
			NgLogE("Could not parse y in Root.onTouchEvent from command: " + cmd );
			return false;
		}
		
		obj[ "touchTargetCount" ] = Core.Proc.parseInt( cmd[ 4 ] );
		if( obj[ "touchTargetCount" ] === undefined )
		{
			NgLogE("Could not parse touchTargetCount in Root.onTouchEvent from command: " + cmd );
			return false;
		}
		
		cmd.splice(0, 5);
		return true;
	},
	
	/** @private */
	_touchTargetRecvGen: function( cmd, obj )
	{ 
		if( cmd.length < 1 )
		{
			NgLogE("Could not parse due to wrong argument count in Root.touchTarget from command: " + cmd );
			return false;
		}
		
		obj[ "nodeId" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "nodeId" ] === undefined )
		{
			NgLogE("Could not parse nodeId in Root.touchTarget from command: " + cmd );
			return false;
		}
		
		cmd.splice(0, 1);
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":309,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_addChildSendGen: function( child )
	{
		Core.Proc.appendToCommandString( ":309,2," + this.__objectRegistryId + "," + child  );
	},
	
	/** @private */
	_removeChildSendGen: function( child )
	{
		Core.Proc.appendToCommandString( ":309,3," + this.__objectRegistryId + "," + child  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// addChild: function( child ) {}
	
	// removeChild: function( child ) {}
	
	// _onTouchEventRecv: function( cmd ) {}
	// _touchTargetRecv: function( cmd ) {}

// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/GL2/Sprite'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/GL2/Sprite'] || {}; $MODULE_REGISTRY['NGCore/Client/GL2/Sprite'] = exports; var Node = require('NGCore/Client/GL2/Node').Node;
var Animation = require('NGCore/Client/GL2/Animation').Animation;
var Core = require('NGCore/Client/Core').Core;

exports.Sprite = Node.subclass(
/** @lends GL2.Sprite.prototype */
{
	classname: 'Sprite',
	
	/**	 
	 * @class The <code>Sprite</code> class constructs objects that are used to display either a single image file 
	 * (see <code><a href="GL2.Sprite.html#setImage">setImage()</a></code>) or an animation.<br><br>
	 * Sprites apply their composite node transform and color to the final 
	 * rendered output of each <code><a href="GL2.Animation.Frame.html">frame</a></code> they display. Frames manage the
	 * pre-transform offset within the image. The pre-transform offset is used by frames for rotation and scale of the image. Combining these
	 * two features, an application can accurately place an image within the view.<br><br>
	 * Animations that reach the end of the last animation frame will trigger the
	 * <code>AnimationCompleteEmitter</code> (see <code><a href="GL2.Sprite.html#getAnimationCompleteEmitter">getAnimationCompleteEmitter()</a></code>). 
	 * All other cases, such as setting a new
	 * animation, does not trigger the emitter.<br><br>
	 * <b>Note:</b> The tick rate for any animation instantiated through <code>Sprite</code> is set through <code>{@link Core.UpdateEmitter#setTickRate}</code>.
	 * @constructs The default constructor.
	 * @augments GL2.Node
	 */
    initialize: function()
    {
		this._clubObject = null;
        this._animation = null;
		this._ownsAnimation = false;
		
		this._animationCompleteEmitter = new Core.MessageEmitter();
    },

	/**
	 * The default destructor.
	 * This call cleans up any attached <code>Animation</code> and <code>AnimationCompleteEmitter</code> objects.
	 * @see GL2.Animation,
	 * @see GL2.Sprite#getAnimationCompleteEmitter
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	destroy: function()
	{
		this._tryDestroyAnimation();
		this._animationCompleteEmitter.destroy();
	},
	
	/**
	 * Retrieve the current <code>Sprite</code> animation.
	 * If the sprite is rendering a single image animation through <code>setImage()</code>,
	 * this method will return <code>undefined</code>.
	 * @returns {GL2.Animation} The current animation. Returns <code>null</code> if the application is not currently playing an animation.
	 * @see GL2.Sprite#setAnimation,
	 * @see GL2.Sprite#setImage
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getAnimation: function()
	{
		if(this._ownsAnimation) return null;
		
		return this._animation;
	},
    
    /**
	 * Retrieve the animation complete emitter for this <code>Sprite</code>.
	 *
	 * This emitter is triggered when one of the following conditions occurs:<br><br>
	 *<ul>
	 * <li>The sprite reaches the end of an animation for which the last frame has a duration of <code>0</code>.</li>
	 * <li>A <code>setAnimation()</code> or a <code>setImage()</code> call resets the animation complete emitter.</li>
	 *</ul>
	 * Any code that requires notification when an animation completes should register as a 
	 * listener to this emitter. The emitter callback will pass this sprite as the only parameter.<br><br>
	 * <b>Note:</b> Looping animations and starting new animations do not trigger this emitter.
	 * @returns {Core.MessageEmitter} The emitter that triggers the completion callback.
	 * @see GL2.Sprite#setAnimation,
	 * @see GL2.Sprite#setImage	 
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getAnimationCompleteEmitter: function()
	{
		return this._animationCompleteEmitter;
	},
    
    /**
	 * Begin playing the specified animation with this <code>Sprite</code>.
	 * If the sprite is playing another animation at the time of this call, the new animation will take priority over the sprite.
	 * The previous animation will stop and the complete emitter will not respond. This is because the animation did not technically complete a full playback cycle. 
	 * <br><br>
	 * <b>Note:</b> You can release the resources for any animation set with <code>setAnimation()</code> from the native backend if no other frame
	 * contains it.
	 * @example var animation = Animation.getNamed('background');
	 * ...
	 * var sprite = new GL2.Sprite();
	 * sprite.setAnimation(animation);
	 * @param {GL2.Animation} animation The animation to play.
	 * @param {Number} [startTime=0] The time offset where playback should start relative to the actual start of the animation. Expressed in milliseconds.<br><br>
	 * <b>Example:</b> If <code>setAnimation()</code> is called with a <code>startTime</code> equal to half the total duration of the animation, 
	 * playback begins half way through the animation.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setAnimation: function(animation, startTime)
	{
		this._tryDestroyAnimation();
		this._animation = animation;
		
		this._setAnimationSendGen(Core.ObjectRegistry.objectToId(animation), startTime || 0);
		
		return this;
	},
    
    /**
	 * Set a static image as the current animation for this <code>Sprite</code>.
	 * Internally, this method instantiates a single frame animation of infinite duration using the
	 * specified image. If the sprite is playing another animation at the time of this call, the new animation will take priority over the sprite.
	 * The previous animation will stop and the complete emitter will not respond. This is because the animation did not technically complete a full playback cycle. 
	 * <br><br>
	 * <b>Note:</b> You can release the resources for any image set with <code>setImage()</code> from the native backend if no other frame
	 * contains it.
	 * @example var myImage = new GL2.Sprite();
	 * myImage.setImage('./Content/animation.png', size);
	 * @param {String} image The directory path to an image resource.
	 * @param {Core.Size} [size] The size of the image to display (in pixels).
	 * @param {Core.Point} [anchor] The anchor coordinates that indicate the image center in the animation.
	 * @param {Core.Rect} [uvs] The UV coordinates used to specify the subset of an image.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setImage: function(image, size, anchor, uvs)
	{
		this._tryDestroyAnimation();
		
		// Create a single frame animation.
		var args = Array.prototype.slice.call(arguments, 0);
		args.splice(1, 0, 0); // Insert a duration of zero into our arguments.
		var frame = new Animation.Frame();
		frame.constructor.apply(frame, args);
		var animation = new Animation();
		animation.pushFrame(frame);
		
		this._animation = animation;
		this._ownsAnimation = true;
		
		this._setAnimationSendGen(Core.ObjectRegistry.objectToId(animation),0);
		
		return this;
	},
	
	_tryDestroyAnimation: function()
	{
		if(this._ownsAnimation)
		{
			// Set our animation to NULL to unlink ourselves from the animation on the backend
			// or else trying to destory the animation will fail because we are still using it.
			this._setAnimationSendGen(0,0);
		
			this._animation.destroy();
			this._animation = null;
			this._ownsAnimation = false;
		}
		this._animation = null;
	},
	
	_animationCompleteRecv: function(cmd)
	{
		var msg = {};
		if(!this._animationCompleteRecvGen(cmd, msg))
			return;
		
		this._animationCompleteEmitter.emit(this);
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 310
	// Method create = -1
	// Method setAnimation = 2
	// Method animationComplete = 3
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 3:
					instance._animationCompleteRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Sprite._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Sprite._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[310] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_animationCompleteRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 0 )
		{
			NgLogE("Could not parse due to wrong argument count in Sprite.animationComplete from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":310,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_setAnimationSendGen: function( animation, startTime )
	{
		Core.Proc.appendToCommandString( ":310,2," + this.__objectRegistryId + "," + animation + "," + startTime  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// setAnimation: function( animation, startTime ) {}
	
	// _animationCompleteRecv: function( cmd ) {}

// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/GL2/Text'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/GL2/Text'] || {}; $MODULE_REGISTRY['NGCore/Client/GL2/Text'] = exports; var Node = require('NGCore/Client/GL2/Node').Node;
var Core = require('NGCore/Client/Core').Core;

exports.Text = Node.subclass(
/** @lends GL2.Text.prototype */
{
	classname: 'Text',
    
	/**
	 * @class The <code>Text</code> class constructs objects that provide font specifications to the GL2 module. 
	 * <code>Text</code> objects define positionable areas for rendering text strings as application labels.
	 * @constructs The default constructor. 
	 * @augments GL2.Node
	 * @param {String} [text] The text string to render in the constructor.
	 */
    initialize: function(text)
    {
		this._size = new Core.Size();
		this._anchor = new Core.Point(0.5, 0.5);
        this._horizontalAlign = this.HorizontalAlign.Center;
        this._verticalAlign = this.VerticalAlign.Middle;
        this._text = '';
		if (text)
			 this.setText(text);
							 
        this._fontFamily = '';
        this._fontSize = 18;
		this._overflowMode = this.OverflowMode.Multiline;
		this._fontLocation = this.FontLocation.Default;
    },
    
	/**
	 * Destroy this instance and release resources on the backend.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	destroy: function()
	{
	},
	
	/**
	 * Retrieve the size of the text area from this <code>Text</code> node.
	 * The text area size is defined through two components: <i>width</i> and <i>height</i>.
	 * A value of <code>0</code> for either component means the text area will expand to the size of the string.
	 * @returns {Core.Vector} The current size of the text area (expressed as points).
	 * @see GL2.Text#setSize
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getSize: function()
	{
		return this._size;
	},
	
	/**
	 * Retrieve the placement offset for translating before applying the transform of this <code>Text</code> node.
	 * This value is specified as a multiple of the text area size with <code>(0,0)</code> as the top-left corner.
	 * @returns {Core.Vector} The current placement offset.
	 * @see GL2.Text#setAnchor
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getAnchor: function()
	{
		return this._anchor;
	},
	
	/**
	 * Retrieve the horizontal alignment of the text area from this <code>Text</code> node.
	 * @returns {GL2.Text#HorizontalAlign} The current horizontal alignment of the text area.
	 * @see GL2.Text#setHorizontalAlign
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getHorizontalAlign: function()
	{
		return this._horizontalAlign;
	},
	
	/**
	 * Retrieve the vertical alignment of the text area from this <code>Text</code> node.
	 * @returns {GL2.Text#VerticalAlign} The curren vertical alignment of the text area.
	 * @see GL2.Text#setVerticalAlign
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getVerticalAlign: function()
	{
		return this._verticalAlign;
	},
	
	/**
	 * Retrieve the text string this <code>Text</code> node will render.
	 * @returns {String} The current text string to render in the text area.
	 * @see GL2.Text#setText
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getText: function()
	{
		return this._text;
	},
	
	/**
	 * Retrieve the font family for the text area from this <code>Text</code> node.
	 * The GL2 module uses Arial as the text area font family when this value is undefined.<br><br>
	 * <b>Note:</b> <code>Text</code> nodes default to Arial as the font family when an application cannot load the specified font.
	 * @returns The current font family defined for the text area.
	 * @see GL2.Text#setFontFamily
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getFontFamily: function()
	{
		return this._fontFamily;
	},
	
	/**
	 * Retrieve the font size for the text area from this <code>Text</code> node.
	 * @returns {Number} The current font size defined for the text area.
	 * @see GL2.Text#setFontSize
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getFontSize: function()
	{
		return this._fontSize;
	},
	
	/**
	 * Retrieve the overflow style of the text area from this <code>Text</code> node. 
	 * @returns {GL2.Text#OverflowMode} The current overflow style defined for the text area.
	 * @see GL2.Text#setOverflowMode,
	 * @see GL2.Text#OverflowMode
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getOverflowMode: function()
	{
		return this._overflowMode;
	},
	
    /**
	 * Set the size in pixels of the text area for this <code>Text</code> node.
	 * The text area size is defined through two components: <i>width</i> and <i>height</i>. 
	 * @example var w = Core.Capabilities.getScreenWidth();
	 * var h = Core.Capabilities.getScreenHeight();
	 * ...
	 * var label = new GL2.Text();
	 * label.setSize(w, h);
	 * @param {Core.Vector} size A new vector specifying the text area size in pixels.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Text#getSize
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setSize: function(size)
	{
		var s = this._size;
		s.setAll.apply(s, arguments);

		this._setSizeSendGen(s.getWidth(),s.getHeight());
		
		return this;
	},
	
    /**
	 * Set the text area offset as a multiple of the area size (<i>width</i> and <i>height</i>).
	 * An <code>Anchor</code> defines a location the text area will rotate and scale around; <code>Anchors</code> are applied
	 * to the drawing prior to the composite transform for the node. When the text size of the text area is <code>0</code> in either
	 * dimension, the offset is measured from the rendered size of the string in that dimension.<br><br>
	 * <b>Example:</b> If you want to display a text area as centered, you can set the <code>horizontalAlign</code> to
	 * <code>centered</code> and set the <code>anchor</code> to <code>[0.5,h]</code> with <i>h</i> representing a vertical offset.
	 * @example text.setAnchor(0.5,h);
	 * @param {Core.Vector} location A new vector specifying the offset location.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Node,
	 * @see GL2.Text#getAnchor,
	 * @see GL2.Text#setHorizontalAlign
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setAnchor: function(location)
	{
		var a = this._anchor;
		a.setAll.apply(a, arguments);
		
		this._setAnchorSendGen(a.getX(),a.getY());
		
		return this;
	},
	
    /**
	 * Set the horizontal alignment of the text area for this <code>Text</code> node.
	 * @example var t = new GL2.Text(this._label);
	 * ...
	 * t.setHorizontalAlign(GL2.Text.HorizontalAlign.Center);
	 * @param {GL2.Text#HorizontalAlign} horizontalAlign The new horizontal alignment for the text area.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setHorizontalAlign: function(horizontalAlign)
	{
		this._horizontalAlign = horizontalAlign;
		
		this._setHorizontalAlignSendGen(horizontalAlign);
		
		return this;
	},
    
    /**
	 * Set the vertical alignment of the text area for this <code>Text</code> node.
	 * @example var t = new GL2.Text(this._label);
	 * ...
	 * t.setVerticalAlign(GL2.Text.VerticalAlign.Middle);
	 * @param {GL2.Text#VerticalAlign} verticalAlign The new vertical alignment for the text area.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Text#getVerticalAlign
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setVerticalAlign: function(verticalAlign)
	{
		this._verticalAlign = verticalAlign;
		
		this._setVerticalAlignSendGen(verticalAlign);
		
		return this;
	},
    
    /**
	 * Set the text string to render in the text area of this <code>Text</code> node.
	 * @example var label = new GL2.Text();
	 * ...
	 * label.setText('This is a label');
	 * @param {String} text The new text string to render in the text area.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Text#getText
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setText: function(text)
	{
		this._text = text;
		
		this._setTextSendGen(text);
		
		return this;
	},
    
    /**
	 * Set the font family to use for rendering text strings in the text area of this <code>Text</code> node.<br><br>
	 * Using this call to set application specific fonts (os-independent) requires you to add the font file name with extension (.ttf) to the manifest.json.
	 * The font family file must reside in the <code>Content</code> directory. The font family file name is passed in this call. The font face is applied to each object of type 
	 * <code>GL2.Text</code> that will override the system font.
	 * @example var font = new GL2.Text();
	 * ...
	 * font.setFontFamily("Content/Cacophony.ttf");
	 * @param {String} [fontFamily=Arial] The new font family to render in the text area.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Text#getFontFamily
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setFontFamily: function(fontFamily)
	{
		this._fontFamily = fontFamily;
		
		this._setFontFamilySendGen(fontFamily);
		
		return this;
	},
    
    /**
	 * Set the text area font size for this <code>Text</code> node.
	 * @example var fontSize = 24;
	 *
	 * var font = new GL2.Text();
	 * ...
	 * font.setFontSize(fontSize);
	 * @param {Number} [fontSize=18pt] The new font size for text strings (expressed in points).
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Text#getFontSize
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setFontSize: function(fontSize)
	{
		this._fontSize = fontSize;
		
		this._setFontSizeSendGen(fontSize);
		
		return this;
	},
	
	/**
	 * Set the overflow style of the text area for this <code>Text</code> node. 
	 * This method defines how a <code>Text</code> node will fit a rendered string inside 
	 * the text area when the string is too long.
	 * @example var font = new GL2.Text();
	 * ...
	 * font.setOverflowMode(GL2.Text.OverflowMode.ReduceFontSize);
	 * @param {GL2.Text#OverflowMode} overflowMode The overflow rendering style for long text strings.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Text#getOverflowMode,
	 * @see GL2.Text#OverflowMode
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setOverflowMode: function(overflowMode)
	{
		this._overflowMode = overflowMode;
		
		this._setOverflowModeSendGen(overflowMode);
		
		return this;
	},
	
	/**
	 * Set the directory path to the location of a font used by this <code>Text</code> node.
	 * @example var font = new GL2.Text();
	 * ...
	 * font.setFontLocation(GL2.Text.FontLocation.System);
	 * @param {String} fontLocation The new directory path to a font used in the text area.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setFontLocation: function(fontLocation)
	{
		this._fontLocation = fontLocation;
		
		this._setFontLocationSendGen(fontLocation);
		
		return this;
	},
	
	/**
	 * Translate a global scene location to the local coordinate space of this <code>Text</code> node.
	 * Use this method when determining <code>touchMoved</code> offsets.
	 * @example var p = Game.getRoot().screenToLocal(touch.getPosition());
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {Core.Vector} location The location to transform.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	screenToLocal: function($super, location)
	{
		location = $super(location);
		if(!location)
			return undefined;
		
		var a = this._anchor;
		var s = this._size;
			
		location.setX(location.getX() + a.getX() * s.getWidth());
		location.setY(location.getY() + a.getY() * s.getHeight());
		return location;
	},
	
	/**
	 * Translate a location in the local coordinate space to the global scene coordinate space of this <code>Text</code> node.
	 * Use this method for translating between local coordinate spaces.
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {Core.Vector} location The location to transform.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	localToScreen: function($super, location)
	{
		var a = this._anchor;
		var s = this._size;
			
		location.setX(location.getX() - a.getX() * s.getWidth());
		location.setY(location.getY() - a.getY() * s.getHeight());
		
		location = $super(location);
		if(!location)
			return undefined;
		return location;
	},
	
// {{?Wg Generated Code}}
	
	// Enums.
	/** 
	 * Enumeration for horizontal alignment modes.
	 * @namespace
	 */
	HorizontalAlign:
	{ 
		/** Align text to the left. */
		Left: 0,
		/** Align text in the center. */
		Center: 1,
		/** Align text to the right. */
		Right: 2,
	},
	
	/** 
	 * Enumeration for vertical alignment modes.
	 * @namespace
	 */
	VerticalAlign:
	{ 
		/** Align text to the top. */
		Top: 0,
		/** Align text in the middle. */
		Middle: 1,
		/** Align text to the bottom. */
		Bottom: 2,
	},
	
	/** 
	 * Enumeration for the behavior when there is too much text to fit on one line.
	 * @namespace
	 */
	OverflowMode:
	{ 
		/** Reduce the font size until the text fits. */
		ReduceFontSize: 0,
		/** Break the text across multiple lines. */
		Multiline: 1,
	},
	
	/** 
	 * Enumeration for location of fonts.
	 * @namespace
	 */
	FontLocation:
	{ 
		/** Use Default fonts. */
		Default: 0,
		/** Use System fonts. */
		System: 1,
		/** Use bundled fonts that ship with engine and available to all apps. */
		Bundled: 2,
		/** Use custom fonts that are loaded with app manifest. */
		Manifest: 3,
	},
	
	///////
	// Class constants (for internal use only):
	// Class ID = 311
	// Method create = -1
	// Method destroy = 2
	// Method setSize = 3
	// Method setAnchor = 4
	// Method setHorizontalAlign = 5
	// Method setVerticalAlign = 6
	// Method setText = 7
	// Method setFontFamily = 8
	// Method setFontSize = 9
	// Method setOverflowMode = 10
	// Method setFontLocation = 11
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Text._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Text._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[311] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":311,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":311,2," + this.__objectRegistryId );
	},
	
	/** @private */
	_setSizeSendGen: function( width, height )
	{
		Core.Proc.appendToCommandString( ":311,3," + this.__objectRegistryId + "," + width + "," + height  );
	},
	
	/** @private */
	_setAnchorSendGen: function( x, y )
	{
		Core.Proc.appendToCommandString( ":311,4," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	_setHorizontalAlignSendGen: function( align )
	{
		Core.Proc.appendToCommandString( ":311,5," + this.__objectRegistryId + "," + align  );
	},
	
	/** @private */
	_setVerticalAlignSendGen: function( align )
	{
		Core.Proc.appendToCommandString( ":311,6," + this.__objectRegistryId + "," + align  );
	},
	
	/** @private */
	_setTextSendGen: function( text )
	{
		Core.Proc.appendToCommandString( ":311,7," + this.__objectRegistryId + "," + Core.Base64.encode( text )  );
	},
	
	/** @private */
	_setFontFamilySendGen: function( fontFamily )
	{
		Core.Proc.appendToCommandString( ":311,8," + this.__objectRegistryId + "," + Core.Base64.encode( fontFamily )  );
	},
	
	/** @private */
	_setFontSizeSendGen: function( fontSize )
	{
		Core.Proc.appendToCommandString( ":311,9," + this.__objectRegistryId + "," + fontSize  );
	},
	
	/** @private */
	_setOverflowModeSendGen: function( overflowMode )
	{
		Core.Proc.appendToCommandString( ":311,10," + this.__objectRegistryId + "," + overflowMode  );
	},
	
	/** @private */
	_setFontLocationSendGen: function( fontLocation )
	{
		Core.Proc.appendToCommandString( ":311,11," + this.__objectRegistryId + "," + fontLocation  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// setSize: function( width, height ) {}
	
	// setAnchor: function( x, y ) {}
	
	// setHorizontalAlign: function( align ) {}
	
	// setVerticalAlign: function( align ) {}
	
	// setText: function( text ) {}
	
	// setFontFamily: function( fontFamily ) {}
	
	// setFontSize: function( fontSize ) {}
	
	// setOverflowMode: function( overflowMode ) {}
	
	// setFontLocation: function( fontLocation ) {}
	

// {{/Wg Generated Code}}
});

; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/GL2/RenderTarget'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/GL2/RenderTarget'] || {}; $MODULE_REGISTRY['NGCore/Client/GL2/RenderTarget'] = exports; var Core = require('NGCore/Client/Core').Core;

exports.RenderTarget = Core.Class.subclass(
	/** @lends GL2.RenderTarget.prototype */
{
	classname: 'RenderTarget',

	/**
	 * @class The GL2.RenderTarget object is used to render a set of GL2.Nodes into a texture target.
	 * this target can then be attached to GL2.Animation.Frames and rendered attached to a GL2.Sprite or GL2.Primitive node.
	 *
	 * @constructs Constructs a new GL2.RenderTarget object.
	 * @param {Number} width Width of texture, must be power of two.
	 * @param {Number} height Height of texture, must be power of two.
	 * @param {bool} [isOpaque] When false (the default) the texture will include an alpha channel, when true the texture will be opaque.
	 */
	initialize: function (width, height, isOpaque, sizePolicy) {
		Core.ObjectRegistry.register(this);
		this._children = [];
		this._width = width;
		this._height = height;
		this._isOpaque = isOpaque ? true : false;
		this._createSendGen(this.__objectRegistryId, width, height, this._isOpaque);
		this._callbackIndexCounter = 1;
		this._callbacks = [];
	},

	/**
	 * Destroys the texture target.
	 */
	destroy: function () {
		var children = this._children;
		while (children.length) {
			this.removeChild(children[0]);
		}
		this._destroySendGen();
		Core.ObjectRegistry.unregister(this);
	},

	/**
	 * Adds a GL2.Node object to the RenderTarget.  Visual changes will take effect on the next update.
	 * @param {GL2.Node} child Node to be added.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 */
	addChild: function (child) {
		this._children.push(child);
		child._didAddToParent(this);
		this._addChildSendGen(Core.ObjectRegistry.objectToId(child));
		return this;
	},

	/**
	 * Removes a GL2.Node object from the RenderTarget. Visual changes will take effect on the next update.
	 * @param {GL2.Node} child Node to be removed.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 */
	removeChild: function (child) {
		child._willRemoveFromParent();
		var index = this._children.indexOf(child);
		if (index === -1)
			throw new Error('removeChild called for a node that is not a child');
		this._children.splice(index, 1);
		this._removeChildSendGen(Core.ObjectRegistry.objectToId(child));
		return this;
	},

	/**
	 * Render all the currently attached GL2.Nodes into the texture target.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 */
	update: function () {
		this._updateSendGen();
		return this;
	},

	/**
	 * Automatically render all currently attached GL2.Nodes every frame.
	 * This has the same effect as calling the update method on every frame.
	 * @param {bool} [autoUpdateEnable] Defaults to true, which causes the texture to be updated frame.  Set to false to stop auto updates.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 */
	setAutoUpdate: function (autoUpdateEnable) {
		var enable = (autoUpdateEnable || (autoUpdateEnable === undefined)) ? true : false;
		this._setAutoUpdateSendGen(enable);
		return this;
	},

	/**
	 * Clear texture background before rendering.  By default the background is not cleared.
	 * @param {bool} [clearEnabled] Defaults to true, causing the texture to be cleared before nodes are drawn.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 */
	setClearEnable : function (clearEnable) {
		var enable = (clearEnable || (clearEnable === undefined)) ? true : false;
		this._setClearEnableSendGen(enable);
		return this;
	},

	/**
	 * Set background color of texture.  Can be called with a single Core.color argument or 3 Number arguments.
	 * The default clear color is white.  If the RenderTarget has an alpha component it can be set via the setClearColorAlpha() method.
	 * @param {Number|Core.color} colorOrRed Opaque background color, or the red component if 3 or 4 parameters are given.
	 * @param {Number} [green] Green component of clear color (0, 1).
	 * @param {Number} [blue] Blue component of clear color (0, 1).
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 */
	setClearColor : function () {
		var r, g, b, color;
		if (arguments.length === 1)
		{
			color = arguments[0];
			r = color.getRed();
			g = color.getGreen();
			b = color.getBlue();
		}
		else
		{
			r = arguments[0];
			g = arguments[1];
			b = arguments[2];
		}
		this._setClearColorSendGen(r, g, b);
		return this;
	},

	/**
	 * Set alpha component of background color of texture.
	 * The default clear alpha is 1, opaque.
	 * @param {Number} alpha background color opacity.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 */
	setClearColorAlpha : function (alpha) {
		this._setClearColorAlphaSendGen(alpha);
		return this;
	},

	/**
	 * Save image to the filesystem.
	 * @param {String} filename name of bitmap.
	 * @param {Core.Rect} [rect] Image clip rectangle.  If not specfied the entire RenderTexture will be saved.
	 * @param {Function} [callback] A closure to be executed after image has been saved.  The resulting filename is passed as an argument.
	 */
	save : function (filename, rect, callback) {
		var id = 0;
		if (callback) {
			id = this._callbackIndexCounter++;
			this._callbacks[id] = callback;
		}
		var x = rect ? rect.getOrigin().getX() : -1;
		var y = rect ? rect.getOrigin().getY() : -1;
		var w = rect ? rect.getSize().getWidth() : -1;
		var h = rect ? rect.getSize().getHeight() : -1;
		this._saveSendGen(id, filename, x, y, w, h);
	},

	/**
	 * @private
	 */
	_invokeCallbackRecv: function (cmd)	{
		var msg = {};
		if (!this._invokeCallbackRecvGen(cmd, msg)) {
			return;
		}

		var id = msg.callbackId;
		var err = msg.error;
		if (!id) {
			NgLogE("invokeCallbackRecv command : bad id = " + id);
			return;
		}
		var cb = this._callbacks[id];
		if (!cb) {
			NgLogE("invokeCallbackRecv command : No registered callback found, id = " + id);
			return;
		}
		delete this._callbacks[id];
		cb(err);
	},

	/**
	 * Enable or disable backing store for RenderTarget. Disabled by default
	 * The backing store is used to guarantee that texture will be restored after the application is suspended and restored.
	 * If backing store is not enabled, then the texture is not guaranteed to render correctly after the application is restored.
	 * @param {Bool} [backingStoreEnable] If omitted backing store will be enabled.
	 */
	setBackingStoreEnable: function (backingStoreEnable) {
		var enable = (backingStoreEnable || (backingStoreEnable === undefined)) ? true : false;
		this._setBackingStoreEnableSendGen(enable);
		return this;
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 353
	// Method create = -1
	// Method destroy = 2
	// Method addChild = 3
	// Method removeChild = 4
	// Method update = 5
	// Method setAutoUpdate = 6
	// Method setClearEnable = 7
	// Method setClearColor = 8
	// Method setClearColorAlpha = 9
	// Method save = 10
	// Method invokeCallback = 11
	// Method setBackingStoreEnable = 12
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 11:
					instance._invokeCallbackRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in RenderTarget._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in RenderTarget._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[353] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_invokeCallbackRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in RenderTarget.invokeCallback from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in RenderTarget.invokeCallback from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in RenderTarget.invokeCallback from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( objectRegistryId, width, height, isOpaque )
	{
		Core.Proc.appendToCommandString( ":353,-1," + objectRegistryId + "," + width + "," + height + "," + ( isOpaque ? 1 : 0 )  );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":353,2," + this.__objectRegistryId );
	},
	
	/** @private */
	_addChildSendGen: function( child )
	{
		Core.Proc.appendToCommandString( ":353,3," + this.__objectRegistryId + "," + child  );
	},
	
	/** @private */
	_removeChildSendGen: function( child )
	{
		Core.Proc.appendToCommandString( ":353,4," + this.__objectRegistryId + "," + child  );
	},
	
	/** @private */
	_updateSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":353,5," + this.__objectRegistryId );
	},
	
	/** @private */
	_setAutoUpdateSendGen: function( autoUpdateEnable )
	{
		Core.Proc.appendToCommandString( ":353,6," + this.__objectRegistryId + "," + ( autoUpdateEnable ? 1 : 0 )  );
	},
	
	/** @private */
	_setClearEnableSendGen: function( clearEnable )
	{
		Core.Proc.appendToCommandString( ":353,7," + this.__objectRegistryId + "," + ( clearEnable ? 1 : 0 )  );
	},
	
	/** @private */
	_setClearColorSendGen: function( r, g, b )
	{
		Core.Proc.appendToCommandString( ":353,8," + this.__objectRegistryId + "," + r + "," + g + "," + b  );
	},
	
	/** @private */
	_setClearColorAlphaSendGen: function( a )
	{
		Core.Proc.appendToCommandString( ":353,9," + this.__objectRegistryId + "," + a  );
	},
	
	/** @private */
	_saveSendGen: function( callbackId, filename, originX, originY, width, height )
	{
		Core.Proc.appendToCommandString( ":353,10," + this.__objectRegistryId + "," + callbackId + "," + Core.Base64.encode( filename ) + "," + originX + "," + originY + "," + width + "," + height  );
	},
	
	/** @private */
	_setBackingStoreEnableSendGen: function( backingStoreEnable )
	{
		Core.Proc.appendToCommandString( ":353,12," + this.__objectRegistryId + "," + ( backingStoreEnable ? 1 : 0 )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( objectRegistryId, width, height, isOpaque ) {}
	
	// destroy: function(  ) {}
	
	// addChild: function( child ) {}
	
	// removeChild: function( child ) {}
	
	// update: function(  ) {}
	
	// setAutoUpdate: function( autoUpdateEnable ) {}
	
	// setClearEnable: function( clearEnable ) {}
	
	// setClearColor: function( r, g, b ) {}
	
	// setClearColorAlpha: function( a ) {}
	
	// save: function( callbackId, filename, originX, originY, width, height ) {}
	
	// _invokeCallbackRecv: function( cmd ) {}
	// setBackingStoreEnable: function( backingStoreEnable ) {}
	

// {{/Wg Generated Code}}

});; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Audio/ActiveEffect'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Audio/ActiveEffect'] || {}; $MODULE_REGISTRY['NGCore/Client/Audio/ActiveEffect'] = exports; var Core = require('NGCore/Client/Core').Core;

exports.ActiveEffect = Core.Class.subclass(
/** @lends Audio.ActiveEffect.prototype */
{
	/**
	 * @class The <code>ActiveEffect</code> class constructs objects that control 
	 * the reproduction of an audio effect. Audio effects in Mobage applications are captured as <code>{@link Audio.Effect}</code> objects. 
	 * <code>{@link Audio.Effect}</code> objects handle and load data for an audio effect into memory. 
	 * This seperation allows applications to manage effect data independently of effect reproduction.
	 * <br><br>
	 * <b>Note:</b> You can only specify <code>{@link Audio.Effect}</code> objects to reproduce at instantiation.
	 * 
	 * @example
	 *
	 *   var effect = new Audio.Effect('some_effect.wav');
	 *   var activeEffect = new Audio.ActiveEffect(effect);
	 *   activeEffect.play();
	 * @constructs The default constructor. 	 
	 * @augments Core.Class
	 * @param {Audio.Effect} effect The <code>{@link Audio.Effect}</code> that this <code>ActiveEffect</code> object plays.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	initialize: function(effect)
	{
		this._volume  = 1.0;
		this._loops   = false;
		this._playing = false;
		this._paused  = false;

		this._playCompleteEmitter = new Core.MessageEmitter();

		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
		this._setEffect(effect);
	},
	
	/**
	 * Destroy this instance and releases resources on the backend.
	 * <b>Note:</b> This call does not automatically destroy the associated <code>{@link Audio.Effect}</code>.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	destroy: function()
	{
		this.stop();
		this._effect = null;
		this._playCompleteEmitter.destroy();
		this._destroySendGen();
		Core.ObjectRegistry.unregister(this);
	},
	
	/**
	 * Return the volume level for the <code>{@link Audio.Effect}</code> this <code>ActiveEffect</code> is reproducing.
	 * @returns {Number} The current volume level.
	 * @see Audio.ActiveEffect#setVolume
	 * @status iOS, Android, Test
	 */
	getVolume: function()
	{
		return this._volume;
	},
	
	/**
	 * Set the volume level for the <code>{@link Audio.Effect}</code> this <code>ActiveEffect</code> is reproducing.
	 * Calling this changes the volume even if an application is in the middle of reproducing an <code>{@link Audio.Effect}</code> object.
	 * The new volume level applies to any subsequent reproductions of the <code>{@link Audio.Effect}</code> object.
	 * @example Audio.ActiveEffect.setVolume(0.5);
	 * @param {Number} [volume=1] The new volume level. Supported values range between <code>(0-1)</code>. 
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Audio.ActiveEffect#getVolume
	 * @status iOS, Android
	 */
	setVolume: function(volume)
	{
		if (volume < 0.0) volume = 0.0;
		if (volume > 1.0) volume = 1.0;

		this._volume = volume;
		this._setVolumeSendGen(volume);
		return this;
	},
	
	/**
	 * Return the loop status for the <code>{@link Audio.Effect}</code> this <code>ActiveEffect</code> is reproducing.
	 * @returns {Boolean} Returns <code>true</code> if looping is enabled.
	 * @see Audio.ActiveEffect#setLoops
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getLoops: function()
	{
		return this._loops;
	},
	
	/**
	 * Set the loop state for the <code>{@link Audio.Effect}</code> this <code>ActiveEffect</code> is reproducing.
	 * A looped effect wraps seamlessly from begining to end.
	 * @example Audio.ActiveEffect.setLoops(true);
	 * @param {Boolean} loops Set as <code>true</code> to enable looping.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Audio.ActiveEffect#getLoops
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	setLoops: function(loops)
	{
		this._loops = loops;
		this._setLoopsSendGen(loops);
		return this;
	},
	
	/**
	 * Return the <code>Play Complete</code> emitter for the <code>{@link Audio.Effect}</code> this <code>ActiveEffect</code> is reproducing.
	 * The <code>Play Complete</code> emitter notifies applications when reproduction of an <code>{@link Audio.Effect}</code> is complete.<br><br>
	 * <b>Notes:</b>
	 * <ul>
	 *   <li>Any <code>{@link Audio.Effect}</code> object that does not loop uses the <code>Play Complete</code> emitter. </li>
	 * </ul>
	 * @returns {Core.MessageEmitter} The current state of the <code>Play Complete</code> emitter.
	 * @status iOS
	 */
	getPlayCompleteEmitter: function()
	{
		return this._playCompleteEmitter;
	},
	
	/**
	 * Return the play status of the <code>{@link Audio.Effect}</code> this <code>ActiveEffect</code> is reproducing.
	 * @returns {Boolean} Returns <code>true</code> if this <code>ActiveEffect</code> is reproducing an <code>{@link Audio.Effect}</code>.
	 * @see Audio.ActiveEffect#play
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getIsPlaying: function()
	{
		return this._playing;
	},
	
	/**
	 * Return the pause status of the <code>{@link Audio.Effect}</code> this <code>ActiveEffect</code> is reproducing.
	 * @returns {Boolean} Returns <code>true</code> if this <code>(@link Audio.Effect}</code> is in a paused state.
	 * @see Audio.ActiveEffect#pause
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getIsPaused: function()
	{
		return this._paused;
	},
	
	/**
	 * Begin reproducing an <code>{@link Audio.Effect}</code>.
	 * <ul>
	 * <li>If this <code>{@link Audio.Effect}</code> is new or in a stopped state,
	 * reproduction starts at the beginning.</li>
	 * <li>If this <code>{@link Audio.Effect}</code> is in a paused state, reproduction resumes from the previous position.</li>
	 * <li>If this <code>{@link Audio.Effect}</code> is playing, this call does nothing.</li>
	 * </ul>
	 * @see Audio.ActiveEffect#getIsPlaying
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	play: function()
	{
		this._playing = true;
		this._paused  = false;
		this._playSendGen( );
	},
	
	/**
	 * Pause reproduction of an <code>{@link Audio.Effect}</code>.
	 * <ul>
	 * <li>If this <code>ActiveEffect</code> is in the process of reproducing an <code>{@link Audio.Effect}</code>, this call pauses reproduction.</li>
	 * <li>If the <code>{@link Audio.Effect}</code> is in a stopped or paused state, this call does nothing.</li>
	 * </ul>
	 * <b>Note:</b> Calling this does not trigger the <code>Play Complete</code> emitter.
	 * @see Audio.ActiveEffect#getIsPaused
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	pause: function()
	{
		this._playing = false;
		this._paused  = true;
		this._pauseSendGen( );
	},
	
	/**
	 * Stop reprodution of an <code>{@link Audio.Effect}</code> object.
	 * <ul>
	 * <li>If this <code>ActiveEffect</code> is currently reproducing an <code>{@link Audio.Effect}</code> or the <code>{@link Audio.Effect}</code> is in a paused state, this call stops reproduction.</li>
	 * <li>If the <code>{@link Audio.Effect}</code> is in a stopped state, this call does nothing.</li>
	 * </ul>
	 * <b>Note:</b> Calling <code>stop()</code> does not trigger the <code>Play Complete</code> emitter.
	 * @status iOS, Android, Test, iOSTested, AndroidTested	 
	 */
	stop: function()
	{
		this._playing = false;
		this._paused  = false;
		this._stopSendGen( );
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 328
	// Method create = -1
	// Method destroy = 2
	// Method setVolume = 3
	// Method setLoops = 4
	// Method play = 5
	// Method pause = 6
	// Method stop = 7
	// Method setEffect = 8
	// Method playComplete = 9
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 9:
					instance._playCompleteRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in ActiveEffect._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in ActiveEffect._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[328] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_playCompleteRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 0 )
		{
			NgLogE("Could not parse due to wrong argument count in ActiveEffect.playComplete from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":328,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":328,2," + this.__objectRegistryId );
	},
	
	/** @private */
	_setVolumeSendGen: function( volume )
	{
		Core.Proc.appendToCommandString( ":328,3," + this.__objectRegistryId + "," + volume  );
	},
	
	/** @private */
	_setLoopsSendGen: function( loops )
	{
		Core.Proc.appendToCommandString( ":328,4," + this.__objectRegistryId + "," + ( loops ? 1 : 0 )  );
	},
	
	/** @private */
	_playSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":328,5," + this.__objectRegistryId );
	},
	
	/** @private */
	_pauseSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":328,6," + this.__objectRegistryId );
	},
	
	/** @private */
	_stopSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":328,7," + this.__objectRegistryId );
	},
	
	/** @private */
	_setEffectSendGen: function( effectId )
	{
		Core.Proc.appendToCommandString( ":328,8," + this.__objectRegistryId + "," + effectId  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// setVolume: function( volume ) {}
	
	// setLoops: function( loops ) {}
	
	// play: function(  ) {}
	
	// pause: function(  ) {}
	
	// stop: function(  ) {}
	
	// setEffect: function( effectId ) {}
	
	// _playCompleteRecv: function( cmd ) {}

// {{/Wg Generated Code}}

	_setEffect: function(effect)
	{
		this._effect  = effect;
		this._setEffectSendGen(this._effect.__objectRegistryId);
		return this;
	},

	_playCompleteRecv: function( cmd )
	{
		var msg = {};
		if(!this._playCompleteRecvGen(cmd, msg))
			return;

		this._playing = false;
		this._paused  = false;

		this._playCompleteEmitter.emit(this);
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Audio/Effect'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Audio/Effect'] || {}; $MODULE_REGISTRY['NGCore/Client/Audio/Effect'] = exports; var Core = require('NGCore/Client/Core').Core;

exports.Effect = Core.Class.subclass(
/** @lends Audio.Effect.prototype */
{
	/**
	 * @class The <code>Effect</code> class constructs objects for handling audio resources that comprise an audio effect.
	 * Instantiating these objects allocates resources on the backend.
	 * After creating an <code>Effect</code> object, applications can control reproduction through an <code>{@link Audio.ActiveEffect}</code> object.<br><br>
	 * @example
	 * var effect = new Audio.Effect('Content/explosion.wav');
	 * @constructs The default constructor.<br><br>
	 * The following code is an example of constructing a new <code>Effect</code> object.
	 * @augments Core.Class
	 * @param {String} path A directory path that points to the audio file to load.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	initialize: function(path)
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
		this._setPath(path);
	},
	
	/**
	 * Destroy this instance and release resources on the backend.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	destroy: function()
	{
		this._destroySendGen();
		Core.ObjectRegistry.unregister(this);
	},
	
	/**
	 * Set a directory path to the audio file resource for this <code>Effect</code> object.
	 * @param {String} path The new directory path.
	 * @returns Calls to <code>setPath()</code> return <code>this</code> to support method invocation chaining.
	 */
	_setPath: function(path)
	{
		this._path = path;
		this._setPathSendGen(path);
		return this;
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 326
	// Method create = -1
	// Method destroy = 2
	// Method setPath = 3
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Effect._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Effect._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[326] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":326,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":326,2," + this.__objectRegistryId );
	},
	
	/** @private */
	_setPathSendGen: function( path )
	{
		Core.Proc.appendToCommandString( ":326,3," + this.__objectRegistryId + "," + Core.Base64.encode( path )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// setPath: function( path ) {}
	

// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Audio/Device'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Audio/Device'] || {}; $MODULE_REGISTRY['NGCore/Client/Audio/Device'] = exports; var Core = require('NGCore/Client/Core').Core;

exports.Device = Core.Class.singleton(
/** @lends Audio.Device.prototype */
{
	classname: 'Device',

	/**
	 * @class The <code>Device</code> class constructs a singleton object that contains audio device properties.
	 * Applications can use <codeDevice</code> objects to control global audio effects volume 
	 * and reproduce detached audio effects.
	 * <br><br>
	 * <b>Note:</b> An application should never directly allocate a singleton.
	 * @constructs The default constructor. 
	 * @augments Core.Class
	 */
	 
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
		this._volume = undefined; // default value

		var KeyValueCache = require('NGCore/Client/Storage/KeyValue').KeyValueCache;
		var initialValues = KeyValueCache.global("Audio.Device.InitialValues");

		var self = this;
		initialValues.getItem("effectsVolume", function(error, value) {
			self._volume = parseFloat(value);
		});
	},
	
	/**
	 * Return the global sound effects volume for this <code>Device</code> object.
	 * @returns {Number} The current global sound effects volume.
	 * @see Audio.Device#setEffectsVolume	 
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getEffectsVolume: function()
	{
		return this._volume;
	},
	
	/**
	 * Set the global sound effects volume for this <code>Device</code> object.
	 * Volume for each active effect multiplies
	 * by this value to produce a new volume level. 
	 * For example, if the global sound effects volume is set to 0.5, each active effect will play at half the volume set on the effect.
	 * @param {Number} [effectsVolume=1] The new volume for global sound effects. 
	 * Supported values range between <code>(0-1)</code>. 
	 * @example Audio.Device.setEffectsVolume(0.5);
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Audio.Device#getEffectsVolume
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	setEffectsVolume: function(effectsVolume)
	{
		if (effectsVolume < 0.0) effectsVolume = 0.0;
		if (effectsVolume > 1.0) effectsVolume = 1.0;

		this._volume = effectsVolume;
		this._setEffectsVolumeSendGen(effectsVolume);
		return this;
	},
	
	/**
	 * Play an audio effect in a way that is completely detached from upstream or downstream processing.
	 * Using this call is a simple, high-level way to reproduce an audio effect.<br><br>
	 * The specified audio effect is only reproduced once.
	 * There is no control over the effect volume or effect playback.
	 * Resource allocation automatically occurs on the backend when playback begins. Resources are automatically released when playback ends.	 
	 * The following code is an example of a <code>playDetached()</code> call.
	 * @example
	 * Audio.Device.playDetached('Content/explosion.wav');
	 * @param {String} path A relative directory path to the audio file.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	playDetached: function(path)
	{
		this._playDetachedSendGen( path );
		return this;
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 327
	// Method create = -1
	// Method setEffectsVolume = 2
	// Method playDetached = 3
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Device._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Device._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[327] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":327,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_setEffectsVolumeSendGen: function( effectsVolume )
	{
		Core.Proc.appendToCommandString( ":327,2," + this.__objectRegistryId + "," + effectsVolume  );
	},
	
	/** @private */
	_playDetachedSendGen: function( path )
	{
		Core.Proc.appendToCommandString( ":327,3," + this.__objectRegistryId + "," + Core.Base64.encode( path )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// setEffectsVolume: function( effectsVolume ) {}
	
	// playDetached: function( path ) {}
	

// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Audio/Music'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Audio/Music'] || {}; $MODULE_REGISTRY['NGCore/Client/Audio/Music'] = exports; var Core = require('NGCore/Client/Core').Core;

exports.Music = Core.Class.singleton(
/** @lends Audio.Music.prototype */
{
	classname: 'Music',

	/**
	 * @class The <code>Music</code> class constructs a singleton object that provides control over reproduction
	 * of application background music.
	 * This object is constructed independently of <code>Device</code> objects because many devices
	 * already provide hardware-accelerated streaming and decode
	 * for a single background music track. Some
	 * devices gracefully mute a background music track
	 * if the user is playing a music track from their own library.
	 * <br><br>
	 * <b>Note:</b> Applications should never directly allocate a singleton.
	 * @example 
	 * var background = new Audio.Music('Content/music.mp3');
	 * @constructs The default constructor. 
	 * @augments Core.Class
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this.__objectRegistryId);
		this._path    = null;
		this._playing = false;
		this._paused  = false;
		this._volume  = 1.0;
	},
	
	/**
	 * Return the directory path to the background music file used as a resource for this <code>Music</code> object.
	 * @returns {String} The directory path to a music file.
	 * @see Audio.Music#setPath
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getPath: function()
	{
		return this._path;
	},
	
	/**
	 * Set the directory path for the background music file that this <code>Music</code> object loads.<br><br>
	 * <b>Note:</b> If the application is reproducing music when this is called, reproduction will stop.
	 * The application must call <code>play()</code> again to start reproduction of the new resource.<br><br>
	 * The code in the following example sets a directory path to a music resource and plays that resource.
	 * @example
	 * Audio.Music.setPath('Content/music.mp3');
	 * Audio.Music.play();
	 *
	 * @param {string} path The new directory path to a music file.
	 * @see Audio.Music#getPath,
	 * @see Audio.Music#play
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	setPath: function(path)
	{
		this._path = path;
		this._setPathSendGen(path);
	},
	
	/**
	 * Return the volume level used for reproduction of this <code>Music</code> object.
	 * @returns {Number} The current volume level.
	 * @see Audio.Music#setVolume
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getVolume: function()
	{
		return this._volume;
	},
	
	/**
	 * Set the volume level used for reproduction of this <code>Music</code> object.
	 * This call instantly modifies the background music volume level.
	 * Any subsequent reproductions of background music will play at the specified volume.
	 * @example Audio.Music.setVolume(0.5);
	 * @param {Number} [volume=1] The new volume. Supported values range between <code>(0-1)</code>.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Audio.Music#getVolume
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	setVolume: function(volume)
	{
		if (volume < 0.0) volume = 0.0;
		if (volume > 1.0) volume = 1.0;

		this._volume = volume;
		this._setVolumeSendGen(volume);
		return this;
	},
	
	/**
	 * Return the playback state of this <code>Music</code> object. 
	 * @returns {Boolean} Returns <code>true</code> if an application is reproducing background music.
	 * @see Audio.Music#play
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getIsPlaying: function()
	{
		return this._playing;
	},
	
	/**
	 * Return the pause state of this <code>Music</code> object.
	 * @returns {Boolean} Returns <code>true</code> if an application is reproducing background music.
	 * @see Audio.Music#pause
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getIsPaused: function()
	{
		return this._paused;
	},
	
	/**
	 * Begin reproduction of this <code>Music</code> object.
	 * <ul>	
	 * <li>If this <code>Music</code> object is a new background music track, or the application has stopped the current background music track, 
	 * this call begins reproduction from the beginning.</li>
	 * <li>If the background music track is in a paused state, this call resumes reproduction from the previous position.</li>
	 * <li>If the background music track is currently playing, this call does nothing.</li>
	 * </ul>
	 * @see Audio.Music#getIsPlaying,
	 * @see Audio.Music#pause,
	 * @see Audio.Music#stop
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	play: function()
	{
		this._playing = true;
		this._paused  = false;
		this._playSendGen( );
	},
	
	/**
	 * Pause reproduction of this <code>Music</code> object.
	 * <ul>
	 * <li>If an application is currently reproducing a background music track, this call pauses reproduction.</li>
	 * <li>If the background music track is in a paused or stopped state, this call does nothing.</li>
	 * </ul>
	 * @see Audio.Music#getIsPaused
	 * @see Audio.Music#play,
	 * @see Audio.Music#stop
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	pause: function()
	{
		this._playing = false;
		this._paused  = true;
		this._pauseSendGen( );
	},
	
	/**
	 * Stop reproduction of this <code>Music</code> object.
	 * <ul>
	 * <li>If the background music track is playing or in a paused state, this call stops playback.</li>
	 * <li>If the background music track is in a stopped state, this call does nothing.</li>
	 * </ul>
	 * @see Audio.Music#play,
	 * @see Audio.Music#pause
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	stop: function()
	{
		this._playing = false;
		this._paused  = false;
		this._stopSendGen( );
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 329
	// Method create = -1
	// Method destroy = 2
	// Method setPath = 3
	// Method setVolume = 4
	// Method play = 5
	// Method pause = 6
	// Method stop = 7
	// Method playComplete = 8
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift(), 10 );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift(), 10 );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 8:
					instance._playCompleteRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Music._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Music._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[329] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_playCompleteRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 0 )
		{
			NgLogE("Could not parse due to wrong argument count in Music.playComplete from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":329,-1," + __objectRegistryId  );
	},
	
	/** @private */
	_destroySendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":329,2," + this.__objectRegistryId );
	},
	
	/** @private */
	_setPathSendGen: function( path )
	{
		Core.Proc.appendToCommandString( ":329,3," + this.__objectRegistryId + "," + Core.Base64.encode( path )  );
	},
	
	/** @private */
	_setVolumeSendGen: function( volume )
	{
		Core.Proc.appendToCommandString( ":329,4," + this.__objectRegistryId + "," + volume  );
	},
	
	/** @private */
	_playSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":329,5," + this.__objectRegistryId );
	},
	
	/** @private */
	_pauseSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":329,6," + this.__objectRegistryId );
	},
	
	/** @private */
	_stopSendGen: function(  )
	{
		Core.Proc.appendToCommandString( ":329,7," + this.__objectRegistryId );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// setPath: function( path ) {}
	
	// setVolume: function( volume ) {}
	
	// play: function(  ) {}
	
	// pause: function(  ) {}
	
	// stop: function(  ) {}
	
	// _playCompleteRecv: function( cmd ) {}

// {{/Wg Generated Code}}

	_playCompleteRecv: function( cmd )
	{
		var msg = {};
		if(!this._playCompleteRecvGen(cmd, msg))
			return;

		this._playing = false;
		this._paused  = false;
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Mobclix/AdView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Mobclix/AdView'] || {}; $MODULE_REGISTRY['NGCore/Client/Mobclix/AdView'] = exports; //
//  Mobclix.AdView.Base.js
//  Mobclix Mobage SDK
//
//  Copyright 2011 Mobclix. All rights reserved.
//

var AdViewInternal = require('NGCore/Client/Mobclix/AdViewInternal').AdViewInternal;

var AdView = exports.AdView = AdViewInternal.subclass(
/** @lends Mobclix.AdView.prototype */
{
	__className: "Mobclix.AdView",
	_subsequent: false,
	
	/**
	 * @class 
	 * This class should not be instantiated directly, instead use one of the following subclasses:
	 * <ul>
	 * <li>{@link Mobclix.AdView_320x50}</li>
	 * <li>{@link Mobclix.AdView_300x250}</li>
	 * </ul>
     *<br>
     * Mobclix.AdViews are resized automatically for screen density. Please
     * do not override the width and height of the AdView.<br>
     * Thus, when positioning a Mobclix.AdView, do not override the AdView's
     * frame's width and height accidentally. Positioning of the AdView
     * should be done in the following manner:<br><br>
     * var adViewFrame = adView.getFrame();<br>
     * adViewFrame[0] = x;<br>
     * adViewFrame[1] = y;<br>
     * adView.setFrame(adViewFrame);<br>
     *
	 * @constructs The default constructor.
	 * @public
	 */
	initialize: function($super) {
		$super();
	},

	/**
	 * Requests a new ad from the server
	 * If ad refreshes are paused, this will also call resumeAdAutoRefresh
	 *
	 * This should only be called when you want to manually refresh an ad.
	 * @public
	 */
	getAd: function() {
		this._subsequent = false;
		AdViewInternal.prototype.getAd.apply(this, arguments);
	},
	
	/**
	 * Pauses the autorefresh of ads
	 *
	 * This should be called in viewWillDisappear
	 * @public
	 */
	pauseAdAutoRefresh: function() {
		this.cancelScheduledGetAd();
	},

	/**
	 *	Resumes the autorefresh of ads
	 *
	 * This should be called in viewDidAppear
	 * @public
	 */
	resumeAdAutoRefresh: function() {
		if(!this._subsequent) {
			this.getAd();
		} else {
			this.scheduleNextGetAd();	
		}
	},

	/**
	 * Cancels any ads currently load and calls pauseAdRefresh
	 *
	 * This should be called in viewDidUnload/dealloc
	 * @public
	 */
	cancelAd: function() {
		this._cancelAd();
	}
});

/**
 * @class
 * Use this class to create an ad view for the 320x50 unit.
 * @name Mobclix.AdView_320x50
 * @extends Mobclix.AdView
 * @public
 */
exports.AdView_320x50 = AdView.subclass({
	_size: {
		width: 320,
		height: 50
	}
});

/**
 * @class
 * Use this class to create an ad view for the 300x250 unit.
 * @name Mobclix.AdView_300x250
 * @extends Mobclix.AdView
 * @public
 */
exports.AdView_300x250 = AdView.subclass({
	_size: {
		width: 300,
		height: 250
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Mobclix/FullScreenAdView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Mobclix/FullScreenAdView'] || {}; $MODULE_REGISTRY['NGCore/Client/Mobclix/FullScreenAdView'] = exports; //
//  Mobclix.FullScreenAdView.Base.js
//  Mobclix Mobage SDK
//
//  Copyright 2011 Mobclix. All rights reserved.
//

var AdViewInternal = require('NGCore/Client/Mobclix/AdViewInternal').AdViewInternal;

var FullScreenAdView = exports.FullScreenAdView = AdViewInternal.subclass(
/** @lends Mobclix.FullScreenAdView.prototype */
{
	__className: "Mobclix.FullScreenAdView",
	_subsequent: false,
	_canRequestNextAd: true,
    
	/**
	 * @class 
	 * This class should not be instantiated directly, instead use one of the following subclasses:
	 * <ul>
	 * <li>{@link Mobclix.AdView_FullScreen}</li>
	 * </ul>
     * <br>
     * This view does not need to be added to the view hierarchy. The
     * requested fullscreen ad will automatically be attached.
     * The easiest implementation of the FullScreenAdView can be done in
     * the following manner:<br><br>
     * var fullScreenAdView = new Mobclix.AdView_FullScreen();<br>
     * fullScreenAdView.requestAndDisplayAd();<br>
     *
	 * @constructs The default constructor.
	 * @public
	 */
	initialize: function($super) {
		$super();
	},

	/**
	 * Requests a new ad from the server. This ad will preload, but will not
     * display until displayAd is called.
     *
	 * @public
	 */
	requestAd: function() {
        if (!this._canRequestNextAd)
            return;
        this._canRequestNextAd = false;
		this._subsequent = false;
        this.prefetchAd();
	},


    /**
	 * Displays a requested ad. If no ad has been previously requested, this
     * method will not do anything.
     *
	 * @public
	 */
	displayAd: function() {
		AdViewInternal.prototype.displayAd.apply(this, arguments);
	},
    
    /**
	 * Requests and displays a requested ad as soon as it is finished
     * loading.
     *
	 * @public
	 */
	requestAndDisplayAd: function() {
        if (!this._canRequestNextAd)
            return;
        this._canRequestNextAd = false;
        this.getAd();
	},
    
    /**
	 * Returns if the FullScreenAdView has an ad prepared for display.
     *
     * @return	{bool}	If true, the FullScreenAdView is ready to display an
     * ad via the displayAd method.
	 * @public
	 */
    hasAd: function() {
        return this._hasPrefetchedAd;
    },

	/**
	 * Cancels any ads currently load and calls pauseAdRefresh
	 *
	 * This should be called in viewDidUnload/dealloc
	 * @public
	 */
	cancelAd: function() {
		this._cancelAd();
	},
});

/**
 * @class
 * Use this class to create a full screen adview.
 * @name Mobclix.AdView_FullScreen
 * @extends Mobclix.FullScreenAdView
 * @public
 */
exports.AdView_FullScreen = FullScreenAdView.subclass({
	_size: {
		width: 999,
		height: 999
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Mobclix/Core/Controller'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Mobclix/Core/Controller'] || {}; $MODULE_REGISTRY['NGCore/Client/Mobclix/Core/Controller'] = exports; //
//  Mobclix.Core.Controller.js
//  Mobclix Mobage SDK
//
//  Copyright 2011 Mobclix. All rights reserved.
//

var Core = require('NGCore/Client/Core').Core;
var Device = require('NGCore/Client/Device').Device;
var Storage = require('NGCore/Client/Storage').Storage;
var Session = require('NGCore/Client/Mobclix/Core/Session').Session;
var SessionTracking = require('NGCore/Client/Mobclix/Core/SessionTracking').SessionTracking;
var Config = require('NGCore/Client/Mobclix/Core/Config').Config;
var $mc = require('NGCore/Client/Mobclix/Core/Utils').Utils;

var ProxyListener = Core.MessageListener.subclass({
	onUpdate: function() {}
});

exports.Controller = Core.Class.singleton({
	applicationId: null,
    userAgent: null,
	networkEmitter: null,
	proxyListener: null,
	_isAppActive: true,
	sessionTracking: null,
	inModal: false,
	emitter: null,
	_hasBeenStarted: false,
	
	initialize: function() {
		this.proxyListener = new ProxyListener();
		var self = this;
		
		this.emitter = new Core.MessageEmitter();
		
		Device.NetworkEmitter.addListener(this.proxyListener, function() { });
		Device.LifecycleEmitter.addListener(this.proxyListener, function(event) {
			if(event == Device.LifecycleEmitter.Event.Suspend) {
				self.willGoInactive();
			} else if(event == Device.LifecycleEmitter.Event.Resume) {
				self.didBecomeActive();
			} else if(event == Device.LifecycleEmitter.Event.Terminate) {
				self.willTerminate();
			}
		});
	},
	
	hasBeenStarted: function() {
		return this._hasBeenStarted;
	},
	
	startWithApplicationId: function(id) {
		$mc.log("Starting with app id: " + id);

		var oldAppId = this.applicationId;
		var self = this;
		this.applicationId = id;

		if(!oldAppId || oldAppId != id) {
			Session.renewIdentifier();
			
			if(this.sessionTracking) this.sessionTracking.destroy();
			this.sessionTracking = new SessionTracking(this);
		}
		
		this._hasBeenStarted = true;
		
		Config.updateConfiguration(this);
		setTimeout(function() {
			self.emitter.emit(self);
		}, 1);
	},
	
	addListener: function(listener, func) {
		this.emitter.addListener(listener, func);
	},
	
	removeListener: function(listener) {
		this.emitter.removeListener(listener);
	},

	willTerminate: function() {
		this._isAppActive = false;
		if(this.sessionTracking) this.sessionTracking.willTerminate();
		$mc.log("App Lifecycle: willTerminate");
	},
	
	didBecomeActive: function() {
		this._isAppActive = true;
		if(this.sessionTracking) this.sessionTracking.didBecomeActive();
		$mc.log("App Lifecycle: didBecomeActive");
	},
	
	willGoInactive: function() {
		this._isAppActive = false;
		if(this.sessionTracking) this.sessionTracking.willGoInactive();
		$mc.log("App Lifecycle: willGoInactive");
	},
	
	isApplicationActive: function() {
		return this._isAppActive;
	},
	
	isAndroid: function() {
		return Core.Capabilities.getPlatformOS().match(/android/i);
	},
	
	isIOS: function() {
		return Core.Capabilities.getPlatformOS().match(/iphone|ipad|ios|ipod/i);
	},
	
	isIPad: function() {
		return Core.Capabilities.getPlatformOS().match(/ipad/i);
	},
		
	getNetworkState: function() {
		return "wifi";
		
		// This is broken
		switch (Device.NetworkEmitter.getLastStatus()) {
			case Device.NetworkEmitter.Status.Cellular:
				return "wifi";
			case Device.NetworkEmitter.Status.Wifi:
				return "carrier";
			default:
				return "none";
		}
	},
	
	getLocation: function() {
		if(Device.LocationEmitter.getListenerCount() > 0) {
			var lastLocation = Device.LocationEmitter.getLastLocation();
			if(lastLocation && lastLocation.position) {
				return lastLocation.position.getX() + "," + lastLocation.position.getY();
			}
		}

		return null;
	},
	
	getApplicationId: function() {
		return this.applicationId;
	},
    
    setUserAgent: function(ua, fromCache) {
        if (this.userAgent == null && fromCache) {
            $mc.log("Loading user agent from cache: ", ua);
            this.userAgent = ua;
            return;
        } else if (this.userAgent == null ||
                ua != this.userAgent) {
            $mc.log("Saving new user agent to cache: ", ua);
            this.userAgent = ua;
            var kv = new Storage.KeyValue();
            kv.registerForKey("mobclix");
            kv.setItem("userAgent", ua, function(param1, value, key) {
                kv.destroy();
            });
            return;
        }
        $mc.log("Ignoring matching user agent: ", ua);
    },
    
    getUserAgent: function(ua) {
        return this.userAgent;
    },
	
	destroy: function() {
		this.applicationId = null;
		if(this.sessionTracking) this.sessionTracking.destroy();
		this.sessionTracking = null;
		Device.NetworkEmitter.removeListener(this.proxyListener);
		this.emitter = null;
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Mobclix/AdViewInternal'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Mobclix/AdViewInternal'] || {}; $MODULE_REGISTRY['NGCore/Client/Mobclix/AdViewInternal'] = exports; //
//  Mobclix.AdViewInternal.js
//  Mobclix Mobage SDK
//
//  Copyright 2011 Mobclix. All rights reserved.
//

var Core = require('NGCore/Client/Core').Core;
var UI = require('NGCore/Client/UI').UI;
var MMView = require('NGCore/Client/Mobclix/Core/MMView').MMView;

var Config = require('NGCore/Client/Mobclix/Core/Config').Config;
var $mc = require('NGCore/Client/Mobclix/Core/Utils').Utils;
var Controller = require('NGCore/Client/Mobclix/Core/Controller').Controller;
var HTTPRequest = require('NGCore/Client/Mobclix/Core/HTTPRequest').HTTPRequest;
var MMArray = require('NGCore/Client/Mobclix/Core/MMArray').MMArray;

var Browser = require('NGCore/Client/Mobclix/Browser').Browser;

var Creative = require('NGCore/Client/Mobclix/Creative').Creative;

var WebCreativeView = require('NGCore/Client/Mobclix/CreativeView/Web').Web;
var FullScreenCreativeView = require('NGCore/Client/Mobclix/CreativeView/FullScreen').FullScreen;

var Social = require('NGCore/Client/Social').Social;

var FullScreenAdSize = exports.FullScreenAdSize = {
	width: 999,
	height: 999
};

var AdViewInternal = exports.AdViewInternal = MMView.subclass(
/** @lends Mobclix.AdViewInternal.prototype */
{
	__className: "Mobclix.AdViewInternal",

	/**
	 * Enumeration for error codes.
	 * @name Mobclix.AdView.Error
	 * @namespace
	 * @public
	 */
	Error: {
		/** 
		 * Unknown error occured
		 * @name Mobclix.AdView.Error#Unknown
		 */
		Unknown: 0,

		/** 
		 * There was an error on the Mobclix Server
		 * @name Mobclix.AdView.Error#ServerError
		 */
		ServerError: -500,
		
		/** 
		 * Ads are currently unavailable
		 * @name Mobclix.AdView.Error#ServerError
		 */
		Unavailable: -503,

		/** 
		 * Connection error occured
		 * @name Mobclix.AdView.Error#Connection
		 */
		Connection: -7777777,

		/** 
		 * An ad was requested without calling {@link Mobclix#startWithApplicationId}
		 * @name Mobclix.AdView.Error#NotStarted
		 */
		NotStarted: -8888888,
		
		/** 
		 * The requested unit side has been remotely disabled
		 * @name Mobclix.AdView.Error#Disabled
		 */
		Disabled: -9999999
	},
	
	_listener: null,
	_ordinalNumber: 0,
	_inTestMode: false,
	_size: {
		width: 320,
		height: 50
	},
	
	_shouldGetAdAfterConfig: false,
	_autoDisplayNextAdRequest: false,
	_hasPrefetchedAd: false,
	_wasPaused: false,
	_pausedSelf: false,
	_isLoading: false,
	_refreshTimeout: null,
	_shouldAutoplay: false,
	_lastAutoplayTime: 0,
	_hasFinishedStarting: false,
	_shouldGetAdAfterFinishedStarting: false,
	_originOfRegistration: null,
    _distributionName: null,
    
	/**
	 * @class AdViewInternal 
	 * @constructs The default constructor. 
	 * @param $super This parameter is stripped out during execution. Do not supply it.
	 * @private
	 */
	initialize: function($super) {
		$super();
		var self = this;
        
        this._setAdSpace();
        
		this.setFrame([0, 0, $mc.dip(this._size.width), $mc.dip(this._size.height)]);
		this._listener = new Core.MessageListener();
		Config.addListener(this._listener, function() { self._configUpdated(); });
		Controller.addListener(this._listener, function() { self._finishStarting(); });
		var creatives = new MMArray();
		this.currentCreatives = creatives;
		creatives.release();
		
		if(Controller.hasBeenStarted()) {
			this._finishStarting();
		}
	},
	
    _setAdSpace: function() {
        var self = this;
        try {
            var session = Social.US.Session.getCurrentSession();
            var user = session.user();
            user.getOriginOfRegistration(function(error, originOfRegistration) {
                if(!originOfRegistration) {
                    var errorCode = error.errorCode;
                    var errorDesc = error.description;
                } else {
                    self._originOfRegistration = originOfRegistration.replace(/[aeiou_-]/g,"");
                }
            });
            
        } catch(e) {
            $mc.log("Error getting the OoR.", e);
        }
        try {
            var dist = Core.Capabilities.getDistributionName();
            this._distributionName = dist.replace(/[aeiou_-]/g,"");
        } catch(e) {
            $mc.log("Error getting the Distribution Name.", e);
        }
    },
    
	/**
	 * Called after {@link Mobclix.Config} is finished updating.
	 * @private
	 */
	_configUpdated: function() {
		$mc.log("config finished updating");
		if(this._shouldGetAdAfterConfig) {
			this._shouldGetAdAfterConfig = false;
			this.getAd();
		}
	},
	
	_finishStarting: function() {
		if(this._hasFinishedStarting) return;
		this._hasFinishedStarting = true;
	
		if(this._shouldGetAdAfterFinishedStarting) {
			this._shouldGetAdAfterFinishedStarting = false;
			this.getAd();
		}
	},
	
	_handleMobclixNotStarting: function() {
		if(this._hasFinishedStarting) return;
		this._shouldGetAdAfterFinishedStarting = false;

		this.failWithError(this.Error.NotStarted, "No application id found.  Please be sure to start Mobclix prior to requesting ads.");
	},
	
	// ====
	// Autorefreshing methods
	// ====
	
	/**
	 * Clears the refresh timeout
	 * @private
	 */
	clearRefreshTimeout: function() {
		if(this._refreshTimeout) {
			clearTimeout(this._refreshTimeout);
			this._refreshTimeout = null;
		}
	},
	
	/**
	 * Schedule the next get ad
	 * @private
	 */
	scheduleNextGetAd: function() {
		this._wasPaused = false;
		this._pausedSelf = false;
		var refreshTime = this._getRefreshTime();
		$mc.log("scheduleNextGetAd:", refreshTime);

		if(refreshTime > 0) {
			var self = this;
			this.clearRefreshTimeout();
			this._refreshTimeout = setTimeout(function() { $mc.log("Requesting ad!"); self.getAd(); }, refreshTime);
		}
	},
	
	/**
	 * Schedule the next get ad from an internal error
	 * This behaves identical to {@link Mobclix.AdViewInternal#scheduleNextGetAd} except it doesn't change internal state variables
	 * @private
	 */
	scheduleNextGetAdFromError: function() {
		$mc.log("scheduleNextGetAdFromError");
		var refreshTime = this._getRefreshTime();
		if(refreshTime > 0) {
			var self = this;
			this.clearRefreshTimeout();
			this._refreshTimeout = setTimeout(function() { self.getAd(); }, refreshTime);
		}
	},
	
	/**
	 * Cancel any scheduled get ads
	 * @private
	 */
	cancelScheduledGetAd: function() {
		$mc.log("cancelScheduledGetAd");
		this._wasPaused = true;
		this._pausedSelf = false;
		clearTimeout(this._refreshTimeout);
	},

	/**
	 * Returns the refresh time in milliseconds
	 * @private
	 */
	_getRefreshTime: function() {
		var refreshTime = 0;
		
		try {
			refreshTime = parseInt(this.refreshTime, 10);
		} catch(e) {
			refreshTime = 0;
		}

		if(refreshTime == 0 || isNaN(refreshTime)) {
			return Config.refreshInteveralForAdUnit(this._size) * 1000;
		} else {
			return refreshTime * 1000;
		}
	},
	
	/**
	 * Determines whether next ad should be scheduled
	 * @private
	 */
	shouldScheduleGetAd: function() {
        if (this._size.width == 999)
            return false;
		return !this._wasPaused || this._pausedSelf;
	},

	// ====
	// Request Lifecycle
	// ====

	/**
	 * Requests a new ad from the server
	 * If ad refreshes are paused, this will also call resumeAdAutoRefresh
	 *
	 * This should only be called when you want to manually refresh an ad.
	 * @private
	 */
	getAd: function() {
		this._getAd(null, true);
	},
	
	/**
	 * Request an ad to be displayed in the future
	 * A subsequent call to {@link Mobclix.AdViewInternal#displayAd} must be called when the ad is
	 * displayed to fire off any events that need to be triggered when displayed.
	 * @private
	 */
	prefetchAd: function() {
		if(this._hasPrefetchedAd) return;
		
		this.cancelScheduledGetAd();
		this._wasPaused = false;
		this._getAd(null, false);
	},
	
	/**
	 * Internal called from other methods such as {@link #getAd} and {@link #prefetchAd}
	 * 
	 * Requests an ad from the servers (if possible)
	 * @param	{object}	params	Additional parameters to pass back to the server, this must be a single dimensional key-value object
	 * @param 	{bool}		shouldAutoDisplay	Flag to indicate whether or not this request should display itself when it's finished
	 * @private
	 */
	_getAd: function(params, shouldAutoDisplay) {
		var self = this;
		
		// If we have an ad prefetched, we should display it, not get another ad
		if(this.hasPrefetchedAd) {
			this.displayAd();
			return;
		}

		// Set autodisplay toggle
		this._autoDisplayNextAdRequest = shouldAutoDisplay;
		
		// We can't request ads until Mobclix has finished starting
		if(!this._hasFinishedStarting) {
			$mc.log("Mobclix hasn't been started yet..");
			this._shouldGetAdAfterFinishedStarting = true;
			setTimeout(function() {
				self._handleMobclixNotStarting();
			}, 10000);
			return;
		}

		// If config is updating, we wait
		if(Config.isUpdating()) {
			$mc.log("RC Updating blocked adview..");
			this._shouldGetAdAfterConfig = true;
			return;
		}
		
		// If we're already waiting, we wait
		if(this._isLoading) {
			this.scheduleNextGetAdFromError();
			return;
		}
		
		// If we've already taken over the screen, we wait
		if(Controller.inModal) {
			this.scheduleNextGetAdFromError();
			return;
		}

		// If we're disabled, we don't load
		if(!Config.isAdUnitEnabled(this._size)) {
			$mc.log("Ad unit is not enabled..");
			this.failWithError(this.Error.Disabled, "This ad unit size has been remotely disabled in the developer dashboard.");
			return;
		}
		
		// Build parameters
		params = params || {};
		params = typeof params == 'object' ? params : {};

		// Determine autoplay
		this._shouldAutoplay = Config.isAutoPlayEnabled(this._size);
		if(typeof this.canAutoplay == 'function') {
			this._shouldAutoplay = this.canAutoplay(this) ? true : false;
		}
		
		// Determine RMRUI
		var richMediaRequiresUserInteraction = Config.richMediaRequiresUserInteraction(this._size);
		if(typeof this.richMediaRequiresUserInteraction == 'function') {
			richMediaRequiresUserInteraction = this.richMediaRequiresUserInteraction(this) ? true : false;
		}

		// Set ordinal
		var ordinalNumber;
		if(this._size == FullScreenAdSize) {
			ordinalNumber = __fullscreenOrdinalNumber++;
		} else {
			ordinalNumber = this._ordinalNumber++;
		}
		
		// Cancel any scheduled ads
		var wasWasPaused = this._wasPaused;
		this.cancelScheduledGetAd();

		if(!wasWasPaused && this._getRefreshTime() > 0) {
			// cancelScheduledGetAd sets wasPaused to TRUE and pausedSelf to FALSE
			this._pausedSelf = true;
		}

		// ---------------------------
		// Ad Feed ID Parameters
		// ---------------------------

		// Application ID
		params.i = Controller.getApplicationId();

		// Platform Name
		params.p = Controller.isAndroid() ? 'android' : (Controller.isIPad() ? 'ipad' : 'iphone');

		// Unit Size
		if(this._size.width == 999) {
			params.s = "fullscreen";
		} else {
			params.s = this._size.width + "x" + this._size.height;
		}

		// ---------------------------
		// Ad View State ID Parameters
		// ---------------------------

		// Should Autoplay
		params.ap = this._shouldAutoplay;

		// Rich Media requires user interaction
		params.rm = richMediaRequiresUserInteraction;

		// Ordinal Number
		params.o = ordinalNumber;

		// Ad Space
		var adSpace = "";
        if (this._originOfRegistration != null) {
            adSpace += this._originOfRegistration;
        }
        
        if (this._distributionName != null) {
            adSpace += this._distributionName;
        }
        
        this.adSpaceName = adSpace;
		if(adSpace && adSpace.length > 0) {
			if(adSpace.length > 32) {
				adSpace = adSpace.substr(0,32);
			}

			params.as = adSpace;
		}

		// Test Mode (Only if enabled)
		if(this._inTestMode) params.t = 1;

		// ---------------------------
		// Hardware Environment
		// ---------------------------

		// UDID
		params.u = Core.Capabilities.getUniqueId();

		// Connection Type
		params.ct = Controller.getNetworkState();

		// Device Model
		params.dm = Core.Capabilities.getDeviceName();

		// Hardware Device Model
		params.hwdm = Core.Capabilities.getPlatformHW();

        // User Agent
        if (Controller.getUserAgent() != null)
            params.ua = Controller.getUserAgent();

		// ---------------------------
		// Software Environment
		// ---------------------------	

		// Application Version
		// params.av = "1.0"; // TODO

		// SDK Version
		params.v = Config.getVersion();

		// OS Version
		params.sv = Core.Capabilities.getPlatformOSVersion();
		
		// Runtime
		params.rt = 'mobage';
		params.rtv = Core.Capabilities.getSDKVersion();
		

		// ---------------------------
		// Location
		// ---------------------------

		var location = null;
		if((location = Controller.getLocation())) {
			queryString.ll = location;
			location = null;
		}

		// ---------------------------
		// Additional Parameters
		// These would be passed in from a previous request that failed
		// ---------------------------

		if(typeof this.requestKeywords == 'function') {
			params.k = this.requestKeywords(this);
			if(!params.k) delete(params.k);
			else params.k = params.k.toString();
		}
		
		if(typeof this.requestQuery == 'function') {
			params.q = this.requestQuery(this);
			if(!params.q) delete(params.q);
			else params.q = params.q.toString();
		}
		
		// Set the request ad url if the delegate responds
		if(typeof this.requestAdUrl == 'function') {
			params.adurl = this.requestAdUrl(this);
			if(!params.adurl) delete(params.adurl);
			else params.adurl = params.adurl.toString();
		}

		var request = new HTTPRequest;
		request.start({
			url: Config.getAdvertisingURL(),
			data: params,
			type: "get",
            userAgent: Controller.getUserAgent(),
			success: function(request, response) {
				if(request.getStatusCode() == 200) {
					self.adRequestFinished(request, response);
				} else {
					self.requestFailed(request, null);
				}
			},
			error: function(request, error) {
				self.requestFailed(request, error);
			}
		});
		request.release();
	},
	
	/**
	 * Handles an ad request that suceeded with a status code of 200
	 * Attempts to parse the response for creatives and load an ad,
	 * If failed to load, it will {@link Mobclix.AdViewInternal#requestFailed}
	 * 
	 * @see Mobclix.AdViewInternal#requestFailed
	 * @see Mobclix.AdViewInternal#loadAd
	 * @private
	 */
	adRequestFinished: function(request, response) {
		this._isLoading = false;
		
		$mc.log("Request finished, response: " + request.getResponseText());

		var newCreatives = new MMArray();
		try {
			for(var index in response.creatives) {
				try {
					var creative = Creative.Create({creative: response.creatives[index]});
					newCreatives.push(creative);
					creative.release();
				} catch(e2) {
					$mc.log("Error while building creative model: ", e);
				}
			}
		} catch(e) {
			$mc.log("Error while building creative models: ", e);
		}
		
		$mc.log("setting currentcreatives");
		
		this.currentCreatives = newCreatives;

		$mc.log("release newcreatives");
		newCreatives.release();

		if(!this.currentCreatives || this.currentCreatives.length < 1) {
			this.requestFailed(request, "Failed to parse creative");
		} else {
			this.loadCreative(this.currentCreatives.get(0));
		}
	},
	
	/**
	 * Handles a failed ad request
	 * @see Mobclix.AdViewInternal#failWithError
	 * @private
	 */
	requestFailed: function(request, error) {
		$mc.log("Request failed -- error: ", error, "status code: ", request.request.status);

		if(request.request.status == 500) {
			this.failWithError(this.Error.Server, error);
		} else if(request.request.status == 0) {
			this.failWithError(this.Error.Connection, error);
		} else {
			this.failWithError(this.Error.Unknown, error);
		}
        
        if (this._size.width == 999) {
            this._canRequestNextAd = true;
        }
	},
	
	// ====
	// Creative Display Lifecycle
	// ====
	
	/**
	 * Loads the provided creative into the related CreativeView Type
	 * @param	{Object}	creative	Creative model to be loaded, must be an instance of {@link Mobclix.Creative.Base}
	 * @private
	 */
	loadCreative: function(creative) {
		$mc.log("Loading creative: " + creative);
		this.currentCreative = creative;
		
        if(this._size.width == 999) {
            $mc.log("Creating FullScreen Creative View");
            var creativeView = new FullScreenCreativeView();
            this.nextCreativeView = creativeView;
            creativeView.release();
            
            this.nextCreativeView.adView = this;
            this.nextCreativeView.loadWithCreative(this.currentCreative);
        } else {
            var creativeView = new WebCreativeView();
            this.nextCreativeView = creativeView;
            creativeView.release();
            
            var x = 0;
            
            var frame = this.getBounds();
            frame[0] = frame[2] * -2;
            frame[1] = frame[3] * -2;
            
            this.nextCreativeView.setFrame(frame);
            this.nextCreativeView.adView = this;
            this.addChild(this.nextCreativeView);
            this.nextCreativeView.loadWithCreative(this.currentCreative);
        }
	},

	/**
	 * Callback for instances of {@link Mobclix.Creative.Base} to indicate they're finished loading and ready to be displayed
	 * 
	 * @param	{object}	creativeView	Instance of {@link Mobclix.CreativeView.Base}
	 * @param	{object}	creative		Instance of {@link Mobclix.Creative.Base}
	 * @return	{bool}	If false, the creativeView/creative is no longer the current creative being loaded and should immediately halt it's lifecycle
	 * @private
	 */
	creativeViewFinishedLoading: function(creativeView, creative) {
		if(creative != this.currentCreative) {
			$mc.log("Creative load finished, but wasn't current creative: ", creative);
			creativeView.removeFromParent();
			return false;
		}

		// Notify the delegate
		this._wasPaused = false;
		if(typeof this.onFinishLoad == 'function') {
			this.onFinishLoad(this);
		}

		// Auto display ad
		if(this._autoDisplayNextAdRequest)
            this.displayAd();
        else
			this._hasPrefetchedAd = true;
		
		// Schedule the next ad
		if(this.shouldScheduleGetAd()) this.scheduleNextGetAd();

		return true;
	},

	/**
	 * Callback for instances of {@link Mobclix.Creative.Base} to indicate they've failed to load
	 * 
	 * @param	{object}	creativeView	Instance of {@link Mobclix.CreativeView.Base}
	 * @param	{object}	creative		Instance of {@link Mobclix.Creative.Base}
	 * @param	{object}	error	Underlying error
	 * @return	{boolean}	Flag indicating whether or not the provided creativeView/creative is still the current creative being loaded
	 * @private
	 */
	creativeViewFailedToLoad: function(creativeView, creative, error) {
        $mc.log("creativeViewFailedToLoad: ", creativeView);
        $mc.log("creativeViewFailedToLoad: ", creative);
        $mc.log("creativeViewFailedToLoad: ", error);
		var returnValue = true;
		
		if(creative != this.currentCreative) {
			$mc.log("Creative load failed, but wasn't current creative: ", creative);
			returnValue = false;
		} else {
			this.nextCreativeView = null;

			var creativeIndex = this.currentCreatives.indexOf(creative);

			if(creativeIndex + 1 < this.currentCreatives.length) {
				this.loadCreative(this.currentCreatives.get(creativeIndex + 1));
				returnValue = false;
			} else {
				if(creative.requestParameters && creative.requestParameters.length > 0) {
					this._getAd(creative.requestParameters, this._autoDisplayNextAdRequest);
					returnValue = false;
				} else {
					this.failWithError(this.Error.Unknown, error);
					returnValue = true;
				}
			}
		}

		creativeView.removeFromParent(); // We remove at the end, because it deallocs on remove
		return returnValue;
	},
	
	/**
	 * Displays the next creative view and triggers any actions/events asssociated with it
	 * @private
	 */
	displayAd: function() {
        if (this.nextCreativeView == null)
            return;
    
		var creativeView = this.nextCreativeView;
		var self = this;
        
        // Remove any old creative views, but leave current creative views
        $mc.each(this.getChildren(), function(view) {
            if(view == creativeView) return;
            $mc.log("Removing: " + view);
            self.queueReusableCreativeView(view);
            view.removeFromParent();
        });
    
        // Add new creativeview if it's not already in the stack.
        // This shouldn't ever happen, but we better be sure.
        if(!creativeView.getParent() || creativeView.getParent() != this) {
            this.addChild(creativeView);
        }
            

        if (this._size.width == 999) {
            creativeView.display();
            
            if(typeof this.onPresentAd == 'function') {
                this.onPresentAd(this);
            }
                
            // Update current reference
            this.currentCreativeView = creativeView;
        } else {
            
            // Place a temporary view over the view, or else the first ad on
            // Android won't load.
            if (Controller.isAndroid()) {
                var tempView = new MMView();
                this.addChild(tempView);
                tempView.removeFromParent();
            }

            // Bring view on screen
            creativeView.setFrame(this.getBounds());

            // Update current reference
            this.currentCreativeView = creativeView;

            // Autoplay if asked to
            var action = this.currentCreative.getAction();
            if(action && action.shouldAutoplay() && this._shouldAutoplay) {
                this._lastAutoplayTime = new Date();
                this.openActionURL(self.currentCreative, action.getUrl());
            }
        
        }

        // Notify tracking URLs
        try { this.currentCreative.getEvents().triggerEvent("show"); } catch(e) { }
        this.currentCreativeView.creativeHasBeenDisplayed();
            
		this.nextCreativeView = null;
		this._hasPrefetchedAd = false;
		this._shouldAutoplay = false;
	},
	
	/**
	 * Attempts to queue a resueable creative view
	 * @param	{object}	creativeView	Instance of {@link Mobclix.CreativeView.Base}
	 * @private
	 */
	queueReusableCreativeView: function(creativeView) {
		// TODO
	},
	
	/**
	 * Handles errors when loading an ad and notifies any listeners
	 * @private
	 */
	failWithError: function(code, error) {
		this._isLoading = false;

		if(typeof this.onFailedToLoad == 'function') {
			this.onFailedToLoad(this, code, error);
		}

		if(this.shouldScheduleGetAd()) this.scheduleNextGetAd();
	},
	
	// ====
	// Actions
	// ====

	/**
	 * Determines whether or not a creative can touch through
	 * 
	 * @param	{object}	creative		Instance of {@link Mobclix.Creative.Base}
	 * 
	 * @return	{boolean}	Whether or not the creative can touch through
	 * @private
	 */
	shouldTouchThrough: function(creative) {
		return !Controller.inModal;
	},

	/**
	 * Tells the ad view a creative will touch through
	 * Any touch through events will be fired at this point
	 * 
	 * @param	{object}	creative		Instance of {@link Mobclix.Creative.Base}
	 * @private
	 */
	willTouchThrough: function(creative) {
		Controller.inModal = true;
		this.cancelScheduledGetAd();

		if(typeof this.onWillTouchThrough == 'function') {
			this.onWillTouchThrough(this);
		}
	},
	
	/**
	 * Tells the ad view a creative did touch through
	 * Any did touch through events will be fired at this point
	 * 
	 * @param	{object}	creative		Instance of {@link Mobclix.Creative.Base}
	 * @private
	 */
	didTouchThrough: function(creative) {
		Controller.inModal = false;

		if(typeof this.onDidTouchThrough == 'function') {
			this.onDidTouchThrough(this);
		}

		if(this.shouldScheduleGetAd()) this.scheduleNextGetAd();
	},
	
	/**
	 * Convenience method to handle opening a full screen action URL.
	 * This method will automatically handle any events
	 * that need to be triggered when handling full screen takeovers
	 * 
	 * @param	{object}	creative		Instance of {@link Mobclix.Creative.Base}
	 * @param	{string}	url		Action URL to open in a full screen browser
	 * 
	 * @return	{boolean}	Whether or not the action url was able to open
	 * @private
	 */
	openActionURL: function(creative, url) {
		if(!this.shouldTouchThrough()) {
			$mc.log("Already in modal, can't open url");
			return false;
		}

		var self = this;
		
		this.willTouchThrough();
		$mc.log("Opening action URL:", url);
		
		var browserType = null;
		
		try {
			browserType = creative.getBrowserType();
		} catch (e) {
			browserType = Browser.Type.Toolbar;
		}
		
		var browser = new Browser(browserType);
		browser.onDidFinish = function() {
			self.didTouchThrough(creative);
		};
		
		browser.loadUrl(url);
		browser.presentViewController(true);
		browser.release();
		browser = null;
	},
	
	// ====
	// Memory Management
	// ====
	
	/** @private */
	destroy: function($super) {
		Config.removeListener(this._listener);
		this._listener.destroy();
		
		this.currentCreatives = null;
		this.currentCreative = null;
		this.nextCreativeView = null;
		this.adSpaceName = null;
		this._size = null;
		
		$mc.log(" ---- ADVIEW DESTROY ---- ");
		$super();
	}
});

// Properties
(function() {
	AdViewInternal.addProperty('currentCreatives', true);
	AdViewInternal.addProperty('currentCreative', true);
	AdViewInternal.addProperty('nextCreativeView', true);
	AdViewInternal.addProperty('adSpaceName', false);
	AdViewInternal.addProperty('requestAdUrl', false);
	AdViewInternal.addProperty('refreshTime', false, 0);
})();

// MobclixAdView Events
(function() {
	/**
	 * @name Mobclix.AdView#setOnFinishLoad
	 * @description Set a function to call when the <code>finishLoad</code> event occurs.
	 * @param {Function} eventCallback The new callback function, the signature for the callback is equivalent
	 * to:<br><br>
	 * <pre>function(adView)</pre><br>
	 * The <code>adView</code> parameter is the instance of the MobclixAdView that loaded.
	 * <br><br><b>Note:</b> This event is disabled if the value of this parameter is not a function.<br>
	 * @see Mobclix.AdView#getOnFinishLoad
	 * @function
	 */
	/**
	 * @name Mobclix.AdView#getOnFinishLoad
	 * @description Retrieve the function to call when the <code>finishLoad</code> event occurs.
	 * @return {Function} The current callback function.
	 * @see Mobclix.AdView#setOnFinishLoad
	 * @function
	 */
    /**
	 * @name Mobclix.FullScreenAdView#setOnFinishLoad
	 * @description Set a function to call when the <code>finishLoad</code> event occurs.
	 * @param {Function} eventCallback The new callback function, the signature for the callback is equivalent
	 * to:<br><br>
	 * <pre>function(adView)</pre><br>
	 * The <code>adView</code> parameter is the instance of the MobclixAdView that loaded.
	 * <br><br><b>Note:</b> This event is disabled if the value of this parameter is not a function.<br>
	 * @see Mobclix.FullScreenAdView#getOnFinishLoad
	 * @function
	 */
	/**
	 * @name Mobclix.FullScreenAdView#getOnFinishLoad
	 * @description Retrieve the function to call when the <code>finishLoad</code> event occurs.
	 * @return {Function} The current callback function.
	 * @see Mobclix.FullScreenAdView#setOnFinishLoad
	 * @function
	 */
	AdViewInternal.addProperty('onFinishLoad', false);

	/**
	 * @name Mobclix.AdView#setOnFailedToLoad
	 * @description Set a function to call when the <code>failedToLoad</code> event occurs.
	 * @param {Function} eventCallback The new callback function, the signature for the callback is equivalent
	 * to:<br><br>
	 * <pre>function(adView, code, error)</pre><br>
	 * The <code>adView</code> parameter is the instance of the MobclixAdView that loaded.
	 * The <code>code</code> parameter is the error code matching {@link Mobclix.AdView#Error}.
	 * The <code>error</code> parameter is a string describing the error.
	 * <br><br><b>Note:</b> This event is disabled if the value of this parameter is not a function.<br>
	 * @see Mobclix.AdView#getOnFailedToLoad
	 * @function
	 */

	/**
	 * @name Mobclix.AdView#getOnFailedToLoad
	 * @description Retrieve the function to call when the <code>failedToLoad</code> event occurs.
	 * @return {Function} The current callback function.
	 * @see Mobclix.AdView#setOnFailedToLoad
	 * @function
	 */
    
    	/**
	 * @name Mobclix.FullScreenAdView#setOnFailedToLoad
	 * @description Set a function to call when the <code>failedToLoad</code> event occurs.
	 * @param {Function} eventCallback The new callback function, the signature for the callback is equivalent
	 * to:<br><br>
	 * <pre>function(adView, code, error)</pre><br>
	 * The <code>adView</code> parameter is the instance of the MobclixAdView that loaded.
	 * The <code>code</code> parameter is the error code matching {@link Mobclix.AdView#Error}.
	 * The <code>error</code> parameter is a string describing the error.
	 * <br><br><b>Note:</b> This event is disabled if the value of this parameter is not a function.<br>
	 * @see Mobclix.FullScreenAdView#getOnFailedToLoad
	 * @function
	 */

	/**
	 * @name Mobclix.FullScreenAdView#getOnFailedToLoad
	 * @description Retrieve the function to call when the <code>failedToLoad</code> event occurs.
	 * @return {Function} The current callback function.
	 * @see Mobclix.FullScreenAdView#setOnFailedToLoad
	 * @function
	 */
	AdViewInternal.addProperty('onFailedToLoad', false);

	/**
	 * @name Mobclix.AdView#setOnCanAutoplay
	 * @description Set a function for the ad view to call to determine if an ad can autoplay.
	 * This will override the default setting used on the developer dashboard.
	 * <br /><br />
	 * Autoplay ads are similar to interstitial ads and will automatically
	 * open a website, video, or any other kind of modal action supported by the SDK.
	 * <br /><br />
	 * If this method isn't implemented, the settings provided on the Dashboard are used.
	 * @param {Function} callback The new callback function, the signature for the callback is equivalent
	 * to:<br><br>
	 * <pre>function(adView)</pre><br>
	 * The <code>adView</code> parameter is the instance of the MobclixAdView that loaded.
	 * This function most return boolean value indicating whether or not ads can autoplay.
	 * <br><br><b>Note:</b> This event is disabled if the value of this parameter is not a function.<br>
	 * @see Mobclix.AdView#getOnCanAutoplay
	 * @function
	 */
	/**
	 * @name Mobclix.AdView#getOnCanAutoplay
	 * @description Retrieve the function to call when the ad view needs to determine if it can autoplay ads.
	 * @return {Function} The current callback function.
	 * @see Mobclix.AdView#setOnCanAutoplay
	 * @function
	 */
	AdViewInternal.addProperty('onCanAutoplay', false);


	/**
	 * @name Mobclix.AdView#setOnWillTouchThrough
	 * @description Set a function for the ad view to call when the user touches through.  When this happens, the ad view will take over the screen experience, so in the case of a game it should be paused.
	 * @param {Function} callback The new callback function, the signature for the callback is equivalent
	 * to:<br><br>
	 * <pre>function(adView)</pre><br>
	 * The <code>adView</code> parameter is the instance of the MobclixAdView that loaded.
	 * This function most return boolean value indicating whether or not ads can autoplay.
	 * <br><br><b>Note:</b> This event is disabled if the value of this parameter is not a function.<br>
	 * @see Mobclix.AdView#getOnWillTouchThrough
	 * @function
	 */
	/**
	 * @name Mobclix.AdView#getOnWillTouchThrough
	 * @description Retrieve the function to call when the user touches through.
	 * @return {Function} The current callback function.
	 * @see Mobclix.AdView#setOnWillTouchThrough
	 * @function
	 */
	AdViewInternal.addProperty('onWillTouchThrough', false);

	/**
	 * @name Mobclix.AdView#setOnDidTouchThrough
	 * @description Set a function for the ad view to call when the user touch through is finished.  When this happens, the ad view is no longer taking over the screen experience, so in the case of a game, game play can be resumed.
	 * @param {Function} callback The new callback function, the signature for the callback is equivalent
	 * to:<br><br>
	 * <pre>function(adView)</pre><br>
	 * The <code>adView</code> parameter is the instance of the MobclixAdView that loaded.
	 * This function most return boolean value indicating whether or not ads can autoplay.
	 * <br><br><b>Note:</b> This event is disabled if the value of this parameter is not a function.<br>
	 * @see Mobclix.AdView#getOnDidTouchThrough
	 * @function
	 */
	/**
	 * @name Mobclix.AdView#getOnDidTouchThrough
	 * @description Retrieve the function to call when the user touches through.
	 * @return {Function} The current callback function.
	 * @see Mobclix.AdView#setOnDidTouchThrough
	 * @function
	 */
	AdViewInternal.addProperty('onDidTouchThrough', false);

	/**
	 * @name Mobclix.FullScreenAdView#setOnPresentAd
	 * @description Set a function to call when the <code>presentAd</code> event occurs.
	 * @param {Function} eventCallback The new callback function, the signature for the callback is equivalent
	 * to:<br><br>
	 * <pre>function(adView)</pre><br>
	 * The <code>adView</code> parameter is the instance of the MobclixAdView that loaded.
	 * <br><br><b>Note:</b> This event is disabled if the value of this parameter is not a function.<br>
	 * @see Mobclix.FullScreenAdView#getOnPresentAd
	 * @function
	 */

	/**
	 * @name Mobclix.FullScreenAdView#getOnPresentAd
	 * @description Retrieve the function to call when the <code>presentAd</code> event occurs.
	 * @return {Function} The current callback function.
	 * @see Mobclix.FullScreenAdView#setOnPresentAd
	 * @function
	 */
	AdViewInternal.addProperty('onPresentAd', false);
    
    /**
	 * @name Mobclix.FullScreenAdView#setOnDismissAd
	 * @description Set a function to call when the <code>dismissAd</code> event occurs.
	 * @param {Function} eventCallback The new callback function, the signature for the callback is equivalent
	 * to:<br><br>
	 * <pre>function(adView)</pre><br>
	 * The <code>adView</code> parameter is the instance of the MobclixAdView that loaded.
	 * <br><br><b>Note:</b> This event is disabled if the value of this parameter is not a function.<br>
	 * @see Mobclix.FullScreenAdView#getOnDismissAd
	 * @function
	 */

	/**
	 * @name Mobclix.FullScreenAdView#getOnDismissAd
	 * @description Retrieve the function to call when the <code>dismissAd</code> event occurs.
	 * @return {Function} The current callback function.
	 * @see Mobclix.FullScreenAdView#setOnDismissAd
	 * @function
	 */
	AdViewInternal.addProperty('onDismissAd', false);

	/**
	 * @name Mobclix.AdView#setRichMediaRequiresUserInteraction
	 * @description Set a function for the ad view to call when determining if rich media requires user interaction:<br />
	 * Rich Media features include access to the following:<br />
	 * <ul>
	 *	<li>LED Flash</li>
	 *	<li>Vibrate</li>
	 *	<li>Sound</li>
	 * </ul>
	 * To allow these features to work automatically, this callback should return false.
	 * <br /></br />
	 * Applications that vibrate or play sound, should return true.
	 * <br /></br />
	 * If this callback isn't implemented, the settings provided on the Dashboard are used.
	 * @param {Function} callback The new callback function, the signature for the callback is equivalent
	 * to:<br><br>
	 * <pre>function(adView)</pre><br>
	 * The <code>adView</code> parameter is the instance of the MobclixAdView that loaded.
	 * This function most return boolean value indicating whether or not ads can autoplay.
	 * @see Mobclix.AdView#getRichMediaRequiresUserInteraction
	 * @function
	 */
	/**
	 * @name Mobclix.AdView#getRichMediaRequiresUserInteraction
	 * @description Retrieve the function to call when determining if rich media requires user interaction.
	 * @return {Function} The current callback function.
	 * @see Mobclix.AdView#setRichMediaRequiresUserInteraction
	 * @function
	 */
	AdViewInternal.addProperty('richMediaRequiresUserInteraction', false);
	
	/**
	 * @name Mobclix.AdView#setRequestKeywords
	 * @description Set a function for the ad view to call to get the request keywords.
	 * @param {Function} callback The new callback function, the signature for the callback is equivalent
	 * to:<br><br>
	 * <pre>function(adView)</pre><br>
	 * The <code>adView</code> parameter is the instance of the MobclixAdView that loaded.
	 * This function most return boolean value indicating whether or not ads can autoplay.
	 * @see Mobclix.AdView#getRequestKeywords
	 * @function
	 */
	/**
	 * @name Mobclix.AdView#getRequestKeywords
	 * @description Retrieve the function to call to get the request keywords.
	 * @return {Function} The current callback function.
	 * @see Mobclix.AdView#setRequestKeywords
	 * @function
	 */
	AdViewInternal.addProperty('requestKeywords', false);
	
	/**
	 * @name Mobclix.AdView#setRequestQuery
	 * @description Set a function for the ad view to call to get the request query.
	 * @param {Function} callback The new callback function, the signature for the callback is equivalent
	 * to:<br><br>
	 * <pre>function(adView)</pre><br>
	 * The <code>adView</code> parameter is the instance of the MobclixAdView that loaded.
	 * This function most return boolean value indicating whether or not ads can autoplay.
	 * @see Mobclix.AdView#getRequestQuery
	 * @function
	 */
	/**
	 * @name Mobclix.AdView#getRequestQuery
	 * @description Retrieve the function to call to get the request query.
	 * @return {Function} The current callback function.
	 * @see Mobclix.AdView#setRequestQuery
	 * @function
	 */
	AdViewInternal.addProperty('requestQuery', false);
})();

; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Mobclix/Core/MMView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Mobclix/Core/MMView'] || {}; $MODULE_REGISTRY['NGCore/Client/Mobclix/Core/MMView'] = exports; //
//  Mobclix.Core.MMView.js
//  Mobclix Mobage SDK
//
//  Copyright 2011 Mobclix. All rights reserved.
//

var UI = require('NGCore/Client/UI').UI;
var $mc = require('NGCore/Client/Mobclix/Core/Utils').Utils;

/**
 * @class MMView is a memory managed subclass of UI.View that brings in all methods supplied by {@link Mobclix.Core.MMClass}
 * @name Mobclix.Core.MMView
 * @extends UI.View
 * @private
 */
var mmViewMethods = exports.MMViewMethods = 
/** @lends Mobclix.Core.MMView.prototype */
{
	__className: "MMView",

	/**
	 * Adds the child node from it's view hierarchy and retains it
	 * @private
	 * @function
	 */
	addChild: function($super, childNode, index) {
		$super(childNode, index);
		try { childNode.retain(); } catch(e) { }
	},

	/**
	 * Removes the child node from it's view hierarchy and releases it
	 * @private
	 * @function
	 */
	removeChild: function($super, childNode) {
		$super(childNode);
		try { childNode.release(); } catch(e) { }
	},

	/**
	 * Gets the current bounds of the view
	 * @function
	 * @return	{object}	Bounds of the object
	 * @private
	 */
	getBounds: function() {
		var frame = this.getFrame();
        var bounds = [frame[0], frame[1], frame[2], frame[3]];
		bounds[0] = 0;
		bounds[1] = 0;
		return bounds;
	}
};

var MMView = exports.MMView = UI.View.subclass($mc.extend(require('NGCore/Client/Mobclix/Core/MMClass').Memory, mmViewMethods));
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Mobclix/Core/Config'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Mobclix/Core/Config'] || {}; $MODULE_REGISTRY['NGCore/Client/Mobclix/Core/Config'] = exports; //
//  Mobclix.Core.Config.js
//  Mobclix Mobage SDK
//
//  Copyright 2011 Mobclix. All rights reserved.
//

var Core = require('NGCore/Client/Core').Core;
var Network = require('NGCore/Client/Network').Network;
var Storage = require('NGCore/Client/Storage').Storage;
var KeyValueCache = require('NGCore/Client/Storage/KeyValue').KeyValueCache;

var $mc = require('NGCore/Client/Mobclix/Core/Utils').Utils;
// var Controller = require('./Controller').Controller;
var HTTPRequest = require('NGCore/Client/Mobclix/Core/HTTPRequest').HTTPRequest;

exports.Config = Core.Class.singleton({
	version: "0.99",
	
	configURL: "http://data.mobclix.com/post/config",
	advertisingURL: "http://ads.mobclix.com/",
	
	config: {},
	emitter: null,
	_isUpdating: false,
	_hasConfigFailed: false,
	_idleTimeoutInterval: 0.0,
	
	initialize: function() {
		this.emitter = new Core.MessageEmitter();
	},
	
	updateConfiguration: function(controller) {
		if(this.isUpdating()) return;
		else this._setUpdating(true);

		this._updateConfiguration(controller);
	},
	
	_updateConfiguration: function(controller) {
		var sessionTracking = controller.sessionTracking;
		
		if(controller.getNetworkState() == "none") {
			$mc.log("network state none");
			this.isUpdating(false);
			sessionTracking.offlineSessionCount++;
			sessionTracking.saveSessionTrackingData();
			this._hasConfigFailed = true;
			this.emitter.emit(this);
			return;
		}

		var self = this;

		// Load cached first
		try {
			Storage.FileSystem.readFile("MobclixConfig-" + controller.applicationId, false, function(error, value) {
				try {
					value = eval("("+value+")");
				} catch(e) { }

				if(value && typeof value == 'object' && value.length > 0) {
					self.config = value;
				}
			});
            
            var kv = new Storage.KeyValue();
            kv.registerForKey("mobclix");
            kv.getItem("userAgent", function(param1, value, key) {
                controller.setUserAgent(value, true);
                kv.destroy();
            });
		} catch(e) { }

		// Request fresh config
		var queryString = {
			a: controller.applicationId,
			p: controller.isAndroid() ? 'android' : (controller.isIPad() ? 'ipad' : 'iphone'),
			m: this.version,
			// v: "1.0", // TODO
			d: Core.Capabilities.getUniqueId(),
			dm: Core.Capabilities.getDeviceName(),
			// dv: "", // TODO
			hwdm: Core.Capabilities.getPlatformHW(),
			g: controller.getNetworkState(),
			off: sessionTracking.offlineSessionCount,
			st: sessionTracking.lastSessionLength,
			it: sessionTracking.idleSessionTime,
			rt: 'mobage',
			rtv: Core.Capabilities.getSDKVersion()
		};

		$mc.log("sessionTracking.offlineSessionCount:", sessionTracking.offlineSessionCount);
		$mc.log("sessionTracking.lastSessionLength:", sessionTracking.lastSessionLength);
		$mc.log("sessionTracking.idleSessionTime:", sessionTracking.idleSessionTime);
		
		// Location
		var location = null;
		if((location = controller.getLocation())) {
			queryString.ll = location;
			location = null;
		}
		
		var newKey = controller.applicationId + "-new";
		KeyValueCache.local.getItem(newKey, function(error, value) {
			// Determine if new
			if((error && error.length > 0) || value !== "false") {
				$mc.log("Detected new user");
				queryString['new'] = true;
				KeyValueCache.local.setItem(newKey, "false");
			}

			// Start request
			var request = new HTTPRequest;
			request.start({
				url: self.getConfigURL(),
				data: queryString,
				type: "get",
				success: function(request, response) {
					if(request.getStatusCode() == 200) {
						if(typeof response == 'string') {
							// Temp fix until the headers are updated on remote config
							response = eval("("+response+")");
						}

						self.finishedUpdating(response, controller);
					} else {
						self.failedToUpdate("Unknown error", controller);
					}
				},
				error: function(request, error) {
					self.failedToUpdate(error, controller);
				}
			});
			request.release();
		}, true);
	},
	
	finishedUpdating: function(response, controller) {
		this._setUpdating(false);
		this._hasConfigFailed = false;
		this.config = typeof response == 'object' ? response : {};
		controller.sessionTracking.idleSessionTime = 0;
		controller.sessionTracking.lastSessionLength = 0;
		controller.sessionTracking.offlineSessionCount = 0;
		controller.sessionTracking.saveSessionTrackingData();
		
		try {
			Storage.FileSystem.writeFile("MobclixConfig-" + controller.applicationId, JSON.stringify(this.config));
		} catch(e) { }
		
		this.emitter.emit(this);
	},
	
	failedToUpdate: function(error, controller) {
		$mc.log("Config Request failed, error: ", error);
		this._hasConfigFailed = true;
		this._setUpdating(false);
		controller.sessionTracking.offlineSessionCount++;
		controller.sessionTracking.saveSessionTrackingData();
		this.emitter.emit(this);
	},
	
	hasConfigFailed: function() {
		return this._hasConfigFailed;
	},
	
	addListener: function(listener, func) {
		this.emitter.addListener(listener, func);
	},
	
	removeListener: function(listener) {
		this.emitter.removeListener(listener);
	},
	
	getVersion: function() {
		return this.version;
	},
	
	_setUpdating: function(b) {
		this._isUpdating = b;
	},
	
	isUpdating: function() {
		return this._isUpdating;
	},
	
	getIdleTimeoutInterval: function() {
		try {
			return this.config.idle_timeout || this._idleTimeoutInterval;
		} catch (e) {
			return this._idleTimeoutInterval;
		}
	},
	
	getConfigURL: function() {
		try {
			return this.config.urls.config || this.configURL;
		} catch (e) {
			return this.configURL;
		}
	},
	
	getAdvertisingURL: function() {
		try {
			return this.config.urls.ads || this.advertisingURL;
		} catch (e) {
			return this.advertisingURL;
		}
	},
	
	getAnalyticsURL: function() {
		try {
			return this.config.urls.analytics || this.analyticsURL;
		} catch (e) {
			return this.analyticsURL;
		}
	},
	
	getNativeURLs: function() {
		var nativeURLs = null;
		
		try {
			nativeURLs = this.config.native_urls;
			if(!nativeURLs instanceof Array) {
				nativeURLs = null;
			}
		} catch(e) {
			nativeURLs = null;
		}
		
		if(!nativeURLs || nativeURLs.length == 0) {
			nativeURLs = [
							"itunes.apple.com",
							"phobos.apple.com",
							"maps.google.com",
							"youtube.com",
							"mailto:"
						];
		}
		
		return nativeURLs;
	},
	
	isAdUnitEnabled: function(size) {
		var props = this._propertiesForAdUnit(size);
		return $mc.parseBool(props.autoplay_interval) || true;
	},
	
	isAutoPlayEnabled: function(size) {
		var props = this._propertiesForAdUnit(size);
		return $mc.parseBool(props.autoplay) || false;
	},
	
	richMediaRequiresUserInteraction: function(size) {
		var props = this._propertiesForAdUnit(size);
		return $mc.parseBool(props.rm_require_user) || true;
	},
	
	refreshInteveralForAdUnit: function(size) {
		var props = this._propertiesForAdUnit(size);
		return parseInt(props.autoplay_interval, 10) || 30;
	},
	
	autoplayTimeoutInteveralForAdUnit: function(size) {
		var props = this._propertiesForAdUnit(size);
		return parseInt(props.autoplay_interval, 10) || size.height == 250 ? 0 : 120;
	},
	
	_propertiesForAdUnit: function(size) {
		var props = null;
		
		if(size.width == 999) {
			size = "fullscreen";
		} else {
			size = size.width  + "x" + size.height;
		}

		try {
			if(this.config.ad_units) $mc.each(this.config.ad_units, function(unit, key) {
				if(unit.size == size) {
					props = unit;
					return false;
				}
			});
		} catch(e) { }

		return props || {};
	},
	
	destroy: function() {
		this.version = null;
		this.configURL = null;
		this.advertisingURL = null;
		this.analyticsURL = null;
		this.config = null;
		this.emitter = null;
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Mobclix/Core/Utils'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Mobclix/Core/Utils'] || {}; $MODULE_REGISTRY['NGCore/Client/Mobclix/Core/Utils'] = exports; //
//  Mobclix.Core.Utils.js
//  Mobclix Mobage SDK
//
//  Copyright 2011 Mobclix. All rights reserved.
//

var Core = require('NGCore/Client/Core').Core;

exports.Utils = Core.Class.singleton(
/** @lends Mobclix.Core.Utils.prototype */
{
	/**
	 * @class Utils is a singleton class with a collection of static utility methods to help with development.
	 * @constructs The default constructor.
	 * @private
	 */
	initialize: function() {
		
	},
	
	/**
	 * Gets device indpenedent pixel
	 * @param	{number} pixel	Pixel to conver to DIP
	 * @return	{number} pixel converted to dip
	 * @private
	 */
	$dip: function(pixel) {
		return Math.round(pixel * Core.Capabilities.getScreenUnits());
	},
	
	/**
	 * Add a property to a class so it can be called the following ways:
	 * @example
	 * <code>(function() {
	 * Foo.addProperty('bar', true);
	 * })();
	 *
	 * // Instances of Foo can now access the bar property the following ways:
	 * obj.bar = value;
	 * obj.setBar(value);
	 * var barVal = obj.bar;
	 * var barVal = obj.getBar();</code>
	 * 
	 * 
	 * @param	{class}	target		Target class to this property to
	 * @param	{string}	propName	Name of the property to add to the class
	 * @param	{boolean}	shouldRetain	Whether or not this property should be retained when set (and released when unset)
	 * @param	{mixed}	defaultValue	Default value of this property
	 * @private
	 * @function
	 * @static
	 */
	$addProperty: function(target, propName, shouldRetain, defaultValue) {
		if(!propName) return;
		var self = this;
		
		shouldRetain = shouldRetain || false;

		var instVarName = '__' + propName;
		var caseAdjusted = propName.charAt(0).toUpperCase() + propName.substr(1);

		target.prototype[instVarName] = defaultValue || null;
		
		if(typeof target.prototype['get'+caseAdjusted] != 'function') {
			target.prototype['get'+caseAdjusted] = function() {
				return this[instVarName];
			};
		}

		if(typeof target.prototype['set'+caseAdjusted] != 'function') {
			target.prototype['set'+caseAdjusted] = function(newValue) {
				this[instVarName] = newValue;
			};
		}

		target.prototype.__defineSetter__(propName, function(newValue) {
			if(this[instVarName] && shouldRetain) {
				if(shouldRetain) {
					try {
						this[instVarName].release();
					} catch(e) {
						self.log("Error releasing ", target[instVarName], e);
					} finally {
						this[instVarName] = defaultValue;
					}
				}
			}
			
			this[instVarName] = newValue;
			if(shouldRetain && newValue) {
				try {
					newValue.retain();
				} catch(e) {
					self.log("Error retaining ", newValue, e);
				}
			}
		});
		
		target.prototype.__defineGetter__(propName, function() {
			return this[instVarName];
		});
	},
	
	/**
	 * Logs to console
	 */
	$log: function() {
		arguments[0] = "MobclixSDK: " + arguments[0];
		console.log.apply(console.log, arguments);
	},
	
	/**
	 * Primative stack trace tool
	 */
	$trace: function() {
		var stack = arguments.callee;
		
		this.log("+ Starting Trace");

		while(stack) {
			this.log("|", stack.toString().split('\n')[0].replace(/\{\s?/, ""));
			stack = stack.caller;
		}
		
		this.log("+ Finished Trace");
	},
	
	/**
	 * Quickly enumerate an object or array
	 * 
	 * @param	{mixed}	object	Object or array to enumerate through
	 * @param	{function}	callback	Calback function that will be run on each element in the object.  Should conform to <code>function(value, key)</code>
	 * @private
	 * @function
	 * @static
	 */
	$each: function(object, callback) {
		if(!object) {
			this.log("Passed null object.. ");
			this.trace();
		}
		
		if(typeof object == 'array' || (typeof object.length == 'number' && typeof object[0] != 'undefined')) {
			for(var index = 0; index < object.length; index++) {
				if(callback(object[index], index) === false) break;
			}
		} else if(typeof object == 'object' && (typeof object.length != 'number' || object.length > 0)) {
			for(var key in object) {
				if(callback(object[key], key) === false) break;
			}
		}
	},
	
	/**
	 * Extend classes with functions and variables from another object
	 * 
	 * @param	{mixed}	target	base target to extend
	 * @param	{object}	objects,...	subsequent objects to apply to the base target
	 * @return	{mixed}	target extended with new functions/params
	 */
	$extend: function() {
		self = this;
		
		// Make sure we have a target
		if(arguments.length == 0) return {};

		// Get the tag
		var target = arguments[0];

		// Ensure we have an extendable target
		if(typeof target != 'object' && typeof target != 'function') {
			target = {};
		}

		for(var i = 1; i < arguments.length; i++) {
			// Get the object
			var object = arguments[i];

			// Ensure we have an object we can extend with, otherwise, bail.
			if(typeof object != 'object') {
				return target;
			}

			// Loop through object and bring eerything into the target scope
			for(var key in object) {
				var value = object[key];

				// Ignore undefined values
				if(typeof value == 'undefined') continue;

				// Handle null
				else if(value == null) {
					if(typeof target == 'function') target.prototype[key] = null;
					else target[key] = null;
				}

				// Handle objects recursively
				else if(typeof value == 'object') {
					if(typeof target == 'function') {
						target.prototype[key] = self.extend(target.prototype[key], value);
					} else {
						target[key] = self.extend(target[key], value);
					}
				}

				// For the rest, just do a straight assign
				else {
					if(typeof target == 'function') target.prototype[key] = value;
					else target[key] = value;
				}
			}
		}

		// Pass it back
		return target;
	},
	
	/**
	 * Get the bounds of a provided view
	 * 
	 * @param	{UI.View}	view	Instance of <code>UI.View</code> to get the bounds of
	 * @private
	 * @function
	 * @static
	 * @return	Bounds of the view
	 */
	$bounds: function(view) {
		var frame = view.getFrame();
		frame[0] = 0;
		frame[1] = 0;
		return frame;
	},
	
	/**
	 * Get the boolean value of a string
	 * 
	 * @param	{string}	str
	 * @private
	 * @function
	 * @static
	 * @return	Boolean
	 */
	$parseBool: function(str) {
		if(typeof str == 'undefined') return false;
		
		if(typeof str == 'boolean') {
			return str;
		}
		
		try {
			str = str.toString().substr(0, 1);
			if(str == "t" || str == "y" || str == "1") {
				return true;
			} else {
				return false;
			}
		} catch(e) {
			return false;
		}
	},
	
	/**
	 * Get the double value of a string
	 * 
	 * @param	{string}	str
	 * @private
	 * @function
	 * @static
	 * @return	Double
	 */
	$parseDouble: function(str) {
		if(typeof str == 'double' || typeof str == 'undefined') {
			return str;
		}
		
		if(str == null) return str;
		
		return str + 0.0;
	},
	
	/**
	 * Get the SHA1 value of a string
	 * 
	 * @param	{string}	msg
	 * @private
	 * @function
	 * @static
	 * @return	SHA1 String
	 */
	$sha1: function(msg) {
		/**
		*
		*  Secure Hash Algorithm (SHA1)
		*  http://www.webtoolkit.info/
		*
		**/

		function rotate_left(n,s) {
			var t4 = ( n<<s ) | (n>>>(32-s));
			return t4;
		};

		function lsb_hex(val) {
			var str="";
			var i;
			var vh;
			var vl;

			for( i=0; i<=6; i+=2 ) {
				vh = (val>>>(i*4+4))&0x0f;
				vl = (val>>>(i*4))&0x0f;
				str += vh.toString(16) + vl.toString(16);
			}
			return str;
		};

		function cvt_hex(val) {
			var str="";
			var i;
			var v;

			for( i=7; i>=0; i-- ) {
				v = (val>>>(i*4))&0x0f;
				str += v.toString(16);
			}
			return str;
		};


		function Utf8Encode(string) {
			string = string.replace(/\r\n/g,"\n");
			var utftext = "";

			for (var n = 0; n < string.length; n++) {

				var c = string.charCodeAt(n);

				if (c < 128) {
					utftext += String.fromCharCode(c);
				}
				else if((c > 127) && (c < 2048)) {
					utftext += String.fromCharCode((c >> 6) | 192);
					utftext += String.fromCharCode((c & 63) | 128);
				}
				else {
					utftext += String.fromCharCode((c >> 12) | 224);
					utftext += String.fromCharCode(((c >> 6) & 63) | 128);
					utftext += String.fromCharCode((c & 63) | 128);
				}

			}

			return utftext;
		};

		var blockstart;
		var i, j;
		var W = new Array(80);
		var H0 = 0x67452301;
		var H1 = 0xEFCDAB89;
		var H2 = 0x98BADCFE;
		var H3 = 0x10325476;
		var H4 = 0xC3D2E1F0;
		var A, B, C, D, E;
		var temp;

		msg = Utf8Encode(msg);

		var msg_len = msg.length;

		var word_array = new Array();
		for( i=0; i<msg_len-3; i+=4 ) {
			j = msg.charCodeAt(i)<<24 | msg.charCodeAt(i+1)<<16 |
			msg.charCodeAt(i+2)<<8 | msg.charCodeAt(i+3);
			word_array.push( j );
		}

		switch( msg_len % 4 ) {
			case 0:
				i = 0x080000000;
			break;
			case 1:
				i = msg.charCodeAt(msg_len-1)<<24 | 0x0800000;
			break;

			case 2:
				i = msg.charCodeAt(msg_len-2)<<24 | msg.charCodeAt(msg_len-1)<<16 | 0x08000;
			break;

			case 3:
				i = msg.charCodeAt(msg_len-3)<<24 | msg.charCodeAt(msg_len-2)<<16 | msg.charCodeAt(msg_len-1)<<8	| 0x80;
			break;
		}

		word_array.push( i );

		while( (word_array.length % 16) != 14 ) word_array.push( 0 );

		word_array.push( msg_len>>>29 );
		word_array.push( (msg_len<<3)&0x0ffffffff );


		for ( blockstart=0; blockstart<word_array.length; blockstart+=16 ) {

			for( i=0; i<16; i++ ) W[i] = word_array[blockstart+i];
			for( i=16; i<=79; i++ ) W[i] = rotate_left(W[i-3] ^ W[i-8] ^ W[i-14] ^ W[i-16], 1);

			A = H0;
			B = H1;
			C = H2;
			D = H3;
			E = H4;

			for( i= 0; i<=19; i++ ) {
				temp = (rotate_left(A,5) + ((B&C) | (~B&D)) + E + W[i] + 0x5A827999) & 0x0ffffffff;
				E = D;
				D = C;
				C = rotate_left(B,30);
				B = A;
				A = temp;
			}

			for( i=20; i<=39; i++ ) {
				temp = (rotate_left(A,5) + (B ^ C ^ D) + E + W[i] + 0x6ED9EBA1) & 0x0ffffffff;
				E = D;
				D = C;
				C = rotate_left(B,30);
				B = A;
				A = temp;
			}

			for( i=40; i<=59; i++ ) {
				temp = (rotate_left(A,5) + ((B&C) | (B&D) | (C&D)) + E + W[i] + 0x8F1BBCDC) & 0x0ffffffff;
				E = D;
				D = C;
				C = rotate_left(B,30);
				B = A;
				A = temp;
			}

			for( i=60; i<=79; i++ ) {
				temp = (rotate_left(A,5) + (B ^ C ^ D) + E + W[i] + 0xCA62C1D6) & 0x0ffffffff;
				E = D;
				D = C;
				C = rotate_left(B,30);
				B = A;
				A = temp;
			}

			H0 = (H0 + A) & 0x0ffffffff;
			H1 = (H1 + B) & 0x0ffffffff;
			H2 = (H2 + C) & 0x0ffffffff;
			H3 = (H3 + D) & 0x0ffffffff;
			H4 = (H4 + E) & 0x0ffffffff;

		}

		var temp = cvt_hex(H0) + cvt_hex(H1) + cvt_hex(H2) + cvt_hex(H3) + cvt_hex(H4);

		return temp.toLowerCase();
	},


	/**
	 * Base64 decode
	 * http://www.webtoolkit.info/
	 * 
	 * @param	{string}	input	base64 encoded string
	 * @function
	 * @static
	 * @private
	 * @return	{string} base64 decoded string
	 **/
	$base64Decode: function(input) {
		var keyStr = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
		
		var utf8_decode = function(utftext) {
			var string = "";
			var i = 0;
			var c = c1 = c2 = 0;

			while ( i < utftext.length ) {

				c = utftext.charCodeAt(i);

				if (c < 128) {
					string += String.fromCharCode(c);
					i++;
				}
				else if((c > 191) && (c < 224)) {
					c2 = utftext.charCodeAt(i+1);
					string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
					i += 2;
				}
				else {
					c2 = utftext.charCodeAt(i+1);
					c3 = utftext.charCodeAt(i+2);
					string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
					i += 3;
				}

			}

			return string;
		};
		
		var output = "";
		var chr1, chr2, chr3;
		var enc1, enc2, enc3, enc4;
		var i = 0;

		input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");

		while (i < input.length) {

			enc1 = keyStr.indexOf(input.charAt(i++));
			enc2 = keyStr.indexOf(input.charAt(i++));
			enc3 = keyStr.indexOf(input.charAt(i++));
			enc4 = keyStr.indexOf(input.charAt(i++));

			chr1 = (enc1 << 2) | (enc2 >> 4);
			chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
			chr3 = ((enc3 & 3) << 6) | enc4;

			output = output + String.fromCharCode(chr1);

			if (enc3 != 64) {
				output = output + String.fromCharCode(chr2);
			}
			if (enc4 != 64) {
				output = output + String.fromCharCode(chr3);
			}

		}

		return utf8_decode(output);
	}

});; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Mobclix/Core/HTTPRequest'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Mobclix/Core/HTTPRequest'] || {}; $MODULE_REGISTRY['NGCore/Client/Mobclix/Core/HTTPRequest'] = exports; //
//  Mobclix.Core.HTTPRequest.js
//  Mobclix Mobage SDK
//
//  Copyright 2011 Mobclix. All rights reserved.
//

var MMClass = require('NGCore/Client/Mobclix/Core/MMClass').MMClass;
var Network = require('NGCore/Client/Network').Network;
var Utils = require('NGCore/Client/Mobclix/Core/Utils').Utils;

exports.HTTPRequest = MMClass.subclass({
	__className: "HTTPRequest",

	success: false,
	loading: false,
	error: false,
	response: null,
	statusCode: 0,
	request: null,
	
	initialize: function() {
		try {
			this.request = new Network.XHR();
		} catch (e) {
			this.request = null;
		}
	},
	
	getStatusCode: function() {
		return this.statusCode;
	},
	
	getResponse: function() {
		return this.response;
	},
	
	getResponseText: function() {
		return this.request.responseText;
	},
	
	wasSuccessful: function() {
		return this.success;
	},
	
	getError: function() {
		return this.error;
	},

	start: function(options) {
		// If we don't have an ajax object, bail out
		if(!this.request) {
			this.error = true;
			if(options.error) options.error(this);
			return false;
		}
		
		// Cleanup options
		if(typeof options != "object") {
			options = {url: options};
		}
		
		// Setup some defaults
		options.type = options.type || "GET";
		options.timeout = options.timeout || 120;
		options.data = options.data || "";
		options.async = options.async || true;
		
		
		// Build data
		if(typeof options.data == "object") {
			var params = options.data;
			options.data = "";

			for(var key in params) {
				options.data += "&" + escape(key) + "=" + escape(params[key]);
			}
			
			if(options.data.length > 0) {
				options.data = options.data.substring(1, options.length);
			}
		} else if(options != null && typeof options != 'undefined') {
			options.data = options.data.toString();
		} else {
			options.data = "";
		}
        
		// Setup state change handler
		var self = this;
		self.retain();

		this.request.onreadystatechange = function() {
			// Check if we're done loading
			if(self.request.readyState != 4) return;
			self.loading = false;
			
			// Store status code
			self.statusCode = self.request.status;

			// See if it's a valid response
			if((self.statusCode >= 200 && self.statusCode < 300) || (!options.async && self.statusCode == 0)) {
				self.success = true;

				if(self.request.getResponseHeader("Content-type").indexOf("json") >= 0 || self.request.getResponseHeader("Content-type").indexOf("javascript") >= 0) {
					try {
						resp = eval("("+self.request.responseText+")");
					} catch (e) {
						resp = null;
					}
					
					if(resp == null || typeof resp == 'undefined') {
						resp = self.request.responseText;
					}
				} else {
					resp = self.request.responseText;
				}
				
				if(options.success) options.success(self, resp);
			} else if(self.request.responseXML) {
				resp = self.request.responseXML;
			} else {
				self.error = true;
				if(options.error) options.error(self, self.statusCode);
			}
			
			self.release();
		};
		
		// Start the request
		if(options.type.toLowerCase() == "get") {
			var url = options.url + (options.url.indexOf("?") >= 0 ? "&" : "?") + options.data;
			this.request.open("GET", url, options.async);

            if (options.userAgent != null)
                this.request.setRequestHeader("User-Agent", options.userAgent);
			this.request.send(null);
		} else {
			this.request.open(options.type, options.url, options.async);
			this.request.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
			this.request.setRequestHeader("Content-length", options.data.length);
            if (options.userAgent != null)
                this.request.setRequestHeader("User-Agent", options.userAgent);
			this.request.send(options.data);
		}
		
		this.loading = true;
	},
	
	destroy: function($super) {
		// if(this.request) this.request.destroy(); // Network.XHR doesn't have a .destroy() -- what?
		this.request = null;
		this.response = null;
		
		$super();
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Mobclix/Core/MMArray'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Mobclix/Core/MMArray'] || {}; $MODULE_REGISTRY['NGCore/Client/Mobclix/Core/MMArray'] = exports; //
//  Mobclix.Core.MMArray.js
//  Mobclix Mobage SDK
//
//  Copyright 2011 Mobclix. All rights reserved.
//

var MMClass = require('NGCore/Client/Mobclix/Core/MMClass').MMClass;
var $mc = require('NGCore/Client/Mobclix/Core/Utils').Utils;

var MMArray = exports.MMArray = MMClass.subclass({
	__className: "MMArray",
	___array: null,
	length: 0,
	
	initialize: function($super) {
		$super();
		this.___array = new Array();
	},
	
	get: function(index) {
		return this.___array[index];
	},
	
	set: function(index, element) {
		if(this.___array[index]) {
			try { this.___array[index].release(); } catch (e) { }
		}
		
		this.___array[index] = element;
		try { this.___array[index].retain(); } catch(e) { }
		
		this.length = this.___array.length;
	},
	
	remove: function(index) {
		var element = this.___array[index];
		this.___array = this.___array.slice(0, index).join(this.___array.slice(index+1));
		try { element.release(); } catch (e) { }
		this.length = this.___array.length;
	},
	
	push: function() {
		for(var i = 0; i < arguments.length; i++) {
			var element = arguments[i];
			$mc.log("Adding " + element.__description()  + " to " + this.__description());
			this.___array.push(element);
			try { element.retain(); } catch(e) {}
		}
		this.length = this.___array.length;
	},
	
	pop: function() {
		var element = this.___array.pop();
		try { element.release(); } catch(e) { }
		this.length = this.___array.length;
		return element;
	},
	
	valueOf: function() {
		return this.___array.valueOf();
	},
	
	toString: function() {
		return this.___array.toString();
	},
	
	reverse: function() {
		this.___array.reverse();
	},
	
	indexOf: function(element) {
		for(var i = 0; i < this.___array.length; i++) {
			if(element == this.___array[i]) {
				return i;
			}
		}
		
		return -1;
	},
	
	each: function(callback) {
		for(var i = 0; i < this.___array.length; i++) {
			if(callback(this.___array[i], i) === false) break;
		}
	},
	
	destroy: function($super) {
		var self = this;
		this.each(function(element) {
			$mc.log("Removing " + element.__description()  + " from " + self.__description());
			try { element.release(); } catch(e) { }
		});
		
		this.length = this.___array.length;
		this.___array = null;

		$super();
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Mobclix/Browser'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Mobclix/Browser'] || {}; $MODULE_REGISTRY['NGCore/Client/Mobclix/Browser'] = exports; //
//  Mobclix.Browser.js
//  Mobclix Mobage SDK
//
//  Copyright 2011 Mobclix. All rights reserved.
//

var Core = require('NGCore/Client/Core').Core;
var Device = require('NGCore/Client/Device').Device;
var UI = require('NGCore/Client/UI').UI;
var ViewController = require('NGCore/Client/Mobclix/ViewController').ViewController;
var Controller = require('NGCore/Client/Mobclix/Core/Controller').Controller;
var MMView = require('NGCore/Client/Mobclix/Core/MMView').MMView;
var MMWebView = require('NGCore/Client/Mobclix/Core/MMWebView').MMWebView;
var Config = require('NGCore/Client/Mobclix/Core/Config').Config;
var $mc = require('NGCore/Client/Mobclix/Core/Utils').Utils;

var ProxyListener = Core.MessageListener.subclass({
	onUpdate: function() {}
});

var Browser = exports.Browser = ViewController.subclass(
/** @lends Mobclix.Browser.prototype */
{
	__className: "Mobclix.Browser",
	webView: null,
	onDidFinish: null,
    browserType: null,
	topBar: null,
	bottomBar: null,
	bottomBorders: [null, null],
	prevArrow: null,
	nextArrow: null,
	doneButton: null,
	proxyListener: null,
    keyListener: null,
	
    // Null unless this is a fullscreen ad
    creativeView: null,
    
	Type: {
		Toolbar: 1,
		Navigation: 2,
		Full: 3,
		Minimal: 4
	},
	
	initialize: function($super, browserType, creativeView) {
		$super();
		
		var self = this;
		var types = this.Type;
        this.creativeView = creativeView;

        // Register register to close browser when app loses focus if not a fullscreen ad.
        if (creativeView == null) {
            this.proxyListener = new ProxyListener();
            Device.LifecycleEmitter.addListener(this.proxyListener, function(event) {
                if(event == Device.LifecycleEmitter.Event.Suspend) {
                    if(self.isPresented()) {
                        self.dismissViewController();
                    }
                }
            });
        }
        
        this.keyListener = new ProxyListener();
        Device.KeyEmitter.addListener(this.keyListener, function(event) {
            if(event.code === Device.KeyEmitter.Keycode.back) {
                if(self.isPresented()) {
                    self.dismissViewController();
                    return true;
                }
            }
        }, 0xffffffff);

		var browserType = browserType || this.Type.Toolbar;
		this.browserType = browserType;
        
		// Web View
		this.webView = new MMWebView();
		this.addChild(this.webView);
		
		// Bottom Bar
		(function() {
			if(browserType != types.Toolbar && browserType != types.Navigation && browserType != types.Full) return;
			
			self.bottomBar = new MMView();
			self.bottomBar.setGradient({
				gradient: [ "ffb0bccd 0.0", "ff879ab3 0.5", "ff8094ae 0.5", "ff6d83a1 1.0" ]
			});
			self.addChild(self.bottomBar);
			
			self.doneButton = new UI.Button({
				'text': 'Close',
				'textColor': 'ff',
				'textShadow': "8000 1.0 {0,1}",
				'textSize': 13,
				'textFont': UI.FontStyle.Bold,
				'textGravity': UI.ViewGeometry.Gravity.Center,
				'frame': [0, 0, 60, 30]
			});
			
			var corners = $mc.dip(4);
			corners = [corners, corners, corners, corners].join(' ');
			
			self.doneButton.setNormalGradient({
				corners: corners,
				outerLine: "ff2952b8 1",
				gradient: [ "ff7b9eea 0.0", "ff376fe0 0.5", "ff2260dd 0.5", "ff2463de 1.0" ]
			});
			self.doneButton.setHighlightedGradient({
				corners: corners,
				outerLine: "ff1b2c4e 1",
				gradient: [ "ff7d88a5 0.0", "ff3a4e77 0.5", "ff253c6a 0.5", "ff273e6d 1.0" ]
			});
			
			self.doneButton.setOnClick(function() {
				self.dismissViewController(true);
			});

			self.bottomBar.addChild(self.doneButton);

			var arrowProps = {
				'text': '◀',
				'textColor': 'ff',
				'textShadow': "8000 1.0 {0,1}",
				'textSize': 16,
				'textFont': UI.FontStyle.Bold,
				'textGravity': UI.ViewGeometry.Gravity.Center
			};
			
			if(Controller.isAndroid()) {
				arrowProps.textSize = 32;
			}
			
			self.prevArrow = new UI.Button(arrowProps);
			self.prevArrow.setOnClick(function() { self.webView.goBack(); });
			self.prevArrow.setTextColor('ffa8d4ff', UI.State.Pressed);
			self.bottomBar.addChild(self.prevArrow);

			arrowProps.text = '▶';
			self.nextArrow = new UI.Button(arrowProps);
			self.nextArrow.setTextColor('ffa8d4ff', UI.State.Pressed);
			self.nextArrow.setOnClick(function() { self.webView.goForward(); });
			self.bottomBar.addChild(self.nextArrow);
			
			self.bottomBorders[0] = new MMView();
			self.bottomBorders[0].setBackgroundColor('ff2d3034');
			self.bottomBar.addChild(self.bottomBorders[0]);
			
			self.bottomBorders[1] = new MMView();
			self.bottomBorders[1].setBackgroundColor('ffd8dee6');
			self.bottomBar.addChild(self.bottomBorders[1]);
			
			self.loadingIndicator = new UI.Spinner({
				'frame': [0, 0, 30, 30]
			});
			self.bottomBar.addChild(self.loadingIndicator);
			
			// Setup WebView listenres to control the bar items
            // Only for non-fullscreen creatives. Fullscreen listeners are set below.
            if (self.creativeView == null) {
                self.webView.setOnPageevent(function(event) {
                    self.updateArrows();
                });

                self.webView.setOnStartload(function(event) {
                    self.updateArrows();
                    self.loadingIndicator.setVisible(true);
                });

                self.webView.setOnPageload(function(event) {
                    self.updateArrows();
                    self.loadingIndicator.setVisible(false);
                });

                self.webView.setOnError(function(event) {
                    self.updateArrows();
                    self.loadingIndicator.setVisible(false);
                });

                self.webView.setOnLoad(function(event) {
                    self.updateArrows();
                });
            }
		})();

		// Widget close
		(function() {
			if(browserType != types.Minimal) return;

			var cornerSize = $mc.dip(14);
			var backFontSize = 18;
		
			if(Controller.isAndroid()) {
				backFontSize = 20;
			}

			var back = new UI.Button({
				'text': '✖',
				'textColor': 'ff',
				'textSize': backFontSize,
				'textFont': UI.FontStyle.Bold,
				'textGravity': UI.ViewGeometry.Gravity.Center,
				'textInsets': [1, 0, 0, 1],
				'frame': [$mc.dip(10), $mc.dip(10), $mc.dip(32), $mc.dip(32)]
			});

			back.setGradient({
				corners: [cornerSize, cornerSize, cornerSize, cornerSize].join(' '),
				outerLine: "ff 2",
				gradient: [ "00 0.0", "00 1.0" ]
			}, UI.State.Normal);
		
			back.setGradient({
				corners: [cornerSize, cornerSize, cornerSize, cornerSize].join(' '),
				outerLine: "ff 2",
				gradient: [ "00 0.0", "00 1.0" ]
			}, UI.State.Pressed);
		
			back.onclick = function() {
				self.dismissViewController(true);
			};
		
			self.addChild(back);
		})();
        
        if (creativeView != null) {
            this.webView.setOnPageevent(function(event) {
                self.onPageEvent(event);
            });
            
            this.webView.setOnStartload(function(event) {
                self.onStartLoad(event);
            });

            this.webView.setOnShouldload(function(event) {
                return self.onShouldLoad(event);
            });

            this.webView.setOnPageload(function(event) {
                self.onPageLoad(event);
            });
            
            this.webView.setOnError(function(event) {
                self.onError(event);
            });
        }
	},
	
    updateArrows: function() {
        var canGoForward = this.webView.canGoForward();
        this.nextArrow.setAlpha(canGoForward ? 1.0 : 0.6);
        this.nextArrow.setState(canGoForward ? UI.State.Normal : UI.State.Disabled);

        var canGoBack = this.webView.canGoBack();
        this.prevArrow.setAlpha(canGoBack ? 1.0 : 0.6);
        this.prevArrow.setState(canGoBack ? UI.State.Normal : UI.State.Disabled);
    },
    
	viewWillAppear: function($super, animated) {
		$super(animated);
		this.layoutSubviews();
	},
	
	setFrame: function() {
		UI.View.prototype.setFrame.apply(this, arguments);
		this.layoutSubviews();
	},
	
	layoutSubviews: function() {
		var bounds = this.getBounds();
		var webViewFrame = this.getBounds();
		
		if(this.bottomBar) {
			var barHeight = $mc.dip(44);
			this.bottomBar.setFrame(0, bounds[3] - barHeight, bounds[2], barHeight);
			webViewFrame[3] -= barHeight;

			var loadingFrame = [0,0,25,25];
			loadingFrame[0] = Math.floor((bounds[2] - loadingFrame[2]) / 2);
			loadingFrame[1] = Math.floor((barHeight - loadingFrame[3]) / 2);
			this.loadingIndicator.setFrame(loadingFrame);
		
			var donePadding = $mc.dip(6);
			
			var doneFrame = this.doneButton.getFrame();
			doneFrame[2] = $mc.dip(54);
			doneFrame[3] = $mc.dip(29);
			doneFrame[0] = bounds[2] - doneFrame[2] - donePadding;
			doneFrame[1] = Math.floor((barHeight - doneFrame[3]) / 2);
			this.doneButton.setFrame(doneFrame);
			
			var doneOuterWidth = doneFrame[2] + $mc.dip(6);
			
			var arrowFrame = [0,0,0,0];
			arrowFrame[0] = doneOuterWidth;
			arrowFrame[1] = 0;
			arrowFrame[2] = Math.floor((bounds[2] - (doneOuterWidth * 2)) / 3);
			arrowFrame[3] = barHeight;
			this.prevArrow.setFrame(arrowFrame);

			arrowFrame[0] = bounds[2] - arrowFrame[2] - doneOuterWidth;
			this.nextArrow.setFrame(arrowFrame);
			
			var borderFrame = [0, 0, bounds[2], $mc.dip(1)];
			this.bottomBorders[0].setFrame(borderFrame);
			
			borderFrame[1] = $mc.dip(1);
			this.bottomBorders[1].setFrame(borderFrame);
		}
		
		this.webView.setFrame(webViewFrame);
	},
	
	dismissViewController: function($super, animated) {
		if(typeof this.onDidFinish == 'function') {
			this.onDidFinish();
		}
		$super(animated);
	},
	
	loadUrl: function(url) {
		this.webView.loadUrl(url);
	},
    
    loadWithCreative: function(cacheLocation) {
		this.webView.loadDocument(cacheLocation);
	},
	
    getParameterByName: function(url, name, d) {
		name = name.replace(/[\[]/,"\\\[").replace(/[\]]/,"\\\]");
		var regexS = "[\\?&]"+name+"=([^&#]*)";
		var regex = new RegExp( regexS );
		var results = regex.exec( url );
		if( results == null )
			return d;
		else
			return decodeURIComponent(results[1].replace(/\+/g, " "));
	},
    
    onShouldLoad: function(event) {
        if (this.creativeView.loaded && !this.creativeView.touched) {
            try {
                this.creativeView.adView.currentCreative.getEvents().triggerEvent("touch");
            } catch(e) { }
        }
        this.creativeView.touched = true;
		return true;
	},
	
	onPageEvent: function(event) {
		$mc.log("WebView webgame Page Event: ", JSON.stringify(event));
        var method = event.eventStream.split("?")[0];
        if (method == "setUserAgent") {
            var userAgent = this.getParameterByName(event.eventStream, "ua") || null;
            Controller.setUserAgent(userAgent);
        }
        if(this.browserType == this.Type.Toolbar || this.browserType == this.Type.Navigation || this.browserType == this.Type.Full)
            this.updateArrows();
	},

	onStartLoad: function(event) {
		$mc.log("WebView webgame Page Start Load: ", JSON.stringify(event));
        if(this.browserType == this.Type.Toolbar || this.browserType == this.Type.Navigation || this.browserType == this.Type.Full) {
            this.updateArrows();
            this.loadingIndicator.setVisible(true);
        }
	},

	onPageLoad: function(event) {
		$mc.log("WebView webgame Page Load: ", JSON.stringify(event));
		if (!this.creativeView.loaded) {
			this.creativeView.loaded = true;
			this.creativeView.adView.creativeViewFinishedLoading(this.creativeView, this.creativeView.currentCreative);
            try {
                this.webView.invoke("var uaUrl = \"ngcore://setUserAgent?ua=\" + escape(navigator.userAgent); window.location=uaUrl;");
            } catch (err) {}
		}
        if(this.browserType == this.Type.Toolbar || this.browserType == this.Type.Navigation || this.browserType == this.Type.Full) {
            this.updateArrows();
            this.loadingIndicator.setVisible(false);
        }
	},

	onError: function(event) {
		$mc.log("WebView webgame Error: ", JSON.stringify(event));
        if(this.browserType == this.Type.Toolbar || this.browserType == this.Type.Navigation || this.browserType == this.Type.Full) {
            this.updateArrows();
            this.loadingIndicator.setVisible(false);
        }
	},
    
	destroy: function($super) {
		if(this.bottomBar) {
			this.prevArrow.removeFromParent();
			this.nextArrow.removeFromParent();
			this.doneButton.removeFromParent();
			this.loadingIndicator.removeFromParent();
			this.bottomBorders[0].removeFromParent();
			this.bottomBorders[1].removeFromParent();
			
			try { this.prevArrow.destroy(); } catch (e) { }
			try { this.nextArrow.destroy(); } catch (e) { }
			try { this.doneButton.destroy(); } catch (e) { }
			try { this.loadingIndicator.destroy(); } catch (e) { }
			try { this.bottomBorders[0].destroy(); } catch (e) { }
			try { this.bottomBorders[1].destroy(); } catch (e) { }

			this.removeChild(this.bottomBar);
			this.bottomBar.release();
			this.bottomBar = null;
		}
		
		this.removeChild(this.webView);
		this.webView.release();
        try {
            Device.NetworkEmitter.removeListener(this.proxyListener);
        } catch (e) {}
        try {
            Device.KeyEmitter.removeListener(this.keyListener);
        } catch (e) {}

		$super();
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Mobclix/Creative'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Mobclix/Creative'] || {}; $MODULE_REGISTRY['NGCore/Client/Mobclix/Creative'] = exports; //
//  Mobclix.Creative.js
//  Mobclix Mobage SDK
//
//  Copyright 2011 Mobclix. All rights reserved.
//

var Core = require('NGCore/Client/Core').Core;
var $mc = require('NGCore/Client/Mobclix/Core/Utils').Utils;

exports.Creative =
/** @lends Mobclix.Creative.prototype */
{
	Types: require('NGCore/Client/Mobclix/Creative/Base').Types,
	Web: require('NGCore/Client/Mobclix/Creative/Web').Web,

	/**
	 * Create an Creative model from a JSON objects
	 * @param {object}	JSON creative object
	 * @private
	 */
	Create: function(obj) {
		var creativeType = null;
		try {
			creativeType = obj.creative.type || "web";
		} catch(e) {
			creativeType = "web";
		}

		switch(creativeType) {
			case 'html':
			case 'web':
			default:
				$mc.log("HTML or Unknown ad type detected: ", creativeType);
				return new this.Web(obj);
		}
	}
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Mobclix/CreativeView/Web'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Mobclix/CreativeView/Web'] || {}; $MODULE_REGISTRY['NGCore/Client/Mobclix/CreativeView/Web'] = exports; //
//  Mobclix.CreativeView.Web.js
//  Mobclix Mobage SDK
//
//  Copyright 2011 Mobclix. All rights reserved.
//

var Core = require('NGCore/Client/Core').Core;
var Controller = require('NGCore/Client/Mobclix/Core/Controller').Controller;
var UI = require('NGCore/Client/UI').UI;
var Device = require('NGCore/Client/Device').Device;
var Storage = require('NGCore/Client/Storage').Storage;
var Base = require('NGCore/Client/Mobclix/CreativeView/Base').Base;
var MMWebView = require('NGCore/Client/Mobclix/Core/MMWebView').MMWebView;
var RMWebView = require('NGCore/Client/Mobclix/CreativeView/WebView').WebView;
var Browser = require('NGCore/Client/Mobclix/Browser').Browser;
var $mc = require('NGCore/Client/Mobclix/Core/Utils').Utils;

var ProxyListener = Core.MessageListener.subclass({
	onUpdate: function() {}
});

exports.Web = Base.subclass(
/** @lends Mobclix.CreativeView.Web.prototype */
{
	__className: "Mobclix.CreativeView.Web",
	webView: null,
	cacheLocation: null,
	loaded: false,
    touched: false,
	fs: null,
	useRichMedia: false,
	
	/**
	 * @class Web CreativeView class for display {@link Mobclix.Creative.Web} creatives
	 * @constructs The default constructor. 
	 * @param $super This parameter is stripped out during execution. Do not supply it.
	 * @extends Mobclix.Creative.Base
	 * @private
	 */
	initialize: function($super) {
		$super();

		if(this.useRichMedia) {
			this.webView = new RMWebView();
			this.webView.parentCreative = this;
		} else {
			this.webView = new MMWebView();
		}
		
		this.addChild(this.webView);
		this.fs = Storage.FileSystem;
		
		var self = this;
		
        this.webView.setScrollable(false);
        
		if(this.useRichMedia) {
			this.webView.setOnPageevent(this.webView.onPageEvent);
		} else {
            this.webView.setOnPageevent(function(event) {
                self.onPageEvent(event);
            });
        }
		
		this.webView.setOnStartload(function(event) {
			self.onStartLoad(event);
		});

		this.webView.setOnShouldload(function(event) {
			return self.onShouldLoad(event);
		});

		this.webView.setOnPageload(function(event) {
			self.onPageLoad(event);
		});
		
		this.webView.setOnError(function(event) {
			self.onError(event);
		});
		
		this.proxyListener = new ProxyListener();
		$mc.log("Adding life cycle listener");
		Device.LifecycleEmitter.addListener(this.proxyListener, function(event) {
			$mc.log("life cycle changed!");
			if(event == Device.LifecycleEmitter.Event.Terminate) {
				self.fs.deleteFile(this.cacheLocation);
				self.fs = null;
				self.cacheLocation = null;
			}
		});
		$mc.log("Added life cycle listener");
	},
	
	getParameterByName: function(url, name, d) {
		name = name.replace(/[\[]/,"\\\[").replace(/[\]]/,"\\\]");
		var regexS = "[\\?&]"+name+"=([^&#]*)";
		var regex = new RegExp( regexS );
		var results = regex.exec( url );
		if( results == null )
			return d;
		else
			return decodeURIComponent(results[1].replace(/\+/g, " "));
	},
	
	/**
	 * Resize the internal webview if our bounds change
	 * 
	 * NOTE: Couldn't find any "autoresizing" options like iOS
	 * has, this should be replaced with that if found.
	 */
	setFrame: function() {
		UI.View.prototype.setFrame.apply(this, arguments);
		var frame = this.getFrame();
		this.webView.setFrame(0, 0, frame[2], frame[3]);
	},

	/**
	 * Tells AdView what kind of view this is
	 * and when to reuse it
	 */
	reuseIdentifier: function() {
		return "web";
	},
	
	/**
	 * Should prepare the current creative view to be reused
	 * Only called if canBeReused returns true
	 */
	prepareForReuse: function() {
		this.webView.loadUrl("about:blank");
		this.fs.deleteFile(this.cacheLocation);
		this.cacheLocation = null;
        this.loaded = false;
        this.touched = false;
	},
	
	/**
	 * Whether or not the current creative view can be reused
	 * Reuseable creative views are encouraged to lower memory and cpu usage
	 */
	canBeReused: function() {
		return true;
	},
	
	/**
	 * Load the current creative
	 */
	loadWithCreative: function($super, creative) {
		$super(creative);
		
		var ts = parseInt((new Date()).getTime(), 10);
		this.cacheLocation = "MobclixTempCreative-"+ts+".html";
		
		$mc.log("Loading HTML: ", this.currentCreative.html);
		
		this.fs.writeFile(this.cacheLocation, this.currentCreative.html);
		this.webView.loadDocument(this.cacheLocation);
	},
	
	onShouldLoad: function(event) {
        if(this.loaded && !this.touched) {
            try {
                this.adView.currentCreative.getEvents().triggerEvent("touch");
            } catch(e) { }
        }
        this.touched = true;
		if(!this.useRichMedia) {
			this.adView.openActionURL(this.currentCreative, event.url);
			return false;
		}
		
		var shouldOpenInNewWindow = this.getParameterByName(event.url, "shouldOpenInNewWindow", null);
		
		if ((this.webView.expanded || this.webView.fullscreen) &&
				shouldOpenInNewWindow != "yes") {
			return true;
		} else if (shouldOpenInNewWindow == "no") {
			return true;
		}
		
		// If not an expanded or fullscreen ad, check if another modal is open
		if (!this.webView.expanded && !this.webView.fullscreen) {
			if(!this.adView.shouldTouchThrough()) {
				$mc.log("Already in modal, can't open:", url);
				return false;
			}
			this.adView.willTouchThrough();
		}
		
		var browser = new Browser();
		
		var self = this;
		browser.onDidFinish = function() {
			// If not an expanded or fullscreen ad, reset touchThrough status
			if (!self.webView.expanded && !self.webView.fullscreen)
				self.adView.didTouchThrough(self);
			self.webView.adDidReturnFromHidden();
			self.webView.resumeListeners();
		};
		this.webView.adWillBecomeHidden();
		this.webView.pauseListeners();
	
		browser.loadUrl(event.url);
		browser.presentViewController(true);
		browser.release();
		browser = null;

		return false;
	},
	
	onPageEvent: function(event) {
		$mc.log("WebView webgame Page Event: ", JSON.stringify(event));
        var method = event.eventStream.split("?")[0];
        if (method == "setUserAgent") {
            var userAgent = this.getParameterByName(event.eventStream, "ua") || null;
            Controller.setUserAgent(userAgent);
        }
	},

	onStartLoad: function(event) {
		$mc.log("WebView webgame Page Start Load: ", JSON.stringify(event));
	},

	onPageLoad: function(event) {
		$mc.log("WebView webgame Page Load: ", JSON.stringify(event));
		if (!this.loaded) {
			this.adView.creativeViewFinishedLoading(this, this.currentCreative);
			this.loaded = true;
            try {
                this.webView.invoke("var uaUrl = \"ngcore://setUserAgent?ua=\" + escape(navigator.userAgent); window.location=uaUrl;");
            } catch (err) {}
		}
	},

	onError: function(event) {
		$mc.log("WebView webgame Error: ", JSON.stringify(event));
	},
	
	/**
	 * Stop all loading of the creative
	 */
	stopLoading: function() {
		this.webView.stopLoading();
	},
	
	/**
	 * Called after a creative has been displayed, any post-display 
	 * events or actions that need to be triggered, should be triggered here
	 */
	creativeHasBeenDisplayed: function() {
		
	},
	
	/**
	 * Clean up
	 */
	destroy: function($super) {
		$mc.log('Web - destroy - adView_frame: ');
		this.webView.removeFromParent();
		
		try {
			this.webView.release();
			this.webView = null;
		} catch (e) {
			$mc.log("Exception while destroying WebView: ", e);
		}
			
		try {
			this.fs.deleteFile(this.cacheLocation);
			this.fs = null;
			this.cacheLocation = null;
		} catch (e) {
			$mc.log("Exception while destroying CreativeView.Web: ", e);
		}
		
		this.proxyListener = null;
		
		$super();
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Mobclix/CreativeView/FullScreen'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Mobclix/CreativeView/FullScreen'] || {}; $MODULE_REGISTRY['NGCore/Client/Mobclix/CreativeView/FullScreen'] = exports; //
//  Mobclix.CreativeView.FullScreen.js
//  Mobclix Mobage SDK
//
//  Copyright 2011 Mobclix. All rights reserved.
//

var Core = require('NGCore/Client/Core').Core;
var Controller = require('NGCore/Client/Mobclix/Core/Controller').Controller;
var UI = require('NGCore/Client/UI').UI;
var Device = require('NGCore/Client/Device').Device;
var Storage = require('NGCore/Client/Storage').Storage;
var Base = require('NGCore/Client/Mobclix/CreativeView/Base').Base;
var MMWebView = require('NGCore/Client/Mobclix/Core/MMWebView').MMWebView;
var RMWebView = require('NGCore/Client/Mobclix/CreativeView/WebView').WebView;
var Browser = require('NGCore/Client/Mobclix/Browser').Browser;
var $mc = require('NGCore/Client/Mobclix/Core/Utils').Utils;

var ProxyListener = Core.MessageListener.subclass({
	onUpdate: function() {}
});

exports.FullScreen = Base.subclass(
/** @lends Mobclix.CreativeView.FullScreen.prototype */
{
	__className: "Mobclix.CreativeView.FullScreen",
	browser: null,
	cacheLocation: null,
	fs: null,
	useRichMedia: false,
	loaded: false,
    touched: false,
    
	/**
	 * @class Web CreativeView class for display {@link Mobclix.Creative.Web} creatives
	 * @constructs The default constructor. 
	 * @param $super This parameter is stripped out during execution. Do not supply it.
	 * @extends Mobclix.Creative.Base
	 * @private
	 */
	initialize: function($super) {
		$super();

        $mc.log("Initializing the FullScreen CreativeView");
        
		var self = this;
        
        
		
        
        $mc.log("Initializing the FileSystem");
		this.fs = Storage.FileSystem;
		
        $mc.log("Setting up poxylistener");
		this.proxyListener = new ProxyListener();
		$mc.log("Adding life cycle listener");
		Device.LifecycleEmitter.addListener(this.proxyListener, function(event) {
			$mc.log("life cycle changed!");
			if(event == Device.LifecycleEmitter.Event.Terminate) {
				self.fs.deleteFile(this.cacheLocation);
				self.fs = null;
				self.cacheLocation = null;
			}
		});
		$mc.log("Added life cycle listener");
	},
	
	/**
	 * Resize the internal webview if our bounds change
	 * 
	 * NOTE: Couldn't find any "autoresizing" options like iOS
	 * has, this should be replaced with that if found.
	 *
	setFrame: function() {
		UI.View.prototype.setFrame.apply(this, arguments);
		var frame = this.getFrame();
		this.webView.setFrame(0, 0, frame[2], frame[3]);
	},*/

	/**
	 * Tells AdView what kind of view this is
	 * and when to reuse it
	 */
	reuseIdentifier: function() {
		return "fullscreen";
	},
	
	/**
	 * Should prepare the current creative view to be reused
	 * Only called if canBeReused returns true
	 */
	prepareForReuse: function() {
		//this.webView.loadUrl("about:blank");
		this.fs.deleteFile(this.cacheLocation);
		this.cacheLocation = null;
        this.loaded = false;
        this.touched = false;
	},
	
	/**
	 * Whether or not the current creative view can be reused
	 * Reuseable creative views are encouraged to lower memory and cpu usage
	 */
	canBeReused: function() {
		return true;
	},
	
	/**
	 * Load the current creative
	 */
	loadWithCreative: function($super, creative) {
		$super(creative);
		
		var ts = parseInt((new Date()).getTime(), 10);
		this.cacheLocation = "MobclixTempCreative-"+ts+".html";
		
		$mc.log("Loading HTML: ", this.currentCreative.html);
		
        var browserType = Browser.Type.Toolbar;
        if (this.currentCreative.html.search(/<meta[^>]*MobclixUseWidgetStyle/i) != -1)
            browserType = Browser.Type.Minimal;
        if (this.currentCreative.html.search(/<meta[^>]*MobileAdsUseWidgetStyle/i) != -1)
            browserType = Browser.Type.Minimal;
        
        var self = this;
        
        $mc.log("Creating browser");
		this.browser = new Browser(browserType, this);
        
        // Set the frame here to prevent iOS scaling issues.
        var screenSize = {width: NGWindow.getWidth(), height: NGWindow.getHeight()};
		var startFullScreenFrame = [0, screenSize.height, screenSize.width, screenSize.height];
        this.browser.setFrame(startFullScreenFrame);
        
        this.browser.onDidFinish = function() {
            try {
                if(typeof self.adView.onDismissAd == 'function') {
                    self.adView.onDismissAd(self.adView);
                }
            } catch (err) {}
            try {
                self.adView._canRequestNextAd = true;
            } catch (err) {}
        };
        
		this.fs.writeFile(this.cacheLocation, this.currentCreative.html);
		this.browser.loadWithCreative(this.cacheLocation);
	},
	
	/**
	 * Stop all loading of the creative
	 */
	stopLoading: function() {
		//this.webView.stopLoading();
	},
	
    display: function() {
        this.browser.presentViewController(true);
		this.browser.release();
		this.browser = null;
    },
    
	/**
	 * Called after a creative has been displayed, any post-display 
	 * events or actions that need to be triggered, should be triggered here
	 */
	creativeHasBeenDisplayed: function() {
		
	},
	
	/**
	 * Clean up
	 */
	destroy: function($super) {
		$mc.log('Web - destroy - fullscreen creativeview: ');
		
		try {
			this.browser.release();
            this.browser = null;
		} catch (e) {
			$mc.log("Exception while destroying Browser: ", e);
		}
			
		try {
			this.fs.deleteFile(this.cacheLocation);
			this.fs = null;
			this.cacheLocation = null;
		} catch (e) {
			$mc.log("Exception while destroying CreativeView.Web: ", e);
		}
		
		this.proxyListener = null;
		
		$super();
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Mobclix/Core/MMClass'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Mobclix/Core/MMClass'] || {}; $MODULE_REGISTRY['NGCore/Client/Mobclix/Core/MMClass'] = exports; //
//  Mobclix.Core.MMClass.js
//  Mobclix Mobage SDK
//
//  Copyright 2011 Mobclix. All rights reserved.
//

var Core = require('NGCore/Client/Core').Core;
var $mc = require('NGCore/Client/Mobclix/Core/Utils').Utils;
var __internalMMClassCounter = 0;

exports.Memory =
/** @lends Mobclix.Core.MMClass.prototype */
{
	__className: "MMClass",
	retainCount: 0,
	__instanceId: 0,

	/**
	 * @class MMClass provides a base foundation for memory managed objects
	 * @description Any objects that subclass MMClass will have their memory managed for them
	 * @constructs The default constructor. 
	 * @param $super This parameter is stripped out during execution. Do not supply it.
	 * @private
	 */
	initialize: function($super) {
		if($super) $super();
		this.__instanceId = ++__internalMMClassCounter;
		// $mc.log("--- initialized: "+this.__description()+" ---");
		this.retain();
	},
	
	/**
	 * Redirects all calls to $addProperty
	 * @private
	 * @see Mobclix.Utils#$addProperty
	 * @function
	 * @static
	 */
	$addProperty: function(propName, shouldRetain, defaultValue) {
		$mc.addProperty(this, propName, shouldRetain, defaultValue);
	},
	
	/**
	 * Gets the description of the current object
	 *  @private
	 */
	__description: function() {
		var hash = this.__instanceId.toString();
		while(hash.length < 5) 	hash = "0" + hash;

		return "[" + this.__className + " 0x" + hash + "]";
	},
	
	/**
	 * Increase the instances retain count by one
	 * @return	current instance
	 * @private
	 */
	retain: function() {
		this.retainCount++;
		// $mc.log("--- retained: "+this.__description()+", new count: "  + this.retainCount + " ---");
		return this;
	},
	
	/**
	 * Schedules {@link #release} to be called at the start of the next run loop
	 * @see Mobclix.Core.MMClass.release
	 * @return	current instance
	 * @private
	 */
	autorelease: function() {
		var self = this;
		setTimeout(function() {
			self.release();
		}, 1);
		return this;
	},
	
	/**
	 * Decreases the instances retain count by one
	 * If the retainCount hits 0, the object will call {@link #destroy}.
	 * @see Mobclix.Core.MMClass.destroy
	 * @private
	 */
	release: function() {
		this.retainCount--;

		// $mc.log("--- released: "+this.__description()+", new count: "  + this.retainCount + " ---");
		
		if(this.retainCount <= 0) {
			this.destroy();
		}
	},
	
	/**
	 * Convers the object to a useable string format
	 * @private
	 */
	toString: function() {
		return "[" + this.__className + " object]";
	},
	
	/**
	 * @private
	 */
	destroy: function($super) {
		// $mc.log("--- destroy: "+this.__description()+" ---");
		if($super) $super();
	}
	
};

exports.MMClass = Core.Class.subclass(exports.Memory);
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Mobclix/Core/Session'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Mobclix/Core/Session'] || {}; $MODULE_REGISTRY['NGCore/Client/Mobclix/Core/Session'] = exports; //
//  Mobclix.Core.Session.js
//  Mobclix Mobage SDK
//
//  Copyright 2011 Mobclix. All rights reserved.
//

var Core = require('NGCore/Client/Core').Core;
var $mc = require('NGCore/Client/Mobclix/Core/Utils').Utils;

exports.Session = Core.Class.singleton({
	identifier: null,
	connectionType: null,

	initialize: function() {

	},
	
	renewIdentifier: function() {
		this.identifier = $mc.sha1(Core.Capabilities.getUniqueId() + Core.Time.getRealTime());
		$mc.log("Generated session identifier: " + this.identifier);
	},
	
	update: function() {
		
	},
	
	destroy: function() {
		this.identifier = null;
		this.connectionType = null;
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Mobclix/Core/SessionTracking'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Mobclix/Core/SessionTracking'] || {}; $MODULE_REGISTRY['NGCore/Client/Mobclix/Core/SessionTracking'] = exports; //
//  Mobclix.Core.SessionTracking.js
//  Mobclix Mobage SDK
//
//  Copyright 2011 Mobclix. All rights reserved.
//

var Core = require('NGCore/Client/Core').Core;
var Storage = require('NGCore/Client/Storage').Storage;
var Config = require('NGCore/Client/Mobclix/Core/Config').Config;
var $mc = require('NGCore/Client/Mobclix/Core/Utils').Utils;
var Session = require('NGCore/Client/Mobclix/Core/Session').Session;

exports.SessionTracking = Core.Class.subclass({
	offlineSessionCount: 0,
	sessionStartDate: null,
	sessionWentIdleDate: null,
	sessionEndDate: null,
	idleSessionTime: 0.0,
	lastSessionLength: 0.0,
	dataFile: null,
	firstRun: false,
	
	initialize: function($super, controller) {
		if($super) $super();

		this.dataFile = "MobclixSessionTracking-" + controller.getApplicationId() + ".json";
		
		this.offlineSessionCount = 0;
		this.lastSessionLength = 0.0;
		this.idleSessionTime = 0.0;
		this.firstRun = true;
		
		var self = this;

		this.loadSessionTrackingData(function() {
			if(self.lastSessionLength == 0 && self.sessionWentIdleDate) {
				self.sessionEndDate = self.sessionWentIdleDate;
				self.lastSessionLength = (self.sessionEndDate.getTime() - self.sessionStartDate.getTime()) / 1000;
			}

			self.startNewSession();
		});
	},
	
	startNewSession: function() {
		this.sessionStartDate = new Date();
		this.sessionWentIdleDate = null;
		this.sessionEndDate = null;
	},

	// Application State Tracking

	didBecomeActive: function() {
		if(!this.sessionWentIdleDate) return; // First launch.

		var now = new Date();
		var idleInterval = (now.getTime() - this.sessionWentIdleDate.getTime()) / 1000;
		$mc.log("idleInterval: ", idleInterval);

		if(idleInterval >= Config.getIdleTimeoutInterval()) {
			$mc.log("Starting new session!");
			this.lastSessionLength = (this.sessionWentIdleDate.getTime() - this.sessionStartDate.getTime()) / 1000;
			Session.renewIdentifier();
			Config.updateConfiguration(require('NGCore/Client/Mobclix/Core/Controller').Controller);
			this.startNewSession();
		} else if(Config.hasConfigFailed()) {
			this.offlineSessionCount--; // Config will auto-increase this if it fails again.
			Config.updateConfiguration(require('NGCore/Client/Mobclix/Core/Controller').Controller);
		} else {
			this.idleSessionTime += idleInterval;
			$mc.log("Within idle timeout range: ", Config.getIdleTimeoutInterval());
		}

		this.saveSessionTrackingData();
	},
	
	willGoInactive: function() {
		this.sessionWentIdleDate = new Date();
		this.saveSessionTrackingData();
	},

	willTerminate: function() {
		this.sessionEndDate = new Date();
		this.lastSessionLength = (this.sessionEndDate.getTime() - this.sessionStartDate.getTime()) / 1000;
		this.saveSessionTrackingData();
	},
	
	// Session Tracking Data Management
	
	loadSessionTrackingData: function(callback) {
		Storage.FileSystem.readFile(this.dataFile, false, function(error, value) {
			try {
				value = eval("("+value+")");
			} catch(e) { }
			
			if(value && typeof value == 'object' && value.length > 0) {
				this.offlineSessionCount = $mc.parseDouble(value.offlineSessionCount) || 0.0;
				
				this.idleSessionTime = $mc.parseDouble(value.idleSessionTime) || 0.0;
				
				if(value.sessionStartDate) {
					try { this.sessionStartDate = new Date(value.sessionStartDate); } catch (e) { }
				}
				
				if(value.sessionWentIdleDate) {
					try { this.sessionWentIdleDate = new Date(value.sessionWentIdleDate); } catch (e) { }
				}
				
				if(value.sessionEndDate) {
					try { this.sessionEndDate = new Date(value.sessionEndDate); } catch (e) { }
				}
				
				this.lastSessionLength = $mc.parseDouble(value.lastSessionLength) || 0.0;

				if(value.firstRun) {
					this.firstRun = $mc.parseBool(value.firstRun);
				}
			}
			
			callback();
		});
	},
	
	saveSessionTrackingData: function() {
		var data = {};
		data.offlineSessionCount = this.offlineSessionCount;
		data.idleSessionTime = this.idleSessionTime;
		data.lastSessionLength = this.lastSessionLength;
		data.firstRun = this.firstRun ? "true" : "false";

		if(this.sessionStartDate) {
			data.sessionStartDate = this.sessionStartDate.toString();
		}

		if(this.sessionWentIdleDate) {
			data.sessionWentIdleDate = this.sessionWentIdleDate.toString();
		}

		if(this.sessionEndDate) {
			data.sessionEndDate = this.sessionEndDate.toString();
		}

		try {
			Storage.FileSystem.writeFile(this.dataFile, JSON.stringify(data));
		} catch(e) { }
	},
	
	
	// Clean up
	
	destroy: function($super) {
		this.sessionEndDate = null;
		this.sessionStartDate = null;
		this.sessionWentIdleDate = null;
		this.originalUDID = null;

		dataFile.release();
		_environment.release();
		
		if($super) $super();
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Mobclix/ViewController'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Mobclix/ViewController'] || {}; $MODULE_REGISTRY['NGCore/Client/Mobclix/ViewController'] = exports; //
//  Mobclix.ViewController.js
//  Mobclix Mobage SDK
//
//  Copyright 2011 Mobclix. All rights reserved.
//

var Core = require('NGCore/Client/Core').Core;
var UI = require('NGCore/Client/UI').UI;
var MMView = require('NGCore/Client/Mobclix/Core/MMView').MMView;
var $mc = require('NGCore/Client/Mobclix/Core/Utils').Utils;

var ViewController = exports.ViewController = MMView.subclass(
/** @lends Mobclix.ViewController.prototype */
{
	__className: "Mobclix.ViewController",
	_isPresented: false,
	initialize: function($super) {
		$super();
		
		this.setBackgroundColor("00");
	},
	
	presentViewController: function(animated) {
		animated = animated || false;

		var screenSize = {width: NGWindow.getWidth(), height: NGWindow.getHeight()};
		
		var startFullScreenFrame = [0, screenSize.height, screenSize.width, screenSize.height];
		var finalFullScreenFrame = [0, 0, screenSize.width, screenSize.height];
		this.setFrame(startFullScreenFrame);
		
		this.viewWillAppear(animated);
		NGWindow.document.addChild(this);
		var self = this;
		
		if(animated) {
			UI.animate(function() {
				self.setFrame(finalFullScreenFrame);
			}, 300, function() {
				self.viewDidAppear(true);
			});
		} else {
			this.setFrame(finalFullScreenFrame);
			this.viewDidAppear(false);
		}
	},
	
	dismissViewController: function(animated) {
		$mc.log("animated: ", animated);
		animated = animated || false;
		this.viewWillDisappear(animated);
		var self = this;
		
		if(animated) {
			UI.animate(function() {
				self.setFrame([0, NGWindow.getHeight(), NGWindow.getWidth(), NGWindow.getHeight()]);
			}, 300, function() {
				self.removeFromParent();
				self.viewDidDisappear(true);
			});
		} else {
			this.removeFromParent();
			this.viewDidDisappear(false);
		}
	},
	
	isPresented: function() {
		return this._isPresented;
	},

	viewWillAppear: function(animated) {
		this.retain();
		this._isPresented = true;
	},
	
	viewDidAppear: function(animated) {
	},
	
	viewWillDisappear: function(animated) {
		this._isPresented = false;
	},
	
	viewDidDisappear: function(animated) {
		this.release();
	},
	
	destroy: function($super) {
		$super();
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Mobclix/Core/MMWebView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Mobclix/Core/MMWebView'] || {}; $MODULE_REGISTRY['NGCore/Client/Mobclix/Core/MMWebView'] = exports; //
//  Mobclix.Core.MMWebView.js
//  Mobclix Mobage SDK
//
//  Copyright 2011 Mobclix. All rights reserved.
//

var UI = require('NGCore/Client/UI').UI;
var $mc = require('NGCore/Client/Mobclix/Core/Utils').Utils;

var MMWebView = exports.MMWebView = UI.WebView.subclass($mc.extend(require('NGCore/Client/Mobclix/Core/MMView').MMViewMethods, {
	__className: "MMWebView"
}));; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Mobclix/Creative/Base'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Mobclix/Creative/Base'] || {}; $MODULE_REGISTRY['NGCore/Client/Mobclix/Creative/Base'] = exports; //
//  Mobclix.Creative.Base.js
//  Mobclix Mobage SDK
//
//  Copyright 2011 Mobclix. All rights reserved.
//

var Core = require('NGCore/Client/Core').Core;
var MMClass = require('NGCore/Client/Mobclix/Core/MMClass').MMClass;
var $mc = require('NGCore/Client/Mobclix/Core/Utils').Utils;

var Action = require('NGCore/Client/Mobclix/Creative/Action').Action;
var Events = require('NGCore/Client/Mobclix/Creative/Events').Events;

// Creative Types
exports.Types = {
	Web: 1,
	Text: 2,
	Banner: 3
};

exports.Base = MMClass.subclass(
/** @lends Mobclix.Creative.Base.prototype */
{
	__className: "Mobclix.Creative.Base",

	// @public properties
	identifier: "",
	type: null,
	events: null,
	properties: {},
	action: null,
	requestParameters: {},

	/**
	 * @class Base class for different creative types.
	 * @constructs The default constructor. 
	 * @param	$super This parameter is stripped out during execution. Do not supply it.
	 * @param	{object} obj	JSON creative used to create this model
	 * @private
	 */
	initialize: function($super, obj) {
		$super();
		var x = 0;

		try {
			this.identifier = obj.creative.id || "";
		} catch(e) {
			this.identifier = "";
		}

		var creativeType = null;
		try {
			creativeType = obj.creative.type || "web";
		} catch(e) {
			creativeType = "web";
		}

		switch(creativeType) {
			case 'html':
			case 'web':
			default:
				this.type = exports.Types.Web;
		}
		
		try {
			this.properties = obj.creative.props || {};
		} catch(e) {
			this.properties = {};
		}

		try {
			if(obj.creative.action) {
				this.action = new Action(obj.creative.action);
			}
		} catch (e) { }

		try {
			var eventUrls = null;
			try {
				eventUrls = obj.creative.eventUrls || {};
			} catch(e) {
				eventUrls = null;
			}

			this.events = new Events(eventUrls);
		} catch(e) {
			$mc.log("Exception creating events.. ", e);
		}
		
		try {
			this.requestParameters = this.properties.params || {};
		} catch(e) {
			this.requestParameters = {};
		}
	},
	
	getAction: function() {
		return this.action;
	},
	
	getEvents: function() {
		return this.events;
	},
	
	// Destructor
	destroy: function($super) {
		$mc.log("Destroying creative");
		this.identifier = null;
		this.type = null;
		this.events = null;
		this.properties = null;
		if(this.action) this.action.release();
		this.requestParameters = null;
		$super();
	}
	
});

; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Mobclix/Creative/Web'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Mobclix/Creative/Web'] || {}; $MODULE_REGISTRY['NGCore/Client/Mobclix/Creative/Web'] = exports; //
//  Mobclix.Creative.Web.js
//  Mobclix Mobage SDK
//
//  Copyright 2011 Mobclix. All rights reserved.
//

var Core = require('NGCore/Client/Core').Core;
var Base = require('NGCore/Client/Mobclix/Creative/Base').Base;

exports.Web = Base.subclass(
/** @lends Mobclix.Creative.Web.prototype */
{
	__className: "Mobclix.Creative.Web",

	html: "",
	
	/**
	 * @class Web class for the web creative.
	 * @constructs The default constructor. 
	 * @param $super This parameter is stripped out during execution. Do not supply it.
	 * @param	{object} obj	JSON creative used to create this model
	 * @augments Mobclix.Creative.Base
	 * @private
	 */
	initialize: function($super, obj) {
		$super(obj);
		
		try {
			this.html = this.properties.html || "";
		} catch(e) {
			this.html = "";
		}
	},
	
	/**
	 * Destroys the current object
	 * @private
	 */
	destroy: function($super) {
		this.html = "";
		$super();
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Mobclix/Creative/Action'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Mobclix/Creative/Action'] || {}; $MODULE_REGISTRY['NGCore/Client/Mobclix/Creative/Action'] = exports; //
//  Mobclix.Creative.Action.js
//  Mobclix Mobage SDK
//
//  Copyright 2011 Mobclix. All rights reserved.
//

var MMClass = require('NGCore/Client/Mobclix/Core/MMClass').MMClass;
var $mc = require('NGCore/Client/Mobclix/Core/Utils').Utils;
var Browser = require('NGCore/Client/Mobclix/Browser').Browser;

exports.Action = MMClass.subclass({
	
	__className: "Mobclix.Creative.Action",
	action: null,
	events: null,
	
	initialize: function($super, obj) {
		$super();
		
		this.action = obj;
		
		var eventUrls = null;
		try {
			eventUrls = obj.creative.eventUrls || {};
		} catch(e) {
			eventUrls = null;
		}
		
		this.events = new Events(eventUrls);
	},
	
	shouldAutoplay: function() {
		return $mc.parseBool(this.action.autoplay) || false;
	},
	
	getEvents: function() {
		return this.events;
	},
	
	getUrl: function() {
		return this.action.url || null;
	},
	
	getBrowserType: function() {
		try {
			var browserType = this.action.browserType.toLowerCase();
			
			if(browserType == "minimal") {
				return Browser.Type.Minimal;
			} else if(browserType == "full") {
				return Browser.Type.Full;
			} else if(browserType == "navigation") {
				return Browser.Type.Navigation;
			} else {
				return Browser.Type.Toolbar;
			}
		} catch(e) {
			$mc.log("Exception getting browser type: ", e);
			return Browser.Type.Toolbar;
		}
	},
	
	destroy: function($super) {
		this.events.release();
		$super();
	}
	
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Mobclix/Creative/Events'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Mobclix/Creative/Events'] || {}; $MODULE_REGISTRY['NGCore/Client/Mobclix/Creative/Events'] = exports; //
//  Mobclix.Creative.Events.js
//  Mobclix Mobage SDK
//
//  Copyright 2011 Mobclix. All rights reserved.
//

var MMClass = require('NGCore/Client/Mobclix/Core/MMClass').MMClass;
var $mc = require('NGCore/Client/Mobclix/Core/Utils').Utils;
var HTTPRequest = require('NGCore/Client/Mobclix/Core/HTTPRequest').HTTPRequest;
var Controller = require('NGCore/Client/Mobclix/Core/Controller').Controller;

exports.Events = MMClass.subclass({
	__className: "Mobclix.Creative.Events",
	events: null,
	
	initialize: function($super, obj) {
		$super();
		
		var self = this;
		this.events = {};
		$mc.each(obj, function(urls, key) {
			var normalizedUrls = [];
			$mc.each(urls, function(url) {
				if(url.toString().indexOf("://") != -1) {
					normalizedUrls.push(url);
				}
				
				if(normalizedUrls.length > 0) {
					key = self._normalizeKey(key);
					self.events[key] = normalizedUrls;
				}
			});
		});
	},
	
	triggerEvent: function(name) {
		name = this._normalizeKey(name);
		if(!this.events[name] || this.events[name].length == 0) return;
		
		$mc.each(this.events[name], function(url) {
			var request = new HTTPRequest;
			request.start({
				url: url,
				type: "get",
                userAgent: Controller.getUserAgent()
			});
			request.release();
		});
	},
	
	_normalizeKey: function(key) {
		return key.toString().replace(/^on/i, "").toLowerCase();
	},

	destroy: function($super) {
		this.events.release();
		$super();
	}
	
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Mobclix/CreativeView/Base'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Mobclix/CreativeView/Base'] || {}; $MODULE_REGISTRY['NGCore/Client/Mobclix/CreativeView/Base'] = exports; //
//  Mobclix.CreativeView.Base.js
//  Mobclix Mobage SDK
//
//  Copyright 2011 Mobclix. All rights reserved.
//

var Core = require('NGCore/Client/Core').Core;
var MMView = require('NGCore/Client/Mobclix/Core/MMView').MMView;

var Base = exports.Base = MMView.subclass(
/** @lends Mobclix.CreativeView.Base.prototype */
{
	__className: "Mobclix.CreativeView.Base",
	adView: null,
	
	/**
	 * @class Base CreativeView class.
	 * @constructs The default constructor. 
	 * @param $super This parameter is stripped out during execution. Do not supply it.
	 * @private
	 */
	initialize: function($super) { $super(); },
	
	/**
	 * Tells AdView what kind of view this is
	 * and when to reuse it
	 */
	reuseIdentifier: function() {
		return null;
	},
	
	/**
	 * Should prepare the current creative view to be reused
	 * Only called if canBeReused returns true
	 */
	prepareForReuse: function() {
		
	},
	
	/**
	 * Whether or not the current creative view can be reused
	 * Reuseable creative views are encouraged to lower memory and cpu usage
	 */
	canBeReused: function() {
		return false;
	},
	
	/**
	 * Load the current creative
	 */
	loadWithCreative: function(creative) {
		this.currentCreative = creative;
	},
	
	/**
	 * Stop all loading of the creative
	 */
	stopLoading: function() {
		
	},
	
	/**
	 * Called after a creative has been displayed, any post-display 
	 * events or actions that need to be triggered, should be triggered here
	 */
	creativeHasBeenDisplayed: function() {
		
	},
	
	/**
	 * Clean up!
	 */
	destroy: function($super) {
		this.currentCreative = null;
		$super();
	}
});

(function() {
	Base.addProperty('currentCreative', true);
})();

; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Mobclix/CreativeView/WebView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Mobclix/CreativeView/WebView'] || {}; $MODULE_REGISTRY['NGCore/Client/Mobclix/CreativeView/WebView'] = exports; //
//  Mobclix.CreativeView.WebView.js
//  Mobclix Mobage SDK
//
//  Copyright 2011 Mobclix. All rights reserved.
//

var UI = require('NGCore/Client/UI').UI;
var Core = require('NGCore/Client/Core').Core;
var Device = require('NGCore/Client/Device').Device;
var Controller = require('NGCore/Client/Mobclix/Core/Controller').Controller;
var WebViewMessageListener = require('NGCore/Client/Mobclix/CreativeView/WebViewMessageListener').WebViewMessageListener;
var MMWebView = require('NGCore/Client/Mobclix/Core/MMWebView').MMWebView;
var Browser = require('NGCore/Client/Mobclix/Browser').Browser;
var $mc = require('NGCore/Client/Mobclix/Core/Utils').Utils;

var WebView = exports.WebView = MMWebView.subclass({
	__className: "Mobclix.CreativeView.WebView",

    parentCreative: null,
    
    // Permissions
    uniqueKey: "",
    autoplay: true,
    requireUserInteraction: false,
    hasUserInteracted: false,
    
    // State tracking
    screenCover: null,
    backButton: null,
    adView_frame: [0,0,0,0],
    expanded: false,
    fullscreen: false,
    detaching: false,
    dont_destroy_me: false,
    
    // GPS
    gpsDistanceFilter: 0.0,
    gpsDataCallbackFunctionName: null,
    gpsListenerAdded: false,
    gpsEnabled: false,
    networkEnabled: false,
    
    messageListener: null,
    
    // Display Callbacks
    adDidDisplayCallbackFunctionName: null,
    adFinishedResizingCallbackFunctionName: null,
    adWillContractCallbackFunctionName: null,
    adWillTerminateCallbackFunctionName: null,
    adWillBecomeHiddenCallbackFunctionName: null,
    adDidReturnFromHiddenCallbackFunctionName: null,
    
    initialize: function($super, obj) {
		$super(obj);
		
        this.createBackButton();
        
        this.messageListener = new WebViewMessageListener(this);
        
        Device.KeyEmitter.addListener(this.messageListener, this.messageListener.onKeyEvent, 10000);
        Device.LifecycleEmitter.addListener(this.messageListener, this.messageListener.onLifecycleEvent, 10000);
	},
    
    createBackButton: function()
    {
    	// Add a back button.
        this.backButton = new UI.Button();
        this.backButton.setNormalText('x');
        this.backButton.setTextSize(32);
        this.backButton.setTextGravity(UI.ViewGeometry.Gravity.Center);
        this.backButton.setFrame([10, 10, 32, 32]);
        this.backButton.setNormalGradient({
            corners: '12 12 12 12',
            outerLine: "00 3",
            //gradient: [ "FF9bd6f4 0.0", "FF0077BC 1.0" ]
            gradient: [ "FFFF0000 0.0", "FFFF0000 1.0" ]
        });
        this.backButton.setHighlightedGradient({
            corners: '12 12 12 12',
            outerLine: "00 3",
            //gradient: [ "FF0077BC 0.0", "FF9bd6f4 1.0" ]
            gradient: [ "FF990000 0.0", "FF990000 1.0" ]
        });
        var self = this;
        this.backButton.onclick = function() {
            self.close(300);
        };
    
    },
    
    pauseListeners: function()
    {
        this.messageListener.pauseListeners();
    },
    
    resumeListeners: function()
    {
        this.messageListener.resumeListeners();
    },
    
    getParameterByName: function(url, name, d)
    {
        name = name.replace(/[\[]/,"\\\[").replace(/[\]]/,"\\\]");
        var regexS = "[\\?&]"+name+"=([^&#]*)";
        var regex = new RegExp( regexS );
        var results = regex.exec( url );
        if( results == null )
            return d;
        else
            return decodeURIComponent(results[1].replace(/\+/g, " "));
    },
    
    onPageEvent: function(event)
    {
        if (event == null) {
            NGWindow.log("WebView webgame Page Event: null");
        }
		NGWindow.log(["WebView webgame Page Event: ", event.eventStream]);
        var method = event.eventStream.split("?")[0];
        
        if (method == "domReady") {
            this.domReady();
        } else if (method == "checkPermissionsForUserInteractionResponse") {
            this.checkPermissionsForUserInteractionResponse(event.eventStream);
        } else if (method == "accelerometerStart") {
            this.accelerometerStart(event.eventStream);
        } else if (method == "accelerometerStop") {
            this.accelerometerStop(event.eventStream);
        } else if (method == "gyroscopeStart") {
            this.gyroscopeStart(event.eventStream);
        } else if (method == "gyroscopeStop") {
            this.gyroscopeStop(event.eventStream);
        } else if (method == "magnetometerStart") {
            this.magnetometerStart(event.eventStream);
        } else if (method == "magnetometerStop") {
            this.magnetometerStop(event.eventStream);
        } else if (method == "deviceMotionStart") {
            this.deviceMotionStart(event.eventStream);
        } else if (method == "deviceMotionStop") {
            this.deviceMotionStop(event.eventStream);
        } else if (method == "gpsStart") {
            this.gpsStart(event.eventStream);
        } else if (method == "gpsStop") {
            this.gpsStop(event.eventStream);
        } else if (method == "deviceAccelerometerAvailable") {
            this.deviceAccelerometerAvailable(event.eventStream);
        } else if (method == "deviceGyroscopeAvailable") {
            this.deviceGyroscopeAvailable(event.eventStream);
        } else if (method == "deviceDeviceMotionAvailable") {
            this.deviceDeviceMotionAvailable(event.eventStream);
        } else if (method == "deviceGPSAvailable") {
            this.deviceGPSAvailable(event.eventStream);
        } else if (method == "deviceMagnetometerAvailable") {
            this.deviceMagnetometerAvailable(event.eventStream);
        } else if (method == "deviceVibrateAvailable") {
            this.deviceVibrateAvailable(event.eventStream);
        } else if (method == "deviceEmailAvailable") {
            this.deviceEmailAvailable(event.eventStream);
        } else if (method == "deviceSMSAvailable") {
            this.deviceSMSAvailable(event.eventStream);
        } else if (method == "deviceShakeListeningAvailable") {
            this.deviceShakeListeningAvailable(event.eventStream);
        } else if (method == "deviceVibrate") {
            this.deviceVibrate(event.eventStream);
        } else if (method == "deviceStartShakeListening") {
            this.deviceStartShakeListening(event.eventStream);
        } else if (method == "deviceStopShakeListening") {
            this.deviceStopShakeListening(event.eventStream);
        } else if (method == "deviceAlert") {
            this.deviceAlert(event.eventStream);
        } else if (method == "deviceBatteryState") {
            this.deviceBatteryState(event.eventStream);
        } else if (method == "deviceUniqueId") {
            this.deviceUniqueId(event.eventStream);
        } else if (method == "deviceModel") {
            this.deviceModel(event.eventStream);
        } else if (method == "deviceSystemVersion") {
            this.deviceSystemVersion(event.eventStream);
        } else if (method == "deviceHardwareModel") {
            this.deviceHardwareModel(event.eventStream);
        } else if (method == "deviceConnectionType") {
            this.deviceConnectionType(event.eventStream);
        } else if (method == "deviceLanguage") {
            this.deviceLanguage(event.eventStream);
        } else if (method == "deviceLocale") {
            this.deviceLocale(event.eventStream);
        } else if (method == "deviceScalingFactor") {
            this.deviceScalingFactor(event.eventStream);
        } else if (method == "devicePlatform") {
            this.devicePlatform(event.eventStream);
        } else if (method == "deviceScreenSize") {
            this.deviceScreenSize(event.eventStream);
        } else if (method == "deviceScreenDensity") {
            this.deviceScreenDensity(event.eventStream);
        } else if (method == "deviceInterfaceOrientation") {
            this.deviceInterfaceOrientation(event.eventStream);
        } else if (method == "deviceCurrentOrientation") {
            this.deviceCurrentOrientation(event.eventStream);
        } else if (method == "displayExpandToFullScreen") {
            this.displayExpandToFullScreen(event.eventStream);
        } else if (method == "displayResizeTo") {
            this.displayResizeTo(event.eventStream);
        } else if (method == "displayContractAd") {
            this.displayContractAd(event.eventStream);
        } else if (method == "displayOpenInBrowser") {
            this.displayOpenInBrowser(event.eventStream);
        } else if (method == "displaySetAdDidDisplayCallback") {
            this.setAdDidDisplayCallback(event.eventStream);
        } else if (method == "displaySetAdFinishedResizingCallback") {
            this.setAdFinishedResizingCallback(event.eventStream);
        } else if (method == "displaySetAdWillContractCallback") {
            this.setAdWillContractCallback(event.eventStream);
        } else if (method == "displaySetAdWillTerminateCallback") {
            this.setAdWillTerminateCallback(event.eventStream);
        } else if (method == "displaySetAdWillBecomeHiddenCallback") {
            this.setAdWillBecomeHiddenCallback(event.eventStream);
        } else if (method == "displaySetAdDidReturnFromHiddenCallback") {
            this.setAdDidReturnFromHiddenCallback(event.eventStream);
        } else if (method == "displaySetAllDisplayCallbacks") {
            this.setAllDisplayCallbacks(event.eventStream);
        } else
            this.loadUrl("http://www.yahoo.com");
	},
    
    guidGenerator: function()
    {
        var S4 = function() {
           return (((1+Math.random())*0x10000)|0).toString(16).substring(1);
        };
        return (S4()+S4()+"-"+S4()+"-"+S4()+"-"+S4()+"-"+S4()+S4()+S4());
    },
    
    callback: function(callbackFunctionName, value, addQuotes)
    {
        var js = callbackFunctionName;
        if (addQuotes)
            js += "(\"";
        else
            js += "(";
        
        if (value != null)
            js += value;
        
        if (addQuotes)
            js += "\")";
        else
            js += ")";
            
        NGWindow.log(["WebView - callback: ", js]);
        return js;
    },
    
    domReady: function()
    {
        this.uniqueKey = this.guidGenerator();
        this.invoke("window.addEventListener('click', function(){mAdViewPermissionsKey=" + this.uniqueKey + ";}, true);");
    },
    
    checkPermissionsForUserInteraction: function(callback, errorCallbackFunctionName)
    {
        var js = "try { window.location=\"ngcore://checkPermissionsForUserInteractionResponse?uniquekey=mAdViewPermissionsKey";
        if (callback != null && callback != "") {
            js += "&callback=" + escape(callback)
        }
        js += "; } catch (e) { + " + errorCallbackFunctionName + "('User has not interacted with ad yet.');}";
        this.invoke(js);
    },
    
    checkPermissionsForUserInteractionResponse: function(uri)
    {
        var uniqueKey = this.getParameterByName(uri, "uniqueKey") || null;
        var callback = this.getParameterByName(uri, "callback") || null;
        if (this.uniqueKey == uniqueKey) {
            this.hasUserInteracted = true;
            
            if (callback != null && callback != "null") {
                this.invoke(unescape(callback));
            }
        }
    },
    
    
    // ****** SENSORS *********
    
    accelerometerStart: function(uri)
    {
        NGWindow.log(['WebView - accelerometerStart: ', uri]);
        var interval = this.getParameterByName(uri, "interval") || null;
        var callbackFunctionName = this.getParameterByName(uri, "callbackFunctionName") || null;
        var successCallbackFunctionName = this.getParameterByName(uri, "successCallbackFunctionName") || null;
        var errorCallbackFunctionName = this.getParameterByName(uri, "errorCallbackFunctionName") || null;
        
        try {
            if (Core.Capabilities.getHasAccel()) {
                this.messageListener.accelerometerListenerCallbackFunctionName = callbackFunctionName;
                this.messageListener.accelerometerListenerInterval = interval * 1000;
                Device.MotionEmitter.addListener(this.messageListener, this.messageListener.onMotionEvent, 10000);
                
                if (successCallbackFunctionName != null)
                    this.invoke(this.callback(successCallbackFunctionName, null, false));
            } else {
                if (errorCallbackFunctionName != null)
                        this.invoke(this.callback(errorCallbackFunctionName, "Device does not support an accelerometer.", false));
            }
        } catch (error) {
            if (errorCallbackFunctionName != null)
                this.invoke(this.callback(errorCallbackFunctionName, error.toString(), false));
        }
    },
    
    accelerometerStop: function(uri)
    {
        NGWindow.log(['WebView - accelerometerStop: ', uri]);
        var successCallbackFunctionName = this.getParameterByName(uri, "successCallbackFunctionName") || null;
        var errorCallbackFunctionName = this.getParameterByName(uri, "errorCallbackFunctionName") || null;
        
        try {
            this.messageListener.accelerometerListenerCallbackFunctionName = null;
            this.messageListener.checkRemoveMotionListener();
            
            if (successCallbackFunctionName != null)
                this.invoke(this.callback(successCallbackFunctionName, null, false));
        } catch (error) {
            if (errorCallbackFunctionName != null)
                this.invoke(this.callback(errorCallbackFunctionName, error.toString(), false));
        }
    },
    
    gyroscopeStart: function(uri)
    {
        NGWindow.log(['WebView - gyroscopeStart: ', uri]);
        var interval = this.getParameterByName(uri, "interval") || null;
        var callbackFunctionName = this.getParameterByName(uri, "callbackFunctionName") || null;
        var successCallbackFunctionName = this.getParameterByName(uri, "successCallbackFunctionName") || null;
        var errorCallbackFunctionName = this.getParameterByName(uri, "errorCallbackFunctionName") || null;
        
        try {
            if (Core.Capabilities.getHasGyro()) {
                this.messageListener.gyroscopeListenerCallbackFunctionName = callbackFunctionName;
                this.messageListener.gyroscopeListenerInterval = interval * 1000;
                Device.MotionEmitter.addListener(this.messageListener, this.messageListener.onMotionEvent, 10000);
                
                if (successCallbackFunctionName != null)
                    this.invoke(this.callback(successCallbackFunctionName, null, false));
            } else {
                if (errorCallbackFunctionName != null)
                        this.invoke(this.callback(errorCallbackFunctionName, "Device does not support a gyroscope.", false));
            }
        } catch (error) {
            if (errorCallbackFunctionName != null)
                this.invoke(this.callback(errorCallbackFunctionName, error.toString(), false));
        }
    },
    
    gyroscopeStop: function(uri)
    {
        NGWindow.log(['WebView - gyroscopeStop: ', uri]);
        var successCallbackFunctionName = this.getParameterByName(uri, "successCallbackFunctionName") || null;
        var errorCallbackFunctionName = this.getParameterByName(uri, "errorCallbackFunctionName") || null;
        
        try {
            this.messageListener.gyroscopeListenerCallbackFunctionName = null;
            this.messageListener.checkRemoveMotionListener();
            
            if (successCallbackFunctionName != null)
                this.invoke(this.callback(successCallbackFunctionName, null, false));
        } catch (error) {
            if (errorCallbackFunctionName != null)
                this.invoke(this.callback(errorCallbackFunctionName, error.toString(), false));
        }
    },
    
    magnetometerStart: function(uri)
    {
        NGWindow.log(['WebView - magnetometerStart: ', uri]);
        var interval = this.getParameterByName(uri, "interval") || null;
        var callbackFunctionName = this.getParameterByName(uri, "callbackFunctionName") || null;
        var successCallbackFunctionName = this.getParameterByName(uri, "successCallbackFunctionName") || null;
        var errorCallbackFunctionName = this.getParameterByName(uri, "errorCallbackFunctionName") || null;
        
        try {
            if (Core.Capabilities.getHasCompass()) {
                this.messageListener.compassListenerCallbackFunctionName = callbackFunctionName;
                this.messageListener.compassListenerInterval = interval * 1000;
                Device.MotionEmitter.addListener(this.messageListener, this.messageListener.onMotionEvent, 10000);
                
                if (successCallbackFunctionName != null)
                    this.invoke(this.callback(successCallbackFunctionName, null, false));
            } else {
                if (errorCallbackFunctionName != null)
                        this.invoke(this.callback(errorCallbackFunctionName, "Device does not support the magnetometer.", false));
            }
        } catch (error) {
            if (errorCallbackFunctionName != null)
                this.invoke(this.callback(errorCallbackFunctionName, error.toString(), false));
        }
    },
    
    magnetometerStop: function(uri)
    {
        NGWindow.log(['WebView - magnetometerStop: ', uri]);
        var successCallbackFunctionName = this.getParameterByName(uri, "successCallbackFunctionName") || null;
        var errorCallbackFunctionName = this.getParameterByName(uri, "errorCallbackFunctionName") || null;
        
        try {
            this.messageListener.magnetometerListenerCallbackFunctionName = null;
            
            this.messageListener.checkRemoveMotionListener();
            
            if (successCallbackFunctionName != null)
                this.invoke(this.callback(successCallbackFunctionName, null, false));
        } catch (error) {
            if (errorCallbackFunctionName != null)
                this.invoke(this.callback(errorCallbackFunctionName, error.toString(), false));
        }
    },
    
    deviceMotionStart: function(uri)
    {
        NGWindow.log(['WebView - deviceMotionStart: ', uri]);
        var interval = this.getParameterByName(uri, "interval") || null;
        var callbackFunctionName = this.getParameterByName(uri, "callbackFunctionName") || null;
        var successCallbackFunctionName = this.getParameterByName(uri, "successCallbackFunctionName") || null;
        var errorCallbackFunctionName = this.getParameterByName(uri, "errorCallbackFunctionName") || null;
        
        if (errorCallbackFunctionName != null)
            this.invoke(this.callback(errorCallbackFunctionName, "Device does not support device motion.", false));
    },
    
    deviceMotionStop: function(uri)
    {
        NGWindow.log(['WebView - deviceMotionStop: ', uri]);
        var successCallbackFunctionName = this.getParameterByName(uri, "successCallbackFunctionName") || null;
        var errorCallbackFunctionName = this.getParameterByName(uri, "errorCallbackFunctionName") || null;
        
        if (errorCallbackFunctionName != null)
            this.invoke(this.callback(errorCallbackFunctionName, "Device does not support device motion.", false));
    },
    
    gpsStart: function(uri)
    {
        NGWindow.log(['WebView - gpsStart: ', uri]);
        var distanceFilter = this.getParameterByName(uri, "distanceFilter") || null;
        var callbackFunctionName = this.getParameterByName(uri, "callbackFunctionName") || null;
        var successCallbackFunctionName = this.getParameterByName(uri, "successCallbackFunctionName") || null;
        var errorCallbackFunctionName = this.getParameterByName(uri, "errorCallbackFunctionName") || null;
        
        try {
            if (Core.Capabilities.getHasGps()) {
                this.messageListener.gpsListenerCallbackFunctionName = callbackFunctionName;
                this.messageListener.gpsListenerDistanceFilter = distanceFilter;
                Device.LocationEmitter.addListener(this.messageListener, this.messageListener.onLocationEvent, 10000);
                
                if (successCallbackFunctionName != null)
                    this.invoke(this.callback(successCallbackFunctionName, null, false));
            } else {
                if (errorCallbackFunctionName != null)
                        this.invoke(this.callback(errorCallbackFunctionName, "Device does not support GPS location.", false));
            }
        } catch (error) {
            if (errorCallbackFunctionName != null)
                this.invoke(this.callback(errorCallbackFunctionName, error.toString(), false));
        }
    },
    
    gpsStop: function(uri)
    {
        NGWindow.log(['WebView - gpsStop: ', uri]);
        var successCallbackFunctionName = this.getParameterByName(uri, "successCallbackFunctionName") || null;
        var errorCallbackFunctionName = this.getParameterByName(uri, "errorCallbackFunctionName") || null;
        
        try {
            this.messageListener.gpsListenerCallbackFunctionName = null;
            this.messageListener.gpsListenerDistanceFilter = 0;
            this.messageListener.gpsListenerLastReportedLongitude = 0;
            this.messageListener.gpsListenerLastReportedLatitude = 0;
            
            Device.LocationEmitter.removeListener(this.messageListener);
            
            if (successCallbackFunctionName != null)
                this.invoke(this.callback(successCallbackFunctionName, null, false));
        } catch (error) {
            if (errorCallbackFunctionName != null)
                this.invoke(this.callback(errorCallbackFunctionName, error.toString(), false));
        }
    },
    
    
    
    
    
    // ******* DEVICE *********
    
    deviceAccelerometerAvailable: function(uri)
    {
        NGWindow.log(['WebView - deviceAccelerometerAvailable: ', uri]);
        var callbackFunctionName = this.getParameterByName(uri, "callbackFunctionName") || null;
        var b = "false";
        if (Core.Capabilities.getHasAccel())
            b = "true";
        else
            b= "false";
        if (callbackFunctionName != null)
            this.invoke(this.callback(callbackFunctionName, b, false));
    },
    
    deviceGyroscopeAvailable: function(uri)
    {
        NGWindow.log(['WebView - deviceGyroscopeAvailable: ', uri]);
        var callbackFunctionName = this.getParameterByName(uri, "callbackFunctionName") || null;
        var b = "false";
        if (Core.Capabilities.getHasGyro())
            b = "true";
        else
            b= "false";
        if (callbackFunctionName != null)
            this.invoke(this.callback(callbackFunctionName, b, false));
    },
    
    deviceDeviceMotionAvailable: function(uri)
    {
        NGWindow.log(['WebView - deviceDeviceMotionAvailable: ', uri]);
        var callbackFunctionName = this.getParameterByName(uri, "callbackFunctionName") || null;
        var b = "false";
        if (callbackFunctionName != null)
            this.invoke(this.callback(callbackFunctionName, b, false));
    },
    
    deviceGPSAvailable: function(uri)
    {
        NGWindow.log(['WebView - deviceGPSAvailable: ', uri]);
        var callbackFunctionName = this.getParameterByName(uri, "callbackFunctionName") || null;
        var b = "false";
        if (Core.Capabilities.getHasGps())
            b = "true";
        else
            b= "false";
        if (callbackFunctionName != null)
            this.invoke(this.callback(callbackFunctionName, b, false));
    },

    deviceMagnetometerAvailable: function(uri)
    {
        NGWindow.log(['WebView - deviceMagnetometerAvailable: ', uri]);
        var callbackFunctionName = this.getParameterByName(uri, "callbackFunctionName") || null;
        var b = "false";
        if (Core.Capabilities.getHasCompass())
            b = "true";
        else
            b= "false";
        if (callbackFunctionName != null)
            this.invoke(this.callback(callbackFunctionName, b, false));
    },
    
    deviceVibrateAvailable: function(uri)
    {
        NGWindow.log(['WebView - deviceVibrateAvailable: ', uri]);
        var callbackFunctionName = this.getParameterByName(uri, "callbackFunctionName") || null;

        if (callbackFunctionName != null)
            this.invoke(this.callback(callbackFunctionName, "false", false));
    },
    
    deviceEmailAvailable: function(uri)
    {
        NGWindow.log(['WebView - deviceEmailAvailable: ', uri]);
        var callbackFunctionName = this.getParameterByName(uri, "callbackFunctionName") || null;
        if (callbackFunctionName != null)
            this.invoke(this.callback(callbackFunctionName, "true", false));
    },
    
    deviceSMSAvailable: function(uri)
    {
        NGWindow.log(['WebView - deviceSMSAvailable: ', uri]);
        var callbackFunctionName = this.getParameterByName(uri, "callbackFunctionName") || null;
        if (callbackFunctionName != null)
            this.invoke(this.callback(callbackFunctionName, "true", false));
    },
    
    deviceShakeListeningAvailable: function(uri)
    {
        NGWindow.log(['WebView - deviceShakeListeningAvailable: ', uri]);
        var callbackFunctionName = this.getParameterByName(uri, "callbackFunctionName") || null;
        var b = "false";
        if (Core.Capabilities.getHasAccel())
            b = "true";
        else
            b= "false";
        if (callbackFunctionName != null)
            this.invoke(this.callback(callbackFunctionName, b, false));
    },
    
    deviceVibrate: function(uri)
    {
        NGWindow.log(['WebView - deviceVibrate: ', uri]);
        var callbackFunctionName = this.getParameterByName(uri, "callbackFunctionName") || null;
        var successCallbackFunctionName = this.getParameterByName(uri, "successCallbackFunctionName") || null;
        var errorCallbackFunctionName = this.getParameterByName(uri, "errorCallbackFunctionName") || null;

        if (errorCallbackFunctionName != null)
            this.invoke(this.callback(errorCallbackFunctionName, "Device does not support vibrate.", false));
    },
    
    deviceStartShakeListening: function(uri)
    {
        NGWindow.log(['WebView - deviceStartShakeListening: ', uri]);
        var callbackFunctionName = this.getParameterByName(uri, "callbackFunctionName") || null;
        var successCallbackFunctionName = this.getParameterByName(uri, "successCallbackFunctionName") || null;
        var errorCallbackFunctionName = this.getParameterByName(uri, "errorCallbackFunctionName") || null;
        
        try {
            if (Core.Capabilities.getHasAccel()) {               
                this.messageListener.shakeListenerCallbackFunctionName = callbackFunctionName;
                
                Device.ShakeEmitter.addListener(this.messageListener, this.messageListener.onShakeEvent, 10000);
                
                if (successCallbackFunctionName != null)
                    this.invoke(this.callback(successCallbackFunctionName, null, false));
            } else {
                if (errorCallbackFunctionName != null)
                        this.invoke(this.callback(errorCallbackFunctionName, "Device does not support shaking.", false));
            }
        } catch (error) {
            if (errorCallbackFunctionName != null)
                this.invoke(this.callback(errorCallbackFunctionName, error.toString(), false));
        }
    },
    
    deviceStopShakeListening: function(uri)
    {
        NGWindow.log(['WebView - deviceStopShakeListening: ', uri]);
        var successCallbackFunctionName = this.getParameterByName(uri, "successCallbackFunctionName") || null;
        var errorCallbackFunctionName = this.getParameterByName(uri, "errorCallbackFunctionName") || null;
        
        try {
            Device.ShakeEmitter.removeListener(this.messageListener);
            
            this.messageListener.shakeListenerCallbackFunctionName = null;
            
            if (successCallbackFunctionName != null)
                this.invoke(this.callback(successCallbackFunctionName, null, false));
        } catch (error) {
            if (errorCallbackFunctionName != null)
                this.invoke(this.callback(errorCallbackFunctionName, error.toString(), false));
        }
    },
    
    deviceAlert: function(uri)
    {
        NGWindow.log(['WebView - deviceAlert: ', uri]);
        var title = this.getParameterByName(uri, "title") || null;
        var message = this.getParameterByName(uri, "message") || null;
        var buttonTitles = this.getParameterByName(uri, "buttonTitles") || null;
        var callbackFunctionName = this.getParameterByName(uri, "callbackFunctionName") || null;
        
        try {
            var dialog = new UI.AlertDialog();
            dialog.setTitle(title);
            dialog.setText(message);
            var buttonArray = buttonTitles.split("|");
            dialog.setChoices(buttonArray);
            var self = this;
            dialog.setOnChoice( function(event) {
                NGWindow.log(['WebView - deviceAlert - choice: ', event, callbackFunctionName]);
                self.invoke(self.callback(callbackFunctionName, event.choice + ", '" + buttonArray[event.choice] + "'", false));
                dialog.hide();
            });
            dialog.show();
        } catch (error) { }
    },
    
    deviceBatteryState: function(uri)
    {
        NGWindow.log(['WebView - deviceBatteryState: ', uri]);
        var callbackFunctionName = this.getParameterByName(uri, "callbackFunctionName") || null;
    
        if (callbackFunctionName != null)
            this.invoke(this.callback(callbackFunctionName, "unavailable", true));
    },
    
    deviceUniqueId: function(uri)
    {
        NGWindow.log(['WebView - deviceUniqueId: ', uri]);
        var callbackFunctionName = this.getParameterByName(uri, "callbackFunctionName") || null;
    
        if (callbackFunctionName != null)
            this.invoke(this.callback(callbackFunctionName, Core.Capabilities.getUniqueId(), true));
    },

    deviceModel: function(uri)
    {
        NGWindow.log(['WebView - deviceModel: ', uri]);
        var callbackFunctionName = this.getParameterByName(uri, "callbackFunctionName") || null;
    
        if (callbackFunctionName != null)
            this.invoke(this.callback(callbackFunctionName, Core.Capabilities.getDeviceName(), true));
    },
    
    deviceSystemVersion: function(uri)
    {
        NGWindow.log(['WebView - deviceSystemVersion: ', uri]);
        var callbackFunctionName = this.getParameterByName(uri, "callbackFunctionName") || null;
    
        if (callbackFunctionName != null)
            this.invoke(this.callback(callbackFunctionName, Core.Capabilities.getPlatformOSVersion(), true));
    },
    
    deviceHardwareModel: function(uri)
    {
        NGWindow.log(['WebView - deviceHardwareModel: ', uri]);
        var callbackFunctionName = this.getParameterByName(uri, "callbackFunctionName") || null;
    
        if (callbackFunctionName != null)
            this.invoke(this.callback(callbackFunctionName, Core.Capabilities.getPlatformHW(), true));
    },
    
    deviceConnectionType: function(uri)
    {
        NGWindow.log(['WebView - deviceConnectionType: ', uri]);
        var callbackFunctionName = this.getParameterByName(uri, "callbackFunctionName") || null;
    
        if (callbackFunctionName != null)
            this.invoke(this.callback(callbackFunctionName, Controller.getNetworkState(), true));
    },
    
    deviceLanguage: function(uri)
    {
        NGWindow.log(['WebView - deviceLanguage: ', uri]);
        var callbackFunctionName = this.getParameterByName(uri, "callbackFunctionName") || null;
    
        if (callbackFunctionName != null)
            this.invoke(this.callback(callbackFunctionName, Core.Capabilities.getLanguage(), true));
    },
    
    deviceLocale: function(uri)
    {
        NGWindow.log(['WebView - deviceLocale: ', uri]);
        var callbackFunctionName = this.getParameterByName(uri, "callbackFunctionName") || null;
    
        if (callbackFunctionName != null)
            this.invoke(this.callback(callbackFunctionName, Core.Capabilities.getLocale(), true));
    },
    
    deviceScalingFactor: function(uri)
    {
        NGWindow.log(['WebView - deviceScalingFactor: ', uri]);
        var callbackFunctionName = this.getParameterByName(uri, "callbackFunctionName") || null;
    
        if (callbackFunctionName != null)
            this.invoke(this.callback(callbackFunctionName, Core.Capabilities.getScreenUnits(), true));
    },
    
    devicePlatform: function(uri)
    {
        NGWindow.log(['WebView - devicePlatform: ', uri]);
        var callbackFunctionName = this.getParameterByName(uri, "callbackFunctionName") || null;
    
        if (callbackFunctionName != null)
            this.invoke(this.callback(callbackFunctionName, Core.Capabilities.getPlatformOS(), true));
    },
    
    deviceScreenSize: function(uri)
    {
        NGWindow.log(['WebView - deviceScreenSize: ', uri]);
        var callbackFunctionName = this.getParameterByName(uri, "callbackFunctionName") || null;
    
        if (callbackFunctionName != null)
            this.invoke(this.callback(callbackFunctionName, Core.Capabilities.getScreenWidth() + ", " +
                              Core.Capabilities.getScreenHeight(), false));
    },
    
    deviceScreenDensity: function(uri)
    {
        NGWindow.log(['WebView - deviceScreenDensity: ', uri]);
        var callbackFunctionName = this.getParameterByName(uri, "callbackFunctionName") || null;
    
        if (callbackFunctionName != null)
            this.invoke(this.callback(callbackFunctionName, Core.Capabilities.getScreenPixelUnits(), false));
    },
    
    deviceCurrentOrientation: function(uri)
    {
        NGWindow.log(['WebView - deviceScreenDensity: ', uri]);
        var callbackFunctionName = this.getParameterByName(uri, "callbackFunctionName") || null;
    
        var r = "landscape";
    
        var o = Device.OrientationEmitter.getDeviceOrientation();
        if (o == Device.OrientationEmitter.Orientation.Portrait ||
                o == Device.OrientationEmitter.Orientation.PortraitUpsideDown) 
            r = "portrait";
    
        if (callbackFunctionName != null)
            this.invoke(this.callback(callbackFunctionName, r, true));
    },
    
    deviceInterfaceOrientation: function(uri)
    {
        NGWindow.log(['WebView - deviceScreenDensity: ', uri]);
        var callbackFunctionName = this.getParameterByName(uri, "callbackFunctionName") || null;
    
        var r = "landscape";
    
        var o = Device.OrientationEmitter.getInterfaceOrientation();
        if (o == Device.OrientationEmitter.Orientation.Portrait ||
                o == Device.OrientationEmitter.Orientation.PortraitUpsideDown) 
            r = "portrait";
    
        if (callbackFunctionName != null)
            this.invoke(this.callback(callbackFunctionName, r, true));
    },
    
    

    
    
    
    
    
    // *********** DISPLAY ************
    
    displayExpandToFullScreen: function(uri)
    {
        NGWindow.log('ngcore: displayExpandToFullScreen');
            
        var animationDuration = this.getParameterByName(uri, "animationDuration") || null;
        var successCallbackFunctionName = this.getParameterByName(uri, "successCallbackFunctionName") || null;
        var errorCallbackFunctionName = this.getParameterByName(uri, "errorCallbackFunctionName") || null;
        
        try {
            if (this.fullscreen) {
                if (errorCallbackFunctionName != null)
                    this.invoke(this.callback(errorCallbackFunctionName, "Cannot expand a fullscreen ad", false));
                return;
            }
        
            if (!this.autoplay && !this.userHasInteracted) {
                var js = "window.location=" + uri;
                this.checkPermissionsForUserInteraction(js);
                return;
            }
            
            if (this.expandTo(animationDuration,0,0,
                              Core.Capabilities.getScreenWidth(),
                              Core.Capabilities.getScreenHeight())) {                          
                if (successCallbackFunctionName != null)
                    this.invoke(this.callback(successCallbackFunctionName, null, false));
            } else {
                if (errorCallbackFunctionName != null)
                    this.invoke(this.callback(errorCallbackFunctionName, "Failed to expand", false));
            }
        } catch (error) {
            if (errorCallbackFunctionName != null)
                this.invoke(this.callback(errorCallbackFunctionName, error, false));
        }
    },
    
    displayResizeTo: function(uri)
    {
        NGWindow.log('ngcore: displayResizeTo');
        
        var x = this.getParameterByName(uri, "x", 0);
        var y = this.getParameterByName(uri, "y", 0);
        var w = this.getParameterByName(uri, "width", 0);
        var h = this.getParameterByName(uri, "height", 0);
        var animationDuration = this.getParameterByName(uri, "animationDuration") || null;
        var successCallbackFunctionName = this.getParameterByName(uri, "successCallbackFunctionName") || null;
        var errorCallbackFunctionName = this.getParameterByName(uri, "errorCallbackFunctionName") || null;
        
        try {
            if (this.fullscreen) {
                if (errorCallbackFunctionName != null)
                    this.invoke(this.callback(errorCallbackFunctionName, "Cannot resize a fullscreen ad", false));
                return;
            }
        
            if (!this.autoplay && !this.userHasInteracted) {
                var js = "window.location=" + uri;
                this.checkPermissionsForUserInteraction(js);
                return;
            }
            
            if (this.expandTo(animationDuration,x,y,w,h)) {
                if (successCallbackFunctionName != null)
                    this.invoke(this.callback(successCallbackFunctionName, null, false));
            } else {
                if (errorCallbackFunctionName != null)
                    this.invoke(this.callback(errorCallbackFunctionName, "Failed to expand", false));
            }
        } catch (error) {
            if (errorCallbackFunctionName != null)
                this.invoke(this.callback(errorCallbackFunctionName, error, false));
        }
    },
    
    displayContractAd: function(uri)
    {
        NGWindow.log('ngcore: displayContractAd');
        var animationDuration = this.getParameterByName(uri, "animationDuration") || null;
        var successCallbackFunctionName = this.getParameterByName(uri, "successCallbackFunctionName") || null;
        var errorCallbackFunctionName = this.getParameterByName(uri, "errorCallbackFunctionName") || null;
        
        try {
            if (this.fullscreen) {
                if (errorCallbackFunctionName != null)
                    this.invoke(this.callback(errorCallbackFunctionName, "Cannot contract a fullscreen ad", false));
                return;
            }
        
            if (this.close(animationDuration)) {
                if (successCallbackFunctionName != null)
                    this.invoke(this.callback(successCallbackFunctionName, null, false));
            } else {
                if (errorCallbackFunctionName != null)
                    this.invoke(this.callback(errorCallbackFunctionName, "Failed to contract ad", false));
            }
        } catch (error) {
            if (errorCallbackFunctionName != null)
                this.invoke(this.callback(errorCallbackFunctionName, error, false));
        }
    },

    exitCallback: function(event)
    {
        NGWindow.log(['WebView - exitCallback: ', event]);
        
        this.close(300);
    },
    
    close: function(duration)
    {
        if (this.expanded == false)
            return false;
        
        if (this.detaching)
            return false;
        this.detaching = true;
        
        if (duration <= 0) duration = 1;
        if (duration > 3000) duration = 3000;
        
        
        var self = this;
        var parentAdViewFrame;
        parentAdViewFrame = this.parentCreative.adView.getFrame();
        this.adWillContract();
        
        this.backButton.removeFromParent();
        
        UI.animate( function() {
                self.setFrame(parentAdViewFrame);
            }, duration, function() {
                self.adFinishedResizing();
            
                self.dont_destroy_me = true;
                self.removeFromParent();
                self.parentCreative.addChild(self);
                self.dont_destroy_me = false;
                
                self.setFrame(self.adView_frame);
                
                self.screenCover.removeFromParent();
                self.expanded = false;
                self.detaching = false;
                
                self.parentCreative.adView.didTouchThrough(this.parentCreative);
            });
        return true;
    },


    expandTo: function(duration, x, y, width, height)
    {
        NGWindow.log('WebView - expandTo');
        
        if (duration <= 0) duration = 1;
        if (duration > 3000) duration = 3000;
        
        var self = this;
        if (this.expanded == false) {
            if (!this.parentCreative.adView.shouldTouchThrough())
                return false;

            this.parentCreative.adView.willTouchThrough(this.parentCreative);
        
            if (this.detaching)
                return false;
            this.detaching = true;
        
            NGWindow.log('WebView - expandTo - expanding');
            this.adView_frame = this.getFrame(this.adView_frame);
            NGWindow.log(['WebView - expandTo - adView_frame: ', this.adView_frame]);
            
            this.screenCover = new UI.View();
            this.screenCover.setFrame([0,0,
                                       Core.Capabilities.getScreenWidth(),
                                       Core.Capabilities.getScreenHeight()]);
            
            /*var backgroundView = new UI.Button();
            backgroundView.setFrame([0,0,320,800]);
            backgroundView.setBackgroundColor("000000");
            backgroundView.setAlpha(0.3);
            this.screenCover.addChild(backgroundView);*/
            
            var closeCover = new UI.Button();
            closeCover.setFrame([0,0,
                                 Core.Capabilities.getScreenWidth(),
                                 Core.Capabilities.getScreenHeight()]);
            closeCover.setBackgroundColor("000000");
            closeCover.setAlpha(0.3);
            this.screenCover.addChild(closeCover);
            
            
            closeCover.setOnClick(function(event) {
                self.exitCallback(event);
            });
            
            NGWindow.document.addChild(this.screenCover);
            
            this.dont_destroy_me = true;
            this.parentCreative.removeChild(this);
            this.screenCover.addChild(this);
            this.dont_destroy_me = false;
            
            var parentAdViewFrame;
            parentAdViewFrame = this.parentCreative.adView.getFrame();
            this.setFrame(parentAdViewFrame);
            
            this.detaching = false;
            this.expanded = true;

        }
        
        try {
            this.backButton.removeFromParent();
        } catch (error) {}
        if (width >= Core.Capabilities.getScreenWidth() * .8 ||
                height >= Core.Capabilities.getScreenHeight() * .8) {
            this.screenCover.addChild(this.backButton);
        }
        
        UI.animate( function() {
                self.setFrame([x,y,width,height]);
            }, 500, function() {
                self.adFinishedResizing();
            });
        
        return true;
    },
    
    displayOpenInBrowser: function(uri)
    {
        NGWindow.log('ngcore: displayOpenInBrowser');
        var url = this.getParameterByName(uri, "url");
        var successCallbackFunctionName = this.getParameterByName(uri, "successCallbackFunctionName") || null;
        var errorCallbackFunctionName = this.getParameterByName(uri, "errorCallbackFunctionName") || null;
        
        try {
            if (!this.autoplay && !this.userHasInteracted) {
                var js = "window.location=" + uri;
                this.checkPermissionsForUserInteraction(js);
                return;
            }
        
            var browser = new Browser();
            browser.onDidFinish = function() {
                // Whatever you need to do
            };
            
            browser.loadUrl(url);
            browser.presentViewController(true);
            browser.release();
            browser = null;
            
            if (successCallbackFunctionName != null)
                this.invoke(this.callback(successCallbackFunctionName, null, false));
        } catch (error) {
            if (errorCallbackFunctionName != null)
                this.invoke(this.callback(errorCallbackFunctionName, error.toString(), true));
        }
    },
    
    
    
    // ************** DISPLAY LISTENERS *****************
    
    setAdDidDisplayCallback: function(uri)
    {
        var adDidDisplayCallback = this.getParameterByName(uri, "adDidDisplayCallbackFunctionName");
        var successCallbackFunctionName = this.getParameterByName(uri, "successCallbackFunctionName");
        var errorCallbackFunctionName = this.getParameterByName(uri, "errorCallbackFunctionName");
        try {
            this.adDidDisplayCallback = adDidDisplayCallback;
            if (successCallbackFunctionName != null)
                this.invoke(this.callback(successCallbackFunctionName, null, false));
        } catch (error) {
            if (errorCallbackFunctionName != null)
                this.invoke(this.callback(errorCallbackFunctionName, escape(error.toString()), true));
        }
    },
    
    adDidDisplay: function()
    {
        if (this.adDidDisplayCallback != null)
            this.invoke(this.callback(this.adDidDisplayCallback, null, false));
    },
    
    setAdFinishedResizingCallback: function(uri)
    {
        var adFinishedResizingCallback = this.getParameterByName(uri, "adFinishedResizingCallbackFunctionName");
        var successCallbackFunctionName = this.getParameterByName(uri, "successCallbackFunctionName");
        var errorCallbackFunctionName = this.getParameterByName(uri, "errorCallbackFunctionName");
        try {
            this.adFinishedResizingCallback = adFinishedResizingCallback;
            if (successCallbackFunctionName != null)
                this.invoke(this.callback(successCallbackFunctionName, null, false));
        } catch (error) {
            if (errorCallbackFunctionName != null)
                this.invoke(this.callback(errorCallbackFunctionName, escape(error.toString()), true));
        }
    },
    
    adFinishedResizing: function()
    {
        if (this.adFinishedResizingCallback != null)
            this.invoke(this.callback(this.adFinishedResizingCallback, null, false));
    },
    
    setAdWillContractCallback: function(uri)
    {
        var adWillContractCallback = this.getParameterByName(uri, "adWillContractCallbackFunctionName");
        var successCallbackFunctionName = this.getParameterByName(uri, "successCallbackFunctionName");
        var errorCallbackFunctionName = this.getParameterByName(uri, "errorCallbackFunctionName");
        try {
            this.adWillContractCallback = adWillContractCallback;
            if (successCallbackFunctionName != null)
                this.invoke(this.callback(successCallbackFunctionName, null, false));
        } catch (error) {
            if (errorCallbackFunctionName != null)
                this.invoke(this.callback(errorCallbackFunctionName, escape(error.toString()), true));
        }
    },
    
    adWillContract: function()
    {
        if (this.adWillContractCallback != null)
            this.invoke(this.callback(this.adWillContractCallback, null, false));
    },
    
    setAdWillTerminateCallback: function(uri)
    {
        var adWillTerminateCallback = this.getParameterByName(uri, "adWillTerminateCallbackFunctionName");
        var successCallbackFunctionName = this.getParameterByName(uri, "successCallbackFunctionName");
        var errorCallbackFunctionName = this.getParameterByName(uri, "errorCallbackFunctionName");
        try {
            this.adWillTerminateCallback = adWillTerminateCallback;
            if (successCallbackFunctionName != null)
                this.invoke(this.callback(successCallbackFunctionName, null, false));
        } catch (error) {
            if (errorCallbackFunctionName != null)
                this.invoke(this.callback(errorCallbackFunctionName, escape(error.toString()), true));
        }
    },
    
    adWillTerminate: function()
    {
        if (this.adWillTerminateCallback != null)
            this.invoke(this.callback(this.adWillTerminateCallback, null, false));
    },
    
    setAdWillBecomeHiddenCallback: function(uri)
    {
        var adWillBecomeHiddenCallback = this.getParameterByName(uri, "adWillBecomeHiddenCallbackFunctionName");
        var successCallbackFunctionName = this.getParameterByName(uri, "successCallbackFunctionName");
        var errorCallbackFunctionName = this.getParameterByName(uri, "errorCallbackFunctionName");
        try {
            this.adWillBecomeHiddenCallback = adWillBecomeHiddenCallback;
            if (successCallbackFunctionName != null)
                this.invoke(this.callback(successCallbackFunctionName, null, false));
        } catch (error) {
            if (errorCallbackFunctionName != null)
                this.invoke(this.callback(errorCallbackFunctionName, escape(error.toString()), true));
        }
    },
    
    adWillBecomeHidden: function()
    {
        if (this.adWillBecomeHiddenCallback != null)
            this.invoke(this.callback(this.adWillBecomeHiddenCallback, null, false));
    },
    
    setAdDidReturnFromHiddenCallback: function(uri)
    {
        var adDidReturnFromHiddenCallback = this.getParameterByName(uri, "adDidReturnFromHiddenCallbackFunctionName");
        var successCallbackFunctionName = this.getParameterByName(uri, "successCallbackFunctionName");
        var errorCallbackFunctionName = this.getParameterByName(uri, "errorCallbackFunctionName");
        try {
            this.adDidReturnFromHiddenCallback = adDidReturnFromHiddenCallback;
            if (successCallbackFunctionName != null)
                this.invoke(this.callback(successCallbackFunctionName, null, false));
        } catch (error) {
            if (errorCallbackFunctionName != null)
                this.invoke(this.callback(errorCallbackFunctionName, escape(error.toString()), true));
        }
    },
    
    adDidReturnFromHidden: function()
    {
        if (this.adDidReturnFromHiddenCallback != null)
            this.invoke(this.callback(this.adDidReturnFromHiddenCallback, null, false));
    },
    
    setAllDisplayCallbacks: function(uri)
    {
        var adFinishedResizingCallback = this.getParameterByName(uri, "adFinishedResizingCallbackFunctionName");
        var adWillContractCallback = this.getParameterByName(uri, "adWillContractCallbackFunctionName");
        var adWillTerminateCallback = this.getParameterByName(uri, "adWillTerminateCallbackFunctionName");
        var adWillBecomeHiddenCallback = this.getParameterByName(uri, "adWillBecomeHiddenCallbackFunctionName");
        var adDidReturnFromHiddenCallback = this.getParameterByName(uri, "adDidReturnFromHiddenCallbackFunctionName");
        var successCallbackFunctionName = this.getParameterByName(uri, "successCallbackFunctionName");
        var errorCallbackFunctionName = this.getParameterByName(uri, "errorCallbackFunctionName");
        try {
            this.adFinishedResizingCallback = adFinishedResizingCallback;
            this.adWillContractCallback = adWillContractCallback;
            this.adWillTerminateCallback = adWillTerminateCallback;
            this.adWillBecomeHiddenCallback = adWillBecomeHiddenCallback;
            this.adDidReturnFromHiddenCallback = adDidReturnFromHiddenCallback;
            if (successCallbackFunctionName != null)
                this.invoke(this.callback(successCallbackFunctionName, null, false));
        } catch (error) {
            if (errorCallbackFunctionName != null)
                this.invoke(this.callback(errorCallbackFunctionName, escape(error.toString()), true));
        }
    },
    
    
    /**
	 * Destroys the current object
	 * @private
	 */
	destroy: function($super) {
        NGWindow.log('WebView - destroy');
        if (this.dont_destroy_me) {

        } else {
            if (this.screenCover != null) {
                this.screenCover.removeFromParent();
                this.screenCover.destroy();
            }
            
            messageListener.destroy();
            
            $super();
        }
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Mobclix/CreativeView/WebViewMessageListener'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Mobclix/CreativeView/WebViewMessageListener'] || {}; $MODULE_REGISTRY['NGCore/Client/Mobclix/CreativeView/WebViewMessageListener'] = exports; //
//  Mobclix.Core.MMWebViewMessageListener.js
//  Mobclix Mobage SDK
//
//  Copyright 2011 Mobclix. All rights reserved.
//

var UI = require('NGCore/Client/UI').UI;
var Core = require('NGCore/Client/Core').Core;
var Device = require('NGCore/Client/Device').Device;
var $mc = require('NGCore/Client/Mobclix/Core/Utils').Utils;

var WebViewMessageListener = exports.WebViewMessageListener = Core.MessageListener.subclass({
	__className: "WebViewMessageListener",
    
    webview: null,
    
    accelerometerListenerCallbackFunctionName: null,
    accelerometerListenerInterval: 0,
    accelerometerListenerLastTimestamp: 0,
    
    gyroscopeListenerCallbackFunctionName: null,
    gyroscopeListenerInterval: 0,
    gyroscopeListenerLastTimestamp: 0,
    
    compassListenerCallbackFunctionName: null,
    compassListenerInterval: 0,
    compassListenerLastTimestamp: 0,
    
    shakeListenerCallbackFunctionName: null,
    gpsListenerCallbackFunctionName: null,
    gpsListenerDistanceFilter: 0,
    gpsListenerLastReportedLongitude: 0,
    gpsListenerLastReportedLatitude: 0,
    
    initialize: function($super, webview) {
		$super();
		this.webview = webview;
	},
    
    pauseListeners: function()
    {
        try {
            Device.ShakeEmitter.removeListener(this);
        } catch (error) {}
        try {
            Device.MotionEmitter.removeListener(this);
        } catch (error) {}
        try {
            Device.LocationEmitter.removeListener(this);
        } catch (error) {}
    },
    
    resumeListeners: function()
    {
        try {
            if (this.shakeListenerCallbackFunctionName != null) {
                Device.ShakeEmitter.addListener(this, this.onShakeEvent, 10000);
            }
        } catch (error) {}
        try {
            Device.MotionEmitter.addListener(this, this.onMotionEvent, 10000);
            this.checkRemoveMotionListener();
        } catch (error) {}
        try {
            if (this.gpsListenerCallbackFunctionName != null) {
                Device.LocationEmitter.addListener(this, this.onLocationEvent, 10000);
            }
        } catch (error) {}
    },
    
    onKeyEvent: function(params) {
        NGWindow.log(["MMWebViewMessageListener - onKeyEvent - event: ", params]);
    },
    
    onLifecycleEvent: function(params) {
        NGWindow.log(["MMWebViewMessageListener - onLifecycleEvent - event: ", params]);
        if (params == Device.LifecycleEmitter.Event.Suspend) {
            this.webview.adWillBecomeHidden();
            this.pauseListeners();
        } else if (params == Device.LifecycleEmitter.Event.Resume) {
            this.webview.adDidReturnFromHidden();
            this.resumeListeners();
        } else if (params == Device.LifecycleEmitter.Event.Terminate) {
            this.webview.adWillTerminate();
            this.pauseListeners();
        }
    },
 
    onMotionEvent: function(params) {
        var t = (new Date()).getTime();
        if (this.accelerometerListenerCallbackFunctionName != null &&
                t > this.accelerometerListenerLastTimestamp + this.accelerometerListenerInterval) {
            this.accelerometerListenerLastTimestamp = t;
            var data = params.getAccelData();
            try {
                this.webview.invoke(this.webview.callback(this.accelerometerListenerCallbackFunctionName,
                                                          data[0] + "," + data[1] + "," + data[2],
                                                          false));
            } catch (error) {}
        }
        if (this.gyroscopeListenerCallbackFunctionName != null &&
                t > this.gyroscopeListenerLastTimestamp + this.gyroscopeListenerInterval) {
            this.gyroscopeListenerLastTimestamp = t;
            var data = params.getGyroData();
            try {
                this.webview.invoke(this.webview.callback(this.gyroscopeListenerCallbackFunctionName,
                                                          data[0] + "," + data[1] + "," + data[2],
                                                          false));
            } catch (error) {}
        }
        if (this.compassListenerCallbackFunctionName != null &&
                t > this.compassListenerLastTimestamp + this.compassListenerInterval) {
            this.compassListenerLastTimestamp = t;
            var data = params.getCompassData();
            try {
                this.webview.invoke(this.webview.callback(this.compassListenerCallbackFunctionName,
                                                          data[0],
                                                          false));
            } catch (error) {}
        }
    },
    
    checkRemoveMotionListener: function() {
        NGWindow.log(["MMWebViewMessageListener - checkRemoveMotionListener"]);
        if (this.accelerometerListenerCallbackFunctionName == null &&
                this.gyroscopeListenerCallbackFunctionName == null &&
                this.compassListenerCallbackFunctionName == null) {
            try {
                NGWindow.log(["MMWebViewMessageListener - checkRemoveMotionListener - trying to remove listener"]);
                Device.MotionEmitter.removeListener(this);
            } catch (error) {
                NGWindow.log(["MMWebViewMessageListener - checkRemoveMotionListener - error: ", error.toString()]);
            }
        }
    },
 
    onLocationEvent: function(params)
    {
        if (this.gpsListenerCallbackFunctionName != null) {
            try {
                if (distanceBetweenCoordinates(
                        params.getPosition().getX(),
                        params.getPosition().getY(),
                        this.gpsListenerLastReportedLongitude,
                        this.gpsListenerLastReportedLatitude) < this.gpsListenerDistanceFilter) {
                    return;
                }
                
                this.gpsListenerLastReportedLongitude = params.getPosition().getX();
                this.gpsListenerLastReportedLatitude = params.getPosition().getY();
            
                var locationData = { "coordinate": { "latitude": params.getPosition().getX(),
                                                     "longitude": params.getPosition().getY() },
                                     "course": params.getHeading(),
                                     "speed": 0,
                                     "timestamp": params.getTimestamp(),
                                     "horizontalAccuracy": params.getAccuracy(),
                                     "verticalAccuracy": params.getAccuracy() };
                this.webview.invoke(this.webview.callback(this.gpsListenerCallbackFunctionName,
                                                          "eval('(" + JSON.stringify(locationData) + ")')",
                                                          false));
            
            } catch (error) {}
        }
    },
    
    distanceBetweenCoordinates: function(long1, lat1, long2, lat2)
    {
        var R = 6371000; // meters
        return Math.acos(Math.sin(lat1)*Math.sin(lat2) + 
                         Math.cos(lat1)*Math.cos(lat2) *
                         Math.cos(long2-long1)) * R;
    },
 
    onShakeEvent: function(params)
    {
        NGWindow.log(['MMWebViewMessageListener - onShakeEvent: ', params]);
        if (this.shakeListenerCallbackFunctionName != null)
            webview.invoke(this.callback(this.shakeListenerCallbackFunctionName, null, false));
    },
    
    /**
	 * Destroys the current object
	 * @private
	 */
	destroy: function($super) {
        NGWindow.log('MMWebViewMessageListener - destroy');
        
        try {
            Device.KeyEmitter.removeListener(this);
        } catch (error) {}
        try {
            Device.LifecycleEmitter.removeListener(this);
        } catch (error) {}
        try {
            Device.ShakeEmitter.removeListener(this);
        } catch (error) {}
        try {
            Device.MotionEmitter.removeListener(this);
        } catch (error) {}
        try {
            Device.LocationEmitter.removeListener(this);
        } catch (error) {}
        
        $super();
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/SocialAPI/SocialModelClasses/GiftModel'] = function(){var exports = $MODULE_REGISTRY['Code/SocialAPI/SocialModelClasses/GiftModel'] || {}; $MODULE_REGISTRY['Code/SocialAPI/SocialModelClasses/GiftModel'] = exports; exports.GiftModel = Core.Class.subclass({
	classname: 'GiftModel',

	initialize: function() 
	{
		this.objId = '';
		this.senderName = '';
		this.senderId = '';
		this.giftId = '';
		this.senderGame = '';
		this.senderTimeStamp = '';
		this.senderType = '';
		
	},
	
	//this is actually GiftDatabaseKey (Gift dbKey) -> used for acknowledging a user gift
	getObjId:function()
	{
		return this.objId;
	},
	
	setObjId:function(value){
		this.objId = value;
	},
	
	getSenderName:function()
	{
		return this.senderName;
	},
	
	setSenderName:function(value){
		this.senderName = value;
	},
	
	getSenderId:function()
	{
		return this.senderId;
	},
	
	setSenderId:function(value){
		this.senderId = value;
	},
	
	getGiftId:function()
	{
		return this.giftId;
	},
	
	setGiftId:function(value){
		this.giftId = value;
	},
	
	getSenderGame:function()
	{
		return this.senderGame;
	},
	
	setSenderGame:function(value){
		this.senderGame = value;
	},
	
	getSenderTimeStamp:function()
	{		
		return this.senderTimeStamp;
	},
	
	setSenderTimeStamp:function(value){
		this.senderTimeStamp = value;
	},
	
	getSenderType:function()
	{
		return this.senderType;
	},
	
	setSenderType:function(value){
		this.senderType = value;
	},
	
	
});	; return exports;};
$MODULE_FACTORY_REGISTRY['Code/GameCentralHandler'] = function(){var exports = $MODULE_REGISTRY['Code/GameCentralHandler'] || {}; $MODULE_REGISTRY['Code/GameCentralHandler'] = exports; /**
 * Filename: GameCentralHandler.js
 * Author: Wasay Abbasi
 * Date Created: 16thMay-2011
 * Date Updated: 
 */
exports.GameCentralHandler = Core.Class.singleton({
	classname: 'GameCentralHandler',
    
	initialize: function() 
	{
		this.initiateSingletons();
		TFStorageManager.getAllValuesFromStorage();
		GameCentralHandler.startGameLoadingScreen();
		this.showedMobageButton = false;
		
		this.gAPICommunicator = null;
			
	},
    
	initiateSingletons: function()
	{
		if(kDEV_MENU == true){
			console.log("statring");
			DevelopmentMenu.instantiate();
			
		}
		TFUtil.instantiate();
		TFStorageManager.instantiate();
		LogHandler.performInitialization();
		TFGameState.instantiate();
	},
	
	loadSuccessForStorageManager: function() 
	{

		this.sendConnectCall();
		
	},
	
	loadDatabase: function()
	{
		console.log("loadDatabase started");
		console.log("inside loadDatabase");
		var resources = null;
		
		if(TFGameState.atNeighbor){
			console.log("Loading Neighbor database");
			resources = ["User","GameLevels"];
		} else {
			resources = ["User","GameLevels","Breeding","SocialFriends"];
		}
		
		DatabaseInterface.startFetchingData(resources);
		console.log("loadDatabase ended");
	},
	
	sendConnectCall: function()
	{
		if(this.gAPICommunicator == null)
			this.gAPICommunicator = new GAPICommunicator();
	},
	
	loadSuccessForDatabaseInterface :function()
	{

		TFGameState._serverTimeDiff = GAGameLoader.getResponseObject().getTimeDifference();
		
		var user = TFGameState.getCurrentUser();
		TFGameState.logConnectCall();

        this.getUserTypeInfo();
		this._storeIdsArray = TFUtil.fishArray.allKeys();

		this._storeIdsArray = this._storeIdsArray.concat(TFUtil.decorationArray.allKeys());
		this._storeIdsArray = this._storeIdsArray.concat(TFUtil.plantsArray.allKeys());
		this._storeIdsArray = this._storeIdsArray.concat(TFUtil.foodBricksArray.allKeys());
		//this._storeIdsArray = this._storeIdsArray.concat(TFGameState.getCurrentUser()._inventoryDict.allKeys());
		
		for(var i = 0; i<user._userObj.purchasedBackgroundArray.length;i++)
		{
			var storeId = user._userObj.purchasedBackgroundArray[i].storeId;
			this._storeIdsArray = this._storeIdsArray.concat(storeId);
		}
		this._storeIdsArray.push("1_8_31");
		if(TFGameState.atNeighbor)
			GameCentralHandler.showProgress(kGAGameLoadLevel.kGAGameLoadLevelStoreParsingDone,null);
		this.gAPICommunicator.sendSyncRequest(this._storeIdsArray);
	},
	
	loadSuccessForNewDatabaseInterface :function()
	{
		console.log("loadSuccessForNewDatabaseInterface started");
		console.log("inside loadSuccessForNewDatabaseInterface");
		//this.startGameLoadingScreen();
		
		var myString = GALocalizationHandler.getRelativeString(Core.Localization.getString("DOWNLOADING_RESOURCES"), ["0"]);
		
		this.loadDatabase();
		console.log("loadSuccessForNewDatabaseInterface ended");
	},
	
	destroyGameLayer: function()
	{
		//GameLayer.destroyTank();
	},


	loadSecondaryManifest: function()
	{
		UIFactory.showProgressHUD("Please wait while resources are downloading...");
		console.log("START LOADING SECONDARY MANIFEST");
		var url = Core.Capabilities.getContentUrl();
		var downloader = new ManifestContentDownloader(url, "./", "webgame.00.ngmanifest", this);
		
		
	},
	
	showCommunityButton: function () {
		UIFactory.hideProgressHUD();
		if(!this.showedMobageButton){
			GAMobageSocialHandler.showCommunityButton([0.0,1.0]);
			this.showedMobageButton = true;
		}
	},
	
	doneDownloading: function() {
		console.log("DONE LOADING SECONDARY MANIFEST");
		
		this._downloadedCount = 0;
		var keysArray = TFGameState.getCurrentUser()._inventoryDict.allKeys();
		
		if(TFGameState.getCurrentUser()._inventoryDict.length > 0) {
			UIFactory.showProgressHUD("Please wait while Inventory items are downloading...");
			for (i=0; i<TFGameState.getCurrentUser()._inventoryDict.length; i++)
			{
				var storeId = keysArray[i];
				this.imageLoader(storeId,i);
			}
		}
		else {
			this.showCommunityButton();
		}
	},
	
	imageLoader: function(storeId,index){
		var storeItem = GAGameLoader.getStoreHandler().getStoreObjectForKey(storeId);
		var resourceDownloader =  new GAResourceDownloader(storeItem , this.resourceDownloadingSuccessful.bind(this), this.resourceDownloadingFailed.bind(this),  GAResourceType.kDetail);
		resourceDownloader.setTag(index);
		resourceDownloader.startDownloading();
	},
	
	resourceDownloadingSuccessful:function (savePath,flag,downloader) 
	{
        downloader.destroy();
        downloader = null;
        this._downloadedCount++;
        if(this._downloadedCount == TFGameState.getCurrentUser()._inventoryDict.length){
        	this.showCommunityButton();
        }
	},
	
	resourceDownloadingFailed:function (errorCode, errorMsg,downloader)
	{
		var keysArray = TFGameState.getCurrentUser()._inventoryDict.allKeys();
		var index =  downloader.getTag();
		var storeId = keysArray[index];   									 
		this.imageLoader(storeId,index);
		downloader.destroy();
		downloader = null;
		this.showCommunityButton();
	},
	
	updateMenifestProgress: function(percentage) {
		console.log(percentage + "% of SECONDARY MANIFEST LOADED");
		
		if(percentage == 100)
		{
			TFStorageManager.saveToUserDefault(kUserDefaultKeys[6], true);
			GAGameStateManager._getConfigParams();
			GAGameStateManager._postState();
		}
	},

	
	startGameLoadingScreen: function()
	{
		
		
		this.gameLoadingScreen = new GameLoadingScreen();
		if(TFGameState.atNeighbor)
       	{ 
       		 	var incX = 0;
     			var incY = 0;
   
		      if(SCREEN_ASPECT_RATIO == AspectRatios.Ratio171)
		      {
		      	 incX = 28; 
		      	 incY = 0;
		      }
		      else if (SCREEN_ASPECT_RATIO == AspectRatios.Ratio160)
		      {
		      	 incX = 80; 
		      	 incY = 0;
		      }
//       		if(GameLayer._mobclixState)
//       		{
       			GAMobclixForView.show(TFUtil.getAdjustedY(100+incX),TFUtil.getAdjustedX(0+incY));	
//				NGWindow.document.addChild(this._mobclix);
//       		}
       	}
		this.gameLoadingScreen.startSplashScreen();
		
		
												
	},
		
	endGameLoadingScreen: function()
	{
		
		if(!this.gameLoadingScreen)
			return;
		console.log("this.gameLoadingScreen  " +this.gameLoadingScreen);
//		if(this._mobclix)
//		{
			//if(GameLayer._mobclixState)
			//	NGWindow.document.removeChild(this._mobclix);
			GAMobclixForView.removeAd();
//		}
		this.gameLoadingScreen.endSplashScreen();
		this.gameLoadingScreen = null;
		if(TFGameState.atNeighbor)
		{
			
			var _socialFriendsList = SocialUtil.getSocialFriends();
			if(_socialFriendsList.isFriendExist(TFGameState.getCurrentUser().getUsername()))
			{
				var neighborName = _socialFriendsList.getFriendWithName(TFGameState.getCurrentUser().getUsername());
			}
			else
			{
				var neighborName = _socialFriendsList.getFriendWithName('-1');
			}
			var lastVisitTime = neighborName.getLastVisitTime();
			var currentTimeStamp = TFGameState.getServerTime();
			if((currentTimeStamp - lastVisitTime) >= VISIT_AWARD_TIME_CONSTANT ||  lastVisitTime == '0')
			{
				this.awardXP();
				neighborName.setLastVisitTime(currentTimeStamp);
			}	
			_socialFriendsList.updateSocialFriends();
			
//			if(GameLayer._mobclixState)	
//			{
			var incX = 0;
     			var incY = 0;
   
		      if(SCREEN_ASPECT_RATIO == AspectRatios.Ratio171)
		      {
		      	 incX = 28; 
		      	 incY = 0;
		      }
		      else if (SCREEN_ASPECT_RATIO == AspectRatios.Ratio160)
		      {
		      	 incX = 80; 
		      	 incY = 0;
		      }
		      
				GAMobclixForView.show(TFUtil.getAdjustedY(80+incX),TFUtil.getAdjustedX(265+incY));	
//				NGWindow.document.addChild(this.mobclix);
				this.adTimer = setTimeout(this.removeAd.bind(this),5000);
//			}
			
		}
	},
	
	removeAd: function()
	{
		//NGWindow.document.removeChild(this.mobclix);
		GAMobclixForView.removeAd();
	},
	
	awardXP:function(){
		var coins = 5;
			
		var labelXPCOINSAward = VISIT_NEIGHOR_XP_COINS_AWARD + coins + " coins";
		
		var alertWindow = new TFMiniUIAlertView("",labelXPCOINSAward,this,"",GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
		alertWindow.setType("ok");
		alertWindow.setMessageColor("FFFFFF");
		alertWindow.setMessageFont(TFUtil.getFontName());
		alertWindow.setButtonsFont(TFUtil.getFontName());
		alertWindow.setButtonColor("FFFFFF");
		alertWindow.show();
	
		DatabaseHelper.updateCurrency(kOperationType.kOperationAddCoins, coins);
		DatabaseHelper.updateUser();
	},
																								
	addLoadingScreen: function()
	{
		this.loadingScreen = new LoadingScreen();
		this.loadingScreen.addLoadingScreen();
	},
	
	removeLoadingScreen: function()
	{
		this.loadingScreen.removeLoadingScreen();
	},
	
	startGame: function()
	{
		var user = TFGameState.getCurrentUser();
		GameLayer.instantiate();
		GameLayer.initializeTank();
		GameLayer.showUserMessage();
		this.endGameLoadingScreen();
	},
	
	onConnectSuccess: function()
	{
		this.loadDatabase();
    },

	onSuccess: function()
	{
		this.startGame();
		//this.gAPICommunicator.destroy();//commenting as needs to do neighbor and gamestates later
	},
	
	showProgress :function(progressStatus, uiprogressstatus)
	{
		if(uiprogressstatus == null || uiprogressstatus == 'undefined')
		{
			uiprogressstatus = 0;
		}
		if(progressStatus == null || progressStatus == 'undefined')
		{
			progressStatus = 3;
		}
		this.gameLoadingScreen.updateProgress(progressStatus,uiprogressstatus);
	},
	
	updatePercentage: function(percentage){
		this.gameLoadingScreen.updatePercentage(percentage);
	},

	setOrientationInterfaceListener: function(orientationInterfaceListener)
	{
		this.listerner = orientationInterfaceListener;											
	},

    getUserTypeInfo:function()
    {
    	TFGameState._isQAUser = GAGameLoader.getResponseObject().isQAUser();
		TFGameState._isSuperUser = GAGameLoader.getResponseObject().isSuperUser();
		
		TFStorageManager.saveToUserDefault(kUserDefaultKeys[3], TFGameState._isQAUser);
		TFStorageManager.saveToUserDefault(kUserDefaultKeys[4], TFGameState._isSuperUser);
		
		if(TFGameState._isSuperUser)
		{
			console.log("test","superuser is enabled");
			DatabaseInterface.createSuperUser();
		}
	
		if(TFGameState._isQAUser)
		{
			console.log("test","qauser is enabled");
			this.applyUserType();
		}		
    },
    
    
    applyUserType:function()
    {
    	console.log("test","applyUserType method reached..");
    	TFGameState.Save_Qa_Super_UserInfo();  	
    	var UserTypeSelectionAlert =  new TFMiniUIAlertView(GALocalizationHandler.getLocalizedString('TF_EMPTY_STRING'),GALocalizationHandler.getLocalizedString('SELECT_TIME_MODE'),this,GALocalizationHandler.getLocalizedString('TF_SERVER_TIME'),GALocalizationHandler.getLocalizedString('TF_LOCAL_TIME'));
		UserTypeSelectionAlert.setTagValue("TimeSelection");
		UserTypeSelectionAlert.setMessageColor("FFFFFF");
		UserTypeSelectionAlert.setButtonColor("FFFFFF");	
		UserTypeSelectionAlert.setTitleFont(TFUtil.getFontName());
		UserTypeSelectionAlert.setMessageFont(TFUtil.getFontName());
		UserTypeSelectionAlert.setButtonsFont(TFUtil.getFontName());
		UserTypeSelectionAlert.show();
    	
    },
    
	clickedButtonAtIndex: function(buttonIndex,alertView)
	{
		if(buttonIndex == 0)
		{
			switch(alertView.getTagValue())
			{
				case "TimeSelection":
				console.log("test","LocalTime Selected");
				TFStorageManager.saveToUserDefault(kUserDefaultKeys[5],GALocalizationHandler.getLocalizedString('TF_LOCAL_TIME'));			
				TFGameState._serverTimeDiff = 0;
				break;
			}
		}
		else if(buttonIndex == 1)
		{
			switch(alertView.getTagValue())
			{
				case "TimeSelection":
				console.log("test","Server Time Selected");
				TFStorageManager.saveToUserDefault(kUserDefaultKeys[5],GALocalizationHandler.getLocalizedString('TF_SERVER_TIME') );
				TFGameState._serverTimeDiff = GAGameLoader.getResponseObject().getTimeDifference();
				break;
			}
		}
	},
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/GameStartUI/GameLoadingScreen'] = function(){var exports = $MODULE_REGISTRY['Code/GameStartUI/GameLoadingScreen'] || {}; $MODULE_REGISTRY['Code/GameStartUI/GameLoadingScreen'] = exports; /*
<copyright file="GameLoadingScreen.js" company="GameViewStudios">
*  <author>Ammara Zulfiqar</author>
* <summary>
* Code add background,progress bar,spinner and Status label in the game.
* </summary>
*/

var TransitionDialog = UI.View.subclass(
{
	//function make and add, progress bar and spinner 
	initialize: function($super, attributes)
	{
		$super(attributes);
		
		var barRect = [TFUtil.getAdjustedY(95),TFUtil.getAdjustedX(275),TFUtil.getAdjustedY(295),TFUtil.getAdjustedX(20)];
			this.bar = new UI.ProgressBar({
			'frame': barRect,
			'progressGradient': {
				gradient: ["FF0397d6 0.0", "FFa0d0f4 1.0"],
				outerLine: "0000 4.0",
				innerLine: "0000 1.0",
				corners: '11'},
			'gradient': {
				gradient: ["FF00 0.0", "FF50 1.0"],
				outerLine: "FFFF 4.0",
				corners: '11'}
		});
		
		var spinnerRect = [TFUtil.getAdjustedY(100),TFUtil.getAdjustedX(245),40,40];
		this.spinner=new UI.Spinner({
			'frame':spinnerRect,
			'textColor':"ffffff"});
		
		this.addChild(this.spinner);
		this.addChild(this.bar);
		this.bar.useForUpdateProgress(true);
		
	},
	//function set Progress in status
	setProgress:function(progresslevel)
	{
		this.bar.setProgress(progresslevel);
	},
	destroy: function($super) 
	{
		TFUtil.destroyView(this);
		$super();
	}
});



exports.GameLoadingScreen = UI.View.subclass(
{
										
	classname: 'GameLoadingScreen',
	initialize: function($super) 
    {
    	
		$super();
		this.percentage=0;
		this._successCount=0;
		this._w = Core.Capabilities.getScreenWidth();
		this.progresslevel = 0;
		this._h = Core.Capabilities.getScreenHeight();
		this.setFrame([0,0,this._h,this._w]);
		this.text=['TF_CONNECTINGTOSERVER','TF_CSFNF','TF_LOADINGRESOURCES','TF_CREATINGUI'];//"ConnectingToServer","CSFNF","LoadingResources","CreatingUI"
		this.frame=[TFUtil.getAdjustedY(160),TFUtil.getAdjustedX(265),TFUtil.getAdjustedY(290),TFUtil.getAdjustedX(30)];
		this.percentageFrame=[TFUtil.getAdjustedY(120),TFUtil.getAdjustedX(265),TFUtil.getAdjustedY(290),TFUtil.getAdjustedX(30)];
		NGWindow.document.addChild(this);
			
    },
    
	//function get image,label from UIFactory.Use image for setting background and label for setting status
	startSplashScreen: function()
	{
		var background = UIFactory.getImage([0,0,this._h, this._w], './Content/images/loading.jpg');
		this.addChild(background);
//		if(TFGameState.atNeighbor)
//       	{ 
//       		console.log('aleeeeem mobclix in neighbor going in');
//        	this._mobclix= GAMobclixForView.show(170,0);	
//			this.addChild(this._mobclix);
//       	}

		//if(( Core.Capabilities.getPlatformOS() == 'Android') )
        //{
        
           var barRect = [TFUtil.getAdjustedY(145),TFUtil.getAdjustedX(285),TFUtil.getAdjustedY(205),TFUtil.getAdjustedX(20)];
        //}
        //else{
         //  var barRect = [TFUtil.getAdjustedY(245),TFUtil.getAdjustedX(260),TFUtil.getAdjustedY(205),TFUtil.getAdjustedX(28)];
       // }
		this.loadingState= UIFactory.getTextArea(this.frame,null,16,[0,0],"ffffff",null);
		this.percentageState= UIFactory.getTextArea(this.percentageFrame,null,16,[0,0],"ffffff",null);
			this.bar = new UI.ProgressBar({
			'frame': barRect,
			'progressGradient': {
				gradient: ["FF5a2d04 0.0", "FFd16a0d 1.0"],
				outerLine: "0000 4.0",
				innerLine: "0000 1.0",
				corners: '11',},
			'gradient': {
				gradient: ["FF00 0.0", "FF50 1.0"],
				outerLine: "FFb89c83 4.0",
				corners: '11',}
		});
		this.addChild(this.bar);
		this.bar.useForUpdateProgress(false);
		
		this.loadingState= UIFactory.getTextArea(this.frame,null,16,[0,0],"ffffff",null);
		this.percentageState= UIFactory.getTextArea(this.percentageFrame,null,16,[0,0],"ffffff",null);
		this.dialog = new TransitionDialog(null);
		this.addChild(this.dialog);
		this.addChild(this.loadingState);
		this.addChild(this.percentageState);
		this.updateProgress(0,0);
		//this.updatePercentage(1);
        
	},
	
	endSplashScreen: function()
	{
//		if(TFGameState.atNeighbor)
//		{
//			console.log('aleeeeem mobclix in neighbor going out');
//			this.removeChild(this._mobclix);
//		}
		this.destroy();
	},
	
	updatePercentage: function(percentage){
		console.log("percentage " + percentage);
		//this.percentage=percentage;
		//this.updateProgress(0);
		//this.loadingState.setText(this.myString+ " " + percentage + "%");
	},
    //function add current progress level and status
	updateProgress: function(progressStatus, UIProgressStatus)
	{

		var progressFactor = 1/this.text.length;
		var progressToAdd = 0;
		//console.log('aleem: progressToAdd: ' + progressToAdd);
		//console.log('aleem: this.progresslevel: ' + this.progresslevel);
	//	if(TFGameState.atNeighbor)
	//	{
			var myString = GALocalizationHandler.getLocalizedString(this.text[progressStatus]);
			//var percentageString =  Math.ceil(this.percentage)+'%';
			//var percentageString =  this.percentage+'%';
			//console.log('aleem: myString' + myString);
			//console.log('aleem: percentageString ' + percentageString);
			//var percentageSign = Math.ceil(this.percentage) + '%';
			//this.loadingState.setText(myString);
			this.loadingState.setText(myString);
			//console.log("aleem : " + this.percentageState);
			//this.percentageState.setText(this.percentage+'%');
		var myString = GALocalizationHandler.getLocalizedString(this.text[progressStatus]);
		//this.loadingState.setText(this.myString);//+ " " + (progressToAdd*100) + "%");
		if(UIProgressStatus > 75)
		{
			this.loadingState.setText(myString+ " " + Math.round(UIProgressStatus) + "%");
			progressToAdd = (UIProgressStatus/100);
			
		}
		else if(progressStatus == 3)
		{
			this.loadingState.setText(myString+ " 75%");
			progressToAdd = 0.75;
		}
		else
		{
			progressToAdd = (progressFactor * progressStatus) + progressFactor;
			this.loadingState.setText(myString+ " " + (progressToAdd*100) + "%");
			
		}

		if(progressToAdd > this.progresslevel)
		{
			
			this.progresslevel = progressToAdd;	
			this.loadingState.setTextFont(TFUtil.getFontName());
			this.dialog.setProgress(this.progresslevel);
			this.bar.setProgress(this.progresslevel);
		}
	},
	
	destroy: function($super)
	{
		TFUtil.destroyView(this);
		$super();
	}
	
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/GameStartUI/LoadingScreen'] = function(){var exports = $MODULE_REGISTRY['Code/GameStartUI/LoadingScreen'] || {}; $MODULE_REGISTRY['Code/GameStartUI/LoadingScreen'] = exports; /**
* Filename: LoadingScreen.js
 * Author: Wasay Abbasi
 * Date Created: 16thMay-2011
 * Date Updated: 
 */
exports.LoadingScreen = UI.View.subclass(
{
	initialize: function($super) 
	{
		$super();
    	
		var w = Core.Capabilities.getScreenWidth();
		var h = Core.Capabilities.getScreenHeight();
		this.setFrame([0,0,w,h]);
		NGWindow.document.addChild(this);
	},
    
	addLoadingScreen: function()
	{
		var w = Core.Capabilities.getScreenWidth();
		var h = Core.Capabilities.getScreenHeight();
		var background = UIFactory.getImage([0,0,w, h], './Content/images/loading.jpg');
		this.addChild(background);
	},
    
	removeLoadingScreen: function()
	{
		this.destroy();
	},
    
	destroy: function($super)
	{
		TFUtil.destroyView(this);
		NGWindow.document.removeChild(this);
		$super();
	},
	
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/DatabaseInterface/DatabaseInterface'] = function(){var exports = $MODULE_REGISTRY['Code/DatabaseInterface/DatabaseInterface'] || {}; $MODULE_REGISTRY['Code/DatabaseInterface/DatabaseInterface'] = exports; //# DatabaseInterface.js
//# ngFish
//#
//# Created by Kamran.lodhi on 5/4/11.
//# Copyright 2011 __MyCompanyName__. All rights reserved.

exports.DatabaseInterface = Core.Class.singleton(
{
classname: 'DatabaseInterface',
	
initialize: function()
	{
		this._firstTime = true;
	},
	
	startFetchingData: function(resources)
	{
		console.log("startFetchingData started");
		console.log('Fetcching resources length ' + resources.length);
		console.log('Fetcching resources length ' + resources);
		if(TFGameState.atNeighbor){
			//DatabaseInterface.unLoadTanks(resources);
			console.log('startFetchingData atNeighbor');

			GAPersistenceManager.loadResources(resources, this.myProgress.bind(this), this.myDoneLoadingUser.bind(this),null, true);
		}else{
			console.log('startFetchingData not atNeighbor');
			GAPersistenceManager.loadResources(resources, this.myProgress.bind(this), this.myDoneLoadingUser.bind(this),this.failLoadingUser.bind(this));		
		}
		console.log("startFetchingData ended");
	},
	
	createSuperUser:function()
	{
		var user = TFGameState.getCurrentUser();
		if(user._userObj.currentLevel < 80){
			user._userObj.currentLevel = 80;
			user._userObj.exp = 17000000;
		}
		DatabaseInterface.updateUser();		
	},
	
	myProgress:function (loaded, total) 
	{
												 
	},
	
	fetchUserRating: function () {
		var url = TFUtil.getRatingUrl(kRatingType.GET) ;
		var webFetcher = new GAWebFetcher(this, 30, 0);
		webFetcher.invokeGetRequest(url);
	},
	
	webFetchSuccess : function(webFetcher, responseData){
		try{
			var jsonResponse = eval("(" + responseData + ")");
			var data = jsonResponse.data;
			if((jsonResponse.status != 'OK')){
				console.log("Rating -> Response not OK!");
			}
			
			else if (jsonResponse.status == 'ERROR')
			{
				console.log("Rating -> User not Rated Yet");
			}
			
			else{
				var user = TFGameState.getCurrentUser();
				user.setRating(data.rating);
				user.setRatingCount(data.ratingcount);
				if(TFGameState.atNeighbor)
					GameLayer.updateControlLayer();
			}
		
		}catch(exception){
			console.log("Rating exception :: "+exception);
		}
		
		if(webFetcher != null){
			webFetcher.destroy();
			webFetcher = null;
		}
		this.neighborActionWebFetchCallBack(this._neighborActionArray);
	},
	
	webFetchFailure : function(webFetcher, errorCode){	
		//console.log('faizan failure');
		//GALogger.logWithLevel(errorMsg,LOG_LEVEL.LOG_NONFATAL_ERROR);
		if(webFetcher != null){
			webFetcher.destroy();
			webFetcher = null;
		}
	},
	
	myDoneLoadingUser: function() 
	{
		console.log("faizan myDoneLoadingUser started");
		if(!TFGameState.atNeighbor){
			console.log("myDoneLoadingUser not at neighbor");
			var userObj = GAPersistenceManager.getResource("User");
			
			var levelInfo = GAPersistenceManager.getResource("GameLevels");
							 
		    var breedInfo = GAPersistenceManager.getResource("Breeding");
		    
		    var socialFriendsInfo = GAPersistenceManager.getResource("SocialFriends");
		    var socialFriends = new SocialFriends(socialFriendsInfo);
		    socialFriends.loadFriends();
		    SocialUtil.instantiate();
		    SocialUtil._socialFriends = socialFriends;
		    
			var user = new User();
			user._userObj = userObj;
			TFGameState._currentUser = user;
			TFGameState.setLevelInfo(levelInfo);
		    TFGameState._currentUser._userBreedingObj=breedInfo;
		    TFGameState._currentUser.populateBreedingTanks();													
			TFUtil.getAllTanksResourcesDictionary(kObjectActionType.kObjectActionAdd);
		} else {
			console.log("myDoneLoadingUser at Neighbor");
			var userObj = GAPersistenceManager.getResource("User");//this._neighborData;
			var levelInfo = GAPersistenceManager.getResource("GameLevels");
		
			var user = new User();
			user._userObj = userObj;
			
			var socialFriends = SocialUtil.getSocialFriends();
			var socialFriend = socialFriends.getFriendWithName('-1');
			socialFriend.setLastRateTime(0);
			socialFriends.updateSocialFriends();
			
			console.log("myDoneLoadingUser TFGameState._currentUser set current user");
			console.log("myDoneLoadingUser ._userObj.coins" + user._userObj.coins);
			console.log("myDoneLoadingUser ._userObj.selectedTankId" + user._userObj.selectedTankId);
			TFGameState._currentUser = user;
			TFGameState.setLevelInfo(levelInfo);
		    TFGameState._currentUser._userBreedingObj=null;
			console.log("myDoneLoadingUser TFGameState._currentUser set current user");
			TFUtil.getAllTanksResourcesDictionary(kObjectActionType.kObjectActionAdd);

		}
		
		this.fetchUserRating();
		console.log("myDoneLoadingUser ended");
	},
	
	failLoadingUser: function (resourceName,error) {
		this.writeSocialJSONtoDb();
	},
	
	defaultTankProgress: function (loaded, total)
	{
		console.log("defaultTankProgress started");
		console.log("Progress tank: " + loaded + " / " + total);
		console.log("defaultTankProgress ended");
	},
	
	writeSocialJSONtoDb: function () {
		
		var socialFriends = new SocialFriends();
		socialFriends._friendsObj.classname = 'SocialFriends';
		
		var socialFriend =  new SocialFriend();
		socialFriend.setName('-1');
		socialFriends.addSocialFriend(socialFriend);
		
		var pathToResource = GAConfigurations.getUserGameStateDBPath() + "/" + socialFriends._friendsObj.classname + ".json";;
		var jsonStr = JSON.stringify(socialFriends._friendsObj);
		Storage.FileSystem.writeFile(pathToResource, jsonStr, false, this.loadResourcesForSocialFriends.bind(this));
		var filenames = GAConfigurations.getDbFileNames();
		filenames= filenames.concat(socialFriends._friendsObj.classname);
		if(!TFGameState.socialFriends)
		{
			GAConfigurations.setDbFileNames(filenames);
		}
	},
	
												 
	writeJSONtoDb: function (newTank) 
	{
		var tankModel = new Tank();

		tankModel._tankObj.name = GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_TANK_NAME'), [TFGameState.getCurrentUser()._userObj.selectedTankId]);
		tankModel._tankObj.classname = tankModel._tankObj.name;

		var pathToResource = "";
		if(!TFGameState.atNeighbor){
			console.log("writeJSONtoDb not at neighbor");
			pathToResource = GAConfigurations.getUserGameStateDBPath() + "/" + tankModel._tankObj.classname + ".json";
		}else{
			console.log("writeJSONtoDb at neighbor");
			pathToResource = GAConfigurations.getUserGameStateDBPath() + "/random/" + tankModel._tankObj.classname + ".json";
		}

		var jsonStr = JSON.stringify(tankModel._tankObj);

		Storage.FileSystem.writeFile(pathToResource, jsonStr, false, this.loadResourcesForSelectedTank.bind(this, newTank));
		 var filenames = GAConfigurations.getDbFileNames();
		 filenames= filenames.concat(tankModel._tankObj.classname);
		 GAConfigurations.setDbFileNames(filenames);	
		var userTankInfo = {"tankId": TFGameState.getCurrentUser()._userObj.selectedTankId.toString(), "tankName": tankModel._tankObj.name};
		
		TFGameState.getCurrentUser()._userObj.tankArray[TFGameState.getCurrentUser()._userObj.selectedTankId.toString()] = userTankInfo;
		TFGameState.getCurrentUser()._userObj.tankId++;
		TFGameState.getCurrentUser()._userObj.persist();

		tankModel.destroy();

	},	
	
	addNewTank:function()
	{

		var newTankId = 0;
		for(objectId in TFGameState.getCurrentUser()._userObj.tankArray)//>< to be changed later taking direct length
		{
			
			if(+objectId > +newTankId)
			{								 
				newTankId = objectId;
			}
		}
		TFGameState.getCurrentUser()._userObj.selectedTankId = +newTankId + 1;
		this.loadResourcesForSelectedTank(true);
	},
	
	loadResourcesForSocialFriends: function () {
		GameCentralHandler.loadDatabase();
	},
	
	loadResourcesForSelectedTank: function(newTank)
	{
		console.log("loadResourcesForSelectedTank started");
		var resources = ['Tank'+TFGameState.getCurrentUser()._userObj.selectedTankId];
		GAPersistenceManager.loadResources(resources, this.defaultTankProgress.bind(this), this.resourceLoadedForSelectedTank.bind(this, newTank),this.resourceLoadingFailureForSelectedTank.bind(this, newTank), TFGameState.atNeighbor);
		console.log("loadResourcesForSelectedTank ended");
	},
	
	resourceLoadedForSelectedTank: function(newTank)
	{
		console.log("resourceLoadedForSelectedTank started");
		var tankToLoad = 'Tank'+TFGameState.getCurrentUser()._userObj.selectedTankId;
		var myTankObj = GAPersistenceManager.getResource(tankToLoad);
		console.log("myTankObj " + myTankObj);
		if(newTank)
		{
			myTankObj.lastCleaned = TFGameState.getServerTime();
		}
		
		if(myTankObj)
		{
			this.firstTankDoneLoading();
		}
		else
		{
			console.log ('Tank resource Success');
			//this.writeJSONtoDb();
			//show some error
		}
		
		console.log("resourceLoadedForSelectedTank ended");
	},

	resourceLoadingFailureForSelectedTank: function(newTank)
	{
		this.writeJSONtoDb(newTank);
	},
	
	loadTanks: function(resources,actionType)
	{
		console.log("loadTanks started");
		console.log("TFGameState.atNeighbor " + TFGameState.atNeighbor);
//		if(!TFGameState.atNeighbor)
			GAPersistenceManager.loadResources(resources, this.defaultTankProgress.bind(this), this.tanksLoaded.bind(this,resources,actionType), this.resourceLoadingFailureForSelectedTank.bind(this), TFGameState.atNeighbor);
//		else
//			this.loadResourcesForSelectedTank();
		
		console.log("loadTanks ended");
	},
	
	tanksLoaded: function(resources,actionType)
	{
		TFUtil.fishArray.removeAllObjects();
		console.log("tanksLoaded started");
		TFUtil.resourceLoadedForTanks(resources,actionType);
		this.loadResourcesForSelectedTank(false);
		console.log("tanksLoaded ended");
	},
	
	unLoadTanks: function(resources)
	{
		console.log("unLoadTanks started resources " + resources.length);
		var len = resources.length;
		var i = 0;
		for (; i < len; i++) {
			GAPersistenceManager.unLoadResource(resources[i]);
		}
		console.log("unLoadTanks ended");
	},
	
	firstTankDoneLoading: function()
	{

		var tankToLoad = 'Tank'+TFGameState.getCurrentUser()._userObj.selectedTankId;
		console.log("tank to load " + tankToLoad);
		var myTankObj = GAPersistenceManager.getResource(tankToLoad);
		console.log("myTankObj.classname " + myTankObj.classname);
		console.log("myTankObj.backgroundStoreID " + myTankObj.backgroundStoreID);
		var tankModel = null;
		
		if (TFGameState.atNeighbor){
//			console.log("myTankObj. atNeighbor" );
			this._neighborActions = SocialActionsHandler.getNeighborActionArray();
			for(objId in this._neighborActions){
				var tank = this._neighborActions[objId].getTankId();
				var uName = this._neighborActions[objId].getName();
				var rName = this._neighborActions[objId].getRname();
				var currentUser = TFGameState.getCurrentUser()._userObj.name;
				var myName = GAConfigurations.getUserId();
				//console.log("myTankObj. TankId "+tank );
				if((TFGameState.getCurrentUser()._userObj.selectedTankId == tank) && (uName == myName) && (rName == currentUser ) ){
//					console.log("myTankObj. operationPerformed on this tank " +tank);
//					console.log("myTankObj. operationPerformed on this uName " +uName);
//					console.log("myTankObj. operationPerformed on this rName " +rName);
					if(this._neighborActions[objId].getCleanTimeStamp() != 0.00)
						myTankObj.lastCleaned = this._neighborActions[objId].getCleanTimeStamp();
					
					if(this._neighborActions[objId].getFeedTimeStamp() != 0.00){
						myTankObj.lastFed = this._neighborActions[objId].getFeedTimeStamp();
						for (objId in myTankObj.Store_Items.tank_fishArray){
//							console.log("myTankObj.  " +objId);
	        				myTankObj.Store_Items.tank_fishArray[objId].lastFed = myTankObj.lastFed;
	        				//console.log("SocialManager :: exception "+myTankObj.Store_Items.tank_fishArray[objId].lastFed);
	        				
	        			}
					}
					if(this._neighborActions[objId].getReviveTimeStamp())
					{
						if(this._neighborActions[objId].getReviveTimeStamp() != 0.00){
							myTankObj.lastRevived = this._neighborActions[objId].getReviveTimeStamp();
							for (objId in myTankObj.Store_Items.tank_fishArray){
								console.log("myTankObj.  " +objId);
								//myTankObj.lastCleaned = this._neighborActions[objId].getReviveTimeStamp();
		        				myTankObj.Store_Items.tank_fishArray[objId].lastFed = myTankObj.lastRevived;
		        				//console.log("SocialManager :: exception "+myTankObj.Store_Items.tank_fishArray[objId].lastFed);
		        			}
						}
					}
				} 
			}
		}
		
		
		
		
//		if(!TFGameState.atNeighbor){
			tankModel = new Tank(myTankObj);
//		}else{
//			tankModel = new Tank(null);
//		}
		
		tankModel.initializeTankObjectArrays();
		tankModel._tankObj.classname = 'Tank'+TFGameState.getCurrentUser()._userObj.selectedTankId;
		
		
		
		if(!this._firstTime)
		{
			if(TFGameState.getCurrentUser()._tankObj){
				console.log("TFGameState.getCurrentUser() " + TFGameState.getCurrentUser());
				console.log("TTFGameState.getCurrentUser()._tankObj " + TFGameState.getCurrentUser()._tankObj);
				//TFGameState.getCurrentUser()._tankObj.destroy();
			}
			TFGameState.getCurrentUser()._tankObj = tankModel;
			GameLayer.destroyTank();
			if(TFGameState.atNeighbor && !TFGameState.isNeighborResourceDownloaded){
				console.log("at neighbor with no resources downlaoded");
				GameCentralHandler.loadSuccessForDatabaseInterface();
				TFGameState.isNeighborResourceDownloaded = true;
			} else {
				console.log("at neighbor with resources downlaoded");
				GameCentralHandler.endGameLoadingScreen();
				GameLayer.initializeTank();
			}
			if(TFGameState.goingToHome){
				TFGameState.goingToHome = false;
				this.populateInventory();
				console.log("inventory populated");
			}
			return;
		}
		this.notFirstRun = TFStorageManager.getValueFromUserDefault(kUserDefaultKeys[0]);	


		this._firstTime = false;
		TFGameState.getCurrentUser()._tankObj = tankModel;
		this.populateInventory();
		GameCentralHandler.loadSuccessForDatabaseInterface();
										 
	},
		
	changeTank:function(tankName)
	{
		TFGameState.getCurrentUser()._userObj.selectedTankId = tankName;
		this.loadResourcesForSelectedTank(false);
        this.updateUser();
	},
	
	deleteTank:function(tankID)
	{
		var tankName = ['Tank'+tankID];
		var pathToResource = GAConfigurations.getUserGameStateDBPath() + "/" + tankName + ".json";																								 
		console.log('Tank Path' + pathToResource);
		Storage.FileSystem.deleteFile(pathToResource, this.deleteComplete.bind(this));
			 var filenames = GAConfigurations.getDbFileNames();
				 for(var i=0; i<filenames.length;i++ )
				 {
					 if(filenames[i]==tankName)
						 filenames.splice(i,1); 
				 } 
			 GAConfigurations.setDbFileNames(filenames);	
	
		for(objectId in TFGameState.getCurrentUser()._userObj.tankArray)
		{
			var tank = TFGameState.getCurrentUser()._userObj.tankArray[objectId];
			if(tank.tankId == tankID)
			{
				delete TFGameState.getCurrentUser()._userObj.tankArray[objectId];
				this.updateUser();
				break;
			}
		}
		
	},
	
	deleteComplete:function()
	{
		console.log('Tank Deleted');
		TFGameState.justDeleted = false;
	},
	
	///////Persistance method calls/////////
	
	addBackground:function(newBackground)
	{
		var backgroundCount = this._user.purchasedBackgroundArray.length;
		newBackground.objectId = backgroundCount+1;
	
		this._user.purchasedBackgroundArray[backgroundCount] = newBackground;
		this._user.currentBackgroundId = newBackground.storeId;
		
		this._selectedTankObject.backgroundStoreID = newBackground.storeId;
		this.updateTank();
		this.updateUser();
												
	},
												 
	getFishId:function()
	{
			return this._selectedTankObject.fishId;
	},
    
	addFish:function(newFish)
	{
		newFish._fishObj.objectId = this._selectedTankObject.fishId;
        
		this._selectedTankObject.Store_Items['tank_fishArray'][newFish._fishObj.objectId.toString()] = newFish._fishObj;
		this._selectedTankObject.fishId++;
		this.updateTank();	
	},
	
	addToInventory:function(modelObject)
	{	
		modelObject.objectId = this._user.inventoryId;
		this._user.inventory[this._user.inventoryId.toString()] = modelObject;
		this._user.inventoryId++;
		this.updateUser();
	},
												
	getFishSample: function()
	{
		return this.cloneObject(this._selectedTankObject.fish_sample);
	},
	
	getDecorationSample: function()
	{
		return this.cloneObject(this._selectedTankObject.decoration_sample);
	},
		
	getBackgroundSample: function()
	{
		return this.cloneObject(this._user.background_sample);
	},
	
	getFish:function(index)
	{   
		return this._selectedTankObject.Store_Items['tank_fishArray'][index];
	},
	
    
    getDecoration:function(index)
    {   
		return this._selectedTankObject.Store_Items['tank_decorationArray'][index];
	},
    
    getBackground:function(index)
    {   
		return this._selectedTankObject.tank_backgroundArray[index];
	},
	
	cloneObject: function (obj){
		if(obj == null || typeof(obj) != 'object')
		{
			return obj;
		}
		
		var temp = obj.constructor();
		
		for(var key in obj)
		{
			temp[key] = this.cloneObject(obj[key]);
		}
		
		return temp;
	},
	

	updateUser:function()
	{
		if(!TFGameState.atNeighbor){
//			console.log("ahsan : updateUser if ");
			TFGameState.getCurrentUser()._userObj.persist();
		}else{
//			console.log("ahsan : updateUser else ");
			DatabaseHelper.updateUser();
		}
	},
	
	updateTank:function()
	{
		if(TFGameState.atNeighbor){
			return;  //FOR SAFETY PURPOSE!
		}
		var currentUser = TFGameState.getCurrentUser();
		var tankObj = currentUser._tankObj._tankObj;
		tankObj.persist();

	},

	///////Persistance method calls/////////

	getAllFish: function() 
	{

	},
	
	testFunc: function()
	{
		var testDict = new GAMutableDictionary();
		testDict.setObject('1',this._user);
		
		var tempUser = testDict.objectForKey('1');
		
	},
	
	populateInventory: function()
	{	
		var inventoryDict = new GAMutableDictionary();
		for(objectId in TFGameState.getCurrentUser()._userObj.inventory)
		{

			var inventoryItem = TFGameState.getCurrentUser()._userObj.inventory[objectId];

			var inventoryItemArr = inventoryDict.objectForKey(inventoryItem.storeId);
			
			if(!inventoryItemArr)
			{
				inventoryItemArr = new GAMutableArray();
				inventoryItemArr.addObject(inventoryItem);
				inventoryDict.setObject(inventoryItem.storeId,inventoryItemArr);	
			}
			else
			{
				inventoryItemArr.addObject(inventoryItem);
			}		
		}
		
		TFGameState.getCurrentUser()._inventoryDict = inventoryDict;
	},
		
	removeFromInventory:function(index)
	{
			delete TFGameState.getCurrentUser()._userObj.inventory[index];
			this.updateUser();
	},
    updateBreedingTank:function ()
    {
	        TFGameState.getCurrentUser()._userBreedingObj.persist();
	},
	
	loadNeighbor: function(path)
	{
		this._isNeighbor = true;
		GameCentralHandler.loadSuccessForNewDatabaseInterface();
	},
	
	backToHome: function() {
		this._isNeighbor = false;
		GameCentralHandler.loadSuccessForNewDatabaseInterface();
	},
	
	_dbFileReadCallback: function (error,contents){
		console.log("_dbFileReadCallback started");
		console.log('>> dbFileReadCallback 111 '+error);
		if(!error){
//			console.log('>> dbFileReadCallback 112 ');
			this._isNeighbor = true;									 
//			console.log('>> dbFileReadCallback 116');
			var data = eval('('+ contents +')');
//			console.log('>> dbFileReadCallback 115 ');
			this._neighborData = data;
			console.log("DATA " + data.coins);
			console.log("DATA " + data.exp);
//			console.log('>> dbFileReadCallback 114 ');
			GameCentralHandler.loadSuccessForNewDatabaseInterface();
//			console.log('>> dbFileReadCallback 113 ');
			
		} else {
			console.log('error occured');
		}
		console.log("_dbFileReadCallback ended");
	},
	

});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/GameState/TFGameState'] = function(){var exports = $MODULE_REGISTRY['Code/GameState/TFGameState'] || {}; $MODULE_REGISTRY['Code/GameState/TFGameState'] = exports; /**
 * Filename: TFGameState.js
 * Author: Wasay Abbasi
 * Date Created: 30th May, 2011
 */

exports.TFGameState = Core.Class.singleton(
{
	classname: 'TFGameState',
	
	initialize: function()
	{
		this._currentUser = null;
		this._neighborName = null;
		this._musicOn = null;
		this._levelsInfo = null;
		this._serverTimeDiff = 0;
		this.notFirstRun = true;
		this._isQAUser = false;
		this._isSuperUser = false;
		this.data = null;
		this.atNeighbor = false;
		this.isNeighborResourceDownloaded = false;
		this.goingToHome = false;
		this.isFriend = false;
		this.socialFriends = false;
		this.justDeleted = false;
		
	},
	
    changeFileName: function(basePath,storeObject)
	{
	   this.storeObj = storeObject;
	   this.basePath = basePath;
	   Storage.FileSystem.readFile(this.basePath+'/default.png', true, this.keyCheck.bind(this));
	},
	
	updateKey: function() {
		Storage.FileSystem.writeFile(this.basePath+'/default.jpg',  this.data, true, this.keyUpdated.bind(this));		
	},
	
	keyUpdated: function() {
		//this._successCb(this.basePath+'/default.jpg', true);
	},

	keyCheck: function(error, contents) {

		if(error)
		{
			console.log("++++++++++++++++++++++++Error is===="+error);	
			return;
		}
		this.data = eval('('+ contents +')');
		Storage.FileSystem.writeFile(this.basePath+'/default.jpg', this.data ,true, null);							   
	},

	isMusicOn: function()
	{
		return this._musicOn;
	},
    
	getLevelInfo:function()
	{
		return this._levelsInfo;
	},
    
	initiate: function()
	{
		this.notFirstRun = TFStorageManager.getValueFromUserDefault(kUserDefaultKeys[0]);								   
		if(this.notFirstRun === null)
		{
			this.notFirstRun = false;
			TFStorageManager.saveToUserDefault(kUserDefaultKeys[0], this.notFirstRun);
		}
	},
	
	isNewUser: function(){
		var responseObject = GAGameLoader.getResponseObject();
		
		if ((responseObject != null) && (responseObject != undefined)){
			var devStat = responseObject.getDevStat();
			
			if ((devStat != null) && (devStat != undefined)){
				if (devStat == 'new'){
					return true;
				}
				else if (devStat == 'exist'){
					return false;
				}
				else{
					return false;
				}
			}
		}
	},
	
	logConnectCall : function() {
		var eventType = null;
		if (this.isNewUser()){
			if(LogHandler.isDazzle()) {
				eventType = GADazzleEventType.Registration;
			}
			else {
				eventType = "Registration";
			}
		}
		else{
			if(LogHandler.isDazzle()) {
				eventType = GADazzleEventType.Connect;
			}
			else {
				eventType = "GameConnect";
			}
		}
		LogHandler.logEvent(eventType);
	},
	
	setLevelInfo:function(levelsinfo)
	{
		this._levelsInfo = levelsinfo;
	},
	
	  isOnMute: function()
	  {
		if(TFStorageManager.getValueFromUserDefault(SOUND_KEY) == '1')
			return true;
		else
			return false;
	  },
	  getUserMessage: function()
	  {
		  var userMessage=null;
		  if(GAGameLoader.getResponseObject().getUserMessageModel())
		  {
			userMessage = GAGameLoader.getResponseObject().getUserMessageModel().getMessage();  
		  }
		
		return userMessage;
	  },
  
   isBackgroundAlreadyBought: function(storeId)
   {
	   this.user = TFGameState.getCurrentUser();
	   var backgroundCount = this.user._userObj.purchasedBackgroundArray.length;
   
	   for(var i =0 ;i<backgroundCount;i++)
	   {
		   if(this.user._userObj.purchasedBackgroundArray[i].storeId == storeId)
		   {
			   this.backGroundId = storeId;
			   return true;
		   }
	   }
	   return false;
   },
   
	Save_Qa_Super_UserInfo:function()
	{
		if(this._isQAUser == true)
		{
			TFStorageManager.saveToUserDefault(kUserDefaultKeys[3], this._isQAUser);
		}
		if(this._isSuperUser == true)
		{
			TFStorageManager.saveToUserDefault(kUserDefaultKeys[4], this._isSuperUser);
		}
	},

	shouldSoundBePlayed: function()
	{
		var key = "musicOn";
		var musicOn = TFStorageManager.getValueFromUserDefault(key);
		if(musicOn != null)
		{
			if(musicOn == 1)
			{
				this._musicOn = true;
				return true;
			}
			else if(musicOn == 2)
			{
				this._musicOn = false;
				return false;
			}
		}
		TFStorageManager.saveToUserDefault(key, "1");
		this._musicOn = true;
		return true;
	},
										   
	getServerTime: function()
	{		
		var today = new Date();
		var currentDateInSec = today.getTime()/1000;
		var realTime = currentDateInSec + this._serverTimeDiff;
		return realTime;
	},
	
	setServerTime: function(serverTimeDiff){
    	this._serverTimeDiff = serverTimeDiff;
	},
   
	getLevelInfoForLevel:function(level)
	{
//		if(!this.atNeighbor)
			return this._levelsInfo.levels[level];
//		else
//			return 0;
			
	},
	
	getCurrentUser:function ()
	{
		return this._currentUser;
	},
	
});
	
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/GLLayer/GameLayer'] = function(){var exports = $MODULE_REGISTRY['Code/GLLayer/GameLayer'] || {}; $MODULE_REGISTRY['Code/GLLayer/GameLayer'] = exports; /**
 * Filename: GameCentralHandler.js
 * Author: Shamas Shahid
 * Date Created: 17thMay-2011
 * Date Updated: 
 */
exports.GameLayer = Core.Class.singleton({
    classname: 'GameLayer',
    
	initialize: function() 
	{
		this.initSoundEffects();
		//this.initializeTank();
		//this.showUserMessage();
		this._tutorial = null;
		this._controlLayer = null;
		//receive gifts for the user
		var customAttributes = GAGameLoader.getResponseObject().getCustomAttributes();
		var mobclixState = customAttributes["mobclix_ads"];
		var mobclixID = customAttributes["mobclix_id"];
		GAMobclixForView.instantiate();
		GAMobclixForView.setID(mobclixState,mobclixID);
		//this._mobclixState
		
		SocialManager.handleSocialAction(kSocialTypes.CALLBACK_ENABLE,false);
		SocialManager.handleSocialAction(kSocialTypes.BlOCKED_USERS,null);
		//SocialManager.handleSocialAction(kSocialTypes.FRIEND_LIST,null);
		SocialManager.handleSocialAction(kSocialTypes.GET_NEIGHBOR_ACTION,null);
		SocialManager.handleSocialAction(kSocialTypes.RECEIVE_MESSAGES,null);		
		
		var username = TFGameState.getCurrentUser().getUsername();
		if(username != GAConfigurations.getUserId()){
			TFGameState.getCurrentUser().setUsername(GAConfigurations.getUserId());
		}
		//SocialGiftsHandler.getGiftResponseObject().getGiftsArray();-> to access
		
		//TFUtil.populateGiftableKeysDictionary(); --> gets list of items that can be sent as a gift
	},
	
	initSoundEffects: function () {
		GAAudioManager.setBGMusicPath(BACKGROUND_MUSIC_PATH);
		GAAudioManager.setTickMusicPath(CLICK_SOUND_NAME1);
		GAAudioManager.initializeSoundEffect();
	},

	
	initializeTank:function()
	{
		var myUser = TFGameState.getCurrentUser();
		var myTank = myUser._tankObj;
		
		this._GLNode = new GL2.Node();
		GL2.Root.addChild(this._GLNode);
		
		var myUser = TFGameState.getCurrentUser();
		this.myUser = myUser;
		var selectedTankObj = myUser._tankObj;
		
		var myTank = new TankUI(selectedTankObj);
		
		this._selectedTank = myTank;
		this._GLNode.addChild(myTank);
		this.tank = myTank;
		var width = Core.Capabilities.getScreenWidth();
		var height = Core.Capabilities.getScreenHeight();
		
		this.startGame();
		
	},
	
	showUserMessage : function()
	{
		if(!TFGameState.atNeighbor){
			var usermsg = TFGameState.getUserMessage();
			if(usermsg!= null)
			{
				console.log("<<>>> in showUserMessage");
				userMenuCloseButton= true;
				var coinsAlert = "Test";
				var message = TFGameState.getUserMessage();
				var userMessAlert =  new GAUIAlertView("",message,this,null,GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
				userMessAlert.setTagValue(0001);
				userMessAlert.setMessageColor("FFFFFF");
				userMessAlert.setMessageFont(TFUtil.getFontName());
				userMessAlert.setButtonsFont(TFUtil.getFontName());
				userMessAlert.setButtonColor("FFFFFF");
				userMessAlert.show();
				
				//TBParticleAnimation.getSnowParticleAnimation();  
				 
			}
		}
	
	},

	showNewFriendRequestView: function(reqCount)
	{
		this.currentRequestCount = TFStorageManager.getValueFromUserDefault(kUserDefaultKeys[9]);								   
		if(this.currentRequestCount === null)
		{
			this.currentRequestCount = 0;
			TFStorageManager.saveToUserDefault(kUserDefaultKeys[9], this.currentRequestCount);
		}
		var newRequestCount = parseInt(reqCount) - this.currentRequestCount ;
		if (newRequestCount > 0) {
			var message = GALocalizationHandler.getRelativeString(Core.Localization.getString("SOCIAL_NEW_FRND_RQST_COUNT"),[newRequestCount]);
	        //var alertWindow = new SocialMiniUIAlertView("",message,this,null,GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
	        var alertWindow = new TFMiniGLAlertView("",message,this,null,GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
	       	alertWindow.setTagValue(0004);
	        alertWindow.setMessageColor("FFFFFF");
			alertWindow.setMessageFont(SocialUtil.getFont(),SocialUtil.getFontLocation());
			alertWindow.setButtonsFont(SocialUtil.getFont(),SocialUtil.getFontLocation());
			alertWindow.setButtonColor("FFFFFF");
			alertWindow.show() ;
			this.currentRequestCount = parseInt(this.currentRequestCount)+ parseInt(newRequestCount) ;
			TFStorageManager.saveToUserDefault(kUserDefaultKeys[9], this.currentRequestCount);
		}
	},
	
	showNewMessagesView: function(msgCount)
	{
		
		this.CurrentMsgsCount = TFStorageManager.getValueFromUserDefault(kUserDefaultKeys[7]);								   
		if(this.CurrentMsgsCount === null)
		{
			this.CurrentMsgsCount = 0;
			TFStorageManager.saveToUserDefault(kUserDefaultKeys[7], this.CurrentMsgsCount);
		}
		var newMsgsCount = parseInt(msgCount) - this.CurrentMsgsCount ;
		if (newMsgsCount > 0) {
			var message = GALocalizationHandler.getRelativeString(Core.Localization.getString("SOCIAL_NEW_MESSAGES_COUNT"),[newMsgsCount]);
	        
	        var alertWindow = 0;
	        if(SocialManager.isSocialScreenShowing())
	        {
	        	console.log("GameLayer:showNewMessagesView-> Social Window showing!")

				var alertWindow = new TFMiniUIAlertView("",message,this,null,GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
				alertWindow.setType("ok");
				alertWindow.setMessageColor("FFFFFF");
				alertWindow.setMessageFont(TFUtil.getFontName());
				alertWindow.setButtonsFont(TFUtil.getFontName());
				alertWindow.setButtonColor("FFFFFF");
				alertWindow.show();
				
	        }
	        else
	        {
	        	console.log("GameLayer:showNewMessagesView-> Social Window not showing!")
				var alertWindow = new TFMiniGLAlertView("",message,this,null,GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
		       	alertWindow.setTagValue(0003);
		        alertWindow.setMessageColor("FFFFFF");
				alertWindow.setMessageFont(TFUtil.getFont(),TFUtil.getFontLocation());
				alertWindow.setButtonsFont(TFUtil.getFont(),TFUtil.getFontLocation());
				alertWindow.setButtonColor("FFFFFF");
				alertWindow.show() ;
	        }
	        

			this.CurrentMsgsCount = parseInt(this.CurrentMsgsCount)+ parseInt(newMsgsCount) ;
			TFStorageManager.saveToUserDefault(kUserDefaultKeys[7], this.CurrentMsgsCount);
		}
	},
	
	showNewGiftsMessage:function(giftsCount)
	{
		if(!TFGameState.atNeighbor)
		{	
			console.log("GameLayer: showNewGiftsMessage....");
			//console.log("GameLayer: -> giftsCount -> "+TFStorageManager.getValueFromUserDefault(kUserDefaultKeys[8]))
			
			var currentGiftsCount = TFStorageManager.getValueFromUserDefault(kUserDefaultKeys[8]);								   
			if(currentGiftsCount === null)
			{
				currentGiftsCount = 0;
				TFStorageManager.saveToUserDefault(kUserDefaultKeys[8], currentGiftsCount);
				//console.log("GameLayer NULL -> kUserDefaultKeys[8] -> "+kUserDefaultKeys[8]+ " -> currentGiftsCount -> "+currentGiftsCount);
			}
			var newGiftsCount = parseInt(giftsCount) - currentGiftsCount;
			//console.log("GameLayer -> kUserDefaultKeys[8] -> "+kUserDefaultKeys[8]+ " -> newGiftsCount -> "+newGiftsCount);
			
			if (newGiftsCount > 0)
			{
				var message = GALocalizationHandler.getRelativeString(Core.Localization.getString("SOCIAL_NEW_GIFTS_COUNT"),[newGiftsCount]);
		        
		        if(SocialManager.isSocialScreenShowing())
		        {
		        	console.log("GameLayer:showNewGiftsMessage-> Social Window showing!")

					var alertWindow = new TFMiniUIAlertView("",message,this,null,GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
			       	alertWindow.setTagValue(0003);
			        alertWindow.setMessageColor("FFFFFF");
					alertWindow.setMessageFont(TFUtil.getFontName());
					alertWindow.setButtonsFont(TFUtil.getFontName());
					alertWindow.setButtonColor("FFFFFF");
					alertWindow.show();

		        }
		        else
		        {
		        	console.log("GameLayer:showNewGiftsMessage-> Social Window not showing!")
			        var alertWindow = new TFMiniGLAlertView("",message,this,null,GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
			       	alertWindow.setTagValue(0003);
			        alertWindow.setMessageColor("FFFFFF");
					alertWindow.setMessageFont(TFUtil.getFont(),TFUtil.getFontLocation());
					alertWindow.setButtonsFont(TFUtil.getFont(),TFUtil.getFontLocation());
					alertWindow.setButtonColor("FFFFFF");
					alertWindow.show();
		        }   
		        
				
				currentGiftsCount = parseInt(currentGiftsCount)+ parseInt(newGiftsCount) ;
				TFStorageManager.saveToUserDefault(kUserDefaultKeys[8], currentGiftsCount);
				//console.log("GameLayer -> kUserDefaultKeys[8] -> "+kUserDefaultKeys[8]+ " -> currentGiftsCount -> "+currentGiftsCount);
			}
			
			//update the currentGiftCount incase its not synched with actualCurrentState of unaccepted gifts
			if(currentGiftsCount > parseInt(giftsCount))
			{
				//console.log("GameLayer -> kUserDefaultKeys[8] -> "+kUserDefaultKeys[8]+ " -> saved to -> "+parseInt(giftsCount));
				TFStorageManager.saveToUserDefault(kUserDefaultKeys[8], parseInt(giftsCount));
			}
			

		}
	},
	
	showGiftSentAcknowledgement:function(name)
	{
		if(name == null || name == 'undefined' || name.length == 0)
			return;
		
		var message = GALocalizationHandler.getRelativeString(Core.Localization.getString("SOCIAL_ACK_GIFT_SUCCESS"),[name]);
		var alertWindow = new SocialMiniUIAlertView("",message,this,null,GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
       	alertWindow.setTagValue(0003);
        alertWindow.setMessageColor("FFFFFF");
		alertWindow.setMessageFont(SocialUtil.getFontName());
		alertWindow.setButtonsFont(SocialUtil.getFontName());
		alertWindow.setButtonColor("FFFFFF");
		alertWindow.show();
	},
	
	showLevelUpScreenForLevel : function(level,xp,bonus)
	{
		var coinsAlert = "";
		if(bonus !=0)
		{
			coinsAlert = GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_LEVEL_UP_ALERT_WINDOW_FOR_COINS'),[bonus]);
		}
		TBParticleAnimation.getSnowParticleAnimation();  //Show Animation on GameLevel up
		
		var xpMessage = "";
		if (xp == 1){
			xpMessage = "xp";
		}
		else{
			xpMessage = "xps";
		}
		
		if(!TFGameState.atNeighbor){
//			var levelUpAlert = new TFMiniGLAlertView(/*GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_LEVEL_UP_HEADER'),[level])*/"",GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_LEVEL_UP_ALERT_WINDOW'),[level,coinsAlert,xp,xpMessage,level+1]),this,"",GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
//			
//			levelUpAlert._type=GALocalizationHandler.getLocalizedString('TF_OK_BUTTON');
//			levelUpAlert.setTagValue(0001);
//			levelUpAlert.setMessageColor(255,255,255);		
//			levelUpAlert.setMessageFont(TFUtil.getFont(),TFUtil.getFontLocation());
//			levelUpAlert.setButtonsFont(TFUtil.getFont(),TFUtil.getFontLocation());
//			levelUpAlert.show(); 
			
		//	var levelUpAlert = new TFMiniUIAlertView("",GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_LEVEL_UP_ALERT_WINDOW'),[level,coinsAlert,xp,xpMessage,level+1]),this,"",GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
			 var levelUpAlert = new GAUIAlertView("",GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_LEVEL_UP_ALERT_WINDOW'),[level,coinsAlert,xp,xpMessage,level+1]),this,null,Core.Localization.getString("OK"));
		   
			levelUpAlert.setType("ok");
			levelUpAlert.setTagValue(0001);
			levelUpAlert.setMessageColor("FFFFFF");		
			levelUpAlert.setMessageFont(TFUtil.getFontName());
			levelUpAlert.setButtonsFont(TFUtil.getFontName());
			levelUpAlert.setButtonColor("FFFFFF");
			levelUpAlert.show(); 

			var customAttributes = GAGameLoader.getResponseObject().getCustomAttributes();
		       
	      	var ratingLevel = customAttributes["showRatingLevel"];
			if(level == ratingLevel && Core.Capabilities.getPlatformOS() != 'iPhone OS')
			{
				this.rateGamePrompt();
			}
		}
	},
	    
	rateGamePrompt: function ()
	{
		var rateDialog = new UI.AlertDialog();
		    
		rateDialog.setTitle("Rate us!"); // Core.Localization.getString("Hello World")
		rateDialog.setText("Please give us 5 Stars and tell us what you think.");
		rateDialog.setChoices(["Sounds great", "No thanks"]);
		rateDialog.setOnChoice(function(event){
			switch(event.choice) {
				case 0:
					var marketUrl = "market://details?id=com.mobage.ww.a442.tapjurassic_android";
					Device.IPCEmitter.launch(marketUrl, function(error){
						console.log("rateGamePrompt: Error launching URL: " + marketUrl);
					});
				break;
			default:
			}
               // this.destroy();
		});
		rateDialog.show();
	},
	    
	    


//	clickedButtonAtIndex: function(buttonIndex,levelUpAlert)
//	{
//		
//		if (buttonIndex == 0) 
//		{
//			switch(levelUpAlert.getTagValue())
//			{
//				case 0001:
//				{
//					
//				}
//				default:
//				{
//					
//				}
//			}
//			
//		}
//		else if (buttonIndex == 1) 
//		{
//			this.destroy();
//		}
//		
//	},


//	clickedButtonAtIndex: function(buttonIndex,levelUpAlert)
//	{
//		
//		if (buttonIndex == 0) 
//		{
//			switch(levelUpAlert.getTagValue())
//			{
//				case 0001:
//				{
//					
//				}
//				default:
//				{
//					
//				}
//			}
//			
//		}
//		else if (buttonIndex == 1) 
//		{
//			this.destroy();
//		}
//		
//	},

	getSelectedTank: function()
	{
		return this._selectedTank;
	},
	
	getControlLayer:function()
	{
		return this._controlLayer;
	},
									  
	startGame:function()
	{	
		//added for tutorial window
		var notFirstRun = TFStorageManager.getValueFromUserDefault(kUserDefaultKeys[0]);
		
		/////////////////////////////////////////
		if(this._controlLayer) {
			//this._GLNode.removeChild(this._controlLayer);
			this._controlLayer.destroy();
			this._controlLayer = null;
		}
		this._controlLayer = new TFControlLayer();
		if(!TFGameState.atNeighbor){
			this._controlLayer.fetchEnvelopNotifications();
		}
		this._GLNode.addChild(this._controlLayer);
		/////////////////////////////////////////
		if(!notFirstRun || notFirstRun == 'false'){
			TFStorageManager.saveToUserDefault(kUserDefaultKeys[0], false);
			notFirstRun = false;
		}
		//added for tutorial window
		if(notFirstRun === false){
			this._tutorial = new TutorialWindow();	
			this._controlLayer.addChild(this._tutorial);
			TFStorageManager.saveToUserDefault(kUserDefaultKeys[0], true);
			
		}
		
		var manifestDownloaded = TFStorageManager.getValueFromUserDefault(kUserDefaultKeys[6]);
		if(!manifestDownloaded)
			GameCentralHandler.loadSecondaryManifest();
		else
			GameCentralHandler.showCommunityButton();
		
	},

	destroy: function()
	{
		this.releaseTutorialWindow();		
	},
	
	destroyTank: function()
	{
		this._GLNode.removeChild(this._selectedTank);
		this._selectedTank.destroy();
		this._selectedTank = null;
	},
	
	onTouchStore: function()
	{
		var storeWindowLayer = new StoreWindow();  
		storeWindowLayer.createMenu();
		this.addChild(storeWindowLayer);
   
	},
	
	
	updateControlLayer: function () {
		if(this._controlLayer) {
			this._controlLayer.updateRating();
		}
	},
										 
	// GAGLAlert window call back									 
	 clickedButtonAtIndex: function(buttonIndex,alertWindow)
	 {
	  
		 switch (alertWindow.getTagValue()) {
		 	case  kAlertWindowType.kAlertWindowSellAllFish:
		 		console.log("kAlertWindowSellAllFish");
				if(buttonIndex==0)
				{	 
					console.log("kAlertWindowSellAllFishOK");
					this._selectedTank.sellAllAdultFish();
				}
				break;
				 
				default:
				return;
				 
		 	}
	 
	 },
	
	releaseTutorialWindow : function()
	{
		if(this._tutorial)
		{
			this._controlLayer.removeChild(this._tutorial);
			this._tutorial.destroy();
			this._tutorial = null;
		}
	},									 
	
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/GLLayer/StoreWindow'] = function(){var exports = $MODULE_REGISTRY['Code/GLLayer/StoreWindow'] || {}; $MODULE_REGISTRY['Code/GLLayer/StoreWindow'] = exports; 
/**
* Filename: StoreWindow.js
 * Author: Kamran Lodhi
 * Date Created: 20th May-2011
 * Date Updated: 
// The Main Store Window Class
 */


exports.StoreWindow = GL2.Node.subclass({
classname: 'StoreWindow',
	
	initialize: function($super,parent) 
	{
		$super();
		var SCREEN_HEIGHT = Core.Capabilities.getScreenWidth();
		var SCREEN_WIDTH = Core.Capabilities.getScreenHeight();
		this.myMessageListener = new Core.MessageListener();
		var touchTarget = new GL2.TouchTarget();
		touchTarget.setSize(SCREEN_WIDTH,SCREEN_HEIGHT);
		touchTarget.setAnchor(0,0);
		touchTarget.getTouchEmitter().addListener(this.myMessageListener, this.swallowTouches.bind(this));
		touchTarget.setDepth(1);
		this.addChild(touchTarget);	
		
		this.destination = null;
		this.moveBack = null;
		this.scaleTo = null;							 
		this.isAnimating=true;	
		this.areButtonsEnabled = true;
		this.parent = parent;
				
	},
	swallowTouches: function(touch)
	{
		return true;
	},
	
	disableButtons:function()
	{
		this.areButtonsEnabled = false;
	},
	
	enableButtons:function()
	{
		this.areButtonsEnabled = true;
	},
	
	show: function() {
		this.enableButtons();
		if(this.isAnimating)
		{
			this.callAnimation();
		}
		this.parent.addChild(this);
		

     	var incX = 0;
     	var incY = 0;
   
      if(SCREEN_ASPECT_RATIO == AspectRatios.Ratio171)
      {
      	 incX = 28; 
      	 incY = 4;
      }
      else if (SCREEN_ASPECT_RATIO == AspectRatios.Ratio160)
      {
      	 incX = 80; 
      	 incY = 20;
      }
			GAMobclixForView.show(TFUtil.getAdjustedY(96 + incX),TFUtil.getAdjustedX(232 +incY));
// NGWindow.document.addChild(this._mobclix);
//		}
		
	},
	
	hide: function() {
		this.parent.removeChild(this);
	},
	
	createMenu: function()
	{
		
		this._background = new GLFactory.getSprite([TFUtil.getAdjustedY(240),TFUtil.getAdjustedX(170)],100,'./Content/images/Store/Storebackground.png',[TFUtil.getAdjustedY(445),TFUtil.getAdjustedX(255)],[0.5,0.5]);
		this.addChild(this._background);

		var crossButton = new GLButton('./Content/images/Store/cross_normal.png','./Content/images/Store/cross_selected.png',TFUtil.adjustHeightWithDevice(34), TFUtil.adjustWidthWithDevice(36),this.crossClicked.bind(this),this._background,100);  //TFUtil.adjustWidthWithDevice(34)
		crossButton.setPosition(TFUtil.getAdjustedY(220),TFUtil.getAdjustedX(-100));

		var storeText = new GLFactory.getText([TFUtil.getAdjustedY(-90),TFUtil.getAdjustedX(-140)],0,GALocalizationHandler.getLocalizedString('TF_MSG_MY_AQUARIUM'),[TFUtil.getAdjustedY(189),TFUtil.getAdjustedX(55)],TFUtil.getAdjustedFontSize(150));
		storeText.setAnchor(0,0);
		storeText.setDepth(100);
		storeText.setColor(new Core.Color([0, 0, 0.5]));	
		storeText.setFontLocation(TFUtil.getFontLocation());
		storeText.setFontFamily(TFUtil.getFont());
		this._background.addChild(storeText);	
				
		var pointerButton = new GLButton('./Content/images/Store/pointer.png','./Content/images/Store/pointer_over.png',TFUtil.adjustHeightWithDevice(60), TFUtil.adjustWidthWithDevice(60),this.pointerClicked.bind(this),this._background,100,GALocalizationHandler.getLocalizedString('TF_STORE_TEXT_MENU'),new Core.Color(1,1,1),new Core.Color(1,1,1),null,TFUtil.getAdjustedFontSize(80));
		pointerButton.setPosition(TFUtil.getAdjustedY(-175),TFUtil.getAdjustedX(-50));
		pointerButton.setTextFont(TFUtil.getFont(),TFUtil.getFontLocation());
		pointerButton.buttonText.setPosition([TFUtil.getAdjustedX(0),TFUtil.getAdjustedY(-15)]);
		
		var foodButton = new GLButton('./Content/images/Store/food_normal.png','./Content/images/Store/food_over.png',TFUtil.adjustHeightWithDevice(60), TFUtil.adjustWidthWithDevice(60),this.foodClicked.bind(this),this._background,100,GALocalizationHandler.getLocalizedString('TF_STORE_TEXT_FOOD'),new Core.Color(1,1,1),new Core.Color(1,1,1),null,TFUtil.getAdjustedFontSize(80));
		foodButton.setPosition(TFUtil.getAdjustedY(-105),TFUtil.getAdjustedX(-50));
		foodButton.setTextFont(TFUtil.getFont(),TFUtil.getFontLocation());
		foodButton.buttonText.setPosition([TFUtil.getAdjustedX(0),TFUtil.getAdjustedY(-15)]);
		
		if(!TFGameState.atNeighbor){
			var eggButton = new GLButton('./Content/images/Store/egge.png','./Content/images/Store/egge_over.png',TFUtil.adjustHeightWithDevice(60), TFUtil.adjustWidthWithDevice(60),this.eggClicked.bind(this),this._background,100,GALocalizationHandler.getLocalizedString('TF_TITLE_FISH_EGGS'),new Core.Color(1,1,1),new Core.Color(1,1,1),null,TFUtil.getAdjustedFontSize(80));
			eggButton.setPosition(TFUtil.getAdjustedY(-35),TFUtil.getAdjustedX(-50));
			eggButton.setTextFont(TFUtil.getFont(),TFUtil.getFontLocation());
			eggButton.buttonText.setPosition([TFUtil.getAdjustedX(0),TFUtil.getAdjustedY(-15)]);
			
			var breedButton = new GLButton('./Content/images/Store/breed.png','./Content/images/Store/breed_over.png',TFUtil.adjustHeightWithDevice(60), TFUtil.adjustWidthWithDevice(60),this.breedClicked.bind(this),this._background,100,GALocalizationHandler.getLocalizedString('TF_STORE_TEXT_BREED'),new Core.Color(1,1,1),new Core.Color(1,1,1),null,TFUtil.getAdjustedFontSize(80));
			breedButton.setPosition(TFUtil.getAdjustedY(35),TFUtil.getAdjustedX(-50));
			breedButton.setTextFont(TFUtil.getFont(),TFUtil.getFontLocation());
			breedButton.buttonText.setPosition([TFUtil.getAdjustedX(0),TFUtil.getAdjustedY(-15)]);
			
			var storeButton = new GLButton('./Content/images/Store/store.png','./Content/images/Store/store_over.png',TFUtil.adjustHeightWithDevice(60), TFUtil.adjustWidthWithDevice(60),this.storeClicked.bind(this),this._background,100,GALocalizationHandler.getLocalizedString('TF_MSG_STORE'),new Core.Color(1,1,1),new Core.Color(1,1,1),null,TFUtil.getAdjustedFontSize(80));
			storeButton.setPosition(TFUtil.getAdjustedY(105),TFUtil.getAdjustedX(-50));
			storeButton.setTextFont(TFUtil.getFont(),TFUtil.getFontLocation());
			storeButton.buttonText.setPosition([TFUtil.getAdjustedX(0),TFUtil.getAdjustedY(-15)]);
			
			var sellButton = new GLButton('./Content/images/Store/sell.png','./Content/images/Store/sell_over.png',TFUtil.adjustHeightWithDevice(60), TFUtil.adjustWidthWithDevice(60),this.sellAllClicked.bind(this),this._background,100,GALocalizationHandler.getLocalizedString('TF_SELL_TEXT'),new Core.Color(1,1,1),new Core.Color(1,1,1),null,TFUtil.getAdjustedFontSize(80));
			sellButton.setPosition(TFUtil.getAdjustedY(175),TFUtil.getAdjustedX(-50));
			sellButton.setTextFont(TFUtil.getFont(),TFUtil.getFontLocation());
			sellButton.buttonText.setPosition([TFUtil.getAdjustedX(0),TFUtil.getAdjustedY(-15)]);
			
			var loveButton = new GLButton('./Content/images/Store/love.png','./Content/images/Store/love_over.png',TFUtil.adjustHeightWithDevice(60), TFUtil.adjustWidthWithDevice(60),this.loveClicked.bind(this),this._background,100,GALocalizationHandler.getLocalizedString('TF_STORE_TEXT_LOVE'),new Core.Color(1,1,1),new Core.Color(1,1,1),null,TFUtil.getAdjustedFontSize(80));
			loveButton.setPosition(TFUtil.getAdjustedY(-175),TFUtil.getAdjustedX(20));
			loveButton.setTextFont(TFUtil.getFont(),TFUtil.getFontLocation());
			loveButton.buttonText.setPosition([TFUtil.getAdjustedX(0),TFUtil.getAdjustedY(-15)]);
														
			var trophiesButton = new GLButton('./Content/images/Store/trophies.png','./Content/images/Store/trophies_over.png',TFUtil.adjustHeightWithDevice(60), TFUtil.adjustWidthWithDevice(60),this.trophiesClicked.bind(this),this._background,100,GALocalizationHandler.getLocalizedString('TF_STORE_TEXT_TROPHIES'),new Core.Color(1,1,1),new Core.Color(1,1,1),null,TFUtil.getAdjustedFontSize(80));
			trophiesButton.setPosition(TFUtil.getAdjustedY(-35),TFUtil.getAdjustedX(20));
			trophiesButton.setTextFont(TFUtil.getFont(),TFUtil.getFontLocation());
			trophiesButton.buttonText.setPosition([TFUtil.getAdjustedX(0),TFUtil.getAdjustedY(-15)]);
					
			var socialButton = new GLButton('./Content/images/Store/social.png','./Content/images/Store/social_over.png',TFUtil.adjustHeightWithDevice(60), TFUtil.adjustWidthWithDevice(60),this.socialClicked.bind(this),this._background,100,GALocalizationHandler.getLocalizedString('TF_STORE_TEXT_SOCIAL'),new Core.Color(1,1,1),new Core.Color(1,1,1),null,TFUtil.getAdjustedFontSize(80));
			socialButton.setPosition(TFUtil.getAdjustedY(35),TFUtil.getAdjustedX(20));
			socialButton.setTextFont(TFUtil.getFont(),TFUtil.getFontLocation());
			socialButton.buttonText.setPosition([TFUtil.getAdjustedX(0),TFUtil.getAdjustedY(-15)]);
			
			var coinsButton = new GLButton('./Content/images/Store/coins.png','./Content/images/Store/coins_over.png',TFUtil.adjustHeightWithDevice(60), TFUtil.adjustWidthWithDevice(60),this.coinsClicked.bind(this),/*this*/ this._background,100,GALocalizationHandler.getLocalizedString('TF_MESSAGE_COINS_WITH_CAPITAL_C'),new Core.Color(1,1,1),new Core.Color(1,1,1),null,TFUtil.getAdjustedFontSize(80));
			coinsButton.setPosition(TFUtil.getAdjustedY(105),TFUtil.getAdjustedX(20));
			coinsButton.setTextFont(TFUtil.getFont(),TFUtil.getFontLocation());
			coinsButton.buttonText.setPosition([TFUtil.getAdjustedX(0),TFUtil.getAdjustedY(-15)]);
			
			var bucksButton = new GLButton('./Content/images/Store/fishBucks.png','./Content/images/Store/fishBucks_over.png',TFUtil.adjustHeightWithDevice(60), TFUtil.adjustWidthWithDevice(60),this.bucksClicked.bind(this),this._background,100,GALocalizationHandler.getLocalizedString('TF_STORE_TEXT_BUCKS'),new Core.Color(1,1,1),new Core.Color(1,1,1),null,TFUtil.getAdjustedFontSize(80));
			bucksButton.setPosition(TFUtil.getAdjustedY(175),TFUtil.getAdjustedX(20));
			bucksButton.setTextFont(TFUtil.getFont(),TFUtil.getFontLocation());
			bucksButton.buttonText.setPosition([TFUtil.getAdjustedX(0),TFUtil.getAdjustedY(-15)]);

		} else {
			var eggButton = new GLButton('./Content/images/Store/egge_dis.png','./Content/images/Store/egge_dis.png',TFUtil.adjustHeightWithDevice(60), TFUtil.adjustWidthWithDevice(60),this.clickedAtNeighbor.bind(this),this._background,100,GALocalizationHandler.getLocalizedString('TF_TITLE_FISH_EGGS'),new Core.Color(1,1,1),new Core.Color(1,1,1),null,TFUtil.getAdjustedFontSize(80));
			eggButton.setPosition(TFUtil.getAdjustedY(-35),TFUtil.getAdjustedX(-50));
			eggButton.setTextFont(TFUtil.getFont(),TFUtil.getFontLocation());
			eggButton.buttonText.setPosition([TFUtil.getAdjustedX(0),TFUtil.getAdjustedY(-15)]);
			
			var breedButton = new GLButton('./Content/images/Store/breed_dis.png','./Content/images/Store/breed_dis.png',TFUtil.adjustHeightWithDevice(60), TFUtil.adjustWidthWithDevice(60),this.clickedAtNeighbor.bind(this),this._background,100,GALocalizationHandler.getLocalizedString('TF_STORE_TEXT_BREED'),new Core.Color(1,1,1),new Core.Color(1,1,1),null,TFUtil.getAdjustedFontSize(80));
			breedButton.setPosition(TFUtil.getAdjustedY(35),TFUtil.getAdjustedX(-50));
			breedButton.setTextFont(TFUtil.getFont(),TFUtil.getFontLocation());
			breedButton.buttonText.setPosition([TFUtil.getAdjustedX(0),TFUtil.getAdjustedY(-15)]);
			
			var storeButton = new GLButton('./Content/images/Store/store_dis.png','./Content/images/Store/store_dis.png',TFUtil.adjustHeightWithDevice(60), TFUtil.adjustWidthWithDevice(60),this.clickedAtNeighbor.bind(this),this._background,100,GALocalizationHandler.getLocalizedString('TF_MSG_STORE'),new Core.Color(1,1,1),new Core.Color(1,1,1),null,TFUtil.getAdjustedFontSize(80));
			storeButton.setPosition(TFUtil.getAdjustedY(105),TFUtil.getAdjustedX(-50));
			storeButton.setTextFont(TFUtil.getFont(),TFUtil.getFontLocation());
			storeButton.buttonText.setPosition([TFUtil.getAdjustedX(0),TFUtil.getAdjustedY(-15)]);
			
			var sellButton = new GLButton('./Content/images/Store/sell_dis.png','./Content/images/Store/sell_dis.png',TFUtil.adjustHeightWithDevice(60), TFUtil.adjustWidthWithDevice(60),this.clickedAtNeighbor.bind(this),this._background,100,GALocalizationHandler.getLocalizedString('TF_SELL_TEXT'),new Core.Color(1,1,1),new Core.Color(1,1,1),null,TFUtil.getAdjustedFontSize(80));
			sellButton.setPosition(TFUtil.getAdjustedY(175),TFUtil.getAdjustedX(-50));
			sellButton.setTextFont(TFUtil.getFont(),TFUtil.getFontLocation());
			sellButton.buttonText.setPosition([TFUtil.getAdjustedX(0),TFUtil.getAdjustedY(-15)]);
			
			var loveButton = new GLButton('./Content/images/Store/love_dis.png','./Content/images/Store/love_dis.png',TFUtil.adjustHeightWithDevice(60), TFUtil.adjustWidthWithDevice(60),this.clickedAtNeighbor.bind(this),this._background,100,GALocalizationHandler.getLocalizedString('TF_STORE_TEXT_LOVE'),new Core.Color(1,1,1),new Core.Color(1,1,1),null,TFUtil.getAdjustedFontSize(80));
			loveButton.setPosition(TFUtil.getAdjustedY(-175),TFUtil.getAdjustedX(20));
			loveButton.setTextFont(TFUtil.getFont(),TFUtil.getFontLocation());
			loveButton.buttonText.setPosition([TFUtil.getAdjustedX(0),TFUtil.getAdjustedY(-15)]);
														
			var trophiesButton = new GLButton('./Content/images/Store/trophies_dis.png','./Content/images/Store/trophies_dis.png',TFUtil.adjustHeightWithDevice(60), TFUtil.adjustWidthWithDevice(60),this.clickedAtNeighbor.bind(this),this._background,100,GALocalizationHandler.getLocalizedString('TF_STORE_TEXT_TROPHIES'),new Core.Color(1,1,1),new Core.Color(1,1,1),null,TFUtil.getAdjustedFontSize(80));
			trophiesButton.setPosition(TFUtil.getAdjustedY(-35),TFUtil.getAdjustedX(20));
			trophiesButton.setTextFont(TFUtil.getFont(),TFUtil.getFontLocation());
			trophiesButton.buttonText.setPosition([TFUtil.getAdjustedX(0),TFUtil.getAdjustedY(-15)]);
					
			var socialButton = new GLButton('./Content/images/Store/social_dis.png','./Content/images/Store/social_dis.png',TFUtil.adjustHeightWithDevice(60), TFUtil.adjustWidthWithDevice(60),this.clickedAtNeighbor.bind(this),this._background,100,GALocalizationHandler.getLocalizedString('TF_STORE_TEXT_SOCIAL'),new Core.Color(1,1,1),new Core.Color(1,1,1),null,TFUtil.getAdjustedFontSize(80));
			socialButton.setPosition(TFUtil.getAdjustedY(35),TFUtil.getAdjustedX(20));
			socialButton.setTextFont(TFUtil.getFont(),TFUtil.getFontLocation());
			socialButton.buttonText.setPosition([TFUtil.getAdjustedX(0),TFUtil.getAdjustedY(-15)]);
			
			var coinsButton = new GLButton('./Content/images/Store/coins_dis.png','./Content/images/Store/coins_dis.png',TFUtil.adjustHeightWithDevice(60), TFUtil.adjustWidthWithDevice(60),this.clickedAtNeighbor.bind(this),/*this*/ this._background,100,GALocalizationHandler.getLocalizedString('TF_MESSAGE_COINS_WITH_CAPITAL_C'),new Core.Color(1,1,1),new Core.Color(1,1,1),null,TFUtil.getAdjustedFontSize(80));
			coinsButton.setPosition(TFUtil.getAdjustedY(105),TFUtil.getAdjustedX(20));
			coinsButton.setTextFont(TFUtil.getFont(),TFUtil.getFontLocation());
			coinsButton.buttonText.setPosition([TFUtil.getAdjustedX(0),TFUtil.getAdjustedY(-15)]);
			
			var bucksButton = new GLButton('./Content/images/Store/fishBucks_dis.png','./Content/images/Store/fishBucks_dis.png',TFUtil.adjustHeightWithDevice(60), TFUtil.adjustWidthWithDevice(60),this.clickedAtNeighbor.bind(this),this._background,100,GALocalizationHandler.getLocalizedString('TF_STORE_TEXT_BUCKS'),new Core.Color(1,1,1),new Core.Color(1,1,1),null,TFUtil.getAdjustedFontSize(80));
			bucksButton.setPosition(TFUtil.getAdjustedY(175),TFUtil.getAdjustedX(20));
			bucksButton.setTextFont(TFUtil.getFont(),TFUtil.getFontLocation());
			bucksButton.buttonText.setPosition([TFUtil.getAdjustedX(0),TFUtil.getAdjustedY(-15)]);

		}

		var cleanButton = new GLButton('./Content/images/Store/clean.png','./Content/images/Store/clean_over.png',TFUtil.adjustHeightWithDevice(60), TFUtil.adjustWidthWithDevice(60),this.cleanClicked.bind(this),this._background,100,GALocalizationHandler.getLocalizedString('TF_STORE_TEXT_CLEAN'),new Core.Color(1,1,1),new Core.Color(1,1,1),null,TFUtil.getAdjustedFontSize(80));
		cleanButton.setPosition(TFUtil.getAdjustedY(-105),TFUtil.getAdjustedX(20));
		cleanButton.setTextFont(TFUtil.getFont(),TFUtil.getFontLocation());
		cleanButton.buttonText.setPosition([TFUtil.getAdjustedX(0),TFUtil.getAdjustedY(-15)]);
															
		var aboutUsButton = new GLButton('./Content/images/Store/AboutUs/aboutUs_button.png','./Content/images/Store/AboutUs/aboutUs_buttonOver.png',TFUtil.adjustHeightWithDevice(60), TFUtil.adjustWidthWithDevice(60),this.aboutUsCallBackFunction.bind(this),this._background,100,GALocalizationHandler.getLocalizedString('TF_ABOUT_TAP_FISH'),new Core.Color(1,1,1),new Core.Color(1,1,1),[TFUtil.adjustHeightWithDevice(50), TFUtil.adjustWidthWithDevice(50)],TFUtil.getAdjustedFontSize(75));
		aboutUsButton.setPosition(TFUtil.getAdjustedY(180),TFUtil.getAdjustedX(90));
		aboutUsButton.setTextFont(TFUtil.getFont(),TFUtil.getFontLocation());
		aboutUsButton.buttonText.setPosition([TFUtil.getAdjustedX(0),TFUtil.getAdjustedY(10)]);
		
		var helpButton = new GLButton('./Content/images/Store/helpButton.png','./Content/images/Store/helpButtonSelected.png',TFUtil.adjustHeightWithDevice(60), TFUtil.adjustWidthWithDevice(60),this.tapFishHelp.bind(this),this._background,100,GALocalizationHandler.getLocalizedString('TF_HELP_TAP_FISH'),new Core.Color(1,1,1),new Core.Color(1,1,1),null,TFUtil.getAdjustedFontSize(75));
		helpButton.setPosition(TFUtil.getAdjustedY(-180),TFUtil.getAdjustedX(90));
		helpButton.setTextFont(TFUtil.getFont(),TFUtil.getFontLocation());
		helpButton.buttonText.setPosition([TFUtil.getAdjustedX(0),TFUtil.getAdjustedY(10)]);
		
										
		},
		
	   callAnimation: function()
	  {
		this.moveBack = new Core.Vector(0.98,0.98);  
		this.destination = new Core.Vector(0,0);
		console.log("start scaling store  "+this.destination);
		this.isAnimating=false;
		this.scaleTo = new GAScaleTo(this._background,this.destination,2,true,this.callBackOnStart.bind(this));
	  },

	  callBackOnStart:function()
	  {
		this.scaleTo = new GAScaleTo(this._background,this.moveBack,200,true,this.stop.bind(this));
		console.log("comes here at callBack on start store");
	  },
	 
	  stop:function()
	  {
		this.isAnimating=true;
		console.log("comes here at stop store");	
	  },

	  callBack:function()
	  {
		console.log("on reverse start store"+this.destination);							 
		this.scaleTo = new GAScaleTo(this._background,this.moveBack,200,true,this.callBackOnClose.bind(this));
	  },

	  callBackOnClose:function()
	  {
		this.moveTo = new GAScaleTo(this._background,this.destination,200,true,this.hide.bind(this));
	  },
                                                 
	changeToPointer: function()
	{
		
		GameLayer.getControlLayer().setImageForStoreButton('Content/images/MenuButtons/arrowforgreencircle.png','Content/images/MenuButtons/arrowforgreencircle.png'); 
		try
		{
			var currentTankAction = kTankActionType.kTankActionArrow;
			GameLayer.getSelectedTank().setCurrentTankAction(currentTankAction);
					}
		catch(exception)
		{
			console.log("tankAction..."+e);
		}
		
	},
	
	tapFishHelp : function()
	{	
		if(TFGameState.atNeighbor)
		{
			return;
		}
		
		if(this.areButtonsEnabled == false)
		{
			return;
		}
		
		this.disableButtons();
		TFStorageManager.saveToUserDefault("storeWindowOption","help");
		this.crossClicked();
		var helpPage = new HelpPage();
		helpPage.show();
		GameLayer._GLNode.addChild(helpPage);
		
	},
	
	aboutUsCallBackFunction:function()
	{
		if(TFGameState.atNeighbor)
		{
			return;
		}

		if(this.areButtonsEnabled == false)
		{
			return;
		}
		
		this.disableButtons();
		TFStorageManager.saveToUserDefault("storeWindowOption","aboutus");
		this.crossClicked();
		var aboutUsWindow = new AboutUs();
		aboutUsWindow.aboutUs();
		GameLayer._GLNode.addChild(aboutUsWindow);
	},

	sellAllClicked: function()
	{
		if(this.areButtonsEnabled == false)
		{
			return;
		}
		
		this.disableButtons();
		TFStorageManager.saveToUserDefault("storeWindowOption","sell");
		this.crossClicked();

		var selectedTank=TFGameState.getCurrentUser()._tankObj;
		if(!selectedTank._tankObj.isTankLocked)
		{ 
			if(selectedTank.getAllAdultFishCount() == 0)
			{
				var myString = GALocalizationHandler.getLocalizedString('TF_NO_ADULT_ALERT');
				console.log(myString);
				var alertWindow = new TFMiniGLAlertView("",myString,this,GALocalizationHandler.getLocalizedString('TF_CANCEL_BUTTON'),GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
				alertWindow.setTagValue(kAlertWindowType.kAlertWindowCustom);
				alertWindow.setMessageColor(255,255,255);						
				alertWindow.setMessageFont(TFUtil.getFont(),TFUtil.getFontLocation());
				alertWindow.setButtonsFont(TFUtil.getFont(),TFUtil.getFontLocation());
				alertWindow.show();    
			}
			else
			{
				var myString = GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_SELL_ALL_ALERT'), [ selectedTank.getAllAdultFishCount(),  selectedTank.getAllAdultFishPriceWithHappinessAndTax()]);
				console.log(myString);
				var alertWindow = new TFMiniGLAlertView("",myString,GameLayer,GALocalizationHandler.getLocalizedString('TF_CANCEL_BUTTON'),GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
				alertWindow._type="okwithcancel";
				alertWindow.setTagValue(kAlertWindowType.kAlertWindowSellAllFish);
				alertWindow.setMessageColor(255,255,255);
				alertWindow.setMessageFont(TFUtil.getFont(),TFUtil.getFontLocation());
				alertWindow.setButtonsFont(TFUtil.getFont(),TFUtil.getFontLocation());
				alertWindow.show();        
			}
		}
		else
		{
			var myString = GALocalizationHandler.getLocalizedString('TF_TANK_FISH_LOCKED_ALERT');
			console.log(myString);
			var alertWindow = new TFMiniGLAlertView("",myString,this,GALocalizationHandler.getLocalizedString('TF_CANCEL_BUTTON'),GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
			alertWindow.setTagValue(kAlertWindowType.kAlertWindowCustom);
			alertWindow.setMessageColor(255,255,255);
			alertWindow.setMessageFont(TFUtil.getFont(),TFUtil.getFontLocation());
			alertWindow.setButtonsFont(TFUtil.getFont(),TFUtil.getFontLocation());
			alertWindow.show();    
		}
		
		
	},   
	
	clickedAtNeighbor: function()
	{
		return;
	},    


	storeClicked: function()
	{
		if(this.areButtonsEnabled == false)
		{
			return;
		}
		
		this.disableButtons();
		TFStorageManager.saveToUserDefault("storeWindowOption","store");
		this.crossClicked();
		
		
		var storeMainView = new StoreMainView();
		NGWindow.document.addChild(storeMainView);
		this.changeToPointer();									
	},    
	loveClicked: function()
	{
		if(this.areButtonsEnabled == false)
		{
			return;
		}
		
		this.disableButtons();
		TFStorageManager.saveToUserDefault("storeWindowOption","love");
		this.crossClicked();
		
		this.changeToPointer();                               
		
	//	this.changeToPointer();                               

		if(TFGameState.getCurrentUser()._tankObj.loveFish())
		{

			TBParticleAnimation.getSnowParticleAnimation() ;
			var myString = GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_FISH_LOVE_BUCKS_ALERT_OK'), [ TF_Love_BONUS_COINS, TF_Love_BONUS_XP]);
			this._alertWindow = new TFMiniGLAlertView("",myString,this,GALocalizationHandler.getLocalizedString('TF_CANCEL_BUTTON'),GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
			this._alertWindow.setTagValue(111);
			this._alertWindow.setMessageColor(255,255,255);
			this._alertWindow.setMessageFont(TFUtil.getFont(),TFUtil.getFontLocation());
			this._alertWindow.setButtonsFont(TFUtil.getFont(),TFUtil.getFontLocation());
			this._alertWindow.show();                                
		}
		else
		{
			var myString = GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_FISH_LOVE_BUCKS_ALERT_CANCELL'), [ TF_LOVE_TIME_DIFF/3600]);
			this._alertWindow = new TFMiniGLAlertView("",myString,this,GALocalizationHandler.getLocalizedString('TF_CANCEL_BUTTON'),GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
			this._alertWindow.setTagValue(1111);
			this._alertWindow.setMessageColor(255,255,255);
			this._alertWindow.setMessageFont(TFUtil.getFont(),TFUtil.getFontLocation());
			this._alertWindow.setButtonsFont(TFUtil.getFont(),TFUtil.getFontLocation());
			this._alertWindow.show();                                
		}
		
	},

	clickedButtonAtIndex: function(buttonIndex,alertWindow)
	{
	},

	crossClicked: function()
	{
		
		var storeWindowOption = TFStorageManager.getValueFromUserDefault("storeWindowOption");
		//check whether clean sound should be played or not (i.e, after the store menu closes)
		if(storeWindowOption !=null && storeWindowOption ==='clean') 
		{
		    GAAudioManager.setCleanMusicPath(SQUEAK_CLEAN_SOUND_NAME1);
		}
		else
		{
			if(GAAudioManager.isCleanSoundEnabled()){
				GAAudioManager.disableCleanSound();
			}
		}
				
		var myParent = this.getParent();
		if(myParent){
//			if(GameLayer._mobclixState)
//			{
				//NGWindow.document.removeChild(this._mobclix);
				GAMobclixForView.removeAd();
//			}
			myParent.enableButtons();
			this.callBack();
		}
		return true;
	},
	
	foodClicked:function()
	{
		if(this.areButtonsEnabled == false)
		{
			return;
		}
		
		this.disableButtons();
		TFStorageManager.saveToUserDefault("storeWindowOption","food");
		this.crossClicked();
		
		GameLayer.getControlLayer().setImageForStoreButton('Content/images/MenuButtons/foodButton.png','Content/images/MenuButtons/foodButton.png'); 

		var tankUI = GameLayer.getSelectedTank();
		tankUI.setCurrentTankAction(kTankActionType.kTankActionFood);
		
	},

	cleanClicked:function()
	{
		if(this.areButtonsEnabled == false)
		{
			return;
		}
		
		this.disableButtons();
		TFStorageManager.saveToUserDefault("storeWindowOption","clean");
		this.crossClicked();
		GameLayer.getControlLayer().setImageForStoreButton('Content/images/MenuButtons/cleanButton.png','Content/images/MenuButtons/cleanButton.png');
		var tankUI = GameLayer.getSelectedTank();
		tankUI.setCurrentTankAction(kTankActionType.kTankActionSponge);
		
		//save click
	},
	
	pointerClicked:function()
	{
		if(this.areButtonsEnabled == false)
		{
			return;
		}
		
		this.disableButtons();
		TFStorageManager.saveToUserDefault("storeWindowOption","pointer");
		this.crossClicked();
		//save click
		
		GameLayer.getControlLayer().setImageForStoreButton('Content/images/MenuButtons/arrowforgreencircle.png','Content/images/MenuButtons/arrowforgreencircle.png'); 
		try
		{
			var currentTankAction = kTankActionType.kTankActionArrow;
			GameLayer.getSelectedTank().setCurrentTankAction(currentTankAction);
		}
		catch(exception)
		{
			console.log("tankAction..."+exception);
		}
			
	},
	eggClicked:function()  
	{
		if(this.areButtonsEnabled == false)
		{
			return;
		}
		
		this.disableButtons();
		TFStorageManager.saveToUserDefault("storeWindowOption","egg");
		this.crossClicked();
	
		var storeMainView = new StoreMainView(true);
		storeMainView.setStoreType(TFStoreType.kFishEggs);
		NGWindow.document.addChild(storeMainView);    
		
	},
											
	breedClicked:function() 
	{

		if(this.areButtonsEnabled == false)
		{
			return;
		}
		
		this.disableButtons();
		TFStorageManager.saveToUserDefault("storeWindowOption","breed");
		this.crossClicked();
		var breed = new BreedFishUI();  
		GameLayer._GLNode.addChild(breed);
		
	},

	bucksClicked:function()
	{
		if(this.areButtonsEnabled == false)
		{
			return;
		}
		
		this.disableButtons();
		TFStorageManager.saveToUserDefault("storeWindowOption","bucks");
		this.crossClicked();
		
		var inAppMainView = new InAppMainView(true);
		NGWindow.document.addChild(inAppMainView);
		
	},

	coinsClicked:function()
	{
		if(this.areButtonsEnabled == false)
		{
			return;
		}
		
		this.disableButtons();
		TFStorageManager.saveToUserDefault("storeWindowOption","coins");
		this.crossClicked();
		var inAppMainView = new InAppMainView(false);
		NGWindow.document.addChild(inAppMainView);
	},
	
	trophiesClicked: function()
	{
		if(this.areButtonsEnabled == false)
		{
			return;
		}
		this.disableButtons();
		TFStorageManager.saveToUserDefault("storeWindowOption","trophies");
		this.crossClicked();
		
		TFUtil.populatebreededFishKeysDictionary();
        var trophyMainView = new TrophyMainView();
		NGWindow.document.addChild(trophyMainView);   	
		
		
	},
	
	socialClicked: function()
	{
		if(this.areButtonsEnabled == false)
		{
			return;
		}
		
		this.disableButtons();
		TFStorageManager.saveToUserDefault("storeWindowOption","social");
		this.crossClicked();
		SocialManager.showSocialScreen(GameLayer._GLNode,kSocialUIType.FRIENDSUI,TFGameState.atNeighbor);
		

//		GameCentralHandler.startGameLoadingScreen();
//		setTimeout(this.getNeighborGameStateTimeOut.bind(this),500);	
		
	},
	
//	getNeighborGameStateTimeOut: function()
//	{
//		//console.log(">>>>>>>getNeighborGameState");	
//		GAGameStateGetHandler.getNeighborState("neighbor",this.success.bind(this), this.failure.bind(this));
//		
//	},
//	
//	success: function(path, files){
//	    //console.log("the value of the neoghbor is ******************   "+path+"     *********files**********     "+files);
//		DatabaseInterface.loadNeighbor(path);
//		console.log("SUCCESS iN NEIGHBOUR");
//	   
//  },
//   							   
//  failure: function(){
//	   console.log("FAILUER iN NEIGHBOUR");
//	   this._failureUIAlert = new GAUIAlertView(Core.Localization.getString("warning"),Core.Localization.getString("NEIGHBOR_FAILURE"),this,null,Core.Localization.getString("ok"));
//	   this._failureUIAlert.setTagValue(1111);
//	   this._failureUIAlert.show();
//  },
		
	destroy: function($super)
	{    
		if(this.myMessageListener){
			this.myMessageListener.destroy();
			this.myMessageListener = null;
		}
		TFUtil.destroyNodeChildren(this);
		$super();
	},




});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/GLLayer/FishUI'] = function(){var exports = $MODULE_REGISTRY['Code/GLLayer/FishUI'] || {}; $MODULE_REGISTRY['Code/GLLayer/FishUI'] = exports; /**
 * Filename: GameCentralHandler.js
 * Author: Shamas Shahid
 * Date Created: 17thMay-2011
 * Date Updated: 
 */
 


var SCREEN_WIDTH = 480;
var SCREEN_HEIGHT = 320;
var IPAD_SIZE = 1.0;
var IPAD_SIZE_Y = 1.0;
var IPAD_SIZE_PADING = 0;
var TF_ACTION_FOOD_HUNT = 3;


exports.FishUI = GL2.Node.subclass({
    
  classname: 'FishUI',  
	initialize: function($super,fishObj,fishParentTnk,fishType) 
	{
		$super();
		this.hungerSprite=null;
		this.fishParentTank = fishParentTnk;

		this._fishObject = fishObj;	
	
		this.paused = null; 
		this.touchesBegan = null; 
		this.isEgg = null;
		
		var storeFish = GAGameLoader.getStoreHandler().getStoreObjectForKey(fishObj._fishObj.storeId);
		
		this.width = storeFish.custom_attributes.size_width;
		this.height = storeFish.custom_attributes.size_height;
		
		this.hungerSpriteWidth = this.width/2;
		this.hungerSpriteHeight = this.height/2;
		
		var imagePath;
		if(fishType == TFFishType.tfFishisEgg)
		{
			
			imagePath = '/Content/egg.png';
			this._fishSprite = GLFactory.getSprite([0,0],0,imagePath,[TFUtil.getAdjustedX(28),TFUtil.getAdjustedY(26)],[.5,.5]);
			this.isEgg = true;
		}
		else
		{
			
			this._basePath = TFUtil.getBasePathForResourceType(fishObj._fishObj.storeId, GAResourceType.kDetail);
			imagePath = this._basePath+'/1.png';
			this._fishSprite = GLFactory.getSprite([0,0],0,imagePath,[TFUtil.getAdjustedY(this.width),TFUtil.getAdjustedX(this.height)],[.5,.5]);
			this.isEgg = false;
		}

		this.addChild(this._fishSprite);
				
		SCREEN_HEIGHT = Core.Capabilities.getScreenWidth();
		SCREEN_WIDTH = Core.Capabilities.getScreenHeight();
		
		this.dx = 0; 
		this.dy = 0; 
		this.fishAngle = 0;
											 
		this.isHungry = this._fishObject.isHungry();
		this.isTouched = false;
		this.speed = 1.0; 
		this.newSpeed = 0; 
		this.scaleValue = 0;
		this.currentAction = TFActionType.tfActionNone;
		this.foodHuntType = null;
		this.paused = false;
		this.scared = null; 
		this.isDead = false;
		this.speedDecrement = null;

		this.finsMovement = 0;
		this.curTexture = 0;
		
		this.foodParticleIndex = null;
		this.boostTurns = null;
		this.boostCheck = null;
		
		this.generateRandomDelta();

		if(this._fishObject.isAlive()) // original check was on the fishObject isAlvie
		{
			var xPos = Math.abs(Math.random()*(SCREEN_WIDTH - (100*IPAD_SIZE)) +(50*IPAD_SIZE));
			this._fishSprite.setPosition(xPos, Math.random()*(SCREEN_HEIGHT-30*IPAD_SIZE)+50*IPAD_SIZE);
			this.fakeRevive();
		}
		else
		{
			if(TFGameState.goingToHome == false){
				var xPos = Math.abs(Math.random()*(SCREEN_WIDTH - (100*IPAD_SIZE)) +(50*IPAD_SIZE));
				this._fishSprite.setPosition(xPos, SCREEN_HEIGHT-50*IPAD_SIZE);
				this.die();
			}
			else {
				var xPos = Math.abs(Math.random()*(SCREEN_WIDTH - (100*IPAD_SIZE)) +(50*IPAD_SIZE));
				this._fishSprite.setPosition(xPos, SCREEN_HEIGHT-50*IPAD_SIZE);
			}
		}
	
		this.myMessageListener = new Core.MessageListener();
		this._target = new GL2.TouchTarget();
		this._target.setAnchor(0,0);
		this._target.setSize(SCREEN_WIDTH,SCREEN_HEIGHT);
		this._target.getTouchEmitter().addListener(this.myMessageListener, this.onTouch.bind(this));
		this._target.setDepth(1);
		this.addChild(this._target);
	},
	
	getFishNode: function()
	{
		return this._fishSprite;
	},
	
	
	getFishObject: function()
	{
		return this._fishObject;
	},
	
	getBasePathForResourceType:function(resourceType) 
	{
       var storeFish = this._fishObject.getStoreObject();
       var resource = GAResourceUtils.getResourceOfType(storeFish, resourceType);
       var basePath = GAResourceUtils.getResourceSavePath(storeFish, resource);
       return basePath;
   },
	
	getTarget: function()
	{
		return this._target;
	},
	
	onTouch: function(touch)
    {
		 if(GameLayer.getSelectedTank().getCurrentTankAction() != kTankActionType.kTankActionArrow)
		{
		   return;
		}
								   
		if(touch.getAction() == touch.Action.Start)
		{
			if(this.ccTouchesBegan(touch))
			{
				
				return true;
			}
		}
		else if(touch.getAction() == touch.Action.End)
		{
			this.ccTouchesEnded(touch);
		}
		return false;
    },
	
	ccTouchesMoved: function(touch)
	{
		
	},
	
	ccTouchesEnded: function(touch)
	{
		
		//if(TFGameState.atNeighbor)
		//	return;
		
		if(!this.touchesBegan) 
		{
			return false;
		}

		this.touchesBegan = false;
		this.unPause();

		GameLayer.getSelectedTank().didSelectFish(this,touch.getPosition().clone());
		this.currentAction = TFActionType.tfActionSpeed;	
		
	},
	
	ccTouchesBegan: function(touch)
	{
		if(!TFUtil.getIsTouched())
		{
			if(this.isEgg || !this.isFishTouched(touch.getPosition().clone()) || this.paused)
			{
				//handles cases when tank is tapped simultaneously
				if(this.touchesBegan !=null && this.touchesBegan == true)
				{
				return true;	
			}
			
			this.touchesBegan = false;
			return false;
		}
	
			this.touchesBegan = true;
			this.pause();
			return true;
		}
		else
		{
			//console.log("Didnt go ");
		}
	},
	
	isFishTouched: function(position)
	{
		var fishPosition = this._fishSprite.getPosition();
		var origin = new Core.Vector(fishPosition.getX() - ((this.width/2)*this.scaleValue),fishPosition.getY() - ((this.height/2)*this.scaleValue));
		var sizeVec = new Core.Size(this.width*this.scaleValue,this.height*this.scaleValue);
		var rect = new Core.Rect(origin,sizeVec);
		if(Math2.rectContainsPoint(rect,position))
		{
			delete origin;
			delete sizeVec;
			delete rect;
			return true;
		}
		else
		{
			delete origin;
			delete sizeVec;
			delete rect;
			return false;
		}
	},
	
	unPause: function()
	{
		this.paused = false;
		TFUtil.setIsTouched(false);
	},
	
	pause: function()
	{
		if(TFGameState.atNeighbor){
			return;
		}
		TFUtil.setIsTouched(true);
		if(!this.isDead)
		{
			var imagePath = TFUtil.getBasePathForResourceType(this._fishObject._fishObj.storeId, GAResourceType.kDetail);
			imagePath = this._basePath+'/selected.png';
			this._fishSprite.setImage(imagePath,[this.width,this.height],[.5,.5]);
		}
		
		this.paused = true;
		if(this.currentAction = TFActionType.tfActionFoodHunt)
		{
			GameLayer.getSelectedTank().getFoodParticles().ignoreFoodParticle(this.foodParticleIndex);
		}
	},
	
	startAnimation: function()
	{
		
		if(this.isEgg)
		{
			var positonSaved = this._fishSprite.getPosition().clone();
			if(this._fishSprite){
				this.removeChild(this._fishSprite);
				this._fishSprite.destroy();//destroying the previously formed egg sprite.
				this._fishSprite = null
			}
			this._basePath = TFUtil.getBasePathForResourceType(this._fishObject._fishObj.storeId, GAResourceType.kDetail);
			var imagePath = this._basePath+'/1.png';
			this._fishSprite = new GLFactory.getSprite([0,0],0,imagePath,[TFUtil.getAdjustedX(this.width),TFUtil.getAdjustedY(this.height)],[.5,.5]);
			this.addChild(this._fishSprite);
			this._fishSprite.setPosition(positonSaved);
			this.isEgg = false;
//			if(this._fishObject.getCategoryId() == ALGAE_EATER_CATEGORY_ID){
//				GameLayer.getSelectedTank().removeAlgae();
//			}
		}
								   
	    this.checkHungry();
		this.setFishScale();
		this.setFishTextures();

		this.timerVar = setTimeout(this.movement.bind(this),TF_TIMER_INTERVAL);
		this.scheduleGenrateRandomAction();
	},
	
	
	setFishScale: function()
	{
		if(!this._fishObject)
		{
			return;
		}
		var currentAge = this._fishObject.getCurrentAgePercentage();
		var scaleValueDiff = (TF_MAXIMUM_SCALE - TF_MINIMUM_SCALE);
		var scaleValueTemp = (scaleValueDiff*currentAge)/100.0;
		this.scaleValue = TF_MINIMUM_SCALE + scaleValueTemp;	
		var scaleX=this.scaleValue;
		var scaleY= this.scaleValue;
		if(this._fishObject.isAlive())
		{
			this._fishSprite.setScale(this._fishSprite.getScale().getX(),scaleY);
			this.fakeRevive();
		}
		else
		{
			if(TFGameState.goingToHome == false){
				this.die();
				this._fishSprite.setScale(this._fishSprite.getScale().getX(),-scaleY);
			}
		}
		if(this._fishSprite.getScale().getX() < 0)
		{
			this._fishSprite.setScale(-scaleX,this._fishSprite.getScale().getY());
		}
		else
		{
			this._fishSprite.setScale(scaleX,this._fishSprite.getScale().getY());
		}
	},
    
    isFishHungry: function()
    {
        return this._fishObject.isHungry();  //@shamas: iOS uses value of whether hungry sprite is visible or not.. so change it to that 
    },
    
    getFishSprite: function()
    {
        return this._fishSprite;
    },
	
    eatFoodParticle: function(pIndex)
    {
        if(!this.isFishHungry()) 
        	return false;
        if(this.currentAction == TFActionType.tfActionFoodHunt) 
        	return false;
        
        
        this.currentAction = TFActionType.tfActionFoodHunt;
        this.foodHuntType = TF_FOOD_HUNT_PARTICLE;
        this.foodParticleIndex = pIndex;
        
        var foodPosition = GameLayer.getSelectedTank().getFoodParticles().getFoodParticlePosition(this.foodParticleIndex);
        if(foodPosition.getX() == -1 && foodPosition.getY() == -1) 
        	return false;
        
        this.dx = foodPosition.getX() - this._fishSprite.getPosition().getX();
        this.dy = foodPosition.getY() - this._fishSprite.getPosition().getY();
        
        var max = Math.abs(this.dy);
        
        if(Math.abs(this.dx) > Math.abs(this.dy))
        {
            max = Math.abs(this.dx);
        }
        
        this.dx = this.dx / max;
        this.dy = this.dy / max;
        
        this.newSpeed = this.speed;
        this.speed = 3; 
        return true;
    },
	
	eatFoodFromBrick: function(pIndex)
	{
		if(!this.isFishHungry()) 
			return false;
		if(this.currentAction == TFActionType.tfActionFoodHunt) 
			return false;
		this.currentAction = TFActionType.tfActionFoodHunt;
		this.foodHuntType = TF_FOOD_HUNT_BRICK;
		
		var foodPosition = 	GameLayer.getSelectedTank().getFoodBrick().getBrickPosition(pIndex);
		if(foodPosition.getX() == -1 && foodPosition.getY() == -1) 
			return false;
		
        this.dx = foodPosition.getX() - this._fishSprite.getPosition().getX();
        this.dy = foodPosition.getY() - this._fishSprite.getPosition().getY();
        
        var max = Math.abs(this.dy);
        
        if(Math.abs(this.dx) > Math.abs(this.dy))
        {
            max = Math.abs(this.dx);
        }
        
        this.dx = this.dx / max;
        this.dy = this.dy / max;
        
        this.newSpeed = this.speed;
        this.speed = 7; 
        return true;
	},
    
	foodConsumed: function () {
		GameLayer.getSelectedTank().getFoodParticles().consumeFoodParticle(this.foodParticleIndex);
	    this._fishObject.updateLastFed();
		
		if(this.foodHuntType == TF_FOOD_HUNT_BRICK)
		{	
			var foodBrick = GameLayer.getSelectedTank().getFoodBrick().foodBrickModelObject;
			var remainingTimeInSec = foodBrick.getTimeRemaining();
			var newLastFed = TFGameState.getServerTime() + remainingTimeInSec;
			this._fishObject.updateLastFedToTime(newLastFed);
		}
		
	    this.currentAction = TFActionType.tfActionSpeed;	
		this.checkHungry();
		this.fishParentTank.showFishFedAlert();
	},
	

	movement: function()
	{
		this.setFishScale();
		clearTimeout(this.timerVar);
		if(this.paused)
		{
			this.timerVar = setTimeout(this.movement.bind(this),TF_TIMER_INTERVAL);
			return;
		}
		
		
//		if((this.isDead) && (TFGameState.goingToHome == false)) // Dead Fish
		if(this.isDead) // Dead Fish
		{
			if (TFGameState.goingToHome == true)
				{
					return;
				}
			
			this.dx = (Math.random()*100) /100 -.5;
			var myPos = new Core.Vector(this.dx*this.speed,this.dy*this.speed);
			var newPosition = new Core.Vector(this._fishSprite.getPosition().getX()+myPos.getX(), this._fishSprite.getPosition().getY() + myPos.getY());
			this._fishSprite.setPosition(newPosition);
			delete myPos;
			delete newPosition;
			
			if(this.dy < 0 && this._fishSprite.getPosition().getY() < TFUtil.getAdjustedX(45) *IPAD_SIZE )
			{
				this.dy *=-1;
				var newPosition = new Core.Vector(this._fishSprite.getPosition().getX(),TFUtil.getAdjustedX(45) *IPAD_SIZE);
				this._fishSprite.setPosition(newPosition);
				delete newPosition;
			}
			if(this._fishSprite.getPosition().getY() > TFUtil.getAdjustedX(42) * IPAD_SIZE)
			{
				var newPosition = new Core.Vector(this._fishSprite.getPosition().getX(),TFUtil.getAdjustedX(42)  *IPAD_SIZE - 1) ;
				this._fishSprite.setPosition(newPosition);
				delete newPosition;
				this.dy *= -1;
				this.speed = 0.5*IPAD_SIZE + (Math.random()*10)/100;
			}
			this.timerVar = setTimeout(this.movement.bind(this),TF_TIMER_INTERVAL);
			return;
		}
		
		this.finsMovement = this.finsMovement + 1;
		if(this.finsMovement >=  Math.round(5*(1+(this.dx*this.dy)*this.speed)))
		{
			this.curTexture = this.curTexture + 1;
			if(this.curTexture >= TF_ACTION_FOOD_HUNT) 
				this.curTexture = 0;
			this.setFishTextures();
			this.finsMovement = 0;
		}
		
		
        if(this.currentAction == TFActionType.tfActionFoodHunt)
        {
            var foodPosition = new Core.Vector(-1,-1);
            if(this.foodHuntType == TF_FOOD_HUNT_PARTICLE)
            {
                foodPosition = GameLayer.getSelectedTank().getFoodParticles().getFoodParticlePosition(this.foodParticleIndex);
            }
			
			if(this.foodHuntType == TF_FOOD_HUNT_BRICK)
			{
				var foodPosition = 	GameLayer.getSelectedTank().getFoodBrick().getBrickPosition(0);
			}
            
            if(foodPosition.getX() == -1 && foodPosition.getY() == -1)
            {
                this.currentAction = TFActionType.tfActionSpeed;
				this.timerVar = setTimeout(this.movement.bind(this),TF_TIMER_INTERVAL);
                return;
            }
            
            this.dx = foodPosition.getX() - this._fishSprite.getPosition().getX();
            this.dy = foodPosition.getY() - this._fishSprite.getPosition().getY();
            var max = Math.abs(this.dy);
            if(Math.abs(this.dx) > Math.abs(this.dy))
            {
                max = Math.abs(this.dx);
            }
            this.dx = this.dx / max;
            this.dy = this.dy / max;
            
            var distanceVec = new Core.Vector(this._fishSprite.getPosition().getX() - foodPosition.getX(),
                                                this._fishSprite.getPosition().getY() - foodPosition.getY());
            var dist = Math.sqrt(Math.pow(distanceVec.getX(),2)+Math.pow(distanceVec.getY(),2));
            
            if(dist <= 35)
            {
               this.foodConsumed();
			}
            delete distanceVec;
            delete foodPosition;
		}
		if(this.currentAction == TFActionType.tfActionHover)
		{
			if(this.speed > .3)
			{
				this.speed = this.speed - .015;
			}
		}
		if(this.scared)
		{
			if(this.speed > 5 )
			this.speed = this.speed - this.speedDecrement;
		}
		if(this.currentAction == TFActionType.tfActionSpeed)
		{
		}
		else
		{
			if(this.speed < this.newSpeed) this.speed = this.speed + .015;
			if(this.speed > this.newSpeed) this.speed = this.speed - .015;
		}
		if(this.currentAction == TFActionType.tfActionCurve)
		{
			if(this.topBoundaryHit || this.bottomBoundaryHit)
            {
                if(this.topBoundaryHit)
                {
                    this.topBoundaryHit = false;
					this.dy = Math.abs(this.dy);
					this.dy = this.dy;
                }
                
                if(this.bottomBoundaryHit)
                {
                    this.bottomBoundaryHit = false;
					this.dy = this.dy *-1;
                }
            }
            else
			{
				if(this.expandedRandomBetweenTwo() == 0)
				{ 
					this.dy = this.dy - .04;
				}
				else
				{

				   this.dy = this.dy + .04;
				}
			}
		}
		
		if(this.currentAction != TFActionType.tfActionFoodHunt)
		{
			if(Math.abs(this.dx) >= 0.8)
			{
				this.dx = this.dx/2;
			}
			
			if(Math.abs(this.dy) >= Math.abs(this.dx))
			{
				this.dy = this.dx + .3;
			}
		}
		
		var newSpeed = this.speed;
		if(!this._fishSprite)
		{
			return;
		}
		var pos1 = this._fishSprite.getPosition();
		var pos2 = new Core.Vector(this.dx*newSpeed,this.dy*newSpeed);
		var newPosition = Math2.ccpAdd(pos1,pos2);
		var newAngle = this.calculateAngle(this._fishSprite.getPosition(),newPosition);
								  								   
		if( (newAngle >= 0 && newAngle<= 90) || (newAngle >= 270 && newAngle <= 360))
		{
			this._fishSprite.setScale(-this.scaleValue,this._fishSprite.getScale().getY());
		}
		else
		{
			this._fishSprite.setScale(this.scaleValue,this._fishSprite.getScale().getY());
		}
		this._fishSprite.setPosition(newPosition);
		delete pos2;
		
		var touchedBoundary = this.boundaryTouched();
		
		if(touchedBoundary == ScreenBoundary.boundaryRight){
			this.dx = this.dx * -1;
			this._fishSprite.setPosition(new Core.Vector(SCREEN_WIDTH + TF_BOUNDARY_MARGIN,this._fishSprite.getPosition().getY()));
		} 
		else if(touchedBoundary == ScreenBoundary.boundaryLeft){
			this.dx = this.dx * -1;
			this._fishSprite.setPosition(new Core.Vector( - TF_BOUNDARY_MARGIN, this._fishSprite.getPosition().getY()));
			
		} 
		else if(touchedBoundary == ScreenBoundary.boundaryBottom)
		{
			if(this.currentAction != TFActionType.tfActionFoodHunt)
			{
				//this.currentAction = TFActionType.tfActionCurve;
			}
			
			if(this.dy>0)
			{
				this.dy = this.dy * -1.5 *IPAD_SIZE;
			}
			else //case where this is already less than 0 (-ve)
			{
				this.dy = this.dy * 1.5 *IPAD_SIZE;
			}
								   
			this._fishSprite.setPosition(this._fishSprite.getPosition().getX(), SCREEN_HEIGHT  - TF_BOUNDARY_BOTTOM_MARGIN);
		} 
		else if(touchedBoundary == ScreenBoundary.boundaryTop){
			
			if(this.currentAction != TFActionType.tfActionFoodHunt)
			{
				//this.currentAction = TFActionType.tfActionCurve;
			}
			
			this.dy = this.dy * -1.5 *IPAD_SIZE;
								   
			this._fishSprite.setPosition(this._fishSprite.getPosition().getX(), TF_BOUNDARY_TOP_MARGIN);
		}
		this.timerVar = setTimeout(this.movement.bind(this),TF_TIMER_INTERVAL);
	},
    
    boundaryTouched: function()
	{
    	
		var fishPosition = this._fishSprite.getPosition();
		
		if(fishPosition.getX() > SCREEN_WIDTH + TF_BOUNDARY_MARGIN) // RIGHT BOUNDARY
		{
			
			return ScreenBoundary.boundaryRight;
		}
		if(fishPosition.getX() < 0 -TF_BOUNDARY_MARGIN)// -SCREEN_WIDTH/2) // LEFT BOUNDARY
		{
			
			return ScreenBoundary.boundaryLeft;
		}
		
		if(fishPosition.getY() < 0+TF_BOUNDARY_TOP_MARGIN)//(-TF_BOUNDARY_BOTTOM_MARGIN - SCREEN_HEIGHT/2))
        { // top
			
            if(!this.scared)
            {
                this.topBoundaryHit = true;
            }
            return ScreenBoundary.boundaryTop;
        }
		if(fishPosition.getY() > (SCREEN_HEIGHT  - TF_BOUNDARY_BOTTOM_MARGIN)) // bottom
		{	
			
            if(!this.scared)
            {
                this.bottomBoundaryHit = true;
            }
			
            return ScreenBoundary.boundaryBottom;
        }
		return ScreenBoundary.boundaryNone;
	},
    
    tankTapped: function(touch)
    {
        if(this.isDead || this.isEgg) return; // I'm dead or new born, I don't run no more or not yet.
        if(this.currentAction == TFActionType.tfActionFoodHunt)
        {
            return;
        }
        var newVector = new Core.Vector(touch.getPosition().getX(),touch.getPosition().getY());
        var localizedVec = this.screenToLocal(newVector);
        var distanceVec = new Core.Vector(this._fishSprite.getPosition().getX()-localizedVec.getX(),
                                          this._fishSprite.getPosition().getY()-localizedVec.getY());
        
        var dist = Math.sqrt(Math.pow(distanceVec.getX(),2)+Math.pow(distanceVec.getY(),2));
        if(dist>100)                                 
        {
            return;
        }
        if(!this.scared)
        {
            this.newSpeed = this.speed;
            this.scared = true;
        }
        else
        {
            clearTimeout(this._tapEndedTimeOut);
        }
        clearTimeout(this._gRATimeOut);
        this.currentAction = TFActionType.tfActionSpeed;
        this.speed = TF_TANK_TAP_SPEED;
        
        this.speedDecrement = Math.abs(this.newSpeed - this.speed)/(TF_TIMER_INTERVAL);
        
        if(this._fishSprite.getPosition().getX() > localizedVec.getX())
        {
            if(this.dx <0)
            {
                this.dx = this.dx * -1;
            }
        }
        else
        {
            if(this.dx > 0)
            {
                this.dx = this.dx *-1;
            }
        }
        
        this._tapEndedTimeOut = setTimeout(this.tankTapEnded.bind(this),.9*1000);
        delete newVector;
        delete distanceVec;
        
    },
    
    tankTapEnded: function()
    {
        this.scared = false;
        this.currentAction = TFActionType.tfActionCurve;
        this.scheduleGenrateRandomAction();
        
    },
	
	setFishTextures: function()
	{
		
		if(this.curTexture == 0)
		{
			if(!this._fishSprite)
			{
				return;
			}
			var firstImage = this._basePath+'/1.png';
			this._fishSprite.setImage(firstImage,[this.width,this.height],[.5,.5]);
		}
		else if(this.curTexture == 1)
		{
			var secondImage = this._basePath+'/2.png';
			this._fishSprite.setImage(secondImage,[this.width,this.height],[.5,.5]);
		}
		else if(this.curTexture == 2)
		{
			var thirdImage = this._basePath+'/3.png';
			this._fishSprite.setImage(thirdImage,[this.width,this.height],[.5,.5]);
		}
	},
	
	calculateAngle: function(p1,p2)
	{
		var angle = Math.atan2(p1.getY() - p1.getY(), p2.getX() - p1.getX());
		newAngle = (angle * (180/Math.PI)); 
		if(newAngle<0) newAngle = newAngle + 360;
		newAngle = newAngle *-1;
		if(newAngle<0) newAngle = newAngle +360;
		
		return newAngle;
	},

	checkHungry:function()
	{
		
		if(this.isFishHungry()  && !this.hungerSprite &&  this._fishObject.isAlive())
		{

//			var fishWidth = this._fishSprite._animation.getFrame(0).getSize().getHeight();
			var storeFishVirtualItem = GAGameLoader.getStoreHandler().getStoreObjectForKey(this._fishObject._fishObj.storeId);
			var fishWidth = storeFishVirtualItem.custom_attributes.size_width;
//		
			this.hungerSprite = GLFactory.getSprite([TFUtil.getAdjustedY(this.dy-(fishWidth/2)+20),TFUtil.getAdjustedX(this.dx-20)],100,"./Content/hungrycallout.png",[TFUtil.adjustHeightWithDevice(40),TFUtil.adjustWidthWithDevice(30)],[.5,.5]);	
			this._fishSprite.addChild(this.hungerSprite);
		}
		if(!this.isFishHungry()  && this.hungerSprite)
		{
			this.currentAction = TFActionType.tfActionNone;
			this._fishSprite.removeChild(this.hungerSprite);
			this.hungerSprite.destroy();
			this.hungerSprite = null;
			
		}
	},

	generateRandomAction: function()
	{
		if(this.paused)
		{
			return;
		}
		
		this.checkHungry();
		
		if(this.isHungry)
		{	
			if(GameLayer.getSelectedTank().getFoodBrick())
			{
				this.eatFoodFromBrick(0);
			}
		}
		// self checkHungry
		// some more functions
		if(this.currentAction == TFActionType.tfActionFoodHunt) 
        {
            this.scheduleGenrateRandomAction();
            return;
        }
		
		this.updateRandomDelta();
		
		var tempAction = this.currentAction;
		
		this.currentAction = Math.floor( Math.random() * 5); 
		
		while(tempAction == TFActionType && this.currentAction == TFActionType.tfActionHover) // food actino is not includded
		{
			this.currentAction = Math.floor( Math.random() * 5); 
		}
		
        if(this.topBoundaryHit || this.bottomBoundaryHit)
        {
			//this.currentAction = TFActionType.tfActionCurve;
        }
        
		if(this.currentAction == TFActionType.tfActionNone)
		{
			this.generateRandomDelta();
		}
		
		this.scheduleGenrateRandomAction();
	},
    
    scheduleGenrateRandomAction: function()
    {
        var updateActionInterval = TF_MINIMUM_ACTION_INTERVAL + (Math.random() % (TF_MAXIMUM_ACTION_INTERVAL - TF_MINIMUM_ACTION_INTERVAL));
		this._gRATimeOut = setTimeout(this.generateRandomAction.bind(this), updateActionInterval*1000);

    },
	
	updateRandomDelta: function()
	{
		if(this.topBoundaryHit || this.bottomBoundaryHit)
		{
			if(this.topBoundaryHit)
			{
				this.dy = this.dy + .1;
			}
			
			if(this.bottomBoundaryHit)
			{
				this.dy = this.dy -.1;
			}
			
		}
		else
		{
			if(this.expandedRandomBetweenTwo() == 1)   //if(Math.round(Math.random()*2) == 1)
			{
				this.dy = this.dy +.1;
			}
			else
			{
				this.dy = this.dy - .1;
			}
		}
		if(this.dy > .2) this.dy = .2;
		if(this.dy < .2) this.dy = this.dy - .2;
		
	},
	generateRandomDelta: function()
	{
		this.dx = .5 + (Math.random()*50) / 100;
		this.dy = (Math.random()*20) / 100;
		
		if(this.expandedRandomBetweenTwo() == 1)  //if(Math.round(Math.random()*2) == 1)
		{
			this.dx = this.dx * -1;
		}
		if(this.expandedRandomBetweenTwo() == 1)    //if(Math.round(Math.random()*2) == 1)
		{
			this.dy = this.dy * -1;
		}
		
		this.generateRandomSpeed();
		
	},
	
	generateRandomSpeed: function()
	{
		this.newSpeed = (.9 + Math.random() * 3);
	},
	
	die:function()
	{
		if(TFGameState.goingToHome == true ){
			return;
		}
		this._fishSprite.setColor(0.3, 0.3, 0.3);
		if(this.isDead){
			return;
		}
		this.isDead = true;
		
			
	},
   revive : function()
   {
	   if(!this.isDead)
	   {
			return;
	   }
	   this.currentAction = TFActionType.tfActionSpeed;
	   this._fishObject.revive();
	   this._fishSprite.setColor(255, 255, 255);
	   this.isDead = false; 
	   this.newSpeed += 0.2;
	   this.generateRandomDelta();
   },

	fakeRevive: function()
	{
		 //this.currentAction = TFActionType.tfActionSpeed;
		 this._fishSprite.setColor(255, 255, 255);
		 this.isDead = false; 
		 //  this.newSpeed += 0.2;
		 //  this.generateRandomDelta();
	},						
    expandedRandomBetweenTwo: function()
    {
        var randValue = Math.round(Math.random() * 100);
        var returnValue = randValue%2;
        return returnValue;
    },

    destroy: function($super)
    {
    	if(this.isHungry)
		{	
			if(GameLayer.getSelectedTank().getFoodBrick())
			{
				this.eatFoodFromBrick(0);
			}
		}
    	
    	if(this.currentAction == TFActionType.tfActionFoodHunt){
    		this.foodConsumed();
    	}
    	
		clearTimeout(this._gRATimeOut);
		if(this.timerVar)
		{
			clearTimeout(this.timerVar);
			this.timerVar = null;
		}
		if(this.myMessageListener) {
			this.myMessageListener.destroy();
			this.myMessageListener = null;
		}
//		if(this._fishObject)
//		{
//			this._fishObject.destroy();
//			this._fishObject = null;
//		}
		TFUtil.destroyNodeChildren(this._fishSprite);
		TFUtil.destroyNodeChildren(this);
		$super();
    },
    
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/GLLayer/TankUI'] = function(){var exports = $MODULE_REGISTRY['Code/GLLayer/TankUI'] || {}; $MODULE_REGISTRY['Code/GLLayer/TankUI'] = exports; 
exports.TankUI = GL2.Node.subclass({
    
  classname: 'TankUI',  
	initialize: function($super,tankModel) 
	{
		$super();
		this.tankModel = tankModel;
		this.firstRun = TFStorageManager.getValueFromUserDefault(kUserDefaultKeys[0]);
		this.currentTankAction = kTankActionType.kTankActionArrow;
		this.previousTankAction = kTankActionType.kTankActionArrow;
		
		this.selectedFish = null;
		this.shouldPlayClickSound = false;
		
		this.SCREEN_HEIGHT = Core.Capabilities.getScreenWidth();
		this.SCREEN_WIDTH = Core.Capabilities.getScreenHeight();
		
		this.lastTouch = 0;
		this.distinctFishes = new Array();
		//this.tankModel._tankObj.lastTapped = TFGameState.getServerTime();
		
		var storeid = tankModel._tankObj.backgroundStoreID;
		var storeBackground = GAGameLoader.getStoreHandler().getStoreObjectForKey(storeid);
		this._basePath = TFUtil.getBasePathForResourceType(storeid,GAResourceType.kDetail);
		TFGameState.changeFileName(this._basePath,storeBackground);
		var pathImage = this._basePath+'/default.jpg';

		this.background = new GL2.Sprite();
		if(storeid==null || storeid=='')
		{
			this.background.setImage("./Content/default.png",[this.SCREEN_WIDTH,this.SCREEN_HEIGHT],[0,0]);
			
		}
		else
		{
			this.background.setImage(pathImage,[this.SCREEN_WIDTH,this.SCREEN_HEIGHT],[0,0]);
		}
		
		this.background.setDepth(1);
		this.addChild(this.background);
		
		this.algaeLayer = new AlgaeLayer();
		this.algaeLayer.setDepth(6);
		this.addChild(this.algaeLayer);
		this.tempRewardCoins =0;
		this.tempRewardXP = 0;
		this.areButtonsEnabled = true;
								  					   
		this.tempCurrentAlgae = this.tankModel.updateTankAlgae();
			
		if (this.tempCurrentAlgae > 5 && this.tempCurrentAlgae < 10 )
		{
			this.tempCurrentAlgae = 10;
		}
		//this.tempCurrentAlgae = 50;
		this.algaeLayer.setAlgaePercentage(this.tempCurrentAlgae);
		//this.algaeLayer.draw();	
			
		this.myFishArray = new Array();
		var fishModelsCount=this.tankModel._allFish.length;
		
		this.myFoodBrickArray = new Array();
		this.initializeFoodBrick();
		for(var i=0 ; i<fishModelsCount ; i++)
		{
			var modelFish = this.tankModel._allFish[i];
			if(modelFish.getCategoryId() == ALGAE_EATER_CATEGORY_ID){
				this.tempCurrentAlgae = 0;
				this.algaeLayer.setAlgaePercentage(0); //algae cant be in tank if there is algae eater
				//this.algaeLayer.draw();	
				
			}
									
			//here check if brick is present in a tank. if it is present, feed the fish
			if(this.myFoodBrickArray && this.myFoodBrickArray.length != 0)
			{
				var foodBrick = this.foodBrickUI.foodBrickModelObject;
				var remainingTimeInSec = foodBrick.getTimeRemaining();
				var newLastFed = TFGameState.getServerTime() + remainingTimeInSec;
				modelFish.updateLastFedToTime(newLastFed);
			}

			if(this.isDistinctFish(modelFish)){
				this.distinctFishes.push(modelFish);
			}
			
			var myfish = new FishUI(modelFish,this);
			myfish.setDepth(4);
			this.myFishArray[this.myFishArray.length] = myfish;
			this.addChild(myfish);
			myfish.startAnimation();
		}						   
		console.log("this.distinctFishes.length " + this.distinctFishes.length);
		this.myDecorationArray = new Array();
		var decoModelsCount = this.tankModel._allDecorations.length;
		
		for(var i=0 ; i<decoModelsCount ; i++)
		{
			var modelDecoration = this.tankModel._allDecorations[i];
			var newDecoration = new DecorationUI(modelDecoration,this);
			newDecoration.setDepth(3); 
			this.myDecorationArray[this.myDecorationArray.length] = newDecoration;
		}		
		
		var index = 0;
		var mergedArray = new Array();
		
		for(index; index < this.myDecorationArray.length; index++)
		{
			mergedArray[mergedArray.length] = this.myDecorationArray[index];			
		}
		mergedArray.sort(function(a,b){return a.getZIndex() - b.getZIndex()});		
		for(index = 0; index < mergedArray.length; index++)
		{
			this.addChild(mergedArray[index]);
		}
						
		this.myPlantArray = new Array();
        var plantsModelCount = this.tankModel._allPlants.length;
        for(var i = 0; i < plantsModelCount;i++)
        {
            var modelPlant = this.tankModel._allPlants[i];
            var newPlant = new PlantUI(modelPlant,this);
            newPlant.setDepth(3);
            this.myPlantArray[this.myPlantArray.length] = newPlant;
            this.addChild(newPlant);
        }			  
		
		this.myMessageListener = new Core.MessageListener();

        this._target = new GL2.TouchTarget();
		this._target.setAnchor(.5,.5);
        this._target.setPosition(this.SCREEN_WIDTH/2,this.SCREEN_HEIGHT/2);
		this._target.setSize(this.SCREEN_WIDTH,this.SCREEN_HEIGHT);
		this._target.getTouchEmitter().addListener(this.myMessageListener, this.onTouch.bind(this));

		this._nodeForTouchTarget = new GL2.Node();
        this._nodeForTouchTarget.addChild(this._target);
        this._nodeForTouchTarget.setDepth(0);
        this.addChild(this._nodeForTouchTarget);

        this.foodParticles = new FoodParticles(this);
        this.foodParticles.setDepth(10);
        this.addChild(this.foodParticles);
			
		this.waterAnimation();
		this.animateBubble();
	
		this.eventRewardUIArrary = null;
			
		//this.addShower();
		if(GAAudioManager.isCleanSoundEnabled()){
			GAAudioManager.disableCleanSound();
		}
										   
		return this;
	},
	
	removeFishFromDistinctFishArray: function(modelFish){
		console.log("removeFishFromDistinctFishArray");
		
		for(var i=0; i<this.distinctFishes.length; i++){
			console.log("modelFish.getStoreId() " + modelFish.getStoreId());
			console.log("this.distinctFishes[i].getStoreId() " + this.distinctFishes[i].getStoreId());
			if(modelFish.getStoreId() == this.distinctFishes[i].getStoreId()){
				this.distinctFishes.splice(i, 1);
				console.log("distinct fishes new length " + this.distinctFishes.length);
			}
		}
		
	},
	
	searchDistinctFishWithId: function(storeId){
		console.log("searching for distinct fish with id " + storeId);
		var j=0;
		
		for(j=0; j<this.distinctFishes.length; j++){
//			console.log("inside loop");
			console.log("this.distinctFishes[j].getStoreId() " + this.distinctFishes[j].getStoreId());
			if(this.distinctFishes[j].getStoreId() == storeId){
				break;
			}
		}
		
		if(j == this.distinctFishes.length){
			console.log("DISTINCT");
			return true;
		}else{
			console.log("NOT DISTINCT");
			return false;
		}

		
	},
	
	isDistinctFish: function(modelFish){
		console.log("isDistinctFish " + this.distinctFishes.length);

		return this.searchDistinctFishWithId(modelFish.getStoreId());
	},
	
	isLastDistinctFish: function(modelFish){
		console.log("isLastDistinctFish " + this.distinctFishes.length);
		var count = 0;
		for(var i=0; i<this.distinctFishes.length; i++){
			console.log("this.distinctFishes[i].getStoreId() " + this.distinctFishes[i].getStoreId());
//			console.log("modelFish.getStoreId()) " + modelFish.getStoreId());
			if(this.distinctFishes[i].getStoreId() == modelFish.getStoreId()){
				count++;
				if(count > 1)
					break;
			}
		}
		console.log("distinctFishes count " + count);
		if(count == 1){
			console.log("returning true");
			return true;
		}else{
			console.log("returning false");
			return false;
		}
	},

	onTouchSettingsButton: function()
	{
		if(GameLayer.getControlLayer()._areButtonsEnabled)
		{
			GameLayer.getControlLayer().disableButtons();
	   	}
		else
	   	{
			return;
	   	}
		
		this.settingsUI = new TFSettingsUI();
		GameLayer.getControlLayer().addChild(this.settingsUI);  
	},

	
	//*** FOOD BRICK FUNCTIONS BEGIN ***// - 17th June
	initializeFoodBrick : function()
	{
		for(var i=0 ; i<this.tankModel._allFoodBricks.length ; i++)
		{	
			var modelFoodBrick = this.tankModel._allFoodBricks[i];
			
			var storeBrick = GAGameLoader.getStoreHandler().getStoreObjectForKey(modelFoodBrick._foodBrickObj.storeId);
			if(storeBrick)
			{
				this.foodBrickUI = new FoodBrickUI(modelFoodBrick,this);
				this.foodBrickUI.setDepth(4);
				this.myFoodBrickArray[this.myFoodBrickArray.length] = this.foodBrickUI;
				this.addChild(this.foodBrickUI);
				
				timeRemaining = modelFoodBrick.getTimeRemaining();
				timePercentage = this.foodBrickUI.foodBrickModelObject.getTimePercentage();
				if(timePercentage < 0)
				{
					this.removeFoodBrick();
				}
				else
				{
					this.timerVar = setTimeout(this.removeFoodBrick.bind(this),timeRemaining*1000);
				}
			}
		
		}
	},
	
	disableButtons:function()
	{
		this.areButtonsEnabled = false;
	},
	
	enableButtons:function()
	{
		this.areButtonsEnabled = true;
	},
	
	  removeFoodBrick:function()
	  {
		var objectId = this.foodBrickUI.foodBrickModelObject._foodBrickObj.objectId;
		this.tankModel.removeFoodBrick(objectId);
		var index = this.myFoodBrickArray.indexOf(this.foodBrickUI);
		this.myFoodBrickArray.splice(index,1);
		this.removeChild(this.foodBrickUI);
		this.foodBrickUI.destroy();
		this.foodBrickUI = null;
	
	  },
		
	//*** FOOD BRICK functions end ***//
	
	animateBubble:function ()
	{
		var bubbleAnimation = new GL2.Animation();
		this._bubblesprite = new GL2.Sprite();
		var basePath = '/Content/pubbleAnimation/bubbleanimation';
		bubbleAnimation.pushFrame(new GL2.Animation.Frame(basePath+'1.png',200,[TFUtil.adjustHeightWithDevice(150), TFUtil.adjustWidthWithDevice(300)],[0,0],[0,0,1,1]));
		bubbleAnimation.pushFrame(new GL2.Animation.Frame(basePath+'2.png',200,[TFUtil.adjustHeightWithDevice(150), TFUtil.adjustWidthWithDevice(300)],[0,0],[0,0,1,1]));
		bubbleAnimation.pushFrame(new GL2.Animation.Frame(basePath+'3.png',200,[TFUtil.adjustHeightWithDevice(150), TFUtil.adjustWidthWithDevice(300)],[0,0],[0,0,1,1]));
		bubbleAnimation.pushFrame(new GL2.Animation.Frame(basePath+'4.png',200,[TFUtil.adjustHeightWithDevice(150), TFUtil.adjustWidthWithDevice(300)],[0,0],[0,0,1,1]));
		bubbleAnimation.pushFrame(new GL2.Animation.Frame(basePath+'5.png',0,[TFUtil.adjustHeightWithDevice(150), TFUtil.adjustWidthWithDevice(300)],[0,0],[0,0,1,1]));
		bubbleAnimation.setLoopingEnabled(true);
		this._bubblesprite.setAnimation(bubbleAnimation);
		this._bubblesprite.setPosition(TFUtil.adjustHeightWithDevice(300), TFUtil.adjustWidthWithDevice(0)); 
		this.addChild(this._bubblesprite);
		this._bubblesprite.setDepth(2);
		bubbleAnimation.destroy();
		bubbleAnimation = null;
	},
	waterAnimation:function ()
	{	
		var waterAnimation = new GL2.Animation();
		this._watersprite = new GL2.Sprite();
		var basePath = '/Content/waterAnimation/wateranimaion';
		waterAnimation.pushFrame(new GL2.Animation.Frame(basePath+'1.png',400,[this.SCREEN_WIDTH ,TFUtil.getAdjustedX(120)],[0, 0],[0,0,1,1]));
		waterAnimation.pushFrame(new GL2.Animation.Frame(basePath+'2.png',400,[this.SCREEN_WIDTH ,TFUtil.getAdjustedX(120)],[0, 0],[0,0,1,1]));
		waterAnimation.pushFrame(new GL2.Animation.Frame(basePath+'3.png',400,[this.SCREEN_WIDTH ,TFUtil.getAdjustedX(120)],[0, 0],[0,0,1,1]));
		waterAnimation.pushFrame(new GL2.Animation.Frame(basePath+'4.png',400,[this.SCREEN_WIDTH ,TFUtil.getAdjustedX(120)],[0, 0],[0,0,1,1]));
		waterAnimation.pushFrame(new GL2.Animation.Frame(basePath+'5.png',400,[this.SCREEN_WIDTH ,TFUtil.getAdjustedX(120)],[0, 0],[0,0,1,1]));
		waterAnimation.setLoopingEnabled(true);
		this._watersprite.setAnimation(waterAnimation);
		this._watersprite.setDepth(2);
		this._watersprite.setPosition(TFUtil.adjustHeightWithDevice(0), TFUtil.adjustWidthWithDevice(0));
		this.addChild(this._watersprite);
		waterAnimation.destroy();
		waterAnimation = null;
	},
	addShower: function()
	{
		   if(!this.tankModel.getShowerEnabled() || !TFGameState.getCurrentUser()._userObj.isMasterShowerEnabled)
		   {
				return;
		   }	
								   					   
								   
			var showerStorId = this.tankModel._tankObj.showerId;
			if(!showerStorId)
			{
				return;
			}
			this.eventRewardUIArrary = new Array();
			this._basePath = TFUtil.getBasePathForResourceType(showerStorId,GAResourceType.kDetail);
			var normalImage = this._basePath+'/2.png';
				
				
				
		//		if(!this.tankModel._tankObj.isShowerEnabled)
		//		{
		//			return;
		//		}
				for(var i = 0; i<MAX_REWARDS_SHOWN_ON_SCREEN;i++)
				{
					this.eventRewardUIArrary[i] = new TankShower(normalImage);
					this.addChild(this.eventRewardUIArrary[i]);
					this.eventRewardUIArrary[i].setDepth(10);
					
				}
			
		
	},
	removeShower: function()
	{
		if(this.eventRewardUIArrary){
		
			for(var i = 0; i<this.eventRewardUIArrary.length;i++)
			{
				var a = this.eventRewardUIArrary[i];
				a.destroy();
				a = null;
				console.log("Removing data from array");
				
			}
			delete this.eventRewardUIArrary;
		}
	},
	updateShower: function()
	{
		console.log("in is updatd shower is called");
		this.removeShower();
		this.addShower();
	},
	showerOneOff: function()
	{
		this.tankModel.setShowerEnabled(false);
		this.removeShower();
	},
	showerOneon: function()
	{
		this.tankModel.setShowerEnabled(true);
		this.updateShower();
	},
	showerAllOff: function()
	{
		this.tankModel.setShowerEnabledAll(false);
		this.removeShower();
	},
	showerAllon: function()
	{
		this.tankModel.setShowerEnabledAll(true);
		this.updateShower();
	},
	getTankAction: function()
	{
		return this.currentTankAction;
	},
    
	setCurrentTankAction: function(newValue)
	{
		this.currentTankAction = newValue;
	},
		//ADDED BY TARIQ MAHMOOD						   
	getCurrentTankAction: function(newValue)
	{
		return this.currentTankAction ;
	},
	
	setStoreID: function(newValue)
	{
		this._storeID = newValue;
	},
	
	storeAction: function()
	{
		/*if(this.currentTankAction != kTankActionType.kTankActionBlockTank)
		{
			this.previousTankAction = this.currentTankAction;
			this.currentTankAction = kTankActionBlockTank;
		}*/
		//NgLogE("have stored action");
	},
	
	restoreAction: function()
	{
		if(this.previousTankAction == 0)
		{
			this.currentTankAction = kTankActionArrow;
			return;
		}
		if(this.previousTankAction != kTankActionType.kTankActionBlockTank)
		{
			this.currentTankAction = this.previousTankAction;
		}
	},
	
    getFoodParticles: function()
    {
        return this.foodParticles;
    },
	
    getFoodBrick : function ()
    {
       return this.foodBrickUI;
    },
	
	onTouch: function(touch)
    {
		switch(touch.getAction())
		{
			case touch.Action.Start:
			{
				
				this.checkForWelcomeRewards();
				this.touchesBegan(touch);
				break;
			}
		}
		return true;
    },
	
	touchesBegan: function(touch)
	{
		
		this.shouldPlayClickSound=true;
		if(GameLayer.getControlLayer().getControlLayerAbove()._isInfoButtonOpened)
		{

			GameLayer.getControlLayer().getControlLayerAbove().closeLeftPanel();
			
			return;
		}			   
        if(this.currentTankAction == kTankActionType.kTankActionArrow)
        {
			var touchDoesBelong = false;
			if(!TFGameState.atNeighbor){
				console.log("inside pointer action");
				for(var j = 0; j<this.myFishArray.length; j++)
				{
					var currentFish = this.myFishArray[j];
					currentFish.ccTouchesBegan(touch);
					currentFish.tankTapped(touch);
				}
			}
				
		   if(this.shouldPlayClickSound)
		   {
			  GAAudioManager.playTickSound();
		   }
								  
								   
		   return;
        }
        else if(this.currentTankAction == kTankActionType.kTankActionFood)
        {
            this.dropFoodAtPoint(touch);
		    return;
        }
		else if(this.currentTankAction == kTankActionType.kTankActionSponge)
		{
		}

		else if(this.currentTankAction == kTankActionType.kTankActionEggs)
		{
			if(! this.canFishBeAdded(this._storeID, touch))
			{
				return;
			}
			
			
			try
			{
				this.addFish(this._storeID , true, touch,false);
			}
			catch(e)
			{
				console.log("Exception in fish class"+e);
			}
		}

    },
	
    checkForWelcomeRewards:function()
    {
    	if(TFGameState.atNeighbor)
    		return;
    	
    	this.lastTouch = this.tankModel._tankObj.lastTapped;
    	
    	var currentTime = TFGameState.getServerTime();
		this.tankModel._tankObj.lastTapped = currentTime;
		if( ((currentTime - this.lastTouch) > TF_WELCOME_BACK_TIME) || (this.firstRun == true && this.lastTouch == 0) )
		{
			var userObj = TFGameState.getCurrentUser();
			var level = userObj._userObj.currentLevel;
			var coins = 0;
			var xps = 2;
			if(!TFGameState.atNeighbor){
				if (level<=5)
				{
					coins = 5;
				}
				else if(level >5 && level<=10)
				{
					coins =  15;
				}
				else if(level >10 && level<=30)
				{
					coins =  25;
				}
				else if(level >30)
				{
					coins =  50;
				}
				
				userObj.updateCurrency(kOperationType.kOperationAddCoins, coins);
				userObj.updateXPandLevel(xps);
				DatabaseInterface.updateUser();
				
			}
			
			
			DatabaseInterface.updateTank();
			var message = GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('WELCOME_BACK_REWARDS'),[coins,xps]);
			console.log(message);
			
//			var alertWindow = new TFMiniGLAlertView(GALocalizationHandler.getLocalizedString('TF_EMPTY_STRING'),message,this,GALocalizationHandler.getLocalizedString('TF_CANCEL_BUTTON'),GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
//			alertWindow._type="ok";
//			alertWindow.setTagValue("greetAlert");
//			alertWindow.setMessageColor(255,255,255);
//			alertWindow.setMessageFont(TFUtil.getFont(),TFUtil.getFontLocation());
//			alertWindow.setButtonsFont(TFUtil.getFont(),TFUtil.getFontLocation());
//			alertWindow.show();
			
			var alertWindow = new TFMiniUIAlertView("",message,this,GALocalizationHandler.getLocalizedString('TF_CANCEL_BUTTON'),GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));			
			alertWindow.setType("ok");
			alertWindow.setTagValue("greetAlert");
			alertWindow.setMessageColor("FFFFFF");
			alertWindow.setMessageFont(TFUtil.getFontName());
			alertWindow.setButtonsFont(TFUtil.getFontName());
			alertWindow.setButtonColor("FFFFFF");
			alertWindow.show();
			
			TBParticleAnimation.getSnowParticleAnimation();
		}
	
    	
    },
    
	canFishBeAdded: function(storeId, touch, showPopup)
	{
		if(this.myFishArray.length >= TF_TANK_FISH_LIMIT)
		{
			if(showPopup){
				var message = GALocalizationHandler.getLocalizedString('TF_TANK_FULL');
				console.log(message);
				var alertWindow = new TFMiniGLAlertView("",message,this,GALocalizationHandler.getLocalizedString('TF_CANCEL_BUTTON'),GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
				alertWindow._type="ok";
				alertWindow.setTagValue(0);
				alertWindow.setMessageColor(255,255,255);
				alertWindow.setMessageFont(TFUtil.getFont(),TFUtil.getFontLocation());
				alertWindow.setButtonsFont(TFUtil.getFont(),TFUtil.getFontLocation());
				alertWindow.show();
			} else {
				this.getAnimatedText(touch, GALocalizationHandler.getLocalizedString('TF_MSG_TANK_FULL'));
			}
			
			return false;
		}
		
		if(this.searchDistinctFishWithId(storeId)){
			if(this.distinctFishes.length >= TF_TANK_DISTINCT_FISH_LIMIT)
			{
				if(showPopup){
					var message = GALocalizationHandler.getLocalizedString('TF_MAX_DISTINCT_FISH_LIMIT');
					console.log(message);
					var alertWindow = new TFMiniGLAlertView("",message,this,GALocalizationHandler.getLocalizedString('TF_CANCEL_BUTTON'),GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
					alertWindow._type="ok";
					alertWindow.setTagValue(0);
					alertWindow.setMessageColor(255,255,255);
					alertWindow.setMessageFont(TFUtil.getFont(),TFUtil.getFontLocation());
					alertWindow.setButtonsFont(TFUtil.getFont(),TFUtil.getFontLocation());
					alertWindow.show();
				} else {
					this.getAnimatedText(touch, GALocalizationHandler.getLocalizedString('TF_MSG_DISTINCT_FISH_LIMIT'));
				}
				
				return false;
			}
		}
		return true; 
	},
	
	getCenterX : function()
	{

		var tempX = (Core.Capabilities.getScreenHeight())/2;
		return tempX;
	},
	
	getCenterY : function()
	{

		var tempY = (Core.Capabilities.getScreenWidth())/2;
		return tempY;
	},


	
	getAnimatedText:function(touch, message){
		console.log("getAnimatedText");
		var positionX;
		var positionY;
		
		if(!touch){

			positionX = this.getCenterX();
			positionY = this.getCenterY();
		} else{
			positionX = touch.getPosition().getX();
			positionY = touch.getPosition().getY();
		}
			
			
		this.text= message;
		this.target = new Core.Vector(positionX,positionY);
		this.color = new Core.Color(235,0,0);
		this.animatedLabel = new TFAnimation(this.text,[positionX,positionY],this.color,this.target);
		
		this.addChild(this.animatedLabel);

	},
	addFish: function(storeID , isEgg, touch,isPurchased)
	{
	//if touch is empty it will place it at random position
	//if isEgg is true, egg animation will appear first
		

		var storeFish = GAGameLoader.getStoreHandler().getStoreObjectForKey(storeID);
		var buyPriceKey = GACommonUtils.getBuyPrice(storeFish);
		var currency = StoreUtil.getCurrency(buyPriceKey);
		var price = StoreUtil.getPrice(buyPriceKey);   
		//var color = new Core.Color(0,1,0);

		var modelFish = new TankFish();
		modelFish._fishObj.storeId = storeID;
		if(this.isDistinctFish(modelFish)){
			console.log("ADDING DISTINCT FISH");
			this.distinctFishes.push(modelFish);
			console.log("ADDED DISTINCT FISH new length " + this.distinctFishes.length);
		}

		modelFish._fishObj.lastFed = TFGameState.getServerTime()-24*61*60;
		modelFish._fishObj.created_time = TFGameState.getServerTime();
		modelFish._fishObj.fishName = storeFish.name;

		if( this.tankModel.addFish(modelFish,isPurchased))
		{
			var storeObject= GAGameLoader.getStoreHandler().getStoreObjectForKey(storeID);
			LogHandler.logTransaction(storeObject);
		   
			var fishT=TFFishType.tfFishIsFish;
			if(isEgg)
			{
				fishT=TFFishType.tfFishisEgg;
				TFGameState.getCurrentUser().updateXPandLevel(1);
				GameLayer.getControlLayer().getControlLayerAbove().updateTopPanel();				   
				//GameLayer.getControlLayer().getControlLayerAbove().updateTopPanel();
			}
										   
			var fishUIObj = new FishUI(modelFish,this,fishT);
			fishUIObj.setDepth(4);

			this.myFishArray[this.myFishArray.length] = fishUIObj;
			this.addChild(fishUIObj);
			TFUtil.setFishInFishArray(storeID,storeID);

			if(touch)
			{
				fishUIObj.getFishNode().setPosition(touch.getPosition().clone());
				if(this.SCREEN_HEIGHT - touch.getPosition().getY() >= 100)
					this.destination = new Core.Vector(touch.getPosition().getX(),touch.getPosition().getY() + 100);
				else
					this.destination = new Core.Vector(touch.getPosition().getX(),this.SCREEN_HEIGHT - 30);
				var touchVector = new Core.Vector(touch.getPosition().getX(),touch.getPosition().getY());
				if(currency == kCurrencyType.kCurrencyTypeCoins) 
				{		
					this.textAnimation(touchVector,GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_MESSAGE_COINS_XP'),[price,'1'] ),new Core.Color(0,1,0));
				}
				else
				{
					this.textAnimation(touchVector,GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_MESSAGE_BUCKS_XP'),[price,'1']),new Core.Color(0,1,0));
				}
				moveTo = new GAMoveTo(fishUIObj.getFishNode(),this.destination,1700,true,fishUIObj.startAnimation.bind(fishUIObj));
			}
			else
			{
				fishUIObj.startAnimation();
				
			}
		
		}
		else
		{
			if(touch)
			{
				
				var touchVector = new Core.Vector(touch.getPosition().getX(),touch.getPosition().getY());
				
				// fish not purchasable... no enough money
				if(currency == kCurrencyType.kCurrencyTypeCoins) 
				{
				// no coins

				this.textAnimation(touchVector,GALocalizationHandler.getLocalizedString('TF_NO_FISH_COINS'),new Core.Color(1,0,0));
				}
				else
				{
				this.textAnimation(touchVector,GALocalizationHandler.getLocalizedString('TF_NO_FISH_BUCKS'),new Core.Color(1,0,0));

				}
			}

		}

	},
								   
	   addDecoration: function(storeID, isPurchased)
	   {
		
		   if(!isPurchased)
		   {
		   	 	isPurchased = false;		
		   }
		   console.log("TankUI: addDecoration -> isPurchased -> "+isPurchased);			 
		 
		   var isDecoShowerAble = false;		   
		   var tankDecoration = new TankDecoration(null);
		   tankDecoration._decorationObj.storeId = storeID;
		   tankDecoration._decorationObj.z_index = this.tankModel._tankObj.tankObjectIndex;
			if(isDecoShowerAble)
			{
				if( this.tankModel.addShowerInDatabase(storeID) )
				{
					this.updateShower();					
				}
				
				return;
			}
			
			
			if( this.tankModel.addDecorationInDatabase(tankDecoration,isPurchased) )
			{
				TFUtil.updateResourceDict(tankDecoration._decorationObj,kObjectActionType.kObjectActionAdd,kResourceType.kResourceTypeDecoration);
				this.tankModel._tankObj.tankObjectIndex++;
				var newDecoration = new DecorationUI(tankDecoration,this);
				this.myDecorationArray[this.myDecorationArray.length] = newDecoration;
				newDecoration.setDepth(3); //@GT move depths later to constants..
				this.addChild(newDecoration);
			}
			else
		   {
//			   var storeID=newDecoration._decorationObj.decoration_store_id;
			   var storeID=tankDecoration._decorationObj.storeId;
			   var store_item = GAGameLoader.getStoreHandler().getStoreObjectForKey(storeID);
			   var buyPriceKey = GACommonUtils.getBuyPrice(store_item)
			   var currency = StoreUtil.getCurrency(buyPriceKey)
			   this.target = new Core.Vector(Core.Capabilities.getScreenWidth()/2,Core.Capabilities.getScreenHeight/2);
			   if(currency == kCurrencyType.kCurrencyTypeCoins) 
			   {
					// no coins
				   this.textAnimation( this.target,GALocalizationHandler.getLocalizedString('TF_NOT_ENOUGH_COINS'),new Core.Color(1,0,0));

			   }
			   else
			   {
				   // no bucks
				   this.textAnimation( this.target,GALocalizationHandler.getLocalizedString('TF_ERROR_NO_FISH_BUCKS'),new Core.Color(1,0,0));
				
			   }
			}
			
	   },
								   
		addPlant: function(storeID, isPurchased)
		{
		   if(!isPurchased)
		   {
		   	 	isPurchased = false;		
		   }
		   console.log("TankUI: addPlant -> isPurchased -> "+isPurchased);					   
								   
			var tankPlant = new TankPlant();
			tankPlant._plantObj.storeId = storeID;
			tankPlant._plantObj.z_index = this.tankModel._tankObj.tankObjectIndex;
			
			if( this.tankModel.addPlantInDatabase(tankPlant,isPurchased) )
			{
				TFUtil.updateResourceDict(tankPlant._plantObj,kObjectActionType.kObjectActionAdd,kResourceType.kResourceTypePlant);
				
				
				this.tankModel._tankObj.tankObjectIndex++;
				var newPlant = new PlantUI(tankPlant,this);
				this.myPlantArray[this.myPlantArray.length] = newPlant;
				newPlant.setDepth(3); //@GT move depths later to constants..
				this.addChild(newPlant);
			}
			else
			{
				var storeID=tankPlant._plantObj.storeId;
				var store_item = GAGameLoader.getStoreHandler().getStoreObjectForKey(storeID);
				var buyPriceKey = GACommonUtils.getBuyPrice(store_item)
				var currency = StoreUtil.getCurrency(buyPriceKey)
				this.target = new Core.Vector(Core.Capabilities.getScreenWidth()/2,Core.Capabilities.getScreenHeight/2);
				if(currency == kCurrencyType.kCurrencyTypeCoins) 
				{
					// no coins
					this.textAnimation( this.target,GALocalizationHandler.getLocalizedString('TF_NOT_ENOUGH_COINS'),new Core.Color(1,0,0));
					
				}
				else
				{
				   // no bucks
					this.textAnimation( this.target,GALocalizationHandler.getLocalizedString('TF_ERROR_NO_FISH_BUCKS'),new Core.Color(1,0,0));
				}
			}
			
			
		},
	   
		addFoodBrick: function(storeID, isPurchased)
		{   
		   if(!isPurchased)
		   {
		   	 	isPurchased = false;		
		   }
		   console.log("TankUI: addFoodBrick -> isPurchased -> "+isPurchased);
			
			
			if(this.myFoodBrickArray.length < 1)
			{		   
				var storeFoodBrick = GAGameLoader.getStoreHandler().getStoreObjectForKey(storeID);
				var tankFoodBrick = new TankFoodBrick();
				tankFoodBrick._foodBrickObj.storeId = storeID;
				tankFoodBrick._foodBrickObj.z_index = this.tankModel._tankObj.tankObjectIndex;
				tankFoodBrick._foodBrickObj.created_time = TFGameState.getServerTime();
				this.tankModel._tankObj.tankObjectIndex++;
									   
				TFUtil.updateResourceDict(tankFoodBrick._foodBrickObj,kObjectActionType.kObjectActionAdd,kResourceType.kResourceTypeFoodBrick);
				this.tankModel.addFoodBrickInDatabase(tankFoodBrick, isPurchased);
									   
				this.foodBrickUI = new FoodBrickUI(tankFoodBrick,this);
				this.myFoodBrickArray[this.myFoodBrickArray.length] = this.foodBrickUI;
				this.foodBrickUI.setDepth(4); //@GT move depths later to constants..
				this.addChild(this.foodBrickUI);
				
				timeRemaining = tankFoodBrick.getTimeRemaining();
				this.timerVar = setTimeout(this.removeFoodBrick.bind(this),timeRemaining*1000);
			}
			else
			{
				textForFoodbrick = new TFAnimation(GALocalizationHandler.getLocalizedString('TF_FOODBRICK_MULTIFOODBRICK_CHECK_LABEL'),[TFUtil.getAdjustedY(250),TFUtil.getAdjustedX(170)],new Core.Color(1,0,0));
				this.addChild(textForFoodbrick);
			}
		},
								   
								   
		setTankBackground: function(storeID)
		{
			console.log('testing storeID' + storeID);
		
//			if(storeID==null || storeID=='')
//			{
//				storeID = '1_8_28';
//			}
			
			this.backgroundID = storeID;
			this.setBackGroundImage(this.backgroundID);
		},
		
		setBackGroundImage: function(storeID)
		{
			var storeBackground = GAGameLoader.getStoreHandler().getStoreObjectForKey(storeID);
			var background = new TankBackground();
			background._backgroundObj.name = storeBackground.name;
			background._backgroundObj.storeId = storeID;
			background.addInDatabase();
			background.destroy();
			
		   this._basePath = TFUtil.getBasePathForResourceType(storeID,GAResourceType.kDetail);
	       TFGameState.changeFileName(this._basePath,storeBackground);
			var pathImage = this._basePath+'/default.jpg';
			if(this.background)
			{
				this.removeChild(this.background);
				this.background.destroy();
				this.background = null;
			}
			this.background = new GLFactory.getSprite([this.SCREEN_WIDTH/2,this.SCREEN_HEIGHT/2],0,pathImage, [this.SCREEN_WIDTH,this.SCREEN_HEIGHT], [.5, .5]);
			this.background.setDepth(1);
			this.addChild(this.background);

		},
	
    dropFoodAtPoint: function(touch)
    {
        var touchPos = new Core.Vector(touch.getPosition().getX(),touch.getPosition().getY());
        var tranformTouch = this.screenToLocal(touchPos);
        this.foodParticles.addFoodParticleAtPosition(tranformTouch);
        delete touchPos;
    },
    
	_callBack:function()
	{
		try
		{
			//this._fishEgg.destroy();
		}
		catch(e)
		{
			console.log("add fish from fishegg"+e);
		}
	},

	textAnimation:function(touch,textToDisplay,color)
	{
		try{

		this.text=textToDisplay;
		this.target = new Core.Vector(touch.getX(),touch.getY());						   
		this.color = color;								   
		this.animatedLabel = new TFAnimation(this.text,touch,this.color,this.target);
		this.addChild(this.animatedLabel);
		}
		catch(e)
		{
			console.log("animation of fish label"+e);
			
		}
	
	},
  						   
    getFishUI: function(index)
    {
        if(index >= 0 && index < this.myFishArray.length)
        {
            return this.myFishArray[index];
        }
        return null;
    },
    
    getFishArray : function()
	{
		return this.myFishArray;
	},
    
	setSelectedObject: function(newObject)
	{
		this.selectedObject = newObject;
	},
	
	getSelectedObject: function()
	{
		return this.selectedObject;
	},
    
	didSelectFish: function(fish,location)
	{
		if(this.areButtonsEnabled == false)
		{
			return;
		}
		
		this.disableButtons();
		
		this.selectedFish = fish;
		this.selectedFish._fishObject.currentAction = TFActionType.tfActionNone;
		var controlLayer = GameLayer.getControlLayer();
		var aType=attributeWindowType.fishEnum;
		if(TFGameState.atNeighbor && !this.selectedFish._fishObject.isAlive())
		{
			if(!this.selectedFish._fishObject.isAlive())
			{
				aType=attributeWindowType.deadFishEnum;	
			}
	
			var attributeWindow = new AttributeWindow(aType,fish); 
			controlLayer.addChild(attributeWindow);
			controlLayer.disableButtons();
	
			//play tick sound, if not mute
			this.shouldPlayClickSound = true;
			var soundOn = TFGameState.isOnMute();
	
			if(this.shouldPlayClickSound && !soundOn)
		   {
			   GAAudioManager.playTickSound();
		   }
			this.areButtonsEnabled = true;
		}
		else if(!TFGameState.atNeighbor)
		{
			if(!this.selectedFish._fishObject.isAlive())
			{
				aType=attributeWindowType.deadFishEnum;	
			}
	
			var attributeWindow = new AttributeWindow(aType,fish); 
			controlLayer.addChild(attributeWindow);
			controlLayer.disableButtons();
	
			//play tick sound, if not mute
			this.shouldPlayClickSound = true;
			var soundOn = TFGameState.isOnMute();
	
			if(this.shouldPlayClickSound && !soundOn)
		   {
			   GAAudioManager.playTickSound();
		   }
			this.areButtonsEnabled = true;
		}
	// add attribute window to control layer here.. and disable the right bottom button..
	},
								   
	
	didSelectDecoration: function(decoration,location)
	{
		if(this.areButtonsEnabled == false)
		{
			return;
		}
		
		this.disableButtons();
		
		this.selectedDecoration = decoration;
		this.shouldPlayClickSound = false;
		var controlLayer = GameLayer.getControlLayer();
		var attributeWindow = new AttributeWindow(attributeWindowType.decorationEnum,decoration); 
		controlLayer.addChild(attributeWindow);
		controlLayer.disableButtons();
		this.areButtonsEnabled = true;
	}, 
	sellAllAdultFish:function()
	{
		var totalAdultFishCount = this.tankModel.getAllAdultFishCount() ;
		if(totalAdultFishCount > 0)
		{
			var fishUIArray = this.myFishArray;
			for (var i = 0; i < fishUIArray.length; i++)
			{
				var fish1UI = fishUIArray[i];
				var fishObject = fish1UI.getFishObject();
				if ( fishObject.isAdult() && fishObject.isAlive() ) 
				{ 
					var index = this.myFishArray.indexOf(fish1UI);
					this.myFishArray.splice(index,1);
					this.removeChild(fish1UI);
					fish1UI.destroy();
					i--;
				}
			}
			this.tankModel.sellAllFish();
		}	
			
	},
								   
	deleteAllDeadFish:function()
	{
		var fishUIArray = this.myFishArray;
		   for (var i = 0; i < fishUIArray.length; i++)
		   {
			   var fish1UI = fishUIArray[i];
			   var fishObject = fish1UI.getFishObject();
			   if ( !fishObject.isAlive() ) 
			   { 
				   var index = this.myFishArray.indexOf(fish1UI);
				   this.myFishArray.splice(index,1);
				   this.removeChild(fish1UI);
				   fish1UI.destroy();
				   this.tankModel.deleteFish(fishObject);
				   i--;
			   }
		   }
	   DatabaseInterface.updateTank();
	},


	reviveAllDeadFish:function()
	{
	   var fishUIArray = this.myFishArray;
	   for (var i = 0; i < fishUIArray.length; i++)
	   {
		   var fish1UI = fishUIArray[i];
		   var fishObject = fish1UI.getFishObject();
		   if ( !fishObject.isAlive() ) 
		   { 
				fish1UI.revive();
		   }
	   }
	    if(TFGameState.atNeighbor && TFGameState.isFriend)
		{
		//	DatabaseHelper.updateCurrency(kOperationType.kOperationSubtractBucks,TF_REVIVE_ALL_PRICE);
			//DatabaseHelper.updateUser();
		}
		else
		{
		    TFGameState.getCurrentUser().updateCurrency(kOperationType.kOperationSubtractBucks,TF_REVIVE_ALL_PRICE);
		    DatabaseInterface.updateTank();
		    DatabaseInterface.updateUser();								   
		}        
		if(TFGameState.atNeighbor)
		{
			var feedTime = 0.00;
			var cleanTime = 0.00;
			var giftTime = 0.00;
			var reviveTime = TFGameState.getServerTime();
		    SocialManager.handleSocialAction(kSocialTypes.SEND_NEIGHBOR_ACTION,kSocialFriendActionType.REVIVE_FISHES);//.neighborTankActions(currentTime);
		    this.pushActionToLocalArray(feedTime,cleanTime,giftTime,reviveTime);
	    }
	},
								   
								  
	//Added By Tariq
    sellFish:function(fishUIObj)
    {
								
    	var fishObject = fishUIObj._fishObject;

    	if(this.isLastDistinctFish(fishObject)){
    		console.log("its last distinct fish: removing from array");
    		TFUtil.removeFishFromFishArray(fishObject._fishObj.storeId);
    		this.removeFishFromDistinctFishArray(fishObject);
    		console.log("its last distinct fish: removed from array");
    	}
		
		
		var vector = new Core.Vector(Core.Capabilities.getScreenHeight()/2,Core.Capabilities.getScreenWidth()/2);
		var fishCurrentPrice = fishObject.getCurrentSellPrice();
		this.textAnimation(vector,GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_SELL_ANIMATING_TEXT'),[fishCurrentPrice,2]),new Core.Color(0,1,0));		
		
		TFUtil.updateResourceDict(fishObject._fishObj,kObjectActionType.kObjectActionRemove,kResourceType.kResourceTypeFish);
		
		this.tankModel.sellFish(fishObject._fishObj.objectId,false);						   
		var index = this.myFishArray.indexOf(fishUIObj);
    	this.myFishArray.splice(index,1);
    	this.removeChild(fishUIObj);
    	fishUIObj.destroy();
    	
    	
    },
	
	sellDecoration:function(decorationUIObject)
	{
		TFUtil.updateResourceDict(decorationUIObject.decorationModelObject._decorationObj,kObjectActionType.kObjectActionRemove,kResourceType.kResourceTypeDecoration);
		this.tankModel.sellDecoration(decorationUIObject.decorationModelObject._decorationObj.objectId);
		var index = this.myDecorationArray.indexOf(decorationUIObject);
		this.myDecorationArray.splice(index,1);
		this.removeChild(decorationUIObject);
		decorationUIObject.destroy();
	},

	sellPlant: function(plantUiObject)
	{	
		TFUtil.updateResourceDict(plantUiObject.plantModelObject._plantObj,kObjectActionType.kObjectActionRemove,kResourceType.kResourceTypePlant);
		this.tankModel.sellPlant(plantUiObject.plantModelObject._plantObj.objectId);
		var index = this.myPlantArray.indexOf(plantUiObject);
		this.myPlantArray.splice(index,1);
		this.removeChild(plantUiObject);
		plantUiObject.destroy();
	},
	
    moveToInventory:function(fishUIObj)
    {
    	var index = this.myFishArray.indexOf(fishUIObj);
    	this.myFishArray.splice(index,1);
    	this.removeChild(fishUIObj);
    	fishUIObj.destroy();
    },

		
	getHungeryFishCount : function()
	{
	   var totalFishCount = this.myFishArray.length;
	   var hungryFishCount = 0;
	   for (var i = 0; i < totalFishCount; i++)
	   {
		   var fish1 = this.myFishArray[i];
		   if(fish1._fishObject.isHungry() && fish1._fishObject.isAlive())
		   {
			   hungryFishCount++;
		   }
	   }
	   
	   return hungryFishCount;						   
	},
	showFishFedAlert : function()
	{
		if(TFGameState.atNeighbor)
		{
			var coinsEarned = TF_ALL_FED_COINS_NEIGHBOR;
		}
		else
		{
			var coinsEarned = TF_ALL_FED_COINS;
		}
		
		var xp = TF_ALL_FED_XP;
		var xpString = '';
		if(xp < 2)
			xpString = 'xp';
		else
			xpString = 'xps';
		var hungryFish = this.getHungeryFishCount();
		if(hungryFish == 0)
		{
			GameLayer.getControlLayer().setImageForStoreButton('Content/images/MenuButtons/arrowforgreencircle.png','Content/images/MenuButtons/arrowforgreencircle.png'); 
			var currentTankAction = kTankActionType.kTankActionArrow;
			this.setCurrentTankAction(currentTankAction);
			
			TBParticleAnimation.getSnowParticleAnimation();
			

			if(TFGameState.atNeighbor){
				SocialManager.handleSocialAction(kSocialTypes.SEND_NEIGHBOR_ACTION,kSocialFriendActionType.FEED_FISH);//.neighborTankActions(currentTime);
				if(TFGameState.isFriend)
				{
					var fishFedAlert = new TFMiniUIAlertView("",GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_FRIEND_FISH_FED_ALERT_WINDOW'),[coinsEarned,xp, xpString]),this,"",GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));			
					fishFedAlert.setType("ok");
					fishFedAlert.setTagValue(0001);
					fishFedAlert.setMessageColor("FFFFFF");
					fishFedAlert.setMessageFont(TFUtil.getFontName());
					fishFedAlert.setButtonsFont(TFUtil.getFontName());
					fishFedAlert.setButtonColor("FFFFFF");
					fishFedAlert.show();
				}
				else
				{
					var fishFedAlert = new TFMiniUIAlertView("",GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_NEIGHBOR_FISH_FED_ALERT_WINDOW'),[coinsEarned,xp, xpString]),this,"",GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));			
					fishFedAlert.setType("ok");
					fishFedAlert.setTagValue(0001);
					fishFedAlert.setMessageColor("FFFFFF");
					fishFedAlert.setMessageFont(TFUtil.getFontName());
					fishFedAlert.setButtonsFont(TFUtil.getFontName());
					fishFedAlert.setButtonColor("FFFFFF");
					fishFedAlert.show();
				}
				DatabaseHelper.updateCurrency(kOperationType.kOperationAddCoins, coinsEarned);
				DatabaseHelper.updateXPandLevel(xp);
				DatabaseHelper.updateUser();
				var feedTime = TFGameState.getServerTime();
				var cleanTime = 0.00;
				var giftTime = 0.00;
				var reviveTime = 0.00;
				this.pushActionToLocalArray(feedTime,cleanTime,giftTime,reviveTime);

			} else {
			
				GameLayer.getControlLayer().setImageForStoreButton('Content/images/MenuButtons/arrowforgreencircle.png','Content/images/MenuButtons/arrowforgreencircle.png'); 
				
	//			var fishFedAlert = new TFMiniGLAlertView("",GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_FISH_FED_ALERT_WINDOW'),[coinsEarned,xp, xpString]),this,"",GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
	//			fishFedAlert._type=GALocalizationHandler.getLocalizedString('TF_OK_BUTTON');
	//			fishFedAlert.setTagValue(0001);
	//			fishFedAlert.setMessageColor(255,255,255);
	//			fishFedAlert.setMessageFont(TFUtil.getFont(),TFUtil.getFontLocation());
	//			fishFedAlert.setButtonsFont(TFUtil.getFont(),TFUtil.getFontLocation());
	//			fishFedAlert.show(); 
				
				var fishFedAlert = new TFMiniUIAlertView("",GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_FISH_FED_ALERT_WINDOW'),[coinsEarned,xp, xpString]),this,"",GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));			
				fishFedAlert.setType("ok");
				fishFedAlert.setTagValue(0001);
				fishFedAlert.setMessageColor("FFFFFF");
				fishFedAlert.setMessageFont(TFUtil.getFontName());
				fishFedAlert.setButtonsFont(TFUtil.getFontName());
				fishFedAlert.setButtonColor("FFFFFF");
				fishFedAlert.show();
				
				var myUser = TFGameState.getCurrentUser();
				myUser.updateCurrency(kOperationType.kOperationAddCoins, coinsEarned);
				myUser.updateXPandLevel(xp);
				DatabaseInterface.updateUser();
				DatabaseInterface.updateTank();
				GameLayer.getControlLayer().getControlLayerAbove().updateTopPanel();
			}
		}
	},
	
	pushActionToLocalArray: function(feedTime, cleanTime, giftTime, reviveTime){
		
		this._neighborActionArray = SocialActionsHandler.getNeighborActionArray();
		
		uname = GAConfigurations.getUserId();
		rname = TFGameState.getCurrentUser()._userObj.name;
		game = 'ngFish';
		tankID = TFGameState.getCurrentUser()._userObj.selectedTankId;
		
		{
			var actionsModel = new ActionsModel();
			var objId = this._neighborActionArray.length;
			
			actionsModel.setObjId(objId);
			//user Info
			actionsModel.setName(uname+'');
			actionsModel.setRname(rname+'');
			actionsModel.setUdid(uname+'');
			actionsModel.setGame(game+'');
//				//actions performed
			
			actionsModel.setCleanTimeStamp(cleanTime+'');
			actionsModel.setFeedTimeStamp(feedTime+'');
			actionsModel.setGiftTimeStamp(giftTime+'');
			actionsModel.setReviveTimeStamp(reviveTime+'');
			actionsModel.setTankId(tankID+'');
			
			//console.log("ahsan TankUI :: actionsModel "+actionsModel);
			this._neighborActionArray.push(actionsModel);
		}
		//console.log("ahsan TankUI :: this._neighborActionArray3 "+this._neighborActionArray);this._neighborActionArray = SocialActionsHandler.getNeighborActionArray();
		
	},
	
	
		
	clickedButtonAtIndex: function(buttonIndex,fishFedAlert)
	{
		
		if (buttonIndex == 0) 
		{
			switch(fishFedAlert.getTagValue())
			{
				case 0001:
				{
					
					console.log("GT: Alrt ok option");
				}
				default:
				{
					
				}
			}
			
		}
		else if (buttonIndex == 1) 
		{
			this.destroy();
		}
		
	},

    
	moveDecorationToInventory:function(decorationUIObject)
	{
		this.tankModel.moveDecorationToInventory(decorationUIObject.decorationModelObject._decorationObj.objectId);
		var index = this.myDecorationArray.indexOf(decorationUIObject);
		this.myDecorationArray.splice(index,1);
		this.removeChild(decorationUIObject);
		decorationUIObject.destroy();
	},
	
	moveDecorationFromInventory:function(decorationModel)
	{
		this.tankModel.addDecorationInDatabase(decorationModel,true);
		var newDecoration = new DecorationUI(decorationModel,this);
		this.myDecorationArray[this.myDecorationArray.length] = newDecoration;
		newDecoration.setDepth(3); //@GT move depths later to constants..
		this.addChild(newDecoration);
			
	},

	moveFishToInventory:function(fishUIObj)
	{
		
		this.tankModel.moveFishToInventory(fishUIObj._fishObject._fishObj.objectId);
		var index = this.myFishArray.indexOf(fishUIObj);
//		console.log(this.myFishArray[index].getStoreId());
		if(this.isLastDistinctFish(fishUIObj._fishObject)){
    		console.log("its last distinct fish: removing from array");
    		TFUtil.removeFishFromFishArray(fishUIObj._fishObject._fishObj.storeId);
    		this.removeFishFromDistinctFishArray(fishUIObj._fishObject);
    		console.log("its last distinct fish: removed from array");
    	}
		
		this.myFishArray.splice(index,1);
		this.removeChild(fishUIObj);
		fishUIObj.destroy();
	},
	
	removeAlgae: function(){
		
		if(this.algaeLayer != null){
			this.tempCurrentAlgae = 0;
			this.algaeLayer.setAlgaePercentage(0); //algae cant be in tank if there is algae eater
			//this.algaeLayer.draw();	
		}
	},

	moveFishFromInventory:function(fishModel)
	{
			if(this.foodBrickUI)
			{
				var timeToAdd = this.foodBrickUI.foodBrickModelObject.getTimeRemaining();
				var time = TFGameState.getServerTime();
				fishModel.updateLastFedToTime(time+timeToAdd);
		    }
			
//			if(fishModel.getCategoryId() == ALGAE_EATER_CATEGORY_ID){
//				this.removeAlgae();
//			}

			if(this.isDistinctFish(fishModel)){
				console.log("ADDING DISTINCT FISH");
				this.distinctFishes.push(fishModel);
				console.log("ADDED DISTINCT FISH new length " + this.distinctFishes.length);
			}


		this.tankModel.addFish(fishModel,true);
		var newFish = new FishUI(fishModel,this);
		this.myFishArray[this.myFishArray.length] = newFish;
		newFish.setDepth(4); //@GT move depths later to constants..
		this.addChild(newFish);
		newFish.startAnimation();
	},

	movePlantToInventory:function(plantUiObject)
	{
		this.tankModel.movePlantToInventory(plantUiObject.plantModelObject._plantObj.objectId);
		var index = this.myPlantArray.indexOf(plantUiObject);
		this.myPlantArray.splice(index,1);
		this.removeChild(plantUiObject);
		plantUiObject.destroy();
	},

	movePlantFromInventory:function(plantModelObject)
	{
		this.tankModel.addPlantInDatabase(plantModelObject,true);
		var newPlant = new PlantUI(plantModelObject,this);
		this.myPlantArray[this.myPlantArray.length] = newPlant;
		newPlant.setDepth(3); //@GT move depths later to constants..
		this.addChild(newPlant);
	},
	

	// Algae Tank Functions
	intermediateAlgaeCalculation:function(midAlgaePercentage)
	{
		var difference = this.tempCurrentAlgae - midAlgaePercentage;
		if ( difference >= 7 )
		{
			this.tempCurrentAlgae = midAlgaePercentage;
			TFGameState.getCurrentUser().updateCurrency(kOperationType.kOperationAddCoins, 5);
			this.tempRewardCoins += 5;
			this.tempRewardXP += 1;
			TFGameState.getCurrentUser().updateXPandLevel(1);
			GameLayer.getControlLayer().getControlLayerAbove().updateTopPanel();
		}
	},

	algaeRemainingCallback:function(algaePercentage)
	{
			if(algaePercentage == 0 && this.tempRewardCoins > 0)
			{
				DatabaseInterface.updateTank();
				GameLayer.getControlLayer().setImageForStoreButton('Content/images/MenuButtons/arrowforgreencircle.png','Content/images/MenuButtons/arrowforgreencircle.png'); 
				this.setCurrentTankAction(kTankActionType.kTankActionArrow);
				TBParticleAnimation.getSnowParticleAnimation();
				
				//disable only when its enabled
				if(GAAudioManager.isCleanSoundEnabled()){
					GAAudioManager.disableCleanSound();
				}
				
				if(TFGameState.atNeighbor){
					var xp = this.tempRewardXP;
					var coins = this.tempRewardCoins;
					if(this.tempRewardXP ==1)
					{
						xp = this.tempRewardXP + " xp";
					}
					else if(this.tempRewardXP > 1)
					{
						xp = this.tempRewardXP + " xps";
					}

					//var currentTime = Math.round((new Date()).getTime() / 1000);
					//NgLogE("inside algaeRemainingCallback :: TFGameState.atNeighbor :: currentTime " +currentTime);
					SocialManager.handleSocialAction(kSocialTypes.SEND_NEIGHBOR_ACTION,kSocialFriendActionType.CLEAN_TANK);//.neighborTankActions(currentTime);
					this.tempRewardCoins = 2;
					this.tempRewardXP = 1;
					var tankOwner = "neighbor's";
					if(TFGameState.isFriend){
						tankOwner = "friend's";
					}
					var myString = GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_MSG_NEIGHBOR_TANK_CLEAN'), [ this.tempRewardCoins, tankOwner])
					var alertWindow = new TFMiniGLAlertView("",myString,this,GALocalizationHandler.getLocalizedString('TF_CANCEL_BUTTON'),GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
					alertWindow.setType("ok");
					alertWindow.setMessageColor("FFFFFF");
					alertWindow.setMessageFont(TFUtil.getFont(),TFUtil.getFontLocation());
					alertWindow.setButtonsFont(TFUtil.getFont(),TFUtil.getFontLocation());
					alertWindow.show();
						
					DatabaseHelper.updateCurrency(kOperationType.kOperationAddCoins, this.tempRewardCoins);
					DatabaseHelper.updateXPandLevel(this.tempRewardXP);
					DatabaseHelper.updateUser();
					
					var cleanTime = TFGameState.getServerTime();
					var feedTime = 0.00;
					var giftTime = 0.00;
					this.pushActionToLocalArray(feedTime,cleanTime,giftTime);

					
				} else {
				// the following calclation is to determice the singularity or plurality of the xps after the tank is cleaned.
					if(this.tempRewardXP ==1)
					{
						this.tempRewardXP = this.tempRewardXP + " xp";
					}
					else if(this.tempRewardXP > 1)
					{
						this.tempRewardXP = this.tempRewardXP + " xps";
					}
					
					var myString = GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_MSG_TANK_CLEAN'), [ this.tempRewardCoins, this.tempRewardXP])
					var alertWindow = new TFMiniGLAlertView("",myString,this,GALocalizationHandler.getLocalizedString('TF_CANCEL_BUTTON'),GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
					alertWindow.setType("ok");
					alertWindow.setMessageColor(255,255,255);				   
					alertWindow.setMessageFont(TFUtil.getFont(),TFUtil.getFontLocation());
					alertWindow.setButtonsFont(TFUtil.getFont(),TFUtil.getFontLocation());
					alertWindow.show();
									   
					this.algaeLayer.setAlgaePercentage(0); //algae cant be in tank if there is algae eater
					//this.algaeLayer.draw();
					
					
				}
					
			}
			
			var algaeInOneSecond = ( 75 / (36 * 60.0 * 60.0) ); 
			var currentTime = TFGameState.getServerTime();
			var lastTime = currentTime - (algaePercentage / algaeInOneSecond);
			this.tankModel._tankObj.lastCleaned = lastTime;
			this.tankModel.updateTank();
			
	},
	
	clearArray: function (array) {
		for(var i=0 ;i < array.length;i++) {
			var obj = array[i];
			if(obj != null){
				this.removeChild(obj);
				obj.destroy();
				obj = null;
				array.splice(i,1);
				--i;
			}
		}
		delete array;
		array = null;
	},

    destroy: function($super)
    {
    	if(this.timerVar)
		{
			clearTimeout(this.timerVar);
			this.timerVar = null;
		}
    	
    	if(this.myMessageListener) {
    		this.myMessageListener.destroy();
    		this.myMessageListener = null;
    	}
    	this.clearArray(this.myFishArray);
    	console.log("faizan clearedFishArray");
    	this.clearArray(this.myDecorationArray);
    	this.clearArray(this.myPlantArray);
    	this.clearArray(this.myFoodBrickArray);
		if(this.tankModel)
		{
			this.tankModel.destroy();
			this.tankModel = null;
		}
		TFUtil.destroyNodeChildren(this);
		$super();
    },
    
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/GLLayer/FoodParticles'] = function(){var exports = $MODULE_REGISTRY['Code/GLLayer/FoodParticles'] || {}; $MODULE_REGISTRY['Code/GLLayer/FoodParticles'] = exports; 
var SCREEN_WIDTH = 480;
var SCREEN_HEIGHT = 320;
var MAX_FOOD_PARTICLES = 30;


exports.FoodParticles = GL2.Node.subclass({
    classname: 'FoodParticles',
    
    initialize: function($super,tankSelected) 
    {
    	$super();
       this._movePartTimer = null;
       this.selectedTank = tankSelected;
       this.active = new Array();
       this.food = new Array();
       this.deltas = new Array();
       this.particlesCount = 0;
       return this;
    },
    
    addFoodParticleAtPosition: function(pos)
    {
        if(this.particlesCount >= MAX_FOOD_PARTICLES) 
        	return;
        
        var foodSprite = new GL2.Sprite();
        foodSprite.setImage('./Content/foodparticles.png',[46,46],[.5,.5]);
        
        var deltaVec = new Core.Vector();
        deltaVec.setX(Math.random()*.4);
        deltaVec.setY((.8 + (Math.random()*20)/100));
        this.deltas.push(deltaVec);
        var newPosVec = new Core.Vector(pos.getX()+Math.random()*25,pos.getY()+Math.random()*25);
        foodSprite.setPosition(newPosVec);
        this.addChild(foodSprite);
        this.food.push(foodSprite);
        this.active.push(false);
        this.particlesCount++;
        delete newPosVec;
       if(this._movePartTimer == null)
    	   this._movePartTimer = setTimeout(this.moveParticles.bind(this),TF_TIMER_INTERVAL);
           
        
    },
    
    moveParticles: function()
    {
    	if(this.food == null)
    		return;
        for(var i = 0; i< this.food.length; i++)
        {
            if(this.food[i] != null) {
        		if(this.food[i].getPosition().getY() < 300)
                {
                    var newPos = new Core.Vector(this.food[i].getPosition().getX() + this.deltas[i].getX(),this.food[i].getPosition().getY()+this.deltas[i].getY());
                    this.food[i].setPosition(newPos);
                    delete newPos;
                }
                else
                {
                    this.food[i].setAlpha(this.food[i].getAlpha() - .008);
                }
                
                if(this.food[i].getAlpha() <= 0)
                {
                    this.destroyFoodParticle(i);

                }
            }
		}
        
		var fishArray = this.selectedTank.getFishArray();
		for(var i = 0 ; i < fishArray.length ; i++)
		{	
			var fish = fishArray[i];
			if(fish.isFishHungry())
			{                    
				
				var index = this.getNearestParticleIndex(fish.getFishSprite().getPosition());
				
				if((this.food[index] != null) && (!this.active[index]) && (index != null) && (fish.eatFoodParticle(index)))
                {
                	this.active[index] = true;
                }
             
            }
		}

        this._movePartTimer =  setTimeout(this.moveParticles.bind(this,1),TF_TIMER_INTERVAL);
  
    },
    
    
    getNearestParticleIndex: function(fromPosition)
    {
        
        for(var i = 0; i< this.food.length ; i++)
        {
        	
        	if(this.food[i] != null) {
	            var distanceVec = new Core.Vector(this.food[i].getPosition().getX() - fromPosition.getX(),
	                                                this.food[i].getPosition().getY() - fromPosition.getY());
	            var dist = Math.sqrt(Math.pow(distanceVec.getX(),2)+Math.pow(distanceVec.getY(),2));
	            if(!this.active[i]) {
	                if(dist < TF_TANK_FOOD_PICK_DISTANCE )
	                {
	                	delete distanceVec;
	                    return i;
	                    
	                }
	            }
        	}
        }
        return null;
    },
    
    destroyFoodParticle : function (i) {
    	if(this.food && this.food[i] != null) {
	    	 this.removeChild(this.food[i]);
	         this.food[i].destroy();
	         this.food[i] = null;
	         delete this.deltas[i];
	         this.particlesCount--;
	         if(this.particlesCount == 0) {
        		this.clearFoodParticlesArray();
              	clearTimeout(this._movePartTimer);
              	this._movePartTimer = null;
	         }
    	}
    },
    
    clearFoodParticlesArray: function () {
    	for (var i=0 ;i <this.food.length;i++) {
    		this.food.splice(i,1);
    		this.deltas.splice(i,1);
 	        this.active.splice(i,1);
 	        --i;
    	}
    },
    
    consumeFoodParticle: function(index)
    {
        if(index >= 0 && index < this.food.length)
        {
        	this.destroyFoodParticle(index);
        }
    },
    
    getFoodParticlePosition: function(index)
    {
        if(index >= 0 && index < this.food.length)
        {
        	if(this.food[index] != null)
        		return this.food[index].getPosition().clone();
        }
        return new Core.Vector(-1,-1);
    },
    
    
    ignoreFoodParticle: function(index)
	{
		if(index >= 0 && index< this.food.length)
		{
			if(this.active[index])
			{
				this.active[index] = false;
			}
		}
	},
    
    destroy: function($super)
    {	
    	if(this._movePartTimer)
		{
			clearTimeout(this._movePartTimer);
			this._movePartTimer = null;
		}
    	
		delete this.active;
		this.active = null;
		
		for(i = 0; i < this.food.length; i++)
		{
			if(this.food[i] != null) {
				var tempFood = this.food[i];
				tempFood.destroy();
			}
		}
		delete this.food;
		this.food = null;
		
		delete this.deltas;
		this.deltas = null;
		TFUtil.destroyNodeChildren(this);
		$super();
    },
    
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/GLLayer/TFAnimation'] = function(){var exports = $MODULE_REGISTRY['Code/GLLayer/TFAnimation'] || {}; $MODULE_REGISTRY['Code/GLLayer/TFAnimation'] = exports; 
exports.TFAnimation = GL2.Node.subclass({
	
	classname: 'TFAnimation',
	initialize: function($super,text,position,color,target)
    {
    	//console.log("ANimation class....");
		$super();
		this._label = new GLFactory.getText(position,8000,text,[350,50],GACommonUtils.getAdjustedFontSize(200));
		this._label.setAnchor(0.5,0.5);
		this._label.setFontLocation(TFUtil.getFontLocation());
		this._label.setFontFamily(TFUtil.getFont());
		this._label.setColor(color.getRed(),color.getGreen(),color.getBlue());
		this._label.setDepth(4);
		//this._label.setTextSize();
		this.addChild(this._label);
		this.setDepth(4);
		
		this._updateListener = new Core.MessageListener();
		Core.UpdateEmitter.addListener(this._updateListener, this.animateLabel.bind(this));
		
    },
    
    showAnimation: function()
	{
	},
	
	
    animateLabel: function()
	{
		if(this._label.getAlpha() <= 0 )
		{
			this.removeAnimation();
			this.destroy();
			return;
		}
		var x = this._label.getPosition().getX();
		var y = this._label.getPosition().getY();
		
		
		this._label.setPosition(x,y-.4);
		
		var newAlpha = this._label.getAlpha();
		this._label.setAlpha(newAlpha - 0.030);
		
	},
	
	removeAnimation:function()
	 {
		if(this.getParent() != null) 
		{
			this.getParent().removeChild(this);
		}
		Core.UpdateEmitter.removeListener(this._updateListener, this.animateLabel.bind(this));
	},
	
	destroy:function($super)
	{
		if(this._updateListener) {
			this._updateListener.destroy();
			this._updateListener = null;
		}
		if(this._label) {
			this.removeChild(this._label);
			this._label.destroy();
			this._label = null;
		}
		$super();
	},
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/GLLayer/TFControlLayer'] = function(){var exports = $MODULE_REGISTRY['Code/GLLayer/TFControlLayer'] || {}; $MODULE_REGISTRY['Code/GLLayer/TFControlLayer'] = exports; 

exports.TFControlLayer = GL2.Node.subclass(
{
	classname: 'TFControlLayer',
	initialize: function() 
	{
		//this.superUserEnabled = false;
		//this.qaUserEnabled = false;
		this.flag=true;
		this.destination = null;
		this.moveBack = null;
		this.moveTo = null;
		this.update = false;
		var w=0, h = 0 , myMessageListener = 0;
		w = Core.Capabilities.getScreenWidth();
		h = Core.Capabilities.getScreenHeight();
		this.iconSize = new Core.Size(w*0.080,w*0.080);	
										   
		this.isAnimating=true;
		this.setAreButtonsEnabled(true);
		this._tfControlLayerAbove= new TFControlLayerAbove();
		this._tfControlLayerAbove.getParentNode().setPosition(TFUtil.adjustHeightWithDevice(480),TFUtil.adjustWidthWithDevice(0));
		this.addChild(this._tfControlLayerAbove.getParentNode());

		this._topBarAnimation = new GLButton('./Content/images/UIPanels/TopBar/topArrow_right.png','./Content/images/UIPanels/TopBar/topArrow_right.png', TFUtil.adjustHeightWithDevice(30),TFUtil.adjustWidthWithDevice(25),this.onClick.bind(this),this,null);
		this._topBarAnimation.setPosition(TFUtil.getAdjustedY(465),TFUtil.getAdjustedX(20));
		this.button=this._topBarAnimation.getButton();
		this.button.setImage('./Content/images/UIPanels/TopBar/topArrow_left.png',[TFUtil.getAdjustedY(30),TFUtil.getAdjustedX(25)]);
		setTimeout(this.setTopBar.bind(this),500);

		this._storeButton = new GLButton('./Content/images/MenuButtons/greencircleicon.png','./Content/images/MenuButtons/greencircleicon_over.png', TFUtil.adjustHeightWithDevice(34), TFUtil.adjustWidthWithDevice(34), this.onTouchStore.bind(this),this,null);
		this._storeButton.setPosition(TFUtil.getAdjustedY(455),TFUtil.getAdjustedX(300));
		this.setImageForStoreButton('./Content/images/MenuButtons/arrowforgreencircle.png','./Content/images/MenuButtons/arrowforgreencircle.png');
		
		if(TFGameState.atNeighbor){
			this._homeButton = new GLButton('./Content/images/MenuButtons/greencircleicon.png','./Content/images/MenuButtons/greencircleicon_over.png', TFUtil.adjustHeightWithDevice(34), TFUtil.adjustWidthWithDevice(34), this.onTouchHome.bind(this),this,null);
			this._homeButton.setPosition(TFUtil.getAdjustedY(420),TFUtil.getAdjustedX(300));
			
			this.setImageForHomeButton('./Content/images/MenuButtons/home.png','./Content/images/MenuButtons/home.png');
		
		
		}
//		
//		if(!TFGameState.atNeighbor){
//			this._dailySpinButton = new GLButton('./Content/images/DailySpinUI/win0.png','./Content/images/DailySpinUI/win1.png', TFUtil.adjustHeightWithDevice(34), TFUtil.adjustWidthWithDevice(34), this.onTouchDailySpin.bind(this),this,null);
//			this._dailySpinButton.setPosition(TFUtil.getAdjustedY(390),TFUtil.getAdjustedX(300));
//				
//		}
		
		this._storeWindowLayer = null;
		this.notificaitonButton= null;
		this.notificationLabel = null;
		this._giftButton = null;
		
		if(TFStorageManager.getValueFromUserDefault(kUserDefaultKeys[3])!=null && TFStorageManager.getValueFromUserDefault(kUserDefaultKeys[3])!=false)
		{
			this.addQAUserButton();
		}									 
		
		if(TFStorageManager.getValueFromUserDefault(kUserDefaultKeys[4])!=null && TFStorageManager.getValueFromUserDefault(kUserDefaultKeys[4])!=false)
		{			
			this.addSuperUserButton();
		}
	
		if(TFGameState.atNeighbor) {
			this.showGiftIcon();
		}
		
		if(TFGameState.atNeighbor) {
			this.showStatsRateButton(true);
		}
		else
		{
			this.showStatsRateButton(false);
		}
		
		
		return this;
	},
	
	clickedButtonAtIndex: function(buttonIndex,fishFedAlert)
	{
		
		if (buttonIndex == 0) 
		{
			switch(fishFedAlert.getTagValue())
			{
				case 0001:
				{
					
					console.log("GT: Alrt ok option");
				}
				default:
				{
					
				}
			}
			
		}
		else if (buttonIndex == 1) 
		{
		
		}

	},
	
	fetchEnvelopNotifications : function() {
		SocialManager.handleSocialAction(kSocialTypes.CALLBACK_ENABLE,true);
		SocialManager.handleSocialAction(kSocialTypes.FRIEND_REQUEST_LIST,kSocialFriendHandlerCallType.GAMELAYER);
		SocialManager.handleSocialAction(kSocialTypes.RECEIVE_GIFTS_COUNT,null);
	},
	

	onTouchSettingsButton: function()
	{
		if(GameLayer.getControlLayer()._areButtonsEnabled)
		{
			GameLayer.getControlLayer().disableButtons();
	   	}
		else
	   	{
			return;
	   	}
		
		this.settingsUI = new TFSettingsUI();
		GameLayer.getControlLayer().addChild(this.settingsUI);  
	},
	
	disableNotificationButton : function () {
		if(this.notificaitonButton) {
			//this.removeChild(this.notificaitonButton);
			this.notificaitonButton.destroy();
			this.notificaitonButton = null;
		}
		if(this.notificationLabel) {
			//this.removeChild(this.notificationLabel);
			this.notificationLabel.destroy();
			this.notificationLabel = null;
		}
	},
	
	setNotificationLabelText: function (text) {
		
		if(TFGameState.atNeighbor)
		{
			return;
		}
		
		if(text == null || text == 'undefined' || text == '' || text == 0) {
			return;
		}

//		console.log('faizan notificaton' + this.notificaitonButton);
		if(text == null || text == 'undefined' || text == '' || text == 0) {
			return;
		}
		if(this.notificaitonButton == null || this.notificaitonButton == 'undefined') {
			this.notificaitonButton = new GLButton(SOCIALAPI_ENVELOP_IMG_PATH,SOCIALAPI_ENVELOP_SELECTED_IMG_PATH, TFUtil.adjustHeightWithDevice(46), TFUtil.adjustWidthWithDevice(34), this.envelopClicked.bind(this),this,null);
			this.notificaitonButton.setPosition(TFUtil.getAdjustedY(410),TFUtil.getAdjustedX(300));
		}
		if(this.notificationLabel == null || this.notificationLabel == 'undefined' ) {
			this.notificationLabel = new GLFactory.getText([TFUtil.getAdjustedY(420),TFUtil.getAdjustedX(295)],null,'',[TFUtil.adjustHeightWithDevice(46), TFUtil.adjustWidthWithDevice(34)],17);
			this.notificationLabel.setColor(0, 0, 0);
			this.addChild(this.notificationLabel);
		}
		var currentText = this.notificationLabel.getText();
//		if(text == -1) {
//			this.update = true;
//			NgLogE("TFControlLayer: -> text -1 ->"+ "this.update -> "+this.update);
//			return;
//		}
//		if(this.update){
//			currentText = '';
//			this.update =  false;
//			NgLogE("TFControlLayer: -> this.update true! -> currentText-> "+currentText+ "... "+" -> this.update -> "+this.update);
//		}
		
		if(currentText == null || currentText == '' || currentText =='undefined' || currentText.length==0)
		{
			this.notificationLabel.setText(text);
			//NgLogE("TFControlLayer: -> setting to text");
		}
		else
		{
			this.notificationLabel.setText(parseInt(currentText)+parseInt(text));
			//NgLogE("TFControlLayer: -> setting to currentText + text");
		}

	},
	
	decrementNotificationCount: function(count, isGift)
	{
		if(this.notificationLabel == null || this.notificationLabel == 'undefined')
			return;
		
		if(!isGift)
		{
			isGift = false;	
		}
		
		var currentCount = this.notificationLabel.getText();
		currentCount = parseInt(currentCount);
		
		if(currentCount>0 && currentCount!=1)
		{
			this.notificationLabel.setText(currentCount-count);
		}
		else
		{
			this.disableNotificationButton();
		}
		
		if(isGift)
		{
			var currentGiftsCount = TFStorageManager.getValueFromUserDefault(kUserDefaultKeys[8]);								   
			if(currentGiftsCount == null || currentGiftsCount == 'undefined')
			{
				currentGiftsCount = 0;
				TFStorageManager.saveToUserDefault(kUserDefaultKeys[8], currentGiftsCount);
				//console.log("TFControlLayer -> NULL -> kUserDefaultKeys[8] -> "+kUserDefaultKeys[8]+ " -> currentGiftsCount -> "+currentGiftsCount);
				return;
			}
			
			currentGiftsCount = currentGiftsCount - count;
			TFStorageManager.saveToUserDefault(kUserDefaultKeys[8], currentGiftsCount);
			//console.log("TFControlLayer -> kUserDefaultKeys[8] -> "+kUserDefaultKeys[8]+ " -> currentGiftsCount -> "+currentGiftsCount);
		}
	},
	
	setNoGiftAvailable: function()
	{
		//if current giftsCount >0 -> decrement the count on screen as well as store giftsCount as 0
		
		var currentGiftsCount = TFStorageManager.getValueFromUserDefault(kUserDefaultKeys[8]);								   
		if(currentGiftsCount == null || currentGiftsCount == 'undefined')
		{
			currentGiftsCount = 0;
			TFStorageManager.saveToUserDefault(kUserDefaultKeys[8], currentGiftsCount);
			//NgLogE("TFControlLayer -> NULL -> kUserDefaultKeys[8] -> "+kUserDefaultKeys[8]+ " -> currentGiftsCount -> "+currentGiftsCount);
			return;
		}
		
		if(currentGiftsCount > 0)
		{
			//NgLogE("TFControlLayer -> currentGiftsCount>0 -> "+currentGiftsCount);
			if(this.notificationLabel == null || this.notificationLabel == 'undefined')
			{
				//NgLogE("TFControlLayer -> No notifications present, setting gifts to zero");
				TFStorageManager.saveToUserDefault(kUserDefaultKeys[8], 0);
			}
			else
			{
				this.decrementNotificationCount(currentGiftsCount, true);
			}
		}
		else
			console.log("TFControlLayer -> currentGiftsCount<=0 ");

	},
	
	
	envelopClicked: function () {
		if(this.getControlLayerAbove()._isInfoButtonOpened)
		{
			this.getControlLayerAbove().closeLeftPanel();
		}
		SocialManager.showSocialScreen(GameLayer._GLNode,kSocialUIType.NOTIFICATIONSUI,TFGameState.atNeighbor);
	},
	
	giftClicked: function () {
		if(this.getControlLayerAbove()._isInfoButtonOpened)
		{
			this.getControlLayerAbove().closeLeftPanel();
		}
		SocialManager.showSocialScreen(GameLayer._GLNode,kSocialUIType.GIFTSUI,true);
	},
	
	
	showGiftIcon: function () {
		if(this._giftButton == null) {
			this._giftButton = new GLButton(SOCIALAPI_GIFT_ICON_IMG_PATH,SOCIALAPI_GIFT_ICON_SELECTED_IMG_PATH, TFUtil.adjustHeightWithDevice(33), TFUtil.adjustWidthWithDevice(34), this.giftClicked.bind(this),this,null);
			this._giftButton.setPosition(TFUtil.getAdjustedY(460),TFUtil.getAdjustedX(70));
		}
	},
	
	statsButtonClicked: function(){
		
		var TFStatsView = require('Code/UI Layers/TFStatsView').TFStatsView;
		this._statsView = new TFStatsView();
		this._statsView.show();
		
	},
	
	clickedButtonAtIndex: function(buttonIndex,alertWindow)
	{
		
	},
	
	rateNeighborClicked: function () {
		
		var user = TFGameState.getCurrentUser();
		var socialFriends = SocialUtil.getSocialFriends();
		var socialFriend = null;
		if(socialFriends.isFriendExist(user.getUsername())) {
			socialFriend = socialFriends.getFriendWithName(user.getUsername());
		}
		else {
			socialFriend = socialFriends.getFriendWithName('-1');
		}
		var timeStamp = socialFriend.getLastRateTime();
		var mess =  SocialUtil.getParsedVisitTime(timeStamp);
		if(mess != '-1') {
			 this.showRateAlert(mess);
			 return;
		}
		
		var TFRatingView = require('Code/UI Layers/TFRatingView').TFRatingView;
		this._statsRateView = new TFRatingView(this);
		this._statsRateView.showRatingsScreen();
	},
	
	showRateAlert: function (mess) {
		var alert =  new SocialMiniUIAlertView('',GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_RATING_MESSAGE'),[mess]),this,null,GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
		alert.setTagValue(0001);
		alert.setMessageColor("FFFFFF");
		alert.setTitleFont(SocialUtil.getFontName())
		alert.setMessageFont(SocialUtil.getFontName());
		alert.setButtonsFont(SocialUtil.getFontName());
		alert.setButtonColor("FFFFFF");
		alert.show();
	},
	
	updateRating: function () {
		this.updateFillerStars();
	},
	
	updateFillerStars : function () {
		var user = TFGameState.getCurrentUser();
		this._filledStars.setImage(
				'Content/images/StatsRateScreen/star-fish-01.png',
				[ TFUtil.adjustHeightWithDevice(user.getRatingPercentage() * 1.16),
						TFUtil.adjustWidthWithDevice(52) ], [0, 0 ],
				new Core.Rect([ 0, 0 ], [user.getRatingPercentage() / 100, 1 ]));
	},
	
	ratingVoted: function () {
		this.updateRating();
	},
	
	showStatsRateButton: function(onVisit){
		
		
		if(this.statsRateButton) {
			this.removeChild(this.statsRateButton);
			this.statsRateButton.destroy();
			this.statsRateButton = null;				
		}
		
		if(onVisit)
		{	
			//get rating of the visited tank, then draw the scale on the top left which will be clickable
			//a click will open up the big scale where you can rate this tank yourself
			
			//here a function call would be made that would return the current popularity(rating) of the tank being
			//visited, if not ... show 50% by default
			
			 var emptyStars = new GLButton(
					 'Content/images/StatsRateScreen/bg-01.png',
					 'Content/images/StatsRateScreen/bg-01.png',
						TFUtil.adjustHeightWithDevice(116), TFUtil.adjustWidthWithDevice(52),
						this.rateNeighborClicked.bind(this), this,
						-100);
			 emptyStars.setPosition(TFUtil.getAdjustedY(67),
						TFUtil.getAdjustedX(77));
			
			var receiverName = null;
			if(TFGameState.getCurrentUser().getUsername() == 0 || TFGameState.getCurrentUser().getUsername() == '' && TFGameState.isFriend)
      		 {
          		 receiverName = TFGameState._neighborName;
      		 }
      		 else
      		 	 receiverName = TFGameState.getCurrentUser().getUsername();
      		 	 
      		 	 
			 var label = GLFactory.getText([TFUtil.getAdjustedY(67),TFUtil.getAdjustedX(60)],-100,GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_RATE_NEIGHBOR'),[receiverName]),[TFUtil.adjustHeightWithDevice(116),TFUtil.adjustWidthWithDevice(30)],TFUtil.getAdjustedFontSize(70),GL2.Text.HorizontalAlign.Center);
			 label.setColor(1, 1, 1);
			 label.setFontLocation(TFUtil.getFontLocation());
			 label.setFontFamily(TFUtil.getFont());
			 this.addChild(label);
			  
			
			this._filledStars = GLFactory
					.getSprite(
							[ TFUtil.getAdjustedY(9),
									TFUtil.getAdjustedX(51) ],
							-100,
							'Content/images/StatsRateScreen/star-fish-01.png',
							[ TFUtil.adjustHeightWithDevice(116), TFUtil.adjustWidthWithDevice(52) ],
							[ 0, 0 ]);
			
			this.updateRating();
			this.addChild(this._filledStars)
	
		}
		else
		{		
			
			console.log("TFControl")
							
			this.statsRateButton = new GLButton('Content/images/StatsRateScreen/tf-stats-btn-1.png','Content/images/StatsRateScreen/tf-stats-btn-2.png',
									  TFUtil.adjustHeightWithDevice(33), TFUtil.adjustWidthWithDevice(34), this.statsButtonClicked.bind(this),this,null);
			this.statsRateButton.setPosition(TFUtil.getAdjustedX(30),TFUtil.getAdjustedY(55));								
								
		}
	},
	
	onClick:function()
	{
		if(this.isAnimating)
		{
			if(this.flag)
			{
				try
				{
					this.destination = new Core.Vector(TFUtil.adjustHeightWithDevice(-40),TFUtil.adjustWidthWithDevice(0));
					this.moveBack = new Core.Vector(TFUtil.adjustHeightWithDevice(480),TFUtil.adjustWidthWithDevice(0));
					this.path='./Content/images/UIPanels/TopBar/topArrow_left.png';
					this.flag=false;
//					console.log("image changed IF");
				}
					catch(e)
				{
						console.log("changeImage"+e);
				}
					this.isAnimating=false;
			}
			else
			{
				this.destination = new Core.Vector(TFUtil.adjustHeightWithDevice(-40),TFUtil.adjustWidthWithDevice(0));
				this.moveBack = new Core.Vector(TFUtil.adjustHeightWithDevice(5),TFUtil.adjustWidthWithDevice(0));
				this.path='./Content/images/UIPanels/TopBar/topArrow_right.png';
				this.flag=true;
//				console.log("image changed ELSE");
				this.isAnimating=false;
			}
//			console.log("clicked in onClick()");
			this.button.setImage(this.path,[TFUtil.getAdjustedY(30),TFUtil.getAdjustedX(25)]);
			this.moveTo = new GAMoveTo(this._tfControlLayerAbove.getParentNode(),this.destination,200,true,this.callBack.bind(this));
			
		}
			
		
	},
	
	setImageForHomeButton : function(normalImage,selectedImage)
	{
		if(this._homeButtonImage != null)
		{
			this._homeButtonImage.destroy();
		}
		this._homeButtonImage = new GLButton(normalImage, selectedImage, TFUtil.adjustHeightWithDevice(25), TFUtil.adjustWidthWithDevice(25), this.onTouchHome.bind(this),this,100);
		this._homeButtonImage.setPosition(TFUtil.getAdjustedY(420),TFUtil.getAdjustedX(300));
	},

		
	setImageForStoreButton : function(normalImage,selectedImage)
	{
		if(this._storeButtonImage != null)
		{
			this._storeButtonImage.destroy();
		}
		this._storeButtonImage = new GLButton(normalImage, selectedImage, TFUtil.adjustHeightWithDevice(34), TFUtil.adjustWidthWithDevice(34), this.onTouchStore.bind(this),this,100);
		this._storeButtonImage.setPosition(TFUtil.getAdjustedY(455),TFUtil.getAdjustedX(300));
	},
										   
	setImageForMenuButton:function(imagePath)
	{
		this._storeButtonImage.getButton().setImage(imagePath,[TFUtil.getAdjustedY(50),TFUtil.getAdjustedX(50)]);
	},
		
	onTouchStore: function()
	{
		if(this.getControlLayerAbove()._isInfoButtonOpened)
		{
			this.getControlLayerAbove().closeLeftPanel();
		}									   
		if(this._areButtonsEnabled)
		{
			this.disableButtons();
		}
		else
		{
			return;
		}
		if(this._storeWindowLayer == null) {
			this._storeWindowLayer = new StoreWindow(this);  
			this._storeWindowLayer.createMenu();
		}
		this._storeWindowLayer.show();
	},
	
	/*onTouchDailySpin: function(){
		
		console.log("Ahsan :: onTouchDailySpin");
		
		if(this.getControlLayerAbove()._isInfoButtonOpened)
		{
			this.getControlLayerAbove().closeLeftPanel();
		}									   
		if(this._areButtonsEnabled)
		{
			this.disableButtons();
		}
		else
		{
			return;
		}
		if(this._dailySpinWindow == null) {
			this._dailySpinWindow = new DailySpinWindow(this);  
			this._dailySpinWindow.createMenu();
		}
		this._dailySpinWindow.show();
	},*/
	
	onTouchHome: function()
	{
		GameCentralHandler.startGameLoadingScreen();
		if(this.getControlLayerAbove()._isInfoButtonOpened)
		{
			this.getControlLayerAbove().closeLeftPanel();
		}									   
		TFGameState.atNeighbor = false;
		TFGameState.goingToHome = true;
		TFGameState.isFriend = false;
		DatabaseInterface.backToHome();
	},

	callBack:function()
	{
		if(!this.isAnimating)
		{
			console.log("clicked in callBack()");
			this.moveTo = new GAMoveTo(this._tfControlLayerAbove.getParentNode(),this.moveBack,300,true,this._callBack.bind(this));
		}
	},
										   
	_callBack:function()
	{
		this.isAnimating=true;
	},
										   
	disableButtons:function()
	{
		this._areButtonsEnabled = false;
		
	},

	setTopBar: function()
	{
		if(this.isAnimating)
		{
			this.isAnimating=false;
			this.button.setImage('./Content/images/UIPanels/TopBar/topArrow_right.png',[TFUtil.getAdjustedY(30),TFUtil.getAdjustedX(25)]);
			this.destination = new Core.Vector(TFUtil.adjustHeightWithDevice(-40),TFUtil.adjustHeightWithDevice(0));
			this.moveBack = new Core.Vector(TFUtil.adjustHeightWithDevice(5),TFUtil.adjustWidthWithDevice(0));
			this.moveTo = new GAMoveTo(this._tfControlLayerAbove.getParentNode(),this.destination,200,true,this.callBack.bind(this));
			console.log("clicked in setTopBar()");
		}

	},
		
	enableButtons:function()
	{
		this._areButtonsEnabled = true;
	},

	getAreButtonsEnabled: function()
	{
		return this._areButtonsEnabled;
	},

	setAreButtonsEnabled: function(value)
	{
		this._areButtonsEnabled = value;
	},
				
	getControlLayerAbove: function()
	{
		return this._tfControlLayerAbove;
	},
		
	onTouchMenu: function()
	{    
		if(!this.getAreButtonsEnabled())
		{
			return true;
		}
		
		var menu = new TZMenu();  
		GL2.Root.addChild(menu);

		return true;
	},

	decrementPanelCount: function()
	{
		this._panelCount++;
	},
		
	addPanelWindow:function(alertWindow)
	{
		this._panelCount++;
		this.addChild(alertWindow , this._panelCount);
	},
	
	addSuperUserButton:function()
	{
		this.SuperUsercirlceIcon = GLFactory.getSprite([TFUtil.getAdjustedY(60),TFUtil.getAdjustedX(55)], 2, './Content/images/UserModes/superuser.png' , this.iconSize, [0.5, 0.5]);
	  	this.addChild(this.SuperUsercirlceIcon);
	},
	
	removeSuperUserButton:function()
	{
		if(this.SuperUsercirlceIcon!=null)
		{
			this.removeChild(this.SuperUsercirlceIcon);
			this.SuperUsercirlceIcon.destroy();
		}
	},
	
	
	addQAUserButton:function()
	{
		this.QAUsercirlceIcon = GLFactory.getSprite([TFUtil.getAdjustedY(85),TFUtil.getAdjustedX(55)], 2, './Content/images/UserModes/qauser.png' , this.iconSize, [0.5, 0.5]);
	  	this.addChild(this.QAUsercirlceIcon);
	},
	
	removeQAUserButton:function()
	{
		if(this.QAUsercirlceIcon!=null)
		{
			this.removeChild(this.QAUsercirlceIcon);
			this.QAUsercirlceIcon.destroy();
		}
	},
	
	destroy: function($super)
	{
		TFUtil.destroyNodeChildren(this);
		if(this.destination)
		{
			delete this.destination;
			this.destination = null;
		}
		if(this.moveBack)
		{
			delete this.moveBack;
			this.moveBack = null;
		}
		if(this.moveTo)
		{
			this.moveTo.destroy();
			this.moveTo = null;
		}
		$super();
	},
		
		
});
























; return exports;};
$MODULE_FACTORY_REGISTRY['Code/GLLayer/PlantUI'] = function(){var exports = $MODULE_REGISTRY['Code/GLLayer/PlantUI'] || {}; $MODULE_REGISTRY['Code/GLLayer/PlantUI'] = exports; exports.PlantUI = GL2.Node.subclass({
    classname: 'PlantUI',
    
    initialize: function($super,plantModel,parentTank) 
    {
    	$super();
		this.SCREEN_HEIGHT = Core.Capabilities.getScreenWidth();
		this.SCREEN_WIDTH = Core.Capabilities.getScreenHeight();

		this.isFlipped = plantModel._plantObj.isFlipped;
		this.parentTank = parentTank;
		this.shouldMoveAround = false;
		this.touchesBegan = false;

		var storePlant = GAGameLoader.getStoreHandler().getStoreObjectForKey(plantModel._plantObj.storeId);

		this._width = storePlant.custom_attributes.size_width;
		this._heigth = storePlant.custom_attributes.size_height;
		 
		this.plantModelObject = plantModel;
		this._basePath = TFUtil.getBasePathForResourceType(plantModel._plantObj.storeId, GAResourceType.kDetail);
		 
		this.normalImage = this._basePath+'/2.png';
		this.selectedImage = null;							
										 
		this._gaSprite = new GASprite(this.normalImage, [this._width,this._heigth], [.5,.5]);
		this._onePlant = this._gaSprite.getNode();
										 
		if(plantModel.getPositionVector().getX() == 0 && plantModel.getPositionVector().getY() == 0)
		{
			this._onePlant.setPosition(this.SCREEN_WIDTH/2,this.SCREEN_HEIGHT/2);
			this.setScaleOfPlant();
		}

		else
		{
			this._onePlant.setPosition(plantModel.getPositionVector());
			this.setScaleOfPlant();
			if(this.isFlipped != 1)
			{
				this._onePlant.setPosition(plantModel.getPositionVector());
				this.setScaleOfPlant();
	
			}
			
		}

		this.addChild(this._onePlant);
		this.myMessageListener = new Core.MessageListener();
		this._target = new GL2.TouchTarget();
		this._target.setSize(this.SCREEN_WIDTH,this.SCREEN_HEIGHT);
		this._target.getTouchEmitter().addListener(this.myMessageListener, this.onTouch.bind(this));
		this._target.setDepth(1);
		this.addChild(this._target);
    },
       
    onTouch: function(touch)
		{
			if(touch.getAction() == touch.Action.Start)
			{
		
				if(this.ccTouchesBegan(touch))
				{
					return true;
				}
			}
			else if(touch.getAction() == touch.Action.Move)
			{					 
				this.ccTouchesMoved(touch);
			}
			else if(touch.getAction() == touch.Action.End)
			{
				this.ccTouchesEnded(touch);
			}
			return false;
		
		},
    
    
    ccTouchesBegan: function(touch)
    {
    	if(!TFUtil.getIsTouched())//IS_TOUCHED)
		{
    		var selectedTankAction = GameLayer.getSelectedTank().getTankAction();
			if(selectedTankAction == kTankActionType.kTankActionArrow && this._gaSprite.isTouched(touch.getPosition().clone()))
			{
				this.touchesBegan = true;
				var initialTouch = touch.getPosition().clone();
				var myPosition = this._onePlant.getPosition();
				this.deltaVector = new Core.Vector(myPosition.getX() - initialTouch.getX(),
													 myPosition.getY() - initialTouch.getY());
				TFUtil.setIsTouched(true);
				return true;
				
			}
		}
    },
    
    ccTouchesEnded: function(touch)
    {
    	if(TFGameState.atNeighbor)
			return;
			
			this._onePlant.setImage(this.normalImage, [this._width,this._heigth], [.5,.5]);						
			if(!this.touchesBegan)
			{
					return false;
			}  
		
			if(!this.shouldMoveAround)
			{
				this.selectedImage = this._basePath+'/selected.png';
				this._onePlant.setImage(this.selectedImage, [this._width,this._heigth], [.5,.5]);
				
				var controlLayer = GameLayer.getControlLayer();
				var attributeWindow = new AttributeWindow(attributeWindowType.plantsEnum,this); 
				controlLayer.addChild(attributeWindow);
				controlLayer.disableButtons();
				
			}
			TFUtil.setIsTouched(false);
			this.plantModelObject.setPosition(this._onePlant.getPosition(),this.parentTank.tankModel);
			this.touchesBegan = false;
			this.shouldMoveAround = false;
    },
        
    ccTouchesMoved: function(touch)
    { 
		if(this.shouldMoveAround && this.touchesBegan)
		{
			this.setScaleOfPlant();  
			var newVector = new Core.Vector(touch.getPosition().getX()+this.deltaVector.getX(),touch.getPosition().getY()+this.deltaVector.getY());
			var xVal = this._onePlant.getScale().getX();
			var yVal = this._onePlant.getScale().getY();	
			if(xVal<0)	
			{
				xVal = -1*xVal;
			}
			if (newVector.getX() > (this._width * xVal)/2 &&  newVector.getX() < this.SCREEN_WIDTH - (this._width * xVal)/2  
				&& newVector.getY() > (this._heigth * yVal)/2 && newVector.getY() < this.SCREEN_HEIGHT - (this._heigth * yVal)/2)
			{
				this._onePlant.setPosition(newVector);
			}

			else
			{
				//do nothing
			}
			TFUtil.setIsTouched(false);
			
		}
		return false;
    },
	
	setScaleOfPlant: function()
	{
		var x = this._onePlant.getPosition().getY();
		var x1 = 0;
		var x2 = this.SCREEN_HEIGHT;
		var y1 = 0.8;
		var y2 = 2.2;

		var y = (1+(.4/this.SCREEN_HEIGHT)*(x-this._heigth/2));
		this._onePlant.setScale(this.isFlipped*y ,y); 

	},
   
	setPosition: function(x, y)
	{
		this._onePlant.setPosition(TFUtil.getAdjustedY(x), TFUtil.getAdjustedX(y));
	},
	
	flipPlantSet:function()
	{
		this._onePlant.setScale(-1*this._onePlant.getScale().getX(),this._onePlant.getScale().getY());
		this.plantModelObject.setPlantFlip(this.isFlipped,this.parentTank.tankModel);
	},
    
	flipPlant:function()
	{
	
		if(this.isFlipped == -1)
		{
			this.isFlipped = 1;
		}
		else
		{
			this.isFlipped = -1;
		}
	this.flipPlantSet();
	},

	selectedPlant:function()
	{
		this.selectedImage = this._basePath+'/selected.png';
		this._onePlant.setImage(this.selectedImage, [this._width,this._heigth], [.5,.5]);

		this.shouldMoveAround = true;

	},
	destroy: function($super)
	{
		if(this.myMessageListener) {
			this.myMessageListener.destroy();
			this.myMessageListener = null;
		}

		if(this.plantModelObject)
		{
			this.plantModelObject.destroy();
			this.plantModelObject = null;
		}
		TFUtil.destroyNodeChildren(this);
			
		$super();
	},
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/GLLayer/FoodBrickUI'] = function(){var exports = $MODULE_REGISTRY['Code/GLLayer/FoodBrickUI'] || {}; $MODULE_REGISTRY['Code/GLLayer/FoodBrickUI'] = exports; 
 exports.FoodBrickUI = GL2.Node.subclass({
    classname: 'FoodBrickUI',
    initialize: function($super,foodBrickModel,parentTank) 
    {
    	$super();
		SCREEN_HEIGHT = TFUtil.getAdjustedX(Core.Capabilities.getScreenWidth());
		SCREEN_WIDTH = TFUtil.getAdjustedY(Core.Capabilities.getScreenHeight());

		this.parentTank = parentTank;
		this.shouldMoveAround = false;
		this.touchesBegan = true;
		//creating sprite

		var storeFoodBrick = GAGameLoader.getStoreHandler().getStoreObjectForKey(foodBrickModel._foodBrickObj.storeId);

		this._width = storeFoodBrick.custom_attributes.size_width;
		this._heigth = storeFoodBrick.custom_attributes.size_height;
		 
		this.foodBrickModelObject = foodBrickModel;
		this._basePath = TFUtil.getBasePathForResourceType(foodBrickModel._foodBrickObj.storeId, GAResourceType.kDetail);
		 
		this.normalImage = this._basePath+'2.png';
		this.selectedImage = null;								 
		this._gaSprite = new GASprite(this.normalImage, [this._width,this._heigth], [.5,.5]);

		this._oneFoodBrick = this._gaSprite.getNode();	
									 
		if(foodBrickModel.getPositionVector().getX() == 0 && foodBrickModel.getPositionVector().getY() == 0)
		{
			this._oneFoodBrick.setPosition(SCREEN_WIDTH/4,SCREEN_HEIGHT/2);
			this.setScaleOfFoodBrick();
			
		}
		else
		{
			this._oneFoodBrick.setPosition(foodBrickModel.getPositionVector());
			this.setScaleOfFoodBrick();
			
		}


		this.addChild(this._oneFoodBrick);

		//creating tounchTarget for sprite
		this.myMessageListener = new Core.MessageListener();
		this._target = new GL2.TouchTarget();
		this._target.setSize(SCREEN_WIDTH,SCREEN_HEIGHT);
		this._target.getTouchEmitter().addListener(this.myMessageListener, this.onTouch.bind(this));
		this._target.setDepth(1);
		this.addChild(this._target);
    },
       
    onTouch: function(touch)
	{
        if(touch.getAction() == touch.Action.Start)
		{
			if(this.ccTouchesBegan(touch))
				return true;
		}
        else if(touch.getAction() == touch.Action.Move)
        {			 
            this.ccTouchesMoved(touch);
        }
		else if(touch.getAction() == touch.Action.End)
		{
			this.ccTouchesEnded(touch);
		}
		return false;
		
    },
    
    ccTouchesBegan: function(touch)
    {
    	if(!TFUtil.getIsTouched())//IS_TOUCHED)
		{
			var selectedTankAction = GameLayer.getSelectedTank().getTankAction();
			if(selectedTankAction == kTankActionType.kTankActionArrow && this._gaSprite.isTouched(touch.getPosition().clone()))
			{
				this.touchesBegan = true;
				var initialTouch = touch.getPosition().clone();
				var myPosition = this._oneFoodBrick.getPosition();
				this.deltaVector = new Core.Vector(myPosition.getX() - initialTouch.getX(),myPosition.getY() - initialTouch.getY());
				TFUtil.setIsTouched(true);
				return true;
				
			}
		}
    },
    
    ccTouchesEnded: function(touch)
    {
    	
    	if(TFGameState.atNeighbor)
			return;
		
		this._oneFoodBrick.setImage(this.normalImage, [this._width,this._heigth], [.5,.5]);
		if(!this.touchesBegan)
		{
				return false;
		}  

		if(!this.shouldMoveAround)
		{	
			this.selectedImage = this._basePath+'/selected.png';
			this._oneFoodBrick.setImage(this.selectedImage, [this._width,this._heigth], [.5,.5]);
			
			var controlLayer = GameLayer.getControlLayer();
			var attributeWindow = new AttributeWindow(attributeWindowType.foodBrickEnum,this); 
			controlLayer.addChild(attributeWindow);
			controlLayer.disableButtons();
			
		}
		TFUtil.setIsTouched(false);
		this.foodBrickModelObject.setPosition(this._oneFoodBrick.getPosition(),this.parentTank.tankModel);
		this.touchesBegan = false;
		this.shouldMoveAround = false;
    },
        
    ccTouchesMoved: function(touch)
    { 
		//setting scaling factor
		if(this.shouldMoveAround && this.touchesBegan)
		{
			this.setScaleOfFoodBrick();  
			var newVector = new Core.Vector(touch.getPosition().getX()+this.deltaVector.getX(),touch.getPosition().getY()+this.deltaVector.getY());
			//checking boundry conditions
			if (newVector.getX() > (this._width * this._oneFoodBrick.getScale().getX())/2 &&  newVector.getX() < SCREEN_WIDTH - (this._width * this._oneFoodBrick.getScale().getX())/2  
				&& newVector.getY() > (this._heigth * this._oneFoodBrick.getScale().getY())/2 && newVector.getY() < SCREEN_HEIGHT - (this._heigth * this._oneFoodBrick.getScale().getY())/2)
			{
				this._oneFoodBrick.setPosition(newVector);
			}

			else
			{
				//do nothing
			}
			delete newVector;
			TFUtil.setIsTouched(false);
							
		}
		return false;
    },
	
	setScaleOfFoodBrick: function()
	{
		var x = this._oneFoodBrick.getPosition().getY();
		var x1 = 0;
		var x2 = SCREEN_HEIGHT;
		var y1 = 0.8;
		var y2 = 2.2;

		var y = (1+(.4/SCREEN_HEIGHT)*(x-this._heigth/2));
		this._oneFoodBrick.setScale(y,y); 

	},
   
	setPosition: function(x, y)
	{
		this._oneFoodBrick.setPosition(TFUtil.getAdjustedY(x), TFUtil.getAdjustedX(y));
	},

	selectedFoodBrick:function()
	{
		this.selectedImage = this._basePath+'/selected.png';
		this._oneFoodBrick.setImage(this.selectedImage, [this._width,this._heigth], [.5,.5]);
		this.shouldMoveAround = true;

	},
    
	getBrickPosition: function(index)
	{
		return this._oneFoodBrick.getPosition();							
	},
										
	destroy: function($super)
	{
		if(this.foodBrickModelObject)
		{
			this.foodBrickModelObject.destroy();
			this.foodBrickModelObject = null;
		}
		if(this.myMessageListener)
		{
			this.myMessageListener.destroy();
			this.myMessageListener = null;
		}
		
		TFUtil.destroyNodeChildren(this);
		$super();
	},
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/GLLayer/InfoView/InfoView'] = function(){var exports = $MODULE_REGISTRY['Code/GLLayer/InfoView/InfoView'] || {}; $MODULE_REGISTRY['Code/GLLayer/InfoView/InfoView'] = exports; /**
 * Filename: InfoView.js
 * Author: Shoaib Ahmed
 * Date Created: --
 * Date Updated: --
 */

exports.InfoView = GL2.Node.subclass({
	
	classname: 'InfoView',
	
	initialize: function($super)
    {
		$super();
		this.destination = null;
		this.moveBack = null;
		this.moveTo = null;							 
		this.isAnimating=true;
									 
		var SCREEN_HEIGHT = Core.Capabilities.getScreenWidth();
		var SCREEN_WIDTH = Core.Capabilities.getScreenHeight();
		var myMessageListener = new Core.MessageListener();
		this.touchTarget = new GL2.TouchTarget();
		
		this.touchTarget.setPosition(TFUtil.getAdjustedX(45),TFUtil.getAdjustedY(185));
		this.touchTarget.setSize(TFUtil.getAdjustedX(120),TFUtil.getAdjustedY(270));
		this.touchTarget.setAnchor(.5,.5);
		this.touchTarget.getTouchEmitter().addListener(myMessageListener, this.swallowTouches.bind(this));
		this.touchTarget.setDepth(10);
		this.addChild(this.touchTarget);					 
		
		this._sidePanel = new GLFactory.getSprite([TFUtil.getAdjustedY(-90),TFUtil.getAdjustedX(185)],100,'./Content/images/UIPanels/SidePanel/sidepanel.png',[TFUtil.adjustHeightWithDevice(120),TFUtil.adjustWidthWithDevice(270)],[0.5,0.5]);
        this.addChild(this._sidePanel);
       if(!TFGameState.atNeighbor){
        var tanksButton = new GLButton('./Content/images/UIPanels/SidePanel/InventoryOverNew.png','./Content/images/UIPanels/SidePanel/inventory1.png',TFUtil.getAdjustedY(30),TFUtil.getAdjustedX(80),this.tanksBttnFunc.bind(this),this._sidePanel,100,GALocalizationHandler.getLocalizedString('TF_INFOAPPVIEW_TANKS_BUTTON'),new Core.Color(0,0,0),new Core.Color(1,1,1),null,TFUtil.getAdjustedFontSize(80));
        tanksButton.setPosition(TFUtil.getAdjustedY(65),TFUtil.getAdjustedX(-65));
        tanksButton.buttonText.setRotation(-90);
		this.button1 = tanksButton.getButton();
		this.button1.setImage('./Content/images/UIPanels/SidePanel/InventoryOverNew.png',[TFUtil.getAdjustedY(30),TFUtil.getAdjustedX(80)]);
		tanksButton.setTextFont(TFUtil.getFont(),TFUtil.getFontLocation());
        tanksButton.buttonText.setSize(TFUtil.getAdjustedY(75),TFUtil.getAdjustedX(75));
        tanksButton.buttonText.setPosition(TFUtil.getAdjustedY(0),TFUtil.getAdjustedX(0));
        
        
         var inventoryButton = null;
       // if(!TFGameState.atNeighbor){
        inventoryButton = new GLButton('./Content/images/UIPanels/SidePanel/InventoryOverNew.png','./Content/images/UIPanels/SidePanel/inventory1.png',TFUtil.getAdjustedY(30),TFUtil.getAdjustedX(80),this.inventoryBttnFunc.bind(this),this._sidePanel,100,GALocalizationHandler.getLocalizedString('TF_INFOAPPVIEW_INVENTORY_BUTTON'),new Core.Color(0,0,0),new Core.Color(1,1,1),null,TFUtil.getAdjustedFontSize(80));
        //} else {
        //	inventoryButton = new GLButton('./Content/images/UIPanels/SidePanel/inventory1.png','./Content/images/UIPanels/SidePanel/inventory1.png',TFUtil.getAdjustedY(30),TFUtil.getAdjustedX(80),this.inventoryBttnFunc.bind(this),this._sidePanel,100,GALocalizationHandler.getLocalizedString('TF_INFOAPPVIEW_INVENTORY_BUTTON'),new Core.Color(0,0,0),new Core.Color(1,1,1),null,TFUtil.getAdjustedFontSize(80));
        //}
        inventoryButton.setPosition(TFUtil.getAdjustedY(65),TFUtil.getAdjustedX(35));

		this.button2 = inventoryButton.getButton();
		this.button2.setImage('./Content/images/UIPanels/SidePanel/inventory1.png',[TFUtil.getAdjustedY(30),TFUtil.getAdjustedX(80)]);
		inventoryButton.setTextFont(TFUtil.getFont(),TFUtil.getFontLocation());
		inventoryButton.buttonText.setRotation(-90);
        inventoryButton.buttonText.setSize(TFUtil.getAdjustedY(75),TFUtil.getAdjustedX(75));
        inventoryButton.buttonText.setPosition(TFUtil.getAdjustedY(0),TFUtil.getAdjustedX(0));
       }
       
									 
		if(this.isAnimating)
		{
			this.destination = new Core.Vector(TFUtil.adjustHeightWithDevice(-90),TFUtil.adjustWidthWithDevice(185));
			this.moveBack = new Core.Vector(TFUtil.adjustHeightWithDevice(45),TFUtil.adjustWidthWithDevice(185));
		    this.isAnimating=false;
		    this.moveTo = new GAMoveTo(this._sidePanel,this.destination,200,true,this.callBackOnStart.bind(this));
		}							 
									 
		this.tanksBttnFunc();
	},
    
	swallowTouches: function(touch)
	{							 
		return true;
									 
	}, 
	
	callBack:function()
	{
		if(this.destination) {
			delete this.destination;
			this.destination = null;
		}
		
		if(this.moveBack) {
			delete this.destination;
			this.destination = null;
		}
		if(this.moveTo) {
			this.moveTo.destroy();
			this.moveTo = null;
		}
		
		this.destination = new Core.Vector(TFUtil.adjustHeightWithDevice(45),TFUtil.adjustWidthWithDevice(185));
		this.moveBack = new Core.Vector(TFUtil.adjustHeightWithDevice(-90),TFUtil.adjustWidthWithDevice(185));							 
		this.moveTo = new GAMoveTo(this._sidePanel,this.destination,200,true,this.callBackOnClose.bind(this));
	},
	
	callBackOnStart:function()
	{
		if(this.moveTo) {
			this.moveTo.destroy();
			this.moveTo = null;
		}
		this.moveTo = new GAMoveTo(this._sidePanel,this.moveBack,200,true,this.stop.bind(this));						 
	},
	
    stop:function()
	{
	  this.isAnimating=true;
	},

    callBackOnClose:function()
	{
    	if(this.moveTo) {
			this.moveTo.destroy();
			this.moveTo = null;
		}
    	this.moveTo = new GAMoveTo(this._sidePanel,this.moveBack,200,true,this.destroy.bind(this));
	},
								 
    tanksBttnFunc: function()
    {	
		if(this.tankPanelOpened)
		{
			return;
		}
					
		this.tankPanelOpened = true;
		this.inventoryPanelOpened = false;
		
		 if(!TFGameState.atNeighbor){
			this.button1.setImage('./Content/images/UIPanels/SidePanel/InventoryOverNew.png',[TFUtil.getAdjustedY(30),TFUtil.getAdjustedX(80)]);
			this.button2.setImage('./Content/images/UIPanels/SidePanel/inventory1.png',[TFUtil.getAdjustedY(30),TFUtil.getAdjustedX(80)]);
		}
		
		
		if(this._inventoryLayer != null)
		{
			this._sidePanel.removeChild(this._inventoryLayer);
            this._inventoryLayer.destroy();
			this._inventoryLayer = null;
		}	
									 
		this._tankLayer = new TankLayer();
        this._sidePanel.addChild(this._tankLayer);
    },
    
    inventoryBttnFunc: function()
    {  
    	console.log("inventory button pressed1");
		if(this.inventoryPanelOpened)
		{
			return;
		}
		
		if(TFGameState.atNeighbor){
			return;
		}
//		console.log("inventory button pressed2");
		
		this.tankPanelOpened = false;
		this.inventoryPanelOpened = true;
		
		if(!TFGameState.atNeighbor){
			this.button1.setImage('./Content/images/UIPanels/SidePanel/inventory1.png',[TFUtil.getAdjustedY(30),TFUtil.getAdjustedX(80)]);
			this.button2.setImage('./Content/images/UIPanels/SidePanel/InventoryOverNew.png',[TFUtil.getAdjustedY(30),TFUtil.getAdjustedX(80)]);
		}
		
		
		if(this._tankLayer != null)
		{
			this._sidePanel.removeChild(this._tankLayer);
            this._tankLayer.destroy();
			this._tankLayer = null;
		}
		
		this._inventoryLayer = new InventoryLayer();
		this._sidePanel.addChild(this._inventoryLayer);									 
    },
    
    destroy: function($super)
	{
    	if(this.destination) {
			delete this.destination;
			this.destination = null;
		}
		
		if(this.moveBack) {
			delete this.destination;
			this.destination = null;
		}
		if(this.moveTo) {
			this.moveTo.destroy();
			this.moveTo = null;
		}
		if(this.touchTarget){
			this.removeChild(this.touchTarget);
			this.touchTarget.destroy();
			this.touchTarget = null
		}
		TFUtil.destroyNodeChildren(this._sidePanel);
		TFUtil.destroyNodeChildren(this);
		$super();
	},
    
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/GLLayer/AlgaeLayer'] = function(){var exports = $MODULE_REGISTRY['Code/GLLayer/AlgaeLayer'] || {}; $MODULE_REGISTRY['Code/GLLayer/AlgaeLayer'] = exports; 
var AlgaeParticle = require('Code/GLLayer/AlgaeParticle').AlgaeParticle;

exports.AlgaeLayer = GL2.Node.subclass({
    classname: 'AlgaeLayer',
    
    initialize: function($super)
    {   
    	$super();
		this.SCREEN_WIDTH = GACommonUtils.getScreenWidth();
		this.SCREEN_HEIGHT = GACommonUtils.getScreenHeight();		
		
		this.algaePercentage = 0;
		this.pixels = null;
		
		//creating tounchTarget for algae
		this.myMessageListener = new Core.MessageListener();
		this._target = new GL2.TouchTarget();
		this._target.setSize(this.SCREEN_WIDTH,this.SCREEN_HEIGHT);
		this._target.getTouchEmitter().addListener(this.myMessageListener, this.onTouch.bind(this));
		this._target.setDepth(1);
		this.addChild(this._target);
	
    },

    playCleanSound: function () {
    	if(GAAudioManager._music)
		{
    		GAAudioManager.playCleanSound();
			this.timerSound = setTimeout(this.playCleanSound.bind(this),800);
		}
    },
    
	onTouch:function(touch)
	{	
		if(touch.getAction() == touch.Action.Start)
		{
			if(this.ccTouchesBegan(touch))
			{
				return true;
			}
		}
        else if(touch.getAction() == touch.Action.Move)
        {
            this.ccTouchesMoved(touch);
        }
		else if(touch.getAction() == touch.Action.End)
		{
			this.ccTouchesEnded(touch);
		}
		return false;
	},
	
	ccTouchesBegan: function(touch)
	{	
		
		if(this.algaePercentage <= 0 || GameLayer.getSelectedTank().currentTankAction != kTankActionType.kTankActionSponge)
		{
			if(this.timerSound) {
				clearTimeout(this.timerSound);
				this.timerSound = null;
			}
			if(GAAudioManager._music)
			{
				GAAudioManager.playCleanSound();
			}
			return false;
		}
		else
		{	
			if(this.timerSound) {
				clearTimeout(this.timerSound);
				this.timerSound = null;
			}
			this.timerSound = setTimeout(this.playCleanSound.bind(this),0);
			
			for(var i = 0; i <  this.pixels.length; i++)
			{	
				var algae = this.pixels[i];
				if(algae.isPointContains(touch)){
					algae.destroy();
					algae = null;
					this.pixels.splice(i,1);
					--i;
				}
			}
			return true;
		}
	},

	ccTouchesEnded: function(touch)
	{
		if(this.timerSound) {
			clearTimeout(this.timerSound);
			this.timerSound = null;
		}
		
		if(this.algaeTouchEndCheck==0 || GameLayer.getSelectedTank().currentTankAction != kTankActionType.kTankActionSponge )
		{
			return false;
		}
		
		this.algaePercentage = (this.pixels.length*100)/this.iterations;
		
		if(this.algaePercentage<0)
		{
			this.algaePercentage=0;
		}
		if(this.algaePercentage>100)
		{
			this.algaePercentage=100;
		}
		if(this.algaePercentage==0)
		{
			this.algaeTouchEndCheck=0;
		}
		
		GameLayer.getSelectedTank().intermediateAlgaeCalculation(this.algaePercentage);
		GameLayer.getSelectedTank().algaeRemainingCallback(this.algaePercentage);
	},

	ccTouchesMoved: function(touch)
	{	
		if(this.algaePercentage <= 0 || GameLayer.getSelectedTank().currentTankAction != kTankActionType.kTankActionSponge)
		{	
			return false;
		}
		
		for(var i = 0; i <  this.pixels.length; i++)
		{	
			var algae = this.pixels[i];
			if(algae.isPointContains(touch)){	
				algae.destroy();
				algae = null;
				this.pixels.splice(i,1);
				this.algaePercentage = (this.pixels.length*100)/this.iterations;
				GameLayer.getSelectedTank().intermediateAlgaeCalculation(this.algaePercentage);
				--i;
			}
			
		}
		return true;

	},
	
    validRandom: function(newPoint,index)
    {
        var particleSize =  ((ALGAE_PARTICLE_SIZE-ALGAE_PARTICLE_SIZE_DIFF)/2);
       
        if (this.tempPoint.getX() < TFUtil.adjustHeightWithDevice(10) -particleSize)
        {
			this.tempPoint.setX(TFUtil.adjustHeightWithDevice(10)-particleSize);
        }
        if (this.tempPoint.getY() < TFUtil.adjustWidthWithDevice(10)-particleSize)
        {
           this.tempPoint.setY(TFUtil.adjustWidthWithDevice(10)-particleSize);
        }
        if (this.tempPoint.getX() > this.SCREEN_WIDTH-particleSize-TFUtil.adjustHeightWithDevice(10))
        {
           this.tempPoint.setX(this.SCREEN_WIDTH-particleSize-TFUtil.adjustHeightWithDevice(10));
        }
        if (this.tempPoint.getY() > this.SCREEN_HEIGHT-particleSize-TFUtil.adjustWidthWithDevice(10))
        {
           this.tempPoint.setY(this.SCREEN_HEIGHT-particleSize-TFUtil.adjustWidthWithDevice(10));
        }
                
        var minPointIndex = -1;
        var minDist = 1000;
        var p = new Core.Point(this.tempPoint.getX(),this.tempPoint.getY());
       
		while(index>=0)
        {
		  	var p1 = this.pixels[index].getPosition();
			
			var dist = Math2.ccpDistance(p,p1);
			if(dist < TFUtil.adjustHeightWithDevice(   (ALGAE_PARTICLE_SIZE-ALGAE_PARTICLE_SIZE_DIFF)/2-TFUtil.adjustHeightWithDevice(10)  )) 
			{
				return false;
			}
		  
			if(dist < minDist)
			{
				minDist = dist;
				minPointIndex = index;
			}
		
			index--;
          
		}
        
        if(minPointIndex != -1)
		{
			p1 = this.pixels[minPointIndex].getPosition();
			var height = (ALGAE_PARTICLE_SIZE-ALGAE_PARTICLE_SIZE_DIFF)/2;
			if(p1.getX() < p.getX())
			{
				p.setX(p1.getX() +  TFUtil.adjustHeightWithDevice( (height - 15 - Math.random()*5) ) );
			}
			else if(p1.getX() > p.getX())
			{
				p.setX(p1.getX() - TFUtil.adjustHeightWithDevice( (height - 15 - Math.random()*5)) );
			}
			
			if(p1.getY() < p.getY())
			{
				p.setY(p1.getY() + TFUtil.adjustWidthWithDevice(  (height -TFUtil.adjustWidthWithDevice(15) - Math.random()*5)) );
			}
			else if(p1.getY() > p.getY())
			{
				p.setY(p1.getY() -TFUtil.adjustWidthWithDevice(  (height - TFUtil.adjustWidthWithDevice(15) - Math.random()*5)) );
			}
			
			this.tempPoint.setX(p.getX());
			this.tempPoint.setY(p.getY());
		
			if (this.tempPoint.getX() < TFUtil.adjustHeightWithDevice(10)-particleSize)
			{
				this.tempPoint.setX(TFUtil.adjustHeightWithDevice(10)-particleSize);
			}
			if (this.tempPoint.getY() < TFUtil.adjustWidthWithDevice(10)-particleSize)
			{
				this.tempPoint.setY(TFUtil.adjustWidthWithDevice(10)-particleSize);
			}
			if (this.tempPoint.getX() > this.SCREEN_WIDTH-particleSize-TFUtil.adjustHeightWithDevice(10))
			{
				this.tempPoint.setX(this.SCREEN_WIDTH-particleSize-TFUtil.adjustHeightWithDevice(10));
			}
			if (this.tempPoint.getY() > this.SCREEN_HEIGHT-particleSize-TFUtil.adjustWidthWithDevice(10))
			{
				this.tempPoint.setY(this.SCREEN_HEIGHT-particleSize-TFUtil.adjustWidthWithDevice(10));
			}
           
		}
        delete p;
	return true;
        
    },
    
	setAlgaePercentage:function(newPercentage)	
	{	
		this.algaePercentage = Math.floor(newPercentage/10);
		this.algaePercentage *= 10;
		
		if(this.algaePercentage<0)
		{
			this.algaePercentage=0;
		}
		
		if(this.algaePercentage>100)
		{
			this.algaePercentage=100;
		}
		
		if(this.algaePercentage!=0)
		{
			this.algaeTouchEndCheck=1;
		}
		else
		{
			this.algaeTouchEndCheck=0;
		}
		
		this.generateAlgae();
	},
	
	getAlgaePercentage : function()
	{
		return this.algaePercentage;
	},
	
	generateAlgae : function()
	{	
		if(this.pixels) {
			for(var i = 0; i <  this.pixels.length; i++)
			{	
				var algae = this.pixels[i];
				algae.destroy();
				algae = null;
				this.pixels.splice(i,1);
				--i;
			}
			delete this.pixels;
		}
	
		var particleSize = ALGAE_PARTICLE_SIZE/2;
		
		this.iterations =  Math.floor((ALGAE_PARTICLE_SIZE * this.algaePercentage )/100.0);

		if(this.iterations <= 0)
		{
			return;
		}
		
		var p1 = new Core.Point((this.SCREEN_WIDTH/2)-particleSize,(this.SCREEN_HEIGHT/2)-particleSize);
		var val = 0.2 + (Math.random()*35)/100.0;
		this.pixels = new Array(this.iterations);
		
		for(var i=0; i< this.iterations; i++)
		{
			var particle = new AlgaeParticle(this);
			this.pixels[i] = particle;
			this.pixels[i].showAlgae();
			do
			{
				var r1 = 1 + Math.random() * (this.SCREEN_WIDTH/2);
				var r2 = 1 + Math.random() * (this.SCREEN_HEIGHT/2);
				if(Math.random() < 0.5)
					r1 *= -1;
				if(Math.random() < 0.5)
					r2 *= -1;
									   
				var p3 = new Core.Point(r1,r2);
				this.tempPoint = Math2.ccpAdd(p1,p3);
				delete p3;
			}
			while(!this.validRandom(this.tempPoint,i-1));
			
			var interval = 0;
			var x = this.tempPoint.getX()+interval%(this.SCREEN_WIDTH-20);			
			var y = this.tempPoint.getY()%(this.SCREEN_HEIGHT);
			this.pixels[i].setPosition(new Core.Point(x,y));
			this.pixels[i].moveParticle();
			
		}
	},
	
    destroy: function($super)
    {
    	if(this.pixels) {
			for(var i = 0; i <  this.pixels.length; i++)
			{	
				var algae = this.pixels[i];
				algae.destroy();
				algae = null;
				this.pixels.splice(i,1);
				--i;
			}
			delete this.pixels;
		}
    	
		if(this.myMessageListener)
		{
			this.myMessageListener.destroy();
			this.myMessageListener = null;
		}

		if(this._target)
		{
			this.removeChild(this._target);
			this._target.destroy();
		}
	
		if(this.timerSound) {
			clearTimeout(this.timerSound);
			this.timerSound = null;
		}
		$super();
	},
    
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/GLLayer/TFSettingsUI'] = function(){var exports = $MODULE_REGISTRY['Code/GLLayer/TFSettingsUI'] || {}; $MODULE_REGISTRY['Code/GLLayer/TFSettingsUI'] = exports; 

exports.TFSettingsUI = GL2.Node.subclass(
{
    classname: 'TFSettingsUI',
    initialize: function($super) 
    {
    	
    	$super();
	  
		var SCREEN_HEIGHT = Core.Capabilities.getScreenWidth();
		var SCREEN_WIDTH = Core.Capabilities.getScreenHeight();
		var myMessageListener = new Core.MessageListener();
		var touchTarget = new GL2.TouchTarget();
		touchTarget.setSize(SCREEN_WIDTH,SCREEN_HEIGHT);
		touchTarget.setAnchor(0,0);
		touchTarget.getTouchEmitter().addListener(myMessageListener, this.swallowTouches.bind(this));
		touchTarget.setDepth(1);
		this.addChild(touchTarget);	
		this._isShowerPresent=GameLayer.getSelectedTank().tankModel._tankObj.showerId;
	
		this.destination = null;
		this.moveBack = null;
		this.scaleTo = null;							 
		this.isAnimating=true;
		
		var width=400;
		var positionX=240;
		if(!this._isShowerPresent){
			width=240;
			positionX=120;
		}
		
		this._backgroundAlertWindow = new GLFactory.getSprite([TFUtil.getAdjustedY(240),TFUtil.getAdjustedX(160)],110,'./Content/images/UIPanels/AlertWindow/alert-background.png',[TFUtil.adjustHeightWithDevice(width),TFUtil.adjustWidthWithDevice(130)],[0.5,0.5]);
		this.addChild(this._backgroundAlertWindow);
    
		this._crossButton = new GLButton('./Content/images/Store/cross_normal.png','./Content/images/Store/cross_selected.png',TFUtil.adjustHeightWithDevice(34), TFUtil.adjustWidthWithDevice(34),this.crossBttnClicked.bind(this),this._backgroundAlertWindow,100);
		this._crossButton.setPosition(TFUtil.getAdjustedY(positionX),TFUtil.getAdjustedX(-55));
 
//		this._cameraButton = new GLButton('./Content/images/SettingsUI/camera0.png','./Content/images/SettingsUI/camera1.png',TFUtil.adjustHeightWithDevice(50), TFUtil.adjustWidthWithDevice(50),this.cameraBttnClicked.bind(this),this._backgroundAlertWindow,100);
//		this._cameraButton.setPosition(TFUtil.getAdjustedY(40),TFUtil.getAdjustedX(0));
	
		this._soundButton = new GLButton('./Content/images/SettingsUI/sound0.png','./Content/images/SettingsUI/sound0.png',TFUtil.adjustHeightWithDevice(50), TFUtil.adjustWidthWithDevice(50),this.soundBttnClicked.bind(this),this._backgroundAlertWindow,100);
		this._soundButton.setPosition(TFUtil.getAdjustedY(0),TFUtil.getAdjustedX(0));
		
		if(this._isShowerPresent)
		{
			this._showerOne = new GLButton('./Content/images/SettingsUI/shower0.png','./Content/images/SettingsUI/shower1.png',TFUtil.adjustHeightWithDevice(50), TFUtil.adjustWidthWithDevice(50),this.showerOne.bind(this),this._backgroundAlertWindow,100);
			this._showerOne.setPosition(TFUtil.getAdjustedY(235),TFUtil.getAdjustedX(65));
			
			this._showerAll = new GLButton('./Content/images/SettingsUI/showerAll0.png','./Content/images/SettingsUI/showerAll1.png',TFUtil.adjustHeightWithDevice(50), TFUtil.adjustWidthWithDevice(50),this.showerAll.bind(this),this._backgroundAlertWindow,100);
			this._showerAll.setPosition(TFUtil.getAdjustedY(305),TFUtil.getAdjustedX(65));
			
			this.OffShowerButton = this._showerOne.getButton();
			this.OffShowerButtonAll = this._showerAll.getButton();
			this.showerOneOn = GameLayer.getSelectedTank().tankModel.getShowerEnabled();
			this.showerAllOn =TFGameState.getCurrentUser()._userObj.isMasterShowerEnabled;
			
			
			if(this.showerOneOn == false)
			{
				this.OffShowerButton.setImage('./Content/images/SettingsUI/shower1.png',[TFUtil.getAdjustedY(50),TFUtil.getAdjustedX(50)]);
			}
			else
			{
				this.OffShowerButton.setImage('./Content/images/SettingsUI/shower0.png',[TFUtil.getAdjustedY(50),TFUtil.getAdjustedX(50)]);
			}
			
			
			if(this.showerAllOn == false)
			{
				this.OffShowerButton.setImage('./Content/images/SettingsUI/shower1.png',[TFUtil.getAdjustedY(50),TFUtil.getAdjustedX(50)]);
				this.OffShowerButtonAll.setImage('./Content/images/SettingsUI/showerAll1.png',[TFUtil.getAdjustedY(50),TFUtil.getAdjustedX(50)]);
			}
			else
			{
				//this.OffShowerButton.setImage('./Content/images/SettingsUI/shower0.png',[TFUtil.getAdjustedY(50),TFUtil.getAdjustedX(50)]);
				this.OffShowerButtonAll.setImage('./Content/images/SettingsUI/showerAll0.png',[TFUtil.getAdjustedY(50),TFUtil.getAdjustedX(50)]);
				
			}
			
		}

		if(GAAudioManager.isBackgroundSoundPlaying())
		{
			this._buttonSetSound=this._soundButton.getButton();
			this._buttonSetSound.setImage('./Content/images/SettingsUI/sound0.png',[TFUtil.getAdjustedY(50),TFUtil.getAdjustedX(50)]);
		}
		
	   else
	   { 
		   this._buttonSetSound=this._soundButton.getButton();
		   this._buttonSetSound.setImage('./Content/images/SettingsUI/sound1.png',[TFUtil.getAdjustedY(50),TFUtil.getAdjustedX(50)]);
		}
		
    },
    
    show : function() {
    	if(this.isAnimating)
		{
			this.callAnimation();
		}
    	GameLayer.getControlLayer().addChild(this); 
    },
	
    
    hide: function () {

    	GameLayer.getControlLayer().removeChild(this);
    },
	
	callAnimation: function()
	{
		this.moveBack = new Core.Vector(0.95,0.95);
		this.destination = new Core.Vector(0,0);
		this.isAnimating=false;
		this.scaleTo = new GAScaleTo(this._backgroundAlertWindow,this.destination,20,true,this.callBackOnStart.bind(this));
	},

	callBackOnStart:function()
	{
		this.scaleTo = new GAScaleTo(this._backgroundAlertWindow,this.moveBack,300,true,this.stop.bind(this));
	},

	stop:function()
	{
		this.isAnimating=true;
	},

	callBack:function()
	{
		
		this.scaleTo = new GAScaleTo(this._backgroundAlertWindow,this.moveBack,200,true,this.callBackOnClose.bind(this));
	},

	callBackOnClose:function()
	{
		GAAudioManager.storageFunc();
		this.moveTo = new GAScaleTo(this._backgroundAlertWindow,this.destination,200,true,this.hide.bind(this));
	},

    
	swallowTouches: function(touch)
    {
		
		return true;
    },
										 
	showerOne: function()
	{
		
		
		if(this.showerOneOn == false)
		{
		
			GameLayer.getSelectedTank().showerOneon();
			this.OffShowerButton.setImage('./Content/images/SettingsUI/shower0.png',[TFUtil.getAdjustedY(50),TFUtil.getAdjustedX(50)]);
			this.showerOneOn = true;
			
		}
		else
		{

			GameLayer.getSelectedTank().showerOneOff();
			this.OffShowerButton.setImage('./Content/images/SettingsUI/shower1.png',[TFUtil.getAdjustedY(50),TFUtil.getAdjustedX(50)]);
			this.showerOneOn = false;
		}
		
	},
	showerAll: function()
	{
		if(this.showerAllOn == false)
		{
			GameLayer.getSelectedTank().showerOneon();
			this.OffShowerButton.setImage('./Content/images/SettingsUI/shower0.png',[TFUtil.getAdjustedY(50),TFUtil.getAdjustedX(50)]);
			this.showerOneOn = true;
			GameLayer.getSelectedTank().showerAllon();
			this.OffShowerButtonAll.setImage('./Content/images/SettingsUI/showerAll0.png',[TFUtil.getAdjustedY(50),TFUtil.getAdjustedX(50)]);
			this.showerAllOn = true;
		}
		else
		{
			GameLayer.getSelectedTank().showerOneOff();
			this.OffShowerButton.setImage('./Content/images/SettingsUI/shower1.png',[TFUtil.getAdjustedY(50),TFUtil.getAdjustedX(50)]);
			this.showerOneOn = false;
			GameLayer.getSelectedTank().showerAllOff();
			this.OffShowerButtonAll.setImage('./Content/images/SettingsUI/showerAll1.png',[TFUtil.getAdjustedY(50),TFUtil.getAdjustedX(50)]);
			this.showerAllOn = false;
		}
		
	},
	soundBttnClicked: function()
    {
	     								 
       if(GAAudioManager._music)
       {
            this._buttonSetSound.setImage('./Content/images/SettingsUI/sound1.png',[TFUtil.getAdjustedY(50),TFUtil.getAdjustedX(50)]);
		  
		    GAAudioManager.toggleBackgroundMusic();
		    GAAudioManager.toggleTickSound();
		    GAAudioManager.toggleCleanSound();		 
			TFStorageManager.saveToUserDefault(SOUND_KEY,'1');
       }
       else
       {
            this._buttonSetSound.setImage('./Content/images/SettingsUI/sound0.png',[TFUtil.getAdjustedY(50),TFUtil.getAdjustedX(50)]);
		  
		    GAAudioManager.toggleBackgroundMusic();
		    GAAudioManager.toggleTickSound();
		    GAAudioManager.toggleCleanSound();		  
		    TFStorageManager.saveToUserDefault(SOUND_KEY,'0');
       }
		    console.log("sound on after click "+GAAudioManager._music);
    },
										 
										 
 
//	cameraBttnClicked: function()
//    {
//       console.log("photo taken!!!! gudluck");
//    },
//    
										 
	crossBttnClicked: function()
	{
		var myParent = this.getParent();
		myParent.enableButtons();
		this.callBack();
		//myParent.removeChild(this);			 
		//this.destroy();
	},
										 
	destroy: function($super)
    {
		TFUtil.destroyNodeChildren(this._backgroundAlertWindow);
		TFUtil.destroyNodeChildren(this);
		$super();
    },
    
    
});
























; return exports;};
$MODULE_FACTORY_REGISTRY['Code/GLLayer/GAMobclixForView'] = function(){var exports = $MODULE_REGISTRY['Code/GLLayer/GAMobclixForView'] || {}; $MODULE_REGISTRY['Code/GLLayer/GAMobclixForView'] = exports; exports.GAMobclixForView = Core.Class.singleton(
{
	classname: 'GAMobclixForView',
	
	initialize: function()
	{
		this._state = false;
	},
	setID: function(state,ID)
	{

		this._state = state;
		if(this._state)
		{	
			console.log('mobclix ID ' + ID);
			Mobclix.startWithApplicationId(ID);
			this._mobclix = new Mobclix.AdView_320x50();
			this._mobclix.getAd();
		}
	},
	
	show: function(x,y)
	{
		if(this._state )
		{
			var adViewFrame = this._mobclix.getFrame();
     		adViewFrame[0] = x;
     		adViewFrame[1] = y;
     		this._mobclix.setFrame(adViewFrame);
     		//return this._mobclix;
     		NGWindow.document.addChild(this._mobclix);
		}
	},
	
	setFrame: function(x,y) {
		var adViewFrame = this._moclix.getFrame();
     	adViewFrame[0] = x;
     	adViewFrame[1] = y;
     	this._moclix.setFrame(adViewFrame);
	},
	
	removeAd: function() {
		if(this._state)
		{	
			NGWindow.document.removeChild(this._mobclix);	
		}	
	},
	
	cancelAdd: function() {
		
	},
	
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/GLLayer/InfoView/TankLayer'] = function(){var exports = $MODULE_REGISTRY['Code/GLLayer/InfoView/TankLayer'] || {}; $MODULE_REGISTRY['Code/GLLayer/InfoView/TankLayer'] = exports; /**
 * Filename: TankLayer.js
 * Author: Shoaib Ahmed
 * Date Created: --
 * Date Updated: --
 */

exports.TankLayer = GL2.Node.subclass({
	
	classname: 'TankLayer',
	
	initialize: function()
	{
		
								
		this.user = TFGameState.getCurrentUser();
		var totalTanks = this.user._userObj.tankArray;
		this.tankNameArray = new Array();
		this.tankIdsArray = new Array();
		this.showButtonArray = new Array();
		this.deleteButtonArray = new Array();
		this.tankCount = 0;
		this.pageIndex = 0;

		for(objectId in totalTanks)
		{
			var tank = this.user._userObj.tankArray[objectId];
			this.tankNameArray.push(tank.tankName);
			this.tankIdsArray.push(tank.tankId);
			this.tankCount++;
		}

		this.pageIndex = this.getCurrentPageIndex();

		if(this.tankCount > 3)
		{
			this.upButton = new GLButton('./Content/images/UIPanels/SidePanel/uparrow-over1.png','./Content/images/UIPanels/SidePanel/uparrow.png',TFUtil.getAdjustedY(40),TFUtil.getAdjustedX(20),this.upBttnFunc.bind(this),this,100,GALocalizationHandler.getLocalizedString('TF_INFOAPPVIEW_ADDNEW_BUTTON'),new Core.Color(1,1,1),new Core.Color(1,1,1),null,TFUtil.getAdjustedFontSize(1));
			this.upButton.setPosition(TFUtil.getAdjustedY(0),TFUtil.getAdjustedX(-115));
			this.upButton.setDisabledImagePath('./Content/images/UIPanels/SidePanel/uparrow-overGray.png');
			
			this.downButton = new GLButton('./Content/images/UIPanels/SidePanel/downarrow-over1.png','./Content/images/UIPanels/SidePanel/downarrow.png',TFUtil.getAdjustedY(40),TFUtil.getAdjustedX(20),this.downBttnFunc.bind(this),this,100,GALocalizationHandler.getLocalizedString('TF_INFOAPPVIEW_ADDNEW_BUTTON'),new Core.Color(1,1,1),new Core.Color(1,1,1),null,TFUtil.getAdjustedFontSize(1));
			this.downButton.setPosition(TFUtil.getAdjustedY(0),TFUtil.getAdjustedX(35));
			this.downButton.setDisabledImagePath('./Content/images/UIPanels/SidePanel/downarrow-overGray.png');
		}

		var price = (this.tankCount - 1)*2000;
		if(price == 0)
		{
			price = GALocalizationHandler.getLocalizedString('TF_INFOAPPVIEW_PRICE_TEXT');//"FREE";
		}
		else 
		{
			price = price+" "+GALocalizationHandler.getLocalizedString('TF_MESSAGE_COINS_WITH_CAPITAL_C');
		}
		
		var addNewButton = null;
//		console.log('aleem : this.tankCound' + this.tankCount);
		
		if(this.tankCount >= 80)
		{
			// do not create button
		}
		else if(!TFGameState.atNeighbor){
			console.log('aleem: in if condition');
			addNewButton = new GLButton('./Content/images/UIPanels/SidePanel/button.png','./Content/images/UIPanels/SidePanel/button.png',TFUtil.getAdjustedY(75),TFUtil.getAdjustedX(25),this.confirmAddNewBttnFunc.bind(this),this,100,GALocalizationHandler.getLocalizedString('TF_INFOAPPVIEW_ADDNEW_BUTTON'),new Core.Color(1,1,1),new Core.Color(1,1,1),null,TFUtil.getAdjustedFontSize(70));
			addNewButton.setPosition(TFUtil.getAdjustedY(0),TFUtil.getAdjustedX(66));
			
			var priceText = GLFactory.getText([TFUtil.getAdjustedY(0),TFUtil.getAdjustedX(90)],100,price,[TFUtil.adjustHeightWithDevice(300),TFUtil.adjustWidthWithDevice(300)],TFUtil.getAdjustedFontSize(75));
			priceText.setColor(1, 1, 1);
			priceText.setFontLocation(TFUtil.getFontLocation());
			priceText.setFontFamily(TFUtil.getFont());
			this.addChild(priceText);
		} else {
			addNewButton = new GLButton('./Content/images/UIPanels/SidePanel/button-disabled.png','./Content/images/UIPanels/SidePanel/button-disabled.png',TFUtil.getAdjustedY(75),TFUtil.getAdjustedX(25),this.confirmAddNewBttnFunc.bind(this),this,100,GALocalizationHandler.getLocalizedString('TF_INFOAPPVIEW_ADDNEW_BUTTON'),new Core.Color(1,1,1),new Core.Color(1,1,1),null,TFUtil.getAdjustedFontSize(70));
			addNewButton.setPosition(TFUtil.getAdjustedY(0),TFUtil.getAdjustedX(66));
		}

		
				
		this.makeButtons();

	},

	getCurrentPageIndex: function()
	{	
		pageIndex = 0;
		for(i = 0; i < this.tankNameArray.length; i++)
		{
			var selectedTankId =  this.user._userObj.selectedTankId;
			if(selectedTankId == this.tankIdsArray[i])
			{		
				pageIndex = Math.floor(i/3);
			}
		}
									  
		return pageIndex;
	},

	setUpAndDownButtons:function()
	{
		if(this.pageIndex == 0)
		{
			this.upButton.setIsEnabled(false);
		}
		else
		{
			this.upButton.setIsEnabled(true);
		}
	
		if(this.pageIndex + 1 >=  this.tankCount/3)
		{
			this.downButton.setIsEnabled(false);
		}
		else
		{
			this.downButton.setIsEnabled(true);
		}
	},

	makeButtons:function()
	{

		var fishRef = this.tankFishCountButton;
		if(fishRef)
		{
			this.tankFishCountButton.destroy();
			this.tankFishCountButton = null;
		}
	
		if(this.tankCount > 3)
		{
			this.setUpAndDownButtons();
		}
	
		for (var j=0; j<this.showButtonArray.length;)
		{
			var buttonRef = this.showButtonArray.pop();
			buttonRef.destroy();
		
			if(!TFGameState.atNeighbor){
				var deleteButton = this.deleteButtonArray.pop();
				deleteButton.destroy();
			}
			
		} 
	
		var totalButtonsToBeMade = 0;
	
		if(this.tankCount - this.pageIndex*3 < 3)
		{	
			totalButtonsToBeMade = this.tankCount%3;
		}
	
		if(totalButtonsToBeMade == 0)
		{
			totalButtonsToBeMade = 3;
		}
	
		for (i=0; i<totalButtonsToBeMade; i++)
		{
			var x = 45;
			var name = this.tankNameArray[i + this.pageIndex*3];
			var tankId = this.tankIdsArray[i + this.pageIndex*3];
			showCurrentTankButton = new GLButton('./Content/images/UIPanels/SidePanel/button.png','./Content/images/UIPanels/SidePanel/ButtonOverNew.png',TFUtil.getAdjustedY(75),TFUtil.getAdjustedX(25),this.showCurrentTankBttnFunc.bind(this,name),this,100,GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_INFOAPPVIEW_SHOWCURRENTTANK_BUTTON'),[name]),new Core.Color(1,1,1),new Core.Color(1,1,1),null,TFUtil.getAdjustedFontSize(70));
			showCurrentTankButton.setPosition(TFUtil.getAdjustedY(0),TFUtil.getAdjustedX(-85+i*x));
		
			if(this.user._userObj.selectedTankId == tankId)
			{	
				showCurrentTankButton.destroy();
				showCurrentTankButton = new GLButton('./Content/images/UIPanels/SidePanel/ButtonOverNew.png','./Content/images/UIPanels/SidePanel/ButtonOverNew.png',TFUtil.getAdjustedY(75),TFUtil.getAdjustedX(25),this.showCurrentTankBttnFunc.bind(this,name),this,100,GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_INFOAPPVIEW_SHOWCURRENTTANK_BUTTON'),[name]),new Core.Color(1,1,1),new Core.Color(1,1,1),null,TFUtil.getAdjustedFontSize(70));
				showCurrentTankButton.setPosition(TFUtil.getAdjustedY(0),TFUtil.getAdjustedX(-85+i*x));
			
				var allFishArr = this.user._tankObj._allFish;
			
				var fishCount = 0;
				for(fishId in allFishArr)
				{	
					fishCount++;
				}
			
				this.tankFishCountButton = new GLButton('./Content/images/UIPanels/SidePanel/TankCountImage.png','./Content/images/UIPanels/SidePanel/TankCountImage.png',TFUtil.getAdjustedY(55),TFUtil.getAdjustedX(16),this.tankFishCount.bind(this),this,100,GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_INFOAPPVIEW_TANKFISHCOUNT_BUTTON'),[fishCount]),new Core.Color(1,1,1),new Core.Color(1,1,1),null,TFUtil.getAdjustedFontSize(60));
				this.tankFishCountButton.setPosition(TFUtil.getAdjustedY(0),TFUtil.getAdjustedX(-85+i*x+21));
			
			}
		
			this.showButtonArray.push(showCurrentTankButton);
			if(!TFGameState.atNeighbor){
				var deleteTankButton = new GLButton('./Content/images/UIPanels/Buttons/cross1.png','./Content/images/UIPanels/Buttons/cross1.png',TFUtil.getAdjustedY(17),TFUtil.getAdjustedX(17),this.confirmDeleteTankBttnFunc.bind(this,name),this,100);
				deleteTankButton.setPosition(TFUtil.getAdjustedY(-35),TFUtil.getAdjustedX(-85 +i*x - 15));
				this.deleteButtonArray.push(deleteTankButton);
			}
		}
	
	},
	
	upBttnFunc: function()
	{
		if(this.pageIndex == 0)
		{
			return;
		}
	
		this.pageIndex--;
		this.makeButtons();
		return;
	},

	downBttnFunc: function()
	{	
	
		var totalPossiblePages = this.tankCount/3;
	
		if(this.tankCount <= 3)
		{
			return;
		}
	
		if(this.pageIndex + 1 >= totalPossiblePages)
		{
			return;
		}
	
		this.pageIndex++;

		this.makeButtons();	
	},

	 confirmAddNewBttnFunc: function()
	    {
	    
	   // console.log('aleem : in confirmation '+ this.tankCount);
		 if(TFGameState.atNeighbor)
		 {
		 	// console.log('aleem : in confirmation '+ this.tankCount);
			 return;
		 }
		 
				GameLayer.getControlLayer().getControlLayerAbove().closeLeftPanel();						  
				var level = this.user._userObj.currentLevel;
				
				if(this.tankCount < level) {
					var price = (this.tankCount - 1)*2000;
					if(price <= this.user._userObj.coins)
					{			  
						var message = GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_ADD_TANK_CONFIRMATION'),[price]);
						var alertWindow = new TFMiniGLAlertView("",message,this,GALocalizationHandler.getLocalizedString('TF_CANCEL_BUTTON'),GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
						alertWindow._type="okwithcancel";
						alertWindow.setTagValue(100);
						alertWindow.setMessageColor(255,255,255);
						alertWindow.setMessageFont(TFUtil.getFont(),TFUtil.getFontLocation());
						alertWindow.setButtonsFont(TFUtil.getFont(),TFUtil.getFontLocation());
						alertWindow.show();
											  
					}
					else
					{
						
						var message = GALocalizationHandler.getLocalizedString('TF_CANNOT_PURCHASE_TANK');
						var notEnoughCoinsAlert = new TFMiniGLAlertView("",message,this,GALocalizationHandler.getLocalizedString('TF_CANCEL_BUTTON'),GALocalizationHandler.getLocalizedString('TF_EARN_COINS'));
						notEnoughCoinsAlert._type="okwithcancel";
						notEnoughCoinsAlert.setTagValue(300);
						notEnoughCoinsAlert.setMessageColor(255,255,255);
						notEnoughCoinsAlert.setMessageFont(TFUtil.getFont(),TFUtil.getFontLocation());
						notEnoughCoinsAlert.setButtonsFont(TFUtil.getFont(),TFUtil.getFontLocation());
						notEnoughCoinsAlert.show();				  
					}
				}
				else 
				{
					var message = GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_NEW_TANK_NOT_ENOUGH'),[level]);
					var notEnoughCoinsAlert = new TFMiniGLAlertView("",message,this,GALocalizationHandler.getLocalizedString('TF_CANCEL_BUTTON'),GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
					notEnoughCoinsAlert._type="ok";
					notEnoughCoinsAlert.setTagValue(kAlertWindowType.kAlertWindowCustom);
					notEnoughCoinsAlert.setMessageColor(255,255,255);
					notEnoughCoinsAlert.setMessageFont(TFUtil.getFont(),TFUtil.getFontLocation());
					notEnoughCoinsAlert.setButtonsFont(TFUtil.getFont(),TFUtil.getFontLocation());
					notEnoughCoinsAlert.show();	
				}
				
			
	    },
    

	addNewTank:function()
	{	
		var price = (this.tankCount - 1)*2000;
		DatabaseInterface.addNewTank();
		this.user.updateCurrency(kOperationType.kOperationSubtractCoins,price);
	},

//	addNewTank:function()
//	{	
//		var price = (this.tankCount - 1)*2000;
//		DatabaseInterface.addNewTank();
//		this.user.updateCurrency(kOperationType.kOperationSubtractCoins,price);
//	},

	
	showCurrentTankBttnFunc: function(tankName)
	{
		var selectedTankName = 'Tank' + this.user._userObj.selectedTankId;
		var selectedTankId = this.user._userObj.selectedTankId;
	
		//MODIFIED BY AHSAN
//		earlier selected tank was passing tankName as parameter and tank to be selected was passing tankId as parameter
//		now both are passing tankName,
//		a flag has been added to TFControlLayerAbove which makes sure double tapping causes no exception.
		if (GameLayer.getControlLayer().getControlLayerAbove().flag == 1){
			//console.log("EXC :: returning :: flag :: "+GameLayer.getControlLayer().getControlLayerAbove().flag);
			return;
		}
		GameLayer.getControlLayer().getControlLayerAbove().flag = 1;

		var tank = null;
		try {
			for(objectId in this.user._userObj.tankArray)
			{
				tank = this.user._userObj.tankArray[objectId];
				
				if(tank.tankName == tankName)// || (tank.tankName == 'Tank'+tankName))
				{
					break;
				}
				tank = null;
			}
		}
		catch(ex) {
			console.log("faizan exception" + ex);
		}
		
		if((tank != null ) && (tank.tankId == selectedTankId))
		{
			GameLayer.getControlLayer().getControlLayerAbove().flag = 0;
			return;
		}
		//console.log("ahsan :: tankLayer :: tank.tankId"+tank.tankId)
		GameLayer.getControlLayer().getControlLayerAbove().closeLeftPanel();
		DatabaseInterface.changeTank(tank.tankId);
				
		/*var selectedTankName = 'Tank' + this.user._userObj.selectedTankId;
		if(tankName == selectedTankName)
		{
			return;
		}
		GameLayer.getControlLayer().getControlLayerAbove().closeLeftPanel();
		DatabaseInterface.changeTank(tankName);*/
	},

	confirmDeleteTankBttnFunc: function(tankName)
	{	
		this.tankToBeDeleted = tankName;
		var selectedTankId = this.user._userObj.selectedTankId;
		var selectedTankName = 'Tank' + this.user._userObj.selectedTankId;
		try {
			for(objectId in this.user._userObj.tankArray)
			{
				var tank = this.user._userObj.tankArray[objectId];
				if(tank.tankName == tankName)
				{
					try {
						if(tank.isLocked) {
							var myString = GALocalizationHandler.getLocalizedString('TF_TANK_LOCKED_ALERT');
							var alertWindow = new TFMiniGLAlertView("",myString,this,GALocalizationHandler.getLocalizedString('TF_CANCEL_BUTTON'),GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
							alertWindow.setMessageColor(255,255,255);
							alertWindow.setMessageFont(TFUtil.getFont(),TFUtil.getFontLocation());
							alertWindow.setButtonsFont(TFUtil.getFont(),TFUtil.getFontLocation());
							alertWindow.show();
							return;
						}
					}
					catch(e) {
						console.log('Log Exception ' + e);
					}
	
					break;
				}
			}
		}
		catch(ex) {
			console.log("faizan exception" + ex);
		}
		if(tank.tankId != selectedTankId)
		{
			this.tankToBeDeletedId = tank.tankId
			var message =  GALocalizationHandler.getLocalizedString('TF_DELETE_TANK_CONFIRMATION');
			var alertWindow = new TFMiniGLAlertView("",message,this,GALocalizationHandler.getLocalizedString('TF_CANCEL_BUTTON'),GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
			alertWindow._type="okwithcancel";
			alertWindow.setTagValue(101);
			alertWindow.setMessageColor(255,255,255);
			alertWindow.setMessageFont(TFUtil.getFont(),TFUtil.getFontLocation());
			alertWindow.setButtonsFont(TFUtil.getFont(),TFUtil.getFontLocation());
			alertWindow.show();
		}
		else
		{
			
			var message = GALocalizationHandler.getLocalizedString('TF_CANNOT_DELETE_TANK');
			var alertWindow = new TFMiniGLAlertView("",message,this,GALocalizationHandler.getLocalizedString('TF_CANCEL_BUTTON'),GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
			alertWindow._type="ok";
			alertWindow.setMessageColor(255,255,255);
			alertWindow.setMessageFont(TFUtil.getFont(),TFUtil.getFontLocation());
			alertWindow.setButtonsFont(TFUtil.getFont(),TFUtil.getFontLocation());
			alertWindow.show();
			
			this.tankToBeDeleted = null;
			this.tankToBeDeletedId = null;
		}

		GameLayer.getControlLayer().getControlLayerAbove().closeLeftPanel();
	},
	
	deleteTank: function()
	{
//		console.log("ahsan :: tankLayer :: tankToBeDeletedId"+this.tankToBeDeletedId);

//		var retValArray = this.tankToBeDeleted.split("k");
//		TFUtil.getResourceDict(retValArray[1],kObjectActionType.kObjectActionRemove);
		TFGameState.justDeleted = true;
		TFUtil.getResourceDict(this.tankToBeDeletedId,kObjectActionType.kObjectActionRemove);
		DatabaseInterface.deleteTank(this.tankToBeDeletedId);
		this.tankToBeDeletedId = null;
	},
    
    tankFishCount: function()
    {
    },


	clickedButtonAtIndex: function(buttonIndex,alertWindow)
	{
		if (buttonIndex == 0) 
		{
			switch(alertWindow.getTagValue())
			{				
				case 100:
				{
					this.addNewTank();
					break;
				}
				case 101:
				{
					this.deleteTank();
					break;
				}
				case 300:
				{
					alertWindow.destroy();
					var inAppMainView = new InAppMainView(false);
        			NGWindow.document.addChild(inAppMainView);
              	  	this._getParentTableView()._ParentMainView.destroy();
                	break;
				}
			}
		}
		else if (buttonIndex == 1) 
		{
			//this.destroy();
		}
	
	},
    
	destroy: function($super)
	{	
		delete this.tankNameArray;
		delete this.tankIdsArray;
		
		for(var i = 0; i < this.showButtonArray.length;)
		{
			var buttonRef = this.showButtonArray.pop();
			buttonRef.destroy();
			
			var deleteButton = this.deleteButtonArray.pop();
			deleteButton.destroy();			
		}
		
		delete this.showButtonArray;
		this.showButtonArray = null;
		
		delete this.deleteButtonArray;
		this.deleteButtonArray = null;
	
		if(this.upButton)
		{
			this.upButton.destroy();
			this.upButton = null;
		}
		
		if(this.downButton)
		{
			this.downButton.destroy();
			this.downButton = null;
		}
		TFUtil.destroyNodeChildren(this);
		$super();							  
	},
    
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/GLLayer/InfoView/InventoryLayer'] = function(){var exports = $MODULE_REGISTRY['Code/GLLayer/InfoView/InventoryLayer'] || {}; $MODULE_REGISTRY['Code/GLLayer/InfoView/InventoryLayer'] = exports; /**
 * Filename: InventoryLayer.js
 * Author: Shoaib Ahmed
 * Date Created: --
 * Date Updated: --
 */

exports.InventoryLayer = GL2.Node.subclass({
	
	classname: 'InventoryLayer',
	
	initialize: function($super)
    {
		$super();
        this.showButtonArray = new Array();
        this.showButtonImageArray = new Array();
		this.upDownButtonArray = new Array();
		this.inventoryDict = TFGameState.getCurrentUser()._inventoryDict;
		this.inventoryCount = this.inventoryDict.length;
		this.currentPossibleNumberOfPages = this.inventoryCount/2;
		
		this.pageIndex = 0;
        
        this.makeButtons();
        
    },

    inventoryButtonPressed: function(storeId)
    {
		var itemArray = this.inventoryDict.objectForKey(storeId);
		var inventoryObject = itemArray.objectAtIndex(0);
		this.inventoryStoreObject =  GAGameLoader.getStoreHandler().getStoreObjectForKey(storeId);
		var storeObjectType = StoreUtil.getStoreObjectType(this.inventoryStoreObject);
        
		if(storeObjectType == kObjectType.kObjectFish)
		{
			if(! GameLayer.getSelectedTank().canFishBeAdded())
			{
				var text= GALocalizationHandler.getLocalizedString("TF_MSG_TANK_FULL");
				var color =  new Core.Color(255,0,0);
				
				this.SCREEN_HEIGHT = Core.Capabilities.getScreenWidth();
				this.SCREEN_WIDTH = Core.Capabilities.getScreenHeight();
				
				
				var target = new Core.Vector(this.SCREEN_WIDTH/2,this.SCREEN_HEIGHT/2);
				GameLayer.getSelectedTank().textAnimation(target,text,color);
				return;
			}
			
			var currentTime = TFGameState.getServerTime();
            var tankFish = new TankFish(inventoryObject);
			tankFish._fishObj.created_time = tankFish._fishObj.created_time + (currentTime - inventoryObject.inventoryCreated);
			tankFish._fishObj.lastFed = tankFish._fishObj.lastFed + (currentTime - inventoryObject.inventoryCreated);
			TFGameState.getCurrentUser().removeFromInventory(inventoryObject.objectId);
			
			GameLayer.getSelectedTank().moveFishFromInventory(tankFish);
			TFUtil.setFishInFishArray(tankFish.getStoreId(),tankFish.getStoreId());
			itemArray.removeObjectAtIndex(0);
			if(itemArray._length == 0)
			{
				this.inventoryDict.removeObjectForKey(storeId);
			}
		}
		else if (storeObjectType == kObjectType.kObjectDecoration)
		{	
			var tankDecoration = new TankDecoration(inventoryObject);
			
			TFGameState.getCurrentUser().removeFromInventory(inventoryObject.objectId);
			
			GameLayer.getSelectedTank().moveDecorationFromInventory(tankDecoration);
			
			itemArray.removeObjectAtIndex(0);
			if(itemArray._length == 0)
			{
				this.inventoryDict.removeObjectForKey(storeId);
			}
			
		}
		
		else if(storeObjectType == kObjectType.kObjectPlant)
		{
			var tankPlant = new TankPlant(inventoryObject);
			
			TFGameState.getCurrentUser().removeFromInventory(inventoryObject.objectId);
			
			GameLayer.getSelectedTank().movePlantFromInventory(tankPlant);
			
			itemArray.removeObjectAtIndex(0);
			if(itemArray._length == 0)
			{
				this.inventoryDict.removeObjectForKey(storeId);
			}
			
		}
		
		this.makeButtons();
		
    },
    
	setUpAndDownButtons:function()
	{	
		for (var j=0;j < this.upDownButtonArray.length;)
		{
			var buttonRef = this.upDownButtonArray.pop();
			buttonRef.destroy();
			buttonRef = null;
		}
		
		if(this.inventoryCount > 2)
		{
			var upButton = new GLButton('./Content/images/UIPanels/SidePanel/uparrow-over1.png','./Content/images/UIPanels/SidePanel/uparrow.png',TFUtil.getAdjustedY(40),TFUtil.getAdjustedX(20),this.upBttnFunc.bind(this),this,100,GALocalizationHandler.getLocalizedString('TF_INFOAPPVIEW_ADDNEW_BUTTON'),new Core.Color(1,1,1),new Core.Color(1,1,1),null,TFUtil.getAdjustedFontSize(1));
			upButton.setPosition(TFUtil.getAdjustedY(-5),TFUtil.getAdjustedX(-130));
			upButton.setDisabledImagePath('./Content/images/UIPanels/SidePanel/uparrow-overGray.png');
			this.upDownButtonArray.push(upButton);
			
			var downButton = new GLButton('./Content/images/UIPanels/SidePanel/downarrow-over1.png','./Content/images/UIPanels/SidePanel/downarrow.png',TFUtil.getAdjustedY(40),TFUtil.getAdjustedX(20),this.downBttnFunc.bind(this),this,100,GALocalizationHandler.getLocalizedString('TF_INFOAPPVIEW_ADDNEW_BUTTON'),new Core.Color(1,1,1),new Core.Color(1,1,1),null,TFUtil.getAdjustedFontSize(1));
			downButton.setPosition(TFUtil.getAdjustedY(-5),TFUtil.getAdjustedX(110));
			downButton.setDisabledImagePath('./Content/images/UIPanels/SidePanel/downarrow-overGray.png');
			this.upDownButtonArray.push(downButton);
		
			
			if(this.pageIndex == 0)
			{
				upButton.setIsEnabled(false);
			}
			else
			{
				upButton.setIsEnabled(true);
			}
	
			if(this.pageIndex + 1 >=  this.inventoryCount/2)
			{
				downButton.setIsEnabled(false);
			}
			else
			{
				downButton.setIsEnabled(true);
			}
		}
	},
	
	updateInventoryCount:function()
	{
		this.inventoryCount = this.inventoryDict.length;
	},
	
	makeButtons:function()
	{
	   this.updateInventoryCount();
	   
	   var totalPossiblePages = this.inventoryCount/2;
	   
	   if(totalPossiblePages < this.currentPossibleNumberOfPages)
	   {
		   this.currentPossibleNumberOfPages = totalPossiblePages;
		   if(this.pageIndex > 0)
		   {   
			   this.pageIndex--;
		   }
	   }
	   
	   this.setUpAndDownButtons();
		
	   for (var j=0;this.showButtonArray.length;)
		{
			var buttonRef = this.showButtonArray.pop();
			if(buttonRef){
				buttonRef.destroy();
				buttonRef = null;
			}
            
            var imageButtonRef = this.showButtonImageArray.pop();
            if(imageButtonRef) {
            	imageButtonRef.destroy();
            	imageButtonRef = null;
            }
        } 
        
		var totalButtonsToBeMade = 0;
	   
		if(this.inventoryCount - this.pageIndex*2 < 2)
		{	
			totalButtonsToBeMade = this.inventoryCount%2;
		}
	
		if(totalButtonsToBeMade == 0 && this.inventoryDict.length != 0)
		{
			totalButtonsToBeMade = 2;
		}
		
		var keysArray = this.inventoryDict.allKeys();
		
		for (i=0; i<totalButtonsToBeMade; i++)
		{
			var x = 100;
            var z = 1;
		
			var storeId = keysArray[i+this.pageIndex*2];
			var itemArray = this.inventoryDict.objectForKey(storeId);
			var storeItem = GAGameLoader.getStoreHandler().getStoreObjectForKey(storeId);
			var width = storeItem.custom_attributes.size_width;
			var height = storeItem.custom_attributes.size_height;
			var size = TFUtil.getAspectMaintainSize(new Core.Size(width,height),new Core.Size(45,45));
			
			showCurrentInventoryButton = new GLButton('./Content/images/UIPanels/SidePanel/boxnumber.png','./Content/images/UIPanels/SidePanel/boxnumber.png',TFUtil.getAdjustedY(75),TFUtil.getAdjustedX(75),this.inventoryButtonPressed.bind(this,storeId),this,100,GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_INVENTORYLAYER_SHOWINVENTORY_BUTTON'),[itemArray._length]),new Core.Color(0,0,0),new Core.Color(0,0,0),null,TFUtil.getAdjustedFontSize(90));
			showCurrentInventoryButton.setPosition(TFUtil.getAdjustedY(-2),TFUtil.getAdjustedX(-60+i*x));
		    showCurrentInventoryButton.buttonText.setPosition(TFUtil.getAdjustedY(28),TFUtil.getAdjustedX(28+i*z));
			this.showButtonArray.push(showCurrentInventoryButton);

			this._basePath = TFUtil.getBasePathForResourceType(storeId, GAResourceType.kDetail);
			var normalImage = this._basePath+'/2.png';
			showCurrentInventoryImageButton = new GLButton(normalImage,normalImage,TFUtil.adjustHeightWithDevice(size.getWidth()),TFUtil.adjustWidthWithDevice(size.getHeight()),this.inventoryButtonPressed.bind(this,storeId),this,100);
			showCurrentInventoryImageButton.setPosition(TFUtil.getAdjustedY(-5),TFUtil.getAdjustedX(-60+i*100));
	        this.showButtonImageArray.push(showCurrentInventoryImageButton);
	        
			delete size;
				
		 }
	
	},
	
	upBttnFunc: function()
	{
		if(this.pageIndex == 0)
		{
			return;
		}
	
		this.pageIndex--;
		this.makeButtons();
		return;
	},

	downBttnFunc: function()
	{	
		
		var totalPossiblePages = this.inventoryCount/2;
		if(this.inventoryCount <= 2)
		{
			return;
		}
	
		if(this.pageIndex + 1 >= totalPossiblePages)
		{
			return;
		}
	
		this.pageIndex++;

		this.makeButtons();	
	},

    destroy: function($super)
	{		
		for (var j=0;j < this.upDownButtonArray.length;)
		{	
			var buttonRef = this.upDownButtonArray.pop();
			buttonRef.destroy();
			buttonRef = null;
		}
		
		delete this.upDownButtonArray;
		this.upDownButtonArray = null;
		
		for (var j=0;this.showButtonArray.length;)
		{
			var buttonRef = this.showButtonArray.pop();
			buttonRef.destroy();
			buttonRef = null;
		}
		
		delete this.showButtonArray;
		this.showButtonArray = null;
		
        delete this.showButtonImageArray;
		this.showButtonImageArray = null;
		TFUtil.destroyNodeChildren(this);
		$super();
	},
    
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Utilities/TFStorageManager'] = function(){var exports = $MODULE_REGISTRY['Code/Utilities/TFStorageManager'] || {}; $MODULE_REGISTRY['Code/Utilities/TFStorageManager'] = exports; /**
 * Filename: TFStorageManager.js
 * Author: Wasay Abbasi
 * Date Created: 17th May, 2011
 * Date Updated: 17th May, 2011
 */

exports.TFStorageManager = Core.Class.singleton({

    classname: 'TFStorageManager',

    initialize: function() 
		{
			userDefaultValues = {};
			this._storage = null;
			this._numberOfCB = null;
			
			//kUserDefaultKeys
			this._numberOfCB = 0;
			this._storage = new Storage.KeyValue();
    },
	
	saveToUserDefault: function(key, value) 
	{
		this._storage.setItem(key, value, function(error, key) {});
		userDefaultValues[key] = value;
	},
	
	getAllValuesFromStorage: function() 
	{
		var keysLength = kUserDefaultKeys.length;
		var i;
		for(i = 0 ; i < keysLength ; i++) 
		{
			this._storage.getItem(kUserDefaultKeys[i], this.gotValue.bind(this));
		}
	},
	
	getValueFromUserDefault: function(key)
	{
		if(userDefaultValues[key] != null) 
		{
			return userDefaultValues[key];
		} 
		else 
		{
			return null;
		}
	},
	gotValue: function(error,value,key)
	{
		if(value != null)
		{
			userDefaultValues[key] = value;
		}
		var keysLength = kUserDefaultKeys.length;
		this._numberOfCB++;
		
		if(this._numberOfCB >= keysLength) {
			GameCentralHandler.loadSuccessForStorageManager();
		}
	},
	
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Utilities/Math2'] = function(){var exports = $MODULE_REGISTRY['Code/Utilities/Math2'] || {}; $MODULE_REGISTRY['Code/Utilities/Math2'] = exports; /**
* Filename: Math2.js
 * Author: Muhammad Jabbar
 * Date Created: 7/7/2011
 * Date Updated: --
 */

exports.Math2 = Core.Class.subclass(
{
	$ccpAdd: function(point1,point2)
	{
		var sumX = 0,sumY = 0,sum = 0;
		sumX = point1.getX()+point2.getX();
		sumY = point1.getY()+point2.getY();
		sum = new Core.Vector(sumX,sumY);
		return sum;	
	},
	$ccpSub: function(point1,point2)
	{
		var diffX = 0,diffY = 0, difference = 0;
		diffX = point1.getX()-point2.getX();
		diffY = point1.getY()-point2.getY();
		difference = new Core.Vector(diffX,diffY);
		return difference;	
	},
	$ccpDistance: function(point1,point2)
	{
		var diffX = 0,diffY = 0, distance = 0;
		diffX = point1.getX()-point2.getX();
		diffY = point1.getY()-point2.getY();
		distance = Math.sqrt(Math.pow(diffX,2)+ Math.pow(diffY,2));
		return distance;	
	},
	$rectContainsPoint: function (rect,point)
	{
		var rextX = 0 , rectY = 0 , rectWidth = 0 , rectHeight = 0, pointX =0 , pointY = 0, temp = 0;
		rectX = rect.getOrigin().getX();
		rectY = rect.getOrigin().getY();
		rectWidth = rect.getSize().getWidth();
		rectHeight =rect.getSize().getHeight(); 
		//point
		pointX = point.getX();
		pointY=point.getY();
			if((pointX>=rectX && pointX<=(rectX+rectWidth)) &&(pointY>=rectY && pointY <= (rectY+rectHeight)))
		{
			temp = true;
		}
		else
		{
			temp = false;
		}
		return temp;
	},
	
	$randomFromTo: function(from, to){
		return Math.floor(Math.random() * (to - from + 1) + from);
	},
	
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Utilities/TFMiniUIAlertView'] = function(){var exports = $MODULE_REGISTRY['Code/Utilities/TFMiniUIAlertView'] || {}; $MODULE_REGISTRY['Code/Utilities/TFMiniUIAlertView'] = exports; 
//Default type for alert window
var kALERT_WINDOW_TYPE = "ok"
var kALERT_WINDOW_TYPE_WITH_CANCEL = "okwithcancel"
	
exports.TFMiniUIAlertView = GAUIAlertView.subclass({
	classname: 'TFMiniUIAlertView',
	initialize: function($super,initWithTitle,message,delegate,cancelButtonTitle,otherButtonTitles) 
	{
		$super(initWithTitle,message,delegate,cancelButtonTitle,otherButtonTitles);
	},
	
	loadView: function($super)
	{
		$super();
		var frame=null;
	 	var x = (480/2) - (310/2);
		var y = (300/2) - (119/2);
		this._backgroundImage.setFrame([this.getAdjustedY(x),this.getAdjustedX(y),this.adjustHeightWithDevice(300),this.adjustWidthWithDevice(150)]);
		frame=[this.getAdjustedY(x+115),this.getAdjustedX(y+100),this.adjustHeightWithDevice(73),this.adjustWidthWithDevice(37)];
		this._okButton.setFrame(frame);
		if( this._type == kALERT_WINDOW_TYPE_WITH_CANCEL)
		{
			frame=[this.getAdjustedY(x+65),this.getAdjustedX(y+100),this.adjustHeightWithDevice(73),this.adjustWidthWithDevice(37)];
			this._okButton.setFrame(frame);
			
			frame=[this.getAdjustedY(x+150),this.getAdjustedX(y+100),this.adjustHeightWithDevice(73),this.adjustWidthWithDevice(37)];
			this._cancelButton.setFrame(frame);
		}
		this._scrollView.removeChild(this._messageLabel);
		this.removeChild(this._scrollView);
		this.addChild(this._messageLabel);
		this._messageLabel.setFrame([this.getAdjustedY(x+10),this.getAdjustedX(y+20),this.adjustHeightWithDevice(280),this.adjustWidthWithDevice(70)]);
		this._titleLabel.setFrame([this.getAdjustedY(x+60),this.getAdjustedX(y+20),this.adjustHeightWithDevice(100),this.adjustWidthWithDevice(30)]);
	},
	
	
	destroy: function($super)
	{
		$super();	
	}
	
	
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/ModelClasses/User'] = function(){var exports = $MODULE_REGISTRY['Code/ModelClasses/User'] || {}; $MODULE_REGISTRY['Code/ModelClasses/User'] = exports; exports.User = Core.Class.subclass(
{
    initialize: function() 
    {
    	this._userObj = null;
    	this._tankObj = null;
		this._userBreedingObj=null;
		this._ratingCount = 0;
		this._rating = 0;

		this._userBackgrounds = new Array(); // TODO: assign user backgrounds array
		this._breedingTanksArray=new Array();
    },
    
	updateCurrency:function (type, currency)
	{	
		this._controlLayerAbove = GameLayer.getControlLayer().getControlLayerAbove();
		
		if(currency < 0) {
			currency = 0;
		}
		switch (type) {
			case kOperationType.kOperationAddCoins:
			{
				this._userObj.coins = this._userObj.coins + currency;
				break;
			}
			case kOperationType.kOperationSubtractCoins:
			{
				this._userObj.coins = this._userObj.coins - currency;
				
				break;
			}
			case kOperationType.kOperationAddBucks:
			{	
				this._userObj.fish_bucks = this._userObj.fish_bucks + currency;
				break;
			}
			case kOperationType.kOperationSubtractBucks:
			{
								   
				this._userObj.fish_bucks = this._userObj.fish_bucks - currency;
				break;	
			}
			default:
				break;
		}
		
		if(this._userObj.coins > TF_MAX_USER_COINS) {
			this._userObj.coins = TF_MAX_USER_COINS;
		}
		if(this._userObj.coins <= 0) {
			this._userObj.coins = 0;
		}
		
		if(this._userObj.fish_bucks > TF_MAX_USER_BUCKS) {
			this._userObj.fish_bucks = TF_MAX_USER_BUCKS;
		}
		if(this._userObj.fish_bucks <= 0) {
			this._userObj.fish_bucks = 0;
		}
		
		DatabaseInterface.updateUser();
		this._controlLayerAbove.updateTopPanel();
	},

    
	getLevelProgress:function (cl,xp) 
	{
		
		var current = 0, next = 0, difference = 0 , progress = 0; 
		current = TFGameState.getLevelInfoForLevel(cl-1);
		if(cl<=79)
		{
			next = TFGameState.getLevelInfoForLevel(cl);
			difference = xp - current.xp_min;
			progress = ( difference*100 / (next.xp_min - current.xp_min) );
		}
		else
		{
			difference = current.xp_min;
			progress = ( difference*100 /current.xp_min);
			progress = 100;
		}
		if(progress < 0) {
			progress = 0;
		}
		if(progress >= 100) {
			progress = 100;
		}
		
		return progress;

	},
								   
	getLevelXp:function(level)			
	{
		return TFGameState.getLevelInfoForLevel(level-1).xp_min;
	},
	getBonusCoins:function(level)			
	{
		return TFGameState.getLevelInfoForLevel(level-1).reward_coins;
	},
	getBonusBucks:function(level)			
	{
		return TFGameState.getLevelInfoForLevel(level-1).reward_bucks;
	},
	
	getUsername: function(){
		return this._userObj.name;
	},

	getRatingCount: function () {
		return this._ratingCount;
	},
	
	setRatingCount: function (val) {
		this._ratingCount = val;
	},
	
	getRating: function () {
		return this._rating;
	},
	
	
	setRating: function (val) {
		this._rating = val;
	},
	
	getRatingPercentage : function () {
		var avg = this._rating/this._ratingCount; 
		var percentage = (avg/5) * 100;		// 5 Max Rate
		return percentage;
	},
	
	

	updateXPandLevel:function(amount) {
		this._controlLayerAbove = GameLayer.getControlLayer().getControlLayerAbove();
		if(amount <= 0) 
		{
			return;
		}
		
		var temp = 0, tempLevel = 0;
		temp = this._userObj.exp + amount;
		tempLevel = this._userObj.currentLevel;
		this.updateLevel(temp);
		this._userObj.exp = this._userObj.exp + amount;
		
		if ( tempLevel != this._userObj.currentLevel)
		{
		
			var requireXp = this.getLevelXp(this._userObj.currentLevel+1) - this.getLevelXp(this._userObj.currentLevel);
			
			var coins = this.getBonusCoins(this._userObj.currentLevel);
			var bucks = this.getBonusBucks(this._userObj.currentLevel);
			GameLayer.showLevelUpScreenForLevel(this._userObj.currentLevel,requireXp,coins);
			this._userObj.coins += coins;
			this._userObj.fish_bucks += bucks;
			var type = null;
			
			if(LogHandler.isDazzle()) {
				type = GADazzleOfferType.LevelUp;
			}
			else {
				type = "LevelUp";
			}
			
			if(coins > 0) {
				LogHandler.logOffer(type, this._userObj.coins, 'coins', '');
			}
			
			if (bucks > 0) {
				LogHandler.logOffer(type, this._userObj.fish_bucks, 'bucks', '');
			}
			
			
			
			//this._userObj.fish_bucks += 1;
		}
		if(!TFGameState.atNeighbor)
			DatabaseInterface.updateUser();
		else
			DatabaseHelper.updateUser();
		GAConfigurations.setGameXp(temp);   
	        GAConfigurations.setGameLevel(this._userObj.currentLevel);
		this._controlLayerAbove.updateTopPanel();

	},

	okButtonClicked: function(tagVal)
	{
		if(tagVal == 85451) 
		{
			
		}
		else if(tagVal == TZ_BUY_MORE_INVENTORY_TAG)
		{
		
		}
  },

	updateLevel:function (newXp) 
	{
	
		
				
		if (this._userObj.currentLevel == 80 ) 
		{
			return;
		}
		
		var progress = this.getLevelProgress(this._userObj.currentLevel,newXp);

		if ( progress >= 100 )
		{
			this._userObj.currentLevel++;
			if(!TFGameState.atNeighbor){
				DatabaseInterface.updateUser();
			}else{
				DatabaseHelper.updateUser();
			}
			this.updateLevel(newXp);
		}
		else {
			return;
		}
		
	},
	setUsername: function(username)
	{
		this._userObj.name = username;
		DatabaseInterface.updateUser();
	},
    
	setMusicOn: function(isEnableBool)
	{
		this._userObj.isSoundOn = isEnableBool;
		DatabaseInterface.updateUser();
	},
								   
	getMusicOn: function()
	{
		return this._userObj.isSoundOn;			   
	},

	getCurrencyForStoreItem:function(storeItem)
	{
		return 0;
	},
	
	getCurrentLevel: function()
	{
		return this._userObj.currentLevel;
	},
	
	getCoins: function()
	{
			return this._userObj.coins;
	},
	
	getBucks: function()
	{
		return this._userObj.fish_bucks;
	},

	getSellPrice:function(storeItem)
	{
		return 0;
	},
	
	addToInventory:function(modelObject)
	{	
		
		modelObject.objectId = this._userObj.inventoryId;
		this._userObj.inventory[this._userObj.inventoryId.toString()] = modelObject;
		this._userObj.inventoryId++;
		DatabaseInterface.updateUser();
	},
	
	removeFromInventory:function(inventoryObjectId)
	{
		delete this._userObj.inventory[inventoryObjectId];
		DatabaseInterface.updateUser();
	},
	
	deductCurrencyForStoreItem: function(store_item)
	{
		var buyPriceKey = GACommonUtils.getBuyPrice(store_item) , i =0;
		var buyPrice = StoreUtil.getPrice(buyPriceKey);
		var currency = StoreUtil.getCurrency(buyPriceKey);
		
		if(currency == kCurrencyType.kCurrencyTypeCoins) 
		{
			var userCoins = TFGameState.getCurrentUser().getCoins();
			if(userCoins >= buyPrice)
			{
				this.updateCurrency(kOperationType.kOperationSubtractCoins, buyPrice);
				return true;
			}
										
		} 
		else 
		{
			var userBucks = TFGameState.getCurrentUser().getBucks();
			if(userBucks >= buyPrice) 
			{
				this.updateCurrency(kOperationType.kOperationSubtractBucks, buyPrice);
				return true;
			}
		}
		
		return false;

	},
										   
	
	awardCurrencyForStoreItem:function(storeItem) 
	{
		this.updateCurrency(kOperationType.kOperationAddCoins,15);
	},



	canPerformActionForCurrency:function (currencyType,amount)
	 {
		
								   
								   
		if(currencyType == kCurrencyType.kCurrencyTypeCoins && this._userObj.coins >= amount) {
			return true;
		} 
		else if(currencyType == kCurrencyType.kCurrencyTypeBucks && this._userObj.fish_bucks >= amount) {
			return true;
		} 
		
		return false;
	},

	okButtonClicked:function(tagVal) {
	},

	cancelButtonClicked:function(tagVal)
	{

	},
		 
	addBackground: function(newBackground)
	{
			var backgroundCount = this._userObj.purchasedBackgroundArray.length;
			newBackground.objectId = backgroundCount+1;
			
			this._userObj.purchasedBackgroundArray[backgroundCount] = newBackground;
			this._userObj.currentBackgroundId = newBackground.storeId;
			
			//this._tankObj.backgroundStoreID = newBackground.storeId;
			DatabaseInterface.updateTank();
			DatabaseInterface.updateUser();
			
	},

	//							   
//	///////// 
//	
//	addShower: function(newShower)
//	{
//		var showerCount = this._userObj.userShowerList.length;
//		newShower.objectId = showerCount+1;
//		
//		this._userObj.userShowerList[showerCount] = newShower;
//		
//		
//		this._selectedTankObject.showerId = newShower.storeId;
//		DatabaseInterface.updateTank();
//		DatabaseInterface.updateUser();
//		
//	},
	isShowerPurchased: function(storeId)
	{
		console.log(">>Store id in user is "+storeId);
		for(var i = 0 ; i<this._userObj.userShowerList.length;i++)
		{
			if(this._userObj.userShowerList[i] == storeId)
			{
				console.log(">>Return true ");
				return true;
			}
		}
		console.log(">>Return false ");
		return false;
	},
//********************Breeding****************************								   
addBreedingRoomforStoreId: function(storeID)
{
	var breedtank = new BreedingTank();
	breedtank._breedTankObj = new Object();
	breedtank.resetBreedingTankObject();
	breedtank.setBreedTankStoreID(storeID);
	this._breedingTanksArray[this._breedingTanksArray.length] = breedtank;
	this._userBreedingObj.BreedingTanks[this._userBreedingObj.nextTankID.toString()] = breedtank._breedTankObj;
	this._userBreedingObj.nextTankID++;
	DatabaseInterface.updateBreedingTank();
	DatabaseInterface.updateUser();
	return breedtank;
},
/*			   
=======
								   addBreedingRoomforStoreId: function(storeID)
								   {
								   var breedtank = new BreedingTank();
								   breedtank._breedTankObj = new Object();
								   breedtank.resetBreedingTankObject();
								   breedtank.setBreedTankStoreID(storeID);
								   this._breedingTanksArray[this._breedingTanksArray.length] = breedtank;
								   this._userBreedingObj.BreedingTanks[this._userBreedingObj.nextTankID.toString()] = breedtank._breedTankObj;
								   this._userBreedingObj.nextTankID++;
								   DatabaseInterface.updateBreedingTank();
								   DatabaseInterface.updateUser();
								   return breedtank;
								   

								   },
								   
								   								   
								   
								   
//addBreedingTank:function(breedingTankObj) 
//{
//								   
//   this._userBreedingObj.BreedingTanks[this._userBreedingObj.nextTankID.toString()] = breedingTankObj;
//   this._userBreedingObj.nextTankID++;
//   DatabaseInterface.updateBreedingTank();
//},
								   
								   
								   
								   
>>>>>>> .r216*/
getBreedingTankPurchased:function(storeID)
{
	var i = 0,breedingTanksArrayLenght = this._breedingTanksArray.length,breedTank,tankPurchased = null;
	for(i; i < breedingTanksArrayLenght; i++)
	{
		breedTank = this._breedingTanksArray[i];
		if(breedTank.getBreedTankObj().breedingTankStoreID == storeID)
		{
			tankPurchased = breedTank;
			return tankPurchased;				   
		}
	}
},
								   
								   
populateBreedingTanks: function()
{
								   console.log("populateBreedingTanks");
	var  i = 0,breedingTankID ,allBreedingTanks = this._userBreedingObj.BreedingTanks;
   for(breedingTankID in allBreedingTanks)
   {
	   var breedingTank = new BreedingTank();
	   breedingTank.setBreedTankObj (this._userBreedingObj.BreedingTanks[breedingTankID]);
	   this._breedingTanksArray.push(breedingTank);
   }
								   
								   console.log("this._breedingTanksArray" +this._breedingTanksArray.length);
},
updateUser:function()
{
	DatabaseInterface.updateUser();
},

destroyUser: function()
{
//	this._userObj.destroy();
//	this._tankObj.destroy();
//	this._userBreedingObj.destroy();
//	
//	this._userObj = null;
//	this._tankObj = null;
//	this._userBreedingObj=null;
	
//	if(TFGameState.atNeighbor)
//	{
//		console.log(">>>>>>>_isNeighbor = true unloading tank and loading neighbor");						   
//		DatabaseInterface.UnloadTankAndInitializeNeighborData();
//	}
//	else
//	{
//		console.log(">>>>>>>_isNeighbor = false unloading tank and loading user");						   
//		DatabaseInterface.UnloadTankAndInitializeUserData();
//	}
},
								   
								  								   

});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/ModelClasses/Tank'] = function(){var exports = $MODULE_REGISTRY['Code/ModelClasses/Tank'] || {}; $MODULE_REGISTRY['Code/ModelClasses/Tank'] = exports; /* Tank.js
 * ngFish
 
 * Created by Kamran.Lodhi on 5/17/11.
 * Copyright 2011 __MyCompanyName__. All rights reserved.
 */
exports.Tank = Core.Class.subclass(
{
   classname: 'Tank',

	initialize: function(tankObj)
	{
		this._allFish = new Array();
		this._allDecorations = new Array();
		this._allBackgrounds = new Array();
		this._allPlants = new Array();
		this._allFoodBricks = new Array();

		if(tankObj)
		{
			this._tankObj = tankObj;
        }
		else
		{
			this._tankObj =
			{
				"classname": "",
				"name": "",
				"isShowerEnabled": 0,
				"isSoundOn": 0,				   
				"lastFed": 0,
				"lastRevived": 0,
				"lastCleaned": 0,
                "showerId" : 0,
				"lastTapped": 0,
				"lastLoved": 0,
				"isTankLocked": 0,
				"happiness": 0,
				"algae": 0,
				"tankObjectIndex": 1,
				"fishId": 1,
				"decorationId": 1,
				"plantId":1,
                "foodBrickId":1,
				"backgroundStoreID": "1_8_31",
				"Store_Items": 
				{
					"tank_fishArray": {},
					"tank_decorationArray": {},
					"tank_plantArray": {},
                    "tank_foodBrickArray":{}
				}
			};
		}
	},
	
	
initializeTankObjectArrays: function()
{
	var fishArray = this._tankObj.Store_Items['tank_fishArray']; 
  
	var i=0;
	for(var objectId in fishArray)
	{
		var modelFish = new TankFish(fishArray[objectId]);
		this._allFish[i]=modelFish;
		i++;
	}
	var decoArray = this._tankObj.Store_Items['tank_decorationArray']; 
	i=0;
	for(var objectId in decoArray)
	{
		var modelDeco = new TankDecoration(decoArray[objectId]);
		this._allDecorations[i]=modelDeco;
		i++;
	}
	
	var plantArray = this._tankObj.Store_Items['tank_plantArray']; 
	i=0;
	for(var objectId in plantArray)
	{
		var modelPlant = new TankPlant(plantArray[objectId]);
		this._allPlants[i]=modelPlant;
		i++;
	}
								   
    var foodBrickArray = this._tankObj.Store_Items['tank_foodBrickArray']; 
    i=0;
    for(var objectId in foodBrickArray)
    {
        var modelFoodBrick = new TankFoodBrick(foodBrickArray[objectId]);
        //modelFoodBrick._foodBrickObj=foodBrickArray[objectId];
        this._allFoodBricks[i]=modelFoodBrick;
        i++;
    }							   
},
							
   loveFish: function()
   {
	   var lastLoveTime = this._tankObj.lastLoved;
	   var currentDate = TFGameState.getServerTime();
									   
	   if(currentDate-lastLoveTime > TF_LOVE_TIME_DIFF)
	   {

		   var myUser = TFGameState.getCurrentUser();
		   myUser.updateCurrency(kOperationType.kOperationAddCoins, TF_Love_BONUS_COINS);
		   myUser.updateXPandLevel(TF_Love_BONUS_XP);
		   
		   this._tankObj.lastLoved=currentDate;
		   
		   DatabaseInterface.updateUser();
		   DatabaseInterface.updateTank();
		   
		   return true;
	   }
	   return false;
	},
  // getHungeeryFishCount : function()
//   {
//	   var totalFishCount = fishArray.length;
//	   var hungryFishCount = 0;
//	   for (var i = 0; i < totalFishCount; i++)
//	   {
//		   var fish1 = fishArray[i];
//		   if(fish1.isHungry())
//		   {
//			   hungryFishCount++;
//		   }
//	   }
//	   
//	   return hungryFishCount;						   
//   },
   updateTankHappiness: function() {
   
	   //*******************************************								   
	   var fishArray = this._allFish;
	 //  console.log('fish model' +fish.fishName);
	   var totalFishCount = fishArray.length;
	   var hungryFishCount = 0;
	   for (var i = 0; i < totalFishCount; i++)
	   {
		   var fish1 = fishArray[i];
		   if(fish1.isHungry())
		   {
			   hungryFishCount++;
		   }
	   }
	    var fedPercentage=0;
	   if(totalFishCount>0)
	   {
		   fedPercentage = 100 - (hungryFishCount / totalFishCount ) * 100;
		   fedPercentage = TF_POINTS_FISH_HUNGER * ( fedPercentage / 100 );
		   if ( fedPercentage > TF_POINTS_FISH_HUNGER )
		   {
			   fedPercentage = TF_POINTS_FISH_HUNGER;
		   }
		   // fedPercentage = 100;
		   //*******************************************
	   }
	   
	   var cleanPercentage = 75.0 - this.updateTankAlgae();
	   cleanPercentage = TF_POINTS_TANK_CLEAN * ( cleanPercentage / 75.0);
	   if ( cleanPercentage > 34 )
		   cleanPercentage = TF_POINTS_TANK_CLEAN;
	   //*******************************************								   
	   
	   var decorationHappiness = 0;
	   var decoArray = this._allDecorations;
	   var totalDecoCount = decoArray.length;
	   for (var i = 0; i < totalDecoCount; i++)
	   {
		   var deco1 = decoArray[i];
		   var storeDeco=deco1.getStoreObject();
		   decorationHappiness += storeDeco.custom_attributes.happiness;
		   //if fish hungry ++ hungryFishCount
	   }
	   
	   if ( decorationHappiness > TF_POINTS_DECORATIONS )
		   decorationHappiness = TF_POINTS_DECORATIONS;
	   
	   //*******************************************								   
	   
	   var plantsHappiness = 0;
	   var plantArray = this._allPlants;// TODO: use plant array
	   var totalPlantCount = plantArray.length;
	   for (var i = 0; i < totalPlantCount; i++)
	   {
		   var plant = plantArray[i];
		   var storeplant=plant.getStoreObject();
		   plantsHappiness += storeplant.custom_attributes.happiness;
	   }
	   if ( plantsHappiness > TF_POINTS_PLANTS )
	   plantsHappiness = TF_POINTS_PLANTS;	
	   
	   //*******************************************	
	   var backgroundPoints = 0;
	   var backgroundList=TFGameState.getCurrentUser()._userBackgrounds.length;
	   if( backgroundList.length > 1 )
	   backgroundPoints = TF_POINTS_BACKGROUND;
	   //*******************************************	
	   var lovePoints = 0;
	   if ( !this.fishNeedLove() )
		   lovePoints = TF_POINTS_LOVE;
	   //*******************************************	

	   var  totalHappiness = fedPercentage + cleanPercentage + decorationHappiness + plantsHappiness + backgroundPoints + lovePoints;
	 //  totalHappiness=90;//TODO: dont harcode
	   
	   this._tankObj.happiness = Math.round(totalHappiness);
	   DatabaseInterface.updateTank();
	   return this._tankObj.happiness;
   },
   
   updateTankAlgae: function()
   {
	   var currentTime = TFGameState.getServerTime();
	   var lastTimeCleaned = this._tankObj.lastCleaned;
	   var algae = 0;
	   
	   var algaeInOneSecond = ( 75 / (36 * 60.0 * 60.0) ); // TF_TOTAL_ALGAE = 75; TF_TOTAL_ALGAE_TIME = 36
	   
	   var difference = currentTime - lastTimeCleaned;
	   
	//[TFLog logWithLevel:LOG_DEBUG format:@"Difference is %f",difference];
	   
	   algae = ( difference * algaeInOneSecond );
	   
	   if ( algae >= 74.99 )
		   algae = 75.0;
	   
	   this.currentAlgae = algae;
	   
	   return this.currentAlgae;
	   
   },
   
   fishNeedLove: function()
   {
	   var lastLoveTime = this._tankObj.lastLoved;
	   var currentDate = TFGameState.getServerTime();
	   
	   if(currentDate-lastLoveTime > TF_LOVE_TIME_DIFF)
	   {
		return true;
	   }
		return false;
   },
								 
	
	getAllAdultFishCount: function()
	{
		var count=0;
		var fishArray = this._allFish;
		var totalFishCount = fishArray.length;
		for (var i = 0; i < totalFishCount; i++)
		{
		   var fish1 = fishArray[i];
		   if(fish1.isAlive() && fish1.isAdult())
		   {
			   
			   count++;
		   }
	   }
		return count;
	},
	
	getAllAdultFishPrice: function()
	{
		var price=0;
		var fishArray = this._allFish;
		var totalFishCount = fishArray.length;
		for (var i = 0; i < totalFishCount; i++)
		{
			var fish1 = fishArray[i];
				if(fish1.isAlive() && fish1.isAdult())
				{
					price += fish1.getAdultPrice();
				}
		   }
		price=Math.round(price);								   
		return price;
	},

	getAllAdultFishPriceWithHappinessAndTax: function()
	{
		var sellPrice = this.getAllAdultFishPrice() ;
		var happiness = this.updateTankHappiness() ;
		if ( happiness >= 80 && happiness <=89 )
			sellPrice += ( sellPrice * 0.10 );
		if ( happiness >= 90 )
			sellPrice += ( sellPrice * 0.20 );
		sellPrice = (sellPrice * 0.85);
	    sellPrice=Math.round(sellPrice);								   
		return sellPrice;
	},


	getAllDeadFishCount: function()
	{
		var count=0;
		var fishArray = this._allFish;
		var totalFishCount = fishArray.length;
		for (var i = 0; i < totalFishCount; i++)
		{
			var fish1 = fishArray[i];
			if(!fish1.isAlive())
			{
				count++;
			}
		}
		return count;
	},

	sellAllFish: function()
	{
	
		var totalAdultFishCount = this.getAllAdultFishCount() ;
		if(totalAdultFishCount > 0)
		{
			var totalCoinsToAdd = this.getAllAdultFishPriceWithHappinessAndTax() ;
			var totalXPToAdd = 2*totalAdultFishCount;
			
			var fishArray = this._allFish;
			var totalFishCount = fishArray.length;
			for (var i = 0; i < fishArray.length; i++)
			{
				var fish1 = fishArray[i];
				if ( fish1.isAdult() && fish1.isAlive() ) 
				{ 
				   this.sellFish(fish1._fishObj.objectId , true);
				   i--;
				}
				
			}
			var myUser = TFGameState.getCurrentUser();
			myUser.updateCurrency(kOperationType.kOperationAddCoins, totalCoinsToAdd);
			myUser.updateXPandLevel(totalXPToAdd);
			DatabaseInterface.updateUser();
			DatabaseInterface.updateTank();
			GameLayer.getControlLayer().getControlLayerAbove().updateTopPanel();

		}
	},


	 deleteFish: function(fishModel)
	 {
		 var fishKey = fishModel._fishObj.objectId.toString();
		 var index=this._allFish.indexOf(fishModel);
		 this._allFish.splice(index,1);
		 fishModel.destroy();
	 },
								   
								   
	sellFish: function(objID,isBulkSell)
	{
		var fishArray = this._allFish;
		var totalFishCount = fishArray.length;
		for(var i=0 ; i<totalFishCount ; i++)
		{
			var fish1 = fishArray[i];
			if(fish1._fishObj.objectId == objID){
				if(!isBulkSell)
				{
					var totalCoinsToAdd = fish1.getCurrentSellPrice() ;
					var totalXPToAdd = 2;
					var happiness = this.updateTankHappiness() ;
					
					if ( happiness >= 80 && happiness <=89 )
						totalCoinsToAdd += ( totalCoinsToAdd * 0.10 );
					if ( happiness >= 90 )
						totalCoinsToAdd += ( totalCoinsToAdd * 0.20 );
					totalCoinsToAdd=Math.round(totalCoinsToAdd);
					
					var myUser = TFGameState.getCurrentUser();
					myUser.updateCurrency(kOperationType.kOperationAddCoins, totalCoinsToAdd);
					myUser.updateXPandLevel(totalXPToAdd);
					DatabaseInterface.updateUser();
					
				}
				
				var fishKey = fish1._fishObj.objectId.toString();
				delete this._tankObj.Store_Items['tank_fishArray'][fishKey];
				fishArray.splice(i,1);
				fish1.destroy();
				break;
			}
		}
		DatabaseInterface.updateTank();
		GameLayer.getControlLayer().getControlLayerAbove().updateTopPanel();
		//TODO: write update top panel call
		
	},
	sellDecoration:function(decorationObjectId)
	{
		var decorationArray = this._allDecorations;
		var totalDecorationCount = decorationArray.length;
		
		for(var i=0 ; i<totalDecorationCount ; i++)
		{
			
			var decoration = decorationArray[i];
			if(decoration._decorationObj.objectId == decorationObjectId)
			{
				var storeId = decoration._decorationObj.storeId;
				var storeDeco = GAGameLoader.getStoreHandler().getStoreObjectForKey(storeId);
				
				var sellPrices = GACommonUtils.getSellPrice(storeDeco);
				var price = StoreUtil.getPrice(sellPrices);
				var currency = StoreUtil.getCurrency(sellPrices);
				
				var totalXPToAdd = 2;
				
				var myUser = TFGameState.getCurrentUser();
				
				if(currency == TF_COINS)
				{
					myUser.updateCurrency(kOperationType.kOperationAddCoins, price);
				}
				else
				{
					myUser.updateCurrency(kOperationType.kOperationAddBucks, price);
				}

				myUser.updateXPandLevel(totalXPToAdd);
				DatabaseInterface.updateUser();
				
				var decorationKey = decoration._decorationObj.objectId.toString();
				delete this._tankObj.Store_Items['tank_decorationArray'][decorationKey];
				decorationArray.splice(i,1);
				break;
			}
		}
		this.updateTank();
		GameLayer.getControlLayer().getControlLayerAbove().updateTopPanel();
	},

								  
/*	addHabitatForStoreIdAndMessage:function(store_id , message) {
		//console.log("Store Id "+store_id);
		if(store_id != null) {
			var user = TZGameState.getCurrentUser();
			var zoo = user.getSelectedZoo();
			
			var storeHabitat = GAGameLoader.getStoreHandler().getStoreObjectForKey(store_id);
			message = user.deductCurrencyForStoreItem(storeHabitat);
			//TODO: will set message value accordingly
			
			var samplehabitat = DatabaseInterface.getHabitatSample();
			var habitat = new ZooHabitat();
			habitat._habitatObj = samplehabitat;
			habitat.setStoreId(store_id);
			habitat.setZooId(zoo.getZooId());
			habitat.setLastCollected(TZGameState.getServerTime());
			habitat.setPosition(new Core.Vector(10,10));
			DatabaseInterface.addHabitat(habitat._habitatObj);
			
			if(!this._allHabitats) {
				this._allHabitats = new Array();
			}
			this._allHabitats[this._allHabitats.length] = habitat;
			
			return habitat;
		}
		return null;
*/
		
	//********************Database persistance********************/
	
	addDecorationInDatabase: function(newDecoration,isPurchased)
	{
		var storeID=newDecoration._decorationObj.storeId;
		var storeDecoration = GAGameLoader.getStoreHandler().getStoreObjectForKey(storeID);
		
		var isPurchasable=false;
		if(!isPurchased){
			isPurchasable= TFGameState.getCurrentUser().deductCurrencyForStoreItem(storeDecoration);
		}
		if(isPurchasable || isPurchased){
			newDecoration.updateDatabaseId(this._tankObj);
			this._tankObj.Store_Items['tank_decorationArray'][newDecoration._decorationObj.objectId.toString()] = newDecoration._decorationObj;
			this._allDecorations[this._allDecorations.length] = newDecoration;
			this._tankObj.decorationId++;
			this.updateTank();
			return true;
		}
		return false;
	},
								   
					   
	addShowerInDatabase: function(storeID)
	{
		console.log(">>addShower in Database");
		var isPurchasable = false;
		var user = TFGameState.getCurrentUser();
		var storeShower = GAGameLoader.getStoreHandler().getStoreObjectForKey(storeID);
	
		if(user.isShowerPurchased(storeID))
		{
			isPurchasable = true;
		}
		else
		{
		isPurchasable = TFGameState.getCurrentUser().deductCurrencyForStoreItem(storeShower);
		}
		if(isPurchasable)
		{
			user._userObj.userShowerList[user._userObj.userShowerList.length.toString()] = storeID;
			this._tankObj.showerId = storeID;
			this.updateTank();
			DatabaseInterface.updateUser();
			return true;
		}
		return false;
	},
	setShowerEnabled: function(isEnableBool)
	{
		this._tankObj.isShowerEnabled = isEnableBool;
		DatabaseInterface.updateTank();
		DatabaseInterface.updateUser();
	},
	setShowerEnabledAll: function(isEnableBool)
	{
		var myUser = TFGameState.getCurrentUser();
		myUser._userObj.isMasterShowerEnabled = isEnableBool;
		this._tankObj.isShowerEnabled = isEnableBool;
		
		DatabaseInterface.updateTank();
		DatabaseInterface.updateUser();
	},
								   
	getShowerEnabled: function()
	{
		return this._tankObj.isShowerEnabled;
	},
	
	addFish:function(newFish,isPurchased)
	{

		var storeID=newFish._fishObj.storeId;
		var storeFish = GAGameLoader.getStoreHandler().getStoreObjectForKey(storeID);
	    var isPurchasable=false;
	    if(!isPurchased){
		 	isPurchasable= TFGameState.getCurrentUser().deductCurrencyForStoreItem(storeFish);
	    }
		if(isPurchasable || isPurchased)
		{
			newFish._fishObj.objectId = this._tankObj.fishId;
			this._tankObj.Store_Items['tank_fishArray'][newFish._fishObj.objectId.toString()] = newFish._fishObj;
			this._allFish[this._allFish.length] = newFish;
			this._tankObj.fishId++;
			this.updateTank();
			return true;
		}
		return false;

	},

	addPlantInDatabase: function(newPlant,isPurchased)
	{
		
		var storeID=newPlant._plantObj.storeId;
		var storePlant = GAGameLoader.getStoreHandler().getStoreObjectForKey(storeID);
		
		var isPurchasable=false;
		if(!isPurchased){
			isPurchasable= TFGameState.getCurrentUser().deductCurrencyForStoreItem(storePlant);
		}
		if(isPurchasable || isPurchased){
			newPlant.updateDatabaseId(this._tankObj);
			this._tankObj.Store_Items['tank_plantArray'][newPlant._plantObj.objectId.toString()] = newPlant._plantObj;
			this._allPlants[this._allPlants.length] = newPlant;
			this._tankObj.plantId++;
			this.updateTank();
			return true;
		}
		return false;
		
								   
//		newPlant.updateDatabaseId(this._tankObj);
//		this._tankObj.Store_Items['tank_plantArray'][newPlant._plantObj.objectId.toString()] = newPlant._plantObj;
//		this._allPlants[this._allPlants.length] = newPlant;
//		this._tankObj.plantId++;
//
//		this.updateTank();
	},
	
    addFoodBrickInDatabase: function(newFoodBrick,isPurchased)
	{
		var storeID=newFoodBrick._foodBrickObj.storeId;
		var storeFoodBrick = GAGameLoader.getStoreHandler().getStoreObjectForKey(storeID);
								   
		var isPurchasable= TFGameState.getCurrentUser().deductCurrencyForStoreItem(storeFoodBrick);
		if(isPurchased || isPurchasable)
		{
			newFoodBrick.updateDatabaseId(this._tankObj);
			this._tankObj.Store_Items['tank_foodBrickArray'][newFoodBrick._foodBrickObj.objectId.toString()] = newFoodBrick._foodBrickObj;
			this._allFoodBricks[this._allFoodBricks.length] = newFoodBrick;
			this._tankObj.foodBrickId++;
			this.updateTank();
			return true;
		}
		return false;
	},
  
	addToDatabase: function(storeId)
   {
	   var isTankBought = TFGameState.isBackgroundAlreadyBought(storeId) ;
	   
	   
	   //if(!isTankBought)
	   {
		   this._tankObj.backgroundStoreID = storeId;
		   this.updateTank();
	   }

   },
								   
	removeFoodBrick : function(objectId)
	{	
		var foodBrickKey = objectId.toString();
		delete this._tankObj.Store_Items['tank_foodBrickArray'][foodBrickKey];
		this._allFoodBricks.splice(0,1);
		this.updateTank();
	},
								   
	sellPlant:function(objectId)
	{
		
		var plantArray = this._allPlants;
		var totalPlantCount = plantArray.length;
		for(var i=0 ; i<totalPlantCount ; i++)
		{
			var plant = plantArray[i];
			if(plant._plantObj.objectId == objectId)
			{	
				var storeId = plant._plantObj.storeId;
				var storePlant = GAGameLoader.getStoreHandler().getStoreObjectForKey(storeId);
				
				var sellPrices = GACommonUtils.getSellPrice(storePlant);
				var price = StoreUtil.getPrice(sellPrices);
				var currency = StoreUtil.getCurrency(sellPrices);
			
				var totalXPToAdd = 2;
					
				var myUser = TFGameState.getCurrentUser();
				
				if(currency == TF_COINS)
				{
					myUser.updateCurrency(kOperationType.kOperationAddCoins, price);
				}
				else
				{
					myUser.updateCurrency(kOperationType.kOperationAddBucks, price);
				}
				
			
				myUser.updateXPandLevel(totalXPToAdd);
				DatabaseInterface.updateUser();
					
				var plantKey = plant._plantObj.objectId.toString();
				delete this._tankObj.Store_Items['tank_plantArray'][plantKey];
				plantArray.splice(i,1);
				break;
			}
		}
		this.updateTank();
		GameLayer.getControlLayer().getControlLayerAbove().updateTopPanel();
	},
	
	updateTank: function()
	{
		DatabaseInterface.updateTank();
	},
	
	// *** Inventory Functions *** //
	moveDecorationToInventory:function(objectId)
	{
		var decorationArray = this._allDecorations;
		
		var inventoryDict = TFGameState.getCurrentUser()._inventoryDict;
		
		for(var i = 0; i < decorationArray.length; i++)
		{
			var decoration = decorationArray[i];
			if(decoration._decorationObj.objectId == objectId)
			{	
				var storeId = decoration._decorationObj.storeId;
				
				var decorArr = inventoryDict.objectForKey(storeId);
				if(!decorArr)
				{
					decorArr = new GAMutableArray();
					decorArr.addObject(decoration._decorationObj);
					inventoryDict.setObject(storeId,decorArr);
				}
				else
				{
					decorArr.addObject(decoration._decorationObj);
				}
				
				var objectId = decoration._decorationObj.objectId;
								   
				TFGameState.getCurrentUser().addToInventory(decoration._decorationObj);
				
				var decorationKey = objectId.toString();
				delete this._tankObj.Store_Items['tank_decorationArray'][decorationKey];
				decorationArray.splice(i,1);
				
				break;
			}
		}
		
		this.updateTank();
		
	},
	///Ahsan started
	updateFishFed:function(feedTime)
	{
		var fishArray = this._allFish;
	
		
		//var inventoryDict = TFGameState.getCurrentUser()._inventoryDict;
		
		for(var i = 0; i < fishArray.length; i++)
		{
			var fish = fishArray[i];	   
				var lastFed = fish._fishObj.lastFed;
		//					fish.updateLastFed();
				fish.updateLastFedToTime(feedTime);
			}
		
	
		this.updateTank();
		DatabaseInterface.updateUser();
	},
	///Ahsan ended
	
	moveFishToInventory:function(objectId)
	{
		var fishArray = this._allFish;
	
		var inventoryDict = TFGameState.getCurrentUser()._inventoryDict;
		
		for(var i = 0; i < fishArray.length; i++)
		{
			var fish = fishArray[i];
			
			if(fish._fishObj.objectId == objectId)
			{	
				var storeId = fish._fishObj.storeId;
				fish._fishObj.inventoryCreated = TFGameState.getServerTime();
								   
				var lastFed = fish._fishObj.lastFed;
				var currentTime = TFGameState.getServerTime();
				
				if(lastFed > currentTime)
				{
					fish.updateLastFed();
				}
								   
				var fishArr = inventoryDict.objectForKey(storeId);
				if(!fishArr)
				{	
					fishArr = new GAMutableArray();
					fishArr.addObject(fish._fishObj);
					inventoryDict.setObject(storeId,fishArr);
				}
				else
				{
					fishArr.addObject(fish._fishObj);
				}
			
				var objectId = fish._fishObj.objectId;
			
				TFGameState.getCurrentUser().addToInventory(fish._fishObj);
			
				var fishKey = objectId.toString();
				delete this._tankObj.Store_Items['tank_fishArray'][fishKey];
				fishArray.splice(i,1);
			
				break;
			}
		}
	
		this.updateTank();
	
	},

	movePlantToInventory:function(objectId)
	{
		var plantArray = this._allPlants;
	
		var inventoryDict = TFGameState.getCurrentUser()._inventoryDict;
	
		for(var i = 0; i < plantArray.length; i++)
		{	
			var plant = plantArray[i];
			if(plant._plantObj.objectId == objectId)
			{	
				var storeId = plant._plantObj.storeId;
			
				var plantArr = inventoryDict.objectForKey(storeId);
				if(!plantArr)
				{	
					plantArr = new GAMutableArray();
					plantArr.addObject(plant._plantObj);
					inventoryDict.setObject(storeId,plantArr);
				}
				else
				{
					plantArr.addObject(plant._plantObj);
				}
			
				var objectId = plant._plantObj.objectId;
				TFGameState.getCurrentUser().addToInventory(plant._plantObj);
				var plantKey = objectId.toString();
				delete this._tankObj.Store_Items['tank_plantArray'][plantKey];
				plantArray.splice(i,1);
			
				break;
			}
		}
	
		this.updateTank();
	
	},

	
	updateTankLastCleaned:function()
	{
		this.currentAlgae = 0;
		var currentTime = TFGameState.getServerTime();
		this._tankObj.lastCleaned = currentTime;
		this.updateTank();
	},
	
	updateTankLastCleanedToTime:function(time)
	{
		this.currentAlgae = 0;
		//var currentTime = TFGameState.getServerTime();
		this._tankObj.lastCleaned = time;
		this.updateTank();
	},
	
	updateTankLastRevivedToTime:function(time)
	{
		this._tankObj.lastRevived = time;
		this.updateTank();
	},
	
/*-(float) updateTankLastCleaned {
	[[GameState sharedState].currentUser getSelectedTank].currentAlgae = 0;
	NSTimeInterval currentTime = [[[GameState sharedState] getServerTime] timeIntervalSince1970];
	[[GameState sharedState].currentUser getSelectedTank].lastCleaned = currentTime;
	return [[DatabaseInterface sharedInterface] updateTankLastCleaned:tankId andTime:currentTime];
}
*/	
	
//********************Destroy********************//
	
	clearArray: function (array) {
		if(array == null)
			return;
		for(var i=0 ;i < array.length;i++) {
			var obj = array[i];
			if(obj != null) {
				obj.destroy();
				obj = null;
				array.splice(i,1);
				--i;
			}
		}
		delete array;
		array = null;
	},
	
	destroy:function() {
		this.clearArray(this._allFish);
    	this.clearArray(this._allDecorations);
    	this.clearArray(this._allBackgrounds);
    	this.clearArray(this._allPlants);
    	this.clearArray(this._allFoodBricks);
    	
		delete this._tankObj;
		this._tankObj = null;
	}
					   
					   
	
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/ModelClasses/TankFish'] = function(){var exports = $MODULE_REGISTRY['Code/ModelClasses/TankFish'] || {}; $MODULE_REGISTRY['Code/ModelClasses/TankFish'] = exports; exports.TankFish = Core.Class.subclass(
{
    classname: 'TankFish',
	initialize: function(fishObj) 
	{
		//this.ALGAE_EATER_CATEGORY_ID = 7;
		if(fishObj)
		{
			this._fishObj = fishObj;
			if(this._fishObj.lastFed <=0 || this._fishObj.created_time <= 0) {
				this._fishObj.lastFed = TFGameState.getServerTime()-24*61*60;
				this._fishObj.created_time = TFGameState.getServerTime();
			}
		}
		else
		{
			this._fishObj = {"objectId": 0, "storeId":0, "tankId":0, "fishType":0, "fishName":"", "created_time":0, "lastFed":0,"inventoryCreated":0}; // JSON Object
		}
		
		
			
	},
	
	getStoreId: function(){
		
		var storeId = this._fishObj.storeId;
		//console.log("Category Id " + categoryId[1]);
		return storeId;
	},

   
	
	getCategoryId: function(){
	
		var categoryId = this._fishObj.storeId.split("_");
		//console.log("Category Id " + categoryId[1]);
		return categoryId[1];
	},
	
	getFishName: function()
	{

	   if(this._fishObj.fishName)
	   {
		   return this._fishObj.fishName;
	   }
	   else
	   {
			var storeFish =GAGameLoader.getStoreHandler().getStoreObjectForKey(this._fishObj.storeId);
			return storeFish.name;
	   }

	},
	setFishName : function(fishName)
	{
	   this._fishObj.fishName=fishName;
	   DatabaseInterface.updateTank();
	},
							
	getCurrentAge : function()
	{
		var currentDate = TFGameState.getServerTime();
		var difference = currentDate - this._fishObj.created_time;
		return difference;
	},
									   
	updateLastFed : function()
	{
		
	   // var selectedTank=TFGameState.getCurrentUser()._tankObj;
		//selectedTank.updateLastFedForFish(this._fishObj.objectId);
		
		var currentTime = TFGameState.getServerTime();
		this._fishObj.lastFed=currentTime;
		DatabaseInterface.updateTank();
		
	},

	updateLastFedToTime :function(newTime)
	{	
		this._fishObj.lastFed = newTime;
		DatabaseInterface.updateTank();
	},
	
	getCurrentAgePercentage : function()
	{
		var createdTime = this._fishObj.created_time;
		var isAlive = this.isAlive();
		if(!isAlive)
		{
			createdTime = createdTime - (this._fishObj.lastFed - this._fishObj.created_time) + 2*24*60*60;
		}
		var currentTime = TFGameState.getServerTime();
		var difference = currentTime - createdTime;
		//console.log("difference " +difference);
		var fullAge = GAGameLoader.getStoreHandler().getStoreObjectForKey(this._fishObj.storeId).custom_attributes.timetoadulthood*60*60;
								
		//console.log("fullAge " +fullAge);
		var percentage = (difference / fullAge) * 100;
		if(percentage < 0)
		{
			percentage = 0;
		}
		if (percentage > 100)
		{
			percentage = 100;
		}
		//console.log("GT:percentage" +percentage);
	    return percentage;
	},
	
	getCurrentHunger : function()
	{
		var percentage = 0;
		if(ALGAE_EATER_CATEGORY_ID != this.getCategoryId()){
			
			var lastFedTime = this._fishObj.lastFed;
			var currentTime = TFGameState.getServerTime();
			var difference = (currentTime - lastFedTime)/60;
			percentage = (difference/2880)*100; // TF_TOTAL_HUNGER_TIME = 2880;
			if(percentage<0)
			{
				percentage=0;
			}
			if(percentage>100)
			{
				percentage=100;
			}
			
		}
		return  percentage;
	},
	
	getAdultAge : function()
	{
		var storeFish = GAGameLoader.getStoreHandler().getStoreObjectForKey(this._fishObj.storeId);
		//console.log('storefish adult age ' +storeFish.custom_attributes.timetoadulthood*60);							   
		return storeFish.custom_attributes.timetoadulthood*60; 
									   
	},
	
	isFishBreedable : function()
	{

	   var storeFish = GAGameLoader.getStoreHandler().getStoreObjectForKey(this._fishObj.storeId);
	   return storeFish.custom_attributes.canbebreeded; 					   
	   
	},
	
	getAdultPrice : function()
	{
		//console.log('My store id is '+this._fishObj.storeId);
		var storeFish =GAGameLoader.getStoreHandler().getStoreObjectForKey(this._fishObj.storeId);
		var sellPrices = GACommonUtils.getSellPrice(storeFish);
     	var price = StoreUtil.getPrice(sellPrices);
		//console.log('storefish adult price ' +price);
		return price; 
	},

	getCurrentSellPrice : function()
	{
		console.log("in getCurrentPrice");							   
		var storeFish = GAGameLoader.getStoreHandler().getStoreObjectForKey(this._fishObj.storeId);
		var currentAgeInPercentAge = this.getCurrentAgePercentage();
	    var price=(this.getAdultPrice() * currentAgeInPercentAge)/100;
	    price=Math.ceil(price);
	    return price;
	},
	
	isHungry : function()	
	{
		if(ALGAE_EATER_CATEGORY_ID != this.getCategoryId()){
			
			var hungerLevel = this.getCurrentHunger();
			hungerLevel = (hungerLevel*2880)/100;
			var age = this.getAdultAge();
			if((hungerLevel/60) > 12)
			{
				return true;
			}
			if(hungerLevel > (age/2))
			{
				return true;
			}

		}

	return false;
		
	},

	isLittleHungry : function()
	{
		if(ALGAE_EATER_CATEGORY_ID != this.getCategoryId()){
			
			var hungerLevel = this.getCurrentHunger();
			hungerLevel = (hungerLevel*2880)/100;
			var age = this.getAdultAge();
			
			if((hungerLevel/60) > 6)
			{
				return true;
			}
			if(hungerLevel > (age/4))
			{
				return true;
			}

		}

	return false;

	},
	
	isAlive : function()
	{
		if(TFGameState.atNeighbor == true && TFGameState.isFriend == false)
		{
				return true;
		}
		else if(this.getCurrentHunger() >= 100)
		{
			return false;
		}
		else
			{
			
			//this.revive();
			}
		return true;
	},

	isAdult : function() 
	{

	//	return true;
		if ( this.getCurrentAgePercentage() >= 100 )
		{
			return true;
		}
		return false;
	},
   revive: function()
   {
	   var currentTime = TFGameState.getServerTime();
	   var newCreated = currentTime - ( ( this._fishObj.lastFed - this._fishObj.created_time ) + 2*24*60*60 );
	   this._fishObj.lastFed=currentTime;
	   this._fishObj.created_time=newCreated;
	   DatabaseInterface.updateTank();
   },
    
    	updateFishCreationTime : function()
	{
		var createdTime = this._fishObj.created_time;
		var storeFish = GAGameLoader.getStoreHandler().getStoreObjectForKey(this._fishObj.storeId);
		var adultAge = storeFish.custom_attributes.timetoadulthood * 3600;
		var dateToAdult = adultAge+createdTime;
		var currentTime = TFGameState.getServerTime();
		var difference = dateToAdult - currentTime;
		createdTime = createdTime - difference;
		this._fishObj.created_time = createdTime;
		DatabaseInterface.updateTank();
	},

	
	destroy: function()
	{
		//Wasay Start MM
		console.log('>< In fish model destroy');
		//delete this._fishObj;
		//this._fishObj = null;
	},
	
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/ModelClasses/TankDecoration'] = function(){var exports = $MODULE_REGISTRY['Code/ModelClasses/TankDecoration'] || {}; $MODULE_REGISTRY['Code/ModelClasses/TankDecoration'] = exports; exports.TankDecoration = Core.Class.subclass(
{
	classname: 'TankDecoration',
	initialize: function(decorationObj) 
	{
		if(decorationObj)
		{
			this._decorationObj = decorationObj;
		}
		else
		{
			this._decorationObj = {"objectId": 0, "positionX":0,"positionY":0,"isFlipped":1,"z_index":0}; // JSON Object
		}

	},
	 getSellPrice : function()
	 {
		 //console.log('My store id is '+this._fishObj.storeId);
		 var storeDecor =GAGameLoader.getStoreHandler().getStoreObjectForKey(this._decorationObj.storeId);
		 var sellPrices = GACommonUtils.getSellPrice(storeDecor);
		 var price = StoreUtil.getPrice(sellPrices);
		 //console.log('storefish adult price ' +price);
		 return price; 
	 },
											 
	getBasePathForResourceType:function(resourceType) 
	{
		var storeDecor = this.getStoreObject();
		var resource = GAResourceUtils.getResourceOfType(storeDecor, resourceType);
		var basePath = GAResourceUtils.getResourceSavePath(storeDecor, resource);
		return basePath;
	},  
	
	getPositionVector: function()
	{ 
		var storeDeco = GAGameLoader.getStoreHandler().getStoreObjectForKey(this._decorationObj.storeId);
		var _width = storeDeco.custom_attributes.size_width;
		var _heigth = storeDeco.custom_attributes.size_height;
		var SCREEN_HEIGHT = Core.Capabilities.getScreenWidth();
		var SCREEN_WIDTH = Core.Capabilities.getScreenHeight();
		if (this._decorationObj.positionX > (_width)/2 &&  this._decorationObj.positionX < SCREEN_WIDTH - (_width)/2  
				&& this._decorationObj.positionY > (_heigth)/2 && this._decorationObj.positionY < SCREEN_HEIGHT - (_heigth)/2){
			
			return new Core.Vector(this._decorationObj.positionX,this._decorationObj.positionY);
		} else {
			if(!this._decorationObj.positionX == 0){
				this._decorationObj.positionX = SCREEN_WIDTH/2;
			} else if(!this._decorationObj.positionX < SCREEN_WIDTH - (_width)/2){
				this._decorationObj.positionX = SCREEN_WIDTH - (_width)/2;
			}else if (!this._decorationObj.positionX > (_width)/2){
				this._decorationObj.positionX = _width;
			}
			
			if(!this._decorationObj.positionY < SCREEN_HEIGHT - (_heigth)/2){
				this._decorationObj.positionY = SCREEN_HEIGHT/2;
			}else if(!this._decorationObj.positionY < SCREEN_HEIGHT - (_heigth)/2){
				this._decorationObj.positionY = SCREEN_HEIGHT;
			}else if (!this._decorationObj.positionY > (_heigth)/2){
				this._decorationObj.positionY = _heigth;
			}
			
			
			
			return new Core.Vector(this._decorationObj.positionX,this._decorationObj.positionY);
		}
		
	},
	
	getStoreObject : function()
	{ 
		var storeDecor = GAGameLoader.getStoreHandler().getStoreObjectForKey(this._decorationObj.storeId);
		return storeDecor;
	},
	
	setPosition: function(newPosition,tankModel)
	{
			this._decorationObj.positionX = newPosition.getX();
			this._decorationObj.positionY = newPosition.getY();
			
			tankModel.updateTank();
	},

	setDecorationFlip:function(isDecorationFlipped,tankModel)
	{
		this._decorationObj.isFlipped = isDecorationFlipped;
		tankModel.updateTank();
	},
	
	getZIndex: function()
	{
		return this._decorationObj.z_index;
	},

	updateDatabaseId: function(tankObj)
	{
		this._decorationObj.objectId = tankObj.decorationId;
		console.log("THe decoration object Id : "+this._decorationObj.objectId);
	},

	destroy: function()
	{
		delete this._decorationObj;
	},
	
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/ModelClasses/TankBackground'] = function(){var exports = $MODULE_REGISTRY['Code/ModelClasses/TankBackground'] || {}; $MODULE_REGISTRY['Code/ModelClasses/TankBackground'] = exports; exports.TankBackground = Core.Class.subclass(
{
	classname: 'TankBackground',
	initialize: function(backgroundObj) 
	{
		if(backgroundObj)
		{
			this._backgroundObj = backgroundObj;
		}
		else
		{
			this._backgroundObj = {"storeId":0,"objectId":0}; // JSON Object
		}
	},
	
	addInDatabase: function()
	{
		TFGameState.getCurrentUser().addBackground(this._backgroundObj);
		GameLayer.getSelectedTank().tankModel.addToDatabase(this._backgroundObj.storeId);
											 
	},
	
	destroy: function()
	{
		delete this._backgroundObj;
	},
	
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/ModelClasses/TankPlant'] = function(){var exports = $MODULE_REGISTRY['Code/ModelClasses/TankPlant'] || {}; $MODULE_REGISTRY['Code/ModelClasses/TankPlant'] = exports; exports.TankPlant = Core.Class.subclass(
{
	classname: 'TankPlant',
	initialize: function(plantObj) 
	{
		if(plantObj)
		{
			this._plantObj = plantObj;
		}
		else
		{
			this._plantObj = {"objectId": 0, "storeId":0, "positionX":0,"positionY":0,"isFlipped":1,"z_index":0}; // JSON Object
		}
	},
	
	getBasePathForResourceType:function(resourceType) 
	{
		var storeDecor = this.getStoreObject();
		var resource = GAResourceUtils.getResourceOfType(storeDecor, resourceType);
		var basePath = GAResourceUtils.getResourceSavePath(storeDecor, resource);
		return basePath;
	},  
	getSellPrice : function()
	{
	//console.log('My store id is '+this._fishObj.storeId);
	var storePlant =GAGameLoader.getStoreHandler().getStoreObjectForKey(this._plantObj.storeId);
	var sellPrices = GACommonUtils.getSellPrice(storePlant);
	var price = StoreUtil.getPrice(sellPrices);
	//console.log('storefish adult price ' +price);
	return price; 
	},
										
	getPositionVector: function()
	{
		return new Core.Vector(this._plantObj.positionX,this._plantObj.positionY);
	},
	
	getStoreObject : function()
	{
		var storeDecor = GAGameLoader.getStoreHandler().getStoreObjectForKey(this._plantObj.storeId);
		return storeDecor;
	},
	
	setPosition: function(newPosition,tankModel)
	{
			this._plantObj.positionX = newPosition.getX();
			this._plantObj.positionY = newPosition.getY();
			
			tankModel.updateTank();
	},

	setPlantFlip:function(isPlantFlipped,tankModel)
	{
		this._plantObj.isFlipped = isPlantFlipped;
		tankModel.updateTank();
	},

	updateDatabaseId: function(tankObj)
	{
		this._plantObj.objectId = tankObj.plantId;
	},
	
	destroy: function()
	{
		delete this._plantObj;
	},
	
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/ModelClasses/TankFoodBrick'] = function(){var exports = $MODULE_REGISTRY['Code/ModelClasses/TankFoodBrick'] || {}; $MODULE_REGISTRY['Code/ModelClasses/TankFoodBrick'] = exports; exports.TankFoodBrick = Core.Class.subclass(
{
	classname: 'TankFoodBrick',
	initialize: function(foodbrickObj) 
	{
		if(foodbrickObj)
		{
			this._foodBrickObj = foodbrickObj;
		}
		else
		{
			this._foodBrickObj = {"objectId": 0, "storeId":0, "positionX":0,"positionY":0,"z_index":0, "created_time":0}; // JSON Object
		}
	},
	
	getBasePathForResourceType:function(resourceType) 
	{
		var storeFoodBrick = this.getStoreObject();
		var resource = GAResourceUtils.getResourceOfType(storeFoodBrick, resourceType);
		var basePath = GAResourceUtils.getResourceSavePath(storeFoodBrick, resource);
		return basePath;
	},  
	
	getPositionVector: function()
	{
											
		return new Core.Vector(this._foodBrickObj.positionX,this._foodBrickObj.positionY);
		
	},
	
	getStoreObject : function()
	{
		var storeFoodBrick = GAGameLoader.getStoreHandler().getStoreObjectForKey(this._foodBrickObj.storeId);
		return storeFoodBrick;
	},
	

	getTimeRemaining: function()
	{
	    var storeFoodBrick = GAGameLoader.getStoreHandler().getStoreObjectForKey(this._foodBrickObj.storeId);
		var startTime = this._foodBrickObj.created_time;
		var validTill = startTime + storeFoodBrick.custom_attributes.foodbricktime*60*60;
		//var currentTime = (new Date()).getTime() / 1000;
		var currentTime = TFGameState.getServerTime();
		var difference = (validTill - currentTime);
		return difference;
	},
	
   getTimePercentage: function()
   {
	   
	   var storeFoodBrick = GAGameLoader.getStoreHandler().getStoreObjectForKey(this._foodBrickObj.storeId);
	   var startTime = this._foodBrickObj.created_time;
       var validTill = startTime + storeFoodBrick.custom_attributes.foodbricktime*60*60;
	   var currentTime = TFGameState.getServerTime();
	   var difference = (validTill - currentTime)/60;
	   var percentageTime = difference/(storeFoodBrick.custom_attributes.foodbricktime*60);
	   return percentageTime;
   },
										
	setPosition: function(newPosition,tankModel)
	{
		this._foodBrickObj.positionX = newPosition.getX();
		this._foodBrickObj.positionY = newPosition.getY();
			
		tankModel.updateTank();
	},

	updateDatabaseId: function(tankObj)
	{
		this._foodBrickObj.objectId = tankObj.foodBrickId;
	},
	
	destroy: function()
	{
		delete this._foodBrickObj;
	},
	
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/gAPICommunicator/GAPICommunicator'] = function(){var exports = $MODULE_REGISTRY['Code/gAPICommunicator/GAPICommunicator'] || {}; $MODULE_REGISTRY['Code/gAPICommunicator/GAPICommunicator'] = exports; exports.GAPICommunicator = Core.Class.subclass({

	classname: 'GAPICommunicator',

	initialize: function() 
	{
		console.log('>> GAPICommunicator Intialize  ');		
		this._readCount = 0;
		this._userLevel = 1;
		this._experience = 0;
		this._offerCoins = 0;
		this._offerBucks = 0;
		this._purchasedCoins = 0;
		this._purchasedBucks = 0;
		this.gameStateType = null;
		this._tankArrayObj = null;
	    this.fileName = null;
		this._startGameConnect();
		
		
	},
	
	_startGameConnect:function(){
		
		console.log('>> _startGAmeConnect Exp2222222:'+this._experience+'Coins'+this._offerCoins);
		 this.fileName = ["User", "GameLevels","Breeding"];
		console.log(">> fileNames at the satrt of setcofigurations "+ this.fileName);
			//GAConfigurations.setGapiConfiguration("ngTF", 1.0, "ngTapFish", "GameView Studio", "https://ngtapfishservice.appspot.com/", "./Content/db", "./Content/textures",fileNames,level,experience,purchasedCurrency1,purchasedCurrency2,offersCurrency1,offersCurrency2)
		GAConfigurations.setGapiConfiguration("ngTF", TF_VERSION_NUMBER, "ngTapFish", "GameView Studio", "https://ngtapfishservice.appspot.com/", "./Content/db", "./Content/textures/Stores", this.fileName);
		GAGameLoader.setDelegate(this);
		GAGameLoader.startConnect();
	},										   
	
	readDataBase:function(path,readDBSuccessCB) {
		this.readDBSuccessCB = readDBSuccessCB;
		console.log('>> getPathCallback ');
		var files = ['User','GameLevels'];
		var length = files.length;
		for(var i=0; i<length; i++){
			var name = files[i];
			console.log('>> path '+path+'/'+name+'.json');								   
			Storage.FileSystem.readFile(path+'/'+name+'.json',this._dbReadCallback.bind(this,name,length));
		}
	},
	_dbReadCallback: function (name,totalFiles,error,contents){
				console.log('>> _dbReadCallback ');
		this._readCount ++;
		if(!error){
			console.log('>> noo error ');	
		    var data = eval('('+ contents +')');
			if(name == 'User'){
				console.log('>> in user if ');
				this._experience = data.exp;
				this._offerCoins = data.offerCoins;
				this._offerBucks = data.offerBucks;
				this._purchasedCoins = data.purchasedCoins;
				this._purchasedBucks = data.purchasedBucks;
				this._tankArrayObj  = data.tankArray;
				
			}
			else if(name == 'GameLevels'){console.log('>> in games level if ');
				var levels = data.levels;
				var totalLevels = levels.length;
				for( var i=0; i< totalLevels; i++){
					var levelObj = levels[i];
					if(this._experience >= levelObj.xp_min && this._experience <= levelObj.xp_max){
						this._userLevel = levelObj.level;
					}
				}
			}
											   
		}
											   
		if(this._readCount == totalFiles){
			console.log('>> _dbReadCallback Exp111111:---------------------'+this._experience+'Coins'+this._offerCoins);
			//this.readDBSuccessCB(this._userLevel,this._experience,this._purchasedCoins,this._purchasedBucks,this._offerCoins,this._offerBucks);
			var tankArray = new Array();
			var objId;
			for(objId in this._tankArrayObj)
				{
			 		var tankId = this._tankArrayObj[objId].tankId;
					tankArray.push("Tank"+tankId);
				}
				if(!TFGameState.socialFriends)
				{
					tankArray.push("SocialFriends");
					TFGameState.socialFriends = true;
				}
			console.log('>> _dbReadCallback  Tank Array:---------------------'+tankArray);
			this.readDBSuccessCB(this._userLevel,this._experience,this._purchasedCoins,this._purchasedBucks,this._offerCoins,this._offerBucks,tankArray);
		}
	},
	   updateFileNames: function(){
		   console.log('>> Resources  updateFileNames callback');
		   var path = GAConfigurations.getUserGameStateDBPath();
		   Storage.FileSystem.readFile(path+'/User.json',this._readUserCb.bind(this));
	   
	   },
	   _readUserCb: function(error, contents)
	   {
		   console.log('>>  Resources  readUserCb '+error);
	   
		   var data = eval('('+ contents +')');
		   console.log('>> check zoo array null');
		   var tankArray = new Array();
		   var objId;
			   for(objId in data.tankArray)
				   {
					   var tankId = data.tankArray[objId].tankId;
					   tankArray.push("Tank"+tankId);
				   }
		   console.log(">> _readUserCb for Get game state:---------------------  data.zooArray "+tankArray);
		   var filenames = this.fileName;//GAConfigurations.getDbFileNames();
		   filenames= filenames.concat(tankArray);
		   console.log('>> Name of resources to be set in Gapi are '+filenames);
		   filenames= filenames.concat('SocialFriends');
		   GAConfigurations.setDbFileNames(filenames);
	   
	   },
	   restartGame:function()
	   {
		   console.log(">> Please restart! Your gamestate on server has been updated from other place.");
		   //var alertDialog = new UI.AlertDialog();
		   //      alertDialog.setText("Please restart! Your gamestate on server has been updated from other place.");
		   //      alertDialog.show();
		   
		   var testUIAlert = new GAUIAlertView(/*Core.Localization.getString("Alert!")*/"",Core.Localization.getString("Please restart! Your gamestate on server has been updated from other device."),this,null,Core.Localization.getString("OK"));
		   testUIAlert.setType("ok");
		   testUIAlert.setMessageColor('FFFFFF');
		   testUIAlert.show();
	   },
		
	//////////////// End /////////////////////										   
																	
	startLoading: function()
	{
		//GAGameLoader.startConnect();
								
	},
	
	//gAPI start game delegates
	
	onSuccess: function() 
	{
		console.log('>>GAPI communicator connect success');
		GameCentralHandler.onConnectSuccess();
	},
	
	onFailure: function(errorCode) 
	{
		
		var message = Core.Localization.getString('TF_ConnectFailure');
		console.log(message);
		
		var message = Core.Localization.getString('TF_ResourceDownloadingFailed');
		var alertWindow =  new TFMiniUIAlertView("",message,this,/*Core.Localization.getString('TF_CANCEL_BUTTON')*/null,GALocalizationHandler.getLocalizedString('TF_RETRY_LABEL'));
		alertWindow.setTagValue(TF_GAPI_CONNECT_ERROR_TAG);
		alertWindow.setMessageColor("FFFFFF");
		alertWindow.setMessageFont(TFUtil.getFontName());
		alertWindow.setButtonsFont(TFUtil.getFontName());
		alertWindow.setButtonColor("FFFFFF");
		alertWindow.show();
	},
	
	showProgress :function(progressStatus) 
	{
		console.log('>>GAPI communicator progress '+progressStatus);
		if(progressStatus == kGAGameLoadLevel.kGAGameLoadLevelStoreParsingDone)
		{
			//this.onSuccess();
		}

			GameCentralHandler.showProgress(progressStatus,null);
	},

	sendSyncRequest: function(storeIdsArray)
	{
		this._resourceSyncHandlerObj = new GAResourceSyncHandler(storeIdsArray, this.resourceSyncHandlerSuccessful.bind(this), this.resourceSyncHandlerFailed.bind(this));
		this._resourceSyncHandlerObj.startLoading();
												   console.log('>>Resource Comitted done');
		//										   this.resourceSyncHandlerSuccessful();
												
												 
	},
	
	
	
	resourceSyncHandlerSuccessful:function () 
	{
		
		console.log('Resource synching done');
		
		this._resourceSyncHandlerObj.destroy();
		this._resourceSyncHandlerObj = null;
		
		GameCentralHandler.onSuccess();

	},
	
	resourceSyncHandlerFailed:function ()
	{
		
		var message = Core.Localization.getString('TF_ResourceDownloadingFailed');
		var alertWindow =  new TFMiniUIAlertView("",message,this,/*Core.Localization.getString('TF_CANCEL_BUTTON')*/null,GALocalizationHandler.getLocalizedString('TF_RETRY_LABEL'));
		alertWindow.setTagValue(TF_GAPI_SYNC_ERROR_TAG);
		alertWindow.setMessageColor("FFFFFF");
		alertWindow.setMessageFont(TFUtil.getFontName());
		alertWindow.setButtonsFont(TFUtil.getFontName());
		alertWindow.setButtonColor("FFFFFF");
		alertWindow.show();
	},
	
	clickedButtonAtIndex: function(buttonIndex,alertView)
	{
		console.log("GAPICommunicator->clickedButtonAtIndex button index"+buttonIndex );
		if (buttonIndex == 0) 
		{
			if(alertView.getTagValue() == TF_GAPI_SYNC_ERROR_TAG)
			{
				this._resourceSyncHandlerObj.retrySyncHandler();
			}
			if(alertView.getTagValue() == TF_GAPI_CONNECT_ERROR_TAG)
			{
				GAGameLoader.startConnect();
			}
		} 
		else if (buttonIndex == 1)
		{

			NgLogE("Cancel button clicked ... quitting the application.");
			//added code
			//GAGameLoader.destroy();
			
//			var LGL = require('../../NGCore/Client/Core/LocalGameList').LocalGameList;
//			LGL.runUpdatedGame('/Samples/Launcher');
//
//			this.addState(UI.State.Disabled);
			
//			var gLauncherUrl = Core.Capabilities.getStartingServer() + "/" + Core.Capabilities.getBootGame();
//            Core.LocalGameList.runGame(gLauncherUrl);
			
		}
		
	},
	
	 //********************GameStateHandlerStarts********************//
	
	//userId is the unique key of the user
	getGameState: function(type,userId)
	{
		this.gameStateType = type;
		if(type == kGameStateNeighbor)
		{
			//change the path
			if(userId)//friend
			{
				
			}
			else//random Neighbor
			{
				
			}
		}
		else if(type == kGameStateRestore)
		{
			if(userId)//super user
			{
				
			}
			else//restore own gamestate
			{
				
			}
		}
		
		//change the project path
	},
	
	getGameStateSuccess: function()
	{
		//sync resources for selected tank
	},
	
	getGameStateFailure: function()
	{
		//revert the path
	},
	
	//********************GameStateHandlerEnds********************//
	
	destroy: function()
	{
		
	},
	
	
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/GLLayer/TFControlLayerAbove'] = function(){var exports = $MODULE_REGISTRY['Code/GLLayer/TFControlLayerAbove'] || {}; $MODULE_REGISTRY['Code/GLLayer/TFControlLayerAbove'] = exports; 
exports.TFControlLayerAbove = Core.MessageListener.subclass(
{

	classname:'TFControlLayerAbove',
	initialize: function()
    {
															
		//GAAudioManager.setBGMusicPath(BACKGROUND_MUSIC_PATH);
		//added, initializing tick sound effect
		//GAAudioManager.setTickMusicPath(CLICK_SOUND_NAME1);
		//GAAudioManager.initializeSoundEffect();
															
       	//variables
       	this._enableButtons = true;
       	this._coins=0;
       	this._bucks=0;
       	this._xp="0/0";
       	this._soundOn= TFGameState.isOnMute();
       	var flag = 0;		//ADDED BY AHSAN										

    	if(!GAAudioManager.isBackgroundSoundPlaying()) 
		{   			
			GAAudioManager.playBgMusic();
		}

     
       	this._user = null;
       	// formula for userProgress=(userProgress/100)*1.03;
       	// creating user object
      
		var user = TFGameState.getCurrentUser();//TZGameLayer.getUser();
        this._user = user;
       	
       	this._parentNode = new GL2.Node();
       	this._coins = user._userObj.coins;
       	this._bucks = user._userObj.fish_bucks;
       	this._level = user._userObj.currentLevel;
		this._xp = user._userObj.exp;

      	if(this._coins <= 0)
       	{
       		this._coins = "0"; // since it doesn't display single value
       	}
       	
       	if(this._bucks <= 0)
       	{
       		this._bucks = "0"; // since it doesn't display single value
       	}
       	
       
       	this._userProgress = this._user.getLevelProgress(this._level, this._xp);
		
		this._userProgress = (this._userProgress/100)*1.03;
										

		this._topBarSprite = new GLFactory.getSprite([TFUtil.getAdjustedY(40),TFUtil.getAdjustedX(0)],0, './Content/images/UIPanels/TopBar/tf-status-bar.png',[TFUtil.getAdjustedY(400),TFUtil.getAdjustedX(40)],[0, 0]);
		this._parentNode.addChild(this._topBarSprite);

						

		
		this.tankId = user._userObj.selectedTankId;

		this.tankArray = user._userObj.tankArray;
		
		this.tankName = 'Tank';
		this.tankName = user._userObj.tankArray[this.tankId.toString()].tankName;
		this.maketankNameButton();
		
       	//tf-xp-bar
       	
		
		//Settings
		var settingsButton = new GLButton('./Content/images/SettingsUI/setting_icon.png','./Content/images/SettingsUI/setting_icon.png', TFUtil.adjustHeightWithDevice(25), TFUtil.adjustWidthWithDevice(25), this.onTouchSettingsButton.bind(this),this._parentNode,null);
		settingsButton.setPosition(TFUtil.getAdjustedY(420),TFUtil.getAdjustedX(20));
		
		//i button
		infoButton = new GLButton('./Content/images/UIPanels/TopBar/normal.png','./Content/images/UIPanels/TopBar/selected.png', TFUtil.adjustHeightWithDevice(33), TFUtil.adjustWidthWithDevice(35), this.onTouchInfo.bind(this),this._parentNode,99);
     	infoButton.setPosition(TFUtil.getAdjustedY(20),TFUtil.getAdjustedX(20));
		
		this.currentUser = TFGameState.getCurrentUser();
		this.selectedTank = this.currentUser._tankObj;
		
		
		if(!TFGameState.atNeighbor){
			
			
			var tfCoins = new GLButton('./Content/images/UIPanels/TopBar/tf-coin.png','./Content/images/UIPanels/TopBar/tf-coin-selected.png', TFUtil.adjustHeightWithDevice(36), TFUtil.adjustWidthWithDevice(23), this.onTouchInAppCoins.bind(this),this._parentNode,99);
	     	tfCoins.setPosition(TFUtil.getAdjustedY(60),TFUtil.getAdjustedX(18));
							//tf-coins  Text
			this._tfCoinsText = new GLFactory.getText([TFUtil.getAdjustedY(40),TFUtil.getAdjustedX(1)],0,this._coins,[TFUtil.getAdjustedY(60),TFUtil.getAdjustedX(25)],TFUtil.getAdjustedFontSize(75));
			this._tfCoinsText.setColor(1,1,1);
			this._tfCoinsText.setFontLocation(TFUtil.getFontLocation());
			this._tfCoinsText.setFontFamily(TFUtil.getFont());
			tfCoins.addChild(this._tfCoinsText);
											
							//tf-bucks
	
			
			var tfbucks = new GLButton('./Content/images/UIPanels/TopBar/tf-bucks.png','./Content/images/UIPanels/TopBar/tf-bucks-selected.png', TFUtil.adjustHeightWithDevice(22), TFUtil.adjustWidthWithDevice(24), this.onTouchInAppBucks.bind(this),this._parentNode,99);
	     	tfbucks.setPosition(TFUtil.getAdjustedY(130),TFUtil.getAdjustedX(18));
	     	
	     	
															
					//tf-bucks  Text
			this._tfbucksText = new GLFactory.getText([TFUtil.getAdjustedY(30),TFUtil.getAdjustedX(1)],0,this._bucks,[TFUtil.getAdjustedY(30),TFUtil.getAdjustedX(25)],TFUtil.getAdjustedFontSize(75));
			this._tfbucksText.setColor(1,1,1);
			this._tfbucksText.setFontLocation(TFUtil.getFontLocation());
			this._tfbucksText.setFontFamily(TFUtil.getFont());
			tfbucks.addChild(this._tfbucksText);
			
			
			
			
			tfXpBar = new GLFactory.getSprite([TFUtil.getAdjustedY(290),TFUtil.getAdjustedX(12)],0,'./Content/images/UIPanels/TopBar/tf-xp-bar.png', [TFUtil.getAdjustedY(110),TFUtil.getAdjustedX(14)], [0, 0]);
	       	this._parentNode.addChild(tfXpBar);
		
	       	
	       	//tf xp Filler bar
			this._tfXpFillerBar = new GLFactory.getSprite([TFUtil.getAdjustedY(0),TFUtil.getAdjustedX(0)],0,'./Content/images/UIPanels/TopBar/tf-xp-filler.png', [TFUtil.getAdjustedY(90),TFUtil.getAdjustedX(14)], [0, 0]);
			tfXpBar.addChild(this._tfXpFillerBar);
	       	
			if(this._level == 80) /////@kamran 80 is MAX_LEVEL! Needs to be moved to CONSTANTS! 
	        {
	        	var requiredXp = '';
	        	this._tfXpFillerBar.setScale(1,1);
	        }
	        else{
	        	var requiredXp =  "/" + this._user.getLevelXp(this._level+1); ////@kamran currently this data is being fetched from the user which in turns go to database. it NEEDS to be moved to GameState where level array / dictionary is maintained. 
	        	this._tfXpFillerBar.setScale(this._userProgress,1);
	        }
	       	
			//tf-xp  Text
		    this._tfXpBarText = new GLFactory.getText([TFUtil.getAdjustedY(10),TFUtil.getAdjustedX(-5)],0,this._xp + requiredXp,[TFUtil.getAdjustedY(80),TFUtil.getAdjustedX(25)],TFUtil.getAdjustedFontSize(75));
	        this._tfXpBarText.setAnchor(0,0);
			this._tfXpBarText.setColor(1,1,1);		
			this._tfXpBarText.setFontLocation(TFUtil.getFontLocation());
			this._tfXpBarText.setFontFamily(TFUtil.getFont());
	       	tfXpBar.addChild(this._tfXpBarText);
	       	
	       	//tf-star
			var tfStar = new GLFactory.getSprite([TFUtil.getAdjustedY(275),TFUtil.getAdjustedX(5)],0,'./Content/images/UIPanels/TopBar/tf-star.png', [TFUtil.getAdjustedY(25),TFUtil.getAdjustedX(25)], [0, 0]);
	       	this._parentNode.addChild(tfStar);
	       	
	       	//tf-star  Text
			this._tfStarText = new GLFactory.getText([TFUtil.getAdjustedY(-4),TFUtil.getAdjustedX(-1)],0,this._level,[TFUtil.getAdjustedY(31),TFUtil.getAdjustedX(30)],TFUtil.getAdjustedFontSize(75));
	        this._tfStarText.setAnchor(0,0);
			this._tfStarText.setColor(1,1,1)
			this._tfStarText.setFontLocation(TFUtil.getFontLocation());
			this._tfStarText.setFontFamily(TFUtil.getFont());
			tfStar.addChild(this._tfStarText);
			
			
			if(this.selectedTank._tankObj.isTankLocked == true)
		    {
				this.lockButton = new GLButton('./Content/images/UIPanels/TankUI/lock3.png','./Content/images/UIPanels/TankUI/lock3.png',TFUtil.getAdjustedY(40),TFUtil.getAdjustedX(40),this.tankRenameInAboveBar.bind(this),this._parentNode,100);
				this.lockButton.setPosition(TFUtil.getAdjustedY(435),TFUtil.getAdjustedX(70));	
			}
			else
			{															
				if(this.lockButton)
				{
					this.lockButton.destroy();
					this.lockButton = null;
				}

			}
	 

		}

															
   },
	
	tankLockBttnClicked: function()
	{
																														
	},
	
	maketankNameButton : function(tankBtnName)
	{	    											
		if(this.tankNameButton)
		{
			this.tankName = tankBtnName;
			this.tankNameButton.destroy();
		}
		
		this.tankNameButton = new GLButton('./Content/images/UIPanels/Buttons/1buttonNormal.png','./Content/images/UIPanels/Buttons/1buttonNormal.png',TFUtil.getAdjustedY(70),TFUtil.getAdjustedX(18),this.tankRenameInAboveBar.bind(this),this._topBarSprite,100,GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_TANK_RENAME'),[this.tankName]),new Core.Color(1,1,1),new Core.Color(1,1,1),null,TFUtil.getAdjustedFontSize(80));
		this.tankNameButton.setTextFont(TFUtil.getFont(),TFUtil.getFontLocation());
		this.tankNameButton.setPosition(TFUtil.getAdjustedY(180),TFUtil.getAdjustedX(20));
	},
		
	tankRenameInAboveBar : function()
	{
		if(!TFGameState.atNeighbor)
		{
			this._isInfoButtonOpened = false;												
			this.closeLeftPanel();
		}
		if(!TFGameState.atNeighbor)
		{
																	
			var tankName = new TankRename(this);
			tankName.tankWindow();
			GameLayer.getControlLayer().addChild(tankName);
		}
	},
    areButtonsEnabled: function()
    {
		
    },
    
    setButtonsEnabled: function(value)
    {
    	this._enableButtons = value;
    },
    
     getParentNode: function()
	{
		 return this._parentNode;
	 },

	
	setCoins: function(coin)
	{
		this._coins=coin;
	},
	
	setBucks: function(buck)
	{
		this._bucks=buck;
	},
    
    setXp: function(xps)
	{
		this._xp=xps;
	},
	
	setVisitors: function(visitor)
	{
		this._visitors=visitor;
	},
    
    // buck button touch
    
    onTouchInAppBucks: function()
    {		
    	if(!GameLayer.getControlLayer()._areButtonsEnabled)
    	{
			return;
    	}
    	
		var inAppMainView = new InAppMainView(true);
		NGWindow.document.addChild(inAppMainView);
    
	},
	
	onTouchInAppCoins: function()
    {		
    	if(!GameLayer.getControlLayer()._areButtonsEnabled)
    	{
			return;
    	}
    	
		var inAppMainView = new InAppMainView(false);
		NGWindow.document.addChild(inAppMainView);
	},
	
	//Settings button touch
	
	onTouchSettingsButton: function()
	{
		if(GameLayer.getControlLayer()._areButtonsEnabled)
		{
			GameLayer.getControlLayer().disableButtons();
	   	}
		else
	   	{
			return;
	   	}
		if(this._isInfoButtonOpened)
		{
			this._isInfoButtonOpened = false;												
			this.closeLeftPanel();
		}
		if(this.settingsUI == null) {
			
			this.settingsUI = new TFSettingsUI();
		}
		this.settingsUI.show();
		 
	},	
															
    onTouchInfo: function()
	{
		if(!GameLayer.getControlLayer()._areButtonsEnabled)
    	{
			return;
    	}
		if(this._isInfoButtonOpened)
		{
			this._isInfoButtonOpened = false;
			this.closeLeftPanel();
		}
		else
		{
			this._isInfoButtonOpened = true;
			this.infoView = new InfoView();
			GameLayer.getControlLayer().addChild(this.infoView);
		}
		
	},
	

	closeLeftPanel:function()
	{
		this._isInfoButtonOpened = false;
		if(this.infoView)
			this.infoView.callBack();
	},
	
    soundTouch: function(){
		var key = "musicOn";
		if(this._soundOn=="true")
		{
			this._soundOn="false";
			this._tfSound.getButton().setImage('./Content/images/UIPanels/TopBar/tf-sound-off.png', [TCUtil.getAdjustedY(25),TCUtil.getAdjustedX(25)]);
			GAAudioManager.pauseBgMusic();
		}
		else
		{	
			this._soundOn="true";
			this._tfSound.getButton().setImage('./Content/images/UIPanels/TopBar/tf-sound-on.png', [TCUtil.getAdjustedY(25),TCUtil.getAdjustedX(25)]);		
			GAAudioManager.playBgMusic();
		}
		
	},
	
	updateBucksLabel: function()
	{
		this._bucks = this._user._userObj.fish_bucks;
		this._tfbucksText.setText(this._bucks);
		
	},
	
	updateCoinsLabel: function()
	{
		this._coins = this._user._userObj.coins ;
		this._tfCoinsText.setText(this._coins);
		
	},
	
	updateTopPanel: function()
	{
		if(TFGameState.atNeighbor){
			return;
		}
		
		// update bucks here
		this._bucks = this._user._userObj.fish_bucks;
		if(this._bucks <= 0)
       	{
       		this._bucks = "0"; // since it doesn't display single value
       	}
		this._tfbucksText.setText(this._bucks);
		
		// update coins here
		this._coins = this._user._userObj.coins;
		if(this._coins <= 0)
       	{
       		this._coins = "0"; // since it doesn't display single value
       	}
		this._tfCoinsText.setText(this._coins);
	
		this._level = this._user._userObj.currentLevel;
		
		this._xp= this._user._userObj.exp;      
		
		// Updating user progress bar.
		this._userProgress = this._user.getLevelProgress(this._level, this._xp);
		this._userProgress = (this._userProgress/100)*1.03;
		this._tfXpFillerBar.setScale(this._userProgress,1);
		
		if(this._level < 80)
		{
			this._tfStarText.setText(this._level);
			this._tfXpBarText.setText(this._xp +"/" + this._user.getLevelXp(this._level+1));

		}
		else if (this._level == 80)
		{
			this._tfStarText.setText(this._level);
			this._tfXpBarText.setText(this._xp) 
		}
		
	},
															
	updateLockBttn: function()
	{
															
		this.currentUser = TFGameState.getCurrentUser();
		this.selectedTank = this.currentUser._tankObj;
															
		if(this.selectedTank._tankObj.isTankLocked == true)
		{  
			if(!this.lockButton)
			{												
				this.lockButton = new GLButton('./Content/images/UIPanels/TankUI/lock3.png','./Content/images/UIPanels/TankUI/lock3.png',TFUtil.getAdjustedY(40),TFUtil.getAdjustedX(40),this.tankRenameInAboveBar.bind(this),this._parentNode,100);
				this.lockButton.setPosition(TFUtil.getAdjustedY(435),TFUtil.getAdjustedX(70));
			}
		}
		else
		{															
		    if(this.lockButton)
			{
							
				this.lockButton.destroy();
				this.lockButton = null;
			}
		}
															
	},
    destroy: function($super)
    {		
    	
    	
    	// removing from parent node
    	
    	this._parentNode.removeChild(this._breedButtonTarget);
    	this._parentNode.removeChild(this._breedButton);
		this._parentNode.removeChild(this._bucksButtonTarget);
    	this._parentNode.removeChild(this._bucksButton);
		this._parentNode.removeChild(this._soundTarget);
		this._parentNode.removeChild(this._tfSound);
		this._parentNode.removeChild(this._tfVisitorsText);
		this._parentNode.removeChild(this._tfVisitors);
		this._parentNode.removeChild(this._tfXpBarText);
		this._parentNode.removeChild(this._tfbucksText);
		this._parentNode.removeChild(this._tfCoinsText);
		this._parentNode.removeChild(this._topBarSprite);
		
		// destroying
		this._breedButtonTarget.destroy();
    	this._breedButton.destroy();
		this._bucksButtonTarget.destroy();
    	this._bucksButton.destroy();
        this._infoButton.destroy();
		this._soundTarget.destroy();
		this._tfSound.destroy();
		this._tfVisitorsText.destroy();
		this._tfVisitors.destroy();
		this._tfXpBarText.destroy();
		this._tfbucksText.destroy();
		this._tfCoinsText.destroy();
		this._topBarSprite.destroy();
		this.lockButton.destroy();
		
		TFUtil.destroyNodeChildren(this._parentNode);
		this._parentNode.destroy();
		
		$super();  
    },
	
	
	
	
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI Layers/GAMoveTo'] = function(){var exports = $MODULE_REGISTRY['Code/UI Layers/GAMoveTo'] || {}; $MODULE_REGISTRY['Code/UI Layers/GAMoveTo'] = exports; /**
 * Filename: GAMoveTo.js
 * Author: Sajid Hussain
 * Date Created: 2011-02-08
 * Date Updated: 2011-02-11
 */

exports.GAMoveTo = Core.MessageListener.subclass({
	
	classname: 'GAMoveTo',
	
    initialize: function($super,spriteNode, destination, duration, rem, callBackFunc) {
    	$super();
        this._callBackFunc = callBackFunc;
        this._rem = rem;
        this._initialPosition = spriteNode.getPosition();
        this._spriteNode = spriteNode;
        this._destination = destination;
        Core.UpdateEmitter.addListener(this, this._setPosition);
        var deltaVector = new Core.Vector();
        deltaVector.setX(this._destination.getX() - this._initialPosition.getX());
        deltaVector.setY(this._destination.getY() - this._initialPosition.getY());
        this._deltaVector = deltaVector;
        var now = Core.Time.getFrameTime();
        this._mStartTime = now;
        this._mStopTime = now + duration;
        this._mDuration = duration;
        
    },

    _setPosition: function(delta) {
        var now = Core.Time.getFrameTime();
        if (now > this._mStopTime) {
            this._spriteNode.setPosition(this._destination.getX(), this._destination.getY());
            if (this._rem) {
                if (typeof this._callBackFunc == 'function') 
                	this._callBackFunc();
                Core.UpdateEmitter.removeListener(this, this._setPosition);
                this.destroy();
                return;
            }
        } else {
            var slice = delta / this._mDuration;
            var newLocation = new Core.Vector();
            newLocation.setX(this._initialPosition.getX() + (this._deltaVector.getX() * slice));
            newLocation.setY(this._initialPosition.getY() + this._deltaVector.getY() * slice);
            this._spriteNode.setPosition(newLocation.getX(), newLocation.getY());
            delete newLocation;
        }
    },

    destroy: function($super) {
    	if(this._deltaVector) {
    		delete  this._deltaVector;
    		delete this.destination;
    		this._deltaVector = null;
    	}
    	$super();
    }

});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI Layers/GAScaleTo'] = function(){var exports = $MODULE_REGISTRY['Code/UI Layers/GAScaleTo'] || {}; $MODULE_REGISTRY['Code/UI Layers/GAScaleTo'] = exports; /**
 * Filename: GAMoveTo.js
 * Author: Sajid Hussain
 * Date Created: 2011-02-08
 * Date Updated: 2011-02-11
 */

exports.GAScaleTo = Core.MessageListener.subclass({
	
	classname: 'GAScaleTo',
	
    initialize: function(spriteNode, destination, duration, rem, callBackFunc) {

        this._callBackFunc = callBackFunc;
        this._rem = rem;
        this._initialScale = spriteNode.getScale();
        this._spriteNode = spriteNode;
        this._destination = destination;
        Core.UpdateEmitter.addListener(this, this._setScale);
        var deltaVector = new Core.Vector();
        deltaVector.setX(this._destination.getX() - this._initialScale.getX());
        deltaVector.setY(this._destination.getY() - this._initialScale.getY());
        this._deltaVector = deltaVector;

        var now = Core.Time.getFrameTime();

        this._mStartTime = now;
        this._mStopTime = now + duration;
        this._mDuration = duration;
    },

    _setScale: function(delta) {
    	try{
        var now = Core.Time.getFrameTime();

        if (now > this._mStopTime) {
			
            this._spriteNode.setScale(this._destination.getX(), this._destination.getY());
            if (this._rem) {
                if (typeof this._callBackFunc == 'function') 
                	this._callBackFunc();
                Core.UpdateEmitter.removeListener(this, this._setPosition);
                this.destroy();
            }
        } else {
            var slice = delta / this._mDuration;
            var newLocation = new Core.Vector();
            newLocation.setX(this._initialScale.getX() + (this._deltaVector.getX() * slice));
            newLocation.setY(this._initialScale.getY() + this._deltaVector.getY() * slice);
            this._spriteNode.setScale(newLocation.getX(), newLocation.getY());
            delete newLocation;
        }
    	}catch(err){
    		this.destroy();
    	}
    },

    destroy: function($super) {
		delete this._deltaVector;
    	$super();	
    }

});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Util/TFUtil'] = function(){var exports = $MODULE_REGISTRY['Code/Util/TFUtil'] || {}; $MODULE_REGISTRY['Code/Util/TFUtil'] = exports; /**
 * Filename: Main.js Author: Wasay Abbasi Date Created: 16thMay-2011 Date
 * Updated:
 */

exports.TFUtil = Core.Class.singleton(
{
	classname:'TFUtil',	// static class
  
	initialize: function()
	{
		this.fishArray = new GAMutableDictionary();
		this.decorationArray = new GAMutableDictionary();
		this.plantsArray = new GAMutableDictionary();
		this.foodBricksArray = new GAMutableDictionary();
		this.breededKeysDictionary = new GAMutableDictionary();
		this.breededFishKeysDictionary = new GAMutableDictionary();
		this.giftableItemsKeysDictionary = new GAMutableArray();
		this.foodConsumed = true;
		this.isTouched = false;
		
	},
  
	$getAdjustedWidth: function(w) 
	{
		
		var width = Core.Capabilities.getScreenWidth();
		
		return (w / aspectRatioFactor.x) * width;
	},
	
	$getAdjustedHeight: function(h) {
		var height = Core.Capabilities.getScreenHeight();
		return (h / aspectRatioFactor.y) * height;
	},
	
	$getAdjustedX: function(x) {
		
		var width = 0 , newWidth = 0 ;
		width = Core.Capabilities.getScreenWidth();
		newWidth = (width / 320) * x;
		
		return newWidth;
		
	},
	
	adjustNumber:function(numberToAdjust,adjustingNumber)
	{
		if(numberToAdjust == adjustingNumber)
		{
			return numberToAdjust;
		}
		else if(numberToAdjust < adjustingNumber)
		{
			return numberToAdjust + (adjustingNumber - numberToAdjust);
		}
		else if(numberToAdjust > adjustingNumber)
		{
			return numberToAdjust - (numberToAdjust - adjustingNumber);
		}
	},
	
	$getBasePathForResourceType:function(storeId, resourceType) 
	{
		var storeObject = this.getStoreObject(storeId);
		var resource = GAResourceUtils.getResourceOfType(storeObject, resourceType);
		var basePath = GAResourceUtils.getResourceSavePath(storeObject, resource);
		return basePath;
	},  
	
    $getStoreObject : function(storeId)
    {
		var storeObject = GAGameLoader.getStoreHandler().getStoreObjectForKey(storeId);
		return storeObject;
    },	
	$getAdjustedY: function(y) 
	{
		var height = 0 , newHeight = 0;
		height = Core.Capabilities.getScreenHeight();
		newHeight = (height / 480) * y;
		
		return newHeight;
	},
    
	$getAdjustedFontSize: function(fieldHeight) {
        return this.getAdjustedY(fieldHeight / 2) / 3.67;
    },
    
    $setTextFont: function(obj) {
    	//obj.setTextFont(this.getFontName());
    },
    
    $getFont: function() {
        return './Content/Font/MarkerFeltThin-Plain.ttf';
    },
    
    $getFontName: function() {
        return 'MarkerFeltThin-Plain';
    },
    
    $getFontLocation: function() {
        return GL2.Text.FontLocation.Manifest;
    },
															
	$adjustHeightWithDevice: function(aHeight)
	{
		var h = 0 , calHeight = 0;
												
		h = Core.Capabilities.getScreenHeight();
														
		calHeight = aHeight * (h/480);
		return calHeight;		
														
	},
	
	$adjustWidthWithDevice: function(aWidth)
	{
		var w = 0, calWidth = 0;
		
		w = Core.Capabilities.getScreenWidth();
		
		calWidth = aWidth * (w/320);
		return calWidth;			
	},
	
	$getAspectMaintainSize: function(currentSize,newSize) {
		var width = currentSize.getWidth();
		var height = currentSize.getHeight();
		if(width > height) {
			var ratio = width/height;
			width = newSize.getWidth();
			height = width/ratio;
		}
		else {
			var ratio = height/width;
			height = newSize.getHeight();
			width = height/ratio;
		}
		currentSize.setWidth(width);
		currentSize.setHeight(height);
		delete newSize;
		return currentSize;
	},
    
	$getRatingUrl: function (type) {
		var responseObject = GAGameLoader.getResponseObject();
		var url = [];
		notificationServerURL = "http://ngtapfishstate.appspot.com/";
		
		switch(type){
		
			case kRatingType.GET:
				url.push(notificationServerURL+"");
				url.push("rate?");
				url.push("type=userkey");
				url.push("&udid=");
				url.push(TFGameState.getCurrentUser().getUsername());
				url.push('&game=');
				url.push('ngTF');
				url.push('&userkey=');
				url.push(TFGameState.getCurrentUser().getUsername());
				url = encodeURI(url.join(""));
				
			break;
			
			case kRatingType.POST:
				url.push(notificationServerURL+"");
				url.push("rate");
				url = encodeURI(url.join(""));
			break;
			
			default:
				
			break;
		}
		
		return url;
	},
	
	$getTimeInProperFormat:function (timeSent)
	{
			
			var ageString="",time = 0, hours=0, min=0, days=0, minutes=0;
			
			if(timeSent <= 60)
			{
					time = Math.round(timeSent);
			}
			else
			{
					time =Math.round(timeSent/60);
					
			}
			
			if(time <= 0) {
					 
					 ageString=Core.Localization.getString('TF_READY');// ready
					 return ageString;
									  
				     // console.log("shoaib: remove call for brick ");
									
			}
			if(time)// check any thing
			{
					if(timeSent <= 60)
					{
							ageString=GALocalizationHandler.getRelativeString(Core.Localization.getString('TF_SEC_LEFT'),[time]);// secleft
							return ageString;
					}
					
					if(time<2)
					{			
							ageString=GALocalizationHandler.getRelativeString(Core.Localization.getString('TF_M_LEFT'),[time]);// mleft
							return ageString;
					}
					
					if(time<=60)
					{			
							ageString=GALocalizationHandler.getRelativeString(Core.Localization.getString('TF_M_LEFT'),[time]);// mleft
							return ageString;
					}
					
					if(time/60 < 24)
					{
							hours=Math.floor(time/60);
							min=Math.floor(time-hours*60);

							if(hours>1 && min>1)
									return GALocalizationHandler.getRelativeString(Core.Localization.getString('TF_HM_LEFT'),[hours,min]); // ("
																																			// %i
																																			// hr,
																																			// %i m
																																			// left",hours,min);
																																			// //hmleft
							if(hours>1 && min<2)
									return GALocalizationHandler.getRelativeString(Core.Localization.getString('TF_HM_LEFT'),[hours,min]); // ("
																																			// %i
																																			// hr,
																																			// %i m
																																			// left",hours,min);
							if(hours<2 && min>1)
									return GALocalizationHandler.getRelativeString(Core.Localization.getString('TF_HM_LEFT'),[hours,min]); // [[[NSString
																																			// alloc]
																																			// initWithFormat:@"
																																			// %i
																																			// hr,
																																			// %i m
																																			// left",hours,min]
																																			// autorelease];
							if(hours<2 && min<2)
									return GALocalizationHandler.getRelativeString(Core.Localization.getString('TF_HM_LEFT'),[hours,min]);// [[[NSString
																																			// alloc]
																																			// initWithFormat:@"
																																			// %i
																																			// hr,
																																			// %i m
																																			// left",hours,min]
																																			// autorelease];
							
					}
					
					else
					{	
							days=Math.floor(time/1440);
							hours=Math.floor((time-(days*1440))/60);
							minutes=Math.floor(time-(days*1440)-(hours*60));
							if(days==1 && hours<2)
							{
									return GALocalizationHandler.getRelativeString(Core.Localization.getString('TF_DHM_LEFT'),[days,hours,minutes]); // dhmleft//[[[NSString
																																						// alloc]
																																						// initWithFormat:@"%i
																																						// d,
																																						// %i
																																						// hr,
																																						// %i m
																																						// left",days,
																																						// hours,minutes]
																																						// autorelease];
							}
							if(days==1 && hours>1)
							{
									return GALocalizationHandler.getRelativeString(Core.Localization.getString('TF_DHM_LEFT'),[days,hours,minutes]); // [[[NSString
																																						// alloc]
																																						// initWithFormat:@"%i
																																						// d,
																																						// %i
																																						// hr,
																																						// %i m
																																						// left",days,
																																						// hours,minutes]
																																						// autorelease];
							}
							if(days>1 && hours<2)
							{
									return GALocalizationHandler.getRelativeString(Core.Localization.getString('TF_DHM_LEFT'),[days,hours,minutes]); // [[[NSString
																																						// alloc]
																																						// initWithFormat:@"%i
																																						// d,
																																						// %i
																																						// hr,
																																						// %i m
																																						// left",days,
																																						// hours,minutes]
																																						// autorelease];
							}
							if(days>1 && hours>1)
							{
									return GALocalizationHandler.getRelativeString(Core.Localization.getString('TF_DHM_LEFT'),[days,hours,minutes]); // [[[NSString
																																						// alloc]
																																						// initWithFormat:@"%i
																																						// d,
																																						// %i
																																						// hr,
																																						// %i m
																																						// left",days,
																																						// hours,minutes]
																																						// autorelease];
							}
					}
			}
			return ageString;
	},
	
	// ********************Resources Managment Methods
	// Start********************//
	
	$getResourceDict: function(tankId, actionType)
	{
		var resources = ['Tank'+tankId];
		console.log("faizan TanK to delete " + resources);
		DatabaseInterface.loadTanks(resources, actionType);
	},
	
	$getAllTanksResourcesDictionary: function(actionType)
	{
		console.log("$getAllTanksResourcesDictionary started");
		console.log("$getAllTanksResourcesDictionary ");
		console.log("$getAllTanksResourcesDictionary " + TFGameState.getCurrentUser());
		console.log("$getAllTanksResourcesDictionary " + TFGameState.getCurrentUser()._userObj);
		console.log("$getAllTanksResourcesDictionary " + TFGameState.getCurrentUser()._userObj.coins);
		console.log("$getAllTanksResourcesDictionary " + TFGameState.getCurrentUser()._userObj.selectedTankId);
		var userTanksArray = TFGameState.getCurrentUser()._userObj.tankArray;
		console.log("$getAllTanksResourcesDictionary TFGameState.getCurrentUser()._userObj.tankArray " + TFGameState.getCurrentUser()._userObj.tankArray);
		var resources = new Array();
		var i = 0;
		for(objectId in userTanksArray)
		{
			console.log("$getAllTanksResourcesDictionary in loop");
			var userTank = userTanksArray[objectId];
			console.log("Pushing resources " + 'Tank'+userTank.tankId);
			resources.push('Tank'+userTank.tankId);
			
		}
		DatabaseInterface.loadTanks(resources,actionType);
		console.log("$getAllTanksResourcesDictionary ended");
	},
	
	$resourceLoadedForTanks: function(resources,actionType)
	{
		console.log("$resourceLoadedForTanks started");
		var i = 0;
		for(; i < resources.length; i++)
		{
			var myTank = GAPersistenceManager.getResource(resources[i]);
			var storeItems = myTank.Store_Items;
			if(storeItems == 'undefined' || storeItems == null)
				continue;
			var storeFishArray = storeItems.tank_fishArray;
			var decortaionArray = storeItems.tank_decorationArray;
			var plantsArray = storeItems.tank_plantArray;
			var foodBricksArray = storeItems.tank_foodBrickArray;
			
			if(!myTank.lastRevived && !TFGameState.atNeighbor && !TFGameState.justDeleted){
	    		myTank.lastRevived = 0;
	    		myTank.persist();
	    	}						  
			
			for(objectId in storeFishArray)
			{
				var myFish = storeFishArray[objectId];
				TFUtil.updateResourceDict(myFish,actionType, kResourceType.kResourceTypeFish);
			}	
			
			for(objectId in decortaionArray)
			{
				var myDecoration = decortaionArray[objectId];
				TFUtil.updateResourceDict(myDecoration,actionType,kResourceType.kResourceTypeDecoration);
			}
			
			for(objectId in plantsArray)
			{
				var myPlant = plantsArray[objectId];
				TFUtil.updateResourceDict(myPlant,actionType,kResourceType.kResourceTypePlant);
			}
									  
			for(objectId in foodBricksArray)
			{
				var myPlant = foodBricksArray[objectId];
				TFUtil.updateResourceDict(myPlant,actionType,kResourceType.kResourceTypeFoodBrick);
			}
		}
		
		// we can make it better by not unloading selected tank

		DatabaseInterface.unLoadTanks(resources);
		delete resources;
		console.log("$resourceLoadedForTanks ended");
	},
	
	$updateResourceDict: function(myResource, actionType, resourceType)
	{
		var objectDict = null;
		if(resourceType == kResourceType.kResourceTypeFish)
		{
			objectDict = this.fishArray;
		}
		else if(resourceType == kResourceType.kResourceTypeDecoration)
		{
			objectDict = this.decorationArray;
		}
		else if(resourceType == kResourceType.kResourceTypePlant)
		{
			objectDict = this.plantsArray;
		}
		else if(resourceType == kResourceType.kResourceTypeFoodBrick)
		{
			objectDict = this.foodBricksArray;
		}
		if(actionType == kObjectActionType.kObjectActionAdd)
		{
			TFUtil.addObjectToDictionary(objectDict, myResource)
		}
		else// kObjectActionRemove
		{
			TFUtil.removeObjectFromDictionary(objectDict,myResource)
		}
	},
	
	// generic methods
	
	$addObjectToDictionary: function(objectDict, object)
	{
		var myDictionaryObject = objectDict.objectForKey(object.storeId);
		if(!myDictionaryObject)
		{
			object.count = +0;
		}
		else
		{
			object = myDictionaryObject;
		}
		object.count++;
		objectDict.setObject(object.storeId, object);
		// TFUtil.printDictionaries();
	},
	
	
	$removeObjectFromDictionary: function(objectDict, object)
	{
		var myDictionaryObject = objectDict.objectForKey(object.storeId);
		if(myDictionaryObject)
		{
			myDictionaryObject.count--;
			if(myDictionaryObject.count == 0)
			{
				objectDict.removeObjectForKey(object.storeId);
			}
			else
			{
				objectDict.setObject(object.storeId, myDictionaryObject);
			}
		}
		// TFUtil.printDictionaries();
	},

	$printDictionaries: function()
	{
		// To print the dictionaries
		this.fishArray.print();
		this.decorationArray.print();
		this.plantsArray.print();
	},
	
	synchronizeServerTime : function() {
        UIFactory.showProgressHUD(Core.Localization.getString("TF_SYNC_PROGRESS"));

        this._webFetcher = new GAWebFetcher(this, 30, 0);
        this._webFetcher.invokeGetRequest('http://svn-133.ngtapfishservice.appspot.com/getServerTime');
    },
    
	webFetchSuccess : function(webFetcher, responseData) {

		if (this._webFetcher != null) {
			this._webFetcher.destroy();
			this._webFetcher = null;
		}

		this._responseObject = eval("(" + responseData + ")");

		UIFactory.hideProgressHUD();
//		UIFactory.showToast(Core.Localization.getString("syncSuccess"));

		this.resynchronizeTimes();
	},
	
	resynchronizeTimes : function() {
		console.log('sarmad: resynchronising time');
		var currentTime = (new Date().getTime()) / 1000;

		console.log("TFUtil sarmad: currentTime " + currentTime);
		var newServerTime = parseInt(this._responseObject.servertime);
		
		console.log("TFUtil sarmad: newServerTime " + newServerTime);
		var newTimeDifference = newServerTime - currentTime;
		
		console.log("TFUtil sarmad: newTimeDifference " + newTimeDifference);
		TFGameState.setServerTime(newTimeDifference);
		console.log('sarmad: TFGameState.setServerTime done|!!');
		
	},


	webFetchFailure : function(webFetcher, errorCode) {
		console.log("sarmad: sync time fail");
		if (this._webFetcher != null) {
			this._webFetcher.destroy();
			this._webFetcher = null;
		}

		var errorMsg = "webFetchFailure() responseStatusCode = > " + errorCode;
		UIFactory.hideProgressHUD();
		//this.onFailure(errorCode);
	},
	
	
//	onFailure: function(errorCode) 
//	{
//		
//		var message = Core.Localization.getString('TF_NETWORK_FAIL');
//		console.log(message);
//		
//		var alertWindow =  new TFMiniUIAlertView("",message,this,Core.Localization.getString('TF_CANCEL_BUTTON'),GALocalizationHandler.getLocalizedString('TF_RETRY_LABEL'));
//		alertWindow.setTagValue(100);
//		alertWindow.setType("ok");
//		alertWindow.setMessageColor("FFFFFF");
//		alertWindow.setMessageFont(TFUtil.getFontName());
//		alertWindow.setButtonsFont(TFUtil.getFontName());
//		alertWindow.setButtonColor("FFFFFF");
//		alertWindow.show();
//	},

	
	// ********************Resources Managment Methods
	// Ends********************//
	// ********************Breed resource Util********************//

	
	
getUserBreedableFishList: function()
{
	var breedableFishArray= new GAMutableArray();
	var allFishStoreIds=this.fishArray.allKeys();
	console.log(" TfUtil : getUserBreedableFishList: "+allFishStoreIds.length);
	for(var i =0 ; i<allFishStoreIds.length ; i++ )
	{
		var storeID=allFishStoreIds[i];
		console.log("getUserBreedableFishList: "+storeID);
		var storeFishVirtualItem = GAGameLoader.getStoreHandler().getStoreObjectForKey(storeID);
		if(storeFishVirtualItem.custom_attributes.canbebreeded) 
		{
			breedableFishArray.addObject(storeID);
		}
	}
	return breedableFishArray;
},
				
populateBreedingKeys: function()
{
//	console.log("Breeding keys.....................................................................................");
	var allStoreItems = GAGameLoader.getStoreHandler().getAllItems(2,0,true);
	var i =0, count = allStoreItems.length ;
	for(i; i < count; i++)
	{
		var key= allStoreItems[i].custom_attributes.parentx + "+" +allStoreItems[i].custom_attributes.parenty;
		var value= new Object(allStoreItems[i].parent.parent.visible_id+ "_" +allStoreItems[i].parent.visible_id +"_"+ allStoreItems[i].visible_id);
		this.breededKeysDictionary.setObject(key,value);
		var temp= this.breededKeysDictionary.objectForKey(key);
		
	}
},

getBreedResultStoreID: function(fish1id,fish2id)
{
	var key1=fish1id+"+"+fish2id;
	console.log(key1);
	if(this.breededKeysDictionary.objectForKey(key1))
	{
		console.log(this.breededKeysDictionary.objectForKey(key1));
		return this.breededKeysDictionary.objectForKey(key1);
	}
	
	var key2=fish2id+"+"+fish1id;
	console.log(key2);
	if(this.breededKeysDictionary.objectForKey(key2))
	{
		console.log(this.breededKeysDictionary.objectForKey(key2));
		return this.breededKeysDictionary.objectForKey(key2);
	}
	
},

/***** By asad *****/
setFishInFishArray : function(key, value) 
{
	var key1= new Object(value);
	console.log('Key 1 ' + key1);
	this.fishArray.setObject(key,key1);
},

removeFishFromFishArray: function(key)
{
	console.log("KEY " + key);
	this.fishArray.removeObjectForKey(key);
},

populatebreededFishKeysDictionary : function()
	{
	var allFishStoreIds=this.fishArray.allKeys();
	console.log(" TfUtil : populatebreededFishKeysDictionary: "+allFishStoreIds.length);
	var pid1;
	var pid2;
	var pid3;
	var key;
	for(var i =0 ; i<allFishStoreIds.length ; i++ )
	{
		var storeID=allFishStoreIds[i];
		key = storeID.split("_");
		pid1 = key[0];
		if(pid1 == 2)
		{
			var storeFishVirtualItem = GAGameLoader.getStoreHandler().getStoreObjectForKey(storeID);
			pid2= storeFishVirtualItem.custom_attributes.parentx;
             pid3 =storeFishVirtualItem.custom_attributes.parenty;
			console.log("populatebreededFishKeysDictionary: "+storeID);
			this.setBreedFish(storeID,pid2,pid3 );
		}
	}
		
	
	},
	
	populateGiftableKeysDictionary : function()
	{
	
	// get all visible Ids
	// get all categories
	// for each item
	// check if the custom attribute has the giftable property
	// populate the giftableitem array
	// this array would then be used in social feature	
	
	var connectResponseObject = GAGameLoader.getResponseObject();
    var array = connectResponseObject.getStoreVisibleIds();
	
	var _storeId = null;
	var category = null;
	var tempArray = null;
	var itemModel = null;
	
	for(var i = 0; i< array.length ; i++)
	{
		_storeId = array[i];
		var _allCategories = GAGameLoader.getStoreHandler().getAllCategories(""+_storeId, true);
		if(_allCategories == null || _allCategories == 'undefined')
		{
			continue;
		}
		
		for(var j = 0; j<_allCategories.length; j++)	
		{
			category = _allCategories[j];
			tempArray = GAGameLoader.getStoreHandler().getAllItems(category.parent.visible_id, category.visible_id, true);
			
			if(tempArray == null || tempArray == 'undefined')
    		{
    			continue;
    		}
    		else
    		{

				//check if giftable, if yes then populate otherwise, continue
    			 for (var k = 0; k < tempArray.length; k++)
    			 { 	
    				 itemModel = tempArray[k];
    				 
    				 if(itemModel == null || itemModel == 'undefined' || !isValidObject(itemModel.custom_attributes))
			    	 {
			    		continue;
			    	 }
			    	 //NgLogE("TFUtil: itemModel.custom_attributes.is_giftable ->"+itemModel.custom_attributes.is_giftable);
    				 
    				 if(itemModel.custom_attributes.is_giftable !=null
    				  && itemModel.custom_attributes.is_giftable != 'undefined'
    				  && itemModel.custom_attributes.is_giftable == true)
    				 {
    				 	 //NgLogE("TFUtil: pushing giftable item");
    					 //push to array
    					 this.giftableItemsKeysDictionary.addObject(itemModel);
    				 }
    		     }
    		}
		}	
	}
	
	_storeId = null;
	category = null;
	tempArray = null;
	itemModel = null;
	
//	for(var i = 0; i<this.giftableItemsKeysDictionary.getLength();i++)
//	{
//		NgLogE('TFUtil: objectId->' +this.giftableItemsKeysDictionary.objectAtIndex(i)+" -> myVal.is_giftable ->"+this.giftableItemsKeysDictionary.objectAtIndex(i).custom_attributes.is_giftable);
//	}
	
	},

setBreedFish: function(fishId, fparent1, fparent2)
{
	var key1= new Object(fparent1+"+"+fparent2);
	console.log('Key 1 ' + key1);
	this.breededFishKeysDictionary.setObject(fishId,key1);
//	TFGameState.getCurrentUser()._userObj.breededFishKeysDictionary.setObject(fishId,key1);
	console.log('Test json:::::' + JSON.stringify(this.breededFishKeysDictionary));
},

isBreedFishExist: function(fishId)
{
	
	if(this.breededFishKeysDictionary.objectForKey(fishId))
//	if(TFGameState.getCurrentUser()._userObj.breededFishKeysDictionary.objectForKey(fishId))
		{
		return true;
		}
	else 
		{
		return false;
		}
},
isChildExist : function(fishId)
{
	
	var allFishStoreIds=this.breededFishKeysDictionary.allKeys();
//	var value = TFGameState.getCurrentUser()._userObj.breededFishKeysDictionary._privateDict;
//	var allFishStoreIds=TFGameState.getCurrentUser()._userObj.breededFishKeysDictionary.allKeys();
//	var value = this.breededFishKeysDictionary._privateDict;
//	var value = TFGameState.getCurrentUser()._userObj.breededFishKeysDictionary._privateDict;
	var size  =  allFishStoreIds.length;
	var count = 0;
	var pid1;
	var pid2;
	var key;
	for(var i =0 ; i<size ; i++ )
	{
//		var temp = this.breededFishKeysDictionary.objectForKey(allFishStoreIds[i]);
//		var temp = TFGameState.getCurrentUser()._userObj.breededFishKeysDictionary.objectForKey(allFishStoreIds[i]);
		var storeFishVirtualItem = GAGameLoader.getStoreHandler().getStoreObjectForKey(allFishStoreIds[i]);
		
		key = this.getItemId(fishId);
		pid1 =storeFishVirtualItem.custom_attributes.parentx;
		pid2 = storeFishVirtualItem.custom_attributes.parenty;
		if(pid1 == key || pid2 == key  ){
			count++;
		}
	}
	return count;
//	this.breededFishKeysDictionary.setObject(fishId,key1);
	
},
/**** end*******/
getItemId: function(key) {
	var storeKeys = key.split("_");
	var len = storeKeys.length;
	if(len > 0)
		return storeKeys[len-1];
},

// destroys

destroyView: function(view) {
	try {
	   if(typeof view == 'undefined' || view == null)
    		return;
		var children = view.getChildren();
		var length = children.length;
		for(var i = length - 1 ; i>=0 ; --i) {
			view.removeChild(children[i]);
			children[i].destroy();
			children[i] = null;
		}
	}
	catch(exception)
	{
		console.log('Logger: EXCEPTION Occured ' + exception.toString());
	}
},

destroyNodeChildren: function(node) {
	try {
		if(node == null)
			return;
		
		var children = node.getChildren();
	 	var length = children.length;
	 	for(var i = length - 1 ; i>=0 ; --i) {
			if(children[i] == null)
				continue;
			node.removeChild(children[i]);
	 		children[i].destroy();
	 		children[i] = null;
	 	}
	}
	catch(exception)
	{
		console.log('Logger: EXCEPTION Occured ' + exception.toString());
	}
},

destroyNodeChildrenLeaveChild: function(node,child) {
	try {
		if(node == null)
			return;
		
		var children = node.getChildren();
	 	var length = children.length;
	 	for(var i = length - 1 ; i>=0 ; --i) {
	 		if(children[i] != child) {
				if(children[i] == null)
					continue;
				node.removeChild(children[i]);
		 		children[i].destroy();
		 		children[i] = null;
	 		}
	 	}
	}
	catch(exception)
	{
		console.log('Logger: EXCEPTION Occured ' + exception.toString());
	}
},

destroyNode: function(node) {
	try {
		if(node == null)
			return;
		var children = node.getChildren();
	 	var length = children.length;
	 	for(var i = length - 1 ; i>=0 ; --i) {
			if(children[i] == null)
				continue;
	 		children[i].destroy();
	 		children[i] = null;
	 	}
	 	node.destroy();
		node = null;
	}
	catch(exception)
	{
		console.log('Logger: EXCEPTION Occured ' + exception.toString());
	}
},
									  									  
	// ********************Breed resource Util********************//
		

setIsTouched: function(param)
{
	this.isTouched = param;
},

getIsTouched: function()
{
	return this.isTouched;
},

getFoodConsumed: function()
{
	return this.foodConsumed;
},
setFoodConsumed: function(param)
{
	this.foodConsumed = param;
},

	
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Util/ManifestContentDownloader'] = function(){var exports = $MODULE_REGISTRY['Code/Util/ManifestContentDownloader'] || {}; $MODULE_REGISTRY['Code/Util/ManifestContentDownloader'] = exports; /*
* # ManifestContentDownloader.js
* # NGJurassic
* #
* # Created by Washaq.Majeed on 5/30/11.
* # Copyright 2011 __MyCompanyName__. All rights reserved.
*/
exports.ManifestContentDownloader = Core.Class.subclass({
														
	classname: 'ManifestContentDownloader',
	
	initialize: function(url, localPath, filename, ref) {
		this._url = url;
		this._localPath = localPath;
		this._filename = filename;
		this._reference = ref;
		
		this.doDownload();
	},
	doDownload: function() {
		//this._reference.progressScreen._prevProgressValue = 0;
		this.dl = new Network.DownloadManifest(); 
		this.dl.start(this._url, this._localPath, this._filename, this._progressCb.bind(this), this._doneCb.bind(this));
	},
	retry: function() {
		this.dl.start(this._url, this._localPath, this._filename, this._progressCb.bind(this), this._doneCb.bind(this));
	},
	_progressCb: function ( completedRequests, totalRequests ) {
		if(completedRequests <= totalRequests){
			var percentage = 0;
			if(totalRequests > 0) {
				percentage = (parseInt((completedRequests/totalRequests)*100));
			}
			else {
				percentage = 100;
			}
			this._reference.updateMenifestProgress(percentage);
		}
		else {
			
		}
		//this._reference.updateMenifestProgress(completedRequests, totalRequests);
	},
	_doneCb: function ( err, manifest ) {
		if(err) {
			this._failureUIAlert = new TFMiniUIAlertView(Core.Localization.getString("warning"),Core.Localization.getString("TF_REQUIRE_INTERNET_CONNECTION"),this,null,Core.Localization.getString("retry"));
			this._failureUIAlert.setTagValue(1111);
			this._failureUIAlert.show();
			
			//var errorAlert = new UI.AlertDialog();
//			errorAlert.setTitle(ALERT_MSG_FAILURE_TITLE);
//			errorAlert.setText(ALERT_MSG_MANIFEST_DOWNLOAD_FAILURE);
//			errorAlert.setChoices(["Retry"]);
//			var self = this;
//			errorAlert.onchoice = function(ret) {
//				errorAlert.hide();
//				self.retry();
//				errorAlert.destroy();
//			};
//			errorAlert.show();
		}	
		else {
			this._reference.doneDownloading();
		}
	},
	clickedButtonAtIndex: function(buttonIndex,alerWindow)
	{
		
		if (buttonIndex == 0) 
		{
			if(alerWindow.getTagValue() == 1111)
			{
				this.retry();
				
			}
			
			
		} 
		else if (buttonIndex == 1)
		{
			//NgLogE("Cancel button clicked");
		}
		
	},
	destroy: function() {
		if(this.dl)
		{
			this.dl.destroy();
			this.dl = null;
		}
	}
});

	; return exports;};
$MODULE_FACTORY_REGISTRY['Code/Utilities/LogHandler'] = function(){var exports = $MODULE_REGISTRY['Code/Utilities/LogHandler'] || {}; $MODULE_REGISTRY['Code/Utilities/LogHandler'] = exports; exports.LogHandler = Core.Class.singleton( {
	classname: 'LogHandler',
	
	initialize: function(){
		// GADazzleHandler.performInitialization();
		Core.Analytics.enable();
		this.isDazzleEnabled = false;
	},
	
	performInitialization: function(){
		/* Dummy method to call the default init */
	},
	
	isDazzle: function () {
		return this.isDazzleEnabled;
	},
	
	logTransaction : function (object) {
		if(this.isDazzle()) {
			this.logDazzleTransactionWithStoreObject(object);
		}
		else {
			this.logAnalyticsTransaction(object);
		}
	},
	
	logDazzleTransactionWithStoreObject: function(object){
		var objTransaction = new GATransactionsModel();
		
		objTransaction.setUserId(GAConfigurations.getUserId() + '');
		objTransaction.setUserLevel(TFGameState.getCurrentUser().getCurrentLevel() + '');
		
		objTransaction.setItemId(object.visible_id + '');
		objTransaction.setItemName(object.name + '');
		objTransaction.setCategoryId(object.parent.visible_id + '');
		objTransaction.setCategoryName(object.parent.name + '');
		objTransaction.setStoreId(object.parent.parent.visible_id + '');
		objTransaction.setStoreName(object.parent.parent.name + '');
		var buyPriceKey = GACommonUtils.getBuyPrice(object);
		var cost = StoreUtil.getPrice(buyPriceKey);
		var type = StoreUtil.getCurrency(buyPriceKey);
		
		objTransaction.setCurrency(type + '');
		objTransaction.setPrice(cost + '');
		objTransaction.setQuantity('1');
		objTransaction.setPriceBucket('default');
		
		var date = new Date();
		objTransaction.setTs(date.getTime()/1000);
		
		GADazzleHandler.logTransaction(objTransaction);
	},
	
	logAnalyticsTransaction: function (object) {
		var itemID = object.visible_id;
		var itemName = object.name;
		var pvid = object.parent.visible_id;
		var pname = object.parent.name;
		var ppvid = object.parent.parent.visible_id;
		var ppname = object.parent.parent.name;
		var buyPriceKey = GACommonUtils.getBuyPrice(object);
		var cost = StoreUtil.getPrice(buyPriceKey);
		var type = StoreUtil.getCurrency(buyPriceKey);
		Core.Analytics.reportPlayerStateChange("Transaction",{"ItemName":itemName},{"ItemID":itemID+'',"CatID":pvid+'',"CatName":pname+'',"StoreID":ppvid+'',"StoreName":ppname,"Currency":type,"Price":cost+'',"Quantity":1+'',"Level":TFGameState.getCurrentUser().getCurrentLevel()+''});
	},
	
	logEvent : function (eventType) {
		if(this.isDazzle()) {
			this.logDazzleEvent(eventType);
		}
		else {
			this.logAnalyticsEvent(eventType);
		}
	},
	
	logDazzleEvent: function(eventType){
		var objEvent = new GAEventsModel();
		
		objEvent.setEventType(eventType + '');
		console.log('Dazzle User Id = ' + GAConfigurations.getUserId());
		objEvent.setUserId(GAConfigurations.getUserId() + '');
		objEvent.setUserLevel(TFGameState.getCurrentUser().getCurrentLevel() + '');
		objEvent.setPCurrBal(TFGameState.getCurrentUser().getCoins() + '');
		objEvent.setSCurrBal(TFGameState.getCurrentUser().getBucks() + '');
		
		var date = new Date();
		objEvent.setTs(date.getTime()/1000);
		
		GADazzleHandler.logEvent(objEvent);
	},
	
	logAnalyticsEvent : function (eventType) {
		Core.Analytics.reportGameEvent(eventType,{"username":GAConfigurations.getUserId()},{"level":TFGameState.getCurrentUser().getCurrentLevel(),"PCurrBal":TFGameState.getCurrentUser().getCoins(),"SCurrBal":TFGameState.getCurrentUser().getBucks()});	
	},
	
	
	logOffer : function (offerType, currency, currencyName, offerId) {
		if(this.isDazzle()) {
			this.logDazzleOffer(offerType, currency, currencyName, offerId);
		}
		else {
			this.logAnalyticsOffer(offerType, currency, currencyName, offerId);
		}
	},
	
	logAnalyticsOffer: function (offerType, currency, currencyName, offerId) {
		Core.Analytics.reportPlayerStateChange(offerType,{"CurrencyName":currencyName},{"Currency":currency+'',"OfferId":offerId+'',"Level":TFGameState.getCurrentUser().getCurrentLevel()+''});
	},
	
	
	logDazzleOffer: function(offerType, currency, currencyName, offerId){
		var objOffer = new GAOffersModel();
		objOffer.setUserId(GAConfigurations.getUserId() + '');
		objOffer.setFireType(offerType);
		objOffer.setUserLevel(TFGameState.getCurrentUser().getCurrentLevel() + '');
		objOffer.setCurrency(currency + '');
		objOffer.setCurrencyName(currencyName + '');
		objOffer.setOfferId(offerId + '');
		
		var date = new Date();
		objOffer.setTs(date.getTime()/1000);
		
		GADazzleHandler.logOffer(objOffer);
	},
	
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI Layers/In App UI/InAppMainView'] = function(){var exports = $MODULE_REGISTRY['Code/UI Layers/In App UI/InAppMainView'] || {}; $MODULE_REGISTRY['Code/UI Layers/In App UI/InAppMainView'] = exports; /**
 * Filename: InAppMainView.js
 * Author: Sunilla Sarfraz
 * Date Created: --
 * Date Updated: --
 */

exports.InAppMainView = UI.View.subclass({
	
	classname: 'InAppMainView',
	
	initialize: function($super,isBucks){
		
		$super();
		this._isBucks = isBucks ;
		this.setFrame([TFUtil.getAdjustedY(0),TFUtil.getAdjustedX(0),TFUtil.getAdjustedY(GACommonUtils.getScreenWidth()),TFUtil.getAdjustedX(GACommonUtils.getScreenHeight())])
        this.setBackgroundColor("000077BC");
        
        this.setOnLoad(this.loadView.bind(this));
	},
	
	loadView: function() {
		this.addBackground();
		this.addFrontBackground();								 
        this.addCloseBtn();
        this.addTopLabel();
 
        /****** IMPORTANT :::: ADD THIS BUTTON TO SHOW MOBA COINS BALANCE **********************/

        var mobageButtonFrame = new UI.ViewGeometry.Rect(TFUtil.getAdjustedY(480/2 -215), TFUtil.getAdjustedX(261), TFUtil.getAdjustedY(100), TFUtil.getAdjustedX(35));
        GAInAppPurchaseHandler.showMobageBalanceButton(mobageButtonFrame);

            // In App Table View Starts here...! 
            
        this._tableView = new InAppTableView(this._isBucks);
        this.addChild(this._tableView);
	},
	
	
	 addBackground: function()
    {   
		 var background = new UIFactory.getImage([TFUtil.getAdjustedY(20),TFUtil.getAdjustedX(20),TFUtil.getAdjustedY(440),TFUtil.getAdjustedX(280)],"./Content/images/InAppWindow/inAppbackground.png",null,null,null);
        this.addChild(background);
    },
    
	 addFrontBackground: function()
	{   
		var frontBackground = new UIFactory.getImage([TFUtil.getAdjustedY(55),TFUtil.getAdjustedX(30),TFUtil.getAdjustedY(370),TFUtil.getAdjustedX(230)],"./Content/images/InAppWindow/buy-fish-bucks-background.png",null,null,null);
		this.addChild(frontBackground);
	},			
										 
    addCloseBtn: function()
    {
    	var closeBtn = new UIFactory.getGenericButton([TFUtil.getAdjustedY(440), TFUtil.getAdjustedX(20), TFUtil.getAdjustedY(32), TFUtil.getAdjustedX(32)],"./Content/images/Store/cross_normal.png","./Content/images/UIPanels/StoreUI/cross_selected.png",null,null,null,this);
		this.addChild(closeBtn);
		
		closeBtn.onclick = function ()
    	{
    		GAInAppPurchaseHandler.hideMobageBalanceButton();
   			this.getParent().removeFromParent();
			this.getParent().destroy();
   		}; 
    },
    
    addTopLabel: function()
    {
    	var storeLabel;
    	  if (this._isBucks)
    	  	storeLabel = new UIFactory.getTextArea([TFUtil.getAdjustedY(110), TFUtil.getAdjustedX(25), TFUtil.getAdjustedY(250), TFUtil.getAdjustedX(45)],GALocalizationHandler.getLocalizedString('TF_BUY_FISHBUCKS_LABEL'),TFUtil.getAdjustedFontSize(100));
		  else
		  	storeLabel = new UIFactory.getTextArea([TFUtil.getAdjustedY(110), TFUtil.getAdjustedX(25), TFUtil.getAdjustedY(250), TFUtil.getAdjustedX(45)],GALocalizationHandler.getLocalizedString('TF_BUY_FISHCOINS_LABEL'),TFUtil.getAdjustedFontSize(100));
		  storeLabel.setTextColor("FFFFFFFF");
		  this.addChild(storeLabel);
    },
    
    setStoreBottomText: function(text)
    {
    	//this._storeLabel.setText(text);
    },
	
	destroy: function($super)
	{
		
		TFUtil.destroyView(this);
		$super();
	}
    
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI Layers/In App UI/InAppTableView'] = function(){var exports = $MODULE_REGISTRY['Code/UI Layers/In App UI/InAppTableView'] || {}; $MODULE_REGISTRY['Code/UI Layers/In App UI/InAppTableView'] = exports; /**
 * Filename: InAppTableView.js
 * Author: Sunilla Sarfraz
 * Date Created: --
 * Date Updated: --
 */
exports.InAppTableView = UI.ListView.subclass({
	
	classname: 'InAppTableView',
	
	initialize : function($super,isBucks)
	{
		$super();
        if (isBucks)
        	this._tableDataForVerifiedIAP = GAGameLoader.getStoreHandler().getAllItems(TF_CURRENCY_STORE_ID,TF_BUCKS_CAT_ID,true);
        else
        	this._tableDataForVerifiedIAP = GAGameLoader.getStoreHandler().getAllItems(TF_CURRENCY_STORE_ID,TF_COINS_CAT_ID,true);
		this._pageNumber = 0;
		this._index = 0;
		
		this.setFrame([TFUtil.getAdjustedY(50),TFUtil.getAdjustedX(45),TFUtil.getAdjustedY(480-100),TFUtil.getAdjustedX(320-120)]);

		var area = new UI.ViewGeometry.Rect(0, 0, GACommonUtils.getScreenWidth(), GACommonUtils.getScreenHeight());
	
		this._items = new Array();
		var rows = this.numberOfRows() , index = 0;
				
		for (i = 0; i < rows; i++) {
				
            if(i < rows-1 )
            {
                index = i;
                this._index++;
            
            } 
            else 
            {  
                index = -1;
            }
				
            var item = new InAppTableViewCell(index,this, isBucks);
            this._items.push(item);
        }
            
        this._listSection = new UI.ListViewSection({///equivalent of numberOfRowsInSection
            'rowHeight': TFUtil.getAdjustedX(50),///equivalent of heightForRowAtIndexPath
            'items': this._items
        })
		this.setSections([this._listSection]);
		this._isBucks = isBucks ;
		UI.Window.document.addChild(this);
	},
	
	numberOfRows: function()
	{
        this._numItems = this.itemCountForCurrentPage();
		return this._numItems+1;
	},
	
	itemCountForCurrentPage : function()
	{
		var totalProducts = this.totalInAppProducts();

		var alreadyShown = this._pageNumber * PRICE_POINTS_PER_PAGE
		var leftToBeShown = totalProducts - alreadyShown;
		
		if(leftToBeShown >= PRICE_POINTS_PER_PAGE) {
			return PRICE_POINTS_PER_PAGE; 
		}
		else {
			return leftToBeShown;
		}
	
	},
	
	totalInAppProducts: function()
	{
		return this._tableDataForVerifiedIAP.length;
	},
	
	moreButtonPressed: function()
	{
		if(this._index >= this.totalInAppProducts() )
		{
			this._index = 0;
			this._pageNumber = 0;
		}
		else if( this._index < this.totalInAppProducts() )
		{
			this._pageNumber = this._pageNumber + 1;
		}
		var i = 0 , itemsCount = this.numberOfRows();
		this.temp = 0 , index = 0, cell = null;
	
		this._listSection.flush();
        
        if(this._items) {
            var length = this._items.length;
    		for (; this.temp < length; this.temp++)
            {
        		cell = this._items.pop();
        		cell.destroy();
        	}
    	}
    	delete this._items;
		this._items = null;
        
        this._items = new Array();
		
		for(; i < itemsCount ; i++)
		{
		
			if(i < itemsCount-1 )
			{
				index = this._index;
				this._index++;
			}
			else
			{  
				index = -1 // -1 index for more button
			}
			var item = new InAppTableViewCell(index,this, this._isBucks);
            this._items.push(item);
			
		}
		
		this._listSection.setItems(this._items);
		this.setSections([this._listSection]);		
		
	},
	
	
	
	destroy: function($super)
    {    
        if(this._items) {
            var length = this._items.length;
    		for (; this.temp < length; this.temp++)
            {
        		cell = this._items[this.temp];
        		cell.destroy();
        	}
    	}
    	delete this._items;
		this._items = null;
        
		if(this._listSection)
		{
			this._listSection.flush();
			this._listSection = null;
		}
		$super();
	}
});



; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI Layers/In App UI/InAppTableViewCell'] = function(){var exports = $MODULE_REGISTRY['Code/UI Layers/In App UI/InAppTableViewCell'] || {}; $MODULE_REGISTRY['Code/UI Layers/In App UI/InAppTableViewCell'] = exports; /**
 * Filename: InAppTableViewCell.js
 * Author: Sunilla Sarfraz
 * Date Created: --
 * Date Updated: --
 */
exports.InAppTableViewCell = UI.ListViewItem.subclass({
	
	classname: 'InAppTableViewCell',
	
	initialize : function($super,index,param, isBucks){
        $super("InAppCell");
		this._parent = param;
		this._index = index;
		this._buttonEnabled = true;
		this._isBucks = isBucks ;
	},
	
	
    _onCreateView: function() 
	{
		var cellView = new CustomCellView();
		
//        cellView.cellBg = new UI.Image();
//		cellView.cellBg.setImage('./Content/images/InAppWindow/bar-center.png');
//		cellView.cellBg.setFrame([TFUtil.getAdjustedY(15),TFUtil.getAdjustedX(20),TFUtil.getAdjustedY(350),TFUtil.getAdjustedX(60)]);
//		cellView.cellBg.setImageFit(UI.ViewGeometry.FitModes.Stretch);
//		cellView.addChild(cellView.cellBg);
		
		cellView.cellBg = new UI.Button();
        cellView.cellBg.setAlpha(1);
//        cellView.cellBg.setText(GALocalizationHandler.getLocalizedString('TF_IN_APP_BUY'));
        cellView.cellBg.setTextColor("FFFFFF");
        cellView.cellBg.setImage("./Content/images/InAppWindow/bar-center.png",UI.State.Normal);
        cellView.cellBg.setImage("./Content/images/InAppWindow/bar-center-selected.png",UI.State.Focused);
        cellView.cellBg.setImageFit(UI.ViewGeometry.FitModes.Stretch);
        //cellView._buyButton.setText(GALocalizationHandler.getLocalizedString('TF_IN_APP_BUY'));
       // cellView._buyButton.setTextColor("5E2605");
        //cellView._buyButton.setTextGravity(UI.ViewGeometry.Gravity.Center);
		cellView.cellBg.setFrame([TFUtil.getAdjustedY(15),TFUtil.getAdjustedX(20),TFUtil.getAdjustedY(350),TFUtil.getAdjustedX(60)]);
        cellView.addChild(cellView.cellBg);
			
	
        cellView.bucksOrCoinsImage = new UI.Image();
        cellView.bucksOrCoinsImage.setFrame([TFUtil.getAdjustedY(15),TFUtil.getAdjustedX(25),TFUtil.getAdjustedY(27),TFUtil.getAdjustedX(16)]);
        cellView.addChild(cellView.bucksOrCoinsImage);
    
    	cellView._nameLabel = new UI.Label();
        cellView._nameLabel.setTextGravity(UI.ViewGeometry.Gravity.Left);
        cellView._nameLabel.setTextColor('ffffff');
        cellView._nameLabel.setTextFont('Arial-BoldMT');
        cellView._nameLabel.setTextSize(13);
        cellView._nameLabel.setFrame([TFUtil.getAdjustedY(50), TFUtil.getAdjustedX(25), TFUtil.getAdjustedY(90), TFUtil.getAdjustedX(18)]);
        cellView.addChild(cellView._nameLabel);
      	
      	cellView._costLabel = new UI.Label();
        cellView._costLabel.setTextGravity(UI.ViewGeometry.Gravity.Left);
        cellView._costLabel.setTextColor('FBB917');
        cellView._costLabel.setTextFont('Arial-BoldMT');
        cellView._costLabel.setTextSize(12);
        cellView._costLabel.setFrame([TFUtil.getAdjustedY(220), TFUtil.getAdjustedX(25), TFUtil.getAdjustedY(100), TFUtil.getAdjustedX(18)]);
        cellView.addChild(cellView._costLabel);
        
        cellView._costLabel2 = new UI.Label();
        cellView._costLabel2.setTextGravity(UI.ViewGeometry.Gravity.Left);
        cellView._costLabel2.setTextColor('FBB917');
        cellView._costLabel2.setTextFont('Arial-BoldMT');
        cellView._costLabel2.setTextSize(12);
        cellView._costLabel2.setFrame([TFUtil.getAdjustedY(255), TFUtil.getAdjustedX(25), TFUtil.getAdjustedY(100), TFUtil.getAdjustedX(18)]);
        cellView.addChild(cellView._costLabel2);
    
    
        cellView.line = new UI.Image();
		cellView.line.setTouchable(false);
		cellView.line.setImage("./Content/images/Store/storetableimgs/black_dot.png",UI.State.Normal);
		cellView.line.setFrame([TFUtil.getAdjustedY(215),TFUtil.getAdjustedX(33),TFUtil.adjustHeightWithDevice(35),TFUtil.adjustWidthWithDevice(2)]);
		cellView.line.setImageFit(UI.ViewGeometry.FitModes.Stretch);
		cellView.line.setVisible(true);
		cellView.addChild(cellView.line);
		 
        cellView._buyButton = new UI.Button();
        cellView._buyButton.setAlpha(1);
        cellView._buyButton.setText(GALocalizationHandler.getLocalizedString('TF_IN_APP_BUY'));
        cellView._buyButton.setTextColor("FFFFFF");
        cellView._buyButton.setImage("./Content/images/UIPanels/Buttons/1buttonNormal.png",UI.State.Normal);
        cellView._buyButton.setImageFit(UI.ViewGeometry.FitModes.Stretch);
        //cellView._buyButton.setText(GALocalizationHandler.getLocalizedString('TF_IN_APP_BUY'));
       // cellView._buyButton.setTextColor("5E2605");
        //cellView._buyButton.setTextGravity(UI.ViewGeometry.Gravity.Center);
        cellView._buyButton.setFrame([TFUtil.getAdjustedY(280),TFUtil.getAdjustedX(20),TFUtil.getAdjustedY(56),TFUtil.getAdjustedX(28)]);
        cellView.addChild(cellView._buyButton);
    
    
        cellView._BigButton = new UI.Button();
        cellView._BigButton.setTextGravity(UI.ViewGeometry.Gravity.Center);
        cellView._BigButton.setFrame([TFUtil.getAdjustedY(0),TFUtil.getAdjustedX(25),TFUtil.getAdjustedY(430),TFUtil.getAdjustedX(45)]);
        cellView._BigButton.setNormalGradient({ corners: '8 8 8 8', outerLine: "00 1.5", gradient: [ "FF9bd6f4 0.0", "FF0077BC 1.0" ] });
        cellView._BigButton.setAlpha(0.02);
        cellView.addChild(cellView._BigButton);
        
        return cellView;
	},


	_onSetView: function(cellView) {
    
        if(this._index > -1)
        {
            var ip = this.pricePointAtIndex(this._index);
	        var name = ip.name;
	        var originalCost = ip.custom_attributes.cost_string;
	        var type = ip.active_bucket;
	        var buyPrice = 0;
	     
	        if(ip.buy_prices != undefined || ip.buy_prices != null) {
	        	var prices = ip.buy_prices["default"];
		        var originalCost = StoreUtil.getPrice(prices);
		        var buyPriceKey = GACommonUtils.getBuyPrice(ip);
		        var buyPrice = StoreUtil.getPrice(buyPriceKey);
	        }
	        else {
	        	buyPrice = originalCost;
	        }
            
            cellView._nameLabel.setText(name);
            cellView._nameLabel.setFrame([TFUtil.getAdjustedY(50), TFUtil.getAdjustedX(25), TFUtil.getAdjustedY(130), TFUtil.getAdjustedX(18)]);
            cellView._costLabel.setFrame([TFUtil.getAdjustedY(160), TFUtil.getAdjustedX(25), TFUtil.getAdjustedY(100), TFUtil.getAdjustedX(18)]);
            if( buyPrice == originalCost) {
            	 cellView._costLabel.setText(buyPrice+" "+Core.Localization.getString("TF_MOBACOIN"));
                 cellView.line.setVisible(false);
                 cellView._costLabel2.setVisible(false);
            }
            else {
            	 cellView._costLabel.setText(originalCost);
            	 cellView._costLabel2.setText(buyPrice+" "+Core.Localization.getString("TF_MOBACOIN"));
                 cellView.line.setVisible(true);
                 cellView._costLabel2.setVisible(true);
            }
            
            if (this._isBucks)
            	cellView.bucksOrCoinsImage.setImage('./Content/images/UIPanels/storewindow/bucks.png');
            else
            	cellView.bucksOrCoinsImage.setImage('./Content/images/UIPanels/storewindow/coins.png');
            cellView.bucksOrCoinsImage.setVisible(true);
            
        
            
            cellView.cellBg.setOnClick(this.buyButtonAction.bind(this));
            cellView.cellBg.setVisible(true);
            cellView._buyButton.setVisible(true);
            cellView._BigButton.setVisible(false);
        } 
        else 
        {   
													  
			cellView.bucksOrCoinsImage.setVisible(false);
			
            cellView._nameLabel.setText(GALocalizationHandler.getLocalizedString('TF_MORE_LABEL'));
            cellView._nameLabel.setFrame([TFUtil.getAdjustedY(480/2 - 75), TFUtil.getAdjustedX(25), TFUtil.getAdjustedY(50), TFUtil.getAdjustedX(18)]);
            
            cellView._costLabel.setText("");
            cellView._costLabel.setFrame([TFUtil.getAdjustedY(0), TFUtil.getAdjustedX(0), TFUtil.getAdjustedY(0), TFUtil.getAdjustedX(0)]);
            cellView.cellBg.setVisible(true);
            cellView.line.setVisible(false);
            cellView._buyButton.setVisible(false);
            cellView._BigButton.setVisible(true);
            cellView._BigButton.onclick = this.moreButtonClicked.bind(this);
        }
	},
    
    moreButtonClicked: function() {
        this._parent.moreButtonPressed();
    },
	
	buyButtonAction: function()
	{
		var user = TFGameState.getCurrentUser();
		if (this._isBucks)
		{
			if( user.getBucks() >= TF_MAX_USER_BUCKS)
			{
				this.testUIAlert = new TFMiniUIAlertView(Core.Localization.getString("message"),TFUtil.getRelativeString(Core.Localization.getString("TF_ALREADY_MAX_BUCKS"),["bucks"]),this,null,"Ok");
				this.testUIAlert.setType("ok");
				this.testUIAlert.setTitleFont(TFUtil.getFontName());
				this.testUIAlert.setMessageFont(TFUtil.getFontName());
				this.testUIAlert.setButtonsFont(TFUtil.getFontName());
				this.testUIAlert.show();
				return;
			}
		}
		else
		if( user.getCoins() >= TF_MAX_USER_COINS)
			{
				this.testUIAlert = new TFMiniUIAlertView(Core.Localization.getString("message"),TFUtil.getRelativeString(Core.Localization.getString("TF_ALREADY_MAX_BUCKS"),["coins"]),this,null,"Ok");
				this.testUIAlert.setType("ok");
				this.testUIAlert.setTitleFont(TFUtil.getFontName());
				this.testUIAlert.setMessageFont(TFUtil.getFontName());
				this.testUIAlert.setButtonsFont(TFUtil.getFontName());
				this.testUIAlert.show();
				return;
			}
		
		if(this._buttonEnabled)
		{
            this._buttonEnabled = false;
			var ip = this.pricePointAtIndex(this._index);
			var inAppItemId = ip.custom_attributes.product_identifier;
	      	var callbackMethod = this.myMethodForInAppCallback.bind(this);
			GAInAppPurchaseHandler.performInAppWithItemIdAndCallback(inAppItemId, callbackMethod);
			
		}
		
	},
	
	closeMobaCoinsWindow:function()
	{
		GAInAppPurchaseHandler.hideMobageBalanceButton();
		this._parent.getParent().removeFromParent();
		this._parent.getParent().destroy();		
	},
	
	myMethodForInAppCallback: function(errorMsg)
	{
		if(!errorMsg)
		{
			var ip = this.pricePointAtIndex(this._index);
			var user = TFGameState.getCurrentUser();
			var bucksToAward = ip.custom_attributes.price_point_reward;
			var eventType = null;
			var rewardType = null;
			if(LogHandler.isDazzle()) {
				eventType = GADazzleOfferType.InAppPurschase;
			}
			else {
				eventType = "InAppPurschase";
			}
			if (this._isBucks)
			{
				rewardType = 'bucks';
				user.updateCurrency(kOperationType.kOperationAddBucks,bucksToAward);
            	GameLayer.getControlLayer().getControlLayerAbove().updateBucksLabel() ;
			}
			else
			{
				rewardType = 'coins';
				user.updateCurrency(kOperationType.kOperationAddCoins,bucksToAward);
            	GameLayer.getControlLayer().getControlLayerAbove().updateCoinsLabel() ;
			}
			
			LogHandler.logOffer(eventType, bucksToAward, rewardType, '');
			
			TBParticleAnimation.getSnowParticleAnimation();
			if (this._isBucks)
				this.testUIAlert = new TFMiniUIAlertView("",GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_INAPP_SUCCESSFUL'),[bucksToAward, "bucks"]),this,null,GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
			else
				this.testUIAlert = new TFMiniUIAlertView("",GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_INAPP_SUCCESSFUL'),[bucksToAward, "coins"]),this,null,GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
			this.testUIAlert.setType("ok");
			this.testUIAlert.setMessageColor("ffffff");	
			this.testUIAlert.setTitleFont(TFUtil.getFontName());
			this.testUIAlert.setMessageFont(TFUtil.getFontName());
			this.testUIAlert.setButtonsFont(TFUtil.getFontName());
			this.testUIAlert.setButtonColor('ffffff');
			this.testUIAlert.show();
			this._buttonEnabled = true;
			this.closeMobaCoinsWindow();
		}
		else
		{
			if(errorMsg.showAlert == true)
			{
				//NgLogE(errorMsg.description);
				this._buttonEnabled = true;
			}
			
		}
	},
    
    clickedButtonAtIndex: function(buttonIndex,alerWindow)
	{
	
		if (buttonIndex == 0) {
	        // Do it!
	       
		} else if (buttonIndex == 1) {
	        // Cancel
	        //NgLogE("Cancel button clicked");
		}
	
	},

    pricePointAtIndex: function(index)
    {
        return this._parent._tableDataForVerifiedIAP[index];
    },	

	destroy: function(){
		if(this.testUIAlert)
		{
			this.testUIAlert.destroy();
			this.testUIAlert = null;
		}
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI Layers/In App UI/TZIAPManager'] = function(){var exports = $MODULE_REGISTRY['Code/UI Layers/In App UI/TZIAPManager'] || {}; $MODULE_REGISTRY['Code/UI Layers/In App UI/TZIAPManager'] = exports; /**
 * Filename: TZIAPManager.js
 * Author: Sunilla Sarfraz
 * Date Created: --
 * Date Updated: --
 */
exports.TZIAPManager = Core.Class.subclass(
{
	initialize: function(type)
	{
		if(type == TF_COINS)
		{
			NgLogE("coins InApp");
			var inAppMainView = new InAppMainView(false); //false indicate that the menu is not for bucks.
			NGWindow.document.addChild(inAppMainView);
		}
		else{
			var inAppMainView = new InAppMainView(true); //true indicate that the menu is for bucks.
			NGWindow.document.addChild(inAppMainView);
		}
	},
	
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI Layers/StoreScreen/StoreMainView'] = function(){var exports = $MODULE_REGISTRY['Code/UI Layers/StoreScreen/StoreMainView'] || {}; $MODULE_REGISTRY['Code/UI Layers/StoreScreen/StoreMainView'] = exports; exports.StoreMainView = UI.View.subclass(
{
    className: "StoreMainView",
    initialize: function($super) 
    {
    	$super();
    	this._storeType = TFStoreType.kDefault;
        this.setFrame([TFUtil.getAdjustedY(0),TFUtil.getAdjustedX(0),TFUtil.getAdjustedY(GACommonUtils.getScreenWidth()),TFUtil.getAdjustedX(GACommonUtils.getScreenHeight())]);
        this.setBackgroundColor("000077BC");
        this.setOnLoad(this.loadView.bind(this));
    },
    
    loadView: function() {
    	 this.addBackground();
         this.addCloseBtn();
         this.addBottomLabel();
         this.isButtonCloseClicked = false;
         this.addBackBtn();
         this._tableView = new StoreGenericTableView();
         this._tableView.setStoreType(this._storeType);
         this._tableView.setParentMainView(this);
         this.addMainBackButton();
         
         this.addChild(this._tableView);
        
//         if(GameLayer._mobclixState)
//         {
			var incX = 0;
     		var incY = 0;
   
		      if(SCREEN_ASPECT_RATIO == AspectRatios.Ratio171)
		      {
		      	  incX = 30; 
      	 incY = 4;
		      }
		      else if (SCREEN_ASPECT_RATIO == AspectRatios.Ratio160)
		      {
		      	incX = 82; 
      	 incY = 20;
		      }
			GAMobclixForView.show(TFUtil.getAdjustedY(96 + incX),TFUtil.getAdjustedX(245 + incY));
//			this.addChild(this._mobclix);
//         }
         
    },
    
    addBackground: function()
    {
		var background = new UI.Image();
        background.setImage("./Content/images/UIPanels/storewindow/storeBG.png",UI.State.Normal);
        background.setFrame([TFUtil.getAdjustedY(30),TFUtil.getAdjustedX(20),TFUtil.getAdjustedY(420),TFUtil.getAdjustedX(300)]);
        background.setImageFit(UI.ViewGeometry.FitModes.Stretch);
        this.addChild(background);
    },
    
    addCloseBtn: function()
    {
    	var closeBtn = new UI.Button();

		closeBtn.setImage("./Content/images/UIPanels/Buttons/cross1.png",UI.State.Normal);
		closeBtn.setImage("./Content/images/UIPanels/Buttons/cross2.png",UI.State.Selected);
		closeBtn.setFrame([TFUtil.getAdjustedY(430), TFUtil.getAdjustedX(20), TFUtil.getAdjustedY(30), TFUtil.getAdjustedX(30)]);
		this.addChild(closeBtn);
		closeBtn.onclick = function ()
    	{
//    		console.log('aleeeeeeem remove');
//    		this.removeChild(this._mobclix);
			GAMobclixForView.removeAd();
			if(this.isButtonCloseClicked)
				return;
			this.isButtonCloseClicked = true;
			this.getParent().removeFromParent();
			//this.getParent().destroy();
   		}; 
    },
    
    addBottomLabel: function()
    {
    	this._storeLabel = new UI.Label();
    	//this._storeLabel.setText("Store");
    	this._storeLabel.setFrame([TFUtil.getAdjustedY(480/2 - 104), TFUtil.getAdjustedX(25), TFUtil.getAdjustedY(197), TFUtil.getAdjustedX(30)]);
    	this._storeLabel.setTextGravity(UI.ViewGeometry.Gravity.Center);
    	this._storeLabel.setTextColor('001A33');
    	this._storeLabel.setTextFont(TFUtil.getFontName());
    	this._storeLabel.setTextSize(18);
		//this._storeLabel.setBackgroundColor("FF000000");
    	this.addChild(this._storeLabel);
    	if(TFStorageManager.getValueFromUserDefault("storeWindowOption") == "egg"){
    		this.setStoreBottomText(GALocalizationHandler.getRelativeString(Core.Localization.getString('TF_STORE'),["Fish Eggs"]));
    	}else{
    		this.setStoreBottomText(GALocalizationHandler.getRelativeString(Core.Localization.getString('TF_STORE'),["Store"]));
    	}
    	//this.setStoreBottomText('Store');
    },
    
    addBackBtn:function()/// only makes it but with alpha 0, means hidden
	{
	this.backBtn = new UI.Button();
	//this.backBtn.setText(Core.Localization.getString('TF_BACK_LABEL'));
	this.backBtn.setTextColor("FFFFFF");
	this.backBtn.setTextFont(TFUtil.getFontName());
	this.backBtn.setText(GALocalizationHandler.getLocalizedString('TF_BACK_LABEL'));
	this.backBtn.setImage("./Content/images/UIPanels/Buttons/1buttonNormal.png",UI.State.Normal);
	this.backBtn.setImage("./Content/images/UIPanels/Buttons/1buttonSelected.png",UI.State.Selected);
	this.backBtn.setImageFit(UI.ViewGeometry.FitModes.Stretch);
	this.backBtn.setFrame([TFUtil.getAdjustedY(45), TFUtil.getAdjustedX(34), TFUtil.getAdjustedY(58), TFUtil.getAdjustedX(22)]);
		
	this.addChild(this.backBtn);
	this.disableAndHideBackButton();
	this.backBtn.onclick = function ()
	{
	  this._tableView.backButtonAction();//[table backButtonAction];
		}.bind(this);
		
},

addMainBackButton:function()
{
	this.mainBackBtn = new UI.Button();
	this.mainBackBtn.setTextColor("FFFFFF");
	this.mainBackBtn.setTextFont(TFUtil.getFontName());
	this.mainBackBtn.setText(GALocalizationHandler.getLocalizedString('TF_BACK_LABEL'));
	this.mainBackBtn.setImage("./Content/images/UIPanels/Buttons/1buttonNormal.png",UI.State.Normal);
	this.mainBackBtn.setImage("./Content/images/UIPanels/Buttons/1buttonSelected.png",UI.State.Selected);
	this.mainBackBtn.setImageFit(UI.ViewGeometry.FitModes.Stretch);
	this.mainBackBtn.setFrame([TFUtil.getAdjustedY(45), TFUtil.getAdjustedX(34), TFUtil.getAdjustedY(58), TFUtil.getAdjustedX(22)]);
	this.addChild(this.mainBackBtn);
	this.disableMainBackButton();
	this.mainBackBtn.setOnClick(this.openStoreWindow.bind(this)); 
},

    
    openStoreWindow:function()
    {
    	if(this.isButtonCloseClicked)
			return;
    	this.isButtonCloseClicked = true;
		this.removeFromParent();
		this.destroy();
		
    	GameLayer.getControlLayer().onTouchStore();
    },
    
    hideBackBtn:function(){
    	this.backBtn.setState(UI.State.Selected);
    },
	
	setStoreBottomText: function(text)
    {
    	this._storeLabel.setText(text);
    },
    
    enableAndShowBackBtn:function()
    {
		this.backBtn.setEnabled(true);
    	//this.backBtn.setAlpha(1);
    	this.backBtn.setVisible(true);
	},
	
	enableAndShowMainBackBtn:function()
    {
		this.mainBackBtn.setEnabled(true);
    	//this.mainBackBtn.setAlpha(1);
    	this.mainBackBtn.setVisible(true);
	},
    
    disableAndHideBackButton:function()
    {
		this.backBtn.setEnabled(false);
    	//this.backBtn.setAlpha(0.03);
    	this.backBtn.setVisible(false);
    },
    
    disableMainBackButton:function()
    {
    	this.mainBackBtn.setEnabled(false);
    	//this.mainBackBtn.setAlpha(0.03);
    	this.mainBackBtn.setVisible(false);
    },
    
    setStoreType:function(type)
    {
    	this._storeType = type;
    },
    
    destroy: function($super)
    {
//    	if(GameLayer._mobclixState)
//    	{
//    		this.removeChild(this._mobclix);
			GAMobclixForView.removeAd();
//    	}
    	if(this._tableView.sortedVisibleIDs){
    		this._tableView.sortedVisibleIDs.destroy();
    		this._tableView.sortedVisibleIDs = null;
    	}
    	TFUtil.destroyView(this);
    	
    	$super();
    },
    
});





; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI Layers/StoreScreen/StoreUtil'] = function(){var exports = $MODULE_REGISTRY['Code/UI Layers/StoreScreen/StoreUtil'] || {}; $MODULE_REGISTRY['Code/UI Layers/StoreScreen/StoreUtil'] = exports; /**
 * Filename: Main.js
 * Author: Wasay Abbasi
 * Date Created: 25th May-2011
 * Date Updated: 
 */

exports.StoreUtil = Core.Class.singleton(
{
	
    classname:'StoreUtil',	//static class
    
    $getPrice: function(itemArray)
		{				 
			if(itemArray.fishbucks == 0 | itemArray.fishbucks == null || typeof itemArray.fishbucks == 'undefined')
			{
				if(itemArray.coins != null )
				{
					return itemArray.coins;
				}
			}
			else
			{
				return itemArray.fishbucks;
			}
			return itemArray.coins;//Will never return as atleast one price point will be there
		},
		
	    $getPriceBreeded: function(itemArray)
		{
//			if(itemArray.fishbucks == 0 | itemArray.fishbucks == null || typeof itemArray.fishbucks == 'undefined')
//			{
				if(itemArray.coins != null )
				{
					return itemArray.coins;
				}
//			}
			else
			{
				0;
//				return itemArray.fishbucks;
			}
//			return itemArray.coins;//Will never return as atleast one price point will be there
		},
    
    $getCurrency: function(itemArray)
    {
    	if(itemArray.fishbucks == 0 | itemArray.fishbucks == null || typeof itemArray.fishbucks == 'undefined')
			{
				if(itemArray.coins != null )
				{
					return  kCurrencyType.kCurrencyTypeCoins;
				}
			}
        return kCurrencyType.kCurrencyTypeBucks;
    },
	
		checkPricingForItemNew:function(store_item)
		{
				var buyPriceKey = GACommonUtils.getBuyPrice(store_item) , i =0;
				var buyPrice = StoreUtil.getPrice(buyPriceKey);
				var currency = StoreUtil.getCurrency(buyPriceKey);
				if(currency == kCurrencyType.kCurrencyTypeCoins) 
				{
					if(buyPrice >= 0)
					{
						var userCoins = TFGameState.getCurrentUser().getCoins();
						if(userCoins >= buyPrice)
						{
							return "1|1";
						} 
						else
						{
							return "0|1";
						}
					}
				} 
				else 
				{
					if(buyPrice > 0) 
					{
						var userBucks = TFGameState.getCurrentUser().getBucks();
						if(userBucks >= buyPrice) 
						{
							return "1|2";
						}
						else 
						{
							return "0|2";
						}
					}
				}
				return "0|0";
		},
	$getStoreObjectType: function(storeObject)
	{		
			if(storeObject) 
			{
				 if(typeof storeObject.custom_attributes.levelrequired == 'undefined' || typeof storeObject.custom_attributes.levelrequired == null)
				 {
					 storeObject.custom_attributes.levelrequired = 0;
				 }
				
				if(typeof storeObject.custom_attributes.levelrequired != 'undefined') {
					var storeVisibleId = storeObject.parent.parent.visible_id;
										 
					//console.log("storeVisibleId " + storeVisibleId);				
					if(storeVisibleId) 
					{
						if(storeVisibleId == '1') 
						{
							return kObjectType.kObjectBackground;
						}
						else if(storeVisibleId == '5' || storeVisibleId == '2') 
						{
							return kObjectType.kObjectFish;
						}
						else  if(storeVisibleId == '4')
						{
							return kObjectType.kObjectDecoration;
						}
						else if(storeVisibleId == '6')
						{
							return kObjectType.kObjectPlant;
						}
						else if(storeVisibleId == '7')
						{
						    return kObjectType.kObjectFoodBrick;
						}				 
				
					}
				}
			}
	},


    
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI Layers/StoreScreen/StoreGenericTableView'] = function(){var exports = $MODULE_REGISTRY['Code/UI Layers/StoreScreen/StoreGenericTableView'] || {}; $MODULE_REGISTRY['Code/UI Layers/StoreScreen/StoreGenericTableView'] = exports; exports.StoreGenericTableView = UI.ListView.subclass(
{
    className: "StoreGenericTableView",
        
    initialize: function($super) 
    {
    	$super();
        this._level = 1;
        this.sections = null;
        this.storeItems = null;
        this.store_cats_items = '';
        this.item_store_id = ""; // this constitutes the item's store id to be stored with the model object
        this._ParentMainView = null;
        this._storeId = -1;// it is keeping the track while coming back from higher level cell(e.g 3) to lower level cell(e.g 2) that which store was previously chosen
        this.sortedVisibleIDs = null;
        this.listSection  = null;
        this._storeType = TFStoreType.kDefault;
                    
       if(GAMobclixForView._state)
		{
			 this.setFrame([TFUtil.getAdjustedY(50),TFUtil.getAdjustedX(60),TFUtil.getAdjustedY(480-100),TFUtil.getAdjustedX(270-98)]);
		}
		else
		{
        	this.setFrame([TFUtil.getAdjustedY(50),TFUtil.getAdjustedX(60),TFUtil.getAdjustedY(480-100),TFUtil.getAdjustedX(320-98)]);
		}
        this.setOnLoad(this.loadView.bind(this));
    },
    
    loadView: function() {
    	this.generateSortedStoreVisibleIDArray();		
    	this.cellRowDelegates();
    	if(this._storeType == TFStoreType.kFishEggs) {
    		this.didSelectRowAtIndexPath(0);
        }
    	
    	
    },
    
    setStoreType:function(type)
    {
    	this._storeType = type;
    },
	
	generateSortedStoreVisibleIDArray: function()
    {
        var connectResponseObject = GAGameLoader.getResponseObject();
        var array = connectResponseObject.getStoreVisibleIds();	
        var storeModels =  connectResponseObject.getStoresModel();
        var storePositionArray = this.getStorePositionArray(storeModels);
        var sortedArray = this.getSortedVisibleIDsRelevantToPosition(array, storePositionArray);

        this.sortedVisibleIDs = new GAMutableArray(sortedArray);
        //this.sortedVisibleIDs.numericSort();
                                            
        this.sortedVisibleIDs.removeObjectsInRange(5,this.sortedVisibleIDs._length);
    	delete storePositionArray;
		storePositionArray = null;
    
    },
	getStorePositionArray: function(storeModelArray){
		var count = storeModelArray.length, i=0, positionArray = new Array();
		for(; i < count ; i++)
		{
			positionArray.push(storeModelArray[i].getPosition());
			
		}
		return  positionArray;
	},
	getSortedVisibleIDsRelevantToPosition: function(idsArray, positionArray)
	{
		var count = positionArray.length, i = 0, j = 0, replaceIndex = 0;
		for(; i < count - 1 ; i++)
		{ 
			replaceIndex = i;
			for(j = i+1 ; j < count ; j++)
			{
				if( +positionArray[replaceIndex] > +positionArray[j])
				{
					replaceIndex = j;
					
				}
			}
			if(i != replaceIndex)
			{
				var temp1 = idsArray[i];
				idsArray[i] = idsArray[replaceIndex];
				idsArray[replaceIndex] = temp1;
				
				var temp2 = positionArray[i];
				positionArray[i] = positionArray[replaceIndex];
				positionArray[replaceIndex] = temp2;
				
				
			}
		}
		
		return idsArray;
	},

	setParentMainView:function(reference)     
	{
		this._ParentMainView = reference;
	},
	getLevel:function() 				
	{
		return this._level;
	},

	getStore_cats_items:function()				
	{
		return this.store_cats_items;
	},

	getStore_cats_item: function(cat_id) 
	{
		return this.store_cats_items[cat_id]
	},

	getStoreId: function()
	{
		return this.item_store_id;
	},
    
    setSections: function($super, sections)
    {
        $super(sections);
    },
 
    cellForRowAtIndexPath:function(indexPath_Row)
    {
    	return this.createCellForMainStoreTable(indexPath_Row);
    },
    
	createCellForMainStoreTable: function(indexPath_Row)
	{
		
		if(this._level == 1)
		{
            var cellModel = GAGameLoader.getStoreHandler().getStoreObjectForKey(this.sortedVisibleIDs.objectAtIndex(indexPath_Row));
			var cellView = new LevelOneCell("storeCell1",cellModel);
			cellView._setParentTableView(this);
			cellView._setIndexPath_Row(indexPath_Row);
			this._ParentMainView.enableAndShowMainBackBtn();
			this._ParentMainView.disableAndHideBackButton();
			return cellView;
		}
		
		else if(this._level == 2)
		{
			
			var cellModel = this._allCategories[indexPath_Row];
			var cellView = new LevelTwoCell("storeCell2",cellModel);
			cellView._setParentTableView(this);
			cellView._setIndexPath_Row(indexPath_Row);
			this._ParentMainView.enableAndShowBackBtn();
			this._ParentMainView.disableMainBackButton();
			return cellView;
		}
		
		else 
        {
            var cellModel = this.allItems[indexPath_Row];
			var cellView = new LevelThreeCell("storeCell3",cellModel);
			cellView._setParentTableView(this);
			cellView._setIndexPath_Row(indexPath_Row);
			return cellView;
		}
		return null;
		
	},
	
	didSelectRowAtIndexPath:function(indexPath_Row)
	{	
    	
		if(this._level == 3) 
		{
			return;
		}
		if (this._level == 1) 
		{
			this.store_cats_items = "" +this.sortedVisibleIDs.objectAtIndex(indexPath_Row);
			this.item_store_id = this.sortedVisibleIDs.objectAtIndex(indexPath_Row);
			this._indexPath_Row = indexPath_Row;
			this._storeId = this.sortedVisibleIDs.objectAtIndex(indexPath_Row);
													 
            this._level = 2;
			
		}	
		else if (this._level == 2)
		{
			this.store_cats_items = this.store_cats_items + '_' + this._allCategories[indexPath_Row].visible_id;
		
			this.item_store_id = this.item_store_id + "_" + this._allCategories[indexPath_Row].visible_id;
			this._indexPath_Row = indexPath_Row;
            this._level = 3;
	
		}
				
        this.setScrollPosition([0,0]);
		this.cellRowDelegates();
		
	},
    
    cellRowDelegates:function()
    {
    	var temp = 0, cell;
		var noOfCells = 0;
													 
	   	if (this._level == 1)
	   	{ 
            noOfCells = this.sortedVisibleIDs.getLength();
        }
    	else if (this._level == 2)
        { 
            this._allCategories = GAGameLoader.getStoreHandler().getAllCategories(""+this._storeId, true);
            noOfCells = this._allCategories.length;
        }
    	else if (this._level == 3)
		{ 
    		var category = this._allCategories[this._indexPath_Row];
    	
    		var tempArray = GAGameLoader.getStoreHandler().getAllItems(category.parent.visible_id, category.visible_id, true);

    		if(tempArray == null || tempArray == undefined)
    		{
    			return;
    		} else{

    			var lockedArray = new Array();
    			var unlockedArray = new Array();
    			this.allItems = new Array();
    			
    			 for (temp = 0; temp < tempArray.length; temp++)
    			 { 	
    				 
    				 if(this.isItemLocked(tempArray[temp])){
    					 lockedArray.push(tempArray[temp]);
    				 }else{
    					 unlockedArray.push(tempArray[temp]);
    				 }
    		     }
    			 
    			 for(temp=0; temp<unlockedArray.length; temp++){
    				 this.allItems.push(unlockedArray[temp]);
    			 }
    			 for(temp=0; temp<lockedArray.length; temp++){
    				 this.allItems.push(lockedArray[temp]);
    			 }
    			
    		}
    		noOfCells = this.allItems.length;
    	}

	   	this.clearStoreItems();
	   	if(this.listSection) {
	   		this.listSection.flush();
	   		this.listSection = null;
	   	}
	   	this.listSection = new UI.ListViewSection({
			'rowHeight': TFUtil.getAdjustedX(70),
		});
        for (temp = 0; temp < noOfCells; temp++)
		{ 	
			cell = this.createCellForMainStoreTable(temp);	
        	this.storeItems.push(cell);
        }
        this.listSection.setItems(this.storeItems);
        this.setSections([this.listSection]);
    },
    
    clearStoreItems: function () {
    	if(this.storeItems) {
			for (var temp = 0;temp < this.storeItems.length; temp++)
			{
        		cell = this.storeItems[temp];
        		cell.destroy();
        		cell = null;
			}
    	}
    	delete this.storeItems;
		this.storeItems = null;
        this.storeItems = [];
    },
    
	isItemLocked: function(itemModel)
	{
		var currentLevel = TFGameState.getCurrentUser().getCurrentLevel();
		var levelrequired = itemModel.custom_attributes.levelrequired;
		if(!levelrequired)
		{
			return false;
		}
		else
		if(currentLevel >= itemModel.custom_attributes.levelrequired)
       	{
			return false;
        }
        else
        {
			return true;
	            
        }
		
		
	},
	
    backButtonAction:function()
    {
		
    	if(this._level == 1) 
		{
            return;
        }
    	this._level--;
		if(this.item_store_id == "7_1" || this.item_store_id =="6_0")
		{
			this._level--;
			
		}
		if(this._level == 1)
		{
			this._ParentMainView.setStoreBottomText(GALocalizationHandler.getRelativeString(Core.Localization.getString('TF_STORE'),["Store"]));
			this.store_cats_items = '';
			this.item_store_id = "";
			this._ParentMainView.disableAndHideBackButton();
		}
		
		if(this._level == 2)
		{
			var _index = this.item_store_id.indexOf('_');
			var storeId = this.item_store_id.substring(0, _index);
			var cellModel = GAGameLoader.getStoreHandler().getStoreObjectForKey(storeId);
			this._ParentMainView.setStoreBottomText(GALocalizationHandler.getRelativeString(Core.Localization.getString('TF_STORE'),[cellModel.name]));
			this.store_cats_items = this.store_cats_items.substr(0,1);
			this.item_store_id = ""+this._storeId;
			
		}
		this.setScrollPosition([0,0]);
		this.cellRowDelegates();
		
    },
    
    destroy: function($super)
    {
    	if(this.listSection)
    	{
    		this.listSection.flush();
    		this.listSection = null;
    	}
    	this.clearStoreItems();
    	$super();
    }
    
});

; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI Layers/StoreScreen/CustomCellView'] = function(){var exports = $MODULE_REGISTRY['Code/UI Layers/StoreScreen/CustomCellView'] || {}; $MODULE_REGISTRY['Code/UI Layers/StoreScreen/CustomCellView'] = exports; exports.CustomCellView = UI.View.subclass({
    
    className: "CustomCellView",
    
    initialize: function($super)
	{
    	 $super();
    },
    
    destroy: function($super) 
	{
    	if(typeof this != 'undefined' && this != null)
    		return;
		var children = this.getChildren();
		var length = children.length;
		for(var i = 0; i < length; i++) 
		{
			this.removeChild(children[i]);
			children[i].destroy();
			children[i] = null;
		}
    	//TFUtil.destroyView(this);
		$super();
    },
});

; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI Layers/StoreScreen/StoreTableViewCell'] = function(){var exports = $MODULE_REGISTRY['Code/UI Layers/StoreScreen/StoreTableViewCell'] || {}; $MODULE_REGISTRY['Code/UI Layers/StoreScreen/StoreTableViewCell'] = exports; exports.StoreTableViewCell = UI.ListViewItem.subclass({
    
    classname: "StoreTableViewCell",
    
    initialize: function($super,reuseId,cellModel) {
		
    	$super(reuseId);
   	
    	this._ParentTableView = null;
    	this._cellView = null;
    	this._indexPath_Row = 0;
        this._cellModel = cellModel;
    },
    
    _onCreateView: function() {
		var width = 0 , height = 0;
													  
        width = GACommonUtils.getScreenWidth();
        height = GACommonUtils.getScreenHeight();
        
		this._cellView = new CustomCellView();

        ///Adding whole cell's size button
        this._cellView._BigButton = new UI.Button();
        this._cellView._BigButton.setTextGravity(UI.ViewGeometry.Gravity.Center);
        this._cellView._BigButton.setFrame([TFUtil.getAdjustedY(0),TFUtil.getAdjustedX(0),TFUtil.getAdjustedY(380),TFUtil.getAdjustedX(100)]);
        this._cellView._BigButton.setGradient({ gradient: ["245779 0.0","3f7EA4 1.0"]});
		this._cellView.addChild(this._cellView._BigButton); 
		
		
        this._cellView._arrowImage = new UI.Image();
		this._cellView._arrowImage.setImage("./Content/images/UIPanels/storewindow/arrow.png",UI.State.Normal);
		this._cellView._arrowImage.setFrame([TFUtil.getAdjustedY(340),TFUtil.getAdjustedX(80/2 - 10),TFUtil.getAdjustedY(12),TFUtil.getAdjustedX(18)]);
		this._cellView._arrowImage.setImageFit(UI.ViewGeometry.FitModes.Stretch);
        this._cellView.addChild(this._cellView._arrowImage);
        
        
		this._cellView._label1 = new UI.Label();
		this._cellView._label1.setTextGravity(UI.ViewGeometry.Gravity.Left);
		this._cellView._label1.setTextColor('FFFFFF');
		//this._cellView._label1.setTextFont('Marker Felt');
		this._cellView._label1.setTextSize(13);
		this._cellView._label1.setFrame([TFUtil.getAdjustedY(75), TFUtil.getAdjustedX(20), TFUtil.adjustHeightWithDevice(200), TFUtil.adjustWidthWithDevice(22)]);
		this._cellView.addChild(this._cellView._label1);
		
		this._boxIcon = new UI.Image();
		this._boxIcon.setFrame([TFUtil.getAdjustedY(7),TFUtil.getAdjustedX(4),TFUtil.getAdjustedY(63),TFUtil.getAdjustedX(63)]);
		this._boxIcon.setImage("./Content/images/Store/storetableimgs/box.png",UI.State.Normal);
		this._cellView.addChild(this._boxIcon);
		
        return this._cellView;
    },
    
    _onSetView: function(cellView) 
    {
        cellView._label1.setText(this._cellModel.name);
		cellView._BigButton.onclick = this.didSelectRow.bind(this);
        
        if(this._ParentTableView._level != 3)
        {
        	cellView._arrowImage.setVisible(true);
        }
        else
        {
            cellView._arrowImage.setVisible(false);
            this.disableBigButton(cellView);
        }
        this._setIconImage(cellView);
        this._cellView = cellView;
    },
    
    _setIconImage: function(cellView)
    {
 
        var path = null;
        if(this._ParentTableView._level == 1) {
            path = '' +this._cellModel.visible_id;
		} else if(this._ParentTableView._level == 2) {
			path = ''+this._cellModel.parent.visible_id+'_'+this._cellModel.visible_id;
		} else {
			path = '' +this._cellModel.parent.parent.visible_id+'_'+this._cellModel.parent.visible_id+'_'+this._cellModel.visible_id;
        }
        
		var obj = GAGameLoader.getStoreHandler().getStoreObjectForKey(path);
													  
		if(cellView.icon != null) {
			cellView.removeChild(cellView.icon);
			cellView.icon.destroy();
			cellView.icon = null;
		}
		
		var width,height,x,y;
		
		if(this._ParentTableView._level == 3) {
			width = obj.custom_attributes.size_width;
			height = obj.custom_attributes.size_height;
			var size = TFUtil.getAspectMaintainSize(new Core.Size(width,height),new Core.Size(46,46));
			width = size.getWidth();
			height = size.getHeight();
			x = (74-width)/2;
			y= (68-height)/2;
		}
		else {
			width = 46;
			height = 50;
			x = 14;
			y= 9;
		}
		
		
		cellView.icon = new GAStoreIcon();
		cellView.icon.setFrame([TFUtil.getAdjustedY(x), TFUtil.getAdjustedX(y), TFUtil.getAdjustedY(width), TFUtil.getAdjustedX(height)]);	
		cellView.icon.load(obj);
		//cellView.icon = this.icon;
		cellView.addChild(cellView.icon);
		
	},
	
	didSelectRow: function() {

		this._ParentTableView._ParentMainView.setStoreBottomText(this._cellModel.name);
		if(this._indexPath_Row == 1 || this._indexPath_Row == 3)
		{
			this._ParentTableView.didSelectRowAtIndexPath(this._indexPath_Row);
			this._ParentTableView.didSelectRowAtIndexPath(0);	
					
		}
		else
		{
			this._ParentTableView.didSelectRowAtIndexPath(this._indexPath_Row);	
		}
	},
    
    disableBigButton:function(cellView)
    {
    	cellView._BigButton.setEnabled(false);
    },
    
    _setParentTableView: function(reference)     
    {
        this._ParentTableView = reference;
    },
    
	_setIndexPath_Row: function(value)	
    {
        this._indexPath_Row = value;
    },
	
	_getParentTableView: function()		
    {
        return this._ParentTableView;
    },
    
    _getIndexPath_Row: function()		
    {
        return this._indexPath_Row;
    },

    destroy: function() {
    	if(this._cellView){
    		this._cellView.destroy();
    		this._cellView = null;
    	}
    	
    },
    
    
});

; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI Layers/StoreScreen/TableViewCells/levelOneCell'] = function(){var exports = $MODULE_REGISTRY['Code/UI Layers/StoreScreen/TableViewCells/levelOneCell'] || {}; $MODULE_REGISTRY['Code/UI Layers/StoreScreen/TableViewCells/levelOneCell'] = exports; exports.levelOneCell = StoreTableViewCell.subclass({
    
    className: "LevelOneCell",
	
    initialize: function($super,reuseId,cellModel) 
    {
        $super(reuseId,cellModel);
        this._indexPath_Row = reuseId;
        this._cellModel = cellModel;
        this.cellView = null;
    },
    
    _onCreateView: function($super) 
    {
    	var cell = $super();
    	this.cellView = cell;
		return cell;
    },
    
    _onSetView: function($super,cellView)
    {
        $super(cellView);
    },
    
    _setParentTableView: function($super,reference)
    {
        $super(reference);
    },
    
	_setIndexPath_Row:function($super,value)
    {
        $super(value);
    },
	
	_getIndexPath_Row: function($super)
    {
        return $super();
    },
    
	_getParentTableView: function($super)			
    {
        return $super();
    },
    
    destroy: function($super) 
    {
    	$super();
    }

});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI Layers/StoreScreen/TableViewCells/levelTwoCell'] = function(){var exports = $MODULE_REGISTRY['Code/UI Layers/StoreScreen/TableViewCells/levelTwoCell'] || {}; $MODULE_REGISTRY['Code/UI Layers/StoreScreen/TableViewCells/levelTwoCell'] = exports; exports.levelTwoCell = StoreTableViewCell.subclass({
    
    className: "LevelTwoCell",
	
    initialize: function($super,reuseId,cellModel)
    {
												   
        $super(reuseId,cellModel);
        this._indexPath_Row = reuseId;
        this._cellModel = cellModel;
        this.cellView = null;
    },
    _onCreateView: function($super) 
    {
    	this.cellView = $super();
        this.cellView._availableLabel = new UI.Label();
        this.cellView._availableLabel.setTextGravity(UI.ViewGeometry.Gravity.Left);
		this.cellView._availableLabel.setTextColor('FFFF33');
		//this.cellView._availableLabel.setTextFont(TFUtil.getFontName());
		TFUtil.setTextFont(this.cellView._availableLabel);
		this.cellView._availableLabel.setTextSize(10);
		this.cellView._availableLabel.setFrame([TFUtil.getAdjustedY(80), TFUtil.getAdjustedX(35), TFUtil.getAdjustedY(230), TFUtil.getAdjustedX(18)]);
        this.cellView.addChild(this.cellView._availableLabel);
        return this.cellView;
    },
    _onSetView: function($super,cellView) 
    {
        $super(cellView);
        var storeId = this._cellModel.parent.visible_id;
        var allItems = GAGameLoader.getStoreHandler().getAllItems(storeId, this._cellModel.visible_id, true);
        cellView._availableLabel.setText(GALocalizationHandler.getRelativeString(Core.Localization.getString('TF_XY_AVAILABLE'),[allItems.length]));//
        
    },
    
    _setParentTableView: function($super,reference)
    {
        $super(reference);
    },
    
	_setIndexPath_Row:function($super,value)
    {
        $super(value);
    },
	
	_getIndexPath_Row: function($super)
    {
        return $super();
    },
    
	_getParentTableView: function($super)			
    {
        return $super();
    },
    
    destroy: function($super) {
    	$super();
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI Layers/StoreScreen/TableViewCells/levelThreeCell'] = function(){var exports = $MODULE_REGISTRY['Code/UI Layers/StoreScreen/TableViewCells/levelThreeCell'] || {}; $MODULE_REGISTRY['Code/UI Layers/StoreScreen/TableViewCells/levelThreeCell'] = exports; exports.levelThreeCell = StoreTableViewCell.subclass({
    
    classname: "LevelThreeCell",
	
    initialize: function($super,reuseId,cellModel) {
     	
        $super(reuseId,cellModel);
        this._cellModel = cellModel;
        this._store_id = '';
		this._gaDownloader = null;
   		this._enableButton = true;
        this.cellView = null;
		this.backGroundId = null;
		this.failureDialogShowing = false;
    },
    _onCreateView: function($super) 
    {
    	this.cellView = $super();
    	
		this.cellView._lockImage = new UI.Image();
		this.cellView._lockImage.setFrame([TFUtil.getAdjustedY(315),TFUtil.getAdjustedX(15),TFUtil.getAdjustedY(39),TFUtil.getAdjustedX(43)]);
		this.cellView._lockImage.setImageFit(UI.FitMode.Fill);
		this.cellView._lockImage.setTouchable(false);
		this.cellView._lockImage.setImage("./Content/images/Store/storetableimgs/lock.png",UI.State.Normal);
		this.cellView.addChild(this.cellView._lockImage);
		
		this.cellView._newImage = new UI.Image();
		this.cellView._newImage.setImage("./Content/images/Store/storetableimgs/flagnew.png",UI.State.Normal);
		this.cellView._newImage.setFrame([TFUtil.getAdjustedY(2),TFUtil.getAdjustedX(4),TFUtil.adjustHeightWithDevice(25),TFUtil.adjustWidthWithDevice(25)]);
		this.cellView._newImage.setImageFit(UI.FitMode.Fill);
		this.cellView._newImage.setTouchable(false);
		this.cellView._newImage.setAlpha(3);
		this.cellView._newImage.setVisible(false);
		this.cellView.addChild(this.cellView._newImage);
		
		
		this.cellView._saleImage = new UI.Image();
		this.cellView._saleImage.setImage("./Content/images/Store/storetableimgs/flagsale.png",UI.State.Normal);
		this.cellView._saleImage.setFrame([TFUtil.getAdjustedY(2),TFUtil.getAdjustedX(4),TFUtil.adjustHeightWithDevice(25),TFUtil.adjustWidthWithDevice(25)]);
		this.cellView._saleImage.setImageFit(UI.FitMode.Fill);
		this.cellView._saleImage.setTouchable(false);
		this.cellView._saleImage.setAlpha(3);
		this.cellView._saleImage.setVisible(false);
		this.cellView.addChild(this.cellView._saleImage);
		 
		this.cellView._buyButton = new UI.Button();
		this.cellView._buyButton.setAlpha(1);
		this.cellView._buyButton.setImage("./Content/images/UIPanels/Buttons/1buttonNormal.png",UI.State.Normal);
		this.cellView._buyButton.setImageFit(UI.ViewGeometry.FitModes.Stretch);
		this.cellView._buyButton.setTextGravity(UI.ViewGeometry.Gravity.Center);
		this.cellView._buyButton.setFrame([TFUtil.getAdjustedY(300),TFUtil.getAdjustedX(30),TFUtil.getAdjustedY(56),TFUtil.getAdjustedX(28)]);
		this.cellView.addChild(this.cellView._buyButton);
		
		this.cellView._useButton = new UI.Button();
		this.cellView._useButton.setAlpha(1);
		this.cellView._useButton.setImage("./Content/images/UIPanels/Buttons/1buttonNormal.png",UI.State.Normal);
		this.cellView._useButton.setImageFit(UI.ViewGeometry.FitModes.Stretch);
		this.cellView._useButton.setTextGravity(UI.ViewGeometry.Gravity.Center);
		this.cellView._useButton.setFrame([TFUtil.getAdjustedY(300),TFUtil.getAdjustedX(30),TFUtil.getAdjustedY(56),TFUtil.getAdjustedX(28)]);
		this.cellView.addChild(this.cellView._useButton);
		
		this.cellView._previewButton = new UI.Button();
        this.cellView._previewButton.setAlpha(1);
        this.cellView._previewButton.setImage("./Content/images/UIPanels/Buttons/1buttonNormal.png",UI.State.Normal);
        this.cellView._previewButton.setImageFit(UI.ViewGeometry.FitModes.Stretch);
        this.cellView._previewButton.setTextGravity(UI.ViewGeometry.Gravity.Center);
        this.cellView._previewButton.setFrame([TFUtil.getAdjustedY(240),TFUtil.getAdjustedX(30),TFUtil.getAdjustedY(56),TFUtil.getAdjustedX(28)]);
        this.cellView.addChild(this.cellView._previewButton);
		this.cellView._previewButton.setVisible(false);
		
		this.cellView._preview = new UI.Button();
        this.cellView._preview.setAlpha(1);
        this.cellView._preview.setImageFit(UI.ViewGeometry.FitModes.Stretch);
        this.cellView._preview.setTextGravity(UI.ViewGeometry.Gravity.Center);
        this.cellView._preview.setFrame([TFUtil.getAdjustedY(0),TFUtil.getAdjustedX(0),GACommonUtils.getScreenWidth(),GACommonUtils.getScreenHeight()]);
        UI.Window.document.addChild(this.cellView._preview);
		this.cellView._preview.setVisible(false);
		
        this.cellView._levelRequired = new UI.Label();
        this.cellView._levelRequired.setTextGravity(UI.ViewGeometry.Gravity.Center);
        this.cellView._levelRequired.setTextColor('FFFFFF');
        this.cellView._levelRequired.setTouchable(false);
       // this.cellView._levelRequired.setTextFont(TFUtil.getFontName());
        TFUtil.setTextFont(this.cellView._levelRequired);
        this.cellView._levelRequired.setTextSize(10);
        this.cellView._levelRequired.setFrame([TFUtil.getAdjustedY(298),TFUtil.getAdjustedX(44),TFUtil.getAdjustedY(65),TFUtil.getAdjustedX(38)]);
        this.cellView.addChild(this.cellView._levelRequired);
        
        this.cellView._canBeBreeded = new UI.Label();
        this.cellView._canBeBreeded.setTextGravity(UI.ViewGeometry.Gravity.Center);
        this.cellView._canBeBreeded.setTextColor('FFFF33');
        this.cellView._canBeBreeded.setTextFont(TFUtil.getFontName());
        this.cellView._canBeBreeded.setTextSize(9);
        this.cellView._canBeBreeded.setFrame([TFUtil.getAdjustedY(65),TFUtil.getAdjustedX(26),TFUtil.getAdjustedY(65),TFUtil.getAdjustedX(38)]);
		this.cellView._canBeBreeded.setTouchable(false);
        this.cellView.addChild(this.cellView._canBeBreeded);
        
        this.cellView._bucksOrCoinsImage = new UI.Image();
		this.cellView._bucksOrCoinsImage.setTouchable(false);
		this.cellView._bucksOrCoinsImage.setFrame([TFUtil.getAdjustedY(75),TFUtil.getAdjustedX(46),TFUtil.getAdjustedY(25),TFUtil.getAdjustedX(25)]);
		this.cellView.addChild(this.cellView._bucksOrCoinsImage);
		
		//according to active bucket
		this.cellView._bucksOrCoinsPriceLabel = new UI.Label();
		this.cellView._bucksOrCoinsPriceLabel.setTouchable(false);
	 	this.cellView._bucksOrCoinsPriceLabel.setTextGravity(UI.ViewGeometry.Gravity.Center);
    	this.cellView._bucksOrCoinsPriceLabel.setTextColor('FFFF33');
    	//this.cellView._bucksOrCoinsPriceLabel.setTextFont(TFUtil.getFontName());
    	TFUtil.setTextFont(this.cellView._bucksOrCoinsPriceLabel);
    	this.cellView._bucksOrCoinsPriceLabel.setTextSize(12);
    	this.cellView._bucksOrCoinsPriceLabel.setFrame([TFUtil.getAdjustedY(85), TFUtil.getAdjustedX(50), TFUtil.getAdjustedY(50), TFUtil.getAdjustedX(18)]);
		this.cellView.addChild(this.cellView._bucksOrCoinsPriceLabel);
		
		
		this.cellView.line = new UI.Image();
		this.cellView.line.setTouchable(false);
		this.cellView.line.setImage("./Content/images/Store/storetableimgs/black_dot.png",UI.State.Normal);
		this.cellView.line.setFrame([TFUtil.getAdjustedY(103),TFUtil.getAdjustedX(48),TFUtil.adjustHeightWithDevice(18),TFUtil.adjustWidthWithDevice(2)]);
		this.cellView.line.setImageFit(UI.ViewGeometry.FitModes.Stretch);
		this.cellView.line.setVisible(false);
		this.cellView.addChild(this.cellView.line);
		
		//if active bucket is not default, if item is on sale so it shows the default price strike-through-ed and new sale price along with it
        this.cellView._salePriceLabel = new UI.Label();
        this.cellView._salePriceLabel.setTouchable(false);
        this.cellView._salePriceLabel.setTextGravity(UI.ViewGeometry.Gravity.Left);
        this.cellView._salePriceLabel.setTextColor('FFFF33');
       // this.cellView._salePriceLabel.setTextFont(TFUtil.getFontName());
        TFUtil.setTextFont(this.cellView._salePriceLabel);
        this.cellView._salePriceLabel.setTextSize(12);
        this.cellView._salePriceLabel.setFrame([TFUtil.getAdjustedY(128), TFUtil.getAdjustedX(40), TFUtil.getAdjustedY(50), TFUtil.getAdjustedX(18)]);
        this.cellView.addChild(this.cellView._salePriceLabel);

        var startingX = 165;
        var startingY = 20;
        var width = 130;
        var height = 60;
        
													 
        this.cellView._rightLabel1 = new UI.Label();
        this.cellView._rightLabel1.setTouchable(false);
        this.cellView._rightLabel1.setTextGravity(UI.ViewGeometry.Gravity.Right);
        this.cellView._rightLabel1.setTextColor('FFFF33');
       // this.cellView._rightLabel1.setTextFont(TFUtil.getFontName());
        TFUtil.setTextFont(this.cellView._rightLabel1);
        this.cellView._rightLabel1.setTextSize(12);
        this.cellView._rightLabel1.setFrame([TFUtil.getAdjustedY(startingX), TFUtil.getAdjustedX(startingY), TFUtil.getAdjustedHeight(width), TFUtil.getAdjustedWidth(height)]);
        this.cellView.addChild(this.cellView._rightLabel1);
        
        startingY = 40;
        
        this.cellView._rightLabel2 = new UI.Label();
        this.cellView._rightLabel2.setTextGravity(UI.ViewGeometry.Gravity.Right);
        this.cellView._rightLabel2.setTextColor('FFFF33');
        //this.cellView._rightLabel2.setTextFont(TFUtil.getFontName());
        TFUtil.setTextFont(this.cellView._rightLabel2);
        this.cellView._rightLabel2.setTextSize(12);
        this.cellView._rightLabel2.setTouchable(false);
        this.cellView._rightLabel2.setFrame([TFUtil.getAdjustedY(startingX), TFUtil.getAdjustedX(startingY), TFUtil.getAdjustedHeight(width), TFUtil.getAdjustedWidth(height)]);
        this.cellView.addChild(this.cellView._rightLabel2);
        return this.cellView;
    },
    
    _onSetView: function($super,cellView) 
    {
		$super(cellView);
		if(!this._cellModel)
			return;
		this._store_id = this._getParentTableView().getStoreId()+"_"+this._cellModel.visible_id;
//		var buyPrices = GACommonUtils.getBuyPrice(this._cellModel);
//		console.log(">>sell model =="+this._cellModel);
//		console.log(">>buy price =="+buyPrices);
//		var price = StoreUtil.getPrice(buyPrices);
			 
		
		//if current level is greater than the level required for item it shows buybutton otherwise a lock image
		
		if(this._cellModel.custom_attributes.canbebreeded){
			cellView._canBeBreeded.setText(Core.Localization.getString("TF_BREEDABLE_TEXT"));
		} else {
			cellView._canBeBreeded.setText("");
		}
        
		 cellView._buyButton.onclick = function() 
		 {
			 this.buyButtonAction();
		 }.bind(this);
		 
		 cellView._useButton.onclick = function() 
		 {
			 GameLayer.getSelectedTank().setBackGroundImage(this._store_id);
			 this._getParentTableView()._ParentMainView.removeFromParent();
			 this._getParentTableView()._ParentMainView.destroy();
		 }.bind(this);
													 
		cellView._previewButton.onclick = function() 
		{
			this.previewButtonAction(cellView);
		}.bind(this);
		
		cellView._preview.onclick = function() 
		{
			this.cellView._preview.setVisible(false);
		}.bind(this);
		
        
        var image = null;
		var prices = this._cellModel.buy_prices["default"];
		var originalBuyPrice = StoreUtil.getPrice(prices);
		var buyPriceKey = GACommonUtils.getBuyPrice(this._cellModel);
		var buyPrice = StoreUtil.getPrice(buyPriceKey);
		var currency = StoreUtil.getCurrency(buyPriceKey);
		//console.log(">>faizan originalBuyPrice =="+originalBuyPrice);
		//console.log(">>faizan buyPrice =="+buyPrice);
		//buyPrice = 10;
     	if(currency == TF_COINS)
		{
			image = 'coins.png';
		}
		else
        {
			image = 'bucks.png';
		}
        cellView._bucksOrCoinsImage.setImage('./Content/images/UIPanels/storewindow/'+image);
        
        cellView._bucksOrCoinsPriceLabel.setText(originalBuyPrice);
        //cellView._bucksOrCoinsPriceLabel.setText(buyPrice);
        
        var bucket = this._cellModel.active_bucket;
        //console.log(">>faizan bucket =="+bucket);
        var imageFrame = null;
        if(originalBuyPrice != buyPrice)
		{
        	cellView._saleImage.setFrame([TFUtil.getAdjustedY(2),TFUtil.getAdjustedX(4),TFUtil.adjustHeightWithDevice(25),TFUtil.adjustWidthWithDevice(25)]);
			cellView._saleImage.setVisible(true);
			cellView._saleImage.setVisible(true);
			cellView.line.setVisible(true);
            cellView._salePriceLabel.setText(buyPrice);
            cellView._bucksOrCoinsPriceLabel.setTextColor('E3170D');
			
        }
        else {
			cellView.line.setVisible(false);
        	cellView._saleImage.setVisible(false);
        }
        
        var storeItem =GAGameLoader.getStoreHandler().getStoreObjectForKey(this._store_id);
        var storeVisibleId = storeItem.parent.parent.visible_id;
        if(storeVisibleId == kSoreItems.kLocalFish)
		 {
			cellView._useButton.setVisible(false);										 
			cellView._previewButton.setVisible(false);
			//cellView._buyButton.setTextFont(TFUtil.getFontName());
			TFUtil.setTextFont(cellView._buyButton);
			cellView._buyButton.setTextColor("FFFFFF");
			cellView._buyButton.setText(GALocalizationHandler.getLocalizedString('TF_IN_APP_BUY'));
			cellView._buyButton.setVisible(true);
													 
			var timetoadulthood = storeItem.custom_attributes.timetoadulthood;
													 
			var sellPrices = GACommonUtils.getSellPrice(storeItem);
			var price = StoreUtil.getPrice(sellPrices);
			cellView._rightLabel2.setText(GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_SELL_FOR'),[price])); //Right Label1
			
			if(	timetoadulthood > 23)
			{
				timetoadulthood = timetoadulthood/24;
				timetoadulthood = Math.round(timetoadulthood*10)/10;
				cellView._rightLabel1.setText(	GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_GROW_IN_DAYS'),[timetoadulthood]));
			}
			else
			{
				cellView._rightLabel1.setText(	GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_GROW_IN_HRS'),[timetoadulthood]));
			}

		 }
		 else if(storeVisibleId == kSoreItems.kLocalDecorations)
		 {
			cellView._useButton.setVisible(false);										 
			cellView._previewButton.setVisible(false); 
			//cellView._buyButton.setTextFont(TFUtil.getFontName());
			TFUtil.setTextFont(cellView._buyButton);
			cellView._buyButton.setTextColor("FFFFFF");
			cellView._buyButton.setText(GALocalizationHandler.getLocalizedString('TF_IN_APP_BUY'));
			cellView._buyButton.setVisible(true);
			var happiness = storeItem.custom_attributes.happiness;
			var sellPrices = GACommonUtils.getSellPrice(storeItem);
			var price = StoreUtil.getPrice(sellPrices);
			cellView._rightLabel1.setText(GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_SELL_FOR'),[price])); //Right Label1
			cellView._rightLabel2.setText(	GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_HAPPINESS'),[happiness]));
		 }
		 else
		if(storeVisibleId == kSoreItems.klocalFoodBrick)
		 {
			cellView._useButton.setVisible(false);
			cellView._previewButton.setVisible(false);
			//cellView._buyButton.setTextFont(TFUtil.getFontName());
			TFUtil.setTextFont(cellView._buyButton);
			cellView._buyButton.setTextColor("FFFFFF");
			cellView._buyButton.setText(GALocalizationHandler.getLocalizedString('TF_IN_APP_BUY'));
			cellView._buyButton.setVisible(true);
			var lastFor = (storeItem.custom_attributes.foodbricktime)/24;
			cellView._rightLabel1.setText(GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_BRICK_LAST_FOR'),[lastFor])); //Right Label1
			cellView._rightLabel2.setText("");

		 } else
		 if(storeVisibleId == kSoreItems.kLocalPlants)
		 {
			 cellView._useButton.setVisible(false);
			 cellView._previewButton.setVisible(false);
			 //cellView._buyButton.setTextFont(TFUtil.getFontName());
			 TFUtil.setTextFont(cellView._buyButton);
			 cellView._buyButton.setTextColor("FFFFFF");
			 cellView._buyButton.setText(GALocalizationHandler.getLocalizedString('TF_IN_APP_BUY'));
			 cellView._buyButton.setVisible(true);
			 var happiness = storeItem.custom_attributes.happiness;
			 var sellPrices = GACommonUtils.getSellPrice(storeItem);
			 var price = StoreUtil.getPrice(sellPrices);
			 cellView._rightLabel1.setText(GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_SELL_FOR'),[price])); //Right Label1
			 cellView._rightLabel2.setText(	GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_HAPPINESS'),[happiness]));
			 
		 }
		else
		if(storeVisibleId == kSoreItems.kLocalBackgrounds)
		{
		    cellView._rightLabel1.setText("");	
			cellView._rightLabel2.setText("");
			//cellView._previewButton.setTextFont(TFUtil.getFontName());
			TFUtil.setTextFont(cellView._previewButton);
			cellView._previewButton.setTextColor("FFFFFF");
			cellView._previewButton.setText(GALocalizationHandler.getLocalizedString('TF_PREVIEW'));
			cellView._previewButton.setVisible(true);
			if(!TFGameState.isBackgroundAlreadyBought(this._store_id))
			{
				//cellView._buyButton.setTextFont(TFUtil.getFontName());
				TFUtil.setTextFont(cellView._buyButton);
				cellView._buyButton.setTextColor("FFFFFF");
				cellView._buyButton.setText(GALocalizationHandler.getLocalizedString('TF_IN_APP_BUY'));
				cellView._useButton.setVisible(false);
				cellView._buyButton.setVisible(true);

			}
			else
			{
				//cellView._useButton.setTextFont(TFUtil.getFontName());
				TFUtil.setTextFont(cellView._useButton);
				cellView._useButton.setTextColor("FFFFFF");
				cellView._useButton.setText(GALocalizationHandler.getLocalizedString('TF_USE'));
				cellView._buyButton.setVisible(false);
				cellView._useButton.setVisible(true);
			}

			
		}
		 
		 var isLocked = this.isItemLocked(cellView);
		 if(isLocked)
		 {
			cellView._buyButton.setVisible(false);
			cellView._lockImage.setVisible(true);
		 }
		 else
		 {
			 cellView._buyButton.setVisible(true);
			 cellView._lockImage.setVisible(false);
			 
		 }
		 
		 var isNew = storeItem.is_new;
		 if(isNew)
		 {
			 cellView._newImage.setVisible(true);
			 cellView._saleImage.setFrame([TFUtil.getAdjustedY(2),TFUtil.getAdjustedX(25),TFUtil.adjustHeightWithDevice(25),TFUtil.adjustWidthWithDevice(25)]);
		 }
		 else
		 {
			 cellView._newImage.setVisible(false);
		 } 
		
		this.cellView = cellView;
			
    },
    
	isItemLocked: function(cellView)
	{
		var currentLevel = TFGameState.getCurrentUser().getCurrentLevel();
		var levelrequired = this._cellModel.custom_attributes.levelrequired;
		if(!levelrequired)
		{
			cellView._levelRequired.setText(""); //Lvl Req
			return false;
		}
		else
		if(currentLevel >= this._cellModel.custom_attributes.levelrequired)
       	{
			cellView._levelRequired.setText(""); //Lvl Req
			return false;
        }
        else
        {
			cellView._levelRequired.setText(GALocalizationHandler.getLocalizedString('TF_LVL_REQ') + this._cellModel.custom_attributes.levelrequired); //Lvl Req
			return true;
	            
        }
		
		
	},
	
	getButtonsState: function()
	{
		return this._enableButton;
	},
		
	
	setEnableButtons: function(value)
	{
		this._enableButton = value;
	},
	
	previewButtonAction: function(cellView)
	{
	
//		cellView._preview.setVisible(true);
//		cellView._preview.setImage("./Content/back.png",UI.State.Normal);
		
		
		UIFactory.showProgressHUD(GALocalizationHandler.getLocalizedString('TF_FETCHINGDATA_LABEL'));//Fetching Data
		this._gaDownloader = new GAResourceDownloader(this._cellModel, this.resourceDownloadingSuccessfulForPreview.bind(this), this.resourceDownloadingFailed.bind(this), GAResourceType.kDetail);
		this._gaDownloader.startDownloading();
	},
													 
  	buyButtonAction: function()
  	{
  		if(!this.getButtonsState())
  		{
  			return;
  		}
		//this.setEnableButtons(false);
	  	
  		var canBuy = false;
		
		var storeItem = this._cellModel;
		var retValArray = StoreUtil.checkPricingForItemNew(this._cellModel);
        
		var retValArray = retValArray.split("|");
				
		var value1 = +retValArray[0];
		var value2 = +retValArray[1];
	
		if(value1 == 0 && value2 == 0)//unable to fetch from server
		{
			
			var message = GALocalizationHandler.getLocalizedString('TF_UNABLE_TO_FETCH_FROM_SERVER');
			var alertWindow = new TFMiniGLAlertView(GALocalizationHandler.getLocalizedString('TF_MESSAGE_LABEL'),message,this,GALocalizationHandler.getLocalizedString('TF_CANCEL_BUTTON'),GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
			alertWindow._type="ok";
			alertWindow.setMessageColor(255,255,255);
			alertWindow.setTitleFont(TFUtil.getFont(),TFUtil.getFontLocation());
			alertWindow.setMessageFont(TFUtil.getFont(),TFUtil.getFontLocation());
			alertWindow.setButtonsFont(TFUtil.getFont(),TFUtil.getFontLocation());
			alertWindow.show();
			
			return;
		}
		else if (!((value1 == 0 && value2 == 0) || (value1 == 0 && value2 == 1)))
		{
			canBuy = true;
		}
	
		if(!canBuy)
		{
			
			var message = GALocalizationHandler.getLocalizedString('TF_NO_COINS_MESSAGE_PURCHASE');
			
			var alertWindow = new TFMiniUIAlertView("",message,this,GALocalizationHandler.getLocalizedString('TF_CANCEL_BUTTON'),GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
			alertWindow.setType("okwithcancel");
			alertWindow.setTagValue(TF_COINS_TAG);
			alertWindow.setMessageColor('FFFFFF');
			alertWindow.setButtonColor('FFFFFF');
			alertWindow.setMessageFont(TFUtil.getFontName());
			alertWindow.setButtonsFont(TFUtil.getFontName());
			alertWindow.show();
			return;
		}
        
		if (value1 == 0 && value2 == 2) 
        {
			
			var message = GALocalizationHandler.getLocalizedString('TF_NO_BUCKS_MESSAGE_PURCHASE');
			
			
			var alertWindow = new TFMiniUIAlertView("",message,this,GALocalizationHandler.getLocalizedString('TF_CANCEL_BUTTON'),GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
			alertWindow.setType("okwithcancel");
			alertWindow.setTagValue(TF_BUCKS_TAG);
			alertWindow.setMessageColor('FFFFFF');
			alertWindow.setButtonColor('FFFFFF');
			alertWindow.setMessageFont(TFUtil.getFontName());
			alertWindow.setButtonsFont(TFUtil.getFontName());
			alertWindow.show();
			
			return;
		}
        
		UIFactory.showProgressHUD(GALocalizationHandler.getLocalizedString('TF_FETCHINGDATA_LABEL'));//Fetching Data
		this._gaDownloader = new GAResourceDownloader(storeItem, this.resourceDownloadingSuccessful.bind(this), this.resourceDownloadingFailed.bind(this), GAResourceType.kDetail);
		this._gaDownloader.startDownloading();
  		
  	},
	
    clickedButtonAtIndex: function(buttonIndex,alertView)
    {
        if (buttonIndex == 0) 
        {
            // Do it!
            this.setEnableButtons(true);
            
            if(alertView.getTagValue() == TF_COINS_TAG)
            {
//                var inAppMainView = new TZIAPManager(TF_COINS);
            	 var inAppMainView = new InAppMainView(false);
        		NGWindow.document.addChild(inAppMainView);
              //  this._getParentTableView()._ParentMainView.removeFromParent();
                this._getParentTableView()._ParentMainView.destroy();
                return;
            }
            else if(alertView.getTagValue() == TF_INTERNET_ERROR_TAG)
            {
                this._gaDownloader.startDownloading();
            }
            else if(alertView.getTagValue() == TF_BUCKS_TAG)
            {
//                var inAppMainView = new TZIAPManager(TF_BUCKS);
            	 var inAppMainView = new InAppMainView(true);
        		NGWindow.document.addChild(inAppMainView);
                this._getParentTableView()._ParentMainView.removeFromParent();
                this._getParentTableView()._ParentMainView.destroy();
                return;
            }

        } 
        else if (buttonIndex == 1) 
        {
            this.setEnableButtons(true);
        }
        
    },

    //********************resource downloaded delegate methods********************//
    
	resourceDownloadingSuccessful:function (savePath) 
	{
		
		var tankSelected = GameLayer.getSelectedTank();

		var storeObjectType = StoreUtil.getStoreObjectType(this._cellModel);
													 
		if(storeObjectType == kObjectType.kObjectFish)
		{
			GameLayer.getControlLayer().setImageForStoreButton('Content/eggsButton.png','Content/eggsButton.png'); 
			tankSelected.setStoreID(this._store_id);
			tankSelected.setCurrentTankAction(kTankActionType.kTankActionEggs);
			tankSelected.storeAction();
		}
		else if (storeObjectType == kObjectType.kObjectDecoration)
		{	
			var storeObject= GAGameLoader.getStoreHandler().getStoreObjectForKey(this._store_id);
			LogHandler.logTransaction(storeObject);
			tankSelected.addDecoration(this._store_id);
		}
		else if(storeObjectType == kObjectType.kObjectBackground)
		{	
			var storeObject= GAGameLoader.getStoreHandler().getStoreObjectForKey(this._store_id);
			LogHandler.logTransaction(storeObject);
			TFGameState.getCurrentUser().deductCurrencyForStoreItem(storeObject);
			tankSelected.setTankBackground(this._store_id);
		}
		else if(storeObjectType == kObjectType.kObjectPlant)
		{
			var storeObject= GAGameLoader.getStoreHandler().getStoreObjectForKey(this._store_id);
			LogHandler.logTransaction(storeObject);
			tankSelected.addPlant(this._store_id);
		}
													 
		else if(storeObjectType == kObjectType.kObjectFoodBrick)
		{
			var storeObject= GAGameLoader.getStoreHandler().getStoreObjectForKey(this._store_id);
			LogHandler.logTransaction(storeObject);
			tankSelected.addFoodBrick(this._store_id);
		}
		UIFactory.hideProgressHUD();	
		if(this._gaDownloader) 
		{
            this._gaDownloader.destroy();
            this._gaDownloader = null;
        }										 
		this._getParentTableView()._ParentMainView.removeFromParent();
		this._getParentTableView()._ParentMainView.destroy();
	},

	resourceDownloadingFailed:function (errorCode, errorMsg)
	{
		UIFactory.hideProgressHUD();
        if(this.failureDialogShowing == true)
        {
        	this._getParentTableView()._ParentMainView.removeFromParent();
        	this._getParentTableView()._ParentMainView.destroy();
        			 	
        	return;
        }
//        									 
//        if(this._gaDownloader) 
//		{
//            this._gaDownloader.destroy();
//            this._gaDownloader = null;
//        }
        var message = GALocalizationHandler.getLocalizedString('TF_RESOURCE_NETWORK_TEXT');
       
        var alertWindow = new TFMiniUIAlertView("",message,this,GALocalizationHandler.getLocalizedString('TF_CANCEL_BUTTON'),GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
		alertWindow.setType("ok");
		//alertWindow.setTagValue(TF_INTERNET_ERROR_TAG);
		alertWindow.setMessageColor('FFFFFF');
		alertWindow.setButtonColor('FFFFFF');
		alertWindow.setMessageFont(TFUtil.getFontName());
		alertWindow.setButtonsFont(TFUtil.getFontName());
		alertWindow.show();
        this.failureDialogShowing=true;		
	},
    
	
	
	
	resourceDownloadingSuccessfulForPreview:function (savePath) 
	{


		var storeObjectType = StoreUtil.getStoreObjectType(this._cellModel);
		
		if(storeObjectType == kObjectType.kObjectBackground)
		{	
			this._basePath = TFUtil.getBasePathForResourceType(this._store_id,GAResourceType.kDetail);
			var storeBackground = GAGameLoader.getStoreHandler().getStoreObjectForKey(this._store_id);										 
			TFGameState.changeFileName(this._basePath,storeBackground);
			var pathImage = this._basePath+'/default.jpg';
			this.cellView._preview.setVisible(true);
			this.cellView._preview.setImage(pathImage,UI.State.Normal);
		}
		if(this._gaDownloader) 
		{
            this._gaDownloader.destroy();
            this._gaDownloader = null;
        }
		UIFactory.hideProgressHUD();	
		
	},


    //********************Setters-Getters********************//
    
    _setIndexPath_Row:function($super,value)
    {
        $super(value);
    },
	
    _getIndexPath_Row: function($super)
    {
        return $super();
    },
    
    _setParentTableView: function($super,value)
    {
        $super(value);
    },
    
		_getParentTableView: function($super)			
    {
        return $super();
    },
    
    //********************Destroy********************//

    destroy: function($super) 
	{
        if(this._gaDownloader) 
		{
            this._gaDownloader.destroy();
            this._gaDownloader = null;
        }
		$super();
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI Layers/TrophyScreen/TrophyGenericTableView'] = function(){var exports = $MODULE_REGISTRY['Code/UI Layers/TrophyScreen/TrophyGenericTableView'] || {}; $MODULE_REGISTRY['Code/UI Layers/TrophyScreen/TrophyGenericTableView'] = exports; /**
 * 
 */

exports.TrophyGenericTableView = UI.ListView.subclass(
{
    classname: "TrophyGenericTableView",
        
        initialize: function() 
        {
													 
            this._level = 1;
            this.sections = null;
            this.storeItems = null;
            this.store_cats_items = '';
            this.item_store_id = ""; 
            this._ParentMainView = null;
            this._storeId = -1;
            this.listSection  = null;
            this.storeVirtualItem = null;        
            this.breedableFishArray = new GAMutableArray(); 
            this.breededFishArray = new GAMutableArray();
            this.breededFishCombinationArray = new GAMutableArray();
            this.topLabel = null;
            this.setFrame([TFUtil.getAdjustedY(45),TFUtil.getAdjustedX(60),TFUtil.getAdjustedY(480-100),TFUtil.getAdjustedX(320-98)]);
            this.setOnLoad(this.loadView.bind(this));
        },
        
        loadView: function() {
    	  this.generateSortedStoreVisibleIDArray();
          this.getBreedablefishArray();
          this.createTopPannel();
          this.cellRowDelegates();
        },
    
        createTopPannel: function()
        {
        	this.topLabel = new UI.Label({
    			'frame': [TFUtil.getAdjustedY(0),TFUtil.getAdjustedX(0),TFUtil.getAdjustedY(380),TFUtil.getAdjustedX(30)],
    			'textColor': "FF",
    			'textShadow': "FF00 2.0 {0,-1}",
    			'textGravity': [0, 0.5],
    			'textFont':TFUtil.getFontName(),
//    			'textInsets': [10, 10, 10, 10],
    			'text':'',
    			'gradient': {
    				'gradient': ["245779 0.0","3f7EA4 1.0"],//["FF9bd6f4 0.0", "FF0077BC 1.0"],//["F0C0 0.0", "F080 1.0"],
    				'innerShadow': "FF00 1.0 {0,0}"
    			}
    		});
    	
    		
        },
		
		generateSortedStoreVisibleIDArray: function()
        {
			this._allCategories = GAGameLoader.getStoreHandler().getAllCategories(""+5, true);
			
			var size = this._allCategories.length;
			for (var temp =0 ; temp < size; temp++)
				{
				var category = this._allCategories[temp];
					var allItemsStore = GAGameLoader.getStoreHandler().getAllItems(category.parent.visible_id, category.visible_id, true);
					var isize = allItemsStore.length;	
					for(var j =0 ; j<isize ; j++ )
						{
							var item = allItemsStore[j];
							if(item.custom_attributes.canbebreeded) 
								{
									this.breedableFishArray.addObject(item);
								}
						}
				}

        },
        
        getBreedablefishArray: function(fishId)
        {
        	this._allCategories = GAGameLoader.getStoreHandler().getAllCategories(""+2, true);
			
			var size = this._allCategories.length;
			for (var temp =0 ; temp < size; temp++)
				{
				var category = this._allCategories[temp];
					var allItemsStore = GAGameLoader.getStoreHandler().getAllItems(category.parent.visible_id, category.visible_id, true);
					var isize = allItemsStore.length;	
					for(var j =0 ; j<isize ; j++ )
						{
							var item = allItemsStore[j];
						
									this.breededFishArray.addObject(item);
									
						}
				}
        },
   
	
		setParentMainView:function(reference)     
		{
			this._ParentMainView = reference;
		},
		getLevel:function() 				
		{
			return this._level;
		},

		
    
    setSections: function($super, sections)
    {
        $super(sections);
    },
 
    cellForRowAtIndexPath:function(indexPath_Row)
    {
    	return this.createCellForMainStoreTable(indexPath_Row);
    },
    
	createCellForMainStoreTable: function(indexPath_Row)
	{
		
		if(this._level == 1)
		{
			var size = this.breedableFishArray.getLength()-1;
			var cellModel = this.breedableFishArray.objectAtIndex(indexPath_Row);
			var result = TFUtil.isChildExist(cellModel.parent.parent.visible_id+'_'+cellModel.parent.visible_id+'_'+cellModel.visible_id);										   
			var cellView = new TrophyMainCell("storeCell1",cellModel,size,result);
			cellView._setParentTableView(this);
			cellView._setIndexPath_Row(indexPath_Row);
			return cellView;
		}
        else if(this._level == 2)
		{
        	
        	var cellModel = this.breededFishCombinationArray.objectAtIndex(indexPath_Row);	
        	if(cellModel == null){}
	    	var cellView = new TrophyBreadingCell("storeCell2",cellModel,this.getParentName(cellModel));
			cellView._setParentTableView(this);
			cellView._setIndexPath_Row(indexPath_Row);
			this._ParentMainView.enableAndShowBackBtn();
			return cellView;
		}
    
		return null;
		
	},
	
	didSelectRowAtIndexPath:function(indexPath_Row)
	{	
    	
		if(this._level == 3) 
		{
			return;
		}
		if (this._level == 1) 
		{
			var temp = this.breedableFishArray.objectAtIndex(indexPath_Row);
			var length = this.breedableFishArray.getLength()-1;
			var result = TFUtil.isChildExist(temp.parent.parent.visible_id+'_'+temp.parent.visible_id+'_'+temp.visible_id);	
	        this._level = 2;
			//this.topLabel.setText(temp.name +' '+ GALocalizationHandler.getRelativeString(Core.Localization.getString('TF_UNLOCKED'),[result,length]));
			
			////////////////////////////////////////////////////////////////////////////////////////////
			this.background = new UI.Label({
    			'frame': [TFUtil.getAdjustedY(0),TFUtil.getAdjustedX(0),TFUtil.getAdjustedY(380),TFUtil.getAdjustedX(30)],
    			'textColor': "FF",
    			'gradient': {
    				'gradient': ["245779 0.0","3f7EA4 1.0"],//["FF9bd6f4 0.0", "FF0077BC 1.0"],//["F0C0 0.0", "F080 1.0"],
    				'innerShadow': "FF00 1.0 {0,0}"
    			}
    		});
    	
			this.background.setTextGravity(UI.ViewGeometry.Gravity.Center);	
			this.addChild(this.background);
			
			this.left = new UI.Label();
			this.left.setTextGravity(UI.ViewGeometry.Gravity.Left);
			this.left.setTextColor('FFFFFF');
			this.left.setTextFont(TFUtil.getFontName());
			this.left.setTextSize(18);
			this.left.setFrame(/*[TFUtil.getAdjustedY(75), TFUtil.getAdjustedX(20), TFUtil.adjustHeightWithDevice(200), TFUtil.adjustWidthWithDevice(22)]*/
			[TFUtil.getAdjustedY(10),TFUtil.getAdjustedX(0),TFUtil.getAdjustedY(380),TFUtil.getAdjustedX(30)]);
			this.left.setText(temp.name);
			this.addChild(this.left);
			
			this.right = new UI.Label();
			this.right.setTextGravity(UI.ViewGeometry.Gravity.Right);
			this.right.setTextColor('FFFFFF');
			this.right.setTextFont(TFUtil.getFontName());
			this.right.setTextSize(18);
			this.right.setFrame(/*[TFUtil.getAdjustedY(75), TFUtil.getAdjustedX(20), TFUtil.adjustHeightWithDevice(200), TFUtil.adjustWidthWithDevice(22)]*/
			[TFUtil.getAdjustedY(-10),TFUtil.getAdjustedX(0),TFUtil.getAdjustedY(380),TFUtil.getAdjustedX(30)]);
			this.right.setText(GALocalizationHandler.getRelativeString(Core.Localization.getString('TF_UNLOCKED'),[result,length]));
			this.addChild(this.right);
			////////////////////////////////////////////////////////////////////////////////////////////
			
			this.getBreededCombinationArray(temp);
			
			
		}	
		else if (this._level == 2)
		{
	
		}
				
        this.setScrollPosition([0,0]);
		this.cellRowDelegates();
		
	},
	
	 getParentName:function(cellModel)
	    {
	    	var parentx =cellModel.custom_attributes.parentx;
	    	var parenty= cellModel.custom_attributes.parenty;
	    	var parentxname= null;
	    	var parentyname= null;
	    	
	    	var size = this.breedableFishArray.getLength();
	    	var item = null;
	    	for(var i = 0 ; i < size ; i++)
	    	{
	    		item = this.breedableFishArray.objectAtIndex(i);
	    		if(parentx == item.visible_id)
	    			{
	    			parentxname = item.name;
	    			}
	    		else if(parenty == item.visible_id)
	    			{
	    			parentyname = item.name;
	    			}
	    		if(parentxname != null && parentyname!= null)
	    			{
	    				return GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_BREED_MSG'),[parentxname,parentyname]);
	    			}
	    	}
	    	
	    },
	    
    
	    getBreededCombinationArray:function(cellModel)
	    {
	    	
	    	this.breededFishCombinationArray = new  GAMutableArray();
	    	var id = cellModel.visible_id;
	    	var size = this.breededFishArray.getLength();
	    	var item = null;
	    	for (var i = 0 ; i< size ; i++ )
	    		{
	    			item = this.breededFishArray.objectAtIndex(i);
	    			if(item.custom_attributes.parentx == id || item.custom_attributes.parenty == id)
	    				{
	    					this.breededFishCombinationArray.addObject(item);
	    				}
	    			
	    		}
	    },
	    
	    
	    
    cellRowDelegates:function()
    {
    	var temp , cell;

    	var noOfCells = 0;
		
    	this.clearStoreItems();
	   	if(this.listSection) {
	   		this.listSection.flush();
	   		this.listSection = null;
	   	}
	   	
	   	if (this._level == 1)
	   	{ 
	   		noOfCells = this.breedableFishArray.getLength();
    		console.log('.....24' + noOfCells);
    		if(noOfCells == 0)
    		{	
    		}
    		
    		 this.listSection = new UI.ListViewSection({// /equivalent of
    			 'rowHeight': TFUtil.getAdjustedX(70)
			});
			 this.topLabel.destroy();
			 this.topLabel = null;
			 this.createTopPannel();

        }
    	else if (this._level == 2)
        { 

    		noOfCells = this.breededFishCombinationArray.getLength();
    		if(noOfCells == 0)
    		{
    			
    		}
    		 this.listSection = new UI.ListViewSection({// /equivalent of
    			 'rowHeight': TFUtil.getAdjustedX(90),
    			 'titleView': this.topLabel
			});

        }

        for (temp = 0; temp < noOfCells; temp++)
		{ 	
			cell = this.createCellForMainStoreTable(temp);	
        	this.storeItems.push(cell);
        }
       
       
		
        this.listSection.setItems(this.storeItems);
        this.setSections([this.listSection]);
    },
    
   
    clearStoreItems: function () {
    	if(this.storeItems) {
			for (var temp = 0;temp < this.storeItems.length; temp++)
			{
        		cell = this.storeItems[temp];
        		cell.destroy();
        		cell = null;
			}
    	}
    	delete this.storeItems;
		this.storeItems = null;
        this.storeItems = [];
    },
    
    
    backButtonAction:function()
    {
		
    	if(this._level == 1) 
		{
								 
            return;
        }
    	this._level--;
			if(this._level == 1)
			{
				if(this.background) {
					this.removeChild(this.background);
					this.background.destroy();
					this.background = null;
				}
				if(this.left) {
					this.removeChild(this.left);
					this.left.destroy();
					this.left = null;
				}
				if(this.right) {
					this.removeChild(this.right);
					this.right.destroy();
					this.right = null;
				}
				this.breededFishCombinationArray.destroy();
				this.breededFishCombinationArray = null;
				this._ParentMainView.setStoreBottomText(GALocalizationHandler.getLocalizedString(Core.Localization.getString('TF_BREADING_TROPHIES')));
				this.store_cats_items = '';// this.store_cats_items.substr(0,1);
				this.item_store_id = "";
			
				this._ParentMainView.disableAndHideBackButton();// [smv.backButton
																// setHidden:TRUE];
			}
			
			
			this.setScrollPosition([0,0]);
			this.cellRowDelegates();
		
    },
    
    
    
    destroy: function($super)
    {
    	
    	if(this.topLabel)
    	{
    		this.topLabel.destroy();
    		this.topLabel = null;
    		
    	}
    
    	if(this.listSection)
    	{
    		this.listSection.flush();
    		this.listSection = null;
    		
    	}
    	if(this.breedableFishArray)
		{
			this.breedableFishArray.destroy();
			this.breedableFishArray = null;
		
		}
    	
    	if(this.breededFishArray)
		{
			this.breededFishArray.destroy();
			this.breededFishArray = null;
		
		}
    	if(this.breededFishCombinationArray)
		{
			this.breededFishCombinationArray.destroy();
			this.breededFishCombinationArray = null;
		
		}
    	this.clearStoreItems();
    	$super();    	
    	
    }
    
});

; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI Layers/TrophyScreen/TrophyMainView'] = function(){var exports = $MODULE_REGISTRY['Code/UI Layers/TrophyScreen/TrophyMainView'] || {}; $MODULE_REGISTRY['Code/UI Layers/TrophyScreen/TrophyMainView'] = exports; /**
 * 
 */

exports.TrophyMainView = UI.View.subclass(
{
    classname: "TrophyMainView",
    
    initialize: function($super) 
    {
    	$super();
        this.setFrame([TFUtil.getAdjustedY(0),TFUtil.getAdjustedX(0),TFUtil.getAdjustedY(GACommonUtils.getScreenWidth()),TFUtil.getAdjustedX(GACommonUtils.getScreenHeight())]);
        this.setBackgroundColor("000077BC");
        this.setOnLoad(this.loadView.bind(this));
    },
    
    loadView: function() {
    	this.addBackground();
        this.addCloseBtn();
        this.addBottomLabel();
        this._tableView = new TrophyGenericTableView();
        this._tableView.setParentMainView(this);
        this.addBackBtn();
        this.addChild(this._tableView);
    },
 
    addBackground: function()
    {
		var background = new UI.Image();
        background.setImage("./Content/images/UIPanels/storewindow/storeBG.png",UI.State.Normal);
        background.setFrame([TFUtil.getAdjustedY(20),TFUtil.getAdjustedX(20),TFUtil.getAdjustedY(430),TFUtil.getAdjustedX(300)]);
        background.setImageFit(UI.ViewGeometry.FitModes.Stretch);
        this.addChild(background);
    },
    
    addCloseBtn: function()
    {
    	
    	var closeBtn = new UI.Button();
		closeBtn.setImage("./Content/images/UIPanels/Buttons/cross1.png",UI.State.Normal);
		closeBtn.setImage("./Content/images/UIPanels/Buttons/cross2.png",UI.State.Selected);
		closeBtn.setFrame([TFUtil.getAdjustedY(430), TFUtil.getAdjustedX(20), TFUtil.getAdjustedY(30), TFUtil.getAdjustedX(30)]);
		this.addChild(closeBtn);
	
		closeBtn.onclick = function ()
		{
			this.getParent().removeFromParent();
			this.getParent().destroy();
		}; 
    },
    
    addBottomLabel: function()
    {
    	this._storeLabel = new UI.Label();
    	this._storeLabel.setFrame([TFUtil.getAdjustedY(480/2 - 70), TFUtil.getAdjustedX(20), TFUtil.getAdjustedY(130), TFUtil.getAdjustedX(45)]);
    	this._storeLabel.setTextGravity(UI.ViewGeometry.Gravity.Center);
    	this._storeLabel.setTextColor('000000');
    	this._storeLabel.setTextFont(TFUtil.getFontName());
    	this._storeLabel.setTextSize(20);
    	this.addChild(this._storeLabel);
    	this.setStoreBottomText(GALocalizationHandler.getLocalizedString(Core.Localization.getString('TF_BREADING_TROPHIES')));
    },
    
    addBackBtn:function()
	{
    	this.backBtn = new UI.Button();
    	this.backBtn.setTextColor("FFFFFF");
    	this.backBtn.setTextFont(TFUtil.getFontName());
   		this.backBtn.setText(GALocalizationHandler.getLocalizedString('TF_BACK_LABEL'));
		this.backBtn.setImage("./Content/images/UIPanels/Buttons/1buttonNormal.png",UI.State.Normal);
		this.backBtn.setImage("./Content/images/UIPanels/Buttons/1buttonSelected.png",UI.State.Selected);
		this.backBtn.setImageFit(UI.ViewGeometry.FitModes.Stretch);
		this.backBtn.setFrame([TFUtil.getAdjustedY(40), TFUtil.getAdjustedX(34), TFUtil.getAdjustedY(58), TFUtil.getAdjustedX(22)]);
			
		this.addChild(this.backBtn);
		this.disableAndHideBackButton();
		this.backBtn.onclick = function ()
    	{
		  this._tableView.backButtonAction();
   		}.bind(this);
    },
    
    hideBackBtn:function(){
    	this.backBtn.setState(UI.State.Selected);
    },
	
	setStoreBottomText: function(text)
    {
    	this._storeLabel.setText(text);
    },
    
    enableAndShowBackBtn:function()
    {
		this.backBtn.setEnabled(true);
    	this.backBtn.setAlpha(1);
	},
    
    disableAndHideBackButton:function()
    {
		this.backBtn.setEnabled(false);
    	this.backBtn.setAlpha(0.03);
    },
    destroy: function($super)
    {
    	TFUtil.destroyView(this);
    	$super();
    },
    
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI Layers/TrophyScreen/TrophyTableViewCell'] = function(){var exports = $MODULE_REGISTRY['Code/UI Layers/TrophyScreen/TrophyTableViewCell'] || {}; $MODULE_REGISTRY['Code/UI Layers/TrophyScreen/TrophyTableViewCell'] = exports; /**
 * 
 */
exports.TrophyTableViewCell = UI.ListViewItem.subclass({
    
    classname: "TrophyTableViewCell",
    
    initialize: function($super,reuseId,cellModel) {
    	$super(reuseId);
    	this._ParentTableView = null;
    	this._cellView = null;
    	this._indexPath_Row = 0;
        this._cellModel = cellModel;
    },
    _onCreateView: function() {
    	
		var width = 0 , height = 0;
													  
        width = GACommonUtils.getScreenWidth();
        height = GACommonUtils.getScreenHeight();
        
		this._cellView = new CustomCellView();
        
        ///Adding whole cell's size button
        this._cellView._BigButton = new UI.Button();
        this._cellView._BigButton.setTextGravity(UI.ViewGeometry.Gravity.Center);
        this._cellView._BigButton.setFrame([TFUtil.getAdjustedY(0),TFUtil.getAdjustedX(0),TFUtil.getAdjustedY(380),TFUtil.getAdjustedX(100)]);

        this._cellView._BigButton.setGradient({ gradient: ["245779 0.0","3f7EA4 1.0"]});
		this._cellView.addChild(this._cellView._BigButton); 
		
		this._cellView._arrowImage = new UI.Image();
		this._cellView._arrowImage.setImage("./Content/images/UIPanels/storewindow/arrow.png",UI.State.Normal);
		this._cellView._arrowImage.setFrame([TFUtil.getAdjustedY(340),TFUtil.getAdjustedX(80/2 - 10),TFUtil.getAdjustedY(12),TFUtil.getAdjustedX(18)]);
		this._cellView._arrowImage.setImageFit(UI.ViewGeometry.FitModes.Stretch);
        this._cellView.addChild(this._cellView._arrowImage);
        
		this._cellView._label1 = new UI.Label();
		this._cellView._label1.setTextGravity(UI.ViewGeometry.Gravity.Left);
		this._cellView._label1.setTextColor('FFFFFF');
		this._cellView._label1.setTextFont(TFUtil.getFontName());
		this._cellView._label1.setTextSize(13);
		this._cellView._label1.setFrame([TFUtil.getAdjustedY(75), TFUtil.getAdjustedX(20), TFUtil.adjustHeightWithDevice(200), TFUtil.adjustWidthWithDevice(22)]);
		
		this._cellView.addChild(this._cellView._label1);

        return this._cellView;
    },
    _onSetView: function(cellView) 
    {
        cellView._label1.setText(this._cellModel.name);
        
		cellView._BigButton.onclick = this.didSelectRow.bind(this);
        
        if(this._ParentTableView._level == 1)
        {
        	cellView._arrowImage.setVisible(true);
        }
        else
        {
            cellView._arrowImage.setVisible(false);
            this.disableBigButton(cellView);
        }
        this._setIconImage(cellView);
        this._cellView = cellView;
    },
    
    _setIconImage: function(cellView)
    {
 
        	var path = null;
	        path = '' +this._cellModel.parent.parent.visible_id+'_'+this._cellModel.parent.visible_id+'_'+this._cellModel.visible_id;
			var obj = GAGameLoader.getStoreHandler().getStoreObjectForKey(path);
													  
			
			if(cellView.icon != null) {
				cellView.removeChild(cellView.icon);
				cellView.icon.destroy();
				cellView.icon = null;
			}
        	
			cellView.icon1 = new GAStoreIcon();
			cellView.icon1.setFrame([TFUtil.getAdjustedY(6), TFUtil.getAdjustedX(12), TFUtil.getAdjustedY(60), TFUtil.getAdjustedX(60)]);
			cellView.icon1.setImage("./Content/images/Store/storetableimgs/box.png",UI.State.Normal);
			cellView.addChild(cellView.icon1);
			
			if(this._ParentTableView._level == 2 && !TFUtil.isBreedFishExist(this._cellModel.parent.parent.visible_id+'_'+this._cellModel.parent.visible_id+'_'+this._cellModel.visible_id))
			{
				if(cellView.icon2 != null) {
					cellView.removeChild(cellView.icon2);
					cellView.icon2.destroy();
					cellView.icon2 = null;
				}
				
				cellView.icon2 = new GAStoreIcon();
				cellView.icon2.setFrame([TFUtil.getAdjustedY(11), TFUtil.getAdjustedX(17), TFUtil.getAdjustedY(48), TFUtil.getAdjustedX(48)]);
				cellView.icon2.setImage("./Content/images/breedlock.png",UI.State.Normal);
				//cellView.icon = this.icon2;
				cellView.addChild(cellView.icon2);
			}
			else
			{
				cellView.icon = new GAStoreIcon();
				cellView.icon.setFrame([TFUtil.getAdjustedY(16), TFUtil.getAdjustedX(23), TFUtil.getAdjustedY(40), TFUtil.getAdjustedX(40)]);
				cellView.icon.load(obj);
	            
				cellView.icon = cellView.icon;
				cellView.addChild(cellView.icon);
			}
		
		
	},
	
	didSelectRow: function() {

		this._ParentTableView.didSelectRowAtIndexPath(this._indexPath_Row);											  
	},
    
    disableBigButton:function(cellView)
    {
    	cellView._BigButton.setEnabled(false);
    },
    
    _setParentTableView: function(reference)     
    {
        this._ParentTableView = reference;
    },
    
	_setIndexPath_Row: function(value)	
    {
        this._indexPath_Row = value;
    },
	
	_getParentTableView: function()		
    {
        return this._ParentTableView;
    },
    
    _getIndexPath_Row: function()		
    {
        return this._indexPath_Row;
    },

    destroy: function() {
    	if(this._cellView){
    		this._cellView.destroy();
    		this._cellView = null;
    	}
    	
    },
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI Layers/TrophyScreen/TrophyCell/TrophyMainCell'] = function(){var exports = $MODULE_REGISTRY['Code/UI Layers/TrophyScreen/TrophyCell/TrophyMainCell'] || {}; $MODULE_REGISTRY['Code/UI Layers/TrophyScreen/TrophyCell/TrophyMainCell'] = exports; exports.TrophyMainCell =  TrophyTableViewCell.subclass({
    
    classname: "TrophyMainCell",
	
    
    initialize: function($super,reuseId,cellModel,count,result) 
    {
    	$super(reuseId,cellModel);
        this._indexPath_Row = reuseId;
        this._cellModel = cellModel;
        this._count = count; 
        this.cellView = null;
        this.result =result;
    },
    
   
    _onCreateView: function($super) 
    {
    	        
    	this.cellView = $super();
		 
        this.cellView._availableLabel = new UI.Label();
        this.cellView._availableLabel.setTextGravity(UI.ViewGeometry.Gravity.Left);
		this.cellView._availableLabel.setTextColor('FFFF33');
		this.cellView._availableLabel.setTextFont(TFUtil.getFontName());
		this.cellView._availableLabel.setTextSize(10);
		this.cellView._availableLabel.setFrame([TFUtil.getAdjustedY(80), TFUtil.getAdjustedX(35), TFUtil.getAdjustedY(230), TFUtil.getAdjustedX(18)]);
        this.cellView.addChild(this.cellView._availableLabel);
        return this.cellView;
    },
    
    _onSetView: function($super,cellView)
    {
    	$super(cellView);										   
        cellView._availableLabel.setText(GALocalizationHandler.getRelativeString(Core.Localization.getString('TF_UNLOCKED'),[this.result,this._count]));
    },
    
    _setParentTableView: function($super,reference)
    {
        $super(reference);
    },
    
		_setIndexPath_Row:function($super,value)
    {
        $super(value);
    },
	
		_getIndexPath_Row: function($super)
    {
        return $super();
    },
    
		_getParentTableView: function($super)			
    {
        return $super();
    },
    
    destroy: function($super) 
    {

		 $super();
	}

});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI Layers/TrophyScreen/TrophyCell/TrophyBreadingCell'] = function(){var exports = $MODULE_REGISTRY['Code/UI Layers/TrophyScreen/TrophyCell/TrophyBreadingCell'] || {}; $MODULE_REGISTRY['Code/UI Layers/TrophyScreen/TrophyCell/TrophyBreadingCell'] = exports; /**
 * 
 */
exports.TrophyBreadingCell = TrophyTableViewCell.subclass({
    
    classname: "TrophyBreadingCell",
	
    initialize: function($super,reuseId,cellModel,parentName)
    {
												   
        $super(reuseId,cellModel);
        this._indexPath_Row = reuseId;
        this._cellModel = cellModel;
        this._parentName = parentName;
        this.cellView = null;
    },
    _onCreateView: function($super) 
    {
    	this.cellView = $super();
        this.cellView._availableLabel = new UI.Label();
        this.cellView._availableLabel.setTextGravity(UI.ViewGeometry.Gravity.Left);
		this.cellView._availableLabel.setTextColor('FFFF33');
		this.cellView._availableLabel.setTextFont(TFUtil.getFontName());
		this.cellView._availableLabel.setTextSize(12);
		this.cellView._availableLabel.setFrame([TFUtil.getAdjustedY(80), TFUtil.getAdjustedX(35), TFUtil.getAdjustedY(230), TFUtil.getAdjustedX(18)]);
        this.cellView.addChild(this.cellView._availableLabel);
        
        this.cellView._availableLabel1 = new UI.Label();
        this.cellView._availableLabel1.setTextGravity(UI.ViewGeometry.Gravity.Left);
		this.cellView._availableLabel1.setTextColor('FFFF33');
		this.cellView._availableLabel1.setTextFont(TFUtil.getFontName());
		this.cellView._availableLabel1.setTextSize(12);
		this.cellView._availableLabel1.setFrame([TFUtil.getAdjustedY(80), TFUtil.getAdjustedX(50), TFUtil.getAdjustedY(230), TFUtil.getAdjustedX(18)]);
        this.cellView.addChild(this.cellView._availableLabel1);
        
        this.cellView._availableLabel2 = new UI.Label();
        this.cellView._availableLabel2.setTextGravity(UI.ViewGeometry.Gravity.Left);
		this.cellView._availableLabel2.setTextColor('FFFF33');
		this.cellView._availableLabel2.setTextFont(TFUtil.getFontName());
		this.cellView._availableLabel2.setTextSize(12);
		this.cellView._availableLabel2.setFrame([TFUtil.getAdjustedY(80), TFUtil.getAdjustedX(65), TFUtil.getAdjustedY(230), TFUtil.getAdjustedX(18)]);
        this.cellView.addChild(this.cellView._availableLabel2);
        
        return this.cellView;
    },
    _onSetView: function($super,cellView) 
    {
        $super(cellView);
		var buyPrices = GACommonUtils.getSellPrice(this._cellModel);
		var price = -1;
			if(buyPrices != null){
			price = StoreUtil.getPriceBreeded(buyPrices);

	    }
        cellView._availableLabel.setText(this._parentName);//
        cellView._availableLabel1.setText(GALocalizationHandler.getRelativeString(Core.Localization.getString('TF_ADULT'),[this.getAdultTime()]));
        cellView._availableLabel2.setText(GALocalizationHandler.getRelativeString(Core.Localization.getString('TF_SELL_FOR'),[price]));
    },
    
    getAdultTime:function()
    {
    	var dayCount = Math.floor(this._cellModel.custom_attributes.timetoadulthood/24);
		var hourCount = this._cellModel.custom_attributes.timetoadulthood%24;
		var adultTime = '';
		if (dayCount > 0) {
			adultTime = (dayCount == 1) ?+dayCount+ ' Day ' : dayCount +' Days ';
		}
		if (hourCount > 0) {
			adultTime += (hourCount == 1) ? hourCount+' Hour' : +hourCount+' '+' Hours';
		}
    	
		return adultTime;
    },
    
   
    _setParentTableView: function($super,reference)
    {
        $super(reference);
    },
    
	_setIndexPath_Row:function($super,value)
    {
        $super(value);
    },
	
	_getIndexPath_Row: function($super)
    {
        return $super();
    },
    
	_getParentTableView: function($super)			
    {
        return $super();
    },
    
    destroy: function($super) {
    	$super();
    }
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/GLLayer/DecorationUI'] = function(){var exports = $MODULE_REGISTRY['Code/GLLayer/DecorationUI'] || {}; $MODULE_REGISTRY['Code/GLLayer/DecorationUI'] = exports; 
exports.DecorationUI = GL2.Node.subclass({

  classname: 'DecorationUI',  
	initialize: function($super,decorationModel,parentTank) 
	{
		$super();
	    var storeDeco = GAGameLoader.getStoreHandler().getStoreObjectForKey(decorationModel._decorationObj.storeId);
	 
		this._width = storeDeco.custom_attributes.size_width;
		this._heigth = storeDeco.custom_attributes.size_height;
		
		 
		this.SCREEN_HEIGHT = Core.Capabilities.getScreenWidth();
		this.SCREEN_WIDTH = Core.Capabilities.getScreenHeight();
		this.isFlipped = decorationModel._decorationObj.isFlipped;
		this.parentTank = parentTank;
		this.touchesBegan = true;
		
		//*** Changes for Animatable Decoration by kamran -- 17th June 2011 ***//
		this.isAnimatable = storeDeco.custom_attributes.animateable;
		this.animationCount = 0;
		//this.decorationAnimation = new GL2.Animation();
		//*** changes end ***//

		this.decorationModelObject = decorationModel;
										 
		this._basePath = TFUtil.getBasePathForResourceType(decorationModel._decorationObj.storeId, GAResourceType.kDetail);
		
		this.normalImage = this._basePath+'/2.png';
		this.selectedImage = null;
				
		this._gaSprite = new GASprite(this.normalImage, [this._width,this._heigth], [.5,.5]);
		this._oneDeco = this._gaSprite.getNode();
		
		if(this.isAnimatable)
		{	var tempAnimation = new GL2.Animation();
			this.animationCount = storeDeco.custom_attributes.animationsetcount;
			for (var i = 1; i  <= this.animationCount; i++)
			{	
				var image = this._basePath+'/'+i+'.png';
				tempAnimation.pushFrame(new GL2.Animation.Frame(image,200,[this._width, this._heigth],[0.5, 0.5],[0,0,1,1]));
				
			}
			tempAnimation.setLoopingEnabled(true);
			this.decorationAnimation = tempAnimation;
			//this.timerVar =	setTimeout(this.animateDecoration.bind(this), 200);
		}
		
		
		if(decorationModel.getPositionVector().getX() == 0 && decorationModel.getPositionVector().getY() == 0)
		{
			
			this._oneDeco.setPosition(this.SCREEN_WIDTH/2,this.SCREEN_HEIGHT/2);
			this.setScaleOfDecoration();
		}
		else
		{
			this._oneDeco.setPosition(decorationModel.getPositionVector());
			this.setScaleOfDecoration();
			if(this.isFlipped != 1)
			{
				 this._oneDeco.setPosition(decorationModel.getPositionVector());
				 this.setScaleOfDecoration();

			}
		}

		this.addChild(this._oneDeco);

		this.myMessageListener = new Core.MessageListener();
		this._target = new GL2.TouchTarget();
		//this._target.setAnchor(0,0);
		this._target.setSize(this.SCREEN_WIDTH,this.SCREEN_HEIGHT);
		this._target.getTouchEmitter().addListener(this.myMessageListener, this.onTouch.bind(this));
		this._target.setDepth(1);
		this.addChild(this._target);
	},

	
	animateDecoration:function()
	{
		this._oneDeco.setAnimation(this.decorationAnimation);
		clearTimeout(this.timerVar);		
		this.timerVar = setTimeout(this.animateDecoration.bind(this), 1000);
	},
	
    onTouch: function(touch)
	{
        if(touch.getAction() == touch.Action.Start)
		{
			if(this.ccTouchesBegan(touch))
				return true;
		}
        else if(touch.getAction() == touch.Action.Move)
        {
				 
            this.ccTouchesMoved(touch);
        }
		else if(touch.getAction() == touch.Action.End)
		{

			this.ccTouchesEnded(touch);
		}
		return false;
		
    },
    
    
    ccTouchesBegan: function(touch)
    {
    	if(!TFUtil.getIsTouched())//IS_TOUCHED)
		{
			var selectedTankAction = GameLayer.getSelectedTank().getTankAction();
			if(selectedTankAction == kTankActionType.kTankActionArrow && this._gaSprite.isTouched(touch.getPosition().clone()))
			{
				this.touchesBegan = true;
				var initialTouch = touch.getPosition().clone();
				var myPosition = this._oneDeco.getPosition();
				this.deltaVector = new Core.Vector(myPosition.getX() - initialTouch.getX(), myPosition.getY() - initialTouch.getY());
				
				TFUtil.setIsTouched(true);
				//IS_TOUCHED = true;
				return true;
				
			}
		}
    },
    
    ccTouchesEnded: function(touch)
    {
    	if(TFGameState.atNeighbor)
			return;
			
		this._oneDeco.setImage(this.normalImage, [this._width,this._heigth], [.5,.5]);
		if(!this.touchesBegan)
		{
				return false;
		}  
	
		if(!this.shouldMoveAround)
		{	
			this.selectedImage = this._basePath+'/selected.png';
			this._oneDeco.setImage(this.selectedImage, [this._width,this._heigth], [.5,.5]);
			
			var controlLayer = GameLayer.getControlLayer();
			var attributeWindow = new AttributeWindow(attributeWindowType.decorationEnum,this); 
			controlLayer.addChild(attributeWindow);
			controlLayer.disableButtons();
			
		}
		TFUtil.setIsTouched(false);
		this.decorationModelObject.setPosition(this._oneDeco.getPosition(),this.parentTank.tankModel);
		this.touchesBegan = false;
		this.shouldMoveAround = false;
    },
	
	ccTouchesMoved: function(touch)
	{ 

		   //setting scaling factor
		if(this.shouldMoveAround && this.touchesBegan)
		{
			
			this.setScaleOfDecoration();  
			
			var newVector = new Core.Vector(touch.getPosition().getX()+this.deltaVector.getX(),touch.getPosition().getY()+this.deltaVector.getY());
			
		   //checking boundry conditions
			
			var scalX =  this._oneDeco.getScale().getX();
			var scalY = this._oneDeco.getScale().getY();
			if(scalX<0)
			{
				scalX = -1*scalX;
			}

			if (newVector.getX() > (this._width * scalX)/2 &&  newVector.getX() < this.SCREEN_WIDTH - (this._width * scalX)/2  
				&& newVector.getY() > (this._heigth * scalY)/2 && newVector.getY() < this.SCREEN_HEIGHT - (this._heigth * scalY)/2)
			{
				this._oneDeco.setPosition(newVector);
			}
			
			else
			{
				   //do nothing
			}
			delete newVector;
			TFUtil.setIsTouched(false);
			
		}
		return false;
	},
	
	setScaleOfDecoration: function()
	{
		var x = this._oneDeco.getPosition().getY();
		var x1 = 0;
		var x2 = this.SCREEN_HEIGHT;
		var y1 = 0.8;
		var y2 = 2.2;
		var y = (1+(.4/this.SCREEN_HEIGHT)*(x-this._heigth/2));
		this._oneDeco.setScale(this.isFlipped*y,y); 

	},
   
	setPosition: function(x, y)
	{
		this._oneDeco.setPosition(TFUtil.getAdjustedY(x), TFUtil.getAdjustedX(y));
	},
	
	flipDecorationSet:function()
	{
		this._oneDeco.setScale(-1*this._oneDeco.getScale().getX(),this._oneDeco.getScale().getY());
		this.decorationModelObject.setDecorationFlip(this.isFlipped,this.parentTank.tankModel);
		
	},
    
	getZIndex: function()
	{
		return this.decorationModelObject.getZIndex();
	},
	
	flipDecoration:function()
	{
		if(this.isFlipped == -1)
		{
			this.isFlipped = 1;
		}
		else
		{
			this.isFlipped = -1;
			
		}
		this.flipDecorationSet();
	},



	selectedDecoration:function()
	{
		this.selectedImage = this._basePath+'/selected.png';
		this._oneDeco.setImage(this.selectedImage, [this._width,this._heigth], [.5,.5]);
		this.shouldMoveAround = true;

	},
	
	destroyDecorationFromDb:function()
	{
		this.parentTank.tankModel.sellDecoration(this.decorationModelObject._decorationObj.objectId);
	},
	getDecorationObject: function()
	{
		return this.decorationModelObject._decorationObj;
	},
	
	destroy: function($super)
	{
		if(this.timerVar)
		{
			clearTimeout(this.timerVar);
			this.timerVar = null;
		}
		
		if(this.myMessageListener){
			this.myMessageListener.destroy();
			this.myMessageListener = null;
		}
		
		if(this.decorationModelObject)
		{
			this.decorationModelObject.destroy();
			this.decorationModelObject = null;
		}
		
		if(this.decorationAnimation)
		{	
			this.decorationAnimation.destroy();
			this.decorationAnimation = null;
		}
		
		if(this.deltaVector){
			delete this.deltaVector;
		}
		TFUtil.destroyNodeChildren(this);
		$super();
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/GLLayer/TFMiniGLAlertView'] = function(){var exports = $MODULE_REGISTRY['Code/GLLayer/TFMiniGLAlertView'] || {}; $MODULE_REGISTRY['Code/GLLayer/TFMiniGLAlertView'] = exports; /**
 * Filename: TFMiniGLAlertView.js
 */
// Initializing AlertWindow 
// there are 5 parameters passed to constructor below are the details of parameters
// 1.initWithTitle				: it is first parameter. it will take title string and set AlertWindow title
// 2.message       				: it will take message string and set Message in AlertWindow
// 3.delegate 	   				: setting delegate.
// 4.cancelButtonTitle			: it will take cancel button title string which should be localized string
// 5.otherButtonTitles			: it will take ok button title string which should be localized string

// setter functions
// there are 9 setter function through which you can set button text, title text and message text colors.
// it is also allow you to set background and button normal and highlighted images path
// you can also set type of your alertWindow and type detail is given below

// there are two type of alert view
// 1."ok" which means AlertWindow with ok button only
// 2."okwithcancel" means AlertWindow with ok and cancel button both 
// by default it takes type "ok"


//Default type for alert window
var kALERT_WINDOW_TYPE = "ok"

//AlertWindow button image default paths

var kALERT_WINDOW_BACKGROUND  = "./Content/images/UIPanels/AlertWindow/alert-background.png"
// Ok buttons
var kALERT_WINDOW_OK_NORMAL ="./Content/images/UIPanels/Buttons/1buttonNormal.png"
var kALERT_WINDOW_OK_SELECTED ="./Content/images/UIPanels/Buttons/1buttonSelected.png"


var kALERT_WINDOW_CANCEL_NORMAL ="./Content/images/UIPanels/Buttons/1buttonNormal.png"
var kALERT_WINDOW_CANCEL_SELECTED ="./Content/images/UIPanels/Buttons/1buttonSelected.png"


exports.TFMiniGLAlertView = GL2.Node.subclass({
	
	classname: 'TFMiniGLAlertView',
	initialize: function($super,initWithTitle,message,delegate,cancelButtonTitle,otherButtonTitles)
	{
		
		$super();
			this.w							= null;
			this.h							= null;
			this._tagValue					= null;
			
			this._title 					= null;
			this._message 					= null;
			this._delegate 					= null;
			this.cancelButtonTitle 			= null;
			this._otherButtonTitles			= null;
			
			
			this._type						= null;
			
			this._backgroundImagePath		= null;
			this._okImageNormalPath 		= null;
			this._okImageSelectedPath 		= null;
			this._cancelImageNormalPath		= null;
			this._cancelImageSelectedPath	= null;
	    	
	    	this._buttonsColor				= null;
	    	this._titleColor				= null;
	    	this._messageColor				= null;
	    	this._messageFont				= null;
	    	this._titleFont					= null;
	    	this._buttonsFont				= null;
	    	this._messageFontLocation		= null;
	    	this._titleFontLocation			= null;
	    	this._buttonsFontLocation		= null;
			
			this._background 				= null;
			this.myMessageListener 			= null;
			
			// initializing data members with parameters 
			if (initWithTitle == null) {
				initWithTitle = GALocalizationHandler.getLocalizedString('TF_MESSAGE_TEXT');//Message
				}
			
			if (initWithTitle.length > 11) {
				this._title = initWithTitle.substring(0, 10);
				} 
			else 
			{
				this._title = initWithTitle;
			}
			
			this._message = message;
			this._delegate = delegate;
			this.cancelButtonTitle = cancelButtonTitle;
			this._otherButtonTitles= otherButtonTitles;	
			
			// setting images default path
			this._backgroundImagePath		=kALERT_WINDOW_BACKGROUND;
			this._okImageNormalPath			=kALERT_WINDOW_OK_NORMAL;
			this._okImageSelectedPath		=kALERT_WINDOW_OK_SELECTED;
			this._cancelImageNormalPath	 	=kALERT_WINDOW_CANCEL_NORMAL;
			this._cancelImageSelectedPath	=kALERT_WINDOW_CANCEL_SELECTED;
			
			
			// setting Default type
			this._type=kALERT_WINDOW_TYPE;
		
			
			// setting default colors
			this._buttonsColorRed=1;
			this._buttonsColorGreen=1;
			this._buttonsColorBlue=1;
			
			this._titleColorRed=1;
			this._titleColorGreen=1;
			this._titleColorBlue=0;
			
			this._messageColorRed=118/255; 
			this._messageColorGreen=50/255;
			this._messageColorBlue=58/255;
			
			// setting frame of this view
			this.w = Core.Capabilities.getScreenWidth();
			this.h = Core.Capabilities.getScreenHeight();
			
			
					
		this.makeTouchSwallower();// fullscreen touch target to swallow the touches beyond the attribute window 

    	
//		return this;
	},
	loadGl: function()
	{

		var background = new GL2.Sprite();		
		background.setImage(this._backgroundImagePath,[this.adjustHeightWithDevice(300),this.adjustWidthWithDevice(150)],[.5,.5]);
		background.setPosition(this.getAdjustedY(250),this.getAdjustedX(160));

        this.addChild(background);
       	
			var okButton = new GLButton(this._okImageNormalPath,this._okImageSelectedPath, this.adjustHeightWithDevice(73),this.adjustWidthWithDevice(37),this.clickedButtonOk.bind(this),this,100);
			okButton.setPosition(this.getAdjustedY(245),this.getAdjustedX(210));
			
			var okButtonText = new GL2.Text();
			okButtonText.setText(this._otherButtonTitles);
			okButtonText.setAnchor(0,0);
			okButtonText.setFontSize(this.getAdjustedFontSize(100));
			okButtonText.setSize([this.adjustHeightWithDevice(71.25),this.adjustWidthWithDevice(55.5)]);
			okButtonText.setPosition(this.getAdjustedY(210),this.getAdjustedX(181));
			okButtonText.setColor(this._buttonsColorRed,this._buttonsColorGreen,this._buttonsColorBlue);
			//this._okButtonText.setColor(1,1,1);
			okButtonText.setDepth(100);
			if (this._buttonsFont && this._buttonsFontLocation) {
	    		okButtonText.setFontLocation(this._buttonsFontLocation);
	    		okButtonText.setFontFamily(this._buttonsFont);
	    	}
			this.addChild(okButtonText);
			
		

		if(this._type == "okwithcancel")
		{
			
			
			okButton.setPosition(this.getAdjustedY(205),this.getAdjustedX(210));
			okButtonText.setPosition(this.getAdjustedY(170),this.getAdjustedX(183));
			
			
			var cancelButton = new GLButton(this._cancelImageNormalPath,this._cancelImageSelectedPath, this.adjustHeightWithDevice(73),this.adjustWidthWithDevice(37),this.clickedButtonCancel.bind(this),this,100);
			cancelButton.setPosition(this.getAdjustedY(285),this.getAdjustedX(210));
			
			
			cancelButtonText = new GL2.Text();
			cancelButtonText.setText(this.cancelButtonTitle);
			cancelButtonText.setAnchor(0,0);
			cancelButtonText.setFontSize(this.getAdjustedFontSize(100));
			cancelButtonText.setSize([this.adjustHeightWithDevice(71.25),this.adjustWidthWithDevice(55.5)]);
			cancelButtonText.setPosition(this.getAdjustedY(253),this.getAdjustedX(183));
			cancelButtonText.setColor(this._buttonsColorRed,this._buttonsColorGreen,this._buttonsColorBlue);
			//this._cancelButtonText.setColor(1,1,1);
			cancelButtonText.setDepth(100);
			if (this._buttonsFont && this._buttonsFontLocation) {
	    		cancelButtonText.setFontLocation(this._buttonsFontLocation);
	    		cancelButtonText.setFontFamily(this._buttonsFont);
	    	}
			this.addChild(cancelButtonText);
			
		}
		
		
		var messageLabel = new GL2.Text();
    	messageLabel.setText(this._message);
    	messageLabel.setSize(this.adjustHeightWithDevice(260),this.adjustWidthWithDevice(200));
    	messageLabel.setAnchor(.5,.5);
    	messageLabel.setFontSize(this.getAdjustedFontSize(120));//changed to 120 from 130
    	messageLabel.setColor(this._messageColorRed,this._messageColorGreen,this._messageColorBlue);
    	messageLabel.setPosition(this.getAdjustedY(240),this.getAdjustedX(130));
    	if (this._messageFont && this._messageFontLocation) {
    		messageLabel.setFontLocation(this._messageFontLocation);
    		messageLabel.setFontFamily(this._messageFont);
    	}	
    	this.addChild(messageLabel);
    	
    	
    	var titleLabel = new GL2.Text();
    	titleLabel.setText(this._title);
    	titleLabel.setAnchor(.5,.5);
    	titleLabel.setFontSize(this.getAdjustedFontSize(100));
    	titleLabel.setColor(this._titleColorRed,this._titleColorGreen,this._titleColorBlue);
    	//this._title.setColor(1,1,1);
    	titleLabel.setPosition(this.getAdjustedY(245),this.getAdjustedX(250));
    	if (this._titleFont && this._titleFontLocation) {
    		titleLabel.setFontLocation(this._titleFontLocation);
    		titleLabel.setFontFamily(this._titleFont);
    	}
    	this.addChild(titleLabel);
    	
		
	},
	show: function()
	{
		this.loadGl();
		GL2.Root.addChild(this);
	},
	
		
	makeTouchSwallower: function()
    {
    	
    	var myMessageListener = 0;
    	var dissolveTouchesTarget = new GL2.TouchTarget();
    	dissolveTouchesTarget.setAnchor(0,0);
		dissolveTouchesTarget.setSize(this.getAdjustedY(this.h),this.getAdjustedX(this.w));
        dissolveTouchesTarget.setPosition(this.getAdjustedY(0),this.getAdjustedX(0));
        myMessageListener = new Core.MessageListener();
		dissolveTouchesTarget.getTouchEmitter().addListener(myMessageListener, this.dissolveTouches.bind(this),kTouchSwallower); //@sunilla make this 10 go to Constants.
		this.addChild(dissolveTouchesTarget);
    },
    
    
    
    dissolveTouches: function()
    {
    	return true;
    },
	
	
	// on click call backs
	clickedButtonOk: function()
	{
		this.clickedButtonAtIndex(0);
        //this.callBack();
	    //return true;

	},
	
	clickedButtonCancel: function()
	{
		this.clickedButtonAtIndex(1);
	    //this.callBack();
		//return true;	

	},
	
	
	clickedButtonAtIndex: function(buttonIndex)
	{
		if(this._delegate)		
		{
			this._delegate.clickedButtonAtIndex(buttonIndex,this);
		}
		//this.callBack();
		this.destroy();	
		
	},
	

	////////////////////////////////////////////////////////////
	
	//getter
	getTagValue: function()
	{
		return this._tagValue;
	},
	
	
	//setters
	
	setTagValue: function(value)
	{
		this._tagValue = value;
	},
	
	setType : function(type)
	{
		this._type=type;
	},
	setButtonColor : function(red,green,blue)
	{
		this._buttonsColorRed	=red;
		this._buttonsColorGreen	=green;
		this._buttonsColorBlue	=blue;
		
	},
	
	setTitleColor : function(red,green,blue)
	{
		this._titleColorRed		=red;
		this._titleColorGreen	=green;
		this._titleColorBlue	=blue;
	},
	
	setMessageColor : function(red,green,blue)
	{
		this._messageColorRed	=red;
		this._messageColorGreen	=green;
		this._messageColorBlue	=blue;
	},
	
	setMessageFont:function(font,fontLocation) 
    {
    	this._messageFont = font;
    	this._messageFontLocation = fontLocation;
    },

    
    setTitleFont:function(font,fontLocation) 
    {
    	this._titleFont = font;
    	this._titleFontLocation = fontLocation;
    },
        
    setButtonsFont:function(font,fontLocation) 
    {
    	this._buttonsFont = font;
    	this._buttonsFontLocation = fontLocation;
    },
    

	setBackgroundImagePath: function(path)
	{
		this._backgroundImagePath =path;
	},
	
	setOkImageNormalPath: function(path)
	{
		this._okImageNormalPath =path;
	},
	
	setOkImageSelectedPath: function(path)
	{
		this._okImageSelectedPath =path;
	},
	
	setCancelImageNormalPath: function(path)
	{
		this._cancelImageNormalPath =path;
	},
	
	setCancelImageSelectedPath: function(path)
	{
		this._cancelImageSelectedPath =path;
	},
		
	////////////////////////////////////////////////////////////
	
getAdjustedX: function(x) {
	
	var width = 0 , newWidth = 0 ;
	width = Core.Capabilities.getScreenWidth();
	newWidth = (width / 320) * x;
	
	return newWidth;
	
},

getAdjustedY: function(y) 
{
	var height = 0 , newHeight = 0;
	height = Core.Capabilities.getScreenHeight();
	newHeight = (height / 480) * y;
	
	return newHeight;
},

adjustWidthWithDevice: function(aWidth)
{
	var w = 0, calWidth = 0;
	
	w = Core.Capabilities.getScreenWidth();
	
	calWidth = aWidth * (w/320);
		//////NgLogE('Bandri Width:'+aWidth +'-->'+calWidth +'device W:'+w);
	return calWidth;			
},
adjustHeightWithDevice: function(aHeight)
{
	var h = 0 , calHeight = 0;
	
	h = Core.Capabilities.getScreenHeight();
	
	calHeight = aHeight * (h/480);
		//////NgLogE('Bandri Width:'+aHeight +'-->'+calHeight +'device H:'+h);
	return calHeight;		
	
},

getAdjustedFontSize: function(fieldHeight) {
	return this.getAdjustedY(fieldHeight / 2) / aspectRatioFactor.d;
},
	////////////////////////////////////////////////////////////

destroy: function($super)
	{
		GL2.Root.removeChild(this);
		TFUtil.destroyNodeChildren(this);
		$super();
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI Elements/PanelUI/AttributeWindow'] = function(){var exports = $MODULE_REGISTRY['Code/UI Elements/PanelUI/AttributeWindow'] || {}; $MODULE_REGISTRY['Code/UI Elements/PanelUI/AttributeWindow'] = exports; 

exports.AttributeWindow = GL2.Node.subclass({

	className: 'AttributeWindow',
	initialize:function($super,attributeWindowType,uiObject)
	{
		$super();
		//Add touch target for whole screen as attribute window open
		var SCREEN_HEIGHT = Core.Capabilities.getScreenWidth();
		var SCREEN_WIDTH = Core.Capabilities.getScreenHeight();
		var myMessageListener = new Core.MessageListener();
		var touchTarget = new GL2.TouchTarget();
		touchTarget.setSize(SCREEN_WIDTH,SCREEN_HEIGHT);
		touchTarget.setAnchor(0,0);
		touchTarget.getTouchEmitter().addListener(myMessageListener, this.swallowTouches.bind(this));
		touchTarget.setDepth(1);
		this.addChild(touchTarget);
		
		
		this.attributeWindowType = attributeWindowType;
		this.uiObject = uiObject;
		this.isTapped = false;
		this.closeWithBoost = false;
		
		this.decorationUI = uiObject;
		
		this.destination = null;
		this.moveBack = null;
		this.scaleTo = null;							 
		this.areButtonsEnabled == false
		
		this._attributeWindowBackground = new GLFactory.getSprite([TFUtil.getAdjustedY(240),TFUtil.getAdjustedX(160)],100,'./Content/images/UIPanels/AlertWindow/AttributeWindowBackground.png',[TFUtil.adjustHeightWithDevice(470),TFUtil.adjustWidthWithDevice(260)],[0.5,0.5]);
		//this._attributeWindowBackground.setScale(.7,.8);
		

		var crossButton = new GLButton('./Content/images/UIPanels/Buttons/cross1.png','./Content/images/UIPanels/Buttons/cross1.png',TFUtil.getAdjustedY(50),TFUtil.getAdjustedX(52),this.closeAttributeWindow.bind(this),this._attributeWindowBackground,100); //getAdjustedX(55)
		crossButton.setPosition(TFUtil.getAdjustedY(230),TFUtil.getAdjustedX(-110));
		
		this.getAttributeWindow(attributeWindowType,this.uiObject);
											
	},
	
	disableButtons:function()
	{
		this.areButtonsEnabled = false;
	},
	
	enableButtons:function()
	{
		this.areButtonsEnabled = true;
	},
	swallowTouches: function(touch)
	{
		console.log("swallow touches");
		return true;

	},
		
	getAttributeWindow:function(enumType,uiObject)
	{
		if(GameLayer.getControlLayer().getControlLayerAbove()._isInfoButtonOpened)
		{
			GameLayer.getControlLayer().getControlLayerAbove().closeLeftPanel();
		}
		
		this.enumType= enumType;
		switch(enumType)
		{
			case attributeWindowType.fishEnum:
			{
				uiObject.pause();
				this.attributeWindowForFish();
				break;
			}
			case attributeWindowType.decorationEnum:
			{
				this.attributeWindowDecoration();
				break;
			}
			case attributeWindowType.deadFishEnum:
			{
				this.attributeWindowForDeadFish();
				break;
			}
			case attributeWindowType.plantsEnum:
			{
				this.attributeWindowForPlant();
				break;
			}
            ///foodbrick
            case attributeWindowType.foodBrickEnum:
			{
				this.attributeWindowForFoodBrick();
				break;
			}
			default:

		}

	},
    
    attributeWindowForFoodBrick:function()
	{
		if(TFGameState.atNeighbor)
			return;
		

		this.moveBack = new Core.Vector(.58,.72);
		this.callAnimation();
			
		var storeId = this.uiObject.foodBrickModelObject._foodBrickObj.storeId;
		this.storeVirtualItem = GAGameLoader.getStoreHandler().getStoreObjectForKey(storeId);
											
		var width = this.storeVirtualItem.custom_attributes.size_width;
		var height = this.storeVirtualItem.custom_attributes.size_height;
									
		//this.foodBrickName = this.storeVirtualItem.name;
		this._basePath = TFUtil.getBasePathForResourceType(storeId, GAResourceType.kDetail);
		
		var remainingTimePercentage = this.uiObject.foodBrickModelObject.getTimePercentage();									
		var remainingTime =   this.uiObject.foodBrickModelObject.getTimeRemaining();									
		var normalImage = this._basePath+'2.png';
		
      //  this._attributeWindowBackground.setScale(.58,.72);
        
        var foodBrickHeaderNameText = GLFactory.getText([TFUtil.getAdjustedY(0),TFUtil.getAdjustedX(-105)],100,GALocalizationHandler.getLocalizedString('TF_FOODBRICK_HEADER_TEXT'),[TFUtil.adjustHeightWithDevice(300),TFUtil.adjustWidthWithDevice(300)],TFUtil.getAdjustedFontSize(170));
		foodBrickHeaderNameText.setColor(1, 1, 1);
		foodBrickHeaderNameText.setFontLocation(TFUtil.getFontLocation());
		foodBrickHeaderNameText.setFontFamily(TFUtil.getFont());
        
        var timeRemainingText = GLFactory.getText([TFUtil.getAdjustedY(65),TFUtil.getAdjustedX(-40)],100,GALocalizationHandler.getLocalizedString('TF_FOODBRICK_TIMEREMAINING_LABEL'),[TFUtil.adjustHeightWithDevice(300),TFUtil.adjustWidthWithDevice(300)],TFUtil.getAdjustedFontSize(200));
		timeRemainingText.setColor(1, 1, 1);
		timeRemainingText.setFontLocation(TFUtil.getFontLocation());
		timeRemainingText.setFontFamily(TFUtil.getFont());
        
		var timeBarFiller = remainingTimePercentage*240;
        
        var timeBar = GLFactory.getSprite([TFUtil.getAdjustedY(-50),TFUtil.getAdjustedX(-15)],100,'./Content/images/UIPanels/AlertWindow/brick_bar_back.png',[TFUtil.adjustHeightWithDevice(240),TFUtil.adjustWidthWithDevice(25)],[0,0]);
		this._attributeWindowBackground.addChild(timeBar);

		var timeBarFil = GLFactory.getSprite([TFUtil.getAdjustedY(-50),TFUtil.getAdjustedX(-14)],101,'./Content/images/UIPanels/AlertWindow/brick_bar_front.png',[TFUtil.adjustHeightWithDevice(timeBarFiller),TFUtil.adjustWidthWithDevice(24)],[0,0]);
		this._attributeWindowBackground.addChild(timeBarFil);
        
		var timeLeft = TFUtil.getTimeInProperFormat(remainingTime);
        var timeDisplayText = GLFactory.getText([TFUtil.getAdjustedY(60),TFUtil.getAdjustedX(40)],100,timeLeft,[TFUtil.adjustHeightWithDevice(300),TFUtil.adjustWidthWithDevice(60)],TFUtil.getAdjustedFontSize(150));
		timeDisplayText.setColor(1, 1, 1);
        
		var moveButton = new GLButton('./Content/images/UIPanels/Buttons/1buttonNormal.png','./Content/images/UIPanels/Buttons/1buttonSelected.png',TFUtil.getAdjustedY(160),TFUtil.getAdjustedX(45),this.moveFoodBrick.bind(this),this._attributeWindowBackground,100,GALocalizationHandler.getLocalizedString('TF_MOVE_BUTTON_TEXT'),new Core.Color(1,1,1),new Core.Color(1,1,1),null,TFUtil.getAdjustedFontSize(180));
		moveButton.setPosition(TFUtil.getAdjustedY(10),TFUtil.getAdjustedX(95));
		moveButton.setTextFont(TFUtil.getFont(), TFUtil.getFontLocation());

//        this.brickButton = new GLButton('./Content/images/UIPanels/AlertWindow/brick_button.png','./Content/images/UIPanels/AlertWindow/brick_button.png',TFUtil.getAdjustedY(140),TFUtil.getAdjustedX(120),this.moveFoodBrick.bind(this),this._attributeWindowBackground,null);
//		this.brickButton.setPosition(TFUtil.getAdjustedY(-150),TFUtil.getAdjustedX(0));
		        
        var brickImage = GLFactory.getSprite([TFUtil.getAdjustedY(-185),TFUtil.getAdjustedX(-35)],100,normalImage,[TFUtil.adjustHeightWithDevice(width),TFUtil.adjustWidthWithDevice(width)],[0,0]);
		this._attributeWindowBackground.addChild(brickImage);
        
        this._attributeWindowBackground.addChild(foodBrickHeaderNameText);
        this._attributeWindowBackground.addChild(timeRemainingText);
        this._attributeWindowBackground.addChild(timeDisplayText);
		this.addChild(this._attributeWindowBackground);
	},


	attributeWindowForDeadFish:function()
	{
	
		//if(TFGameState.atNeighbor)   // removing Temporarily
		//	return;
	
		this.moveBack = new Core.Vector(0.7,0.55);
		this.callAnimation();
		var adjustReviveButton = 0;
		if(TFGameState.atNeighbor)
		{
			adjustReviveButton = 100;
		}
		var storeId = this.uiObject._fishObject._fishObj.storeId;
		var storeFishVirtualItem = GAGameLoader.getStoreHandler().getStoreObjectForKey(storeId);
		this.fishName = storeFishVirtualItem.name;
		this._basePath = TFUtil.getBasePathForResourceType(storeId, GAResourceType.kDetail);
		var fishHeaderImage = this._basePath+'/2.png';
		//this._attributeWindowBackground.setScale(.7,.55);

		var backgroundHeaderDeadFish = GLFactory.getSprite([TFUtil.getAdjustedY(-130),TFUtil.getAdjustedX(-140)],100,fishHeaderImage,[TFUtil.adjustHeightWithDevice(90),TFUtil.adjustWidthWithDevice(70)],[0,0]);
		this._attributeWindowBackground.addChild(backgroundHeaderDeadFish);

		var fDeadFishHeaderNameText = GLFactory.getText([TFUtil.getAdjustedY(30),TFUtil.getAdjustedX(-105)],100,GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_FISH_HEADER_NAME'),[this.fishName]),[TFUtil.adjustHeightWithDevice(300),TFUtil.adjustWidthWithDevice(300)],TFUtil.getAdjustedFontSize(170));
		fDeadFishHeaderNameText.setColor(1, 1, 1);	
		fDeadFishHeaderNameText.setFontLocation(TFUtil.getFontLocation());
		fDeadFishHeaderNameText.setFontFamily(TFUtil.getFont());

		this.reviveAllButton = new GLButton('./Content/images/UIPanels/Buttons/1buttonNormal.png','./Content/images/UIPanels/Buttons/1buttonSelected.png',TFUtil.getAdjustedY(145),TFUtil.getAdjustedX(55),this.reviveAllDead.bind(this),this._attributeWindowBackground,100,GALocalizationHandler.getLocalizedString('TF_DEADFISH_REVIVEALL_BUTTON'),new Core.Color(1,1,1),new Core.Color(1,1,1),null,TFUtil.getAdjustedFontSize(210));
		this.reviveAllButton.setPosition(TFUtil.getAdjustedY(-110 + adjustReviveButton),TFUtil.getAdjustedX(80));
		this.reviveAllButton.setTextFont(TFUtil.getFont(), TFUtil.getFontLocation());

		if(!TFGameState.atNeighbor)
		{
			var flushAllButton = new GLButton('./Content/images/UIPanels/Buttons/1buttonNormal.png','./Content/images/UIPanels/Buttons/1buttonSelected.png',TFUtil.getAdjustedY(145),TFUtil.getAdjustedX(55),this.flushAllDead.bind(this),this._attributeWindowBackground,100,GALocalizationHandler.getLocalizedString('TF_DEADFISH_FLUSHALL_BUTTON'),new Core.Color(1,1,1),new Core.Color(1,1,1),null,TFUtil.getAdjustedFontSize(210));
			flushAllButton.setPosition(TFUtil.getAdjustedY(110),TFUtil.getAdjustedX(80));
			flushAllButton.setTextFont(TFUtil.getFont(), TFUtil.getFontLocation());
			
			var fFlushDetailText = GLFactory.getText([TFUtil.getAdjustedY(0),TFUtil.getAdjustedX(-10)],100,GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_DEADFISH_FLUSH_DETAIL'),[TF_REVIVE_ALL_PRICE]),[TFUtil.adjustHeightWithDevice(440),TFUtil.adjustWidthWithDevice(480)],TFUtil.getAdjustedFontSize(170));
			fFlushDetailText.setColor(1, 1, 1);
			fFlushDetailText.setFontLocation(TFUtil.getFontLocation());
			fFlushDetailText.setFontFamily(TFUtil.getFont());
		}
		else
		{
			var fFlushDetailText = GLFactory.getText([TFUtil.getAdjustedY(0),TFUtil.getAdjustedX(-10)],100,GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_DEADFISH_REVIVE_DETAIL'),[TF_REVIVE_ALL_PRICE]),[TFUtil.adjustHeightWithDevice(440),TFUtil.adjustWidthWithDevice(480)],TFUtil.getAdjustedFontSize(170));
			fFlushDetailText.setColor(1, 1, 1);
			fFlushDetailText.setFontLocation(TFUtil.getFontLocation());
			fFlushDetailText.setFontFamily(TFUtil.getFont());
		}
		
	
			this._attributeWindowBackground.addChild(fFlushDetailText);
		this._attributeWindowBackground.addChild(fDeadFishHeaderNameText);

		this.addChild(this._attributeWindowBackground);
	},
	flushAllDead: function()
	{
		GameLayer.getSelectedTank().deleteAllDeadFish();
		this.closeAttributeWindow();
	},
	reviveAllDead: function()
	{
		this.reviveAllButton.setIsEnabled(false);
		this.currentUser = TFGameState.getCurrentUser();
		var bucks = this.currentUser._userObj.fish_bucks;
		if(parseInt(bucks)<TF_REVIVE_ALL_PRICE)
		{		
			var myString = GALocalizationHandler.getLocalizedString('TF_NO_FISH_BUCKS_ALERT');
			console.log(myString);
			var alertWindow = new TFMiniGLAlertView("",myString,null,GALocalizationHandler.getLocalizedString('TF_CANCEL_BUTTON'),GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
			alertWindow.setTagValue(kAlertWindowType.kAlertWindowCustom);
			alertWindow.setMessageColor(255,255,255);
			alertWindow.setMessageFont(TFUtil.getFont(),TFUtil.getFontLocation());
			alertWindow.setButtonsFont(TFUtil.getFont(),TFUtil.getFontLocation());
			alertWindow.show();    
		}
		else
		{
			GameLayer.getSelectedTank().reviveAllDeadFish();
		}
		this.closeAttributeWindow();

	},
											
///////////////
	attributeWindowDecoration:function()
	{
		if(TFGameState.atNeighbor)
			return;
		
		
		this.moveBack = new Core.Vector(0.58,0.68);
		this.callAnimation();
	
		var storeId = this.uiObject.decorationModelObject._decorationObj.storeId;
		this.storeVirtualItem = GAGameLoader.getStoreHandler().getStoreObjectForKey(storeId);							
		
		var width = this.storeVirtualItem.custom_attributes.size_width;
		var height = this.storeVirtualItem.custom_attributes.size_height;
		
		console.log(">>width =="+width+">>Height is == "+height);		
											
		if(width > 100)
		{
			width = 100;
		}
		if(height > 100)
		{
			height = 100; 
		}									
											
		this.sellPrices = GACommonUtils.getSellPrice(this.storeVirtualItem);
		this.decoName = this.storeVirtualItem.name;
		this.price = StoreUtil.getPrice(this.sellPrices);
		this._basePath = TFUtil.getBasePathForResourceType(storeId, GAResourceType.kDetail);

		var normalImage = this._basePath+'/2.png';
										

		
		
		this._fHeaderText = GLFactory.getText([TFUtil.getAdjustedY(0),TFUtil.getAdjustedX(-105)],100,GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_DECO_NAME'),[this.decoName]),[TFUtil.adjustHeightWithDevice(300),TFUtil.adjustWidthWithDevice(300)],TFUtil.getAdjustedFontSize(160));
		this._fHeaderText.setColor(1, 1, 1);
		this._fHeaderText.setHorizontalAlign(GL2.Text.HorizontalAlign.Center);
		this._fHeaderText.setFontLocation(TFUtil.getFontLocation());
		this._fHeaderText.setFontFamily(TFUtil.getFont());
		
		this._attributeWindowBackground.addChild(this._fHeaderText);

		var moveButton = new GLButton('./Content/images/UIPanels/Buttons/1buttonNormal.png','./Content/images/UIPanels/Buttons/1buttonSelected.png',TFUtil.getAdjustedY(140),TFUtil.getAdjustedX(40),this.moveDecoration.bind(this),this._attributeWindowBackground,100,GALocalizationHandler.getLocalizedString('TF_MOVE_BUTTON_TEXT'),new Core.Color(1,1,1),new Core.Color(1,1,1),null,TFUtil.getAdjustedFontSize(170));
		moveButton.setPosition(TFUtil.getAdjustedY(120),TFUtil.getAdjustedX(-55));
		moveButton.setTextFont(TFUtil.getFont(), TFUtil.getFontLocation());

		var inventoryButton = new GLButton('./Content/images/UIPanels/Buttons/1buttonNormal.png','./Content/images/UIPanels/Buttons/1buttonSelected.png',TFUtil.getAdjustedY(140),TFUtil.getAdjustedX(40),this.moveDecorationToInventory.bind(this),this._attributeWindowBackground,100,GALocalizationHandler.getLocalizedString('TF_INVENTORY_BUTTON_TEXT'),new Core.Color(1,1,1),new Core.Color(1,1,1),null,TFUtil.getAdjustedFontSize(170));
		inventoryButton.setPosition(TFUtil.getAdjustedY(120),TFUtil.getAdjustedX(-5));
		inventoryButton.setTextFont(TFUtil.getFont(), TFUtil.getFontLocation());

		var sellButton = new GLButton('./Content/images/UIPanels/Buttons/1buttonNormal.png','./Content/images/UIPanels/Buttons/1buttonSelected.png',TFUtil.getAdjustedY(140),TFUtil.getAdjustedX(40),this.sellDecoration.bind(this),this._attributeWindowBackground,100,GALocalizationHandler.getLocalizedString('TF_SELL_BUTTON_TEXT'),new Core.Color(1,1,1),new Core.Color(1,1,1),null,TFUtil.getAdjustedFontSize(170));
		sellButton.setPosition(TFUtil.getAdjustedY(120),TFUtil.getAdjustedX(45));
		sellButton.setTextFont(TFUtil.getFont(), TFUtil.getFontLocation());

		var flipButton = new GLButton('./Content/images/UIPanels/Buttons/1buttonNormal.png','./Content/images/UIPanels/Buttons/1buttonSelected.png',TFUtil.getAdjustedY(140),TFUtil.getAdjustedX(40),this.flipDecoration.bind(this),this._attributeWindowBackground,100,GALocalizationHandler.getLocalizedString('TF_FLIP_BUTTON_TEXT'),new Core.Color(1,1,1),new Core.Color(1,1,1),null,TFUtil.getAdjustedFontSize(170));
		flipButton.setPosition(TFUtil.getAdjustedY(120),TFUtil.getAdjustedX(95));
		flipButton.setTextFont(TFUtil.getFont(), TFUtil.getFontLocation());
		

		var decorationPiece = GLFactory.getSprite([TFUtil.getAdjustedY(-150),TFUtil.getAdjustedX(-60)],100,normalImage,[TFUtil.adjustHeightWithDevice(width),TFUtil.adjustWidthWithDevice(height)],[0,0]);
		this._attributeWindowBackground.addChild(decorationPiece);

		var fSellingPriceText = GLFactory.getText([TFUtil.getAdjustedY(-90),TFUtil.getAdjustedX(70)],100,GALocalizationHandler.getLocalizedString('TF_SELLING_PRICE_TEXT'),[TFUtil.adjustHeightWithDevice(200),TFUtil.adjustWidthWithDevice(300)],TFUtil.getAdjustedFontSize(190));
		fSellingPriceText.setColor(1, 1, 1);
		fSellingPriceText.setHorizontalAlign(GL2.Text.HorizontalAlign.Left);
		fSellingPriceText.setFontLocation(TFUtil.getFontLocation());
		fSellingPriceText.setFontFamily(TFUtil.getFont());
		this._attributeWindowBackground.addChild(fSellingPriceText);

		var fShowSellingPriceText = GLFactory.getText([TFUtil.getAdjustedY(-10),TFUtil.getAdjustedX(100)],100,GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_SHOW_PRICE_TEXT'),[this.price]),[TFUtil.adjustHeightWithDevice(200),TFUtil.adjustWidthWithDevice(300)],TFUtil.getAdjustedFontSize(190));
		fShowSellingPriceText.setColor(1, 1, 1);
		fShowSellingPriceText.setHorizontalAlign(GL2.Text.HorizontalAlign.Left);
		fShowSellingPriceText.setFontLocation(TFUtil.getFontLocation());
		fShowSellingPriceText.setFontFamily(TFUtil.getFont());
		this._attributeWindowBackground.addChild(fShowSellingPriceText);

		var coin = GLFactory.getSprite([TFUtil.getAdjustedY(-175),TFUtil.getAdjustedX(80)],100,'./Content/images/UIPanels/AlertWindow/coin.png',[TFUtil.adjustHeightWithDevice(70),TFUtil.adjustWidthWithDevice(45)],[0,0]);
		this._attributeWindowBackground.addChild(coin);

		this.addChild(this._attributeWindowBackground);

	},
	
	callAnimation: function()
	{
		
											
		this._attributeWindowBackground.setScale(0.01,0.01);	
		this.destination = new Core.Vector(0.01,0.01);
		this.scaleTo = new GAScaleTo(this._attributeWindowBackground,this.destination,2,true,this.callBackOnStart.bind(this));
	},

	callBackOnStart:function()
	{
		
		this.scaleTo = new GAScaleTo(this._attributeWindowBackground,this.moveBack,200,true,this.stop.bind(this));
	},

	stop:function()
	{

	},
	
	callBack:function()
	{
							
							 
		this.scaleTo = new GAScaleTo(this._attributeWindowBackground,this.moveBack,200,true,this.callBackOnClose.bind(this));
	},
	
	callBackOnClose:function()
	{
		this.moveTo = new GAScaleTo(this._attributeWindowBackground,this.destination,200,true,this.destroy.bind(this));
	},
	
	attributeWindowForPlant:function()
	{
	
		if(TFGameState.atNeighbor)
			return;
		
		this.moveBack = new Core.Vector(.58,.68);
		this.callAnimation();

	
		var storeId = this.uiObject.plantModelObject._plantObj.storeId;
		var storePlantVirtualItem = GAGameLoader.getStoreHandler().getStoreObjectForKey(storeId);
											
		var width = storePlantVirtualItem.custom_attributes.size_width;
		var height = storePlantVirtualItem.custom_attributes.size_height;
											
		if(width > 100)
		{
			width = 100;
		}
		if(height > 100)
		{
			height = 100; 
		}		
											
		var sellPrices = GACommonUtils.getSellPrice(storePlantVirtualItem);
		this.plantName = storePlantVirtualItem.name;
		this.plantPrice = StoreUtil.getPrice(sellPrices);

		this._basePath = TFUtil.getBasePathForResourceType(storeId, GAResourceType.kDetail);
		
		var normalImage = this._basePath+'/2.png';
		
		//this._attributeWindowBackground.setScale(.58,.68);

		this._fHeaderText = GLFactory.getText([TFUtil.getAdjustedY(0),TFUtil.getAdjustedX(-105)],100,GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_DECO_NAME'),[this.plantName]),[TFUtil.adjustHeightWithDevice(300),TFUtil.adjustWidthWithDevice(300)],TFUtil.getAdjustedFontSize(190));
		this._fHeaderText.setColor(1, 1, 1);
		this._fHeaderText.setHorizontalAlign(GL2.Text.HorizontalAlign.Center);
		this._fHeaderText.setFontLocation(TFUtil.getFontLocation());
		this._fHeaderText.setFontFamily(TFUtil.getFont());
		
		
		this._attributeWindowBackground.addChild(this._fHeaderText);

		var moveButton = new GLButton('./Content/images/UIPanels/Buttons/1buttonNormal.png','./Content/images/UIPanels/Buttons/1buttonSelected.png',TFUtil.getAdjustedY(140),TFUtil.getAdjustedX(40),this.movePlant.bind(this),this._attributeWindowBackground,100,GALocalizationHandler.getLocalizedString('TF_MOVE_BUTTON_TEXT'),new Core.Color(1,1,1),new Core.Color(1,1,1),null,TFUtil.getAdjustedFontSize(170));
		moveButton.setPosition(TFUtil.getAdjustedY(120),TFUtil.getAdjustedX(-55));
		moveButton.setTextFont(TFUtil.getFont(), TFUtil.getFontLocation());

		var inventoryButton = new GLButton('./Content/images/UIPanels/Buttons/1buttonNormal.png','./Content/images/UIPanels/Buttons/1buttonSelected.png',TFUtil.getAdjustedY(140),TFUtil.getAdjustedX(40),this.movePlantToInventory.bind(this),this._attributeWindowBackground,100,GALocalizationHandler.getLocalizedString('TF_INVENTORY_BUTTON_TEXT'),new Core.Color(1,1,1),new Core.Color(1,1,1),null,TFUtil.getAdjustedFontSize(170));
		inventoryButton.setPosition(TFUtil.getAdjustedY(120),TFUtil.getAdjustedX(-5));
		inventoryButton.setTextFont(TFUtil.getFont(), TFUtil.getFontLocation());

		var sellButton = new GLButton('./Content/images/UIPanels/Buttons/1buttonNormal.png','./Content/images/UIPanels/Buttons/1buttonSelected.png',TFUtil.getAdjustedY(140),TFUtil.getAdjustedX(40),this.sellPlant.bind(this),this._attributeWindowBackground,100,GALocalizationHandler.getLocalizedString('TF_SELL_BUTTON_TEXT'),new Core.Color(1,1,1),new Core.Color(1,1,1),null,TFUtil.getAdjustedFontSize(170));
		sellButton.setPosition(TFUtil.getAdjustedY(120),TFUtil.getAdjustedX(45));
		sellButton.setTextFont(TFUtil.getFont(), TFUtil.getFontLocation());

		var flipButton = new GLButton('./Content/images/UIPanels/Buttons/1buttonNormal.png','./Content/images/UIPanels/Buttons/1buttonSelected.png',TFUtil.getAdjustedY(140),TFUtil.getAdjustedX(40),this.flipPlant.bind(this),this._attributeWindowBackground,100,GALocalizationHandler.getLocalizedString('TF_FLIP_BUTTON_TEXT'),new Core.Color(1,1,1),new Core.Color(1,1,1),null,TFUtil.getAdjustedFontSize(170));
		flipButton.setPosition(TFUtil.getAdjustedY(120),TFUtil.getAdjustedX(95));
		flipButton.setTextFont(TFUtil.getFont(), TFUtil.getFontLocation());

		var plantPiece = GLFactory.getSprite([TFUtil.getAdjustedY(-180),TFUtil.getAdjustedX(-60)],100,normalImage,[TFUtil.adjustHeightWithDevice(width),TFUtil.adjustWidthWithDevice(height)],[0,0]);
		this._attributeWindowBackground.addChild(plantPiece);

		var fSellingPriceText = GLFactory.getText([TFUtil.getAdjustedY(-90),TFUtil.getAdjustedX(70)],100,GALocalizationHandler.getLocalizedString('TF_SELLING_PRICE_TEXT'),[TFUtil.adjustHeightWithDevice(200),TFUtil.adjustWidthWithDevice(300)],TFUtil.getAdjustedFontSize(190));
		fSellingPriceText.setColor(1, 1, 1);
		fSellingPriceText.setHorizontalAlign(GL2.Text.HorizontalAlign.Left);
		fSellingPriceText.setFontLocation(TFUtil.getFontLocation());
		fSellingPriceText.setFontFamily(TFUtil.getFont());
		this._attributeWindowBackground.addChild(fSellingPriceText);

		var fShowSellingPriceText = GLFactory.getText([TFUtil.getAdjustedY(-10),TFUtil.getAdjustedX(100)],100,GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_SHOW_PRICE_TEXT'),[this.plantPrice]),[TFUtil.adjustHeightWithDevice(200),TFUtil.adjustWidthWithDevice(300)],TFUtil.getAdjustedFontSize(190));
		fShowSellingPriceText.setColor(1, 1, 1);
		fShowSellingPriceText.setHorizontalAlign(GL2.Text.HorizontalAlign.Left);
		fShowSellingPriceText.setFontLocation(TFUtil.getFontLocation());
		fShowSellingPriceText.setFontFamily(TFUtil.getFont());
		this._attributeWindowBackground.addChild(fShowSellingPriceText);

		var coin = GLFactory.getSprite([TFUtil.getAdjustedY(-175),TFUtil.getAdjustedX(80)],100,'./Content/images/UIPanels/AlertWindow/coin.png',[TFUtil.adjustHeightWithDevice(70),TFUtil.adjustWidthWithDevice(45)],[0,0]);
		this._attributeWindowBackground.addChild(coin);

		this.addChild(this._attributeWindowBackground);

	},
///////////////
	attributeWindowForFish:function()
	{
		if(TFGameState.atNeighbor)
			return;
		

		this.moveBack = new Core.Vector(0.7,0.8);
		this.callAnimation();

											
		var storeId = this.uiObject._fishObject._fishObj.storeId;
		var storeFishVirtualItem = GAGameLoader.getStoreHandler().getStoreObjectForKey(storeId);
		this.fishName =  this.uiObject._fishObject.getFishName();
		
		//console.log("EXC :: bred :: " +storeId[0]);
		if(storeId[0] == 2 ){
			this.breedableLabel = "Bred";
			 var heightFishNameLabel = -115;
		}
		else {
			this.breedableLabel = "";
			 var heightFishNameLabel = -108;
		}
			
		this._basePath = TFUtil.getBasePathForResourceType(storeId, GAResourceType.kDetail);
		
		var fishHeaderImage = this._basePath+'/2.png';
		var fishAdultPrice = this.uiObject._fishObject.getAdultPrice();
		
        this._isBreedable = this.uiObject._fishObject.isFishBreedable();       
        
		if(	this._isBreedable == true)
        {
		   this.breedableLabel = GALocalizationHandler.getLocalizedString('TF_ISBREEDABLE_TRUE_TEXT');	
		   var heightFishNameLabel = -115;
		}
        else
        {
        	if(storeId[0] == 2 ){
    			this.breedableLabel = "Bred";
    			 var heightFishNameLabel = -115;
    		}
    		else {
    			this.breedableLabel = GALocalizationHandler.getLocalizedString('TF_ISBREEDABLE_FALSE_TEXT');
    			 var heightFishNameLabel = -108;
    		}
//           this.breedableLabel = GALocalizationHandler.getLocalizedString('TF_ISBREEDABLE_FALSE_TEXT');
//           var heightFishNameLabel = -108;
        }									
		var fishCurrentPrice = this.uiObject._fishObject.getCurrentSellPrice();
		var currentAge = this.uiObject._fishObject.getCurrentAgePercentage();
		var ageInSeconds = this.uiObject._fishObject.getCurrentAge();
		var adulTime = this.uiObject._fishObject.getAdultAge()*60;
	
		var finalAge = this.timeToAdult(ageInSeconds,adulTime);
		
		var currentHunger = this.uiObject._fishObject.getCurrentHunger();
		var fishParentTank = this.uiObject.fishParentTank;
		var happiness = fishParentTank.tankModel.updateTankHappiness();
											
										
		this._bonusSellPrice=0;									
		if ( happiness >= 80 && happiness <=89 )
		{
			this._bonusSellPrice = ( fishCurrentPrice * 0.10 );
			this._bonusSellPrice = Math.ceil(this._bonusSellPrice);
		}
		if ( happiness >= 90 )
		{
			this._bonusSellPrice = ( fishCurrentPrice * 0.20 );
			this._bonusSellPrice = Math.ceil(this._bonusSellPrice);
		}
																				
		var fishAge = GALocalizationHandler.getLocalizedString('TF_FISHAGE_BABY_TEXT');//"Baby";
		if(currentAge>25 && currentAge<50)
		{
			fishAge = GALocalizationHandler.getLocalizedString('TF_FISHAGE_TOODLER_TEXT');//"Toodler";
		}
		if(currentAge>50 && currentAge<75)
		{
			fishAge = GALocalizationHandler.getLocalizedString('TF_FISHAGE_TEENAGER_TEXT');//"Teenager";
		}	
		if(currentAge>75)
		{
			fishAge = GALocalizationHandler.getLocalizedString('TF_FISHAGE_ADULT_TEXT');//"Adult";
		}
		var fishHunger = GALocalizationHandler.getLocalizedString('TF_FISHHUNGER_NOTHUNGRY_TEXT');//"Not Hungry";
		if(this.uiObject._fishObject.isLittleHungry())
		{
			fishHunger = GALocalizationHandler.getLocalizedString('TF_FISHHUNGER_LITTELHUNGRY_TEXT');//"Litter Hungry";
		}
		if(this.uiObject.isFishHungry())
		{
			fishHunger = GALocalizationHandler.getLocalizedString('TF_FISHHUNGER_HUNGRY_TEXT');//"Hungry";
		}
		if(currentHunger>60 && currentHunger<75)
		{
			fishHunger = GALocalizationHandler.getLocalizedString('TF_FISHHUNGER_HUNGRY_TEXT');//"Hungry";
		}
		if(currentHunger>75)
		{
			fishHunger = GALocalizationHandler.getLocalizedString('TF_FISHHUNGER_STARVING_TEXT');//"Starving";
		}
		
		
		       
		var ageBarFiller = (currentAge*180)/100; 
		var hungerBar = (currentHunger*180)/100;  
		var happinessBar = (happiness*180)/100;
		///////////////////////////////////////////////////////        
		///AGE         
		var fAge = GLFactory.getSprite([TFUtil.getAdjustedY(-215),TFUtil.getAdjustedX(-65)],100,'./Content/images/UIPanels/AlertWindow/age.png',[TFUtil.adjustHeightWithDevice(40),TFUtil.adjustWidthWithDevice(35)],[0,0]);
		this._attributeWindowBackground.addChild(fAge);

		var fAgeBar = GLFactory.getSprite([TFUtil.getAdjustedY(-50),TFUtil.getAdjustedX(-50)],100,'./Content/images/UIPanels/AlertWindow/ageBar.png',[TFUtil.adjustHeightWithDevice(180),TFUtil.adjustWidthWithDevice(21)],[0,0]);
		this._attributeWindowBackground.addChild(fAgeBar);

		var fAgeBarFiller = GLFactory.getSprite([TFUtil.getAdjustedY(-50),TFUtil.getAdjustedX(-48)],101,'./Content/images/UIPanels/AlertWindow/hunger.png',[TFUtil.adjustHeightWithDevice(ageBarFiller),TFUtil.adjustWidthWithDevice(17)],[0,0]);
		this._attributeWindowBackground.addChild(fAgeBarFiller);
		///FOOD		
		var fFood = GLFactory.getSprite([TFUtil.getAdjustedY(-215),TFUtil.getAdjustedX(-20)],100,'./Content/images/UIPanels/AlertWindow/food.png',[TFUtil.adjustHeightWithDevice(45),TFUtil.adjustWidthWithDevice(35)],[0,0]);
		this._attributeWindowBackground.addChild(fFood);

		var fFoodBar = GLFactory.getSprite([TFUtil.getAdjustedY(-50),TFUtil.getAdjustedX(-12)],100,'./Content/images/UIPanels/AlertWindow/hunger1.png',[TFUtil.adjustHeightWithDevice(180),TFUtil.adjustWidthWithDevice(21)],[0,0]);
		this._attributeWindowBackground.addChild(fFoodBar);

		var fFoodBarFiller = GLFactory.getSprite([TFUtil.getAdjustedY(-50),TFUtil.getAdjustedX(-10)],101,'./Content/images/UIPanels/AlertWindow/hunger.png',[TFUtil.adjustHeightWithDevice(hungerBar),TFUtil.adjustWidthWithDevice(17)],[0,0]);
		this._attributeWindowBackground.addChild(fFoodBarFiller);
		///HAPPINESS		
		var fHappiness = GLFactory.getSprite([TFUtil.getAdjustedY(-215),TFUtil.getAdjustedX(20)],100,'./Content/images/UIPanels/AlertWindow/happiness.png',[TFUtil.adjustHeightWithDevice(45),TFUtil.adjustWidthWithDevice(35)],[0,0]);
		this._attributeWindowBackground.addChild(fHappiness);

		var fHappinessBar = GLFactory.getSprite([TFUtil.getAdjustedY(-50),TFUtil.getAdjustedX(25)],100,'./Content/images/UIPanels/AlertWindow/happines1.png',[TFUtil.adjustHeightWithDevice(180),TFUtil.adjustWidthWithDevice(21)],[0,0]);
		this._attributeWindowBackground.addChild(fHappinessBar);
			
		//this.backgroundHeaderFish = GLFactory.getSprite([TFUtil.getAdjustedY(-130),TFUtil.getAdjustedX(-116)],100,'./Content/1.png',[TFUtil.adjustHeightWithDevice(80),TFUtil.adjustWidthWithDevice(55)],[0,0]);

		var fHappinessBarFiller = GLFactory.getSprite([TFUtil.getAdjustedY(-50),TFUtil.getAdjustedX(27)],101,'./Content/images/UIPanels/AlertWindow/hunger.png',[TFUtil.adjustHeightWithDevice(happinessBar),TFUtil.adjustWidthWithDevice(17)],[0,0]);
		this._attributeWindowBackground.addChild(fHappinessBarFiller);
				
		var width = storeFishVirtualItem.custom_attributes.size_width;
		var height = storeFishVirtualItem.custom_attributes.size_height;	

		if(width>110)
		{
			width = 110;
		}
		if(height > 40)
		{
			height = 55;
		}
		var backgroundHeaderFish = GLFactory.getSprite([TFUtil.getAdjustedY(-130),TFUtil.getAdjustedX(-130)],100,fishHeaderImage,[TFUtil.adjustHeightWithDevice(width),TFUtil.adjustWidthWithDevice(height)],[0,0]);

		this._attributeWindowBackground.addChild(backgroundHeaderFish);

		var fdaysTimeText = GLFactory.getText([TFUtil.getAdjustedY(60),TFUtil.getAdjustedX(-65)],100,GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_FISH_DHM_LEFT'),[finalAge]),[TFUtil.adjustHeightWithDevice(200),TFUtil.adjustWidthWithDevice(300)],TFUtil.getAdjustedFontSize(100));
		fdaysTimeText.setColor(1, 1, 1);
		fdaysTimeText.setHorizontalAlign(GL2.Text.HorizontalAlign.Left);
		fdaysTimeText.setFontLocation(TFUtil.getFontLocation());
		fdaysTimeText.setFontFamily(TFUtil.getFont());

		
		
		this._fHeaderText = GLFactory.getText([TFUtil.getAdjustedY(25),TFUtil.getAdjustedX(heightFishNameLabel)],100,GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_FISH_HEADER_NAME'),[this.fishName]),[TFUtil.adjustHeightWithDevice(200),TFUtil.adjustWidthWithDevice(300)],TFUtil.getAdjustedFontSize(120));
		this._fHeaderText.setColor(1, 1, 1);
		this._fHeaderText.setFontLocation(TFUtil.getFontLocation());
		this._fHeaderText.setFontFamily(TFUtil.getFont());
		this._fHeaderText.setHorizontalAlign(GL2.Text.HorizontalAlign.Right);
        
        var breedableText = GLFactory.getText([TFUtil.getAdjustedY(23),TFUtil.getAdjustedX(-95)],100,GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_FISH_BREEDABLE_LABEL'),[this.breedableLabel]),[TFUtil.adjustHeightWithDevice(200),TFUtil.adjustWidthWithDevice(300)],TFUtil.getAdjustedFontSize(110));
        breedableText.setColor(1, 1, 0);
        breedableText.setHorizontalAlign(GL2.Text.HorizontalAlign.Right);
        breedableText.setFontLocation(TFUtil.getFontLocation());
		breedableText.setFontFamily(TFUtil.getFont());

		var fAgeText = GLFactory.getText([TFUtil.getAdjustedY(-115),TFUtil.getAdjustedX(-45)],100,GALocalizationHandler.getLocalizedString('TF_FISH_AGE'),[TFUtil.adjustHeightWithDevice(100),TFUtil.adjustWidthWithDevice(100)],TFUtil.getAdjustedFontSize(160));
		fAgeText.setColor(1, 1, 1);
		fAgeText.setHorizontalAlign(GL2.Text.HorizontalAlign.Left);
		fAgeText.setFontLocation(TFUtil.getFontLocation());
		fAgeText.setFontFamily(TFUtil.getFont());

		var fAgeBarFilled = GLFactory.getText([TFUtil.getAdjustedY(185),TFUtil.getAdjustedX(-40)],100,GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_FISH_AGE_STAGE'),[fishAge]),[TFUtil.adjustHeightWithDevice(100),TFUtil.adjustWidthWithDevice(100)],TFUtil.getAdjustedFontSize(120));
		fAgeBarFilled.setColor(1, 1, 1);
		fAgeBarFilled.setHorizontalAlign(GL2.Text.HorizontalAlign.Left);
		fAgeBarFilled.setFontLocation(TFUtil.getFontLocation());
		fAgeBarFilled.setFontFamily(TFUtil.getFont());

		var fHungerText = GLFactory.getText([TFUtil.getAdjustedY(-115),TFUtil.getAdjustedX(-5)],100,GALocalizationHandler.getLocalizedString('TF_FISH_HUNGER'),[TFUtil.adjustHeightWithDevice(100),TFUtil.adjustWidthWithDevice(100)],TFUtil.getAdjustedFontSize(160));
		fHungerText.setColor(1, 1, 1);
		fHungerText.setHorizontalAlign(GL2.Text.HorizontalAlign.Left);
		fHungerText.setFontLocation(TFUtil.getFontLocation());
		fHungerText.setFontFamily(TFUtil.getFont());

		var fHungerStateText = GLFactory.getText([TFUtil.getAdjustedY(185),TFUtil.getAdjustedX(-5)],100,GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_FISH_HUNGER_STAGE'),[fishHunger]),[TFUtil.adjustHeightWithDevice(100),TFUtil.adjustWidthWithDevice(100)],TFUtil.getAdjustedFontSize(120));
		fHungerStateText.setColor(1, 1, 1);
		fHungerStateText.setHorizontalAlign(GL2.Text.HorizontalAlign.Left);
		fHungerStateText.setFontLocation(TFUtil.getFontLocation());
		fHungerStateText.setFontFamily(TFUtil.getFont());

		var fHappinessText = GLFactory.getText([TFUtil.getAdjustedY(-115),TFUtil.getAdjustedX(35)],100,GALocalizationHandler.getLocalizedString('TF_FISH_HAPPINESS'),[TFUtil.adjustHeightWithDevice(100),TFUtil.adjustWidthWithDevice(100)],TFUtil.getAdjustedFontSize(150));
		fHappinessText.setColor(1, 1, 1);
		fHappinessText.setHorizontalAlign(GL2.Text.HorizontalAlign.Left);
		fHappinessText.setFontLocation(TFUtil.getFontLocation());
		fHappinessText.setFontFamily(TFUtil.getFont());

		var fHappinessStateText = GLFactory.getText([TFUtil.getAdjustedY(185),TFUtil.getAdjustedX(35)],100,GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_FISH_HAPPINESS_STAGE'),[happiness+"%"]),[TFUtil.adjustHeightWithDevice(100),TFUtil.adjustWidthWithDevice(100)],TFUtil.getAdjustedFontSize(120));
		fHappinessStateText.setColor(1, 1, 1);
		fHappinessStateText.setHorizontalAlign(GL2.Text.HorizontalAlign.Left);
		fHappinessStateText.setFontLocation(TFUtil.getFontLocation());
		fHappinessStateText.setFontFamily(TFUtil.getFont());

		var fAdultPriceText = GLFactory.getText([TFUtil.getAdjustedY(-115),TFUtil.getAdjustedX(70)],100,GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_FISH_ADULT_PRICE'),[fishAdultPrice]),[TFUtil.adjustHeightWithDevice(150),TFUtil.adjustWidthWithDevice(100)],TFUtil.getAdjustedFontSize(115));
		fAdultPriceText.setColor(1, 1, 1);
		fAdultPriceText.setHorizontalAlign(GL2.Text.HorizontalAlign.Left);
		fAdultPriceText.setFontLocation(TFUtil.getFontLocation());
		fAdultPriceText.setFontFamily(TFUtil.getFont());

		if(this._bonusSellPrice>0)
		{	
			var fCurrentPriceText = GLFactory.getText([TFUtil.getAdjustedY(125),TFUtil.getAdjustedX(70)],100,GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_FISH_CURRENT_PRICE'),[fishCurrentPrice+"+"+this._bonusSellPrice ]),[TFUtil.adjustHeightWithDevice(200),TFUtil.adjustWidthWithDevice(100)],TFUtil.getAdjustedFontSize(115));
			fCurrentPriceText.setColor(1, 1, 1);
			fCurrentPriceText.setHorizontalAlign(GL2.Text.HorizontalAlign.Left);
			fCurrentPriceText.setFontLocation(TFUtil.getFontLocation());
			fCurrentPriceText.setFontFamily(TFUtil.getFont());
		}
		else
		{
			var fCurrentPriceText = GLFactory.getText([TFUtil.getAdjustedY(125),TFUtil.getAdjustedX(70)],100,GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_FISH_CURRENT_PRICE'),[fishCurrentPrice]),[TFUtil.adjustHeightWithDevice(200),TFUtil.adjustWidthWithDevice(100)],TFUtil.getAdjustedFontSize(115));
			fCurrentPriceText.setColor(1, 1, 1);
			fCurrentPriceText.setHorizontalAlign(GL2.Text.HorizontalAlign.Left);
			fCurrentPriceText.setFontLocation(TFUtil.getFontLocation());
			fCurrentPriceText.setFontFamily(TFUtil.getFont());
		}	
		var speedUpButton = new GLButton('./Content/images/UIPanels/Buttons/1buttonNormal.png','./Content/images/UIPanels/Buttons/1buttonSelected.png',TFUtil.getAdjustedY(100),TFUtil.getAdjustedX(30),this.boostOption.bind(this),this._attributeWindowBackground,100,GALocalizationHandler.getLocalizedString('TF_FISH_SPEED_UP'),new Core.Color(1,1,1),new Core.Color(1,1,1),null,TFUtil.getAdjustedFontSize(140));
		speedUpButton.setPosition(TFUtil.getAdjustedY(-160),TFUtil.getAdjustedX(100));
		speedUpButton.setTextFont(TFUtil.getFont(), TFUtil.getFontLocation());

		var sellButton = new GLButton('./Content/images/UIPanels/Buttons/1buttonNormal.png','./Content/images/UIPanels/Buttons/1buttonSelected.png',TFUtil.getAdjustedY(100),TFUtil.getAdjustedX(30),this.sell.bind(this),this._attributeWindowBackground,100,GALocalizationHandler.getLocalizedString('TF_SELL_BUTTON_TEXT'),new Core.Color(1,1,1),new Core.Color(1,1,1),null,TFUtil.getAdjustedFontSize(140));
		sellButton.setPosition(TFUtil.getAdjustedY(-50),TFUtil.getAdjustedX(100));
		sellButton.setTextFont(TFUtil.getFont(), TFUtil.getFontLocation());

		var renameButton = new GLButton('./Content/images/UIPanels/Buttons/1buttonNormal.png','./Content/images/UIPanels/Buttons/1buttonSelected.png',TFUtil.getAdjustedY(100),TFUtil.getAdjustedX(30),this.renameFish.bind(this),this._attributeWindowBackground,100,GALocalizationHandler.getLocalizedString('TF_FISH_RENAME'),new Core.Color(1,1,1),new Core.Color(1,1,1),null,TFUtil.getAdjustedFontSize(140));
		renameButton.setPosition(TFUtil.getAdjustedY(60),TFUtil.getAdjustedX(100));
		renameButton.setTextFont(TFUtil.getFont(), TFUtil.getFontLocation());

		var inventoryButton = new GLButton('./Content/images/UIPanels/Buttons/1buttonNormal.png','./Content/images/UIPanels/Buttons/1buttonSelected.png',TFUtil.getAdjustedY(100),TFUtil.getAdjustedX(30),this.moveFishToInventory.bind(this),this._attributeWindowBackground,100,GALocalizationHandler.getLocalizedString('TF_FISH_INVENTORY'),new Core.Color(1,1,1),new Core.Color(1,1,1),null,TFUtil.getAdjustedFontSize(140));
		inventoryButton.setPosition(TFUtil.getAdjustedY(170),TFUtil.getAdjustedX(100));
		inventoryButton.setTextFont(TFUtil.getFont(), TFUtil.getFontLocation());

		this._attributeWindowBackground.addChild(fHappinessStateText);
		this._attributeWindowBackground.addChild(fHungerStateText);
		this._attributeWindowBackground.addChild(fAgeBarFilled);
		this._attributeWindowBackground.addChild(this._fHeaderText);
		this._attributeWindowBackground.addChild(fdaysTimeText);
		this._attributeWindowBackground.addChild(fCurrentPriceText);
		this._attributeWindowBackground.addChild(fAdultPriceText);
		this._attributeWindowBackground.addChild(fHappinessText);
		this._attributeWindowBackground.addChild(fHungerText);
		this._attributeWindowBackground.addChild(fAgeText);
        this._attributeWindowBackground.addChild(breedableText);

		this.addChild(this._attributeWindowBackground);
	},
											
	renameFish: function()
	{
		if(this.areButtonsEnabled == false)
		{
			return;
		}
		
		//this.disableButtons();
		
		//(initWithTitle,message,delegate,cancelButtonTitle,otherButtonTitles)
		var testUIAlert = new GAUIAlertViewWithEditText(GALocalizationHandler.getLocalizedString('TF_RENAMEFISH_TEXT'),"",this,GALocalizationHandler.getLocalizedString('TF_CANCEL_BUTTON'),GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'),this.fishName);
		testUIAlert.setType("okwithcancel");
		testUIAlert.setTagValue(10);
		testUIAlert.setMessageColor("FFFFFF");
		testUIAlert.setButtonColor("FFFFFF");
		testUIAlert.setTitleFont(TFUtil.getFontName());
		testUIAlert.setMessageFont(TFUtil.getFontName());
		testUIAlert.setButtonsFont(TFUtil.getFontName());
		testUIAlert.setEditedTextFont(TFUtil.getFontName());
		testUIAlert.show();
		
	},
	
											
	timeToAdult:function(fishAgeInseconds,timeForAdult)
	{
		
		var fishAdultLabel = GALocalizationHandler.getLocalizedString('TF_FISHADULT_TEXT');
		var readySell = GALocalizationHandler.getLocalizedString('TF_READYTOSELL_TEXT');							
		if(fishAgeInseconds>=timeForAdult)
		{
			return readySell;
		}
		else
		{
			var ageRemaining = timeForAdult - fishAgeInseconds;
			return TFUtil.getTimeInProperFormat(ageRemaining);
		}
		
	},
////////////
	closeAttributeWindow:function()
	{
		var controlLayer = GameLayer.getControlLayer();
		controlLayer.enableButtons();

		
		if(this.enumType == attributeWindowType.fishEnum)
		{
			this.uiObject.unPause();
		}
		else		
		if(this.enumType == attributeWindowType.plantsEnum)
		{
			if(this.uiObject._onePlant != null)
				this.uiObject._onePlant.setImage(this.uiObject.normalImage, [this.uiObject._width,this.uiObject._heigth], [.5,.5]);
		}
		else
		if(this.enumType == attributeWindowType.foodBrickEnum)
		{
			if(this.uiObject._oneFoodBrick != null)
				this.uiObject._oneFoodBrick.setImage(this.uiObject.normalImage, [this.uiObject._width,this.uiObject._heigth], [.5,.5]);
		}
		else
		if(this.enumType == attributeWindowType.decorationEnum)
		{
			if(this.uiObject._oneDeco != null)
				this.uiObject._oneDeco.setImage(this.uiObject.normalImage, [this.uiObject._width,this.uiObject._heigth], [.5,.5]);
		}
			
        this.callBack();

		//this.destroy();

	},
///////////
	testFunc:function()
	{

	},
///////////

	sell:function()
	{
		if(this.isTapped)
		{		
			return;
		}
		this.isTapped = true;
												
		var selectedTank=TFGameState.getCurrentUser()._tankObj;
		if(!selectedTank._tankObj.isTankLocked){ 
			//GameLayer.getSelectedTank().sellFish(this.uiObject); 
			var fishObject = this.uiObject._fishObject;
			var totalSellPrice = fishObject.getCurrentSellPrice() + this._bonusSellPrice;
			var myString = GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_SELL_OK'),[fishObject.getFishName(),totalSellPrice]);
			if(fishObject.getCurrentSellPrice()==1)
			{
				myString = myString + ' coin?';
				
			}
			else
			{
				myString = myString + ' coins?';
				//var myString = GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_SELL_OK'),[fishObject.getFishName(),fishObject.getCurrentSellPrice()]);
			}
			console.log("Sell "+ myString);
			var alertWindow = new TFMiniGLAlertView("",myString,this,GALocalizationHandler.getLocalizedString('TF_CANCEL_BUTTON'),GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
			alertWindow._type="okwithcancel";
			alertWindow.setTagValue(13);
			alertWindow.setMessageColor(255,255,255);
			alertWindow.setMessageFont(TFUtil.getFont(),TFUtil.getFontLocation());
			alertWindow.setButtonsFont(TFUtil.getFont(),TFUtil.getFontLocation());
			alertWindow.show();  
		}
	else
	{
		var myString = GALocalizationHandler.getLocalizedString('TF_TANK_FISH_LOCKED_ALERT');
		console.log(myString);
		var alertWindow = new TFMiniGLAlertView("",myString,this,GALocalizationHandler.getLocalizedString('TF_CANCEL_BUTTON'),GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
		alertWindow.setTagValue(kAlertWindowType.kAlertWindowCustom);
		alertWindow.setMessageColor(255,255,255);
		alertWindow.setMessageFont(TFUtil.getFont(),TFUtil.getFontLocation());
		alertWindow.setButtonsFont(TFUtil.getFont(),TFUtil.getFontLocation());
		alertWindow.show();  
		this.closeAttributeWindow();
	}
											
},
//////////
	moveDecoration:function()
	{
		if(this.areButtonsEnabled == false)
		{
			return;
		}
		
		this.disableButtons();
		
		var controlLayer = GameLayer.getControlLayer();
		controlLayer.enableButtons();									
		this.decorationUI.selectedDecoration();
		this.destroy();										
		// this.closeAttributeWindow.bind(this)
	},
	flipDecoration:function()
	{
		if(this.areButtonsEnabled == false)
		{
			return;
		}
		
		this.disableButtons();
		
		var controlLayer = GameLayer.getControlLayer();
		controlLayer.enableButtons();
		this.decorationUI.flipDecoration();
		this.destroy();										
		
	},

	sellDecoration:function()
	{
		if(this.isTapped)
		{		
			return;
		}
		this.isTapped = true;
											
		var selectedTank=TFGameState.getCurrentUser()._tankObj;
		if(!selectedTank._tankObj.isTankLocked)
		{ 
			var sellDecorationAlertWindow = new TFMiniGLAlertView("",GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_SELL'),[this.decoName,this.price]),this,GALocalizationHandler.getLocalizedString('TF_CANCEL_BUTTON'),GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
			sellDecorationAlertWindow._type="okwithcancel";
			sellDecorationAlertWindow.setTagValue(11);
			sellDecorationAlertWindow.setMessageColor(255,255,255);
			sellDecorationAlertWindow.setMessageFont(TFUtil.getFont(),TFUtil.getFontLocation());
			sellDecorationAlertWindow.setButtonsFont(TFUtil.getFont(),TFUtil.getFontLocation());
			sellDecorationAlertWindow.show();  								
		}
		else
		{
			this.closeAttributeWindow();								
			var myString = GALocalizationHandler.getLocalizedString('TF_TANK_DECORATION_LOCKED_ALERT');
			console.log(myString);
			var sellDecoAlertWindow = new TFMiniGLAlertView("",myString,this,GALocalizationHandler.getLocalizedString('TF_CANCEL_BUTTON'),GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
			sellDecoAlertWindow.setTagValue(kAlertWindowType.kAlertWindowCustom);
			sellDecoAlertWindow.setMessageColor(255,255,255);
			sellDecoAlertWindow.setMessageFont(TFUtil.getFont(),TFUtil.getFontLocation());
			sellDecoAlertWindow.setButtonsFont(TFUtil.getFont(),TFUtil.getFontLocation());
			sellDecoAlertWindow.show();    
		}
					  
										
	},
    
    moveFoodBrick:function()
	{
		if(this.areButtonsEnabled == false)
		{
			return;
		}
		
		this.disableButtons();
		
		var controlLayer = GameLayer.getControlLayer();
		controlLayer.enableButtons();									
		this.uiObject.selectedFoodBrick();
		this.destroy();									
		
	},
    
	clickedButtonAtIndex: function(buttonIndex,alertWindow)
	{
		
		if (buttonIndex == 0) 
		{
			switch(alertWindow.getTagValue())
			{
				case 11:// sell deco 
				{
	
					var vector = new Core.Vector(Core.Capabilities.getScreenHeight()/2,Core.Capabilities.getScreenWidth()/2);
					var decorationCurrentPrice = this.uiObject.decorationModelObject.getSellPrice();
					GameLayer.getSelectedTank().textAnimation(vector,GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_SELL_ANIMATING_TEXT'),[decorationCurrentPrice,2]),new Core.Color(0,1,0));		
					this.sellDecorationOk();
					break;
				}
				case 10://fish rename
				{
					var fishNameEntered/*this.fishName*/=alertWindow.getText();
												
					var inputCheck = new InputCheck();
											
					if(fishNameEntered.length > 15)
					{ 	
						
						var message = GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_RENAME_LIMIT_CHARS'),[15]);
						console.log(message);
						var alertWindow = new TFMiniGLAlertView("",message,this,GALocalizationHandler.getLocalizedString('TF_CANCEL_BUTTON'),GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
						alertWindow._type="ok";
						alertWindow.setMessageColor(255,255,255);
						alertWindow.setMessageFont(TFUtil.getFont(),TFUtil.getFontLocation());
						alertWindow.setButtonsFont(TFUtil.getFont(),TFUtil.getFontLocation());
						alertWindow.show();
						
						return;					
					}
											
					if(!inputCheck.textCheck(fishNameEntered/*this.fishName*/))
					{

						
						var message = GALocalizationHandler.getLocalizedString('TF_SPEACIAL_CHARS_NOTALLOWED_TEXT');
						console.log(message);
						var alertWindow = new TFMiniGLAlertView("",message,this,GALocalizationHandler.getLocalizedString('TF_CANCEL_BUTTON'),GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
						alertWindow._type="ok";
						alertWindow.setMessageColor(255,255,255);
						alertWindow.setMessageFont(TFUtil.getFont(),TFUtil.getFontLocation());
						alertWindow.setButtonsFont(TFUtil.getFont(),TFUtil.getFontLocation());
						alertWindow.show();
											
					}						
					else
					{
						this.fishName = fishNameEntered;
						console.log('Fish Name'+this.fishName);
						this.uiObject._fishObject.setFishName(this.fishName);
						this.redrawFishName();		
					}
					break;
											
				}
				case 12:
				{
					var vector = new Core.Vector(Core.Capabilities.getScreenHeight()/2,Core.Capabilities.getScreenWidth()/2);
					var plantCurrentPrice = this.uiObject.plantModelObject.getSellPrice();
					GameLayer.getSelectedTank().textAnimation(vector,GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_SELL_ANIMATING_TEXT'),[plantCurrentPrice,2]),new Core.Color(0,1,0));		
					
					this.sellPlantOk();				
					break;
				}
				case 111:
				{
					this.boostOk();
					break;
				}
				case 112:
				{
					var inAppMainView = new InAppMainView(true);
				    NGWindow.document.addChild(inAppMainView);
					break;
				}
				case 13:
					{
						GameLayer.getSelectedTank().sellFish(this.uiObject); 
						this.closeAttributeWindow();
						break;
					}
				default:
				{
					break;
				}
			}
			   
		}
		else if (buttonIndex == 1) 
		{
			if(alertWindow.getTagValue() != 10){
				this.closeAttributeWindow();
			}
		}
		
	},

	redrawFishName: function()
	{
		this._attributeWindowBackground.removeChild(this._fHeaderText);
		if(this.uiObject._fishObject.isFishBreedable()){
			var heightFishNameLabel = -115;
		}
		else{
			var heightFishNameLabel = -108;
		}
		this._fHeaderText.destroy();
		this._fHeaderText = GLFactory.getText([TFUtil.getAdjustedY(25),TFUtil.getAdjustedX(heightFishNameLabel)],100,GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_FISH_HEADER_NAME'),[this.fishName]),[TFUtil.adjustHeightWithDevice(200),TFUtil.adjustWidthWithDevice(300)],TFUtil.getAdjustedFontSize(120));
		this._fHeaderText.setColor(1, 1, 1);
		this._fHeaderText.setFontLocation(TFUtil.getFontLocation());
		this._fHeaderText.setFontFamily(TFUtil.getFont());
		this._fHeaderText.setHorizontalAlign(GL2.Text.HorizontalAlign.Right);
		this._attributeWindowBackground.addChild(this._fHeaderText);
	},

	sellDecorationOk:function()
	{
		if(this.areButtonsEnabled == false)
		{
			return;
		}
		
		this.disableButtons();
		
		this.uiObject.parentTank.sellDecoration(this.uiObject);
		
		this.closeAttributeWindow();
	},

	
 //// Plant Functions
	movePlant:function()
	{
		//this.uiObject.selectedPlant();
		this.closeAttributeWindow();
		
		if(this.areButtonsEnabled == false)
		{
			return;
		}
		
		this.disableButtons();
		
		var controlLayer = GameLayer.getControlLayer();
		controlLayer.enableButtons();									
		this.uiObject.selectedPlant();
		this.destroy();
		//this.closeAttributeWindow();
	},

	flipPlant:function()
	{
		if(this.areButtonsEnabled == false)
		{
			return;
		}
		
		this.disableButtons();
		
		this.uiObject.flipPlant();
		this.closeAttributeWindow();
	},

	sellPlant:function()
	{
		if(this.isTapped)
		{		
			return;
		}
		this.isTapped = true;
		
		var selectedTank=TFGameState.getCurrentUser()._tankObj;
		if(!selectedTank._tankObj.isTankLocked)
		{ 
			var sellPlantAlertWindow = new TFMiniGLAlertView("",GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_SELL'),[this.plantName,this.plantPrice]),this,GALocalizationHandler.getLocalizedString('TF_CANCEL_BUTTON'),GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
			sellPlantAlertWindow._type="okwithcancel";
		    sellPlantAlertWindow.setTagValue(12);
			sellPlantAlertWindow.setMessageColor(255,255,255);
			sellPlantAlertWindow.setMessageFont(TFUtil.getFont(),TFUtil.getFontLocation());
			sellPlantAlertWindow.setButtonsFont(TFUtil.getFont(),TFUtil.getFontLocation());
			sellPlantAlertWindow.show();
		}
		else
		{
			this.closeAttributeWindow();									
			var myString = GALocalizationHandler.getLocalizedString('TF_TANK_PLANT_LOCKED_ALERT');
			console.log(myString);
			var sellPlantAlertWindow = new TFMiniGLAlertView("",myString,this,GALocalizationHandler.getLocalizedString('TF_CANCEL_BUTTON'),GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
			sellPlantAlertWindow.setTagValue(kAlertWindowType.kAlertWindowCustom);
			sellPlantAlertWindow.setMessageColor(255,255,255);
			sellPlantAlertWindow.setMessageFont(TFUtil.getFont(),TFUtil.getFontLocation());
			sellPlantAlertWindow.setButtonsFont(TFUtil.getFont(),TFUtil.getFontLocation());
			sellPlantAlertWindow.show();    
		}
										
											
	},
	
	sellPlantOk:function()
	{
		if(this.areButtonsEnabled == false)
		{
			return;
		}
		
		this.disableButtons();
		
		GameLayer.getSelectedTank().sellPlant(this.uiObject);
		this.closeAttributeWindow();
	},


	//////////
	boostOption:function()
	{
		//var boostBucks = ceil(([fishObj getAdultAge]-[fishObj getCurrentAge])/(TF_BOOST_HOURS*60));;
		var fish = this.uiObject._fishObject;
		var bucks = TFGameState.getCurrentUser()._userObj.fish_bucks;
		var boostBucks = Math.ceil((fish.getAdultAge() - fish.getCurrentAge()/60)/(TF_BOOST_HOURS*60));
		
	//	if(bucks>=boostBucks)
		{
			// Atleast 1 fish buck is present
			if(!fish.isAdult())
			{
				
				this.closeWithBoost = true;
				
				this.speedUpUIAlert = new TFMiniGLAlertView("",GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_BOOST_FISH_CONFIRM_MESSAGE'),[boostBucks]),this,GALocalizationHandler.getLocalizedString('TF_CANCEL_BUTTON'),GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));//TODO LOCALIZE THIS TEXT
				
				this.speedUpUIAlert.setType("okwithcancel");
				this.speedUpUIAlert.setTagValue(111);
				this.speedUpUIAlert.setMessageColor(255,255,255);
				this.speedUpUIAlert.setMessageFont(TFUtil.getFont(),TFUtil.getFontLocation());
				this.speedUpUIAlert.setButtonsFont(TFUtil.getFont(),TFUtil.getFontLocation());
				this.speedUpUIAlert.show();
											
				
			}
			else
			{
				var cannotBoost = new TFMiniGLAlertView("",GALocalizationHandler.getLocalizedString('TF_BOOST_SELECTED_ADULT_FISH'),this,GALocalizationHandler.getLocalizedString('TF_CANCEL_BUTTON'),GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
				cannotBoost.setType("ok");
				cannotBoost.setTagValue(0);
				cannotBoost.setMessageColor(255,255,255);
				cannotBoost.setMessageFont(TFUtil.getFont(),TFUtil.getFontLocation());
				cannotBoost.setButtonsFont(TFUtil.getFont(),TFUtil.getFontLocation());
				cannotBoost.show();
				this.closeAttributeWindow();
			}
		}
//		else
//		{
//			var notEnoughBucksAlert = new GAGLAlertWindow("",GALocalizationHandler.getLocalizedString('TF_ERROR_NO_FISH_BUCKS'),this,GALocalizationHandler.getLocalizedString('TF_CANCEL_BUTTON'),GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
//			notEnoughBucksAlert.setType("ok");
//			notEnoughBucksAlert.setTagValue(0);
//			notEnoughBucksAlert.setMessageColor(255,255,255);
//			notEnoughBucksAlert.setMessageFont(TFUtil.getFont(),TFUtil.getFontLocation());
//			notEnoughBucksAlert.setButtonsFont(TFUtil.getFont(),TFUtil.getFontLocation());
//			notEnoughBucksAlert.show();											
//		}
	},

	boostOk:function()
	{
		var fish = this.uiObject._fishObject;
		var bucks = TFGameState.getCurrentUser()._userObj.fish_bucks;
		var boostBucks = Math.ceil((fish.getAdultAge() - fish.getCurrentAge()/60)/(TF_BOOST_HOURS*60));
		
		if(bucks>=boostBucks) 
		{
			TFGameState.getCurrentUser().updateCurrency(kOperationType.kOperationSubtractBucks,boostBucks);
			fish.updateFishCreationTime();
			GameLayer.getSelectedTank().selectedFish.currentAction = TFActionType.tfActionFoodHunt;
			//this.updateFishAttributeWindow();
			this.closeAttributeWindow();
		} else{
			var notEnoughBucksAlert = new TFMiniGLAlertView("",GALocalizationHandler.getLocalizedString('TF_NO_BUCKS_MESSAGE_PURCHASE'),this,GALocalizationHandler.getLocalizedString('TF_CANCEL_BUTTON'),GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
			notEnoughBucksAlert.setType("okwithcancel");
			notEnoughBucksAlert.setTagValue(112);
			notEnoughBucksAlert.setMessageColor(255,255,255);
			notEnoughBucksAlert.setMessageFont(TFUtil.getFont(),TFUtil.getFontLocation());
			notEnoughBucksAlert.setButtonsFont(TFUtil.getFont(),TFUtil.getFontLocation());
			notEnoughBucksAlert.show();											
		}
		
		
	},
	/////////
	boostCancel:function()
	{
		
	},

	moveDecorationToInventory:function()
	{
		if(this.areButtonsEnabled == false)
		{
			return;
		}
		
		this.disableButtons();
		
		this.uiObject.parentTank.moveDecorationToInventory(this.uiObject);
		this.closeAttributeWindow();
	},

	moveFishToInventory:function()
	{
		if(this.areButtonsEnabled == false)
		{
			return;
		}
		
		this.disableButtons();
		
		console.log("Fish Moved Attribute Window");
		GameLayer.getSelectedTank().moveFishToInventory(this.uiObject);
		this.closeAttributeWindow();
	},

	movePlantToInventory:function()
	{
		if(this.areButtonsEnabled == false)
		{
			return;
		}
		
		this.disableButtons();
		
		console.log("move plant to inventory :: "+this.uiObject);
		this.uiObject.parentTank.movePlantToInventory(this.uiObject);
		this.closeAttributeWindow();
	},

	destroy: function($super)
	{
		
		TFUtil.destroyNodeChildren(this._attributeWindowBackground);
		TFUtil.destroyNodeChildren(this);
		$super();
		
	},

	
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/GLLayer/GAGLAlertWindow'] = function(){var exports = $MODULE_REGISTRY['Code/GLLayer/GAGLAlertWindow'] || {}; $MODULE_REGISTRY['Code/GLLayer/GAGLAlertWindow'] = exports; /**
 * Filename: GAGLAlertWindow.js
 * Author: Sunilla Sarfraz
 * Date Created: --
 * Date Updated: --
 * copied from TZ
 */
// Initializing AlertWindow 
// there are 5 parameters passed to constructor below are the details of parameters
// 1.initWithTitle				: it is first parameter. it will take title string and set AlertWindow title
// 2.message       				: it will take message string and set Message in AlertWindow
// 3.delegate 	   				: setting delegate.
// 4.cancelButtonTitle			: it will take cancel button title string which should be localized string
// 5.otherButtonTitles			: it will take ok button title string which should be localized string

// setter functions
// there are 9 setter function through which you can set button text, title text and message text colors.
// it is also allow you to set background and button normal and highlighted images path
// you can also set type of your alertWindow and type detail is given below

// there are two type of alert view
// 1."ok" which means AlertWindow with ok button only
// 2."okwithcancel" means AlertWindow with ok and cancel button both 
// by default it takes type "ok"


//Default type for alert window
var kALERT_WINDOW_TYPE = "ok"

//AlertWindow button image default paths
//var kALERT_WINDOW_BACKGROUND  = "./Content/images/UIPanels/AlertWindow/alert-background2.png"// changed
var kALERT_WINDOW_BACKGROUND  = "./Content/images/UIPanels/AlertWindow/alert-background.png"
// Ok buttons
var kALERT_WINDOW_OK_NORMAL ="./Content/images/UIPanels/Buttons/1buttonNormal.png"
var kALERT_WINDOW_OK_SELECTED ="./Content/images/UIPanels/Buttons/1buttonSelected.png"

// Cancel buttons
//var kALERT_WINDOW_CANCEL_NORMAL ="./Content/images/UIPanels/AlertWindow/alert-cancel-normal.png"// chnaged
//var kALERT_WINDOW_CANCEL_SELECTED ="./Content/images/UIPanels/AlertWindow/alert-cancel-selected.png"// changed
var kALERT_WINDOW_CANCEL_NORMAL ="./Content/images/UIPanels/Buttons/1buttonNormal.png"
var kALERT_WINDOW_CANCEL_SELECTED ="./Content/images/UIPanels/Buttons/1buttonSelected.png"


exports.GAGLAlertWindow = GL2.Node.subclass({
	
	classname: 'GAGLAlertWindow',
	initialize: function($super,initWithTitle,message,delegate,cancelButtonTitle,otherButtonTitles)
	{
		$super();
		this.w							= null;
		this.h							= null;
		this._tagValue					= null;
		
		this._title 					= null;
		this._message 					= null;
		this._delegate 					= null;
		this.cancelButtonTitle 			= null;
		this._otherButtonTitles			= null;
		
		
		this._type						= null;
		
		this._backgroundImagePath		= null;
		this._okImageNormalPath 		= null;
		this._okImageSelectedPath 		= null;
		this._cancelImageNormalPath		= null;
		this._cancelImageSelectedPath	= null;
    	
    	this._buttonsColor				= null;
    	this._titleColor				= null;
    	this._messageColor				= null;
    	this._messageFont				= null;
    	this._titleFont					= null;
    	this._buttonsFont				= null;
    	this._messageFontLocation		= null;
    	this._titleFontLocation			= null;
    	this._buttonsFontLocation		= null;
		
		// initializing data members with parameters 
		if (initWithTitle == null) {
			initWithTitle = GALocalizationHandler.getLocalizedString('TF_MESSAGE_TEXT');//Message
			}
		
		this._title = initWithTitle;
		
		
		this._message = message;
		this._delegate = delegate;
		this.cancelButtonTitle = cancelButtonTitle;
		this._otherButtonTitles= otherButtonTitles;	
		
		// setting images default path
		this._backgroundImagePath		=kALERT_WINDOW_BACKGROUND;
		this._okImageNormalPath			=kALERT_WINDOW_OK_NORMAL;
		this._okImageSelectedPath		=kALERT_WINDOW_OK_SELECTED;
		this._cancelImageNormalPath	 	=kALERT_WINDOW_CANCEL_NORMAL;
		this._cancelImageSelectedPath	=kALERT_WINDOW_CANCEL_SELECTED;
		
		
		// setting Default type
		this._type=kALERT_WINDOW_TYPE;
	
		
		// setting default colors
		this._buttonsColorRed=1;
		this._buttonsColorGreen=1;
		this._buttonsColorBlue=1;
		
		this._titleColorRed=1;
		this._titleColorGreen=1;
		this._titleColorBlue=0;
		
		this._messageColorRed=118/255; 
		this._messageColorGreen=50/255;
		this._messageColorBlue=58/255;
		
		// setting frame of this view
		this.w = Core.Capabilities.getScreenWidth();
		this.h = Core.Capabilities.getScreenHeight();
			
					
		this.makeTouchSwallower();// fullscreen touch target to swallow the touches beyond the attribute window 

		return this;
	},
	
	loadGl: function()
	{

		var background = new GL2.Sprite();		
		background.setImage(this._backgroundImagePath,[this.adjustHeightWithDevice(356),this.adjustWidthWithDevice(229)],[.5,.5]);
		background.setPosition(this.getAdjustedY(250),this.getAdjustedX(160));

        this.addChild(background);
       	
		var okButton = new GLButton(this._okImageNormalPath,this._okImageSelectedPath, this.adjustHeightWithDevice(73),this.adjustWidthWithDevice(37),this.clickedButtonOk.bind(this),this,100);
		okButton.setPosition(this.getAdjustedY(245),this.getAdjustedX(210));
		
		var okButtonText = new GL2.Text();
		okButtonText.setText(this._otherButtonTitles);
		okButtonText.setAnchor(0,0);
		okButtonText.setFontSize(this.getAdjustedFontSize(100));
		okButtonText.setSize([this.adjustHeightWithDevice(71.25),this.adjustWidthWithDevice(55.5)]);
		okButtonText.setPosition(this.getAdjustedY(210),this.getAdjustedX(184));
		okButtonText.setColor(this._buttonsColorRed,this._buttonsColorGreen,this._buttonsColorBlue);
		//this._okButtonText.setColor(1,1,1);
		okButtonText.setDepth(100);
		if (this._buttonsFont && this._buttonsFontLocation) {
    		okButtonText.setFontLocation(this._buttonsFontLocation);
    		okButtonText.setFontFamily(this._buttonsFont);
    	}
		this.addChild(okButtonText);

		if(this._type == "okwithcancel")
		{
			
			okButton.setPosition(this.getAdjustedY(205),this.getAdjustedX(210));
			okButtonText.setPosition(this.getAdjustedY(170),this.getAdjustedX(183));
			
			
			var cancelButton = new GLButton(this._cancelImageNormalPath,this._cancelImageSelectedPath, this.adjustHeightWithDevice(73),this.adjustWidthWithDevice(37),this.clickedButtonCancel.bind(this),this,100);
			cancelButton.setPosition(this.getAdjustedY(285),this.getAdjustedX(210));
			
			
			var cancelButtonText = new GL2.Text();
			cancelButtonText.setText(this.cancelButtonTitle);
			cancelButtonText.setAnchor(0,0);
			cancelButtonText.setFontSize(this.getAdjustedFontSize(100));
			cancelButtonText.setSize([this.adjustHeightWithDevice(71.25),this.adjustWidthWithDevice(55.5)]);
			cancelButtonText.setPosition(this.getAdjustedY(250),this.getAdjustedX(183));
			cancelButtonText.setColor(this._buttonsColorRed,this._buttonsColorGreen,this._buttonsColorBlue);
			//this._cancelButtonText.setColor(1,1,1);
			cancelButtonText.setDepth(100);
			if (this._buttonsFont && this._buttonsFontLocation) {
	    		cancelButtonText.setFontLocation(this._buttonsFontLocation);
	    		cancelButtonText.setFontFamily(this._buttonsFont);
	    	}
			this.addChild(cancelButtonText);
			
		}
		
		
		var messageLabel = new GL2.Text();
    	messageLabel.setText(this._message);
    	messageLabel.setSize(this.adjustHeightWithDevice(260),this.adjustWidthWithDevice(200));
    	messageLabel.setAnchor(.5,.5);
    	messageLabel.setFontSize(this.getAdjustedFontSize(120));//changed to 120 from 130
    	messageLabel.setColor(this._messageColorRed,this._messageColorGreen,this._messageColorBlue);
    	messageLabel.setPosition(this.getAdjustedY(240),this.getAdjustedX(130));
    	if (this._messageFont && this._messageFontLocation) {
    		messageLabel.setFontLocation(this._messageFontLocation);
    		messageLabel.setFontFamily(this._messageFont);
    	}	
    	this.addChild(messageLabel);
    	
    	
    	var titleLabel = new GL2.Text();
    	titleLabel.setText(this._title);
    	titleLabel.setAnchor(.5,.5);
    	titleLabel.setFontSize(this.getAdjustedFontSize(100));
    	titleLabel.setColor(this._titleColorRed,this._titleColorGreen,this._titleColorBlue);
    	//this._title.setColor(1,1,1);
    	titleLabel.setPosition(this.getAdjustedY(245),this.getAdjustedX(250));
    	if (this._titleFont && this._titleFontLocation) {
    		titleLabel.setFontLocation(this._titleFontLocation);
    		titleLabel.setFontFamily(this._titleFont);
    	}
    	this.addChild(titleLabel);
    	
		
	},
	show: function()
	{
		this.loadGl();
		GL2.Root.addChild(this);
	},
	
		
	makeTouchSwallower: function()
    {
    	
    	var myMessageListener = 0;
    	var dissolveTouchesTarget = new GL2.TouchTarget();
    	dissolveTouchesTarget.setAnchor(0,0);
		dissolveTouchesTarget.setSize(this.getAdjustedY(this.h),this.getAdjustedX(this.w));
        dissolveTouchesTarget.setPosition(this.getAdjustedY(0),this.getAdjustedX(0));
        myMessageListener = new Core.MessageListener();
		dissolveTouchesTarget.getTouchEmitter().addListener(myMessageListener, this.dissolveTouches.bind(this),kTouchSwallower); //@sunilla make this 10 go to Constants.
		this.addChild(dissolveTouchesTarget);
    },
    
    
    
    dissolveTouches: function()
    {
    	return true;
    },
	
	clickedButtonOk: function()
	{
		console.log('in Clicked Button ok ');
		this.clickedButtonAtIndex(0);

	},
	
	clickedButtonCancel: function()
	{
		this.clickedButtonAtIndex(1);
		console.log('in Clicked Button cancle ');

	},
	
	clickedButtonAtIndex: function(buttonIndex)
	{
		console.log('in clickedButtonAtIndex ');
		if(this._delegate)		
		{
			this._delegate.clickedButtonAtIndex(buttonIndex,this);
		}
		this.destroy();	
		
	},
	

	
	
	//getter
	getTagValue: function()
	{
		return this._tagValue;
	},
	
	
	//setters
	
	setTagValue: function(value)
	{
		this._tagValue = value;
	},
	
	setType : function(type)
	{
		this._type=type;
	},
	setButtonColor : function(red,green,blue)
	{
		this._buttonsColorRed	=red;
		this._buttonsColorGreen	=green;
		this._buttonsColorBlue	=blue;
		
	},
	
	setTitleColor : function(red,green,blue)
	{
		this._titleColorRed		=red;
		this._titleColorGreen	=green;
		this._titleColorBlue	=blue;
	},
	
	setMessageColor : function(red,green,blue)
	{
		this._messageColorRed	=red;
		this._messageColorGreen	=green;
		this._messageColorBlue	=blue;
	},
	
	setMessageFont:function(font,fontLocation) 
    {
    	this._messageFont = font;
    	this._messageFontLocation = fontLocation;
    },

    
    setTitleFont:function(font,fontLocation) 
    {
    	this._titleFont = font;
    	this._titleFontLocation = fontLocation;
    },
        
    setButtonsFont:function(font,fontLocation) 
    {
    	this._buttonsFont = font;
    	this._buttonsFontLocation = fontLocation;
    },
    

	setBackgroundImagePath: function(path)
	{
		this._backgroundImagePath =path;
	},
	
	setOkImageNormalPath: function(path)
	{
		this._okImageNormalPath =path;
	},
	
	setOkImageSelectedPath: function(path)
	{
		this._okImageSelectedPath =path;
	},
	
	setCancelImageNormalPath: function(path)
	{
		this._cancelImageNormalPath =path;
	},
	
	setCancelImageSelectedPath: function(path)
	{
		this._cancelImageSelectedPath =path;
	},
		
	////////////////////////////////////////////////////////////
	
getAdjustedX: function(x) {
	
	var width = 0 , newWidth = 0 ;
	width = Core.Capabilities.getScreenWidth();
	newWidth = (width / 320) * x;
	
	return newWidth;
	
},

getAdjustedY: function(y) 
{
	var height = 0 , newHeight = 0;
	height = Core.Capabilities.getScreenHeight();
	newHeight = (height / 480) * y;
	
	return newHeight;
},

adjustWidthWithDevice: function(aWidth)
{
	var w = 0, calWidth = 0;
	
	w = Core.Capabilities.getScreenWidth();
	
	calWidth = aWidth * (w/320);
		//////NgLogE('Bandri Width:'+aWidth +'-->'+calWidth +'device W:'+w);
	return calWidth;			
},
adjustHeightWithDevice: function(aHeight)
{
	var h = 0 , calHeight = 0;
	
	h = Core.Capabilities.getScreenHeight();
	
	calHeight = aHeight * (h/480);
		//////NgLogE('Bandri Width:'+aHeight +'-->'+calHeight +'device H:'+h);
	return calHeight;		
	
},

getAdjustedFontSize: function(fieldHeight) {
	return this.getAdjustedY(fieldHeight / 2) / aspectRatioFactor.d;
},
	////////////////////////////////////////////////////////////

	destroy: function($super)
	{
		GL2.Root.removeChild(this);
		TFUtil.destroyNodeChildren(this);
		$super();
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI Elements/TankUI/TBParticleAnimation'] = function(){var exports = $MODULE_REGISTRY['Code/UI Elements/TankUI/TBParticleAnimation'] || {}; $MODULE_REGISTRY['Code/UI Elements/TankUI/TBParticleAnimation'] = exports; // Classes: Particle, Emitter  
// Author: Mustafa Hanif
// 3 July 2011
// Version: 0.1


var starCounter = 0;

var Particle = Core.MessageListener.subclass({
	classname: 'Particle',
	initialize: function(path,totalParticles){
		
		starCounter++;
		this._point = new Core.Vector([40, 120]);
		this._yOffset = this._point.getY(); 
		this._totalParticles = 15;
		this._width = TFUtil.getAdjustedWidth(500);
		this._x = 2 * Math.random()*this._width;
		var rightSide = 2*this._width* 0.90;
		var leftSide = 2*this._width * 0.5;

		while((this._x > rightSide ) || (this._x < (leftSide) )){
				this._x = 2*Math.random() * this._width;
		}
		
		
		this._dummy =0;
		this._starNumber = starCounter; 
		this._sameStarSpeeds = starCounter;
		
		if(this._sameStarSpeeds >(this._totalParticles/2)){
			
			this._sameStarSpeeds = ( this._sameStarSpeeds % (this._totalParticles/2) ) + 1;
		}
		
		var r = Math.random();
		this._dummy = ((480/8));
				
		
		Core.UpdateEmitter.addListener(this, this.onUpdate);
		
		this._node = null;
		this._node = new GL2.Sprite();
		
		this._node.setImage(path,[30,30]);  
			
		this._node.setDepth(110);
		
		var r = Math.random();
		r += 0.1;
		
		this._node.setRotation(r*120);
		
	},
		
	
	
	setPosition: function(x,y){
		this._node.setPosition(x,y);
		this._body.setDepth(this._node.getPosition().getY() + 1000);
		
	},
	
	onUpdate: function(delta){
		this._dummy = this._dummy + 4 ;
		
		if(this._starNumber < (this._totalParticles/2)) {
			this._x = this._x + 4;
		}
		
		else{
			this._x = this._x - 4;
		}
		y = ( ( Math.pow((this._dummy - (70 + 5 * this._sameStarSpeeds)), 2)) /50 )  + this._yOffset;
		
		//animation must end when stars get out of the screen
		this._node.setPosition(this._x,y);
		
		if (y > NGWindow.outerHeight){
			Core.UpdateEmitter.removeListener(this);
			return;
		}
			
		
	},
	
	getNode: function(){
		return this._node;
	},
	getY: function(){
		return this._node.getPosition().getY();
	},
	destroy: function($super){
		if(this._node == null)
			return;
		
		if(this._node) {
			this._node.destroy();
			this._node = null;
		}
		$super();

	}
});

var Emitter = Core.MessageListener.subclass(
{
	classname: 'Emitter',
	initialize: function($super){
		$super();
		this._spawn_rate = 25; 
		Core.UpdateEmitter.addListener(this, this.onUpdate);
		this._nodes = null;
		
		this._parent_node = new GL2.Node();
		this._parent_node.setChildrenDepthGrouped(false);
		GL2.Root.addChild(this._parent_node); //parent is in the display ... adding childs to it should display
		this._nodes = new Array();
		for (var i = 0; i < this._spawn_rate; i++){
			var node = new Particle('./Content/fire.png',this._spawn_rate);
			this._parent_node.addChild(node.getNode());  //The parent has the node ... should be on display
			this._nodes.push(node);
		}  
		starCounter = 0;

	},
	kill: function(){
		
		this._alive = false;
			
	},
	
	onUpdate: function(){
		if (this._alive == true){
			for (var i = 0; i < this._spawn_rate; i++){
				var node = new Particle('./Content/fire.png',this._spawn_rate);
				this._parent_node.addChild(node.getNode());  //The parent has the node ... should be on display
				this._nodes.push(node);
			}  
			 starCounter = 0;
		}
		
		for (var i = 0; i <this._nodes.length; i++){
			var node = this._nodes[i];
			if (node != null){
				if (node.getY() >NGWindow.outerHeight){
					this._nodes[i].destroy();
					this._nodes[i] = null;
					this._nodes.splice(i,1);
					--i;
				}
			}
		}
		
		if (this._nodes.length === 0){
			this.destroy();
		}
		
	},
	destroy: function($super){
		if(this._nodes == null)
			return;
		Core.UpdateEmitter.removeListener(this);
		for (var i = 0; i <this._nodes.length; i++){
			if(this._nodes[i] == null)
				continue;
			this._nodes[i].destroy();
			this._nodes[i] = null;
		}
		this._nodes = null;
		
		if(this._parent_node != null) {
			this._parent_node.destroy();
			this._parent_node = null;
		}
		
		$super();
		
	}
});

exports.TBParticleAnimation = Core.Class.singleton({
	classname : 'TBParticleAnimation',
	initialize: function(){
		this._e = null;
	},
	
	getSnowParticleAnimation: function(){
		
		if (this._e != null){
			this._e.destroy();
			this._e = null;
			this._e = new Emitter();

		}else{
			this._e = new Emitter();
		}
	
	},
	
	destroy: function(){
		if (this._e != null && typeof(this._e) != 'undefined'){
			this._e.destroy();
			this._e = null;
		}
	}
});

; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI Elements/TankRename/TankRename'] = function(){var exports = $MODULE_REGISTRY['Code/UI Elements/TankRename/TankRename'] || {}; $MODULE_REGISTRY['Code/UI Elements/TankRename/TankRename'] = exports; 

exports.TankRename = GL2.Node.subclass({

	className: 'TankRename',
	initialize:function($super,aboveBar)
	{
		$super();
		//this.touchTarget = null;
		this._tankAlertWindow = null;
		this._myTankNameText = null;
		this.tankButton = null;
		this.okButton = null;
		this.cancelButton = null;
		this.checkBox	= null;
		this._lockMyTankText = null;
									   
		var SCREEN_HEIGHT = Core.Capabilities.getScreenWidth();
		var SCREEN_WIDTH = Core.Capabilities.getScreenHeight();
		var myMessageListener = new Core.MessageListener();
		var touchTarget = new GL2.TouchTarget();
		touchTarget.setSize(SCREEN_WIDTH,SCREEN_HEIGHT);
		touchTarget.setAnchor(0,0);
		touchTarget.getTouchEmitter().addListener(myMessageListener, this.swallowTouches.bind(this));
		touchTarget.setDepth(1);
		this.addChild(touchTarget);				

				
		this.aboveBar = aboveBar;
		this.currentUser = TFGameState.getCurrentUser();
		this.selectedTank = this.currentUser._tankObj;
		this.tankId = this.currentUser._userObj.selectedTankId;
		this.tankArray = this.currentUser._userObj.tankArray;
		
		this.isLocked = this.selectedTank._tankObj.isTankLocked;
		this.buttonTankName = this.tankArray[this.aboveBar.tankId.toString()].tankName;
	},
	
	swallowTouches: function(touch)
	{
		console.log("swallow touches");							   
		return true;
	},

	tankWindow : function()
	{
		this._tankAlertWindow = GLFactory.getSprite([TFUtil.getAdjustedY(240),TFUtil.getAdjustedX(160)],100,'./Content/images/UIPanels/TankUI/tank-name-background.png',[TFUtil.adjustHeightWithDevice(327),TFUtil.adjustWidthWithDevice(171)],[0.5,0.5]);
		
		this._tankImage = GLFactory.getSprite([TFUtil.getAdjustedY(-120),TFUtil.getAdjustedX(-10)],100,'./Content/images/UIPanels/TankUI/tank-image.png',[TFUtil.adjustHeightWithDevice(60),TFUtil.adjustWidthWithDevice(61)],[0.5,0.5]);
		
		var myTankNameText = GLFactory.getText([TFUtil.getAdjustedY(30),TFUtil.getAdjustedX(-60)],100,GALocalizationHandler.getLocalizedString('TF_MY_TANK_NAME'),[TFUtil.adjustHeightWithDevice(200),TFUtil.adjustWidthWithDevice(300)],TFUtil.getAdjustedFontSize(150));
		myTankNameText.setColor(0, 0, 0);
		myTankNameText.setFontLocation(TFUtil.getFontLocation());
		myTankNameText.setFontFamily(TFUtil.getFont());
		myTankNameText.setHorizontalAlign(GL2.Text.HorizontalAlign.Left);
		this._tankAlertWindow.addChild(myTankNameText);
		
		this.tankButton = new GLButton('./Content/images/UIPanels/TankUI/tank-name-bar.png','./Content/images/UIPanels/TankUI/tank-name-bar.png',TFUtil.getAdjustedY(152),TFUtil.getAdjustedX(29),this.myTank.bind(this),this._tankAlertWindow,100,this.buttonTankName,new Core.Color(0,0,0),new Core.Color(0,0,0),null,TFUtil.getAdjustedFontSize(100));
		this.tankButton.setPosition(TFUtil.getAdjustedY(0),TFUtil.getAdjustedX(-20));
		this.tankButton.setTextFont(TFUtil.getFont(),TFUtil.getFontLocation());

		var okButton = new GLButton('./Content/images/UIPanels/Buttons/1buttonNormal.png',
									'./Content/images/UIPanels/Buttons/1buttonSelected.png',
									TFUtil.getAdjustedY(90),TFUtil.getAdjustedX(40),
									this.tankOk.bind(this),
									this._tankAlertWindow,
									100,
									GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'),
									new Core.Color(1,1,1),
									new Core.Color(1,1,1),
									null,
									TFUtil.getAdjustedFontSize(140));
		okButton.setTextFont(TFUtil.getFont(),TFUtil.getFontLocation());
		okButton.setPosition(TFUtil.getAdjustedY(-80),TFUtil.getAdjustedX(55));
	
		var cancelButton = new GLButton('./Content/images/UIPanels/Buttons/1buttonNormal.png','./Content/images/UIPanels/Buttons/1buttonSelected.png',TFUtil.getAdjustedY(90),TFUtil.getAdjustedX(40),this.tankCancel.bind(this),this._tankAlertWindow,100,GALocalizationHandler.getLocalizedString('TF_CANCEL_BUTTON'),new Core.Color(1,1,1),new Core.Color(1,1,1),null,TFUtil.getAdjustedFontSize(140));
		cancelButton.setPosition(TFUtil.getAdjustedY(80),TFUtil.getAdjustedX(55));
		cancelButton.setTextFont(TFUtil.getFont(),TFUtil.getFontLocation());
		this._tankAlertWindow.addChild(this._tankImage);
		
		this.checkBox = new GLButton('./Content/images/UIPanels/TankUI/checkbox-normal.png','./Content/images/UIPanels/TankUI/checkbox-normal.png',TFUtil.getAdjustedY(31),TFUtil.getAdjustedX(34),this.checkBoxCallBack.bind(this),this._tankAlertWindow,100,"",null,null,null,null);
		this.checkBox.setPosition(TFUtil.getAdjustedY(-50),TFUtil.getAdjustedX(10));
		this.setCheckBoxValue(this.selectedTank._tankObj.isTankLocked);
		var lockMyTankText = GLFactory.getText([TFUtil.getAdjustedY(70),TFUtil.getAdjustedX(10)],100,GALocalizationHandler.getLocalizedString('TF_LOCK_MY_TANK'),[TFUtil.adjustHeightWithDevice(200),TFUtil.adjustWidthWithDevice(300)],TFUtil.getAdjustedFontSize(100));
		lockMyTankText.setColor(0, 0, 0);
		lockMyTankText.setFontLocation(TFUtil.getFontLocation());
		lockMyTankText.setFontFamily(TFUtil.getFont());
		lockMyTankText.setHorizontalAlign(GL2.Text.HorizontalAlign.Left);
		this._tankAlertWindow.addChild(lockMyTankText);
		
		this.addChild(this._tankAlertWindow);
	},
	
	tankCancel: function()
	{
		this.destroy();
	},
	
	checkBoxCallBack: function()
	{
		if(this.isLocked)
		{
			this.isLocked = false;
		}
		else
		{
			this.isLocked = true;
		}
	
//		GameLayer.getControlLayer().getControlLayerAbove().updateLockBttn();
//		DatabaseInterface.updateTank();
		this.setCheckBoxValue(this.isLocked);
		//this.destroy();
	},
	
	myTank: function()
	{
		this.tankRename();
	},
	
	setCheckBoxValue:function(value)
	{
		if(value == true)
		{
			this.checkBox.setButtonImage("./Content/images/UIPanels/TankUI/checkbox-selected.png");
		}
		else
		{
			this.checkBox.setButtonImage("./Content/images/UIPanels/TankUI/checkbox-normal.png");
		}
		
	},
	
	tankOk: function()
	{
									   
//		if(this.checkBox._ButtonIsSelected)
//		{
//			this.selectedTank._tankObj.isTankLocked = true;
//			console.log(">>Tank lock button is selected");
//										   
//		}
//		else
//		{
//			this.selectedTank._tankObj.isTankLocked = false;
//			console.log(">>Tank lock button is not selected");						   
//		}
		this.selectedTank._tankObj.isTankLocked = this.isLocked;
		try {
			this.tankArray[this.aboveBar.tankId.toString()].isLocked = this.isLocked;
			TFGameState.getCurrentUser()._userObj.persist();
		}
		catch (ex) {
			console.log("Log exception " + ex);
		}
		GameLayer.getControlLayer().getControlLayerAbove().updateLockBttn();
		this.redrawTankName();
		DatabaseInterface.updateTank();
		this.destroy();
	},
	
	tankRename: function()
	{
		var testUIAlert = new GAUIAlertViewWithEditText(GALocalizationHandler.getLocalizedString('TF_RENAMETANK_TEXT'),"",this,GALocalizationHandler.getLocalizedString('TF_CANCEL_BUTTON'),GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'),this.buttonTankName);
		testUIAlert.setType("okwithcancel");
		testUIAlert.setTagValue(1);
		testUIAlert.setMessageColor("FFFFFF");
		testUIAlert.setButtonColor("FFFFFF");
		testUIAlert.setTitleFont(TFUtil.getFontName());
		testUIAlert.setMessageFont(TFUtil.getFontName());
		testUIAlert.setButtonsFont(TFUtil.getFontName());
		testUIAlert.setEditedTextFont(TFUtil.getFontName());
		testUIAlert.setEditTextOnChange(this.limitCheck.bind(testUIAlert)) ;
		testUIAlert.show();
		
	},
	
	limitCheck: function() {
		console.log("Moiez Class Name: "+ this.classname);
		if(this.editableField.getText().length > 8){
			this.editableField.setEnabled(false) ;
			var maxText = this.editableField.getText() ;
			newText = maxText.slice(0, 8) ;
			this.editableField.setText(newText) ;    		
			this.editableField.setEnabled(true) ;
    	} 
	},
	
	clickedButtonAtIndex: function(buttonIndex,alertWindow)
	{
		
		if (buttonIndex == 0) 
		{
			switch(alertWindow.getTagValue())
			{
				case 1:
				{
					
					this.tankName = alertWindow.getText();
					if(this.tankName == "" || this.tankName ==null)
					{
						this.tankName = this.buttonTankName; 
					}
					
					var inputCheck = new InputCheck();
					if(this.tankName.length > 8)
					{
					    this.tankName = this.buttonTankName; 
					    
					    var message = GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_RENAME_LIMIT_CHARS'),[8]);
					    console.log(message);
					    var alertWindow = new TFMiniGLAlertView("",message,this,GALocalizationHandler.getLocalizedString('TF_CANCEL_BUTTON'),GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
					    alertWindow._type="ok";
					    alertWindow.setMessageColor(255,255,255);
						alertWindow.setMessageFont(TFUtil.getFont(),TFUtil.getFontLocation());
						alertWindow.setButtonsFont(TFUtil.getFont(),TFUtil.getFontLocation());
					    alertWindow.show();
									
					}
									   
					if(!inputCheck.textCheck(this.tankName))
					{
						this.tankName = this.buttonTankName; 
						
						var message = GALocalizationHandler.getLocalizedString('TF_SPEACIAL_CHARS_NOTALLOWED_TEXT');
						console.log(message);
						var alertWindow = new TFMiniGLAlertView("",message,this,GALocalizationHandler.getLocalizedString('TF_CANCEL_BUTTON'),GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
						alertWindow._type="ok";
						alertWindow.setMessageColor(255,255,255);
						alertWindow.setMessageFont(TFUtil.getFont(),TFUtil.getFontLocation());
						alertWindow.setButtonsFont(TFUtil.getFont(),TFUtil.getFontLocation());
						alertWindow.show();
						
					}
					else
					{
					console.log("GT:Tank name"+this.tankName);
					this.tankArray[this.aboveBar.tankId.toString()].tankName = this.tankName;
					this.tankButton.destroy();
					this.tankButton = new GLButton('./Content/images/UIPanels/TankUI/tank-name-bar.png','./Content/images/UIPanels/TankUI/tank-name-bar.png',TFUtil.getAdjustedY(152),TFUtil.getAdjustedX(29),this.myTank.bind(this),this._tankAlertWindow,100,this.tankName,new Core.Color(0,0,0),new Core.Color(0,0,0),null,TFUtil.getAdjustedFontSize(80));
					this.tankButton.setPosition(TFUtil.getAdjustedY(0),TFUtil.getAdjustedX(-20));
					
					this.aboveBar._user.updateUser();
					}											
					
					break;
				}
				default:
				{
					break;
				}
			}
			
		}
		else if(buttonIndex == 1) 
		{
			
		}
		
	},
	
	redrawTankName: function()
	{
		if(this.tankName)
		{
			this.aboveBar.maketankNameButton(this.tankName);
		}
		else
		{
			this.aboveBar.maketankNameButton(this.buttonTankName);
		}
	},
	
	destroy: function($super)
	{
		
		TFUtil.destroyNodeChildren(this._tankAlertWindow);
		TFUtil.destroyNodeChildren(this);
		$super();
	}
	
									   
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI Elements/TankRename/InputCheck'] = function(){var exports = $MODULE_REGISTRY['Code/UI Elements/TankRename/InputCheck'] || {}; $MODULE_REGISTRY['Code/UI Elements/TankRename/InputCheck'] = exports; 

exports.InputCheck = GL2.Node.subclass({

	className: 'InputCheck',
	initialize:function()
	{  
		    
	},
    
   textCheck:function(inputText)
   {
   
	   if(!inputText)
	   {
	   return false;
	   }
   
	   for(var i=0; i<inputText.length;i++)
	   {
		  var fisrtChar = inputText[i];
		   var asciVal = inputText.charCodeAt(i);
		   if((asciVal>=48 && asciVal<=58))
		   {
			   continue;
		   
		   }
		   else if((asciVal>=65 && asciVal<=91))
		   {
			   continue;
		   }
		   else if((asciVal>=97 && asciVal<=123))
		   {
			   continue;
		   }
		   else if(asciVal == 32)
		   {
			  continue;
		   }
		   else
		   {
			   return false;
		   }
		   
	   }
	   return true;
	   //numeric 49-58
	   //Capital letters 66-91
	   //98-123	
},
	   
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/GLLayer/AboutUs'] = function(){var exports = $MODULE_REGISTRY['Code/GLLayer/AboutUs'] || {}; $MODULE_REGISTRY['Code/GLLayer/AboutUs'] = exports; 


exports.AboutUs = GL2.Node.subclass({
    classname: 'AboutUs',
    
    initialize: function($super) 
    {
    	$super();
		var SCREEN_HEIGHT = Core.Capabilities.getScreenWidth();
		var SCREEN_WIDTH = Core.Capabilities.getScreenHeight();
		var myMessageListener = new Core.MessageListener();
		var touchTarget = new GL2.TouchTarget();
		touchTarget.setSize(SCREEN_WIDTH,SCREEN_HEIGHT);
		touchTarget.setAnchor(0,0);
		touchTarget.getTouchEmitter().addListener(myMessageListener, this.swallowTouches.bind(this));
		touchTarget.setDepth(1);
		this.addChild(touchTarget);			
    },
	swallowTouches: function(touch)
	{
		console.log("swallow touches");
		return true;

	},
	aboutUs:function ()
	{
		this.aboutUsWindow = GLFactory.getSprite([TFUtil.getAdjustedY(0),TFUtil.getAdjustedX(0)],101,'./Content/images/Store/AboutUs/about_tap_fish.jpg',[TFUtil.adjustHeightWithDevice(480),TFUtil.adjustWidthWithDevice(320)],[0,0]);
		this.addChild(this.aboutUsWindow);
		
		var closeButton = new GLButton('./Content/images/UIPanels/Buttons/1buttonNormal.png','./Content/images/UIPanels/Buttons/1buttonSelected.png',TFUtil.getAdjustedY(90),TFUtil.getAdjustedX(35),this.closeAboutUs.bind(this),this.aboutUsWindow,102,GALocalizationHandler.getLocalizedString('TF_CLOSE'),null,null,null,TFUtil.getAdjustedFontSize(140));
		closeButton.setPosition(TFUtil.getAdjustedY(290),TFUtil.getAdjustedX(280));
		
		var feedBackButton = new GLButton('./Content/images/UIPanels/Buttons/1buttonNormal.png','./Content/images/UIPanels/Buttons/1buttonSelected.png',TFUtil.getAdjustedY(90),TFUtil.getAdjustedX(35),this.feedBack.bind(this),this.aboutUsWindow,102,GALocalizationHandler.getLocalizedString('TF_FEEDBACK'),null,null,null,TFUtil.getAdjustedFontSize(140));
		feedBackButton.setPosition(TFUtil.getAdjustedY(185),TFUtil.getAdjustedX(280));
		
//		var aboutUsText = GLFactory.getText([TFUtil.getAdjustedY(230),TFUtil.getAdjustedX(140)],102,GALocalizationHandler.getLocalizedString('TF_ABOUT_US_HEADER'),[TFUtil.adjustHeightWithDevice(90),TFUtil.adjustWidthWithDevice(45)],TFUtil.getAdjustedFontSize(160));
//		aboutUsText.setColor(1, 1, 1);
//		aboutUsText.setFontLocation(TFUtil.getFontLocation());
//		aboutUsText.setFontFamily(TFUtil.getFont());
//		aboutUsText.setHorizontalAlign(GL2.Text.HorizontalAlign.Center);
		
		this.aboutUsImage = GLFactory.getSprite([TFUtil.getAdjustedY(165),TFUtil.getAdjustedX(120)],103,'./Content/images/Store/AboutUs/about-us.png',[TFUtil.adjustHeightWithDevice(150),TFUtil.adjustWidthWithDevice(40)],[0,0]);
		this.addChild(this.aboutUsImage);
		
		var aboutUsDetailText = GLFactory.getText([TFUtil.getAdjustedY(230),TFUtil.getAdjustedX(190)],102,GALocalizationHandler.getLocalizedString('TF_ABOUT_US_DETAIL'),[TFUtil.adjustHeightWithDevice(250),TFUtil.adjustWidthWithDevice(280)],TFUtil.getAdjustedFontSize(100));
		aboutUsDetailText.setColor(1, 1, 1);
		aboutUsDetailText.setFontLocation(TFUtil.getFontLocation());
		aboutUsDetailText.setFontFamily(TFUtil.getFont());
		aboutUsDetailText.setHorizontalAlign(GL2.Text.HorizontalAlign.Center);
		
		var webSiteLink = new GLButton('./Content/images/Store/AboutUs/transparentImage.png','./Content/images/Store/AboutUs/transparentImage.png',TFUtil.getAdjustedY(170),TFUtil.getAdjustedX(20),this.openWebSite.bind(this),this.aboutUsWindow,100,GALocalizationHandler.getLocalizedString('TF_WEBSITE_LINK'),/*null*/new Core.Color([0, 1.0, 0]),null,null,TFUtil.getAdjustedFontSize(95));
		webSiteLink.setTextFont(TFUtil.getFont(),TFUtil.getFontLocation());
		webSiteLink.setPosition(TFUtil.getAdjustedY(230),TFUtil.getAdjustedX(225));
		
		var aboutUsVersion = GLFactory.getText([TFUtil.getAdjustedY(200),TFUtil.getAdjustedX(245)],102,GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_MSG_VERSION_DETAIL'),[TF_VERSION_NUMBER]),[TFUtil.adjustHeightWithDevice(90),TFUtil.adjustWidthWithDevice(35)],TFUtil.getAdjustedFontSize(100));
		aboutUsVersion.setColor(1, 1, 1);
		aboutUsVersion.setHorizontalAlign(GL2.Text.HorizontalAlign.Center);
		
		var aboutUsBuild = GLFactory.getText([TFUtil.getAdjustedY(280),TFUtil.getAdjustedX(245)],102,GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_MSG_BUILD_DETAIL'),[TF_BUILD_NUMBER]),[TFUtil.adjustHeightWithDevice(90),TFUtil.adjustWidthWithDevice(35)],TFUtil.getAdjustedFontSize(100));
		aboutUsBuild.setColor(1, 1, 1);
		aboutUsBuild.setHorizontalAlign(GL2.Text.HorizontalAlign.Center);
		
		//this.aboutUsWindow.addChild(aboutUsText);
		this.aboutUsWindow.addChild(aboutUsDetailText);
		this.aboutUsWindow.addChild(aboutUsVersion);
		this.aboutUsWindow.addChild(aboutUsBuild);
	
	},
	
	closeAboutUs : function()
	{
		this.destroy();
	},
	
	clickedButtonOk : function()
	{
		
	},
	
	feedBack : function()
	{
		
		var message = GALocalizationHandler.getLocalizedString('TF_CONFIRM_SEND_MAIL');
		console.log("test "+message);
		var alertWindow = new TFMiniGLAlertView("",message,this,GALocalizationHandler.getLocalizedString('TF_CANCEL_BUTTON'),GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
		alertWindow.setType("okwithcancel");
		alertWindow.setTagValue("feedback_mail");
		alertWindow.setMessageColor("FFFFFF");
		alertWindow.setMessageFont(TFUtil.getFont(),TFUtil.getFontLocation());
		alertWindow.setButtonsFont(TFUtil.getFont(),TFUtil.getFontLocation());
		alertWindow.show();
		
	},
	

	clickedButtonAtIndex: function(buttonIndex,alertView)
	{
		
		if(buttonIndex == 0)
		{
			if(alertView.getTagValue() == "feedback_mail")
			{
				this.destroy();
				var view = UIFactory.getView([TFUtil.getAdjustedY(25),TFUtil.getAdjustedX(25),TFUtil.adjustHeightWithDevice(480),TFUtil.adjustWidthWithDevice(320)]);
				var thisWebView = new UI.WebView();
				thisWebView.setFrame([TFUtil.getAdjustedY(30), TFUtil.getAdjustedX(50), TFUtil.getAdjustedHeight(360), TFUtil.getAdjustedWidth(530)]);
				thisWebView.setBackgroundColor('00000000');
				var baseUrl = GAConfigurations.getURL();
				var feedbackSubject = GAConfigurations.getDeviceType()+'-'+GAConfigurations.getGameName()+' v'+GAConfigurations.getGameVersion()+' - Feedback'; 
				console.log("test","passed4"+feedbackSubject);
				var vStatus = this.calculateVStatForUser();
				var feedbackBody = '\n\n*****Do not change the following*******: \n\nDEVICE : '+GAConfigurations.getDeviceName()+' '+GAConfigurations.getDeviceType()+' | OS : '+GAConfigurations.getOsVersion()+' | IMEI/UDID : '+GAConfigurations.getUdid()+' | USERNAME :'+GAConfigurations.getUserId()+' | GAME : '+GAConfigurations.getGameCode()+' | VERSION : '+TF_VERSION_NUMBER+' | BUILD : '+TF_BUILD_NUMBER+' | LEVEL : '+ TFGameState.getCurrentUser()._userObj.currentLevel +' | Vstat : '+vStatus;
				var urlString = '?subject='+encodeURI(feedbackSubject)+'&body='+encodeURI(feedbackBody);
				//var consolidatedURL = baseUrl+'help/ngtown_help.html'+urlString;
				//var consolidatedURL = 'http://ngtaptownservice.appspot.com//help/ngtown_help.html'+urlString;                           //   TODO THIS LINK WILL REPLACE WITH ORGINAL NGFISH HELP LINK.
				var consolidatedURL = 'mailto:ngtapfish@gameviewstudios.com'+urlString;
					
				thisWebView.loadUrl(consolidatedURL);
				view.addChild(thisWebView);						
			}
		}
		else if (buttonIndex == 1)
		{
			 console.log("Cancel button clicked");
		}
	},
	
	openWebSite : function()
	{
		
	},
	
	calculateVStatForUser: function(){
		var vStat = 100;
		var bucks = TFGameState.getCurrentUser()._userObj.fish_bucks;
		vStat = (bucks == 0) ? 100 : vStat;
		vStat = (bucks > 0 && bucks < 100) ? 200 : vStat;
		vStat = (bucks > 100) ? 300 : vStat;
		return vStat;
	},
	
	errInMail: function(bool)
	{
		console.log('Logger: canOpen URL = '+bool);
	},

	remove: function()
	{
		view.destroy();
		view = null;
	},
	
	destroy: function($super)
	{
		TFUtil.destroyNodeChildren(this.aboutUsWindow);
		TFUtil.destroyNodeChildren(this);
		$super();
	},
	
   
  });; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI Elements/HelpPage/HelpPage'] = function(){var exports = $MODULE_REGISTRY['Code/UI Elements/HelpPage/HelpPage'] || {}; $MODULE_REGISTRY['Code/UI Elements/HelpPage/HelpPage'] = exports; 

exports.HelpPage = GL2.Node.subclass({

	className: 'HelpPage',

	initialize : function($super)
	{
		try
		{
			$super();
			//		var SCREEN_HEIGHT = Core.Capabilities.getScreenWidth();
			var SCREEN_HEIGHT = Core.Capabilities.getScreenWidth();
			var SCREEN_WIDTH = Core.Capabilities.getScreenHeight();
			var myMessageListener = new Core.MessageListener();
			var touchTarget = new GL2.TouchTarget();
			touchTarget.setSize(SCREEN_WIDTH,SCREEN_HEIGHT);
			touchTarget.setAnchor(0,0);
			touchTarget.getTouchEmitter().addListener(myMessageListener, this.swallowTouches.bind(this));
			touchTarget.setDepth(1);
			this.addChild(touchTarget);
			
			this._helpView = null;
			this.width = null;
			this.height = null;
			
			this.width=Core.Capabilities.getScreenWidth();
			this.height=Core.Capabilities.getScreenHeight();
			
			var view = UIFactory.getView([TFUtil.getAdjustedY(25),TFUtil.getAdjustedX(25),TFUtil.adjustHeightWithDevice(480),TFUtil.adjustWidthWithDevice(320)]);
			
			var background = new UI.Image();
			background.setImage("./Content/images/Store/helpBackGround.png");
			background.setFrame([TFUtil.getAdjustedY(0),TFUtil.getAdjustedX(0),TFUtil.adjustHeightWithDevice(420),TFUtil.adjustWidthWithDevice(280)]);
			background.setImageFit(UI.ViewGeometry.FitModes.Stretch);
			view.addChild(background);
			
			var background2 = new UI.Image();
			background2.setImage('./Content/images/UIPanels/AlertWindow/alert-background.png');
			background2.setFrame([TFUtil.getAdjustedY(20),TFUtil.getAdjustedX(35),TFUtil.adjustHeightWithDevice(380),TFUtil.adjustWidthWithDevice(230)]);
			background2.setImageFit(UI.ViewGeometry.FitModes.Stretch);
			view.addChild(background2);
			
			
			var thisWebView = new UI.WebView();
			thisWebView.setFrame([TFUtil.getAdjustedY(30), TFUtil.getAdjustedX(50), TFUtil.getAdjustedHeight(360), TFUtil.getAdjustedWidth(530)]);
			thisWebView.setBackgroundColor('00000000');
			var baseUrl = GAConfigurations.getURL();

			
			var feedbackSubject = GAConfigurations.getDeviceType()+'-'+GAConfigurations.getGameName()+' v'+GAConfigurations.getGameVersion()+' - Feedback'; 
			var vStatus = this.calculateVStatForUser();
			var feedbackBody = '%0A%0A*****Do not change the following: | DEVICE : '+GAConfigurations.getDeviceName()+' '+GAConfigurations.getDeviceType()+' | OS : '+GAConfigurations.getOsVersion()+' | IMEI/UDID : '+GAConfigurations.getUdid()+' | GAME : '+GAConfigurations.getGameCode()+' | LEVEL : '+ TFGameState.getCurrentUser()._userObj.currentLevel +' | '+vStatus;
			var urlString = '?subject='+encodeURI(feedbackSubject)+'&body='+encodeURI(feedbackBody);
			//var consolidatedURL = baseUrl+'/help/ngtown_help.html'+urlString;
			
			var consolidatedURL = 'http://ngtapfishservice.appspot.com/help/ngfish_help.html'+urlString;     
			thisWebView.loadUrl(consolidatedURL);
			thisWebView.setOnPageload(this.stopIndicator.bind(this));
			view.addChild(thisWebView);
			
			this.close_button = UIFactory.getGenericButton([TFUtil.getAdjustedY(400), TFUtil.getAdjustedX(0), TFUtil.getAdjustedHeight(35), TFUtil.getAdjustedWidth(90)], './Content/images/UIPanels/Buttons/cross1.png', './Content/images/UIPanels/Buttons/cross1.png');
            this.close_button.setOnClick((function(){
				console.log(">>>In remove button");
				this.remove();  					
			}).bind(this));
           view.addChild(this.close_button);
			
				
			this.label = UIFactory.getTextArea([TFUtil.getAdjustedY(-15), TFUtil.getAdjustedX(8), TFUtil.getAdjustedHeight(450), TFUtil.getAdjustedWidth(60)], Core.Localization.getString('TF_HELP_TEXT'),TFUtil.getAdjustedFontSize(100), [0.5, 0.5], "000000");
			this.label.setTextFont(TFUtil.getFontName());
			view.addChild(this.label);
			
			this._helpView = view;
		}
		catch(e)
		{
			console.log('Logger: EXCEPTION:' +e.toString());
		}
	},
	swallowTouches: function(touch)
	{
		console.log("swallow touches");
		return true;

	},

	calculateVStatForUser: function(){
		var vStat = 100;
		var bucks = TFGameState.getCurrentUser()._userObj.fish_bucks;
		vStat = (bucks == 0) ? 100 : vStat;
		vStat = (bucks > 0 && bucks < 100) ? 200 : vStat;
		vStat = (bucks > 100) ? 300 : vStat;
		return vStat;
	},
	
	errInMail: function(bool)
	{
		console.log('Logger: canOpen URL = '+bool);
	},


	show: function()
	{		
		
		
		NGWindow.document.addChild(this._helpView);
		this.showIndicator();
	},	

	showIndicator: function(){
		this.activityIndicator = new UI.Spinner();
		this.activityIndicator.setFrame( [ (this.height - TFUtil.adjustWidthWithDevice(50))/2, (this.width + TFUtil.adjustHeightWithDevice(50))/2, TFUtil.adjustHeightWithDevice(30), TFUtil.adjustHeightWithDevice(30) ]);		
		NGWindow.document.addChild(this.activityIndicator);	
	},

	stopIndicator: function(){
		NGWindow.document.removeChild(this.activityIndicator);
		this.activityIndicator.destroy();
		this.activityIndicator = null;
	},

	remove: function()
	{
		this.destroy();
	},
	destroy:function($super)
	{		
		NGWindow.document.removeChild(this._helpView);
		if (this.activityIndicator != null){
			this.activityIndicator.destroy();
			this.activityIndicator = null;
		}
		TFUtil.destroyNodeChildren(this._helpView);
		TFUtil.destroyNodeChildren(this);
		$super();
		
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI Elements/BreedingPanel/FishListLayer'] = function(){var exports = $MODULE_REGISTRY['Code/UI Elements/BreedingPanel/FishListLayer'] || {}; $MODULE_REGISTRY['Code/UI Elements/BreedingPanel/FishListLayer'] = exports; /**
 * Filename: FishListLayer.js
 * Author: Tariq Akram
 * Date Created: May 23,2011
 * Date Updated: --
 */

exports.FishListLayer = GL2.Node.subclass({
	
classname: 'FishListLayer',
	
    initialize: function($super,breedFishUI) 
    {
    	$super();
		this._breedFishUI = breedFishUI;   
		this._firstFishSelected = false;
        this._buyButton = null;
		this._noBreedAbleFishText = null;
		this._upArrow = null;
		this._downArrow = null;
		this._firstSelectedFishStoreID  = null;
        this._bredFishArray = null;
		this._fishArrayCurrentIndex=-1;
        
//        this.addUpArrow();
//        this.addDownArrow();
		
//        this._bredFishArray = this.populateBreedingFishArray();
        this._bredFishArray = TFUtil.getUserBreedableFishList();
        this.showFishInTheList();
		
	},
    
    populateBreedingFishArray:function (key)
	{
        var bredFishArray = null;
        
		if(key)
		{
			//this._storeItem = GAGameLoader.getStoreHandler().getStoreObjectForKey(key);
//			this._allStoreItems = GAGameLoader.getStoreHandler().getAllItems(this._storeItem.parent.parent.visible_id,this._storeItem.parent.visible_id,true);
//			var i =0, count = this._allStoreItems.length ; 
//			
//            bredFishArray = new GAMutableArray();
//            
//			for(; i < count; i++)
//			{
//				//check whether animal is breedable or not
//				if(this._allStoreItems[i].custom_attributes.bredgroup > 0)
//				{
//                    bredFishArray.addObject(this._allStoreItems[i].parent.parent.visible_id+ '_' +this._allStoreItems[i].parent.visible_id +'_'+ this._allStoreItems[i].visible_id);
//				}
//			}
											
			bredFishArray = new GAMutableArray();
			var tempArray=TFUtil.getUserBreedableFishList();
			
			var length =tempArray.getLength();
			for(var i=0 ; i<length ; i++)
			{
		     	var tempObj=tempArray.objectAtIndex(i);
				if(tempObj != key)
				{
					  bredFishArray.addObject(tempObj);
				}
			}
											
		}
		else
		{
				//TFUtil.getUserBreedableFishList();
				bredFishArray = TFUtil.getUserBreedableFishList();
	    }
		
        return TFUtil.getUserBreedableFishList();
		//this.showFishInTheList();
	},
    
											
	reloadBreedingFishArray: function(key) 
	{
		this._bredFishArray = this.populateBreedingFishArray();
		//this.showFishInTheList();
	},
											
											
											
    showFishInTheList:function()
	{
		var oldFirstImage = this._listFirstFish;
		var oldSecondImage = this._listSecondFish;
		var bredFishArrayLength = this._bredFishArray.getLength();
//		console.log("EXC  :: bredFishArrayLength " + bredFishArrayLength);
//		if ( bredFishArrayLength > 0 ){
//	        this.addUpArrow();
//	        this.addDownArrow();
//		}
		
//		this.disableUpArrow();
		this._fishArrayCurrentIndex = -1;
		if(bredFishArrayLength > 0)
		{
	        this.addUpArrow();
	        this.addDownArrow();
	        this.disableUpArrow();
			if(this._bredFishArrayLength <= 2)
			{
				this.disableDownArrow();
			}
			else
			{
				this.enableDownArrow();
			}
			this.downArrowTapped();           //   before click
		}
		else
		{
			
			//this.disableDownArrow();
			 //console.log("BreedingTankStatus: 66666666 ");
			this._buyButton = new GLButton('./Content/images/UIPanels/Buttons/1buttonNormal.png','./Content/images/UIPanels/Buttons/1buttonSelected.png', TFUtil.adjustHeightWithDevice(55),TFUtil.adjustWidthWithDevice(35),this.buyButtonTapped.bind(this),this,null,GALocalizationHandler.getLocalizedString('TF_BUY_BUTTON'),null,null,null,TFUtil.getAdjustedFontSize(85));
			this._buyButton.setPosition(TFUtil.getAdjustedY(78),TFUtil.getAdjustedX(220));
            
			this._noBreedAbleFishText = GLFactory.getText([TFUtil.getAdjustedY(80),TFUtil.getAdjustedX(150)], null,GALocalizationHandler.getLocalizedString('TF_MESSAGE_NO_BREEDABLE_FISH'), [TFUtil.adjustHeightWithDevice(80),TFUtil.adjustWidthWithDevice(80)], TFUtil.getAdjustedFontSize(85));
			this._noBreedAbleFishText.setColor(1,1,1); 
			this._noBreedAbleFishText.setFontLocation(TFUtil.getFontLocation());
			this._noBreedAbleFishText.setFontFamily(TFUtil.getFont());
			this.addChild(this._noBreedAbleFishText);
		}
		this.destroyAllFish(oldFirstImage, oldSecondImage);
		
	},
    
    buyButtonTapped:function ()
	{
//		this._breedFishUI.closeClicked();
//		var storeMainView = new StoreMainView();
//		storeMainView._tableView.didSelectRowAtIndexPath(1);
//		NGWindow.document.addChild(storeMainView);
		
		//this._breedFishUI.closeClicked();
    	TFStorageManager.saveToUserDefault("storeWindowOption","egg");
		var storeMainView = new StoreMainView(true);
		storeMainView.setStoreType(TFStoreType.kFishEggs);
		NGWindow.document.addChild(storeMainView);  
		this._breedFishUI.closeClicked();
	},
    
    addUpArrow: function()
	{ 
		this._upArrow = new GLButton('Content/images/BreedFishPanel/upBreedNormal.png','Content/images/BreedFishPanel/upBreedSelected.png', TFUtil.adjustHeightWithDevice(90),TFUtil.adjustWidthWithDevice(45),this.upArrowTapped.bind(this),this,100);
		this._upArrow.setDisabledImagePath('Content/images/BreedFishPanel/upBreedDisabled.png');
		this._upArrow.setPosition(TFUtil.getAdjustedY(80),TFUtil.getAdjustedX(85));
											
											
											
	 },
	addDownArrow: function()
	{
											
		this._downArrow = new GLButton('Content/images/BreedFishPanel/downBreedNormal.png','Content/images/BreedFishPanel/downBreedSelected.png', TFUtil.adjustHeightWithDevice(90),TFUtil.adjustWidthWithDevice(45),this.downArrowTapped.bind(this),this,100);
		this._downArrow.setDisabledImagePath('Content/images/BreedFishPanel/downBreedDisabled.png');
		this._downArrow.setPosition(TFUtil.getAdjustedY(80),TFUtil.getAdjustedX(280));
	},
    
    downArrowTapped: function()
	{
    
        var bredFishArrayLength = this._bredFishArray.getLength();
        var firstImage = this._listFirstFish;
        var secondImage = this._listSecondFish;
		
		if(this._fishArrayCurrentIndex >= bredFishArrayLength-1)
	    {
			return;
	    }
        
	    if( this._fishArrayCurrentIndex < bredFishArrayLength && this._fishArrayCurrentIndex >= 0)			
	    {
	    	
            this.enableUpArrow();
	    }
	    this._fishArrayCurrentIndex++;
		this._buttonFlag = true;
        
	    this.addFishInTheList(this._fishArrayCurrentIndex,1);  
        
		if(this._fishArrayCurrentIndex >= bredFishArrayLength-1)
	    {
	        this.disableDownArrow();
	    }
		
		this.destroyAllFish(firstImage, secondImage);
	    
	},
    
    upArrowTapped: function()
	{
		
		if(this._fishArrayCurrentIndex<=1)
		{
	        return;
		} 
		
		var firstImage = this._listFirstFish;
	    var secondImage = this._listSecondFish;
		
		//this.destroyAllFish();
		this._fishArrayCurrentIndex -= 2;
		
		
		this.addFishInTheList(this._fishArrayCurrentIndex,2);   /////////////////// Hard Coded 2 is describing thet its coming from Left
		
		if(this._fishArrayCurrentIndex >= 1)
		{
	    	this.enableDownArrow();
		}
		if(this._fishArrayCurrentIndex<=1)
		{
	        this.disableUpArrow();
		} 
		
		this.destroyAllFish(firstImage, secondImage);
	},
    
    disableDownArrow: function()
	{
		this._downArrow.setIsEnabled(false);

	},
	
	disableUpArrow: function()
	{
        this._upArrow.setIsEnabled(false);     
	},
    
    enableUpArrow: function() {
		 this._upArrow.setIsEnabled(true);
    },
    
    enableDownArrow: function() {
		this._downArrow.setIsEnabled(true);
    },
    
    fishTapped: function(key)
	{
		if(!this._breedFishUI.getBreedingTankController().getBreedingTankObject().isBreedingTankLocked() && this._breedFishUI.getBreedingTankController().getBreedingTankObject().canAnimalBePlaced(key))
		{
			this._breedFishUI.addFishInBreedingTankUI(key);
			if(!this._firstFishSelected)
		  {
				this._firstSelectedFishStoreID = key;								
				this._firstFishSelected = true;								
				if(this._bredFishArray) {
					this._bredFishArray.destroy();
					this._bredFishArray = null;
				}
				this._bredFishArray = this.populateBreedingFishArray(key);
				//this.showFishInTheList();
			}
											
		}
	},
    addFishInTheList: function(value,buttonIndex)
	{
		var value2;
		if(buttonIndex == 1)
		{
			this._fishArrayCurrentIndex++;
			value2 = this._fishArrayCurrentIndex;
		}
		else if(buttonIndex == 2)
		{
			value2 = value;
			value = this._fishArrayCurrentIndex-1;
		}
		var key = this._bredFishArray.objectAtIndex(value);
		if(key && key != 'undefined')
		{
			this._listFirstFish  = new FishListObject(key);
            this._listFirstFish._parentUI = this;
			this._listFirstFish.setPosition(TFUtil.getAdjustedY(45),TFUtil.getAdjustedX(90));
			this.addChild(this._listFirstFish);
		}
		
		key = this._bredFishArray.objectAtIndex(value2);
		console.log("second image key " + key);
		if(key && key != 'undefined')
		{
			this._listSecondFish = new FishListObject(key);
            this._listSecondFish._parentUI = this;
			this._listSecondFish.setPosition(TFUtil.getAdjustedY(45),TFUtil.getAdjustedX(165));
			this.addChild(this._listSecondFish);
		} else {
			console.log("inside second image else");
			this._listSecondFish = null;
		}
		
	},
	
	//this is used when we start over the breed Room 
	setFirstFishSelectedFlag:function (boolValue)
	{
		this._firstFishSelected = boolValue;
	},
	
	getFirstFishSelectedFlag:function ()
	{
		return this._firstFishSelected;
	},
		
	getBreedFishUI:function ()
	{
		return this._breedFishUI;
	},
	
	getFirstSelectedFishStoreID:function()
	{
		return this._firstSelectedFishStoreID;
	},
	
    destroyArrowButtons:function()
	{
		if(this._upArrow)
		{
			this._upArrow.destroy();
			this._upArrow = null;
		}
		if(this._downArrow)
		{
			this._downArrow.destroy();
			this._downArrow = null;
		}
		
	},
	
	destroyAllFish:function(firstImage, secondImage)
	{
		if(firstImage)
		{
			//this.removeChild(firstImage);
			firstImage.destroy();
			firstImage = null;
		}
		if(secondImage)
		{
			//this.removeChild(secondImage);
			secondImage.destroy(); 
			secondImage = null;
	    }
		
	},
	
	destroy:function ($super)
	{
		
		if(this._noBreedAbleFishText)
		{
			this._noBreedAbleFishText.destroy();
			this._noBreedAbleFishText = null;
		}
        if(this._buyButton)
        {
            this._buyButton.destroy();
            this._buyButton = null;
        }
		if(this._bredFishArray)
		{
			this._bredFishArray.destroy();
			this._bredFishArray = null;
		}
        this.destroyArrowButtons();
		this.destroyAllFish(this._listFirstFish, this._listSecondFish);
		$super();
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI Elements/BreedingPanel/BreedingTankUI'] = function(){var exports = $MODULE_REGISTRY['Code/UI Elements/BreedingPanel/BreedingTankUI'] || {}; $MODULE_REGISTRY['Code/UI Elements/BreedingPanel/BreedingTankUI'] = exports; /**
 * Filename: BreedingRoomUI.js Author: Tariq Akram Date Created: May
 * 26,2011BreedingTankUI Date Updated: --
 */

exports.BreedingTankUI = GL2.Node.subclass({
	
classname: 'BreedingTankUI',
	
	initialize: function($super,breedTankConroller,breedRoomObj) 
	{
		$super();
		this._breedingTankController = breedTankConroller;  
		this._breedTankObj = breedRoomObj;	
        
		this._checkifclicked = 0;
// this._roomavailable = 1;
		this._eggSprite = null;
		this._firstFishImagePath = null;
		this._secondFishImagePath = null;
        this._childFishStoreID = null;
		this._firstFishSprite = null;
		this._secondFishSprite = null;
        this._childFishSprite = null;
		this._resourceType = null;
		this._tankBackgroundSprite = null;
		this._heartAnimationSprite = null;	
		this._startOverButton = null;	
		this._startBreedingButton = null;
		this._speedupButton = null;
        this._moveToTankButton = null;
	    this._thirdFishName = null;
		this.breedTimeText = null;
		this._buyBreedingRoomPriceLabel = null;
		this._buyBreedingRoomSalePriceLabel = null;
		this._breedingRoomSaleFlagSprite = null;
		this._resourceDownloadSucess = false;
		this._isActionInProgress = false;
		this.breedingStarted = false;
		this.addBreedingTankUIComponents();
		this.addbackBtn();
	  },
	
    
	addBreedingTankUIComponents:function()
	{   
		if(!this._breedTankObj)
		{
            var tankBackgroundSprite = GLFactory.getSprite([TFUtil.getAdjustedY(290),TFUtil.getAdjustedX(180)],null,'./Content/images/BreedFishPanel/locked_breeding_panel.png', [TFUtil.adjustHeightWithDevice(200),TFUtil.adjustWidthWithDevice(150)] , [0.5,0.5]);
			this.addChild(tankBackgroundSprite);  
			var buyButton = new GLButton('./Content/images/UIPanels/Buttons/1buttonNormal.png','./Content/images/UIPanels/Buttons/1buttonSelected.png', TFUtil.adjustHeightWithDevice(80),TFUtil.adjustWidthWithDevice(25),this.confirmBuyBreedingRoom.bind(this),this,null,GALocalizationHandler.getLocalizedString('TF_BUY_BUTTON'),null,null,null,TFUtil.getAdjustedFontSize(100));// TF_BuyBtn
			buyButton.setPosition(TFUtil.getAdjustedY(290),TFUtil.getAdjustedX(275));
            

			
			
            var storeBreedingRoom = GAGameLoader.getStoreHandler().getStoreObjectForKey(this._breedingTankController.getCurrentTankStoreID());
			var prices = storeBreedingRoom.buy_prices["default"];
			var originalBuyPrice = StoreUtil.getPrice(prices);
			var buyPriceKey = GACommonUtils.getBuyPrice(storeBreedingRoom);
			var buyPrice = StoreUtil.getPrice(buyPriceKey);
			var currency = StoreUtil.getCurrency(buyPriceKey);
			
			var currencyType = "";
			if(currency == kCurrencyType.kCurrencyTypeCoins) {
				currencyType = GALocalizationHandler.getLocalizedString('TF_COINS_WORD');// COINS_WORD
			} else {
				currencyType = GALocalizationHandler.getLocalizedString('TF_FISHBUCK_WORD');// FISHBUCK_WORD
			}
			var buyLabelPosition = null;
			var buyBreedingRoomPriceLabel = GLFactory.getText(buyLabelPosition, null, GALocalizationHandler.getRelativeString(Core.Localization.getString('TF_BREED_TANK_BUY_PRICE'),[originalBuyPrice,currencyType]), [TFUtil.adjustHeightWithDevice(200),TFUtil.adjustWidthWithDevice(40)], TFUtil.getAdjustedFontSize(90));			        	 
			buyBreedingRoomPriceLabel.setColor(1,1,1);	
			buyBreedingRoomPriceLabel.setFontLocation(TFUtil.getFontLocation());
			buyBreedingRoomPriceLabel.setFontFamily(TFUtil.getFont());
			this.addChild(buyBreedingRoomPriceLabel);
			if(originalBuyPrice == buyPrice)
			{
				buyLabelPosition = [TFUtil.getAdjustedY(290),TFUtil.getAdjustedX(240)];
				
			}
			else{
				buyLabelPosition = [TFUtil.getAdjustedY(290),TFUtil.getAdjustedX(220)];
				var buyBreedingRoomSalePriceLabel = GLFactory.getText([TFUtil.getAdjustedY(290),TFUtil.getAdjustedX(240)], null, GALocalizationHandler.getRelativeString(Core.Localization.getString('TF_BREED_TANK_SALE_PRICE'),[buyPrice,currencyType]), [TFUtil.adjustHeightWithDevice(200),TFUtil.adjustWidthWithDevice(40)], TFUtil.getAdjustedFontSize(90));			        	 
				buyBreedingRoomSalePriceLabel.setColor(1,1,1);
				buyBreedingRoomSalePriceLabel.setFontLocation(TFUtil.getFontLocation());
				buyBreedingRoomSalePriceLabel.setFontFamily(TFUtil.getFont());
				this.addChild(buyBreedingRoomSalePriceLabel);
				
				this._line = GLFactory.getSprite([TFUtil.getAdjustedY(290),TFUtil.getAdjustedX(220)],null,'./Content/images/Store/storetableimgs/black_dot.png', [TFUtil.adjustHeightWithDevice(110),TFUtil.adjustWidthWithDevice(2)] , [0.5,0.5]);
				this.addChild(this._line);
				
				var breedingRoomSaleFlagSprite = GLFactory.getSprite([TFUtil.getAdjustedY(200),TFUtil.getAdjustedX(120)],null,'./Content/images/Store/storetableimgs/flagsale.png', [TFUtil.adjustHeightWithDevice(35),TFUtil.adjustWidthWithDevice(25)] , [0.5,0.5]);
				this.addChild(breedingRoomSaleFlagSprite);
			}
			
			buyBreedingRoomPriceLabel.setPosition(buyLabelPosition);
			
		}
		else
		{

			var tankBackgroundSprite = GLFactory.getSprite([TFUtil.getAdjustedY(290),TFUtil.getAdjustedX(180)],null,'./Content/images/BreedFishPanel/breedingTank.png', [TFUtil.adjustHeightWithDevice(200),TFUtil.adjustWidthWithDevice(150)] , [0.5,0.5]);
		    this.addChild(tankBackgroundSprite);  
            var breedingTankStatus = this._breedTankObj.getBreedingTankStatus();
					if(breedingTankStatus == kBreedingTankStatus.kStatusReady)
					{
						this.breedingStarted = false;
					}					   

//           console.log("FA this.breedingStarted:" + this.breedingStarted);
            if(breedingTankStatus == kBreedingTankStatus.kStatusTankEmpty && !this.breedingStarted)
            {
            	console.log("FA kBreedingTankStatus.kStatusTankEmpty");
			}
            else if(breedingTankStatus == kBreedingTankStatus.kStatusFirstFish && !this.breedingStarted )
            {
            	console.log("FA kBreedingTankStatus.kStatusFirstFish");
                this.addFish(this._breedTankObj.getFirstFishID());
            }
            else if(breedingTankStatus == kBreedingTankStatus.kStatusSecondFish && !this.breedingStarted)
            {
            	console.log("FA kBreedingTankStatus.kStatusSecondFish");
                this.addFish(this._breedTankObj.getFirstFishID());
                this.addFish(this._breedTankObj.getSecondFishID());
            }
            else if(breedingTankStatus == kBreedingTankStatus.kStatusEgg || this.breedingStarted)
            {
            	console.log("FA kBreedingTankStatus.kStatusEgg");
                this.addEggImage();
                this.addBreedingRoomButtons();
            } 
            else if(breedingTankStatus == kBreedingTankStatus.kStatusReady && !this.breedingStarted)
            {
//            	console.log("FA kBreedingTankStatus.kStatusReady");
            	this._storeObjectKey = this._breedTankObj.getThirdFishID();
            	 if (GAGameLoader.isResourceAvailable(this._storeObjectKey, GAResourceType.kThumb) == false) {
//	        		console.log("ahsan:: BreedingTankUI >> addBreedingTankUIComponents isResourceAvailable :"+false);	
	        		UIFactory.showProgressHUD("Fetching Data");
	        		//this.downloadThumbResoureceForChildAnimal(this._storeObjectKey);
	        		this.breedingTankImageLoader(this._storeObjectKey,GAResourceType.kThumb);
				}
	        	else{
	                var savePath = TFUtil.getBasePathForResourceType(this._breedTankObj.getThirdFishID() ,GAResourceType.kThumb);
	                savePath = savePath +'thumb.png';
											   
											   
											   
					var storeItemTemp = GAGameLoader.getStoreHandler().getStoreObjectForKey(this._breedTankObj.getThirdFishID());
	
					var width = storeItemTemp.custom_attributes.size_width;
					var height = storeItemTemp.custom_attributes.size_height;
											   
											   
	                var childFishSprite = GLFactory.getSprite([TFUtil.getAdjustedY(300),TFUtil.getAdjustedX(180)],null,savePath, [TFUtil.adjustHeightWithDevice(width),TFUtil.adjustWidthWithDevice(height)], [0.5,0.5]);     // ////////////
																																																								// change
	                this.addChild(childFishSprite);
	                
	                
					var storeBreedFish = GAGameLoader.getStoreHandler().getStoreObjectForKey(this._breedTankObj.getThirdFishID());
				    var fishName  = storeBreedFish.name;
				    this._thirdFishName = GLFactory.getText([TFUtil.getAdjustedY(290),TFUtil.getAdjustedX(230)], null, fishName, [TFUtil.adjustHeightWithDevice(300),TFUtil.adjustWidthWithDevice(80)], TFUtil.getAdjustedFontSize(100));
				    this._thirdFishName.setFontLocation(TFUtil.getFontLocation());
					this._thirdFishName.setFontFamily(TFUtil.getFont());
				    this._thirdFishName.setColor(1,1,1);
				    this.addChild(this._thirdFishName);
	                
	        	}	

                this.addBreedingRoomButtons();                
            }
		}
										   
	   var breedText = this.getBreedingRoomTextLabel(this._breedingTankController._currentTank); 
	   this.addChild(breedText);

	},
    
	breedingTankImageLoader: function(storeId,type){
		UIFactory.showProgressHUD("Fetching Data");
		// console.log("ahsan:: BreedingTankUI >> imageLoader ");
		var storeItem = GAGameLoader.getStoreHandler().getStoreObjectForKey(storeId);
		var resourceDownloader =  new GAResourceDownloader(storeItem , this.resourceDownloadingSuccessfulForImageLoader.bind(this,storeId,type), this.resourceDownloadingFailedForImageLoader.bind(this),  type );
		resourceDownloader.startDownloading();
	},
	
	resourceDownloadingSuccessfulForImageLoader:function (storeId,type,savePath,flag,downloader) 
	{
		UIFactory.hideProgressHUD();
        downloader.destroy();
        downloader = null;
       // console.log("ahsan:: BreedingTankUI >> resourceDownloadingSuccessful2 ");
        this.addBreedingTankUIComponents();
        if ((type = GAResourceType.kThumb ) && (GAGameLoader.isResourceAvailable(storeId, GAResourceType.kDetail) == false))
        	this.breedingTankImageLoader(storeId,GAResourceType.kDetail );
        	//if(GAGameLoader.isResourceAvailable(storeId, GAResourceType.kDetail) == false)
        		

	},
	
	resourceDownloadingFailedForImageLoader:function (errorCode, errorMsg,downloader)
	{
		UIFactory.hideProgressHUD();
		// console.log("ahsan:: BreedingTankUI >> resourceDownloadingFailed2 ");

		downloader.destroy();
		downloader = null;
		//this.showCommunityButton();
	},
	
    confirmBuyBreedingRoom: function() {
        var user = TFGameState.getCurrentUser();
		var storeBreedingRoom = GAGameLoader.getStoreHandler().getStoreObjectForKey(this._breedingTankController.getCurrentTankStoreID());
        var buyPriceKey = GACommonUtils.getBuyPrice(storeBreedingRoom);
        var buyPrice = StoreUtil.getPrice(buyPriceKey);
        var currency = StoreUtil.getCurrency(buyPriceKey);
        if(user.canPerformActionForCurrency(currency, buyPrice)) {
			user.deductCurrencyForStoreItem(storeBreedingRoom);
			this._breedTankObj = user.addBreedingRoomforStoreId(this._breedingTankController.getCurrentTankStoreID());
			this.removeAllBreedingUIComponents();
			this.addBreedingTankUIComponents();
		} 
        else 
        {
            if(currency == kCurrencyType.kCurrencyTypeBucks)
		   {
			   var notEnoughBucksAlert = new TFMiniGLAlertView("",GALocalizationHandler.getLocalizedString('TF_ERROR_NO_FISH_BUCKS'),this,GALocalizationHandler.getLocalizedString('TF_CANCEL_BUTTON'),GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
			   notEnoughBucksAlert.setType("ok");
			   notEnoughBucksAlert.setTagValue(0);
			   notEnoughBucksAlert.setMessageColor(255,255,255);
			   notEnoughBucksAlert.setMessageFont(TFUtil.getFont(),TFUtil.getFontLocation());
			   notEnoughBucksAlert.setButtonsFont(TFUtil.getFont(),TFUtil.getFontLocation());
			   notEnoughBucksAlert.show();				
            }
            else
		   {
			   var notEnoughBucksAlert = new TFMiniGLAlertView("",GALocalizationHandler.getLocalizedString('TF_NOT_ENOUGH_COINS'),this,GALocalizationHandler.getLocalizedString('TF_CANCEL_BUTTON'),GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
			   notEnoughBucksAlert.setType("ok");
			   notEnoughBucksAlert.setMessageColor(255,255,255);						
			   notEnoughBucksAlert.setTagValue(0);
			   notEnoughBucksAlert.setMessageFont(TFUtil.getFont(),TFUtil.getFontLocation());
			   notEnoughBucksAlert.setButtonsFont(TFUtil.getFont(),TFUtil.getFontLocation());
			   notEnoughBucksAlert.show();	
			}
        
        }
    },
    
    addFish:function(storeId)
	{
        this._fishStoreID = storeId;
        var savePath = TFUtil.getBasePathForResourceType(storeId ,GAResourceType.kThumb);
        savePath = savePath +'thumb.png';
        this.displayFishInBreedingRoom(savePath);
	},
    
    displayFishInBreedingRoom: function(address)
	{

	   	if(this._breedingTankController._currentTank < this._breedingTankController.getAllBreedingTanks().getLength())
		{			
			// if(this._firstFishImagePath==null || this._checkifclicked == 1)
            if(this._firstFishImagePath == null)
			{
				if(this._breedRoomText)
				{	
					this.removeChild(this._breedRoomText);
					this._breedRoomText.destroy();
					this._breedRoomText = null;
				}
                
				this._breedTankObj.setFirstFishID(this._fishStoreID);
				this._firstFishImagePath = address;
										   
										   var storeItemTemp = GAGameLoader.getStoreHandler().getStoreObjectForKey(this._breedTankObj.getFirstFishID());
										   var width = TFUtil.adjustNumber(storeItemTemp.custom_attributes.size_width,95);
										   var height = TFUtil.adjustNumber(storeItemTemp.custom_attributes.size_height,80);				   
										   
										   
				var firstFishSprite = GLFactory.getSprite([TFUtil.getAdjustedY(335),TFUtil.getAdjustedX(180)],null,address, [TFUtil.adjustHeightWithDevice(width),TFUtil.adjustWidthWithDevice(height)], [0.5,0.5]);     // ////////////
																																																							// change
				this.addChild(firstFishSprite);
                
				this.addBreedingRoomButtons();
			}
			else if(this._secondFishImagePath== null)
			{
//										   console.log("displayFishInBreedingRoom:" +this._secondFishImagePath);
										   
										   
                if(this._breedRoomText)
				{	
                	this.removeChild(this._breedRoomText);
					this._breedRoomText.destroy();
					this._breedRoomText = null;
				}
                
                this._breedTankObj.setSecondFishID(this._fishStoreID);

				this._secondFishImagePath = address;
										   
										   var storeItemTemp = GAGameLoader.getStoreHandler().getStoreObjectForKey(this._breedTankObj.getSecondFishID());
										   var width = TFUtil.adjustNumber(storeItemTemp.custom_attributes.size_width,95);
										   var height = TFUtil.adjustNumber(storeItemTemp.custom_attributes.size_height,80);		
										   
				var secondFishSprite = GLFactory.getSprite([TFUtil.getAdjustedY(240),TFUtil.getAdjustedX(180)],null,address, [TFUtil.adjustHeightWithDevice(width),TFUtil.adjustWidthWithDevice(height)], [0.5,0.5]);     // ////////////
																																																							// change
				this.addChild(secondFishSprite);
			
				secondFishSprite.setScale(-1,1);
				this.addBreedingRoomButtons();
				this.resetAnimalListLayer();

               // var breedCost = this._breedTankObj.getBreedingCost();
//                
// var breedCostStr =
// GALocalizationHandler.getRelativeString(Core.Localization.getString("breeding_cost"),[breedCost]);
// this._breedCostText =
// GLFactory.getText([TFUtil.getAdjustedY(220),TFUtil.getAdjustedX(270)], null,
// breedCostStr,
// [TFUtil.adjustHeightWithDevice(350),TFUtil.adjustWidthWithDevice(80)],
// TFUtil.getAdjustedFontSize(106));
// this.addChild(this._breedCostText);
			}
		}
	},
	
    addbackBtn:function()/// only makes it but with alpha 0, means hidden
	{
		var backBtn = new GLButton('./Content/images/UIPanels/Buttons/1buttonNormal.png','./Content/images/UIPanels/Buttons/1buttonSelected.png', TFUtil.adjustHeightWithDevice(80),TFUtil.adjustWidthWithDevice(25),this.openStoreWindow.bind(this),this,null,GALocalizationHandler.getLocalizedString('TF_BACK_LABEL'),new Core.Color(1,1,1),new Core.Color(0,0,0),null,TFUtil.getAdjustedFontSize(70));
		backBtn.setPosition(TFUtil.getAdjustedY(55), TFUtil.getAdjustedX(45));
		backBtn.setTextFont(TFUtil.getFont(), TFUtil.getFontLocation());
	},
    
    openStoreWindow:function()
    {
    	//this.removeFromParent();
    	this._breedingTankController._parentUI.closeClicked();
		//this.destroy();
		GameLayer.getControlLayer().onTouchStore();
    },


    addBreedingRoomButtons: function()
	{
    	this._isActionInProgress = false;
        var breedingTankStatus = this._breedTankObj.getBreedingTankStatus();
	    if(breedingTankStatus == kBreedingTankStatus.kStatusFirstFish || breedingTankStatus == kBreedingTankStatus.kStatusSecondFish || breedingTankStatus == kBreedingTankStatus.kStatusEgg || breedingTankStatus == kBreedingTankStatus.kStatusReady)
		{
		  if(!this._startOverButton)
		  {
			var startOverButton = new GLButton('./Content/images/UIPanels/Buttons/1buttonNormal.png','./Content/images/UIPanels/Buttons/1buttonSelected.png', TFUtil.adjustHeightWithDevice(80),TFUtil.adjustWidthWithDevice(25),this.startOverAction.bind(this),this,null,GALocalizationHandler.getLocalizedString('TF_RESET_BREED')/*,null,null*/,new Core.Color(1,1,1),new Core.Color(0,0,0),null,TFUtil.getAdjustedFontSize(70));
			startOverButton.setPosition(TFUtil.getAdjustedY(340),TFUtil.getAdjustedX(275));
			startOverButton.setTextFont(TFUtil.getFont(), TFUtil.getFontLocation());
//			this._startOverButton.setFontLocation(TFUtil.getFontLocation());
//    		this._startOverButton.setFontFamily(TFUtil.getFont());
		  }
		}
        if(breedingTankStatus == kBreedingTankStatus.kStatusSecondFish)
		{
			var startBreedingButton = new GLButton('./Content/images/UIPanels/Buttons/1buttonNormal.png','./Content/images/UIPanels/Buttons/1buttonSelected.png', TFUtil.adjustHeightWithDevice(80),TFUtil.adjustWidthWithDevice(25),this.startBreeding.bind(this),this,null,GALocalizationHandler.getLocalizedString('TF_BREED_TEXT')/*,null,null*/,new Core.Color(1,1,1),new Core.Color(0,0,0),null,TFUtil.getAdjustedFontSize(70));
			startBreedingButton.setPosition(TFUtil.getAdjustedY(245),TFUtil.getAdjustedX(275));
			startBreedingButton.setTextFont(TFUtil.getFont(), TFUtil.getFontLocation());
//    		this._startBreedingButton.setFontFamily(TFUtil.getFont());
		}
   
        if(breedingTankStatus == kBreedingTankStatus.kStatusEgg)
		{
				var speedupButton = new GLButton('./Content/images/UIPanels/Buttons/1buttonNormal.png','./Content/images/UIPanels/Buttons/1buttonSelected.png', TFUtil.adjustHeightWithDevice(80),TFUtil.adjustWidthWithDevice(25),this.speedupAction.bind(this),this,null,GALocalizationHandler.getLocalizedString('TF_SPEEDUP_TEXT')/*,null,null*/,new Core.Color(1,1,1),new Core.Color(0,0,0),null,TFUtil.getAdjustedFontSize(70));
				speedupButton.setPosition(TFUtil.getAdjustedY(245),TFUtil.getAdjustedX(275));
				speedupButton.setTextFont(TFUtil.getFont(), TFUtil.getFontLocation());
				
				var customAttributes = GAGameLoader.getResponseObject().getCustomAttributes();
		       	this._saleUp = customAttributes["speedupSale"];
		       	
		       	if(this._saleUp != 0)
				{
					var SaleFlagSprite = GLFactory.getSprite([TFUtil.getAdjustedY(214),TFUtil.getAdjustedX(267)],null,'./Content/images/Store/storetableimgs/flagsale.png', [TFUtil.adjustHeightWithDevice(30),TFUtil.adjustWidthWithDevice(20)] , [0.5,0.5]);
					this.addChild(SaleFlagSprite);
				}
// 			this._speedupButton.setFontLocation(TFUtil.getFontLocation());
//    		this._speedupButton.setFontFamily(TFUtil.getFont());
        }
        
        if(breedingTankStatus == kBreedingTankStatus.kStatusReady) {
            // Here we will put Move to Habitat Button
            var moveToTankButton = new GLButton('./Content/images/UIPanels/Buttons/1buttonNormal.png','./Content/images/UIPanels/Buttons/1buttonSelected.png', TFUtil.adjustHeightWithDevice(80),TFUtil.adjustWidthWithDevice(25),this.moveToTankAction.bind(this),this,null,GALocalizationHandler.getLocalizedString('TF_MOVEBREED_TEXT')/*,null,null*/,new Core.Color(1,1,1),new Core.Color(0,0,0),null,TFUtil.getAdjustedFontSize(70));
			moveToTankButton.setPosition(TFUtil.getAdjustedY(245),TFUtil.getAdjustedX(275));
			moveToTankButton.setTextFont(TFUtil.getFont(), TFUtil.getFontLocation());
//			this._moveToTankButton.setFontLocation(TFUtil.getFontLocation());
//    		this._moveToTankButton.setFontFamily(TFUtil.getFont());
        }
		
	},
    
	startBreeding: function()
	{
		
		if(this._isActionInProgress) 
			return;
		//this._breedingTankController.disableLeftArrow();
		//this._breedingTankController.disableRightArrow();
		this.breedingStarted = true;
		breedingTankStatus = kBreedingTankStatus.kStatusEgg;
		this._isActionInProgress = true;
		this._childFishStoreID =  TFUtil.getBreedResultStoreID(TFUtil.getItemId(this._breedTankObj.getFirstFishID()),TFUtil.getItemId(this._breedTankObj.getSecondFishID()));
		this._heartAnimationSprite =  GLFactory.getSprite([TFUtil.getAdjustedY(290),TFUtil.getAdjustedX(190)],50,'./Content/images/BreedFishPanel/heart1.png', [TFUtil.adjustHeightWithDevice(200),TFUtil.adjustWidthWithDevice(200)], [0.5,0.5]);								   
		this.addChild(this._heartAnimationSprite);
		this.breedingAnimation();       					   									   
		this.downloadThumbResoureceForChildAnimal(this._childFishStoreID);
	},
    
    startOverAction: function()
	{
    	this.disableAnimation();
    	
//    	if(this._isActionInProgress) 
//    		return;
    	
    	this._isActionInProgress = true;
		var message = GALocalizationHandler.getLocalizedString('TF_WRStartOverText');
		var alertWindow = new TFMiniGLAlertView("",message,this,GALocalizationHandler.getLocalizedString('TF_CANCEL_BUTTON'),GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
		alertWindow._type="okwithcancel";
		alertWindow.setTagValue(1112);
		alertWindow.setMessageColor(255,255,255);
		alertWindow.setMessageFont(TFUtil.getFont(),TFUtil.getFontLocation());
		alertWindow.setButtonsFont(TFUtil.getFont(),TFUtil.getFontLocation());
		alertWindow.show();
	},
    
    moveToTankAction: function()
    {
    	if(this._isActionInProgress) 
    		return;
    	this._isActionInProgress = true;
    	
    	var currentTank=TFGameState.getCurrentUser()._tankObj;
    	if(GameLayer.getSelectedTank().canFishBeAdded()){	
		   GameLayer.getSelectedTank().addFish(this._breedTankObj.getThirdFishID(),false,null,true);
		   
		   TFUtil.setBreedFish(this._breedTankObj.getThirdFishID(),this._breedTankObj.getFirstFishID(),this._breedTankObj.getSecondFishID());
		   
		   this.removeAllBreedingUIComponents();
		   this._firstFishImagePath = null;
		   this._secondFishImagePath = null;
		   this._breedTankObj.resetBreedingTankObject();
		   //this.addBreedingTankUIComponents();	
		   this._breedingTankController._parentUI.closeClicked();
//		   TFUtil.isChildExist(123);

		   //add function call to increase xp
		   TFGameState.getCurrentUser().updateXPandLevel(1);
		   		
	   }
	   else
	   {   
		   var message = GALocalizationHandler.getLocalizedString('TF_TANK_FULL');
		   console.log(message);
		   var alertWindow = new TFMiniGLAlertView("",message,this,GALocalizationHandler.getLocalizedString('TF_CANCEL_BUTTON'),GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
		   alertWindow._type="ok";
		   alertWindow.setTagValue(0);
		   alertWindow.setMessageColor(255,255,255);
		   alertWindow.setTitleFont(TFUtil.getFont(),TFUtil.getFontLocation());
		   alertWindow.setMessageFont(TFUtil.getFont(),TFUtil.getFontLocation());
		   alertWindow.setButtonsFont(TFUtil.getFont(),TFUtil.getFontLocation());
		   alertWindow.show();
		   
	   }	   
    },
    
    speedupAction: function()
	{	
    
    	if(this._isActionInProgress) 
    		return;
    	this._isActionInProgress = true;
        if(this._saleUp == 0)
        {
        	var speedUpCost = this._breedTankObj.getSpeedUpCost();        	
        	 var message = GALocalizationHandler.getRelativeString(Core.Localization.getString('TF_WRSpeedUpText'),[speedUpCost]);
        	 
        	console.log(message);
       		var alertWindow = new TFMiniGLAlertView("",message,this,GALocalizationHandler.getLocalizedString('TF_CANCEL_BUTTON'),GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
       		alertWindow._type="okwithcancel";
      		alertWindow.setTagValue(1113);
      		alertWindow.setMessageColor(255,255,255);
      		alertWindow.setMessageFont(TFUtil.getFont(),TFUtil.getFontLocation());
			alertWindow.setButtonsFont(TFUtil.getFont(),TFUtil.getFontLocation());
      		alertWindow.show();
        }
        else
        {
        	var originalPrice = this._breedTankObj.getSpeedUpCost();
        	var speedUpCost = originalPrice - Math.floor((this._saleUp/100) * originalPrice);
        	
           	var message1 = GALocalizationHandler.getRelativeString(Core.Localization.getString('TF_WRSpeedUpText_Sale1'),[originalPrice]);
        	var message2 = GALocalizationHandler.getRelativeString(Core.Localization.getString('TF_WRSpeedUpText_Sale2'),[speedUpCost]);
        	var message3 = GALocalizationHandler.getRelativeString(Core.Localization.getString('TF_WRSpeedUpText_Sale3'),[]);
        	
        	var TFMiniSaleGLAlertView = require('Code/GLLayer/TFMiniSaleGLAlertView').TFMiniSaleGLAlertView;
        	var alertWindow = new TFMiniSaleGLAlertView("",message1,message2,message3,this,GALocalizationHandler.getLocalizedString('TF_CANCEL_BUTTON'),GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
       		alertWindow._type="okwithcancel";
      		alertWindow.setTagValue(1113);
      		alertWindow.setMessageColor(255,255,255);
      		alertWindow.setMessageFont(TFUtil.getFont(),TFUtil.getFontLocation());
			alertWindow.setButtonsFont(TFUtil.getFont(),TFUtil.getFontLocation());
      		alertWindow.show();
        }
		
	},
    
    confirmSpeedUpBreedingRoom: function() {

        var user = TFGameState.getCurrentUser();
        
        if(this._saleUp == 0)
        {
        	var speedUpCost = this._breedTankObj.getSpeedUpCost();
        }
        else
        {
        	var originalPrice = this._breedTankObj.getSpeedUpCost();
        	var speedUpCost = originalPrice - Math.floor((this._saleUp/100) * originalPrice);
        }
        if(user.canPerformActionForCurrency(kCurrencyType.kCurrencyTypeBucks, speedUpCost)) {
										   
			user.updateCurrency(kOperationType.kOperationSubtractBucks, speedUpCost);
			this.breedingStarted = false;
            this._breedTankObj.doPerformSpeedUp(); 
                       
            this.removeAllBreedingUIComponents();
			this.addBreedingTankUIComponents();
			
        } 
        else 
        {
        	//console.log("result1 ::: +++++++++++++ TF_NO_BUCKS_MESSAGE_PURCHASE");
        	//var message = GALocalizationHandler.getLocalizedString('TF_NO_BUCKS_MESSAGE_PURCHASE');
        	//var message = GALocalizationHandler.getLocalizedString('TF_NO_BUCKS_MESSAGE_PURCHASE');
        	//console.log(message);
        	/*var alertWindow = new TFMiniGLAlertView(GALocalizationHandler.getLocalizedString('TF_MESSAGE_LABEL'),message,this,GALocalizationHandler.getLocalizedString('TF_CANCEL_BUTTON'),GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
        	alertWindow._type="okwithcancel";
        	alertWindow.setTagValue(TZ_BUCKS_TAG);
        	alertWindow.setMessageColor(255,255,255);
        	alertWindow.setTitleFont(TFUtil.getFont(),TFUtil.getFontLocation());
        	alertWindow.setMessageFont(TFUtil.getFont(),TFUtil.getFontLocation());
			alertWindow.setButtonsFont(TFUtil.getFont(),TFUtil.getFontLocation());
        	alertWindow.show();*/
        	
        	var message = GALocalizationHandler.getLocalizedString('TF_NO_BUCKS_MESSAGE_PURCHASE');
			
			
			var alertWindow = new TFMiniUIAlertView("",message,this,GALocalizationHandler.getLocalizedString('TF_CANCEL_BUTTON'),GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
			alertWindow.setType("okwithcancel");
			alertWindow.setTagValue(TF_BUCKS_TAG);
			alertWindow.setMessageColor('FFFFFF');
			alertWindow.setButtonColor('FFFFFF');
			alertWindow.setMessageFont(TFUtil.getFontName());
			alertWindow.setButtonsFont(TFUtil.getFontName());
			alertWindow.show();
        	
                 
        }
    },
    
    clickedButtonAtIndex: function(buttonIndex,alerWindow)                        // alert
																					// button																				// action
	{	
		if (buttonIndex == 0) 
		{
			
			if(alerWindow.getTagValue() == 1111)
			{
				this.confirmBuyBreedingRoom();
			}
			else if(alerWindow.getTagValue() == 1112)
			{
				this.removeAllBreedingUIComponents();
				this._firstFishImagePath = null;
				this._secondFishImagePath = null;
                this.breedingStarted  = false;
															
                this._breedTankObj.resetBreedingTankObject();
                this.addBreedingTankUIComponents();
				
			}
			else if(alerWindow.getTagValue() == 1113)
			{
				// this._resourceSyncHandlerObj.retrySyncHandler();
                this.confirmSpeedUpBreedingRoom();
			}
			else if(alerWindow.getTagValue() == TF_BUCKS_TAG)
            {
				this._breedingTankController._parentUI.closeClicked();
            	 var inAppMainView = new InAppMainView(true);
        		NGWindow.document.addChild(inAppMainView);
                //this.destroy();
        		 
        		return;
            }
           // else if(alerWindow.getTagValue() == TF_COINS_TAG)
// {
// var inAppMainView = new TZIAPManager(TF_COINS);
// return;
// }
// else if(alerWindow.getTagValue() == TF_BUCKS_TAG)
// {
// var inAppMainView = new TZIAPManager(TF_BUCKS);
// return;
// }
		} 
		else if (buttonIndex == 1)
		{
			// NgLogE("Cancel button clicked");
		}
		this._isActionInProgress = false;
	},
    
    // //////////////////// Resource Downloading For Breeding Child Animal
	// ////////////////////////
    
    downloadThumbResoureceForChildAnimal:function(key)
	{
		this._resourceType = GAResourceType.kThumb;
		this._storeItem = GAGameLoader.getStoreHandler().getStoreObjectForKey(key);
		this._resourceDownloader =  new GAResourceDownloader(this._storeItem , this.resourceDownloadingSuccessful.bind(this), this.resourceDownloadingFailed.bind(this), GAResourceType.kThumb);
		this._resourceDownloader.startDownloading();	
	},
    
    downloadDetailedResourecesForChildAnimal:function (key)
	{
		this._resourceType = GAResourceType.kDetail;
		this._storeItem = GAGameLoader.getStoreHandler().getStoreObjectForKey(key);
		this._resourceDownloader =  new GAResourceDownloader(this._storeItem , this.resourceDownloadingSuccessful.bind(this), this.resourceDownloadingFailed.bind(this),  GAResourceType.kDetail);
		this._resourceDownloader.startDownloading();
		
	},
    
    resourceDownloadingSuccessful:function (savePath) 
	{
        
		this.destroyResourceDownloader();
        
		if(this._resourceType == GAResourceType.kThumb)
		{
			this.downloadDetailedResourecesForChildAnimal(this._childFishStoreID);
			
		}
		else if(this._resourceType == GAResourceType.kDetail)
		{
			this.childAnimalResourcesDowndloadSuccessful(this._childFishStoreID);
		}
	   
	   
	   //////////////////////////////////////////////////////////////////////////////
	    
	  	if(this._resourceDownloadSucess)
	  	{
	  		NgLogE("BreedingTankUI:resourceDownloadingSuccessful IF -> "+this._resourceDownloadSucess);	
			this.removeAllBreedingUIComponents();
		   	this.addBreedingTankUIComponents();
		}
		else
			NgLogE("BreedingTankUI:resourceDownloadingSuccessful ELSE -> "+this._resourceDownloadSucess);
		
	},
    
    childAnimalResourcesDowndloadSuccessful:function ()
	{
        UIFactory.hideProgressHUD();
        this.removeAllBreedingUIComponents();
        this._breedTankObj.breedFish(this._childFishStoreID);
		this._resourceDownloadSucess = true;
		// if(this._isAnimationTimeOutEnd)
// {
// if(this._heartAnimation)
// {
// this._heartAnimation.destroy();
// this._heartAnimation = null;
// }
// if(this._heartAnimationSprite)
// {
// this._heartAnimationSprite.destroy();
// this._heartAnimationSprite = null;
// }
//		
// }
//		        
        
		// @jabbar enable this animation when functionality is done
			/*
			 * this._heartAnimationSprite =
			 * GLFactory.getSprite([TFUtil.getAdjustedY(240),TFUtil.getAdjustedX(225)],50,'content/images/BreedingPanel/heart.png',
			 * [TFUtil.adjustHeightWithDevice(75),TFUtil.adjustWidthWithDevice(85)],
			 * [0.5,0.5]); ; this.addChild(this._heartAnimationSprite);
			 * //this._heartAnimationSprite.setScale(.1,.1);
			 * this.breedingAnimation();
			 */
		// again populating the animals array list
        
		
        this.resetAnimalListLayer();
        var breedingTankStatus = this._breedTankObj.getBreedingTankStatus();
        if (breedingTankStatus == kBreedingTankStatus.kStatusEgg)
        	this.addEggImage();
//        this.addBreedingTankUIComponents();
//		this.addBreedingRoomButtons();
	},
	
	
    
    resourceDownloadingFailed:function (errorCode, errorMsg)
	{
        UIFactory.hideProgressHUD();
        this.destroyResourceDownloader();
        
        var message = GALocalizationHandler.getLocalizedString('TF_ResourceDownloadingFailed');
        console.log(message);
        var alertWindow = new TFMiniGLAlertView("",message,this,GALocalizationHandler.getLocalizedString('TF_CANCEL_BUTTON'),GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
        alertWindow._type="ok";
        alertWindow.setMessageColor(255,255,255);
    	alertWindow.setMessageFont(TFUtil.getFont(),TFUtil.getFontLocation());
		alertWindow.setButtonsFont(TFUtil.getFont(),TFUtil.getFontLocation());
        alertWindow.show();
        
        // Here you will show Failure resource downloading Alert and WAJ.....
        /*
		 * if(this._resourceType == GAResourceType.kThumb) {
		 * this.downloadThumbResoureceForChildAnimal(this._childFishStoreID); }
		 * else if(this._resourceType == GAResourceType.kDetail) {
		 * this.downloadDetailedResourecesForChildAnimal(this._childFishStoreID); }
		 * else { console.log("resourceDownloadingFailed, error:" + errorCode + ",
		 * errorMsg:" + errorMsg); this._resourceDownloader = new
		 * GAResourceDownloader(this._storeItem ,
		 * this.resourceDownloadingSuccessful.bind(this),
		 * this.resourceDownloadingFailed.bind(this), GAResourceType.kThumb);
		 * this._resourceDownloader.startDownloading(); }
		 */
		
		
		clearTimeout(this._animationEndTimeOutCheck);
		if(this._heartAnimation)
		{
			this._heartAnimation.destroy();
			this._heartAnimation = null;
		}
		if(this._heartAnimationSprite)
		{
			this._heartAnimationSprite.destroy();
			this._heartAnimationSprite = null;
		}
		
		
	},

	destroyResourceDownloader: function()
	{
        if(this._resourceDownloader) {
            this._resourceDownloader.destroy();
            this._resourceDownloader = null;
        }
	},
    
    // //////////////////////////////////////// Recource Downloading End
	// //////////////////////////////////////
    
    
	resetAnimalListLayer:function()
	{
		var breedAnimaUI = this._breedingTankController._parentUI;
		var animalListLayer = breedAnimaUI.getFishListLayer();
        animalListLayer.reloadBreedingFishArray();
	},
	
	addEggImage:function ()
	{
		var eggSprite = GLFactory.getSprite([TFUtil.getAdjustedY(290),TFUtil.getAdjustedX(180)],null,'Content/egg.png', [TFUtil.adjustHeightWithDevice(40),TFUtil.adjustWidthWithDevice(40)], [0.5,0.5]);     // ////////////
																																																				// change
		this.addChild(eggSprite);
        
//	    if(this._thirdFishName)
//	    {
//	    	
//			this._thirdFishName.destroy();
//			this._thirdFishName = null;
//	    }
										   
	    var storeBreedFish = GAGameLoader.getStoreHandler().getStoreObjectForKey(this._breedTankObj.getThirdFishID());
	    var fishName  = storeBreedFish.name;
	    this._thirdFishName = GLFactory.getText([TFUtil.getAdjustedY(290),TFUtil.getAdjustedX(230)], null, fishName, [TFUtil.adjustHeightWithDevice(300),TFUtil.adjustWidthWithDevice(80)], TFUtil.getAdjustedFontSize(100));
	    this._thirdFishName.setColor(1,1,1);
	    this._thirdFishName.setFontLocation(TFUtil.getFontLocation());
		this._thirdFishName.setFontFamily(TFUtil.getFont());
	    this.addChild(this._thirdFishName);
										   
		var valuesIs = this._breedTankObj.remainingBreedingTime();
		valuesIs = valuesIs-1;
		
		var timeRemaining = TFUtil.getTimeInProperFormat(valuesIs*60);
		
		var breedTimeText = GLFactory.getText([TFUtil.getAdjustedY(290),TFUtil.getAdjustedX(150)], null,timeRemaining, [TFUtil.adjustHeightWithDevice(200),TFUtil.adjustWidthWithDevice(80)], TFUtil.getAdjustedFontSize(115));
		breedTimeText.setColor(1,1,1);
		breedTimeText.setFontLocation(TFUtil.getFontLocation());
		breedTimeText.setFontFamily(TFUtil.getFont());
		this.addChild(breedTimeText);
		

	},
	
	// breedingAnimation:function()
// {
// var heartAnimation = new GL2.Animation();
// heartAnimation.pushFrame(new
// GL2.Animation.Frame('content/images/BreedingPanel/heart.png',1000,
// [TFUtil.adjustHeightWithDevice(75),TFUtil.adjustWidthWithDevice(85)],[0.5,
// 1],[0,0,1,1]));
// heartAnimation.pushFrame(new
// GL2.Animation.Frame('content/images/BreedingPanel/heart.png',1000,
// [TFUtil.adjustHeightWithDevice(150),TFUtil.adjustWidthWithDevice(170)],[0.5,
// 1],[0,0,1,1]));
// heartAnimation.pushFrame(new
// GL2.Animation.Frame('content/images/BreedingPanel/heart.png',1000,
// [TFUtil.adjustHeightWithDevice(300),TFUtil.adjustWidthWithDevice(340)],[0.5,
// 1],[0,0,1,1]));
// heartAnimation.pushFrame(new
// GL2.Animation.Frame('content/images/BreedingPanel/heart.png',1000,
// [TFUtil.adjustHeightWithDevice(150),TFUtil.adjustWidthWithDevice(170)],[0.5,
// 1],[0,0,1,1]));
// heartAnimation.pushFrame(new
// GL2.Animation.Frame('content/images/BreedingPanel/heart.png',1000,
// [TFUtil.adjustHeightWithDevice(75),TFUtil.adjustWidthWithDevice(85)],[0.5,
// 1],[0,0,1,1]));
// //heartAnimation.pushFrame(new
// GL2.Animation.Frame('content/images/BreedingPanel/heart.png',1000,
// [TFUtil.adjustHeightWithDevice(75),TFUtil.adjustWidthWithDevice(85)][0.5,
// 1],[0,0,1,1]));
// heartAnimation.setLoopingEnabled(false);
// this._heartAnimation = heartAnimation;
// this._heartAnimationSprite.setAnimation(this._heartAnimation);
//		
// },
	
		 
										   

breedingAnimation:function()
{
	
	var heartAnimation = new GL2.Animation(),i = 0 , maxSize = 120, minSize = 50, animationFrameTime = 10, totalAnimationTime = 0;	
	for(i=0; i < maxSize - minSize ; i++)
	{
			// i+=10;
		heartAnimation.pushFrame(new GL2.Animation.Frame('./Content/images/BreedFishPanel/heart1.png',animationFrameTime, [TFUtil.adjustHeightWithDevice(minSize + i),TFUtil.adjustWidthWithDevice(minSize+10 + (i+1))],[0.5, 0.5],[0,0,1,1]));
	}
	for(i=0; i < maxSize - minSize ; i++)
	{
		heartAnimation.pushFrame(new GL2.Animation.Frame('./Content/images/BreedFishPanel/heart1.png',animationFrameTime, [TFUtil.adjustHeightWithDevice(maxSize-i),TFUtil.adjustWidthWithDevice(maxSize+10-(i+1))],[0.5, 0.5],[0,0,1,1]));
		totalAnimationTime += animationFrameTime;
	}
	
	heartAnimation.setLoopingEnabled(true);
	this._resourceDownloadSucess = false;
	this._isAnimationTimeOutEnd = false;
	this._heartAnimation = heartAnimation;
	this._heartAnimationSprite.setAnimation(this._heartAnimation);
	this._animationEndTimeOutCheck = setTimeout(this.endTimeOutCallBack.bind(this),1000);
},  	 


										   
		
	// breedingAnimation:function()
// {
// var heartAnimation = new GL2.Animation(),i = 0 , maxSize = 200, minSize =
// 100, animationFrameTime = 10, totalAnimationTime = 0;
// for(; i < maxSize-minSize ; i+=1)
// {
// //i+=10;
// heartAnimation.pushFrame(new
// GL2.Animation.Frame('Content/images/BreedFishPanel/heart1.png',animationFrameTime,
// [TFUtil.adjustHeightWithDevice(minSize+i),TFUtil.adjustWidthWithDevice(minSize+10+(i+1))],[0.5,
// 0.5],[0,0,1,1]));
// totalAnimationTime += animationFrameTime;
// console.log("wish:minSize+10+(i+1) = "+(minSize+10+(i+1)));
// }
// heartAnimation.setLoopingEnabled(true);
// this._resourceDownloadSucess = false;
// this._isAnimationTimeOutEnd = false;
// this._heartAnimation = heartAnimation;
// this._heartAnimationSprite.setAnimation(this._heartAnimation);
// this._animationTimeOut =
// setTimeout(this.secondAnimation.bind(this),totalAnimationTime);
// this._animationEndTimeOutCheck =
// setTimeout(this.endTimeOutCallBack.bind(this),5000);
// },
	secondAnimation: function()
	{
		clearTimeout(this._animationTimeOut);
										   
		if(this._heartAnimationSprite)
		{
			// this._heartAnimationSprite.destroy();
			// this._heartAnimationSprite = null;
		}
		
		var heartAnimation = new GL2.Animation(),i = 0 , maxSize = 200, minSize = 100, animationFrameTime = 10, totalAnimationTime = 0;
		// this._heartAnimationSprite =
		// GLFactory.getSprite([TFUtil.getAdjustedY(240),TFUtil.getAdjustedX(160)],50,'content/images/BreedingPanel/heart.png',
		// [TFUtil.adjustHeightWithDevice(maxSize),TFUtil.adjustWidthWithDevice(maxSize+11)],
		// [0.5,0.5]);

		for(; i < maxSize - minSize ; i++)
		{
			// i+=10;
			heartAnimation.pushFrame(new GL2.Animation.Frame('./Content/images/BreedFishPanel/heart1.png',animationFrameTime, [TFUtil.adjustHeightWithDevice(maxSize-i),TFUtil.adjustWidthWithDevice(maxSize+10-(i+1))],[0.5, 0.5],[0,0,1,1]));
			totalAnimationTime += animationFrameTime;
		}
		
		for(i=0; i < maxSize - minSize ; i++)
		{
			// i+=10;
			heartAnimation.pushFrame(new GL2.Animation.Frame('./Content/images/BreedFishPanel/heart1.png',animationFrameTime, [TFUtil.adjustHeightWithDevice(minSize + i),TFUtil.adjustWidthWithDevice(minSize+10 + (i+1))],[0.5, 0.5],[0,0,1,1]));
		}
										   
										   
										   
										   
	    heartAnimation.setLoopingEnabled(true);
		this._heartAnimationSprite.setAnimation(heartAnimation);
		if(this._heartAnimation)
		{
			this._heartAnimation.destroy();
			this._heartAnimation = null;
		}								   
		this._heartAnimation = heartAnimation;
		
	},
	
	endTimeOutCallBack: function()
	{
		clearTimeout(this._animationEndTimeOutCheck);								   
		this._isAnimationTimeOutEnd = true;
		if(this._resourceDownloadSucess)
		{
			if(this._heartAnimation)
			{
				this._heartAnimation.destroy();
				this._heartAnimation = null;
			}
			if(this._heartAnimationSprite != null)
			{
				this.removeChild(this._heartAnimationSprite);
				this._heartAnimationSprite.destroy();
				this._heartAnimationSprite = null;
			}
			this._isActionInProgress = false;
		}
		
		else
		{
			this._animationEndTimeOutCheck = setTimeout(this.endTimeOutCallBack.bind(this),1000);
			
		}
		
	},

	
	getBreedingRoomTextLabel: function(value)
	{
		var str = GALocalizationHandler.getRelativeString(Core.Localization.getString('TF_BREED_TANK_NAME'),[value+1]);
  	    var breedText = GLFactory.getText([TFUtil.getAdjustedY(290),TFUtil.getAdjustedX(120)], null, str, [TFUtil.adjustHeightWithDevice(180),TFUtil.adjustWidthWithDevice(50)], TFUtil.getAdjustedFontSize(130));
  	    breedText.setFontLocation(TFUtil.getFontLocation());
  	    breedText.setFontFamily(TFUtil.getFont());
  	    breedText.setColor(1,1,1);
		return breedText;
	},
	
    // ////////// Breeding Room UI Utility Functions //////////
										       
    isBreedingTankLocked: function()
	{
		if(this._breedTankObj)
		{ 
						
			return false;
		}
		else
		{
							
			return true;
		}
	},
    
    canAnimalBePlaced: function(animalID) 
    {
        var breedingTankStatus = this._breedTankObj.getBreedingTankStatus();
        if(breedingTankStatus == kBreedingTankStatus.kStatusRoomEmpty || breedingTankStatus == kBreedingTankStatus.kStatusFirstFish) {
		   if(breedingTankStatus == kBreedingTankStatus.kStatusFirstFish)
		   {
			   var storeId=this._breedTankObj.getFirstFishID();
			   if(animalID == storeId)
			   {
					return false;
			   }
			   else
			   {
					return true;
			   }
		   }										   
		   return true;

										   
        }
		return false;
    },
	
	getBreedRoomObj:function ()
	{
		return this._breedTankObj;
	},
	
    getFirstAnimalImagePath: function()
    {
      return this._firstFishImagePath;
    },
    setFirstAnimalImagePath: function(value)
    {
    	this._firstFishImagePath = value;
    },
    
	getSecondAnimalImagePath: function()
    {
      return this._secondFishImagePath;
    },
    setSecondAnimalImagePath: function(value)
    {
    	this._secondFishImagePath = value;
    },
		
	removeAllBreedingUIComponents: function()
	{
        TFUtil.destroyNodeChildrenLeaveChild(this,this._heartAnimationSprite);
	},
	disableAnimation:function()
	{
		if(this._heartAnimationSprite)
		{
			this.removeChild(this._heartAnimationSprite);
			this._heartAnimationSprite.destroy();
			this._heartAnimationSprite = null;
		}
	},
	
	destroy:function($super)
	{
        this.destroyResourceDownloader();
		
        if(this._animationEndTimeOutCheck) {
        	clearTimeout(this._animationEndTimeOutCheck);
        	this._animationEndTimeOutCheck = null;
        }
        
		if(this._heartAnimation)
		{
			this._heartAnimation.destroy();
            this._heartAnimation = null;
		}

		TFUtil.destroyNodeChildren(this);
		$super();

	},
	
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI Elements/BreedingPanel/BreedingTank'] = function(){var exports = $MODULE_REGISTRY['Code/UI Elements/BreedingPanel/BreedingTank'] || {}; $MODULE_REGISTRY['Code/UI Elements/BreedingPanel/BreedingTank'] = exports; /**
* Filename: ZooAnimal.js
 * Author: Muhammad Jabbar
 * Date Created: May 30,2011
 * Date Updated: --
 */


exports.BreedingTank = GL2.Node.subclass({
	
	classname: 'BreedingTank',
	
	initialize: function($super) 
    {
	    $super();
		this._firstFishStoreID = null;
	    this._secondFishStoreID = null;
		this._breedTankObj = null;
	},
	
	getBreedingTankStatus:function() 
	{
		if(this._breedTankObj.firstFishID != 0 && this._breedTankObj.secondFishID !=0) 
		{
			if(this.remainingBreedingTime() > 0)
			{
				return kBreedingTankStatus.kStatusEgg;
			}
			return kBreedingTankStatus.kStatusReady;
	
		} 
		else if(this._firstFishStoreID != null || this._secondFishStoreID != null) 
		{
			if(this._firstFishStoreID != null && this._secondFishStoreID != null) 
			{
				return kBreedingTankStatus.kStatusSecondFish;
			}
			else
			{
				return kBreedingTankStatus.kStatusFirstFish;
			}
		}
		else
		{
			return kBreedingTankStatus.kStatusRoomEmpty;
		}
	},
	
	breedFish: function(childStoreId) 
	{
		this._breedTankObj.thirdFishID = childStoreId;
		this._breedTankObj.startingTime = TFGameState.getServerTime();
		this._breedTankObj.firstFishID = this._firstFishStoreID;
		this._breedTankObj.secondFishID = this._secondFishStoreID;
		DatabaseInterface.updateBreedingTank(); 
	},
	
	
	doPerformSpeedUp: function(){
		this._breedTankObj.startingTime = 0;
		DatabaseInterface.updateBreedingTank();
	},
	
	resetBreedingTankObject:function()
	{
		this._firstFishStoreID = null;
		this._secondFishStoreID = null;
		this._breedTankObj.firstFishID = 0;
		this._breedTankObj.secondFishID = 0;
		this._breedTankObj.thirdFishID = 0;
		this._breedTankObj.startingTime = 0;
		DatabaseInterface.updateBreedingTank();//persisting things to DBs								 
	},
	
	getBreedingCost: function() {
		return 30;
	},
	
	getSpeedUpCost: function() {
		return 12;
	},
	
	isBreedingValid: function() 
	{
		if(this._firstFishStoreID != null && this._secondFishStoreID != null) 
		{
			return true;
		}
		return false;
	},
	
	setFishIdsToNull: function()
	{
		this._firstFishStoreID = null; 
		this._secondFishStoreID = null;
	},
											 
	//******************************************
										 
	setBreedTankStoreID:function (newID)
	{
		this._breedTankObj.breedingTankStoreID = newID;
	},
	
	getBreedTankStoreID:function ()
	{
		return this._breedTankObj.breedingTankStoreID;
	},
	
	setBreedTankObj:function (obj)
	{
		this._breedTankObj = obj;
		
	},
	
	getBreedTankObj:function ()
	{
		return this._breedTankObj;
		
	},
	
	setFirstFishID:function (fishStoreID)
	{
		this._firstFishStoreID = fishStoreID;  
	},
	
	getFirstFishID:function ()
	{
		return this._firstFishStoreID; 
	},
		
	setSecondFishID:function (fishStoreID)
	{
		this._secondFishStoreID = fishStoreID;
		
	},
	
	getSecondFishID:function ()
	{
		return this._secondFishStoreID ;
	},
	setThirdFishID:function ()
	{
	//	var user = TZGameState.getCurrentUser();	
//		var thirFishID = user.getBreedFishIDForParentFishs(this.getFirstFishID(),this.getSecondFishID());
//		this._breedTankObj.thirdFishID = thirFishID;

	},
	getThirdFishID:function ()
	{
		return this._breedTankObj.thirdFishID;
	},

	setStartingTime:function (time)
	{
		this._breedTankObj.startingTime = time;
		
	},
	getStartingTime:function ()
	{
		return this._breedTankObj.startingTime ;
	},
	
	remainingBreedingTime:function()
	{

		var startingTime = this.getStartingTime();
		var diff =  TFGameState.getServerTime() - startingTime ;
		var remainingBreedingTime = TF_BREEDED_FISH_ADULT_TIME - (diff/60);
		
		return remainingBreedingTime; 
										 
		
	},
	
	resetAllBreedRoomObjects:function()
	{
		 this._firstFishStoreID = 0;
		 this._secondFishStoreID = 0;
												 
		//this._breedTankObj.breedingTankStoreID = 0;// chck if needed
		this._breedTankObj.firstFishID = 0;
		this._breedTankObj.secondFishID = 0;
		this._breedTankObj.thirdFishID = 0;
		this._breedTankObj.startingTime = 0;
		DatabaseInterface.updateBreedingTank();//persisting things to DBs								 
	},
	
										 
	setBreedRoomObjParameters:function()
	{
		this._breedTankObj.firstFishID = this._firstFishStoreID;
		this._breedTankObj.secondFishID = this._secondFishStoreID;
	},
    
    destroy:function($super)
    {
        if(this._breedTankObj)
        {
            this._breedTankObj.destroy();
            this._breedTankObj = null;
        }
        $super();
    }
	
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI Elements/BreedingPanel/BreedFishUI'] = function(){var exports = $MODULE_REGISTRY['Code/UI Elements/BreedingPanel/BreedFishUI'] || {}; $MODULE_REGISTRY['Code/UI Elements/BreedingPanel/BreedFishUI'] = exports; /**
 * Filename: BreedFishUI.js
 * Author: Tariq Akram
 * Date Created: May 24,2011
 * Date Updated: --
 */
exports.BreedFishUI = GL2.Node.subclass( {
	
classname: 'BreedFishUI',	
	
	initialize: function($super)
	{
		$super();
		
        this.makeTouchSwallower();
		this.setAreButtonsDisabled(false);
		this._isClosing = false;
		this._isTapped = false;
		
		var textureImage = GLFactory.getSprite([TFUtil.getAdjustedY(240),TFUtil.getAdjustedX(180)],null,'Content/images/BreedFishPanel/breeding-panel-bg.png', [TFUtil.adjustHeightWithDevice(460),TFUtil.adjustWidthWithDevice(270)], [0.5,0.5]);
		this.addChild(textureImage);
		
		this._setUpCloseButton();
		this._FishListLayer =  new FishListLayer(this);                      // passing the reference in the parameter
		this.addChild(this._FishListLayer);                                    //  instant of AnimalLayerList Class
		
		this._breedingTankController = new BreedingTankController(this);                          // passing the reference in the parameter
		this.addChild(this._breedingTankController);                                       //  instant of Breeding Room
     	TFUtil.populateBreedingKeys();
	},
	
	makeTouchSwallower: function()
	{
		var w = 0 , h = 0 , myMessageListener = 0;
        w = Core.Capabilities.getScreenWidth();
        h = Core.Capabilities.getScreenHeight();
        var dissolveTouchesTarget = new GL2.TouchTarget();
        dissolveTouchesTarget.setAnchor(0,0);
        dissolveTouchesTarget.setSize(TFUtil.getAdjustedY(h),TFUtil.getAdjustedX(w));
        dissolveTouchesTarget.setPosition(TFUtil.getAdjustedY(0),TFUtil.getAdjustedX(0));
        myMessageListener = new Core.MessageListener();
        dissolveTouchesTarget.getTouchEmitter().addListener(myMessageListener, this.dissolveTouches.bind(this),kTouchSwallower);
        this.addChild(dissolveTouchesTarget);
	},
    
	addFishInBreedingTankUI: function(key)
	{
	  this._breedingTankController.addFishInBreedingTank(key);
	},
	
   
    getBreedingTankController:function()
    {
        return this._breedingTankController;
    },
    getFishListLayer:function ()
	{
        return this._FishListLayer;
    },
    dissolveTouches: function()
    {
        return true;
    },
	
    getParentNode: function()
    {
        return this;
    },
	
	
    _setUpCloseButton: function()
    {
        var closeButton = new GLButton('Content/images/UIPanels/Buttons/cross1.png','Content/images/UIPanels/Buttons/cross2.png', TFUtil.adjustHeightWithDevice(30),TFUtil.adjustWidthWithDevice(30),this.closeClicked.bind(this),this,100);
        closeButton.setPosition(TFUtil.getAdjustedY(462),TFUtil.getAdjustedX(50));
    },
	
    closeClicked: function()
    {
        if(this._isClosing)
        {
            return true;
        }
        this._isClosing = true;
        this.setAreButtonsDisabled(true); 
        var myParent = this.getParent();
		myParent.removeChild(this);
		this.destroy();							  
        return true;
	},
	
    setAreButtonsDisabled: function(value)
    {
        this._areButtonsDisabled = value;
    },
	
    getAreButtonsDisabled: function()
    {
        return this._areButtonsDisabled;
    },	
    destroy: function($super)
    {
    	TFUtil.destroyNodeChildren(this);
        $super();
    },
	
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI Elements/BreedingPanel/FishListObject'] = function(){var exports = $MODULE_REGISTRY['Code/UI Elements/BreedingPanel/FishListObject'] || {}; $MODULE_REGISTRY['Code/UI Elements/BreedingPanel/FishListObject'] = exports; /**
* Filename: ZooAnimal.js
 * Author: Muhammad Jabbar(Edited by Umair)
 * Date Created: May 30,2011
 * Date Updated: --
 */


exports.FishListObject = GL2.Node.subclass({
	
	classname: 'FishListObject',
	
	initialize: function($super,key) 
    {
		$super();
		this._key = key;
		this._fishImage = null;
		this._patchSprite = null;
        this._parentUI = null;
        this._patchSprite = new GLButton('Content/images/BreedFishPanel/panel_button.png','Content/images/BreedFishPanel/panel_button_selected.png', TFUtil.adjustHeightWithDevice(75),TFUtil.adjustWidthWithDevice(55),this.fishTouch.bind(this),this,1);
        this._patchSprite.setPosition(TFUtil.getAdjustedY(35),TFUtil.getAdjustedX(60));
        this._patchSprite.setIsEnabled(false);
		//this._mugShotImage = GLFactory.getSprite([TFUtil.getAdjustedY(-30),TFUtil.getAdjustedX(-30)], 2, 'content/images/mugshot-fish.png', [TFUtil.adjustHeightWithDevice(95),TFUtil.adjustWidthWithDevice(55)], [0,0]);
		//this._mugShotImage.setScale(.5,.5);
		//this._patchSprite.addChild(this._mugShotImage);
		this._storeItem = GAGameLoader.getStoreHandler().getStoreObjectForKey(key);
		this._resourceDownloader =  new GAResourceDownloader(this._storeItem , this.resourceDownloadingSuccessful.bind(this), this.resourceDownloadingFailed.bind(this), GAResourceType.kThumb);
		this._resourceDownloader.startDownloading();	
		this.addFishNameLabel();
	    
    },
	resourceDownloadingSuccessful:function (savePath) 
	{
		console.log("resourceDownloadingSuccess");						 
		this.destroyResourceDownloader();
        this._patchSprite.setIsEnabled(true);
		this.addFishInAnimalListLayer(savePath);
	},
    
    resourceDownloadingFailed:function (errorCode, errorMsg)
	{
		console.log("resourceDownloadingFailed, error:" + errorCode + ", errorMsg:" + errorMsg);
        this.destroyResourceDownloader();
	},
    
	addFishInAnimalListLayer:function(savePath)
	{
		//this._mugShotImage.destroy();
        //this._mugShotImage = null;
		savePath = savePath +'thumb.png';      
		
		this._fishImage = GLFactory.getSprite([TFUtil.getAdjustedY(0),TFUtil.getAdjustedX(0)], 10, savePath, [TFUtil.adjustHeightWithDevice(60),TFUtil.adjustWidthWithDevice(55)], [.5,.5]);
        this._patchSprite.addChild(this._fishImage);
       		
	},
	addFishNameLabel: function(){
		var fishNameText = this._storeItem.name;
		this.fishNameLabel= GLFactory.getText([TFUtil.getAdjustedY(32),TFUtil.getAdjustedX(25)], null,fishNameText, [TFUtil.adjustHeightWithDevice(80),TFUtil.adjustWidthWithDevice(80)], TFUtil.getAdjustedFontSize(70));
		this.fishNameLabel.setColor(1,1,1); 
		this.fishNameLabel.setFontLocation(TFUtil.getFontLocation());
		this.fishNameLabel.setFontFamily(TFUtil.getFont());
		this.addChild(this.fishNameLabel);
		
	},
											 
	fishTouch:function()
	{
	    console.log("fishTouch:" +this._key);
		this._parentUI.fishTapped(this._key);
	},
	destroyResourceDownloader: function()
	{
		if(this._resourceDownloader)
		{
			this._resourceDownloader.destroy();
			this._resourceDownloader = null;
		}
	},
	destroy:function($super)
	{
		this.destroyResourceDownloader();	
		TFUtil.destroyNodeChildren(this._patchSprite);
		TFUtil.destroyNodeChildren(this);
		$super();
//        if(this._mugShotImage)
//		{
//			this._mugShotImage.destroy();
//			this._mugShotImage = null;
//		}

	}
	
	

});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI Elements/BreedingPanel/BreedingTankController'] = function(){var exports = $MODULE_REGISTRY['Code/UI Elements/BreedingPanel/BreedingTankController'] || {}; $MODULE_REGISTRY['Code/UI Elements/BreedingPanel/BreedingTankController'] = exports; /**
 * Filename: BreedingTankController.js
 * Author: Tariq Akram
 * Date Created: May 25,2011
 * Date Updated: --
 */

exports.BreedingTankController = GL2.Node.subclass({
	
classname: 'BreedingTankController',
	
	initialize: function($super,parentNode) 
    {
		$super();
	    this._currentTank = -1;
        this._parentUI = parentNode;
        
		this._allBreedTanks = this.getAllBreedingTankStoreIdsArray(); 
        this._arrowHeadLeft = null;
        this._arrowHeadRight = null;
        this._breedingTankUIObj = null;
        
		this.addRightArrow();
        this.addLeftArrow();
        this.disableLeftArrow();
	    this.rightArrowTapped();           
	   
    },
	
	getAllBreedingTankStoreIdsArray:function()
	{
        var breedingTanksArray = new GAMutableArray();
		var allStoreItems = GAGameLoader.getStoreHandler().getAllItems(11,1,false);
		var i =0, count = allStoreItems.length ;
		for(i; i < count; i++)
		{
			if(this.keepObject(allStoreItems[i])){
				breedingTanksArray.addObject(allStoreItems[i].parent.parent.visible_id+ '_' +allStoreItems[i].parent.visible_id +'_'+ allStoreItems[i].visible_id);
			} 
		}
        return breedingTanksArray;
	},
	
	keepObject: function(storeObject) {	// return true if we'd like to keep this object (and NOT filter it)
		var gameVersion = GAConfigurations.getGameVersion();
		var isQAUser = GAGameLoader.getResponseObject().isQAUser();
		var minVersion = (typeof storeObject.version_min != 'undefined') ? storeObject.version_min : 0;
		var maxVersion = (typeof storeObject.version_max != 'undefined') ? storeObject.version_max : gameVersion;
		if (gameVersion >= minVersion && gameVersion <= maxVersion && storeObject.is_active == true) {
			if (isQAUser == false && storeObject.visible_to.toLowerCase() == "qa".toLowerCase()) {
				return false;
			}
			else {
				return true;
			}
		}
		else {
			return false;
		}
	},

    
    addFishInBreedingTank: function(storeId)
    { 
    	if(!this._breedingTankUIObj.isBreedingTankLocked())
		{
			this._breedingTankUIObj.addFish(storeId);										   
		}
    },

	rightArrowTapped: function()
    {
        var length = this._allBreedTanks.getLength();
		if(this._currentTank == length-1)            //    To handle the multi-touch issue
		{
			return;  	
		}
		
		if( this._currentTank < length && this._currentTank>=0)
		{   
			this.removeChild(this._breedingTankUIObj);
            this._breedingTankUIObj.destroy();
			this.enableLeftArrow();
		}
		this._currentTank++;
		var breedTankStoreID = this.getStoreIdForTank(this._currentTank);
		var user = TFGameState.getCurrentUser();
		var breedRoom  = user.getBreedingTankPurchased(breedTankStoreID);
												   
		this._breedingTankUIObj = new BreedingTankUI(this,breedRoom);
		this.addChild(this._breedingTankUIObj);
		
		if(this._currentTank == length-1)
	    {
			this.disableRightArrow();
	    }
	    
    },
	
	leftArrowTapped: function()
	{
	  	if(this._currentTank==0)             //    To handle the multi-touch issue
	  	{
			return;
	    }
	  	
	  	this.removeChild(this._breedingTankUIObj);
        this._breedingTankUIObj.destroy();
		this._currentTank--; 

		var breedTankStoreID = this.getStoreIdForTank(this._currentTank);
        
        if(breedTankStoreID != null) {
		   var user = TFGameState.getCurrentUser();
		   var breedRoom  = user.getBreedingTankPurchased(breedTankStoreID);
           this._breedingTankUIObj = new BreedingTankUI(this,breedRoom);
           this.addChild(this._breedingTankUIObj);
		}
        
		if(this._currentTank>0)
		{
	    	this.enableRightArrow();
		}
	    else
	    {
	        this.disableLeftArrow();
	    } 
	},
    
	getAllBreedingTanks:function()
	{
		return this._allBreedTanks;
		
	},
	
    getStoreIdForTank: function(roomIndex) {
        
        if(roomIndex >= 0 && roomIndex < this._allBreedTanks.getLength()) 
        {
            //return this._allBreedTanks[roomIndex];
            return this._allBreedTanks.objectAtIndex(roomIndex);
        }
        return null;
    },
    
	getCurrentTankStoreID:function()
	{
		//return this._allBreedTanks[this._currentTank];
        return this._allBreedTanks.objectAtIndex(this._currentTank);
	},
    
	addLeftArrow: function()
	{
	   	this._arrowHeadLeft = new GLButton('./Content/images/BreedFishPanel/leftBreedNormal.png','./Content/images/BreedFishPanel/leftBreedSelected.png', TFUtil.adjustHeightWithDevice(45),TFUtil.adjustWidthWithDevice(90),this.leftArrowTapped.bind(this),this,null);
        this._arrowHeadLeft.setDisabledImagePath('Content/images/BreedFishPanel/leftBreedDisabled.png');
		this._arrowHeadLeft.setPosition(TFUtil.getAdjustedY(160),TFUtil.getAdjustedX(190));
	},
    
	addRightArrow: function()
	{
		this._arrowHeadRight = new GLButton('./Content/images/BreedFishPanel/rightBreedNormal.png','./Content/images/BreedFishPanel/rightBreedSelected.png', TFUtil.adjustHeightWithDevice(45),TFUtil.adjustWidthWithDevice(90),this.rightArrowTapped.bind(this),this,null);
        this._arrowHeadRight.setDisabledImagePath('./Content/images/BreedFishPanel/rightBreedDisabled.png');
		this._arrowHeadRight.setPosition(TFUtil.getAdjustedY(420),TFUtil.getAdjustedX(190));
	},
    
	disableRightArrow: function()
	{
        this._arrowHeadRight.setIsEnabled(false);
	},
    
	enableRightArrow: function()
    {
        this._arrowHeadRight.setIsEnabled(true);    
    },
    
	disableLeftArrow: function()
	{
        this._arrowHeadLeft.setIsEnabled(false);
	},
    
    enableLeftArrow: function()
    {
        this._arrowHeadLeft.setIsEnabled(true);
    },
    
	getBreedingTankObject:function()
	{
		return this._breedingTankUIObj;
	},

    destroy: function($super)
    {
    	
    		
        var breedModelsArray = TFGameState.getCurrentUser()._breedingTanksArray, i=0, count = breedModelsArray.length, tempModel = null;
        for(; i<count ; i++) 
        {
            tempModel = breedModelsArray[i];
            tempModel.setFishIdsToNull();
        }
        if(this._allBreedTanks) {
    		this._allBreedTanks.destroy();
    		this._allBreedTanks = null
    	}
        
        TFUtil.destroyNodeChildren(this);
        $super();
    }
	
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/EventPakage/TankShower'] = function(){var exports = $MODULE_REGISTRY['Code/EventPakage/TankShower'] || {}; $MODULE_REGISTRY['Code/EventPakage/TankShower'] = exports; 
exports.TankShower = GL2.Node.subclass({
	classname: 'TankShower',

	
	initialize: function(basePath) 
	{
		
		this.SCREEN_HEIGHT = Core.Capabilities.getScreenWidth();
		this.SCREEN_WIDTH = Core.Capabilities.getScreenHeight();

		this.rewardItem = GLFactory.getSprite([TFUtil.getAdjustedY(50),TFUtil.getAdjustedX(50)],200,basePath,[TFUtil.adjustHeightWithDevice(30),TFUtil.adjustWidthWithDevice(30)],[0,0]);
		this.addChild(this.rewardItem);
		
		var startPosition = new Core.Vector(this.getRandomX(),-40);
		this.rewardItem.setPosition(startPosition); 
		var speed = 3.0;
		this.speed = speed;
		this.isActive = false;
		this.dx = 0;
		this.dy = 1;
		this._rotation=0;
		this.timerVar1 = setTimeout(this.movement.bind(this),100);
		this.timerVar2 = setTimeout(this.generateRandomAction.bind(this),500);
		this.timerVar3 = setTimeout(this.generateRandomRotation.bind(this),300);
		this.timerVar4 = setTimeout(this.startAnimation.bind(this),2000);
									   		
	},
	
	
	
	startAnimation: function()
	{	
		//cleatTimeout(this.timerVar4);
		var random =Math.random();
		if(!this.isActive && random < 0.25)
		{
			this.isActive = true;
			var startPosition = new Core.Vector(this.getRandomX(),-40);
			this.rewardItem.setPosition(startPosition); 
			this.generateRandomRotation();			
		}
		this.timerVar4 = setTimeout(this.startAnimation.bind(this),2000);
		
	},

	generateRandomAction: function()
	{	
		//cleatTimeout(this.timerVar2);
		this.timerVar2 = setTimeout(this.generateRandomAction.bind(this),500);
		

		if(!this.isActive)
		{
			return;
		}
		
		var random = Math.random();
		if(random < 0.5)
		{
			if(this.dx<=5)
			{
				this.dx += 0.2;
			}
		}
		else 
			if(random >0.5)
			{
				if(this.dx>=-5)
				{
					this.dx-= 0.2;
				}
			}
		
	},


	generateRandomRotation: function()
	{
		//cleatTimeout(this.timerVar3);
		this.timerVar3 = setTimeout(this.generateRandomRotation.bind(this),300);
		
		if(!this.isActive)
		{
			return;
		}
		
		var random = Math.random();
		if(random < 0.5)
		{
			if(this.rewardItem.getRotation() <=355)
			{
				this._rotation = 5;
			}
			else 
			{
				this.rewardItem.setRotation(0) ;
			}
			
		}
	},
	

	boundaryTouched : function()
	{

		if(this.rewardItem.getPosition().getX()  > this.SCREEN_WIDTH )
		{
			return 1;
		}
		if(this.rewardItem.getPosition().getX()  < 0)
		{
			return 2;
		}
		if(this.rewardItem.getPosition().getY()  > this.SCREEN_HEIGHT+30)
		{
			return 3;
		}
		if(this.rewardItem.getPosition().getY()  < -40)
		{
			return 4;
		}
		
		return 0;
		
	},

	getRandomX : function()
	{

		var tempX = (Math.random()*300)+100;
		return tempX;
	},


	movement : function()
	{	
		//clearTimeout(this.timerVar1);
		this.timerVar1 = setTimeout(this.movement.bind(this),100);
		
		
		if(!this.isActive)
		{
			return;
		}
		
		var x = this.rewardItem.getPosition();
		var y = new Core.Vector(this.dx*this.speed , this.dy*this.speed);
		var newPosition = Math2.ccpAdd(x,y);
		this.rewardItem.setPosition(newPosition) ;
		var newRotation=this.rewardItem.getRotation()+this._rotation;
		this.rewardItem.setRotation( newRotation );
		
		var touchedBoundary = this.boundaryTouched();
		if(touchedBoundary == 1)	//right boundry
		{
			this.dx *= -0.2;
			var position1 = new Core.Vector(this.SCREEN_WIDTH, this.rewardItem.getPosition().getY());
			this.rewardItem.setPosition(position1); 
		}
		if(touchedBoundary == 2) //left boundry
		{
			this.dx *= -0.2;
			var position2 = new Core.Vector(0,this.rewardItem.getPosition().getY());
			this.rewardItem.setPosition(position2); 
		}
		if(touchedBoundary == 3)	//bottom
		{
			this.isActive = false;
		}
		
	},

	destroy :function()
	{
		clearTimeout(this.timerVar1);
		clearTimeout(this.timerVar2);
		clearTimeout(this.timerVar3);
		clearTimeout(this.timerVar4);
		console.log("GT:Hi Shower is destroying");
		if(this.rewardItem)
		{
			this.rewardItem.destroy();
		}
		
	},


});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/GLLayer/InterfaceListener'] = function(){var exports = $MODULE_REGISTRY['Code/GLLayer/InterfaceListener'] || {}; $MODULE_REGISTRY['Code/GLLayer/InterfaceListener'] = exports; var Device = require('NGCore/Client/Device').Device;
var Core = require('NGCore/Client/Core').Core;

exports.InterfaceListener = Core.MessageListener.subclass({
    classname: 'InterfaceListener',
    
    initialize: function() {
		Device.OrientationEmitter.addListener(this, this.onUpdate);
	},
	onUpdate : function(msg) { //Orientation Update
		if (msg.type == Device.OrientationEmitter.OrientationType.Interface && msg.orientation != Device.OrientationEmitter.Orientation.LandscapeLeft) {
			Device.OrientationEmitter.setInterfaceOrientation(Device.OrientationEmitter.Orientation.LandscapeLeft, false);
		}
	},
	destroy: function() {
		Device.OrientationEmitter.removeListener(this);
	},
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI Layers/TutorialWindow'] = function(){var exports = $MODULE_REGISTRY['Code/UI Layers/TutorialWindow'] || {}; $MODULE_REGISTRY['Code/UI Layers/TutorialWindow'] = exports; 
var SKIP_BUTTON = "./Content/images/UIPanels/Buttons/1buttonNormal.png"
var SKIP_BUTTON_SELECTED = "./Content/images/UIPanels/Buttons/1buttonSelected.png"
var NEXT_BUTTON = "./Content/images/UIPanels/Buttons/1buttonNormal.png"
var NEXT_BUTTON_SELECTED = "./Content/images/UIPanels/Buttons/1buttonSelected.png"

var BUTTON_NORMAL = "./Content/images/UIPanels/Buttons/1buttonNormal.png"
var BUTTON_SELECTED = "./Content/images/UIPanels/Buttons/1buttonSelected.png"

var TUTORIAL_COMPLETED_EVENT = "TUTORIAL_COMPLETED_EVENT"

exports.TutorialWindow =  GL2.Node.subclass(
{
	initialize: function(){
		this._currentTutorial = 0;
		this._animationArrowSprite = null;
        
        //this.makeTouchSwallower()
											
		this._background = GLFactory.getSprite([TFUtil.getAdjustedY(180),TFUtil.getAdjustedX(235)], null,
		'./Content/images/tutorialWindow.png'
		, [TFUtil.adjustHeightWithDevice(274),TFUtil.adjustWidthWithDevice(164)], [0.5, 0.5]);
		
		this._background.setAlpha(0.9);
		this.addChild(this._background);
		
		this._tutorialText = new GLFactory.getText([TFUtil.getAdjustedY(95),TFUtil.getAdjustedX(145)],0,GALocalizationHandler.getLocalizedString('1'),[TFUtil.getAdjustedY(150),TFUtil.getAdjustedX(50)],TFUtil.getAdjustedFontSize(130));
		this._tutorialText.setAnchor(0,0);
		this._tutorialText.setDepth(100);
		this._tutorialText.setColor(new Core.Color([1, 1, 1]));
		this._tutorialText.setHorizontalAlign(GL2.Text.HorizontalAlign.Center);
		this._tutorialText.setFontLocation(TFUtil.getFontLocation());
		this._tutorialText.setFontFamily(TFUtil.getFont());
		this._tutorialText.setText(Core.Localization.getString("TUTORIAL") + " " + ('1'));
		this.addChild(this._tutorialText);
				
		// message label
		this._message = GLFactory.getText([TFUtil.getAdjustedY(175),TFUtil.getAdjustedX(240)], 100, Core.Localization.getString("TUTORIAL_0"), [TFUtil.getAdjustedY(250),TFUtil.getAdjustedX(245)], TFUtil.getAdjustedFontSize(100));							  
		//this._message.setColor(0.6,0.19,0);
		this._message.setColor(1,1,1);
		//this._message.setHorizontalAlign(GL2.Text.HorizontalAlign.Center);
		this._message.setFontLocation(TFUtil.getFontLocation());
		this._message.setFontFamily(TFUtil.getFont());
		this.addChild(this._message);
		
		// close button
		this._closeButton = new GLButton(BUTTON_NORMAL,BUTTON_SELECTED,TFUtil.adjustHeightWithDevice(73),TFUtil.adjustWidthWithDevice(35),this.close.bind(this),this,100,Core.Localization.getString("Close"), new Core.Color(1,1,1),null,null,TFUtil.getAdjustedFontSize(100));
		this._closeButton.buttonText.setPosition([TFUtil.getAdjustedY(0),TFUtil.getAdjustedX(-1)]);
		this._closeButton.setPosition(TFUtil.getAdjustedY(125),TFUtil.getAdjustedX(290));
		this._closeButton.setTextFont(TFUtil.getFont(),TFUtil.getFontLocation());
		// next button
		this._nextButton = new GLButton(BUTTON_NORMAL,BUTTON_SELECTED,TFUtil.adjustHeightWithDevice(93),TFUtil.adjustWidthWithDevice(35),this.showNextTutorial.bind(this),this,100,Core.Localization.getString("Continue"), new Core.Color(1,1,1),null,null,TFUtil.getAdjustedFontSize(100));
		this._nextButton.buttonText.setPosition(TFUtil.getAdjustedY(0),TFUtil.getAdjustedX(-1));
		this._nextButton.setPosition(TFUtil.getAdjustedY(225),TFUtil.getAdjustedX(290));
		this._nextButton.setTextFont(TFUtil.getFont(),TFUtil.getFontLocation());
		// title
		//this._title = GLFactory.getText([TFUtil.getAdjustedY(170),TFUtil.getAdjustedX(302)], 100, Core.Localization.getString(/*"TF_TUTORIAL_WELCOME"*/"step0"), [TFUtil.adjustHeightWithDevice(130),TFUtil.adjustWidthWithDevice(27)], TFUtil.getAdjustedFontSize(120));							  
		//this._title.setColor(1,1,0);
       	//this.addChild(this._title);
									
	},
     
	makeTouchSwallower: function()
    {
        var w = 0 , h = 0 , myMessageListener = 0;
    	w = Core.Capabilities.getScreenWidth();
		h = Core.Capabilities.getScreenHeight();
    	this._dissolveTouchesTarget = new GL2.TouchTarget();
    	this._dissolveTouchesTarget.setAnchor(0.5,0.5);
		this._dissolveTouchesTarget.setSize( [TFUtil.adjustHeightWithDevice(274),TFUtil.adjustWidthWithDevice(164)]);
        this._dissolveTouchesTarget.setPosition([TFUtil.getAdjustedY(175),TFUtil.getAdjustedX(235)]);
        myMessageListener = new Core.MessageListener();
		this._dissolveTouchesTarget.getTouchEmitter().addListener(myMessageListener, this.dissolveTouches.bind(this),kTouchSwallower); 
		this.addChild(this._dissolveTouchesTarget);
    },
    
    dissolveTouches: function()
    {
    	return true;
    },
    
	// next buttton action
	showNextTutorial: function(){
		if(this._animationArrowSprite)
		{
			this._animationArrowSprite.destroy();
			this._animationArrowSprite = null;
		}
		this._currentTutorial++;
		this._message.setText(Core.Localization.getString(["TUTORIAL_"]+this._currentTutorial));
		
		//change this in heading instead
		//this._title.setText(Core.Localization.getString(["step"]+this._currentTutorial));
		this._tutorialText.setText(Core.Localization.getString("TUTORIAL") + " " + (this._currentTutorial+1));
				
		switch(this._currentTutorial)
		{
			case TUTORIAL_END_COUNT:
				this._nextButton.destroy();
				this._nextButton = null;
				this._closeButton.setPosition(TFUtil.getAdjustedY(175),TFUtil.getAdjustedX(290));
				NgLogE("showNextTutorial: Final tutorial reached!");							
				this.checkForFirstRun();				
				break;
				
		}
		
	},
	// close buttton action		
	checkForFirstRun: function()
	{
		var notFirstRun = TFStorageManager.getValueFromUserDefault(kUserDefaultKeys[0]);
		if(notFirstRun === false){
			NgLogE("TutorialWindow: checkForFirstRun -> setting notFirstRun == true");
			TFStorageManager.saveToUserDefault(kUserDefaultKeys[0],true);		
		}
	},
	close: function(){
		this.checkForFirstRun();
	
		if(GameLayer._tutorial)
		{
			GameLayer.releaseTutorialWindow();
			
		}
		else
		{
			this.destroy();
		}
											
		
	},
										
	destroy: function(){
//		if(this._title)
//		{
//			this._title.destroy();
//			this._title = null;
//		}
		if(this._message)
		{
			this._message.destroy();
			this._message = null;
		}
		if(this._nextButton)
		{									
			this._nextButton.destroy();
			this._nextButton = null;
		}
		if(this._animationArrowSprite)
		{
			this._animationArrowSprite.destroy();
			this._animationArrowSprite = null;
		}
		if(this._closeButton)
		{
			this._closeButton.destroy();
			this._closeButton = null;
		}
		if(this._background)
		{
			this._background.destroy();
			this._background = null;
		}
        if(this._dissolveTouchesTarget)
        {
            this._dissolveTouchesTarget.destroy();
            this._dissolveTouchesTarget = null;
        }
	},

});

; return exports;};
$MODULE_FACTORY_REGISTRY['Code/DevelopmentMenu'] = function(){var exports = $MODULE_REGISTRY['Code/DevelopmentMenu'] || {}; $MODULE_REGISTRY['Code/DevelopmentMenu'] = exports; /*
 * DevelopmentMenu.js
 *
 * Author: Harris Khurram
 * Date: 10-12-2011
 * Update: 10-15-2011
 *
 * 
 * @Description:
 *	Adds development menu to applications.
 * 	@Android: Hit hardware back button and the menu will appear. Hit it again and the menu will hide.
 *	@iOS: For iOS devices a button [Dev Menu] will be added. [Dev Menu] toggles visibility of the Development Menu.
 * 	
 * 	If you hit Update button and game gets stuck due to some error at server end, bad token, exception etc; press Exit button or the hardware back button to Exit the game.
 * 
 * 		Restart: Relaunch the current game without downloading new source code.
 * 		Update: Relaunch the current game with the new source code from the server.
 * 		Exit: Exit Mobage instantly.
 *
 * 		Menu is added to UI.Window so if it gets behind some block-view, hit hardware back button twice, so it gets in front to take the touch.
 * 		
 * 	@Requires:
 * 		Pre included UI package and Core packages.
 *
 * @Sample Code:
 * kDEV_MENU = true		//should be global, define in Configuration Manager OR Constants
 * DevelopmentMenu.instantiate();
 * Make it the first call in main() so that you always have a restart button before an exception occurs.
 * 
*/
var DevelopmentMenu = Core.Class.singleton(
{
    classname: "DevelopmentMenu",
    menuAdded: false,
    
    initialize: function()
    {
        try
	{
	    if(kDEV_MENU === false)
	    {
	        //if kDEV_MENU is set as false, do not add this functionality
	        return;
	    }
	}
	catch (exception)
	{
	    //if kDEV_MENU is not defined, generate a console log, and add Development Menu
	    console.log("\n \n \n\t\tEXCEPTION: "+this.classname+"\n\t\t######################\n\t\t\t" + this.classname + " kDEV_MENU is not defined\n\t\t\tAdding DevelopmentMenu as a default action,\n\t\t\tplease define kDEV_MENU as a global.\n\t\t#########################\n \n \n");
	    console.log(exception);
	}
	finally
	{
	    //nothing to do here for now.    
	}
	
	this._backKey = null;
	this._mainView = null;
	this._restartButton = null;
	this._updateButton = null;
	this._exitButton = null;
	
	this._getDimensions();
	this._registerBackButton();
	this._makeMenu();
	
    },
    
    destroy: function()
    {
	if(this._backKey)
	{
	    this._backKey.destroy();
	}
	
	if(this._mainView)
	{
	    this._mainView.destroy();
	}
	
	if(this._restartButton)
	{
	    this._restartButton.destroy();
	}
	
	if(this._updateButton)
	{
	    this._updateButton.destroy();
	}
	
	if(this._exitButton)
	{
	    this._exitButton.destroy();
	}
	
	delete this._backKey;
	delete this._mainView;
	delete this._restartButton;
	delete this._updateButton;
	delete this._exitButton;
	
	delete this._width;
	delete this._height;
	delete this._ratio;
        
    },
    
    $initWithGame: function(aGamePath)
    {
	//deprecated.
	console.log("\n \n \n\t\tWARNIING: "+ this.classname + "\n\t\t################\n\t\t\t" + this.classname + ".initWithGame() method is deprecated,\n\t\t\tuse " + this.classname + ".instantiate()\n\t\t#########################\n \n \n ");
    },
    
    _getDimensions: function()
    {
	this._width = UI.Window.getWidth();
	this._height = UI.Window.getHeight();
        
        if(this._height>this._width)
        {
            var tempHolder = this._width;
            this._width = this._height;
            this._height = tempHolder;
        }
	this._widthRatio = this._width/480;
	this._heightRatio = this._height/320;
    },
    
    _registerBackButton: function()
    {
	if(Core.Capabilities.getPlatformOS().toLowerCase() === 'android' )
	{
	    this._registerAndroidBackButton();
	}
	else
	{
	    this._makeiOSButton();
	}
    },
    
    $_makeMenu: function()
    {	
	var mainScope = this;
	var localGameServer = Core.Capabilities.getServer();
        var localGamePath = "/" + Core.Capabilities.getGame();
	var remoteGameURL = Core.Capabilities.getUrl();
	
	this._mainView = new UI.View({frame:[0, 0, this._width, this._height], backgroundColor:"A8000000"});
	
	var quitting = false;
	this._restartButton = new UI.Button({
		frame: [0*mainScope._widthRatio-2, 64*mainScope._heightRatio, 128*mainScope._widthRatio, 64*mainScope._heightRatio],
		text: "Restart",
		disabledTextColor: "FFFF",
		textSize: 12*this._heightRatio,
		textGravity: UI.ViewGeometry.Gravity.Center,
		gradient: {
			corners: '0 8 8 0',
			outerLine: "00 1.5",
			gradient: [ "FF9bd6f4 0.0", "FF0077BC 1.0" ]
		},
		highlightedGradient: {
			corners: '0 8 8 0',
			outerLine: "00 1.5",
			gradient: [ "FF0077BC 0.0", "FF9bd6f4 1.0" ]
		},
		disabledGradient: {
			corners: '0 8 8 0',
			gradient: [ "FF55 0.0", "FF00 1.0"]
		},
		onClick: function() {
			if (quitting)
				return;
			quitting = true;
			Core.LocalGameList.restartGame();
			var btFrame = this.getFrame();
			var spinner = new UI.Spinner({
				frame: new UI.ViewGeometry.Rect([btFrame[2]+10*mainScope._widthRatio, btFrame[1], btFrame[3], btFrame[3]])
			});
			UI.Window.document.addChild(spinner);			
			this.setText('Restarting...')
			this.addState(UI.State.Disabled);
			mainScope._updateButton.addState(UI.State.Disabled);
			mainScope._exitButton.addState(UI.State.Disabled)
		}
	});
	this._mainView.addChild(DevelopmentMenu._restartButton);

	this._updateButton = new UI.Button({
		frame: [0*mainScope._widthRatio-2, 135*mainScope._heightRatio, 128*mainScope._widthRatio, 64*mainScope._heightRatio],
		text: "Update",
		disabledTextColor: "FFFF",
		textSize: 12*this._heightRatio,
		textGravity: UI.ViewGeometry.Gravity.Center,
		gradient: {
			corners: '0 8 8 0',
			outerLine: "00 1.5",
			gradient: [ "FF9bd6f4 0.0", "FF0077BC 1.0" ]
		},
		highlightedGradient: {
			corners: '0 8 8 0',
			outerLine: "00 1.5",
			gradient: [ "FF0077BC 0.0", "FF9bd6f4 1.0" ]
		},
		disabledGradient: {
			corners: '0 8 8 0',
			gradient: [ "FF55 0.0", "FF00 1.0"]
		},
		onClick: function() {
			if (quitting)
				return;
			quitting = true;
			Core.LocalGameList.runUpdatedGame(localGamePath)
			var btFrame = this.getFrame();
			var spinner = new UI.Spinner({
				frame: new UI.ViewGeometry.Rect([btFrame[2]+10*mainScope._widthRatio, btFrame[1], btFrame[3], btFrame[3]])
			});
			UI.Window.document.addChild(spinner);
			
			this.setText('Updating...');
			this.addState(UI.State.Disabled);
			mainScope._restartButton.addState(UI.State.Disabled);
			mainScope._backKey.backButton = mainScope._exitButton;
		}
	});
	this._mainView.addChild(DevelopmentMenu._updateButton);

	this._exitButton = new UI.Button({
			    frame: [0*mainScope._widthRatio-2, 206*mainScope._heightRatio, 128*mainScope._widthRatio, 64*mainScope._heightRatio],
			    text: "Exit!",
			    textSize: 12*mainScope._heightRatio,
			    textColor: "FFFFFF",
			    textGravity: UI.ViewGeometry.Gravity.Center,
			    gradient: {
				    corners: '0 8 8 0',
				    outerLine: "00 1.5",
				    gradient: [ "FFf46060 0.0", "FFBC2020 1.0" ]
			    },
			    highlightedGradient: {
				    corners: '0 8 8 0',
				    outerLine: "00 1.5",
				    gradient: [ "FFBC2020 0.0", "FFf46060 1.0" ]
			    },
			    disabledGradient: {
				    corners: '0 8 8 0',
				    gradient: [ "FF55 0.0", "FF00 1.0"]
			    },

			    onClick: function()
			    {
				    Device.LifecycleEmitter.exitProcess();
				    this.addState(UI.State.Disabled)
			    }
			});
	this._mainView.addChild(DevelopmentMenu._exitButton);

    },
    
    $_showMenu: function()
    {
	DevelopmentMenu.menuAdded = true;
	UI.Window.document.addChild(this._mainView)
    },
    
    $_hideMenu: function()
    {
	DevelopmentMenu.menuAdded = false;
	UI.Window.document.removeChild(this._mainView)
    },
    $_makeiOSButton: function()
    {
	var mainScope = this;
	this._backKey = new UI.Button({
		frame: [mainScope._width/2 - 48*mainScope._widthRatio/2, mainScope._height - 48*mainScope._heightRatio+2, 48*mainScope._widthRatio, 48*mainScope._heightRatio],
		text: "Dev Menu",
		textSize: 12*mainScope._heightRatio,
		textColor: "000000",
		textGravity: UI.ViewGeometry.Gravity.Center,
		gradient: {
			corners: '8 8 0 0',
			outerLine: "00 1.5",
			gradient: [ "FF20BCf4 0.0", "FF60f4bc 1.0" ]
		},
		highlightedGradient: {
			corners: '8 8 0 0',
			outerLine: "00 1.5",
			gradient: [ "FF20BCf4 0.0", "FF60f4bc 0.25", "8020BC20 1.0" ]
		},
		disabledGradient: {
			corners: '8 8 0 0',
			gradient: [ "FF55 0.0", "FF00 1.0"]
		},

		onClick: function()
		{
		    if(this.backButton)
		    {
			this.backButton.onclick();
		    }
		    else
		    {
			if(DevelopmentMenu.menuAdded)
			{
			    this.clearState(UI.State.Pressed);
			    this.setFrame([mainScope._width/2 - 48*mainScope._widthRatio/2, mainScope._height - 48*mainScope._heightRatio+2, 48*mainScope._widthRatio, 48*mainScope._heightRatio]);
			    DevelopmentMenu._hideMenu();
			}
			else
			{
			    this.addState(UI.State.Pressed);
			    this.setFrame([mainScope._width/2 - 48*mainScope._widthRatio/2, mainScope._height - 96*mainScope._heightRatio+2, 48*mainScope._widthRatio, 96*mainScope._heightRatio]);
			    DevelopmentMenu._showMenu();
			}
    		    }
		}
	    });
			
	UI.Window.document.addChild(this._backKey);
    },
    _registerAndroidBackButton: function()
    {
	var BackKeyListener = Core.MessageListener.subclass (
	    {
		initialize: function()
		{
		    Device.KeyEmitter.addListener(this, this.onUpdate);
		},
		
		destroy: function($super)
		{
		    Device.KeyEmitter.removeListener(this);
		    this.backButton = null;
		    $super();
		},
		// registers a listener to detect the pressing of the back button
		onUpdate : function(keyEvent)
		{
		    if (keyEvent.code === Device.KeyEmitter.Keycode.back)
		    {
			if (this.backButton)
			{
			    this.backButton.onclick();
			}
			else
			{
			    (DevelopmentMenu.menuAdded) ? DevelopmentMenu._hideMenu() : DevelopmentMenu._showMenu();			    
			}
			return true;
		    }
		    return false;
		}
	    });
	    this._backKey = new BackKeyListener();
    }
});
exports.DevelopmentMenu = DevelopmentMenu;; return exports;};
$MODULE_FACTORY_REGISTRY['Code/SocialAPI/SocialUI'] = function(){var exports = $MODULE_REGISTRY['Code/SocialAPI/SocialUI'] || {}; $MODULE_REGISTRY['Code/SocialAPI/SocialUI'] = exports; /**
 * Author: Ahsan Zaheer
 * Date Created: Oct 21,2011
 * Date Updated: --
 */
exports.SocialUI = GL2.Node.subclass( {
	
classname: 'SocialUI',	
	
	initialize: function($super,isNeighbour)
	{
		$super();
		this.isatNeighbour = isNeighbour;
        this.makeTouchSwallower();
		this._isClosing = false;
		this.addBackground();
		this._setUpCloseButton();
		this._makeButtons();
		
		this._friendsView = null;
		this._messagesView = null ;
		this._cannedMessagesView = null;
		this._notificationView = null;
		this._socialGiftstUI = null;
		this.customMessageUI = null
		
		this._currentView = null;
		
	},
	
	addBackground: function(){
		
		var textureImage = GLFactory.getSprite([SocialUtil.getAdjustedY(240),SocialUtil.getAdjustedX(165)],null,SOCIALAPI_BG_IMG_PATH, [SocialUtil.adjustHeightWithDevice(460),SocialUtil.adjustWidthWithDevice(310)], [0.5,0.5]);
		this.addChild(textureImage);
		
	},
	
	makeTouchSwallower: function()
	{
		var w = 0 , h = 0 , myMessageListener = 0;
        w = Core.Capabilities.getScreenWidth();
        h = Core.Capabilities.getScreenHeight();
        var dissolveTouchesTarget = new GL2.TouchTarget();
        dissolveTouchesTarget.setAnchor(0,0);
        dissolveTouchesTarget.setSize(SocialUtil.getAdjustedY(h),SocialUtil.getAdjustedX(w));
        dissolveTouchesTarget.setPosition(SocialUtil.getAdjustedY(0),SocialUtil.getAdjustedX(0));
        myMessageListener = new Core.MessageListener();
        dissolveTouchesTarget.getTouchEmitter().addListener(myMessageListener, this.dissolveTouches.bind(this),kTouchSwallower);
        this.addChild(dissolveTouchesTarget);
	},
	
	dissolveTouches: function()
    {
        return true;
    },
	
    getParentNode: function()
    {
        return this;
    },
    
    _setUpCloseButton: function()
    {
    	
        var closeButton = new GLButton(SOCIALAPI_CLOSE_BTN_PATH,SOCIALAPI_CLOSE_BTN_SELECTED_PATH, SocialUtil.adjustHeightWithDevice(30),SocialUtil.adjustWidthWithDevice(30),this.closeClicked.bind(this),this,100);
        closeButton.setPosition(SocialUtil.getAdjustedY(462),SocialUtil.getAdjustedX(20));
    },
    
    _makeButtons: function(){
    	if(!this.isatNeighbour){
	    	var friendsButton = new GLButton(SOCIALAPI_NEIGHBOUR_BTN_PATH,SOCIALAPI_NEIGHBOUR_BTN_SELECTED_PATH, SocialUtil.adjustHeightWithDevice(115),SocialUtil.adjustWidthWithDevice(35),this.showFriendsView.bind(this),this,100,neighbourButtonText);
	    	friendsButton.setPosition(SocialUtil.getAdjustedY(115),SocialUtil.getAdjustedX(45));
	    	friendsButton.setTextFont(SocialUtil.getFont(),SocialUtil.getFontLocation());
	    	this.button1 = friendsButton.getButton();
			this.button1.setImage(SOCIALAPI_NEIGHBOUR_BTN_SELECTED_PATH,[SocialUtil.adjustHeightWithDevice(115),SocialUtil.adjustWidthWithDevice(35)]);
	    	
	    	var messageButton = new GLButton(SOCIALAPI_MESSAGE_BTN_PATH,SOCIALAPI_MESSAGE_BTN_SELECTED_PATH, SocialUtil.adjustHeightWithDevice(115),SocialUtil.adjustWidthWithDevice(35),this.showMessageView.bind(this),this,100,messageButtonText);
	    	messageButton.setPosition(SocialUtil.getAdjustedY(240),SocialUtil.getAdjustedX(45));
	    	messageButton.setTextFont(SocialUtil.getFont(),SocialUtil.getFontLocation());
	    	this.button2 = messageButton.getButton();
			this.button2.setImage(SOCIALAPI_NEIGHBOUR_BTN_SELECTED_PATH,[SocialUtil.adjustHeightWithDevice(115),SocialUtil.adjustWidthWithDevice(35)]);
	    	
	    	var notificationButton = new GLButton(SOCIALAPI_NOTIFICATION_BTN_PATH,SOCIALAPI_NOTIFICATION_BTN_SELECTED_PATH, SocialUtil.adjustHeightWithDevice(115),SocialUtil.adjustWidthWithDevice(35),this.showNotificaitonView.bind(this),this,100,notificationButtonText);
	    	notificationButton.setPosition(SocialUtil.getAdjustedY(365),SocialUtil.getAdjustedX(45));
	    	notificationButton.setTextFont(SocialUtil.getFont(),SocialUtil.getFontLocation());
	    	this.button3 = notificationButton.getButton();
			this.button3.setImage(SOCIALAPI_NEIGHBOUR_BTN_SELECTED_PATH,[SocialUtil.adjustHeightWithDevice(115),SocialUtil.adjustWidthWithDevice(35)]);
    	}
    	else {
	    	var giftsButton = new GLButton(SOCIALAPI_NEIGHBOUR_BTN_PATH,SOCIALAPI_NEIGHBOUR_BTN_SELECTED_PATH, SocialUtil.adjustHeightWithDevice(115),SocialUtil.adjustWidthWithDevice(35),this.showGiftsView.bind(this),this,100,giftsButtonText);
	    	giftsButton.setPosition(SocialUtil.getAdjustedY(170),SocialUtil.getAdjustedX(45));
	    	giftsButton.setTextFont(SocialUtil.getFont(),SocialUtil.getFontLocation());
	    	
	    	var messageButton = new GLButton(SOCIALAPI_MESSAGE_BTN_PATH,SOCIALAPI_MESSAGE_BTN_SELECTED_PATH, SocialUtil.adjustHeightWithDevice(115),SocialUtil.adjustWidthWithDevice(35),this.showReplyMessageView.bind(this,TFGameState.getCurrentUser().getUsername()),this,100,messageButtonText);
	    	messageButton.setPosition(SocialUtil.getAdjustedY(320),SocialUtil.getAdjustedX(45));
	    	messageButton.setTextFont(SocialUtil.getFont(),SocialUtil.getFontLocation());
    	}
    },
    
    addNameLabel: function(){
    	
    	this._nameLabel = GLFactory.getText([SocialUtil.getAdjustedY(140),SocialUtil.getAdjustedX(95)],102,nameLabelText,[SocialUtil.getAdjustedY(100),SocialUtil.getAdjustedX(27)],SocialUtil.getAdjustedFontSize(100));
        this._nameLabel.setColor(1, 1, 1);
        this._nameLabel.setFontLocation(SocialUtil.getFontLocation());
        this._nameLabel.setFontFamily(SocialUtil.getFont());
        this._nameLabel.setHorizontalAlign(GL2.Text.HorizontalAlign.Center);
        this.addChild(this._nameLabel);
        
        var name = GAConfigurations.getUserId();
        this._nameLabelText = GLFactory.getText([SocialUtil.getAdjustedY(240),SocialUtil.getAdjustedX(95)],102,name,[SocialUtil.getAdjustedY(100),SocialUtil.getAdjustedX(27)],SocialUtil.getAdjustedFontSize(100));
	    this._nameLabelText.setColor(1, 1, 1);
        this._nameLabelText.setFontLocation(SocialUtil.getFontLocation());
        this._nameLabelText.setFontFamily(SocialUtil.getFont());
        this._nameLabelText.setHorizontalAlign(GL2.Text.HorizontalAlign.Center);
        this.addChild(this._nameLabelText);
    	
    },
    
    closeClicked: function()
    {
        if(this._isClosing)
        {
            return true;
        }
        this._isClosing = true;
        this.clearCurrentView();					  
    	SocialManager.hideSocialScreen();
    },
	
	showFriendsView:function() {
		
		this.button1.setImage(SOCIALAPI_NEIGHBOUR_BTN_SELECTED_PATH,[SocialUtil.adjustHeightWithDevice(115),SocialUtil.adjustWidthWithDevice(35)]);
		this.button2.setImage(SOCIALAPI_NEIGHBOUR_BTN_PATH,[SocialUtil.adjustHeightWithDevice(115),SocialUtil.adjustWidthWithDevice(35)]);
		this.button3.setImage(SOCIALAPI_NEIGHBOUR_BTN_PATH,[SocialUtil.adjustHeightWithDevice(115),SocialUtil.adjustWidthWithDevice(35)]);
		if(this._friendsView != null && this._currentView == this._friendsView)
			return;
    	this.clearCurrentView();
    	this._friendsView = new SocialFriendsUI();
	this._currentView = this._friendsView;
	this.renderFriendsUI(SocialUtil.getSocialFriends().getAllFriends());
    	//this._friendsView.fetchFriendList();
    	this.addChild(this._friendsView);
    },
    
    showReplyMessageView: function(userName, userType) {
    	this.clearCurrentView();
    	var socialFriends = SocialUtil.getSocialFriends();
		if(socialFriends.isFriendExist(userName)) {
			if(!this.isatNeighbour)
    			this.showNewMessageDialogue(userName, kMessagesUIType.REPLY_FRIEND);
    		else
    			this.showNewMessageDialogue(userName, kMessagesUIType.REPLY_NEIGHBOUR_FRIEND);	
		}
		else {
			if(!this.isatNeighbour)
    			this.showCannedMessageView(userName, kMessagesUIType.REPLY_ANONYMOUS);
    		else
    			this.showCannedMessageView(userName, kMessagesUIType.REPLY_NEIGHBOUR_ANONYMOUS);
		}
    },
    
    showNewMessageDialogue: function(userName, userType) {
    	this.clearCurrentView();
    	this._newMessagesView = new SocialMessagesDialogue(userName, userType);
		this.addChild(this._newMessagesView );
    	this._currentView = this._newMessagesView ;
    },
    
	showMessageView: function(){
		this.button1.setImage(SOCIALAPI_NEIGHBOUR_BTN_PATH,[SocialUtil.adjustHeightWithDevice(115),SocialUtil.adjustWidthWithDevice(35)]);
		this.button2.setImage(SOCIALAPI_NEIGHBOUR_BTN_SELECTED_PATH,[SocialUtil.adjustHeightWithDevice(115),SocialUtil.adjustWidthWithDevice(35)]);
		this.button3.setImage(SOCIALAPI_NEIGHBOUR_BTN_PATH,[SocialUtil.adjustHeightWithDevice(115),SocialUtil.adjustWidthWithDevice(35)]);
		
		if(this._messagesView != null && this._currentView == this._messagesView)
			return;
    	this.clearCurrentView();
		this._messagesView = new SocialMessagesUI();
    	this._currentView = this._messagesView ;
		this._messagesView.fetchMessageList() ;
		//this._cannedMessagesView.showMessagesList();
    	this.addChild(this._messagesView );
	},
	
	showCannedMessageView: function(receiverName, msgType){
		if(this._cannedMessagesView != null && this._currentView == this._cannedMessagesView)
			return;
    	this.clearCurrentView();
		this._cannedMessagesView = new SocialCannedMessagesUI(receiverName, msgType);
    	this._currentView = this._cannedMessagesView;
		this._cannedMessagesView.fetchCannedMessageList() ;
		//this._cannedMessagesView.showMessagesList();
    	this.addChild(this._cannedMessagesView);
	},
	
	showCustomMessageView: function(userName, userType) {
		this.clearCurrentView();
		try {
			var SocialCustomMessagesUI = require('Code/SocialAPI/SocialMessagesUI/SocialCustomMessagesUI').SocialCustomMessagesUI;
	    	this.customMessageUI = new SocialCustomMessagesUI(userName, userType) ;
	    	//this.customMessageUI.setParentMainView(this);
	    	NGWindow.document.addChild(this.customMessageUI);
		} catch(ex) {
			throw ex ;
		}
    	
    	
	},
	
	showNotificaitonView: function(){
		
		this.button1.setImage(SOCIALAPI_NEIGHBOUR_BTN_PATH,[SocialUtil.adjustHeightWithDevice(115),SocialUtil.adjustWidthWithDevice(35)]);
		this.button2.setImage(SOCIALAPI_NEIGHBOUR_BTN_PATH,[SocialUtil.adjustHeightWithDevice(115),SocialUtil.adjustWidthWithDevice(35)]);
		this.button3.setImage(SOCIALAPI_NEIGHBOUR_BTN_SELECTED_PATH,[SocialUtil.adjustHeightWithDevice(115),SocialUtil.adjustWidthWithDevice(35)]);
		
		if(this._notificationView != null && this._currentView == this._notificationView)
			return;
    	this.clearCurrentView();
    	
    	UIFactory.showProgressHUD('fetching required data');
    	SocialManager.handleSocialAction(kSocialTypes.CALLBACK_OVERRIDE,true);
    	SocialManager.handleSocialAction(kSocialTypes.CALLBACK_ENABLE,false);
		//SocialManager.handleSocialAction(kSocialTypes.FRIEND_LIST,null);
    	
		this._notificationView = new SocialNotificationsUI();
    	this._currentView = this._notificationView;
		this._notificationView.fetchNotificationList();
    	this.addChild(this._notificationView);
	},
	
	showGiftsView: function () {
		if(this._socialGiftstUI != null && this._currentView == this._socialGiftstUI)
			return;
		this.clearCurrentView();
		this._socialGiftstUI = new SocialGiftstUI();
		this._currentView = this._socialGiftstUI;
    	this._socialGiftstUI.fetchGiftsList();
    	this.addChild(this._socialGiftstUI);
	},
	
	
	clearCurrentView: function(){
		if(this._currentView) {
			this.removeChild(this._currentView);
			this._currentView.destroy();
			this._currentView = null;
		}
		if(this.customMessageUI){
			NGWindow.document.removeChild(this.customMessageUI);
			this.customMessageUI.destroy() ;
			this.customMessageUI = null ;
		}
		this._friendsView = null;
		this._messagesView = null ;
		this._cannedMessagesView = null;
		this._notificationView = null;
		this._socialGiftstUI = null;
	},
	
	renderFriendsUI: function (data)				//call by Social Manager 
    {	
    	console.log("SocialUI test: SocialUI => renderFriendsUI");
    	if(this._friendsView != null && this._friendsView != 'undefined')
    	{
    		if (this._currentView != this._friendsView)
    			return ;
    		this._friendsView.showFriendList(data);
    	}
    	
    },
    
    renderCannedMessagesUI: function(data){				//call by Social Manager 
    	//console.log("ahsan test: SocialUI => renderCannedMessagesUI");
    	if(this._cannedMessagesView != null) {
    		if (this._currentView != this._cannedMessagesView)
    			return ;
    		this._cannedMessagesView.showMessagesList(data);
    	}
    },
    
    renderMessagesUI: function(data) {
    	if(this._messagesView != null) {
    		if (this._currentView != this._messagesView)
    			return ;
    		this._messagesView.showMessagesList(data);
    	}
    },
    
    renderNotificationsUI: function(data){				//call by Social Manager 
    	console.log("SocialUI => renderNotificationsUI");
    	if(this._notificationView!= null) {
    		if (this._currentView != this._notificationView)
    			return ;
    		this._notificationView.showNotificationsList(data);
    	}
    		
    },
    
    renderGiftsUI: function (data) {
    	console.log("SocialUI => renderGiftsUI");
    	if(this._socialGiftstUI != null) {
    		if (this._currentView != this._socialGiftstUI)
    			return ;
    		this._socialGiftstUI.showGiftsList(data);
    	}
    		
    },
    
    clearNotificationList: function(){
    	this._notificationView.acknowledgeNotifications();
    	if(this._socialGiftstUI != null) {
    		if (this._currentView != this._socialGiftstUI)
    			return ;
    		this._socialGiftstUI.showGiftsList(data);
    	}
    		
    },
    
    
    reloadNotificationUI: function(dataObject){				//call by Social Manager 
    	console.log("SocialUI => reloadNotificationUI");
    	if(this._notificationView != null)
    		this._notificationView.reloadUI(dataObject);
    },
    
    setAreButtonsDisabled: function(value)
    {
        this._areButtonsDisabled = value;
    },
	
    getAreButtonsDisabled: function()
    {
        return this._areButtonsDisabled;
    },	
    destroy: function($super)
    {
    	SocialUtil.destroyNodeChildren(this);
        $super();
    },
	
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/SocialAPI/SocialFriends/SocialFriends'] = function(){var exports = $MODULE_REGISTRY['Code/SocialAPI/SocialFriends/SocialFriends'] || {}; $MODULE_REGISTRY['Code/SocialAPI/SocialFriends/SocialFriends'] = exports; 
exports.SocialFriends = Core.Class.subclass(
{
	classname: 'SocialFriends',

	initialize: function(friendsObj)
	{

		this._friends = new Array();
		
		if(friendsObj)
		{
			this._friendsObj = friendsObj;
        }
		else
		{
			this._friendsObj =
			{
				"classname": "",
				"friends": {}
			};
		}
	},
	
	loadFriends: function () {
		
		var friendsArray = this._friendsObj['friends'];
		var length = 0;
		for(var objectId in friendsArray)
		{
			var socialFriend = new SocialFriend(friendsArray[objectId]);
			this._friends[length] = socialFriend;
			length++;
		}
		//console.log("faizan : 	this._friends:  " + 	this._friends.length);
	},
	
	addSocialFriend: function (socialFriend) {
		this._friendsObj.friends[this._friends.length] =  socialFriend._friendObj;
		this._friends.push(socialFriend);
	},
	
	syncMobageFriendList: function (mobageFriendList) {
		var found = false;
		for (var key in this._friends) {
			var friendObj = this._friends[key];
			if(friendObj.getName() == '-1')
				continue;
			for (var mkey in mobageFriendList) {
				var user = mobageFriendList[mkey];
				if(friendObj.getName() == user.gamertag) {
					found = true;
					break;
				}
			}
			
			if (!found) {
				this.deleteFriendFromJson(friendObj.getName());
				this._friends.splice(key,1);
			}
			found = false;
		}
		for (var key in mobageFriendList) {
			 var user = mobageFriendList[key];
    		 if(!this.isFriendExist(user.gamertag)) {
    			 var socialFriend =  new SocialFriend();
    			 socialFriend.setName(user.gamertag);
    			 this.addSocialFriend(socialFriend);
    		 }
    		 
    		 var socialFriend =  this.getFriendWithName(user.gamertag);
    		 for(var gamekey in user.games) {
				 var game = user.games[gamekey];
				 if(game.name.toLowerCase() == SOCIAL_APP_NAME.toLowerCase() || game.name.toLowerCase() == SOCIAL_APP_NAME_OLD.toLowerCase()) {
					 socialFriend.setIsPlayingCurrentGame(true);
					 break;
				 }
			 }
		}
		this.updateSocialFriends();
	},
	
	deleteFriendFromJson:  function (name) {
		for (var key in this._friendsObj.friends) {
			var friendObj = this._friendsObj.friends[key];
			if (friendObj.name == name) {
				delete this._friendsObj.friends[key];
				break;
			}
		}
	},
	
	getAllFriends: function () {
		return this._friends.slice(1);
	},
	
	clearFriends: function () {
		
		for(var key in this._friends)
		{
			var friendObj = this._friends[key];
			if(friendObj.getName() == '-1') {
				continue;
			}
			delete this._friendsObj.friends[key];
			this._friends.splice(key,1);
		}
		
	},
	
	isFriendExist: function (name) {
		for(var key in this._friends)
		{
			var socialFriend = this._friends[key];
			if(socialFriend.getName() == name) {
				return true;
			}
		}
		return false;
	},
	
	getFriendWithName: function (name) {
		for(var key in this._friends)
		{
			var socialFriend = this._friends[key];
			if(socialFriend.getName() == name) {
				return socialFriend;
			}
		}
	},
	
	updateSocialFriends: function () {
		this._friendsObj.persist();
	},
	
	
	destroy:function() {
		delete this._friendsObj;
		this._friendsObj = null;
	}
	
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/SocialAPI/SocialFriends/SocialFriend'] = function(){var exports = $MODULE_REGISTRY['Code/SocialAPI/SocialFriends/SocialFriend'] || {}; $MODULE_REGISTRY['Code/SocialAPI/SocialFriends/SocialFriend'] = exports; 
exports.SocialFriend = Core.Class.subclass(
{
	classname: 'SocialFriend',

	initialize: function(friendObj)
	{

		if(friendObj)
		{
			this._friendObj = friendObj;
        }
		else
		{
			this._friendObj =
			{
				"name": "",
				"lastFedTime": 0,
				"lastCleanedTime": 0,
				"lastRateTime": 0,
				"lastVisitTime": 0,
				"isPlayingCurrentGame": false
			};
		}
	},
	
	setName: function (name) {
		this._friendObj.name = name;
	},
	
	getName: function () {
		return this._friendObj.name;
	},
	
	setLastFedTime: function (val) {
		this._friendObj.lastFedTime = val;
	},
	
	getLastFedTime: function () {
		return this._friendObj.lastFedTime;
	},
	
	setLastCleanedTime: function (val) {
		this._friendObj.lastCleanedTime = val;
	},
	
	getLastCleanedTime: function () {
		return this._friendObj.lastCleanedTime;
	},
	
	setLastRateTime: function (val) {
		this._friendObj.lastRateTime = val;
	},
	
	getLastRateTime: function () {
		return this._friendObj.lastRateTime;
	},
	
	setLastVisitTime: function (val) {
		this._friendObj.lastVisitTime =  val;
	},
	
	getLastVisitTime: function () {
		return this._friendObj.lastVisitTime;
	},
	
	setIsPlayingCurrentGame: function(val) {
		this._friendObj.isPlayingCurrentGame = val;
	},
	
	isPlayingCurrentGame: function () {
		return this._friendObj.isPlayingCurrentGame;
	},
	
	destroy:function() {
		delete this._friendObj;
		this._friendObj = null;
	}
	
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/SocialAPI/SocialManager'] = function(){var exports = $MODULE_REGISTRY['Code/SocialAPI/SocialManager'] || {}; $MODULE_REGISTRY['Code/SocialAPI/SocialManager'] = exports; /**
 * Author: Hassan Adeel
 */
var SocialUI = require('Code/SocialAPI/SocialUI').SocialUI;

exports.SocialManager = Core.Class.singleton(
{
    classname: 'SocialManager',
    //callBack: null,
    
    initialize: function() 
    {
    	
    	this.socialView = null;
    	this.timerUpdate = setTimeout(this.updateHandlersData.bind(this),UPDATE_TIME);
    	this.isCallBacksEnable = false;
    	this.overrideCallBackEnable = false;
    	this.runningRequests = new Array();
    	this.popUpVisible = false;
    },
    
    showSocialScreen: function(gameLayerNode,currentView,isNeighbour){
    	
    	this.setCallBackEnable(true);
    	this.socialView = new SocialUI(isNeighbour);
    	switch(currentView){
		case kSocialUIType.FRIENDSUI:
			this.socialView.showFriendsView();
			break;
		case kSocialUIType.CANNED_MESSAGESUI:
			this.socialView.showCannedMessageView();
			break;
		case kSocialUIType.NOTIFICATIONSUI:
			this.socialView.showNotificaitonView();
			break;
		case kSocialUIType.GIFTSUI:
			this.socialView.showGiftsView();
			break;
		default:
			this.socialView.showFriendsView();
			break;
    	}
    	
		gameLayerNode.addChild(this.socialView);
    },
    
    hideSocialScreen: function () {
    	this.socialView.destroy();
    	this.socialView = null;
    },
    
    isSocialScreenShowing: function () {
    	
    	if(this.socialView == null || this.socialView == 'undefined')
		{
			return false;
		}
		else
		{
			return true;
		}
		
		return false;
    },
    
    
    handleSocialAction: function(socialType, data){
    	switch(socialType){
    		case kSocialTypes.FRIEND_LIST:
    			this.manageFriendList();
    			break;
    		case kSocialTypes.FRIEND_REQUEST_LIST:
    			this.manageFriendRequestList(data);
    			break;
    		case kSocialTypes.GET_CANNED_MESSAGES:
    			this.getCannedMessages(kSocialTypes.GET_CANNED_MESSAGES);
    			break;
    		case kSocialTypes.RECEIVE_MESSAGES:
    			this.getUserMessages(kSocialTypes.RECEIVE_MESSAGES);
    			break;
    		case kSocialTypes.NOTIFICATIONS:
    			this.manageNotifications();
    			break;
    		case kSocialTypes.ADD_FRIENDS:
    			this.addFriend();
    			break;
    		case kSocialTypes.RANDOM_NEIGHBOUR:
    			this.manageRandomNeighbour();
    			break;
    		case kSocialTypes.VISIT:
    			this.sendVisitRequest();
    			break;
    		case kSocialTypes.INVITE:
    			this.sendInviteRequest(data);
    			break;
    		case kSocialTypes.REMOVE:
    			this.removeFriend();
    			break;
    		case kSocialTypes.RECEIVE_GIFTS:
    			this.receiveUserGifts(kSocialTypes.RECEIVE_GIFTS);
    			break;
    		case kSocialTypes.RECEIVE_GIFTS_COUNT:
    			
    			if(!data)
    			{
    				this.receiveUserGifts(kSocialTypes.RECEIVE_GIFTS_COUNT);
    			}
    			else
    			{
    				this.receiveUserGifts(data);
    			}
    			
    			break;
    		case kSocialTypes.SEND_GIFTS:
    			this.sendGiftsToUser(data);
    			break;
    		case kSocialTypes.VERIFY_GIFT_SENT:
    			//not implemented
    			break;	
    		case kSocialTypes.ACK_GIFT_RCV:
    			this.acknowledgeGiftForUser(data);
    			break;
    		case kSocialTypes.CLEAR_FRIENDS_HANDLER:
    			this.clearFriendsHandler();
    			break;
    		case kSocialTypes.GET_GIFTABLE_ITEMS:
    			this.giftableItems();
    			break;
    		case kSocialTypes.SEND_NEIGHBOR_ACTION:
    			this.manageNeighborActions(data);
    			break;
    		case kSocialTypes.GET_NEIGHBOR_ACTION:
    			this.getNeighborActions();
    			break;
    		case kSocialTypes.SEND_MESSAGES:
    			this.sendMessage(data) ;
    			break ;
    		case kSocialTypes.CALLBACK_ENABLE:
    			this.setCallBackEnable(data);
    			break;
    		case kSocialTypes.CALLBACK_OVERRIDE:
    			this.setOverrideCallBackEnable(data);
    			break;	
    		case kSocialTypes.UPDATE_HANDLERS:
    			this.updateHandlersData();
    			break;
    		case kSocialTypes.CLEAR_NOTIFICATIONS:
    			this.clearNotifications();
    			break;
    		case kSocialTypes.ACK_NOTIFICATIONS:
    			this.acknowledgeNotifications();
    			break;
    		case kSocialTypes.BlOCKED_USERS:
    			this.manageBlockedUsers();
    			break;
    			
    		default:
    		
    	}
    	
    },
    
    setCallBackEnable: function (val) {
    	this.isCallBacksEnable = val;
    },
    
    setOverrideCallBackEnable: function (val) {
    	this.overrideCallBackEnable = val;
    },
    
    getCannedMessages: function(action){
    	SocialMessagesHandler.performMessageAction(action);
    },
    
    showMessageCount: function(msgCount) {
    	GameLayer.showNewMessagesView(msgCount) ;
    },
    
    getUserMessages: function(action){
    	SocialMessagesHandler.performMessageAction(action);   	
    },
    
    sendMessage: function(msg) {
    	SocialMessagesHandler.sendMessage(msg) ;
    },
    
    callBackSocialCannedMessagesList: function(messagesList){
    	this.socialView.renderCannedMessagesUI(messagesList);    	
    },
    
    callBackSocialMessagesList: function(messagesList) {
    	console.log("SocialManager => callBackSocialMessagesList");
    	if(this.socialView != null)
    		this.socialView.renderMessagesUI(messagesList);
    	else
    		GameLayer.showNewMessagesView(messagesList.length);
    },
    
    callBackNotificaitonsList: function (notificationList) {
    	//console.log("faizan notificationList : " + notificationList);
    	//if(this.isCallBacksEnable){
    		this.socialView.renderNotificationsUI(notificationList);
    	//}
    },
    
    manageFriendList: function(){
    	//var index = this.runningRequests.indexOf(UPDATE+kSocialTypes.FRIEND_LIST);
    	//if(index == -1) {
    		SocialFriendsHandler.getMobageFriendsList();
    	//}
    },
    
    manageFriendRequestList: function(callerType){
    	SocialFriendsHandler.getMobageFriendsRequestList(callerType);
    },
    
    manageBlockedUsers: function () {
    	SocialFriendsHandler.getMobageBlockedUserList();
    },
    
    callBackForItem: function(){
    	
    },
    
    callBackDone: function(error, data){
		 if(error){
			  var errorCode = error.errorCode;
		      var errorDesc = error.description;
		      console.log("errorCode " +errorCode+' description' + errorDesc);
		  }
		  else {
			  console.log("callBackDone");
		  }
    },
    
    callBackSocialFriendList: function(friendList){
    	console.log("======callBackSocialFriendList::");
    	var socialFriends = SocialUtil._socialFriends;
    	socialFriends.syncMobageFriendList(friendList);
    	//var index = this.runningRequests.indexOf(UPDATE+kSocialTypes.FRIEND_LIST);
    	//if(index != -1) {
    		//this.runningRequests.splice(index,1);
    	//}
    	
//    	if(this.overrideCallBackEnable==false){
//    		this.socialView.renderFriendsUI(friendList);
//    	}
//    	else
//    	{
//    		if(this.overrideCallBackEnable)
//    		{
//    			UIFactory.hideProgressHUD();
//    		}
//    		this.handleSocialAction(kSocialTypes.CALLBACK_OVERRIDE,false);
//    	}
    },
    
    callBackSocialFriendRequestList: function(friendRequestList,callerType){
    	console.log("======callBackSocialFriendRequestList:: " + callerType);
    	
	    	switch(callerType){
				case kSocialFriendHandlerCallType.GAMELAYER:
				if(friendRequestList!=null && friendRequestList.length>0)
			    	{
			    		GameLayer.getControlLayer().setNotificationLabelText(friendRequestList.length);
			    		GameLayer.showNewFriendRequestView(friendRequestList.length);
			    	}
			    	//else
			    	//	NgLogE("SocialManager: friend request not available!");
					break;
				case kSocialFriendHandlerCallType.SOCIALNOTIFICATIONUI:
					//if(this.isCallBacksEnable){
						var array = new Array();
						if(friendRequestList.length > 0)
							array.push(friendRequestList.length+'');
				    	this.socialView.renderNotificationsUI(array);  
						break;
					//}
				default:			
    	}
	    	
//    	if(friendRequestList!=null && friendRequestList.length>0)
//    	{
//    		GameLayer.getControlLayer().setNotificationLabelText(friendRequestList.length);
//    		GameLayer.showNewFriendRequestView(friendRequestList.length);
//    		
//    		var array = new Array();
//			if(friendRequestList.length > 0)
//				array.push(friendRequestList.length+'');
//			
//			if(this.socialView != null)
//				this.socialView.renderNotificationsUI(array); 
//    	}
    },
    
    callBackBlockUsers: function (blockedUserList) {
    	SocialUtil.setBlockUsers(blockedUserList);
    },
    
    showFriendList: function(){
    	
    },
    
    manageNotifications: function(){
    	
    },
    
    addFriend: function(){
    	
    },
    
    manageRandomNeighbour: function(){
    	
    },
    
    sendVisitRequest: function(){
    	
    },
    
    sendInviteRequest: function(user){
    	SocialFriendsHandler.inviteFriend(user);
    },
    
    removeFriend: function(user){
    	SocialFriendsHandler.removeFriend(user);
    },
    
    clearFriendsHandler: function () {
    	SocialFriendsHandler.clear();
    },
    
    clearNotifications: function () {
    	SocialActionsHandler.clearNeighborActionArray();
    },
    
    acknowledgeNotifications: function () {
    	SocialActionsHandler.acknowledgeNeighborAction();
    },
    
    callBackForAcknowledgeNotification: function(){
    	this.socialView.clearNotificationList();
    },
    callBackForItem: function(friendActionType){
    	
    },
    
    receiveUserGifts : function(_type)
    {
		SocialGiftsHandler.receiveGiftsForUser(_type);    	
    },
    
    sendGiftsToUser: function(storeObject)
    {
    	
    	var senderName = GAConfigurations.getUserId();
    	var receiverName = TFGameState.getCurrentUser().getUsername();// TFGameState.getCurrentUser()._userObj.name;
    	
    	//console.log('aleeem: receiverName' + receiverName);
    	if(receiverName == 0 || receiverName == '')
    	{
    		receiverName=TFGameState._neighborName;
    		//console.log('aleeem: receiverName' + receiverName);
    	}
    	
    	console.log("SocialManager: sendGiftsToUser -> senderName -> "+senderName+ " -> receiverName -> "+receiverName);
//    	NgLogE("SocialManager: sendGiftsToUser -> "+senderName+ " -> receiverName -> "+TFGameState.getCurrentUser()._userObj.name);
		
    	//(senderType, senderName, receiverName, senderGameName, receiverGameName, storeObject, custom)
    	SocialGiftsHandler.sendGiftToAUser('', senderName, receiverName, kGameName, kGameName, storeObject, '');
		
    },
    
    acknowledgeGiftForUser: function(giftObject)
    {	
    	console.log("acknowledgeGiftForUser: -> ack gift ... " + giftObject.getGiftId());
    	//if its a fish then check the limit for this tank before going on with the flow
    	var storeObject =  GAGameLoader.getStoreHandler().getStoreObjectForKey(giftObject.getGiftId());
		var storeObjectType = StoreUtil.getStoreObjectType(storeObject);

		if(storeObjectType == kObjectType.kObjectFish)
		{
			if(!GameLayer.getSelectedTank().canFishBeAdded())
			{
				UIFactory.hideProgressHUD();
				
				var text= GALocalizationHandler.getLocalizedString("TF_MSG_TANK_FULL_GIFT_CLAIM");
//				var color =  new Core.Color(255,0,0);
//				
//				this.SCREEN_HEIGHT = Core.Capabilities.getScreenWidth();
//				this.SCREEN_WIDTH = Core.Capabilities.getScreenHeight();
//				
//				
//				var target = new Core.Vector(this66.SCREEN_WIDTH/2,this.SCREEN_HEIGHT/2);
//				GameLayer.getSelectedTank().textAnimation(target,text,color);

				var userMessAlert = new SocialMiniUIAlertView("",text,this,null,GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
		       	//userMessAlert.setTagValue("");
		        userMessAlert.setMessageColor("FFFFFF");
				userMessAlert.setMessageFont(SocialUtil.getFontName());
				userMessAlert.setButtonsFont(SocialUtil.getFontName());
				userMessAlert.setButtonColor("FFFFFF");
				userMessAlert.show();
				
				return;
			}
		}
    	
    	//otherwise acknowledge this gift and add to the tank (later in the flow)
    	SocialGiftsHandler.acknowledgeUserGift(giftObject);
    },
    
    //Gift Handler callbacks ////////////////////////////////////////////////////////////////////
    receiveGiftsSuccessCallback: function(giftsArray)
    {
    	console.log("Socialmanager-> receiveGiftsSuccessCallback called!");
    	
    	if(giftsArray == null || giftsArray == 'undefined')
    	{
    		giftsArray = [];
    	}
    	
    	if(giftsArray.length >=2)
		{
			//sort
			giftsArray.sort(function(a,b){return b.getSenderTimeStamp() - a.getSenderTimeStamp()});
		}
    	
    	this.socialView.renderNotificationsUI(giftsArray);
    },
    
    receiveGiftsFailureCallback: function(response)
    {
    	//show error
    	console.log("Socialmanager-> receiveGiftsFailureCallback called!");
    	
    	this.socialView.renderNotificationsUI(response);
    },
    
    receiveGiftsCountSuccessCallback: function(giftArray)
    {
    	
    	console.log("Socialmanager-> receiveGiftsCountSuccessCallback called!");
    	if(giftArray!=null && giftArray.length>0)
    	{
    		GameLayer.getControlLayer().setNotificationLabelText(giftArray.length);
    		GameLayer.showNewGiftsMessage(giftArray.length);
    	}   
    },
    
    receiveGiftsCountFailureCallback: function(response)
    {
    	//show error
    	console.log("Socialmanager-> receiveGiftsCountFailureCallback called!");
    },
    
    sendGiftsSuccessCallback:function(storeObject)
    {
    	console.log("Socialmanager-> sendGiftsSuccessCallback called!");
    	UIFactory.hideProgressHUD();
    	
        //now the user can buy this item (Will be done by callback)
        var buyPriceKey = GACommonUtils.getBuyPrice(storeObject)
		var currency = StoreUtil.getCurrency(buyPriceKey)
		var price = StoreUtil.getPrice(buyPriceKey); 
		
//		NgLogE("SocialManager: sendGiftsSuccessCallback -> buyPriceKey-> "+buyPriceKey);
//		NgLogE("SocialManager: sendGiftsSuccessCallback -> currency->"+currency);
//		NgLogE("SocialManager: sendGiftsSuccessCallback -> price->"+price);
		
     	if(currency == TF_COINS)
		{
//			NgLogE("SocialManager: sendGiftsSuccessCallback -> It is coins");
			
			DatabaseHelper.updateCurrency(kOperationType.kOperationSubtractCoins,price);
			DatabaseHelper.updateUser();
//	   		TFGameState.getCurrentUser().updateCurrency(kOperationType.kOperationSubtractCoins,price);
//	   		DatabaseInterface.updateUser();
		}
		else
        {
//        	NgLogE("SocialManager: sendGiftsSuccessCallback -> It is bucks");
        	
        	DatabaseHelper.updateCurrency(kOperationType.kOperationSubtractBucks,price);
			DatabaseHelper.updateUser();
//			TFGameState.getCurrentUser().updateCurrency(kOperationType.kOperationSubtractBucks,price);
//		    DatabaseInterface.updateUser();
		}
		
		GameLayer.showGiftSentAcknowledgement(storeObject.name) ;
    	
    },
    
    sendGiftsFailureCallback:function(storeObject)
    {
    	console.log("Socialmanager-> sendGiftsFailureCallback called!");
    	UIFactory.hideProgressHUD();
    	
    },
    
    noGiftReceiveCallback:function()
    {
    	//show message "you have no gifts etc", remove the ProgressHud and continue
    	//make sure others are also Zero otherwise, don't show this message
    	//as notifications tab contains 3 types of notifications
    	console.log("noGiftReceiveCallback: called");
    	//UIFactory.hideProgressHUD();
    	
    	this.socialView.renderNotificationsUI([]);
    },
    
    noGiftReceiveCountCallback:function()
    {
    	//to do
    	console.log("noGiftReceiveCountCallback: called");
    	
    	GameLayer.getControlLayer().setNoGiftAvailable();
    },
    
    acknowledgeGiftForUserSuccessCallback:function(giftObject)
    {	
    	console.log("acknowledgeGiftForUserSuccessCallback: called");
    	
		//download this item first then add to tank
		UIFactory.hideProgressHUD();
		
		SocialGiftsHandler.downloadAcknowledgedGift();
		
    },
    
    acknowledgeGiftForUserFailureCallback:function(giftObject)
    {
    	//to do
    	console.log("acknowledgeGiftForUserFailureCallback: called");
    	
    	UIFactory.hideProgressHUD();
    	
    },
    
    downloadAcnknowledgedGiftSuccessCallback: function(giftObject)
    {    
    	console.log("downloadAcnknowledgedGiftSuccessCallback: called");
    	
    	UIFactory.hideProgressHUD();
    	
    	UIFactory.showProgressHUD("Placing gift...");
    	
		var tankSelected = GameLayer.getSelectedTank();
		var storeObject = GAGameLoader.getStoreHandler().getStoreObjectForKey(giftObject.getGiftId());
		var storeObjectType = StoreUtil.getStoreObjectType(storeObject);
		var storeID = giftObject.getGiftId();
		
		SocialGiftsHandler.removeGiftObject(giftObject);
		
//		NgLogE("=====>SocialGiftsHandler.getGiftAcknowledged() ->  "+SocialGiftsHandler.getGiftAcknowledged());
		
        SocialGiftsHandler.setGiftAcknowledged(null);
        
//        NgLogE("=====>SocialGiftsHandler.getGiftAcknowledged() ->  "+SocialGiftsHandler.getGiftAcknowledged());

		GameLayer.getControlLayer().decrementNotificationCount(1, true);

		this.socialView.reloadNotificationUI(giftObject);
		
		//add to tank
		if(storeObjectType == kObjectType.kObjectFish)
		{	
			console.log("SocialManager: downloadAcnknowledgedGiftSuccessCallback -> adding gifted Fish in the tank");
			tankSelected.addFish(storeID, false, null,true);
		}
		else if (storeObjectType == kObjectType.kObjectDecoration)
		{	
			console.log("SocialManager: downloadAcnknowledgedGiftSuccessCallback -> adding gifted DecorationItem in the tank");
			tankSelected.addDecoration(storeID, true);
		}
		else if(storeObjectType == kObjectType.kObjectBackground)
		{	
			console.log("SocialManager: downloadAcnknowledgedGiftSuccessCallback -> adding gifted Background in the tank");
			tankSelected.setTankBackground(storeID);
		}
		else if(storeObjectType == kObjectType.kObjectPlant)
		{	
			console.log("SocialManager: downloadAcnknowledgedGiftSuccessCallback -> adding gifted Plant in the tank");
			tankSelected.addPlant(storeID, true);
		}
													 
		else if(storeObjectType == kObjectType.kObjectFoodBrick)
		{
			console.log("SocialManager: downloadAcnknowledgedGiftSuccessCallback -> adding gifted FoodBrick in the tank");
			tankSelected.addFoodBrick(storeID, true);
		}
		
		DatabaseInterface.updateUser();
		DatabaseInterface.updateTank();
		
		UIFactory.hideProgressHUD();
		
		console.log("SocialManager: downloadAcnknowledgedGiftSuccessCallback ended!");
    },
    
    downloadAcnknowledgedGiftFailureCallback: function(giftObject)
    {
    	//to do
		UIFactory.hideProgressHUD();
		
		console.log("downloadAcnknowledgedGiftFailureCallback: called");
		
		//remove this gift from the gifts array that gifthandler has
		SocialGiftsHandler.removeGiftObject(giftObject);
		
		// this is one of 2 places where its reference will be lost, otherwise, keep this for failure cases
        SocialGiftsHandler.setGiftAcknowledged(null);
		
		//decrement the notification count shown at the bottom left corner
		GameLayer.getControlLayer().decrementNotificationCount(1, true);
		
		//remove the claimed gift from the list
		this.socialView.reloadNotificationUI(giftObject);
    },
    //Gift Handler callbacks ////////////////////////////////////////////////////////////////////
    
    giftableItems: function () {
    	this.socialView.renderGiftsUI(SocialUtil.getGiftableItems());  
    },
    
    manageNeighborActions: function(actionType)
    {
    	var currentTime = TFGameState.getServerTime();
    	
    	switch(actionType)
		{
			case kSocialFriendActionType.CLEAN_TANK : //send gift
				console.log("socialmanager-> managNeighborrActions CLEAN_TANK!");
//				var currentTime = Math.round((new Date()).getTime() / 1000);
				SocialActionsHandler.neighborTankActions(currentTime,null,null,null);
				//parse and call the appropriate callback
				break;
			case kSocialFriendActionType.FEED_FISH: // verify gift sent
				console.log("socialmanager-> manageNeighborActions FEED_FISH!");
				SocialActionsHandler.neighborTankActions(null,currentTime,null,null);
				//parse and call the appropriate callback
				break;
			case kSocialFriendActionType.GIFT: // verify gift sent
				console.log("socialmanager-> manageNeighborActions GIFT!");
				SocialActionsHandler.neighborTankActions(null,null,currentTime,null);
				//SocialActionsHandler.neighborTankActions(null,null,currentTime);
				//SocialActionsHandler.generateGiftNotification(currentTime);
				//parse and call the appropriate callback
				break;

			case kSocialFriendActionType.REVIVE_FISHES: // verify gift sent
				SocialActionsHandler.neighborTankActions(null,null,null, currentTime);
				//parse and call the appropriate callback
				break;

			default:
								
		};
    	//NgLogE("ahsan:-> socialmanager-> manageNeighborActions called!");
    },
    
    neighborActionWebFetchCallBack: function(_neighborActionArray){
    	
    	SocialActionsHandler.neighborActionWebFetchCallBack(_neighborActionArray);
    },
    
    getNeighborActions: function()
    {
    	SocialActionsHandler.getActionsPerformed();
    },
    
    showFailurePromptWithMessage: function(message) {
		UIFactory.hideProgressHUD();
//		if(this.overrideCallBackEnable){ 
//			this.overrideCallBackEnable = false;
//			return;
//		}
//		if(!this.isCallBacksEnable) {
//			this.isCallBackEnable = true;
//			return;
//		}
	    if(!this.popUpVisible)
	    {
	    	this.popUpVisible = true;
		    var alertWindow = new SocialMiniUIAlertView("",message,this,null,GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
		    alertWindow.setTagValue(0002);
		    alertWindow.setMessageColor("FFFFFF");
		    alertWindow.setMessageFont(SocialUtil.getFontName());
		    alertWindow.setButtonsFont(SocialUtil.getFontName());
		    alertWindow.setButtonColor("FFFFFF");
		    alertWindow.show() ;
	    }
	},
    
    updateHandlersData: function () {
    	if(this.timerUpdate) {
    		clearTimeout(this.timerUpdate);
    		this.timerUpdate = null;
    	}
    	if(this.runningRequests) {
    		delete this.runningRequests;
    	}
    	this.runningRequests = new Array();
    	this.setCallBackEnable(false);
    	
    	GameLayer.getControlLayer().disableNotificationButton();
    	
    	this.handleSocialAction(kSocialTypes.CLEAR_FRIENDS_HANDLER, null);
    	this.handleSocialAction(kSocialTypes.CLEAR_NOTIFICATIONS, null);
    	
    	
    	this.handleSocialAction(kSocialTypes.BlOCKED_USERS,null);    	
    	this.handleSocialAction(kSocialTypes.RECEIVE_GIFTS_COUNT,kSocialTypes.UPDATE);
    	this.handleSocialAction(kSocialTypes.FRIEND_REQUEST_LIST, kSocialFriendHandlerCallType.GAMELAYER);
    	this.handleSocialAction(kSocialTypes.GET_NEIGHBOR_ACTION,null);
    	SocialMessagesHandler.performMessageAction(kSocialTypes.RECEIVE_MESSAGES) ;
    	
    	this.timerUpdate = setTimeout(this.updateHandlersData.bind(this),UPDATE_TIME);
    	
    },
    
    clickedButtonAtIndex: function(buttonIndex,alert)
	{
		this.popUpVisible = false;
	}
    
    ///////////////////////////////////////////////////
});

; return exports;};
$MODULE_FACTORY_REGISTRY['Code/SocialAPI/SocialList/SocialUITableViewCell'] = function(){var exports = $MODULE_REGISTRY['Code/SocialAPI/SocialList/SocialUITableViewCell'] || {}; $MODULE_REGISTRY['Code/SocialAPI/SocialList/SocialUITableViewCell'] = exports; exports.SocialUITableViewCell = UI.ListViewItem.subclass({
    
    classname: "SocialUITableViewCell",
    
    initialize: function($super,reuseId,cellModel) {
    	$super(reuseId);
    	this._ParentTableView = null;
    	this._cellView = null;
    	this._indexPath_Row = 0;
    	this._height = 40;
        this._cellModel = cellModel;
    },
    
    _onCreateView: function() {
		var width = 0 , height = 0;
													  
        width = GACommonUtils.getScreenWidth();
        height = GACommonUtils.getScreenHeight();
        
		this._cellView = new SocialCustomCellView();

        ///Adding whole cell's size button
        this._cellView._BigButton = new UI.Button();
        this._cellView._BigButton.setTextGravity(UI.ViewGeometry.Gravity.Left);
        this._cellView._BigButton.setFrame([SocialUtil.getAdjustedY(0),SocialUtil.getAdjustedX(0),SocialUtil.getAdjustedY(380-5),SocialUtil.getAdjustedX(this._height)]);
        this._cellView._BigButton.setImage(SOCIALAPI_LIST_BG_PATH,[SocialUtil.getAdjustedY(380-20),SocialUtil.getAdjustedX(this._height)]);
        this._cellView._BigButton.setImageFit(UI.ViewGeometry.FitModes.Stretch);
		this._cellView.addChild(this._cellView._BigButton); 
		
        return this._cellView;
    },
    
    _onSetView: function(cellView) 
    {
        this._cellView = cellView;
    },
    
    _setHeight: function(height){
    	this._height = height;
    },
    
	didSelectRow: function() {

	},
    
    disableBigButton:function(cellView)
    {
    	cellView._BigButton.setEnabled(false);
    },
    
    _setParentTableView: function(reference)     
    {
        this._ParentTableView = reference;
    },
    
	_setIndexPath_Row: function(value)	
    {
        this._indexPath_Row = value;
    },
	
	_getParentTableView: function()		
    {
        return this._ParentTableView;
    },
    
    _getIndexPath_Row: function()		
    {
        return this._indexPath_Row;
    },

    destroy: function() {
    	if(this._cellView){
    		this._cellView.destroy();
    		this._cellView = null;
    	}
    	
    },
    
    
});

; return exports;};
$MODULE_FACTORY_REGISTRY['Code/SocialAPI/SocialFriendsUI/SocialUILevelTwoCell'] = function(){var exports = $MODULE_REGISTRY['Code/SocialAPI/SocialFriendsUI/SocialUILevelTwoCell'] || {}; $MODULE_REGISTRY['Code/SocialAPI/SocialFriendsUI/SocialUILevelTwoCell'] = exports; exports.SocialUILevelTwoCell = SocialUITableViewCell.subclass({
    
    classname: "SocialUILevelTwoCell",
	
    initialize: function($super,reuseId,cellModel) {
        $super(reuseId,cellModel);
        this._cellModel = cellModel;  // User object
        this.cellView = null;
    },
    _onCreateView: function($super) 
    {
    	this.cellView = $super();
    	
    	this.cellView.visitButton = new UI.Button();
        this.cellView.visitButton.setTextGravity(UI.ViewGeometry.Gravity.Center);
        this.cellView.visitButton.setFrame([SocialUtil.getAdjustedY(275),SocialUtil.getAdjustedX(10),SocialUtil.getAdjustedY(55),SocialUtil.getAdjustedX(25)]);
        this.cellView.visitButton.setImage(SOCIALAPI_VISIT_BTN_PATH,UI.State.Normal);
        this.cellView.visitButton.setImage(SOCIALAPI_VISIT_BTN_SELECTED_PATH,UI.State.Pressed);
        this.cellView.visitButton.setImageFit(UI.ViewGeometry.FitModes.Stretch);
		this.cellView.visitButton.setTextColor('FFFFFF');
		this.cellView.addChild(this.cellView.visitButton);
		
		this.cellView._boxIcon = new UI.Image();
		this.cellView._boxIcon.setFrame([SocialUtil.getAdjustedY(7),SocialUtil.getAdjustedX(3),SocialUtil.getAdjustedY(36),SocialUtil.getAdjustedX(36)]);
		this.cellView._boxIcon.setImage(SOCIALAPI_ICON_BG_PATH,UI.State.Normal);
		this.cellView.addChild(this.cellView._boxIcon);
		
		this.cellView._boxIconImage = new UI.Image();
		this.cellView._boxIconImage.setFrame([SocialUtil.getAdjustedY(11),SocialUtil.getAdjustedX(8),SocialUtil.getAdjustedY(27),SocialUtil.getAdjustedX(27)]);
		this.cellView._boxIconImage.setImage(SOCIALAPI_ICON_PATH,UI.State.Normal);
		this.cellView.addChild(this.cellView._boxIconImage);
		
		this.cellView._nameLabel = new UI.Label();
		this.cellView._nameLabel.setFrame([SocialUtil.getAdjustedY(45),SocialUtil.getAdjustedX(8),SocialUtil.adjustHeightWithDevice(150),SocialUtil.adjustWidthWithDevice(27)]);
		this.cellView._nameLabel.setTextColor('FFFFFF'); 
		this.cellView._nameLabel.setTextGravity(UI.ViewGeometry.Gravity.Center);
		this.cellView._nameLabel.setTextFont(SocialUtil.getFontName());
		this.cellView.addChild(this.cellView._nameLabel);
    
		
		
        return this.cellView;
    },
    
    _onSetView: function($super,cellView) 
    {
		$super(cellView);
		if(!this._cellModel)
			return;
		
		if(this._cellModel.isPlayingCurrentGame()) {
			cellView.visitButton.setText('Visit');
			cellView.visitButton.setOnClick(this.visitButtonAction.bind(this,this._cellModel));
		}
		else {
			cellView.visitButton.setText('Invite');
			cellView.visitButton.setOnClick(this.inviteButtonAction.bind(this,this._cellModel));
		}
		cellView._nameLabel.setText(this._cellModel.getName());
		//cellView.removeButton.setOnClick(this.removeButtonAction.bind(this,this._cellModel));
		this.cellView = cellView;
			
    },
    
    visitButtonAction: function(user){
    	var visitNeighbor = new VisitNeighbor();
    	visitNeighbor.goToFriend(user.getName());
    	SocialManager.hideSocialScreen();
    },
    
    inviteButtonAction : function (user) {
    	SocialManager.handleSocialAction(kSocialTypes.INVITE,user);
    },
    
    removeButtonAction: function(user){
    	SocialManager.removeFriend(user.getName());
    },
    
    isPlayingCurrentGame: function () {
    	for(var key in this._cellModel.games) {
    		var game = this._cellModel.games[key];    		
    		//console.log("user name : "+this._cellModel.gamertag +" Game name : " + game.name);
    		if(game.name.toLowerCase() == SOCIAL_APP_NAME.toLowerCase() || game.name.toLowerCase() == SOCIAL_APP_NAME_OLD.toLowerCase()) {
       			return true;
    		}
    		
    	}
    	return false;
    },

	getButtonsState: function()
	{
		return this._enableButton;
	},
		
	
	setEnableButtons: function(value)
	{
		this._enableButton = value;
	},


    //********************Setters-Getters********************//
    
    _setIndexPath_Row:function($super,value)
    {
        $super(value);
    },
	
    _getIndexPath_Row: function($super)
    {
        return $super();
    },
    
    _setParentTableView: function($super,value)
    {
        $super(value);
    },
    
		_getParentTableView: function($super)			
    {
        return $super();
    },
    

    destroy: function($super) 
	{
		$super();
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/SocialAPI/SocialList/SocialUIGenericTableView'] = function(){var exports = $MODULE_REGISTRY['Code/SocialAPI/SocialList/SocialUIGenericTableView'] || {}; $MODULE_REGISTRY['Code/SocialAPI/SocialList/SocialUIGenericTableView'] = exports; 
var SocialGiftsCell = require('Code/SocialAPI/SocialGiftsUI/SocialGiftsCell').SocialGiftsCell;
var SocialMoreCell = require('Code/SocialAPI/SocialList/SocialMoreCell').SocialMoreCell;

exports.SocialUIGenericTableView = UI.ListView.subclass(
{
    className: "SocialUIGenericTableView",
        
    initialize: function($super,frameHeight,frameX,data) 
    {
    	$super();
        this.sections = null;
        this.storeItems = null;
        this._ParentMainView = null;
        this.listSection  = null;
        this.dataList = data;
        if(!frameHeight)
    	{
    		frameHeight = 135;
    		frameX = 123;
    	}
        this._totalPages =  Math.ceil(this.dataList.length/MAXCELL);
        this._currentPage = 0;
        this._storeType = kSocialUIType.FRIENDSUI;
        this._rowHeight = 45;
        this.setFrame([SocialUtil.getAdjustedY(50),SocialUtil.getAdjustedX(frameX),SocialUtil.getAdjustedY(480-90),SocialUtil.getAdjustedX(frameHeight)]);
        this.setOnLoad(this.loadView.bind(this));
        
    },
    
    loadView: function() {
    	this.cellRowDelegates();
    	
    },
    
    setStoreType:function(type)
    {
    	this._storeType = type;
    },
    
    _setHeight: function(height){
    	this._rowHeight = height;
    },
	

	setParentMainView:function(reference)     
	{
		this._ParentMainView = reference;
	},
    setSections: function($super, sections)
    {
        $super(sections);
    },
 
    cellForRowAtIndexPath:function(indexPath_Row)
    {
    	return this.createCellForMainStoreTable(indexPath_Row);
    },
    
	createCellForMainStoreTable: function(indexPath_Row)
	{
		var dataObject = this.dataList[indexPath_Row];
		if(this._storeType == kSocialUIType.FRIENDSUI)
		{
			
			//console.log("faizan user " + dataObject.getName());
			var cellView = new SocialUILevelTwoCell('Friend',dataObject);
			cellView.setHeight(this._rowHeight-5);
			cellView._setParentTableView(this);
			cellView._setIndexPath_Row(indexPath_Row);
			return cellView;
		}
		
		else if(this._storeType == kSocialUIType.CANNED_MESSAGESUI)
		{
			var cellView = new SocialMessages('Message',dataObject);
			cellView.setHeight(this._rowHeight-10);
			cellView._setParentTableView(this);
			cellView._setIndexPath_Row(indexPath_Row);
			return cellView;
		}
		else if(this._storeType == kSocialUIType.MESSAGESUI)
		{
			var cellView = new SocialMessagesUICell(dataObject);
			cellView.setHeight(this._rowHeight-10);
			cellView._setParentTableView(this);
			cellView._setIndexPath_Row(indexPath_Row);
			return cellView;
		}
		
		else if(this._storeType == kSocialUIType.NOTIFICATIONSUI)
		{
			var cellView = null;
			if(typeof dataObject == 'string') {
				var cellView1 = new SocialNotificationFriendsCell('NotificationFriend',dataObject);
				cellView1.setHeight(this._rowHeight-5);
				cellView1._setParentTableView(this);
				cellView1._setIndexPath_Row(indexPath_Row);
				cellView = cellView1;
			}
			
			else if(typeof(dataObject) =='object' && dataObject.classname == 'GiftModel')
			{
								
				var cellView1 = new SocialGiftsCell('NotificationGift',dataObject);
				cellView1.setHeight(this._rowHeight-5);
				cellView1._setParentTableView(this);
				cellView1._setIndexPath_Row(indexPath_Row);
				cellView = cellView1;
			}
			
			else if(typeof(dataObject) =='object' && dataObject.classname == 'ActionsModel')
			{
				var cellView1 = new SocialNotificationsCell('Notification',dataObject);
				cellView1.setHeight(this._rowHeight-5);
				cellView1._setParentTableView(this);
				cellView1._setIndexPath_Row(indexPath_Row);
				cellView = cellView1;
			}
			
			return cellView;
		}
		
		else if(this._storeType == kSocialUIType.GIFTSUI)
		{
			var cellView = new SocialNeighbourGiftCell('GIFT',dataObject);
			cellView.setHeight(this._rowHeight);
			cellView._setParentTableView(this);
			cellView._setIndexPath_Row(indexPath_Row);
			return cellView;
		}
		

	},
	
    cellRowDelegates:function()
    {
     	var startIndex = this._currentPage*MAXCELL;
     	
		//var noOfCells = this.dataList.length;  
	   	this.clearStoreItems();
	   	this.setScrollPosition([0,0]);
	   	if(this.listSection) {
	   		this.listSection.flush();
	   		this.listSection = null;
	   	}
	   	
	   	if(this._storeType == kSocialUIType.GIFTSUI) {
	   		this._rowHeight = 70;
	   	}
	   	
	   	this.listSection = new UI.ListViewSection({
			'rowHeight': SocialUtil.getAdjustedX(this._rowHeight),
		});
	    
        for (var temp = startIndex ; temp < MAXCELL*(this._currentPage+1); temp++)
		{ 	
//        	console.log("faizan temp : " + temp);
        	if(temp >= this.dataList.length)
        		break;
        	
			cell = this.createCellForMainStoreTable(temp);	
        	this.storeItems.push(cell);
        }
        if(this._totalPages > 1) {
	        var cellView = new SocialMoreCell('MORE','more');
			cellView.setHeight(45);
			cellView._setParentTableView(this);
			cellView._setIndexPath_Row(-1);
			cellView.setCurrentPage(this._currentPage);
			cellView.setTotalPages(this._totalPages);
			this.storeItems.push(cellView);
			
        }
        
        
        this.listSection.setItems(this.storeItems);
        this.setSections([this.listSection]);
    },
    
    clearStoreItems: function () {
    	if(this.storeItems) {
    		for (var temp = 0;temp < this.storeItems.length; temp++)
			{
        		cell = this.storeItems[temp];
        		cell.destroy();
        		cell = null;
			}
    	}
    	delete this.storeItems;
		this.storeItems = null;
        this.storeItems = [];
    },
    
    loadNextPage: function () {
    	this._currentPage++;
    	this.cellRowDelegates();
    	
    },
    
    loadPrevPage: function () {
    	this._currentPage--;
    	this.cellRowDelegates();
    	
    },
    
    unSelectSelectedMessage: function() {
    	for(var i = 0; i< this.storeItems.length; i++)
    		if(this.storeItems[i].isSelected)
    			this.storeItems[i].unselectMessage() ;
    },
    
    getSelectedMsg: function() {
    	if(this.storeItems) {
    		for(var i = 0; i< this.storeItems.length; i++)
    			if(this.storeItems[i].isSelected)
    				return this.storeItems[i]._cellModel ;
    	}
    },
    
     refreshData: function(dataObject)
    {
    	
    	if(this.dataList == null || this.dataList == 'undefined' || dataObject == null  ||  dataObject == 'undefined')
    	{
    		return;
    	}
    	
//    	console.log("SocialUIGenericTableView refreshData -> this.dataList.length -> " +this.dataList.length);
//    	console.log("SocialUIGenericTableView refreshData ... removing giftObject...");
    	
    	//refresh the table cells, after removing this dataObject, as this should not be visible now
    	for(var i=0;i<this.dataList.length;i++)
		{
			//i.e, if GiftObject, as after claiming a gift it should be removed from the list
			if((typeof(this.dataList[i]) =='object' && this.dataList[i].classname == 'GiftModel')
			  && (typeof(dataObject) =='object' && dataObject.classname == 'GiftModel'))
			{	
				if(this.dataList[i].getObjId()==dataObject.getObjId())
				{
					this.dataList.splice(i,1);
					dataObject = null;
					break;
				} 
			}
		}
		
//		console.log("SocialUIGenericTableView refreshData ... After removing giftObject...");
//		console.log("SocialUIGenericTableView refreshData -> this.dataList.length -> " +this.dataList.length);
    	
    	this.cellRowDelegates();
		    	
    },
    
    clearOnlyNotifications: function(){
    	if(this.dataList == null || this.dataList == 'undefined')
    	{
    		return;
    	}
    	for(var i=0;i<this.dataList.length;i++){
    		if(this.dataList[i].classname == 'ActionsModel'){
    			this.dataList.splice(i,1);
    			--i;
    		}
    	}
    	this._totalPages =  Math.ceil(this.dataList.length/MAXCELL);
    	this._currentPage = 0;
    	this.cellRowDelegates();
    },
    
    isListEmpty: function () {
    	if(this.dataList.length == 0)
    		return true;
    	return false;
    },
        
    destroy: function($super)
    {
    	this.clearStoreItems();
    	if(this.listSection)
    	{
    		this.listSection.flush();
    		this.listSection = null;
    	}    	
    	$super();
    }
    
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/SocialAPI/SocialUtil/SocialUtil'] = function(){var exports = $MODULE_REGISTRY['Code/SocialAPI/SocialUtil/SocialUtil'] || {}; $MODULE_REGISTRY['Code/SocialAPI/SocialUtil/SocialUtil'] = exports; exports.SocialUtil = Core.Class.singleton(
{
	classname:'SocialUtil',	// static class
  
	initialize: function()
	{
		this.giftableItems = null;
		this.visitingNeighbor = false;
		this._socialFriends = null;					//SocialFriends type obj
		this._socialBlockUsers = null;				// User type obj
	},
	
	$getAdjustedWidth: function(w) 
	{
		
		var width = Core.Capabilities.getScreenWidth();
		
		return (w / aspectRatioFactor.x) * width;
	},
	
	$getAdjustedHeight: function(h) {
		var height = Core.Capabilities.getScreenHeight();
		return (h / aspectRatioFactor.y) * height;
	},
	
	$getAdjustedX: function(x) {
		
		var width = 0 , newWidth = 0 ;
		width = Core.Capabilities.getScreenWidth();
		newWidth = (width / 320) * x;
		
		return newWidth;
		
	},
	$getBasePathForResourceType:function(storeId, resourceType) 
	{
		var storeObject = this.getStoreObject(storeId);
		var resource = GAResourceUtils.getResourceOfType(storeObject, resourceType);
		var basePath = GAResourceUtils.getResourceSavePath(storeObject, resource);
		return basePath;
	},  
	
    $getStoreObject : function(storeId)
    {
		var storeObject = GAGameLoader.getStoreHandler().getStoreObjectForKey(storeId);
		return storeObject;
    },	
	$getAdjustedY: function(y) 
	{
		var height = 0 , newHeight = 0;
		height = Core.Capabilities.getScreenHeight();
		newHeight = (height / 480) * y;
		
		return newHeight;
	},
    
	$getAdjustedFontSize: function(fieldHeight) {
        return this.getAdjustedY(fieldHeight / 2) / 3.67;
    },
    
    $setTextFont: function(obj) {
    	//obj.setTextFont(this.getFontName());
    },
    
    $getFont: function() {
        return './Content/Font/MarkerFeltThin-Plain.ttf';
    },
    
    $getFontName: function() {
        return 'MarkerFeltThin-Plain';
    },
    
    $getFontLocation: function() {
        return GL2.Text.FontLocation.Manifest;
    },
															
	$adjustHeightWithDevice: function(aHeight)
	{
		var h = 0 , calHeight = 0;
												
		h = Core.Capabilities.getScreenHeight();
														
		calHeight = aHeight * (h/480);
		return calHeight;		
														
	},
	
	$getAspectMaintainSize: function(currentSize,newSize) {
		var width = currentSize.getWidth();
		var height = currentSize.getHeight();
		if(width > height) {
			var ratio = width/height;
			width = newSize.getWidth();
			height = width/ratio;
		}
		else {
			var ratio = height/width;
			height = newSize.getHeight();
			width = height/ratio;
		}
		currentSize.setWidth(width);
		currentSize.setHeight(height);
		delete newSize;
		return currentSize;
	},
	
	isVisitingNeighbor: function(){
		return this.visitingNeighbor;
	},
	
	setVisitingNeighbor: function(visitingNeighbor){
		this.visitingNeighbor = visitingNeighbor;
	},
	
	setBlockUsers: function (list) {
		this._socialBlockUsers = list;
	},
	
	getBlockUsers: function () {
		return this._socialBlockUsers;
	},
	
	getSocialFriends: function () {
		return this._socialFriends;
	},
	
	isUserBlocked: function (name) {
		for (var key in this._socialBlockUsers) {
			var user = this._socialBlockUsers[key];
			if(user.gamertag == name)
				return true;
		}
		return false;
	},
	
	populateGiftableKeysDictionary : function()
	{
	
	// get all visible Ids
	// get all categories
	// for each item
	// check if the custom attribute has the giftable property
	// populate the giftableitem array
	// this array would then be used in social feature	
	
	var connectResponseObject = GAGameLoader.getResponseObject();
    var array = connectResponseObject.getStoreVisibleIds();
	
	var _storeId = null;
	var category = null;
	var tempArray = null;
	var itemModel = null;
	
	for(var i = 0; i< array.length ; i++)
	{
		_storeId = array[i];
		var _allCategories = GAGameLoader.getStoreHandler().getAllCategories(""+_storeId, true);
		if(_allCategories == null || _allCategories == 'undefined')
		{
			continue;
		}
		
		for(var j = 0; j<_allCategories.length; j++)	
		{
			category = _allCategories[j];
			tempArray = GAGameLoader.getStoreHandler().getAllItems(category.parent.visible_id, category.visible_id, true);
			
			if(tempArray == null || tempArray == 'undefined')
    		{
    			continue;
    		}
    		else
    		{

				//check if giftable, if yes then populate otherwise, continue
    			 for (var k = 0; k < tempArray.length; k++)
    			 { 	
    				 itemModel = tempArray[k];
    				 
    				 if(itemModel == null || itemModel == 'undefined' || !isValidObject(itemModel.custom_attributes))
			    	 {
			    		continue;
			    	 }
			    	 //NgLogE("TFUtil: itemModel.custom_attributes.is_giftable ->"+itemModel.custom_attributes.is_giftable);
    				 
    				 if(itemModel.custom_attributes.is_giftable !=null
    				  && itemModel.custom_attributes.is_giftable != 'undefined'
    				  && itemModel.custom_attributes.is_giftable == true)
    				 {
    				 	 //NgLogE("TFUtil: pushing giftable item");
    					 //push to array
    					 this.giftableItems.push(itemModel);
    				 }
    		     }
    		}
		}	
	}
	
	_storeId = null;
	category = null;
	tempArray = null;
	itemModel = null;
	
	},
	
	getParsedTimeStamp: function (timeStamp) {
		
		var currentTimeStamp = TFGameState.getServerTime();   //Current Time
		//console.log("faizan : currentTimeStamp " + currentTimeStamp);
		//console.log("faizan : timeStamp " + timeStamp);
		var elapsedTime = currentTimeStamp-timeStamp;
		//console.log("faizan : elapsedTime " + elapsedTime);
		var secondInMillis = 1;
		var minuteInMillis = secondInMillis * 60;
		var hourInMillis = minuteInMillis * 60;
		var dayInMillis = hourInMillis * 24;
		var yearInMillis = dayInMillis * 365;

		var elapsedYears = (elapsedTime / yearInMillis);
		elapsedTime = elapsedTime % yearInMillis;
		var elapsedDays = (elapsedTime / dayInMillis);
		elapsedTime = elapsedTime % dayInMillis;
		var elapsedHours = (elapsedTime / hourInMillis);
		elapsedTime = elapsedTime % hourInMillis;
		var elapsedMinutes = (elapsedTime / minuteInMillis);
		elapsedTime = elapsedTime % minuteInMillis;
		var elapsedSeconds = (elapsedTime / secondInMillis);
		var elapsedMonths = (Math.floor(elapsedDays/30.0));
		
//		console.log("faizan : elapsedYears " + elapsedYears);
//		console.log("faizan : elapsedDays " + elapsedDays);
//		console.log("faizan : elapsedHours " + elapsedHours);
//		console.log("faizan : elapsedMinutes " + elapsedMinutes);
//		console.log("faizan : elapsedSeconds " + elapsedSeconds);
//		console.log("faizan : elapsedMonths " + elapsedMonths);
		
		var ago = "ago";
		
		if(elapsedYears >= 1)
			return parseInt(elapsedYears) + " year(s) " + ago;
		if(elapsedMonths >= 1)
			return parseInt(elapsedMonths) + " month(s) " + ago;
		if(elapsedDays >= 1)
			return parseInt(elapsedDays) + " day(s) " + ago;
		if(elapsedHours >= 1)
			return parseInt(elapsedHours) + " hour(s) " + ago;
		if(elapsedMinutes >= 1)
			return parseInt(elapsedMinutes) + " minute(s) " + ago;
		if(elapsedSeconds > 0)
			return parseInt(elapsedSeconds) + " second(s) " + ago;
		 return "few seconds " + ago;
	},
	
	getParsedVisitTime: function (timeStamp) {	
		var currentTimeStamp = TFGameState.getServerTime();   //Current Time
		var elapsedTime = currentTimeStamp-timeStamp;
		
		elapsedTime = WEEK_DAYS - elapsedTime;
		
		if (elapsedTime <= 0)
			return '-1';
		
		var secondInMillis = 1;
		var minuteInMillis = secondInMillis * 60;
		var hourInMillis = minuteInMillis * 60;
		var dayInMillis = hourInMillis * 24;
		var yearInMillis = dayInMillis * 365;

		var elapsedYears = parseInt(elapsedTime / yearInMillis);
		elapsedTime = elapsedTime % yearInMillis;
		var elapsedDays = parseInt(elapsedTime / dayInMillis);
		elapsedTime = elapsedTime % dayInMillis;
		var elapsedHours = parseInt(elapsedTime / hourInMillis);
		elapsedTime = elapsedTime % hourInMillis;
		var elapsedMinutes = parseInt(elapsedTime / minuteInMillis);
		elapsedTime = elapsedTime % minuteInMillis;
		var elapsedSeconds = parseInt(elapsedTime / secondInMillis);
		
		var mess = '';
		var count = 0;
		if (elapsedDays > 0 && count < 2) {
			mess = mess + elapsedDays + ' day(s) ';
			count++;
		}
		
		if(elapsedHours > 0 && count < 2) {
			mess = mess + elapsedHours + ' hour(s) ';
			count++;
		}
		
		if(elapsedMinutes > 0 && count < 2) {
			mess = mess + elapsedMinutes + ' minute(s) ';
			count++;
		}
		
		if(elapsedSeconds > 0 && count < 2) {
			mess = mess + elapsedSeconds + ' second(s) ';
			count++;
		}
		
		
		return mess;
		
		//console.log('faizan mess ' + mess);
		
//		//if(elapsedTime >= WEEK_DAYS) {
//			console.log('faizan elapsedTime' + elapsedTime);
//			console.log('faizan elapsedDays' + elapsedDays);
//			console.log('faizan elapsedHours' + elapsedHours);
//			console.log('faizan elapsedMinutes' + elapsedMinutes);
//			console.log('faizan elapsedSeconds' + elapsedSeconds);
//		//}
//			
	},
	
	getGiftableItems: function () {
		if(this.giftableItems == null) {
			this.giftableItems = new Array();;
			this.populateGiftableKeysDictionary();
		}
		return this.giftableItems;
	},
	
	$adjustWidthWithDevice: function(aWidth)
	{
		var w = 0, calWidth = 0;
		
		w = Core.Capabilities.getScreenWidth();
		
		calWidth = aWidth * (w/320);
		return calWidth;			
	},
	
	getCloseButtonPath: function(){
		
		//var path = 
	},
	
	
	
	getSocialActionURL: function(action){
		
		var responseObject = GAGameLoader.getResponseObject();
		var notificationServerURL = responseObject.getNotificationServer();
		
		//console.log("sarmad: TESTING notification server url " + notificationServerURL);
		//notificationServerURL = "http://devsocialnotifications.appspot.com/";//hardcoding for timebeing.
		
		var url = [];
		
		switch(action){
			
			case kSocialTypes.RECEIVE_GIFTS: //receive user gifts
			
				url.push(notificationServerURL+"");
				url.push("userGift?ruserid=");//+"355921042844124"
				url.push(GAConfigurations.getUserId());
				//url.push(GAConfigurations.getUdid());
				url.push("&rusername=");
				url.push(GAConfigurations.getUserId());
				url.push('&rgame=');
				url.push(kGameName);//GAConfigurations.getGameName());//'ngFish'
				url = encodeURI(url.join(""));
			break;
			
			case kSocialTypes.SEND_GIFTS: //receive user gifts
			
				url.push(notificationServerURL+"");
				url.push("userGift");
				url = encodeURI(url.join(""));
			
			break;
			
			case kSocialTypes.GET_CANNED_MESSAGES:
				url.push(notificationServerURL+"");
				url.push("precannedMessage?game=TF");
				//url.push(kGameName);//(GAConfigurations.getGameName());
				url.push("&language=");//+"355921042844124"
				url = encodeURI(url.join(""));
			break ;
			
			case kSocialTypes.GET_MESSAGE_COUNT: ///messageCount?ruserid=2&rgame=TF&rusername=2&ts=0
				url.push(notificationServerURL+"");
				url.push("messageCount?ruserid=");//+"355921042844124"
				url.push(GAConfigurations.getUserId());
				url.push('&rgame=');
				url.push(kGameName);//GAConfigurations.getGameName());
				url.push("&rusername=");
				url.push(GAConfigurations.getUserId());
				url.push("&ts=0");
				//url.push();
				url = encodeURI(url.join(""));
			break ;
			
			case kSocialTypes.RECEIVE_MESSAGES: ///message?ruserid=2&rgame=TF&rusername=2&offset=
				url.push(notificationServerURL+"");
				url.push("message?ruserid=");//+"355921042844124"
				url.push(GAConfigurations.getUserId());
				url.push('&rgame=');
				url.push(kGameName);//GAConfigurations.getGameName());
				url.push("&rusername=");
				url.push(GAConfigurations.getUserId());
				//url.push("offset=");
				//url.push();
				url = encodeURI(url.join(""));
			break ;
			
			case kSocialTypes.ACK_GIFT_RCV:
				url.push(notificationServerURL+"");
				url.push("ackUserGift");
				url = encodeURI(url.join(""));
			break;
			
			case kSocialTypes.SEND_NEIGHBOR_ACTION:
				url.push(notificationServerURL+"");
				url.push("neighborAction");
				url = encodeURI(url.join(""));
			break;
			
			case kSocialTypes.GET_NEIGHBOR_ACTION :
				//https://devsocialnotifications.appspot.com/neighborAction?udid=2&game=ngFish
				url.push(notificationServerURL+"");
				url.push("neighborAction?udid=");
				url.push(GAConfigurations.getUserId());
				url.push('&game=');
				url.push('ngFish');//(kGameName);
				url = encodeURI(url.join(""));
			break;
			
			case kSocialTypes.SEND_MESSAGES: //receive user gifts
				url.push(notificationServerURL+"");
				url.push("message");
				url = encodeURI(url.join(""));
			break;
			
			case kSocialTypes.ACK_NOTIFICATIONS: 
				url.push(notificationServerURL+"");
				url.push("ackNeighborAction");
				url = encodeURI(url.join(""));
			break;
		};
		return url;
	},
	
	destroyView: function(view) {
		try {
		   if(typeof view == 'undefined' || view == null)
	    		return;
			var children = view.getChildren();
			var length = children.length;
			for(var i = length - 1 ; i>=0 ; --i) {
				view.removeChild(children[i]);
				children[i].destroy();
				children[i] = null;
			}
		}
		catch(exception)
		{
			console.log('Logger: EXCEPTION Occured ' + exception.toString());
		}
	},
	
	destroyNodeChildren: function(node) {
		try {
			if(node == null)
				return;
			
			var children = node.getChildren();
		 	var length = children.length;
		 	for(var i = length - 1 ; i>=0 ; --i) {
				if(children[i] == null)
					continue;
				node.removeChild(children[i]);
		 		children[i].destroy();
		 		children[i] = null;
		 	}
		}
		catch(exception)
		{
			console.log('Logger: EXCEPTION Occured ' + exception.toString());
		}
	},

	destroyNodeChildrenLeaveChild: function(node,child) {
		try {
			if(node == null)
				return;
			
			var children = node.getChildren();
		 	var length = children.length;
		 	for(var i = length - 1 ; i>=0 ; --i) {
		 		if(children[i] != child) {
					if(children[i] == null)
						continue;
					node.removeChild(children[i]);
			 		children[i].destroy();
			 		children[i] = null;
		 		}
		 	}
		}
		catch(exception)
		{
			console.log('Logger: EXCEPTION Occured ' + exception.toString());
		}
	},

	destroyNode: function(node) {
		try {
			if(node == null)
				return;
			var children = node.getChildren();
		 	var length = children.length;
		 	for(var i = length - 1 ; i>=0 ; --i) {
				if(children[i] == null)
					continue;
		 		children[i].destroy();
		 		children[i] = null;
		 	}
		 	node.destroy();
			node = null;
		}
		catch(exception)
		{
			console.log('Logger: EXCEPTION Occured ' + exception.toString());
		}
	},
	
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/SocialAPI/SocialFriendsUI/SocialFriendsUI'] = function(){var exports = $MODULE_REGISTRY['Code/SocialAPI/SocialFriendsUI/SocialFriendsUI'] || {}; $MODULE_REGISTRY['Code/SocialAPI/SocialFriendsUI/SocialFriendsUI'] = exports; /**
 * Filename: SocialUI.js
 * Author: Ahsan Zaheer
 * Date Created: Oct 21,2011
 * Date Updated: --
 */
exports.SocialFriendsUI = GL2.Node.subclass( {
	
classname: 'SocialFriendsUI',	
	
	initialize: function($super)
	{
		$super();
		this._tableView = null;
		this.addBackground();
		this.makeButtons();
		this.showUserPanel();
		
	},

	addBackground: function(){
		
		this.textureImage = GLFactory.getSprite([SocialUtil.getAdjustedY(240),SocialUtil.getAdjustedX(190)],null,SOCIALAPI_BG_FRIENDS_IMG_PATH, [SocialUtil.adjustHeightWithDevice(410),SocialUtil.adjustWidthWithDevice(240)], [0.5,0.5]);
		this.addChild(this.textureImage);
		
	},
	
	makeButtons: function(){
    	
    	this.randomNeighbourButton = new GLButton(SOCIALAPI_RND_NEIGHBOUR_BTN_PATH, SOCIALAPI_RND_NEIGHBOUR_SELECTED_BTN_PATH, SocialUtil.adjustHeightWithDevice(180),SocialUtil.adjustWidthWithDevice(35),this.neighbourClicked.bind(this),this,100,randomNeighbourButtonText);
    	this.randomNeighbourButton.setPosition(SocialUtil.getAdjustedY(310),SocialUtil.getAdjustedX(280));
    	this.randomNeighbourButton.setTextFont(SocialUtil.getFont(),SocialUtil.getFontLocation());
    	
    	this.addFriendsButton = new GLButton(SOCIALAPI_ADD_FRND_BTN_PATH, SOCIALAPI_ADD_FRND_SELECTED_BTN_PATH, SocialUtil.adjustHeightWithDevice(115),SocialUtil.adjustWidthWithDevice(35),this.addFriendsClick.bind(this),this,100,addFriendsButtonText);
    	this.addFriendsButton.setPosition(SocialUtil.getAdjustedY(120),SocialUtil.getAdjustedX(280));
    	this.addFriendsButton.setTextFont(SocialUtil.getFont(),SocialUtil.getFontLocation());
    	
    },
    
    showListEmptyLabel : function (){
    	this._label = GLFactory.getText([SocialUtil.getAdjustedY(240),SocialUtil.getAdjustedX(180)],102,nameLabelText,[SocialUtil.getAdjustedY(300),SocialUtil.getAdjustedX(27)],SocialUtil.getAdjustedFontSize(100));
        this._label.setColor(1, 1, 1);
        this._label.setFontLocation(SocialUtil.getFontLocation());
        this._label.setFontFamily(SocialUtil.getFont());
        this._label.setText('You have no friends yet. ');
        this._label.setHorizontalAlign(GL2.Text.HorizontalAlign.Center);
        this.addChild(this._label);
    },
    
    showUserPanel:function () {
    	
    	var barImage = GLFactory.getSprite([SocialUtil.getAdjustedY(240),SocialUtil.getAdjustedX(95)],null,SOCIALAPI_BG_FRIENDS_BAR_PATH, [SocialUtil.adjustHeightWithDevice(314),SocialUtil.adjustWidthWithDevice(35)], [0.5,0.5]);
		this.addChild(barImage);
		
    	this._nameLabel = GLFactory.getText([SocialUtil.getAdjustedY(140),SocialUtil.getAdjustedX(95)],102,nameLabelText,[SocialUtil.getAdjustedY(100),SocialUtil.getAdjustedX(27)],SocialUtil.getAdjustedFontSize(100));
        this._nameLabel.setColor(1, 1, 1);
        this._nameLabel.setFontLocation(SocialUtil.getFontLocation());
        this._nameLabel.setFontFamily(SocialUtil.getFont());
        this._nameLabel.setHorizontalAlign(GL2.Text.HorizontalAlign.Center);
        this.addChild(this._nameLabel);
        
        var name = GAConfigurations.getUserId();
        this._nameLabelText = GLFactory.getText([SocialUtil.getAdjustedY(240),SocialUtil.getAdjustedX(95)],102,name,[SocialUtil.getAdjustedY(100),SocialUtil.getAdjustedX(27)],SocialUtil.getAdjustedFontSize(100));
	    this._nameLabelText.setColor(1, 1, 1);
        this._nameLabelText.setFontLocation(SocialUtil.getFontLocation());
        this._nameLabelText.setFontFamily(SocialUtil.getFont());
        this._nameLabelText.setHorizontalAlign(GL2.Text.HorizontalAlign.Center);
        this.addChild(this._nameLabelText);
    },
    
    
    fetchFriendList: function () {
    	UIFactory.showProgressHUD('Fetching data');
    	//SocialManager.handleSocialAction(kSocialTypes.FRIEND_LIST,null);
    },
    
    showFriendList: function(data) {
    	
    	UIFactory.hideProgressHUD();
    	if(data.length == 0) {
    		this.showListEmptyLabel();
    		return;
    	}
    	
    	if(this._tableView == null || this._tableView =='undefined')
    	{
    		NgLogE("SocialFriendsUI: creating");
	    	this._tableView = new SocialUIGenericTableView(135,123,data);
	    	this._tableView.setStoreType(kSocialUIType.FRIENDSUI);
			this._tableView._setHeight(50);
			this._tableView.setParentMainView(this);
	        NGWindow.document.addChild(this._tableView);
    	}
    	
    },
    
    addFriendsClick: function () {
    	Social.US.Service.Friends.showFindFriends(null);
    	SocialManager.hideSocialScreen();
    },
    
    neighbourClicked: function(){
    	
		console.log("socialClicked started visit neighbor");
		var visitNeighbor = new VisitNeighbor();
		visitNeighbor.goToNeighbor();
		console.log("socialClicked ended visit neighbor");
//		this.destory();
		NGWindow.document.removeChild(this._tableView);
    	this._tableView.destroy();
    	this._tableView = null;
	},

    destroy: function($super)
    {
    	if(this._tableView) {
	    	NGWindow.document.removeChild(this._tableView);
	    	this._tableView.destroy();
	    	this._tableView = null;
	    	SocialUtil.destroyNodeChildren(this);
    	}
        $super();
    },
	
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/SocialAPI/SocialFriendsHandler'] = function(){var exports = $MODULE_REGISTRY['Code/SocialAPI/SocialFriendsHandler'] || {}; $MODULE_REGISTRY['Code/SocialAPI/SocialFriendsHandler'] = exports; /**
 * Author: Hassan Adeel
 */

exports.SocialFriendsHandler = Core.Class.singleton(
{
    classname: 'SocialFriendsHandler',
    
    initialize: function() 
    {
    	this.mobageFriendList = [];
    	this.mobageFriendRequestList = [];
    	this.mobageBlockedUserList = [];
    	this._user = Social.US.Session.getCurrentSession().user();		// current User
    	this._callerType  = null;
    },
    
    getMobageFriendsWithCallBack: function(){
    	
    	var friendList =  this._user.getMobageFriendsList(); //returns OrderList type object
		friendList.forAll(SocialManager.callBackForItem.bind(this), SocialManager.callBackDone.bind(this));
    },
    
    getMobageFriendsList: function(){	
    	if (this.mobageFriendList.length > 0) {
    		SocialManager.callBackSocialFriendList(this.mobageFriendList);
    	}
    	else {
    		this.count = 0;
    		if(this.mobageFriendList) {
    			delete this.mobageFriendList;
    		}
    		this.mobageFriendList = [];
    		var friendList =  this._user.getMobageFriendsList(); //returns OrderList type object
    		friendList.forAll(this.callBackFriendForItem.bind(this), this.callBackFriendDone.bind(this));
    	}
    },
    
    getMobageFriendsRequestList: function(callerType){
    	this._callerType =  callerType;
    	if (this.mobageFriendRequestList.length > 0) {
    		SocialManager.callBackSocialFriendRequestList(this.mobageFriendRequestList,this._callerType);
    	}
    	else {
    		var friendList =  this._user.getMobageFriendRequestsList(); //returns OrderList type object
        	friendList.forAll(this.callBackFriendRequestForItem.bind(this), this.callBackFriendRequestDone.bind(this));
    	}
    	
    	
    },
    
    getMobageBlockedUserList: function () {
    	if (this.mobageBlockedUserList.length > 0) {
    		SocialManager.callBackBlockUsers(this.mobageBlockedUserList);
    	}
    	else {
    		var friendList =  this._user.getMobageBlockedUserList(); //returns OrderList type object
        	friendList.forAll(this.callBackBlockUserForItem.bind(this), this.callBackBlockUserDone.bind(this));
    	}
    },
    
    getMobageFriendsRequestListForFilteration: function(){	
    	
    	var friendList =  this._user.getMobageFriendRequestsList(); //returns OrderList type object
    	friendList.forAll(this.callBackFriendRequestForItem.bind(this), this.callBackFilterFriendRequestDone.bind(this));
    },
    
    filterMobageFriendsList: function () {
    	for(var i=0 ;i < this.mobageFriendList.length;i++) {
			 var user = this.mobageFriendList[i];
			 for(var j in this.mobageFriendRequestList ){
				 var ruser = this.mobageFriendRequestList[j];
				 if(user.gamertag == ruser.gamertag) {
					 this.mobageFriendList.splice(i,1);
					 --i;
					 break;
				 }
			 }
		 }
   	 	SocialManager.callBackSocialFriendList(this.mobageFriendList);
    },
    
	callBackFriendForItem: function (continueCb, user, index) {
		this.mobageFriendList.push(user);
		continueCb(true);
	},
	
	callBackFriendDone:function (error) {
		  if(error){
			  var errorCode = error.errorCode;
		      var errorDesc = error.description;
		      console.log("callBackFriendDone : errorCode: " +errorCode+' description' + errorDesc);
		      SocialManager.showFailurePromptWithMessage('Network error. Please make sure you are connected with internet.');
		  }
		  else {
			 console.log("callBackFriendDone Called");
			 if(this.mobageFriendList.length == 0) {
				 SocialManager.callBackSocialFriendList(this.mobageFriendList);
				 return;
			 }
			 for(var key in this.mobageFriendList) {
				 var user = this.mobageFriendList[key];
				 user.getUserDetails(this.callBackDetailsDone.bind(this));
			 }
			
		  }
	},
	
	callBackFriendRequestForItem: function (continueCb, user, index) {		
		this.mobageFriendRequestList.push(user);
		continueCb(true);
	},
	
	callBackFriendRequestDone:function (error) {
		  if(error){
			  var errorCode = error.errorCode;
		      var errorDesc = error.description;
		      console.log("callBackFriendRequestDone : errorCode: " +errorCode+' description' + errorDesc);
		      //SocialManager.showFailurePromptWithMessage('Unable to fetch friend requests. Please make sure you are connected to internet.');
		  }
		  else {
			 console.log("callBackFriendRequestDone Called");
			 
		  }
		  SocialManager.handleSocialAction(kSocialTypes.FRIEND_LIST,null);
		  SocialManager.callBackSocialFriendRequestList(this.mobageFriendRequestList,this._callerType);
	},
	
	callBackBlockUserForItem: function (continueCb, user, index) {	
//		console.log("faizan : blockUser " + user.gamertag);
		this.mobageBlockedUserList.push(user);
		continueCb(true);
	},
	
	callBackBlockUserDone:function (error) {
		  if(error){
			  var errorCode = error.errorCode;
		      var errorDesc = error.description;
		      console.log("callBackBlockUserDone : errorCode: " +errorCode+' description' + errorDesc);
		      delete this.mobageBlockedUserList;
		      this.mobageBlockedUserList = [];
		      //SocialManager.showFailurePromptWithMessage('Unable to fetch friend requests. Please make sure you are connected to internet.');
		  }
		  else {
			 console.log("callBackBlockUserDone Called");
			 
		  }
		  SocialManager.callBackBlockUsers(this.mobageBlockedUserList);
	},
	
	callBackFilterFriendRequestDone:function (error) {
		  if(error){
			  var errorCode = error.errorCode;
		      var errorDesc = error.description;
		      console.log("callBackFriendRequestDone : errorCode: " +errorCode+' description' + errorDesc);
		      if(this.mobageFriendList) {
	    			delete this.mobageFriendList;
		      }
		      this.mobageFriendList = [];
		      SocialManager.showFailurePromptWithMessage('Network error. Please make sure you are connected with internet.');
		      
		  }
		  else {
			 console.log("callBackFriendRequestDone Called");
			 this.filterMobageFriendsList();
		
		  }
	},
	
	callBackDetailsDone: function (error,user) {
		  if(error){
			  var errorCode = error.errorCode;
		      var errorDesc = error.description;
		      if(this.mobageFriendList) {
	    			delete this.mobageFriendList;
		      }
		      this.mobageFriendList = [];
		      SocialManager.showFailurePromptWithMessage('Network error. Please make sure you are connected with internet.');
		  }
		  else {
			  this.count++;
			  if(this.count == this.mobageFriendList.length) {
				  console.log("callBackDetails Done Called");
				  if (this.mobageFriendRequestList.length > 0) {
					  this.filterMobageFriendsList();
				  }
				  else {
					  this.getMobageFriendsRequestListForFilteration();
				  }
			  }
		  }
	},
	
	callBackInviteDone: function (error) {
	var message = null;
	  if(error){
		  var errorCode = error.errorCode;
	      var errorDesc = error.description;
	      console.log("callBackInviteDone Done : errorCode: " +errorCode+' description' + errorDesc);
	      message = 'invitation failed please try again later.';
	  }
	  else {
		  UIFactory.hideProgressHUD();
		  message = 'Friend invited successfully.';
	        
	  }
	 // SocialManager.showFailurePromptWithMessage(message);
	  UIFactory.hideProgressHUD();
	  var alertWindow = new SocialMiniUIAlertView("",message,this,null,GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
	    alertWindow.setTagValue(0002);
	    alertWindow.setMessageColor("FFFFFF");
	    alertWindow.setMessageFont(SocialUtil.getFontName());
	    alertWindow.setButtonsFont(SocialUtil.getFontName());
	    alertWindow.setButtonColor("FFFFFF");
	    alertWindow.show() ;
	},
	
	removeFriend: function (user) {
		//SocialManager._user.removeBuddy(user,cb);
	},
	
	inviteFriend: function (user) {
		UIFactory.showProgressHUD('inviting ' + user.getName());
		Social.US.User.getUserWithGamertag(user.getName(),this.callBackUserByTag.bind(this));
	},
	
	callBackUserByTag:function (error,user) {
	  if(!user) 
	  	{
	        var errorCode = error.errorCode;
	        var errorDesc = error.description;
	        console.log("Invite : errorCode " +errorCode+' description' + errorDesc);
	        UIFactory.hideProgressHUD();
	        SocialManager.showFailurePromptWithMessage('Network error. Please make sure you are connected with internet.');
		}
	  	else 
	  	{
	  		//console.log("faizan user found");
	  		user.inviteToCurrentGame(this.callBackInviteDone.bind(this));
	    }
	},
	
	getMobageFriendsListData:function()
	{
		if (this.mobageFriendList)
			return this.mobageFriendList;
		else
			return [];	
	},
	
	clear: function () {
		if(this.mobageFriendList) {
			delete this.mobageFriendList;
		}
		this.mobageFriendList = [];
		
		if(this.mobageFriendRequestList) {
			delete this.mobageFriendRequestList;
		}
		this.mobageFriendRequestList = [];
		
		if(this.mobageBlockedUserList) {
			delete this.mobageBlockedUserList;
		}
		this.mobageBlockedUserList = [];	},
	
	clickedButtonAtIndex: function(buttonIndex,alertView)
	{
		console.log("SocialFriendsHandler ->clickedButtonAtIndex button index"+buttonIndex);
		if (buttonIndex == 0) 
		{

		} 
		else if (buttonIndex == 1)
		{
				
		}
		
		
		
				
		
	},
	

});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/SocialAPI/SocialMessagesUI/SocialMessages'] = function(){var exports = $MODULE_REGISTRY['Code/SocialAPI/SocialMessagesUI/SocialMessages'] || {}; $MODULE_REGISTRY['Code/SocialAPI/SocialMessagesUI/SocialMessages'] = exports; /**
 * Filename: SocialMessages.js
 * Author: Ahsan Zaheer
 * Date Created: Oct 21,2011
 * Date Updated: --
 */
exports.SocialMessages = SocialUITableViewCell.subclass({
	
classname: 'SocialMessages',	
	
	initialize: function($super,reuseId,cellModel) {
	 	
	    $super(reuseId,cellModel);
	    this._cellModel = cellModel;
	    this.isSelected = false ;
	    this.cellView = null;
	},
	
	_onCreateView: function($super) 
    {
    	this.cellView = $super();
    	
    	this.cellView.messageLabel = new UI.Label();
    	this.cellView.messageLabel.setTextGravity(UI.ViewGeometry.Gravity.Left);
		this.cellView.messageLabel.setTextColor('E5D81E');
		this.cellView.messageLabel.setTextSize(13);
		this.cellView.messageLabel.setFrame([SocialUtil.getAdjustedY(10), SocialUtil.getAdjustedX(10), SocialUtil.adjustHeightWithDevice(321), SocialUtil.adjustWidthWithDevice(55)]);
		this.cellView.addChild(this.cellView.messageLabel);	
    	
		this._cellView.checkBoxButton = new UI.Button();
        this._cellView.checkBoxButton.setTextGravity(UI.ViewGeometry.Gravity.Center);
        this._cellView.checkBoxButton.setFrame([SocialUtil.getAdjustedY(331),SocialUtil.getAdjustedX(15),SocialUtil.getAdjustedY(36),SocialUtil.getAdjustedX(36)]);
        this._cellView.checkBoxButton.setImage(SOCIALAPI_CHECKBOX_IMG_PATH,UI.State.Normal);
        this._cellView.checkBoxButton.setImage(SOCIALAPI_CHECKBOX_IMG_SELECTED_PATH,UI.State.Pressed); 
        this._cellView.checkBoxButton.setImageFit(UI.ViewGeometry.FitModes.Stretch);
        this._cellView.checkBoxButton.enable = true;
		this._cellView.addChild(this._cellView.checkBoxButton);
    	
		return this.cellView;
    },
    
    _onSetView: function($super,cellView) 
    {
		$super(cellView);
		if(!this._cellModel)
			return;
		
//		 cellView.checkBoxButton.onclick = function() 
//		 {
//			 this.checkBoxAction();
//		 }.bind(this);
		 
		cellView.messageLabel.setText(this._cellModel);
		cellView.checkBoxButton.setOnClick(this.selectMessage.bind(this));
		
		this.cellView = cellView;
		
    },
    
    selectMessage: function(){
    	this._ParentTableView.unSelectSelectedMessage() ;
    	this.isSelected = true ;
    	this._cellView.checkBoxButton.setImage(SOCIALAPI_CHECKBOX_IMG_SELECTED_PATH,UI.State.Normal);
    },
    
    unselectMessage: function(){
    	this.isSelected = false ;
    	this._cellView.checkBoxButton.setImage(SOCIALAPI_CHECKBOX_IMG_PATH,UI.State.Normal);
    },
    
    
    _setIndexPath_Row:function($super,value)
    {
        $super(value);
    },
    
    _getIndexPath_Row: function($super)
    {
        return $super();
    },
    
    _setParentTableView: function($super,value)
    {
        $super(value);
    },
    
	_getParentTableView: function($super)			
    {
        return $super();
    },

    destroy: function($super) 
	{

		$super();
	}
});
	
	
    
    
   ; return exports;};
$MODULE_FACTORY_REGISTRY['Code/SocialAPI/SocialMessagesUI/SocialMessagesUI'] = function(){var exports = $MODULE_REGISTRY['Code/SocialAPI/SocialMessagesUI/SocialMessagesUI'] || {}; $MODULE_REGISTRY['Code/SocialAPI/SocialMessagesUI/SocialMessagesUI'] = exports; /**
 * Filename: SocialUI.js
 * Author: Moiez Ul Hasnain
 * Date Created: Nov 2,2011
 * Date Updated: --
 */
exports.SocialMessagesUI = GL2.Node.subclass( {
	
classname: 'SocialMessagesUI',	
	
	initialize: function($super)
	{
		$super();
		//console.log("ahsan test: SocialMessagesUI => initialize");
		//this.getCannedMessages();
		this._tableView = null;
		//this.addLabel();
		//this.getCannedMessages();
		//this.showMessagesList();
	},
	
	addLabel: function(){
		
		this.noteLabel = GLFactory.getText([SocialUtil.getAdjustedY(250),SocialUtil.getAdjustedX(75)],102,PLSE_SELECT_TEXT,[SocialUtil.getAdjustedY(200),SocialUtil.getAdjustedX(27)],SocialUtil.getAdjustedFontSize(100));
        this.noteLabel.setColor(1, 1, 1);
        this.noteLabel.setFontLocation(SocialUtil.getFontLocation());
        this.noteLabel.setFontFamily(SocialUtil.getFont());
        this.noteLabel.setHorizontalAlign(GL2.Text.HorizontalAlign.Center);
        this.addChild(this.noteLabel);
		
	},
	
	showListEmptyLabel : function (){
    	this._label = GLFactory.getText([SocialUtil.getAdjustedY(240),SocialUtil.getAdjustedX(180)],102,nameLabelText,[SocialUtil.getAdjustedY(300),SocialUtil.getAdjustedX(27)],SocialUtil.getAdjustedFontSize(100));
        this._label.setColor(1, 1, 1);
        this._label.setFontLocation(SocialUtil.getFontLocation());
        this._label.setFontFamily(SocialUtil.getFont());
        this._label.setText('You have no messages yet. ');
        this._label.setHorizontalAlign(GL2.Text.HorizontalAlign.Center);
        this.addChild(this._label);
    },
	
	 updateUIData: function (data) {
		// console.log("ahsan test: SocialMessagesUI => updateUIData");
	    	this._tableView.refreshData(data);
	    },
	    

	fetchMessageList: function () {
    	UIFactory.showProgressHUD('Fetching Messages List');
    	SocialManager.handleSocialAction(kSocialTypes.RECEIVE_MESSAGES,null);
    },
	    
	getMessages: function(){
//		SocialMessagesHandler.instantiate();
		var _responseObject = SocialMessagesHandler.getMessageResponseObject();
		//console.log("_responseObject :: "+ _responseObject);
		this.list = SocialMessagesHandler.getList();
//		console.log("this.list 2:: "+ this.list);
		//console.log("_responseObject :: "+ list2);
	},

	showMessagesList: function(data) {
		UIFactory.hideProgressHUD();
    	if(data.length == 0) {
    		this.showListEmptyLabel();
    		return;
    	}
    	
		//console.log("ahsan test: SocialMessagesUI => showMessagesList");
		if(this._tableView == null || this._tableView =='undefined')
    	{
			NgLogE("SocialMessagesUI: creating");
			this._tableView = new SocialUIGenericTableView(195,90,data);
			this._tableView.setStoreType(kSocialUIType.MESSAGESUI);
			this._tableView._setHeight(120);
			this._tableView.setParentMainView(this);
			NGWindow.document.addChild(this._tableView);
    	}
    },
    
    close: function(){
		NGWindow.document.removeChild(this._tableView);
    	this._tableView.destroy();
    	SocialUtil.destroyNodeChildren(this);
    	this.destroy();
	},
    
    destroy: function($super)
    {
		if(this._tableView) {
	    	NGWindow.document.removeChild(this._tableView);
	    	this._tableView.destroy();
	    	this._tableView = null;
	    	SocialUtil.destroyNodeChildren(this);
    	}
        $super();
    },
	
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/SocialAPI/SocialMessagesUI/SocialMessagesUICell'] = function(){var exports = $MODULE_REGISTRY['Code/SocialAPI/SocialMessagesUI/SocialMessagesUICell'] || {}; $MODULE_REGISTRY['Code/SocialAPI/SocialMessagesUI/SocialMessagesUICell'] = exports; /**
 * Filename: SocialMessagesUICell.js
 * Author: Ahsan Zaheer
 * Date Created: Oct 21,2011
 * Date Updated: --
 */
exports.SocialMessagesUICell = SocialUITableViewCell.subclass({
	
classname: 'SocialMessagesUICell',	
	
	initialize: function($super,msgModel) {
	 	
	    $super(msgModel);
	    this._msgModel = msgModel;
	   
	    this.cellView = null;
	},
	
	_onCreateView: function($super) 
    {
    	this.cellView = $super();
    	this.cellView.nameLabel = new UI.Label();
    	this.cellView.nameLabel.setTextGravity(UI.ViewGeometry.Gravity.Left);
		this.cellView.nameLabel.setTextColor('E5D81E'); 
		this.cellView.nameLabel.setTextFont('DroidSans-Bold') ;
		this.cellView.nameLabel.setTextSize(SocialUtil.getAdjustedFontSize(55));
		this.cellView.nameLabel.setFrame([SocialUtil.getAdjustedY(10), SocialUtil.getAdjustedX(10), SocialUtil.adjustHeightWithDevice(200), SocialUtil.adjustWidthWithDevice(15)]);
		this.cellView.addChild(this.cellView.nameLabel);	
		
		this.cellView.timeLabel = new UI.Label();
    	this.cellView.timeLabel.setTextGravity(UI.ViewGeometry.Gravity.Right);
		this.cellView.timeLabel.setTextColor('E5D81E');
		this.cellView.timeLabel.setTextFont('DroidSans-Bold') ;
		this.cellView.timeLabel.setTextSize(SocialUtil.getAdjustedFontSize(55));
		this.cellView.timeLabel.setFrame([SocialUtil.getAdjustedY(260), SocialUtil.getAdjustedX(10), SocialUtil.adjustHeightWithDevice(100), SocialUtil.adjustWidthWithDevice(15)]);
		this.cellView.addChild(this.cellView.timeLabel);	
		
		this.cellView.msgBody = new UI.Label();
    	this.cellView.msgBody.setTextGravity(UI.ViewGeometry.Gravity.Left);
    	this.cellView.msgBody.setTextFont('DroidSerif-Italic') ;
		this.cellView.msgBody.setTextColor('E5D81E');
		this.cellView.msgBody.setTextSize(SocialUtil.getAdjustedFontSize(50));
		this.cellView.addChild(this.cellView.msgBody);
		
		this.cellView.visitButton = new UI.Button();
        this.cellView.visitButton.setTextGravity(UI.ViewGeometry.Gravity.Center);
        this.cellView.visitButton.setFrame([SocialUtil.getAdjustedY(295),SocialUtil.getAdjustedX(65),SocialUtil.getAdjustedY(28),SocialUtil.getAdjustedX(30)]);
        this.cellView.visitButton.setImage(SOCIALAPI_MSG_VISIT_NEIGHBOUR_BTN_IMG_PATH,UI.State.Normal);
        this.cellView.visitButton.setImage(SOCIALAPI_MSG_VISIT_NEIGHBOUR_BTN_SELECTED_IMG_PATH,UI.State.Pressed);
        this.cellView.visitButton.setImageFit(UI.ViewGeometry.FitModes.Stretch);
        this.cellView.visitButton.enable = true;
		this.cellView.addChild(this.cellView.visitButton);
		
		this.cellView.replyButton = new UI.Button();
        this.cellView.replyButton.setTextGravity(UI.ViewGeometry.Gravity.Center);
        this.cellView.replyButton.setFrame([SocialUtil.getAdjustedY(330),SocialUtil.getAdjustedX(65),SocialUtil.getAdjustedY(28),SocialUtil.getAdjustedX(30)]);
        this.cellView.replyButton.setImage(SOCIALAPI_MSG_REPLY_BTN_IMG_PATH,UI.State.Normal);
        this.cellView.replyButton.setImage(SOCIALAPI_MSG_REPLY_BTN_SELECTED_IMG_PATH,UI.State.Pressed);
        this.cellView.replyButton.setImageFit(UI.ViewGeometry.FitModes.Stretch);
        this.cellView.replyButton.enable = true;
		this.cellView.addChild(this.cellView.replyButton);
	
		return this.cellView;
    },
    
    _onSetView: function($super,cellView) 
    {
		$super(cellView);
		if(!this._msgModel)
			return;
		
		cellView.nameLabel.setText(this._msgModel.getSenderName()+" said:");
		var currentTimeStamp = parseInt(TFGameState.getServerTime());
	//	var timeString = this.getDuration(this._msgModel.getSenderTimeStamp(), currentTimeStamp) ;
		var timeString = SocialUtil.getParsedTimeStamp(this._msgModel.getSenderTimeStamp()) ;		

		cellView.timeLabel.setText(timeString);
		
		var height = Math.ceil((this._msgModel.getSenderMessage().length/55))*15 ;
		cellView.msgBody.setFrame([SocialUtil.getAdjustedY(10), SocialUtil.getAdjustedX(30), SocialUtil.adjustHeightWithDevice(280), SocialUtil.adjustWidthWithDevice(height)]);
		cellView.msgBody.setText(this._msgModel.getSenderMessage()) ;
		
		cellView.replyButton.setOnClick(this.replyButtonAction.bind(this));
		cellView.visitButton.setOnClick(this.visitButtonAction.bind(this));
		this.cellView = cellView;
		
    },
    
    replyButtonAction: function() {
    	this.cellView.replyButton.setImage(SOCIALAPI_MSG_REPLY_BTN_IMG_PATH,UI.State.Normal);
    	SocialManager.socialView.showReplyMessageView(this._msgModel.getSenderName(), kMessagesUIType.REPLY_FRIEND);
    },
    
    visitButtonAction: function() {
//    	this.cellView.visitButton.setImage(SOCIALAPI_MSG_VISIT_NEIGHBOUR_BTN_IMG_PATH,UI.State.Normal);
//    	var visitNeighbor = new VisitNeighbor();
//    	visitNeighbor.goToFriend(this._msgModel.getSenderName());
//    	SocialManager.hideSocialScreen();
    	
    	
    	this.cellView.visitButton.setImage(SOCIALAPI_MSG_VISIT_NEIGHBOUR_BTN_IMG_PATH,UI.State.Normal);
    	
    	var friendsList = SocialFriendsHandler.getMobageFriendsListData();
    	
    	var isFriend = false;
    	if(friendsList && friendsList.length>0)
    	{
    		var giftSenderName = this._msgModel.getSenderName();
    		for(var i = 0; i<friendsList.length ; i++)
    		{
    			console.log("SocialMessagesUICell-> visitButtonAction-> friendsList.gamertag -> "+friendsList[i].gamertag);
    			if(giftSenderName == friendsList[i].gamertag)
    			{
    				isFriend = true;
    				break;		
    			}
    		}
    	}
    	
    	if(isFriend)
    	{
    		console.log("SocialMessagesUICell-> visitButtonAction-> This is my friend!");
    		var visitNeighbor = new VisitNeighbor();
    		visitNeighbor.goToFriend(this._msgModel.getSenderName());
    		SocialManager.hideSocialScreen();
    		
    	}
    	else
    	{
    		console.log("SocialMessagesUICell-> visitButtonAction->NOT my friend!");
    		var visitNeighbor = new VisitNeighbor();
    		visitNeighbor.goToNeighborWithName(this._msgModel.getSenderName());
    		SocialManager.hideSocialScreen();
    	}
    	
    },
    
//    bestFont: function() 
//	{ 
//		var l = arguments.length;
//	 	var SystemFonts = Core.Capabilities.getAvailableFonts();
//	 	for (var i = 0; i < SystemFonts.length; i++) 
//		{
//			console.log("Fonts: " + SystemFonts[i]);
//	 		//if (SystemFonts.indexOf(arguments[i]) > -1) return arguments[i]; 
//		}
//	 	return undefined; 
//	},
    
    _setIndexPath_Row:function($super,value)
    {
        $super(value);
    },
    
    _getIndexPath_Row: function($super)
    {
        return $super();
    },
    
    _setParentTableView: function($super,value)
    {
        $super(value);
    },
    
		_getParentTableView: function($super)			
    {
        return $super();
    },
    
    getDuration: function(postingTime, receivingTime) {
    	var duration = (receivingTime*1) - (postingTime*1) ;
    	var timeString ;
    	if (duration < 3600)
    		timeString = Math.floor((duration/60)) + " minutes ago" ;
    	else if (duration < 86400)
    		timeString = Math.floor((duration/3600)) + " hours ago" ;
    	else if (duration < 604800)
    		timeString = Math.floor((duration/86400)) + " days ago" ;
    	else if (duration < 2592000)
    		timeString = Math.floor((duration/604800)) + " weeks ago" ;
    	else if (duration < 31104000)
    		timeString = Math.floor((duration/2592000)) + " months ago" ;
    	else timeString = Math.floor((duration/31104000)) + " years ago" ;
    	return timeString ;
    		
    },
    
    //********************Destroy********************//

    destroy: function($super) 
	{

		$super();
	}
});
	
	
    
    
   ; return exports;};
$MODULE_FACTORY_REGISTRY['Code/SocialAPI/SocialMessagesUI/SocialMessagesDialogue'] = function(){var exports = $MODULE_REGISTRY['Code/SocialAPI/SocialMessagesUI/SocialMessagesDialogue'] || {}; $MODULE_REGISTRY['Code/SocialAPI/SocialMessagesUI/SocialMessagesDialogue'] = exports; /**
 * Filename: SocialMessagesDialogue.js
 * Author: Moiez Ul Hasnain
 * Date Created: Nov 14,2011
 * Date Updated: --
 */
exports.SocialMessagesDialogue = GL2.Node.subclass( {
	
classname: 'SocialMessagesDialogue',	
	
	initialize: function($super, userName, userType)
	{
		$super();
		//this.getCannedMessages();
		this.addUI();
		this.userName = userName ;
		this.userType = userType ;
		//this.getCannedMessages();
		//this.showMessagesList();
	},
	
	addUI: function(){
		//var SocialMessagesDialogueUI = require('./SocialMessagesDialogueUI').SocialMessagesDialogueUI ;
		//this.dialogueView = new SocialMessagesDialogueUI() ;
		//this.dialogueView.setParentMainView(this);
		var textureImage = GLFactory.getSprite([SocialUtil.getAdjustedY(240),SocialUtil.getAdjustedX(165)],null,SOCIAL_MESSAGES_DIALOGUE_BG_PATH, [SocialUtil.adjustHeightWithDevice(250),SocialUtil.adjustWidthWithDevice(110)], [0.5,0.4]);
		this.customButton = new GLButton(SOCIALAPI_NOTIFICATION_CLEAR_BTN_PATH, SOCIALAPI_NOTIFICATION_CLEAR_BTN_SELECETD_PATH,SocialUtil.getAdjustedY(85),SocialUtil.getAdjustedX(30),this.showCustomMessage.bind(this),this,102,GALocalizationHandler.getLocalizedString('SOCIAL_CUSTOM_MESSAGE_LABEL'),null,null,null,SocialUtil.getAdjustedFontSize(85));
		this.customButton.setPosition(SocialUtil.getAdjustedY(185),SocialUtil.getAdjustedX(205));
		this.customButton.setTextFont(SocialUtil.getFont(),SocialUtil.getFontLocation());
		
		this.cannedButton = new GLButton(SOCIALAPI_NOTIFICATION_CLEAR_BTN_PATH, SOCIALAPI_NOTIFICATION_CLEAR_BTN_SELECETD_PATH,SocialUtil.getAdjustedY(85),SocialUtil.getAdjustedX(30),this.showCannedMessage.bind(this),this,102,GALocalizationHandler.getLocalizedString('SOCIAL_CANNED_MESSAGE_LABEL'),null,null,null,SocialUtil.getAdjustedFontSize(85));
		this.cannedButton.setPosition(SocialUtil.getAdjustedY(295),SocialUtil.getAdjustedX(205));
		this.cannedButton.setTextFont(SocialUtil.getFont(),SocialUtil.getFontLocation());
		
		this.dialogueMsg = GLFactory.getText([SocialUtil.getAdjustedY(240),SocialUtil.getAdjustedX(160)],102,GALocalizationHandler.getLocalizedString('SOCIAL_MESSAGE_DIALOGUE_LABEL'), [SocialUtil.adjustHeightWithDevice(220),SocialUtil.adjustWidthWithDevice(70)],SocialUtil.getAdjustedFontSize(100));
		this.dialogueMsg.setColor(0, 0, 0);
		this.dialogueMsg.setFontLocation(SocialUtil.getFontLocation());
		this.dialogueMsg.setFontFamily(SocialUtil.getFont());
		this.addChild(this.dialogueMsg);
		
		//this.backgroundImage.setImage(SOCIAL_MESSAGES_DIALOGUE_BG_PATH, UI.State.Normal) ;
    	//this.backgroundImage.setFrame([SocialUtil.getAdjustedY(50),SocialUtil.getAdjustedX(100),SocialUtil.getAdjustedY(350),SocialUtil.getAdjustedX(100)]) ;
    	this.addChild(textureImage);
    	//NGWindow.document.addChild(this.backgroundImage);
    },
    
    showCustomMessage: function() {
    	SocialManager.socialView.showCustomMessageView(this.userName, this.userType) ;
    },
    
    showCannedMessage: function() {
    	//this.cannedButton.setImage(SOCIALAPI_NOTIFICATION_CLEAR_BTN_PATH,UI.State.Normal);
    	SocialManager.socialView.showCannedMessageView(this.userName, this.userType) ;
    },
    

    
    destroy: function($super)
    {
		//if(this.dialogueView) {
	    //	NGWindow.document.removeChild(this.dialogueView);
	    	//this.dialogueView.destroy();
	    	//this.dialogueView = null;
	    	SocialUtil.destroyNodeChildren(this);
    	//}
        $super();
    },
	
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/SocialAPI/SocialMessagesUI/SocialCannedMessagesUI'] = function(){var exports = $MODULE_REGISTRY['Code/SocialAPI/SocialMessagesUI/SocialCannedMessagesUI'] || {}; $MODULE_REGISTRY['Code/SocialAPI/SocialMessagesUI/SocialCannedMessagesUI'] = exports; /**
 * Filename: SocialUI.js
 * Author: Ahsan Zaheer
 * Date Created: Oct 21,2011
 * Date Updated: --
 */
exports.SocialCannedMessagesUI = GL2.Node.subclass( {
	
classname: 'SocialCannedMessagesUI',	
	
	initialize: function($super, receiverName, msgType)
	{
		$super();
		//console.log("ahsan test: SocialCannedMessagesUI => initialize");
		//this.getCannedMessages();
		this.messageType = msgType ;
		this._tableView = null;
		this.makeButtons();
		this.receiverName = receiverName ;
		this.addLabel();
		
		//this.getCannedMessages();
		//this.showMessagesList();
	},
	
	addLabel: function(){
		
		if(this.receiverName == 0 || this.receiverName == '')
    	{
    		this.receiverName = TFGameState._neighborName;
    	}
    	
		var noteLabelMessage = PLSE_SELECT_TEXT + " " + this.receiverName;
		this.noteLabel = GLFactory.getText([SocialUtil.getAdjustedY(250),SocialUtil.getAdjustedX(80)],102,noteLabelMessage,[SocialUtil.getAdjustedY(200),SocialUtil.getAdjustedX(50)],SocialUtil.getAdjustedFontSize(100));
		
        this.noteLabel.setColor(1, 1, 1);
        this.noteLabel.setFontLocation(SocialUtil.getFontLocation());
        this.noteLabel.setFontFamily(SocialUtil.getFont());
        this.noteLabel.setHorizontalAlign(GL2.Text.HorizontalAlign.Center);
        this.noteLabel.setOverflowMode(GL2.Text.OverflowMode.ReduceFontSize);
        this.addChild(this.noteLabel);
		
	},
	
	showListEmptyLabel : function (){
    	this._label = GLFactory.getText([SocialUtil.getAdjustedY(240),SocialUtil.getAdjustedX(180)],102,nameLabelText,[SocialUtil.getAdjustedY(300),SocialUtil.getAdjustedX(27)],SocialUtil.getAdjustedFontSize(100));
        this._label.setColor(1, 1, 1);
        this._label.setFontLocation(SocialUtil.getFontLocation());
        this._label.setFontFamily(SocialUtil.getFont());
        this._label.setText('You have no messages yet. ');
        this._label.setHorizontalAlign(GL2.Text.HorizontalAlign.Center);
        this.addChild(this._label);
    },
    
	makeButtons: function(){
		
		this.sendButton = new GLButton(SOCIALAPI_NOTIFICATION_CLEAR_BTN_PATH, SOCIALAPI_NOTIFICATION_CLEAR_BTN_SELECETD_PATH, SocialUtil.adjustHeightWithDevice(100),SocialUtil.adjustWidthWithDevice(35),this.sendClicked.bind(this),this,100,sendButtonText);
    	this.sendButton.setPosition(SocialUtil.getAdjustedY(355),SocialUtil.getAdjustedX(290));
    	this.sendButton.setTextFont(SocialUtil.getFont(),SocialUtil.getFontLocation());
    	
    	if (this.messageType != null && this.messageType != 'undefined' && this.messageType != kMessagesUIType.REPLY_NEIGHBOUR_ANONYMOUS) {
    		this.backButton = new GLButton(SOCIALAPI_NOTIFICATION_CLEAR_BTN_PATH, SOCIALAPI_NOTIFICATION_CLEAR_BTN_SELECETD_PATH, SocialUtil.adjustHeightWithDevice(80),SocialUtil.adjustWidthWithDevice(25),this.backClicked.bind(this),this,100,backButtonText);
	    	this.backButton.setPosition(SocialUtil.getAdjustedY(100),SocialUtil.getAdjustedX(95));
	    	this.backButton.setTextFont(SocialUtil.getFont(),SocialUtil.getFontLocation());
    	}
	},
	
	sendClicked: function(){
		if (this._tableView) {
			var replyMsgText = this._tableView.getSelectedMsg() ;
		 	if (replyMsgText) {
		 		var SocialMessageModel = require('Code/SocialAPI/SocialModelClasses/SocialMessageModel').SocialMessageModel;
		 		replyMsg = new SocialMessageModel() ;
		 		replyMsg.setSenderGame(kGameName) ;
		 		replyMsg.setSenderId(GAConfigurations.getUserId()) ;
		 		replyMsg.setSenderName(GAConfigurations.getUserId()) ;
		 		replyMsg.setReceiverGame(kGameName) ;
		 		replyMsg.setReceiverId(this.receiverName) ;
		 		replyMsg.setReceiverName(this.receiverName) ;
		 		replyMsg.setSenderMessage(replyMsgText) ;
		 		SocialManager.handleSocialAction(kSocialTypes.SEND_MESSAGES, replyMsg) ;
		 	}
		 }
	},
	
	backClicked: function(){
		if(this.messageType == kMessagesUIType.REPLY_FRIEND || this.messageType == kMessagesUIType.REPLY_NEIGHBOUR_FRIEND)
    		SocialManager.socialView.showReplyMessageView(this.receiverName) ;
    	if(this.messageType == kMessagesUIType.REPLY_ANONYMOUS)
    		SocialManager.socialView.showMessageView() ;
    		
	},
	
	updateUIData: function (data) {
		this._tableView.refreshData(data);
	},
	    

	fetchCannedMessageList: function () {
    	UIFactory.showProgressHUD('Fetching data');
    	SocialManager.handleSocialAction(kSocialTypes.GET_CANNED_MESSAGES,null);
    },
	    
	getCannedMessages: function(){
//		SocialMessagesHandler.instantiate();
		var _responseObject = SocialMessagesHandler.getMessageResponseObject();
		//console.log("_responseObject :: "+ _responseObject);
		this.list = SocialMessagesHandler.getList();
//		console.log("this.list 2:: "+ this.list);
		//console.log("_responseObject :: "+ list2);
	},

	showMessagesList: function(data) {
		UIFactory.hideProgressHUD();
    	if(data.length == 0) {
    		this.showListEmptyLabel();
    		return;
    	}
    	
    	if(this._tableView == null || this._tableView =='undefined')
    	{
    		NgLogE("SocialCannedMessagesUI: creating");
			this._tableView = new SocialUIGenericTableView(155,113,data);
			this._tableView.setStoreType(kSocialUIType.CANNED_MESSAGESUI);
			this._tableView._setHeight(80);
			this._tableView.setParentMainView(this);
			NGWindow.document.addChild(this._tableView);
    	}
    },
    
    close: function(){
		NGWindow.document.removeChild(this._tableView);
    	this._tableView.destroy();
    	SocialUtil.destroyNodeChildren(this);
    	this.destroy();
	},
    
    destroy: function($super)
    {
		if(this._tableView) {
	    	NGWindow.document.removeChild(this._tableView);
	    	this._tableView.destroy();
	    	this._tableView = null;
	    	SocialUtil.destroyNodeChildren(this);
    	}
        $super();
    },
	
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/SocialAPI/SocialList/SocialCustomCellView'] = function(){var exports = $MODULE_REGISTRY['Code/SocialAPI/SocialList/SocialCustomCellView'] || {}; $MODULE_REGISTRY['Code/SocialAPI/SocialList/SocialCustomCellView'] = exports; exports.SocialCustomCellView = UI.View.subclass({
    
    className: "SocialCustomCellView",
    
    initialize: function($super)
	{
    	 $super();
    },
    
    destroy: function($super) 
	{
    	if(typeof this != 'undefined' && this != null)
    		return;
		var children = this.getChildren();
		var length = children.length;
		for(var i = 0; i < length; i++) 
		{
			this.removeChild(children[i]);
			children[i].destroy();
			children[i] = null;
		}
		$super();
    },
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/SocialAPI/SocialNotificationsUI/SocialNotificationsUI'] = function(){var exports = $MODULE_REGISTRY['Code/SocialAPI/SocialNotificationsUI/SocialNotificationsUI'] || {}; $MODULE_REGISTRY['Code/SocialAPI/SocialNotificationsUI/SocialNotificationsUI'] = exports; /**
 * Filename: SocialUI.js
 * Author: Ahsan Zaheer
 * Date Created: Oct 21,2011
 * Date Updated: --
 */
exports.SocialNotificationsUI = GL2.Node.subclass( {
	
classname: 'SocialNotificationsUI',	
	
	initialize: function($super)
	{
		$super();
		this._tableView = null;
		this._dataList = new Array();
		this.makeClearButton();
		this._iteratedCount = 0;
		
	},
	
	makeClearButton: function(){
		
		this.clearButton = new GLButton(SOCIALAPI_NOTIFICATION_CLEAR_BTN_PATH, SOCIALAPI_NOTIFICATION_CLEAR_BTN_SELECETD_PATH, SocialUtil.adjustHeightWithDevice(100),SocialUtil.adjustWidthWithDevice(35),this.clearClicked.bind(this),this,100,clearButtonText);
    	this.clearButton.setPosition(SocialUtil.getAdjustedY(355),SocialUtil.getAdjustedX(290));
    	this.clearButton.setTextFont(SocialUtil.getFont(),SocialUtil.getFontLocation());
    	//this.clearButton.buttonText.setFontSize(50);
	},
	
	showListEmptyLabel : function (){
    	this._label = GLFactory.getText([SocialUtil.getAdjustedY(240),SocialUtil.getAdjustedX(180)],102,nameLabelText,[SocialUtil.getAdjustedY(300),SocialUtil.getAdjustedX(27)],SocialUtil.getAdjustedFontSize(100));
        this._label.setColor(1, 1, 1);
        this._label.setFontLocation(SocialUtil.getFontLocation());
        this._label.setFontFamily(SocialUtil.getFont());
        this._label.setText('You have no notifications yet. ');
        this._label.setHorizontalAlign(GL2.Text.HorizontalAlign.Center);
        this.addChild(this._label);
    },
    
	fetchNotificationList: function () {
    	UIFactory.showProgressHUD('Fetching data');
    	SocialManager.handleSocialAction(kSocialTypes.FRIEND_REQUEST_LIST,kSocialFriendHandlerCallType.SOCIALNOTIFICATIONUI);
    	SocialManager.handleSocialAction(kSocialTypes.RECEIVE_GIFTS,null);
    	SocialManager.handleSocialAction(kSocialTypes.GET_NEIGHBOR_ACTION,null);
    	
    },
    
	showNotificationsList: function(data) {
    	this._iteratedCount++;
		if(data != null && data.length > 0) {

			for(var i=0;i<data.length;i++)
			{
				this._dataList.push(data[i]);
			}

		}
    	
    	if(this._iteratedCount < 3) 
    		return;
    	
//    	SocialManager.handleSocialAction(kSocialTypes.CALLBACK_OVERRIDE,false);
    	
    	UIFactory.hideProgressHUD();
    	
//    	NgLogE("SocialNotificationsUI: Datalist -> "+this._dataList);
//    	NgLogE("SocialNotificationsUI: Datalist -> "+this._dataList.length);
    	
    	if(this._dataList.length == 0) {
    		this.showListEmptyLabel();
    		return;
    	}
    	
    	if(this._tableView == null || this._tableView =='undefined')
    	{
    		NgLogE("SocialNotificationsUI: creating");
			this._tableView = new SocialUIGenericTableView(175,93,this._dataList);
			this._tableView.setStoreType(kSocialUIType.NOTIFICATIONSUI);
			this._tableView._setHeight(60);
			this._tableView.setParentMainView(this);
			NGWindow.document.addChild(this._tableView);
    	}
    	else
    	{
    		NgLogE("SocialNotification: donot create");
    	}

    },
    
    reloadUI: function(dataObject) {
    	
    	this._tableView.refreshData(dataObject);
    	if(this._tableView.isListEmpty()) {
    		this.showListEmptyLabel();
    	}
		//UIFactory.hideProgressHUD();
    },
    
    clearClicked: function(){
    	SocialManager.handleSocialAction(kSocialTypes.ACK_NOTIFICATIONS,null);
	},
	
	acknowledgeNotifications: function(){
		this._tableView.clearOnlyNotifications();
	},
    
    destroy: function($super)
    {
    	if(this._tableView) {
	    	NGWindow.document.removeChild(this._tableView);
	    	this._tableView.destroy();
	    	this._tableView = null;
	    	SocialUtil.destroyNodeChildren(this);
    	}
        $super();
    },
	
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/SocialAPI/SocialNotificationsUI/SocialNotificationsCell'] = function(){var exports = $MODULE_REGISTRY['Code/SocialAPI/SocialNotificationsUI/SocialNotificationsCell'] || {}; $MODULE_REGISTRY['Code/SocialAPI/SocialNotificationsUI/SocialNotificationsCell'] = exports; /**
 * Filename: SocialMessages.js
 * Author: Ahsan Zaheer
 * Date Created: Oct 21,2011
 * Date Updated: --
 */
exports.SocialNotificationsCell = SocialUITableViewCell.subclass({
	
classname: 'SocialNotificationsCell',	
	
	    initialize: function($super,reuseId,cellModel) {
        $super(reuseId,cellModel);
        this._cellModel = cellModel;  // Gift object
        this.cellView = null;
    },
	
	_onCreateView: function($super) 
    {
    	this.cellView = $super();
    	this.cellView._notifyLabel = new UI.Label();
    	this.cellView._notifyLabel.setTextGravity(UI.ViewGeometry.Gravity.Left);
		this.cellView._notifyLabel.setTextColor('E5D81E');
		this.cellView._notifyLabel.setTextFont(SocialUtil.getFontName());
		this.cellView._notifyLabel.setTextSize(13);
		this.cellView._notifyLabel.setFrame([SocialUtil.getAdjustedY(10), SocialUtil.getAdjustedX(10), SocialUtil.adjustHeightWithDevice(300), SocialUtil.adjustWidthWithDevice(22)]);
		this.cellView.addChild(this.cellView._notifyLabel);	
		
		this.cellView._timeLabel = new UI.Label();
    	this.cellView._timeLabel.setTextGravity(UI.ViewGeometry.Gravity.Left);
		this.cellView._timeLabel.setTextColor('E5D81E');
		this.cellView._timeLabel.setTextFont(SocialUtil.getFontName());
		this.cellView._timeLabel.setTextSize(13);
		this.cellView._timeLabel.setFrame([SocialUtil.getAdjustedY(280), SocialUtil.getAdjustedX(30), SocialUtil.adjustHeightWithDevice(200), SocialUtil.adjustWidthWithDevice(22)]);
		this.cellView.addChild(this.cellView._timeLabel);	
    	
		return this.cellView;
    },
    
    _onSetView: function($super,cellView) 
    {
		$super(cellView);
		if(!this._cellModel)
			return;
		
		cellView._notifyLabel.setText(this.getNotifyLabelText());
		cellView._timeLabel.setText(this._cellModel.getTimeStamp());
		this.cellView = cellView;
		
    },
    
    getNotifyLabelText: function () {
    	var actionPerformed = this._cellModel.getActionPerformed();
    	var name = this._cellModel.getName();
    	var mess = null;
    	if( name == GAConfigurations.getUserId()){
			mess = this.getUserSameText(actionPerformed);
		}
		else {
			mess = this.getDifferentUserText(actionPerformed);
		}
    	return mess;
    },
    
    
    getDifferentUserText : function (actionPerformed) {
    	var mess = null;
    	switch (actionPerformed) {
    	
		case kSocialFriendActionType.CLEAN_TANK:
			mess = this._cellModel.getName() + ' cleaned your tanks while you were away.';  
			break;
		
		case kSocialFriendActionType.FEED_FISH:
			mess = this._cellModel.getName() +   ' fed your fish while you were away.';  
			break;
		case kSocialFriendActionType.GIFT:
			mess = this._cellModel.getName() + ' sent you a gift.';   
			break;
		case kSocialFriendActionType.REVIVE_FISHES:
			mess = this._cellModel.getName() + ' revived your fish(es) while you were away.';   
			break;
		default:
			
    	}
    	return mess;
    },
    
    getUserSameText: function (actionPerformed) {
    	var mess = null;
    	switch (actionPerformed) {
    	
		case kSocialFriendActionType.CLEAN_TANK:
			mess = 'You cleaned ' +   this._cellModel.getRname() + '\'s tank.';  
			break;
		
		case kSocialFriendActionType.FEED_FISH:
			mess = 'You fed ' +   this._cellModel.getRname() + '\'s fishes.';  
			break;
		case kSocialFriendActionType.GIFT:
			mess = 'You have sent a gift to ' +   this._cellModel.getRname() + '.';  
			break;REVIVE_FISHES
		case kSocialFriendActionType.REVIVE_FISHES:
			mess = 'You have revived ' +   this._cellModel.getRname() + '\'s fish(es).';  
			break;
		default:
			
    	}
    	return mess;
    },
    
    _setIndexPath_Row:function($super,value)
    {
        $super(value);
    },
    
    _getIndexPath_Row: function($super)
    {
        return $super();
    },
    
    _setParentTableView: function($super,value)
    {
        $super(value);
    },
    
		_getParentTableView: function($super)			
    {
        return $super();
    },
    
    //********************Destroy********************//

    destroy: function($super) 
	{

		$super();
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/SocialAPI/SocialNotificationsUI/SocialNotificationFriendsCell'] = function(){var exports = $MODULE_REGISTRY['Code/SocialAPI/SocialNotificationsUI/SocialNotificationFriendsCell'] || {}; $MODULE_REGISTRY['Code/SocialAPI/SocialNotificationsUI/SocialNotificationFriendsCell'] = exports; exports.SocialNotificationFriendsCell = SocialUITableViewCell.subclass({
    
    classname: "SocialNotificationFriendsCell",
	
    initialize: function($super,reuseId,cellModel) {
        $super(reuseId,cellModel);
        this._cellModel = cellModel;  // User object
        this.cellView = null;
    },
    _onCreateView: function($super) 
    {
    	this.cellView = $super();
    	
    	this._cellView.visitButton = new UI.Button();
        this._cellView.visitButton.setTextGravity(UI.ViewGeometry.Gravity.Center);
        this._cellView.visitButton.setFrame([SocialUtil.getAdjustedY(285),SocialUtil.getAdjustedX(14),SocialUtil.getAdjustedY(55),SocialUtil.getAdjustedX(25)]);
        this._cellView.visitButton.setImage(SOCIALAPI_VISIT_BTN_PATH,UI.State.Normal);
        this._cellView.visitButton.setImage(SOCIALAPI_VISIT_BTN_SELECTED_PATH,UI.State.Pressed);
        this._cellView.visitButton.setImageFit(UI.ViewGeometry.FitModes.Stretch);
        this._cellView.visitButton.setText('View');
		this._cellView.visitButton.setTextColor('FFFFFF');
		this._cellView.visitButton.setTextFont(SocialUtil.getFontName());
		this._cellView.addChild(this._cellView.visitButton);
		
		
		this._boxIcon = new UI.Image();
		this._boxIcon.setFrame([SocialUtil.getAdjustedY(7),SocialUtil.getAdjustedX(7),SocialUtil.getAdjustedY(36),SocialUtil.getAdjustedX(36)]);
		this._boxIcon.setImage(SOCIALAPI_ICON_BG_PATH,UI.State.Normal);
		this._cellView.addChild(this._boxIcon);
		
		this._boxIconImage = new UI.Image();
		this._boxIconImage.setFrame([SocialUtil.getAdjustedY(11),SocialUtil.getAdjustedX(12),SocialUtil.getAdjustedY(27),SocialUtil.getAdjustedX(27)]);
		this._boxIconImage.setImage(SOCIALAPI_ICON_PATH,UI.State.Normal);
		this._cellView.addChild(this._boxIconImage);
		
		this._cellView._nameLabel = new UI.Label();
		this._cellView._nameLabel.setFrame([SocialUtil.getAdjustedY(45),SocialUtil.getAdjustedX(12),SocialUtil.adjustHeightWithDevice(250),SocialUtil.adjustWidthWithDevice(27)]);
		this._cellView._nameLabel.setTextColor('FFFFFF'); 
		this._cellView._nameLabel.setTextFont(SocialUtil.getFontName());
		//this._nameLabel.setTextSize(fontSize);
		
		this._cellView._nameLabel.setTextGravity(UI.ViewGeometry.Gravity.Center);
		this._cellView.addChild(this._cellView._nameLabel);
    
		
		
        return this.cellView;
    },
    
    _onSetView: function($super,cellView) 
    {
		$super(cellView);
		if(!this._cellModel)
			return;
		if(this._cellModel > 1)
		{
			cellView._nameLabel.setText('You have '+this._cellModel +  ' friend requests.');
		}
		else
		{
			cellView._nameLabel.setText('You have '+this._cellModel +  ' friend request.');
		}
		cellView.visitButton.setOnClick(this.viewButtonAction.bind(this));
		
		this.cellView = cellView;
			
    },
    
    
    viewButtonAction: function(user){
    	Social.US.Service.Friends.showFindFriends(null);
    	SocialManager.hideSocialScreen();
    },
    

	getButtonsState: function()
	{
		return this._enableButton;
	},
		
	
	setEnableButtons: function(value)
	{
		this._enableButton = value;
	},


    //********************Setters-Getters********************//
    
    _setIndexPath_Row:function($super,value)
    {
        $super(value);
    },
	
    _getIndexPath_Row: function($super)
    {
        return $super();
    },
    
    _setParentTableView: function($super,value)
    {
        $super(value);
    },
    
		_getParentTableView: function($super)			
    {
        return $super();
    },
    

    destroy: function($super) 
	{
		$super();
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/SocialAPI/SocialGiftsHandler'] = function(){var exports = $MODULE_REGISTRY['Code/SocialAPI/SocialGiftsHandler'] || {}; $MODULE_REGISTRY['Code/SocialAPI/SocialGiftsHandler'] = exports; /**
 * Author: Syed Mauze Rehan
 */
 
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////// 
 var GETGiftCallHandler = Core.Class.subclass({
	
	initialize:function(_type)
	{
		this._type = _type;
	},
	
	 webFetchSuccess : function(webFetcher, responseData){
		try{
			var jsonResponse = eval("(" + responseData + ")");
			var gifts = jsonResponse.gifts;
			
			if(jsonResponse.status != 'OK')
			{
				//this is the real error condition
				console.log("GETGiftCallHandler -> Response not OK!");
				if (jsonResponse.status != 'NO_GIFTS')
				{
					console.log("GETGiftCallHandler -> Invalid response received!");
					SocialGiftsHandler.showErrorMessage(Core.Localization.getString('TF_RECEIVING_GIFTS_FAILED'),this._type);
				}
				SocialGiftsHandler.setGiftResponseObject(null);
				switch(this._type)
				{
					case kSocialTypes.RECEIVE_GIFTS:
						SocialManager.noGiftReceiveCallback();
						break;
					case kSocialTypes.RECEIVE_GIFTS_COUNT:
						SocialManager.noGiftReceiveCountCallback();
						break;
					case kSocialTypes.UPDATE:
						console.log("GETGiftCallHandler: Data updated....");
						SocialManager.noGiftReceiveCountCallback();
						break;	
					default:
						
				};
				
			}
			else
			{
				//var requestURL = webFetcher._request.settings.url+'';
				var _giftResponseObject= new GASocialGiftReceivedResponse(jsonResponse);
				_giftResponseObject.parseSocialGiftReceivedResponse();
				
				SocialGiftsHandler.setGiftResponseObject(_giftResponseObject);
				
				switch(this._type)
				{
					case kSocialTypes.RECEIVE_GIFTS:
						SocialManager.receiveGiftsSuccessCallback(_giftResponseObject.getGiftsArray());
						break;
					case kSocialTypes.RECEIVE_GIFTS_COUNT:
						SocialManager.receiveGiftsCountSuccessCallback(_giftResponseObject.getGiftsArray());
						break;
					case kSocialTypes.UPDATE:
						console.log("GETGiftCallHandler: Data updated....");
						SocialManager.receiveGiftsCountSuccessCallback(_giftResponseObject.getGiftsArray());
						break;	
					default:
						
				};
				
			}
		}catch(exception){
			
			switch(this._type)
			{
				case kSocialTypes.RECEIVE_GIFTS:
					SocialGiftsHandler.showErrorMessage(Core.Localization.getString('TF_RECEIVING_GIFTS_FAILED'),kSocialTypes.RECEIVE_GIFTS);
					SocialManager.receiveGiftsFailureCallback([]);
					break;
				case kSocialTypes.RECEIVE_GIFTS_COUNT:
					SocialGiftsHandler.showErrorMessage(Core.Localization.getString('TF_RECEIVING_GIFTS_FAILED'),kSocialTypes.RECEIVE_GIFTS_COUNT);
					SocialManager.receiveGiftsCountFailureCallback([]);
					break;
				case kSocialTypes.UPDATE:
					console.log("GETGiftCallHandler: Data update failed....");
					break;	
				default:
					
			};
			throw exception;
		}
		
		if(webFetcher != null){
			webFetcher.destroy();
			webFetcher = null;
		}
		
		this._type =  null;
	},
	webFetchFailure : function(webFetcher, errorCode){	
		var errorMsg = "GETGiftCallHandler::webFetchFailure() responseStatusCode = > " + errorCode;
		//GALogger.logWithLevel(errorMsg,LOG_LEVEL.LOG_NONFATAL_ERROR);
		if(webFetcher != null){
			webFetcher.destroy();
			webFetcher = null;
		}
	
		console.log(errorMsg);
		switch(this._type)
		{
			case kSocialTypes.RECEIVE_GIFTS:
				SocialGiftsHandler.showErrorMessage(Core.Localization.getString('TF_RECEIVING_GIFTS_FAILED'),kSocialTypes.RECEIVE_GIFTS);
				SocialManager.receiveGiftsFailureCallback([]);
				break;
			case kSocialTypes.RECEIVE_GIFTS_COUNT:
				SocialGiftsHandler.showErrorMessage(Core.Localization.getString('TF_RECEIVING_GIFTS_FAILED'),kSocialTypes.RECEIVE_GIFTS_COUNT);
				SocialManager.receiveGiftsCountFailureCallback([]);
				break;
			case kSocialTypes.UPDATE:
				console.log("GETGiftCallHandler: Data update failed....");
				break;	
			default:
				
		};
		
		this._type =  null;	
		
	},
	
	destroy:function()
	{
		this._type =  null;
	},
});

 var POSTGiftCallHandler = Core.Class.subclass({
	
	initialize:function(_type, _giftObject)
	{
		this._type = _type;
		this._giftObject = _giftObject;
	},
	
	 webFetchSuccess : function(webFetcher, responseData){
		try{
			var jsonResponse = eval("(" + responseData + ")");
			console.log("POSTGiftCallHandler: responseData -> "+responseData);
			
			//{"status": "OK", "msg": "Your gift has been posted", "custom": ""}
			 
			if(jsonResponse.status != 'OK'){
				//this is the real error condition
				console.log("POSTGiftCallHandler -> Response not OK!");

				switch(this._type)
				{
					case kSocialTypes.SEND_GIFTS: //send gift
						UIFactory.hideProgressHUD();
						SocialGiftsHandler.showErrorMessage(Core.Localization.getString('SOCIAL_SEND_GIFT_FAILURE'),kSocialTypes.SEND_GIFTS);
						SocialManager.sendGiftsFailureCallback(this._giftObject);
						// to be done
						break;
					case kSocialTypes.VERIFY_GIFT_SENT: // verify gift sent
						// not implemented
						break;
					case kSocialTypes.ACK_GIFT_RCV: // Ack Gift Received
						//status->used ... if alreayd acknowledged, handle it
						//to remove claiming gift spinner
    					UIFactory.hideProgressHUD();
    					
						if(jsonResponse.status != 'used')
						{
							SocialGiftsHandler.showErrorMessage(Core.Localization.getString('SOCIAL_ACK_GIFT_FAILURE'),kSocialTypes.ACK_GIFT_RCV);
							SocialManager.acknowledgeGiftForUserFailureCallback(this._giftObject);
						}
						
						break;
					default:
										
				};

			}
			else
			{
				//var requestURL = webFetcher._request.settings.url+'';
				switch(this._type)
				{
					case kSocialTypes.SEND_GIFTS: //send gift
						SocialManager.sendGiftsSuccessCallback(this._giftObject);
						SocialManager.handleSocialAction(kSocialTypes.SEND_NEIGHBOR_ACTION,kSocialFriendActionType.GIFT);
						break;
					case kSocialTypes.VERIFY_GIFT_SENT: // verify gift sent
						//not implemented
						break;
					case kSocialTypes.ACK_GIFT_RCV: // Ack Gift Received
						SocialGiftsHandler.setGiftAcknowledged(this._giftObject);
						SocialManager.acknowledgeGiftForUserSuccessCallback(this._giftObject);
						break;
					default:
								
				};
				
			}
		}catch(exception){
			//SocialGiftsHandler.showErrorMessage(Core.Localization.getString('TF_RECEIVING_GIFTS_FAILED'),'1111');
			
			switch(this._type)
			{
				case kSocialTypes.SEND_GIFTS: //send gift
					UIFactory.hideProgressHUD();
					SocialGiftsHandler.showErrorMessage(Core.Localization.getString('SOCIAL_SEND_GIFT_FAILURE'),kSocialTypes.SEND_GIFTS);
					SocialManager.sendGiftsFailureCallback(this._giftObject);
					//parse and call the appropriate callback
					break;
				case kSocialTypes.VERIFY_GIFT_SENT: // verify gift sent
					// not implemented
					//parse and call the appropriate callback
					break;
				case kSocialTypes.ACK_GIFT_RCV: // Ack Gift Received
					UIFactory.hideProgressHUD();
					SocialGiftsHandler.showErrorMessage(Core.Localization.getString('SOCIAL_ACK_GIFT_FAILURE'),kSocialTypes.ACK_GIFT_RCV);
					SocialManager.acknowledgeGiftForUserFailureCallback(this._giftObject);
					//parse and call the appropriate callback
					break;
				default:
									
			};
			
			throw exception;
		}
		
		if(webFetcher != null){
			webFetcher.destroy();
			webFetcher = null;
		}
		
		this._type =  null;
	},
	webFetchFailure : function(webFetcher, errorCode){	
		var errorMsg = "POSTGiftCallHandler::webFetchFailure() responseStatusCode = > " + errorCode;
		//GALogger.logWithLevel(errorMsg,LOG_LEVEL.LOG_NONFATAL_ERROR);
		if(webFetcher != null){
			webFetcher.destroy();
			webFetcher = null;
		}

		console.log(errorMsg);        	
        switch(this._type)
		{
			case kSocialTypes.SEND_GIFTS: //send gift
				UIFactory.hideProgressHUD();
				SocialGiftsHandler.showErrorMessage(Core.Localization.getString('SOCIAL_SEND_GIFT_FAILURE'),kSocialTypes.SEND_GIFTS);
				SocialManager.sendGiftsFailureCallback(this._giftObject);
				//parse and call the appropriate callback
				break;
			case kSocialTypes.VERIFY_GIFT_SENT: // verify gift sent
				// to be implemented
				//parse and call the appropriate callback
				break;
			case kSocialTypes.ACK_GIFT_RCV: // Ack Gift Received
				UIFactory.hideProgressHUD();
				SocialGiftsHandler.showErrorMessage(Core.Localization.getString('SOCIAL_ACK_GIFT_FAILURE'),kSocialTypes.ACK_GIFT_RCV);
				SocialManager.acknowledgeGiftForUserFailureCallback(this._giftObject);
				//parse and call the appropriate callback
				break;
			default:
								
		};  	
		
		this._type =  null;
	},
	
	destroy:function()
	{
		this._type =  null;
	},
	
});
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

exports.SocialGiftsHandler = Core.Class.singleton(
{
    classname: 'SocialGiftsHandler',
    
        
    initialize: function()//_callBackFunc,_type) 
    {
    	this._giftResponseObject = null;
    	this._acknowledgedGift = null;
    },
    
    //SocialGiftsHandler.receiveGiftsForUser(kSocialTypes.RECEIVE_GIFTS);
	receiveGiftsForUser: function(_type)
	{
		if(this._giftResponseObject!=null && _type != kSocialTypes.UPDATE)
		{
			switch(_type)
			{
				case kSocialTypes.RECEIVE_GIFTS:
					SocialManager.receiveGiftsSuccessCallback(this._giftResponseObject.getGiftsArray());
					return;
				case kSocialTypes.RECEIVE_GIFTS_COUNT:
					SocialManager.receiveGiftsCountSuccessCallback(this._giftResponseObject.getGiftsArray());
					return;
				default:
					//SocialManager.receiveGiftsFailureCallback();
					return; 	
			};
		}
		
		//if update
		if(this._giftResponseObject != null)
		{
			this._giftResponseObject.destroy();
			this._acknowledgedGift = null;
		}
		
		var url = SocialUtil.getSocialActionURL(kSocialTypes.RECEIVE_GIFTS);
		var getGiftHandlerClass = new GETGiftCallHandler(_type);
		
		//console.log("SocialGiftHandler: URL for notifications -> "+url);		
		this._webFetcher = new GAWebFetcher(getGiftHandlerClass, 30, 0);
		this._webFetcher.invokeGetRequest(url);
		
	},
	
	sendGiftToAUser: function(senderType, senderName, receiverName, senderGameName, receiverGameName, storeObject, custom)
	{	
		var giftStoreId = '' +storeObject.parent.parent.visible_id+'_'+storeObject.parent.visible_id+'_'+storeObject.visible_id;
		
		var url = SocialUtil.getSocialActionURL(kSocialTypes.SEND_GIFTS);
		//console.log("SocialGiftsHandler: sendGiftToAUser  -> send gift URL -> "+url); 	
		var body = "";
		var timeStamp = parseInt(TFGameState.getServerTime());
		var signature = senderGameName+receiverGameName+senderName+senderName+receiverName+receiverName+timeStamp+giftStoreId+kSocialSignatureKey;
		
		//console.log("SocialGiftsHandler: sendGiftToAUser  -> signature before signing  -> "+signature);
		
		signature = Core.SHA1.hex_sha1(signature);
		
		//console.log("SocialGiftsHandler: sendGiftToAUser  -> signature after signing  -> "+signature);
		
		var params = "stype="+senderType+"&sgame="+senderGameName+"&suserid="+senderName+"&susername="+senderName+"&rgame="+receiverGameName+
			    	"&ruserid="+receiverName+"&rusername="+receiverName+
			    	"&gid="+giftStoreId+"&ts="+timeStamp+"&signature="+signature+"&custom="+custom;		
		
		//console.log("SocialGiftsHandler: sendGiftToAUser  -> params  -> "+params);
		
		console.log("SocialGiftsHandler: sendGiftToAUser  -> giftSender -> "+senderName+"  -> giftReceiver -> "+receiverName);
		
		var postGiftCallHandler = new POSTGiftCallHandler(kSocialTypes.SEND_GIFTS, storeObject);
		
		this._webFetcher = new GAWebFetcher(postGiftCallHandler, 30, 0);
		this._webFetcher.invokePostRequest(url, params, true);
		
	},
	
	acknowledgeUserGift:function(giftObject)
	{
		console.log("acknowledgeUserGift: -> ack gift ... " + giftObject.getGiftId());
		//kGameName,GAConfigurations.getUserId(),giftModel.getObjId(),giftModel.getGiftId()
		var receiverGame = kGameName;
		var receiverName = GAConfigurations.getUserId();
		var dbKeys = "[\""+giftObject.getObjId()+"\"]";
		var giftStoreId = giftObject.getGiftId();
		
		var url = SocialUtil.getSocialActionURL(kSocialTypes.ACK_GIFT_RCV);
		//console.log("SocialGiftsHandler: acknowledgeUserGift  -> ack gift URL -> "+url); 	
		var body = "";
		var timeStamp = parseInt(TFGameState.getServerTime());
		var signature =	receiverGame+receiverName+receiverName+dbKeys+kSocialSignatureKey; 
		
		//console.log("SocialGiftsHandler: acknowledgeUserGift  -> signature before signing  -> "+signature);
		
		signature = Core.SHA1.hex_sha1(signature);
		
		//console.log("SocialGiftsHandler -> signature after signing  -> "+signature);
		
		var params = "rgame="+receiverGame+"&ruserid="+receiverName+"&rusername="+receiverName+"&dbkeys="+dbKeys+
					 "&signature="+signature;
		
		//console.log("SocialGiftsHandler: acknowledgeUserGift -> params  -> "+params);
		
		var postGiftCallHandler = new POSTGiftCallHandler(kSocialTypes.ACK_GIFT_RCV, giftObject);
		
		this._webFetcher = new GAWebFetcher(postGiftCallHandler, 30, 0);
		this._webFetcher.invokePostRequest(url, params, true);
		
	},
	
	downloadAcknowledgedGift: function()
	{
		console.log("SocialGiftsHandler-> downloadAcknowledgedGift ...");
		
		var giftObject = this.getGiftAcknowledged();
		
		var storeItem = GAGameLoader.getStoreHandler().getStoreObjectForKey(giftObject.getGiftId());
		
		var _gaDownloader = new GAResourceDownloader(storeItem, this.resourceDownloadingSuccessful.bind(this), this.resourceDownloadingFailed.bind(this), GAResourceType.kDetail);
		
		UIFactory.showProgressHUD("Downloading resources...");
		_gaDownloader.startDownloading();
		
	},
	
	//call getGiftsArray on this object to access the list of gifts received
	getGiftResponseObject: function()
	{
		return this._giftResponseObject;
	},
	
	setGiftResponseObject: function(value)
	{
		this._giftResponseObject = value;
	},
	
	getGiftAcknowledged: function()
	{
		return this._acknowledgedGift;
	},
	
	setGiftAcknowledged: function(value)
	{
		this._acknowledgedGift = value;
	},
	
	removeGiftObject: function(giftObject)
	{
		var giftsArray = this._giftResponseObject.getGiftsArray();
		
//		console.log("SocialGiftsHandler:removeGiftObject-> Before Removing ....");
//		NgLogE("SocialGiftsHandler:removeGiftObject-> Before Removing ....");
//		var tmp = '';
//		for(var i=0;i<giftsArray.length;i++)
//		{	
//			tmp += giftsArray[i].getObjId()+",";
//		}
//		
//		console.log("=====> "+tmp);
//		NgLogE("=====> "+tmp);

		if(giftsArray == null || giftsArray == 'undefined' || giftObject == null  ||  giftObject == 'undefined')
		{
			return;
		}
		
		for(var i=0;i<giftsArray.length;i++)
		{	
			if(giftsArray[i].getObjId()==giftObject.getObjId())
			{
				giftsArray.splice(i,1);
				break;
			} 
			
		}
		
		if(giftsArray!= null && giftsArray != 'undefined' && giftsArray.length >=2)
		{
			//sorting once again
			giftsArray.sort(function(a,b){return b.getSenderTimeStamp() - a.getSenderTimeStamp()});
		}
		
//		console.log("SocialGiftsHandler:removeGiftObject-> After Removing ....");
//		NgLogE("SocialGiftsHandler:removeGiftObject-> After Removing ....");
//		var tmp = '';
//		for(var i=0;i<giftsArray.length;i++)
//		{	
//			tmp += giftsArray[i].getObjId()+",";
//		}
//		
//		console.log("=====> "+tmp);
//		NgLogE("=====> "+tmp);
		
	},
	
	showErrorMessage:function(message, tag)
	{	
		console.log("SocialGiftsHandler: showErrorMessage....");
		
//		if(tag == kSocialTypes.DOWNLOAD_ACK_GIFT)
//		{
//			var userMessAlert = new SocialMiniUIAlertView("",message,this,Core.Localization.getString('TF_CANCEL_BUTTON'),GALocalizationHandler.getLocalizedString('TF_RETRY_LABEL'));
//	       	userMessAlert.setTagValue(tag);
//	        userMessAlert.setMessageColor("FFFFFF");
//			userMessAlert.setMessageFont(SocialUtil.getFontName());
//			userMessAlert.setButtonsFont(SocialUtil.getFontName());
//			userMessAlert.setButtonColor("FFFFFF");
//			userMessAlert.show();
//		}
//		else
//		{
//			var userMessAlert = new SocialMiniUIAlertView("",message,this,null,GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
//	       	userMessAlert.setTagValue(tag);
//	        userMessAlert.setMessageColor("FFFFFF");
//			userMessAlert.setMessageFont(SocialUtil.getFontName());
//			userMessAlert.setButtonsFont(SocialUtil.getFontName());
//			userMessAlert.setButtonColor("FFFFFF");
//			userMessAlert.show();
//		}
		
		
	},
	
	clickedButtonAtIndex: function(buttonIndex,alertView)
	{
		console.log("SocialGiftsHandler ->clickedButtonAtIndex button index"+buttonIndex);
		if (buttonIndex == 0) 
		{
//			if(alertView.getTagValue() == kSocialTypes.RECEIVE_GIFTS)
//			{
//				console.log("SocialGiftHandler -> Retrying RECEIVE_GIFTS.........");
//				this.receiveGiftsForUser(kSocialTypes.RECEIVE_GIFTS);
//			}
//			else
//			if(alertView.getTagValue() == kSocialTypes.RECEIVE_GIFTS_COUNT)
//			{
//				console.log("SocialGiftHandler -> Retrying RECEIVE_GIFTS_COUNT.........");
//				this.receiveGiftsForUser(kSocialTypes.RECEIVE_GIFTS_COUNT);
//			}
//			else
			if(alertView.getTagValue() == kSocialTypes.DOWNLOAD_ACK_GIFT)
			{
				console.log("SocialGiftHandler -> Retrying downloading gift.........");
				this.downloadAcknowledgedGift();
			}

		} 
		else if (buttonIndex == 1)
		{	
			if(alertView.getTagValue() == kSocialTypes.DOWNLOAD_ACK_GIFT)
			{
				console.log("SocialGiftHandler -> Canceling retry for downloading acknowledged gift.........");
        		var giftObject = this.getGiftAcknowledged();
        		SocialManager.downloadAcnknowledgedGiftFailureCallback(giftObject);
			}
			
		}
		
	},
	
	//downloading resources
    resourceDownloadingSuccessful:function(savePath, param2, _gaDownloader) 
	{	
		UIFactory.hideProgressHUD();
		
		console.log("SocialGiftsHandler-> resourceDownloadingSuccessful ...");
		
		if(_gaDownloader) 
		{
            _gaDownloader.destroy();
            _gaDownloader = null;
        }
        
        var giftObject = this.getGiftAcknowledged();
        SocialManager.downloadAcnknowledgedGiftSuccessCallback(giftObject);
        									 
	},

	resourceDownloadingFailed:function (savePath, errorMsg, _gaDownloader)
	{
		UIFactory.hideProgressHUD();
		console.log("SocialGiftsHandler-> resourceDownloadingFailed ...");
        
		if(_gaDownloader) 
		{
            _gaDownloader.destroy();
            _gaDownloader = null;
        }
        
        //show error message
        var message = GALocalizationHandler.getLocalizedString('TF_RESOURCE_NETWORK_TEXT');
       	this.showErrorMessage(message, kSocialTypes.DOWNLOAD_ACK_GIFT);
       	
	},
	 
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/SocialAPI/SocialGiftsUI/SocialGiftstUI'] = function(){var exports = $MODULE_REGISTRY['Code/SocialAPI/SocialGiftsUI/SocialGiftstUI'] || {}; $MODULE_REGISTRY['Code/SocialAPI/SocialGiftsUI/SocialGiftstUI'] = exports; 
exports.SocialGiftstUI = GL2.Node.subclass( {
	
classname: 'SocialGiftstUI',	
	
	initialize: function($super)
	{
		$super();
		this._tableView = null;
		
	},

    showListEmptyLabel : function (){
    	this._label = GLFactory.getText([SocialUtil.getAdjustedY(240),SocialUtil.getAdjustedX(180)],102,nameLabelText,[SocialUtil.getAdjustedY(300),SocialUtil.getAdjustedX(27)],SocialUtil.getAdjustedFontSize(100));
        this._label.setColor(1, 1, 1);
        this._label.setFontLocation(SocialUtil.getFontLocation());
        this._label.setFontFamily(SocialUtil.getFont());
        this._label.setText('Currently there are not giftable items available. ');
        this._label.setHorizontalAlign(GL2.Text.HorizontalAlign.Center);
        this.addChild(this._label);
    },
    
    
    
    fetchGiftsList: function () {
    	UIFactory.showProgressHUD('Fetching data');
    	SocialManager.handleSocialAction(kSocialTypes.GET_GIFTABLE_ITEMS,null);
    },
    
    showGiftsList: function(data) {
    	
    	UIFactory.hideProgressHUD();
    	if(data.length == 0) {
    		this.showListEmptyLabel();
    		return;
    	}
    	
    	if(this._tableView == null || this._tableView =='undefined')
    	{
    		NgLogE("SocialGiftsUI: creating");
	    	this._tableView = new SocialUIGenericTableView(180,80,data);
	    	this._tableView.setStoreType(kSocialUIType.GIFTSUI);
			this._tableView._setHeight(50);
			this._tableView.setParentMainView(this);
	        NGWindow.document.addChild(this._tableView);
    	}
    },
    
    destroy: function($super)
    {
    	if(this._tableView) {
	    	NGWindow.document.removeChild(this._tableView);
	    	this._tableView.destroy();
	    	this._tableView = null;
	    	SocialUtil.destroyNodeChildren(this);
    	}
        $super();
    },
	
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/SocialAPI/SocialGiftsUI/SocialNeighbourGiftCell'] = function(){var exports = $MODULE_REGISTRY['Code/SocialAPI/SocialGiftsUI/SocialNeighbourGiftCell'] || {}; $MODULE_REGISTRY['Code/SocialAPI/SocialGiftsUI/SocialNeighbourGiftCell'] = exports; exports.SocialNeighbourGiftCell = SocialUITableViewCell.subclass({
    
    classname: "SocialNeighbourGiftCell",
	
    initialize: function($super,reuseId,cellModel) {
        $super(reuseId,cellModel);
        this._cellModel = cellModel;  // User object
        this.cellView = null;
        this._store_id = '';
    },
    _onCreateView: function($super) 
    {
    	this.cellView = $super();
    	this._cellView._BigButton.setFrame([SocialUtil.getAdjustedY(0),SocialUtil.getAdjustedX(0),SocialUtil.getAdjustedY(380-5),SocialUtil.getAdjustedX(70)]);
    	this._cellView._BigButton.setImage(SOCIALAPI_GIFTS_BAR_PATH,[SocialUtil.getAdjustedY(380-20),SocialUtil.getAdjustedX(70)]);

    	this._boxIcon = new UI.Image();
		this._boxIcon.setFrame([SocialUtil.getAdjustedY(7),SocialUtil.getAdjustedX(4),SocialUtil.getAdjustedY(63),SocialUtil.getAdjustedX(63)]);
		this._boxIcon.setImage("./Content/images/Store/storetableimgs/box.png",UI.State.Normal);
		this._cellView.addChild(this._boxIcon);
		
//		this.cellView._lockImage = new UI.Image();
//		this.cellView._lockImage.setFrame([SocialUtil.getAdjustedY(315),SocialUtil.getAdjustedX(15),SocialUtil.getAdjustedY(39),SocialUtil.getAdjustedX(43)]);
//		this.cellView._lockImage.setImageFit(UI.FitMode.Fill);
//		this.cellView._lockImage.setTouchable(false);
//		this.cellView._lockImage.setImage("./Content/images/Store/storetableimgs/lock.png",UI.State.Normal);
//		this.cellView.addChild(this.cellView._lockImage);
		
		this.cellView._newImage = new UI.Image();
		this.cellView._newImage.setImage("./Content/images/Store/storetableimgs/flagnew.png",UI.State.Normal);
		this.cellView._newImage.setFrame([SocialUtil.getAdjustedY(2),SocialUtil.getAdjustedX(4),SocialUtil.adjustHeightWithDevice(25),SocialUtil.adjustWidthWithDevice(25)]);
		this.cellView._newImage.setImageFit(UI.FitMode.Fill);
		this.cellView._newImage.setTouchable(false);
		this.cellView._newImage.setAlpha(3);
		this.cellView._newImage.setVisible(false);
		this.cellView.addChild(this.cellView._newImage);
		
		
		this.cellView._saleImage = new UI.Image();
		this.cellView._saleImage.setImage("./Content/images/Store/storetableimgs/flagsale.png",UI.State.Normal);
		this.cellView._saleImage.setFrame([SocialUtil.getAdjustedY(2),SocialUtil.getAdjustedX(4),SocialUtil.adjustHeightWithDevice(25),SocialUtil.adjustWidthWithDevice(25)]);
		this.cellView._saleImage.setImageFit(UI.FitMode.Fill);
		this.cellView._saleImage.setTouchable(false);
		this.cellView._saleImage.setAlpha(3);
		this.cellView._saleImage.setVisible(false);
		this.cellView.addChild(this.cellView._saleImage);
		
		this.cellView._sendButton = new UI.Button();
		this.cellView._sendButton.setAlpha(1);
		
		this.cellView._sendButton.setImage(SOCIALAPI_BTN_YELLOW_IMG_PATH,UI.State.Normal);
		this.cellView._sendButton.setImage(SOCIALAPI_BTN_YELLOW_SELECTED_IMG_PATH,UI.State.Pressed);
		this.cellView._sendButton.setImageFit(UI.ViewGeometry.FitModes.Stretch);
		this.cellView._sendButton.setTextGravity(UI.ViewGeometry.Gravity.Center);
		this.cellView._sendButton.setFrame([SocialUtil.getAdjustedY(300),SocialUtil.getAdjustedX(30),SocialUtil.getAdjustedY(56),SocialUtil.getAdjustedX(28)]);
		this.cellView.addChild(this.cellView._sendButton);
		
		this.cellView._previewButton = new UI.Button();
        this.cellView._previewButton.setAlpha(1);
        this.cellView._previewButton.setImage("./Content/images/UIPanels/Buttons/1buttonNormal.png",UI.State.Normal);
        this.cellView._previewButton.setImageFit(UI.ViewGeometry.FitModes.Stretch);
        this.cellView._previewButton.setTextGravity(UI.ViewGeometry.Gravity.Center);
        this.cellView._previewButton.setFrame([SocialUtil.getAdjustedY(240),SocialUtil.getAdjustedX(30),SocialUtil.getAdjustedY(56),SocialUtil.getAdjustedX(28)]);
        this.cellView.addChild(this.cellView._previewButton);
		this.cellView._previewButton.setVisible(false);
		
		this.cellView._preview = new UI.Button();
        this.cellView._preview.setAlpha(1);
        this.cellView._preview.setImageFit(UI.ViewGeometry.FitModes.Stretch);
        this.cellView._preview.setTextGravity(UI.ViewGeometry.Gravity.Center);
        this.cellView._preview.setFrame([SocialUtil.getAdjustedY(0),SocialUtil.getAdjustedX(0),GACommonUtils.getScreenWidth(),GACommonUtils.getScreenHeight()]);
        UI.Window.document.addChild(this.cellView._preview);
		this.cellView._preview.setVisible(false);
		
		this.cellView._levelRequired = new UI.Label();
        this.cellView._levelRequired.setTextGravity(UI.ViewGeometry.Gravity.Center);
        this.cellView._levelRequired.setTextColor('FFFFFF');
        this.cellView._levelRequired.setTouchable(false);
        this.cellView._levelRequired.setTextSize(10);
        this.cellView._levelRequired.setFrame([SocialUtil.getAdjustedY(298),SocialUtil.getAdjustedX(44),SocialUtil.getAdjustedY(65),SocialUtil.getAdjustedX(38)]);
        this.cellView.addChild(this.cellView._levelRequired);
        
        this.cellView._canBeBreeded = new UI.Label();
        this.cellView._canBeBreeded.setTextGravity(UI.ViewGeometry.Gravity.Center);
        this.cellView._canBeBreeded.setTextColor('FFFF33');
        this.cellView._canBeBreeded.setTextSize(9);
        this.cellView._canBeBreeded.setFrame([SocialUtil.getAdjustedY(65),SocialUtil.getAdjustedX(26),SocialUtil.getAdjustedY(65),SocialUtil.getAdjustedX(38)]);
		this.cellView._canBeBreeded.setTouchable(false);
        this.cellView.addChild(this.cellView._canBeBreeded);
        
        this.cellView._bucksOrCoinsImage = new UI.Image();
		this.cellView._bucksOrCoinsImage.setTouchable(false);
		this.cellView._bucksOrCoinsImage.setFrame([SocialUtil.getAdjustedY(75),SocialUtil.getAdjustedX(46),SocialUtil.getAdjustedY(25),SocialUtil.getAdjustedX(25)]);
		this.cellView.addChild(this.cellView._bucksOrCoinsImage);
		
		//according to active bucket
		this.cellView._bucksOrCoinsPriceLabel = new UI.Label();
		this.cellView._bucksOrCoinsPriceLabel.setTouchable(false);
	 	this.cellView._bucksOrCoinsPriceLabel.setTextGravity(UI.ViewGeometry.Gravity.Center);
    	this.cellView._bucksOrCoinsPriceLabel.setTextColor('FFFF33');
    	SocialUtil.setTextFont(this.cellView._bucksOrCoinsPriceLabel);
    	this.cellView._bucksOrCoinsPriceLabel.setTextSize(12);
    	this.cellView._bucksOrCoinsPriceLabel.setFrame([SocialUtil.getAdjustedY(85), SocialUtil.getAdjustedX(50), SocialUtil.getAdjustedY(50), SocialUtil.getAdjustedX(18)]);
		this.cellView.addChild(this.cellView._bucksOrCoinsPriceLabel);
		
		
		this.cellView.line = new UI.Image();
		this.cellView.line.setTouchable(false);
		this.cellView.line.setImage("./Content/images/Store/storetableimgs/black_dot.png",UI.State.Normal);
		this.cellView.line.setFrame([SocialUtil.getAdjustedY(103),SocialUtil.getAdjustedX(48),SocialUtil.adjustHeightWithDevice(18),SocialUtil.adjustWidthWithDevice(2)]);
		this.cellView.line.setImageFit(UI.ViewGeometry.FitModes.Stretch);
		this.cellView.line.setVisible(false);
		this.cellView.addChild(this.cellView.line);
		
		//if active bucket is not default, if item is on sale so it shows the default price strike-through-ed and new sale price along with it
        this.cellView._salePriceLabel = new UI.Label();
        this.cellView._salePriceLabel.setTouchable(false);
        this.cellView._salePriceLabel.setTextGravity(UI.ViewGeometry.Gravity.Left);
        this.cellView._salePriceLabel.setTextColor('FFFF33');
        this.cellView._salePriceLabel.setTextSize(12);
        this.cellView._salePriceLabel.setFrame([SocialUtil.getAdjustedY(128), SocialUtil.getAdjustedX(40), SocialUtil.getAdjustedY(50), SocialUtil.getAdjustedX(18)]);
        this.cellView.addChild(this.cellView._salePriceLabel);

        var startingX = 185;
        var startingY = 20;
        var width = 110;
        var height = 60;
        
													 
        this.cellView._rightLabel1 = new UI.Label();
        this.cellView._rightLabel1.setTouchable(false);
        this.cellView._rightLabel1.setTextGravity(UI.ViewGeometry.Gravity.Right);
        this.cellView._rightLabel1.setTextColor('FFFF33');
        SocialUtil.setTextFont(this.cellView._rightLabel1);
        this.cellView._rightLabel1.setTextSize(12);
        this.cellView._rightLabel1.setFrame([SocialUtil.getAdjustedY(startingX), SocialUtil.getAdjustedX(startingY), SocialUtil.getAdjustedHeight(width), SocialUtil.getAdjustedWidth(height)]);
        this.cellView.addChild(this.cellView._rightLabel1);
        
        startingY = 40;
        
        this.cellView._rightLabel2 = new UI.Label();
        this.cellView._rightLabel2.setTextGravity(UI.ViewGeometry.Gravity.Right);
        this.cellView._rightLabel2.setTextColor('FFFF33');
        SocialUtil.setTextFont(this.cellView._rightLabel2);
        this.cellView._rightLabel2.setTextSize(12);
        this.cellView._rightLabel2.setTouchable(false);
        this.cellView._rightLabel2.setFrame([SocialUtil.getAdjustedY(startingX), SocialUtil.getAdjustedX(startingY), SocialUtil.getAdjustedHeight(width), SocialUtil.getAdjustedWidth(height)]);
        this.cellView.addChild(this.cellView._rightLabel2);
		
		
        this._cellView._name = new UI.Label();
		this._cellView._name.setTextGravity(UI.ViewGeometry.Gravity.Left);
		this._cellView._name.setTextColor('FFFFFF');
		this._cellView._name.setTextSize(13);
		this._cellView._name.setFrame([SocialUtil.getAdjustedY(75), SocialUtil.getAdjustedX(20), SocialUtil.adjustHeightWithDevice(200), SocialUtil.adjustWidthWithDevice(22)]);
		this._cellView.addChild(this._cellView._name);
		
		
        return this.cellView;
    },
    
    _onSetView: function($super,cellView) 
    {
		$super(cellView);
		if(!this._cellModel)
			return;
		
		this._store_id = '' +this._cellModel.parent.parent.visible_id+'_'+this._cellModel.parent.visible_id+'_'+this._cellModel.visible_id;
		
		 cellView._name.setText(this._cellModel.name);
		 
		 cellView._sendButton.onclick = function() 
		 {
			 this.sendButtonAction();
		 }.bind(this);
		
		cellView._previewButton.onclick = function() 
		{
			this.previewButtonAction(cellView);
		}.bind(this);
		
		cellView._preview.onclick = function() 
		{
			this.cellView._preview.setVisible(false);
		}.bind(this);
		
		var image = null;
		var prices = this._cellModel.buy_prices["default"];
		var originalBuyPrice = StoreUtil.getPrice(prices);
		var buyPriceKey = GACommonUtils.getBuyPrice(this._cellModel);
		var buyPrice = StoreUtil.getPrice(buyPriceKey);
		var currency = StoreUtil.getCurrency(buyPriceKey);
		
		if(currency == TF_COINS)
		{
			image = 'coins.png';
		}
		else
        {
			image = 'bucks.png';
		}
		
		cellView._bucksOrCoinsImage.setImage('./Content/images/UIPanels/storewindow/'+image);
        cellView._bucksOrCoinsPriceLabel.setText(originalBuyPrice);
        
        var bucket = this._cellModel.active_bucket;
        var imageFrame = null;
        if(originalBuyPrice != buyPrice)
		{
        	cellView._saleImage.setFrame([SocialUtil.getAdjustedY(2),SocialUtil.getAdjustedX(4),SocialUtil.adjustHeightWithDevice(25),SocialUtil.adjustWidthWithDevice(25)]);
			cellView._saleImage.setVisible(true);
			cellView._saleImage.setVisible(true);
			cellView.line.setVisible(true);
            cellView._salePriceLabel.setText(buyPrice);
            cellView._bucksOrCoinsPriceLabel.setTextColor('E3170D');
			
        }
        else {
			cellView.line.setVisible(false);
        	cellView._saleImage.setVisible(false);
        }
        
        var storeItem =GAGameLoader.getStoreHandler().getStoreObjectForKey(this._store_id);
        var storeVisibleId = storeItem.parent.parent.visible_id;
        if(storeVisibleId == kSoreItems.kLocalFish)
		 {
			cellView._previewButton.setVisible(false);
			SocialUtil.setTextFont(cellView._sendButton);
			cellView._sendButton.setTextColor("FFFFFF");
			cellView._sendButton.setText('Send');
			cellView._sendButton.setVisible(true);
													 
			var timetoadulthood = storeItem.custom_attributes.timetoadulthood;
													 
			var sellPrices = GACommonUtils.getSellPrice(storeItem);
			var price = StoreUtil.getPrice(sellPrices);
			cellView._rightLabel2.setText(GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_SELL_FOR'),[price])); //Right Label1
			
			if(	timetoadulthood > 23)
			{
				timetoadulthood = timetoadulthood/24;
				timetoadulthood = Math.round(timetoadulthood*10)/10;
				cellView._rightLabel1.setText(	GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_GROW_IN_DAYS'),[timetoadulthood]));
			}
			else
			{
				cellView._rightLabel1.setText(	GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_GROW_IN_HRS'),[timetoadulthood]));
			}

		 }
		 else if(storeVisibleId == kSoreItems.kLocalDecorations)
		 {
			cellView._previewButton.setVisible(false); 
			SocialUtil.setTextFont(cellView._sendButton);
			cellView._sendButton.setTextColor("FFFFFF");
			cellView._sendButton.setText('Send');
			cellView._sendButton.setVisible(true);
			var happiness = storeItem.custom_attributes.happiness;
			var sellPrices = GACommonUtils.getSellPrice(storeItem);
			var price = StoreUtil.getPrice(sellPrices);
			cellView._rightLabel1.setText(GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_SELL_FOR'),[price])); //Right Label1
			cellView._rightLabel2.setText(	GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_HAPPINESS'),[happiness]));
		 }
		 else
		if(storeVisibleId == kSoreItems.klocalFoodBrick)
		 {
			cellView._previewButton.setVisible(false);
			SocialUtil.setTextFont(cellView._sendButton);
			cellView._sendButton.setTextColor("FFFFFF");
			cellView._sendButton.setText('Send');
			cellView._sendButton.setVisible(true);
			var lastFor = (storeItem.custom_attributes.foodbricktime)/24;
			cellView._rightLabel1.setText(GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_BRICK_LAST_FOR'),[lastFor])); //Right Label1
			cellView._rightLabel2.setText("");

		 } else
		 if(storeVisibleId == kSoreItems.kLocalPlants)
		 {
			 cellView._previewButton.setVisible(false);
			 SocialUtil.setTextFont(cellView._sendButton);
			 cellView._sendButton.setTextColor("FFFFFF");
			 cellView._sendButton.setText('Send');
			 cellView._sendButton.setVisible(true);
			 var happiness = storeItem.custom_attributes.happiness;
			 var sellPrices = GACommonUtils.getSellPrice(storeItem);
			 var price = StoreUtil.getPrice(sellPrices);
			 cellView._rightLabel1.setText(GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_SELL_FOR'),[price])); //Right Label1
			 cellView._rightLabel2.setText(	GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_HAPPINESS'),[happiness]));
			 
		 }
		else
		if(storeVisibleId == kSoreItems.kLocalBackgrounds)
		{
		    cellView._rightLabel1.setText("");	
			cellView._rightLabel2.setText("");
			SocialUtil.setTextFont(cellView._previewButton);
			cellView._previewButton.setTextColor("FFFFFF");
			cellView._previewButton.setText('Preview');
			cellView._previewButton.setVisible(true);
			SocialUtil.setTextFont(cellView._sendButton);
			cellView._sendButton.setTextColor("FFFFFF");
			cellView._sendButton.setText('Send');
			cellView._sendButton.setVisible(true);

		}
		 
//		 var isLocked = this.isItemLocked(cellView);
//		 if(isLocked)
//		 {
//			cellView._sendButton.setVisible(false);
//			cellView._lockImage.setVisible(true);
//		 }
//		 else
//		 {
//			 cellView._sendButton.setVisible(true);
//			 cellView._lockImage.setVisible(false);
//			 
//		 }
//		 
		 var isNew = storeItem.is_new;
		 if(isNew)
		 {
			 cellView._newImage.setVisible(true);
			 cellView._saleImage.setFrame([SocialUtil.getAdjustedY(2),SocialUtil.getAdjustedX(25),SocialUtil.adjustHeightWithDevice(25),SocialUtil.adjustWidthWithDevice(25)]);
		 }
		 else
		 {
			 cellView._newImage.setVisible(false);
		 } 
        this._setIconImage(cellView);
        
		this.cellView = cellView;
		
		this.setEnableButtons(true);
		
    },
    
    _setIconImage: function(cellView)
    {
		var obj = GAGameLoader.getStoreHandler().getStoreObjectForKey(this._store_id);
													  
		if(cellView.icon != null) {
			cellView.removeChild(cellView.icon);
			cellView.icon.destroy();
			cellView.icon = null;
		}
		
		var width,height,x,y;
		width = obj.custom_attributes.size_width;
		height = obj.custom_attributes.size_height;
		var size = SocialUtil.getAspectMaintainSize(new Core.Size(width,height),new Core.Size(46,46));
		width = size.getWidth();
		height = size.getHeight();
		x = (74-width)/2;
		y= (68-height)/2;
		
		cellView.icon = new GAStoreIcon();
		cellView.icon.setFrame([SocialUtil.getAdjustedY(x), SocialUtil.getAdjustedX(y), SocialUtil.getAdjustedY(width), SocialUtil.getAdjustedX(height)]);	
		cellView.icon.load(obj);
		cellView.addChild(cellView.icon);
		
	},
    
	sendButtonAction: function()
  	{
  		if(!this.getButtonsState())
  		{
  			NgLogE("SocialNeighbourGiftCell: sendButtonAction -> returning...");
  			return;
  		}
  		
	  	NgLogE("SocialNeighbourGiftCell: sendButtonAction -> checking if gift send allowed...");
	  	
	  	//this.setEnableButtons(false);
	  	
	  	var storeItem = this._cellModel;
	  	var buyPriceKey = GACommonUtils.getBuyPrice(storeItem)
		var currency = StoreUtil.getCurrency(buyPriceKey)
		var price = StoreUtil.getPrice(buyPriceKey);
	  	
	  	currency = (currency == kCurrencyType.kCurrencyTypeBucks) ? "bucks" : "coins";
	  	
	  	var message = GALocalizationHandler.getRelativeString(Core.Localization.getString("TF_SEND_GIFT_MESSAGE"),[price,currency]);
		var alertWindow = new SocialMiniUIAlertView("",message,this,GALocalizationHandler.getLocalizedString('TF_CANCEL_BUTTON'),GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
		alertWindow.setType("okwithcancel");
		alertWindow.setTagValue(kSocialTypes.SEND_MESSAGES);
		alertWindow.setMessageColor('FFFFFF');
		alertWindow.setButtonColor('FFFFFF');
		alertWindow.setMessageFont(SocialUtil.getFontName());
		alertWindow.setButtonsFont(SocialUtil.getFontName());
		alertWindow.show();
		
  	},
  	
  	previewButtonAction: function(cellView)
	{
	
		UIFactory.showProgressHUD(GALocalizationHandler.getLocalizedString('TF_FETCHINGDATA_LABEL'));//Fetching Data
		this._gaDownloader = new GAResourceDownloader(this._cellModel, this.resourceDownloadingSuccessfulForPreview.bind(this), this.resourceDownloadingFailed.bind(this), GAResourceType.kDetail);
		this._gaDownloader.startDownloading();
	},
	
	resourceDownloadingSuccessfulForPreview:function (savePath) 
	{

		var storeObjectType = StoreUtil.getStoreObjectType(this._cellModel);
		
		if(storeObjectType == kObjectType.kObjectBackground)
		{	
			this._basePath = TFUtil.getBasePathForResourceType(this._store_id,GAResourceType.kDetail);
			var storeBackground = GAGameLoader.getStoreHandler().getStoreObjectForKey(this._store_id);										 
			TFGameState.changeFileName(this._basePath,storeBackground);
			var pathImage = this._basePath+'/default.jpg';
			this.cellView._preview.setVisible(true);
			this.cellView._preview.setImage(pathImage,UI.State.Normal);
		}
		if(this._gaDownloader) 
		{
            this._gaDownloader.destroy();
            this._gaDownloader = null;
        }
		UIFactory.hideProgressHUD();	
		
	},
	
	resourceDownloadingFailed:function (errorCode, errorMsg)
	{
		UIFactory.hideProgressHUD();
        									 
        if(this._gaDownloader) 
		{
            this._gaDownloader.destroy();
            this._gaDownloader = null;
        }
        
        var message = GALocalizationHandler.getLocalizedString('TF_RESOURCE_NETWORK_TEXT');
       
        var alertWindow = new SocialMiniUIAlertView("",message,this,GALocalizationHandler.getLocalizedString('TF_CANCEL_BUTTON'),GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
		alertWindow.setType("ok");
		alertWindow.setMessageColor('FFFFFF');
		alertWindow.setButtonColor('FFFFFF');
		alertWindow.setMessageFont(SocialUtil.getFontName());
		alertWindow.setButtonsFont(SocialUtil.getFontName());
		alertWindow.show();
	
	},
	
	getButtonsState: function()
	{
		return this._enableButton;
	},
		
	
	setEnableButtons: function(value)
	{
		this._enableButton = value;
	},


    //********************Setters-Getters********************//
    
    _setIndexPath_Row:function($super,value)
    {
        $super(value);
    },
	
    _getIndexPath_Row: function($super)
    {
        return $super();
    },
    
    _setParentTableView: function($super,value)
    {
        $super(value);
    },
    
		_getParentTableView: function($super)			
    {
        return $super();
    },
    
    checkPricingForItemNew:function(store_item)
	{
		var buyPriceKey = GACommonUtils.getBuyPrice(store_item) , i =0;
		var buyPrice = StoreUtil.getPrice(buyPriceKey);
		var currency = StoreUtil.getCurrency(buyPriceKey);
		if(currency == kCurrencyType.kCurrencyTypeCoins) 
		{
			if(buyPrice >= 0)
			{
				var userCoins = DatabaseHelper.getCoins();
				if(userCoins >= buyPrice)
				{
					return "1|1";
				} 
				else
				{
					return "0|1";
				}
			}
		} 
		else 
		{
			if(buyPrice > 0) 
			{
				var userBucks = DatabaseHelper.getBucks();
				if(userBucks >= buyPrice) 
				{
					return "1|2";
				}
				else 
				{
					return "0|2";
				}
			}
		}
		return "0|0";
	
	},
	
	clickedButtonAtIndex: function(buttonIndex,alertView)
    {
        if (buttonIndex == 0) 
        {
            // Do it!
            this.setEnableButtons(true);
            
//            if(alertView.getTagValue() == TF_COINS_TAG)
//            {
//            	var inAppMainView = new InAppMainView(false);
//        		NGWindow.document.addChild(inAppMainView);
//              //  this._getParentTableView()._ParentMainView.removeFromParent();
//                this._getParentTableView()._ParentMainView.destroy();
//                return;
//            }
//            else if(alertView.getTagValue() == TF_BUCKS_TAG)
//            {
// 	          	var inAppMainView = new InAppMainView(true);
//        		NGWindow.document.addChild(inAppMainView);
//                this._getParentTableView()._ParentMainView.removeFromParent();
//                this._getParentTableView()._ParentMainView.destroy();
//                return;
//            }

            if(alertView.getTagValue() == kSocialTypes.SEND_MESSAGES)
            {
		        var canBuy = false;
				var storeItem = this._cellModel;
				var retValArray = this.checkPricingForItemNew(this._cellModel);
				retValArray = retValArray.split("|");
						
				var value1 = +retValArray[0];
				var value2 = +retValArray[1];
			
				if(value1 == 0 && value2 == 0)//unable to fetch from server
				{
					this.setEnableButtons(false);
					
					var message = GALocalizationHandler.getLocalizedString('TF_UNABLE_TO_FETCH_FROM_SERVER');
					var alertWindow = new SocialMiniUIAlertView("",message,this,GALocalizationHandler.getLocalizedString('TF_CANCEL_BUTTON'),GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
					alertWindow._type="ok";
					alertWindow.setMessageColor('FFFFFF');
					alertWindow.setButtonColor('FFFFFF');
					alertWindow.setMessageFont(SocialUtil.getFontName());
					alertWindow.setButtonsFont(SocialUtil.getFontName());
					alertWindow.show();
					
					return;
				}
				else if (!((value1 == 0 && value2 == 0) || (value1 == 0 && value2 == 1)))
				{
					canBuy = true;
				}
			
				if(!canBuy)
				{
					this.setEnableButtons(false);
					
					var message = GALocalizationHandler.getLocalizedString('TF_NO_COINS_MESSAGE_GIFT');
					
					var alertWindow = new SocialMiniUIAlertView("",message,this,GALocalizationHandler.getLocalizedString('TF_CANCEL_BUTTON'),GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
					alertWindow.setType("ok");
					alertWindow.setTagValue(TF_COINS_TAG);
					alertWindow.setMessageColor('FFFFFF');
					alertWindow.setButtonColor('FFFFFF');
					alertWindow.setMessageFont(SocialUtil.getFontName());
					alertWindow.setButtonsFont(SocialUtil.getFontName());
					alertWindow.show();
					return;
				}
		        
				if (value1 == 0 && value2 == 2) 
		        {
		        	this.setEnableButtons(false);
		        	
					var message = GALocalizationHandler.getLocalizedString('TF_NO_BUCKS_MESSAGE_GIFT');
		
					var alertWindow = new SocialMiniUIAlertView("",message,this,GALocalizationHandler.getLocalizedString('TF_CANCEL_BUTTON'),GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
					alertWindow.setType("ok");
					alertWindow.setTagValue(TF_BUCKS_TAG);
					alertWindow.setMessageColor('FFFFFF');
					alertWindow.setButtonColor('FFFFFF');
					alertWindow.setMessageFont(SocialUtil.getFontName());
					alertWindow.setButtonsFont(SocialUtil.getFontName());
					alertWindow.show();
					
					return;
				}
				
				UIFactory.showProgressHUD("Sending gift...");
				
				//will acknowledge a received gift
//		    	console.log("SocialNeighbourGiftCell: clickedButtonAtIndex: -> sending gift ...");
		   	
		    	SocialManager.handleSocialAction(kSocialTypes.SEND_GIFTS,this._cellModel);
		        
            }

        } 
        else if (buttonIndex == 1) 
        {
            this.setEnableButtons(true);
        }
        
    },
	

    destroy: function($super) 
	{
		$super();
	}
	
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/SocialAPI/SocialUtil/SocialMiniUIAlertView'] = function(){var exports = $MODULE_REGISTRY['Code/SocialAPI/SocialUtil/SocialMiniUIAlertView'] || {}; $MODULE_REGISTRY['Code/SocialAPI/SocialUtil/SocialMiniUIAlertView'] = exports; 
//Default type for alert window
var kALERT_WINDOW_TYPE = "ok"
var kALERT_WINDOW_TYPE_WITH_CANCEL = "okwithcancel"
	
exports.SocialMiniUIAlertView = GAUIAlertView.subclass({
	classname: 'SocialMiniUIAlertView',
	initialize: function($super,initWithTitle,message,delegate,cancelButtonTitle,otherButtonTitles) 
	{
		$super(initWithTitle,message,delegate,cancelButtonTitle,otherButtonTitles);
	},
	
	loadView: function($super)
	{
		$super();
		var frame=null;
	 	var x = (480/2) - (310/2);
		var y = (300/2) - (119/2);
		this._backgroundImage.setFrame([this.getAdjustedY(x),this.getAdjustedX(y),this.adjustHeightWithDevice(300),this.adjustWidthWithDevice(150)]);
		frame=[this.getAdjustedY(x+115),this.getAdjustedX(y+100),this.adjustHeightWithDevice(73),this.adjustWidthWithDevice(37)];
		this._okButton.setFrame(frame);
		if( this._type == kALERT_WINDOW_TYPE_WITH_CANCEL)
		{
			frame=[this.getAdjustedY(x+65),this.getAdjustedX(y+100),this.adjustHeightWithDevice(73),this.adjustWidthWithDevice(37)];
			this._okButton.setFrame(frame);
			
			frame=[this.getAdjustedY(x+150),this.getAdjustedX(y+100),this.adjustHeightWithDevice(73),this.adjustWidthWithDevice(37)];
			this._cancelButton.setFrame(frame);
		}
		this._scrollView.removeChild(this._messageLabel);
		this.removeChild(this._scrollView);
		this.addChild(this._messageLabel);
		this._messageLabel.setFrame([this.getAdjustedY(x+10),this.getAdjustedX(y+20),this.adjustHeightWithDevice(280),this.adjustWidthWithDevice(50)]);
		this._titleLabel.setFrame([this.getAdjustedY(x+60),this.getAdjustedX(y+20),this.adjustHeightWithDevice(100),this.adjustWidthWithDevice(30)]);
	},
	
	
	destroy: function($super)
	{
		$super();	
	}
	
	
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/SocialAPI/SocialMessagesHandler'] = function(){var exports = $MODULE_REGISTRY['Code/SocialAPI/SocialMessagesHandler'] || {}; $MODULE_REGISTRY['Code/SocialAPI/SocialMessagesHandler'] = exports; /**
 * Author: Ahsan Zaheer
 * Updated By: Moiez Ul Hasnain
 */


var SendMessageHandler = Core.Class.subclass({
	
	initialize:function(_type, parentHandler)
	{
		this._type = _type;
		this._parent = parentHandler ;
	},
	
	 webFetchSuccess : function(webFetcher, responseData){
		try{
			var jsonResponse = eval("(" + responseData + ")");
			NgLogE("SendMessageHandler: responseData -> "+responseData);
			
			if(jsonResponse.status != 'OK'){
				//this is the real error condition
				NgLogE("SendMessageHandler -> Response not OK!");
				this._parent.showErrorMessage(Core.Localization.getString('SOCIAL_SENDING_MESSAGE_FAILED'),'2222');
			} else {
				this._parent.showSuccessMessage(Core.Localization.getString('SOCIAL_SENDING_MESSAGE_SUCCESSFUL'),'1111');
			}
		}catch(exception){
			
			throw exception;
		}
		
		if(webFetcher != null){
			webFetcher.destroy();
			webFetcher = null;
		}
		
		this._type =  null;
	},
	
	webFetchFailure : function(webFetcher, errorCode){	
		var errorMsg = "SendMessageHandler::webFetchFailure() responseStatusCode = > " + errorCode;
		this._parent.showErrorMessage(Core.Localization.getString('SOCIAL_SENDING_MESSAGE_FAILED'),'2222');
		//GALogger.logWithLevel(errorMsg,LOG_LEVEL.LOG_NONFATAL_ERROR);
		if(webFetcher != null){
			webFetcher.destroy();
			webFetcher = null;
		}

		NgLogE(errorMsg);        	
        
	},
	
	destroy:function()
	{
		
	},
	
});

exports.SocialMessagesHandler = Core.Class.singleton(
{
    classname: 'SocialMessagesHandler',
        
    initialize: function() 
    {
    	this._CannedMessageslist = null ;
    	this._messageList = new Array() ;
    	console.log("SocialMessagesHandler");
    	this.msg = null ;
    	this.popupEnabled = false;
    },
    
    performMessageAction: function(actionType)
	{
    	if(actionType == kSocialTypes.GET_CANNED_MESSAGES && (this._CannedMessageslist != null && this._CannedMessageslist != 'undefined'))
    	{
    		SocialManager.callBackSocialCannedMessagesList(this._CannedMessageslist) ;
    		return ;
    	} 
    	var url = SocialUtil.getSocialActionURL(actionType) ;
		this._webFetcher = new GAWebFetcher(this, 30, 0);
		this._webFetcher.invokeGetRequest(url);
		
	},
	
	webFetchSuccess : function(webFetcher, responseData){
		try{
			var jsonResponse = eval("(" + responseData + ")");
			var url = webFetcher._request.settings.url ;
			url = decodeURI(url) ;
			url = url.split("/") ;
			var requestType = url[url.length-1].split("?") ;
			console.log("message webFetchSuccess");
			console.log("message jsonResponse: " + jsonResponse);			
			if(jsonResponse.status != 'OK'){
				//this is the real error condition
				NgLogE("SocialMessagesHandler -> Response not OK!");
				if(jsonResponse.status == "NO_MSG") {
					if(this._messageList !=null && this._messageList.length != 0)
					{
						this._messageList.splice(0, this._messageList.length);
						this._messageList = new Array() ;
					}
					SocialManager.callBackSocialMessagesList(this._messageList) ;
					return ;
				}
					NgLogE("SocialMessagesHandler -> Invalid response received!");
					this.showErrorMessage(Core.Localization.getString('SOCIAL_RECEIVING_MESSAGES_FAILED'),requestType[0]);
					this._CannedMessageslist = null ;

			}
			else{
				switch(requestType[0]) {
					case "precannedMessage" :
						this._CannedMessageslist = jsonResponse.list;
						for (var temp = 0; temp < this._CannedMessageslist.length; temp++)
							if (this._CannedMessageslist[temp] == "")
								this._CannedMessageslist.splice(temp, 1) ;
						SocialManager.callBackSocialCannedMessagesList(this._CannedMessageslist) ;
					break ;
					
					case "messageCount" :
						this._msgCount = jsonResponse.count ;
						SocialManager.showMessageCount(this._msgCount) ;
					break ;
					
					case "message" :
						if(this._messageList !=null && this._messageList.length != 0)
						{
							this._messageList.splice(0, this._messageList.length);
							this._messageList = new Array() ;
						}
						var SocialMessageModel = require('Code/SocialAPI/SocialModelClasses/SocialMessageModel').SocialMessageModel;
						for (var index = 0; index< jsonResponse.msgs.length; index++){
							var sname= jsonResponse.msgs[index].susername;
							if(!SocialUtil.isUserBlocked(sname)) {
								var message = new SocialMessageModel(jsonResponse, index)
								this._messageList.push(message) ;
							}
						}
						SocialManager.callBackSocialMessagesList(this._messageList) ;
					break ;
				}
			}
		}catch(exception){
			console.log("faizan : " + exception);
			this.showErrorMessage(Core.Localization.getString('SOCIAL_RECEIVING_MESSAGES_FAILED'),'3333');
			
		}
		
		if(webFetcher != null){
			webFetcher.destroy();
			webFetcher = null;
		}
	},
	
	webFetchFailure : function(webFetcher, errorCode){	
		console.log("message webFetchFailure");
		var errorMsg = "SocialMessagesHandler::webFetchFailure() responseStatusCode = > " + errorCode ;
		GALogger.logWithLevel(errorMsg,LOG_LEVEL.LOG_NONFATAL_ERROR);
		
		
		this._CannedMessageslist = null ;
		
		var url = webFetcher._request.settings.url ;
		url = decodeURI(url) ;
		url = url.split("/") ;
		var requestType = url[url.length-1].split("?") ;
		this.showErrorMessage(Core.Localization.getString('SOCIAL_RECEIVING_MESSAGES_FAILED'),requestType[0]);
		if(webFetcher != null){
			webFetcher.destroy();
			webFetcher = null;
		}
	},
	
	sendMessage: function(msg) {
		this.msg = msg ;
		var url = SocialUtil.getSocialActionURL(kSocialTypes.SEND_MESSAGES);
		receiverName=msg.getReceiverName();
		if(receiverName == 0 || receiverName == '')
    	{
    		receiverName=TFGameState._neighborName;
    	}
		var params = "sgame="+msg.getSenderGame()+"&suserid="+msg.getSenderName()+"&susername="+msg.getSenderName()+"&rgame="+msg.getReceiverGame()+
			    	"&ruserid="+receiverName+"&rusername="+receiverName+"&message="+msg.getSenderMessage() ;		
		NgLogE("SocialMessagesHandler -> params  -> "+params);
		
		var msgSender = new SendMessageHandler(kSocialTypes.SEND_MESSAGES, this);
		
		this._webFetcher = new GAWebFetcher(msgSender, 30, 0);
		UIFactory.showProgressHUD('Sending Message');
		this._webFetcher.invokePostRequest(url, params, true);
	},
	
	clickedButtonAtIndex: function(buttonIndex,alertView)
	{
		this.popupEnabled = false;
		NgLogE("SocialMessagesHandler ->clickedButtonAtIndex button index"+buttonIndex);
		if (buttonIndex == 0) 
		{
			if(alertView.getTagValue() == '1111')
			{
				NgLogE("SocialMessagesHandler -> Sending Message Success OK.");
				if(!SocialManager.socialView.isatNeighbour)
					SocialManager.socialView.showMessageView() ;
				else
					SocialManager.socialView.showReplyMessageView(this.msg.getReceiverName()) ;
			}
			
			if(alertView.getTagValue() == '2222')
			{
				NgLogE("SocialMessagesHandler -> Sending Message Failed. Retrying.");
				this.sendMessage(this.msg) ;
			}
			
			if(alertView.getTagValue() == "messageCount")
			{
				NgLogE("SocialMessagesHandler -> Retreiving Messages Count Failed. Retrying.........");
				this.performMessageAction(kSocialTypes.GET_MESSAGE_COUNT) ;
			}
			
			if(alertView.getTagValue() == "message")
			{
				NgLogE("SocialMessagesHandler -> Retreiving Messages List Failed. Retrying.........");
				this.performMessageAction(kSocialTypes.RECEIVE_MESSAGES) ;
			}
			
			if(alertView.getTagValue() == "precannedMessage")
			{
				NgLogE("SocialMessagesHandler -> Retreiving PreCanned Messages Failed. Retrying.........");
				this.performMessageAction(kSocialTypes.GET_CANNED_MESSAGES) ;
			}
		} 
	},
	
	showErrorMessage:function(message, tag)
	{	
		console.log("message errorMessage :" + tag);
		UIFactory.hideProgressHUD();
		message = 'Network error. Please make sure you are connected with internet.';
		if(!this.popupEnabled){
			this.popupEnabled = true;
			var userMessAlert =  new SocialMiniUIAlertView("",message,this,Core.Localization.getString('TF_CANCEL_BUTTON'),GALocalizationHandler.getLocalizedString('TF_RETRY_LABEL'));
			userMessAlert.setTagValue(tag);
			userMessAlert.setMessageColor("FFFFFF");
			userMessAlert.setMessageFont(TFUtil.getFontName());
			userMessAlert.setButtonsFont(TFUtil.getFontName());
			userMessAlert.setButtonColor("FFFFFF");
			userMessAlert.show();
		}
	},
	
	showSuccessMessage:function(message, tag)
	{	
		UIFactory.hideProgressHUD();
		var alertWindow = new SocialMiniUIAlertView("",message,this,null,GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
       	alertWindow.setTagValue('1111');
        alertWindow.setMessageColor("FFFFFF");
		alertWindow.setMessageFont(SocialUtil.getFontName());
		alertWindow.setButtonsFont(SocialUtil.getFontName());
		alertWindow.setButtonColor("FFFFFF");
		alertWindow.show() ;
	},
	
	destroy: function() {
		if(this._webFetcher)
			this._webFetcher.destroy() ;
		if(this.msg)
			this.msg.destroy() ; 
	}

});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/SocialAPI/VisitNeighbor'] = function(){var exports = $MODULE_REGISTRY['Code/SocialAPI/VisitNeighbor'] || {}; $MODULE_REGISTRY['Code/SocialAPI/VisitNeighbor'] = exports; /* Tank.js
 * ngFish
 
 * Created by Kamran.Lodhi on 5/17/11.
 * Copyright 2011 __MyCompanyName__. All rights reserved.
 */
exports.VisitNeighbor = Core.Class.subclass({
	classname : 'VisitNeighbor',

	initialize : function() {
		TFGameState.isNeighborResourceDownloaded = false;
		TFGameState.atNeighbor = true;
	},

	goToNeighbor : function() {
		if(SocialUtil.isVisitingNeighbor()){
			return;
		}
		SocialUtil.setVisitingNeighbor(true);
		GameCentralHandler.startGameLoadingScreen();
		console.log("goToNeighbor started");
		GAGameStateGetHandler.getNeighborState(true, this);
		console.log("goToNeighbor ended");
	},
	
	goToNeighborWithName : function(username) {
		if(SocialUtil.isVisitingNeighbor()){
			return;
		}
		SocialUtil.setVisitingNeighbor(true);
		GameCentralHandler.startGameLoadingScreen();
		console.log("goToNeighborWithName started");
		GAGameStateGetHandler.getNeighborStateWithName(true, this, username);
		console.log("goToNeighborWithName ended");
	},
	
	goToFriend : function(username) {
		if(SocialUtil.isVisitingNeighbor()){
			return;
		}
		SocialUtil.setVisitingNeighbor(true);
		GameCentralHandler.startGameLoadingScreen();
		console.log("goToNeighbor started");
		console.log("aleeem: username " + username);
		TFGameState._neighborName = username;
		GAGameStateGetHandler.getFriendState(true, this, username);
		console.log("goToNeighbor ended");
		TFGameState.isFriend = true;
	},

	gameStateGetSuccess : function(path) {
		SocialUtil.setVisitingNeighbor(false);
		console.log("gameStateGetSuccess started " + path);
		DatabaseHelper.loadUser();
		console.log("old user laoded to Database Helper");
		//DatabaseInterface.loadNeighbor(path);
		console.log("gameStateGetSuccess ended");
	},

	gameStateGetFailure : function() {
		SocialUtil.setVisitingNeighbor(false);
		var failureAlert =  new GAUIAlertView("",GALocalizationHandler.getLocalizedString('TF_NEIGHBOR_FAILED'),this,GALocalizationHandler.getLocalizedString('TF_CANCEL_BUTTON'),GALocalizationHandler.getLocalizedString('TF_RETRY_BUTTON'));
		failureAlert.setTagValue(0001);
		failureAlert.setMessageColor("FFFFFF");
		failureAlert.setMessageFont(TFUtil.getFontName());
		failureAlert.setButtonsFont(TFUtil.getFontName());
		failureAlert.setButtonColor("FFFFFF");
		failureAlert.show();
	},
	
	clickedButtonAtIndex: function(buttonIndex,alert)
	{
		
		if (buttonIndex == 0) 
		{
			switch(alert.getTagValue())
			{
				case 0001:
				{
					GAGameStateGetHandler.getNeighborState(true, this);
				}
				default:
				{
					
				}
			}
			
		}
		else if(buttonIndex == 1)
		{
			TFGameState.atNeighbor = false;
			GameCentralHandler.endGameLoadingScreen();
			
		}
		
	},



	destroy : function() {
	}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/SocialAPI/DatabaseHelper'] = function(){var exports = $MODULE_REGISTRY['Code/SocialAPI/DatabaseHelper'] || {}; $MODULE_REGISTRY['Code/SocialAPI/DatabaseHelper'] = exports; /**
 * 
 */

exports.DatabaseHelper = Core.Class.singleton(
{
classname: 'DatabaseHelper',
	
	initialize: function()
	{
		this.user = null;
		
		
	},	
	
	loadUser:function(){
		console.log("loadUser started");
		var resources = ["User","GameLevels"];
		GAPersistenceManager.loadResources(resources, this.myProgress.bind(this), this.loadUserAndTank.bind(this), this.resourceLoadingFailureForSelectedTank.bind(this), false);
		console.log("User Loaded");
		console.log("loadUser ended");
	},
	
	myProgress:function (loaded, total) 
	{
												 
	},

	loadUserAndTank: function() 
	{
		console.log("loadUserAndTank started");
		var userObj = GAPersistenceManager.getResource("User");
		
		var levelInfo = GAPersistenceManager.getResource("GameLevels");
		
		this.user = new User();
		this.user._userObj = userObj;
		
		TFGameState.setLevelInfo(levelInfo);
		var resources = ['Tank'+this.user._userObj.selectedTankId];
		GAPersistenceManager.loadResources(resources, this.defaultTankProgress.bind(this), this.resourceLoadedForSelectedTank.bind(this),this.resourceLoadingFailureForSelectedTank.bind(this), false);
		console.log("loadUserAndTank ended");

	},
	
	updateCurrency:function (type, currency)
	{	
		
		if(currency < 0) {
			currency = 0;
		}
		switch (type) {
			case kOperationType.kOperationAddCoins:
			{
				this.user._userObj.coins = this.user._userObj.coins + currency;
				break;
			}
			case kOperationType.kOperationSubtractCoins:
			{
				this.user._userObj.coins = this.user._userObj.coins - currency;
				
				break;
			}
			case kOperationType.kOperationAddBucks:
			{	
				this.user._userObj.fish_bucks = this.user._userObj.fish_bucks + currency;
				break;
			}
			case kOperationType.kOperationSubtractBucks:
			{
								   
				this.user._userObj.fish_bucks = this.user._userObj.fish_bucks - currency;
				break;	
			}
			default:
				break;
		}
		
		if(this.user._userObj.coins > TF_MAX_USER_COINS) {
			this.user._userObj.coins = TF_MAX_USER_COINS;
		}
		if(this.user._userObj.coins <= 0) {
			this.user._userObj.coins = 0;
		}
		
		if(this.user._userObj.fish_bucks > TF_MAX_USER_BUCKS) {
			this.user._userObj.fish_bucks = TF_MAX_USER_BUCKS;
		}
		if(this.user._userObj.fish_bucks <= 0) {
			this.user._userObj.fish_bucks = 0;
		}
		
		DatabaseInterface.updateUser();
	},
	
	updateXPandLevel: function(amount){
		this.user.updateXPandLevel(amount);
	},
	
	updateUser: function(){
		this.user._userObj.persist();
	},

	
	defaultTankProgress:function (loaded, total) 
	{
												 
	},
	
	resourceLoadedForSelectedTank: function(){
		console.log("resourceLoadedForSelectedTank started");
		console.log("resourceLoadedForSelectedTank ended");
		DatabaseInterface.loadNeighbor('./Content/db/random/');
	},
	
	resourceLoadingFailureForSelectedTank: function(){
		console.log("resourceLoadingFailureForSelectedTank started");
		console.log("resourceLoadingFailureForSelectedTank ended");
	},
	
	////////////////////////////////////////////////////////////////////////////////
	
	getCoins: function()
	{
			return this.user._userObj.coins;
	},
	
	getBucks: function()
	{
		return this.user._userObj.fish_bucks;
	},
	
	destroy: function(){
		
	},
});

; return exports;};
$MODULE_FACTORY_REGISTRY['Code/SocialAPI/SocialActionsHandler'] = function(){var exports = $MODULE_REGISTRY['Code/SocialAPI/SocialActionsHandler'] || {}; $MODULE_REGISTRY['Code/SocialAPI/SocialActionsHandler'] = exports; /**
 * Author: Ahsan Zaheer
 */

exports.SocialActionsHandler = Core.Class.singleton(
{
    classname: 'SocialActionsHandler',
        
    initialize: function() 
    {
    	//console.log("SocialManger ::SocialActionsHandler ");
    	this._actionHandlerObject = null;
    	this._neighborActionArray = new Array();
    	//load gifts at initialization
    	//console.log("SocialActionsHandler");
    	//this.getActionsPerformed();
    },
    
    neighborTankActions: function(cleanTime,feedTime,giftTime,reviveTime){
		if(!cleanTime)
			cleanTime = 0.000;
		if(!feedTime)
			feedTime = 0.000;
		if(!giftTime)
			giftTime = 0.000;
		if(!reviveTime)
			reviveTime = 0.000;
			
		//console.log("ahsan:-> SocialActionsHandler-> neighborTankActions cleanTime "+cleanTime+" feedTime :: "+feedTime+" reviveTime :: "+reviveTime );

	//	var userActionInfo = {"user-info":{"name":GAConfigurations._userInfo(),"udid":GAConfigurations.getUdid(),"game":GAConfigurations.getGameName()},"actions":{"clean":currentTime,"feed":currentTime, "tank_id":"ab12"}};
			
		var action  =  this.createJsonRequest(GAConfigurations.getUserId(),TFGameState.getCurrentUser()._userObj.name,cleanTime,feedTime,giftTime,reviveTime ); 
		this.postNeighborActionInfo(action,GAConfigurations.getUserId()); // for Current User
		if(!giftTime)
			this.postNeighborActionInfo(action,TFGameState.getCurrentUser()._userObj.name); // for neighbor
		

	},
	
	
	generateGiftNotification: function(giftTime){

		console.log("SocialActionsHandler :-> generateGiftNotification -> giftTime -> "+giftTime);

		if(!giftTime)
			giftTime = 0.000;

	//	var userActionInfo = {"user-info":{"name":GAConfigurations._userInfo(),"udid":GAConfigurations.getUdid(),"game":GAConfigurations.getGameName()},"actions":{"clean":currentTime,"feed":currentTime, "tank_id":"ab12"}};
			
		var action  =  this.createJsonRequest(GAConfigurations.getUserId(),TFGameState.getCurrentUser()._userObj.name,0.00,0.00,giftTime,0.00); 
		this.postNeighborActionInfo(action,GAConfigurations.getUserId()); // for Current User
		//this.postNeighborActionInfo(action,TFGameState.getCurrentUser()._userObj.name); // for neighbor

	},
	
	createJsonRequest: function (uname,rname,cleanTime,feedTime,giftTime,reviveTime) {

		var tankID = -1;
		if(TFGameState.isFriend)
			tankID = TFGameState.getCurrentUser()._userObj.selectedTankId;
			
		var userActionInfo = "{\"user-info\":{\"name\":\""+uname+"\",\"udid\":\""+uname+"\",\"game\":\"ngFish\",\"rname\":\""+rname+"\"},\"actions\":{\"clean\":\""+cleanTime+"\",\"feed\":"+feedTime+",\"gift\":"+giftTime+",\"revive\":"+reviveTime+",\"tank_id\":\"" + tankID+ "\"}}";
		console.log("userActionInfo:: " + userActionInfo);
		return userActionInfo;
	},
	
	
	
	postNeighborActionInfo: function(action,udid)
	{	
		//console.log("Posting Actions performed on neighbor's tank");
    	//url = "https://devsocialnotifications.appspot.com/neighborAction";
		
    	//console.log("FETCHING GAME : "+GAConfigurations.getGameName());
		//nGame = "ngFish";																//have to change it to getGame();
    	//userName = GAConfigurations.getUserId();//"2";					//have to change it to getUdid();
    	//rName = TFGameState.getCurrentUser()._userObj.name;
    	var params = "action="+action+"&game="+"ngFish"+"&udid="+udid;
    	var url = SocialUtil.getSocialActionURL(kSocialTypes.SEND_NEIGHBOR_ACTION);
    	this.postRequest(params, url, kSocialTypes.SEND_NEIGHBOR_ACTION);
		
	},
    
	postRequest : function (params, url, type) {
		
		var postNeighborActionHandler = new POSTNeighborActionHandler(type);				//(kSocialTypes.SEND_NEIGHBOR_ACTION);
		var webFetcher = new GAWebFetcher(postNeighborActionHandler, 30, 0);
		webFetcher.invokePostRequest(url, params, true);
	},
	
    getActionsPerformed: function()
	{
		if(TFGameState.atNeighbor)
    	{
    		return;
    	}
    	if(this._neighborActionArray.length > 0) {
    		SocialManager.callBackNotificaitonsList(this._neighborActionArray);
    	}
    	else {
//    		console.log("FETCHING ACTIONS PERFORMED ON USER TANK");
	    	//console.log("FETCHING GAME : "+GAConfigurations.getGameName());
	    	//console.log("FETCHING GAME : "+GAConfigurations.getGameName());
	    	var url = SocialUtil.getSocialActionURL(kSocialTypes.GET_NEIGHBOR_ACTION) ;
			//NgLogE("SocialActionsHandler: URL for notifications -> "+url);		
			var webFetcher = new GAWebFetcher(this, 30, 0);
			//var consolidatedURL = 'http://devsocialnotifications.appspot.com/precannedMessage?game=ngFish&language=';   
			webFetcher.invokeGetRequest(url);
    	}
		
	},
	
	getNeighborActionArray: function()
	{
		//console.log("getNeighborActionArray " + this._neighborActionArray);
		return this._neighborActionArray;
	},
	
	setNeighborActionArray: function(neighborActionArray)
	{
		this._neighborActionArray = neighborActionArray;
	},
	
	clearNeighborActionArray: function () {
//		console.log("sarmad: SocialActionsHandler=>clearNeighborActionArray");
		if(this._neighborActionArray) {
			delete this._neighborActionArray;
		}
		this._neighborActionArray = new Array();
		
	},
	acknowledgeNeighborAction: function(){
		
		var url = SocialUtil.getSocialActionURL(kSocialTypes.ACK_NOTIFICATIONS);
		var params = "udid=" + GAConfigurations.getUserId() + '&game=' + 'ngFish';
		this.postRequest(params, url, kSocialTypes.ACK_NOTIFICATIONS);
		this.clearNeighborActionArray();
		
	},

	webFetchSuccess : function(webFetcher, responseData){
		try{
			//console.log("SocialActionsHandler :: responseData " + responseData);
			var jsonResponse = eval("(" + responseData + ")");
			var actions = jsonResponse.actions;
			if((jsonResponse.status != 'OK') && (jsonResponse.status != 'NO_ACTIONS')){
				console.log("SocialActionsHandler -> Response not OK!");
				 SocialManager.showFailurePromptWithMessage('Network error. Please make sure you are connected with internet.');
			}
			
			else if (jsonResponse.status == 'NO_ACTIONS')
			{
//				console.log("SocialActionsHandler -> No actions performed! ON YOUR TANK");
			}
			
			else{
//				console.log("SocialActionsHandler :: webFetchSuccess :: -> Response OK!");
//				PARSING ACTIONS
				var actionHandlerObject= new GAActionsReceivedResponse(jsonResponse);
				actionHandlerObject.parseSocialActionsReceivedResponse();
				this._neighborActionArray = actionHandlerObject.getActionsArray();
				
			}
		
		}catch(exception){
			console.log("SocialActionsHandler exception :: "+exception);
		}
		
		if(webFetcher != null){
			webFetcher.destroy();
			webFetcher = null;
		}
		this.neighborActionWebFetchCallBack(this._neighborActionArray);
	},
	webFetchFailure : function(webFetcher, errorCode){	
		var errorMsg = "SocialActionsHandler::webFetchFailure() responseStatusCode = > " + errorCode ;
		GALogger.logWithLevel(errorMsg,LOG_LEVEL.LOG_NONFATAL_ERROR);
		if(webFetcher != null){
			webFetcher.destroy();
			webFetcher = null;
		}
	},
	
	////////////////////////////////////////////////////////////TRUE CLEANING / FEEDING STARTS
	neighborActionWebFetchCallBack: function(_neighborActionArray){
    	
    	if(_neighborActionArray){
    		this._neighborActionArray = _neighborActionArray;
    	}
    	else{
    		//this._neighborActionArray = SocialActionsHandler.getNeighborActionArray();
    	}
    	if(this._neighborActionArray)
		{
    		this.tanksDict = new GAMutableDictionary();
			var actions = this._neighborActionArray;
			
			for(var i =0 ; i < actions.length ; i++){
				var actionsModel = actions[i];
				var _actionPerformed = actionsModel.getActionPerformed();
				
//				if(_actionPerformed == kSocialFriendActionType.CLEAN_TANK)
				
//					console.log("SocialManager: actions ->  actionsModel.getTankId() :: "+actionsModel.getTankId() );
					
					if(TFGameState.getCurrentUser()._userObj.selectedTankId.toString() ==  actionsModel.getTankId())
					{
						console.log("_actionPerformed::" + _actionPerformed);
						if(_actionPerformed == kSocialFriendActionType.CLEAN_TANK){
						
							timeStamp = actionsModel.getCleanTimeStamp();
							if(GameLayer.getSelectedTank().tankModel._tankObj.lastCleaned <  timeStamp){
                               GameLayer.getSelectedTank().removeAlgae();
                               GameLayer.getSelectedTank().tankModel.updateTankLastCleanedToTime(timeStamp);
                               //console.log("ahsan >> inside IF : ");
                       		 }
						}
						
						else if(_actionPerformed == kSocialFriendActionType.FEED_FISH){
    						
    						
    						timeStamp = actionsModel.getFeedTimeStamp();
                            if(GameLayer.getSelectedTank().tankModel._tankObj.lastFed <  timeStamp){
                               GameLayer.getSelectedTank().tankModel.updateFishFed(timeStamp);
						    }
						}
						
						else if(_actionPerformed == kSocialFriendActionType.REVIVE_FISHES){
							timeStamp = actionsModel.getReviveTimeStamp();
							GameLayer.getSelectedTank().reviveAllDeadFish();
						}
						
					}
					else
					{
//						console.log("SocialManager: If is NOT SelectedTank" );
						console.log("SocialManager: actionsModel.getTankId() "  + actionsModel.getTankId());
						if ( TFGameState.getCurrentUser()._userObj.tankArray[actionsModel.getTankId()] ){
							
							var _actionPerformed = actionsModel.getActionPerformed();
//							console.log("SocialManager: _actionPerformed  " +_actionPerformed);
							if(this.tanksDict.objectForKey(actionsModel.getTankId())){
//								console.log("SocialManager: this.tanksDict.objectForKey(actionsModel.getTankId())  " +this.tanksDict.objectForKey(actionsModel.getTankId()));
								
								if(_actionPerformed == kSocialFriendActionType.CLEAN_TANK){
									this.tanksDict.objectForKey(actionsModel.getTankId()).cleanTime = actionsModel.getCleanTimeStamp();
									//timeStamp = actionsModel.getCleanTimeStamp();
								}
								else if(_actionPerformed == kSocialFriendActionType.FEED_FISH){
									
									this.tanksDict.objectForKey(actionsModel.getTankId()).feedTime = actionsModel.getFeedTimeStamp();	
									//timeStamp = actionsModel.getFeedTimeStamp();
								}
								else if(_actionPerformed == kSocialFriendActionType.REVIVE_FISHES){
									console.log("SocialManager REVIVE_FISHES _actionPerformed  " +_actionPerformed);
									this.tanksDict.objectForKey(actionsModel.getTankId()).reviveTime = actionsModel.getReviveTimeStamp();	
									//timeStamp = actionsModel.getFeedTimeStamp();
								}
							}
							else{
								cleanTime = actionsModel.getCleanTimeStamp();
								feedTime = actionsModel.getFeedTimeStamp();
								reviveTime = actionsModel.getReviveTimeStamp();
								var temp = new ActionItems(cleanTime,feedTime,reviveTime);
								this.tanksDict.setObject(actionsModel.getTankId(),temp);
							}
							

						}
						else{
							console.log("SocialManager: Tank not available" );
						}
						//SocialActionsHandler.setNeighborActionArray(actions);
					}
			}
			
			var keys = this.tanksDict.allKeys();
			
			var resources = new Array();
			
			for (var i = 0 ; i < keys.length ; i++){
			//	console.log("SocialManager: looping ");
				resources.push('Tank'+keys[i]);
			}
			
			if(this._neighborActionArray.length >=2)
    		{
    			//sort
				this._neighborActionArray.sort(function(a,b){return b.getUnixTimeStamp() - a.getUnixTimeStamp()});
    		}
			if (keys.length>0){
				//console.log("SocialManager :: resources " +resources);
				this.loadTankResouces(resources,keys);
			}
			else {
				SocialManager.callBackNotificaitonsList(this._neighborActionArray);
			}
		}
    },
    
    
    loadTankResouces: function(resources,keys){
    	
    	
    	//console.log("SocialManager :: loadResourcesForSelectedTank started  tankToLoad "+resources );//+ " :: cleanTime  "+actionsModel.cleanTime+ " :: feedTime  "+actionsModel.feedTime);
		//var resources = ['Tank'+tankToLoad];
		GAPersistenceManager.loadResources(resources, this.defaultTankProgress.bind(this), this.resourceLoadedForTank.bind(this,resources,keys),this.resourceLoadingFailureForSelectedTank.bind(this), null);
		//console.log("SocialManager :: loadResourcesForSelectedTank ended tankToLoad "+resources);
    },
    
    defaultTankProgress: function(){
    	
//    	console.log("SocialManager :: defaultTankProgress resources : ");///*+resources + */" ab " +ab +  " tf "+tf );
    },
    
    resourceLoadedForTank: function(resources,keys){
 
    	//console.log("SocialManager :: resourceLoadedForTank "+resources);
		this.performOperation(resources,keys);
    },
    
    resourceLoadingFailureForSelectedTank: function(){
    	
    	console.log("SocialManager :: resourceLoadingFailureForSelectedTank ");
    },
    
    
    performOperation: function(resources,keys){
    	//console.log("SocialManager :: performOperation ");
    	
    	for ( var i = 0 ; i < resources.length ; i++){
    		
    		var resource = resources[i];
    		var myTankObj = GAPersistenceManager.getResource(resource);
        	var tankToLoad = keys[i];
        	var temp = this.tanksDict.objectForKey(tankToLoad);

    		if(myTankObj)
    		{
    			if(( temp.cleanTime != 0.00 )&&(myTankObj.lastCleaned < temp.cleanTime )){
    				myTankObj.lastCleaned = temp.cleanTime;
    			//	console.log("SocialManager :: CLEANING");
    			}
    			if(( temp.feedTime != 0.00 )&&(myTankObj.lastFed < temp.feedTime )){
    				myTankObj.lastFed = temp.feedTime;
    				for (objId in myTankObj.Store_Items.tank_fishArray){
        				
        				myTankObj.Store_Items.tank_fishArray[objId].lastFed = temp.feedTime;
        				//console.log("SocialManager :: exception "+myTankObj.Store_Items.tank_fishArray[objId].lastFed);
        				
        			}
    				//console.log("SocialManager :: FEEDING");
    			}
				if((temp.reviveTime != 0.00 )&&(myTankObj.lastFed < temp.reviveTime) ){
					for (objId in myTankObj.Store_Items.tank_fishArray){
        				var currentTime = TFGameState.getServerTime();
        				//myTankObj.Store_Items.tank_fishArray[objId].created_time = temp.reviveTime;
        				myTankObj.Store_Items.tank_fishArray[objId].lastFed = currentTime;
        			}
    			}
    			
    			myTankObj.persist();
    			GAPersistenceManager.unLoadResource(resource);
//    			console.log("SocialManager :: unLoadResource "+resource);
    			//this.firstTankDoneLoading();
    		}
    		else
    		{
    			console.log("SocialManager :: tankload failed ");
    			
    		}
    		
    	}

    },
    
   
    
	////////////////////////////////////////////////////////////TRUE CLEANING / FEEDING ENDS

});

var ActionItems = Core.Class.subclass({
//	STORING ACTIONS PERFORMED ON NON-SELECTED TANKS
	initialize:function(cleanTime,feedTime,reviveTime)
	{
		this.cleanTime = cleanTime ;
		this.feedTime = feedTime;
		this.reviveTime = reviveTime
	},
	
	
});

var POSTNeighborActionHandler = Core.Class.subclass({
	//Posts Actions performed on neighbor's tank to server!!!
	
	initialize:function(type)
	{
//		console.log("type " + type);
		this._type = type;
//		console.log("this._type " + this._type);
	},
	
	 webFetchSuccess : function(webFetcher, responseData)
	 {
		try{
			var jsonResponse = eval("(" + responseData + ")");
//			console.log("POSTNeighborActionHandler: jsonResponse.status -> "+jsonResponse.status);
			
			if(jsonResponse.status != 'OK'){
				//this is the real error condition
//				console.log("POSTNeighborActionHandler -> Response not OK!");
		
			}
			else
			{
				//parse and call the appropriate callback
//				console.log("POSTNeighborActionHandler -> Success!!");
//				console.log("this._type " + this._type);
//				console.log("kSocialTypes.ACK_NOTIFICATIONS " + kSocialTypes.ACK_NOTIFICATIONS);
				if(this._type == kSocialTypes.ACK_NOTIFICATIONS){
					
					SocialManager.callBackForAcknowledgeNotification();

				}
	
			}
		}
			catch(exception){
			console.log("POSTNeighborActionHandler -> catch(exception) "+exception);

			
			throw exception;
		}
		
		if(webFetcher != null){
			webFetcher.destroy();
			webFetcher = null;
		}
		
		
	},
	webFetchFailure : function(webFetcher, errorCode){	
		var errorMsg = "POSTNeighborActionHandler::webFetchFailure() responseStatusCode = > " + errorCode;
		//GALogger.logWithLevel(errorMsg,LOG_LEVEL.LOG_NONFATAL_ERROR);
		if(webFetcher != null){
			webFetcher.destroy();
			webFetcher = null;
		}

		NgLogE(errorMsg);        	

		
	},
	
	destroy:function()
	{
		
	},
	
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/SocialAPI/GAActionsReceivedResponse'] = function(){var exports = $MODULE_REGISTRY['Code/SocialAPI/GAActionsReceivedResponse'] || {}; $MODULE_REGISTRY['Code/SocialAPI/GAActionsReceivedResponse'] = exports; /**
 * Author : Ahsan Zaheer
 */
exports.GAActionsReceivedResponse = GAServerResponseCommonModel.subclass({
	classname : 'GAActionsReceivedResponse',
	initialize : function(serverResponse){
		//$super(serverResponse);
		this._serverResponse = serverResponse;
		this._actionsArray = new Array(); 
		this._message = null;
	},
	parseSocialActionsReceivedResponse : function(){
		
		if(this._serverResponse != 'undefined' && this._serverResponse != null)
		{
			
			
//			this._message = this._serverResponse.msg;
			var actions = this._serverResponse.actions;
			//console.log("GAActionsReceivedResponse " + this._serverResponse.actions);
			for(objId in actions)
			{
				
				//NgLogE("SocialActionsHandler :: objId " +objId);
				var actionsModel = new ActionsModel();
				
				actionsModel.setObjId(objId);
				//user Info
				actionsModel.setName(actions[objId]["user-info"].name+'');
				actionsModel.setRname(actions[objId]["user-info"].rname+'');
				actionsModel.setUdid(actions[objId]["user-info"].udid+'');
				actionsModel.setGame(actions[objId]["user-info"].game+'');
//				//actions performed
				
				actionsModel.setCleanTimeStamp(actions[objId].actions.clean+'');
				actionsModel.setFeedTimeStamp(actions[objId].actions.feed+'');
				actionsModel.setGiftTimeStamp(actions[objId].actions.gift+'');
				actionsModel.setReviveTimeStamp(actions[objId].actions.revive+'');
				actionsModel.setTankId(actions[objId].actions.tank_id+'');
//				actionsModel.setActionPerformed(actions[objId].actions.actionPerformed+'');
//				console.log("GAActionsReceivedResponse in loop " + actions[objId].actions.actionPerformed);	
				
//				NgLogE("SocialActionsHandler: -> "+actionsModel.getObjId()+"_"+actionsModel.getName()+"_"+actionsModel.getUdid() +"_"+ actionsModel.getGame() +"_"+ actionsModel.getCleanTimeStamp()+"_"+ actionsModel.getFeedTimeStamp()+"_"+ actionsModel.getTankId());
				this._actionsArray.push(actionsModel);
				//NgLogE("SocialActionsHandler: this._actionsArray -> "+this._actionsArray );
				
			}
			
		}
		  
		//return this._actionsArray;
	},
	
	getActionsArray: function(){
		
		return this._actionsArray;
	},
	
	destroy : function($super){
		
		this._serverResponse = null;
		if(this._actionsArray !=null && this._actionsArray.length != 0)
		{
			this._actionsArray.splice(0);
			this._actionsArray = null;
		}
		
		if(this._giftItems !=null && this._giftItems.length != 0)
		{
			this._giftItems.splice(0);
			this._giftItems = null;
		}
		
		if(this._sendersArray !=null && this._sendersArray.length != 0)
		{
			this._sendersArray.splice(0);
			this._sendersArray = null;
		}
		
//		this.actionsModel = destroy();
//		this.actionsModel = null;
		
		$super();
	}
	
}); ; return exports;};
$MODULE_FACTORY_REGISTRY['Code/SocialAPI/SocialModelClasses/ActionsModel'] = function(){var exports = $MODULE_REGISTRY['Code/SocialAPI/SocialModelClasses/ActionsModel'] || {}; $MODULE_REGISTRY['Code/SocialAPI/SocialModelClasses/ActionsModel'] = exports; /*
 * Author : Ahsan Zaheer
 * 
 */

exports.ActionsModel = Core.Class.subclass({
	classname: 'ActionsModel',

	initialize: function() 
	{
		
		//userInfo = new Array();
		//actions = new Array();
		this.objId = '';
		this.name = '';
		this.rname = '';
		this.udid = '';
		this.cleanTime = '';
		this.reviveTime = '';
		this.feedTime = '';
		this.tankId = '';
		this.game = '';
		this.actionPerformed = '';
		this.giftTime = '';
//		this.giftId = '';
//		this.senderGame = '';
//		this.senderTimeStamp = '';
//		this.senderType = '';
		
	},
	
	//this is actually GiftDatabaseKey (Gift dbKey) -> used for acknowledging a user gift
	getObjId:function()
	{
		return this.objId;
	},
	
	setObjId:function(value){
		this.objId = value;
	},
	
	getName:function()
	{
		return this.name;
	},
	
	setName:function(value){
		this.name = value;
	},
	
	getRname:function()
	{
		if(this.rname == "0")
		{
			this.rname = "Anonymous";
		}
		return this.rname;
	},
	
	setRname:function(value){
		this.rname = value;
	},
	
	getUdid:function()
	{
		return this.udid;
	},
	
	setUdid:function(value){
		this.udid = value;
	},
	
//	getGiftId:function()
//	{
//		return this.giftId;
//	},
	
//	setGiftId:function(value){
//		this.giftId = value;
//	},
	
	getGame:function()
	{
		return this.game;
	},
	
	setGame:function(value){
		this.game = value;
	},

	setCleanTimeStamp:function(value){
		this.cleanTime = value;
	},

	getCleanTimeStamp:function()
	{		
		return this.cleanTime;
	},
	
	setReviveTimeStamp:function(value){
		this.reviveTime = value;
	},
	
	getReviveTimeStamp:function()
	{		
		return this.reviveTime;
	},
	
	setGiftTimeStamp:function(value){
		this.giftTime = value;
	},
	
	getGiftTimeStamp:function()
	{		
		return this.giftTime;
	},
	
	setFeedTimeStamp:function(value){
		this.feedTime = value;
	},
	
	getFeedTimeStamp:function()
	{		
		return this.feedTime;
	},
		
	getTankId:function()
	{
		return this.tankId;
	},
	
	setTankId:function(value){
		this.tankId = value;
	},
	
	setActionPerformed: function(){
		if(this.cleanTime != 0.00 ){
			//console.log("ActionModel :: this.cleanTime ::"+this.cleanTime );
			this.actionPerformed = kSocialFriendActionType.CLEAN_TANK;
		}
		else if (this.feedTime != 0.00 )
		{
			//console.log("ActionModel :: this.feedTime ::"+this.feedTime );
			this.actionPerformed = kSocialFriendActionType.FEED_FISH;
		}
		else if (this.giftTime != 0.00 )
		{
			//console.log("ActionModel :: this.feedTime ::"+this.feedTime );
			this.actionPerformed = kSocialFriendActionType.GIFT;
		}
		else if (this.reviveTime != 0.00 )
		{
			//console.log("ActionModel :: this.feedTime ::"+this.feedTime );
			this.actionPerformed = kSocialFriendActionType.REVIVE_FISHES;
		}
	},
	
	getActionPerformed: function(){
		if(this.actionPerformed == ''){
			this.setActionPerformed();
		}
//		NgLogE("ActionModel :: this.actionPerformed ::"+this.actionPerformed );
		return this.actionPerformed;
	},
	
	getUnixTimeStamp: function () {
		var timeStamp = null;
    	switch (this.actionPerformed) {
    	
			case kSocialFriendActionType.CLEAN_TANK:
				timeStamp =   this.cleanTime;
				break;
			
			case kSocialFriendActionType.FEED_FISH:
				timeStamp =   this.feedTime;
				break;
			case kSocialFriendActionType.GIFT:
				timeStamp =   this.giftTime;
				break;
			case kSocialFriendActionType.REVIVE_FISHES:
				timeStamp =   this.reviveTime;
				break;
			
			default:
			
    	}
		
		return timeStamp;
	},
	
	getTimeStamp: function () {
		var timeStamp = null;
    	switch (this.actionPerformed) {
    	
			case kSocialFriendActionType.CLEAN_TANK:
				timeStamp =   this.cleanTime;
				break;
			
			case kSocialFriendActionType.FEED_FISH:
				timeStamp =   this.feedTime;
				break;
			case kSocialFriendActionType.GIFT:
				timeStamp =   this.giftTime;
				break;
			case kSocialFriendActionType.REVIVE_FISHES:
				timeStamp =   this.reviveTime;
				break;
			
			default:
			
    	}
		
		return SocialUtil.getParsedTimeStamp(timeStamp);
	}
	
	
});	; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI Layers/TFStatsView'] = function(){var exports = $MODULE_REGISTRY['Code/UI Layers/TFStatsView'] || {}; $MODULE_REGISTRY['Code/UI Layers/TFStatsView'] = exports; 
exports.TFStatsView = GL2.Node.subclass({
	  classname: 'TFStatsView',
	  
	  initialize: function($super)
	  {  
		  $super();
	  },
	  
	  show : function () {
		
		  var user = TFGameState.getCurrentUser();
		
		  var myMessageListener = new Core.MessageListener();
		  var target = new GL2.TouchTarget();
		  target.setSize([Core.Capabilities.getScreenHeight(),Core.Capabilities.getScreenWidth()]);
		  target.getTouchEmitter().addListener(myMessageListener, this.onTouch.bind(this));
		  this.addChild(target);
		  
		  var modal = GLFactory.getSprite([0,0],0,"Content/images/StatsRateScreen/modal.png",[Core.Capabilities.getScreenHeight(),Core.Capabilities.getScreenWidth()]);
		  modal.setAlpha(0.5);
		  modal.setTouchable(false);
		  this.addChild(modal);
		  
		  this.backGround = GLFactory.getSprite([TFUtil.getAdjustedX(40),TFUtil.getAdjustedY(34)], null, 'Content/images/StatsRateScreen/bg-stats.png', [TFUtil.adjustHeightWithDevice(400),TFUtil.adjustWidthWithDevice(251)], [0, 0]);
		  this.addChild(this.backGround);
		  
		  
		  var buttonClose = new GLButton(
					'Content/images/StatsRateScreen/button01.png',
					'Content/images/StatsRateScreen/button02.png',
					TFUtil.adjustHeightWithDevice(125), TFUtil.adjustWidthWithDevice(34),
					this.closeButtonClicked.bind(this), this.backGround,
					2,'Close');
		  buttonClose.setPosition(TFUtil.getAdjustedY(200),
					TFUtil.getAdjustedX(220));
		  
		  var levelLabel1 = GLFactory.getText([TFUtil.getAdjustedY(200),TFUtil.getAdjustedX(90)],2,'LEVEL',[TFUtil.adjustHeightWithDevice(50),TFUtil.adjustWidthWithDevice(50)],TFUtil.getAdjustedFontSize(100),GL2.Text.HorizontalAlign.Right);
		  levelLabel1.setColor(1, 1, 1);
		  levelLabel1.setFontLocation(TFUtil.getFontLocation());
  		  levelLabel1.setFontFamily(TFUtil.getFont());
		  this.backGround.addChild(levelLabel1);
		  
		  var levelLabel2 = GLFactory.getText([TFUtil.getAdjustedY(250),TFUtil.getAdjustedX(90)],2,user._userObj.currentLevel,[TFUtil.adjustHeightWithDevice(150),TFUtil.adjustWidthWithDevice(50)],TFUtil.getAdjustedFontSize(100),GL2.Text.HorizontalAlign.Left);
		  levelLabel2.setColor(1, 1, 1);
		  levelLabel2.setFontLocation(TFUtil.getFontLocation());
		  levelLabel2.setFontFamily(TFUtil.getFont());
		  this.backGround.addChild(levelLabel2);
		  
		  var ratingLabel = GLFactory.getText([TFUtil.getAdjustedY(150),TFUtil.getAdjustedX(120)],2,'# OF VOTES',[TFUtil.adjustHeightWithDevice(150),TFUtil.adjustWidthWithDevice(50)],TFUtil.getAdjustedFontSize(100),GL2.Text.HorizontalAlign.Right);
		  ratingLabel.setColor(1, 1, 1);
		  ratingLabel.setFontLocation(TFUtil.getFontLocation());
		  ratingLabel.setFontFamily(TFUtil.getFont());
		  this.backGround.addChild(ratingLabel);
		  
		  var voteLabel = GLFactory.getText([TFUtil.getAdjustedY(250),TFUtil.getAdjustedX(120)],2,user.getRatingCount(),[TFUtil.adjustHeightWithDevice(100),TFUtil.adjustWidthWithDevice(50)],TFUtil.getAdjustedFontSize(100),GL2.Text.HorizontalAlign.Left);
		  voteLabel.setColor(1, 1, 1);
		  voteLabel.setFontLocation(TFUtil.getFontLocation());
		  voteLabel.setFontFamily(TFUtil.getFont());
		  this.backGround.addChild(voteLabel);
		  
		  
		  
		  this._emptyStars = GLFactory
						.getSprite(
								[ TFUtil.getAdjustedY(180),
										TFUtil.getAdjustedX(180) ],
								2,
								'Content/images/StatsRateScreen/bg-01.png',
								[ TFUtil.adjustHeightWithDevice(116), TFUtil.adjustWidthWithDevice(52) ],
								[ 0, 0]);
		  
		  
		  
		  this._filledStars = GLFactory
					.getSprite(
							[ TFUtil.getAdjustedY(180),
									TFUtil.getAdjustedX(180) ],
							2,
							'Content/images/StatsRateScreen/star-fish-01.png',
							[ TFUtil.adjustHeightWithDevice(116), TFUtil.adjustWidthWithDevice(52) ],
							[ 0, 0 ]);
			
			
		  this._filledStars.setImage(
								'Content/images/StatsRateScreen/star-fish-01.png',
								[ TFUtil.adjustHeightWithDevice( user.getRatingPercentage()* 1.16),
										TFUtil.adjustWidthWithDevice(52) ], [0, 0 ],
								new Core.Rect([ 0, 0 ], [user.getRatingPercentage() / 100, 1 ]));
								
		  this.addChild(this._emptyStars);
		  this.addChild(this._filledStars);
		  
		  var label = GLFactory.getText([TFUtil.getAdjustedY(58),TFUtil.getAdjustedX(9)],2,'Rating',[TFUtil.adjustHeightWithDevice(116),TFUtil.adjustWidthWithDevice(30)],TFUtil.getAdjustedFontSize(70),GL2.Text.HorizontalAlign.Center);
		  label.setColor(1, 1, 1);
		  label.setFontLocation(TFUtil.getFontLocation());
		  label.setFontFamily(TFUtil.getFont());
		  this._emptyStars.addChild(label);
		  
		  GL2.Root.addChild(this);
	  },
	 
	  closeButtonClicked:function()
	  {
	  	this.destroy();
	  },
	  
	  onTouch: function(touch){
		  return true;
	  },
	  
	  destroy: function($super)
	  {	 

		GL2.Root.removeChild(this);
		TFUtil.destroyNodeChildren(this._emptyStars);
		TFUtil.destroyNodeChildren(this.backGround);
		TFUtil.destroyNodeChildren(this);
		$super();
	  }
	  
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/UI Layers/TFRatingView'] = function(){var exports = $MODULE_REGISTRY['Code/UI Layers/TFRatingView'] || {}; $MODULE_REGISTRY['Code/UI Layers/TFRatingView'] = exports; /**
 * Filename: TFStatsRateView.js
 * Author: Syed Mauze Rehan
 * Date Created: Nov 22,2011
 * Date Updated: --
 */
exports.TFRatingView = GL2.Node.subclass({
	  classname: 'TFRatingView',
	  
	  initialize: function($super,parent)
	  {  
		  $super();
	  	  
		  this.percentage  = 20;
		  this.rating  = 1;
		  this.parent =  parent;
	  },
	 
	  showRatingsScreen: function()
	  { 
		  var user = TFGameState.getCurrentUser();
		 
		  //adding untouchable background
		  var modal = GLFactory.getSprite([0,0],0,"Content/images/StatsRateScreen/modal.png",[Core.Capabilities.getScreenHeight(),Core.Capabilities.getScreenWidth()]);
		  modal.setAlpha(0.5);
		  modal.setTouchable(false);
		  this.addChild(modal);
		  
		  
		  this.myMessageListener = new Core.MessageListener();
		  this._target = new GL2.TouchTarget();
		  this._target.setSize([Core.Capabilities.getScreenHeight(),Core.Capabilities.getScreenWidth()]);
		  this._target.getTouchEmitter().addListener(this.myMessageListener, this.onTouch.bind(this));
		  this.addChild(this._target);
		  
		  /////////////////////////////////////////////////////////////////////////////////////////////
		  
		  this._backGround = GLFactory.getSprite([TFUtil.getAdjustedX(63),TFUtil.getAdjustedY(75)], null, 'Content/images/StatsRateScreen/bg.png', [TFUtil.adjustHeightWithDevice(366),TFUtil.adjustWidthWithDevice(160)], [0, 0]);
		  this.addChild(this._backGround);
		 
		 var receiverName = null;
		 	if(user.getUsername() == 0 || user.getUsername() == '' && TFGameState.isFriend)
      		 {
          	 receiverName = TFGameState._neighborName;
      		 }
      		 else
      		 	 receiverName = user.getUsername();
       
       
		  var _ratingLabelText =  GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_RATE_NEIGHBOR'),[receiverName]);
		  
		  this._ratingLabel = GLFactory.getText([TFUtil.getAdjustedY(181),TFUtil.getAdjustedX(27)], 100, _ratingLabelText, [TFUtil.adjustHeightWithDevice(185),TFUtil.adjustWidthWithDevice(31)], TFUtil.getAdjustedFontSize(169));
		  this._ratingLabel.setHorizontalAlign(GL2.Text.HorizontalAlign.Center);
		  this._ratingLabel.setColor(1,1,1);
		  this._ratingLabel.setFontLocation(TFUtil.getFontLocation());
		  this._ratingLabel.setFontFamily(TFUtil.getFont());
		  this._ratingLabel.setOverflowMode(GL2.Text.OverflowMode.ReduceFontSize);
		  this._backGround.addChild(this._ratingLabel);

		  
		  var submitButton = new GLButton(
							'Content/images/StatsRateScreen/button01.png',
							'Content/images/StatsRateScreen/button02.png',
							TFUtil.adjustHeightWithDevice(125), TFUtil.adjustWidthWithDevice(34),
							this.submitButtonClicked.bind(this), this._backGround,
							2,'Submit');
		  submitButton.setPosition(TFUtil.getAdjustedY(185),
							TFUtil.getAdjustedX(135));
		  
		  var crossButton = new GLButton('./Content/images/Store/cross_normal.png','./Content/images/Store/cross_selected.png',TFUtil.adjustHeightWithDevice(34), TFUtil.adjustWidthWithDevice(36),this.crossClicked.bind(this),this._backGround,100);  //TFUtil.adjustWidthWithDevice(34)
		  crossButton.setPosition(TFUtil.getAdjustedY(363),TFUtil.getAdjustedX(0));
							
		  //making ratings scale
		  this.makeFilledStars();			
		  this.redrawFilledStars();
		  this._backGround.addChild(this._filledStarsSprite);
		  
		  GL2.Root.addChild(this);
		  
		  
	  },
	  
	  makeEmptyStars: function()
	  {
		this._emptyStarsSprite =  GLFactory
							.getSprite(
								[TFUtil.getAdjustedX(29),TFUtil.getAdjustedY(45)],
								2,
								'./Content/Images/Stats-screen/5_Stars_Unfilled.png',
								[TFUtil.getXRatio(95), TFUtil.getYRatio(20)],
								[0, 0.5]);
								
		this._emptyStarsSprite.setTouchable(false);	
	  	  
	  },
	  
	  makeFilledStars: function()
	  {
	  	 this._filledStarsSprite = GLFactory
							.getSprite(
								[TFUtil.getAdjustedY(0),TFUtil.getAdjustedX(0)],
								2,
								'Content/images/StatsRateScreen/star-fish.png',
								[TFUtil.adjustHeightWithDevice(366),TFUtil.adjustWidthWithDevice(160)],
								[0, 0]);
								
									
	  },
	  
	  setPercentage: function (val) {
		  this.percentage = val;
	  },
	  
	  getPercentage : function () {
		  return this.percentage;
	  },
	  
	  redrawFilledStars: function () {
		  var per = this.getPercentage();
		  var barToFill = 0.0;  // In percentage
		  if(per <= 20) {
			  barToFill = 23.0;
			  this.rating = 1;
		  }
		  else if(per <=40) {
			  barToFill = 41.0;
			  this.rating = 2;
		  }
		  else if(per <=60) {
			  barToFill = 58.0;
			  this.rating = 3;
		  }
		  else if(per <=80) {
			  barToFill = 77.0; 
			  this.rating = 4;
		  }
		  else if(per <=100) {
			  barToFill = 100.0;
			  this.rating = 5;
		  }
		  this._filledStarsSprite.setImage(
					'Content/images/StatsRateScreen/star-fish.png',
					[TFUtil.adjustHeightWithDevice((barToFill/100) * 366),TFUtil.adjustWidthWithDevice(160) ], [0, 0],
					new Core.Rect([0,0], [barToFill /100, 1]));
	  },
	  
	  submitButtonClicked:function()
	  {
//		  var user = TFGameState.getCurrentUser();
//		  var socialFriends = SocialUtil.getSocialFriends();
//		  if(socialFriends.isFriendExist(user.getUsername())) {
//			  var socialFriend = socialFriends.getFriendWithName(user.getUsername());
//			  var timeStamp = socialFriend.getLastRateTime();
//			  var mess =  SocialUtil.getParsedVisitTime(timeStamp);
//			  if(mess != '-1') {
//				  	this.destroy();	
//					var alert =  new SocialMiniUIAlertView('',GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_RATING_MESSAGE'),[mess]),this,null,GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
//					alert.setTagValue(0001);
//					alert.setMessageColor("FFFFFF");
//					alert.setTitleFont(SocialUtil.getFontName())
//					alert.setMessageFont(SocialUtil.getFontName());
//					alert.setButtonsFont(SocialUtil.getFontName());
//					alert.setButtonColor("FFFFFF");
//					alert.show();
//				  
//				  return;
//			  }
//		  }
//		  
		  UIFactory.showProgressHUD("Rating..");
		  var url = TFUtil.getRatingUrl(kRatingType.POST) ;
		  var params = "udid="+TFGameState.getCurrentUser().getUsername()+"&userkey="+TFGameState.getCurrentUser().getUsername()+"&game=ngTF"+"&rating="+this.rating+"&type=userkey";
		  var webFetcher = new GAWebFetcher(this, 30, 0);
		  webFetcher.invokePostRequest(url, params, true);
	  },
	  
	  
	  webFetchSuccess : function(webFetcher, responseData)
	  {
		  try{
			var jsonResponse = eval("(" + responseData + ")");
			if(jsonResponse.status != 'OK'){
				console.log("WebFetch error ");
			}
			else
			{
				var user = TFGameState.getCurrentUser();
				user.setRating(user.getRating()+this.rating);
				user.setRatingCount(user.getRatingCount()+1);
				var socialFriend = null;
				var socialFriends = SocialUtil.getSocialFriends();
				if(socialFriends.isFriendExist(user.getUsername())) {
					socialFriend = socialFriends.getFriendWithName(user.getUsername());
				}
				else {
					socialFriend = socialFriends.getFriendWithName('-1');
				}
				socialFriend.setLastRateTime(TFGameState.getServerTime());
				socialFriends.updateSocialFriends();
				this.parent.ratingVoted();
				this.destroy();
				
			}
		  }
		  catch(exception){
			throw exception;
		  }
		  UIFactory.hideProgressHUD();	
		  if(webFetcher != null){
			  webFetcher.destroy();
			  webFetcher = null;
		  }
			
			
		},
	webFetchFailure : function(webFetcher, errorCode){	
		var errorMsg = "webFetchFailure() responseStatusCode = > " + errorCode;
		UIFactory.hideProgressHUD();
		this.onFailure(errorCode);
		
		if(webFetcher != null){
			webFetcher.destroy();
			webFetcher = null;
		}
	
	},
	
	onFailure: function(errorCode) 
	{
		
		var message = Core.Localization.getString('TF_NETWORK_FAIL');
		console.log(message);
		
		var alertWindow =  new TFMiniUIAlertView("",message,this,Core.Localization.getString('TF_CANCEL_BUTTON'),GALocalizationHandler.getLocalizedString('TF_RETRY_LABEL'));
		alertWindow.setTagValue(100);
		alertWindow.setMessageColor("FFFFFF");
		alertWindow.setMessageFont(TFUtil.getFontName());
		alertWindow.setButtonsFont(TFUtil.getFontName());
		alertWindow.setButtonColor("FFFFFF");
		alertWindow.show();
	},
	
	clickedButtonAtIndex: function(buttonIndex,alertWindow)
	{
		if (buttonIndex == 0) 
		{
			switch(alertWindow.getTagValue())
			{				
				case 100:
				{
					this.submitButtonClicked();
					break;
				}
			}
		}
		else if (buttonIndex == 1){
			
			this.crossClicked();
		}
	},
	  
		
	  
	  crossClicked : function () {
		  this.destroy();
	  },
	  
	  onTouch: function(touch){
		  if(touch.getAction() == touch.Action.Start)
		  {
			this.ccTouchesBegan(touch)
				return true;
		  }
	      else if(touch.getAction() == touch.Action.Move)
	      {
	    	  this.ccTouchesMoved(touch);
	      }
			
	      else if(touch.getAction() == touch.Action.End)
	      {
	    	  this.ccTouchesEnded(touch);
	      }
		return false;
			
	  },	
		
	  ccTouchesBegan: function(touch)
	  {
		  if(this.isPointContains(this._filledStarsSprite,touch)) {
			  var percentage = ((touch.getPosition().getX()-this._backGround.getPosition().getX())/TFUtil.adjustHeightWithDevice(366))*100;
			  this.setPercentage(percentage);
			  this.redrawFilledStars();
		   }
	  },
	    
	   ccTouchesEnded: function(touch)
	   {
		   //console.log('End');
	   },
		
	   ccTouchesMoved: function(touch)
	   { 
		   if(this.isPointContains(this._filledStarsSprite,touch)) {
			  var percentage = ((touch.getPosition().getX()-this._backGround.getPosition().getX())/TFUtil.adjustHeightWithDevice(366))*100;
			  this.setPercentage(percentage);
			  this.redrawFilledStars();
		   }
		   return false;
	   },
	   
	   isPointContains: function (sprite,touch) {
	    	
	    	var tx = touch.getPosition().getX();
	    	var ty= touch.getPosition().getY();
	    	var ax = this._backGround.getPosition().getX() + sprite.getPosition().getX()+TFUtil.getAdjustedX(20);
	    	var ay = this._backGround.getPosition().getY() + sprite.getPosition().getY()+TFUtil.getAdjustedY(50);
	    	var awidth = ax+ TFUtil.adjustHeightWithDevice(366)-TFUtil.adjustHeightWithDevice(20);
	    	var aheight = ay+TFUtil.adjustWidthWithDevice(160)-TFUtil.adjustWidthWithDevice(100);
	    	
	    	if(tx >= ax && ty >= ay && tx <= awidth && ty <= aheight) {
	    		return true;
	    	}
	    	else {
	    		return false;
	    	}
	   },
		
	  getNode: function(){
			return this;
	  }, 
	 
	  destroy: function($super)
	  {	 

		GL2.Root.removeChild(this);
		TFUtil.destroyNodeChildren(this._backGround);
		TFUtil.destroyNodeChildren(this);
		$super();
	  },
	  
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/GLLayer/AlgaeParticle'] = function(){var exports = $MODULE_REGISTRY['Code/GLLayer/AlgaeParticle'] || {}; $MODULE_REGISTRY['Code/GLLayer/AlgaeParticle'] = exports; 
exports.AlgaeParticle = GL2.Node.subclass({
    classname: 'AlgaeParticle',
    
    initialize: function($super,parent)
    {   
    	$super();
    	this.parent  = parent;
    	
    	this.SCREEN_WIDTH = GACommonUtils.getScreenWidth();
		this.SCREEN_HEIGHT = GACommonUtils.getScreenHeight();
    	
		this.width = TFUtil.adjustHeightWithDevice(70);
    	this.height = TFUtil.adjustWidthWithDevice(70);
    
		this.position  = new Core.Point(-1,-1);
		this.move  = true;
		this.moveTimer  = null;
		
    },
    
    showAlgae : function (position) {
    	this.algae = GLFactory.getSprite(position,100,'./Content/Particle.png',[this.width,this.height],[0,0]);
    	this.algae.setColor(0, 0.5, 0);
		this.parent.addChild(this.algae);
		
    },
    
    startMoving: function () {
    	if(this.moveTimer) {
    		clearTimeout(this.moveTimer);
    		this.moveTimer = null;
    	}
    	this.moveTimer = setTimeout(this.moveParticle.bind(this), 50);
    },
    
    getPosition : function () {
    	return this.position;
    },
    
    setPosition: function (position) {
    	this.position = position;
    	this.algae.setPosition(this.position);
    },
    
    isPointContains: function (touch) {
    	
    	var tx = touch.getPosition().getX();
    	var ty= touch.getPosition().getY();
    	var ax = this.algae.getPosition().getX();
    	var ay = this.algae.getPosition().getY();
    	var awidth = ax+this.width;
    	var aheight = ay+this.height;
    	if(tx >= ax && ty >= ay && tx <= awidth && ty <= aheight) {
    		return true;
    	}
    	else {
    		return false;
    	}
    },
    
    moveParticle: function () {
    	var interval = 0;
    	if(this.move) {
    		interval = -2;
    		this.move = false;
    	}
    	else {
    		interval = 2;
    		this.move = true;
    	}
    	var x = this.algae.getPosition().getX()+interval%(this.SCREEN_WIDTH-20);			
		var y = this.algae.getPosition().getY()%(this.SCREEN_HEIGHT);
		var point = new Core.Point(x,y)
    	this.setPosition(point);	
		delete point;
		this.moveTimer = setTimeout(this.moveParticle.bind(this), 500);
    },

	onTouch:function(touch)
	{	
		if(GameLayer.getSelectedTank().currentTankAction != kTankActionType.kTankActionSponge)
		{
			return false;
		}
		
		if(touch.getAction() == touch.Action.Start)
		{
			if(this.ccTouchesBegan(touch))
			{
				return true;
			}
		}
        else if(touch.getAction() == touch.Action.Move)
        {
            this.ccTouchesMoved(touch);
        }
		else if(touch.getAction() == touch.Action.End)
		{
			this.ccTouchesEnded(touch);
		}
		return false;
	},
	
    destroy: function($super)
    {
    	delete this.position;
    	if(this.moveTimer) {
    		clearTimeout(this.moveTimer);
    		this.moveTimer = null;
    	}
    	if(this.algae){
    		this.parent.removeChild(this.algae);
    		this.algae.destroy();
    		this.algae = null;
    	}
		$super();
	},
    
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/GLLayer/TFMiniSaleGLAlertView'] = function(){var exports = $MODULE_REGISTRY['Code/GLLayer/TFMiniSaleGLAlertView'] || {}; $MODULE_REGISTRY['Code/GLLayer/TFMiniSaleGLAlertView'] = exports; /**
 * Filename: TFMiniGLAlertView.js
 */
// Initializing AlertWindow 
// there are 5 parameters passed to constructor below are the details of parameters
// 1.initWithTitle				: it is first parameter. it will take title string and set AlertWindow title
// 2.message       				: it will take message string and set Message in AlertWindow
// 3.delegate 	   				: setting delegate.
// 4.cancelButtonTitle			: it will take cancel button title string which should be localized string
// 5.otherButtonTitles			: it will take ok button title string which should be localized string

// setter functions
// there are 9 setter function through which you can set button text, title text and message text colors.
// it is also allow you to set background and button normal and highlighted images path
// you can also set type of your alertWindow and type detail is given below

// there are two type of alert view
// 1."ok" which means AlertWindow with ok button only
// 2."okwithcancel" means AlertWindow with ok and cancel button both 
// by default it takes type "ok"


//Default type for alert window
var kALERT_WINDOW_TYPE = "ok"

//AlertWindow button image default paths

var kALERT_WINDOW_BACKGROUND  = "./Content/images/UIPanels/AlertWindow/alert-background.png"
// Ok buttons
var kALERT_WINDOW_OK_NORMAL ="./Content/images/UIPanels/Buttons/1buttonNormal.png"
var kALERT_WINDOW_OK_SELECTED ="./Content/images/UIPanels/Buttons/1buttonSelected.png"


var kALERT_WINDOW_CANCEL_NORMAL ="./Content/images/UIPanels/Buttons/1buttonNormal.png"
var kALERT_WINDOW_CANCEL_SELECTED ="./Content/images/UIPanels/Buttons/1buttonSelected.png"


exports.TFMiniSaleGLAlertView = GL2.Node.subclass({
	
	classname: 'TFMiniSaleGLAlertView',
	initialize: function($super,initWithTitle,message1,message2,message3,delegate,cancelButtonTitle,otherButtonTitles)
	{
		
		$super();
			this.w							= null;
			this.h							= null;
			this._tagValue					= null;
			
			this._title 					= null;
			this._message1 					= null;
			this._message2 					= null;
			this._message3 					= null;
			this._delegate 					= null;
			this.cancelButtonTitle 			= null;
			this._otherButtonTitles			= null;
			
			
			this._type						= null;
			
			this._backgroundImagePath		= null;
			this._okImageNormalPath 		= null;
			this._okImageSelectedPath 		= null;
			this._cancelImageNormalPath		= null;
			this._cancelImageSelectedPath	= null;
	    	
	    	this._buttonsColor				= null;
	    	this._titleColor				= null;
	    	this._messageColor				= null;
	    	this._messageFont				= null;
	    	this._titleFont					= null;
	    	this._buttonsFont				= null;
	    	this._messageFontLocation		= null;
	    	this._titleFontLocation			= null;
	    	this._buttonsFontLocation		= null;
			
			this._background 				= null;
			this.myMessageListener 			= null;
			
			// initializing data members with parameters 
			if (initWithTitle == null) {
				initWithTitle = GALocalizationHandler.getLocalizedString('TF_MESSAGE_TEXT');//Message
				}
			
			if (initWithTitle.length > 11) {
				this._title = initWithTitle.substring(0, 10);
				} 
			else 
			{
				this._title = initWithTitle;
			}
					
			this._message1 = message1;
			this._message2 = message2;
			
    //   		this._message2.addChild(line);
			this._message3 = message3;
			this._delegate = delegate;
			this.cancelButtonTitle = cancelButtonTitle;
			this._otherButtonTitles= otherButtonTitles;	
			
			// setting images default path
			this._backgroundImagePath		=kALERT_WINDOW_BACKGROUND;
			this._okImageNormalPath			=kALERT_WINDOW_OK_NORMAL;
			this._okImageSelectedPath		=kALERT_WINDOW_OK_SELECTED;
			this._cancelImageNormalPath	 	=kALERT_WINDOW_CANCEL_NORMAL;
			this._cancelImageSelectedPath	=kALERT_WINDOW_CANCEL_SELECTED;
			
			
			// setting Default type
			this._type=kALERT_WINDOW_TYPE;
		
			
			// setting default colors
			this._buttonsColorRed=1;
			this._buttonsColorGreen=1;
			this._buttonsColorBlue=1;
			
			this._titleColorRed=1;
			this._titleColorGreen=1;
			this._titleColorBlue=0;
			
			this._messageColorRed=118/255; 
			this._messageColorGreen=50/255;
			this._messageColorBlue=58/255;
			
			// setting frame of this view
			this.w = Core.Capabilities.getScreenWidth();
			this.h = Core.Capabilities.getScreenHeight();
			
			
					
		this.makeTouchSwallower();// fullscreen touch target to swallow the touches beyond the attribute window 

    	
//		return this;
	},
	loadGl: function()
	{

		var background = new GL2.Sprite();		
		background.setImage(this._backgroundImagePath,[this.adjustHeightWithDevice(300),this.adjustWidthWithDevice(150)],[.5,.5]);
		background.setPosition(this.getAdjustedY(250),this.getAdjustedX(160));

        this.addChild(background);
       	
			var okButton = new GLButton(this._okImageNormalPath,this._okImageSelectedPath, this.adjustHeightWithDevice(73),this.adjustWidthWithDevice(37),this.clickedButtonOk.bind(this),this,100);
			okButton.setPosition(this.getAdjustedY(245),this.getAdjustedX(210));
			
			var okButtonText = new GL2.Text();
			okButtonText.setText(this._otherButtonTitles);
			okButtonText.setAnchor(0,0);
			okButtonText.setFontSize(this.getAdjustedFontSize(100));
			okButtonText.setSize([this.adjustHeightWithDevice(71.25),this.adjustWidthWithDevice(55.5)]);
			okButtonText.setPosition(this.getAdjustedY(210),this.getAdjustedX(181));
			okButtonText.setColor(this._buttonsColorRed,this._buttonsColorGreen,this._buttonsColorBlue);
			//this._okButtonText.setColor(1,1,1);
			okButtonText.setDepth(100);
			if (this._buttonsFont && this._buttonsFontLocation) {
	    		okButtonText.setFontLocation(this._buttonsFontLocation);
	    		okButtonText.setFontFamily(this._buttonsFont);
	    	}
			this.addChild(okButtonText);
			
		

		if(this._type == "okwithcancel")
		{
			
			
			okButton.setPosition(this.getAdjustedY(205),this.getAdjustedX(210));
			okButtonText.setPosition(this.getAdjustedY(170),this.getAdjustedX(183));
			
			
			var cancelButton = new GLButton(this._cancelImageNormalPath,this._cancelImageSelectedPath, this.adjustHeightWithDevice(73),this.adjustWidthWithDevice(37),this.clickedButtonCancel.bind(this),this,100);
			cancelButton.setPosition(this.getAdjustedY(285),this.getAdjustedX(210));
			
			
			cancelButtonText = new GL2.Text();
			cancelButtonText.setText(this.cancelButtonTitle);
			cancelButtonText.setAnchor(0,0);
			cancelButtonText.setFontSize(this.getAdjustedFontSize(100));
			cancelButtonText.setSize([this.adjustHeightWithDevice(71.25),this.adjustWidthWithDevice(55.5)]);
			cancelButtonText.setPosition(this.getAdjustedY(253),this.getAdjustedX(183));
			cancelButtonText.setColor(this._buttonsColorRed,this._buttonsColorGreen,this._buttonsColorBlue);
			//this._cancelButtonText.setColor(1,1,1);
			cancelButtonText.setDepth(100);
			if (this._buttonsFont && this._buttonsFontLocation) {
	    		cancelButtonText.setFontLocation(this._buttonsFontLocation);
	    		cancelButtonText.setFontFamily(this._buttonsFont);
	    	}
			this.addChild(cancelButtonText);
			
		}
		
		
		var messageLabel1 = new GL2.Text();
    	messageLabel1.setText(this._message1);
    	messageLabel1.setSize(this.adjustHeightWithDevice(300),this.adjustWidthWithDevice(180));
    	messageLabel1.setAnchor(.5,.5);
    	messageLabel1.setFontSize(this.getAdjustedFontSize(120));//changed to 120 from 130
    	messageLabel1.setColor(this._messageColorRed,this._messageColorGreen,this._messageColorBlue);
    	messageLabel1.setPosition(this.getAdjustedY(200),this.getAdjustedX(135));
    	messageLabel1.setOverflowMode(GL2.Text.OverflowMode.ReduceFontSize);
    	if (this._messageFont && this._messageFontLocation) {
    		messageLabel1.setFontLocation(this._messageFontLocation);
    		messageLabel1.setFontFamily(this._messageFont);
    	}	
    	var line = GLFactory.getSprite([TFUtil.getAdjustedY(53),TFUtil.getAdjustedX(0)],1,'./Content/images/Store/storetableimgs/reddot.png', [TFUtil.adjustHeightWithDevice(33),TFUtil.adjustWidthWithDevice(4)] , [0.5,0.5]);
		line.setRotation(-45);
		messageLabel1.addChild(line);
    	
    	this.addChild(messageLabel1);
    	
    	var messageLabel2 = new GL2.Text();
    	messageLabel2.setText(this._message2);
    	messageLabel2.setSize(this.adjustHeightWithDevice(240),this.adjustWidthWithDevice(180));
    	messageLabel2.setAnchor(.5,.5);
    	messageLabel2.setFontSize(this.getAdjustedFontSize(130));//changed to 120 from 130
    	messageLabel2.setColor(1,0,0);
    	messageLabel2.setPosition(this.getAdjustedY(254),this.getAdjustedX(160));
    	messageLabel2.setOverflowMode(GL2.Text.OverflowMode.ReduceFontSize);
    	if (this._messageFont && this._messageFontLocation) {
    		messageLabel2.setFontLocation(this._messageFontLocation);
    		messageLabel2.setFontFamily(this._messageFont);
    	}	
    	
    	this.addChild(messageLabel2);
    	
    	var messageLabel3 = new GL2.Text();
    	messageLabel3.setText(this._message3);
    	messageLabel3.setSize(this.adjustHeightWithDevice(240),this.adjustWidthWithDevice(180));
    	messageLabel3.setAnchor(.5,.5);
    	messageLabel3.setFontSize(this.getAdjustedFontSize(120));//changed to 120 from 130
    	messageLabel3.setColor(this._messageColorRed,this._messageColorGreen,this._messageColorBlue);
    	messageLabel3.setPosition(this.getAdjustedY(305),this.getAdjustedX(135));
    	messageLabel3.setOverflowMode(GL2.Text.OverflowMode.ReduceFontSize);
    	if (this._messageFont && this._messageFontLocation) {
    		messageLabel3.setFontLocation(this._messageFontLocation);
    		messageLabel3.setFontFamily(this._messageFont);
    	}	
    	this.addChild(messageLabel3);
    	
    	
    	var titleLabel = new GL2.Text();
    	titleLabel.setText(this._title);
    	titleLabel.setAnchor(.5,.5);
    	titleLabel.setFontSize(this.getAdjustedFontSize(100));
    	titleLabel.setColor(this._titleColorRed,this._titleColorGreen,this._titleColorBlue);
    	//this._title.setColor(1,1,1);
    	titleLabel.setPosition(this.getAdjustedY(245),this.getAdjustedX(250));
    	if (this._titleFont && this._titleFontLocation) {
    		titleLabel.setFontLocation(this._titleFontLocation);
    		titleLabel.setFontFamily(this._titleFont);
    	}
    	this.addChild(titleLabel);
    	
		
	},
	show: function()
	{
		this.loadGl();
		GL2.Root.addChild(this);
	},
	
		
	makeTouchSwallower: function()
    {
    	
    	var myMessageListener = 0;
    	var dissolveTouchesTarget = new GL2.TouchTarget();
    	dissolveTouchesTarget.setAnchor(0,0);
		dissolveTouchesTarget.setSize(this.getAdjustedY(this.h),this.getAdjustedX(this.w));
        dissolveTouchesTarget.setPosition(this.getAdjustedY(0),this.getAdjustedX(0));
        myMessageListener = new Core.MessageListener();
		dissolveTouchesTarget.getTouchEmitter().addListener(myMessageListener, this.dissolveTouches.bind(this),kTouchSwallower); //@sunilla make this 10 go to Constants.
		this.addChild(dissolveTouchesTarget);
    },
    
    
    
    dissolveTouches: function()
    {
    	return true;
    },
	
	
	// on click call backs
	clickedButtonOk: function()
	{
		this.clickedButtonAtIndex(0);
        //this.callBack();
	    //return true;

	},
	
	clickedButtonCancel: function()
	{
		this.clickedButtonAtIndex(1);
	    //this.callBack();
		//return true;	

	},
	
	
	clickedButtonAtIndex: function(buttonIndex)
	{
		if(this._delegate)		
		{
			this._delegate.clickedButtonAtIndex(buttonIndex,this);
		}
		//this.callBack();
		this.destroy();	
		
	},
	

	////////////////////////////////////////////////////////////
	
	//getter
	getTagValue: function()
	{
		return this._tagValue;
	},
	
	
	//setters
	
	setTagValue: function(value)
	{
		this._tagValue = value;
	},
	
	setType : function(type)
	{
		this._type=type;
	},
	setButtonColor : function(red,green,blue)
	{
		this._buttonsColorRed	=red;
		this._buttonsColorGreen	=green;
		this._buttonsColorBlue	=blue;
		
	},
	
	setTitleColor : function(red,green,blue)
	{
		this._titleColorRed		=red;
		this._titleColorGreen	=green;
		this._titleColorBlue	=blue;
	},
	
	setMessageColor : function(red,green,blue)
	{
		this._messageColorRed	=red;
		this._messageColorGreen	=green;
		this._messageColorBlue	=blue;
	},
	
	setMessageFont:function(font,fontLocation) 
    {
    	this._messageFont = font;
    	this._messageFontLocation = fontLocation;
    },

    
    setTitleFont:function(font,fontLocation) 
    {
    	this._titleFont = font;
    	this._titleFontLocation = fontLocation;
    },
        
    setButtonsFont:function(font,fontLocation) 
    {
    	this._buttonsFont = font;
    	this._buttonsFontLocation = fontLocation;
    },
    

	setBackgroundImagePath: function(path)
	{
		this._backgroundImagePath =path;
	},
	
	setOkImageNormalPath: function(path)
	{
		this._okImageNormalPath =path;
	},
	
	setOkImageSelectedPath: function(path)
	{
		this._okImageSelectedPath =path;
	},
	
	setCancelImageNormalPath: function(path)
	{
		this._cancelImageNormalPath =path;
	},
	
	setCancelImageSelectedPath: function(path)
	{
		this._cancelImageSelectedPath =path;
	},
		
	////////////////////////////////////////////////////////////
	
getAdjustedX: function(x) {
	
	var width = 0 , newWidth = 0 ;
	width = Core.Capabilities.getScreenWidth();
	newWidth = (width / 320) * x;
	
	return newWidth;
	
},

getAdjustedY: function(y) 
{
	var height = 0 , newHeight = 0;
	height = Core.Capabilities.getScreenHeight();
	newHeight = (height / 480) * y;
	
	return newHeight;
},

adjustWidthWithDevice: function(aWidth)
{
	var w = 0, calWidth = 0;
	
	w = Core.Capabilities.getScreenWidth();
	
	calWidth = aWidth * (w/320);
		//////NgLogE('Bandri Width:'+aWidth +'-->'+calWidth +'device W:'+w);
	return calWidth;			
},
adjustHeightWithDevice: function(aHeight)
{
	var h = 0 , calHeight = 0;
	
	h = Core.Capabilities.getScreenHeight();
	
	calHeight = aHeight * (h/480);
		//////NgLogE('Bandri Width:'+aHeight +'-->'+calHeight +'device H:'+h);
	return calHeight;		
	
},

getAdjustedFontSize: function(fieldHeight) {
	return this.getAdjustedY(fieldHeight / 2) / aspectRatioFactor.d;
},
	////////////////////////////////////////////////////////////

destroy: function($super)
	{
		GL2.Root.removeChild(this);
		TFUtil.destroyNodeChildren(this);
		$super();
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/SocialAPI/SocialMessagesUI/SocialCustomMessagesUI'] = function(){var exports = $MODULE_REGISTRY['Code/SocialAPI/SocialMessagesUI/SocialCustomMessagesUI'] || {}; $MODULE_REGISTRY['Code/SocialAPI/SocialMessagesUI/SocialCustomMessagesUI'] = exports; exports.SocialCustomMessagesUI = UI.View.subclass({
    
    className: "SocialCustomMessagesUI",
    
    initialize: function($super, reciever, recieverType)
	{
    	 $super();
    	 this.setFrame([SocialUtil.getAdjustedY(35),SocialUtil.getAdjustedX(65),SocialUtil.getAdjustedY(425),SocialUtil.getAdjustedX(280)]);
    	 this.addUIComponenet() ;
    	 this.msgReciever = reciever ;
    	 this.recieverType = recieverType ;
    	 this.isMsgDialougeShown = false ;
    },
    
    addUIComponenet: function() {

		frame1=[SocialUtil.getAdjustedY(10),SocialUtil.getAdjustedX(5),SocialUtil.adjustHeightWithDevice(70),SocialUtil.adjustWidthWithDevice(30)];
		this.backButton = UIFactory.getGenericButton(frame1, SOCIALAPI_NOTIFICATION_CLEAR_BTN_PATH, SOCIALAPI_NOTIFICATION_CLEAR_BTN_SELECETD_PATH, "Back", null,null,this,null);
		this.backButton.setTextColor("FFFFFF"); 
		this.backButton.setTextSize(SocialUtil.getAdjustedFontSize(70));
		this.backButton.setTextGravity(UI.ViewGeometry.Gravity.Center);
		this.backButton.setTextFont(SocialUtil.getFontName()) ;
		this.backButton.setOnClick(this.backButtonAction.bind(this));
        this.addChild(this.backButton);
		
		frame2=[SocialUtil.getAdjustedY(330),SocialUtil.getAdjustedX(5),SocialUtil.adjustHeightWithDevice(70),SocialUtil.adjustWidthWithDevice(30)];
		this.clearButton = UIFactory.getGenericButton(frame2, SOCIALAPI_NOTIFICATION_CLEAR_BTN_PATH, SOCIALAPI_NOTIFICATION_CLEAR_BTN_SELECETD_PATH, "Clear", null,null,this,null);
		this.clearButton.setTextColor("FFFFFF"); 
		this.clearButton.setTextSize(SocialUtil.getAdjustedFontSize(70));
		this.clearButton.setTextGravity(UI.ViewGeometry.Gravity.Center);
		this.clearButton.setTextFont(SocialUtil.getFontName()) ;
		this.clearButton.setOnClick(this.clearMessage.bind(this));
        this.addChild(this.clearButton);
		
		frame3=[SocialUtil.getAdjustedY(330),SocialUtil.getAdjustedX(148),SocialUtil.adjustHeightWithDevice(70),SocialUtil.adjustWidthWithDevice(30)];
		this.sendButton = UIFactory.getGenericButton(frame3, SOCIALAPI_NOTIFICATION_CLEAR_BTN_PATH, SOCIALAPI_NOTIFICATION_CLEAR_BTN_SELECETD_PATH, "Send", null,null,this,null);
		this.sendButton.setTextColor("FFFFFF"); 
		this.sendButton.setTextSize(SocialUtil.getAdjustedFontSize(70));
		this.sendButton.setTextGravity(UI.ViewGeometry.Gravity.Center);
		this.sendButton.setTextFont(SocialUtil.getFontName()) ;
		this.sendButton.setOnClick(this.sendMessage.bind(this));
        this.addChild(this.sendButton);
		
		this.charLabel = new UI.Label();
		this.charLabel.setFrame([SocialUtil.getAdjustedY(160),SocialUtil.getAdjustedX(8),SocialUtil.adjustHeightWithDevice(100),SocialUtil.adjustWidthWithDevice(30)]);
		this.charLabel.setTextColor('FFFF00'); 
		this.charLabel.setTextSize(SocialUtil.getAdjustedFontSize(85));
		this.charLabel.setText("0 / 160") ;
		this.charLabel.setTextFont(SocialUtil.getFontName()) ;
		this.charLabel.setTextGravity(UI.ViewGeometry.Gravity.Centre);
		this.addChild(this.charLabel);
		
		this.editText = new UI.EditTextArea() ;
		this.editText.setFrame([SocialUtil.getAdjustedY(15),SocialUtil.getAdjustedX(40),SocialUtil.getAdjustedY(379),SocialUtil.getAdjustedX(100)]) ;
		this.editText.setBackgroundColor("FFFFFF") ;
		this.editText.setTextFont(SocialUtil.getFont());
		this.editText.setOnChange(this.updateCharLabel.bind(this)) ;
		this.addChild(this.editText) ;
    },
    
    sendMessage: function() {
    	this.sendButton.setImage(SOCIALAPI_NOTIFICATION_CLEAR_BTN_PATH,UI.State.Normal);
    	this.replyMsgText = this.editText.getText() ;
    	this.replyMsgText  = this.replyMsgText.replace(new RegExp('\n', 'g') , ' ');
    	if (!this.msgReciever)
    		return ;
    	if (this.replyMsgText) {
    			this.checkMsgProfanity(this.replyMsgText) ;
		}
    },
    
    checkMsgProfanity: function(text) {
    	Social.Common.Profanity.checkProfanity(text, this.profanityCallBack.bind(this));
    },
    
    profanityCallBack: function(error, args) {
    	if(args == null || args == 'undefined'){
    		var errorCode = error.errorCode;
    		var errorDesc = error.description;
    		var userMessAlert =  new GAUIAlertView("",GALocalizationHandler.getLocalizedString('TF_RESOURCE_NETWORK_TEXT'),this,Core.Localization.getString('TF_CANCEL_BUTTON'),GALocalizationHandler.getLocalizedString('TF_RETRY_LABEL'));
			userMessAlert.setTagValue("2222");
			userMessAlert.setMessageColor("FFFFFF");
			userMessAlert.setMessageFont(TFUtil.getFontName());
			userMessAlert.setButtonsFont(TFUtil.getFontName());
			userMessAlert.setButtonColor("FFFFFF");
			userMessAlert.show();
		} 
		else { 
			if (args) {
				var SocialMessageModel = require('Code/SocialAPI/SocialModelClasses/SocialMessageModel').SocialMessageModel;
		 		replyMsg = new SocialMessageModel() ;
		 		replyMsg.setSenderGame(kGameName) ;
		 		replyMsg.setSenderId(GAConfigurations.getUserId()) ;
		 		replyMsg.setSenderName(GAConfigurations.getUserId()) ;
		 		replyMsg.setReceiverGame(kGameName) ;
		 		replyMsg.setReceiverId(this.msgReciever) ;
		 		replyMsg.setReceiverName(this.msgReciever) ;
		 		replyMsg.setSenderMessage(this.replyMsgText) ;
		 		SocialManager.handleSocialAction(kSocialTypes.SEND_MESSAGES, replyMsg) ;
			}
			else {
				var alertWindow = new SocialMiniUIAlertView("",GALocalizationHandler.getLocalizedString('SOCIAL_PROFANITY_FALSE_PROMPT'),this,null,GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
		       	alertWindow.setTagValue('1111');
		        alertWindow.setMessageColor("FFFFFF");
				alertWindow.setMessageFont(SocialUtil.getFontName());
				alertWindow.setButtonsFont(SocialUtil.getFontName());
				alertWindow.setButtonColor("FFFFFF");
				alertWindow.show() ;
			}
		}
	},
    
    clearMessage: function() {
    	this.clearButton.setImage(SOCIALAPI_NOTIFICATION_CLEAR_BTN_PATH, UI.State.Normal);
    	this.editText.setText("");
    },
    
    updateCharLabel: function() {
    	if(this.editText.getText().length > 160){
    		this.editText.setEnabled(false) ;
    		var maxText = this.editText.getText() ;
    		newText = maxText.slice(0, 160) ;
    		this.editText.setText(newText) ;
    		if(!this.isMsgDialogueShown) {
    			this.isMsgDialogueShown = true ;
    			var alertWindow = new SocialMiniUIAlertView("",GALocalizationHandler.getLocalizedString('SOCIAL_CUSTOM_MSG_LIMIT_STRING'),this,null,GALocalizationHandler.getLocalizedString('TF_OK_BUTTON'));
		       	alertWindow.setTagValue('3333');
		        alertWindow.setMessageColor("FFFFFF");
				alertWindow.setMessageFont(SocialUtil.getFontName());
				alertWindow.setButtonsFont(SocialUtil.getFontName());
				alertWindow.setButtonColor("FFFFFF");
				alertWindow.show() ;
    		}    		
    		this.editText.setEnabled(true) ;
    	}    		
    	this.charLabel.setText(this.editText.getText().length+" / 160") ;
    },
    
    backButtonAction: function() {
    	this.backButton.setImage(SOCIALAPI_NOTIFICATION_CLEAR_BTN_PATH, UI.State.Normal);
    	SocialManager.socialView.showNewMessageDialogue(this.msgReciever, this.recieverType) ;
    },
    
    clickedButtonAtIndex: function(buttonIndex,alertView)
	{
		NgLogE("SocialMessagesHandler ->clickedButtonAtIndex button index"+buttonIndex);
		if (buttonIndex == 0) 
		{
			if(alertView.getTagValue() == '1111')
			{
				
			}
			
			if(alertView.getTagValue() == '2222')
			{
				this.sendMessage() ;
			}
			
			if(alertView.getTagValue() == '3333')
			{
				this.isMsgDialogueShown = false ;
			}
		}
	},
    
    destroy: function($super) 
	{
    	if(typeof this != 'undefined' && this != null)
    		return;
		var children = this.getChildren();
		var length = children.length;
		for(var i = 0; i < length; i++) 
		{
			this.removeChild(children[i]);
			children[i].destroy();
			children[i] = null;
		}
		NGWindow.document.removeChild(this);
		$super();
    },
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/SocialAPI/SocialModelClasses/SocialMessageModel'] = function(){var exports = $MODULE_REGISTRY['Code/SocialAPI/SocialModelClasses/SocialMessageModel'] || {}; $MODULE_REGISTRY['Code/SocialAPI/SocialModelClasses/SocialMessageModel'] = exports; exports.SocialMessageModel = Core.Class.subclass({
	classname: 'SocialMessageModel',

	initialize: function(responseObj, msgIndex) 
	{
		if(responseObj){
			this.responseStatus = responseObj.status ;
			this.senderName = responseObj.msgs[msgIndex].susername+'' ;
			this.senderId = responseObj.msgs[msgIndex].suserid+'' ;
			this.senderGameName = responseObj.msgs[msgIndex].sgame+'' ;
			this.message = responseObj.msgs[msgIndex].msg+'' ;
			this.senderTimeStamp = responseObj.msgs[msgIndex].ts ;
			this.senderType = responseObj.msgs[msgIndex].stype+'' ;
			this.offset = responseObj.offset ;
		}
		this.receiverGameName = null ;
		this.receiverId = null ;
		this.receiverName = null ;
		this.receiverTimeStamp = null ;
	},
	

	getSenderName:function()
	{
		return this.senderName;
	},
	
	setSenderName:function(value){
		this.senderName = value;
	},
	
	getSenderId:function()
	{
		return this.senderId;
	},
	
	setSenderId:function(value){
		this.senderId = value;
	},
	
	getSenderGame:function()
	{
		return this.senderGameName;
	},
	
	setSenderGame:function(value){
		this.senderGameName = value;
	},
	
	getSenderTimeStamp:function()
	{		
		return this.senderTimeStamp;
	},
	
	setSenderTimeStamp:function(value){
		this.senderTimeStamp = value;
	},
	
	getReceiverName:function()
	{
		return this.receiverName;
	},
	
	setReceiverName:function(value){
		this.receiverName = value;
	},
	
	getReceiverId:function()
	{
		return this.receiverId;
	},
	
	setReceiverId:function(value){
		this.receiverId = value;
	},
	
	getReceiverGame:function()
	{
		return this.receiverGameName;
	},
	
	setReceiverGame:function(value){
		this.receiverGameName = value;
	},
	
	getReceiverTimeStamp:function()
	{		
		return this.receiverTimeStamp;
	},
	
	setReceiverTimeStamp:function(value){
		this.receiverTimeStamp = value;
	},
	
	getSenderType:function()
	{
		return this.senderType;
	},
	
	setSenderType:function(value){
		this.senderType = value;
	},
	
	getSenderMessage: function() {
		return this.message ;
	},
	
	setSenderMessage: function(value) {
		this.message = value ;
	}
	
	
});	; return exports;};
$MODULE_FACTORY_REGISTRY['Code/SocialAPI/SocialGiftsUI/SocialGiftsCell'] = function(){var exports = $MODULE_REGISTRY['Code/SocialAPI/SocialGiftsUI/SocialGiftsCell'] || {}; $MODULE_REGISTRY['Code/SocialAPI/SocialGiftsUI/SocialGiftsCell'] = exports; /**
 * Author: Syed Mauze Rehan
 */
exports.SocialGiftsCell = SocialUITableViewCell.subclass({
	
classname: 'SocialGiftsCell',	
	initialize: function($super,reuseId,cellModel) {
        $super(reuseId,cellModel);
        this._cellModel = cellModel;  // User object
        this.cellView = null;
    },
	
	 _onCreateView: function($super) 
    {
    	//for each gift,
    	//download the thumb and show it
    	this.cellView = $super();
    	//this.clearButton = new GLButton(, , SocialUtil.adjustHeightWithDevice(100),SocialUtil.adjustWidthWithDevice(35),this.clearClicked.bind(this),this,100,clearButtonText);
    	
    	this.cellView.claimButton = new UI.Button();
        this.cellView.claimButton.setTextGravity(UI.ViewGeometry.Gravity.Center);
        this.cellView.claimButton.setFrame([SocialUtil.getAdjustedY(253),SocialUtil.getAdjustedX(7),SocialUtil.getAdjustedY(55),SocialUtil.getAdjustedX(19)]);
        this.cellView.claimButton.setImage(SOCIALAPI_NOTIFICATION_CLEAR_BTN_PATH,UI.State.Normal);
        this.cellView.claimButton.setImage(SOCIALAPI_NOTIFICATION_CLEAR_BTN_SELECETD_PATH,UI.State.Pressed);
        this.cellView.claimButton.setImageFit(UI.ViewGeometry.FitModes.Stretch);
		this.cellView.claimButton.setTextColor('FFFFFF');
		this.cellView.claimButton.setText('Claim');
		this.cellView.claimButton.setTextFont(SocialUtil.getFontName());
		this.cellView.addChild(this.cellView.claimButton);
		
		this._giftIcon = new UI.Image();
		this._giftIcon.setFrame([SocialUtil.getAdjustedY(7),SocialUtil.getAdjustedX(9),SocialUtil.getAdjustedY(36),SocialUtil.getAdjustedX(36)]);
		this._giftIcon.setImage(SOCIALAPI_GIFTBOX_IMG_PATH,UI.State.Normal);
		this._cellView.addChild(this._giftIcon);
		
		
		this._boxIcon = new UI.Image();
		this._boxIcon.setFrame([SocialUtil.getAdjustedY(321),SocialUtil.getAdjustedX(3),SocialUtil.getAdjustedY(50),SocialUtil.getAdjustedX(50)]);
		this._boxIcon.setImage(SOCIALAPI_ICON_BG_PATH,UI.State.Normal);
		this.cellView.addChild(this._boxIcon);
		
		this.cellView._nameLabel = new UI.Label();
		this.cellView._nameLabel.setFrame([SocialUtil.getAdjustedY(45),SocialUtil.getAdjustedX(11),SocialUtil.adjustHeightWithDevice(55),SocialUtil.adjustWidthWithDevice(19)]);
		this.cellView._nameLabel.setTextColor('FFFFFF'); 
		this.cellView._nameLabel.setTextSize(13);
		this.cellView._nameLabel.setTextGravity(UI.ViewGeometry.Gravity.Left);
		this.cellView._nameLabel.setText("Name  :");
		this.cellView._nameLabel.setTextFont(SocialUtil.getFontName());
		this.cellView.addChild(this.cellView._nameLabel);
		
		this.cellView._giftName = new UI.Label();
		this.cellView._giftName.setFrame([SocialUtil.getAdjustedY(87),SocialUtil.getAdjustedX(11),SocialUtil.adjustHeightWithDevice(150),SocialUtil.adjustWidthWithDevice(19)]);
		this.cellView._giftName.setTextColor('FFFFFF'); 
		this.cellView._giftName.setTextSize(13);
		this.cellView._giftName.setTextGravity(UI.ViewGeometry.Gravity.Left);
		this.cellView._giftName.setTextFont(SocialUtil.getFontName());
		this.cellView.addChild(this.cellView._giftName);
		
		this.cellView._senderNameLabel = new UI.Label();
		this.cellView._senderNameLabel.setFrame([SocialUtil.getAdjustedY(45),SocialUtil.getAdjustedX(29),SocialUtil.adjustHeightWithDevice(55),SocialUtil.adjustWidthWithDevice(19)]);
		this.cellView._senderNameLabel.setTextColor('FFFFFF'); 
		this.cellView._senderNameLabel.setTextSize(13);
		this.cellView._senderNameLabel.setTextGravity(UI.ViewGeometry.Gravity.Left);
		this.cellView._senderNameLabel.setText("Sender:");
		this.cellView._senderNameLabel.setTextFont(SocialUtil.getFontName());
		this.cellView.addChild(this.cellView._senderNameLabel);
		
		this.cellView._senderName = new UI.Label();
		this.cellView._senderName.setFrame([SocialUtil.getAdjustedY(87),SocialUtil.getAdjustedX(29),SocialUtil.adjustHeightWithDevice(150),SocialUtil.adjustWidthWithDevice(19)]);
		this.cellView._senderName.setTextColor('FFFFFF'); 
		this.cellView._senderName.setTextSize(13);
		this.cellView._senderName.setTextGravity(UI.ViewGeometry.Gravity.Left);
		this.cellView._senderName.setTextFont(SocialUtil.getFontName());
		this.cellView.addChild(this.cellView._senderName);
		
		this.cellView.visitButton = new UI.Button();
        this.cellView.visitButton.setTextGravity(UI.ViewGeometry.Gravity.Center);
        this.cellView.visitButton.setFrame([SocialUtil.getAdjustedY(259),SocialUtil.getAdjustedX(31),SocialUtil.getAdjustedY(19),SocialUtil.getAdjustedX(19)]);
        this.cellView.visitButton.setImage(SOCIALAPI_MSG_VISIT_NEIGHBOUR_BTN_IMG_PATH,UI.State.Normal);
        this.cellView.visitButton.setImage(SOCIALAPI_MSG_VISIT_NEIGHBOUR_BTN_SELECTED_IMG_PATH,UI.State.Pressed);
        this.cellView.visitButton.setImageFit(UI.ViewGeometry.FitModes.Stretch);
        this.cellView.visitButton.enable = true;
		this.cellView.addChild(this.cellView.visitButton);
		
		this.cellView.replyButton = new UI.Button();
        this.cellView.replyButton.setTextGravity(UI.ViewGeometry.Gravity.Center);
        this.cellView.replyButton.setFrame([SocialUtil.getAdjustedY(283),SocialUtil.getAdjustedX(31),SocialUtil.getAdjustedY(19),SocialUtil.getAdjustedX(19)]);
        this.cellView.replyButton.setImage(SOCIALAPI_MSG_REPLY_BTN_IMG_PATH,UI.State.Normal);
        this.cellView.replyButton.setImage(SOCIALAPI_MSG_REPLY_BTN_SELECTED_IMG_PATH,UI.State.Pressed);
        this.cellView.replyButton.setImageFit(UI.ViewGeometry.FitModes.Stretch);
        this.cellView.replyButton.enable = true;
		this.cellView.addChild(this.cellView.replyButton);
		
		this.cellView.timeLabel = new UI.Label();
    	this.cellView.timeLabel.setTextGravity(UI.ViewGeometry.Gravity.Left);
		this.cellView.timeLabel.setTextColor('E5D81E');
		this.cellView.timeLabel.setTextFont('DroidSans-Bold') ;
		this.cellView.timeLabel.setTextSize(SocialUtil.getAdjustedFontSize(53));
		this.cellView.timeLabel.setFrame([SocialUtil.getAdjustedY(165), SocialUtil.getAdjustedX(35), SocialUtil.adjustHeightWithDevice(115), SocialUtil.adjustWidthWithDevice(15)]);
		this.cellView.addChild(this.cellView.timeLabel);
		
        return this.cellView;
    },
    
    _onSetView: function($super,cellView) 
    {
		$super(cellView);
		if(!this._cellModel)
		{
//			console.log("SocialGiftCell: _onSetView -> cellmodel null ... returning");
			return;
		}
		
		console.log("SocialGiftCell: _onSetView -> storeId -> "+this._cellModel.getGiftId());
		
		var storeObj = GAGameLoader.getStoreHandler().getStoreObjectForKey(this._cellModel.getGiftId()+'');		
		
		if(storeObj == null || storeObj == 'undefined')
		{	
//			console.log("SocialGiftsCell -> _onSetView -> invalid store Id ... returning ...");
			return;//invalid store ID
		}
		
		
		if(cellView.icon != null) {
			cellView.removeChild(cellView.icon);
			cellView.icon.destroy();
			cellView.icon = null;
		}
		
		cellView.icon = new GAStoreIcon();
		cellView.icon.setFrame([SocialUtil.getAdjustedY(327),SocialUtil.getAdjustedX(8),SocialUtil.getAdjustedY(39),SocialUtil.getAdjustedX(35)]);
		cellView.icon.load(storeObj);
		cellView.addChild(cellView.icon);
		
		cellView._giftName.setText(storeObj.name);
		
		var timeString = SocialUtil.getParsedTimeStamp(this._cellModel.getSenderTimeStamp()) ;
		cellView.timeLabel.setText(timeString);
		
		cellView._senderName.setText(this._cellModel.getSenderName());
		
		cellView.claimButton.setOnClick(this.claimButtonAction.bind(this,this._cellModel));
		
		
		var _socialFriendsList = SocialUtil.getSocialFriends();
		console.log('FA this._cellModel.getSenderName(): ' + this._cellModel.getSenderName());
		if(_socialFriendsList.isFriendExist(this._cellModel.getSenderName()))
		{
			console.log('FA Inside IF');
			cellView.replyButton.setOnClick(this.replyButtonAction.bind(this));
			cellView.visitButton.setOnClick(this.visitButtonAction.bind(this));
		}
		else
		{
			console.log('FA Inside Else');
			cellView.replyButton.setVisible(false);
			cellView.visitButton.setVisible(false);
		}
			
			
	
		
		this.cellView = cellView;
		
		this.setEnableButtons(true);
			
    },
    
        
    claimButtonAction : function (giftObject) {
    	//will acknowledge a received gift
    	console.log("claimButtonAction: -> claiming gift ...");
    	UIFactory.showProgressHUD("Claiming gift...");
   		
   		if(!this.getButtonsState())
  		{
  			console.log("SocialGiftsCell: claimButtonAction -> returning...");
  			return;
  		}
   		
   		//this.setEnableButtons(false);
    	SocialManager.handleSocialAction(kSocialTypes.ACK_GIFT_RCV,giftObject);
    },
    
    replyButtonAction: function() {
    	
    	console.log("SocialGiftsCell: replyButtonAction -> returning");
    	
    	this.cellView.replyButton.setImage(SOCIALAPI_MSG_REPLY_BTN_IMG_PATH,UI.State.Normal);
    	SocialManager.socialView.showReplyMessageView(this._cellModel.getSenderName(), kMessagesUIType.REPLY_FRIEND);
    },
    
    visitButtonAction: function() {
    	
    	this.cellView.visitButton.setImage(SOCIALAPI_MSG_VISIT_NEIGHBOUR_BTN_IMG_PATH,UI.State.Normal);
    	
    	var socialFriends = SocialUtil.getSocialFriends();
		if(socialFriends.isFriendExist(this._cellModel.getSenderName())) {
			console.log("SocialGiftsCell-> visitButtonAction-> This is my friend!");
    		var visitNeighbor = new VisitNeighbor();
    		visitNeighbor.goToFriend(this._cellModel.getSenderName());
    		SocialManager.hideSocialScreen();
		}
		else {
			console.log("SocialGiftsCell-> visitButtonAction->NOT my friend!");
    		var visitNeighbor = new VisitNeighbor();
    		visitNeighbor.goToNeighborWithName(this._cellModel.getSenderName());
    		SocialManager.hideSocialScreen();
		}
		
    	
    },
    
	getButtonsState: function()
	{
		return this._enableButton;
	},
		
	
	setEnableButtons: function(value)
	{
		this._enableButton = value;
	},


    //********************Setters-Getters********************//
    
    _setIndexPath_Row:function($super,value)
    {
        $super(value);
    },
	
    _getIndexPath_Row: function($super)
    {
        return $super();
    },
    
    _setParentTableView: function($super,value)
    {
        $super(value);
    },
    
		_getParentTableView: function($super)			
    {
        return $super();
    },
    

    destroy: function($super) 
	{
		//console.log("SocialGiftsCell: destroy called!");
		
		$super();
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/SocialAPI/SocialList/SocialMoreCell'] = function(){var exports = $MODULE_REGISTRY['Code/SocialAPI/SocialList/SocialMoreCell'] || {}; $MODULE_REGISTRY['Code/SocialAPI/SocialList/SocialMoreCell'] = exports; exports.SocialMoreCell = SocialUITableViewCell.subclass({
	
classname: 'SocialMoreCell',	
	
	    initialize: function($super,reuseId,cellModel) {
        $super(reuseId,cellModel);
        this._cellModel = cellModel;  
        this.cellView = null;
        this._totalPages = 0;
        this._currentPage = 0;
    },
	
	_onCreateView: function($super) 
    {
    	this.cellView = $super();	
		
		this.cellView.nextButton = new UI.Button();
        this.cellView.nextButton.setTextGravity(UI.ViewGeometry.Gravity.Center);
        this.cellView.nextButton.setFrame([SocialUtil.getAdjustedY(220),SocialUtil.getAdjustedX(10),SocialUtil.getAdjustedY(75),SocialUtil.getAdjustedX(25)]);
        this.cellView.nextButton.setImage(SOCIALAPI_BTN_BLUE,UI.State.Normal);
        this.cellView.nextButton.setImage(SOCIALAPI_BTN_BLUE,UI.State.Pressed);
        this.cellView.nextButton.setImageFit(UI.ViewGeometry.FitModes.Stretch);
		this.cellView.nextButton.setTextColor('FFFFFF');
		this.cellView.nextButton.setTextFont(SocialUtil.getFontName());
		this.cellView.nextButton.setText('next');
		
		this.cellView.addChild(this.cellView.nextButton);
		
		this.cellView.prevButton = new UI.Button();
        this.cellView.prevButton.setTextGravity(UI.ViewGeometry.Gravity.Center);
        this.cellView.prevButton.setFrame([SocialUtil.getAdjustedY(100),SocialUtil.getAdjustedX(10),SocialUtil.getAdjustedY(75),SocialUtil.getAdjustedX(25)]);
        this.cellView.prevButton.setImage(SOCIALAPI_BTN_BLUE,UI.State.Normal);
        this.cellView.prevButton.setImage(SOCIALAPI_BTN_BLUE,UI.State.Pressed);
        this.cellView.prevButton.setImageFit(UI.ViewGeometry.FitModes.Stretch);
		this.cellView.prevButton.setTextColor('FFFFFF');
		this.cellView.prevButton.setTextFont(SocialUtil.getFontName());
		this.cellView.prevButton.setText('previous');
		
		this.cellView.addChild(this.cellView.prevButton);
    	
		return this.cellView;
    },
    
    _onSetView: function($super,cellView) 
    {
		$super(cellView);
		if(!this._cellModel)
			return;
		if(this._currentPage == 0) {
			cellView.prevButton.setVisible(false);
			cellView.nextButton.setFrame([SocialUtil.getAdjustedY(145),SocialUtil.getAdjustedX(10),SocialUtil.getAdjustedY(75),SocialUtil.getAdjustedX(25)]);
		}
		else {
			cellView.prevButton.setVisible(true);
			cellView.nextButton.setFrame([SocialUtil.getAdjustedY(220),SocialUtil.getAdjustedX(10),SocialUtil.getAdjustedY(75),SocialUtil.getAdjustedX(25)]);
		}
		
		if(this._currentPage == this._totalPages-1) {
			cellView.nextButton.setVisible(false);
			cellView.prevButton.setFrame([SocialUtil.getAdjustedY(145),SocialUtil.getAdjustedX(10),SocialUtil.getAdjustedY(75),SocialUtil.getAdjustedX(25)]);
		}
		else {
			cellView.nextButton.setVisible(true);
			cellView.prevButton.setFrame([SocialUtil.getAdjustedY(100),SocialUtil.getAdjustedX(10),SocialUtil.getAdjustedY(75),SocialUtil.getAdjustedX(25)]);
		}
		cellView.nextButton.setOnClick(this.nextClicked.bind(this));
		cellView.prevButton.setOnClick(this.prevClicked.bind(this));
		
		this.cellView = cellView;
		
    },
    
    setCurrentPage:function (val) {
    	this._currentPage = val
    },
    
    setTotalPages:function (val) {
    	this._totalPages = val
    },
    
    nextClicked: function () {
    	this._ParentTableView.loadNextPage();
    },
    
    prevClicked: function () {
    	this._ParentTableView.loadPrevPage();
    },
    
    _setIndexPath_Row:function($super,value)
    {
        $super(value);
    },
    
    _getIndexPath_Row: function($super)
    {
        return $super();
    },
    
    _setParentTableView: function($super,value)
    {
        $super(value);
    },
    
		_getParentTableView: function($super)			
    {
        return $super();
    },
    
    //********************Destroy********************//

    destroy: function($super) 
	{

		$super();
	}
});; return exports;};
(function()
{
	if(!Function.prototype.hasOwnProperty('bind'))
	{
		var slice = Array.prototype.slice;
		Function.prototype.bind = function(context)
		{
			var func = this;
			if(arguments.length > 1)
			{
				var args = slice.call(arguments, 1);
				return function()
				{
					if(arguments.length)
					{
						var finalArgs = args.concat(slice.call(arguments));
						return func.apply(context, finalArgs);
					}
					else
					{
						return func.apply(context, args);
					}
				}
			}
			else
			{
				return function()
				{
					if(arguments.length)
						return func.apply(context, arguments);
					else
						return func.call(context);
				}
			}
		}
	}
})();

(function()
{
	if(!Array.prototype.hasOwnProperty('indexOf'))
	{
		Array.prototype.indexOf = function(obj)
		{
			var len = this.length;
			for(var i=0; i < this.length; ++i)
			{
				if(obj === this[i])
					return i;
			}
			return -1;
		}
	}
})();

(function()
{
	if (typeof(console) == 'undefined') { 
		console = { log: function(str) {} };
	}
})();

function userGameInit()
{
	console.log("ngCore calling main()");
	main();
}
//////////////////////////////////////////////////////////////////////////////
/** 
 *  @date:      2010-11-0?
 *  @file:      NgWebEngine.js
 *  Website:    http://www.ngmoco.com/
 *  Copyright:  2010, by ngmoco:)
 *              Unauthorized redistribution of source code is 
 *              strictly prohibited. Violators will be prosecuted.
 * 
 *  @brief:
 */
//////////////////////////////////////////////////////////////////////////////
var NGSetTimeoutRunTimers = require('NGCore/Client/UI/NGJSEnvironmentSupport').NGSetTimeoutRunTimers;
var SystemBinding = require('NGCore/Client/UI/SystemBinding').SystemBinding;
var UI = require('NGCore/Client/UI').UI;
var AlertDialog = UI.AlertDialog;
var ProgressDialog = UI.ProgressDialog;
var Downloader = require('NGCore/Client/Network/DownloadManifest').Downloader;
var LocalGameList = require('NGCore/Client/Core/LocalGameList').LocalGameList;
var Device = require('NGCore/Client/Device').Device;
var Core = require('NGCore/Client/Core').Core;
var Capabilities = require('NGCore/Client/Core/Capabilities').Capabilities;
var Localization = require('NGCore/Client/Core/Localization').Localization;

// Global until oauth does not depend on storage.
Storage = require('NGCore/Client/Storage').Storage;

//////////////////////////////////////////////////////////////////////////////////////////////////
// App switching.

var NgProcID =
{
    PersistProc: -1,
    GameProc: -2
};

//////////////////////////////////////////////////////////////////////////////////////////////////

/**
  * @private
  */

var gNgShutdownPending = false;


/////////////////////////////////////////////////////////////////////////////////////////////////
// Global data.
//////////////////////////////////////////////////////////////////////////////////////////////////

var gNgEngineEntities;
var gNgAddedEngineEntities;
var gNgRemovedEngineEntities;

var gNgUpdateEngineEntities;
var gNgTouchEngineEntities;
var gNgKeyPressEngineEntities;

//////////////////////////////////////////////////////////////////////////////////////////////////
// This function is called once by the html container to initialize the game.
//////////////////////////////////////////////////////////////////////////////////////////////////

/**
  * @private
  */

function NgEngineInitPrivate()
{
	NgLogInit();

	NgApplication.getInstance().restart();

	gNgEngineEntities = new Array();
	gNgAddedEngineEntities = new Array();
	gNgRemovedEngineEntities = new Array();

	gNgUpdateEngineEntities = new Array();
	gNgTouchEngineEntities = new Array();
    gNgKeyPressEngineEntities = new Array();

	Core.Analytics.instantiate();
}

//////////////////////////////////////////////////////////////////////////////////////////////////

/**
  * @private
  */

function NgEngineProcessEntityAddRemove()
{
	for(var i in gNgAddedEngineEntities)
	{
		var e = gNgAddedEngineEntities[i];
		if(e.mIsTouchable) NgInsertSortedTouch(e);
		if(e.mIsKeyable)	NgInsertSortedKeyPress(e);
		if(e.mIsUpdatable) gNgUpdateEngineEntities[e.mId] = e;
	}
	gNgAddedEngineEntities = [];

	for(var i in gNgRemovedEngineEntities)
	{
		var e = gNgRemovedEngineEntities[i];

		if(e.mIsTouchable)	gNgTouchEngineEntities.splice(NgFindIndex(gNgTouchEngineEntities,e),1);
		if(e.mIsKeyable) gNgKeyPressEngineEntities.splice(NgFindIndex(gNgKeyPressEngineEntities,e),1);
		if(e.mIsUpdatable) delete gNgUpdateEngineEntities[e.mId];
	}
	gNgRemovedEngineEntities = [];
}

/**
  * @private
  */

function NgHandleException(ex)
{
	if (Core.Proc.isPrivileged()) {
		NgLogException( ex );
	}
	else {
		var exStr = JSON.stringify(ex);
		NgLogException( ex );
		Core.LocalGameList._forwardException(exStr);
	}
}

function NgEngineInit(inputs)
{
	NgLogD("NgEngineInit beg");
	try
	{
		NgEngineInitPrivate();

		time.setCtr('frame',1000,NgLogD);

		//NgLogD("Initializing Storage");
		//Storage.init();
		//NgLogD("Storage initialized");
		NgLogD("KeyValue Storage initializing...");
		Storage.KeyValueCache.init();
		NgLogD("KeyValue Storage initialized...");
	
		Core.Time.instantiate();
	
		NgLogD("Instantiate the Localization context (singleton), depends on Capabilities");
		Localization.instantiate();

	}
	catch( ex )
	{
		NgHandleException(ex);
	}
	NgLogD("NgEngineInit end");	
	
	return NgEngineUpdate(inputs);
}

function NgPreInit(inputs)
{
	NgLogD("Localization NgPreInit beg");
	return update(inputs);
}

/**
  * @private
  */

function NgGameInit(inputs)
{
	NgLogD("NgGameInit beg");
	try
	{
		NGWindow = UI.Window;

		userGameInit();
	}
	catch( ex )
	{
		NgHandleException(ex);
	}
	NgLogD("NgGameInit end");

	return update(inputs);
}

/**
  * @private
  */

// TEMPORARY: Until native code is updated to call NgEngineUpdate.
function update ( inputs )
{
	return NgEngineUpdate ( inputs );
}

//Frame loop calls this every time, get the object out of require once ahead of time.
var NGSetTimeoutRunTimers = require('NGCore/Client/UI/NGJSEnvironmentSupport').NGSetTimeoutRunTimers;

var setTimeoutOrig = setTimeout;
setTimeout  = function(fn, time)
{
	return setTimeoutOrig(function() 
	{
		try
		{
			fn();
		}
		catch( ex )
		{
			NgHandleException(ex);
		}
	}, time);
	
}


var setIntervalOrig = setInterval;
setInterval  = function(fn, time)
{
	return setIntervalOrig(function() 
	{
		try
		{
			fn();
		}
		catch( ex )
		{
			NgHandleException(ex);
		}
	}, time);
	
}



/**
  *	Main entry point for native to invoke JS.
  * @private
  */
var NgEngineUpdate = (function()
{
	var Core = require('NGCore/Client/Core').Core;
	
return function ( inputs )
{
	// time causes a racehorse-sized leak in v8. Only use this for single profiling runs. DO NOT CHECK IN.
//	time.stop('frame');
//	time.start('frame');
	
	try {
		NGSetTimeoutRunTimers();

		if(inputs.length)
		{
			NgEngineProcessEntityAddRemove();
			var commands = inputs.split(':');
			for(var i=0; i<commands.length; ++i)
			{
				command = commands[i];

				// Make sure this isn't an empty input.
				if(0 == command.length) {
					continue;
				}

				switch(parseInt(command))
				{
					case NgEntityTypes.App:
						NgApplication.getInstance().handleCommand(command);
						break;
					case NgEntityTypes.NgFileSys:
						NgApplication.getInstance().getFileSys().handleCommand(command);
                        break;
					case NgEntityTypes.Storage:
						NgLogD("Command for storage is " + command);
						Storage.getInstanceForCommand(command).handleCommand(command);
						break;
					case NgEntityTypes.NgUI:
						NGWindow.handleCommand(command);
						break;
					case NgEntityTypes.NgSystemBinding:
						SystemBinding.handleCommand(command);
						break;
					case 3117:
						console.log('got leet response');
						if(typeof(_WifiDiagCallback) != 'undefined')
							_WifiDiagCallback(command);
						break;
					default:
						Core.Proc._classRecvGen( command.split( ',' ) );
						break;
				}
			}
		}

		if( gNgShutdownPending )
		{
			gNgShutdownPending = false;
		}
		else	// Don't do updates if we're resetting.
		{
			NgEngineProcessEntityAddRemove();
			for(var i in gNgUpdateEngineEntities)
			{
				var entity = gNgUpdateEngineEntities[i];
				if(!entity.mRegistered) continue;
				entity.onUpdate();
			}
		}
	}
	catch(ex)
	{
		NgHandleException(ex);
	}
		
	var tmp = Core.Proc.getCommandString() + gNgCommandString;
	gNgCommandString = tmp;
	Core.Proc.clearCommandString();

	return NgFlushCommandsToString();
}
})();


//////////////////////////////////////////////////////////////////////////////////////////////////
////	NgApplication class
//////////////////////////////////////////////////////////////////////////////////////////////////

var Capabilities = require('NGCore/Client/Core/Capabilities').Capabilities;
var Logger = require('NGCore/Client/Core/Logger').Logger;

/** @private */

var NgApplicationCommands = {
	Caps : 0,
	Debug : 1,
	FrameTime : 2,
	FrameRate : 3,
	Start : 4,
	DeviceOrientation: 10,
	SetOrientation: 11,
	BackPress: 12,
	OnBackPressed: 13,
	LaunchExternalNativeApp: 15,
	ExitSystemProcess: 16
};

/**
  * Enumeration values for orientation change events received by
  * {@link NgApplicationObserver}.
  */

var NgApplicationOrientation = {
	Portrait : 0,
	PortraitUpsideDown : 1,
	LandscapeLeft : 2,
	LandscapeRight : 3,
	FaceUp : 4,
	FaceDown : 5
};

/**
  * The NgApplication constructor is invoked during application bootstrap and
  * should not be created by the ngGame application.  Access to the application
  * object should be through the singleton accessor {@link NgApplication#getInstance}.
  * @constructor
  *
  * @class
  * The NgApplication class represents global state and services that are available to
  * ngGame applications.  This includes file system operations,
  * download services, etc.  The application class also manages a time source
  * that is synchronized between the native engine and the ngGame application. <br>
  * The application object is a singleton and should only be accessed through the
  * {@link NgApplication#getInstance} method.
  */

function NgApplication()
{
	/** @private */
	this.mFileSys = Storage.FileSystem;
	/** @private */
	this.mFrameTime = 0.0;
	/** @private */
	this.mObservers = [];
}

// Singleton instance.
/** @private */
NgApplication.sInstance = null;

/**
  * Acquire the singleton instance of the application class.
  * @type NgApplication
  * @return The global application object.
  */

NgApplication.getInstance = function()
{
	if( NgApplication.sInstance == null )
		NgApplication.sInstance = new NgApplication();

	return NgApplication.sInstance;
};

// APITODO: Switch these methods to be defined out-of-line, not by an object literal.

NgApplication.prototype =
{
	mFileSys : null,
	mObservers : [],
	mFrameTime : 0.0,
	
	/** @private */
	restart : function()
	{
	},
	
	/** @private */
	handleCommand : function(command)
	{
		//		NgLogD( "NgApplication command = " + command );

		var commandId = NgPeekCommandId( command );

		switch( commandId )
		{
			case NgApplicationCommands.FrameTime:
				this.parseFrameTime( command );
				break;
			case NgApplicationCommands.Start:
				this.onApplicationStart();
				break;
			case NgApplicationCommands.OnBackPressed:
				this.onApplicationBackPressed();
				break;
			default:
				NgLogE( "NgApplication command unknown: " + command);
				break;
		}
	},
	
	/**
	  * Acquire the file system object.
	  * @type NgFileSys
	  * @return The file system instance.
	  */
	getFileSys : function()
	{
		return this.mFileSys;
	},

	/** @private */
	ngLog : function( level, dbgStr )
	{
		NgPushCommand4( NgEntityTypes.App, NgApplicationCommands.Debug, Core.Base64.encode( dbgStr ), level );
	},
	
	/** @private */
	parseFrameTime : function( command )
	{
		var fields = NgParseCommand2(command,parseInt,parseFloat);
		var frameTime = fields[1];

		if(this.mFrameDelta == undefined)
			this.mFrameDelta = 0;
		else
			this.mFrameDelta = frameTime - this.mFrameTime;

		this.mFrameTime = frameTime;
	},
	
	/**
	  * Get the application time for the current frame.
	  * @type number
	  * @return The time in milliseconds.
	  */
	getFrameTime : function()
	{
		return this.mFrameTime;
	},
	
	/**
	  * Get the application time delta between the current frame and the last frame.
	  * @type number
	  * @return The time delta in milliseconds.
	  */
	getFrameDelta : function()
	{
		return this.mFrameDelta;
	},

	/**
	  * Set the desired application frame rate. <br>
	  * Note: The frame rate specification is not currently fully functional on all 
	  * platforms.
	  * @param {number} frameRate The desired frame rate in hz.
	  * @type void
	  */
	setFrameRate : function(frameRate)
	{
		NgPushCommand3( NgEntityTypes.App, NgApplicationCommands.FrameRate, frameRate);
	},

	/**
	  * Set the current device orientation for the application. <br>
	  * Note: Setting the orientation is not currently fully functional on all
	  * platforms.
	  * @param {NgApplicationOrientation} orientation The desired orientation.
	  * @type void
	  */
	setOrientation : function(orientation)
	{
		NgPushCommand3( NgEntityTypes.App, NgApplicationCommands.SetOrientation, orientation);
	},

	/**
	  * Register an application observer to receive application callbacks.
	  * @param {NgApplicationObserver} obs The observer to register.
	  * @type void
	  */
	registerObserver : function(obs)
	{
		obs.index = this.mObservers.push(obs);
	},

	unregisterObserver : function(obs)
	{
		if (obs.index)
			delete this.mObservers[obs.index - 1];
	},

	/** @private */
	onApplicationStart : function()
	{
		NgUI.onLoad();
		for (i in this.mObservers)
		{
			// TODO is this even possible?
			this.mObservers[i].onApplicationStart();
		}
	},
	
	/** @private */
	onApplicationReceivedCustomMessage : function( message )
	{
		for (i in this.mObservers)
		{
			this.mObservers[i].onApplicationReceivedCustomMessage( message );
		}
	},
	
	/** @private */
	onApplicationBackPressed : function()
	{
			var observerResult = false;
			for (i in this.mObservers)
			{
				 if (this.mObservers[i].onApplicationBackPressed())
				 {
					observerResult = true;
					break;
				 }
			}
			if (!observerResult)
			{
				// back button was not fully handled. Ask the native application to handle it.
				NgPushCommand2(NgEntityTypes.App, NgApplicationCommands.BackPress);
			}
	},
	
	/** @private */
	exitSystemProcess : function ()
	{
		NgLogD ( "pushing exit command" );
		//This makes java exit the app through android lifecycle
		NgPushCommand2(NgEntityTypes.App, NgApplicationCommands.BackPress);
		NgLogD ( "pushed exit command" );
	}
};

// Observer base class for application events.

/**
  * Initialize a new application observer.
  * @constructor
  *
  * @class
  * The NgApplicationObserver class is used as the base class for any user-defined
  * class that receives application-level callbacks.  This currently includes
  * notifications on all application lifecycle events and device orientation
  * changes. <br>
  * Register the application observer by calling {@link NgApplication#registerObserver}.
  */

function NgApplicationObserver() {}

NgApplicationObserver.prototype =
{
	index: 0,
	/**
	  * Callback for application lifecycle start event.
	  * @type void
	  */
	onApplicationStart:function() {},

	/** @private */
	onApplicationReceivedCustomMessage:function( message ) {},

	/**
	  * Callback for device orientation change events.
	  * @param {NgApplicationOrientation} orientation Orientation enumeration value.
	  * @type void
	  */
	onApplicationDeviceOrientation:function( orientation ) {},

	/*
	 * Listener for when the user pushes the HW back button. Currently Android only.
	 *
	 * @return boolean true if back was handled entirely (eat the event), 
	 * false if it was not
	 *
	 */
	onApplicationBackPressed:function()
	{
		return false;
	}
};

//////////////////////////////////////////////////////////////////////////////////////////////////
// class Entity
// Base class for other entity types.
//////////////////////////////////////////////////////////////////////////////////////////////////

// ObjectTypes
// Defined in
//		JS:  NgEntityTypes in NgWebEngine.js and
//		C++: EntityCommandIds in GameView.h
// 1 = App
// 2 = NgTouchEvent
// 3 = NgKeyPressEvent
// 4 = Accel
// 5 = NgTextInputBox2D
// 6 = Animation (completion events)
// 7 = Sound (completion events)
// 8 = EngineEntity
// 9 = DrawableEntity2D
// 10 = NgCanvas2D
// 11 = NgCamera2D
// 12 = NgSprite2D
// 13 = NgText2D
// 14 = NgWebView2D
// 15 = NgAudioManager
// 16 = NgGroup2D
// 100 = LoadApp

// App Commands
// in:
// capabilities = 0, command dictionary format
// frameTime = 2, double
// out:
// NgLogD = 1, string

// NgTouchEvent Commands
// non-native
//	action: 1 = add, 2 = remove, 3 = modify
//	id: touch instance ID
//	x: x position
//	y: y position
// native
//	action: 4 = add, 5 = remove, 6 = modify
//	id: touch instance ID
//	x: x pos
//	y: y pos
//  eid: entity instance ID
//	lx: local x pos
//  ly: local y pos

// NgKeyPressEvent Commands
// action: 1 = down, 2 = up
// id: instance ID
// value: key value

// InputText Box Commands

// Animation
// in:
// only one kind of event, so first value is id of sprite to callback.

// Sound
// in:
//

// Accel Commands
// out:
// SetEventRate = 0, rate (hz)
// in:
// x, y, z position (floats)

// EngineEntity commands

// DrawableEntity2D commands:
// SetNativeTouchType=1,id,value (None=1, Enable = 2, EnableBounds = 3)

// NgCanvas2D Commands
// NewNgCanvas2D=1, id
// DeleteNgCanvas2D=2, id
// Update=3, id, args... not used currently
// SetRoot=4, id, grp id
// ClearRoot=5, id
// EnableNativePicking=6, id, bool

// NgCamera2D Commands
// NewNgCamera2D=1,		id, canvasId, porperties
// DeleteNgCamera2D=2,	id
// UpdateNgCamera2D=3,	id, properties
//	Properties: vx, vy, vz, vh, vw, cx, cy, ch, cw

// NgSprite2D Commands
// NewNgSprite2D=1,		id, canvasId, texture, properties
// DeleteNgSprite2D=2,	id
// UpdateNgSprite2D=3,	id, properties
//   Properties: x, y, z, w, h, r, a

// NgText2D Operations
// NewNgText2D=1		id, canvasId, properties
// DeleteNgText2D=2	id
// UpdateNgText2D=3	id, properties
//  Properties: x, y, z, w, h, justify, text

// NgGroup2D Operations
// New = 1			id, canvasId, [properties/todo]
// Delete = 2		id
// Update = 3		id, [properties/todo]
// Child = 4		id, subcmd, [child id]
//						subcmd 0 = add, 1 = rem, 2 = remAll (no child id)
// Rot = 5			id, anglef
// Pos = 6			id, xf, yf, zf
// Alpha = 7		id, alphaf
// Scale = 8		id, xf, yf

// APITODO: Clean up these identifiers.
// APITODO: Sound is probably not used any more.
// APITODO: Animation is probably not used any more.

var NgEntityTypes = {
	App : 1,
	NgTouchEvent : 2,
	NgKeyPressEvent : 3,
	Accel : 4,
	NgTextInputBox2D : 5,
	Animation : 6,
	Sound : 7,
	NgEngineEntity : 8,
	NgDrawableEntity2D : 9,
	NgCanvas2D : 10,
	NgCamera2D : 11,
	NgSprite2D : 12,
	NgText2D : 13,
	NgWebView2D : 14,
	NgGroup2D : 16,
	NgPhysics2D: 17,
	NgPrimitive2D: 18,
	NgFileSys: 19,
	Gyro : 22,
	NgUI : 23,
	Storage: 24,
	NgSystemBinding: 25,
	NgCustomMessage : 50,
	LoadApp : 100
};

var NgEngineEntityCommandIDs = {
	SetNativeTouchType : 1
};

/**
 * Initializes instance to default values. <br>
 * mId member defaults to 0 but can be set by application before calling {@link NgEngineEntity#register}.
 * @constructor
 *
 * @class
 * NgEngineEntity is the base class for all game entities, such as NgSprite2D and NgText2D. <br>
 * This class introduces key callback functions for touch, key press and per-frame update
 * notification. <br>
 * Additionally, the class introduces a register/unregister mechanism
 * for controlling the existence of the entity in the native game engine.
 *
 */

function NgEngineEntity()
{
	/** The entity id.  Used by the native engine for identification.  @type number */
	this.mId = 0;
	/** The touch priority.  Touches are routed first to the highest priority entities.  @type number */
	this.mTouchPriority = 0;
	/** The key press priority.  Key presses are routed first to the highest priority entities.  @type number */
	this.mKeyPressPriority = 0;
	/** @private */
	this.mIsTouchable = false;
	/** @private */
	this.mIsKeyable = false;
	/** @private */
	this.mIsUpdatable = false;
	/** @private */
	this.mNativeTouchType = NgEngineEntity.NativeTouchType.Enable;
	/** @private */
	this.mRegistered = false;
}

// Static methods and data.

/**
  * NgEngineEntity touch policy enumeration. <br>
  * Used with {@link NgEngineEntity#setNativeTouchType} and {@link NgCanvas2D#enableNativePicking}. <br>
  * Values: <br>
  * None : Disables native touches for this entity (and its children). <br>
  * Enable : Enables this entity to receive touches (or visits child entities) <br>
  * EnableBounds : Enables this entity to receive touches on its axis-aligned bounding box.  If
  * a touch is received on a group, it will report the touch and _not_ visit the group's children.
  */

NgEngineEntity.NativeTouchType = {
	None : 0,
	Enable : 1,
	EnableBounds : 2
};

/**
  * @private
  */

NgEngineEntity.engineCurrentId = 1;

/**
  * Allocate a unique ID for an entity.
  * @return ID value.
  * @type number
  * @private
  */

NgEngineEntity.newEngineId = function ()
{
	return NgEngineEntity.engineCurrentId++;
}

/**
  * Reclaim an entity ID.
  * @private
  */

NgEngineEntity.deleteEngineId = function ()
{
	// Nothing.
}

// Instance methods.

// Basic entity callbacks.

/** @private */

NgEngineEntity.prototype.newEntity = function() {}

/** @private */

NgEngineEntity.prototype.deleteEntity = function() {}

/**
  *	Callback for standard touch events. <br>
  * Standard touch events correspond to all touches
  * within the game view.  For each touch on the game view, all registered touchable
  * entities will receive the event.  Application logic must perform filtering to determine
  * if a particular entity corresponds to the touch event. <br>
  * Refer to {@link NgEngineEntity#toggleTouchable} for control of an entity's touchable state.
  * @param {NgTouchEvent} touch The touch event.
  * @return The application can return true to indicate that it has consumed this event or false
  * to allow other entities to continue processing this event.
  * @type bool
  */

NgEngineEntity.prototype.onTouch = function(touch)
{
	return false;
}

/**
  * Callback for native touch events. <br>
  * Native touch events are pre-filtered by the game engine
  * to correspond to a specific touchable entity.  For each touch on the game view, the game
  * engine will determine which game entities are selected by the touch event.  Only the 
  * selected entities will receive the onNativeTouch event callback. <br>
  * Native touch capability is not affected by touchable state of the entity determined by
  * {@link NgEngineEntity#toggleTouchable}.  Refer to {@link NgEngineEntity#setNativeTouchType} 
  * for management of an entity's native touch policy.
  * @param {NgNativeTouchEvent} touch The touch event.
  * @return The application can return true to indicate that it has consumed this event or false
  * to allow other entities to continue processing this event.
  * @type bool
  */

NgEngineEntity.prototype.onNativeTouch = function(touch)
{

}

/**
  * Callback for keyboard events. <br>These events correspond to physical or software keyboard events. <br>
  * Enable/disable key press events for an entity with {@link NgEngineEntity#toggleKeyable}.
  * @param {NgKeyPressEvent} keyPress The key press event.
  * @return The application can return true to indicate that it has consumed this event or false
  * to allow other entities to continue processing this event.
  * @type bool
  */

NgEngineEntity.prototype.onKeyPress = function(keyPress)
{
	return false;
}

/**
  *	Callback for update events. <br>Per-frame entity logic should be implemented in this callback. <br>
  * Enable/disable update events for an entity with {@link NgEngineEntity#toggleUpdatable}.
  * The return value of this method is ignored.
  * @type void
  */

NgEngineEntity.prototype.onUpdate = function()
{
}

/**
  *	Register this entity instance with the native game engine. <br>
  * The initialization sequence of engine entities has specific constraints: <br>
  * After construction and before calling
  * the register method, class methods that affect the native engine state cannot be called.  
  * During this period, changes to entity state by changing instance variables will be
  * sent to the native engine on the call to register. <br>
  * After register is called, 
  * changes to instance variables will be ignored.  During this phase, the only
  * way to affect native engine state is through methods that push commands to
  * the native side.
  * @type void
  */

NgEngineEntity.prototype.register = function()
{
	this.mParents = new Array();

	if( this.mId >= 0 )
	{
		this.mId = NgEngineEntity.newEngineId();
	}

	this.mRegistered = true;
	gNgEngineEntities[this.mId] = this;
	gNgAddedEngineEntities[this.mId] = this;
	this.newEntity();
}

/**
  * Unregister this entity from the native game engine.
  * @type void
  */

NgEngineEntity.prototype.unregister = function()
{
	var parents = this.mParents.concat(new Array());

	for (var i in parents)
	{
		NgLogD ( "Removing child " + this.mId + " from parent Group " + parents[i].mId + " because the Entity was unregistered");
		parents[i].removeChild( this );
	}

	this.mRegistered = false;
	delete gNgEngineEntities[this.mId];
	// CAUTION : DO NOT SPLICE gNgEngineEntities EVER.
	//gNgEngineEntities.splice(this.mId,1);

	gNgRemovedEngineEntities[this.mId] = this;
	this.deleteEntity();

	if(this.mId >= 0)
		NgEngineEntity.deleteEngineId(this.mId);
}

/**
  * Enable/disable key press callbacks for this entity. <br>This method flips the enable state
  * for key press events. <br>
  * In order to receive key press callbacks, an entity
  * must override the onKeyPress event and enable keyable state by calling this 
  * method. <br>
  * The default state is false.
  * @type void
  */

NgEngineEntity.prototype.toggleKeyable = function()
{
	if(this.mIsKeyable)
		gNgKeyPressEngineEntities.splice(NgFindIndex(gNgKeyPressEngineEntities,this),1);
	else
		NgInsertSortedKeyPress(this);

	this.mIsKeyable = !this.mIsKeyable;
}

/**
  * Enable/disable update callbacks for this entity. <br>
  * This method flips the enable state
  * for update events. <br>
  * In order to receive update callbacks, an entity
  * must override the onUpdate event and enable updatable state by calling this 
  * method. <br>
  * The default state is false.
  * @type void
  */

NgEngineEntity.prototype.toggleUpdatable = function()
{
	if(this.mIsUpdatable)
	{
		delete gNgUpdateEngineEntities[this.mId];
	}
	else
	{
		gNgUpdateEngineEntities[this.mId] = this;
	}
	this.mIsUpdatable = !this.mIsUpdatable;
}

/**
  * Enable/disable touch callbacks for this entity. <br>
  * This method flips the enable state for touch events. <br>
  * In order to receive touch callbacks, an entity
  * must override the onTouch event and enable touchable state by calling this 
  * method. <br>
  * The default state is false.
  * @type void
  */

NgEngineEntity.prototype.toggleTouchable = function()
{
	if(this.mIsTouchable)
		gNgTouchEngineEntities.splice(NgFindIndex(gNgTouchEngineEntities,this),1);
	else
		NgInsertSortedTouch(this);

	this.mIsTouchable = !this.mIsTouchable;
}

/**
  * Set native touch traversal policy. <br>
  * This method controls how the native game engine
  * traverses the game scene graph. <br>
  * The policies are described in further detail with {@link NgEngineEntity#NativeTouchType}. <br>
  * The default state is "Enable".
  * @param {NativeTouchType} type The policy enum for native touch processing.
  * @type void
  */

NgEngineEntity.prototype.setNativeTouchType = function( type )
{
	this.mNativeTouchType = type;
	NgPushCommand4(NgEntityTypes.NgDrawableEntity2D, NgEngineEntityCommandIDs.SetNativeTouchType, this.mId, this.mNativeTouchType );
}
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
var Core = require('NGCore/Client/Core').Core;

// These methods handle all composition for commands being sent back to the
// native engine.

/**
  * @private
  */

var gNgCommandStrings = [];

/**
  * @private
  */

var gNgCommandString = '';

// 0 deferred string composition via user loop
// 1 deferred string composition via internal loop
// 2 on-the-fly string composition.

// TODO: Benchmark all variation on all platforms.  Choose appropriate one(s)
// and prune code for others.

// UPDATE: ALL variations on contructing a string performed IDENTICALLY in
// the iPhone's UIWebView.  Unbelievable.

/**
  * @private
  */

var gNgCommandMode = 2;

/**
  * @private
  */

function NgQueueCommandText(command)
{
	switch(gNgCommandMode)
	{
		case 0:
		case 1:
			gNgCommandStrings.push( command );
			break;
		case 2:
			gNgCommandString += command;
			break;
	}
}

/**
  * @private
  */

function NgFlushCommandsToString()
{
	var outputString = '';
	
	switch(gNgCommandMode)
	{	
		case 0:
			for( var num = 0, end = gNgCommandStrings.length; num < end; ++num )
			{
				outputString += gNgCommandStrings[ num ];
			}
			break;
			
		case 1:
			outputString = String.prototype.concat.apply(gNgCommandStrings);
			break;
	}
	
	switch(gNgCommandMode)
	{
		case 0:
		case 1:
			gNgCommandStrings = [];
			break;
		case 2:
			outputString = gNgCommandString;
			gNgCommandString = '';
			break;
	}
	
	return outputString;	
}

//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

function NgParseString(txt)
{
	return txt;
}

/**
  * @private
  */

function NgParseBase64(txt)
{
	if( txt )
		return Core.Base64.decode(txt);
	else
		return "";
}

/**
  * @private
  */

function NgParseBool(txt)
{
	return parseInt(txt) ? true : false;
}

function NgParseInt(txt)
{
	return parseInt(txt, 10);
}

function NgKVArrayToCmd(kvArray)
{
	var out = "";
	var count = 0
	for (var s in kvArray)
	{
		var value = kvArray[s];
		
		out += "," + s + "," + Core.Base64.encode(value);
		++count;
	}
	return count + out;
}
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

/**
 * Submit a command with 1 argument to the native engine.
 * @private
 */
function NgPushCommand1(arg1)
{
	gNgCommandString += ":" + arg1;
}

/**
 * Submit a command with 2 arguments to the native engine.
 * @private
 */
function NgPushCommand2(arg1, arg2)
{
	gNgCommandString += ":" + arg1 + "," + arg2;
}

/**
 * Submit a command with 3 arguments to the native engine.
 * @private
 */
function NgPushCommand3(arg1, arg2, arg3)
{
	gNgCommandString += ":" + arg1 + "," + arg2 + "," + arg3;
}

/**
 * Submit a command with 4 arguments to the native engine.
 * @private
 */
function NgPushCommand4(arg1, arg2, arg3, arg4)
{
	gNgCommandString += ":" + arg1 + "," + arg2 + "," + arg3 + "," + arg4;
}

/**
 * Submit a command with 5 arguments to the native engine.
 * @private
 */
function NgPushCommand5(arg1, arg2, arg3, arg4, arg5)
{
	gNgCommandString += ":" + arg1 + "," + arg2 + "," + arg3 + "," + arg4 + "," + arg5;
}

/**
 * Submit a command with 6 arguments to the native engine.
 * @private
 */
function NgPushCommand6(arg1, arg2, arg3, arg4, arg5, arg6)
{
	gNgCommandString += ":" + arg1 + "," + arg2 + "," + arg3 + "," + arg4 + "," + arg5 + "," + arg6;
}

/**
 * Submit a command with 7 arguments to the native engine.
 * @private
 */
function NgPushCommand7(arg1, arg2, arg3, arg4, arg5, arg6, arg7)
{
	gNgCommandString += ":" + arg1 + "," + arg2 + "," + arg3 + "," + arg4 + "," + arg5 + "," + arg6 + "," + arg7;
}

/**
 * Submit a command with 8 arguments to the native engine.
 * @private
 */
function NgPushCommand8(arg1, arg2, arg3, arg4, arg5, arg6, arg7,arg8)
{
	gNgCommandString += ":" + arg1 + "," + arg2 + "," + arg3 + "," + arg4 + "," + arg5 + "," + arg6 + "," + arg7 + "," + arg8;
}

/**
 * Submit a command with 8 arguments to the native engine.
 * @private
 */
function NgPushCommand9(arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9)
{
	gNgCommandString += ":" + arg1 + "," + arg2 + "," + arg3 + "," + arg4 + "," + arg5 + "," + arg6 + "," + arg7 + "," + arg8 + "," + arg9;
}

/**
 * Submit a command with n arguments to the native engine.
 * @private
 */
function NgPushCommandN()
{
	var argv = arguments;
	var argc = argv.length;
	
	var tmp = ":";
	
	if( argc > 0 )
	{
		tmp += argv[ 0 ];
		
		for( var num = 1; num < argc; ++num )
		{
			tmp += "," + argv[ num ];
		}
	}
	
	gNgCommandString += tmp;
}

/**
 * Peek at the command ID in a command string.  This helps avoid 
 * splitting the string twice in a number of cases.
 * @return Command id or null if parsing failed.
 * @private
 */

function NgPeekCommandId(str)
{
	var vals = str.split ( ",", 2 );
	if( vals.length == 2 )
		return parseInt ( vals[ 1 ] );
	else
		return null;
}

/**
 * Peek at the class and command ID in a command string.  This helps avoid 
 * splitting the string twice in a number of cases.
 * @return Two-element array of ids or null if parsing failed.
 * @private
 */

function NgPeekClassAndCommandId(str)
{
	var vals = str.split ( ",", 2 );
	if( vals.length == 2 )
	{
		vals[ 0 ] = parseInt ( vals[ 0 ] );
		vals[ 1 ] = parseInt ( vals[ 1 ] );
		return vals;
	}
	else
		return null;
}


/**
 * Parse an incoming command string to individual strings.
 * @return an array of fields in serialization order.
 * @private
 */
function NgParseCommandToStrings(src)
{
	return src.split(",");
}

/**
  * @private
  */

function NgParseCommand1(src, func1)
{
	var ret = [];
	
	var fields = src.split(",");
	
	ret[ 0 ] = func1( fields[ 1 ] );
	
	return ret;
}

/**
  * @private
  */

function NgParseCommand2(src, func1, func2)
{
	var ret = [];
	
	var fields = src.split(",");
	
	ret[ 0 ] = func1( fields[ 1 ] );
	ret[ 1 ] = func2( fields[ 2 ] );
	
	return ret;
}

/**
  * @private
  */

function NgParseCommand3(src, func1, func2, func3)
{
	var ret = [];
	
	var fields = src.split(",");
	
	ret[ 0 ] = func1( fields[ 1 ] );
	ret[ 1 ] = func2( fields[ 2 ] );
	ret[ 2 ] = func3( fields[ 3 ] );
	
	return ret;
}

/**
  * @private
  */

function NgParseCommand4(src, func1, func2, func3, func4)
{
	var ret = [];
	
	var fields = src.split(",");
	
	ret[ 0 ] = func1( fields[ 1 ] );
	ret[ 1 ] = func2( fields[ 2 ] );
	ret[ 2 ] = func3( fields[ 3 ] );
	ret[ 3 ] = func4( fields[ 4 ] );
	
	return ret;
}

/**
  * @private
  */

function NgParseCommand5(src, func1, func2, func3, func4, func5)
{
	var ret = [];
	
	var fields = src.split(",");
	
	ret[ 0 ] = func1( fields[ 1 ] );
	ret[ 1 ] = func2( fields[ 2 ] );
	ret[ 2 ] = func3( fields[ 3 ] );
	ret[ 3 ] = func4( fields[ 4 ] );
	ret[ 4 ] = func5( fields[ 5 ] );
	
	return ret;
}


/**
 * Parse an incoming command string to typed values based on passed-in functions.
 * ex: NgParseCommandN("1:1,1.0,ACFHENA==",parseInt, parseFloat, NgParseString);
 * NOTE: The first item is assumed to be the command type, and will be
 * discarded in the output.  I.e., the output starts with the second src element.
 * @return an array of parsed fields in serialization order.
 * @private
 */

function NgParseCommandN(src)
{
	var ret = [];
	
	var argv = arguments;
	var argc = argv.length;
	
	var fields = src.split(",");
	for( var num = 1; num < argc; ++num )
	{
		ret[ num - 1 ] = argv[ num ]( fields[ num ] );
	}
	
	return ret;
}

/**
 * Parse an incoming typed dictionary.  The format of the dictionary is:
 * type,field name,value,type,field name,value[...]
 * Parsed values will be asigned to the field name in the dst array/object.
 * NOTE: Strings passed in this format must not have embedded commas (use
 * base64 encoding if arbitrary strings are being used.
 * @arg src The source command string.
 * @arg srcStart The field index to start parsing dictionary entries from.
 * @arg dst The destination object/array for parsed values.
 * @arg initialFields Optionally store the fields before srcStart in the passed-in array.
 * @return true if all fields were successfully parsed.
 * @private
 */

function NgParseCommandDictionary(src,srcStart,dst,initialFields)
{
	var ret = true;
	var fields = src.split(",");
	var end = fields.length;
	
	if(initialFields)
	{
		for( var num = 0; num < srcStart; ++num )
		{
			initialFields[ num ] = fields[ num ];
		}
	}
	
	for( var num = srcStart; num < end; )
	{
		var type = fields[ num++ ];
		var name = fields[ num++ ];
		var val = fields[ num++ ];
		var good = true;
		
		switch(type)
		{
			case 'i':	// int
				val = parseInt( val );
				break;
			case 'f':	// float
				val = parseFloat( val );
				break;
			case 's':	// string
				break;
			case 'S':	// base64 string
				val = Core.Base64.decode(val);
				break;
			case 'b':	// bool
				val = parseInt(val) ? true : false;
				break;
			default:
				//				NgLogD("NgParseCommandDictionary unknown type for " + type + " " + name + " " + val);
				ret = false;
				good = false;
				break;
		}
		
		if( good )
		{
			dst[ name ] = val;
			
			// TEMP PRW
			NgLogD( "dict: " + name + " : " + dst[ name ] );
		}
		else
		{
			NgLogD("dict: could not process " + type );
		}
	}
	
	return ret;
}
/**
  * @private
  */

var gNgTrace=null;

//////////////////////////////////////////////////////////////////////////////////////////////////
// Logging functions.
//////////////////////////////////////////////////////////////////////////////////////////////////

/**
  * @private
  */
var NgDebugModes = {
	BrowserTrace : {},
	NgCommand : {},
	NgCommandDocLoc : {}
};

/**
  * @private
  */
var NgLogLevel = {
	Verbose : 5,
	Debug : 4,
	Info : 3,
	Warning : 2,
	Error : 1
};

/**
  * @private
  */
var NgLogStr = [ '', 'e', 'w', 'i', 'd', 'v'];


/**
  * @private
  */

// TEMP... this is not how we want to do this long-term.
function NgSetDebugDefaultDestination()
{
	if (typeof navigator == 'undefined')
	{
		return NgDebugModes.NgCommand;
	}

	var agent=navigator.userAgent.toLowerCase();
	if( ! ( (agent.indexOf('iphone') >=0) || (agent.indexOf('ipad') >= 0) ) )
	{
		return NgDebugModes.BrowserTrace;
	}
	else
	{
		return NgDebugModes.NgCommand;
	}
}

/**
  * @private
  */

var gNgDebugMode = NgSetDebugDefaultDestination();

/**
  * @private
  */

function NgLogInit()
{
	if( gNgDebugMode == NgDebugModes.BrowserTrace )
	{
		gNgTrace = document.getElementById("trace");
	}

	// Other modes don't need initialization.
}

function NgLogSetLevel(level)
{
	switch( level )
	{
		case NgLogLevel.Debug:
		{
			NgLogV = NgNoLog;
			NgLogD = NgDoDebugLog;
			NgLogI = NgDoInfoLog;
			NgLogW = NgDoWarningLog;
			NgLogE = NgDoErrorLog;
		}
			break;

		case NgLogLevel.Info:
		{
			NgLogV = NgNoLog;
			NgLogD = NgNoLog;
			NgLogI = NgDoInfoLog;
			NgLogW = NgDoWarningLog;
			NgLogE = NgDoErrorLog;
		}
			break;

		case NgLogLevel.Warning:
		{
			NgLogV = NgNoLog;
			NgLogD = NgNoLog;
			NgLogI = NgNoLog;
			NgLogW = NgDoWarningLog;
			NgLogE = NgDoErrorLog;
		}
			break;

		case NgLogLevel.Error:
		{
			NgLogV = NgNoLog;
			NgLogD = NgNoLog;
			NgLogI = NgNoLog;
			NgLogW = NgNoLog;
			NgLogE = NgDoErrorLog;
		}
			break;

		default:
		case NgLogLevel.Verbose:
		{
			NgLogV = NgDoVerboseLog;
			NgLogD = NgDoDebugLog;
			NgLogI = NgDoInfoLog;
			NgLogW = NgDoWarningLog;
			NgLogE = NgDoErrorLog;
		}
			break;
	}
}

NgDoVerboseLog = function ( msg ) {
	NgLog(NgLogLevel.Verbose, msg);
}

NgDoDebugLog = function ( msg ) {
	NgLog(NgLogLevel.Debug, msg);
}

NgDoInfoLog = function ( msg ) {
	NgLog(NgLogLevel.Info, msg);
}

NgDoWarningLog = function ( msg ) {
	NgLog(NgLogLevel.Warning, msg);
}

NgDoErrorLog = function ( msg ) {
	NgLog(NgLogLevel.Error, msg);
}

NgNoLog = function() {};
NgLogSetLevel(NgLogLevel.Verbose);

var useConsole = ((typeof console != 'undefined') && (typeof console.log == 'function'));

function NgLog( level, msg )
{
	console.log(NgLogStr[level] + ": " + msg);
}

function NgLogException( ex )
{
    var str = "\nEXCEPTION:\n";

    for( var prop in ex )
    {
		str += "property: "+ prop+ " value: ["+ ex[prop]+ "]\n";
    }

    str += "toString(): " + " value: [" + ex.toString() + "]\n\n";

	NgLogD( str );
}
/*
 @author: Remy Sharp / http://remysharp.com
 @date: 2007-04-20
 @name: time
 @methods:
 start - start named timer
 stop - stop named timer
 event - hook predefined event
 func - hook existing function, or hook anonymous function (note refrence is passed back)
 report - output timings
 */
if ((typeof window == 'undefined') || (typeof window.time == 'undefined'))
{
	(function() {
		time = {
			// start + stop taken from firebuglite.js -
			// http://getfirebug.com/firebuglite
			start : function(name) {
				if (!name) {
					error('start: If starting a timer manually a name must be set');
				} else {
					timeMap[name] = (new Date()).getTime();
					if (name in NgRecordMap) {
					} else {
						NgRecordMap[name] = new NgRecord(name);
					}
				}
			},

			stop : function(name) {
				if (name in timeMap) {
					var stop = (new Date()).getTime();
					// var l = new Report(name, timeMap[name], stop);
					var l = NgRecordMap[name].addRecord(stop - timeMap[name]);
					log.push(l);
					if (NgRecordMap[name].records % NgRecordMap[name].ctr == 0) {
						NgRecordMap[name].lineReportMethod.call(this, l);
						NgRecordMap[name].records = 0;
						NgRecordMap[name].avg = 0;
						NgRecordMap[name].min = 55555;
						NgRecordMap[name].max = 0;
					}
					delete timeMap[name];
				} else {
					error('stop:' + name + ' not found');
				}
			},

			event : function(name, elm, type) {
				if (typeof name != 'string') {
					// name has not been passed in
					type = elm;
					elm = name;
					name = '';
				}

				if (!elm.length) {
					elm = [ elm ];
				}

				if (type.indexOf('on') == -1) {
					type = 'on' + type;
				}

				var i = elm.length;
				var timerN = null;
				var c = null;
				while (i--) {
					timerN = name;
					if (!timerN) {
						timerN = elm[i].id || elm[i].getAttribute('class')
								|| elm[i].getAttribute('className')
								|| elm[i].tagName;
					}

					mapEvent(elm[i], type, timerN);
				}
			},

			func : function(name, fn) {
				if (typeof name == 'function') {
					fn = name;
				}

				// get function name as this browser may not support fn.name (IE
				// + Safari + Opera)
				if (!fn.name && typeof fn == 'function') {
					var m = fn.toString().match(/function\s*(.*)\s*\(/);
					if (m[1]) {
						fn.name = m[1];
					}
				}

				if (typeof fn == 'function' && !fn.name) {
					// function is anonymous -
					// time function using var func = time.fn(function() { ...do
					// stuff });
					if (typeof name != 'string') {
						anonFuncId++;
						name = 'anonymous' + anonFuncId;
					}

					return function() {
						time.start(name);
						var ret = fn.apply(window, arguments);
						time.stop(name);
						return ret;
					};
				} else {
					var fnName = fn.name || fn;
					if (typeof name != 'string') {
						name = fnName;
					}

					eval('var fnCopy = ' + fnName);
					if (typeof fnCopy == 'function') {
						var wrap = function() {
							time.start(name);
							var ret = fnCopy.apply(this, arguments);
							time.stop(name);
							return ret;
						};
						wrap.hooked = true;
						eval(fnName + ' = wrap;');
						return eval(fnName);
					} else {
						// error hooking
						error('func: Could not hook function (name: ' + name + ')');
					}
				}
			},

			report : function(name) {
				if (typeof name == 'undefined') {
					reportMethod.call(this, log);
				} else {
					var i = log.length;
					var l = [];
					while (i--) {
						if (name == log[i].name) {
							l.push(log[i]);
						}
					}
					reportMethod.call(this, l);
				}
			},

			setReportMethod : function(fn) {
				if (fn.hooked) {
					error('setReportMethod: Cannot use hooked method ' + fn.name);
				} else {
					reportMethod = fn;
				}
			},

			setCtr : function(name, ctr, fn) {
				if (name in NgRecordMap) {
				} else
					NgRecordMap[name] = new NgRecord(name, ctr, fn);
			},

			setLineReportMethod : function(fn) {
				if (fn.hooked) {
					error('setLineReportMethod: Cannot use hooked method ' + fn.name);
				} else {
					lineReportMethod = fn;
					lineReport = true;
				}
			},

			errors : false
		};

		var timeMap = {};
		var NgRecordMap = {};
		var log = [];
		var reportMethod = defaultReport;
		var lineReport = false;
		var lineReportMethod = defaultLineReport;
		var anonFuncId = 0;

		var Report = function(n, s, e) {
			this.name = n;
			this.start = s;
			this.stop = e;
			this.delta = e - s;
			// useful if I could grab the call - but can't see how due to anon
			// functions (though I can see them in the start method)
		};

		Report.prototype.toString = function() {
			return this.name + ": " + this.delta + "ms";
		};

		function defaultReport(l) {
			alert(l.join("\n"));
		}

		function defaultLineReport(l) {
			alert(l);
		}

		function error(e) {
			if (time.errors)
				alert(e);
		}

		var NgRecord = function(name, ctr, fn) {
			this.name = name;
			this.records = 0;
			this.avg = 0;
			this.min = 555555;
			this.max = 0;
			this.ctr = ctr;
			if (fn.hooked) {
				error('setLineReportMethod: Cannot use hooked method. Will use default method' + fn.name);
				this.lineReportMethod = defaultLineReport;
			} else {
				this.lineReportMethod = fn;
			}

		}

		NgRecord.prototype.addRecord = function(delta) {
			this.avg = (this.avg * this.records + delta) / (this.records + 1);
			if (this.min > delta)
				this.min = delta;
			if (this.max < delta)
				this.max = delta;
			this.records++;
			frq = 1000 / this.avg;
			return this.name + '->  max:' + this.max + '  min:' + this.min
					+ '  avg:' + this.avg.toFixed(2) + '  freq:'
					+ frq.toFixed(2) + '\n';
		}

		// required to create a brand new instance of our copied function
		function mapEvent(e, t, n) {
			var c = e[t];
			if (typeof c == 'function') {
				e[t] = function() {
					time.start(n + ':' + t);
					var ret = c.apply(this, arguments);
					time.stop(n + ':' + t);
					return ret;
				};
			} else {
				error('event: Function must be set on element.' + t
						+ ' before hooking (name: ' + n + ')');
			}
		}
	})();
}

/**
 * Filename: Main.js
 * Author: Wasay Abbasi
 * Date Created: 16thMay-2011
 * Date Updated: 
 */

var background=null;
 
var w =null;
var h =null;
var lifecycleListener = null;

function testingLocalization()
{
	var myString = GALocalizationHandler.getRelativeString(GALocalizationHandler.getLocalizedString('TF_DHM_LEFT'), [10 , 11 , 5]);//"dhmleft"
	GALogger.log('My String '+ myString);
	
	var temp = GALocalizationHandler.getLocalizedString('TF_COMMUNICATION_ERROR'); //communicationError
	GALogger.log('My String1 '+ temp);
	
}




function main()
{
	Device.OrientationEmitter.setInterfaceOrientation(Device.OrientationEmitter.Orientation.LandscapeLeft, false);
	NgApplication.getInstance().setOrientation(NgApplicationOrientation.LandscapeLeft);
    
    var orientationInterfaceListener = new InterfaceListener();
    
     SCREEN_HEIGHT = Core.Capabilities.getScreenHeight();
	 SCREEN_WIDTH = Core.Capabilities.getScreenWidth();
	 SCREEN_ASPECT_RATIO = (Math.round((SCREEN_HEIGHT / SCREEN_WIDTH)*100))/100;
    GameCentralHandler.setOrientationInterfaceListener(orientationInterfaceListener);
    var glView = new UI.GLView();
	glView.onload = function()
	{
		testingLocalization();
		lifecycleListener = new LifecycleListener();
		GameCentralHandler.instantiate();
      
	};
	glView.setAttribute('frame', [0, 0, GACommonUtils.getScreenWidth(), GACommonUtils.getScreenHeight()]);
	glView.setAttribute('active', true);
	
}


var LifecycleListener = Core.MessageListener.subclass( {
	classname: 'LifecycleListener',
	
	initialize : function() {
		Device.LifecycleEmitter.addListener(this, this.onLifecycleUpdate.bind(this));
	},

	destroy : function() {
		Device.LifecycleEmitter.removeListener(this);
	},

	onLifecycleUpdate : function(event) {
		if (event == Device.LifecycleEmitter.Event.Suspend){
			if(GAAudioManager.isBackgroundSoundPlaying()) 
			{   			
				GAAudioManager.pauseBgMusic();
			}
		}
		else if (event == Device.LifecycleEmitter.Event.Resume){
			SocialManager.handleSocialAction(kSocialTypes.UPDATE_HANDLERS,null);
			if(!GAAudioManager.isBackgroundSoundPlaying()) 
			{   			
				GAAudioManager.playBgMusic();
			}
			
			TFUtil.synchronizeServerTime();
		}
		else if(event == Device.LifecycleEmitter.Event.Terminate){
			if(GAAudioManager.isBackgroundSoundPlaying()) 
			{   			
				GAAudioManager.pauseBgMusic();
			}
		}
	}
	
});

/**
 * Filename: TFConstants.js
 * Author: Wasay Abbasi
 * Date Created: 17th May, 2011
 */

//Game configuration constants
var TF_BUILD_NUMBER = '8';
var TF_VERSION_NUMBER = '1.20';
var kDEV_MENU = false;
var TF_TANK_FOOD_PARTICLES_DROP_AMOUNT = 1;
var TF_TANK_FOOD_PICK_DISTANCE = 150;
var TF_FOOD_HUNT_BRICK = 10301;
var TF_FOOD_HUNT_PARTICLE = 10302;
var TF_FOOD_HUNT_BRICK = 10303;
var TF_ALL_FED_XP = 1;
var TF_ALL_FED_COINS = 1;
var TF_ALL_FED_COINS_NEIGHBOR=2;
var TF_CURRENCY_STORE_ID = 3 ;
var TF_BUCKS_CAT_ID = 0 ;
var TF_COINS_CAT_ID = 2 ;
//Game start tags
var TF_GAPI_CONNECT_ERROR_TAG = 1000;
var TF_GAPI_SYNC_ERROR_TAG = 1001;
var MAX_REWARDS_SHOWN_ON_SCREEN = 15;
var ALGAE_EATER_CATEGORY_ID = 7;
var TF_TEMP_IMAGE_PATH = "imagePathInfo.csv";
var userMenuCloseButton=false;
// Game enums
var TFActionType = {
    tfActionNone: 0,
	tfActionHover:1,
	tfActionSpeed:2,
	tfActionCurve:3,
	tfActionFoodHunt:114
};

var TFFishType = {
tfFishIsFish: 0,
tfFishisEgg:1
};

var TFStoreType = {
	kDefault: 0,
	kFishEggs:1
};

var SOUND_KEY = "sound_key";
var BACKGROUND_MUSIC_PATH = './Content/Audio/TF_Bubbles.wav';
var CLICK_SOUND_NAME1 = './Content/Audio/TF_Tapping.wav' ;
var SELL_SOUND_NAME1 = './Content/Audio/GetCoins.wav';
var SQUEAK_CLEAN_SOUND_NAME1  =  './Content/Audio/squeakCleanSound.wav'; 


var TF_MINIMUM_ACTION_INTERVAL = 3;
var TF_MAXIMUM_ACTION_INTERVAL = 7;


var ScreenBoundary = {
	boundaryNone: 0,
	boundaryLeft: 1,
	boundaryTop: 2,
	boundaryRight: 3,
	boundaryBottom:4
};
	
var kTankActionType = {
    kTankActionArrow :1,
    kTankActionSponge:2,
    kTankActionFood: 3,
    kTankActionEggs: 4,
    kTankActionDecoration: 5,
    kTankActionPlant: 6,
    kTankActionBlockTank: 7
};

var kRatingType = {
    GET :1,
    POST:2
};
    
    
var TF_TIMER_INTERVAL = 20; //33 Frames/Sec for smooth animations

var TF_BOUNDARY_TOP_MARGIN  = 50;
var TF_BOUNDARY_BOTTOM_MARGIN = 50;
var TF_BOUNDARY_MARGIN = 90 ;  //Left right boundary (previously 70)
var TF_TANK_TAP_DISTANCE = 100; //Fishes with distance less than 100 will be affected
var TF_TANK_FISH_LIMIT = 50; // Limit to put fish in the tank.
var TF_TANK_DISTINCT_FISH_LIMIT = 25; // Limit to put distinct fish in the tank.

var TF_WELCOME_BACK_TIME = 36*60;

var TF_MINIMUM_SCALE = 0.5;
var TF_MAXIMUM_SCALE = 0.9;
var TF_REVIVE_ALL_PRICE = 1;

var TF_TANK_TAP_SPEED = 11;	//speed of fishes after tank Tap

var kUserDefaultKeys = ["NotFirstRun","superUserFirstRun","musicOn","isQAUser","isSuperUser","QA_PLAY_MODE","isManifestDownloaded","messageCount","giftsCount","friendRequestCount"];


/// currency update types...
var kOperationType= {
	kOperationAddCoins: 1,
	kOperationSubtractCoins :2,
	kOperationAddBucks : 3,
	kOperationSubtractBucks :4
} ;

//Attribute Window enum

var attributeWindowType= {
	fishEnum: 1,
	decorationEnum :2,
	deadFishEnum : 3,
	plantsEnum :4,
	foodBrickEnum : 5
};

var kGameStateType= {
	kGameStateNeighbor: 1,
	kGameStateRestore :2
};

var kObjectActionType = {
	kObjectActionRemove: 1,
	kObjectActionAdd :2
};

var kResourceType = {
	kResourceTypeFish: 1,
	kResourceTypeDecoration :2,
	kResourceTypePlant :3,
	kResourceTypeFoodBrick :4,
};

var TF_MAX_LEVEL = 80;
var TF_MAX_USER_COINS = 99999999;
var TF_MAX_USER_BUCKS = 99999;


var TF_LOVE_TIME_DIFF = 3*60*60; //3 hours
var TF_Love_BONUS_COINS=25;
var TF_Love_BONUS_XP=2;


var kTouchSwallower=10;



var TF_POINTS_FISH_HUNGER = 35;
var TF_POINTS_TANK_CLEAN = 35;
var TF_POINTS_DECORATIONS = 11;
var TF_POINTS_PLANTS = 11;
var TF_POINTS_BACKGROUND = 6;
var TF_POINTS_LOVE = 2;
var TF_BOOST_HOURS = 3;




//In App Constants
var PRICE_POINTS_PER_PAGE = 3;

// algae constants
var ALGAE_PARTICLE_SIZE = 90;
var ALGAE_PARTICLE_SIZE_DIFF = 0;
var ALGAE_TOTAL_PIXELS = 70;

var TF_BREEDED_FISH_ADULT_TIME =4320;
// Aspect Ratio
var AspectRatios = {
	Ratio133: 1.33,//ipad
	Ratio150: 1.50,//ipod, iphone, lg optimus, iOS simulator, droid pro
	Ratio160: 1.60,//xoom, galaxy tab 10.
	Ratio167: 1.67,//nexus s, galaxy s, htc inspire and every other device
	Ratio170: 1.7,//xoom
	Ratio171: 1.71,//galaxy tab
	Ratio178: 1.78,//milestone, droid x
	};



/// currency update types...
var kAlertWindowType= {
	kAlertWindowCustom: 1,
	kAlertWindowSellAllFish :2
} ;

var kBreedingTankStatus = {
    kStatusTankLock     : 0,
    kStatusTankEmpty    : 1,
	kStatusFirstFish  : 2,
	kStatusSecondFish : 3,
	kStatusEgg          : 4,
	kStatusReady        : 5
};

var kSoreItems = {
	
   	kLocalFish : 5,
	kLocalBackgrounds : 1,
	kLocalDecorations : 4,
	kLocalPlants : 6,
	klocalFoodBrick : 7,
	kUndefined : -1
};


var TUTORIAL_END_COUNT = 7; 


/**
 * Filename: TFConstants.js
 * Author: Wasay Abbasi
 * Date Created: 25th May, 2011
 */

///InAPP Constants////
var PRICE_POINTS_PER_PAGE = 3
var TF_COINS = 1
var TF_BUCKS = 2
var TF_COINS_TAG = 1;
var TF_BUCKS_TAG = 2;

//General Tab
var TF_INTERNET_ERROR_TAG = "TF_INTERNET_ERROR_TAG";
	

var kCurrencyType = {
	kCurrencyTypeCoins : 1,
	kCurrencyTypeBucks : 2,
};

var kObjectType = {
	kObjectBackground: 0,
	kObjectFish: 1,
	kObjectDecoration: 2,
	kObjectPlant: 3,
	kObjectFoodBrick: 4,
};
/**
 * Filename: Require.js
 * Author: Abid Hussain
 * Date Created: 2011-04-13
 */

//var GAGlobalUtils = require('../GACommon/GAGlobalUtils');		//not working, so i am including global util methods here for the hour.

//putting global utility methods -- Harris

/* start of part maintained by Harris */
						function isValidString(candidateText) {
							return (candidateText != null && (typeof candidateText == "string" || candidateText instanceof String))
						}

						function isValidNumber(candidateNumber) {
							return (candidateNumber != null && (typeof candidateNumber == "number" || candidateText instanceof Number))

						}

						function isValidObject(candidateObject) {
							return (candidateObject != null && (typeof candidateObject == "object" || candidateObject instanceof Object))

						}
/* end of part maintained by Harris */




var Core 	= 		require('NGCore/Client/Core').Core;
var GL2 	= 		require('NGCore/Client/GL2').GL2;
var Social 	= 		require('NGCore/Client/Social').Social;
var Bank 	= 		require('NGCore/Client/Social').Bank;
var Network = 		require('NGCore/Client/Network').Network;
var Storage = 		require('NGCore/Client/Storage').Storage;
var Device 	= 		require('NGCore/Client/Device').Device;
var Audio 	= 		require('NGCore/Client/Audio').Audio;
var	UI 		= 		require('NGCore/Client/UI').UI;
var Capabilities =	require('NGCore/Client/Core/Capabilities').Capabilities;
var GL2		=		require('NGCore/Client/GL2').GL2;
var Mobclix = 		require('NGCore/Client/Mobclix').Mobclix;

var GALogger = require('Code/ngAPI/GACommon/GALogger').GALogger;
var GAWebFetcher = require('Code/ngAPI/GACommon/GAWebFetcher').GAWebFetcher;
var GACommonUtils = require('Code/ngAPI/GACommon/GACommonUtils').GACommonUtils;

var GLFactory = require('Code/ngAPI/GACommon/GLFactory').GLFactory;
var UIFactory = require('Code/ngAPI/GACommon/UIFactory').UIFactory;
var GLButton = require('Code/ngAPI/GACommon/GLButton').GLButton;

var GAMutableDictionary = require('Code/ngAPI/GACommon/GAMutableDictionary').GAMutableDictionary;

var GAMutableArray = require('Code/ngAPI/GACommon/GAMutableArray').GAMutableArray;

var GAAlertViewPanel = require('Code/ngAPI/GACommon/GAAlertViewPanel').GAAlertViewPanel;
var GAUIAlertViewWithEditText = require('Code/ngAPI/GACommon/GAUIAlertViewWithEditText').GAUIAlertViewWithEditText;
var GALayer = require('Code/ngAPI/GACommon/GAUIAlertView').GALayer;
var GAUIAlertView = require('Code/ngAPI/GACommon/GAUIAlertView').GAUIAlertView;
var GAFileDownloader = require('Code/ngAPI/GACommon/GAFileDownloader').GAFileDownloader;
var GAConfigurations = require('Code/ngAPI/GACommon/GAConfigurations').GAConfigurations;
var GAIsoMetricConfigurations = require('Code/ngAPI/GACommon/GAIsoMetricConfigurations').GAIsoMetricConfigurations;
var GAAudioManager = require('Code/ngAPI/GACommon/GAAudioManager').GAAudioManager;
var GACopyManager = require('Code/ngAPI/GACommon/GACopyManager').GACopyManager;

var GACompressionManager = require('Code/ngAPI/GACommon/GACompressionManager').GACompressionManager;
var GAZip = require('Code/ngAPI/GACommon/GAZip').GAZip;


var GAGameStateHandler = require('Code/ngAPI/GAHandler/GAGameStateHandler').GAGameStateHandler;
var GAGameStateManager = require('Code/ngAPI/GAHandler/GAGameStateManager').GAGameStateManager;

var GAStoreLoader = require('Code/ngAPI/GAHandler/GAStoreLoader').GAStoreLoader;
var GAStoreHandler = require('Code/ngAPI/GAHandler/GAStoreHandler').GAStoreHandler;
var GAResourceSyncHandler = require('Code/ngAPI/GAHandler/GAResourceSyncHandler').GAResourceSyncHandler;
var GAGameLoader = require('Code/ngAPI/GAHandler/GAGameLoader').GAGameLoader;
var GAGameStateGetHandler = require('Code/ngAPI/GAHandler/GAGameStateGetHandler').GAGameStateGetHandler;
var GAGameStatePostHandler = require('Code/ngAPI/GAHandler/GAGameStatePostHandler').GAGameStatePostHandler;
var GACurrencyUpdateHandler = require('Code/ngAPI/GAHandler/GACurrencyUpdateHandler').GACurrencyUpdateHandler;


var GAServerResponseCommonModel = require('Code/ngAPI/GAModel/GAServerResponseCommonModel').GAServerResponseCommonModel;
var GAConnectResponse = require('Code/ngAPI/GAModel/GAConnectResponse').GAConnectResponse;
var GAConnectHandler = require('Code/ngAPI/GAHandler/GAConnectHandler').GAConnectHandler;
var GAPromotionModel = require('Code/ngAPI/GAModel/GAPromotionModel').GAPromotionModel;
var GAPromotionsModel = require('Code/ngAPI/GAModel/GAPromotionsModel').GAPromotionsModel;
var GAUserMessageModel = require('Code/ngAPI/GAModel/GAUserMessageModel').GAUserMessageModel;
var GAStoreVersionModel = require('Code/ngAPI/GAModel/GAStoreVersionModel').GAStoreVersionModel;
var GACurrenciesModel = require('Code/ngAPI/GAModel/GACurrenciesModel').GACurrenciesModel;
var GASocialGiftReceivedResponse = require('Code/ngAPI/GAModel/GASocialGiftReceivedResponse').GASocialGiftReceivedResponse;

 
var GADazzleHandler = require('Code/ngAPI/Dazzle/GADazzleHandler').GADazzleHandler;
var GACommonModel = require('Code/ngAPI/Dazzle/GACommonModel').GACommonModel;
var GATransactionsModel = require('Code/ngAPI/Dazzle/GATransactionsModel').GATransactionsModel;
var GAEventsModel = require('Code/ngAPI/Dazzle/GAEventsModel').GAEventsModel;
var GAOffersModel = require('Code/ngAPI/Dazzle/GAOffersModel').GAOffersModel;
var GAStorage = require('Code/ngAPI/GACommon/GAStorageManager').GAStorageManager;
var GAPersistedObject = require('Code/ngAPI/GAPersistence/GAPersistedObject').GAPersistedObject;
var GAPersistenceManager = require('Code/ngAPI/GAPersistence/GAPersistenceManager').GAPersistenceManager;
var GAInAppPurchaseHandler = require('Code/ngAPI/GAInApp/GAInAppPurchaseHandler').GAInAppPurchaseHandler;
var GALocalizationHandler = require('Code/ngAPI/GALocalization/GALocalizationHandler').GALocalizationHandler;

var GAResourceDownloader = require('Code/ngAPI/GAResources/GAResourceDownloader').GAResourceDownloader;
var GAResourceUtils = require('Code/ngAPI/GAResources/GAResourceUtils').GAResourceUtils;
var GAStoreIcon = require('Code/ngAPI/GAResources/GAStoreIcon').GAStoreIcon;

var GASprite = require('Code/ngAPI/GASprite/GASprite').GASprite; 

var GAIsometricView = require('Code/ngAPI/GAIsoMetricView/GAIsometricView').GAIsometricView;
var GAObjectLayer = require('Code/ngAPI/GAIsoMetricView/GAObjectLayer').GAObjectLayer;
var GridObject = require('Code/ngAPI/GAIsoMetricView/GridObject').GridObject;
var GridObjectDecoration = require('Code/ngAPI/GAIsoMetricView/GridObjectDecoration').GridObjectDecoration;

var GAMobageSocialHandler = require('Code/ngAPI/GAMobageSocial/GAMobageSocialHandler').GAMobageSocialHandler;

var GAManifestContentDownloader = require('Code/ngAPI/GACommon/GAManifestContentDownloader').GAManifestContentDownloader;
var GAInterfaceListener = require('Code/ngAPI/GAHandler/GAInterfaceListener').GAInterfaceListener;

//Actions
var GAMoveTo = require('Code/ngAPI/GAActions/GAMoveTo').GAMoveTo;
var GAPurchaseSyncHandler = require('Code/ngAPI/GAInApp/GAPurchaseSyncHandler').GAPurchaseSyncHandler;

/**
 * Filename: NJRequire.js
 * Author: Wasay Abbasi
 * Date Created: 16thMay-2011
 * Date Updated: 
 */


var GameCentralHandler = require('Code/GameCentralHandler').GameCentralHandler;

//GamestartUI
var GameLoadingScreen =require('Code/GameStartUI/GameLoadingScreen').GameLoadingScreen;
var LoadingScreen =require('Code/GameStartUI/LoadingScreen').LoadingScreen;

//DatabaseInterface
var DatabaseInterface = require('Code/DatabaseInterface/DatabaseInterface').DatabaseInterface;

//GameState
var TFGameState = require('Code/GameState/TFGameState').TFGameState;

//GLLayer
var GameLayer = require('Code/GLLayer/GameLayer').GameLayer;
var StoreWindow = require('Code/GLLayer/StoreWindow').StoreWindow;
var FishUI = require('Code/GLLayer/FishUI').FishUI;
var TankUi = require('Code/GLLayer/TankUI').TankUI;
var FoodParticles = require('Code/GLLayer/FoodParticles').FoodParticles;
var TFAnimation = require('Code/GLLayer/TFAnimation').TFAnimation;
var TFControlLayer = require('Code/GLLayer/TFControlLayer').TFControlLayer;
var PlantUI = require('Code/GLLayer/PlantUI').PlantUI;
var FoodBrickUI = require('Code/GLLayer/FoodBrickUI').FoodBrickUI;
var InfoView = require('Code/GLLayer/InfoView/InfoView').InfoView;
var AlgaeLayer = require('Code/GLLayer/AlgaeLayer').AlgaeLayer;
var TFSettingsUI = require('Code/GLLayer/TFSettingsUI').TFSettingsUI;
var GAMobclixForView = require('Code/GLLayer/GAMobclixForView').GAMobclixForView;
//InfoView
var InfoView = require('Code/GLLayer/InfoView/InfoView').InfoView;
var TankLayer = require('Code/GLLayer/InfoView/TankLayer').TankLayer;
var InventoryLayer = require('Code/GLLayer/InfoView/InventoryLayer').InventoryLayer;

//Utilities
var TFStorageManager  = require('Code/Utilities/TFStorageManager').TFStorageManager;
var Math2 = require('Code/Utilities/Math2').Math2;
var TFMiniUIAlertView = require('Code/Utilities/TFMiniUIAlertView').TFMiniUIAlertView;

//model classes
var User = require('Code/ModelClasses/User').User;
var Tank = require('Code/ModelClasses/Tank').Tank;
var TankFish = require('Code/ModelClasses/TankFish').TankFish;
var TankDecoration = require('Code/ModelClasses/TankDecoration').TankDecoration;
var TankBackground = require('Code/ModelClasses/TankBackground').TankBackground;
var TankPlant = require('Code/ModelClasses/TankPlant').TankPlant;
var TankFoodBrick = require('Code/ModelClasses/TankFoodBrick').TankFoodBrick;

//gAPICommunicator
var GAPICommunicator = require('Code/gAPICommunicator/GAPICommunicator').GAPICommunicator;

// Control Layer
var TFControlLayer = require('Code/GLLayer/TFControlLayer').TFControlLayer;
var TFControlLayerAbove = require('Code/GLLayer/TFControlLayerAbove').TFControlLayerAbove;
var GAMoveTo = require('Code/UI Layers/GAMoveTo').GAMoveTo;
var GAScaleTo = require('Code/UI Layers/GAScaleTo').GAScaleTo;

// Util Class
var TFUtil  = require('Code/Util/TFUtil').TFUtil;
var ManifestContentDownloader  = require('Code/Util/ManifestContentDownloader').ManifestContentDownloader;
var LogHandler = require('Code/Utilities/LogHandler').LogHandler;

// In App Classes
var InAppMainView = require('Code/UI Layers/In App UI/InAppMainView').InAppMainView;
var InAppTableView  = require('Code/UI Layers/In App UI/InAppTableView').InAppTableView;
var InAppTableViewCell = require('Code/UI Layers/In App UI/InAppTableViewCell').InAppTableViewCell;
var TZIAPManager = require('Code/UI Layers/In App UI/TZIAPManager').TZIAPManager;


///StoreScreens
var StoreMainView   = require('Code/UI Layers/StoreScreen/StoreMainView').StoreMainView;
var StoreUtil	= require('Code/UI Layers/StoreScreen/StoreUtil').StoreUtil;
var StoreGenericTableView   = require('Code/UI Layers/StoreScreen/StoreGenericTableView').StoreGenericTableView;
var CustomCellView      = require('Code/UI Layers/StoreScreen/CustomCellView').CustomCellView;
var StoreTableViewCell      = require('Code/UI Layers/StoreScreen/StoreTableViewCell').StoreTableViewCell;
var LevelOneCell	= require('Code/UI Layers/StoreScreen/TableViewCells/levelOneCell').levelOneCell;
var LevelTwoCell	= require('Code/UI Layers/StoreScreen/TableViewCells/levelTwoCell').levelTwoCell;
var LevelThreeCell	= require('Code/UI Layers/StoreScreen/TableViewCells/levelThreeCell').levelThreeCell;

// Trophy Classes
var TrophyGenericTableView   = require('Code/UI Layers/TrophyScreen/TrophyGenericTableView').TrophyGenericTableView;
var TrophyMainView   = require('Code/UI Layers/TrophyScreen/TrophyMainView').TrophyMainView;
var TrophyTableViewCell = require('Code/UI Layers/TrophyScreen/TrophyTableViewCell').TrophyTableViewCell;
var TrophyMainCell = require('Code/UI Layers/TrophyScreen/TrophyCell/TrophyMainCell').TrophyMainCell;
var TrophyBreadingCell = require('Code/UI Layers/TrophyScreen/TrophyCell/TrophyBreadingCell').TrophyBreadingCell;

// UI Classes
var TankUI = require('Code/GLLayer/TankUI').TankUI;
var DecorationUI = require('Code/GLLayer/DecorationUI').DecorationUI;
var FishUI = require('Code/GLLayer/FishUI').FishUI;
var TFMiniGLAlertView = require('Code/GLLayer/TFMiniGLAlertView').TFMiniGLAlertView;

// PanelUI
var AttributeWindow = require('Code/UI Elements/PanelUI/AttributeWindow').AttributeWindow;
var GAGLAlertWindow = require('Code/GLLayer/GAGLAlertWindow').GAGLAlertWindow;
var TBParticleAnimation = require('Code/UI Elements/TankUI/TBParticleAnimation').TBParticleAnimation;
//var ParticleAnimation = require('./UI Elements/TankUI/ParticleAnimation').ParticleAnimation;

var TankRename = require('Code/UI Elements/TankRename/TankRename').TankRename;
var InputCheck = require('Code/UI Elements/TankRename/InputCheck').InputCheck;
var AboutUs = require('Code/GLLayer/AboutUs').AboutUs;
var HelpPage = require('Code/UI Elements/HelpPage/HelpPage').HelpPage;




//Breeding 
var FishListLayer = require('Code/UI Elements/BreedingPanel/FishListLayer').FishListLayer;
var BreedingTankUI = require('Code/UI Elements/BreedingPanel/BreedingTankUI').BreedingTankUI;
var BreedingTank = require('Code/UI Elements/BreedingPanel/BreedingTank').BreedingTank;
var BreedFishUI = require('Code/UI Elements/BreedingPanel/BreedFishUI').BreedFishUI;
var FishListObject = require('Code/UI Elements/BreedingPanel/FishListObject').FishListObject;
var BreedingTankController = require('Code/UI Elements/BreedingPanel/BreedingTankController').BreedingTankController;


var TankShower = require('Code/EventPakage/TankShower').TankShower;
var InterfaceListener = require('Code/GLLayer/InterfaceListener').InterfaceListener;
//Social
//var GASocialMainHandler = require('./Social/GASocialMainHandler').GASocialMainHandler;
//var Social = require('../NGCore/Client/Social').Social;
//var Styles = require('./Social/Styles').Styles;
//var Dump = require('./Social/Dumper').Dump;
//var DialogController = require('./Social/DialogController').DialogController;
var Gravity = UI.ViewGeometry.Gravity;

var TutorialWindow = require('Code/UI Layers/TutorialWindow').TutorialWindow;

var DevelopmentMenu = require('Code/DevelopmentMenu').DevelopmentMenu;
//SOCIAL API


var SocialUI = require('Code/SocialAPI/SocialUI').SocialUI;
var SocialFriends = require('Code/SocialAPI/SocialFriends/SocialFriends').SocialFriends;
var SocialFriend = require('Code/SocialAPI/SocialFriends/SocialFriend').SocialFriend;
var SocialManager = require('Code/SocialAPI/SocialManager').SocialManager;
var SocialUITableViewCell = require('Code/SocialAPI/SocialList/SocialUITableViewCell').SocialUITableViewCell;
var SocialUILevelTwoCell = require('Code/SocialAPI/SocialFriendsUI/SocialUILevelTwoCell').SocialUILevelTwoCell;
var SocialUIGenericTableView = require('Code/SocialAPI/SocialList/SocialUIGenericTableView').SocialUIGenericTableView;
var SocialUtil = require('Code/SocialAPI/SocialUtil/SocialUtil').SocialUtil;
var SocialFriendsUI = require('Code/SocialAPI/SocialFriendsUI/SocialFriendsUI').SocialFriendsUI;
var SocialFriendsHandler = require('Code/SocialAPI/SocialFriendsHandler').SocialFriendsHandler;
var SocialMessages = require('Code/SocialAPI/SocialMessagesUI/SocialMessages').SocialMessages;
var SocialMessagesUI = require('Code/SocialAPI/SocialMessagesUI/SocialMessagesUI').SocialMessagesUI ;
var SocialMessagesUICell = require('Code/SocialAPI/SocialMessagesUI/SocialMessagesUICell').SocialMessagesUICell ;
var SocialMessagesDialogue = require('Code/SocialAPI/SocialMessagesUI/SocialMessagesDialogue').SocialMessagesDialogue ;
var SocialCannedMessagesUI = require('Code/SocialAPI/SocialMessagesUI/SocialCannedMessagesUI').SocialCannedMessagesUI;
var SocialCustomCellView = require('Code/SocialAPI/SocialList/SocialCustomCellView').SocialCustomCellView;
var SocialNotificationsUI = require('Code/SocialAPI/SocialNotificationsUI/SocialNotificationsUI').SocialNotificationsUI;
var SocialNotificationsCell = require('Code/SocialAPI/SocialNotificationsUI/SocialNotificationsCell').SocialNotificationsCell;
var SocialNotificationFriendsCell = require('Code/SocialAPI/SocialNotificationsUI/SocialNotificationFriendsCell').SocialNotificationFriendsCell;
var SocialGiftsHandler = require('Code/SocialAPI/SocialGiftsHandler').SocialGiftsHandler;
var SocialGiftstUI = require('Code/SocialAPI/SocialGiftsUI/SocialGiftstUI').SocialGiftstUI;
var SocialNeighbourGiftCell = require('Code/SocialAPI/SocialGiftsUI/SocialNeighbourGiftCell').SocialNeighbourGiftCell;
var SocialMiniUIAlertView = require('Code/SocialAPI/SocialUtil/SocialMiniUIAlertView').SocialMiniUIAlertView ;
//var SocialGiftUI = require('./SocialAPI/SoicalGiftUI/SocialGiftUI').SocialGiftUI;
//var SocialGiftUICell = require('./SocialAPI/SoicalGiftUI/SocialGiftUICell').SocialGiftUICell;
var SocialMessagesHandler = require('Code/SocialAPI/SocialMessagesHandler').SocialMessagesHandler;
//var GASocialMessageReceivedResponse = require('./SocialAPI/SocialMessagesUI/GASocialMessageReceivedResponse').GASocialMessageReceivedResponse;
var VisitNeighbor = require('Code/SocialAPI/VisitNeighbor').VisitNeighbor;
var DatabaseHelper = require('Code/SocialAPI/DatabaseHelper').DatabaseHelper;
var SocialActionsHandler = require('Code/SocialAPI/SocialActionsHandler').SocialActionsHandler;
var GAActionsReceivedResponse = require('Code/SocialAPI/GAActionsReceivedResponse').GAActionsReceivedResponse;
var ActionsModel = require('Code/SocialAPI/SocialModelClasses/ActionsModel').ActionsModel;



var httpStatus = {
	HTTP_STATUS_ZERO: 0,
    HTTP_STATUS_SUCCESS_OK: 200,
    HTTP_STATUS_SUCCESS_NO_CONTENT: 204,
    HTTP_STATUS_SUCCESS_PARTIAL_CONTENT: 206,
    HTTP_STATUS_CLIENT_ERROR_REQUEST_TIMEOUT: 408
};

var kGADownloadStatus = {
	DOWNLOAD_PENDING : 0,
    DOWNLOAD_START : 1,
    DOWNLOAD_COMPLETE : 2,
    DOWNLOAD_FAIL : -1
};

//Enumeration to get the ReponseType
var kGAStatusType = {
    //General Status Message
    kGAStatusOk: 1,
    kGADelegateNil: 2,
    kGAURLNil: 3,
    kGAURLInvalid: 4,
    kGADBFileNotExists: 25,
    kGAAudioFileNotExits: 26,

    //Web Fetcher and Downloader Responses
    kGAResponseInvalidURLString: 50,
    kGAResponseFailure: 51,
    kGAResponseStatusNotOK: 52,
    kGAResponseNoDataFromServer: 53,
    kGAResponseTimeout: 54,
    kGAResponseUnknownLength: 55,
    kGAResponseNotAllDataDownloaded: 56,

    kGAFileCreateError: 60,
    kGAFileReplaceError: 61,
    kGAFileDeleteError: 62,
    kGAFileCopyError: 63,

    kGAResourceDownloadingFailed: 64,
    kGADownloadedFileAuthenticationFailed: 70,

    //Zip Unzip Status Codes
    kGAZipExtractionFailedWithUnknownException: 101,
    kGAZipSourceFileNotValid: 102,
    kGAZipInavlidSavePath: 103,
    kGAZipInvalidSourcePath: 104,
    kGAZipFolderCreateError: 105,
    kGAZipFileCreateError: 106,
    kGAZipInvalidContentFile: 107,

    //Game Store Status Codes
    kGAGameStoreInvalidSavePath: 200,
    kGAGameLoadConnectParseFailed: 201,
    kGAGameLoadConnectAuthFailed: 202,
    kGAGameLoadStoreUpdateFailed: 203,
    kGAGameLoadStoreParseFailed: 204,
    kGAGameLoadConnectXMLNotFound: 205,

    //in-App Purchase Constants
    kGAErrorNoCode: 301,
    kGAErrorUnknown: 302,
    kGAErrorClientInvalid: 303,
    // client is not allowed to issue the request, etc.
    kGAErrorPaymentCancelled: 304,
    // user cancelled the request, etc.
    kGAErrorPaymentInvalid: 305,
    // purchase identifier was invalid, etc.
    kGAErrorPaymentNotAllowed: 306,
    // this device is not allowed to make the payment
    kGAErrorNoInternet: 307,
    kGAErrorStoreKitTimeout: 308,

    kGAStoreObjectNil: 400,
    kGAResourceObjectNil: 401,

    kGADZDazzleNotInitialized: 501,
    kGADZLoggingParameterInvalid: 502,
    kGADZLoggingParameterMissing: 503,
    kGADZLoggingInternalError: 504
};
var kGAGameState = {
	kLastModifiedTime: "lastModifiedTime",
	kLastSavedXp: "lastSaveXp",
	kTimeOut: 600
};
var kGARequestType = {
    kGARequestGet: 1,
    kGARequestPOST: 2,
    kGAUdid: 3,
    kGAUserKey: 4
};

var kGAGameLoadLevel = {
	kGAGameLoadLevelStart : 0,
	kGAGameLoadLevelConnectDone : 1,
	kGAGameLoadLevelStoreVersionsDone : 2,
	kGAGameLoadLevelStoreParsingDone : 3
};

 var kGAInternalStoreState = {
	kGAInternalStoreStateInitial : 0,
	kGAInternalStoreConfigured : 1,
	kGAInternalStoreStateInProgress : 2,
	kGAInternalStoreStateCompleted : 3,
	kGAInternalStoreStateFailed : 4,
	kGAInternalStoreStateCritical : 5
	
};
 var kGADazzle = {
	kGAPendingLog : 0,
	kGAInProgressLog : 1,
	kGALoggingThreshold : 20,
	kGALoggingCount : "loggingCount"
 };
 
 var GADazzleOfferType = {
	InAppPurschase : 1,
	LevelUp : 2
};

var GADazzleEventType = {
	Registration : 3,
	Connect : 2,
	NewDeviceRegistration : 1
};

var GADazzleLoggingType = {
	NoLogging : 0,
	CountThreshold : 1,
	TimeThreshold : 2,
	BothCountAndTimeThreshold : 3,
	Immediate : 4,
	OnApplicationTermination : 5
};

 var LOG_LEVEL = {
			LOG_ALL : 6,
			LOG_VERBOSE : 5,
			LOG_DEBUG : 4,
			LOG_NONFATAL_ERROR : 3,
			LOG_EXCEPTION : 2,
			LOG_FATAL : 1,
			LOG_SILENT : 0
		};


var kGADeviceType = {
    kGADeviceTypeUnknown: 0,
    kGADeviceTypeIphone: 1,
    kGADeviceTypeIpad: 2,
    kGADeviceTypeIpodTouch: 3
};

var aspectRatioFactor = {
    x: 854,
    y: 480,
    d: 3.67
};

var TextAlignment = {
	kAlignLeft 	: 0,
	kAlignRight	: 1,
	kAlignTop  	: 2,
	kAlignBottom: 3,
	kAlignCenter: 4
};

var GAResourceType = {
	kThumb 	: "thumb",
	kDetail	: "default_zip"
};

var GAInAppPurchase = {
	noButton : -2,
	noFunds : -1,
	badServer : 401,
	noItem: 404,
	serverError: 500,
	miscError: 666
};

var GAInAppPurchaseCurrencyType = {
	kBucks : "bucks",
	kCoins : "coins"
};

var GA_UDID_PARAM_KEY				= "udid"
var GA_DEVICE_TYPE_PARAM_KEY		= "devicetype"
var GA_DEVICE_OS_PARAM_KEY			= "OS"
var GA_GAME_VERSION_PARAM_KEY		= "GV"
var GA_GAME_NAME_PARAM_KEY			= "game"
var GA_DEVICE_GENERATION_PARAM_KEY	= "deviceGen"
var GA_USER_LEVEL_PARAM_KEY			= "level"

var GAINAPP_AUTHENTICATION_KEY = "~O!l@y#m$p%i^c&s*S(o)c_c+e{r}W:o<r>l?d~C!u@p#H$o%c^k&e*y(C)h_a+m{p}:i<o>n?s~h!i@p#2$G%B^R&a*m(C)o_r+e{i}3:R<s>5?5~0!0@0#";


	var ObjectState = {
	    ObjectPlacement: 0,
	    ObjectUnderConstruction: 1,
	    ObjectIdle: 2,
	    ObjectDirty: 3,
	    ObjectReady: 4,
	    ObjectInProgress: 5,
	    ObjectMovement: 6,
	    ObjectExpire: 7
	};
	var TransactionType = {
			TransactionBuy: 0,
			TransactionSell: 1
		};
var ActionType = {
    ActionArrow: 0,
    ActionMove: 1
};

var progressScreenDelay = 1000;
var splashScreenDelay = 1000;
var COMPLETED_TXN_KEY = "COMPLETED_TXNS";
var DOWNLOADED_RESOURCES = "DOWNLOADED_RESOURCES";

var kSocialTypes = {
	FRIEND_LIST : 0,
    MESSAGES : 1,
    NOTIFICATIONS : 2,
    ADD_FRIENDS : 3,
    RANDOM_NEIGHBOUR : 4,
    VISIT : 5,
    INVITE : 6,
    REMOVE : 7,
    RECEIVE_GIFTS :8,
    SEND_GIFTS :9,
    GET_CANNED_MESSAGES: 10,
    GET_MESSAGE_COUNT: 11,
    RECEIVE_MESSAGES: 12,
    SEND_MESSAGES: 13,
    RECEIVE_GIFTS_COUNT :14,
    ACK_GIFT_RCV :15,
    VERIFY_GIFT_SENT :16,
    UPDATE: 17,
    FRIEND_REQUEST_LIST:18,
    CLEAR_FRIENDS_HANDLER:19,
    SEND_NEIGHBOR_ACTION:20,
    GET_NEIGHBOR_ACTION:21,
    GET_GIFTABLE_ITEMS:22,
    CALLBACK_ENABLE:23,
    UPDATE_HANDLERS:24,
    DOWNLOAD_ACK_GIFT :25,
    CLEAR_NOTIFICATIONS:26,
    CALLBACK_OVERRIDE:27,
    ACK_NOTIFICATIONS:28,
    BlOCKED_USERS:29

};

var kSocialUIType = {
		FRIENDSUI : 0,
	    CANNED_MESSAGESUI : 1,
	    SHOW_MESSAGESUI : 2,
	    NOTIFICATIONSUI : 3,
	    GIFTSUI:4
};

var kMessagesUIType = {
		REPLY_FRIEND : 0,
		REPLY_ANONYMOUS: 1,
		REPLY_NEIGHBOUR_FRIEND: 2,
		REPLY_NEIGHBOUR_ANONYMOUS: 3
};

var kSocialFriendHandlerCallType = {
	GAMELAYER: 0,
	SOCIALNOTIFICATIONUI:1
};

var kSocialFriendActionType = {
	CLEAN_TANK: 0,
	FEED_FISH:1,
	GIFT:2,
	REVIVE_FISHES:3
};

var kGameName='ngFish';

var kSocialSignatureKey= '~O!l@y#m$p%i^c&s*S(o)c_c+e{r}W:o<r>l?d~C!u@p#H$o%c^k&e*y(C)h_a+m{p}:i<o>n?s~h!i@p#2$G%B^R&a*m(C)o_r+e{i}3:R<s>5?5~0!0@0#';

var SOCIALAPI_CLOSE_BTN_PATH = 'Code/SocialAPI/images/SocialUI/cross.png';
var SOCIALAPI_CLOSE_BTN_SELECTED_PATH = 'Code/SocialAPI/images/SocialUI/cross_selected.png';

var SOCIALAPI_NEIGHBOUR_BTN_PATH = 'Code/SocialAPI/images/SocialUI/btn_friend_normal.png';
var SOCIALAPI_NEIGHBOUR_BTN_SELECTED_PATH = 'Code/SocialAPI/images/SocialUI/btn_friend_selected.png';

var SOCIALAPI_MESSAGE_BTN_PATH = 'Code/SocialAPI/images/SocialUI/btn_friend_normal.png';
var SOCIALAPI_MESSAGE_BTN_SELECTED_PATH = 'Code/SocialAPI/images/SocialUI/btn_friend_selected.png';

var SOCIALAPI_NOTIFICATION_BTN_PATH = 'Code/SocialAPI/images/SocialUI/btn_friend_normal.png';
var SOCIALAPI_NOTIFICATION_BTN_SELECTED_PATH = 'Code/SocialAPI/images/SocialUI/btn_friend_selected.png';

var SOCIALAPI_RND_NEIGHBOUR_BTN_PATH = 'Code/SocialAPI/images/SocialUI/random_neighbor_btn.png';
var SOCIALAPI_RND_NEIGHBOUR_SELECTED_BTN_PATH = 'Code/SocialAPI/images/SocialUI/random_neighbor_selected.png';

var SOCIALAPI_ADD_FRND_BTN_PATH = 'Code/SocialAPI/images/SocialUI/add_friend_btn.png';
var SOCIALAPI_ADD_FRND_SELECTED_BTN_PATH = 'Code/SocialAPI/images/SocialUI/add_friend_selected.png';

var SOCIALAPI_VISIT_BTN_PATH = './Code/SocialAPI/images/SocialUI/visit_btn.png';
var SOCIALAPI_VISIT_BTN_SELECTED_PATH = './Code/SocialAPI/images/SocialUI/visit_selected.png';

var SOCIALAPI_GIFTS_BAR_PATH = './Code/SocialAPI/images/SocialUI/barGifts.png';

var SOCIALAPI_REMOVE_BTN_PATH = './Code/SocialAPI/images/SocialUI/remove_btn.png';
var SOCIALAPI_REMOVE_BTN_SELECTED_PATH = './Code/SocialAPI/images/SocialUI/remove_selected.png';

var SOCIALAPI_ICON_BG_PATH = "./Code/SocialAPI/images/SocialUI/icon_bg.png";
var SOCIALAPI_ICON_PATH = "./Code/SocialAPI/images/SocialUI/icon.png";
var SOCIALAPI_LIST_BG_PATH = './Code/SocialAPI/images/SocialUI/list_bg.png';

var SOCIALAPI_BG_IMG_PATH = 'Code/SocialAPI/images/SocialUI/background.png';
var SOCIALAPI_BG_FRIENDS_IMG_PATH = 'Code/SocialAPI/images/SocialUI/backgroundFriends.png';
var SOCIALAPI_BG_FRIENDS_BAR_PATH = 'Code/SocialAPI/images/SocialUI/bar.png';

var SOCIALAPI_NOTIFICATION_CLEAR_BTN_PATH = 'Code/SocialAPI/images/SocialUI/btn_normal.png';
var SOCIALAPI_NOTIFICATION_CLEAR_BTN_SELECETD_PATH = 'Code/SocialAPI/images/SocialUI/btn_selected.png';

var SOCIALAPI_CHECKBOX_IMG_PATH = 'Code/SocialAPI/images/SocialUI/checkBox_normal.png';
var SOCIALAPI_CHECKBOX_IMG_SELECTED_PATH = 'Code/SocialAPI/images/SocialUI/checkBox_selected.png';

var SOCIALAPI_GIFT_ICON_IMG_PATH = 'Code/SocialAPI/images/SocialUI/giftBox.png';
var SOCIALAPI_GIFT_ICON_SELECTED_IMG_PATH = 'Code/SocialAPI/images/SocialUI/giftBox_selected.png';

var SOCIALAPI_MSG_REPLY_BTN_IMG_PATH = 'Code/SocialAPI/Images/SocialUI/reply.png';
var SOCIALAPI_MSG_REPLY_BTN_SELECTED_IMG_PATH = 'Code/SocialAPI/Images/SocialUI/reply_selected.png';

var SOCIALAPI_MSG_VISIT_NEIGHBOUR_BTN_IMG_PATH = 'Code/SocialAPI/Images/SocialUI/visit-neighbor.png' ;
var SOCIALAPI_MSG_VISIT_NEIGHBOUR_BTN_SELECTED_IMG_PATH = 'Code/SocialAPI/Images/SocialUI/visit-neighbor_selected.png' ;

var SOCIALAPI_GIFTBOX_IMG_PATH = 'Code/SocialAPI/images/SocialUI/giftBox.png';
var SOCIALAPI_ENVELOP_IMG_PATH = 'Code/SocialAPI/images/SocialUI/mail.png';
var SOCIALAPI_ENVELOP_SELECTED_IMG_PATH = 'Code/SocialAPI/images/SocialUI/mail-selected.png';

var SOCIALAPI_BTN_YELLOW_IMG_PATH = 'Code/SocialAPI/images/SocialUI/btnYellow.png';
var SOCIALAPI_BTN_YELLOW_SELECTED_IMG_PATH = 'Code/SocialAPI/images/SocialUI/btnYellowSelected.png';
var SOCIALAPI_BTN_BLUE = "./Content/images/UIPanels/Buttons/1buttonNormal.png";

var SOCIAL_MESSAGES_DIALOGUE_BG_PATH = 'Code/SocialAPI/images/SocialUI/message_dialog_bg.png';
var SOCIAL_MESSAGES_BODY_BG_PATH = 'Code/SocialAPI/images/SocialUI/message_bar.png' ;

var neighbourButtonText = "My Friends List";
var notificationButtonText = "Notifications";
var messageButtonText = "Messages";
var giftsButtonText = "Gifts";
var randomNeighbourButtonText = "Get Random Neighbor";
var addFriendsButtonText = "Add Friends";
var nameLabelText = "My Name : ";
var clearButtonText = "Clear";
var sendButtonText = "Send";
var PLSE_SELECT_TEXT = "Please Select a message to send to ";
var backButtonText = "Back";
var SOCIAL_APP_NAME = "Tap Fish Exotic";
var SOCIAL_APP_NAME_OLD = "Tap Fish";

var VISIT_NEIGHOR_XP_COINS_AWARD = "Thanks for visiting! You've earned ";

var VISIT_AWARD_TIME_CONSTANT = 86400;

var SOCIAL_RECEIVING_MESSAGES_FAILED ='Canned Messages not recieved';
var NAME = 'Name';
var GIFTS = 'Gifts';
var CLAIM = 'Claim';
var SENDER = 'Sender';

var MAXCELL = 25;
var UPDATE = 'UPDATE';
var UPDATE_TIME = 10*60*1000;
var WEEK_DAYS = 604800;
